// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.crypto.aes');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('alphabase.core');
goog.require('fluree.crypto.sha3');
goog.require('fluree.crypto.util');
goog.require('goog.crypt.Aes');
goog.require('goog.crypt.Cbc');
goog.require('goog.crypt.Pkcs7');
/**
 * Encrypts with AES/CBC/PKCS{5/7}Padding by hashing a 256 bit key out
 *   of key (requires Unlimited Strength crypto to be enabled).
 *   You can provide an alternate initial vector of unsigned(!) bytes of size 16 for CBC.
 */
fluree.crypto.aes.encrypt = (function fluree$crypto$aes$encrypt(var_args){
var args__4736__auto__ = [];
var len__4730__auto___8885 = arguments.length;
var i__4731__auto___8886 = (0);
while(true){
if((i__4731__auto___8886 < len__4730__auto___8885)){
args__4736__auto__.push((arguments[i__4731__auto___8886]));

var G__8887 = (i__4731__auto___8886 + (1));
i__4731__auto___8886 = G__8887;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((2) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((2)),(0),null)):null);
return fluree.crypto.aes.encrypt.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4737__auto__);
});
goog.exportSymbol('fluree.crypto.aes.encrypt', fluree.crypto.aes.encrypt);

fluree.crypto.aes.encrypt.cljs$core$IFn$_invoke$arity$variadic = (function (x,key,p__8878){
var vec__8879 = p__8878;
var map__8882 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__8879,(0),null);
var map__8882__$1 = (((((!((map__8882 == null))))?(((((map__8882.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8882.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__8882):map__8882);
var iv = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__8882__$1,cljs.core.cst$kw$iv,new cljs.core.PersistentVector(null, 16, 5, cljs.core.PersistentVector.EMPTY_NODE, [(6),(224),(71),(170),(241),(204),(115),(21),(30),(8),(46),(223),(106),(207),(55),(42)], null));
var output_format = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__8882__$1,cljs.core.cst$kw$output_DASH_format,cljs.core.cst$kw$hex);
var key_ba = ((typeof key === 'string')?fluree.crypto.util.hash_string_key(key,(32)):key);
var ba = ((typeof x === 'string')?alphabase.core.string__GT_bytes(x):x);
var encrypted = (function (){var cipher = (new goog.crypt.Aes(key_ba));
var cbc = (new goog.crypt.Cbc(cipher));
var pkcs7 = (new goog.crypt.Pkcs7());
var padded = pkcs7.encode((16),ba);
return cbc.encrypt(padded,cljs.core.clj__GT_js(iv));
})();
var G__8884 = cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(output_format);
var G__8884__$1 = (((G__8884 instanceof cljs.core.Keyword))?G__8884.fqn:null);
switch (G__8884__$1) {
case "none":
return encrypted;

break;
case "hex":
return alphabase.core.bytes__GT_hex(encrypted);

break;
case "base64":
return alphabase.core.bytes__GT_base64(encrypted);

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__8884__$1)].join('')));

}
});

fluree.crypto.aes.encrypt.cljs$lang$maxFixedArity = (2);

/** @this {Function} */
fluree.crypto.aes.encrypt.cljs$lang$applyTo = (function (seq8875){
var G__8876 = cljs.core.first(seq8875);
var seq8875__$1 = cljs.core.next(seq8875);
var G__8877 = cljs.core.first(seq8875__$1);
var seq8875__$2 = cljs.core.next(seq8875__$1);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__8876,G__8877,seq8875__$2);
});

/**
 * Decrypts with AES/CBC/PKCS{5/7}Padding by hashing a 256 bit key out of key.
 *   You can provide an alternate initial vector of unsigned(!) bytes of size 16 for CBC.
 */
fluree.crypto.aes.decrypt = (function fluree$crypto$aes$decrypt(var_args){
var args__4736__auto__ = [];
var len__4730__auto___8901 = arguments.length;
var i__4731__auto___8902 = (0);
while(true){
if((i__4731__auto___8902 < len__4730__auto___8901)){
args__4736__auto__.push((arguments[i__4731__auto___8902]));

var G__8903 = (i__4731__auto___8902 + (1));
i__4731__auto___8902 = G__8903;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((2) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((2)),(0),null)):null);
return fluree.crypto.aes.decrypt.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4737__auto__);
});
goog.exportSymbol('fluree.crypto.aes.decrypt', fluree.crypto.aes.decrypt);

fluree.crypto.aes.decrypt.cljs$core$IFn$_invoke$arity$variadic = (function (x,key,p__8893){
var vec__8894 = p__8893;
var map__8897 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__8894,(0),null);
var map__8897__$1 = (((((!((map__8897 == null))))?(((((map__8897.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__8897.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__8897):map__8897);
var iv = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__8897__$1,cljs.core.cst$kw$iv,new cljs.core.PersistentVector(null, 16, 5, cljs.core.PersistentVector.EMPTY_NODE, [(6),(224),(71),(170),(241),(204),(115),(21),(30),(8),(46),(223),(106),(207),(55),(42)], null));
var input_format = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__8897__$1,cljs.core.cst$kw$input_DASH_format,cljs.core.cst$kw$hex);
var output_format = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__8897__$1,cljs.core.cst$kw$output_DASH_format,cljs.core.cst$kw$string);
var key_ba = ((typeof key === 'string')?fluree.crypto.util.hash_string_key(key,(32)):key);
var x_ba = ((typeof x === 'string')?(function (){var G__8899 = cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(input_format);
var G__8899__$1 = (((G__8899 instanceof cljs.core.Keyword))?G__8899.fqn:null);
switch (G__8899__$1) {
case "hex":
return alphabase.core.hex__GT_bytes(x);

break;
case "base64":
return alphabase.core.base64__GT_bytes(x);

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__8899__$1)].join('')));

}
})():x);
var decrypt_ba = (function (){var cipher = (new goog.crypt.Aes(key_ba));
var cbc = (new goog.crypt.Cbc(cipher));
var pkcs7 = (new goog.crypt.Pkcs7());
return pkcs7.decode((16),cbc.decrypt(x_ba,cljs.core.clj__GT_js(iv)));
})();
var G__8900 = cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(output_format);
var G__8900__$1 = (((G__8900 instanceof cljs.core.Keyword))?G__8900.fqn:null);
switch (G__8900__$1) {
case "none":
return decrypt_ba;

break;
case "hex":
return alphabase.core.bytes__GT_hex(decrypt_ba);

break;
case "string":
return alphabase.core.bytes__GT_string(decrypt_ba);

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__8900__$1)].join('')));

}
});

fluree.crypto.aes.decrypt.cljs$lang$maxFixedArity = (2);

/** @this {Function} */
fluree.crypto.aes.decrypt.cljs$lang$applyTo = (function (seq8890){
var G__8891 = cljs.core.first(seq8890);
var seq8890__$1 = cljs.core.next(seq8890);
var G__8892 = cljs.core.first(seq8890__$1);
var seq8890__$2 = cljs.core.next(seq8890__$1);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__8891,G__8892,seq8890__$2);
});

