// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.query.analytical_wikidata');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('clojure.string');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.xhttp');
goog.require('fluree.db.util.log');
goog.require('cljs.core.async');
goog.require('fluree.db.util.async');
fluree.db.query.analytical_wikidata.variable_QMARK_ = (function fluree$db$query$analytical_wikidata$variable_QMARK_(form){
if(((((typeof form === 'string') || ((form instanceof cljs.core.Symbol)))) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.first(cljs.core.name(form)),"?")))){
return cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(form);
} else {
return null;
}
});
/**
 * Takes replacement vars, retrieves values from ctx, and puts into Wikidata VALUES statement,
 *   i.e. VALUES (?name ?countryName) {("Vincent van Gogh" "Kingdom of the Netherlands") ("Edvard Munch" "Norway")}
 */
fluree.db.query.analytical_wikidata.replacementVars__GT_ValuesSmt = (function fluree$db$query$analytical_wikidata$replacementVars__GT_ValuesSmt(vars,values){
var value_groups = cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (value_group){
var stringified = cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__108478_SHARP_){
return ["\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__108478_SHARP_),"\""].join('');
}),value_group);
var joined_group = clojure.string.join.cljs$core$IFn$_invoke$arity$2(" ",stringified);
return [" ( ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(joined_group)," ) "].join('');
}),values);
var value_group_str = clojure.string.join.cljs$core$IFn$_invoke$arity$2(" ",value_groups);
return ["VALUES ( ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.cljs$core$IFn$_invoke$arity$2(" ",vars))," ) { ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(value_group_str)," } "].join('');
});
fluree.db.query.analytical_wikidata.get_next_wd_clauses = (function fluree$db$query$analytical_wikidata$get_next_wd_clauses(coll){
var G__108482 = coll;
var vec__108483 = G__108482;
var seq__108484 = cljs.core.seq(vec__108483);
var first__108485 = cljs.core.first(seq__108484);
var seq__108484__$1 = cljs.core.next(seq__108484);
var clause = first__108485;
var r = seq__108484__$1;
var res = cljs.core.PersistentVector.EMPTY;
var G__108482__$1 = G__108482;
var res__$1 = res;
while(true){
var vec__108489 = G__108482__$1;
var seq__108490 = cljs.core.seq(vec__108489);
var first__108491 = cljs.core.first(seq__108490);
var seq__108490__$1 = cljs.core.next(seq__108490);
var clause__$1 = first__108491;
var r__$1 = seq__108490__$1;
var res__$2 = res__$1;
if(cljs.core.truth_(clause__$1)){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("$wd",cljs.core.first(clause__$1))){
var G__108492 = r__$1;
var G__108493 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(res__$2,clause__$1);
G__108482__$1 = G__108492;
res__$1 = G__108493;
continue;
} else {
return res__$2;
}
} else {
return res__$2;
}
break;
}
});
fluree.db.query.analytical_wikidata.get_all_wd_clauses = (function fluree$db$query$analytical_wikidata$get_all_wd_clauses(coll){
var G__108497 = coll;
var vec__108498 = G__108497;
var seq__108499 = cljs.core.seq(vec__108498);
var first__108500 = cljs.core.first(seq__108499);
var seq__108499__$1 = cljs.core.next(seq__108499);
var clause = first__108500;
var r = seq__108499__$1;
var res = cljs.core.PersistentVector.EMPTY;
var G__108497__$1 = G__108497;
var res__$1 = res;
while(true){
var vec__108504 = G__108497__$1;
var seq__108505 = cljs.core.seq(vec__108504);
var first__108506 = cljs.core.first(seq__108505);
var seq__108505__$1 = cljs.core.next(seq__108505);
var clause__$1 = first__108506;
var r__$1 = seq__108505__$1;
var res__$2 = res__$1;
if(cljs.core.truth_(clause__$1)){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("$wd",cljs.core.first(clause__$1))){
var G__108507 = r__$1;
var G__108508 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(res__$2,cljs.core.rest(clause__$1));
G__108497__$1 = G__108507;
res__$1 = G__108508;
continue;
} else {
var G__108509 = r__$1;
var G__108510 = res__$2;
G__108497__$1 = G__108509;
res__$1 = G__108510;
continue;
}
} else {
return res__$2;
}
break;
}
});
fluree.db.query.analytical_wikidata.drop_all_wd_clauses = (function fluree$db$query$analytical_wikidata$drop_all_wd_clauses(coll){
var G__108514 = coll;
var vec__108515 = G__108514;
var seq__108516 = cljs.core.seq(vec__108515);
var first__108517 = cljs.core.first(seq__108516);
var seq__108516__$1 = cljs.core.next(seq__108516);
var clause = first__108517;
var r = seq__108516__$1;
var res = cljs.core.PersistentVector.EMPTY;
var G__108514__$1 = G__108514;
var res__$1 = res;
while(true){
var vec__108521 = G__108514__$1;
var seq__108522 = cljs.core.seq(vec__108521);
var first__108523 = cljs.core.first(seq__108522);
var seq__108522__$1 = cljs.core.next(seq__108522);
var clause__$1 = first__108523;
var r__$1 = seq__108522__$1;
var res__$2 = res__$1;
if(cljs.core.truth_(clause__$1)){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("$wd",cljs.core.first(clause__$1))){
var G__108524 = r__$1;
var G__108525 = res__$2;
G__108514__$1 = G__108524;
res__$1 = G__108525;
continue;
} else {
var G__108526 = r__$1;
var G__108527 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(res__$2,clause__$1);
G__108514__$1 = G__108526;
res__$1 = G__108527;
continue;
}
} else {
return res__$2;
}
break;
}
});
fluree.db.query.analytical_wikidata.wikiDataVar_QMARK_ = (function fluree$db$query$analytical_wikidata$wikiDataVar_QMARK_(string){
if(cljs.core.truth_((function (){var and__4120__auto__ = typeof string === 'string';
if(and__4120__auto__){
return cljs.core.re_matches(/^wd(t)*:(P|Q)\d+$/,string);
} else {
return and__4120__auto__;
}
})())){
cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(string);
} else {
if(typeof string === 'string'){
["\"",string,"\""].join('');
} else {
}
}


return string;
});
fluree.db.query.analytical_wikidata.ad_hoc_clause_to_wikidata = (function fluree$db$query$analytical_wikidata$ad_hoc_clause_to_wikidata(clause,optional_QMARK_){
var clause_str = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.cljs$core$IFn$_invoke$arity$2(" ",cljs.core.map.cljs$core$IFn$_invoke$arity$2(fluree.db.query.analytical_wikidata.wikiDataVar_QMARK_,clause))),"."].join('');
if(cljs.core.truth_(optional_QMARK_)){
return ["OPTIONAL {",clause_str,"}"].join('');
} else {
return clause_str;
}
});
fluree.db.query.analytical_wikidata.parse_prefixes = (function fluree$db$query$analytical_wikidata$parse_prefixes(prefixes){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc_str,prefix){
var pfx = cljs.core.symbol.cljs$core$IFn$_invoke$arity$1([cljs.core.str.cljs$core$IFn$_invoke$arity$1(fluree.db.util.core.keyword__GT_str(cljs.core.key(prefix))),":"].join(''));
var source = cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(cljs.core.val(prefix));
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(acc_str)," PREFIX ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(pfx)," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(source)," \n "].join('');
}),"",prefixes);
});
fluree.db.query.analytical_wikidata.generateWikiDataQuery = (function fluree$db$query$analytical_wikidata$generateWikiDataQuery(q_map,clauses,select_vars,value_clause,optional_clauses){
var _ = (cljs.core.truth_(cljs.core.cst$kw$wikidataOpts.cljs$core$IFn$_invoke$arity$1(q_map))?fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([["The Wikidata query option map should be included in the opts map. Top-level options are being deprecated. Provided: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([q_map], 0))].join('')], 0)):null);
var opts = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$limit,(100),cljs.core.cst$kw$offset,(0),cljs.core.cst$kw$distinct,false,cljs.core.cst$kw$language,"en"], null),cljs.core.cst$kw$wikidataOpts.cljs$core$IFn$_invoke$arity$1(q_map),cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$opts,cljs.core.cst$kw$wikidataOpts], null),q_map)], 0));
var map__108531 = opts;
var map__108531__$1 = (((((!((map__108531 == null))))?(((((map__108531.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__108531.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__108531):map__108531);
var limit = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108531__$1,cljs.core.cst$kw$limit);
var offset = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108531__$1,cljs.core.cst$kw$offset);
var distinct = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108531__$1,cljs.core.cst$kw$distinct);
var language = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108531__$1,cljs.core.cst$kw$language);
var prefixes = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108531__$1,cljs.core.cst$kw$prefixes);
var prefixes__$1 = (cljs.core.truth_(prefixes)?fluree.db.query.analytical_wikidata.parse_prefixes(prefixes):null);
var select_smt = ["SELECT ",(cljs.core.truth_(distinct)?"DISTINCT ":null)," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.cljs$core$IFn$_invoke$arity$2(" ",cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (_,opts,map__108531,map__108531__$1,limit,offset,distinct,language,prefixes,prefixes__$1){
return (function (p1__108528_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__108528_SHARP_),"Label"].join('');
});})(_,opts,map__108531,map__108531__$1,limit,offset,distinct,language,prefixes,prefixes__$1))
,select_vars)))," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.cljs$core$IFn$_invoke$arity$2(" ",select_vars))].join('');
var where_smt = clojure.string.join.cljs$core$IFn$_invoke$arity$2(" ",cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(((function (_,opts,map__108531,map__108531__$1,limit,offset,distinct,language,prefixes,prefixes__$1,select_smt){
return (function (p1__108529_SHARP_){
return fluree.db.query.analytical_wikidata.ad_hoc_clause_to_wikidata(p1__108529_SHARP_,false);
});})(_,opts,map__108531,map__108531__$1,limit,offset,distinct,language,prefixes,prefixes__$1,select_smt))
,clauses));
var optional_smt = clojure.string.join.cljs$core$IFn$_invoke$arity$2(" ",cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(((function (_,opts,map__108531,map__108531__$1,limit,offset,distinct,language,prefixes,prefixes__$1,select_smt,where_smt){
return (function (p1__108530_SHARP_){
return fluree.db.query.analytical_wikidata.ad_hoc_clause_to_wikidata(p1__108530_SHARP_,true);
});})(_,opts,map__108531,map__108531__$1,limit,offset,distinct,language,prefixes,prefixes__$1,select_smt,where_smt))
,optional_clauses));
var serviceLabel = ["SERVICE wikibase:label { bd:serviceParam wikibase:language \"",cljs.core.str.cljs$core$IFn$_invoke$arity$1((function (){var or__4131__auto__ = language;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "en";
}
})()),"\" . }"].join('');
var full_query = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(prefixes__$1)," ",select_smt," WHERE { ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(value_clause)," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(where_smt)," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(optional_smt)," ",serviceLabel," } ",(cljs.core.truth_(limit)?["\n                          LIMIT ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(limit)].join(''):null)," OFFSET ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(offset)].join('');
return full_query;
});
fluree.db.query.analytical_wikidata.wikidataURL = "https://query.wikidata.org/bigdata/namespace/wdq/sparql?format=json&query=";
fluree.db.query.analytical_wikidata.submit_wikidata_query = (function fluree$db$query$analytical_wikidata$submit_wikidata_query(query){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_108546){
var state_val_108547 = (state_108546[(1)]);
if((state_val_108547 === (1))){
var inst_108533 = fluree.db.util.core.url_encode(query);
var inst_108534 = [fluree.db.query.analytical_wikidata.wikidataURL,cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_108533)].join('');
var inst_108535 = ["User-Agent","Accept"];
var inst_108536 = ["Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/50.0.2661.102 Safari/537.36","application/sparql-results+json"];
var inst_108537 = cljs.core.PersistentHashMap.fromArrays(inst_108535,inst_108536);
var inst_108538 = [cljs.core.cst$kw$headers,cljs.core.cst$kw$request_DASH_timeout,cljs.core.cst$kw$output_DASH_format];
var inst_108539 = [inst_108537,(30000),cljs.core.cst$kw$wikidata];
var inst_108540 = cljs.core.PersistentHashMap.fromArrays(inst_108538,inst_108539);
var inst_108541 = fluree.db.util.xhttp.get(inst_108534,inst_108540);
var state_108546__$1 = state_108546;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108546__$1,(2),inst_108541);
} else {
if((state_val_108547 === (2))){
var inst_108543 = (state_108546[(2)]);
var inst_108544 = fluree.db.util.async.throw_err(inst_108543);
var state_108546__$1 = state_108546;
return cljs.core.async.impl.ioc_helpers.return_chan(state_108546__$1,inst_108544);
} else {
return null;
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto__ = null;
var fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto____0 = (function (){
var statearr_108548 = [null,null,null,null,null,null,null];
(statearr_108548[(0)] = fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto__);

(statearr_108548[(1)] = (1));

return statearr_108548;
});
var fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto____1 = (function (state_108546){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_108546);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e108549){if((e108549 instanceof Object)){
var ex__99706__auto__ = e108549;
var statearr_108550_108552 = state_108546;
(statearr_108550_108552[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_108546);

return cljs.core.cst$kw$recur;
} else {
throw e108549;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__108553 = state_108546;
state_108546 = G__108553;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto__ = function(state_108546){
switch(arguments.length){
case 0:
return fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto____1.call(this,state_108546);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto____0;
fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto____1;
return fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_108551 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_108551[(6)] = c__99809__auto__);

return statearr_108551;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.query.analytical_wikidata.submit_PLUS_parse_wikidata_query = (function fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query(query){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_108571){
var state_val_108572 = (state_108571[(1)]);
if((state_val_108572 === (1))){
var inst_108554 = fluree.db.query.analytical_wikidata.submit_wikidata_query(query);
var state_108571__$1 = state_108571;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108571__$1,(2),inst_108554);
} else {
if((state_val_108572 === (2))){
var inst_108557 = (state_108571[(7)]);
var inst_108556 = (state_108571[(2)]);
var inst_108557__$1 = fluree.db.util.async.throw_err(inst_108556);
var inst_108558 = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(inst_108557__$1);
var inst_108559 = cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2((200),inst_108558);
var state_108571__$1 = (function (){var statearr_108573 = state_108571;
(statearr_108573[(7)] = inst_108557__$1);

return statearr_108573;
})();
if(inst_108559){
var statearr_108574_108582 = state_108571__$1;
(statearr_108574_108582[(1)] = (3));

} else {
var statearr_108575_108583 = state_108571__$1;
(statearr_108575_108583[(1)] = (4));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108572 === (3))){
var inst_108557 = (state_108571[(7)]);
var state_108571__$1 = state_108571;
var statearr_108576_108584 = state_108571__$1;
(statearr_108576_108584[(2)] = inst_108557);

(statearr_108576_108584[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108572 === (4))){
var inst_108557 = (state_108571[(7)]);
var inst_108562 = (function (){var body = inst_108557;
return ((function (body,inst_108557,state_val_108572,c__99809__auto__){
return (function (item){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (body,inst_108557,state_val_108572,c__99809__auto__){
return (function (acc,k_v){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(acc,cljs.core.key(k_v),cljs.core.cst$kw$value.cljs$core$IFn$_invoke$arity$1(cljs.core.val(k_v)));
});})(body,inst_108557,state_val_108572,c__99809__auto__))
,cljs.core.PersistentArrayMap.EMPTY,item);
});
;})(body,inst_108557,state_val_108572,c__99809__auto__))
})();
var inst_108563 = cljs.core.second(inst_108557);
var inst_108564 = cljs.core.second(inst_108563);
var inst_108565 = cljs.core.first(inst_108564);
var inst_108566 = cljs.core.second(inst_108565);
var inst_108567 = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(inst_108562,inst_108566);
var state_108571__$1 = state_108571;
var statearr_108577_108585 = state_108571__$1;
(statearr_108577_108585[(2)] = inst_108567);

(statearr_108577_108585[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108572 === (5))){
var inst_108569 = (state_108571[(2)]);
var state_108571__$1 = state_108571;
return cljs.core.async.impl.ioc_helpers.return_chan(state_108571__$1,inst_108569);
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto__ = null;
var fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto____0 = (function (){
var statearr_108578 = [null,null,null,null,null,null,null,null];
(statearr_108578[(0)] = fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto__);

(statearr_108578[(1)] = (1));

return statearr_108578;
});
var fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto____1 = (function (state_108571){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_108571);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e108579){if((e108579 instanceof Object)){
var ex__99706__auto__ = e108579;
var statearr_108580_108586 = state_108571;
(statearr_108580_108586[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_108571);

return cljs.core.cst$kw$recur;
} else {
throw e108579;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__108587 = state_108571;
state_108571 = G__108587;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto__ = function(state_108571){
switch(arguments.length){
case 0:
return fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto____1.call(this,state_108571);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto____0;
fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto____1;
return fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_108581 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_108581[(6)] = c__99809__auto__);

return statearr_108581;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.query.analytical_wikidata.wikiDataResp__GT_tuples = (function fluree$db$query$analytical_wikidata$wikiDataResp__GT_tuples(wikidataRes,vars){
var labelVars = cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__108588_SHARP_){
return cljs.core.symbol.cljs$core$IFn$_invoke$arity$1([cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__108588_SHARP_),"Label"].join(''));
}),vars);
var headers = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,vars),labelVars);
var headers_as_kws = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (labelVars,headers){
return (function (p1__108589_SHARP_){
return fluree.db.util.core.str__GT_keyword(cljs.core.subs.cljs$core$IFn$_invoke$arity$2(cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__108589_SHARP_),(1)));
});})(labelVars,headers))
,headers);
var results = cljs.core.cst$kw$bindings.cljs$core$IFn$_invoke$arity$1(cljs.core.cst$kw$results.cljs$core$IFn$_invoke$arity$1(wikidataRes));
var tuples = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (labelVars,headers,headers_as_kws,results){
return (function (res){
return cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (labelVars,headers,headers_as_kws,results){
return (function (p1__108590_SHARP_){
return cljs.core.cst$kw$value.cljs$core$IFn$_invoke$arity$1((p1__108590_SHARP_.cljs$core$IFn$_invoke$arity$1 ? p1__108590_SHARP_.cljs$core$IFn$_invoke$arity$1(res) : p1__108590_SHARP_.call(null,res)));
});})(labelVars,headers,headers_as_kws,results))
,headers_as_kws);
});})(labelVars,headers,headers_as_kws,results))
,results);
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$headers,headers,cljs.core.cst$kw$vars,cljs.core.PersistentArrayMap.EMPTY,cljs.core.cst$kw$tuples,tuples], null);
});
fluree.db.query.analytical_wikidata.get_wikidata_tuples = (function fluree$db$query$analytical_wikidata$get_wikidata_tuples(q_map,clauses,matching_vars,matching_vals,all_vars,optional_clauses){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_108625){
var state_val_108626 = (state_108625[(1)]);
if((state_val_108626 === (7))){
var inst_108600 = (state_108625[(2)]);
var inst_108601 = fluree.db.query.analytical_wikidata.generateWikiDataQuery(q_map,clauses,all_vars,inst_108600,optional_clauses);
var inst_108602 = fluree.db.query.analytical_wikidata.submit_PLUS_parse_wikidata_query(inst_108601);
var state_108625__$1 = state_108625;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108625__$1,(8),inst_108602);
} else {
if((state_val_108626 === (1))){
var state_108625__$1 = state_108625;
var statearr_108627_108643 = state_108625__$1;
(statearr_108627_108643[(2)] = null);

(statearr_108627_108643[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108626 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_108625,(3),Error,null,(2));
var inst_108595 = cljs.core.empty_QMARK_(matching_vars);
var state_108625__$1 = state_108625;
if(inst_108595){
var statearr_108628_108644 = state_108625__$1;
(statearr_108628_108644[(1)] = (5));

} else {
var statearr_108629_108645 = state_108625__$1;
(statearr_108629_108645[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108626 === (6))){
var inst_108598 = fluree.db.query.analytical_wikidata.replacementVars__GT_ValuesSmt(matching_vars,matching_vals);
var state_108625__$1 = state_108625;
var statearr_108630_108646 = state_108625__$1;
(statearr_108630_108646[(2)] = inst_108598);

(statearr_108630_108646[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108626 === (3))){
var inst_108591 = (state_108625[(2)]);
var state_108625__$1 = state_108625;
var statearr_108631_108647 = state_108625__$1;
(statearr_108631_108647[(2)] = inst_108591);


cljs.core.async.impl.ioc_helpers.process_exception(state_108625__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108626 === (2))){
var inst_108623 = (state_108625[(2)]);
var state_108625__$1 = state_108625;
return cljs.core.async.impl.ioc_helpers.return_chan(state_108625__$1,inst_108623);
} else {
if((state_val_108626 === (11))){
var inst_108621 = (state_108625[(2)]);
var state_108625__$1 = state_108625;
var statearr_108632_108648 = state_108625__$1;
(statearr_108632_108648[(2)] = inst_108621);


cljs.core.async.impl.ioc_helpers.process_exception(state_108625__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108626 === (9))){
var inst_108605 = (state_108625[(7)]);
var inst_108609 = cljs.core.cst$kw$message.cljs$core$IFn$_invoke$arity$1(inst_108605);
var inst_108610 = cljs.core.subs.cljs$core$IFn$_invoke$arity$3(inst_108609,(0),(1000));
var inst_108611 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_108612 = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(inst_108605);
var inst_108613 = cljs.core.cst$kw$error.cljs$core$IFn$_invoke$arity$1(inst_108605);
var inst_108614 = [inst_108612,inst_108613];
var inst_108615 = cljs.core.PersistentHashMap.fromArrays(inst_108611,inst_108614);
var inst_108616 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_108610,inst_108615);
var inst_108617 = (function(){throw inst_108616})();
var state_108625__$1 = state_108625;
var statearr_108633_108649 = state_108625__$1;
(statearr_108633_108649[(2)] = inst_108617);

(statearr_108633_108649[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108626 === (5))){
var state_108625__$1 = state_108625;
var statearr_108634_108650 = state_108625__$1;
(statearr_108634_108650[(2)] = null);

(statearr_108634_108650[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108626 === (10))){
var inst_108605 = (state_108625[(7)]);
var inst_108619 = fluree.db.query.analytical_wikidata.wikiDataResp__GT_tuples(inst_108605,all_vars);
var state_108625__$1 = state_108625;
var statearr_108635_108651 = state_108625__$1;
(statearr_108635_108651[(2)] = inst_108619);

(statearr_108635_108651[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108626 === (8))){
var inst_108605 = (state_108625[(7)]);
var inst_108604 = (state_108625[(2)]);
var inst_108605__$1 = fluree.db.util.async.throw_err(inst_108604);
var inst_108606 = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(inst_108605__$1);
var inst_108607 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((400),inst_108606);
var state_108625__$1 = (function (){var statearr_108636 = state_108625;
(statearr_108636[(7)] = inst_108605__$1);

return statearr_108636;
})();
if(inst_108607){
var statearr_108637_108652 = state_108625__$1;
(statearr_108637_108652[(1)] = (9));

} else {
var statearr_108638_108653 = state_108625__$1;
(statearr_108638_108653[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto__ = null;
var fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto____0 = (function (){
var statearr_108639 = [null,null,null,null,null,null,null,null];
(statearr_108639[(0)] = fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto__);

(statearr_108639[(1)] = (1));

return statearr_108639;
});
var fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto____1 = (function (state_108625){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_108625);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e108640){if((e108640 instanceof Object)){
var ex__99706__auto__ = e108640;
var statearr_108641_108654 = state_108625;
(statearr_108641_108654[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_108625);

return cljs.core.cst$kw$recur;
} else {
throw e108640;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__108655 = state_108625;
state_108625 = G__108655;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto__ = function(state_108625){
switch(arguments.length){
case 0:
return fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto____1.call(this,state_108625);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto____0;
fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto____1;
return fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_108642 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_108642[(6)] = c__99809__auto__);

return statearr_108642;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
