// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.time_travel');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.util.core');
goog.require('fluree.db.query.range');
goog.require('clojure.string');
goog.require('fluree.db.flake');
goog.require('fluree.db.util.async');
/**
 * Given a duration, returns a ISO-8601 formatted time string of now minus duration
 */
fluree.db.time_travel.duration_parse = (function fluree$db$time_travel$duration_parse(time_str){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Duration timeframes not yet supported in javascript.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_platform_DASH_support], null));
});
fluree.db.time_travel.time_to_t = (function fluree$db$time_travel$time_to_t(db,time_str){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_107710){
var state_val_107711 = (state_107710[(1)]);
if((state_val_107711 === (7))){
var inst_107663 = (state_107710[(7)]);
var inst_107661 = (state_107710[(2)]);
var inst_107663__$1 = fluree.db.dbproto._rootdb(db);
var inst_107664 = (inst_107663__$1 == null);
var state_107710__$1 = (function (){var statearr_107712 = state_107710;
(statearr_107712[(8)] = inst_107661);

(statearr_107712[(7)] = inst_107663__$1);

return statearr_107712;
})();
if(cljs.core.truth_(inst_107664)){
var statearr_107713_107747 = state_107710__$1;
(statearr_107713_107747[(1)] = (8));

} else {
var statearr_107714_107748 = state_107710__$1;
(statearr_107714_107748[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (20))){
var inst_107706 = (state_107710[(2)]);
var state_107710__$1 = state_107710;
var statearr_107715_107749 = state_107710__$1;
(statearr_107715_107749[(2)] = inst_107706);


cljs.core.async.impl.ioc_helpers.process_exception(state_107710__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (1))){
var state_107710__$1 = state_107710;
var statearr_107716_107750 = state_107710__$1;
(statearr_107716_107750[(2)] = null);

(statearr_107716_107750[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_107710,(3),Error,null,(2));
var inst_107656 = typeof time_str === 'string';
var state_107710__$1 = state_107710;
if(cljs.core.truth_(inst_107656)){
var statearr_107717_107751 = state_107710__$1;
(statearr_107717_107751[(1)] = (5));

} else {
var statearr_107718_107752 = state_107710__$1;
(statearr_107718_107752[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (15))){
var inst_107661 = (state_107710[(8)]);
var inst_107686 = ["There is no data as of ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_107661)].join('');
var inst_107687 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_107688 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_block];
var inst_107689 = cljs.core.PersistentHashMap.fromArrays(inst_107687,inst_107688);
var inst_107690 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_107686,inst_107689);
var inst_107691 = (function(){throw inst_107690})();
var state_107710__$1 = state_107710;
var statearr_107719_107753 = state_107710__$1;
(statearr_107719_107753[(2)] = inst_107691);

(statearr_107719_107753[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (21))){
var inst_107696 = (state_107710[(9)]);
var state_107710__$1 = state_107710;
var statearr_107720_107754 = state_107710__$1;
(statearr_107720_107754[(2)] = inst_107696);

(statearr_107720_107754[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (13))){
var inst_107683 = (state_107710[(10)]);
var inst_107683__$1 = (state_107710[(2)]);
var inst_107684 = cljs.core.empty_QMARK_(inst_107683__$1);
var state_107710__$1 = (function (){var statearr_107721 = state_107710;
(statearr_107721[(10)] = inst_107683__$1);

return statearr_107721;
})();
if(inst_107684){
var statearr_107722_107755 = state_107710__$1;
(statearr_107722_107755[(1)] = (15));

} else {
var statearr_107723_107756 = state_107710__$1;
(statearr_107723_107756[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (22))){
var inst_107702 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(db);
var state_107710__$1 = state_107710;
var statearr_107724_107757 = state_107710__$1;
(statearr_107724_107757[(2)] = inst_107702);

(statearr_107724_107757[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (6))){
var state_107710__$1 = state_107710;
var statearr_107725_107758 = state_107710__$1;
(statearr_107725_107758[(2)] = time_str);

(statearr_107725_107758[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (17))){
var inst_107661 = (state_107710[(8)]);
var inst_107697 = (state_107710[(11)]);
var inst_107683 = (state_107710[(10)]);
var inst_107696 = (state_107710[(9)]);
var inst_107694 = (state_107710[(2)]);
var inst_107695 = (function (){var epoch_as_of = inst_107661;
var ts = inst_107683;
var _ = inst_107694;
return ((function (epoch_as_of,ts,_,inst_107661,inst_107697,inst_107683,inst_107696,inst_107694,state_val_107711,c__99809__auto__){
return (function (p1__107651_SHARP_){
return p1__107651_SHARP_.s;
});
;})(epoch_as_of,ts,_,inst_107661,inst_107697,inst_107683,inst_107696,inst_107694,state_val_107711,c__99809__auto__))
})();
var inst_107696__$1 = cljs.core.apply.cljs$core$IFn$_invoke$arity$3(cljs.core.min_key,inst_107695,inst_107683);
var inst_107697__$1 = inst_107696__$1.s;
var state_107710__$1 = (function (){var statearr_107726 = state_107710;
(statearr_107726[(11)] = inst_107697__$1);

(statearr_107726[(9)] = inst_107696__$1);

return statearr_107726;
})();
if(cljs.core.truth_(inst_107697__$1)){
var statearr_107727_107759 = state_107710__$1;
(statearr_107727_107759[(1)] = (18));

} else {
var statearr_107728_107760 = state_107710__$1;
(statearr_107728_107760[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (3))){
var inst_107652 = (state_107710[(2)]);
var state_107710__$1 = state_107710;
var statearr_107729_107761 = state_107710__$1;
(statearr_107729_107761[(2)] = inst_107652);


cljs.core.async.impl.ioc_helpers.process_exception(state_107710__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (12))){
var inst_107675 = (state_107710[(12)]);
var state_107710__$1 = state_107710;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_107710__$1,(14),inst_107675);
} else {
if((state_val_107711 === (2))){
var inst_107708 = (state_107710[(2)]);
var state_107710__$1 = state_107710;
return cljs.core.async.impl.ioc_helpers.return_chan(state_107710__$1,inst_107708);
} else {
if((state_val_107711 === (23))){
var inst_107704 = (state_107710[(2)]);
var state_107710__$1 = state_107710;
var statearr_107730_107762 = state_107710__$1;
(statearr_107730_107762[(2)] = inst_107704);

(statearr_107730_107762[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (19))){
var inst_107696 = (state_107710[(9)]);
var state_107710__$1 = state_107710;
if(cljs.core.truth_(inst_107696)){
var statearr_107731_107763 = state_107710__$1;
(statearr_107731_107763[(1)] = (21));

} else {
var statearr_107732_107764 = state_107710__$1;
(statearr_107732_107764[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (11))){
var state_107710__$1 = state_107710;
var statearr_107733_107765 = state_107710__$1;
(statearr_107733_107765[(2)] = null);

(statearr_107733_107765[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (9))){
var inst_107661 = (state_107710[(8)]);
var inst_107663 = (state_107710[(7)]);
var inst_107667 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_107668 = ["_block/instant",(0)];
var inst_107669 = (new cljs.core.PersistentVector(null,2,(5),inst_107667,inst_107668,null));
var inst_107670 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_107671 = ["_block/instant",inst_107661];
var inst_107672 = (new cljs.core.PersistentVector(null,2,(5),inst_107670,inst_107671,null));
var inst_107673 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$6(inst_107663,cljs.core.cst$kw$post,cljs.core._GT_,inst_107669,cljs.core._LT_,inst_107672);
var state_107710__$1 = state_107710;
var statearr_107734_107766 = state_107710__$1;
(statearr_107734_107766[(2)] = inst_107673);

(statearr_107734_107766[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (5))){
var inst_107658 = fluree.db.util.core.str__GT_epoch_ms(time_str);
var state_107710__$1 = state_107710;
var statearr_107735_107767 = state_107710__$1;
(statearr_107735_107767[(2)] = inst_107658);

(statearr_107735_107767[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (14))){
var inst_107680 = (state_107710[(2)]);
var inst_107681 = fluree.db.util.async.throw_err(inst_107680);
var state_107710__$1 = state_107710;
var statearr_107736_107768 = state_107710__$1;
(statearr_107736_107768[(2)] = inst_107681);

(statearr_107736_107768[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (16))){
var state_107710__$1 = state_107710;
var statearr_107737_107769 = state_107710__$1;
(statearr_107737_107769[(2)] = null);

(statearr_107737_107769[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (10))){
var inst_107675 = (state_107710[(12)]);
var inst_107675__$1 = (state_107710[(2)]);
var inst_107676 = (inst_107675__$1 == null);
var state_107710__$1 = (function (){var statearr_107738 = state_107710;
(statearr_107738[(12)] = inst_107675__$1);

return statearr_107738;
})();
if(cljs.core.truth_(inst_107676)){
var statearr_107739_107770 = state_107710__$1;
(statearr_107739_107770[(1)] = (11));

} else {
var statearr_107740_107771 = state_107710__$1;
(statearr_107740_107771[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (18))){
var inst_107697 = (state_107710[(11)]);
var state_107710__$1 = state_107710;
var statearr_107741_107772 = state_107710__$1;
(statearr_107741_107772[(2)] = inst_107697);

(statearr_107741_107772[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107711 === (8))){
var state_107710__$1 = state_107710;
var statearr_107742_107773 = state_107710__$1;
(statearr_107742_107773[(2)] = null);

(statearr_107742_107773[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$time_travel$time_to_t_$_state_machine__99703__auto__ = null;
var fluree$db$time_travel$time_to_t_$_state_machine__99703__auto____0 = (function (){
var statearr_107743 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_107743[(0)] = fluree$db$time_travel$time_to_t_$_state_machine__99703__auto__);

(statearr_107743[(1)] = (1));

return statearr_107743;
});
var fluree$db$time_travel$time_to_t_$_state_machine__99703__auto____1 = (function (state_107710){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_107710);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e107744){if((e107744 instanceof Object)){
var ex__99706__auto__ = e107744;
var statearr_107745_107774 = state_107710;
(statearr_107745_107774[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_107710);

return cljs.core.cst$kw$recur;
} else {
throw e107744;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__107775 = state_107710;
state_107710 = G__107775;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$time_travel$time_to_t_$_state_machine__99703__auto__ = function(state_107710){
switch(arguments.length){
case 0:
return fluree$db$time_travel$time_to_t_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$time_travel$time_to_t_$_state_machine__99703__auto____1.call(this,state_107710);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$time_to_t_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$time_to_t_$_state_machine__99703__auto____0;
fluree$db$time_travel$time_to_t_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$time_to_t_$_state_machine__99703__auto____1;
return fluree$db$time_travel$time_to_t_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_107746 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_107746[(6)] = c__99809__auto__);

return statearr_107746;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.time_travel.t_to_block = (function fluree$db$time_travel$t_to_block(db,t){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_107825){
var state_val_107826 = (state_107825[(1)]);
if((state_val_107826 === (7))){
var inst_107796 = (state_107825[(7)]);
var inst_107796__$1 = (state_107825[(2)]);
var inst_107797 = (inst_107796__$1 == null);
var state_107825__$1 = (function (){var statearr_107827 = state_107825;
(statearr_107827[(7)] = inst_107796__$1);

return statearr_107827;
})();
if(cljs.core.truth_(inst_107797)){
var statearr_107828_107859 = state_107825__$1;
(statearr_107828_107859[(1)] = (8));

} else {
var statearr_107829_107860 = state_107825__$1;
(statearr_107829_107860[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (20))){
var inst_107821 = (state_107825[(2)]);
var state_107825__$1 = state_107825;
var statearr_107830_107861 = state_107825__$1;
(statearr_107830_107861[(2)] = inst_107821);


cljs.core.async.impl.ioc_helpers.process_exception(state_107825__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (1))){
var state_107825__$1 = state_107825;
var statearr_107831_107862 = state_107825__$1;
(statearr_107831_107862[(2)] = null);

(statearr_107831_107862[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (4))){
var inst_107781 = (state_107825[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_107825,(3),Error,null,(2));
var inst_107781__$1 = fluree.db.dbproto._rootdb(db);
var inst_107782 = (inst_107781__$1 == null);
var state_107825__$1 = (function (){var statearr_107832 = state_107825;
(statearr_107832[(8)] = inst_107781__$1);

return statearr_107832;
})();
if(cljs.core.truth_(inst_107782)){
var statearr_107833_107863 = state_107825__$1;
(statearr_107833_107863[(1)] = (5));

} else {
var statearr_107834_107864 = state_107825__$1;
(statearr_107834_107864[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (15))){
var state_107825__$1 = state_107825;
var statearr_107835_107865 = state_107825__$1;
(statearr_107835_107865[(2)] = null);

(statearr_107835_107865[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (13))){
var inst_107804 = (state_107825[(9)]);
var inst_107808 = cljs.core.first(inst_107804);
var state_107825__$1 = state_107825;
var statearr_107836_107866 = state_107825__$1;
(statearr_107836_107866[(2)] = inst_107808);

(statearr_107836_107866[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (6))){
var inst_107781 = (state_107825[(8)]);
var inst_107785 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_107786 = ["_block/number",t];
var inst_107787 = (new cljs.core.PersistentVector(null,2,(5),inst_107785,inst_107786,null));
var inst_107788 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_107789 = ["_block/number"];
var inst_107790 = (new cljs.core.PersistentVector(null,1,(5),inst_107788,inst_107789,null));
var inst_107791 = [cljs.core.cst$kw$limit];
var inst_107792 = [(1)];
var inst_107793 = cljs.core.PersistentHashMap.fromArrays(inst_107791,inst_107792);
var inst_107794 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$7(inst_107781,cljs.core.cst$kw$psot,cljs.core._GT__EQ_,inst_107787,cljs.core._LT__EQ_,inst_107790,inst_107793);
var state_107825__$1 = state_107825;
var statearr_107837_107867 = state_107825__$1;
(statearr_107837_107867[(2)] = inst_107794);

(statearr_107837_107867[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (17))){
var inst_107816 = (state_107825[(10)]);
var inst_107816__$1 = (state_107825[(2)]);
var inst_107817 = (inst_107816__$1 > (1));
var state_107825__$1 = (function (){var statearr_107838 = state_107825;
(statearr_107838[(10)] = inst_107816__$1);

return statearr_107838;
})();
if(cljs.core.truth_(inst_107817)){
var statearr_107839_107868 = state_107825__$1;
(statearr_107839_107868[(1)] = (18));

} else {
var statearr_107840_107869 = state_107825__$1;
(statearr_107840_107869[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (3))){
var inst_107776 = (state_107825[(2)]);
var state_107825__$1 = state_107825;
var statearr_107841_107870 = state_107825__$1;
(statearr_107841_107870[(2)] = inst_107776);


cljs.core.async.impl.ioc_helpers.process_exception(state_107825__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (12))){
var state_107825__$1 = state_107825;
var statearr_107842_107871 = state_107825__$1;
(statearr_107842_107871[(2)] = null);

(statearr_107842_107871[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (2))){
var inst_107823 = (state_107825[(2)]);
var state_107825__$1 = state_107825;
return cljs.core.async.impl.ioc_helpers.return_chan(state_107825__$1,inst_107823);
} else {
if((state_val_107826 === (19))){
var state_107825__$1 = state_107825;
var statearr_107843_107872 = state_107825__$1;
(statearr_107843_107872[(2)] = (1));

(statearr_107843_107872[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (11))){
var inst_107801 = (state_107825[(2)]);
var inst_107802 = fluree.db.util.async.throw_err(inst_107801);
var state_107825__$1 = state_107825;
var statearr_107844_107873 = state_107825__$1;
(statearr_107844_107873[(2)] = inst_107802);

(statearr_107844_107873[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (9))){
var inst_107796 = (state_107825[(7)]);
var state_107825__$1 = state_107825;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_107825__$1,(11),inst_107796);
} else {
if((state_val_107826 === (5))){
var state_107825__$1 = state_107825;
var statearr_107845_107874 = state_107825__$1;
(statearr_107845_107874[(2)] = null);

(statearr_107845_107874[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (14))){
var inst_107810 = (state_107825[(11)]);
var inst_107810__$1 = (state_107825[(2)]);
var inst_107811 = (inst_107810__$1 == null);
var state_107825__$1 = (function (){var statearr_107846 = state_107825;
(statearr_107846[(11)] = inst_107810__$1);

return statearr_107846;
})();
if(cljs.core.truth_(inst_107811)){
var statearr_107847_107875 = state_107825__$1;
(statearr_107847_107875[(1)] = (15));

} else {
var statearr_107848_107876 = state_107825__$1;
(statearr_107848_107876[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (16))){
var inst_107810 = (state_107825[(11)]);
var inst_107814 = inst_107810.o;
var state_107825__$1 = state_107825;
var statearr_107849_107877 = state_107825__$1;
(statearr_107849_107877[(2)] = inst_107814);

(statearr_107849_107877[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (10))){
var inst_107804 = (state_107825[(9)]);
var inst_107804__$1 = (state_107825[(2)]);
var inst_107805 = (inst_107804__$1 == null);
var state_107825__$1 = (function (){var statearr_107850 = state_107825;
(statearr_107850[(9)] = inst_107804__$1);

return statearr_107850;
})();
if(cljs.core.truth_(inst_107805)){
var statearr_107851_107878 = state_107825__$1;
(statearr_107851_107878[(1)] = (12));

} else {
var statearr_107852_107879 = state_107825__$1;
(statearr_107852_107879[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (18))){
var inst_107816 = (state_107825[(10)]);
var state_107825__$1 = state_107825;
var statearr_107853_107880 = state_107825__$1;
(statearr_107853_107880[(2)] = inst_107816);

(statearr_107853_107880[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107826 === (8))){
var state_107825__$1 = state_107825;
var statearr_107854_107881 = state_107825__$1;
(statearr_107854_107881[(2)] = null);

(statearr_107854_107881[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$time_travel$t_to_block_$_state_machine__99703__auto__ = null;
var fluree$db$time_travel$t_to_block_$_state_machine__99703__auto____0 = (function (){
var statearr_107855 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_107855[(0)] = fluree$db$time_travel$t_to_block_$_state_machine__99703__auto__);

(statearr_107855[(1)] = (1));

return statearr_107855;
});
var fluree$db$time_travel$t_to_block_$_state_machine__99703__auto____1 = (function (state_107825){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_107825);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e107856){if((e107856 instanceof Object)){
var ex__99706__auto__ = e107856;
var statearr_107857_107882 = state_107825;
(statearr_107857_107882[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_107825);

return cljs.core.cst$kw$recur;
} else {
throw e107856;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__107883 = state_107825;
state_107825 = G__107883;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$time_travel$t_to_block_$_state_machine__99703__auto__ = function(state_107825){
switch(arguments.length){
case 0:
return fluree$db$time_travel$t_to_block_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$time_travel$t_to_block_$_state_machine__99703__auto____1.call(this,state_107825);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$t_to_block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$t_to_block_$_state_machine__99703__auto____0;
fluree$db$time_travel$t_to_block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$t_to_block_$_state_machine__99703__auto____1;
return fluree$db$time_travel$t_to_block_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_107858 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_107858[(6)] = c__99809__auto__);

return statearr_107858;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.time_travel.non_border_t_to_block = (function fluree$db$time_travel$non_border_t_to_block(db,t){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_107931){
var state_val_107932 = (state_107931[(1)]);
if((state_val_107932 === (7))){
var inst_107898 = (state_107931[(7)]);
var inst_107898__$1 = (state_107931[(2)]);
var inst_107899 = (inst_107898__$1 == null);
var state_107931__$1 = (function (){var statearr_107933 = state_107931;
(statearr_107933[(7)] = inst_107898__$1);

return statearr_107933;
})();
if(cljs.core.truth_(inst_107899)){
var statearr_107934_107965 = state_107931__$1;
(statearr_107934_107965[(1)] = (8));

} else {
var statearr_107935_107966 = state_107931__$1;
(statearr_107935_107966[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (20))){
var state_107931__$1 = state_107931;
var statearr_107936_107967 = state_107931__$1;
(statearr_107936_107967[(2)] = (1));

(statearr_107936_107967[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (1))){
var state_107931__$1 = state_107931;
var statearr_107937_107968 = state_107931__$1;
(statearr_107937_107968[(2)] = null);

(statearr_107937_107968[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (4))){
var inst_107889 = (state_107931[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_107931,(3),Error,null,(2));
var inst_107889__$1 = fluree.db.dbproto._rootdb(db);
var inst_107890 = (inst_107889__$1 == null);
var state_107931__$1 = (function (){var statearr_107938 = state_107931;
(statearr_107938[(8)] = inst_107889__$1);

return statearr_107938;
})();
if(cljs.core.truth_(inst_107890)){
var statearr_107939_107969 = state_107931__$1;
(statearr_107939_107969[(1)] = (5));

} else {
var statearr_107940_107970 = state_107931__$1;
(statearr_107940_107970[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (15))){
var state_107931__$1 = state_107931;
var statearr_107941_107971 = state_107931__$1;
(statearr_107941_107971[(2)] = null);

(statearr_107941_107971[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (21))){
var inst_107927 = (state_107931[(2)]);
var state_107931__$1 = state_107931;
var statearr_107942_107972 = state_107931__$1;
(statearr_107942_107972[(2)] = inst_107927);


cljs.core.async.impl.ioc_helpers.process_exception(state_107931__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (13))){
var inst_107906 = (state_107931[(9)]);
var inst_107910 = cljs.core.first(inst_107906);
var state_107931__$1 = state_107931;
var statearr_107943_107973 = state_107931__$1;
(statearr_107943_107973[(2)] = inst_107910);

(statearr_107943_107973[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (6))){
var inst_107889 = (state_107931[(8)]);
var inst_107893 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_107894 = [t,"_block/transactions"];
var inst_107895 = (new cljs.core.PersistentVector(null,2,(5),inst_107893,inst_107894,null));
var inst_107896 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(inst_107889,cljs.core.cst$kw$opst,cljs.core._EQ_,inst_107895);
var state_107931__$1 = state_107931;
var statearr_107944_107974 = state_107931__$1;
(statearr_107944_107974[(2)] = inst_107896);

(statearr_107944_107974[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (17))){
var inst_107918 = (state_107931[(2)]);
var inst_107919 = fluree.db.time_travel.t_to_block(db,inst_107918);
var state_107931__$1 = state_107931;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_107931__$1,(18),inst_107919);
} else {
if((state_val_107932 === (3))){
var inst_107884 = (state_107931[(2)]);
var state_107931__$1 = state_107931;
var statearr_107945_107975 = state_107931__$1;
(statearr_107945_107975[(2)] = inst_107884);


cljs.core.async.impl.ioc_helpers.process_exception(state_107931__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (12))){
var state_107931__$1 = state_107931;
var statearr_107946_107976 = state_107931__$1;
(statearr_107946_107976[(2)] = null);

(statearr_107946_107976[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (2))){
var inst_107929 = (state_107931[(2)]);
var state_107931__$1 = state_107931;
return cljs.core.async.impl.ioc_helpers.return_chan(state_107931__$1,inst_107929);
} else {
if((state_val_107932 === (19))){
var inst_107922 = (state_107931[(10)]);
var state_107931__$1 = state_107931;
var statearr_107947_107977 = state_107931__$1;
(statearr_107947_107977[(2)] = inst_107922);

(statearr_107947_107977[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (11))){
var inst_107903 = (state_107931[(2)]);
var inst_107904 = fluree.db.util.async.throw_err(inst_107903);
var state_107931__$1 = state_107931;
var statearr_107948_107978 = state_107931__$1;
(statearr_107948_107978[(2)] = inst_107904);

(statearr_107948_107978[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (9))){
var inst_107898 = (state_107931[(7)]);
var state_107931__$1 = state_107931;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_107931__$1,(11),inst_107898);
} else {
if((state_val_107932 === (5))){
var state_107931__$1 = state_107931;
var statearr_107949_107979 = state_107931__$1;
(statearr_107949_107979[(2)] = null);

(statearr_107949_107979[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (14))){
var inst_107912 = (state_107931[(11)]);
var inst_107912__$1 = (state_107931[(2)]);
var inst_107913 = (inst_107912__$1 == null);
var state_107931__$1 = (function (){var statearr_107950 = state_107931;
(statearr_107950[(11)] = inst_107912__$1);

return statearr_107950;
})();
if(cljs.core.truth_(inst_107913)){
var statearr_107951_107980 = state_107931__$1;
(statearr_107951_107980[(1)] = (15));

} else {
var statearr_107952_107981 = state_107931__$1;
(statearr_107952_107981[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (16))){
var inst_107912 = (state_107931[(11)]);
var inst_107916 = inst_107912.s;
var state_107931__$1 = state_107931;
var statearr_107953_107982 = state_107931__$1;
(statearr_107953_107982[(2)] = inst_107916);

(statearr_107953_107982[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (10))){
var inst_107906 = (state_107931[(9)]);
var inst_107906__$1 = (state_107931[(2)]);
var inst_107907 = (inst_107906__$1 == null);
var state_107931__$1 = (function (){var statearr_107954 = state_107931;
(statearr_107954[(9)] = inst_107906__$1);

return statearr_107954;
})();
if(cljs.core.truth_(inst_107907)){
var statearr_107955_107983 = state_107931__$1;
(statearr_107955_107983[(1)] = (12));

} else {
var statearr_107956_107984 = state_107931__$1;
(statearr_107956_107984[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (18))){
var inst_107922 = (state_107931[(10)]);
var inst_107921 = (state_107931[(2)]);
var inst_107922__$1 = fluree.db.util.async.throw_err(inst_107921);
var inst_107923 = (inst_107922__$1 > (1));
var state_107931__$1 = (function (){var statearr_107957 = state_107931;
(statearr_107957[(10)] = inst_107922__$1);

return statearr_107957;
})();
if(cljs.core.truth_(inst_107923)){
var statearr_107958_107985 = state_107931__$1;
(statearr_107958_107985[(1)] = (19));

} else {
var statearr_107959_107986 = state_107931__$1;
(statearr_107959_107986[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_107932 === (8))){
var state_107931__$1 = state_107931;
var statearr_107960_107987 = state_107931__$1;
(statearr_107960_107987[(2)] = null);

(statearr_107960_107987[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto__ = null;
var fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto____0 = (function (){
var statearr_107961 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_107961[(0)] = fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto__);

(statearr_107961[(1)] = (1));

return statearr_107961;
});
var fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto____1 = (function (state_107931){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_107931);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e107962){if((e107962 instanceof Object)){
var ex__99706__auto__ = e107962;
var statearr_107963_107988 = state_107931;
(statearr_107963_107988[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_107931);

return cljs.core.cst$kw$recur;
} else {
throw e107962;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__107989 = state_107931;
state_107931 = G__107989;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto__ = function(state_107931){
switch(arguments.length){
case 0:
return fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto____1.call(this,state_107931);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto____0;
fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto____1;
return fluree$db$time_travel$non_border_t_to_block_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_107964 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_107964[(6)] = c__99809__auto__);

return statearr_107964;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.time_travel.block_to_int_format = (function fluree$db$time_travel$block_to_int_format(db,block){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_108044){
var state_val_108045 = (state_108044[(1)]);
if((state_val_108045 === (7))){
var inst_108040 = (state_108044[(2)]);
var state_108044__$1 = state_108044;
var statearr_108046_108069 = state_108044__$1;
(statearr_108046_108069[(2)] = inst_108040);


cljs.core.async.impl.ioc_helpers.process_exception(state_108044__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (20))){
var inst_108034 = (state_108044[(2)]);
var state_108044__$1 = state_108044;
var statearr_108047_108070 = state_108044__$1;
(statearr_108047_108070[(2)] = inst_108034);

(statearr_108047_108070[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (1))){
var state_108044__$1 = state_108044;
var statearr_108048_108071 = state_108044__$1;
(statearr_108048_108071[(2)] = null);

(statearr_108048_108071[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_108044,(3),Error,null,(2));
var inst_107994 = cljs.core.pos_int_QMARK_(block);
var state_108044__$1 = state_108044;
if(inst_107994){
var statearr_108049_108072 = state_108044__$1;
(statearr_108049_108072[(1)] = (5));

} else {
var statearr_108050_108073 = state_108044__$1;
(statearr_108050_108073[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (15))){
var inst_108036 = (state_108044[(2)]);
var state_108044__$1 = state_108044;
var statearr_108051_108074 = state_108044__$1;
(statearr_108051_108074[(2)] = inst_108036);

(statearr_108051_108074[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (13))){
var inst_108015 = fluree.db.time_travel.time_to_t(db,block);
var state_108044__$1 = state_108044;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108044__$1,(16),inst_108015);
} else {
if((state_val_108045 === (6))){
var inst_107997 = typeof block === 'string';
var inst_107998 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(block,(0));
var inst_107999 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_107998);
var inst_108000 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("P",inst_107999);
var inst_108001 = ((inst_107997) && (inst_108000));
var state_108044__$1 = state_108044;
if(cljs.core.truth_(inst_108001)){
var statearr_108052_108075 = state_108044__$1;
(statearr_108052_108075[(1)] = (8));

} else {
var statearr_108053_108076 = state_108044__$1;
(statearr_108053_108076[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (17))){
var inst_108021 = (state_108044[(2)]);
var inst_108022 = fluree.db.util.async.throw_err(inst_108021);
var state_108044__$1 = state_108044;
var statearr_108054_108077 = state_108044__$1;
(statearr_108054_108077[(2)] = inst_108022);

(statearr_108054_108077[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (3))){
var inst_107990 = (state_108044[(2)]);
var state_108044__$1 = state_108044;
var statearr_108055_108078 = state_108044__$1;
(statearr_108055_108078[(2)] = inst_107990);


cljs.core.async.impl.ioc_helpers.process_exception(state_108044__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (12))){
var inst_108010 = (state_108044[(2)]);
var inst_108011 = fluree.db.util.async.throw_err(inst_108010);
var state_108044__$1 = state_108044;
var statearr_108056_108079 = state_108044__$1;
(statearr_108056_108079[(2)] = inst_108011);

(statearr_108056_108079[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (2))){
var inst_108042 = (state_108044[(2)]);
var state_108044__$1 = state_108044;
return cljs.core.async.impl.ioc_helpers.return_chan(state_108044__$1,inst_108042);
} else {
if((state_val_108045 === (19))){
var state_108044__$1 = state_108044;
var statearr_108057_108080 = state_108044__$1;
(statearr_108057_108080[(2)] = null);

(statearr_108057_108080[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (11))){
var inst_108006 = (state_108044[(2)]);
var inst_108007 = fluree.db.util.async.throw_err(inst_108006);
var inst_108008 = fluree.db.time_travel.t_to_block(db,inst_108007);
var state_108044__$1 = state_108044;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108044__$1,(12),inst_108008);
} else {
if((state_val_108045 === (9))){
var inst_108013 = typeof block === 'string';
var state_108044__$1 = state_108044;
if(cljs.core.truth_(inst_108013)){
var statearr_108058_108081 = state_108044__$1;
(statearr_108058_108081[(1)] = (13));

} else {
var statearr_108059_108082 = state_108044__$1;
(statearr_108059_108082[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (5))){
var state_108044__$1 = state_108044;
var statearr_108060_108083 = state_108044__$1;
(statearr_108060_108083[(2)] = block);

(statearr_108060_108083[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (14))){
var state_108044__$1 = state_108044;
var statearr_108061_108084 = state_108044__$1;
(statearr_108061_108084[(1)] = (18));



return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (16))){
var inst_108017 = (state_108044[(2)]);
var inst_108018 = fluree.db.util.async.throw_err(inst_108017);
var inst_108019 = fluree.db.time_travel.t_to_block(db,inst_108018);
var state_108044__$1 = state_108044;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108044__$1,(17),inst_108019);
} else {
if((state_val_108045 === (10))){
var inst_108038 = (state_108044[(2)]);
var state_108044__$1 = state_108044;
var statearr_108063_108085 = state_108044__$1;
(statearr_108063_108085[(2)] = inst_108038);

(statearr_108063_108085[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (18))){
var inst_108025 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([block], 0));
var inst_108026 = ["Invalid block key provided: ",inst_108025].join('');
var inst_108027 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_108028 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_time];
var inst_108029 = cljs.core.PersistentHashMap.fromArrays(inst_108027,inst_108028);
var inst_108030 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_108026,inst_108029);
var inst_108031 = (function(){throw inst_108030})();
var state_108044__$1 = state_108044;
var statearr_108064_108086 = state_108044__$1;
(statearr_108064_108086[(2)] = inst_108031);

(statearr_108064_108086[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108045 === (8))){
var inst_108003 = fluree.db.time_travel.duration_parse(block);
var inst_108004 = fluree.db.time_travel.time_to_t(db,inst_108003);
var state_108044__$1 = state_108044;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108044__$1,(11),inst_108004);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto__ = null;
var fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto____0 = (function (){
var statearr_108065 = [null,null,null,null,null,null,null];
(statearr_108065[(0)] = fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto__);

(statearr_108065[(1)] = (1));

return statearr_108065;
});
var fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto____1 = (function (state_108044){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_108044);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e108066){if((e108066 instanceof Object)){
var ex__99706__auto__ = e108066;
var statearr_108067_108087 = state_108044;
(statearr_108067_108087[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_108044);

return cljs.core.cst$kw$recur;
} else {
throw e108066;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__108088 = state_108044;
state_108044 = G__108088;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto__ = function(state_108044){
switch(arguments.length){
case 0:
return fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto____1.call(this,state_108044);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto____0;
fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto____1;
return fluree$db$time_travel$block_to_int_format_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_108068 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_108068[(6)] = c__99809__auto__);

return statearr_108068;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.time_travel.block_to_t = (function fluree$db$time_travel$block_to_t(db,block){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_108138){
var state_val_108139 = (state_108138[(1)]);
if((state_val_108139 === (7))){
var inst_108103 = (state_108138[(7)]);
var inst_108103__$1 = (state_108138[(2)]);
var inst_108104 = (inst_108103__$1 == null);
var state_108138__$1 = (function (){var statearr_108140 = state_108138;
(statearr_108140[(7)] = inst_108103__$1);

return statearr_108140;
})();
if(cljs.core.truth_(inst_108104)){
var statearr_108141_108173 = state_108138__$1;
(statearr_108141_108173[(1)] = (8));

} else {
var statearr_108142_108174 = state_108138__$1;
(statearr_108142_108174[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (20))){
var inst_108123 = (state_108138[(8)]);
var inst_108134 = (state_108138[(2)]);
var state_108138__$1 = (function (){var statearr_108143 = state_108138;
(statearr_108143[(9)] = inst_108134);

return statearr_108143;
})();
var statearr_108144_108175 = state_108138__$1;
(statearr_108144_108175[(2)] = inst_108123);


cljs.core.async.impl.ioc_helpers.process_exception(state_108138__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (1))){
var state_108138__$1 = state_108138;
var statearr_108145_108176 = state_108138__$1;
(statearr_108145_108176[(2)] = null);

(statearr_108145_108176[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (4))){
var inst_108094 = (state_108138[(10)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_108138,(3),Error,null,(2));
var inst_108094__$1 = fluree.db.dbproto._rootdb(db);
var inst_108095 = (inst_108094__$1 == null);
var state_108138__$1 = (function (){var statearr_108146 = state_108138;
(statearr_108146[(10)] = inst_108094__$1);

return statearr_108146;
})();
if(cljs.core.truth_(inst_108095)){
var statearr_108147_108177 = state_108138__$1;
(statearr_108147_108177[(1)] = (5));

} else {
var statearr_108148_108178 = state_108138__$1;
(statearr_108148_108178[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (15))){
var state_108138__$1 = state_108138;
var statearr_108149_108179 = state_108138__$1;
(statearr_108149_108179[(2)] = null);

(statearr_108149_108179[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (13))){
var inst_108111 = (state_108138[(11)]);
var inst_108115 = cljs.core.first(inst_108111);
var state_108138__$1 = state_108138;
var statearr_108150_108180 = state_108138__$1;
(statearr_108150_108180[(2)] = inst_108115);

(statearr_108150_108180[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (6))){
var inst_108094 = (state_108138[(10)]);
var inst_108098 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_108099 = ["_block/number",block];
var inst_108100 = (new cljs.core.PersistentVector(null,2,(5),inst_108098,inst_108099,null));
var inst_108101 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(inst_108094,cljs.core.cst$kw$post,cljs.core._EQ_,inst_108100);
var state_108138__$1 = state_108138;
var statearr_108151_108181 = state_108138__$1;
(statearr_108151_108181[(2)] = inst_108101);

(statearr_108151_108181[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (17))){
var inst_108123 = (state_108138[(8)]);
var inst_108123__$1 = (state_108138[(2)]);
var state_108138__$1 = (function (){var statearr_108152 = state_108138;
(statearr_108152[(8)] = inst_108123__$1);

return statearr_108152;
})();
if(cljs.core.truth_(inst_108123__$1)){
var statearr_108153_108182 = state_108138__$1;
(statearr_108153_108182[(1)] = (18));

} else {
var statearr_108154_108183 = state_108138__$1;
(statearr_108154_108183[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (3))){
var inst_108089 = (state_108138[(2)]);
var state_108138__$1 = state_108138;
var statearr_108155_108184 = state_108138__$1;
(statearr_108155_108184[(2)] = inst_108089);


cljs.core.async.impl.ioc_helpers.process_exception(state_108138__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (12))){
var state_108138__$1 = state_108138;
var statearr_108156_108185 = state_108138__$1;
(statearr_108156_108185[(2)] = null);

(statearr_108156_108185[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (2))){
var inst_108136 = (state_108138[(2)]);
var state_108138__$1 = state_108138;
return cljs.core.async.impl.ioc_helpers.return_chan(state_108138__$1,inst_108136);
} else {
if((state_val_108139 === (19))){
var inst_108126 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([block], 0));
var inst_108127 = ["Invalid block key provided: ",inst_108126].join('');
var inst_108128 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_108129 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_time];
var inst_108130 = cljs.core.PersistentHashMap.fromArrays(inst_108128,inst_108129);
var inst_108131 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_108127,inst_108130);
var inst_108132 = (function(){throw inst_108131})();
var state_108138__$1 = state_108138;
var statearr_108157_108186 = state_108138__$1;
(statearr_108157_108186[(2)] = inst_108132);

(statearr_108157_108186[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (11))){
var inst_108108 = (state_108138[(2)]);
var inst_108109 = fluree.db.util.async.throw_err(inst_108108);
var state_108138__$1 = state_108138;
var statearr_108158_108187 = state_108138__$1;
(statearr_108158_108187[(2)] = inst_108109);

(statearr_108158_108187[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (9))){
var inst_108103 = (state_108138[(7)]);
var state_108138__$1 = state_108138;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108138__$1,(11),inst_108103);
} else {
if((state_val_108139 === (5))){
var state_108138__$1 = state_108138;
var statearr_108159_108188 = state_108138__$1;
(statearr_108159_108188[(2)] = null);

(statearr_108159_108188[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (14))){
var inst_108117 = (state_108138[(12)]);
var inst_108117__$1 = (state_108138[(2)]);
var inst_108118 = (inst_108117__$1 == null);
var state_108138__$1 = (function (){var statearr_108160 = state_108138;
(statearr_108160[(12)] = inst_108117__$1);

return statearr_108160;
})();
if(cljs.core.truth_(inst_108118)){
var statearr_108161_108189 = state_108138__$1;
(statearr_108161_108189[(1)] = (15));

} else {
var statearr_108162_108190 = state_108138__$1;
(statearr_108162_108190[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (16))){
var inst_108117 = (state_108138[(12)]);
var inst_108121 = inst_108117.t;
var state_108138__$1 = state_108138;
var statearr_108163_108191 = state_108138__$1;
(statearr_108163_108191[(2)] = inst_108121);

(statearr_108163_108191[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (10))){
var inst_108111 = (state_108138[(11)]);
var inst_108111__$1 = (state_108138[(2)]);
var inst_108112 = (inst_108111__$1 == null);
var state_108138__$1 = (function (){var statearr_108164 = state_108138;
(statearr_108164[(11)] = inst_108111__$1);

return statearr_108164;
})();
if(cljs.core.truth_(inst_108112)){
var statearr_108165_108192 = state_108138__$1;
(statearr_108165_108192[(1)] = (12));

} else {
var statearr_108166_108193 = state_108138__$1;
(statearr_108166_108193[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (18))){
var state_108138__$1 = state_108138;
var statearr_108167_108194 = state_108138__$1;
(statearr_108167_108194[(2)] = null);

(statearr_108167_108194[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108139 === (8))){
var state_108138__$1 = state_108138;
var statearr_108168_108195 = state_108138__$1;
(statearr_108168_108195[(2)] = null);

(statearr_108168_108195[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$time_travel$block_to_t_$_state_machine__99703__auto__ = null;
var fluree$db$time_travel$block_to_t_$_state_machine__99703__auto____0 = (function (){
var statearr_108169 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_108169[(0)] = fluree$db$time_travel$block_to_t_$_state_machine__99703__auto__);

(statearr_108169[(1)] = (1));

return statearr_108169;
});
var fluree$db$time_travel$block_to_t_$_state_machine__99703__auto____1 = (function (state_108138){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_108138);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e108170){if((e108170 instanceof Object)){
var ex__99706__auto__ = e108170;
var statearr_108171_108196 = state_108138;
(statearr_108171_108196[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_108138);

return cljs.core.cst$kw$recur;
} else {
throw e108170;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__108197 = state_108138;
state_108138 = G__108197;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$time_travel$block_to_t_$_state_machine__99703__auto__ = function(state_108138){
switch(arguments.length){
case 0:
return fluree$db$time_travel$block_to_t_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$time_travel$block_to_t_$_state_machine__99703__auto____1.call(this,state_108138);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$block_to_t_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$block_to_t_$_state_machine__99703__auto____0;
fluree$db$time_travel$block_to_t_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$block_to_t_$_state_machine__99703__auto____1;
return fluree$db$time_travel$block_to_t_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_108172 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_108172[(6)] = c__99809__auto__);

return statearr_108172;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Gets the database as-of a specified block. Either block number or a time string in ISO-8601 format.
 */
fluree.db.time_travel.as_of_block = (function fluree$db$time_travel$as_of_block(db,block_or_t_or_time){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_108267){
var state_val_108268 = (state_108267[(1)]);
if((state_val_108268 === (7))){
var inst_108220 = cljs.core.neg_int_QMARK_(block_or_t_or_time);
var state_108267__$1 = state_108267;
if(inst_108220){
var statearr_108269_108302 = state_108267__$1;
(statearr_108269_108302[(1)] = (13));

} else {
var statearr_108270_108303 = state_108267__$1;
(statearr_108270_108303[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (20))){
var inst_108205 = (state_108267[(7)]);
var inst_108235 = fluree.db.time_travel.time_to_t(inst_108205,block_or_t_or_time);
var state_108267__$1 = state_108267;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108267__$1,(23),inst_108235);
} else {
if((state_val_108268 === (27))){
var inst_108258 = (state_108267[(8)]);
var inst_108261 = (state_108267[(2)]);
var inst_108262 = fluree.db.util.async.throw_err(inst_108261);
var inst_108263 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(db,cljs.core.cst$kw$t,inst_108258,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$block,inst_108262], 0));
var state_108267__$1 = state_108267;
var statearr_108271_108304 = state_108267__$1;
(statearr_108271_108304[(2)] = inst_108263);


cljs.core.async.impl.ioc_helpers.process_exception(state_108267__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (1))){
var state_108267__$1 = state_108267;
var statearr_108272_108305 = state_108267__$1;
(statearr_108272_108305[(2)] = null);

(statearr_108272_108305[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (24))){
var inst_108243 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([block_or_t_or_time], 0));
var inst_108244 = ["Invalid block key provided: ",inst_108243].join('');
var inst_108245 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_108246 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_time];
var inst_108247 = cljs.core.PersistentHashMap.fromArrays(inst_108245,inst_108246);
var inst_108248 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_108244,inst_108247);
var inst_108249 = (function(){throw inst_108248})();
var state_108267__$1 = state_108267;
var statearr_108273_108306 = state_108267__$1;
(statearr_108273_108306[(2)] = inst_108249);

(statearr_108273_108306[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_108267,(3),Error,null,(2));
var inst_108202 = fluree.db.dbproto._latest_db(db);
var state_108267__$1 = state_108267;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108267__$1,(5),inst_108202);
} else {
if((state_val_108268 === (15))){
var inst_108256 = (state_108267[(2)]);
var state_108267__$1 = state_108267;
var statearr_108274_108307 = state_108267__$1;
(statearr_108274_108307[(2)] = inst_108256);

(statearr_108274_108307[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (21))){
var inst_108240 = (state_108267[(2)]);
var state_108267__$1 = state_108267;
var statearr_108275_108308 = state_108267__$1;
(statearr_108275_108308[(2)] = inst_108240);

(statearr_108275_108308[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (13))){
var state_108267__$1 = state_108267;
var statearr_108276_108309 = state_108267__$1;
(statearr_108276_108309[(2)] = block_or_t_or_time);

(statearr_108276_108309[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (22))){
var inst_108232 = (state_108267[(2)]);
var inst_108233 = fluree.db.util.async.throw_err(inst_108232);
var state_108267__$1 = state_108267;
var statearr_108277_108310 = state_108267__$1;
(statearr_108277_108310[(2)] = inst_108233);

(statearr_108277_108310[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (6))){
var state_108267__$1 = state_108267;
var statearr_108278_108311 = state_108267__$1;
(statearr_108278_108311[(2)] = null);

(statearr_108278_108311[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (25))){
var state_108267__$1 = state_108267;
var statearr_108279_108312 = state_108267__$1;
(statearr_108279_108312[(2)] = null);

(statearr_108279_108312[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (17))){
var state_108267__$1 = state_108267;
var statearr_108280_108313 = state_108267__$1;
(statearr_108280_108313[(1)] = (24));



return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (3))){
var inst_108198 = (state_108267[(2)]);
var state_108267__$1 = state_108267;
var statearr_108282_108314 = state_108267__$1;
(statearr_108282_108314[(2)] = inst_108198);


cljs.core.async.impl.ioc_helpers.process_exception(state_108267__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (12))){
var inst_108215 = (state_108267[(2)]);
var inst_108216 = fluree.db.util.async.throw_err(inst_108215);
var state_108267__$1 = state_108267;
var statearr_108283_108315 = state_108267__$1;
(statearr_108283_108315[(2)] = inst_108216);


cljs.core.async.impl.ioc_helpers.process_exception(state_108267__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (2))){
var inst_108265 = (state_108267[(2)]);
var state_108267__$1 = state_108267;
return cljs.core.async.impl.ioc_helpers.return_chan(state_108267__$1,inst_108265);
} else {
if((state_val_108268 === (23))){
var inst_108237 = (state_108267[(2)]);
var inst_108238 = fluree.db.util.async.throw_err(inst_108237);
var state_108267__$1 = state_108267;
var statearr_108284_108316 = state_108267__$1;
(statearr_108284_108316[(2)] = inst_108238);

(statearr_108284_108316[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (19))){
var inst_108205 = (state_108267[(7)]);
var inst_108229 = fluree.db.time_travel.duration_parse(block_or_t_or_time);
var inst_108230 = fluree.db.time_travel.time_to_t(inst_108205,inst_108229);
var state_108267__$1 = state_108267;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108267__$1,(22),inst_108230);
} else {
if((state_val_108268 === (11))){
var inst_108205 = (state_108267[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_108267,(10),cljs.core.cst$kw$default,null,(9));
var inst_108213 = fluree.db.time_travel.block_to_t(inst_108205,block_or_t_or_time);
var state_108267__$1 = state_108267;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108267__$1,(12),inst_108213);
} else {
if((state_val_108268 === (9))){
var inst_108218 = (state_108267[(2)]);
var state_108267__$1 = state_108267;
var statearr_108285_108317 = state_108267__$1;
(statearr_108285_108317[(2)] = inst_108218);

(statearr_108285_108317[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (5))){
var inst_108204 = (state_108267[(2)]);
var inst_108205 = fluree.db.util.async.throw_err(inst_108204);
var inst_108206 = cljs.core.pos_int_QMARK_(block_or_t_or_time);
var state_108267__$1 = (function (){var statearr_108286 = state_108267;
(statearr_108286[(7)] = inst_108205);

return statearr_108286;
})();
if(inst_108206){
var statearr_108287_108318 = state_108267__$1;
(statearr_108287_108318[(1)] = (6));

} else {
var statearr_108288_108319 = state_108267__$1;
(statearr_108288_108319[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (14))){
var inst_108223 = typeof block_or_t_or_time === 'string';
var state_108267__$1 = state_108267;
if(cljs.core.truth_(inst_108223)){
var statearr_108289_108320 = state_108267__$1;
(statearr_108289_108320[(1)] = (16));

} else {
var statearr_108290_108321 = state_108267__$1;
(statearr_108290_108321[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (26))){
var inst_108252 = (state_108267[(2)]);
var state_108267__$1 = state_108267;
var statearr_108291_108322 = state_108267__$1;
(statearr_108291_108322[(2)] = inst_108252);

(statearr_108291_108322[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (16))){
var inst_108225 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(block_or_t_or_time,(0));
var inst_108226 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_108225);
var inst_108227 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("P",inst_108226);
var state_108267__$1 = state_108267;
if(inst_108227){
var statearr_108292_108323 = state_108267__$1;
(statearr_108292_108323[(1)] = (19));

} else {
var statearr_108293_108324 = state_108267__$1;
(statearr_108293_108324[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (10))){
var inst_108205 = (state_108267[(7)]);
var inst_108208 = (state_108267[(2)]);
var inst_108209 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(inst_108205);
var state_108267__$1 = (function (){var statearr_108294 = state_108267;
(statearr_108294[(9)] = inst_108208);

return statearr_108294;
})();
var statearr_108295_108325 = state_108267__$1;
(statearr_108295_108325[(2)] = inst_108209);


cljs.core.async.impl.ioc_helpers.process_exception(state_108267__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (18))){
var inst_108254 = (state_108267[(2)]);
var state_108267__$1 = state_108267;
var statearr_108296_108326 = state_108267__$1;
(statearr_108296_108326[(2)] = inst_108254);

(statearr_108296_108326[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108268 === (8))){
var inst_108205 = (state_108267[(7)]);
var inst_108258 = (state_108267[(8)]);
var inst_108258__$1 = (state_108267[(2)]);
var inst_108259 = fluree.db.time_travel.t_to_block(inst_108205,inst_108258__$1);
var state_108267__$1 = (function (){var statearr_108297 = state_108267;
(statearr_108297[(8)] = inst_108258__$1);

return statearr_108297;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108267__$1,(27),inst_108259);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$time_travel$as_of_block_$_state_machine__99703__auto__ = null;
var fluree$db$time_travel$as_of_block_$_state_machine__99703__auto____0 = (function (){
var statearr_108298 = [null,null,null,null,null,null,null,null,null,null];
(statearr_108298[(0)] = fluree$db$time_travel$as_of_block_$_state_machine__99703__auto__);

(statearr_108298[(1)] = (1));

return statearr_108298;
});
var fluree$db$time_travel$as_of_block_$_state_machine__99703__auto____1 = (function (state_108267){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_108267);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e108299){if((e108299 instanceof Object)){
var ex__99706__auto__ = e108299;
var statearr_108300_108327 = state_108267;
(statearr_108300_108327[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_108267);

return cljs.core.cst$kw$recur;
} else {
throw e108299;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__108328 = state_108267;
state_108267 = G__108328;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$time_travel$as_of_block_$_state_machine__99703__auto__ = function(state_108267){
switch(arguments.length){
case 0:
return fluree$db$time_travel$as_of_block_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$time_travel$as_of_block_$_state_machine__99703__auto____1.call(this,state_108267);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$as_of_block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$as_of_block_$_state_machine__99703__auto____0;
fluree$db$time_travel$as_of_block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$as_of_block_$_state_machine__99703__auto____1;
return fluree$db$time_travel$as_of_block_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_108301 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_108301[(6)] = c__99809__auto__);

return statearr_108301;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
