// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.util.xhttp');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('goog.net.XhrIo');
goog.require('fluree.db.util.json');
goog.require('fluree.db.util.log');
goog.require('cljs.core.async');
goog.require('fluree.db.util.core');
fluree.db.util.xhttp.format_error_response = (function fluree$db$util$xhttp$format_error_response(url,e){
var status = (function (){var temp__5735__auto__ = e.getStatus();
if(cljs.core.truth_(temp__5735__auto__)){
var st = temp__5735__auto__;
if((st > (0))){
return st;
} else {
return null;
}
} else {
return null;
}
})();
var error = (function (){var pred__108331 = cljs.core._EQ_;
var expr__108332 = e.getLastErrorCode();
if(cljs.core.truth_((pred__108331.cljs$core$IFn$_invoke$arity$2 ? pred__108331.cljs$core$IFn$_invoke$arity$2(goog.net.ErrorCode.NO_ERROR,expr__108332) : pred__108331.call(null,goog.net.ErrorCode.NO_ERROR,expr__108332)))){
return cljs.core.cst$kw$xhttp_SLASH_no_DASH_error;
} else {
if(cljs.core.truth_((pred__108331.cljs$core$IFn$_invoke$arity$2 ? pred__108331.cljs$core$IFn$_invoke$arity$2(goog.net.ErrorCode.EXCEPTION,expr__108332) : pred__108331.call(null,goog.net.ErrorCode.EXCEPTION,expr__108332)))){
return cljs.core.cst$kw$xhttp_SLASH_exception;
} else {
if(cljs.core.truth_((pred__108331.cljs$core$IFn$_invoke$arity$2 ? pred__108331.cljs$core$IFn$_invoke$arity$2(goog.net.ErrorCode.HTTP_ERROR,expr__108332) : pred__108331.call(null,goog.net.ErrorCode.HTTP_ERROR,expr__108332)))){
return cljs.core.cst$kw$xhttp_SLASH_http_DASH_error;
} else {
if(cljs.core.truth_((pred__108331.cljs$core$IFn$_invoke$arity$2 ? pred__108331.cljs$core$IFn$_invoke$arity$2(goog.net.ErrorCode.ABORT,expr__108332) : pred__108331.call(null,goog.net.ErrorCode.ABORT,expr__108332)))){
return cljs.core.cst$kw$xhttp_SLASH_abort;
} else {
if(cljs.core.truth_((pred__108331.cljs$core$IFn$_invoke$arity$2 ? pred__108331.cljs$core$IFn$_invoke$arity$2(goog.net.ErrorCode.TIMEOUT,expr__108332) : pred__108331.call(null,goog.net.ErrorCode.TIMEOUT,expr__108332)))){
return cljs.core.cst$kw$xhttp_SLASH_timeout;
} else {
return cljs.core.cst$kw$xhttp_SLASH_unknown_DASH_error;
}
}
}
}
}
})();
var message = ["xhttp error - ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(url),(cljs.core.truth_((function (){var and__4120__auto__ = status;
if(cljs.core.truth_(and__4120__auto__)){
return (status > (0));
} else {
return and__4120__auto__;
}
})())?[": ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(status)].join(''):"")].join('');
return cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(message,(function (){var G__108334 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$url,url,cljs.core.cst$kw$error,error], null);
if(cljs.core.truth_(status)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__108334,cljs.core.cst$kw$status,status);
} else {
return G__108334;
}
})());
});
/**
 * Posts JSON content.
 *   opts is a map with following optional keys:
 *   :request-timeout - how many milliseconds until we throw an exception without a response (default 5000)
 */
fluree.db.util.xhttp.post_json = (function fluree$db$util$xhttp$post_json(url,message,opts){
var map__108335 = opts;
var map__108335__$1 = (((((!((map__108335 == null))))?(((((map__108335.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__108335.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__108335):map__108335);
var request_timeout = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__108335__$1,cljs.core.cst$kw$request_DASH_timeout,(5000));
var token = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108335__$1,cljs.core.cst$kw$token);
var headers = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108335__$1,cljs.core.cst$kw$headers);
var response_chan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var headers__$1 = (function (){var G__108337 = new cljs.core.PersistentArrayMap(null, 1, ["Content-Type","application/json"], null);
var G__108337__$1 = (cljs.core.truth_(headers)?cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([G__108337,headers], 0)):G__108337);
if(cljs.core.truth_(token)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__108337__$1,"Authorization",["Bearer ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(token)].join(''));
} else {
return G__108337__$1;
}
})();
try{var G__108339_108345 = url;
var G__108340_108346 = ((function (G__108339_108345,map__108335,map__108335__$1,request_timeout,token,headers,response_chan,headers__$1){
return (function (event){
var xhr = event.target;
var success_QMARK_ = xhr.isSuccess();
if(cljs.core.truth_(success_QMARK_)){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(response_chan,cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(xhr.getResponseJson(),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0)));
} else {
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(response_chan,fluree.db.util.xhttp.format_error_response(url,xhr));
}
});})(G__108339_108345,map__108335,map__108335__$1,request_timeout,token,headers,response_chan,headers__$1))
;
var G__108341_108347 = "POST";
var G__108342_108348 = fluree.db.util.json.stringify(message);
var G__108343_108349 = cljs.core.clj__GT_js(headers__$1);
var G__108344_108350 = request_timeout;
goog.net.XhrIo.send(G__108339_108345,G__108340_108346,G__108341_108347,G__108342_108348,G__108343_108349,G__108344_108350);
}catch (e108338){var e_108351 = e108338;
fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["CAUGHT ERROR!"], 0));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(response_chan,e_108351);
}
return response_chan;
});
/**
 * Returns result body as a string, or an exception.
 * 
 *   If opts contains :body,
 *   It is assumed body is already in a format that can be sent directly in request (already encoded).
 * 
 *   Options
 *   - output-format - can be :text, :json or :binary (default text), or special format (wikidata) to handle wikidata errors, which come back as html.
 * 
 *   
 */
fluree.db.util.xhttp.get = (function fluree$db$util$xhttp$get(url,opts){
var map__108352 = opts;
var map__108352__$1 = (((((!((map__108352 == null))))?(((((map__108352.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__108352.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__108352):map__108352);
var request_timeout = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__108352__$1,cljs.core.cst$kw$request_DASH_timeout,(5000));
var token = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108352__$1,cljs.core.cst$kw$token);
var headers = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108352__$1,cljs.core.cst$kw$headers);
var body = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108352__$1,cljs.core.cst$kw$body);
var output_format = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__108352__$1,cljs.core.cst$kw$output_DASH_format,cljs.core.cst$kw$text);
var response_chan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var headers__$1 = (function (){var G__108354 = cljs.core.PersistentArrayMap.EMPTY;
var G__108354__$1 = (cljs.core.truth_(headers)?cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([G__108354,headers], 0)):G__108354);
if(cljs.core.truth_(token)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__108354__$1,"Authorization",["Bearer ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(token)].join(''));
} else {
return G__108354__$1;
}
})();
try{var G__108356_108363 = url;
var G__108357_108364 = ((function (G__108356_108363,map__108352,map__108352__$1,request_timeout,token,headers,body,output_format,response_chan,headers__$1){
return (function (event){
var xhr = event.target;
var success_QMARK_ = xhr.isSuccess();
if(cljs.core.truth_(success_QMARK_)){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(response_chan,(function (){var G__108362 = output_format;
var G__108362__$1 = (((G__108362 instanceof cljs.core.Keyword))?G__108362.fqn:null);
switch (G__108362__$1) {
case "text":
return xhr.getResponseText();

break;
case "json":
return xhr.getResponseJson();

break;
default:
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("http get only supports output formats of json and text for now.",cljs.core.PersistentArrayMap.EMPTY);

}
})());
} else {
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(response_chan,fluree.db.util.xhttp.format_error_response(url,xhr));
}
});})(G__108356_108363,map__108352,map__108352__$1,request_timeout,token,headers,body,output_format,response_chan,headers__$1))
;
var G__108358_108365 = "GET";
var G__108359_108366 = body;
var G__108360_108367 = cljs.core.clj__GT_js(headers__$1);
var G__108361_108368 = request_timeout;
goog.net.XhrIo.send(G__108356_108363,G__108357_108364,G__108358_108365,G__108359_108366,G__108360_108367,G__108361_108368);
}catch (e108355){var e_108370 = e108355;
fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["CAUUGHT ERROR!"], 0));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(response_chan,e_108370);
}
return response_chan;
});
/**
 * http get with JSON response.
 * 
 *   If opts contains :body key, it is encoded into JSON and sent as part
 *   of the body.
 */
fluree.db.util.xhttp.get_json = (function fluree$db$util$xhttp$get_json(url,opts){
var opts_STAR_ = (function (){var G__108371 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(cljs.core.assoc_in(opts,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$headers,"Accept"], null),"application/json"),cljs.core.cst$kw$output_DASH_format,cljs.core.cst$kw$json);
if(cljs.core.truth_(cljs.core.cst$kw$body.cljs$core$IFn$_invoke$arity$1(opts))){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__108371,cljs.core.cst$kw$body,fluree.db.util.json.stringify(cljs.core.cst$kw$body.cljs$core$IFn$_invoke$arity$1(opts)));
} else {
return G__108371;
}
})();
return fluree.db.util.xhttp.get(url,opts_STAR_);
});
/**
 * Sends messages across web socket. Sends never block and will immediately queue.
 *   Message to send should be a two-tuple placed on the pub-chan, of:
 *  [msg resp-chan]
 *   where a true/false response will eventually be placed on the resp-chan if the send
 *   is successful.
 */
fluree.db.util.xhttp.socket_publish_loop = (function fluree$db$util$xhttp$socket_publish_loop(ws,pub_chan){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_108401){
var state_val_108402 = (state_108401[(1)]);
if((state_val_108402 === (7))){
var inst_108397 = (state_108401[(2)]);
var state_108401__$1 = state_108401;
var statearr_108403_108421 = state_108401__$1;
(statearr_108403_108421[(2)] = inst_108397);

(statearr_108403_108421[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108402 === (1))){
var state_108401__$1 = state_108401;
var statearr_108404_108422 = state_108401__$1;
(statearr_108404_108422[(2)] = null);

(statearr_108404_108422[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108402 === (4))){
var inst_108375 = (state_108401[(7)]);
var inst_108375__$1 = (state_108401[(2)]);
var inst_108376 = (inst_108375__$1 == null);
var state_108401__$1 = (function (){var statearr_108405 = state_108401;
(statearr_108405[(7)] = inst_108375__$1);

return statearr_108405;
})();
if(cljs.core.truth_(inst_108376)){
var statearr_108406_108423 = state_108401__$1;
(statearr_108406_108423[(1)] = (5));

} else {
var statearr_108407_108424 = state_108401__$1;
(statearr_108407_108424[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108402 === (6))){
var inst_108375 = (state_108401[(7)]);
var inst_108383 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_108375,(0),null);
var inst_108384 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_108375,(1),null);
var state_108401__$1 = (function (){var statearr_108408 = state_108401;
(statearr_108408[(8)] = inst_108384);

(statearr_108408[(9)] = inst_108383);

return statearr_108408;
})();
var statearr_108409_108425 = state_108401__$1;
(statearr_108409_108425[(2)] = null);

(statearr_108409_108425[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108402 === (3))){
var inst_108399 = (state_108401[(2)]);
var state_108401__$1 = state_108401;
return cljs.core.async.impl.ioc_helpers.return_chan(state_108401__$1,inst_108399);
} else {
if((state_val_108402 === (2))){
var state_108401__$1 = state_108401;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108401__$1,(4),pub_chan);
} else {
if((state_val_108402 === (9))){
var inst_108384 = (state_108401[(8)]);
var inst_108385 = (state_108401[(2)]);
var inst_108386 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_108385,"Websocket send message error:",inst_108385], 0));
var inst_108387 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(inst_108384,false);
var state_108401__$1 = (function (){var statearr_108410 = state_108401;
(statearr_108410[(10)] = inst_108386);

return statearr_108410;
})();
var statearr_108411_108426 = state_108401__$1;
(statearr_108411_108426[(2)] = inst_108387);


cljs.core.async.impl.ioc_helpers.process_exception(state_108401__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108402 === (5))){
var inst_108378 = fluree.db.util.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Web socket pub/producer channel closed."], 0));
var state_108401__$1 = state_108401;
var statearr_108412_108427 = state_108401__$1;
(statearr_108412_108427[(2)] = inst_108378);

(statearr_108412_108427[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108402 === (10))){
var inst_108384 = (state_108401[(8)]);
var inst_108383 = (state_108401[(9)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_108401,(9),Error,null,(8));
var inst_108391 = ws.send(inst_108383);
var inst_108392 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(inst_108384,true);
var state_108401__$1 = (function (){var statearr_108413 = state_108401;
(statearr_108413[(11)] = inst_108391);

return statearr_108413;
})();
var statearr_108414_108428 = state_108401__$1;
(statearr_108414_108428[(2)] = inst_108392);


cljs.core.async.impl.ioc_helpers.process_exception(state_108401__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108402 === (8))){
var inst_108394 = (state_108401[(2)]);
var state_108401__$1 = (function (){var statearr_108415 = state_108401;
(statearr_108415[(12)] = inst_108394);

return statearr_108415;
})();
var statearr_108416_108429 = state_108401__$1;
(statearr_108416_108429[(2)] = null);

(statearr_108416_108429[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto__ = null;
var fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto____0 = (function (){
var statearr_108417 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_108417[(0)] = fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto__);

(statearr_108417[(1)] = (1));

return statearr_108417;
});
var fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto____1 = (function (state_108401){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_108401);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e108418){if((e108418 instanceof Object)){
var ex__99706__auto__ = e108418;
var statearr_108419_108430 = state_108401;
(statearr_108419_108430[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_108401);

return cljs.core.cst$kw$recur;
} else {
throw e108418;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__108431 = state_108401;
state_108401 = G__108431;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto__ = function(state_108401){
switch(arguments.length){
case 0:
return fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto____1.call(this,state_108401);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto____0;
fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto____1;
return fluree$db$util$xhttp$socket_publish_loop_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_108420 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_108420[(6)] = c__99809__auto__);

return statearr_108420;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.util.xhttp.close_websocket = (function fluree$db$util$xhttp$close_websocket(ws){
return ws.close();
});
fluree.db.util.xhttp.try_socket = (function fluree$db$util$xhttp$try_socket(url,sub_chan,pub_chan,resp_chan,timeout,close_fn){
var ws = (new WebSocket(url));
var open_QMARK_ = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var timeout_chan = cljs.core.async.timeout(timeout);
ws.binaryType = "arraybuffer";

ws.onopen = ((function (ws,open_QMARK_,timeout_chan){
return (function (){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(open_QMARK_,true);
});})(ws,open_QMARK_,timeout_chan))
;

ws.onmessage = ((function (ws,open_QMARK_,timeout_chan){
return (function (e){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(sub_chan,e.data);
});})(ws,open_QMARK_,timeout_chan))
;

ws.onclose = ((function (ws,open_QMARK_,timeout_chan){
return (function (e){
fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Websocket closed: ",e.reason,"Code: ",e.code], 0));

return (close_fn.cljs$core$IFn$_invoke$arity$0 ? close_fn.cljs$core$IFn$_invoke$arity$0() : close_fn.call(null));
});})(ws,open_QMARK_,timeout_chan))
;

var c__99809__auto___108469 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___108469,ws,open_QMARK_,timeout_chan){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___108469,ws,open_QMARK_,timeout_chan){
return (function (state_108457){
var state_val_108458 = (state_108457[(1)]);
if((state_val_108458 === (1))){
var inst_108436 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_108437 = [open_QMARK_,timeout_chan];
var inst_108438 = (new cljs.core.PersistentVector(null,2,(5),inst_108436,inst_108437,null));
var state_108457__$1 = state_108457;
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic(state_108457__$1,(2),inst_108438,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$priority,true], 0));
} else {
if((state_val_108458 === (2))){
var inst_108440 = (state_108457[(2)]);
var inst_108441 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_108440,(0),null);
var inst_108442 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_108440,(1),null);
var inst_108443 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_108442,timeout_chan);
var state_108457__$1 = (function (){var statearr_108459 = state_108457;
(statearr_108459[(7)] = inst_108441);

return statearr_108459;
})();
if(inst_108443){
var statearr_108460_108470 = state_108457__$1;
(statearr_108460_108470[(1)] = (3));

} else {
var statearr_108461_108471 = state_108457__$1;
(statearr_108461_108471[(1)] = (4));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108458 === (3))){
var inst_108445 = ["Timeout reached, unable to establish communication to server, which responded healthy: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(url)].join('');
var inst_108446 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_108447 = [(400),cljs.core.cst$kw$db_SLASH_connection_DASH_error];
var inst_108448 = cljs.core.PersistentHashMap.fromArrays(inst_108446,inst_108447);
var inst_108449 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_108445,inst_108448);
var inst_108450 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(resp_chan,inst_108449);
var inst_108451 = fluree.db.util.xhttp.close_websocket(ws);
var state_108457__$1 = (function (){var statearr_108462 = state_108457;
(statearr_108462[(8)] = inst_108450);

return statearr_108462;
})();
var statearr_108463_108472 = state_108457__$1;
(statearr_108463_108472[(2)] = inst_108451);

(statearr_108463_108472[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108458 === (4))){
var inst_108453 = fluree.db.util.xhttp.socket_publish_loop(ws,pub_chan);
var state_108457__$1 = state_108457;
var statearr_108464_108473 = state_108457__$1;
(statearr_108464_108473[(2)] = inst_108453);

(statearr_108464_108473[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108458 === (5))){
var inst_108455 = (state_108457[(2)]);
var state_108457__$1 = state_108457;
return cljs.core.async.impl.ioc_helpers.return_chan(state_108457__$1,inst_108455);
} else {
return null;
}
}
}
}
}
});})(c__99809__auto___108469,ws,open_QMARK_,timeout_chan))
;
return ((function (switch__99702__auto__,c__99809__auto___108469,ws,open_QMARK_,timeout_chan){
return (function() {
var fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto__ = null;
var fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto____0 = (function (){
var statearr_108465 = [null,null,null,null,null,null,null,null,null];
(statearr_108465[(0)] = fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto__);

(statearr_108465[(1)] = (1));

return statearr_108465;
});
var fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto____1 = (function (state_108457){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_108457);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e108466){if((e108466 instanceof Object)){
var ex__99706__auto__ = e108466;
var statearr_108467_108474 = state_108457;
(statearr_108467_108474[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_108457);

return cljs.core.cst$kw$recur;
} else {
throw e108466;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__108475 = state_108457;
state_108457 = G__108475;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto__ = function(state_108457){
switch(arguments.length){
case 0:
return fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto____1.call(this,state_108457);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto____0;
fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto____1;
return fluree$db$util$xhttp$try_socket_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___108469,ws,open_QMARK_,timeout_chan))
})();
var state__99811__auto__ = (function (){var statearr_108468 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_108468[(6)] = c__99809__auto___108469);

return statearr_108468;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___108469,ws,open_QMARK_,timeout_chan))
);


return cljs.core.cst$kw$fluree$db$util$xhttp_SLASH_no_DASH_return;
});
