// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('flureedb');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('clojure.string');
goog.require('cljs.core.async');
goog.require('alphabase.core');
goog.require('fluree.crypto');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.graphdb');
goog.require('fluree.db.operations');
goog.require('fluree.db.query.fql');
goog.require('fluree.db.query.block');
goog.require('fluree.db.query.range');
goog.require('fluree.db.util.async');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.json');
goog.require('fluree.db.util.log');
goog.require('fluree.db.query.http_signatures');
goog.require('goog.string.format');
goog.require('shared.fdb');
goog.require('shared.connection_handler');
cljs.core.enable_console_print_BANG_();
if((typeof flureedb !== 'undefined') && (typeof flureedb.app_state !== 'undefined')){
} else {
flureedb.app_state = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$product,"FlureeDB APIs",cljs.core.cst$kw$version,"v0.15.0"], null));
}
cljs.core.println.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$product.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(flureedb.app_state)),cljs.core.cst$kw$version.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(flureedb.app_state))], 0));
flureedb.on_js_reload = (function flureedb$on_js_reload(){
return null;
});
fluree.db.util.log.set_level_BANG_(cljs.core.cst$kw$warning);
/**
 * Configure logging for Fluree processes.  Supported options:
 *   1. level [Values: severe, warning, info, config, fine, finer, finest]
 *   
 */
flureedb.set_logging = (function flureedb$set_logging(opts){
var opts_SINGLEQUOTE_ = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var map__120975 = opts_SINGLEQUOTE_;
var map__120975__$1 = (((((!((map__120975 == null))))?(((((map__120975.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__120975.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__120975):map__120975);
var level = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__120975__$1,cljs.core.cst$kw$level);
return fluree.db.util.log.set_level_BANG_(cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(level));
});
goog.exportSymbol('flureedb.set_logging', flureedb.set_logging);
/**
 * Connect to a ledger server using URL address. If using a ledger group, multiple addresses can be
 * supplied, separated by commas.
 */
flureedb.connect = (function flureedb$connect(var_args){
var G__120978 = arguments.length;
switch (G__120978) {
case 1:
return flureedb.connect.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return flureedb.connect.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.connect', flureedb.connect);

flureedb.connect.cljs$core$IFn$_invoke$arity$1 = (function (servers_string){
return flureedb.connect.cljs$core$IFn$_invoke$arity$2(servers_string,null);
});

flureedb.connect.cljs$core$IFn$_invoke$arity$2 = (function (servers_string,opts){
var opts_SINGLEQUOTE_ = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
return shared.connection_handler.connect.cljs$core$IFn$_invoke$arity$2(servers_string,opts_SINGLEQUOTE_);
});

flureedb.connect.cljs$lang$maxFixedArity = 2;

/**
 * Connect to a ledger server using URL address. If using a ledger group, multiple addresses can be
 * supplied, separated by commas.
 * 
 * Returns a promise that eventually contains the connection object.
 */
flureedb.connect_p = (function flureedb$connect_p(var_args){
var G__120981 = arguments.length;
switch (G__120981) {
case 1:
return flureedb.connect_p.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return flureedb.connect_p.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.connect_p', flureedb.connect_p);

flureedb.connect_p.cljs$core$IFn$_invoke$arity$1 = (function (servers_string){
return flureedb.connect_p.cljs$core$IFn$_invoke$arity$2(servers_string,null);
});

flureedb.connect_p.cljs$core$IFn$_invoke$arity$2 = (function (servers_string,opts){
var opts_SINGLEQUOTE_ = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
return shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$2(servers_string,opts_SINGLEQUOTE_);
});

flureedb.connect_p.cljs$lang$maxFixedArity = 2;

/**
 * Closes a connection
 */
flureedb.close = (function flureedb$close(conn){
return shared.connection_handler.close(conn);
});
goog.exportSymbol('flureedb.close', flureedb.close);
/**
 * Attempts to generate a new user auth record account.
 */
flureedb.password_generate = (function flureedb$password_generate(var_args){
var G__120984 = arguments.length;
switch (G__120984) {
case 4:
return flureedb.password_generate.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return flureedb.password_generate.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.password_generate', flureedb.password_generate);

flureedb.password_generate.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,password,user){
return flureedb.password_generate.cljs$core$IFn$_invoke$arity$5(conn,ledger,password,user,null);
});

flureedb.password_generate.cljs$core$IFn$_invoke$arity$5 = (function (conn,ledger,password,user,opts){
var opts_SINGLEQUOTE_ = (((opts == null))?null:cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0)));
var data = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(opts_SINGLEQUOTE_,cljs.core.cst$kw$user,user);
return shared.connection_handler.password_generate(conn,ledger,password,data);
});

flureedb.password_generate.cljs$lang$maxFixedArity = 5;

/**
 * Returns a JWT token if successful.
 *   Must supply ledger, password and either user or auth identifier.
 *   Expire is optional
 *   - connection - connection object to server
 *   - ledger     - ledger identifier
 *   - password   - plain-text password
 *   - user       - _user/username (TODO: should allow any _user ident in the future)
 *   - auth       - _auth/id (TODO: should allow any _auth ident in the future)
 *   - expire     - requested time to expire in milliseconds
 */
flureedb.password_login = (function flureedb$password_login(var_args){
var G__120987 = arguments.length;
switch (G__120987) {
case 4:
return flureedb.password_login.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 6:
return flureedb.password_login.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.password_login', flureedb.password_login);

flureedb.password_login.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,password,user){
return shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$4(conn,ledger,password,user);
});

flureedb.password_login.cljs$core$IFn$_invoke$arity$6 = (function (conn,ledger,password,user,auth,expire){
return shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$6(conn,ledger,password,user,auth,expire);
});

flureedb.password_login.cljs$lang$maxFixedArity = 6;

/**
 * Renews a JWT token if successful.
 *   Returns a promise that eventually contains the token or an exception
 */
flureedb.renew_token = (function flureedb$renew_token(var_args){
var G__120990 = arguments.length;
switch (G__120990) {
case 2:
return flureedb.renew_token.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return flureedb.renew_token.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.renew_token', flureedb.renew_token);

flureedb.renew_token.cljs$core$IFn$_invoke$arity$2 = (function (conn,jwt){
return shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$3(conn,jwt,null);
});

flureedb.renew_token.cljs$core$IFn$_invoke$arity$3 = (function (conn,jwt,expire){
return shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$3(conn,jwt,expire);
});

flureedb.renew_token.cljs$lang$maxFixedArity = 3;

/**
 * Returns a queryable database from the connection.
 */
flureedb.db = (function flureedb$db(var_args){
var args__4736__auto__ = [];
var len__4730__auto___120999 = arguments.length;
var i__4731__auto___121000 = (0);
while(true){
if((i__4731__auto___121000 < len__4730__auto___120999)){
args__4736__auto__.push((arguments[i__4731__auto___121000]));

var G__121001 = (i__4731__auto___121000 + (1));
i__4731__auto___121000 = G__121001;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((2) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((2)),(0),null)):null);
return flureedb.db.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4737__auto__);
});
goog.exportSymbol('flureedb.db', flureedb.db);

flureedb.db.cljs$core$IFn$_invoke$arity$variadic = (function (conn,ledger,p__120995){
var vec__120996 = p__120995;
var opts = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__120996,(0),null);
var opts__$1 = (((opts == null))?null:cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0)));
return shared.fdb.db.cljs$core$IFn$_invoke$arity$variadic(conn,ledger,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([opts__$1], 0));
});

flureedb.db.cljs$lang$maxFixedArity = (2);

/** @this {Function} */
flureedb.db.cljs$lang$applyTo = (function (seq120992){
var G__120993 = cljs.core.first(seq120992);
var seq120992__$1 = cljs.core.next(seq120992);
var G__120994 = cljs.core.first(seq120992__$1);
var seq120992__$2 = cljs.core.next(seq120992__$1);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__120993,G__120994,seq120992__$2);
});

/**
 * Returns db's schema map.
 */
flureedb.db_schema = (function flureedb$db_schema(db){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121017){
var state_val_121018 = (state_121017[(1)]);
if((state_val_121018 === (1))){
var state_121017__$1 = state_121017;
var statearr_121019_121027 = state_121017__$1;
(statearr_121019_121027[(2)] = null);

(statearr_121019_121027[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121018 === (2))){
var inst_121015 = (state_121017[(2)]);
var state_121017__$1 = state_121017;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121017__$1,inst_121015);
} else {
if((state_val_121018 === (3))){
var inst_121002 = (state_121017[(2)]);
var inst_121003 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121002], 0));
var inst_121004 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121002) : reject.call(null,inst_121002));
var state_121017__$1 = (function (){var statearr_121020 = state_121017;
(statearr_121020[(7)] = inst_121003);

return statearr_121020;
})();
var statearr_121021_121028 = state_121017__$1;
(statearr_121021_121028[(2)] = inst_121004);


cljs.core.async.impl.ioc_helpers.process_exception(state_121017__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121018 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121017,(3),cljs.core.cst$kw$default,null,(2));
var state_121017__$1 = state_121017;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121017__$1,(5),db);
} else {
if((state_val_121018 === (5))){
var inst_121009 = (state_121017[(2)]);
var inst_121010 = fluree.db.util.async.throw_err(inst_121009);
var inst_121011 = cljs.core.cst$kw$schema.cljs$core$IFn$_invoke$arity$1(inst_121010);
var inst_121012 = cljs.core.clj__GT_js(inst_121011);
var inst_121013 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121012) : resolve.call(null,inst_121012));
var state_121017__$1 = state_121017;
var statearr_121022_121029 = state_121017__$1;
(statearr_121022_121029[(2)] = inst_121013);


cljs.core.async.impl.ioc_helpers.process_exception(state_121017__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$db_schema_$_state_machine__99703__auto__ = null;
var flureedb$db_schema_$_state_machine__99703__auto____0 = (function (){
var statearr_121023 = [null,null,null,null,null,null,null,null];
(statearr_121023[(0)] = flureedb$db_schema_$_state_machine__99703__auto__);

(statearr_121023[(1)] = (1));

return statearr_121023;
});
var flureedb$db_schema_$_state_machine__99703__auto____1 = (function (state_121017){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121017);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121024){if((e121024 instanceof Object)){
var ex__99706__auto__ = e121024;
var statearr_121025_121030 = state_121017;
(statearr_121025_121030[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121017);

return cljs.core.cst$kw$recur;
} else {
throw e121024;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121031 = state_121017;
state_121017 = G__121031;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$db_schema_$_state_machine__99703__auto__ = function(state_121017){
switch(arguments.length){
case 0:
return flureedb$db_schema_$_state_machine__99703__auto____0.call(this);
case 1:
return flureedb$db_schema_$_state_machine__99703__auto____1.call(this,state_121017);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$db_schema_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$db_schema_$_state_machine__99703__auto____0;
flureedb$db_schema_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$db_schema_$_state_machine__99703__auto____1;
return flureedb$db_schema_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121026 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121026[(6)] = c__99809__auto__);

return statearr_121026;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});
goog.exportSymbol('flureedb.db_schema', flureedb.db_schema);
/**
 * Completely deletes a ledger.
 *   Returns a promise that will have a response with a corresponding status of success.
 * 
 *   A 200 status indicates the deletion has been successfully initiated.
 *   The full deletion happens in the background on the respective ledger.
 * 
 *   Query servers get notified when this process initiates, and ledger will be marked as
 *   being in a deletion state during the deletion process.
 * 
 *   Attempts to use a ledger in a deletion state will throw an exception.
 */
flureedb.delete_ledger = (function flureedb$delete_ledger(var_args){
var G__121033 = arguments.length;
switch (G__121033) {
case 2:
return flureedb.delete_ledger.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return flureedb.delete_ledger.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.delete_ledger', flureedb.delete_ledger);

flureedb.delete_ledger.cljs$core$IFn$_invoke$arity$2 = (function (conn,ledger){
return flureedb.delete_ledger.cljs$core$IFn$_invoke$arity$3(conn,ledger,null);
});

flureedb.delete_ledger.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121120){
var state_val_121121 = (state_121120[(1)]);
if((state_val_121121 === (7))){
var inst_121046 = (state_121120[(7)]);
var inst_121046__$1 = (state_121120[(2)]);
var inst_121047 = shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2(conn,inst_121046__$1);
var inst_121049 = (inst_121046__$1 == null);
var inst_121050 = cljs.core.not(inst_121049);
var state_121120__$1 = (function (){var statearr_121122 = state_121120;
(statearr_121122[(8)] = inst_121047);

(statearr_121122[(7)] = inst_121046__$1);

return statearr_121122;
})();
if(inst_121050){
var statearr_121123_121173 = state_121120__$1;
(statearr_121123_121173[(1)] = (8));

} else {
var statearr_121124_121174 = state_121120__$1;
(statearr_121124_121174[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (20))){
var inst_121070 = (state_121120[(9)]);
var state_121120__$1 = state_121120;
var statearr_121125_121175 = state_121120__$1;
(statearr_121125_121175[(2)] = inst_121070);

(statearr_121125_121175[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (27))){
var state_121120__$1 = state_121120;
var statearr_121126_121176 = state_121120__$1;
(statearr_121126_121176[(2)] = null);

(statearr_121126_121176[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (1))){
var state_121120__$1 = state_121120;
var statearr_121127_121177 = state_121120__$1;
(statearr_121127_121177[(2)] = null);

(statearr_121127_121177[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (24))){
var state_121120__$1 = state_121120;
var statearr_121128_121178 = state_121120__$1;
(statearr_121128_121178[(2)] = null);

(statearr_121128_121178[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121120,(3),cljs.core.cst$kw$default,null,(2));
var inst_121041 = (opts == null);
var state_121120__$1 = state_121120;
if(cljs.core.truth_(inst_121041)){
var statearr_121129_121179 = state_121120__$1;
(statearr_121129_121179[(1)] = (5));

} else {
var statearr_121130_121180 = state_121120__$1;
(statearr_121130_121180[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (15))){
var inst_121046 = (state_121120[(7)]);
var state_121120__$1 = state_121120;
var statearr_121131_121181 = state_121120__$1;
(statearr_121131_121181[(2)] = inst_121046);

(statearr_121131_121181[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (21))){
var inst_121073 = (state_121120[(10)]);
var inst_121080 = (inst_121073 + (30000));
var state_121120__$1 = state_121120;
var statearr_121132_121182 = state_121120__$1;
(statearr_121132_121182[(2)] = inst_121080);

(statearr_121132_121182[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (31))){
var inst_121111 = (state_121120[(2)]);
var inst_121112 = [cljs.core.cst$kw$status,cljs.core.cst$kw$result];
var inst_121113 = [(200),inst_121111];
var inst_121114 = cljs.core.PersistentHashMap.fromArrays(inst_121112,inst_121113);
var inst_121115 = cljs.core.clj__GT_js(inst_121114);
var inst_121116 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121115) : resolve.call(null,inst_121115));
var state_121120__$1 = state_121120;
var statearr_121133_121183 = state_121120__$1;
(statearr_121133_121183[(2)] = inst_121116);


cljs.core.async.impl.ioc_helpers.process_exception(state_121120__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (32))){
var inst_121103 = (state_121120[(2)]);
var inst_121104 = fluree.db.util.async.throw_err(inst_121103);
var state_121120__$1 = state_121120;
var statearr_121134_121184 = state_121120__$1;
(statearr_121134_121184[(2)] = inst_121104);

(statearr_121134_121184[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (33))){
var inst_121108 = (state_121120[(2)]);
var inst_121109 = fluree.db.util.async.throw_err(inst_121108);
var state_121120__$1 = state_121120;
var statearr_121135_121185 = state_121120__$1;
(statearr_121135_121185[(2)] = inst_121109);

(statearr_121135_121185[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (13))){
var inst_121060 = (state_121120[(2)]);
var state_121120__$1 = state_121120;
var statearr_121136_121186 = state_121120__$1;
(statearr_121136_121186[(2)] = inst_121060);

(statearr_121136_121186[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (22))){
var inst_121077 = (state_121120[(11)]);
var inst_121072 = (state_121120[(12)]);
var inst_121082 = (state_121120[(2)]);
var inst_121083 = [cljs.core.cst$kw$type,cljs.core.cst$kw$db,cljs.core.cst$kw$nonce,cljs.core.cst$kw$expire];
var inst_121084 = [cljs.core.cst$kw$delete_DASH_db,ledger,inst_121077,inst_121082];
var inst_121085 = cljs.core.PersistentHashMap.fromArrays(inst_121083,inst_121084);
var state_121120__$1 = (function (){var statearr_121137 = state_121120;
(statearr_121137[(13)] = inst_121085);

return statearr_121137;
})();
if(cljs.core.truth_(inst_121072)){
var statearr_121138_121187 = state_121120__$1;
(statearr_121138_121187[(1)] = (23));

} else {
var statearr_121139_121188 = state_121120__$1;
(statearr_121139_121188[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (29))){
var inst_121096 = (state_121120[(14)]);
var inst_121091 = (state_121120[(15)]);
var inst_121098 = [cljs.core.cst$kw$cmd,cljs.core.cst$kw$sig];
var inst_121099 = [inst_121091,inst_121096];
var inst_121100 = cljs.core.PersistentHashMap.fromArrays(inst_121098,inst_121099);
var inst_121101 = fluree.db.operations.command_async(conn,inst_121100);
var state_121120__$1 = state_121120;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121120__$1,(32),inst_121101);
} else {
if((state_val_121121 === (6))){
var inst_121044 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var state_121120__$1 = state_121120;
var statearr_121140_121189 = state_121120__$1;
(statearr_121140_121189[(2)] = inst_121044);

(statearr_121140_121189[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (28))){
var inst_121072 = (state_121120[(12)]);
var inst_121096 = (state_121120[(2)]);
var state_121120__$1 = (function (){var statearr_121141 = state_121120;
(statearr_121141[(14)] = inst_121096);

return statearr_121141;
})();
if(cljs.core.truth_(inst_121072)){
var statearr_121142_121190 = state_121120__$1;
(statearr_121142_121190[(1)] = (29));

} else {
var statearr_121143_121191 = state_121120__$1;
(statearr_121143_121191[(1)] = (30));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (25))){
var inst_121072 = (state_121120[(12)]);
var inst_121091 = (state_121120[(2)]);
var state_121120__$1 = (function (){var statearr_121144 = state_121120;
(statearr_121144[(15)] = inst_121091);

return statearr_121144;
})();
if(cljs.core.truth_(inst_121072)){
var statearr_121145_121192 = state_121120__$1;
(statearr_121145_121192[(1)] = (26));

} else {
var statearr_121146_121193 = state_121120__$1;
(statearr_121146_121193[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (17))){
var inst_121069 = (state_121120[(16)]);
var state_121120__$1 = state_121120;
var statearr_121147_121194 = state_121120__$1;
(statearr_121147_121194[(2)] = inst_121069);

(statearr_121147_121194[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (3))){
var inst_121034 = (state_121120[(2)]);
var inst_121035 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121034], 0));
var inst_121036 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121034) : reject.call(null,inst_121034));
var state_121120__$1 = (function (){var statearr_121148 = state_121120;
(statearr_121148[(17)] = inst_121035);

return statearr_121148;
})();
var statearr_121149_121195 = state_121120__$1;
(statearr_121149_121195[(2)] = inst_121036);


cljs.core.async.impl.ioc_helpers.process_exception(state_121120__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (12))){
var state_121120__$1 = state_121120;
var statearr_121150_121196 = state_121120__$1;
(statearr_121150_121196[(2)] = false);

(statearr_121150_121196[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (2))){
var inst_121118 = (state_121120[(2)]);
var state_121120__$1 = state_121120;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121120__$1,inst_121118);
} else {
if((state_val_121121 === (23))){
var inst_121085 = (state_121120[(13)]);
var inst_121087 = fluree.db.util.core.without_nils(inst_121085);
var inst_121088 = fluree.db.util.json.stringify(inst_121087);
var state_121120__$1 = state_121120;
var statearr_121151_121197 = state_121120__$1;
(statearr_121151_121197[(2)] = inst_121088);

(statearr_121151_121197[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (19))){
var inst_121070 = (state_121120[(9)]);
var inst_121077 = (state_121120[(2)]);
var state_121120__$1 = (function (){var statearr_121152 = state_121120;
(statearr_121152[(11)] = inst_121077);

return statearr_121152;
})();
if(cljs.core.truth_(inst_121070)){
var statearr_121153_121198 = state_121120__$1;
(statearr_121153_121198[(1)] = (20));

} else {
var statearr_121154_121199 = state_121120__$1;
(statearr_121154_121199[(1)] = (21));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (11))){
var state_121120__$1 = state_121120;
var statearr_121155_121200 = state_121120__$1;
(statearr_121155_121200[(2)] = true);

(statearr_121155_121200[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (9))){
var state_121120__$1 = state_121120;
var statearr_121156_121201 = state_121120__$1;
(statearr_121156_121201[(2)] = false);

(statearr_121156_121201[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (5))){
var state_121120__$1 = state_121120;
var statearr_121157_121202 = state_121120__$1;
(statearr_121157_121202[(2)] = null);

(statearr_121157_121202[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (14))){
var inst_121046 = (state_121120[(7)]);
var inst_121065 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_121046);
var state_121120__$1 = state_121120;
var statearr_121158_121203 = state_121120__$1;
(statearr_121158_121203[(2)] = inst_121065);

(statearr_121158_121203[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (26))){
var inst_121072 = (state_121120[(12)]);
var inst_121091 = (state_121120[(15)]);
var inst_121093 = fluree.crypto.sign_message(inst_121091,inst_121072);
var state_121120__$1 = state_121120;
var statearr_121159_121204 = state_121120__$1;
(statearr_121159_121204[(2)] = inst_121093);

(statearr_121159_121204[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (16))){
var inst_121069 = (state_121120[(16)]);
var inst_121068 = (state_121120[(2)]);
var inst_121069__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121068,cljs.core.cst$kw$nonce);
var inst_121070 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121068,cljs.core.cst$kw$expire);
var inst_121071 = cljs.core.get.cljs$core$IFn$_invoke$arity$3(inst_121068,cljs.core.cst$kw$timeout,(60000));
var inst_121072 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121068,cljs.core.cst$kw$private_DASH_key);
var inst_121073 = fluree.db.util.core.current_time_millis();
var state_121120__$1 = (function (){var statearr_121160 = state_121120;
(statearr_121160[(18)] = inst_121071);

(statearr_121160[(12)] = inst_121072);

(statearr_121160[(16)] = inst_121069__$1);

(statearr_121160[(9)] = inst_121070);

(statearr_121160[(10)] = inst_121073);

return statearr_121160;
})();
if(cljs.core.truth_(inst_121069__$1)){
var statearr_121161_121205 = state_121120__$1;
(statearr_121161_121205[(1)] = (17));

} else {
var statearr_121162_121206 = state_121120__$1;
(statearr_121162_121206[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (30))){
var inst_121085 = (state_121120[(13)]);
var inst_121106 = fluree.db.operations.unsigned_command_async(conn,inst_121085);
var state_121120__$1 = state_121120;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121120__$1,(33),inst_121106);
} else {
if((state_val_121121 === (10))){
var inst_121063 = (state_121120[(2)]);
var state_121120__$1 = state_121120;
if(cljs.core.truth_(inst_121063)){
var statearr_121163_121207 = state_121120__$1;
(statearr_121163_121207[(1)] = (14));

} else {
var statearr_121164_121208 = state_121120__$1;
(statearr_121164_121208[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (18))){
var inst_121073 = (state_121120[(10)]);
var state_121120__$1 = state_121120;
var statearr_121165_121209 = state_121120__$1;
(statearr_121165_121209[(2)] = inst_121073);

(statearr_121165_121209[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121121 === (8))){
var inst_121046 = (state_121120[(7)]);
var inst_121052 = inst_121046.cljs$lang$protocol_mask$partition0$;
var inst_121053 = (inst_121052 & (64));
var inst_121054 = inst_121046.cljs$core$ISeq$;
var inst_121055 = (cljs.core.PROTOCOL_SENTINEL === inst_121054);
var inst_121056 = ((inst_121053) || (inst_121055));
var state_121120__$1 = state_121120;
if(cljs.core.truth_(inst_121056)){
var statearr_121166_121210 = state_121120__$1;
(statearr_121166_121210[(1)] = (11));

} else {
var statearr_121167_121211 = state_121120__$1;
(statearr_121167_121211[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$state_machine__99703__auto__ = null;
var flureedb$state_machine__99703__auto____0 = (function (){
var statearr_121168 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_121168[(0)] = flureedb$state_machine__99703__auto__);

(statearr_121168[(1)] = (1));

return statearr_121168;
});
var flureedb$state_machine__99703__auto____1 = (function (state_121120){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121120);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121169){if((e121169 instanceof Object)){
var ex__99706__auto__ = e121169;
var statearr_121170_121212 = state_121120;
(statearr_121170_121212[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121120);

return cljs.core.cst$kw$recur;
} else {
throw e121169;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121213 = state_121120;
state_121120 = G__121213;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$state_machine__99703__auto__ = function(state_121120){
switch(arguments.length){
case 0:
return flureedb$state_machine__99703__auto____0.call(this);
case 1:
return flureedb$state_machine__99703__auto____1.call(this,state_121120);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$state_machine__99703__auto____0;
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$state_machine__99703__auto____1;
return flureedb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121171 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121171[(6)] = c__99809__auto__);

return statearr_121171;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

flureedb.delete_ledger.cljs$lang$maxFixedArity = 3;

/**
 * Returns promise with ledger's  with ledger's stats, including db size and # of flakes.
 *   If ledger doesn't exist, will return an empty map.
 */
flureedb.ledger_stats = (function flureedb$ledger_stats(conn,ledger){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121229){
var state_val_121230 = (state_121229[(1)]);
if((state_val_121230 === (1))){
var state_121229__$1 = state_121229;
var statearr_121231_121239 = state_121229__$1;
(statearr_121231_121239[(2)] = null);

(statearr_121231_121239[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121230 === (2))){
var inst_121227 = (state_121229[(2)]);
var state_121229__$1 = state_121229;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121229__$1,inst_121227);
} else {
if((state_val_121230 === (3))){
var inst_121214 = (state_121229[(2)]);
var inst_121215 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121214], 0));
var inst_121216 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121214) : reject.call(null,inst_121214));
var state_121229__$1 = (function (){var statearr_121232 = state_121229;
(statearr_121232[(7)] = inst_121215);

return statearr_121232;
})();
var statearr_121233_121240 = state_121229__$1;
(statearr_121233_121240[(2)] = inst_121216);


cljs.core.async.impl.ioc_helpers.process_exception(state_121229__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121230 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121229,(3),cljs.core.cst$kw$default,null,(2));
var inst_121220 = fluree.db.operations.ledger_stats_async(conn,ledger);
var state_121229__$1 = state_121229;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121229__$1,(5),inst_121220);
} else {
if((state_val_121230 === (5))){
var inst_121222 = (state_121229[(2)]);
var inst_121223 = fluree.db.util.async.throw_err(inst_121222);
var inst_121224 = cljs.core.clj__GT_js(inst_121223);
var inst_121225 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121224) : resolve.call(null,inst_121224));
var state_121229__$1 = state_121229;
var statearr_121234_121241 = state_121229__$1;
(statearr_121234_121241[(2)] = inst_121225);


cljs.core.async.impl.ioc_helpers.process_exception(state_121229__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$ledger_stats_$_state_machine__99703__auto__ = null;
var flureedb$ledger_stats_$_state_machine__99703__auto____0 = (function (){
var statearr_121235 = [null,null,null,null,null,null,null,null];
(statearr_121235[(0)] = flureedb$ledger_stats_$_state_machine__99703__auto__);

(statearr_121235[(1)] = (1));

return statearr_121235;
});
var flureedb$ledger_stats_$_state_machine__99703__auto____1 = (function (state_121229){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121229);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121236){if((e121236 instanceof Object)){
var ex__99706__auto__ = e121236;
var statearr_121237_121242 = state_121229;
(statearr_121237_121242[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121229);

return cljs.core.cst$kw$recur;
} else {
throw e121236;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121243 = state_121229;
state_121229 = G__121243;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$ledger_stats_$_state_machine__99703__auto__ = function(state_121229){
switch(arguments.length){
case 0:
return flureedb$ledger_stats_$_state_machine__99703__auto____0.call(this);
case 1:
return flureedb$ledger_stats_$_state_machine__99703__auto____1.call(this,state_121229);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$ledger_stats_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$ledger_stats_$_state_machine__99703__auto____0;
flureedb$ledger_stats_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$ledger_stats_$_state_machine__99703__auto____1;
return flureedb$ledger_stats_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121238 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121238[(6)] = c__99809__auto__);

return statearr_121238;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});
goog.exportSymbol('flureedb.ledger_stats', flureedb.ledger_stats);
/**
 * Attempts to create new ledger.
 * 
 * A successful result will kick off a process on the ledger server(s) to bootstrap.
 * 
 * Once successful, will return with a command-id.
 * 
 * Ledger creation is handled asynchronously and may not be immediately available.
 * 
 * Options include:
 * - :alias       - Alias, if different than db-ident.
 * - :root        - Root account id to bootstrap with (string). Defaults to connection default account id.
 * - :doc         - Optional doc string about this db.
 * - :fork        - If forking an existing db, ref to db (actual identity, not db-ident). Must exist in network db.
 * - :forkBlock   - If fork is provided, optionally provide the block to fork at. Defaults to latest known.
 * - :persistResp - Respond immediately once persisted with the dbid, don't wait for transaction to be finished
 * 
 */
flureedb.new_ledger = (function flureedb$new_ledger(var_args){
var G__121245 = arguments.length;
switch (G__121245) {
case 2:
return flureedb.new_ledger.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return flureedb.new_ledger.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.new_ledger', flureedb.new_ledger);

flureedb.new_ledger.cljs$core$IFn$_invoke$arity$2 = (function (conn,ledger){
return flureedb.new_ledger.cljs$core$IFn$_invoke$arity$3(conn,ledger,null);
});

flureedb.new_ledger.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121380){
var state_val_121381 = (state_121380[(1)]);
if((state_val_121381 === (7))){
var inst_121268 = (state_121380[(7)]);
var inst_121268__$1 = (state_121380[(2)]);
var inst_121269 = shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2(conn,inst_121268__$1);
var inst_121271 = (inst_121268__$1 == null);
var inst_121272 = cljs.core.not(inst_121271);
var state_121380__$1 = (function (){var statearr_121382 = state_121380;
(statearr_121382[(7)] = inst_121268__$1);

(statearr_121382[(8)] = inst_121269);

return statearr_121382;
})();
if(inst_121272){
var statearr_121383_121453 = state_121380__$1;
(statearr_121383_121453[(1)] = (8));

} else {
var statearr_121384_121454 = state_121380__$1;
(statearr_121384_121454[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (20))){
var inst_121316 = fluree.db.graphdb.validate_ledger_ident(ledger);
var state_121380__$1 = state_121380;
var statearr_121385_121455 = state_121380__$1;
(statearr_121385_121455[(2)] = inst_121316);

(statearr_121385_121455[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (27))){
var state_121380__$1 = state_121380;
var statearr_121386_121456 = state_121380__$1;
(statearr_121386_121456[(2)] = null);

(statearr_121386_121456[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (1))){
var state_121380__$1 = state_121380;
var statearr_121387_121457 = state_121380__$1;
(statearr_121387_121457[(2)] = null);

(statearr_121387_121457[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (24))){
var state_121380__$1 = state_121380;
var statearr_121388_121458 = state_121380__$1;
(statearr_121388_121458[(2)] = null);

(statearr_121388_121458[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (39))){
var state_121380__$1 = state_121380;
var statearr_121389_121459 = state_121380__$1;
(statearr_121389_121459[(2)] = null);

(statearr_121389_121459[(1)] = (40));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121380,(3),cljs.core.cst$kw$default,null,(2));
var inst_121263 = (opts == null);
var state_121380__$1 = state_121380;
if(cljs.core.truth_(inst_121263)){
var statearr_121390_121460 = state_121380__$1;
(statearr_121390_121460[(1)] = (5));

} else {
var statearr_121391_121461 = state_121380__$1;
(statearr_121391_121461[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (15))){
var inst_121268 = (state_121380[(7)]);
var state_121380__$1 = state_121380;
var statearr_121392_121462 = state_121380__$1;
(statearr_121392_121462[(2)] = inst_121268);

(statearr_121392_121462[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (21))){
var state_121380__$1 = state_121380;
var statearr_121393_121463 = state_121380__$1;
(statearr_121393_121463[(2)] = null);

(statearr_121393_121463[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (31))){
var inst_121299 = (state_121380[(9)]);
var inst_121336 = (state_121380[(2)]);
var state_121380__$1 = (function (){var statearr_121394 = state_121380;
(statearr_121394[(10)] = inst_121336);

return statearr_121394;
})();
if(cljs.core.truth_(inst_121299)){
var statearr_121395_121464 = state_121380__$1;
(statearr_121395_121464[(1)] = (32));

} else {
var statearr_121396_121465 = state_121380__$1;
(statearr_121396_121465[(1)] = (33));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (32))){
var inst_121299 = (state_121380[(9)]);
var state_121380__$1 = state_121380;
var statearr_121397_121466 = state_121380__$1;
(statearr_121397_121466[(2)] = inst_121299);

(statearr_121397_121466[(1)] = (34));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (40))){
var inst_121295 = (state_121380[(11)]);
var inst_121356 = (state_121380[(2)]);
var state_121380__$1 = (function (){var statearr_121398 = state_121380;
(statearr_121398[(12)] = inst_121356);

return statearr_121398;
})();
if(cljs.core.truth_(inst_121295)){
var statearr_121399_121467 = state_121380__$1;
(statearr_121399_121467[(1)] = (41));

} else {
var statearr_121400_121468 = state_121380__$1;
(statearr_121400_121468[(1)] = (42));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (33))){
var inst_121332 = (state_121380[(13)]);
var inst_121339 = (inst_121332 + (30000));
var state_121380__$1 = state_121380;
var statearr_121401_121469 = state_121380__$1;
(statearr_121401_121469[(2)] = inst_121339);

(statearr_121401_121469[(1)] = (34));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (13))){
var inst_121282 = (state_121380[(2)]);
var state_121380__$1 = state_121380;
var statearr_121402_121470 = state_121380__$1;
(statearr_121402_121470[(2)] = inst_121282);

(statearr_121402_121470[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (22))){
var inst_121302 = (state_121380[(14)]);
var inst_121319 = (state_121380[(2)]);
var inst_121320 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_121319,(0),null);
var inst_121321 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_121319,(1),null);
var state_121380__$1 = (function (){var statearr_121403 = state_121380;
(statearr_121403[(15)] = inst_121321);

(statearr_121403[(16)] = inst_121320);

return statearr_121403;
})();
if(cljs.core.truth_(inst_121302)){
var statearr_121404_121471 = state_121380__$1;
(statearr_121404_121471[(1)] = (23));

} else {
var statearr_121405_121472 = state_121380__$1;
(statearr_121405_121472[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (36))){
var state_121380__$1 = state_121380;
var statearr_121406_121473 = state_121380__$1;
(statearr_121406_121473[(2)] = null);

(statearr_121406_121473[(1)] = (37));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (41))){
var inst_121351 = (state_121380[(17)]);
var inst_121356 = (state_121380[(12)]);
var inst_121358 = [cljs.core.cst$kw$cmd,cljs.core.cst$kw$sig];
var inst_121359 = [inst_121351,inst_121356];
var inst_121360 = cljs.core.PersistentHashMap.fromArrays(inst_121358,inst_121359);
var inst_121361 = fluree.db.operations.command_async(conn,inst_121360);
var state_121380__$1 = state_121380;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121380__$1,(44),inst_121361);
} else {
if((state_val_121381 === (43))){
var inst_121371 = (state_121380[(2)]);
var inst_121372 = [cljs.core.cst$kw$status,cljs.core.cst$kw$result];
var inst_121373 = [(200),inst_121371];
var inst_121374 = cljs.core.PersistentHashMap.fromArrays(inst_121372,inst_121373);
var inst_121375 = cljs.core.clj__GT_js(inst_121374);
var inst_121376 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121375) : resolve.call(null,inst_121375));
var state_121380__$1 = state_121380;
var statearr_121407_121474 = state_121380__$1;
(statearr_121407_121474[(2)] = inst_121376);


cljs.core.async.impl.ioc_helpers.process_exception(state_121380__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (29))){
var inst_121293 = (state_121380[(18)]);
var state_121380__$1 = state_121380;
var statearr_121408_121475 = state_121380__$1;
(statearr_121408_121475[(2)] = inst_121293);

(statearr_121408_121475[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (44))){
var inst_121363 = (state_121380[(2)]);
var inst_121364 = fluree.db.util.async.throw_err(inst_121363);
var state_121380__$1 = state_121380;
var statearr_121409_121476 = state_121380__$1;
(statearr_121409_121476[(2)] = inst_121364);

(statearr_121409_121476[(1)] = (43));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (6))){
var inst_121266 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var state_121380__$1 = state_121380;
var statearr_121410_121477 = state_121380__$1;
(statearr_121410_121477[(2)] = inst_121266);

(statearr_121410_121477[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (28))){
var inst_121293 = (state_121380[(18)]);
var inst_121331 = (state_121380[(2)]);
var inst_121332 = fluree.db.util.core.current_time_millis();
var state_121380__$1 = (function (){var statearr_121411 = state_121380;
(statearr_121411[(19)] = inst_121331);

(statearr_121411[(13)] = inst_121332);

return statearr_121411;
})();
if(cljs.core.truth_(inst_121293)){
var statearr_121412_121478 = state_121380__$1;
(statearr_121412_121478[(1)] = (29));

} else {
var statearr_121413_121479 = state_121380__$1;
(statearr_121413_121479[(1)] = (30));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (25))){
var inst_121302 = (state_121380[(14)]);
var inst_121326 = (state_121380[(2)]);
var state_121380__$1 = (function (){var statearr_121414 = state_121380;
(statearr_121414[(20)] = inst_121326);

return statearr_121414;
})();
if(cljs.core.truth_(inst_121302)){
var statearr_121415_121480 = state_121380__$1;
(statearr_121415_121480[(1)] = (26));

} else {
var statearr_121416_121481 = state_121380__$1;
(statearr_121416_121481[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (34))){
var inst_121301 = (state_121380[(21)]);
var inst_121303 = (state_121380[(22)]);
var inst_121296 = (state_121380[(23)]);
var inst_121331 = (state_121380[(19)]);
var inst_121295 = (state_121380[(11)]);
var inst_121336 = (state_121380[(10)]);
var inst_121305 = (state_121380[(24)]);
var inst_121300 = (state_121380[(25)]);
var inst_121292 = (state_121380[(26)]);
var inst_121294 = (state_121380[(27)]);
var inst_121312 = (state_121380[(28)]);
var inst_121298 = (state_121380[(29)]);
var inst_121297 = (state_121380[(30)]);
var inst_121341 = (state_121380[(2)]);
var inst_121342 = [cljs.core.cst$kw$copy,cljs.core.cst$kw$snapshotBlock,cljs.core.cst$kw$db,cljs.core.cst$kw$type,cljs.core.cst$kw$expire,cljs.core.cst$kw$auth,cljs.core.cst$kw$alias,cljs.core.cst$kw$snapshot,cljs.core.cst$kw$copyBlock,cljs.core.cst$kw$fork,cljs.core.cst$kw$nonce,cljs.core.cst$kw$doc,cljs.core.cst$kw$forkBlock];
var inst_121343 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_121305),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_121312)].join('');
var inst_121344 = [inst_121297,inst_121298,inst_121343,cljs.core.cst$kw$new_DASH_db,inst_121341,inst_121300,inst_121331,inst_121303,inst_121301,inst_121292,inst_121336,inst_121294,inst_121296];
var inst_121345 = cljs.core.PersistentHashMap.fromArrays(inst_121342,inst_121344);
var state_121380__$1 = (function (){var statearr_121417 = state_121380;
(statearr_121417[(31)] = inst_121345);

return statearr_121417;
})();
if(cljs.core.truth_(inst_121295)){
var statearr_121418_121482 = state_121380__$1;
(statearr_121418_121482[(1)] = (35));

} else {
var statearr_121419_121483 = state_121380__$1;
(statearr_121419_121483[(1)] = (36));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (17))){
var inst_121306 = (state_121380[(32)]);
var inst_121309 = cljs.core.subs.cljs$core$IFn$_invoke$arity$2(inst_121306,(1));
var state_121380__$1 = state_121380;
var statearr_121420_121484 = state_121380__$1;
(statearr_121420_121484[(2)] = inst_121309);

(statearr_121420_121484[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (3))){
var inst_121246 = (state_121380[(2)]);
var inst_121247 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121246], 0));
var inst_121248 = cljs.core.ex_data(inst_121246);
var inst_121249 = cljs.core.ex_message(inst_121246);
var inst_121250 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_121248,cljs.core.cst$kw$message,inst_121249);
var inst_121251 = cljs.core.clj__GT_js(inst_121250);
var inst_121252 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121251) : reject.call(null,inst_121251));
var state_121380__$1 = (function (){var statearr_121421 = state_121380;
(statearr_121421[(33)] = inst_121247);

return statearr_121421;
})();
var statearr_121422_121485 = state_121380__$1;
(statearr_121422_121485[(2)] = inst_121252);


cljs.core.async.impl.ioc_helpers.process_exception(state_121380__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (12))){
var state_121380__$1 = state_121380;
var statearr_121423_121486 = state_121380__$1;
(statearr_121423_121486[(2)] = false);

(statearr_121423_121486[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (2))){
var inst_121378 = (state_121380[(2)]);
var state_121380__$1 = state_121380;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121380__$1,inst_121378);
} else {
if((state_val_121381 === (23))){
var inst_121321 = (state_121380[(15)]);
var inst_121323 = fluree.db.graphdb.validate_ledger_name(inst_121321,"alias");
var state_121380__$1 = state_121380;
var statearr_121424_121487 = state_121380__$1;
(statearr_121424_121487[(2)] = inst_121323);

(statearr_121424_121487[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (35))){
var inst_121345 = (state_121380[(31)]);
var inst_121347 = fluree.db.util.core.without_nils(inst_121345);
var inst_121348 = fluree.db.util.json.stringify(inst_121347);
var state_121380__$1 = state_121380;
var statearr_121425_121488 = state_121380__$1;
(statearr_121425_121488[(2)] = inst_121348);

(statearr_121425_121488[(1)] = (37));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (19))){
var inst_121302 = (state_121380[(14)]);
var inst_121305 = (state_121380[(24)]);
var inst_121312 = (state_121380[(28)]);
var inst_121312__$1 = (state_121380[(2)]);
var inst_121313 = fluree.db.graphdb.validate_ledger_name(inst_121312__$1,"ledger");
var inst_121314 = fluree.db.graphdb.validate_ledger_name(inst_121305,"network");
var state_121380__$1 = (function (){var statearr_121426 = state_121380;
(statearr_121426[(34)] = inst_121313);

(statearr_121426[(35)] = inst_121314);

(statearr_121426[(28)] = inst_121312__$1);

return statearr_121426;
})();
if(cljs.core.truth_(inst_121302)){
var statearr_121427_121489 = state_121380__$1;
(statearr_121427_121489[(1)] = (20));

} else {
var statearr_121428_121490 = state_121380__$1;
(statearr_121428_121490[(1)] = (21));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (11))){
var state_121380__$1 = state_121380;
var statearr_121429_121491 = state_121380__$1;
(statearr_121429_121491[(2)] = true);

(statearr_121429_121491[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (9))){
var state_121380__$1 = state_121380;
var statearr_121430_121492 = state_121380__$1;
(statearr_121430_121492[(2)] = false);

(statearr_121430_121492[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (5))){
var state_121380__$1 = state_121380;
var statearr_121431_121493 = state_121380__$1;
(statearr_121431_121493[(2)] = null);

(statearr_121431_121493[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (14))){
var inst_121268 = (state_121380[(7)]);
var inst_121287 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_121268);
var state_121380__$1 = state_121380;
var statearr_121432_121494 = state_121380__$1;
(statearr_121432_121494[(2)] = inst_121287);

(statearr_121432_121494[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (45))){
var inst_121368 = (state_121380[(2)]);
var inst_121369 = fluree.db.util.async.throw_err(inst_121368);
var state_121380__$1 = state_121380;
var statearr_121433_121495 = state_121380__$1;
(statearr_121433_121495[(2)] = inst_121369);

(statearr_121433_121495[(1)] = (43));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (26))){
var inst_121321 = (state_121380[(15)]);
var inst_121320 = (state_121380[(16)]);
var inst_121328 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_121320),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_121321)].join('');
var state_121380__$1 = state_121380;
var statearr_121434_121496 = state_121380__$1;
(statearr_121434_121496[(2)] = inst_121328);

(statearr_121434_121496[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (16))){
var inst_121306 = (state_121380[(32)]);
var inst_121290 = (state_121380[(2)]);
var inst_121291 = cljs.core.get.cljs$core$IFn$_invoke$arity$3(inst_121290,cljs.core.cst$kw$timeout,(60000));
var inst_121292 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$fork);
var inst_121293 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$nonce);
var inst_121294 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$doc);
var inst_121295 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$private_DASH_key);
var inst_121296 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$forkBlock);
var inst_121297 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$copy);
var inst_121298 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$snapshotBlock);
var inst_121299 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$expire);
var inst_121300 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$auth);
var inst_121301 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$copyBlock);
var inst_121302 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$alias);
var inst_121303 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121290,cljs.core.cst$kw$snapshot);
var inst_121304 = fluree.db.graphdb.validate_ledger_ident(ledger);
var inst_121305 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_121304,(0),null);
var inst_121306__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_121304,(1),null);
var inst_121307 = clojure.string.starts_with_QMARK_(inst_121306__$1,"$");
var state_121380__$1 = (function (){var statearr_121435 = state_121380;
(statearr_121435[(21)] = inst_121301);

(statearr_121435[(22)] = inst_121303);

(statearr_121435[(36)] = inst_121291);

(statearr_121435[(23)] = inst_121296);

(statearr_121435[(9)] = inst_121299);

(statearr_121435[(14)] = inst_121302);

(statearr_121435[(11)] = inst_121295);

(statearr_121435[(18)] = inst_121293);

(statearr_121435[(24)] = inst_121305);

(statearr_121435[(25)] = inst_121300);

(statearr_121435[(32)] = inst_121306__$1);

(statearr_121435[(26)] = inst_121292);

(statearr_121435[(27)] = inst_121294);

(statearr_121435[(29)] = inst_121298);

(statearr_121435[(30)] = inst_121297);

return statearr_121435;
})();
if(inst_121307){
var statearr_121436_121497 = state_121380__$1;
(statearr_121436_121497[(1)] = (17));

} else {
var statearr_121437_121498 = state_121380__$1;
(statearr_121437_121498[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (38))){
var inst_121351 = (state_121380[(17)]);
var inst_121295 = (state_121380[(11)]);
var inst_121353 = fluree.crypto.sign_message(inst_121351,inst_121295);
var state_121380__$1 = state_121380;
var statearr_121438_121499 = state_121380__$1;
(statearr_121438_121499[(2)] = inst_121353);

(statearr_121438_121499[(1)] = (40));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (30))){
var inst_121332 = (state_121380[(13)]);
var state_121380__$1 = state_121380;
var statearr_121439_121500 = state_121380__$1;
(statearr_121439_121500[(2)] = inst_121332);

(statearr_121439_121500[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (10))){
var inst_121285 = (state_121380[(2)]);
var state_121380__$1 = state_121380;
if(cljs.core.truth_(inst_121285)){
var statearr_121440_121501 = state_121380__$1;
(statearr_121440_121501[(1)] = (14));

} else {
var statearr_121441_121502 = state_121380__$1;
(statearr_121441_121502[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (18))){
var inst_121306 = (state_121380[(32)]);
var state_121380__$1 = state_121380;
var statearr_121442_121503 = state_121380__$1;
(statearr_121442_121503[(2)] = inst_121306);

(statearr_121442_121503[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (42))){
var inst_121345 = (state_121380[(31)]);
var inst_121366 = fluree.db.operations.unsigned_command_async(conn,inst_121345);
var state_121380__$1 = state_121380;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121380__$1,(45),inst_121366);
} else {
if((state_val_121381 === (37))){
var inst_121295 = (state_121380[(11)]);
var inst_121351 = (state_121380[(2)]);
var state_121380__$1 = (function (){var statearr_121443 = state_121380;
(statearr_121443[(17)] = inst_121351);

return statearr_121443;
})();
if(cljs.core.truth_(inst_121295)){
var statearr_121444_121504 = state_121380__$1;
(statearr_121444_121504[(1)] = (38));

} else {
var statearr_121445_121505 = state_121380__$1;
(statearr_121445_121505[(1)] = (39));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121381 === (8))){
var inst_121268 = (state_121380[(7)]);
var inst_121274 = inst_121268.cljs$lang$protocol_mask$partition0$;
var inst_121275 = (inst_121274 & (64));
var inst_121276 = inst_121268.cljs$core$ISeq$;
var inst_121277 = (cljs.core.PROTOCOL_SENTINEL === inst_121276);
var inst_121278 = ((inst_121275) || (inst_121277));
var state_121380__$1 = state_121380;
if(cljs.core.truth_(inst_121278)){
var statearr_121446_121506 = state_121380__$1;
(statearr_121446_121506[(1)] = (11));

} else {
var statearr_121447_121507 = state_121380__$1;
(statearr_121447_121507[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$state_machine__99703__auto__ = null;
var flureedb$state_machine__99703__auto____0 = (function (){
var statearr_121448 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_121448[(0)] = flureedb$state_machine__99703__auto__);

(statearr_121448[(1)] = (1));

return statearr_121448;
});
var flureedb$state_machine__99703__auto____1 = (function (state_121380){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121380);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121449){if((e121449 instanceof Object)){
var ex__99706__auto__ = e121449;
var statearr_121450_121508 = state_121380;
(statearr_121450_121508[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121380);

return cljs.core.cst$kw$recur;
} else {
throw e121449;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121509 = state_121380;
state_121380 = G__121509;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$state_machine__99703__auto__ = function(state_121380){
switch(arguments.length){
case 0:
return flureedb$state_machine__99703__auto____0.call(this);
case 1:
return flureedb$state_machine__99703__auto____1.call(this,state_121380);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$state_machine__99703__auto____0;
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$state_machine__99703__auto____1;
return flureedb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121451 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121451[(6)] = c__99809__auto__);

return statearr_121451;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

flureedb.new_ledger.cljs$lang$maxFixedArity = 3;

/**
 * Monitors a database for a specific transaction id included in a block.
 * 
 *   Returns a promise that will eventually contain a response or an exception
 *   if the timeout period has expired.
 * 
 *   Response may contain an exception, if the tx resulted in an exception.
 */
flureedb.monitor_tx = (function flureedb$monitor_tx(conn,ledger,txid,timeout_ms){
if(cljs.core.int_QMARK_(timeout_ms)){
} else {
throw (new Error(["Assert failed: ","monitor requires timeout to be provided in milliseconds as an integer.","\n","(int? timeout-ms)"].join('')));
}

return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121526){
var state_val_121527 = (state_121526[(1)]);
if((state_val_121527 === (1))){
var state_121526__$1 = state_121526;
var statearr_121528_121537 = state_121526__$1;
(statearr_121528_121537[(2)] = null);

(statearr_121528_121537[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121527 === (2))){
var inst_121524 = (state_121526[(2)]);
var state_121526__$1 = state_121526;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121526__$1,inst_121524);
} else {
if((state_val_121527 === (3))){
var inst_121510 = (state_121526[(2)]);
var inst_121511 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121510], 0));
var inst_121512 = cljs.core.clj__GT_js(inst_121510);
var inst_121513 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121512) : reject.call(null,inst_121512));
var state_121526__$1 = (function (){var statearr_121529 = state_121526;
(statearr_121529[(7)] = inst_121511);

return statearr_121529;
})();
var statearr_121530_121538 = state_121526__$1;
(statearr_121530_121538[(2)] = inst_121513);


cljs.core.async.impl.ioc_helpers.process_exception(state_121526__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121527 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121526,(3),cljs.core.cst$kw$default,null,(2));
var inst_121517 = shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$1(conn);
var inst_121518 = shared.fdb.monitor_tx(conn,ledger,txid,timeout_ms);
var state_121526__$1 = (function (){var statearr_121531 = state_121526;
(statearr_121531[(8)] = inst_121517);

return statearr_121531;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121526__$1,(5),inst_121518);
} else {
if((state_val_121527 === (5))){
var inst_121520 = (state_121526[(2)]);
var inst_121521 = cljs.core.clj__GT_js(inst_121520);
var inst_121522 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121521) : resolve.call(null,inst_121521));
var state_121526__$1 = state_121526;
var statearr_121532_121539 = state_121526__$1;
(statearr_121532_121539[(2)] = inst_121522);


cljs.core.async.impl.ioc_helpers.process_exception(state_121526__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$monitor_tx_$_state_machine__99703__auto__ = null;
var flureedb$monitor_tx_$_state_machine__99703__auto____0 = (function (){
var statearr_121533 = [null,null,null,null,null,null,null,null,null];
(statearr_121533[(0)] = flureedb$monitor_tx_$_state_machine__99703__auto__);

(statearr_121533[(1)] = (1));

return statearr_121533;
});
var flureedb$monitor_tx_$_state_machine__99703__auto____1 = (function (state_121526){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121526);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121534){if((e121534 instanceof Object)){
var ex__99706__auto__ = e121534;
var statearr_121535_121540 = state_121526;
(statearr_121535_121540[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121526);

return cljs.core.cst$kw$recur;
} else {
throw e121534;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121541 = state_121526;
state_121526 = G__121541;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$monitor_tx_$_state_machine__99703__auto__ = function(state_121526){
switch(arguments.length){
case 0:
return flureedb$monitor_tx_$_state_machine__99703__auto____0.call(this);
case 1:
return flureedb$monitor_tx_$_state_machine__99703__auto____1.call(this,state_121526);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$monitor_tx_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$monitor_tx_$_state_machine__99703__auto____0;
flureedb$monitor_tx_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$monitor_tx_$_state_machine__99703__auto____1;
return flureedb$monitor_tx_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121536 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121536[(6)] = c__99809__auto__);

return statearr_121536;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});
goog.exportSymbol('flureedb.monitor_tx', flureedb.monitor_tx);
/**
 * Submits a transaction for a ledger and a transaction. Returns a promise
 * that will eventually have the result of the tx, the txid (if :txid-only option used), or
 * an exception due to an invalid transaction or if the timeout occurs prior to a response.
 * 
 * Will locally sign a final transaction command if a private key is provided via :private-key
 * in the options, otherwise will submit the transaction to the connected ledger and request signature,
 * provided the ledger group has a default private key available for signing.
 * 
 * Options (opts) is a map with the following possible keys:
 * - private-key - The private key to use for signing. If not present, a default
 *                 private key will attempt to be used from the connection, if available.
 * - auth        - The auth id for the auth record being used. The private key must
 *                 correspond to this auth record, or an authority of this auth record.
 * - expire      - When this transaction should expire if not yet attempted.
 *                 Defaults to 5 minutes.
 * - nonce       - Any long/64-bit integer value that will make this transaction unique.
 *                 By default epoch milliseconds is used.
 * - deps        - List of one or more txids that must be successfully processed before
 *                 this tx is processed. If any fail, this tx will fail. (not yet implemented)
 * - txid-only   - Boolean (default of false). If true, will not wait for a response to the tx,
 *                 but instead return with the txid once it is successfully persisted by the
 *                 transactors. The txid can be used to look up/monitor the response at a later time.
 * - timeout     - will respond with an exception if timeout reached before response available.
 */
flureedb.transact = (function flureedb$transact(var_args){
var G__121543 = arguments.length;
switch (G__121543) {
case 3:
return flureedb.transact.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return flureedb.transact.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.transact', flureedb.transact);

flureedb.transact.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,txn){
return flureedb.transact.cljs$core$IFn$_invoke$arity$4(conn,ledger,txn,null);
});

flureedb.transact.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,txn,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121566){
var state_val_121567 = (state_121566[(1)]);
if((state_val_121567 === (1))){
var state_121566__$1 = state_121566;
var statearr_121568_121582 = state_121566__$1;
(statearr_121568_121582[(2)] = null);

(statearr_121568_121582[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121567 === (2))){
var inst_121564 = (state_121566[(2)]);
var state_121566__$1 = state_121566;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121566__$1,inst_121564);
} else {
if((state_val_121567 === (3))){
var inst_121544 = (state_121566[(2)]);
var inst_121545 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121544], 0));
var inst_121546 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121544) : reject.call(null,inst_121544));
var state_121566__$1 = (function (){var statearr_121569 = state_121566;
(statearr_121569[(7)] = inst_121545);

return statearr_121569;
})();
var statearr_121570_121583 = state_121566__$1;
(statearr_121570_121583[(2)] = inst_121546);


cljs.core.async.impl.ioc_helpers.process_exception(state_121566__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121567 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121566,(3),cljs.core.cst$kw$default,null,(2));
var inst_121550 = (opts == null);
var state_121566__$1 = state_121566;
if(cljs.core.truth_(inst_121550)){
var statearr_121571_121584 = state_121566__$1;
(statearr_121571_121584[(1)] = (5));

} else {
var statearr_121572_121585 = state_121566__$1;
(statearr_121572_121585[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121567 === (5))){
var state_121566__$1 = state_121566;
var statearr_121573_121586 = state_121566__$1;
(statearr_121573_121586[(2)] = null);

(statearr_121573_121586[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121567 === (6))){
var inst_121553 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var state_121566__$1 = state_121566;
var statearr_121574_121587 = state_121566__$1;
(statearr_121574_121587[(2)] = inst_121553);

(statearr_121574_121587[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121567 === (7))){
var inst_121555 = (state_121566[(2)]);
var inst_121556 = shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2(conn,inst_121555);
var inst_121557 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(txn,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var inst_121558 = shared.fdb.transact_async.cljs$core$IFn$_invoke$arity$4(conn,ledger,inst_121557,inst_121555);
var state_121566__$1 = (function (){var statearr_121575 = state_121566;
(statearr_121575[(8)] = inst_121556);

return statearr_121575;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121566__$1,(8),inst_121558);
} else {
if((state_val_121567 === (8))){
var inst_121560 = (state_121566[(2)]);
var inst_121561 = cljs.core.clj__GT_js(inst_121560);
var inst_121562 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121561) : resolve.call(null,inst_121561));
var state_121566__$1 = state_121566;
var statearr_121576_121588 = state_121566__$1;
(statearr_121576_121588[(2)] = inst_121562);


cljs.core.async.impl.ioc_helpers.process_exception(state_121566__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$state_machine__99703__auto__ = null;
var flureedb$state_machine__99703__auto____0 = (function (){
var statearr_121577 = [null,null,null,null,null,null,null,null,null];
(statearr_121577[(0)] = flureedb$state_machine__99703__auto__);

(statearr_121577[(1)] = (1));

return statearr_121577;
});
var flureedb$state_machine__99703__auto____1 = (function (state_121566){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121566);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121578){if((e121578 instanceof Object)){
var ex__99706__auto__ = e121578;
var statearr_121579_121589 = state_121566;
(statearr_121579_121589[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121566);

return cljs.core.cst$kw$recur;
} else {
throw e121578;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121590 = state_121566;
state_121566 = G__121590;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$state_machine__99703__auto__ = function(state_121566){
switch(arguments.length){
case 0:
return flureedb$state_machine__99703__auto____0.call(this);
case 1:
return flureedb$state_machine__99703__auto____1.call(this,state_121566);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$state_machine__99703__auto____0;
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$state_machine__99703__auto____1;
return flureedb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121580 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121580[(6)] = c__99809__auto__);

return statearr_121580;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

flureedb.transact.cljs$lang$maxFixedArity = 4;

/**
 * Returns a Promise that will eventually contain blocks from start block (inclusive)
 *   to end if provided (inclusive). Each block is a separate map, containing keys :block,
 *   :t and :flakes.
 */
flureedb.block_range = (function flureedb$block_range(var_args){
var G__121592 = arguments.length;
switch (G__121592) {
case 3:
return flureedb.block_range.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return flureedb.block_range.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return flureedb.block_range.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.block_range', flureedb.block_range);

flureedb.block_range.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,start){
return flureedb.block_range.cljs$core$IFn$_invoke$arity$5(conn,ledger,start,start,null);
});

flureedb.block_range.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,start,end){
return flureedb.block_range.cljs$core$IFn$_invoke$arity$5(conn,ledger,start,end,null);
});

flureedb.block_range.cljs$core$IFn$_invoke$arity$5 = (function (conn,ledger,start,end,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121619){
var state_val_121620 = (state_121619[(1)]);
if((state_val_121620 === (7))){
var inst_121604 = (state_121619[(7)]);
var inst_121604__$1 = (state_121619[(2)]);
var inst_121605 = shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2(conn,inst_121604__$1);
var inst_121606 = shared.fdb.db(conn,ledger);
var state_121619__$1 = (function (){var statearr_121621 = state_121619;
(statearr_121621[(7)] = inst_121604__$1);

(statearr_121621[(8)] = inst_121605);

return statearr_121621;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121619__$1,(8),inst_121606);
} else {
if((state_val_121620 === (1))){
var state_121619__$1 = state_121619;
var statearr_121622_121635 = state_121619__$1;
(statearr_121622_121635[(2)] = null);

(statearr_121622_121635[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121620 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121619,(3),cljs.core.cst$kw$default,null,(2));
var inst_121599 = (opts == null);
var state_121619__$1 = state_121619;
if(cljs.core.truth_(inst_121599)){
var statearr_121623_121636 = state_121619__$1;
(statearr_121623_121636[(1)] = (5));

} else {
var statearr_121624_121637 = state_121619__$1;
(statearr_121624_121637[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121620 === (6))){
var inst_121602 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var state_121619__$1 = state_121619;
var statearr_121625_121638 = state_121619__$1;
(statearr_121625_121638[(2)] = inst_121602);

(statearr_121625_121638[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121620 === (3))){
var inst_121593 = (state_121619[(2)]);
var inst_121594 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121593], 0));
var inst_121595 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121593) : reject.call(null,inst_121593));
var state_121619__$1 = (function (){var statearr_121626 = state_121619;
(statearr_121626[(9)] = inst_121594);

return statearr_121626;
})();
var statearr_121627_121639 = state_121619__$1;
(statearr_121627_121639[(2)] = inst_121595);


cljs.core.async.impl.ioc_helpers.process_exception(state_121619__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121620 === (2))){
var inst_121617 = (state_121619[(2)]);
var state_121619__$1 = state_121619;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121619__$1,inst_121617);
} else {
if((state_val_121620 === (9))){
var inst_121612 = (state_121619[(2)]);
var inst_121613 = fluree.db.util.async.throw_err(inst_121612);
var inst_121614 = cljs.core.clj__GT_js(inst_121613);
var inst_121615 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121614) : resolve.call(null,inst_121614));
var state_121619__$1 = state_121619;
var statearr_121628_121640 = state_121619__$1;
(statearr_121628_121640[(2)] = inst_121615);


cljs.core.async.impl.ioc_helpers.process_exception(state_121619__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121620 === (5))){
var state_121619__$1 = state_121619;
var statearr_121629_121641 = state_121619__$1;
(statearr_121629_121641[(2)] = null);

(statearr_121629_121641[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121620 === (8))){
var inst_121604 = (state_121619[(7)]);
var inst_121608 = (state_121619[(2)]);
var inst_121609 = fluree.db.util.async.throw_err(inst_121608);
var inst_121610 = fluree.db.query.block.block_range(inst_121609,start,end,inst_121604);
var state_121619__$1 = state_121619;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121619__$1,(9),inst_121610);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$state_machine__99703__auto__ = null;
var flureedb$state_machine__99703__auto____0 = (function (){
var statearr_121630 = [null,null,null,null,null,null,null,null,null,null];
(statearr_121630[(0)] = flureedb$state_machine__99703__auto__);

(statearr_121630[(1)] = (1));

return statearr_121630;
});
var flureedb$state_machine__99703__auto____1 = (function (state_121619){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121619);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121631){if((e121631 instanceof Object)){
var ex__99706__auto__ = e121631;
var statearr_121632_121642 = state_121619;
(statearr_121632_121642[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121619);

return cljs.core.cst$kw$recur;
} else {
throw e121631;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121643 = state_121619;
state_121619 = G__121643;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$state_machine__99703__auto__ = function(state_121619){
switch(arguments.length){
case 0:
return flureedb$state_machine__99703__auto____0.call(this);
case 1:
return flureedb$state_machine__99703__auto____1.call(this,state_121619);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$state_machine__99703__auto____0;
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$state_machine__99703__auto____1;
return flureedb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121633 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121633[(6)] = c__99809__auto__);

return statearr_121633;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

flureedb.block_range.cljs$lang$maxFixedArity = 5;

/**
 * Returns a Promise that will eventually contain transaction information for blocks from
 * start block (inclusive) to end if provided (exclusive). Each block is a separate map,
 * containing keys :block :tx
 */
flureedb.block_range_with_txn = (function flureedb$block_range_with_txn(var_args){
var G__121645 = arguments.length;
switch (G__121645) {
case 3:
return flureedb.block_range_with_txn.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return flureedb.block_range_with_txn.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.block_range_with_txn', flureedb.block_range_with_txn);

flureedb.block_range_with_txn.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,block_map){
return flureedb.block_range_with_txn.cljs$core$IFn$_invoke$arity$4(conn,ledger,block_map,null);
});

flureedb.block_range_with_txn.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,block_map,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121698){
var state_val_121699 = (state_121698[(1)]);
if((state_val_121699 === (7))){
var inst_121658 = (state_121698[(7)]);
var inst_121660 = (state_121698[(8)]);
var inst_121658__$1 = (state_121698[(2)]);
var inst_121659 = shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2(conn,inst_121658__$1);
var inst_121660__$1 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(block_map,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var inst_121662 = (inst_121660__$1 == null);
var inst_121663 = cljs.core.not(inst_121662);
var state_121698__$1 = (function (){var statearr_121700 = state_121698;
(statearr_121700[(7)] = inst_121658__$1);

(statearr_121700[(8)] = inst_121660__$1);

(statearr_121700[(9)] = inst_121659);

return statearr_121700;
})();
if(inst_121663){
var statearr_121701_121727 = state_121698__$1;
(statearr_121701_121727[(1)] = (8));

} else {
var statearr_121702_121728 = state_121698__$1;
(statearr_121702_121728[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (1))){
var state_121698__$1 = state_121698;
var statearr_121703_121729 = state_121698__$1;
(statearr_121703_121729[(2)] = null);

(statearr_121703_121729[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121698,(3),cljs.core.cst$kw$default,null,(2));
var inst_121653 = (opts == null);
var state_121698__$1 = state_121698;
if(cljs.core.truth_(inst_121653)){
var statearr_121704_121730 = state_121698__$1;
(statearr_121704_121730[(1)] = (5));

} else {
var statearr_121705_121731 = state_121698__$1;
(statearr_121705_121731[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (15))){
var inst_121660 = (state_121698[(8)]);
var state_121698__$1 = state_121698;
var statearr_121706_121732 = state_121698__$1;
(statearr_121706_121732[(2)] = inst_121660);

(statearr_121706_121732[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (13))){
var inst_121673 = (state_121698[(2)]);
var state_121698__$1 = state_121698;
var statearr_121707_121733 = state_121698__$1;
(statearr_121707_121733[(2)] = inst_121673);

(statearr_121707_121733[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (6))){
var inst_121656 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var state_121698__$1 = state_121698;
var statearr_121708_121734 = state_121698__$1;
(statearr_121708_121734[(2)] = inst_121656);

(statearr_121708_121734[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (17))){
var inst_121658 = (state_121698[(7)]);
var inst_121682 = (state_121698[(10)]);
var inst_121683 = (state_121698[(11)]);
var inst_121686 = (state_121698[(2)]);
var inst_121687 = fluree.db.util.async.throw_err(inst_121686);
var inst_121688 = fluree.db.query.block.block_range(inst_121687,inst_121682,inst_121683,inst_121658);
var state_121698__$1 = state_121698;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121698__$1,(18),inst_121688);
} else {
if((state_val_121699 === (3))){
var inst_121646 = (state_121698[(2)]);
var inst_121647 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121646], 0));
var inst_121648 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121646) : reject.call(null,inst_121646));
var state_121698__$1 = (function (){var statearr_121709 = state_121698;
(statearr_121709[(12)] = inst_121647);

return statearr_121709;
})();
var statearr_121710_121735 = state_121698__$1;
(statearr_121710_121735[(2)] = inst_121648);


cljs.core.async.impl.ioc_helpers.process_exception(state_121698__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (12))){
var state_121698__$1 = state_121698;
var statearr_121711_121736 = state_121698__$1;
(statearr_121711_121736[(2)] = false);

(statearr_121711_121736[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (2))){
var inst_121696 = (state_121698[(2)]);
var state_121698__$1 = state_121698;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121698__$1,inst_121696);
} else {
if((state_val_121699 === (11))){
var state_121698__$1 = state_121698;
var statearr_121712_121737 = state_121698__$1;
(statearr_121712_121737[(2)] = true);

(statearr_121712_121737[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (9))){
var state_121698__$1 = state_121698;
var statearr_121713_121738 = state_121698__$1;
(statearr_121713_121738[(2)] = false);

(statearr_121713_121738[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (5))){
var state_121698__$1 = state_121698;
var statearr_121714_121739 = state_121698__$1;
(statearr_121714_121739[(2)] = null);

(statearr_121714_121739[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (14))){
var inst_121660 = (state_121698[(8)]);
var inst_121678 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_121660);
var state_121698__$1 = state_121698;
var statearr_121715_121740 = state_121698__$1;
(statearr_121715_121740[(2)] = inst_121678);

(statearr_121715_121740[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (16))){
var inst_121681 = (state_121698[(2)]);
var inst_121682 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121681,cljs.core.cst$kw$start);
var inst_121683 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_121681,cljs.core.cst$kw$end);
var inst_121684 = shared.fdb.db(conn,ledger);
var state_121698__$1 = (function (){var statearr_121716 = state_121698;
(statearr_121716[(10)] = inst_121682);

(statearr_121716[(11)] = inst_121683);

return statearr_121716;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121698__$1,(17),inst_121684);
} else {
if((state_val_121699 === (10))){
var inst_121676 = (state_121698[(2)]);
var state_121698__$1 = state_121698;
if(cljs.core.truth_(inst_121676)){
var statearr_121717_121741 = state_121698__$1;
(statearr_121717_121741[(1)] = (14));

} else {
var statearr_121718_121742 = state_121698__$1;
(statearr_121718_121742[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (18))){
var inst_121690 = (state_121698[(2)]);
var inst_121691 = fluree.db.util.async.throw_err(inst_121690);
var inst_121692 = fluree.db.query.range.block_with_tx_data(inst_121691);
var inst_121693 = cljs.core.clj__GT_js(inst_121692);
var inst_121694 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121693) : resolve.call(null,inst_121693));
var state_121698__$1 = state_121698;
var statearr_121719_121743 = state_121698__$1;
(statearr_121719_121743[(2)] = inst_121694);


cljs.core.async.impl.ioc_helpers.process_exception(state_121698__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121699 === (8))){
var inst_121660 = (state_121698[(8)]);
var inst_121665 = inst_121660.cljs$lang$protocol_mask$partition0$;
var inst_121666 = (inst_121665 & (64));
var inst_121667 = inst_121660.cljs$core$ISeq$;
var inst_121668 = (cljs.core.PROTOCOL_SENTINEL === inst_121667);
var inst_121669 = ((inst_121666) || (inst_121668));
var state_121698__$1 = state_121698;
if(cljs.core.truth_(inst_121669)){
var statearr_121720_121744 = state_121698__$1;
(statearr_121720_121744[(1)] = (11));

} else {
var statearr_121721_121745 = state_121698__$1;
(statearr_121721_121745[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$state_machine__99703__auto__ = null;
var flureedb$state_machine__99703__auto____0 = (function (){
var statearr_121722 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_121722[(0)] = flureedb$state_machine__99703__auto__);

(statearr_121722[(1)] = (1));

return statearr_121722;
});
var flureedb$state_machine__99703__auto____1 = (function (state_121698){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121698);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121723){if((e121723 instanceof Object)){
var ex__99706__auto__ = e121723;
var statearr_121724_121746 = state_121698;
(statearr_121724_121746[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121698);

return cljs.core.cst$kw$recur;
} else {
throw e121723;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121747 = state_121698;
state_121698 = G__121747;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$state_machine__99703__auto__ = function(state_121698){
switch(arguments.length){
case 0:
return flureedb$state_machine__99703__auto____0.call(this);
case 1:
return flureedb$state_machine__99703__auto____1.call(this,state_121698);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$state_machine__99703__auto____0;
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$state_machine__99703__auto____1;
return flureedb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121725 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121725[(6)] = c__99809__auto__);

return statearr_121725;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

flureedb.block_range_with_txn.cljs$lang$maxFixedArity = 4;

flureedb.block_query = (function flureedb$block_query(var_args){
var G__121749 = arguments.length;
switch (G__121749) {
case 3:
return flureedb.block_query.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return flureedb.block_query.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.block_query', flureedb.block_query);

flureedb.block_query.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,query_map){
return flureedb.block_query.cljs$core$IFn$_invoke$arity$4(conn,ledger,query_map,null);
});

flureedb.block_query.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,query_map,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121812){
var state_val_121813 = (state_121812[(1)]);
if((state_val_121813 === (7))){
var inst_121765 = (state_121812[(7)]);
var inst_121762 = (state_121812[(8)]);
var inst_121762__$1 = (state_121812[(2)]);
var inst_121763 = shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2(conn,inst_121762__$1);
var inst_121764 = cljs.core.cst$kw$private_DASH_key.cljs$core$IFn$_invoke$arity$1(inst_121762__$1);
var inst_121765__$1 = cljs.core.cst$kw$auth.cljs$core$IFn$_invoke$arity$1(inst_121762__$1);
var state_121812__$1 = (function (){var statearr_121814 = state_121812;
(statearr_121814[(9)] = inst_121763);

(statearr_121814[(7)] = inst_121765__$1);

(statearr_121814[(10)] = inst_121764);

(statearr_121814[(8)] = inst_121762__$1);

return statearr_121814;
})();
if(cljs.core.truth_(inst_121765__$1)){
var statearr_121815_121848 = state_121812__$1;
(statearr_121815_121848[(1)] = (8));

} else {
var statearr_121816_121849 = state_121812__$1;
(statearr_121816_121849[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (20))){
var inst_121806 = (state_121812[(2)]);
var inst_121807 = cljs.core.clj__GT_js(inst_121806);
var inst_121808 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121807) : resolve.call(null,inst_121807));
var state_121812__$1 = state_121812;
var statearr_121817_121850 = state_121812__$1;
(statearr_121817_121850[(2)] = inst_121808);


cljs.core.async.impl.ioc_helpers.process_exception(state_121812__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (1))){
var state_121812__$1 = state_121812;
var statearr_121818_121851 = state_121812__$1;
(statearr_121818_121851[(2)] = null);

(statearr_121818_121851[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121812,(3),cljs.core.cst$kw$default,null,(2));
var inst_121756 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(query_map,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var inst_121757 = (opts == null);
var state_121812__$1 = (function (){var statearr_121819 = state_121812;
(statearr_121819[(11)] = inst_121756);

return statearr_121819;
})();
if(cljs.core.truth_(inst_121757)){
var statearr_121820_121852 = state_121812__$1;
(statearr_121820_121852[(1)] = (5));

} else {
var statearr_121821_121853 = state_121812__$1;
(statearr_121821_121853[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (15))){
var inst_121770 = (state_121812[(12)]);
var inst_121775 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_121776 = ["_auth/id",inst_121770];
var inst_121777 = (new cljs.core.PersistentVector(null,2,(5),inst_121775,inst_121776,null));
var state_121812__$1 = state_121812;
var statearr_121822_121854 = state_121812__$1;
(statearr_121822_121854[(2)] = inst_121777);

(statearr_121822_121854[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (21))){
var inst_121794 = (state_121812[(2)]);
var inst_121795 = fluree.db.util.async.throw_err(inst_121794);
var state_121812__$1 = state_121812;
var statearr_121823_121855 = state_121812__$1;
(statearr_121823_121855[(2)] = inst_121795);

(statearr_121823_121855[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (13))){
var inst_121764 = (state_121812[(10)]);
var inst_121789 = (state_121812[(2)]);
var inst_121790 = (inst_121764 == null);
var state_121812__$1 = (function (){var statearr_121824 = state_121812;
(statearr_121824[(13)] = inst_121789);

return statearr_121824;
})();
if(cljs.core.truth_(inst_121790)){
var statearr_121825_121856 = state_121812__$1;
(statearr_121825_121856[(1)] = (18));

} else {
var statearr_121826_121857 = state_121812__$1;
(statearr_121826_121857[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (22))){
var inst_121803 = (state_121812[(2)]);
var inst_121804 = fluree.db.util.async.throw_err(inst_121803);
var state_121812__$1 = state_121812;
var statearr_121827_121858 = state_121812__$1;
(statearr_121827_121858[(2)] = inst_121804);

(statearr_121827_121858[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (6))){
var inst_121760 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var state_121812__$1 = state_121812;
var statearr_121828_121859 = state_121812__$1;
(statearr_121828_121859[(2)] = inst_121760);

(statearr_121828_121859[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (17))){
var inst_121773 = (state_121812[(14)]);
var inst_121780 = (state_121812[(2)]);
var inst_121781 = [inst_121780];
var inst_121782 = cljs.core.PersistentHashMap.fromArrays(inst_121773,inst_121781);
var inst_121783 = shared.fdb.db.cljs$core$IFn$_invoke$arity$variadic(conn,ledger,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121782], 0));
var state_121812__$1 = state_121812;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121812__$1,(14),inst_121783);
} else {
if((state_val_121813 === (3))){
var inst_121750 = (state_121812[(2)]);
var inst_121751 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121750], 0));
var inst_121752 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121750) : reject.call(null,inst_121750));
var state_121812__$1 = (function (){var statearr_121829 = state_121812;
(statearr_121829[(15)] = inst_121751);

return statearr_121829;
})();
var statearr_121830_121860 = state_121812__$1;
(statearr_121830_121860[(2)] = inst_121752);


cljs.core.async.impl.ioc_helpers.process_exception(state_121812__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (12))){
var state_121812__$1 = state_121812;
var statearr_121831_121861 = state_121812__$1;
(statearr_121831_121861[(2)] = null);

(statearr_121831_121861[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (2))){
var inst_121810 = (state_121812[(2)]);
var state_121812__$1 = state_121812;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121812__$1,inst_121810);
} else {
if((state_val_121813 === (19))){
var inst_121756 = (state_121812[(11)]);
var inst_121762 = (state_121812[(8)]);
var inst_121797 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_121798 = [cljs.core.cst$kw$action];
var inst_121799 = (new cljs.core.PersistentVector(null,1,(5),inst_121797,inst_121798,null));
var inst_121800 = cljs.core.assoc_in(inst_121762,inst_121799,cljs.core.cst$kw$block);
var inst_121801 = shared.fdb.signed_query_async.cljs$core$IFn$_invoke$arity$4(conn,ledger,inst_121756,inst_121800);
var state_121812__$1 = state_121812;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121812__$1,(22),inst_121801);
} else {
if((state_val_121813 === (11))){
var inst_121770 = (state_121812[(12)]);
var inst_121773 = [cljs.core.cst$kw$auth];
var state_121812__$1 = (function (){var statearr_121832 = state_121812;
(statearr_121832[(14)] = inst_121773);

return statearr_121832;
})();
if(cljs.core.truth_(inst_121770)){
var statearr_121833_121862 = state_121812__$1;
(statearr_121833_121862[(1)] = (15));

} else {
var statearr_121834_121863 = state_121812__$1;
(statearr_121834_121863[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (9))){
var inst_121762 = (state_121812[(8)]);
var inst_121768 = cljs.core.cst$kw$auth_DASH_id.cljs$core$IFn$_invoke$arity$1(inst_121762);
var state_121812__$1 = state_121812;
var statearr_121835_121864 = state_121812__$1;
(statearr_121835_121864[(2)] = inst_121768);

(statearr_121835_121864[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (5))){
var state_121812__$1 = state_121812;
var statearr_121836_121865 = state_121812__$1;
(statearr_121836_121865[(2)] = null);

(statearr_121836_121865[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (14))){
var inst_121785 = (state_121812[(2)]);
var inst_121786 = fluree.db.util.async.throw_err(inst_121785);
var state_121812__$1 = state_121812;
var statearr_121837_121866 = state_121812__$1;
(statearr_121837_121866[(2)] = inst_121786);

(statearr_121837_121866[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (16))){
var state_121812__$1 = state_121812;
var statearr_121838_121867 = state_121812__$1;
(statearr_121838_121867[(2)] = null);

(statearr_121838_121867[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (10))){
var inst_121764 = (state_121812[(10)]);
var inst_121770 = (state_121812[(2)]);
var inst_121771 = (inst_121764 == null);
var state_121812__$1 = (function (){var statearr_121839 = state_121812;
(statearr_121839[(12)] = inst_121770);

return statearr_121839;
})();
if(cljs.core.truth_(inst_121771)){
var statearr_121840_121868 = state_121812__$1;
(statearr_121840_121868[(1)] = (11));

} else {
var statearr_121841_121869 = state_121812__$1;
(statearr_121841_121869[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121813 === (18))){
var inst_121756 = (state_121812[(11)]);
var inst_121762 = (state_121812[(8)]);
var inst_121789 = (state_121812[(13)]);
var inst_121792 = shared.fdb.block_query_async.cljs$core$IFn$_invoke$arity$3(inst_121789,inst_121756,inst_121762);
var state_121812__$1 = state_121812;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121812__$1,(21),inst_121792);
} else {
if((state_val_121813 === (8))){
var inst_121765 = (state_121812[(7)]);
var state_121812__$1 = state_121812;
var statearr_121842_121870 = state_121812__$1;
(statearr_121842_121870[(2)] = inst_121765);

(statearr_121842_121870[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$state_machine__99703__auto__ = null;
var flureedb$state_machine__99703__auto____0 = (function (){
var statearr_121843 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_121843[(0)] = flureedb$state_machine__99703__auto__);

(statearr_121843[(1)] = (1));

return statearr_121843;
});
var flureedb$state_machine__99703__auto____1 = (function (state_121812){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121812);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121844){if((e121844 instanceof Object)){
var ex__99706__auto__ = e121844;
var statearr_121845_121871 = state_121812;
(statearr_121845_121871[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121812);

return cljs.core.cst$kw$recur;
} else {
throw e121844;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121872 = state_121812;
state_121812 = G__121872;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$state_machine__99703__auto__ = function(state_121812){
switch(arguments.length){
case 0:
return flureedb$state_machine__99703__auto____0.call(this);
case 1:
return flureedb$state_machine__99703__auto____1.call(this,state_121812);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$state_machine__99703__auto____0;
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$state_machine__99703__auto____1;
return flureedb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121846 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121846[(6)] = c__99809__auto__);

return statearr_121846;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

flureedb.block_query.cljs$lang$maxFixedArity = 4;

flureedb.history_query = (function flureedb$history_query(var_args){
var G__121874 = arguments.length;
switch (G__121874) {
case 2:
return flureedb.history_query.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return flureedb.history_query.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.history_query', flureedb.history_query);

flureedb.history_query.cljs$core$IFn$_invoke$arity$2 = (function (sources,query_map){
return flureedb.history_query.cljs$core$IFn$_invoke$arity$3(sources,query_map,null);
});

flureedb.history_query.cljs$core$IFn$_invoke$arity$3 = (function (sources,query_map,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121897){
var state_val_121898 = (state_121897[(1)]);
if((state_val_121898 === (1))){
var state_121897__$1 = state_121897;
var statearr_121899_121913 = state_121897__$1;
(statearr_121899_121913[(2)] = null);

(statearr_121899_121913[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121898 === (2))){
var inst_121895 = (state_121897[(2)]);
var state_121897__$1 = state_121897;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121897__$1,inst_121895);
} else {
if((state_val_121898 === (3))){
var inst_121875 = (state_121897[(2)]);
var inst_121876 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121875], 0));
var inst_121877 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121875) : reject.call(null,inst_121875));
var state_121897__$1 = (function (){var statearr_121900 = state_121897;
(statearr_121900[(7)] = inst_121876);

return statearr_121900;
})();
var statearr_121901_121914 = state_121897__$1;
(statearr_121901_121914[(2)] = inst_121877);


cljs.core.async.impl.ioc_helpers.process_exception(state_121897__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121898 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121897,(3),cljs.core.cst$kw$default,null,(2));
var inst_121881 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(query_map,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var inst_121882 = (opts == null);
var state_121897__$1 = (function (){var statearr_121902 = state_121897;
(statearr_121902[(8)] = inst_121881);

return statearr_121902;
})();
if(cljs.core.truth_(inst_121882)){
var statearr_121903_121915 = state_121897__$1;
(statearr_121903_121915[(1)] = (5));

} else {
var statearr_121904_121916 = state_121897__$1;
(statearr_121904_121916[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121898 === (5))){
var state_121897__$1 = state_121897;
var statearr_121905_121917 = state_121897__$1;
(statearr_121905_121917[(2)] = null);

(statearr_121905_121917[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121898 === (6))){
var inst_121885 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var state_121897__$1 = state_121897;
var statearr_121906_121918 = state_121897__$1;
(statearr_121906_121918[(2)] = inst_121885);

(statearr_121906_121918[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121898 === (7))){
var inst_121881 = (state_121897[(8)]);
var inst_121887 = (state_121897[(2)]);
var inst_121888 = shared.fdb.history_query_async.cljs$core$IFn$_invoke$arity$3(sources,inst_121881,inst_121887);
var state_121897__$1 = state_121897;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121897__$1,(8),inst_121888);
} else {
if((state_val_121898 === (8))){
var inst_121890 = (state_121897[(2)]);
var inst_121891 = fluree.db.util.async.throw_err(inst_121890);
var inst_121892 = cljs.core.clj__GT_js(inst_121891);
var inst_121893 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121892) : resolve.call(null,inst_121892));
var state_121897__$1 = state_121897;
var statearr_121907_121919 = state_121897__$1;
(statearr_121907_121919[(2)] = inst_121893);


cljs.core.async.impl.ioc_helpers.process_exception(state_121897__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$state_machine__99703__auto__ = null;
var flureedb$state_machine__99703__auto____0 = (function (){
var statearr_121908 = [null,null,null,null,null,null,null,null,null];
(statearr_121908[(0)] = flureedb$state_machine__99703__auto__);

(statearr_121908[(1)] = (1));

return statearr_121908;
});
var flureedb$state_machine__99703__auto____1 = (function (state_121897){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121897);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121909){if((e121909 instanceof Object)){
var ex__99706__auto__ = e121909;
var statearr_121910_121920 = state_121897;
(statearr_121910_121920[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121897);

return cljs.core.cst$kw$recur;
} else {
throw e121909;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121921 = state_121897;
state_121897 = G__121921;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$state_machine__99703__auto__ = function(state_121897){
switch(arguments.length){
case 0:
return flureedb$state_machine__99703__auto____0.call(this);
case 1:
return flureedb$state_machine__99703__auto____1.call(this,state_121897);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$state_machine__99703__auto____0;
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$state_machine__99703__auto____1;
return flureedb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121911 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121911[(6)] = c__99809__auto__);

return statearr_121911;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

flureedb.history_query.cljs$lang$maxFixedArity = 3;

flureedb.multi_query = (function flureedb$multi_query(var_args){
var G__121923 = arguments.length;
switch (G__121923) {
case 2:
return flureedb.multi_query.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return flureedb.multi_query.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.multi_query', flureedb.multi_query);

flureedb.multi_query.cljs$core$IFn$_invoke$arity$2 = (function (sources,multi_query_map){
return flureedb.multi_query.cljs$core$IFn$_invoke$arity$3(sources,multi_query_map,null);
});

flureedb.multi_query.cljs$core$IFn$_invoke$arity$3 = (function (sources,multi_query_map,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121941){
var state_val_121942 = (state_121941[(1)]);
if((state_val_121942 === (1))){
var state_121941__$1 = state_121941;
var statearr_121943_121952 = state_121941__$1;
(statearr_121943_121952[(2)] = null);

(statearr_121943_121952[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121942 === (2))){
var inst_121939 = (state_121941[(2)]);
var state_121941__$1 = state_121941;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121941__$1,inst_121939);
} else {
if((state_val_121942 === (3))){
var inst_121924 = (state_121941[(2)]);
var inst_121925 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121924], 0));
var inst_121926 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121924) : reject.call(null,inst_121924));
var state_121941__$1 = (function (){var statearr_121944 = state_121941;
(statearr_121944[(7)] = inst_121925);

return statearr_121944;
})();
var statearr_121945_121953 = state_121941__$1;
(statearr_121945_121953[(2)] = inst_121926);


cljs.core.async.impl.ioc_helpers.process_exception(state_121941__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121942 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121941,(3),cljs.core.cst$kw$default,null,(2));
var inst_121930 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(multi_query_map,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var inst_121931 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var inst_121932 = shared.fdb.multi_query_async.cljs$core$IFn$_invoke$arity$3(sources,inst_121930,inst_121931);
var state_121941__$1 = state_121941;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121941__$1,(5),inst_121932);
} else {
if((state_val_121942 === (5))){
var inst_121934 = (state_121941[(2)]);
var inst_121935 = fluree.db.util.async.throw_err(inst_121934);
var inst_121936 = cljs.core.clj__GT_js(inst_121935);
var inst_121937 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121936) : resolve.call(null,inst_121936));
var state_121941__$1 = state_121941;
var statearr_121946_121954 = state_121941__$1;
(statearr_121946_121954[(2)] = inst_121937);


cljs.core.async.impl.ioc_helpers.process_exception(state_121941__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$state_machine__99703__auto__ = null;
var flureedb$state_machine__99703__auto____0 = (function (){
var statearr_121947 = [null,null,null,null,null,null,null,null];
(statearr_121947[(0)] = flureedb$state_machine__99703__auto__);

(statearr_121947[(1)] = (1));

return statearr_121947;
});
var flureedb$state_machine__99703__auto____1 = (function (state_121941){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121941);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121948){if((e121948 instanceof Object)){
var ex__99706__auto__ = e121948;
var statearr_121949_121955 = state_121941;
(statearr_121949_121955[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121941);

return cljs.core.cst$kw$recur;
} else {
throw e121948;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121956 = state_121941;
state_121941 = G__121956;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$state_machine__99703__auto__ = function(state_121941){
switch(arguments.length){
case 0:
return flureedb$state_machine__99703__auto____0.call(this);
case 1:
return flureedb$state_machine__99703__auto____1.call(this,state_121941);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$state_machine__99703__auto____0;
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$state_machine__99703__auto____1;
return flureedb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121950 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121950[(6)] = c__99809__auto__);

return statearr_121950;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

flureedb.multi_query.cljs$lang$maxFixedArity = 3;

/**
 * Execute a query against a database source, or optionally
 *   additional sources if the query spans multiple data sets.
 * 
 *   Returns promise containing results.
 */
flureedb.q = (function flureedb$q(var_args){
var G__121958 = arguments.length;
switch (G__121958) {
case 2:
return flureedb.q.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return flureedb.q.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.q', flureedb.q);

flureedb.q.cljs$core$IFn$_invoke$arity$2 = (function (sources,query_map){
return flureedb.q.cljs$core$IFn$_invoke$arity$3(sources,query_map,null);
});

flureedb.q.cljs$core$IFn$_invoke$arity$3 = (function (sources,query_map,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_121981){
var state_val_121982 = (state_121981[(1)]);
if((state_val_121982 === (1))){
var state_121981__$1 = state_121981;
var statearr_121983_121997 = state_121981__$1;
(statearr_121983_121997[(2)] = null);

(statearr_121983_121997[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121982 === (2))){
var inst_121979 = (state_121981[(2)]);
var state_121981__$1 = state_121981;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121981__$1,inst_121979);
} else {
if((state_val_121982 === (3))){
var inst_121959 = (state_121981[(2)]);
var inst_121960 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_121959], 0));
var inst_121961 = cljs.core.clj__GT_js(inst_121959);
var inst_121962 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_121961) : reject.call(null,inst_121961));
var state_121981__$1 = (function (){var statearr_121984 = state_121981;
(statearr_121984[(7)] = inst_121960);

return statearr_121984;
})();
var statearr_121985_121998 = state_121981__$1;
(statearr_121985_121998[(2)] = inst_121962);


cljs.core.async.impl.ioc_helpers.process_exception(state_121981__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121982 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121981,(3),cljs.core.cst$kw$default,null,(2));
var inst_121966 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(query_map,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var inst_121967 = (opts == null);
var state_121981__$1 = (function (){var statearr_121986 = state_121981;
(statearr_121986[(8)] = inst_121966);

return statearr_121986;
})();
if(cljs.core.truth_(inst_121967)){
var statearr_121987_121999 = state_121981__$1;
(statearr_121987_121999[(1)] = (5));

} else {
var statearr_121988_122000 = state_121981__$1;
(statearr_121988_122000[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121982 === (5))){
var state_121981__$1 = state_121981;
var statearr_121989_122001 = state_121981__$1;
(statearr_121989_122001[(2)] = null);

(statearr_121989_122001[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121982 === (6))){
var inst_121970 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var state_121981__$1 = state_121981;
var statearr_121990_122002 = state_121981__$1;
(statearr_121990_122002[(2)] = inst_121970);

(statearr_121990_122002[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121982 === (7))){
var inst_121966 = (state_121981[(8)]);
var inst_121972 = (state_121981[(2)]);
var inst_121973 = shared.fdb.query_async.cljs$core$IFn$_invoke$arity$3(sources,inst_121966,inst_121972);
var state_121981__$1 = state_121981;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121981__$1,(8),inst_121973);
} else {
if((state_val_121982 === (8))){
var inst_121975 = (state_121981[(2)]);
var inst_121976 = cljs.core.clj__GT_js(inst_121975);
var inst_121977 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_121976) : resolve.call(null,inst_121976));
var state_121981__$1 = state_121981;
var statearr_121991_122003 = state_121981__$1;
(statearr_121991_122003[(2)] = inst_121977);


cljs.core.async.impl.ioc_helpers.process_exception(state_121981__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$state_machine__99703__auto__ = null;
var flureedb$state_machine__99703__auto____0 = (function (){
var statearr_121992 = [null,null,null,null,null,null,null,null,null];
(statearr_121992[(0)] = flureedb$state_machine__99703__auto__);

(statearr_121992[(1)] = (1));

return statearr_121992;
});
var flureedb$state_machine__99703__auto____1 = (function (state_121981){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121981);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121993){if((e121993 instanceof Object)){
var ex__99706__auto__ = e121993;
var statearr_121994_122004 = state_121981;
(statearr_121994_122004[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121981);

return cljs.core.cst$kw$recur;
} else {
throw e121993;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__122005 = state_121981;
state_121981 = G__122005;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$state_machine__99703__auto__ = function(state_121981){
switch(arguments.length){
case 0:
return flureedb$state_machine__99703__auto____0.call(this);
case 1:
return flureedb$state_machine__99703__auto____1.call(this,state_121981);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$state_machine__99703__auto____0;
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$state_machine__99703__auto____1;
return flureedb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_121995 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121995[(6)] = c__99809__auto__);

return statearr_121995;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

flureedb.q.cljs$lang$maxFixedArity = 3;

/**
 * Execute a query against a ledger, or optionally
 *   additional sources if the query spans multiple data sets.
 * 
 *   Returns promise containing results.
 */
flureedb.signed_query = (function flureedb$signed_query(var_args){
var G__122007 = arguments.length;
switch (G__122007) {
case 3:
return flureedb.signed_query.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return flureedb.signed_query.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});
goog.exportSymbol('flureedb.signed_query', flureedb.signed_query);

flureedb.signed_query.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,query_map){
return flureedb.signed_query.cljs$core$IFn$_invoke$arity$4(conn,ledger,query_map,null);
});

flureedb.signed_query.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,query_map,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_122031){
var state_val_122032 = (state_122031[(1)]);
if((state_val_122032 === (1))){
var state_122031__$1 = state_122031;
var statearr_122033_122047 = state_122031__$1;
(statearr_122033_122047[(2)] = null);

(statearr_122033_122047[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_122032 === (2))){
var inst_122029 = (state_122031[(2)]);
var state_122031__$1 = state_122031;
return cljs.core.async.impl.ioc_helpers.return_chan(state_122031__$1,inst_122029);
} else {
if((state_val_122032 === (3))){
var inst_122008 = (state_122031[(2)]);
var inst_122009 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_122008], 0));
var inst_122010 = cljs.core.clj__GT_js(inst_122008);
var inst_122011 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_122010) : reject.call(null,inst_122010));
var state_122031__$1 = (function (){var statearr_122034 = state_122031;
(statearr_122034[(7)] = inst_122009);

return statearr_122034;
})();
var statearr_122035_122048 = state_122031__$1;
(statearr_122035_122048[(2)] = inst_122011);


cljs.core.async.impl.ioc_helpers.process_exception(state_122031__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_122032 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_122031,(3),cljs.core.cst$kw$default,null,(2));
var inst_122015 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(query_map,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var inst_122016 = (opts == null);
var state_122031__$1 = (function (){var statearr_122036 = state_122031;
(statearr_122036[(8)] = inst_122015);

return statearr_122036;
})();
if(cljs.core.truth_(inst_122016)){
var statearr_122037_122049 = state_122031__$1;
(statearr_122037_122049[(1)] = (5));

} else {
var statearr_122038_122050 = state_122031__$1;
(statearr_122038_122050[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_122032 === (5))){
var state_122031__$1 = state_122031;
var statearr_122039_122051 = state_122031__$1;
(statearr_122039_122051[(2)] = null);

(statearr_122039_122051[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_122032 === (6))){
var inst_122019 = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var state_122031__$1 = state_122031;
var statearr_122040_122052 = state_122031__$1;
(statearr_122040_122052[(2)] = inst_122019);

(statearr_122040_122052[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_122032 === (7))){
var inst_122015 = (state_122031[(8)]);
var inst_122021 = (state_122031[(2)]);
var inst_122022 = shared.fdb.signed_query_async.cljs$core$IFn$_invoke$arity$4(conn,ledger,inst_122015,inst_122021);
var state_122031__$1 = state_122031;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_122031__$1,(8),inst_122022);
} else {
if((state_val_122032 === (8))){
var inst_122024 = (state_122031[(2)]);
var inst_122025 = fluree.db.util.async.throw_err(inst_122024);
var inst_122026 = cljs.core.clj__GT_js(inst_122025);
var inst_122027 = (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(inst_122026) : resolve.call(null,inst_122026));
var state_122031__$1 = state_122031;
var statearr_122041_122053 = state_122031__$1;
(statearr_122041_122053[(2)] = inst_122027);


cljs.core.async.impl.ioc_helpers.process_exception(state_122031__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var flureedb$state_machine__99703__auto__ = null;
var flureedb$state_machine__99703__auto____0 = (function (){
var statearr_122042 = [null,null,null,null,null,null,null,null,null];
(statearr_122042[(0)] = flureedb$state_machine__99703__auto__);

(statearr_122042[(1)] = (1));

return statearr_122042;
});
var flureedb$state_machine__99703__auto____1 = (function (state_122031){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_122031);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e122043){if((e122043 instanceof Object)){
var ex__99706__auto__ = e122043;
var statearr_122044_122054 = state_122031;
(statearr_122044_122054[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_122031);

return cljs.core.cst$kw$recur;
} else {
throw e122043;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__122055 = state_122031;
state_122031 = G__122055;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureedb$state_machine__99703__auto__ = function(state_122031){
switch(arguments.length){
case 0:
return flureedb$state_machine__99703__auto____0.call(this);
case 1:
return flureedb$state_machine__99703__auto____1.call(this,state_122031);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureedb$state_machine__99703__auto____0;
flureedb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureedb$state_machine__99703__auto____1;
return flureedb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_122045 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_122045[(6)] = c__99809__auto__);

return statearr_122045;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

flureedb.signed_query.cljs$lang$maxFixedArity = 4;

/**
 * Listens to all events of a given ledger. Supply a ledger identity,
 *   any key, and a two-argument function that will be called with each event.
 * 
 *   The key is any arbitrary key, and is only used to close the listener via close-listener,
 *   otherwise it is opaque to the listener.
 * 
 *   The callback function's first argument is the event header/metadata and the second argument
 *   is the event data itself.
 */
flureedb.listen = (function flureedb$listen(conn,ledger,key,callback){
return shared.connection_handler.listen(conn,ledger,key,callback);
});
goog.exportSymbol('flureedb.listen', flureedb.listen);
/**
 * Closes a listener.
 */
flureedb.close_listener = (function flureedb$close_listener(conn,ledger,key){
return shared.connection_handler.close_listener(conn,ledger,key);
});
goog.exportSymbol('flureedb.close_listener', flureedb.close_listener);
/**
 * Return a list of listeners currently registered for each ledger along with their respective keys.
 */
flureedb.listeners = (function flureedb$listeners(conn){
return shared.connection_handler.listeners(conn);
});
goog.exportSymbol('flureedb.listeners', flureedb.listeners);
/**
 * Takes an http request and creates an http signature using a private key
 */
flureedb.http_signature = (function flureedb$http_signature(req_method,url,request,private_key,auth){
return fluree.db.query.http_signatures.sign_request.cljs$core$IFn$_invoke$arity$5(req_method,url,request,private_key,auth);
});
goog.exportSymbol('flureedb.http_signature', flureedb.http_signature);
