// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.operations');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.log');
goog.require('cljs.core.async');
/**
 * Returns true if connection has been closed.
 */
fluree.db.operations.conn_closed_QMARK_ = (function fluree$db$operations$conn_closed_QMARK_(conn){
return cljs.core.cst$kw$close_QMARK_.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(conn)));
});
/**
 * Creates the operation header.
 */
fluree.db.operations.formulate_op_header = (function fluree$db$operations$formulate_op_header(var_args){
var G__106878 = arguments.length;
switch (G__106878) {
case 2:
return fluree.db.operations.formulate_op_header.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.operations.formulate_op_header.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.operations.formulate_op_header.cljs$core$IFn$_invoke$arity$2 = (function (operation,db){
return fluree.db.operations.formulate_op_header.cljs$core$IFn$_invoke$arity$3(operation,db,(60000));
});

fluree.db.operations.formulate_op_header.cljs$core$IFn$_invoke$arity$3 = (function (operation,db,timeout){
var req_id = cljs.core.str.cljs$core$IFn$_invoke$arity$1(fluree.db.util.core.random_uuid());
var header = new cljs.core.PersistentArrayMap(null, 5, [cljs.core.cst$kw$db,db,cljs.core.cst$kw$op,operation,cljs.core.cst$kw$req_DASH_id,req_id,cljs.core.cst$kw$timestamp,fluree.db.util.core.current_time_millis(),cljs.core.cst$kw$timeout,timeout], null);
return header;
});

fluree.db.operations.formulate_op_header.cljs$lang$maxFixedArity = 3;

/**
 * Sends operation off, returns core async promise channel that will have eventual response
 *   or timeout response.
 * 
 *   Records the request-id which is stored in an atom along with the response channel.
 * 
 *   Incoming ledger notifications will look at request id and see if
 *   there is a matching request-id in the record with its corresponding
 *   async channel, and if so it will populate that channel with the response.
 * 
 *   We use the timeout to create a timeout channel, so if no transactions with
 *   the corresponding request id are 'seen' in that timeframe, a timeout response
 *   is given.
 */
fluree.db.operations.send_operation = (function fluree$db$operations$send_operation(var_args){
var G__106881 = arguments.length;
switch (G__106881) {
case 3:
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3 = (function (conn,operation,data){
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$4(conn,operation,data,null);
});

fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$4 = (function (conn,operation,data,opts){
var pc = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__99809__auto___106924 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___106924,pc){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___106924,pc){
return (function (state_106909){
var state_val_106910 = (state_106909[(1)]);
if((state_val_106910 === (1))){
var state_106909__$1 = state_106909;
var statearr_106911_106925 = state_106909__$1;
(statearr_106911_106925[(2)] = null);

(statearr_106911_106925[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106910 === (2))){
var inst_106907 = (state_106909[(2)]);
var state_106909__$1 = state_106909;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106909__$1,inst_106907);
} else {
if((state_val_106910 === (3))){
var inst_106882 = (state_106909[(2)]);
var inst_106883 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pc,inst_106882);
var state_106909__$1 = state_106909;
var statearr_106912_106926 = state_106909__$1;
(statearr_106912_106926[(2)] = inst_106883);


cljs.core.async.impl.ioc_helpers.process_exception(state_106909__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106910 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106909,(3),cljs.core.cst$kw$default,null,(2));
var inst_106887 = fluree.db.operations.conn_closed_QMARK_(conn);
var state_106909__$1 = state_106909;
if(cljs.core.truth_(inst_106887)){
var statearr_106913_106927 = state_106909__$1;
(statearr_106913_106927[(1)] = (5));

} else {
var statearr_106914_106928 = state_106909__$1;
(statearr_106914_106928[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106910 === (5))){
var inst_106889 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_106890 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_connection];
var inst_106891 = cljs.core.PersistentHashMap.fromArrays(inst_106889,inst_106890);
var inst_106892 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Connection was closed.",inst_106891);
var inst_106893 = (function(){throw inst_106892})();
var state_106909__$1 = state_106909;
var statearr_106915_106929 = state_106909__$1;
(statearr_106915_106929[(2)] = inst_106893);

(statearr_106915_106929[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106910 === (6))){
var inst_106895 = cljs.core.cst$kw$req_DASH_chan.cljs$core$IFn$_invoke$arity$1(conn);
var inst_106896 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_106897 = [operation,data,pc,opts];
var inst_106898 = (new cljs.core.PersistentVector(null,4,(5),inst_106896,inst_106897,null));
var inst_106899 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(inst_106895,inst_106898);
var inst_106900 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_106901 = [operation,data,pc,opts];
var inst_106902 = (new cljs.core.PersistentVector(null,4,(5),inst_106900,inst_106901,null));
var inst_106903 = fluree.db.util.log.trace.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Put operation on connection req-chan: ",inst_106902], 0));
var state_106909__$1 = (function (){var statearr_106916 = state_106909;
(statearr_106916[(7)] = inst_106899);

return statearr_106916;
})();
var statearr_106917_106930 = state_106909__$1;
(statearr_106917_106930[(2)] = inst_106903);

(statearr_106917_106930[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106910 === (7))){
var inst_106905 = (state_106909[(2)]);
var state_106909__$1 = state_106909;
var statearr_106918_106931 = state_106909__$1;
(statearr_106918_106931[(2)] = inst_106905);


cljs.core.async.impl.ioc_helpers.process_exception(state_106909__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(c__99809__auto___106924,pc))
;
return ((function (switch__99702__auto__,c__99809__auto___106924,pc){
return (function() {
var fluree$db$operations$state_machine__99703__auto__ = null;
var fluree$db$operations$state_machine__99703__auto____0 = (function (){
var statearr_106919 = [null,null,null,null,null,null,null,null];
(statearr_106919[(0)] = fluree$db$operations$state_machine__99703__auto__);

(statearr_106919[(1)] = (1));

return statearr_106919;
});
var fluree$db$operations$state_machine__99703__auto____1 = (function (state_106909){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106909);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106920){if((e106920 instanceof Object)){
var ex__99706__auto__ = e106920;
var statearr_106921_106932 = state_106909;
(statearr_106921_106932[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106909);

return cljs.core.cst$kw$recur;
} else {
throw e106920;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106933 = state_106909;
state_106909 = G__106933;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$operations$state_machine__99703__auto__ = function(state_106909){
switch(arguments.length){
case 0:
return fluree$db$operations$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$operations$state_machine__99703__auto____1.call(this,state_106909);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$operations$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$operations$state_machine__99703__auto____0;
fluree$db$operations$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$operations$state_machine__99703__auto____1;
return fluree$db$operations$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___106924,pc))
})();
var state__99811__auto__ = (function (){var statearr_106922 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106922[(6)] = c__99809__auto___106924);

return statearr_106922;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___106924,pc))
);


return pc;
});

fluree.db.operations.send_operation.cljs$lang$maxFixedArity = 4;

/**
 * A quick async response to confirm as initiated, but deletion happens in background.
 * 
 *   A final 'completed' message will be sent in the future, if anyone cares to hear it.
 */
fluree.db.operations.delete_ledger_async = (function fluree$db$operations$delete_ledger_async(var_args){
var G__106935 = arguments.length;
switch (G__106935) {
case 1:
return fluree.db.operations.delete_ledger_async.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.operations.delete_ledger_async.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.operations.delete_ledger_async.cljs$core$IFn$_invoke$arity$1 = (function (session){
return fluree.db.operations.delete_ledger_async.cljs$core$IFn$_invoke$arity$2(session,null);
});

fluree.db.operations.delete_ledger_async.cljs$core$IFn$_invoke$arity$2 = (function (session,p__106936){
var map__106937 = p__106936;
var map__106937__$1 = (((((!((map__106937 == null))))?(((((map__106937.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__106937.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__106937):map__106937);
var opts = map__106937__$1;
var snapshot_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106937__$1,cljs.core.cst$kw$snapshot_QMARK_);
var map__106939 = session;
var map__106939__$1 = (((((!((map__106939 == null))))?(((((map__106939.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__106939.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__106939):map__106939);
var dbid = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106939__$1,cljs.core.cst$kw$dbid);
var network = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106939__$1,cljs.core.cst$kw$network);
var conn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106939__$1,cljs.core.cst$kw$conn);
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$delete_DASH_db,new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$network,network,cljs.core.cst$kw$dbid,dbid,cljs.core.cst$kw$snapshot_QMARK_,snapshot_QMARK_], null));
});

fluree.db.operations.delete_ledger_async.cljs$lang$maxFixedArity = 2;

/**
 * A quick async response to confirm as initiated, but garbage collection happens in background.
 * 
 *   A final 'completed' message will be sent in the future, if anyone cares to hear it.
 */
fluree.db.operations.garbage_collect_async = (function fluree$db$operations$garbage_collect_async(var_args){
var args__4736__auto__ = [];
var len__4730__auto___106998 = arguments.length;
var i__4731__auto___106999 = (0);
while(true){
if((i__4731__auto___106999 < len__4730__auto___106998)){
args__4736__auto__.push((arguments[i__4731__auto___106999]));

var G__107000 = (i__4731__auto___106999 + (1));
i__4731__auto___106999 = G__107000;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return fluree.db.operations.garbage_collect_async.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

fluree.db.operations.garbage_collect_async.cljs$core$IFn$_invoke$arity$variadic = (function (session,p__106944){
var vec__106945 = p__106944;
var map__106948 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__106945,(0),null);
var map__106948__$1 = (((((!((map__106948 == null))))?(((((map__106948.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__106948.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__106948):map__106948);
var toBlock = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106948__$1,cljs.core.cst$kw$toBlock);
var toTime = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106948__$1,cljs.core.cst$kw$toTime);
var opts = vec__106945;
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,vec__106945,map__106948,map__106948__$1,toBlock,toTime,opts){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,vec__106945,map__106948,map__106948__$1,toBlock,toTime,opts){
return (function (state_106980){
var state_val_106981 = (state_106980[(1)]);
if((state_val_106981 === (7))){
var inst_106963 = (state_106980[(2)]);
var state_106980__$1 = state_106980;
var statearr_106982_107001 = state_106980__$1;
(statearr_106982_107001[(2)] = inst_106963);

(statearr_106982_107001[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106981 === (1))){
var inst_106952 = (session == null);
var inst_106953 = cljs.core.not(inst_106952);
var state_106980__$1 = state_106980;
if(inst_106953){
var statearr_106983_107002 = state_106980__$1;
(statearr_106983_107002[(1)] = (2));

} else {
var statearr_106984_107003 = state_106980__$1;
(statearr_106984_107003[(1)] = (3));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106981 === (4))){
var inst_106966 = (state_106980[(2)]);
var state_106980__$1 = state_106980;
if(cljs.core.truth_(inst_106966)){
var statearr_106985_107004 = state_106980__$1;
(statearr_106985_107004[(1)] = (8));

} else {
var statearr_106986_107005 = state_106980__$1;
(statearr_106986_107005[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106981 === (6))){
var state_106980__$1 = state_106980;
var statearr_106987_107006 = state_106980__$1;
(statearr_106987_107006[(2)] = false);

(statearr_106987_107006[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106981 === (3))){
var state_106980__$1 = state_106980;
var statearr_106988_107007 = state_106980__$1;
(statearr_106988_107007[(2)] = false);

(statearr_106988_107007[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106981 === (2))){
var inst_106955 = session.cljs$lang$protocol_mask$partition0$;
var inst_106956 = (inst_106955 & (64));
var inst_106957 = session.cljs$core$ISeq$;
var inst_106958 = (cljs.core.PROTOCOL_SENTINEL === inst_106957);
var inst_106959 = ((inst_106956) || (inst_106958));
var state_106980__$1 = state_106980;
if(cljs.core.truth_(inst_106959)){
var statearr_106989_107008 = state_106980__$1;
(statearr_106989_107008[(1)] = (5));

} else {
var statearr_106990_107009 = state_106980__$1;
(statearr_106990_107009[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106981 === (9))){
var state_106980__$1 = state_106980;
var statearr_106991_107010 = state_106980__$1;
(statearr_106991_107010[(2)] = session);

(statearr_106991_107010[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106981 === (5))){
var state_106980__$1 = state_106980;
var statearr_106992_107011 = state_106980__$1;
(statearr_106992_107011[(2)] = true);

(statearr_106992_107011[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106981 === (10))){
var inst_106971 = (state_106980[(2)]);
var inst_106972 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_106971,cljs.core.cst$kw$network);
var inst_106973 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_106971,cljs.core.cst$kw$dbid);
var inst_106974 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_106971,cljs.core.cst$kw$conn);
var inst_106975 = [cljs.core.cst$kw$network,cljs.core.cst$kw$dbid,cljs.core.cst$kw$toBlock,cljs.core.cst$kw$toTime];
var inst_106976 = [inst_106972,inst_106973,toBlock,toTime];
var inst_106977 = cljs.core.PersistentHashMap.fromArrays(inst_106975,inst_106976);
var inst_106978 = fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(inst_106974,cljs.core.cst$kw$garbage,inst_106977);
var state_106980__$1 = state_106980;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106980__$1,inst_106978);
} else {
if((state_val_106981 === (8))){
var inst_106968 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,session);
var state_106980__$1 = state_106980;
var statearr_106993_107012 = state_106980__$1;
(statearr_106993_107012[(2)] = inst_106968);

(statearr_106993_107012[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,vec__106945,map__106948,map__106948__$1,toBlock,toTime,opts))
;
return ((function (switch__99702__auto__,c__99809__auto__,vec__106945,map__106948,map__106948__$1,toBlock,toTime,opts){
return (function() {
var fluree$db$operations$state_machine__99703__auto__ = null;
var fluree$db$operations$state_machine__99703__auto____0 = (function (){
var statearr_106994 = [null,null,null,null,null,null,null];
(statearr_106994[(0)] = fluree$db$operations$state_machine__99703__auto__);

(statearr_106994[(1)] = (1));

return statearr_106994;
});
var fluree$db$operations$state_machine__99703__auto____1 = (function (state_106980){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106980);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106995){if((e106995 instanceof Object)){
var ex__99706__auto__ = e106995;
var statearr_106996_107013 = state_106980;
(statearr_106996_107013[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106980);

return cljs.core.cst$kw$recur;
} else {
throw e106995;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__107014 = state_106980;
state_106980 = G__107014;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$operations$state_machine__99703__auto__ = function(state_106980){
switch(arguments.length){
case 0:
return fluree$db$operations$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$operations$state_machine__99703__auto____1.call(this,state_106980);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$operations$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$operations$state_machine__99703__auto____0;
fluree$db$operations$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$operations$state_machine__99703__auto____1;
return fluree$db$operations$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,vec__106945,map__106948,map__106948__$1,toBlock,toTime,opts))
})();
var state__99811__auto__ = (function (){var statearr_106997 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106997[(6)] = c__99809__auto__);

return statearr_106997;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,vec__106945,map__106948,map__106948__$1,toBlock,toTime,opts))
);

return c__99809__auto__;
});

fluree.db.operations.garbage_collect_async.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
fluree.db.operations.garbage_collect_async.cljs$lang$applyTo = (function (seq106942){
var G__106943 = cljs.core.first(seq106942);
var seq106942__$1 = cljs.core.next(seq106942);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__106943,seq106942__$1);
});

/**
 * A quick async response to confirm, but archival happens in background.
 * 
 *   A final 'completed' message will be sent in the future, if anyone cares to hear it.
 */
fluree.db.operations.snapshot_ledger_async = (function fluree$db$operations$snapshot_ledger_async(session,opts){
var map__107015 = session;
var map__107015__$1 = (((((!((map__107015 == null))))?(((((map__107015.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__107015.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__107015):map__107015);
var network = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__107015__$1,cljs.core.cst$kw$network);
var dbid = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__107015__$1,cljs.core.cst$kw$dbid);
var conn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__107015__$1,cljs.core.cst$kw$conn);
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$snapshot_DASH_db,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null));
});
/**
 * Submits a command to connected tx-group server
 */
fluree.db.operations.command_async = (function fluree$db$operations$command_async(conn,cmd){
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$cmd,cmd);
});
/**
 * A response will not be returned until transaction is completed.
 * 
 *   An option of {:wait false} can be provided which will return 'true' when the transaction
 *   has been successfully persisted by the transactors, or throw an exception.
 * 
 *   By default transact will monitor completed blocks and only return once it sees
 *   the successful transaction completed, or it will return with an error.
 */
fluree.db.operations.unsigned_command_async = (function fluree$db$operations$unsigned_command_async(conn,unsigned_cmd_map){
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$unsigned_DASH_cmd,unsigned_cmd_map);
});
/**
 * Returns information about a ledger in a map, or empty map if db doesn't exist.
 */
fluree.db.operations.ledger_info_async = (function fluree$db$operations$ledger_info_async(conn,ledger){
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$ledger_DASH_info,ledger);
});
/**
 * Returns information about a ledger in a map, or empty map if db doesn't exist.
 */
fluree.db.operations.ledger_status_async = (function fluree$db$operations$ledger_status_async(conn,ledger){
return cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$ledger_DASH_info,ledger));
});
/**
 * Returns stats about a ledger in a map, or empty map if db doesn't exist.
 */
fluree.db.operations.ledger_stats_async = (function fluree$db$operations$ledger_stats_async(conn,ledger){
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$ledger_DASH_stats,ledger);
});
/**
 * Returns a list of ledgers in two-tuples of [network ledger-id].
 */
fluree.db.operations.ledgers_async = (function fluree$db$operations$ledgers_async(conn){
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$db_DASH_list,null);
});
/**
 * A response will not be returned until transaction is completed.
 * 
 *   An option of {:wait false} can be provided which will return 'true' when the transaction
 *   has been successfully persisted by the transactors, or throw an exception.
 * 
 *   By default transact will monitor completed blocks and only return once it sees
 *   the successful transaction completed, or it will return with an error.
 */
fluree.db.operations.transact_async = (function fluree$db$operations$transact_async(conn,tx_map){
fluree.db.util.log.trace.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Sending transaction async: ",tx_map], 0));

return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$tx,tx_map);
});
/**
 * Starts a subscription to the session's ledger.
 * 
 *   Supported options:
 *   - auth    - auth, if specified, takes precedence
 *   - jwt     - valid jwt
 *   
 */
fluree.db.operations.subscribe = (function fluree$db$operations$subscribe(var_args){
var G__107018 = arguments.length;
switch (G__107018) {
case 1:
return fluree.db.operations.subscribe.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.operations.subscribe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.operations.subscribe.cljs$core$IFn$_invoke$arity$1 = (function (session){
return fluree.db.operations.subscribe.cljs$core$IFn$_invoke$arity$2(session,null);
});

fluree.db.operations.subscribe.cljs$core$IFn$_invoke$arity$2 = (function (session,opts){
var map__107019 = opts;
var map__107019__$1 = (((((!((map__107019 == null))))?(((((map__107019.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__107019.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__107019):map__107019);
var auth = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__107019__$1,cljs.core.cst$kw$auth);
var jwt = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__107019__$1,cljs.core.cst$kw$jwt);
var conn = cljs.core.cst$kw$conn.cljs$core$IFn$_invoke$arity$1(session);
var auth_or_jwt = (function (){var or__4131__auto__ = auth;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return jwt;
}
})();
var _ = fluree.db.util.log.trace.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Subscribe to: ",cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(session),cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(session),auth_or_jwt], 0));
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$subscribe,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(session),cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(session)], null),auth_or_jwt], null));
});

fluree.db.operations.subscribe.cljs$lang$maxFixedArity = 2;

/**
 * Unsubscribes from the session's ledger.
 */
fluree.db.operations.unsubscribe = (function fluree$db$operations$unsubscribe(session){
var conn = cljs.core.cst$kw$conn.cljs$core$IFn$_invoke$arity$1(session);
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3(conn,cljs.core.cst$kw$unsbuscribe,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(session),cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(session)], null));
});
