// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('flureeworker');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('cljs.core.async');
goog.require('fluree.db.session');
goog.require('fluree.db.connection');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.json');
goog.require('goog.object');
goog.require('shared.fdb');
goog.require('shared.connection_handler');
flureeworker.query_types = new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$block,shared.fdb.block_query_async,cljs.core.cst$kw$history,shared.fdb.history_query_async,cljs.core.cst$kw$multi,shared.fdb.multi_query_async,cljs.core.cst$kw$query,shared.fdb.query_async], null);
flureeworker.conn_register = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
flureeworker.postMessage = (function flureeworker$postMessage(message){
return self.postMessage(cljs.core.clj__GT_js(message));
});
flureeworker.conn_id__GT_db = (function flureeworker$conn_id__GT_db(conn_id,time){
var map__120975 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),conn_id);
var map__120975__$1 = (((((!((map__120975 == null))))?(((((map__120975.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__120975.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__120975):map__120975);
var conn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__120975__$1,cljs.core.cst$kw$conn);
var ledger = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__120975__$1,cljs.core.cst$kw$ledger);
var closed = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__120975__$1,cljs.core.cst$kw$closed);
var queries = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__120975__$1,cljs.core.cst$kw$queries);
return shared.fdb.db.cljs$core$IFn$_invoke$arity$variadic(conn,ledger,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([(function (){var obj120978 = ({"block":time});
return obj120978;
})()], 0));
});
/**
 * Parses a (nested) JavaScript object into a Clojure map
 */
flureeworker.obj__GT_clj = (function flureeworker$obj__GT_clj(obj){
if(cljs.core.truth_(goog.isObject(obj))){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (result,key){
var v = goog.object.get(obj,key);
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("function",goog.typeOf(v))){
return result;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(result,cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(key),(flureeworker.obj__GT_clj.cljs$core$IFn$_invoke$arity$1 ? flureeworker.obj__GT_clj.cljs$core$IFn$_invoke$arity$1(v) : flureeworker.obj__GT_clj.call(null,v)));
}
}),cljs.core.PersistentArrayMap.EMPTY,goog.object.getKeys(obj));
} else {
return obj;
}
});
if((typeof flureeworker !== 'undefined') && (typeof flureeworker.worker_action !== 'undefined')){
} else {
flureeworker.worker_action = (function (){var method_table__4613__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4614__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4615__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4616__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4617__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$3(cljs.core.PersistentArrayMap.EMPTY,cljs.core.cst$kw$hierarchy,(function (){var fexpr__120979 = cljs.core.get_global_hierarchy;
return (fexpr__120979.cljs$core$IFn$_invoke$arity$0 ? fexpr__120979.cljs$core$IFn$_invoke$arity$0() : fexpr__120979.call(null));
})());
return (new cljs.core.MultiFn(cljs.core.symbol.cljs$core$IFn$_invoke$arity$2("flureeworker","worker-action"),((function (method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__){
return (function() { 
var G__120980__delegate = function (conn_id,event,_){
return event;
};
var G__120980 = function (conn_id,event,var_args){
var _ = null;
if (arguments.length > 2) {
var G__120981__i = 0, G__120981__a = new Array(arguments.length -  2);
while (G__120981__i < G__120981__a.length) {G__120981__a[G__120981__i] = arguments[G__120981__i + 2]; ++G__120981__i;}
  _ = new cljs.core.IndexedSeq(G__120981__a,0,null);
} 
return G__120980__delegate.call(this,conn_id,event,_);};
G__120980.cljs$lang$maxFixedArity = 2;
G__120980.cljs$lang$applyTo = (function (arglist__120982){
var conn_id = cljs.core.first(arglist__120982);
arglist__120982 = cljs.core.next(arglist__120982);
var event = cljs.core.first(arglist__120982);
var _ = cljs.core.rest(arglist__120982);
return G__120980__delegate(conn_id,event,_);
});
G__120980.cljs$core$IFn$_invoke$arity$variadic = G__120980__delegate;
return G__120980;
})()
;})(method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__))
,cljs.core.cst$kw$default,hierarchy__4617__auto__,method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__));
})();
}
flureeworker.worker_action.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$setState,(function (conn_id,_,id,state_update){
return flureeworker.postMessage(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$conn,conn_id,cljs.core.cst$kw$event,"setState",cljs.core.cst$kw$ref,id,cljs.core.cst$kw$data,cljs.core.clj__GT_js(state_update)], null));
}));
flureeworker.worker_action.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$connStatus,(function (conn_id,_,id,response){
return flureeworker.postMessage(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$conn,conn_id,cljs.core.cst$kw$event,"connStatus",cljs.core.cst$kw$ref,id,cljs.core.cst$kw$data,cljs.core.clj__GT_js(response)], null));
}));
flureeworker.worker_action.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$login,(function (conn_id,_,ref,response){
return flureeworker.postMessage(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$conn,conn_id,cljs.core.cst$kw$event,"login",cljs.core.cst$kw$ref,ref,cljs.core.cst$kw$data,cljs.core.clj__GT_js(response)], null));
}));
flureeworker.worker_action.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$pwGenerate,(function (conn_id,_,ref,response){
return flureeworker.postMessage(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$conn,conn_id,cljs.core.cst$kw$event,"pwGenerate",cljs.core.cst$kw$ref,ref,cljs.core.cst$kw$data,cljs.core.clj__GT_js(response)], null));
}));
flureeworker.worker_action.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$connClosed,(function (conn_id,_,ref,response){
return flureeworker.postMessage(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$conn,conn_id,cljs.core.cst$kw$event,"connClosed",cljs.core.cst$kw$ref,ref,cljs.core.cst$kw$data,response], null));
}));
flureeworker.worker_action.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$connReset,(function (conn_id,_,ref,response){
return flureeworker.postMessage(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$conn,conn_id,cljs.core.cst$kw$event,"connReset",cljs.core.cst$kw$ref,ref,cljs.core.cst$kw$data,response], null));
}));
flureeworker.worker_action.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$setTransact,(function (conn_id,_,ref,response){
return flureeworker.postMessage(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$conn,conn_id,cljs.core.cst$kw$event,"setTransact",cljs.core.cst$kw$ref,ref,cljs.core.cst$kw$data,cljs.core.clj__GT_js(response)], null));
}));
flureeworker.worker_action.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$connInit,(function (_,___$1){
return flureeworker.postMessage(new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$conn,(0),cljs.core.cst$kw$event,"connInit"], null));
}));
/**
 * Send an error map back to the worker invoker
 */
flureeworker.error_return_map = (function flureeworker$error_return_map(error){
var default_error = new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$message,(function (){var or__4131__auto__ = cljs.core.ex_message(error);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "Unknown Error.";
}
})(),cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error], null);
var e_map = cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([default_error,cljs.core.ex_data(error)], 0));
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$error,e_map,cljs.core.cst$kw$status,"error"], null);
});
/**
 * Process a query for a specific component id and return result with a :setState call.
 */
flureeworker.process_query = (function flureeworker$process_query(conn_id,id,opts){
var vec__120983 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$queries,id], null));
var flureeql = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__120983,(0),null);
var query_opts = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__120983,(1),null);
var query_type = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__120983,(2),null);
var jwt = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$jwt], null));
var opts_SINGLEQUOTE_ = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([opts,query_opts], 0)),cljs.core.cst$kw$jwt,jwt);
if(cljs.core.truth_(flureeql)){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,vec__120983,flureeql,query_opts,query_type,jwt,opts_SINGLEQUOTE_){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,vec__120983,flureeql,query_opts,query_type,jwt,opts_SINGLEQUOTE_){
return (function (state_121032){
var state_val_121033 = (state_121032[(1)]);
if((state_val_121033 === (7))){
var inst_120987 = (state_121032[(7)]);
var inst_120998 = shared.fdb.history_query_async.cljs$core$IFn$_invoke$arity$3(inst_120987,flureeql,opts_SINGLEQUOTE_);
var state_121032__$1 = state_121032;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121032__$1,(10),inst_120998);
} else {
if((state_val_121033 === (20))){
var inst_121020 = (state_121032[(8)]);
var inst_121025 = [cljs.core.cst$kw$result,cljs.core.cst$kw$status];
var inst_121026 = [inst_121020,"loaded"];
var inst_121027 = cljs.core.PersistentHashMap.fromArrays(inst_121025,inst_121026);
var state_121032__$1 = state_121032;
var statearr_121034_121064 = state_121032__$1;
(statearr_121034_121064[(2)] = inst_121027);

(statearr_121034_121064[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (1))){
var inst_120986 = cljs.core.cst$kw$forceTime.cljs$core$IFn$_invoke$arity$1(query_opts);
var inst_120987 = flureeworker.conn_id__GT_db(conn_id,inst_120986);
var inst_120988 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(query_type,cljs.core.cst$kw$block);
var state_121032__$1 = (function (){var statearr_121035 = state_121032;
(statearr_121035[(7)] = inst_120987);

return statearr_121035;
})();
if(inst_120988){
var statearr_121036_121065 = state_121032__$1;
(statearr_121036_121065[(1)] = (2));

} else {
var statearr_121037_121066 = state_121032__$1;
(statearr_121037_121066[(1)] = (3));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (4))){
var inst_121020 = (state_121032[(8)]);
var inst_121020__$1 = (state_121032[(2)]);
var inst_121021 = fluree.db.util.core.exception_QMARK_(inst_121020__$1);
var state_121032__$1 = (function (){var statearr_121038 = state_121032;
(statearr_121038[(8)] = inst_121020__$1);

return statearr_121038;
})();
if(inst_121021){
var statearr_121039_121067 = state_121032__$1;
(statearr_121039_121067[(1)] = (19));

} else {
var statearr_121040_121068 = state_121032__$1;
(statearr_121040_121068[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (15))){
var inst_120987 = (state_121032[(7)]);
var inst_121009 = shared.fdb.query_async.cljs$core$IFn$_invoke$arity$3(inst_120987,flureeql,opts_SINGLEQUOTE_);
var state_121032__$1 = state_121032;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121032__$1,(18),inst_121009);
} else {
if((state_val_121033 === (21))){
var inst_121029 = (state_121032[(2)]);
var inst_121030 = (function (){var G__121041 = conn_id;
var G__121042 = cljs.core.cst$kw$setState;
var G__121043 = id;
var G__121044 = inst_121029;
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121041,G__121042,G__121043,G__121044) : flureeworker.worker_action.call(null,G__121041,G__121042,G__121043,G__121044));
})();
var state_121032__$1 = state_121032;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121032__$1,inst_121030);
} else {
if((state_val_121033 === (13))){
var inst_121016 = (state_121032[(2)]);
var state_121032__$1 = state_121032;
var statearr_121045_121069 = state_121032__$1;
(statearr_121045_121069[(2)] = inst_121016);

(statearr_121045_121069[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (6))){
var inst_120991 = (state_121032[(2)]);
var inst_120992 = shared.fdb.block_query_async.cljs$core$IFn$_invoke$arity$3(inst_120991,flureeql,opts_SINGLEQUOTE_);
var state_121032__$1 = state_121032;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121032__$1,(5),inst_120992);
} else {
if((state_val_121033 === (17))){
var inst_121014 = (state_121032[(2)]);
var state_121032__$1 = state_121032;
var statearr_121046_121070 = state_121032__$1;
(statearr_121046_121070[(2)] = inst_121014);

(statearr_121046_121070[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (3))){
var inst_120996 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(query_type,cljs.core.cst$kw$history);
var state_121032__$1 = state_121032;
if(inst_120996){
var statearr_121047_121071 = state_121032__$1;
(statearr_121047_121071[(1)] = (7));

} else {
var statearr_121048_121072 = state_121032__$1;
(statearr_121048_121072[(1)] = (8));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (12))){
var state_121032__$1 = state_121032;
var statearr_121049_121073 = state_121032__$1;
(statearr_121049_121073[(1)] = (15));



return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (2))){
var inst_120987 = (state_121032[(7)]);
var state_121032__$1 = state_121032;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121032__$1,(6),inst_120987);
} else {
if((state_val_121033 === (19))){
var inst_121020 = (state_121032[(8)]);
var inst_121023 = flureeworker.error_return_map(inst_121020);
var state_121032__$1 = state_121032;
var statearr_121051_121074 = state_121032__$1;
(statearr_121051_121074[(2)] = inst_121023);

(statearr_121051_121074[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (11))){
var inst_120987 = (state_121032[(7)]);
var inst_121004 = shared.fdb.multi_query_async.cljs$core$IFn$_invoke$arity$3(inst_120987,flureeql,opts_SINGLEQUOTE_);
var state_121032__$1 = state_121032;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121032__$1,(14),inst_121004);
} else {
if((state_val_121033 === (9))){
var inst_121018 = (state_121032[(2)]);
var state_121032__$1 = state_121032;
var statearr_121052_121075 = state_121032__$1;
(statearr_121052_121075[(2)] = inst_121018);

(statearr_121052_121075[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (5))){
var inst_120994 = (state_121032[(2)]);
var state_121032__$1 = state_121032;
var statearr_121053_121076 = state_121032__$1;
(statearr_121053_121076[(2)] = inst_120994);

(statearr_121053_121076[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (14))){
var inst_121006 = (state_121032[(2)]);
var state_121032__$1 = state_121032;
var statearr_121054_121077 = state_121032__$1;
(statearr_121054_121077[(2)] = inst_121006);

(statearr_121054_121077[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (16))){
var state_121032__$1 = state_121032;
var statearr_121055_121078 = state_121032__$1;
(statearr_121055_121078[(2)] = null);

(statearr_121055_121078[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (10))){
var inst_121000 = (state_121032[(2)]);
var state_121032__$1 = state_121032;
var statearr_121056_121079 = state_121032__$1;
(statearr_121056_121079[(2)] = inst_121000);

(statearr_121056_121079[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (18))){
var inst_121011 = (state_121032[(2)]);
var state_121032__$1 = state_121032;
var statearr_121057_121080 = state_121032__$1;
(statearr_121057_121080[(2)] = inst_121011);

(statearr_121057_121080[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121033 === (8))){
var inst_121002 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(query_type,cljs.core.cst$kw$multi);
var state_121032__$1 = state_121032;
if(inst_121002){
var statearr_121058_121081 = state_121032__$1;
(statearr_121058_121081[(1)] = (11));

} else {
var statearr_121059_121082 = state_121032__$1;
(statearr_121059_121082[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,vec__120983,flureeql,query_opts,query_type,jwt,opts_SINGLEQUOTE_))
;
return ((function (switch__99702__auto__,c__99809__auto__,vec__120983,flureeql,query_opts,query_type,jwt,opts_SINGLEQUOTE_){
return (function() {
var flureeworker$process_query_$_state_machine__99703__auto__ = null;
var flureeworker$process_query_$_state_machine__99703__auto____0 = (function (){
var statearr_121060 = [null,null,null,null,null,null,null,null,null];
(statearr_121060[(0)] = flureeworker$process_query_$_state_machine__99703__auto__);

(statearr_121060[(1)] = (1));

return statearr_121060;
});
var flureeworker$process_query_$_state_machine__99703__auto____1 = (function (state_121032){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121032);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121061){if((e121061 instanceof Object)){
var ex__99706__auto__ = e121061;
var statearr_121062_121083 = state_121032;
(statearr_121062_121083[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121032);

return cljs.core.cst$kw$recur;
} else {
throw e121061;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121084 = state_121032;
state_121032 = G__121084;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureeworker$process_query_$_state_machine__99703__auto__ = function(state_121032){
switch(arguments.length){
case 0:
return flureeworker$process_query_$_state_machine__99703__auto____0.call(this);
case 1:
return flureeworker$process_query_$_state_machine__99703__auto____1.call(this,state_121032);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureeworker$process_query_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureeworker$process_query_$_state_machine__99703__auto____0;
flureeworker$process_query_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureeworker$process_query_$_state_machine__99703__auto____1;
return flureeworker$process_query_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,vec__120983,flureeql,query_opts,query_type,jwt,opts_SINGLEQUOTE_))
})();
var state__99811__auto__ = (function (){var statearr_121063 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121063[(6)] = c__99809__auto__);

return statearr_121063;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,vec__120983,flureeql,query_opts,query_type,jwt,opts_SINGLEQUOTE_))
);

return c__99809__auto__;
} else {
return null;
}
});
/**
 * Re-execute every registered query.
 */
flureeworker.process_all_queries = (function flureeworker$process_all_queries(conn_id){
var map__121085 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),conn_id);
var map__121085__$1 = (((((!((map__121085 == null))))?(((((map__121085.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121085.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121085):map__121085);
var queries = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121085__$1,cljs.core.cst$kw$queries);
var opts = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121085__$1,cljs.core.cst$kw$opts);
var query_ids = cljs.core.keys(queries);
var seq__121087 = cljs.core.seq(query_ids);
var chunk__121088 = null;
var count__121089 = (0);
var i__121090 = (0);
while(true){
if((i__121090 < count__121089)){
var id = chunk__121088.cljs$core$IIndexed$_nth$arity$2(null,i__121090);
flureeworker.process_query(conn_id,id,opts);


var G__121091 = seq__121087;
var G__121092 = chunk__121088;
var G__121093 = count__121089;
var G__121094 = (i__121090 + (1));
seq__121087 = G__121091;
chunk__121088 = G__121092;
count__121089 = G__121093;
i__121090 = G__121094;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq(seq__121087);
if(temp__5735__auto__){
var seq__121087__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__121087__$1)){
var c__4550__auto__ = cljs.core.chunk_first(seq__121087__$1);
var G__121095 = cljs.core.chunk_rest(seq__121087__$1);
var G__121096 = c__4550__auto__;
var G__121097 = cljs.core.count(c__4550__auto__);
var G__121098 = (0);
seq__121087 = G__121095;
chunk__121088 = G__121096;
count__121089 = G__121097;
i__121090 = G__121098;
continue;
} else {
var id = cljs.core.first(seq__121087__$1);
flureeworker.process_query(conn_id,id,opts);


var G__121099 = cljs.core.next(seq__121087__$1);
var G__121100 = null;
var G__121101 = (0);
var G__121102 = (0);
seq__121087 = G__121099;
chunk__121088 = G__121100;
count__121089 = G__121101;
i__121090 = G__121102;
continue;
}
} else {
return null;
}
}
break;
}
});
flureeworker.ledger_listener = (function flureeworker$ledger_listener(conn,ledger,conn_id){
var vec__121103 = fluree.db.session.resolve_ledger(conn,ledger);
var network = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__121103,(0),null);
var ledger_id = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__121103,(1),null);
var cb = ((function (vec__121103,network,ledger_id){
return (function (header,data){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,vec__121103,network,ledger_id){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,vec__121103,network,ledger_id){
return (function (state_121111){
var state_val_121112 = (state_121111[(1)]);
if((state_val_121112 === (1))){
var inst_121106 = cljs.core.async.timeout((100));
var state_121111__$1 = state_121111;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121111__$1,(2),inst_121106);
} else {
if((state_val_121112 === (2))){
var inst_121108 = (state_121111[(2)]);
var inst_121109 = flureeworker.process_all_queries(conn_id);
var state_121111__$1 = (function (){var statearr_121113 = state_121111;
(statearr_121113[(7)] = inst_121108);

return statearr_121113;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_121111__$1,inst_121109);
} else {
return null;
}
}
});})(c__99809__auto__,vec__121103,network,ledger_id))
;
return ((function (switch__99702__auto__,c__99809__auto__,vec__121103,network,ledger_id){
return (function() {
var flureeworker$ledger_listener_$_state_machine__99703__auto__ = null;
var flureeworker$ledger_listener_$_state_machine__99703__auto____0 = (function (){
var statearr_121114 = [null,null,null,null,null,null,null,null];
(statearr_121114[(0)] = flureeworker$ledger_listener_$_state_machine__99703__auto__);

(statearr_121114[(1)] = (1));

return statearr_121114;
});
var flureeworker$ledger_listener_$_state_machine__99703__auto____1 = (function (state_121111){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121111);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121115){if((e121115 instanceof Object)){
var ex__99706__auto__ = e121115;
var statearr_121116_121118 = state_121111;
(statearr_121116_121118[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121111);

return cljs.core.cst$kw$recur;
} else {
throw e121115;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121119 = state_121111;
state_121111 = G__121119;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureeworker$ledger_listener_$_state_machine__99703__auto__ = function(state_121111){
switch(arguments.length){
case 0:
return flureeworker$ledger_listener_$_state_machine__99703__auto____0.call(this);
case 1:
return flureeworker$ledger_listener_$_state_machine__99703__auto____1.call(this,state_121111);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureeworker$ledger_listener_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureeworker$ledger_listener_$_state_machine__99703__auto____0;
flureeworker$ledger_listener_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureeworker$ledger_listener_$_state_machine__99703__auto____1;
return flureeworker$ledger_listener_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,vec__121103,network,ledger_id))
})();
var state__99811__auto__ = (function (){var statearr_121117 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121117[(6)] = c__99809__auto__);

return statearr_121117;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,vec__121103,network,ledger_id))
);

return c__99809__auto__;
});})(vec__121103,network,ledger_id))
;
return fluree.db.connection.add_listener(conn,network,ledger_id,conn_id,cb);
});
flureeworker.remove_conn_listener = (function flureeworker$remove_conn_listener(conn,conn_id,ledger){
var vec__121120 = fluree.db.session.resolve_ledger(conn,ledger);
var network = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__121120,(0),null);
var ledger_id = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__121120,(1),null);
return fluree.db.connection.remove_listener(conn,network,ledger_id,conn_id);
});
/**
 * Registers new connection with all of its items.
 */
flureeworker.register_connection = (function flureeworker$register_connection(conn,config,queries){
var map__121123 = config;
var map__121123__$1 = (((((!((map__121123 == null))))?(((((map__121123.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121123.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121123):map__121123);
var servers = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121123__$1,cljs.core.cst$kw$servers);
var ledger = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121123__$1,cljs.core.cst$kw$ledger);
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121123__$1,cljs.core.cst$kw$id);
var log = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121123__$1,cljs.core.cst$kw$log);
var compact = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121123__$1,cljs.core.cst$kw$compact);
var private$ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121123__$1,cljs.core.cst$kw$private);
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(flureeworker.conn_register,cljs.core.assoc,id,cljs.core.PersistentHashMap.fromArrays([cljs.core.cst$kw$closed,cljs.core.cst$kw$ledger,cljs.core.cst$kw$private,cljs.core.cst$kw$config,cljs.core.cst$kw$opts,cljs.core.cst$kw$servers,cljs.core.cst$kw$queries,cljs.core.cst$kw$log,cljs.core.cst$kw$conn],[false,ledger,private$,config,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$compact,compact], null),servers,(function (){var or__4131__auto__ = queries;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.PersistentArrayMap.EMPTY;
}
})(),log,conn]));
});
/**
 * Creates a new connection from existing configuration
 */
flureeworker.connect_STAR_ = (function flureeworker$connect_STAR_(conn_id,ref){
var conn_data = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),conn_id);
var map__121125 = conn_data;
var map__121125__$1 = (((((!((map__121125 == null))))?(((((map__121125.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121125.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121125):map__121125);
var config = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121125__$1,cljs.core.cst$kw$config);
var queries = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121125__$1,cljs.core.cst$kw$queries);
var jwt = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121125__$1,cljs.core.cst$kw$jwt);
var map__121126 = config;
var map__121126__$1 = (((((!((map__121126 == null))))?(((((map__121126.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121126.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121126):map__121126);
var servers = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121126__$1,cljs.core.cst$kw$servers);
var ledger = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121126__$1,cljs.core.cst$kw$ledger);
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121126__$1,cljs.core.cst$kw$id);
var keepAlive = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121126__$1,cljs.core.cst$kw$keepAlive);
var cb = (cljs.core.truth_(keepAlive)?((function (conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive){
return (function (){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive){
return (function (state_121134){
var state_val_121135 = (state_121134[(1)]);
if((state_val_121135 === (1))){
var inst_121129 = cljs.core.async.timeout((100));
var state_121134__$1 = state_121134;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121134__$1,(2),inst_121129);
} else {
if((state_val_121135 === (2))){
var inst_121131 = (state_121134[(2)]);
var inst_121132 = (flureeworker.connect_STAR_.cljs$core$IFn$_invoke$arity$2 ? flureeworker.connect_STAR_.cljs$core$IFn$_invoke$arity$2(id,ref) : flureeworker.connect_STAR_.call(null,id,ref));
var state_121134__$1 = (function (){var statearr_121136 = state_121134;
(statearr_121136[(7)] = inst_121131);

return statearr_121136;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_121134__$1,inst_121132);
} else {
return null;
}
}
});})(c__99809__auto__,conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive))
;
return ((function (switch__99702__auto__,c__99809__auto__,conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive){
return (function() {
var flureeworker$connect_STAR__$_state_machine__99703__auto__ = null;
var flureeworker$connect_STAR__$_state_machine__99703__auto____0 = (function (){
var statearr_121137 = [null,null,null,null,null,null,null,null];
(statearr_121137[(0)] = flureeworker$connect_STAR__$_state_machine__99703__auto__);

(statearr_121137[(1)] = (1));

return statearr_121137;
});
var flureeworker$connect_STAR__$_state_machine__99703__auto____1 = (function (state_121134){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121134);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121138){if((e121138 instanceof Object)){
var ex__99706__auto__ = e121138;
var statearr_121139_121149 = state_121134;
(statearr_121139_121149[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121134);

return cljs.core.cst$kw$recur;
} else {
throw e121138;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121150 = state_121134;
state_121134 = G__121150;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureeworker$connect_STAR__$_state_machine__99703__auto__ = function(state_121134){
switch(arguments.length){
case 0:
return flureeworker$connect_STAR__$_state_machine__99703__auto____0.call(this);
case 1:
return flureeworker$connect_STAR__$_state_machine__99703__auto____1.call(this,state_121134);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureeworker$connect_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureeworker$connect_STAR__$_state_machine__99703__auto____0;
flureeworker$connect_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureeworker$connect_STAR__$_state_machine__99703__auto____1;
return flureeworker$connect_STAR__$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive))
})();
var state__99811__auto__ = (function (){var statearr_121140 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121140[(6)] = c__99809__auto__);

return statearr_121140;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive))
);

return c__99809__auto__;
});})(conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive))
:null);
var opts = cljs.core.assoc_in(config,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$keep_DASH_alive_DASH_fn], null),cb);
return shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$2(servers,opts).then(((function (conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive,cb,opts){
return (function (conn){
if(cljs.core.truth_(jwt)){
shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2(conn,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$jwt,jwt], null));
} else {
}

flureeworker.register_connection(conn,config,queries);

flureeworker.ledger_listener(conn,ledger,id);

var G__121141_121151 = conn_id;
var G__121142_121152 = cljs.core.cst$kw$connReset;
var G__121143_121153 = ref;
var G__121144_121154 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(200),cljs.core.cst$kw$message,"Connection reset"], null);
(flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121141_121151,G__121142_121152,G__121143_121153,G__121144_121154) : flureeworker.worker_action.call(null,G__121141_121151,G__121142_121152,G__121143_121153,G__121144_121154));

return flureeworker.process_all_queries(conn_id);
});})(conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive,cb,opts))
).catch(((function (conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive,cb,opts){
return (function (error){
var error_data = (function (){var temp__5733__auto__ = cljs.core.ex_data(error);
if(cljs.core.truth_(temp__5733__auto__)){
var ex_data = temp__5733__auto__;
return cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(function (){var or__4131__auto__ = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(ex_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (500);
}
})(),cljs.core.cst$kw$message,cljs.core.ex_message(error)], null),ex_data], 0));
} else {
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$message,["Unexpected error: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([error], 0))].join('')], null);
}
})();
var G__121145 = conn_id;
var G__121146 = cljs.core.cst$kw$connReset;
var G__121147 = ref;
var G__121148 = error_data;
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121145,G__121146,G__121147,G__121148) : flureeworker.worker_action.call(null,G__121145,G__121146,G__121147,G__121148));
});})(conn_data,map__121125,map__121125__$1,config,queries,jwt,map__121126,map__121126__$1,servers,ledger,id,keepAlive,cb,opts))
);
});
flureeworker.close_connection_STAR_ = (function flureeworker$close_connection_STAR_(var_args){
var G__121156 = arguments.length;
switch (G__121156) {
case 1:
return flureeworker.close_connection_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return flureeworker.close_connection_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

flureeworker.close_connection_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (conn_id){
return flureeworker.close_connection_STAR_.cljs$core$IFn$_invoke$arity$2(conn_id,false);
});

flureeworker.close_connection_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (conn_id,save_config_QMARK_){
var conn_data = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),conn_id);
var map__121157 = conn_data;
var map__121157__$1 = (((((!((map__121157 == null))))?(((((map__121157.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121157.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121157):map__121157);
var conn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121157__$1,cljs.core.cst$kw$conn);
var ledger = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121157__$1,cljs.core.cst$kw$ledger);
var config = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121157__$1,cljs.core.cst$kw$config);
var jwt = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121157__$1,cljs.core.cst$kw$jwt);
var new_config = (cljs.core.truth_(save_config_QMARK_)?new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$closed,true,cljs.core.cst$kw$config,config,cljs.core.cst$kw$jwt,jwt], null):new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$closed,true], null));
if((((conn_data == null)) || (cljs.core.cst$kw$closed.cljs$core$IFn$_invoke$arity$1(conn_data) === true))){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Connection doesn't exist, or is already closed.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_connection], null));
} else {
flureeworker.remove_conn_listener(conn,conn_id,ledger);

shared.connection_handler.close(conn);

cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(flureeworker.conn_register,cljs.core.assoc,conn_id,new_config);

return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(200),cljs.core.cst$kw$message,"Connection closed."], null);
}
});

flureeworker.close_connection_STAR_.cljs$lang$maxFixedArity = 2;

flureeworker.close_connection = (function flureeworker$close_connection(conn_id,ref){
try{var G__121165 = conn_id;
var G__121166 = cljs.core.cst$kw$connClosed;
var G__121167 = ref;
var G__121168 = flureeworker.close_connection_STAR_.cljs$core$IFn$_invoke$arity$1(conn_id);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121165,G__121166,G__121167,G__121168) : flureeworker.worker_action.call(null,G__121165,G__121166,G__121167,G__121168));
}catch (e121160){var e = e121160;
var msg = (function (){var or__4131__auto__ = cljs.core.ex_message(e);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "Unexpected error.";
}
})();
var data = (function (){var or__4131__auto__ = cljs.core.ex_data(e);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error], null);
}
})();
var G__121161 = conn_id;
var G__121162 = cljs.core.cst$kw$connClosed;
var G__121163 = ref;
var G__121164 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(data,cljs.core.cst$kw$message,msg);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121161,G__121162,G__121163,G__121164) : flureeworker.worker_action.call(null,G__121161,G__121162,G__121163,G__121164));
}});
flureeworker.reset_connection = (function flureeworker$reset_connection(conn_id,ref){
try{var save_config_QMARK_ = true;
flureeworker.close_connection_STAR_.cljs$core$IFn$_invoke$arity$2(conn_id,save_config_QMARK_);

return flureeworker.connect_STAR_(conn_id,ref);
}catch (e121169){var e = e121169;
var msg = (function (){var or__4131__auto__ = cljs.core.ex_message(e);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "Unexpected error.";
}
})();
var data = (function (){var or__4131__auto__ = cljs.core.ex_data(e);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error], null);
}
})();
var G__121170 = conn_id;
var G__121171 = cljs.core.cst$kw$connReset;
var G__121172 = ref;
var G__121173 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(data,cljs.core.cst$kw$message,msg);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121170,G__121171,G__121172,G__121173) : flureeworker.worker_action.call(null,G__121170,G__121171,G__121172,G__121173));
}});
/**
 * Open new connection to a Fluree instance
 */
flureeworker.connect_p = (function flureeworker$connect_p(config,ref){
var config_STAR_ = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(config,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var map__121174 = config_STAR_;
var map__121174__$1 = (((((!((map__121174 == null))))?(((((map__121174.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121174.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121174):map__121174);
var servers = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121174__$1,cljs.core.cst$kw$servers);
var ledger = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121174__$1,cljs.core.cst$kw$ledger);
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121174__$1,cljs.core.cst$kw$id);
var keepAlive = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121174__$1,cljs.core.cst$kw$keepAlive);
var cb = (cljs.core.truth_(keepAlive)?((function (config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive){
return (function (){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive){
return (function (state_121181){
var state_val_121182 = (state_121181[(1)]);
if((state_val_121182 === (1))){
var inst_121176 = cljs.core.async.timeout((100));
var state_121181__$1 = state_121181;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121181__$1,(2),inst_121176);
} else {
if((state_val_121182 === (2))){
var inst_121178 = (state_121181[(2)]);
var inst_121179 = flureeworker.connect_STAR_(id,ref);
var state_121181__$1 = (function (){var statearr_121183 = state_121181;
(statearr_121183[(7)] = inst_121178);

return statearr_121183;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_121181__$1,inst_121179);
} else {
return null;
}
}
});})(c__99809__auto__,config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive))
;
return ((function (switch__99702__auto__,c__99809__auto__,config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive){
return (function() {
var flureeworker$connect_p_$_state_machine__99703__auto__ = null;
var flureeworker$connect_p_$_state_machine__99703__auto____0 = (function (){
var statearr_121184 = [null,null,null,null,null,null,null,null];
(statearr_121184[(0)] = flureeworker$connect_p_$_state_machine__99703__auto__);

(statearr_121184[(1)] = (1));

return statearr_121184;
});
var flureeworker$connect_p_$_state_machine__99703__auto____1 = (function (state_121181){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121181);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121185){if((e121185 instanceof Object)){
var ex__99706__auto__ = e121185;
var statearr_121186_121196 = state_121181;
(statearr_121186_121196[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121181);

return cljs.core.cst$kw$recur;
} else {
throw e121185;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121197 = state_121181;
state_121181 = G__121197;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureeworker$connect_p_$_state_machine__99703__auto__ = function(state_121181){
switch(arguments.length){
case 0:
return flureeworker$connect_p_$_state_machine__99703__auto____0.call(this);
case 1:
return flureeworker$connect_p_$_state_machine__99703__auto____1.call(this,state_121181);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureeworker$connect_p_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureeworker$connect_p_$_state_machine__99703__auto____0;
flureeworker$connect_p_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureeworker$connect_p_$_state_machine__99703__auto____1;
return flureeworker$connect_p_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive))
})();
var state__99811__auto__ = (function (){var statearr_121187 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121187[(6)] = c__99809__auto__);

return statearr_121187;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive))
);

return c__99809__auto__;
});})(config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive))
:null);
var opts = cljs.core.assoc_in(config_STAR_,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$keep_DASH_alive_DASH_fn], null),cb);
return shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$2(servers,opts).then(((function (config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive,cb,opts){
return (function (conn){
flureeworker.register_connection(conn,config_STAR_,null);

flureeworker.ledger_listener(conn,ledger,id);

var G__121188 = id;
var G__121189 = cljs.core.cst$kw$connStatus;
var G__121190 = ref;
var G__121191 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(200),cljs.core.cst$kw$message,"Connection is ready."], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121188,G__121189,G__121190,G__121191) : flureeworker.worker_action.call(null,G__121188,G__121189,G__121190,G__121191));
});})(config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive,cb,opts))
).catch(((function (config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive,cb,opts){
return (function (error){
var G__121192 = id;
var G__121193 = cljs.core.cst$kw$connStatus;
var G__121194 = ref;
var G__121195 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$message,cljs.core.str.cljs$core$IFn$_invoke$arity$1(error)], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121192,G__121193,G__121194,G__121195) : flureeworker.worker_action.call(null,G__121192,G__121193,G__121194,G__121195));
});})(config_STAR_,map__121174,map__121174__$1,servers,ledger,id,keepAlive,cb,opts))
);
});
/**
 * Returns true if connection has been closed.
 */
flureeworker.conn_closed_QMARK_ = (function flureeworker$conn_closed_QMARK_(conn_id){
return cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$closed], null));
});
/**
 * Authenticate with ledger via username and password.
 * 
 * If authentication is successful, a 200 status is returned with a JSON web token.
 * Otherwise, an error status is returned.
 */
flureeworker.login = (function flureeworker$login(var_args){
var args__4736__auto__ = [];
var len__4730__auto___121256 = arguments.length;
var i__4731__auto___121257 = (0);
while(true){
if((i__4731__auto___121257 < len__4730__auto___121256)){
args__4736__auto__.push((arguments[i__4731__auto___121257]));

var G__121258 = (i__4731__auto___121257 + (1));
i__4731__auto___121257 = G__121258;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((4) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((4)),(0),null)):null);
return flureeworker.login.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),argseq__4737__auto__);
});

flureeworker.login.cljs$core$IFn$_invoke$arity$variadic = (function (conn_id,ref,username,password,p__121203){
var vec__121204 = p__121203;
var expire = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__121204,(0),null);
var map__121207 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),conn_id);
var map__121207__$1 = (((((!((map__121207 == null))))?(((((map__121207.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121207.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121207):map__121207);
var conn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121207__$1,cljs.core.cst$kw$conn);
var ledger = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121207__$1,cljs.core.cst$kw$ledger);
var jwt = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121207__$1,cljs.core.cst$kw$jwt);
var _ = (cljs.core.truth_(ledger)?null:(function (){var G__121209 = conn_id;
var G__121210 = cljs.core.cst$kw$login;
var G__121211 = ref;
var G__121212 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$message,"Connection missing Ledger information. Password authentication is specific to a ledger."], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121209,G__121210,G__121211,G__121212) : flureeworker.worker_action.call(null,G__121209,G__121210,G__121211,G__121212));
})());
var auth = null;
var c__99809__auto___121259 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___121259,map__121207,map__121207__$1,conn,ledger,jwt,_,auth,vec__121204,expire){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___121259,map__121207,map__121207__$1,conn,ledger,jwt,_,auth,vec__121204,expire){
return (function (state_121230){
var state_val_121231 = (state_121230[(1)]);
if((state_val_121231 === (1))){
var state_121230__$1 = state_121230;
var statearr_121232_121260 = state_121230__$1;
(statearr_121232_121260[(2)] = null);

(statearr_121232_121260[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121231 === (2))){
var inst_121228 = (state_121230[(2)]);
var state_121230__$1 = state_121230;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121230__$1,inst_121228);
} else {
if((state_val_121231 === (3))){
var inst_121213 = (state_121230[(2)]);
var inst_121214 = [cljs.core.cst$kw$status,cljs.core.cst$kw$message];
var inst_121215 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_121213);
var inst_121216 = [(400),inst_121215];
var inst_121217 = cljs.core.PersistentHashMap.fromArrays(inst_121214,inst_121216);
var inst_121218 = (function (){var G__121233 = conn_id;
var G__121234 = cljs.core.cst$kw$login;
var G__121235 = ref;
var G__121236 = inst_121217;
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121233,G__121234,G__121235,G__121236) : flureeworker.worker_action.call(null,G__121233,G__121234,G__121235,G__121236));
})();
var state_121230__$1 = state_121230;
var statearr_121237_121261 = state_121230__$1;
(statearr_121237_121261[(2)] = inst_121218);


cljs.core.async.impl.ioc_helpers.process_exception(state_121230__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121231 === (4))){
var ___$1 = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121230,(3),cljs.core.cst$kw$default,null,(2));
var inst_121222 = shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$6(conn,ledger,password,username,auth,expire);
var inst_121223 = (function (){return ((function (___$1,inst_121222,state_val_121231,c__99809__auto___121259,map__121207,map__121207__$1,conn,ledger,jwt,_,auth,vec__121204,expire){
return (function (token){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(flureeworker.conn_register,cljs.core.assoc_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$jwt], null),token);

var G__121238 = conn_id;
var G__121239 = cljs.core.cst$kw$login;
var G__121240 = ref;
var G__121241 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(200),cljs.core.cst$kw$result,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$username,username,cljs.core.cst$kw$token,token], null)], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121238,G__121239,G__121240,G__121241) : flureeworker.worker_action.call(null,G__121238,G__121239,G__121240,G__121241));
});
;})(___$1,inst_121222,state_val_121231,c__99809__auto___121259,map__121207,map__121207__$1,conn,ledger,jwt,_,auth,vec__121204,expire))
})();
var inst_121224 = inst_121222.then(inst_121223);
var inst_121225 = (function (){return ((function (___$1,inst_121222,inst_121223,inst_121224,state_val_121231,c__99809__auto___121259,map__121207,map__121207__$1,conn,ledger,jwt,_,auth,vec__121204,expire){
return (function (resp){
var err = (function (){try{return cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(resp,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
}catch (e121242){var ___$2 = e121242;
return null;
}})();
var status = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(err);
if((!((status == null)))){
var message = (function (){var or__4131__auto__ = cljs.core.cst$kw$message.cljs$core$IFn$_invoke$arity$1(err);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "Authentication failed: unknown authentication error";
}
})();
var error = (function (){var or__4131__auto__ = cljs.core.cst$kw$error.cljs$core$IFn$_invoke$arity$1(err);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.cst$kw$db_SLASH_invalid_DASH_request;
}
})();
var G__121243 = conn_id;
var G__121244 = cljs.core.cst$kw$login;
var G__121245 = ref;
var G__121246 = new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$status,status,cljs.core.cst$kw$message,message,cljs.core.cst$kw$error,error], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121243,G__121244,G__121245,G__121246) : flureeworker.worker_action.call(null,G__121243,G__121244,G__121245,G__121246));
} else {
var G__121247 = conn_id;
var G__121248 = cljs.core.cst$kw$login;
var G__121249 = ref;
var G__121250 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(401),cljs.core.cst$kw$message,["Authentication failed: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(resp)].join('')], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121247,G__121248,G__121249,G__121250) : flureeworker.worker_action.call(null,G__121247,G__121248,G__121249,G__121250));

}
});
;})(___$1,inst_121222,inst_121223,inst_121224,state_val_121231,c__99809__auto___121259,map__121207,map__121207__$1,conn,ledger,jwt,_,auth,vec__121204,expire))
})();
var inst_121226 = inst_121224.catch(inst_121225);
var state_121230__$1 = state_121230;
var statearr_121251_121262 = state_121230__$1;
(statearr_121251_121262[(2)] = inst_121226);


cljs.core.async.impl.ioc_helpers.process_exception(state_121230__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
});})(c__99809__auto___121259,map__121207,map__121207__$1,conn,ledger,jwt,_,auth,vec__121204,expire))
;
return ((function (switch__99702__auto__,c__99809__auto___121259,map__121207,map__121207__$1,conn,ledger,jwt,_,auth,vec__121204,expire){
return (function() {
var flureeworker$state_machine__99703__auto__ = null;
var flureeworker$state_machine__99703__auto____0 = (function (){
var statearr_121252 = [null,null,null,null,null,null,null];
(statearr_121252[(0)] = flureeworker$state_machine__99703__auto__);

(statearr_121252[(1)] = (1));

return statearr_121252;
});
var flureeworker$state_machine__99703__auto____1 = (function (state_121230){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121230);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121253){if((e121253 instanceof Object)){
var ex__99706__auto__ = e121253;
var statearr_121254_121263 = state_121230;
(statearr_121254_121263[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121230);

return cljs.core.cst$kw$recur;
} else {
throw e121253;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121264 = state_121230;
state_121230 = G__121264;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureeworker$state_machine__99703__auto__ = function(state_121230){
switch(arguments.length){
case 0:
return flureeworker$state_machine__99703__auto____0.call(this);
case 1:
return flureeworker$state_machine__99703__auto____1.call(this,state_121230);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureeworker$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureeworker$state_machine__99703__auto____0;
flureeworker$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureeworker$state_machine__99703__auto____1;
return flureeworker$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___121259,map__121207,map__121207__$1,conn,ledger,jwt,_,auth,vec__121204,expire))
})();
var state__99811__auto__ = (function (){var statearr_121255 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121255[(6)] = c__99809__auto___121259);

return statearr_121255;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___121259,map__121207,map__121207__$1,conn,ledger,jwt,_,auth,vec__121204,expire))
);


return true;
});

flureeworker.login.cljs$lang$maxFixedArity = (4);

/** @this {Function} */
flureeworker.login.cljs$lang$applyTo = (function (seq121198){
var G__121199 = cljs.core.first(seq121198);
var seq121198__$1 = cljs.core.next(seq121198);
var G__121200 = cljs.core.first(seq121198__$1);
var seq121198__$2 = cljs.core.next(seq121198__$1);
var G__121201 = cljs.core.first(seq121198__$2);
var seq121198__$3 = cljs.core.next(seq121198__$2);
var G__121202 = cljs.core.first(seq121198__$3);
var seq121198__$4 = cljs.core.next(seq121198__$3);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__121199,G__121200,G__121201,G__121202,seq121198__$4);
});

/**
 * Attempts to generate a new user auth record account.
 * 
 * If request is successful, a 200 status is returned with a JSON web token.
 * Otherwise, an error status is returned.
 */
flureeworker.pw_generate = (function flureeworker$pw_generate(conn_id,ref,map_data){
var map__121265 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),conn_id);
var map__121265__$1 = (((((!((map__121265 == null))))?(((((map__121265.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121265.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121265):map__121265);
var conn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121265__$1,cljs.core.cst$kw$conn);
var ledger = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121265__$1,cljs.core.cst$kw$ledger);
var _ = (cljs.core.truth_(ledger)?null:(function (){var G__121268 = conn_id;
var G__121269 = cljs.core.cst$kw$login;
var G__121270 = ref;
var G__121271 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$message,"Connection missing Ledger information. Password authentication is specific to a ledger."], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121268,G__121269,G__121270,G__121271) : flureeworker.worker_action.call(null,G__121268,G__121269,G__121270,G__121271));
})());
var map__121266 = map_data;
var map__121266__$1 = (((((!((map__121266 == null))))?(((((map__121266.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121266.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121266):map__121266);
var username = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121266__$1,cljs.core.cst$kw$username);
var password = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121266__$1,cljs.core.cst$kw$password);
var options = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121266__$1,cljs.core.cst$kw$options);
var opts = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(cljs.core.select_keys(options,cljs.core.keys(options)),cljs.core.cst$kw$user,username);
var c__99809__auto___121316 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___121316,map__121265,map__121265__$1,conn,ledger,_,map__121266,map__121266__$1,username,password,options,opts){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___121316,map__121265,map__121265__$1,conn,ledger,_,map__121266,map__121266__$1,username,password,options,opts){
return (function (state_121290){
var state_val_121291 = (state_121290[(1)]);
if((state_val_121291 === (1))){
var state_121290__$1 = state_121290;
var statearr_121292_121317 = state_121290__$1;
(statearr_121292_121317[(2)] = null);

(statearr_121292_121317[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121291 === (2))){
var inst_121288 = (state_121290[(2)]);
var state_121290__$1 = state_121290;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121290__$1,inst_121288);
} else {
if((state_val_121291 === (3))){
var inst_121273 = (state_121290[(2)]);
var inst_121274 = [cljs.core.cst$kw$status,cljs.core.cst$kw$message];
var inst_121275 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_121273);
var inst_121276 = [(400),inst_121275];
var inst_121277 = cljs.core.PersistentHashMap.fromArrays(inst_121274,inst_121276);
var inst_121278 = (function (){var G__121293 = conn_id;
var G__121294 = cljs.core.cst$kw$pwGenerate;
var G__121295 = ref;
var G__121296 = inst_121277;
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121293,G__121294,G__121295,G__121296) : flureeworker.worker_action.call(null,G__121293,G__121294,G__121295,G__121296));
})();
var state_121290__$1 = state_121290;
var statearr_121297_121318 = state_121290__$1;
(statearr_121297_121318[(2)] = inst_121278);


cljs.core.async.impl.ioc_helpers.process_exception(state_121290__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_121291 === (4))){
var ___$1 = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_121290,(3),cljs.core.cst$kw$default,null,(2));
var inst_121282 = shared.connection_handler.password_generate(conn,ledger,password,opts);
var inst_121283 = (function (){return ((function (___$1,inst_121282,state_val_121291,c__99809__auto___121316,map__121265,map__121265__$1,conn,ledger,_,map__121266,map__121266__$1,username,password,options,opts){
return (function (token){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(flureeworker.conn_register,cljs.core.assoc_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$jwt], null),token);

var G__121298 = conn_id;
var G__121299 = cljs.core.cst$kw$pwGenerate;
var G__121300 = ref;
var G__121301 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(200),cljs.core.cst$kw$result,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$username,username,cljs.core.cst$kw$token,token], null)], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121298,G__121299,G__121300,G__121301) : flureeworker.worker_action.call(null,G__121298,G__121299,G__121300,G__121301));
});
;})(___$1,inst_121282,state_val_121291,c__99809__auto___121316,map__121265,map__121265__$1,conn,ledger,_,map__121266,map__121266__$1,username,password,options,opts))
})();
var inst_121284 = inst_121282.then(inst_121283);
var inst_121285 = (function (){return ((function (___$1,inst_121282,inst_121283,inst_121284,state_val_121291,c__99809__auto___121316,map__121265,map__121265__$1,conn,ledger,_,map__121266,map__121266__$1,username,password,options,opts){
return (function (resp){
var err = (function (){try{return cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(resp,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
}catch (e121302){var ___$2 = e121302;
return null;
}})();
var status = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(err);
if((!((status == null)))){
var message = (function (){var or__4131__auto__ = cljs.core.cst$kw$message.cljs$core$IFn$_invoke$arity$1(err);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "Password Generation failed: unknown error";
}
})();
var error = (function (){var or__4131__auto__ = cljs.core.cst$kw$error.cljs$core$IFn$_invoke$arity$1(err);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.cst$kw$db_SLASH_invalid_DASH_request;
}
})();
var G__121303 = conn_id;
var G__121304 = cljs.core.cst$kw$pwGenerate;
var G__121305 = ref;
var G__121306 = new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$status,status,cljs.core.cst$kw$message,message,cljs.core.cst$kw$error,error], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121303,G__121304,G__121305,G__121306) : flureeworker.worker_action.call(null,G__121303,G__121304,G__121305,G__121306));
} else {
var G__121307 = conn_id;
var G__121308 = cljs.core.cst$kw$pwGenerate;
var G__121309 = ref;
var G__121310 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(401),cljs.core.cst$kw$message,["Password Generation failed: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(resp)].join('')], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121307,G__121308,G__121309,G__121310) : flureeworker.worker_action.call(null,G__121307,G__121308,G__121309,G__121310));

}
});
;})(___$1,inst_121282,inst_121283,inst_121284,state_val_121291,c__99809__auto___121316,map__121265,map__121265__$1,conn,ledger,_,map__121266,map__121266__$1,username,password,options,opts))
})();
var inst_121286 = inst_121284.catch(inst_121285);
var state_121290__$1 = state_121290;
var statearr_121311_121319 = state_121290__$1;
(statearr_121311_121319[(2)] = inst_121286);


cljs.core.async.impl.ioc_helpers.process_exception(state_121290__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
});})(c__99809__auto___121316,map__121265,map__121265__$1,conn,ledger,_,map__121266,map__121266__$1,username,password,options,opts))
;
return ((function (switch__99702__auto__,c__99809__auto___121316,map__121265,map__121265__$1,conn,ledger,_,map__121266,map__121266__$1,username,password,options,opts){
return (function() {
var flureeworker$pw_generate_$_state_machine__99703__auto__ = null;
var flureeworker$pw_generate_$_state_machine__99703__auto____0 = (function (){
var statearr_121312 = [null,null,null,null,null,null,null];
(statearr_121312[(0)] = flureeworker$pw_generate_$_state_machine__99703__auto__);

(statearr_121312[(1)] = (1));

return statearr_121312;
});
var flureeworker$pw_generate_$_state_machine__99703__auto____1 = (function (state_121290){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121290);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121313){if((e121313 instanceof Object)){
var ex__99706__auto__ = e121313;
var statearr_121314_121320 = state_121290;
(statearr_121314_121320[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121290);

return cljs.core.cst$kw$recur;
} else {
throw e121313;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121321 = state_121290;
state_121290 = G__121321;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureeworker$pw_generate_$_state_machine__99703__auto__ = function(state_121290){
switch(arguments.length){
case 0:
return flureeworker$pw_generate_$_state_machine__99703__auto____0.call(this);
case 1:
return flureeworker$pw_generate_$_state_machine__99703__auto____1.call(this,state_121290);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureeworker$pw_generate_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureeworker$pw_generate_$_state_machine__99703__auto____0;
flureeworker$pw_generate_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureeworker$pw_generate_$_state_machine__99703__auto____1;
return flureeworker$pw_generate_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___121316,map__121265,map__121265__$1,conn,ledger,_,map__121266,map__121266__$1,username,password,options,opts))
})();
var state__99811__auto__ = (function (){var statearr_121315 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121315[(6)] = c__99809__auto___121316);

return statearr_121315;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___121316,map__121265,map__121265__$1,conn,ledger,_,map__121266,map__121266__$1,username,password,options,opts))
);


return true;
});
flureeworker.unregisterQuery = (function flureeworker$unregisterQuery(conn_id,ref){
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$variadic(flureeworker.conn_register,cljs.core.update_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$queries], null),cljs.core.dissoc,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([ref], 0));
});
/**
 * Registers a new flurql query
 */
flureeworker.registerQuery = (function flureeworker$registerQuery(conn_id,ref,js_flurql,js_opts,force_update_QMARK_){
var flureeql = cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(js_flurql,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0));
var opts = (cljs.core.truth_(js_opts)?cljs.core.js__GT_clj.cljs$core$IFn$_invoke$arity$variadic(js_opts,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$keywordize_DASH_keys,true], 0)):cljs.core.PersistentArrayMap.EMPTY);
var qry_type = (function (){var or__4131__auto__ = cljs.core.cst$kw$queryType.cljs$core$IFn$_invoke$arity$1(opts);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "query";
}
})();
var _ = console.info(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$query,flureeql,cljs.core.cst$kw$type,qry_type], null)], 0)));
var qry_data = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [flureeql,cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(opts,cljs.core.cst$kw$queryType),cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(qry_type)], null);
if(((cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(qry_data,cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$queries,ref], null)))) || (force_update_QMARK_ === true))){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$variadic(flureeworker.conn_register,cljs.core.update_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$queries], null),cljs.core.assoc,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([ref,qry_data], 0));

flureeworker.process_query(conn_id,ref,cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$opts], null)));
} else {
}

return true;
});
/**
 * Submits a transaction across a websocket to a fluree instance
 */
flureeworker.transact = (function flureeworker$transact(conn_id,ref,map_data){
var map__121322 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(flureeworker.conn_register),conn_id);
var map__121322__$1 = (((((!((map__121322 == null))))?(((((map__121322.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121322.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121322):map__121322);
var conn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121322__$1,cljs.core.cst$kw$conn);
var ledger = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121322__$1,cljs.core.cst$kw$ledger);
var jwt = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121322__$1,cljs.core.cst$kw$jwt);
var _ = (cljs.core.truth_(ledger)?null:(function (){var G__121325 = conn_id;
var G__121326 = cljs.core.cst$kw$login;
var G__121327 = ref;
var G__121328 = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$message,"Connection missing Ledger information. Password authentication is specific to a ledger."], null);
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121325,G__121326,G__121327,G__121328) : flureeworker.worker_action.call(null,G__121325,G__121326,G__121327,G__121328));
})());
var map__121323 = map_data;
var map__121323__$1 = (((((!((map__121323 == null))))?(((((map__121323.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__121323.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__121323):map__121323);
var txn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121323__$1,cljs.core.cst$kw$txn);
var options = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__121323__$1,cljs.core.cst$kw$options);
var txn_SINGLEQUOTE_ = ((typeof txn === 'string')?fluree.db.util.json.parse(txn):txn);
var opts = (cljs.core.truth_(options)?cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(cljs.core.select_keys(options,cljs.core.keys(options)),cljs.core.cst$kw$jwt,jwt):new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$jwt,jwt], null));
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,map__121322,map__121322__$1,conn,ledger,jwt,_,map__121323,map__121323__$1,txn,options,txn_SINGLEQUOTE_,opts){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,map__121322,map__121322__$1,conn,ledger,jwt,_,map__121323,map__121323__$1,txn,options,txn_SINGLEQUOTE_,opts){
return (function (state_121359){
var state_val_121360 = (state_121359[(1)]);
if((state_val_121360 === (1))){
var inst_121330 = fluree.db.util.core.without_nils(opts);
var inst_121331 = shared.fdb.transact_async.cljs$core$IFn$_invoke$arity$4(conn,ledger,txn_SINGLEQUOTE_,inst_121330);
var state_121359__$1 = state_121359;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_121359__$1,(2),inst_121331);
} else {
if((state_val_121360 === (2))){
var inst_121333 = (state_121359[(7)]);
var inst_121333__$1 = (state_121359[(2)]);
var inst_121334 = fluree.db.util.core.exception_QMARK_(inst_121333__$1);
var state_121359__$1 = (function (){var statearr_121361 = state_121359;
(statearr_121361[(7)] = inst_121333__$1);

return statearr_121361;
})();
if(inst_121334){
var statearr_121362_121383 = state_121359__$1;
(statearr_121362_121383[(1)] = (3));

} else {
var statearr_121363_121384 = state_121359__$1;
(statearr_121363_121384[(1)] = (4));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121360 === (3))){
var inst_121333 = (state_121359[(7)]);
var inst_121336 = (state_121359[(8)]);
var inst_121336__$1 = cljs.core.ex_data(inst_121333);
var state_121359__$1 = (function (){var statearr_121364 = state_121359;
(statearr_121364[(8)] = inst_121336__$1);

return statearr_121364;
})();
if(cljs.core.truth_(inst_121336__$1)){
var statearr_121365_121385 = state_121359__$1;
(statearr_121365_121385[(1)] = (6));

} else {
var statearr_121366_121386 = state_121359__$1;
(statearr_121366_121386[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_121360 === (4))){
var inst_121333 = (state_121359[(7)]);
var inst_121352 = [cljs.core.cst$kw$result,cljs.core.cst$kw$status];
var inst_121353 = [inst_121333,(200)];
var inst_121354 = cljs.core.PersistentHashMap.fromArrays(inst_121352,inst_121353);
var inst_121355 = (function (){var G__121367 = conn_id;
var G__121368 = cljs.core.cst$kw$setTransact;
var G__121369 = ref;
var G__121370 = inst_121354;
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121367,G__121368,G__121369,G__121370) : flureeworker.worker_action.call(null,G__121367,G__121368,G__121369,G__121370));
})();
var state_121359__$1 = state_121359;
var statearr_121371_121387 = state_121359__$1;
(statearr_121371_121387[(2)] = inst_121355);

(statearr_121371_121387[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121360 === (5))){
var inst_121357 = (state_121359[(2)]);
var state_121359__$1 = state_121359;
return cljs.core.async.impl.ioc_helpers.return_chan(state_121359__$1,inst_121357);
} else {
if((state_val_121360 === (6))){
var inst_121336 = (state_121359[(8)]);
var state_121359__$1 = state_121359;
var statearr_121372_121388 = state_121359__$1;
(statearr_121372_121388[(2)] = inst_121336);

(statearr_121372_121388[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121360 === (7))){
var inst_121339 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_121340 = [(500),cljs.core.cst$kw$db_SLASH_unexpected_DASH_error];
var inst_121341 = cljs.core.PersistentHashMap.fromArrays(inst_121339,inst_121340);
var state_121359__$1 = state_121359;
var statearr_121373_121389 = state_121359__$1;
(statearr_121373_121389[(2)] = inst_121341);

(statearr_121373_121389[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_121360 === (8))){
var inst_121333 = (state_121359[(7)]);
var inst_121343 = (state_121359[(2)]);
var inst_121344 = [cljs.core.cst$kw$error,cljs.core.cst$kw$status];
var inst_121345 = cljs.core.ex_message(inst_121333);
var inst_121346 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_121343,cljs.core.cst$kw$message,inst_121345);
var inst_121347 = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(inst_121343);
var inst_121348 = [inst_121346,inst_121347];
var inst_121349 = cljs.core.PersistentHashMap.fromArrays(inst_121344,inst_121348);
var inst_121350 = (function (){var G__121374 = conn_id;
var G__121375 = cljs.core.cst$kw$setTransact;
var G__121376 = ref;
var G__121377 = inst_121349;
return (flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$4(G__121374,G__121375,G__121376,G__121377) : flureeworker.worker_action.call(null,G__121374,G__121375,G__121376,G__121377));
})();
var state_121359__$1 = state_121359;
var statearr_121378_121390 = state_121359__$1;
(statearr_121378_121390[(2)] = inst_121350);

(statearr_121378_121390[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__,map__121322,map__121322__$1,conn,ledger,jwt,_,map__121323,map__121323__$1,txn,options,txn_SINGLEQUOTE_,opts))
;
return ((function (switch__99702__auto__,c__99809__auto__,map__121322,map__121322__$1,conn,ledger,jwt,_,map__121323,map__121323__$1,txn,options,txn_SINGLEQUOTE_,opts){
return (function() {
var flureeworker$transact_$_state_machine__99703__auto__ = null;
var flureeworker$transact_$_state_machine__99703__auto____0 = (function (){
var statearr_121379 = [null,null,null,null,null,null,null,null,null];
(statearr_121379[(0)] = flureeworker$transact_$_state_machine__99703__auto__);

(statearr_121379[(1)] = (1));

return statearr_121379;
});
var flureeworker$transact_$_state_machine__99703__auto____1 = (function (state_121359){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_121359);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e121380){if((e121380 instanceof Object)){
var ex__99706__auto__ = e121380;
var statearr_121381_121391 = state_121359;
(statearr_121381_121391[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_121359);

return cljs.core.cst$kw$recur;
} else {
throw e121380;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__121392 = state_121359;
state_121359 = G__121392;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
flureeworker$transact_$_state_machine__99703__auto__ = function(state_121359){
switch(arguments.length){
case 0:
return flureeworker$transact_$_state_machine__99703__auto____0.call(this);
case 1:
return flureeworker$transact_$_state_machine__99703__auto____1.call(this,state_121359);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
flureeworker$transact_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = flureeworker$transact_$_state_machine__99703__auto____0;
flureeworker$transact_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = flureeworker$transact_$_state_machine__99703__auto____1;
return flureeworker$transact_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,map__121322,map__121322__$1,conn,ledger,jwt,_,map__121323,map__121323__$1,txn,options,txn_SINGLEQUOTE_,opts))
})();
var state__99811__auto__ = (function (){var statearr_121382 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_121382[(6)] = c__99809__auto__);

return statearr_121382;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,map__121322,map__121322__$1,conn,ledger,jwt,_,map__121323,map__121323__$1,txn,options,txn_SINGLEQUOTE_,opts))
);

return c__99809__auto__;
});
/**
 * Takes javascript array and move it into a clojurescript list without
 *   converting individual elements.
 */
flureeworker.js_array__GT_clj_list = (function flureeworker$js_array__GT_clj_list(js_array){
return cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__121393_SHARP_){
return (js_array[p1__121393_SHARP_]);
}),cljs.core.range.cljs$core$IFn$_invoke$arity$1(js_array.length));
});
/**
 * Main handler function for worker events
 *   Even data is a javascript object with the following keys:
 *   - action - the action to perform
 *   - params - parameters for the action we are calling
 *   - conn - the connection ID
 *   - ref - the reference ID to include in the response
 *   
 */
flureeworker.decode_message = (function flureeworker$decode_message(event){
try{var data = (event["data"]);
var action_str = (data["action"]);
var conn_id = (data["conn"]);
var ref = (data["ref"]);
var params_js = (data["params"]);
var params = ((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"pwGenerate")) || (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"transact"))))?flureeworker.obj__GT_clj(cljs.core.first(params_js)):flureeworker.js_array__GT_clj_list(params_js)
);
if(cljs.core.truth_(flureeworker.conn_closed_QMARK_(conn_id))){
if(cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"unregisterQuery")){
return flureeworker.postMessage(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$conn,conn_id,cljs.core.cst$kw$event,action_str,cljs.core.cst$kw$ref,ref,cljs.core.cst$kw$data,({"status": (400), "message": "Connection has been closed."})], null));
} else {
return null;
}
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"connect")){
return flureeworker.connect_p(cljs.core.first(params),ref);
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"close")){
return flureeworker.close_connection(conn_id,ref);
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"reset")){
return flureeworker.reset_connection(conn_id,ref);
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"registerQuery")){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(flureeworker.registerQuery,conn_id,params);
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"unregisterQuery")){
return flureeworker.unregisterQuery(conn_id,ref);
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"login")){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$4(flureeworker.login,conn_id,ref,params);
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"pwGenerate")){
return flureeworker.pw_generate(conn_id,ref,params);
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(action_str,"transact")){
return flureeworker.transact(conn_id,ref,params);
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Unknown action: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(action_str)].join(''),new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$status,(400)], null));

}
}
}
}
}
}
}
}
}
}catch (e121394){var e = e121394;
var data = (event["data"]);
var error_data = (function (){var temp__5733__auto__ = cljs.core.ex_data(e);
if(cljs.core.truth_(temp__5733__auto__)){
var ex_data = temp__5733__auto__;
return cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(function (){var or__4131__auto__ = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(ex_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (500);
}
})(),cljs.core.cst$kw$message,cljs.core.ex_message(e)], null),ex_data], 0));
} else {
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$message,["Unexpected error: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([e], 0))].join('')], null);
}
})();
console.error("Error executing message:",data);

console.error(cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([error_data], 0)));

return flureeworker.postMessage(new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$conn,(data["conn"]),cljs.core.cst$kw$event,(data["action"]),cljs.core.cst$kw$ref,(data["ref"]),cljs.core.cst$kw$data,error_data], null));
}});
/**
 * Log errors in this web worker
 */
flureeworker.log_error = (function flureeworker$log_error(error){
return console.error(error);
});
var temp__5735__auto___121395 = cljs.core.not(self.document);
if(temp__5735__auto___121395){
var worker_QMARK__121396 = temp__5735__auto___121395;
self.onerror = flureeworker.log_error;

self.onmessage = flureeworker.decode_message;
} else {
}
var G__121397_121399 = null;
var G__121398_121400 = cljs.core.cst$kw$connInit;
(flureeworker.worker_action.cljs$core$IFn$_invoke$arity$2 ? flureeworker.worker_action.cljs$core$IFn$_invoke$arity$2(G__121397_121399,G__121398_121400) : flureeworker.worker_action.call(null,G__121397_121399,G__121398_121400));
