// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.operations');
goog.require('cljs.core');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.log');
goog.require('cljs.core.async');
/**
 * Returns true if connection has been closed.
 */
fluree.db.operations.conn_closed_QMARK_ = (function fluree$db$operations$conn_closed_QMARK_(conn){
return new cljs.core.Keyword(null,"close?","close?",1600185693).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(conn)));
});
/**
 * Creates the operation header.
 */
fluree.db.operations.formulate_op_header = (function fluree$db$operations$formulate_op_header(var_args){
var G__93300 = arguments.length;
switch (G__93300) {
case 2:
return fluree.db.operations.formulate_op_header.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.operations.formulate_op_header.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.operations.formulate_op_header.cljs$core$IFn$_invoke$arity$2 = (function (operation,db){
return fluree.db.operations.formulate_op_header.call(null,operation,db,(60000));
});

fluree.db.operations.formulate_op_header.cljs$core$IFn$_invoke$arity$3 = (function (operation,db,timeout){
var req_id = cljs.core.str.cljs$core$IFn$_invoke$arity$1(fluree.db.util.core.random_uuid.call(null));
var header = new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"db","db",993250759),db,new cljs.core.Keyword(null,"op","op",-1882987955),operation,new cljs.core.Keyword(null,"req-id","req-id",-471642231),req_id,new cljs.core.Keyword(null,"timestamp","timestamp",579478971),fluree.db.util.core.current_time_millis.call(null),new cljs.core.Keyword(null,"timeout","timeout",-318625318),timeout], null);
return header;
});

fluree.db.operations.formulate_op_header.cljs$lang$maxFixedArity = 3;

/**
 * Sends operation off, returns core async promise channel that will have eventual response
 *   or timeout response.
 * 
 *   Records the request-id which is stored in an atom along with the response channel.
 * 
 *   Incoming ledger notifications will look at request id and see if
 *   there is a matching request-id in the record with its corresponding
 *   async channel, and if so it will populate that channel with the response.
 * 
 *   We use the timeout to create a timeout channel, so if no transactions with
 *   the corresponding request id are 'seen' in that timeframe, a timeout response
 *   is given.
 */
fluree.db.operations.send_operation = (function fluree$db$operations$send_operation(var_args){
var G__93303 = arguments.length;
switch (G__93303) {
case 3:
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$3 = (function (conn,operation,data){
return fluree.db.operations.send_operation.call(null,conn,operation,data,null);
});

fluree.db.operations.send_operation.cljs$core$IFn$_invoke$arity$4 = (function (conn,operation,data,opts){
var pc = cljs.core.async.promise_chan.call(null);
var c__86675__auto___93346 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___93346,pc){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___93346,pc){
return (function (state_93331){
var state_val_93332 = (state_93331[(1)]);
if((state_val_93332 === (1))){
var state_93331__$1 = state_93331;
var statearr_93333_93347 = state_93331__$1;
(statearr_93333_93347[(2)] = null);

(statearr_93333_93347[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93332 === (2))){
var inst_93329 = (state_93331[(2)]);
var state_93331__$1 = state_93331;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_93331__$1,inst_93329);
} else {
if((state_val_93332 === (3))){
var inst_93304 = (state_93331[(2)]);
var inst_93305 = cljs.core.async.put_BANG_.call(null,pc,inst_93304);
var state_93331__$1 = state_93331;
var statearr_93334_93348 = state_93331__$1;
(statearr_93334_93348[(2)] = inst_93305);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93331__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93332 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_93331,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_93309 = fluree.db.operations.conn_closed_QMARK_.call(null,conn);
var state_93331__$1 = state_93331;
if(cljs.core.truth_(inst_93309)){
var statearr_93335_93349 = state_93331__$1;
(statearr_93335_93349[(1)] = (5));

} else {
var statearr_93336_93350 = state_93331__$1;
(statearr_93336_93350[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93332 === (5))){
var inst_93311 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_93312 = [(400),new cljs.core.Keyword("db","invalid-connection","db/invalid-connection",2026003745)];
var inst_93313 = cljs.core.PersistentHashMap.fromArrays(inst_93311,inst_93312);
var inst_93314 = cljs.core.ex_info.call(null,"Connection was closed.",inst_93313);
var inst_93315 = (function(){throw inst_93314})();
var state_93331__$1 = state_93331;
var statearr_93337_93351 = state_93331__$1;
(statearr_93337_93351[(2)] = inst_93315);

(statearr_93337_93351[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93332 === (6))){
var inst_93317 = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(conn);
var inst_93318 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_93319 = [operation,data,pc,opts];
var inst_93320 = (new cljs.core.PersistentVector(null,4,(5),inst_93318,inst_93319,null));
var inst_93321 = cljs.core.async.put_BANG_.call(null,inst_93317,inst_93320);
var inst_93322 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_93323 = [operation,data,pc,opts];
var inst_93324 = (new cljs.core.PersistentVector(null,4,(5),inst_93322,inst_93323,null));
var inst_93325 = fluree.db.util.log.trace.call(null,"Put operation on connection req-chan: ",inst_93324);
var state_93331__$1 = (function (){var statearr_93338 = state_93331;
(statearr_93338[(7)] = inst_93321);

return statearr_93338;
})();
var statearr_93339_93352 = state_93331__$1;
(statearr_93339_93352[(2)] = inst_93325);

(statearr_93339_93352[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93332 === (7))){
var inst_93327 = (state_93331[(2)]);
var state_93331__$1 = state_93331;
var statearr_93340_93353 = state_93331__$1;
(statearr_93340_93353[(2)] = inst_93327);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93331__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__86675__auto___93346,pc))
;
return ((function (switch__86624__auto__,c__86675__auto___93346,pc){
return (function() {
var fluree$db$operations$state_machine__86625__auto__ = null;
var fluree$db$operations$state_machine__86625__auto____0 = (function (){
var statearr_93341 = [null,null,null,null,null,null,null,null];
(statearr_93341[(0)] = fluree$db$operations$state_machine__86625__auto__);

(statearr_93341[(1)] = (1));

return statearr_93341;
});
var fluree$db$operations$state_machine__86625__auto____1 = (function (state_93331){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_93331);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e93342){if((e93342 instanceof Object)){
var ex__86628__auto__ = e93342;
var statearr_93343_93354 = state_93331;
(statearr_93343_93354[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93331);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e93342;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__93355 = state_93331;
state_93331 = G__93355;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$operations$state_machine__86625__auto__ = function(state_93331){
switch(arguments.length){
case 0:
return fluree$db$operations$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$operations$state_machine__86625__auto____1.call(this,state_93331);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$operations$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$operations$state_machine__86625__auto____0;
fluree$db$operations$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$operations$state_machine__86625__auto____1;
return fluree$db$operations$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___93346,pc))
})();
var state__86677__auto__ = (function (){var statearr_93344 = f__86676__auto__.call(null);
(statearr_93344[(6)] = c__86675__auto___93346);

return statearr_93344;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___93346,pc))
);


return pc;
});

fluree.db.operations.send_operation.cljs$lang$maxFixedArity = 4;

/**
 * A quick async response to confirm as initiated, but deletion happens in background.
 * 
 *   A final 'completed' message will be sent in the future, if anyone cares to hear it.
 */
fluree.db.operations.delete_ledger_async = (function fluree$db$operations$delete_ledger_async(var_args){
var G__93357 = arguments.length;
switch (G__93357) {
case 1:
return fluree.db.operations.delete_ledger_async.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.operations.delete_ledger_async.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.operations.delete_ledger_async.cljs$core$IFn$_invoke$arity$1 = (function (session){
return fluree.db.operations.delete_ledger_async.call(null,session,null);
});

fluree.db.operations.delete_ledger_async.cljs$core$IFn$_invoke$arity$2 = (function (session,p__93358){
var map__93359 = p__93358;
var map__93359__$1 = (((((!((map__93359 == null))))?(((((map__93359.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__93359.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__93359):map__93359);
var opts = map__93359__$1;
var snapshot_QMARK_ = cljs.core.get.call(null,map__93359__$1,new cljs.core.Keyword(null,"snapshot?","snapshot?",99555670));
var map__93361 = session;
var map__93361__$1 = (((((!((map__93361 == null))))?(((((map__93361.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__93361.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__93361):map__93361);
var dbid = cljs.core.get.call(null,map__93361__$1,new cljs.core.Keyword(null,"dbid","dbid",-196647356));
var network = cljs.core.get.call(null,map__93361__$1,new cljs.core.Keyword(null,"network","network",2050004697));
var conn = cljs.core.get.call(null,map__93361__$1,new cljs.core.Keyword(null,"conn","conn",278309663));
return fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"delete-db","delete-db",1646085839),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"network","network",2050004697),network,new cljs.core.Keyword(null,"dbid","dbid",-196647356),dbid,new cljs.core.Keyword(null,"snapshot?","snapshot?",99555670),snapshot_QMARK_], null));
});

fluree.db.operations.delete_ledger_async.cljs$lang$maxFixedArity = 2;

/**
 * A quick async response to confirm as initiated, but garbage collection happens in background.
 * 
 *   A final 'completed' message will be sent in the future, if anyone cares to hear it.
 */
fluree.db.operations.garbage_collect_async = (function fluree$db$operations$garbage_collect_async(var_args){
var args__4736__auto__ = [];
var len__4730__auto___93420 = arguments.length;
var i__4731__auto___93421 = (0);
while(true){
if((i__4731__auto___93421 < len__4730__auto___93420)){
args__4736__auto__.push((arguments[i__4731__auto___93421]));

var G__93422 = (i__4731__auto___93421 + (1));
i__4731__auto___93421 = G__93422;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return fluree.db.operations.garbage_collect_async.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

fluree.db.operations.garbage_collect_async.cljs$core$IFn$_invoke$arity$variadic = (function (session,p__93366){
var vec__93367 = p__93366;
var map__93370 = cljs.core.nth.call(null,vec__93367,(0),null);
var map__93370__$1 = (((((!((map__93370 == null))))?(((((map__93370.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__93370.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__93370):map__93370);
var toBlock = cljs.core.get.call(null,map__93370__$1,new cljs.core.Keyword(null,"toBlock","toBlock",1609458185));
var toTime = cljs.core.get.call(null,map__93370__$1,new cljs.core.Keyword(null,"toTime","toTime",903224641));
var opts = vec__93367;
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,vec__93367,map__93370,map__93370__$1,toBlock,toTime,opts){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,vec__93367,map__93370,map__93370__$1,toBlock,toTime,opts){
return (function (state_93402){
var state_val_93403 = (state_93402[(1)]);
if((state_val_93403 === (7))){
var inst_93385 = (state_93402[(2)]);
var state_93402__$1 = state_93402;
var statearr_93404_93423 = state_93402__$1;
(statearr_93404_93423[(2)] = inst_93385);

(statearr_93404_93423[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93403 === (1))){
var inst_93374 = (session == null);
var inst_93375 = cljs.core.not.call(null,inst_93374);
var state_93402__$1 = state_93402;
if(inst_93375){
var statearr_93405_93424 = state_93402__$1;
(statearr_93405_93424[(1)] = (2));

} else {
var statearr_93406_93425 = state_93402__$1;
(statearr_93406_93425[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93403 === (4))){
var inst_93388 = (state_93402[(2)]);
var state_93402__$1 = state_93402;
if(cljs.core.truth_(inst_93388)){
var statearr_93407_93426 = state_93402__$1;
(statearr_93407_93426[(1)] = (8));

} else {
var statearr_93408_93427 = state_93402__$1;
(statearr_93408_93427[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93403 === (6))){
var state_93402__$1 = state_93402;
var statearr_93409_93428 = state_93402__$1;
(statearr_93409_93428[(2)] = false);

(statearr_93409_93428[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93403 === (3))){
var state_93402__$1 = state_93402;
var statearr_93410_93429 = state_93402__$1;
(statearr_93410_93429[(2)] = false);

(statearr_93410_93429[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93403 === (2))){
var inst_93377 = session.cljs$lang$protocol_mask$partition0$;
var inst_93378 = (inst_93377 & (64));
var inst_93379 = session.cljs$core$ISeq$;
var inst_93380 = (cljs.core.PROTOCOL_SENTINEL === inst_93379);
var inst_93381 = ((inst_93378) || (inst_93380));
var state_93402__$1 = state_93402;
if(cljs.core.truth_(inst_93381)){
var statearr_93411_93430 = state_93402__$1;
(statearr_93411_93430[(1)] = (5));

} else {
var statearr_93412_93431 = state_93402__$1;
(statearr_93412_93431[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93403 === (9))){
var state_93402__$1 = state_93402;
var statearr_93413_93432 = state_93402__$1;
(statearr_93413_93432[(2)] = session);

(statearr_93413_93432[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93403 === (5))){
var state_93402__$1 = state_93402;
var statearr_93414_93433 = state_93402__$1;
(statearr_93414_93433[(2)] = true);

(statearr_93414_93433[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93403 === (10))){
var inst_93393 = (state_93402[(2)]);
var inst_93394 = cljs.core.get.call(null,inst_93393,new cljs.core.Keyword(null,"network","network",2050004697));
var inst_93395 = cljs.core.get.call(null,inst_93393,new cljs.core.Keyword(null,"dbid","dbid",-196647356));
var inst_93396 = cljs.core.get.call(null,inst_93393,new cljs.core.Keyword(null,"conn","conn",278309663));
var inst_93397 = [new cljs.core.Keyword(null,"network","network",2050004697),new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"toBlock","toBlock",1609458185),new cljs.core.Keyword(null,"toTime","toTime",903224641)];
var inst_93398 = [inst_93394,inst_93395,toBlock,toTime];
var inst_93399 = cljs.core.PersistentHashMap.fromArrays(inst_93397,inst_93398);
var inst_93400 = fluree.db.operations.send_operation.call(null,inst_93396,new cljs.core.Keyword(null,"garbage","garbage",-2063107600),inst_93399);
var state_93402__$1 = state_93402;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_93402__$1,inst_93400);
} else {
if((state_val_93403 === (8))){
var inst_93390 = cljs.core.apply.call(null,cljs.core.hash_map,session);
var state_93402__$1 = state_93402;
var statearr_93415_93434 = state_93402__$1;
(statearr_93415_93434[(2)] = inst_93390);

(statearr_93415_93434[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,vec__93367,map__93370,map__93370__$1,toBlock,toTime,opts))
;
return ((function (switch__86624__auto__,c__86675__auto__,vec__93367,map__93370,map__93370__$1,toBlock,toTime,opts){
return (function() {
var fluree$db$operations$state_machine__86625__auto__ = null;
var fluree$db$operations$state_machine__86625__auto____0 = (function (){
var statearr_93416 = [null,null,null,null,null,null,null];
(statearr_93416[(0)] = fluree$db$operations$state_machine__86625__auto__);

(statearr_93416[(1)] = (1));

return statearr_93416;
});
var fluree$db$operations$state_machine__86625__auto____1 = (function (state_93402){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_93402);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e93417){if((e93417 instanceof Object)){
var ex__86628__auto__ = e93417;
var statearr_93418_93435 = state_93402;
(statearr_93418_93435[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93402);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e93417;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__93436 = state_93402;
state_93402 = G__93436;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$operations$state_machine__86625__auto__ = function(state_93402){
switch(arguments.length){
case 0:
return fluree$db$operations$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$operations$state_machine__86625__auto____1.call(this,state_93402);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$operations$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$operations$state_machine__86625__auto____0;
fluree$db$operations$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$operations$state_machine__86625__auto____1;
return fluree$db$operations$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,vec__93367,map__93370,map__93370__$1,toBlock,toTime,opts))
})();
var state__86677__auto__ = (function (){var statearr_93419 = f__86676__auto__.call(null);
(statearr_93419[(6)] = c__86675__auto__);

return statearr_93419;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,vec__93367,map__93370,map__93370__$1,toBlock,toTime,opts))
);

return c__86675__auto__;
});

fluree.db.operations.garbage_collect_async.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
fluree.db.operations.garbage_collect_async.cljs$lang$applyTo = (function (seq93364){
var G__93365 = cljs.core.first.call(null,seq93364);
var seq93364__$1 = cljs.core.next.call(null,seq93364);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__93365,seq93364__$1);
});

/**
 * A quick async response to confirm, but archival happens in background.
 * 
 *   A final 'completed' message will be sent in the future, if anyone cares to hear it.
 */
fluree.db.operations.snapshot_ledger_async = (function fluree$db$operations$snapshot_ledger_async(session,opts){
var map__93437 = session;
var map__93437__$1 = (((((!((map__93437 == null))))?(((((map__93437.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__93437.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__93437):map__93437);
var network = cljs.core.get.call(null,map__93437__$1,new cljs.core.Keyword(null,"network","network",2050004697));
var dbid = cljs.core.get.call(null,map__93437__$1,new cljs.core.Keyword(null,"dbid","dbid",-196647356));
var conn = cljs.core.get.call(null,map__93437__$1,new cljs.core.Keyword(null,"conn","conn",278309663));
return fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"snapshot-db","snapshot-db",199417128),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null));
});
/**
 * Submits a command to connected tx-group server
 */
fluree.db.operations.command_async = (function fluree$db$operations$command_async(conn,cmd){
return fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"cmd","cmd",-302931143),cmd);
});
/**
 * A response will not be returned until transaction is completed.
 * 
 *   An option of {:wait false} can be provided which will return 'true' when the transaction
 *   has been successfully persisted by the transactors, or throw an exception.
 * 
 *   By default transact will monitor completed blocks and only return once it sees
 *   the successful transaction completed, or it will return with an error.
 */
fluree.db.operations.unsigned_command_async = (function fluree$db$operations$unsigned_command_async(conn,unsigned_cmd_map){
return fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"unsigned-cmd","unsigned-cmd",1466012010),unsigned_cmd_map);
});
/**
 * Returns information about a ledger in a map, or empty map if db doesn't exist.
 */
fluree.db.operations.ledger_info_async = (function fluree$db$operations$ledger_info_async(conn,ledger){
return fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"ledger-info","ledger-info",-161414079),ledger);
});
/**
 * Returns information about a ledger in a map, or empty map if db doesn't exist.
 */
fluree.db.operations.ledger_status_async = (function fluree$db$operations$ledger_status_async(conn,ledger){
return new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"ledger-info","ledger-info",-161414079),ledger));
});
/**
 * Returns stats about a ledger in a map, or empty map if db doesn't exist.
 */
fluree.db.operations.ledger_stats_async = (function fluree$db$operations$ledger_stats_async(conn,ledger){
return fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"ledger-stats","ledger-stats",765646297),ledger);
});
/**
 * Returns a list of ledgers in two-tuples of [network ledger-id].
 */
fluree.db.operations.ledgers_async = (function fluree$db$operations$ledgers_async(conn){
return fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"db-list","db-list",230589843),null);
});
/**
 * A response will not be returned until transaction is completed.
 * 
 *   An option of {:wait false} can be provided which will return 'true' when the transaction
 *   has been successfully persisted by the transactors, or throw an exception.
 * 
 *   By default transact will monitor completed blocks and only return once it sees
 *   the successful transaction completed, or it will return with an error.
 */
fluree.db.operations.transact_async = (function fluree$db$operations$transact_async(conn,tx_map){
fluree.db.util.log.trace.call(null,"Sending transaction async: ",tx_map);

return fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"tx","tx",466630418),tx_map);
});
/**
 * Starts a subscription to the session's ledger.
 * 
 *   Supported options:
 *   - auth    - auth, if specified, takes precedence
 *   - jwt     - valid jwt
 *   
 */
fluree.db.operations.subscribe = (function fluree$db$operations$subscribe(var_args){
var G__93440 = arguments.length;
switch (G__93440) {
case 1:
return fluree.db.operations.subscribe.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.operations.subscribe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.operations.subscribe.cljs$core$IFn$_invoke$arity$1 = (function (session){
return fluree.db.operations.subscribe.call(null,session,null);
});

fluree.db.operations.subscribe.cljs$core$IFn$_invoke$arity$2 = (function (session,opts){
var map__93441 = opts;
var map__93441__$1 = (((((!((map__93441 == null))))?(((((map__93441.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__93441.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__93441):map__93441);
var auth = cljs.core.get.call(null,map__93441__$1,new cljs.core.Keyword(null,"auth","auth",1389754926));
var jwt = cljs.core.get.call(null,map__93441__$1,new cljs.core.Keyword(null,"jwt","jwt",1504015441));
var conn = new cljs.core.Keyword(null,"conn","conn",278309663).cljs$core$IFn$_invoke$arity$1(session);
var auth_or_jwt = (function (){var or__4131__auto__ = auth;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return jwt;
}
})();
var _ = fluree.db.util.log.trace.call(null,"Subscribe to: ",new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(session),new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(session),auth_or_jwt);
return fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"subscribe","subscribe",416253756),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(session),new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(session)], null),auth_or_jwt], null));
});

fluree.db.operations.subscribe.cljs$lang$maxFixedArity = 2;

/**
 * Unsubscribes from the session's ledger.
 */
fluree.db.operations.unsubscribe = (function fluree$db$operations$unsubscribe(session){
var conn = new cljs.core.Keyword(null,"conn","conn",278309663).cljs$core$IFn$_invoke$arity$1(session);
return fluree.db.operations.send_operation.call(null,conn,new cljs.core.Keyword(null,"unsbuscribe","unsbuscribe",888593047),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(session),new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(session)], null));
});
