// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.query.fql_parser');
goog.require('cljs.core');
goog.require('fluree.db.util.core');
goog.require('fluree.db.dbproto');
goog.require('clojure.string');
goog.require('fluree.db.spec');
goog.require('fluree.db.util.async');
goog.require('fluree.db.util.log');
goog.require('fluree.db.query.schema');
/**
 * Checks to see if the where clause has ' = ', ' > ', ' < ', ' <= ', or ' >= ', and returns true if yes
 */
fluree.db.query.fql_parser.where_clause_valid_QMARK_ = (function fluree$db$query$fql_parser$where_clause_valid_QMARK_(where_clause){
var and__4120__auto__ = typeof where_clause === 'string';
if(and__4120__auto__){
return cljs.core.re_find.call(null,/^.* (=|>|<|>=|<=|not=) .*$/,where_clause);
} else {
return and__4120__auto__;
}
});
/**
 * Returns a where clause spec based on a string where caluse.
 *   The spec can be applied to a specific db to coerce predicate names
 *   to predicate ids, validate types, and ultimately generate a filtering function.
 */
fluree.db.query.fql_parser.parse_where_spec = (function fluree$db$query$fql_parser$parse_where_spec(var_args){
var G__96248 = arguments.length;
switch (G__96248) {
case 1:
return fluree.db.query.fql_parser.parse_where_spec.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.query.fql_parser.parse_where_spec.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.fql_parser.parse_where_spec.cljs$core$IFn$_invoke$arity$1 = (function (where){
return fluree.db.query.fql_parser.parse_where_spec.call(null,where,null);
});

fluree.db.query.fql_parser.parse_where_spec.cljs$core$IFn$_invoke$arity$2 = (function (where,default_collection){
if(cljs.core.truth_(fluree.db.query.fql_parser.where_clause_valid_QMARK_.call(null,where))){
} else {
throw cljs.core.ex_info.call(null,["Invalid where clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(where)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null));
}

var where_type = (cljs.core.truth_((function (){var and__4120__auto__ = cljs.core.re_matches.call(null,/.+ AND .+/,where);
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.not.call(null,cljs.core.re_matches.call(null,/.+ OR .+/,where));
} else {
return and__4120__auto__;
}
})())?new cljs.core.Keyword(null,"and","and",-971899817):(cljs.core.truth_((function (){var and__4120__auto__ = cljs.core.re_matches.call(null,/.+ OR .+/,where);
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.not.call(null,cljs.core.re_matches.call(null,/.+ AND .+/,where));
} else {
return and__4120__auto__;
}
})())?new cljs.core.Keyword(null,"or","or",235744169):((((cljs.core.not.call(null,cljs.core.re_matches.call(null,/.+ OR .+/,where))) && (cljs.core.not.call(null,cljs.core.re_matches.call(null,/.+ AND .+/,where)))))?new cljs.core.Keyword(null,"or","or",235744169):(function(){throw cljs.core.ex_info.call(null,["Where clause can have either AND or OR operations, but not both currently: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(where)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null))})()
)));
var args = (function (){var G__96249 = where_type;
var G__96249__$1 = (((G__96249 instanceof cljs.core.Keyword))?G__96249.fqn:null);
switch (G__96249__$1) {
case "and":
return clojure.string.split.call(null,where,/ AND /);

break;
case "or":
return clojure.string.split.call(null,where,/ OR /);

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__96249__$1)].join('')));

}
})();
var statements = cljs.core.reduce.call(null,((function (where_type,args){
return (function (acc,arg){
var arg__$1 = clojure.string.trim.call(null,arg);
var vec__96250 = cljs.core.re_find.call(null,/^([^\s=><].+)[\s]+:?(=|>|<|>=|<=|not=)[\s]+:?(.+)$/,arg__$1);
var _ = cljs.core.nth.call(null,vec__96250,(0),null);
var pred_name = cljs.core.nth.call(null,vec__96250,(1),null);
var op = cljs.core.nth.call(null,vec__96250,(2),null);
var match = cljs.core.nth.call(null,vec__96250,(3),null);
var pred_name__$1 = ((fluree.db.query.schema.reverse_ref_QMARK_.call(null,pred_name,false))?(function(){throw cljs.core.ex_info.call(null,["Reverse references cannot be used in a where clause. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(pred_name)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null))})():((clojure.string.includes_QMARK_.call(null,pred_name,"/"))?pred_name:(cljs.core.truth_(default_collection)?[cljs.core.str.cljs$core$IFn$_invoke$arity$1(default_collection),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(pred_name)].join(''):(function(){throw cljs.core.ex_info.call(null,["Only full namespaced predicate\n                                         names can be used in a where clause. This can be\n                                         provided in a from clause. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(pred_name)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null))})()
)));
var op_STAR_ = (function (){var G__96253 = op;
switch (G__96253) {
case "=":
return cljs.core._EQ_;

break;
case ">":
return cljs.core._GT_;

break;
case ">=":
return cljs.core._GT__EQ_;

break;
case "<":
return cljs.core._LT_;

break;
case "<=":
return cljs.core._LT__EQ_;

break;
case "not=":
return cljs.core.not_EQ_;

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__96253)].join('')));

}
})();
var match_STAR_ = (function (){var temp__5733__auto__ = (function (){var or__4131__auto__ = cljs.core.re_find.call(null,/'(.*)'$/,match);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.re_find.call(null,/\"(.*)\"$/,match);
}
})();
if(cljs.core.truth_(temp__5733__auto__)){
var match_str = temp__5733__auto__;
return cljs.core.second.call(null,match_str);
} else {
try{if(cljs.core._EQ_.call(null,"true",match)){
return true;
} else {
if(cljs.core._EQ_.call(null,"false",match)){
return false;
} else {
if(clojure.string.includes_QMARK_.call(null,match,".")){
return parseFloat(match);
} else {
return parseInt(match);

}
}
}
}catch (e96254){var ___$1 = e96254;
throw cljs.core.ex_info.call(null,["Invalid where clause in argument: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arg__$1)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null));
}}
})();
return cljs.core.conj.call(null,acc,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [pred_name__$1,op_STAR_,match_STAR_], null));
});})(where_type,args))
,cljs.core.PersistentVector.EMPTY,args);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [where_type,statements], null);
});

fluree.db.query.fql_parser.parse_where_spec.cljs$lang$maxFixedArity = 2;

/**
 * Conforms a where spec, using provided db, to use predicate ids and coerces where match values.
 *   If an predicate does not exist, it drops it.
 */
fluree.db.query.fql_parser.conform_where = (function fluree$db$query$fql_parser$conform_where(db,p__96258){
var vec__96259 = p__96258;
var where_type = cljs.core.nth.call(null,vec__96259,(0),null);
var statements = cljs.core.nth.call(null,vec__96259,(1),null);
var statements_STAR_ = cljs.core.not_empty.call(null,cljs.core.remove.call(null,cljs.core.nil_QMARK_,cljs.core.map.call(null,((function (vec__96259,where_type,statements){
return (function (p__96262){
var vec__96263 = p__96262;
var pred_name = cljs.core.nth.call(null,vec__96263,(0),null);
var op = cljs.core.nth.call(null,vec__96263,(1),null);
var o = cljs.core.nth.call(null,vec__96263,(2),null);
var pid = fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),pred_name);
if(cljs.core.truth_(pid)){
var pred_type = fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"type","type",1174270348),pid);
var o_STAR_ = fluree.db.spec.type_check.call(null,o,pred_type);
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [pid,op,o_STAR_], null);
} else {
return null;
}
});})(vec__96259,where_type,statements))
,statements)));
if(cljs.core.truth_(statements_STAR_)){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [where_type,statements_STAR_], null);
} else {
return null;
}
});
/**
 * Parses a where clause and coerces the predicates 
 */
fluree.db.query.fql_parser.parse_where = (function fluree$db$query$fql_parser$parse_where(var_args){
var G__96267 = arguments.length;
switch (G__96267) {
case 2:
return fluree.db.query.fql_parser.parse_where.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.query.fql_parser.parse_where.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.fql_parser.parse_where.cljs$core$IFn$_invoke$arity$2 = (function (db,where){
return fluree.db.query.fql_parser.parse_where.call(null,db,where,null);
});

fluree.db.query.fql_parser.parse_where.cljs$core$IFn$_invoke$arity$3 = (function (db,where,default_collection){
var where_spec = fluree.db.query.fql_parser.parse_where_spec.call(null,where,default_collection);
return fluree.db.query.fql_parser.conform_where.call(null,db,where_spec);
});

fluree.db.query.fql_parser.parse_where.cljs$lang$maxFixedArity = 3;

/**
 * Takes a sequential select statement and turns it into a map.
 */
fluree.db.query.fql_parser.to_select_map = (function fluree$db$query$fql_parser$to_select_map(select){
return cljs.core.reduce.call(null,(function (acc,x){
var kv = ((cljs.core.sequential_QMARK_.call(null,x))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [fluree.db.util.core.keyword__GT_str.call(null,cljs.core.first.call(null,x)),(function (){var v_STAR_ = cljs.core.second.call(null,x);
if(cljs.core.coll_QMARK_.call(null,v_STAR_)){
return fluree.db.query.fql_parser.to_select_map.call(null,v_STAR_);
} else {
return v_STAR_;
}
})()], null):((cljs.core.map_QMARK_.call(null,x))?(function (){var values = cljs.core.mapv.call(null,(function (x_item){
var key_x = fluree.db.util.core.keyword__GT_str.call(null,cljs.core.key.call(null,x_item));
var val_x = cljs.core.val.call(null,x_item);
var val_x_SINGLEQUOTE_ = ((cljs.core._EQ_.call(null,"_orderBy",key_x))?((cljs.core.coll_QMARK_.call(null,val_x))?new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"order","order",-1254677256),cljs.core.first.call(null,val_x),new cljs.core.Keyword(null,"predicate","predicate",-1742501860),cljs.core.second.call(null,val_x)], null):new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"order","order",-1254677256),"ASC",new cljs.core.Keyword(null,"predicate","predicate",-1742501860),val_x], null)):((cljs.core.coll_QMARK_.call(null,val_x))?fluree.db.query.fql_parser.to_select_map.call(null,val_x):val_x
));
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [key_x,val_x_SINGLEQUOTE_], null);
}),x);
return cljs.core.into.call(null,cljs.core.PersistentVector.EMPTY,cljs.core.flatten.call(null,values));
})():new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [x,null], null)
));
return cljs.core.apply.call(null,cljs.core.assoc,acc,kv);
}),cljs.core.PersistentArrayMap.EMPTY,select);
});
/**
 * Parses select statement into our own select format.
 *   Has no dependency on a database, or a given schema
 *   at this point.
 * 
 *   Select spec has the following keys:
 *   :name  - name of the predicate
 *   :namespace? - if the predicate 'name' has a namespace included
 *   :wildcard? - true if wildcard query
 *   :id? - true if  _id was explicitly requested
 *   :reverse? - if this predicate is a reverse lookup. 'name' will be the non-reverse named predicate
 *   :as - The result key name to use in the results map for this predicate
 *   :recur - number of recur iterations, if specified
 *   :limit - limit the number of results, if specified (100 default)
 *   :offset - offset the number of results, if specified (0 default)
 *   :select - sub-selection for this predicate - only applicable to 'ref' predicates
 *   :compact - If we are to remove namespaces (or names from reverse refs)
 *   
 */
fluree.db.query.fql_parser.parse = (function fluree$db$query$fql_parser$parse(select,opts){
var select__$1 = ((cljs.core.coll_QMARK_.call(null,select))?fluree.db.query.fql_parser.to_select_map.call(null,select):select);
var default_compact_QMARK_ = new cljs.core.Keyword(null,"compact","compact",-348732150).cljs$core$IFn$_invoke$arity$1(opts);
return cljs.core.reduce_kv.call(null,((function (select__$1,default_compact_QMARK_){
return (function (acc,k,v){
var pred = (((k instanceof cljs.core.Keyword))?fluree.db.util.core.keyword__GT_str.call(null,k):(((k instanceof cljs.core.Symbol))?cljs.core.str.cljs$core$IFn$_invoke$arity$1(k):k
));
var v_SINGLEQUOTE_ = ((cljs.core.sequential_QMARK_.call(null,v))?fluree.db.query.fql_parser.to_select_map.call(null,v):v);
var compact_QMARK_ = ((cljs.core.contains_QMARK_.call(null,v_SINGLEQUOTE_,"_compact"))?cljs.core.get.call(null,v_SINGLEQUOTE_,"_compact"):default_compact_QMARK_);
if(cljs.core._EQ_.call(null,"*",pred)){
return cljs.core.assoc.call(null,acc,new cljs.core.Keyword(null,"wildcard?","wildcard?",-686044101),true,new cljs.core.Keyword(null,"compact?","compact?",1216893298),compact_QMARK_);
} else {
if(cljs.core._EQ_.call(null,"_id",pred)){
return cljs.core.assoc.call(null,acc,new cljs.core.Keyword(null,"id?","id?",-1487101183),true);
} else {
var _ = (cljs.core.truth_((function (){var and__4120__auto__ = v_SINGLEQUOTE_;
if(cljs.core.truth_(and__4120__auto__)){
return (!(cljs.core.map_QMARK_.call(null,v)));
} else {
return and__4120__auto__;
}
})())?(function(){throw cljs.core.ex_info.call(null,["Invalid select spec: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(select__$1)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"db","db",993250759),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null))})():null);
var sub_select = (function (){var G__96269 = cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,v_SINGLEQUOTE_,"_limit","_offset","_as","_recur","_component","_orderBy","_compact"));
if((G__96269 == null)){
return null;
} else {
return fluree.db.query.fql_parser.parse.call(null,G__96269,opts);
}
})();
var namespace_QMARK_ = clojure.string.includes_QMARK_.call(null,pred,"/");
var reverse_QMARK_ = clojure.string.includes_QMARK_.call(null,pred,"/_");
var pred_SINGLEQUOTE_ = ((reverse_QMARK_)?clojure.string.replace.call(null,pred,"/_","/"):pred);
var as = ((cljs.core.contains_QMARK_.call(null,v_SINGLEQUOTE_,"_as"))?cljs.core.get.call(null,v_SINGLEQUOTE_,"_as"):(cljs.core.truth_((function (){var and__4120__auto__ = default_compact_QMARK_;
if(cljs.core.truth_(and__4120__auto__)){
return reverse_QMARK_;
} else {
return and__4120__auto__;
}
})())?cljs.core.re_find.call(null,/^[^\/]+/,pred):(cljs.core.truth_((function (){var and__4120__auto__ = default_compact_QMARK_;
if(cljs.core.truth_(and__4120__auto__)){
return namespace_QMARK_;
} else {
return and__4120__auto__;
}
})())?cljs.core.second.call(null,cljs.core.re_find.call(null,/\/(.+)/,pred)):k
)));
var spec = cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"id?","id?",-1487101183),new cljs.core.Keyword(null,"componentFollow?","componentFollow?",-1486906651),new cljs.core.Keyword(null,"limit","limit",-1355822363),new cljs.core.Keyword(null,"reverse?","reverse?",-1672868474),new cljs.core.Keyword(null,"offset","offset",296498311),new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"as","as",1148689641),new cljs.core.Keyword(null,"namespace?","namespace?",-203321783),new cljs.core.Keyword(null,"recur","recur",-437573268),new cljs.core.Keyword(null,"compact?","compact?",1216893298),new cljs.core.Keyword(null,"wildcard?","wildcard?",-686044101),new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"orderBy","orderBy",-1329797793)],[new cljs.core.Keyword(null,"id?","id?",-1487101183).cljs$core$IFn$_invoke$arity$1(sub_select),cljs.core.get.call(null,v_SINGLEQUOTE_,"_component"),cljs.core.get.call(null,v_SINGLEQUOTE_,"_limit",(100)),reverse_QMARK_,cljs.core.get.call(null,v_SINGLEQUOTE_,"_offset",(0)),pred_SINGLEQUOTE_,as,namespace_QMARK_,cljs.core.get.call(null,v_SINGLEQUOTE_,"_recur"),compact_QMARK_,new cljs.core.Keyword(null,"wildcard?","wildcard?",-686044101).cljs$core$IFn$_invoke$arity$1(sub_select),new cljs.core.Keyword(null,"select","select",1147833503).cljs$core$IFn$_invoke$arity$1(sub_select),cljs.core.get.call(null,v_SINGLEQUOTE_,"_orderBy")]);
if(reverse_QMARK_){
return cljs.core.assoc_in.call(null,acc,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"reverse","reverse",-888455266),pred_SINGLEQUOTE_], null),spec);
} else {
if(namespace_QMARK_){
return cljs.core.assoc_in.call(null,acc,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"pred-id","pred-id",-942630484),pred_SINGLEQUOTE_], null),spec);
} else {
return cljs.core.assoc_in.call(null,acc,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"ns-lookup","ns-lookup",960704767),pred_SINGLEQUOTE_], null),spec);

}
}

}
}
});})(select__$1,default_compact_QMARK_))
,cljs.core.PersistentArrayMap.EMPTY,select__$1);
});
fluree.db.query.fql_parser.p__GT_pred_config = (function fluree$db$query$fql_parser$p__GT_pred_config(db,p,compact_QMARK_){
var name = fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"name","name",1843675177),p);
return new cljs.core.PersistentArrayMap(null, 8, [new cljs.core.Keyword(null,"p","p",151049309),p,new cljs.core.Keyword(null,"limit","limit",-1355822363),(100),new cljs.core.Keyword(null,"name","name",1843675177),name,new cljs.core.Keyword(null,"as","as",1148689641),(cljs.core.truth_((function (){var and__4120__auto__ = compact_QMARK_;
if(cljs.core.truth_(and__4120__auto__)){
return name;
} else {
return and__4120__auto__;
}
})())?cljs.core.second.call(null,cljs.core.re_find.call(null,/\/(.+)/,name)):(function (){var or__4131__auto__ = name;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.str.cljs$core$IFn$_invoke$arity$1(p);
}
})()),new cljs.core.Keyword(null,"multi?","multi?",-749311069),fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"multi","multi",-190293005),p),new cljs.core.Keyword(null,"component?","component?",407783990),fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"component","component",1555936782),p),new cljs.core.Keyword(null,"tag?","tag?",1714008252),cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"tag","tag",-1290361223),fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"type","type",1174270348),p)),new cljs.core.Keyword(null,"ref?","ref?",1932693720),fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"ref?","ref?",1932693720),p)], null);
});
/**
 * For a flake selection, build out parts of the
 *   base set of predicates so we don't need to look them up
 *   each time... like multi, component, etc.
 */
fluree.db.query.fql_parser.build_predicate_map = (function fluree$db$query$fql_parser$build_predicate_map(db,pred_name){
var temp__5735__auto__ = fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),pred_name);
if(cljs.core.truth_(temp__5735__auto__)){
var p = temp__5735__auto__;
return fluree.db.query.fql_parser.p__GT_pred_config.call(null,db,p,false);
} else {
return null;
}
});
/**
 * Given an predicate spec produced by the parsed select statement,
 *   when an predicate does not have a namespace we will default it to
 *   utilize the namespace of the subject.
 * 
 *   This fills out the predicate spec that couldn't be done earlier because
 *   we did not know the collection.
 */
fluree.db.query.fql_parser.ns_lookup_pred_spec = (function fluree$db$query$fql_parser$ns_lookup_pred_spec(db,collection_id,ns_lookup_spec_map){
var collection_name = fluree.db.dbproto._c_prop.call(null,db,new cljs.core.Keyword(null,"name","name",1843675177),collection_id);
return cljs.core.reduce_kv.call(null,((function (collection_name){
return (function (acc,k,v){
var pred = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(collection_name),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(k)].join('');
var temp__5733__auto__ = fluree.db.query.fql_parser.build_predicate_map.call(null,db,pred);
if(cljs.core.truth_(temp__5733__auto__)){
var p_map = temp__5733__auto__;
return cljs.core.assoc.call(null,acc,new cljs.core.Keyword(null,"p","p",151049309).cljs$core$IFn$_invoke$arity$1(p_map),cljs.core.merge.call(null,p_map,v));
} else {
return acc;
}
});})(collection_name))
,null,ns_lookup_spec_map);
});
fluree.db.query.fql_parser.parse_db_STAR_ = (function fluree$db$query$fql_parser$parse_db_STAR_(db,sub_select){
var G__96276 = sub_select;
var vec__96277 = G__96276;
var seq__96278 = cljs.core.seq.call(null,vec__96277);
var first__96279 = cljs.core.first.call(null,seq__96278);
var seq__96278__$1 = cljs.core.next.call(null,seq__96278);
var vec__96280 = first__96279;
var k = cljs.core.nth.call(null,vec__96280,(0),null);
var v = cljs.core.nth.call(null,vec__96280,(1),null);
var r = seq__96278__$1;
var acc = cljs.core.PersistentArrayMap.EMPTY;
var G__96276__$1 = G__96276;
var acc__$1 = acc;
while(true){
var vec__96339 = G__96276__$1;
var seq__96340 = cljs.core.seq.call(null,vec__96339);
var first__96341 = cljs.core.first.call(null,seq__96340);
var seq__96340__$1 = cljs.core.next.call(null,seq__96340);
var vec__96342 = first__96341;
var k__$1 = cljs.core.nth.call(null,vec__96342,(0),null);
var v__$1 = cljs.core.nth.call(null,vec__96342,(1),null);
var r__$1 = seq__96340__$1;
var acc__$2 = acc__$1;
if(cljs.core.not.call(null,k__$1)){
return acc__$2;
} else {
var v_SINGLEQUOTE_ = ((cljs.core.not.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pred-id","pred-id",-942630484),null,new cljs.core.Keyword(null,"reverse","reverse",-888455266),null], null), null).call(null,k__$1)))?v__$1:(function (){var G__96351 = v__$1;
var vec__96352 = G__96351;
var seq__96353 = cljs.core.seq.call(null,vec__96352);
var first__96354 = cljs.core.first.call(null,seq__96353);
var seq__96353__$1 = cljs.core.next.call(null,seq__96353);
var vec__96355 = first__96354;
var k_STAR_ = cljs.core.nth.call(null,vec__96355,(0),null);
var v_STAR_ = cljs.core.nth.call(null,vec__96355,(1),null);
var r_STAR_ = seq__96353__$1;
var acc_STAR_ = cljs.core.PersistentArrayMap.EMPTY;
var G__96351__$1 = G__96351;
var acc_STAR___$1 = acc_STAR_;
while(true){
var vec__96364 = G__96351__$1;
var seq__96365 = cljs.core.seq.call(null,vec__96364);
var first__96366 = cljs.core.first.call(null,seq__96365);
var seq__96365__$1 = cljs.core.next.call(null,seq__96365);
var vec__96367 = first__96366;
var k_STAR___$1 = cljs.core.nth.call(null,vec__96367,(0),null);
var v_STAR___$1 = cljs.core.nth.call(null,vec__96367,(1),null);
var r_STAR___$1 = seq__96365__$1;
var acc_STAR___$2 = acc_STAR___$1;
if(cljs.core.not.call(null,k_STAR___$1)){
return acc_STAR___$2;
} else {
var p_map = fluree.db.query.fql_parser.build_predicate_map.call(null,db,k_STAR___$1);
var acc_STAR__STAR_ = (cljs.core.truth_(p_map)?cljs.core.assoc.call(null,acc_STAR___$2,new cljs.core.Keyword(null,"p","p",151049309).cljs$core$IFn$_invoke$arity$1(p_map),cljs.core.merge.call(null,p_map,v_STAR___$1)):acc_STAR___$2);
var G__96395 = r_STAR___$1;
var G__96396 = acc_STAR__STAR_;
G__96351__$1 = G__96395;
acc_STAR___$1 = G__96396;
continue;
}
break;
}
})());
var v_SINGLEQUOTE__SINGLEQUOTE_ = (function (){var G__96376 = v_SINGLEQUOTE_;
var vec__96377 = G__96376;
var seq__96378 = cljs.core.seq.call(null,vec__96377);
var first__96379 = cljs.core.first.call(null,seq__96378);
var seq__96378__$1 = cljs.core.next.call(null,seq__96378);
var vec__96380 = first__96379;
var k_STAR_ = cljs.core.nth.call(null,vec__96380,(0),null);
var v_STAR_ = cljs.core.nth.call(null,vec__96380,(1),null);
var r_STAR_ = seq__96378__$1;
var acc_STAR_ = cljs.core.PersistentArrayMap.EMPTY;
var G__96376__$1 = G__96376;
var acc_STAR___$1 = acc_STAR_;
while(true){
var vec__96389 = G__96376__$1;
var seq__96390 = cljs.core.seq.call(null,vec__96389);
var first__96391 = cljs.core.first.call(null,seq__96390);
var seq__96390__$1 = cljs.core.next.call(null,seq__96390);
var vec__96392 = first__96391;
var k_STAR___$1 = cljs.core.nth.call(null,vec__96392,(0),null);
var v_STAR___$1 = cljs.core.nth.call(null,vec__96392,(1),null);
var r_STAR___$1 = seq__96390__$1;
var acc_STAR___$2 = acc_STAR___$1;
if(cljs.core.not.call(null,k_STAR___$1)){
return acc_STAR___$2;
} else {
var acc_STAR__STAR_ = (cljs.core.truth_(new cljs.core.Keyword(null,"select","select",1147833503).cljs$core$IFn$_invoke$arity$1(v_STAR___$1))?cljs.core.assoc.call(null,acc_STAR___$2,k_STAR___$1,cljs.core.assoc.call(null,v_STAR___$1,new cljs.core.Keyword(null,"select","select",1147833503),fluree.db.query.fql_parser.parse_db_STAR_.call(null,db,new cljs.core.Keyword(null,"select","select",1147833503).cljs$core$IFn$_invoke$arity$1(v_STAR___$1)))):cljs.core.assoc.call(null,acc_STAR___$2,k_STAR___$1,v_STAR___$1));
var G__96397 = r_STAR___$1;
var G__96398 = acc_STAR__STAR_;
G__96376__$1 = G__96397;
acc_STAR___$1 = G__96398;
continue;
}
break;
}
})();
var acc_SINGLEQUOTE_ = cljs.core.assoc.call(null,acc__$2,k__$1,v_SINGLEQUOTE__SINGLEQUOTE_);
var G__96399 = r__$1;
var G__96400 = acc_SINGLEQUOTE_;
G__96276__$1 = G__96399;
acc__$1 = G__96400;
continue;
}
break;
}
});
fluree.db.query.fql_parser.select_cache = cljs.core.atom.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"version","version",425292698),(0)], null));
fluree.db.query.fql_parser.reset_select_cache_BANG_ = (function fluree$db$query$fql_parser$reset_select_cache_BANG_(){
return cljs.core.reset_BANG_.call(null,fluree.db.query.fql_parser.select_cache,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"version","version",425292698),(0)], null));
});
/**
 * Parses, but leverages a specific db to convert predicate
 * names that it can into more complete select statement maps.
 * 
 * Caches results based on database version.
 */
fluree.db.query.fql_parser.parse_db = (function fluree$db$query$fql_parser$parse_db(db,select,opts){
var schema_version = fluree.db.query.schema.version.call(null,db);
if((schema_version < new cljs.core.Keyword(null,"version","version",425292698).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,fluree.db.query.fql_parser.select_cache)))){
cljs.core.reset_BANG_.call(null,fluree.db.query.fql_parser.select_cache,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"version","version",425292698),schema_version], null));
} else {
}

var or__4131__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,fluree.db.query.fql_parser.select_cache),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema_version,select,opts], null));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var select_smt = fluree.db.query.fql_parser.parse.call(null,select,opts);
var select_smt_STAR_ = cljs.core.assoc.call(null,select_smt,new cljs.core.Keyword(null,"select","select",1147833503),fluree.db.query.fql_parser.parse_db_STAR_.call(null,db,new cljs.core.Keyword(null,"select","select",1147833503).cljs$core$IFn$_invoke$arity$1(select_smt)));
cljs.core.swap_BANG_.call(null,fluree.db.query.fql_parser.select_cache,cljs.core.assoc,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [schema_version,select,opts], null),select_smt_STAR_);

return select_smt_STAR_;
}
});
