// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.util.xhttp');
goog.require('cljs.core');
goog.require('goog.net.XhrIo');
goog.require('fluree.db.util.json');
goog.require('fluree.db.util.log');
goog.require('cljs.core.async');
goog.require('fluree.db.util.core');
fluree.db.util.xhttp.format_error_response = (function fluree$db$util$xhttp$format_error_response(url,e){
var status = (function (){var temp__5735__auto__ = e.getStatus();
if(cljs.core.truth_(temp__5735__auto__)){
var st = temp__5735__auto__;
if((st > (0))){
return st;
} else {
return null;
}
} else {
return null;
}
})();
var error = (function (){var pred__88368 = cljs.core._EQ_;
var expr__88369 = e.getLastErrorCode();
if(cljs.core.truth_(pred__88368.call(null,goog.net.ErrorCode.NO_ERROR,expr__88369))){
return new cljs.core.Keyword("xhttp","no-error","xhttp/no-error",1902047248);
} else {
if(cljs.core.truth_(pred__88368.call(null,goog.net.ErrorCode.EXCEPTION,expr__88369))){
return new cljs.core.Keyword("xhttp","exception","xhttp/exception",1363682040);
} else {
if(cljs.core.truth_(pred__88368.call(null,goog.net.ErrorCode.HTTP_ERROR,expr__88369))){
return new cljs.core.Keyword("xhttp","http-error","xhttp/http-error",-960604305);
} else {
if(cljs.core.truth_(pred__88368.call(null,goog.net.ErrorCode.ABORT,expr__88369))){
return new cljs.core.Keyword("xhttp","abort","xhttp/abort",666776046);
} else {
if(cljs.core.truth_(pred__88368.call(null,goog.net.ErrorCode.TIMEOUT,expr__88369))){
return new cljs.core.Keyword("xhttp","timeout","xhttp/timeout",357433562);
} else {
return new cljs.core.Keyword("xhttp","unknown-error","xhttp/unknown-error",693274399);
}
}
}
}
}
})();
var message = ["xhttp error - ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(url),(cljs.core.truth_((function (){var and__4120__auto__ = status;
if(cljs.core.truth_(and__4120__auto__)){
return (status > (0));
} else {
return and__4120__auto__;
}
})())?[": ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(status)].join(''):"")].join('');
return cljs.core.ex_info.call(null,message,(function (){var G__88371 = new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"url","url",276297046),url,new cljs.core.Keyword(null,"error","error",-978969032),error], null);
if(cljs.core.truth_(status)){
return cljs.core.assoc.call(null,G__88371,new cljs.core.Keyword(null,"status","status",-1997798413),status);
} else {
return G__88371;
}
})());
});
/**
 * Posts JSON content.
 *   opts is a map with following optional keys:
 *   :request-timeout - how many milliseconds until we throw an exception without a response (default 5000)
 */
fluree.db.util.xhttp.post_json = (function fluree$db$util$xhttp$post_json(url,message,opts){
var map__88372 = opts;
var map__88372__$1 = (((((!((map__88372 == null))))?(((((map__88372.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__88372.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__88372):map__88372);
var request_timeout = cljs.core.get.call(null,map__88372__$1,new cljs.core.Keyword(null,"request-timeout","request-timeout",-2047539823),(5000));
var token = cljs.core.get.call(null,map__88372__$1,new cljs.core.Keyword(null,"token","token",-1211463215));
var headers = cljs.core.get.call(null,map__88372__$1,new cljs.core.Keyword(null,"headers","headers",-835030129));
var response_chan = cljs.core.async.chan.call(null);
var headers__$1 = (function (){var G__88374 = new cljs.core.PersistentArrayMap(null, 1, ["Content-Type","application/json"], null);
var G__88374__$1 = (cljs.core.truth_(headers)?cljs.core.merge.call(null,G__88374,headers):G__88374);
if(cljs.core.truth_(token)){
return cljs.core.assoc.call(null,G__88374__$1,"Authorization",["Bearer ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(token)].join(''));
} else {
return G__88374__$1;
}
})();
try{goog.net.XhrIo.send(url,((function (map__88372,map__88372__$1,request_timeout,token,headers,response_chan,headers__$1){
return (function (event){
var xhr = event.target;
var success_QMARK_ = xhr.isSuccess();
if(cljs.core.truth_(success_QMARK_)){
return cljs.core.async.put_BANG_.call(null,response_chan,cljs.core.js__GT_clj.call(null,xhr.getResponseJson(),new cljs.core.Keyword(null,"keywordize-keys","keywordize-keys",1310784252),true));
} else {
return cljs.core.async.put_BANG_.call(null,response_chan,fluree.db.util.xhttp.format_error_response.call(null,url,xhr));
}
});})(map__88372,map__88372__$1,request_timeout,token,headers,response_chan,headers__$1))
,"POST",fluree.db.util.json.stringify.call(null,message),cljs.core.clj__GT_js.call(null,headers__$1),request_timeout);
}catch (e88375){var e_88376 = e88375;
fluree.db.util.log.warn.call(null,"CAUGHT ERROR!");

cljs.core.async.put_BANG_.call(null,response_chan,e_88376);
}
return response_chan;
});
/**
 * Returns result body as a string, or an exception.
 * 
 *   If opts contains :body,
 *   It is assumed body is already in a format that can be sent directly in request (already encoded).
 * 
 *   Options
 *   - output-format - can be :text, :json or :binary (default text), or special format (wikidata) to handle wikidata errors, which come back as html.
 * 
 *   
 */
fluree.db.util.xhttp.get = (function fluree$db$util$xhttp$get(url,opts){
var map__88377 = opts;
var map__88377__$1 = (((((!((map__88377 == null))))?(((((map__88377.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__88377.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__88377):map__88377);
var request_timeout = cljs.core.get.call(null,map__88377__$1,new cljs.core.Keyword(null,"request-timeout","request-timeout",-2047539823),(5000));
var token = cljs.core.get.call(null,map__88377__$1,new cljs.core.Keyword(null,"token","token",-1211463215));
var headers = cljs.core.get.call(null,map__88377__$1,new cljs.core.Keyword(null,"headers","headers",-835030129));
var body = cljs.core.get.call(null,map__88377__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var output_format = cljs.core.get.call(null,map__88377__$1,new cljs.core.Keyword(null,"output-format","output-format",-1826382676),new cljs.core.Keyword(null,"text","text",-1790561697));
var response_chan = cljs.core.async.chan.call(null);
var headers__$1 = (function (){var G__88379 = cljs.core.PersistentArrayMap.EMPTY;
var G__88379__$1 = (cljs.core.truth_(headers)?cljs.core.merge.call(null,G__88379,headers):G__88379);
if(cljs.core.truth_(token)){
return cljs.core.assoc.call(null,G__88379__$1,"Authorization",["Bearer ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(token)].join(''));
} else {
return G__88379__$1;
}
})();
try{goog.net.XhrIo.send(url,((function (map__88377,map__88377__$1,request_timeout,token,headers,body,output_format,response_chan,headers__$1){
return (function (event){
var xhr = event.target;
var success_QMARK_ = xhr.isSuccess();
if(cljs.core.truth_(success_QMARK_)){
return cljs.core.async.put_BANG_.call(null,response_chan,(function (){var G__88381 = output_format;
var G__88381__$1 = (((G__88381 instanceof cljs.core.Keyword))?G__88381.fqn:null);
switch (G__88381__$1) {
case "text":
return xhr.getResponseText();

break;
case "json":
return xhr.getResponseJson();

break;
default:
throw cljs.core.ex_info.call(null,"http get only supports output formats of json and text for now.",cljs.core.PersistentArrayMap.EMPTY);

}
})());
} else {
return cljs.core.async.put_BANG_.call(null,response_chan,fluree.db.util.xhttp.format_error_response.call(null,url,xhr));
}
});})(map__88377,map__88377__$1,request_timeout,token,headers,body,output_format,response_chan,headers__$1))
,"GET",body,cljs.core.clj__GT_js.call(null,headers__$1),request_timeout);
}catch (e88380){var e_88383 = e88380;
fluree.db.util.log.warn.call(null,"CAUUGHT ERROR!");

cljs.core.async.put_BANG_.call(null,response_chan,e_88383);
}
return response_chan;
});
/**
 * http get with JSON response.
 * 
 *   If opts contains :body key, it is encoded into JSON and sent as part
 *   of the body.
 */
fluree.db.util.xhttp.get_json = (function fluree$db$util$xhttp$get_json(url,opts){
var opts_STAR_ = (function (){var G__88384 = cljs.core.assoc.call(null,cljs.core.assoc_in.call(null,opts,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"headers","headers",-835030129),"Accept"], null),"application/json"),new cljs.core.Keyword(null,"output-format","output-format",-1826382676),new cljs.core.Keyword(null,"json","json",1279968570));
if(cljs.core.truth_(new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(opts))){
return cljs.core.assoc.call(null,G__88384,new cljs.core.Keyword(null,"body","body",-2049205669),fluree.db.util.json.stringify.call(null,new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(opts)));
} else {
return G__88384;
}
})();
return fluree.db.util.xhttp.get.call(null,url,opts_STAR_);
});
/**
 * Sends messages across web socket. Sends never block and will immediately queue.
 *   Message to send should be a two-tuple placed on the pub-chan, of:
 *  [msg resp-chan]
 *   where a true/false response will eventually be placed on the resp-chan if the send
 *   is successful.
 */
fluree.db.util.xhttp.socket_publish_loop = (function fluree$db$util$xhttp$socket_publish_loop(ws,pub_chan){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_88414){
var state_val_88415 = (state_88414[(1)]);
if((state_val_88415 === (7))){
var inst_88410 = (state_88414[(2)]);
var state_88414__$1 = state_88414;
var statearr_88416_88434 = state_88414__$1;
(statearr_88416_88434[(2)] = inst_88410);

(statearr_88416_88434[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88415 === (1))){
var state_88414__$1 = state_88414;
var statearr_88417_88435 = state_88414__$1;
(statearr_88417_88435[(2)] = null);

(statearr_88417_88435[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88415 === (4))){
var inst_88388 = (state_88414[(7)]);
var inst_88388__$1 = (state_88414[(2)]);
var inst_88389 = (inst_88388__$1 == null);
var state_88414__$1 = (function (){var statearr_88418 = state_88414;
(statearr_88418[(7)] = inst_88388__$1);

return statearr_88418;
})();
if(cljs.core.truth_(inst_88389)){
var statearr_88419_88436 = state_88414__$1;
(statearr_88419_88436[(1)] = (5));

} else {
var statearr_88420_88437 = state_88414__$1;
(statearr_88420_88437[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88415 === (6))){
var inst_88388 = (state_88414[(7)]);
var inst_88396 = cljs.core.nth.call(null,inst_88388,(0),null);
var inst_88397 = cljs.core.nth.call(null,inst_88388,(1),null);
var state_88414__$1 = (function (){var statearr_88421 = state_88414;
(statearr_88421[(8)] = inst_88397);

(statearr_88421[(9)] = inst_88396);

return statearr_88421;
})();
var statearr_88422_88438 = state_88414__$1;
(statearr_88422_88438[(2)] = null);

(statearr_88422_88438[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88415 === (3))){
var inst_88412 = (state_88414[(2)]);
var state_88414__$1 = state_88414;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_88414__$1,inst_88412);
} else {
if((state_val_88415 === (2))){
var state_88414__$1 = state_88414;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_88414__$1,(4),pub_chan);
} else {
if((state_val_88415 === (9))){
var inst_88397 = (state_88414[(8)]);
var inst_88398 = (state_88414[(2)]);
var inst_88399 = fluree.db.util.log.error.call(null,inst_88398,"Websocket send message error:",inst_88398);
var inst_88400 = cljs.core.async.put_BANG_.call(null,inst_88397,false);
var state_88414__$1 = (function (){var statearr_88423 = state_88414;
(statearr_88423[(10)] = inst_88399);

return statearr_88423;
})();
var statearr_88424_88439 = state_88414__$1;
(statearr_88424_88439[(2)] = inst_88400);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88414__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88415 === (5))){
var inst_88391 = fluree.db.util.log.info.call(null,"Web socket pub/producer channel closed.");
var state_88414__$1 = state_88414;
var statearr_88425_88440 = state_88414__$1;
(statearr_88425_88440[(2)] = inst_88391);

(statearr_88425_88440[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88415 === (10))){
var inst_88397 = (state_88414[(8)]);
var inst_88396 = (state_88414[(9)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_88414,(9),Error,null,(8));
var inst_88404 = ws.send(inst_88396);
var inst_88405 = cljs.core.async.put_BANG_.call(null,inst_88397,true);
var state_88414__$1 = (function (){var statearr_88426 = state_88414;
(statearr_88426[(11)] = inst_88404);

return statearr_88426;
})();
var statearr_88427_88441 = state_88414__$1;
(statearr_88427_88441[(2)] = inst_88405);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88414__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88415 === (8))){
var inst_88407 = (state_88414[(2)]);
var state_88414__$1 = (function (){var statearr_88428 = state_88414;
(statearr_88428[(12)] = inst_88407);

return statearr_88428;
})();
var statearr_88429_88442 = state_88414__$1;
(statearr_88429_88442[(2)] = null);

(statearr_88429_88442[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto__ = null;
var fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto____0 = (function (){
var statearr_88430 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_88430[(0)] = fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto__);

(statearr_88430[(1)] = (1));

return statearr_88430;
});
var fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto____1 = (function (state_88414){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_88414);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e88431){if((e88431 instanceof Object)){
var ex__86628__auto__ = e88431;
var statearr_88432_88443 = state_88414;
(statearr_88432_88443[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88414);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e88431;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__88444 = state_88414;
state_88414 = G__88444;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto__ = function(state_88414){
switch(arguments.length){
case 0:
return fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto____1.call(this,state_88414);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto____0;
fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto____1;
return fluree$db$util$xhttp$socket_publish_loop_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_88433 = f__86676__auto__.call(null);
(statearr_88433[(6)] = c__86675__auto__);

return statearr_88433;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.util.xhttp.close_websocket = (function fluree$db$util$xhttp$close_websocket(ws){
return ws.close();
});
fluree.db.util.xhttp.try_socket = (function fluree$db$util$xhttp$try_socket(url,sub_chan,pub_chan,resp_chan,timeout,close_fn){
var ws = (new WebSocket(url));
var open_QMARK_ = cljs.core.async.promise_chan.call(null);
var timeout_chan = cljs.core.async.timeout.call(null,timeout);
ws.binaryType = "arraybuffer";

ws.onopen = ((function (ws,open_QMARK_,timeout_chan){
return (function (){
return cljs.core.async.put_BANG_.call(null,open_QMARK_,true);
});})(ws,open_QMARK_,timeout_chan))
;

ws.onmessage = ((function (ws,open_QMARK_,timeout_chan){
return (function (e){
return cljs.core.async.put_BANG_.call(null,sub_chan,e.data);
});})(ws,open_QMARK_,timeout_chan))
;

ws.onclose = ((function (ws,open_QMARK_,timeout_chan){
return (function (e){
fluree.db.util.log.warn.call(null,"Websocket closed: ",e.reason,"Code: ",e.code);

return close_fn.call(null);
});})(ws,open_QMARK_,timeout_chan))
;

var c__86675__auto___88482 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___88482,ws,open_QMARK_,timeout_chan){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___88482,ws,open_QMARK_,timeout_chan){
return (function (state_88470){
var state_val_88471 = (state_88470[(1)]);
if((state_val_88471 === (1))){
var inst_88449 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_88450 = [open_QMARK_,timeout_chan];
var inst_88451 = (new cljs.core.PersistentVector(null,2,(5),inst_88449,inst_88450,null));
var state_88470__$1 = state_88470;
return cljs.core.async.ioc_alts_BANG_.call(null,state_88470__$1,(2),inst_88451,new cljs.core.Keyword(null,"priority","priority",1431093715),true);
} else {
if((state_val_88471 === (2))){
var inst_88453 = (state_88470[(2)]);
var inst_88454 = cljs.core.nth.call(null,inst_88453,(0),null);
var inst_88455 = cljs.core.nth.call(null,inst_88453,(1),null);
var inst_88456 = cljs.core._EQ_.call(null,inst_88455,timeout_chan);
var state_88470__$1 = (function (){var statearr_88472 = state_88470;
(statearr_88472[(7)] = inst_88454);

return statearr_88472;
})();
if(inst_88456){
var statearr_88473_88483 = state_88470__$1;
(statearr_88473_88483[(1)] = (3));

} else {
var statearr_88474_88484 = state_88470__$1;
(statearr_88474_88484[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88471 === (3))){
var inst_88458 = ["Timeout reached, unable to establish communication to server, which responded healthy: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(url)].join('');
var inst_88459 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_88460 = [(400),new cljs.core.Keyword("db","connection-error","db/connection-error",-707380971)];
var inst_88461 = cljs.core.PersistentHashMap.fromArrays(inst_88459,inst_88460);
var inst_88462 = cljs.core.ex_info.call(null,inst_88458,inst_88461);
var inst_88463 = cljs.core.async.put_BANG_.call(null,resp_chan,inst_88462);
var inst_88464 = fluree.db.util.xhttp.close_websocket.call(null,ws);
var state_88470__$1 = (function (){var statearr_88475 = state_88470;
(statearr_88475[(8)] = inst_88463);

return statearr_88475;
})();
var statearr_88476_88485 = state_88470__$1;
(statearr_88476_88485[(2)] = inst_88464);

(statearr_88476_88485[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88471 === (4))){
var inst_88466 = fluree.db.util.xhttp.socket_publish_loop.call(null,ws,pub_chan);
var state_88470__$1 = state_88470;
var statearr_88477_88486 = state_88470__$1;
(statearr_88477_88486[(2)] = inst_88466);

(statearr_88477_88486[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88471 === (5))){
var inst_88468 = (state_88470[(2)]);
var state_88470__$1 = state_88470;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_88470__$1,inst_88468);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto___88482,ws,open_QMARK_,timeout_chan))
;
return ((function (switch__86624__auto__,c__86675__auto___88482,ws,open_QMARK_,timeout_chan){
return (function() {
var fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto__ = null;
var fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto____0 = (function (){
var statearr_88478 = [null,null,null,null,null,null,null,null,null];
(statearr_88478[(0)] = fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto__);

(statearr_88478[(1)] = (1));

return statearr_88478;
});
var fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto____1 = (function (state_88470){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_88470);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e88479){if((e88479 instanceof Object)){
var ex__86628__auto__ = e88479;
var statearr_88480_88487 = state_88470;
(statearr_88480_88487[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88470);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e88479;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__88488 = state_88470;
state_88470 = G__88488;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto__ = function(state_88470){
switch(arguments.length){
case 0:
return fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto____1.call(this,state_88470);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto____0;
fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto____1;
return fluree$db$util$xhttp$try_socket_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___88482,ws,open_QMARK_,timeout_chan))
})();
var state__86677__auto__ = (function (){var statearr_88481 = f__86676__auto__.call(null);
(statearr_88481[(6)] = c__86675__auto___88482);

return statearr_88481;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___88482,ws,open_QMARK_,timeout_chan))
);


return new cljs.core.Keyword("fluree.db.util.xhttp","no-return","fluree.db.util.xhttp/no-return",1591333002);
});
