// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('shared.connection_handler');
goog.require('cljs.core');
goog.require('cljs.core.async');
goog.require('alphabase.core');
goog.require('fluree.db.connection');
goog.require('fluree.db.session');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.log');
goog.require('fluree.db.token_auth');
/**
 * Verifies that the jwt token has not expired.
 * 
 *   Only returns when token is valid.  Otherwise, an exception is thrown.
 */
shared.connection_handler.validate_token = (function shared$connection_handler$validate_token(conn,jwt){
var secret = alphabase.core.base_to_byte_array.call(null,new cljs.core.Keyword(null,"jwt-secret","jwt-secret",-356972172).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018).cljs$core$IFn$_invoke$arity$1(conn))),new cljs.core.Keyword(null,"hex","hex",41691346));
return fluree.db.token_auth.verify_jwt.call(null,secret,jwt);
});
/**
 * Connect to a ledger server using URL address. If using a ledger group, multiple addresses can be
 * supplied, separated by commas.
 */
shared.connection_handler.connect = (function shared$connection_handler$connect(var_args){
var G__110030 = arguments.length;
switch (G__110030) {
case 1:
return shared.connection_handler.connect.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shared.connection_handler.connect.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.connection_handler.connect.cljs$core$IFn$_invoke$arity$1 = (function (servers_string){
return shared.connection_handler.connect.call(null,servers_string,null);
});

shared.connection_handler.connect.cljs$core$IFn$_invoke$arity$2 = (function (servers_string,opts){
var conn = cljs.core.assoc_in.call(null,fluree.db.connection.connect.call(null,servers_string,opts),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018)], null),cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY));
var pc = cljs.core.async.promise_chan.call(null);
var _ = (function (){var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,conn,pc){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,conn,pc){
return (function (state_110039){
var state_val_110040 = (state_110039[(1)]);
if((state_val_110040 === (1))){
var inst_110031 = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(conn);
var inst_110032 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_110033 = [new cljs.core.Keyword(null,"settings","settings",1556144875),null,pc,null];
var inst_110034 = (new cljs.core.PersistentVector(null,4,(5),inst_110032,inst_110033,null));
var inst_110035 = cljs.core.async.put_BANG_.call(null,inst_110031,inst_110034);
var inst_110036 = (function (){return ((function (inst_110031,inst_110032,inst_110033,inst_110034,inst_110035,state_val_110040,c__86675__auto__,conn,pc){
return (function (x){
if((x == null)){
return null;
} else {
var seq__110041 = cljs.core.seq.call(null,cljs.core.keys.call(null,x));
var chunk__110042 = null;
var count__110043 = (0);
var i__110044 = (0);
while(true){
if((i__110044 < count__110043)){
var k = cljs.core._nth.call(null,chunk__110042,i__110044);
cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018).cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [k], null),cljs.core.get.call(null,x,k,null));


var G__110051 = seq__110041;
var G__110052 = chunk__110042;
var G__110053 = count__110043;
var G__110054 = (i__110044 + (1));
seq__110041 = G__110051;
chunk__110042 = G__110052;
count__110043 = G__110053;
i__110044 = G__110054;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq.call(null,seq__110041);
if(temp__5735__auto__){
var seq__110041__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__110041__$1)){
var c__4550__auto__ = cljs.core.chunk_first.call(null,seq__110041__$1);
var G__110055 = cljs.core.chunk_rest.call(null,seq__110041__$1);
var G__110056 = c__4550__auto__;
var G__110057 = cljs.core.count.call(null,c__4550__auto__);
var G__110058 = (0);
seq__110041 = G__110055;
chunk__110042 = G__110056;
count__110043 = G__110057;
i__110044 = G__110058;
continue;
} else {
var k = cljs.core.first.call(null,seq__110041__$1);
cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018).cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [k], null),cljs.core.get.call(null,x,k,null));


var G__110059 = cljs.core.next.call(null,seq__110041__$1);
var G__110060 = null;
var G__110061 = (0);
var G__110062 = (0);
seq__110041 = G__110059;
chunk__110042 = G__110060;
count__110043 = G__110061;
i__110044 = G__110062;
continue;
}
} else {
return null;
}
}
break;
}
}
});
;})(inst_110031,inst_110032,inst_110033,inst_110034,inst_110035,state_val_110040,c__86675__auto__,conn,pc))
})();
var inst_110037 = cljs.core.async.take_BANG_.call(null,pc,inst_110036);
var state_110039__$1 = (function (){var statearr_110045 = state_110039;
(statearr_110045[(7)] = inst_110035);

return statearr_110045;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_110039__$1,inst_110037);
} else {
return null;
}
});})(c__86675__auto__,conn,pc))
;
return ((function (switch__86624__auto__,c__86675__auto__,conn,pc){
return (function() {
var shared$connection_handler$state_machine__86625__auto__ = null;
var shared$connection_handler$state_machine__86625__auto____0 = (function (){
var statearr_110046 = [null,null,null,null,null,null,null,null];
(statearr_110046[(0)] = shared$connection_handler$state_machine__86625__auto__);

(statearr_110046[(1)] = (1));

return statearr_110046;
});
var shared$connection_handler$state_machine__86625__auto____1 = (function (state_110039){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_110039);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e110047){if((e110047 instanceof Object)){
var ex__86628__auto__ = e110047;
var statearr_110048_110063 = state_110039;
(statearr_110048_110063[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110039);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e110047;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__110064 = state_110039;
state_110039 = G__110064;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
shared$connection_handler$state_machine__86625__auto__ = function(state_110039){
switch(arguments.length){
case 0:
return shared$connection_handler$state_machine__86625__auto____0.call(this);
case 1:
return shared$connection_handler$state_machine__86625__auto____1.call(this,state_110039);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$connection_handler$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = shared$connection_handler$state_machine__86625__auto____0;
shared$connection_handler$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = shared$connection_handler$state_machine__86625__auto____1;
return shared$connection_handler$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,conn,pc))
})();
var state__86677__auto__ = (function (){var statearr_110049 = f__86676__auto__.call(null);
(statearr_110049[(6)] = c__86675__auto__);

return statearr_110049;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,conn,pc))
);

return c__86675__auto__;
})();
return conn;
});

shared.connection_handler.connect.cljs$lang$maxFixedArity = 2;

/**
 * Connect to a ledger server using URL address. If using a ledger group, multiple addresses can be
 * supplied, separated by commas.
 * 
 * Returns a promise that eventually contains the connection object.
 */
shared.connection_handler.connect_p = (function shared$connection_handler$connect_p(var_args){
var G__110066 = arguments.length;
switch (G__110066) {
case 1:
return shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$1 = (function (servers_string){
return shared.connection_handler.connect_p.call(null,servers_string,null);
});

shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$2 = (function (servers_string,opts){
return (new Promise((function (resolve,reject){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_110091){
var state_val_110092 = (state_110091[(1)]);
if((state_val_110092 === (1))){
var state_110091__$1 = state_110091;
var statearr_110093_110107 = state_110091__$1;
(statearr_110093_110107[(2)] = null);

(statearr_110093_110107[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110092 === (2))){
var inst_110089 = (state_110091[(2)]);
var state_110091__$1 = state_110091;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_110091__$1,inst_110089);
} else {
if((state_val_110092 === (3))){
var inst_110067 = (state_110091[(2)]);
var inst_110068 = fluree.db.util.log.error.call(null,inst_110067);
var inst_110069 = reject.call(null,inst_110067);
var state_110091__$1 = (function (){var statearr_110094 = state_110091;
(statearr_110094[(7)] = inst_110068);

return statearr_110094;
})();
var statearr_110095_110108 = state_110091__$1;
(statearr_110095_110108[(2)] = inst_110069);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110091__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110092 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_110091,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_110073 = fluree.db.connection.connect.call(null,servers_string,opts);
var inst_110074 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_110075 = [new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018)];
var inst_110076 = (new cljs.core.PersistentVector(null,1,(5),inst_110074,inst_110075,null));
var inst_110077 = cljs.core.PersistentHashMap.EMPTY;
var inst_110078 = cljs.core.atom.call(null,inst_110077);
var inst_110079 = cljs.core.assoc_in.call(null,inst_110073,inst_110076,inst_110078);
var inst_110080 = cljs.core.async.promise_chan.call(null);
var inst_110081 = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(inst_110079);
var inst_110082 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_110083 = [new cljs.core.Keyword(null,"settings","settings",1556144875),null,inst_110080,null];
var inst_110084 = (new cljs.core.PersistentVector(null,4,(5),inst_110082,inst_110083,null));
var inst_110085 = cljs.core.async.put_BANG_.call(null,inst_110081,inst_110084);
var inst_110086 = (function (){var conn = inst_110079;
var pc = inst_110080;
return ((function (conn,pc,_,inst_110073,inst_110074,inst_110075,inst_110076,inst_110077,inst_110078,inst_110079,inst_110080,inst_110081,inst_110082,inst_110083,inst_110084,inst_110085,state_val_110092,c__86675__auto__){
return (function (x){
if((x == null)){
} else {
var seq__110096_110109 = cljs.core.seq.call(null,cljs.core.keys.call(null,x));
var chunk__110097_110110 = null;
var count__110098_110111 = (0);
var i__110099_110112 = (0);
while(true){
if((i__110099_110112 < count__110098_110111)){
var k_110113 = cljs.core._nth.call(null,chunk__110097_110110,i__110099_110112);
cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018).cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [k_110113], null),cljs.core.get.call(null,x,k_110113,null));


var G__110114 = seq__110096_110109;
var G__110115 = chunk__110097_110110;
var G__110116 = count__110098_110111;
var G__110117 = (i__110099_110112 + (1));
seq__110096_110109 = G__110114;
chunk__110097_110110 = G__110115;
count__110098_110111 = G__110116;
i__110099_110112 = G__110117;
continue;
} else {
var temp__5735__auto___110118 = cljs.core.seq.call(null,seq__110096_110109);
if(temp__5735__auto___110118){
var seq__110096_110119__$1 = temp__5735__auto___110118;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__110096_110119__$1)){
var c__4550__auto___110120 = cljs.core.chunk_first.call(null,seq__110096_110119__$1);
var G__110121 = cljs.core.chunk_rest.call(null,seq__110096_110119__$1);
var G__110122 = c__4550__auto___110120;
var G__110123 = cljs.core.count.call(null,c__4550__auto___110120);
var G__110124 = (0);
seq__110096_110109 = G__110121;
chunk__110097_110110 = G__110122;
count__110098_110111 = G__110123;
i__110099_110112 = G__110124;
continue;
} else {
var k_110125 = cljs.core.first.call(null,seq__110096_110119__$1);
cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018).cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [k_110125], null),cljs.core.get.call(null,x,k_110125,null));


var G__110126 = cljs.core.next.call(null,seq__110096_110119__$1);
var G__110127 = null;
var G__110128 = (0);
var G__110129 = (0);
seq__110096_110109 = G__110126;
chunk__110097_110110 = G__110127;
count__110098_110111 = G__110128;
i__110099_110112 = G__110129;
continue;
}
} else {
}
}
break;
}
}

return resolve.call(null,conn);
});
;})(conn,pc,_,inst_110073,inst_110074,inst_110075,inst_110076,inst_110077,inst_110078,inst_110079,inst_110080,inst_110081,inst_110082,inst_110083,inst_110084,inst_110085,state_val_110092,c__86675__auto__))
})();
var inst_110087 = cljs.core.async.take_BANG_.call(null,inst_110080,inst_110086);
var state_110091__$1 = (function (){var statearr_110100 = state_110091;
(statearr_110100[(8)] = inst_110085);

return statearr_110100;
})();
var statearr_110101_110130 = state_110091__$1;
(statearr_110101_110130[(2)] = inst_110087);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110091__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var shared$connection_handler$state_machine__86625__auto__ = null;
var shared$connection_handler$state_machine__86625__auto____0 = (function (){
var statearr_110102 = [null,null,null,null,null,null,null,null,null];
(statearr_110102[(0)] = shared$connection_handler$state_machine__86625__auto__);

(statearr_110102[(1)] = (1));

return statearr_110102;
});
var shared$connection_handler$state_machine__86625__auto____1 = (function (state_110091){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_110091);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e110103){if((e110103 instanceof Object)){
var ex__86628__auto__ = e110103;
var statearr_110104_110131 = state_110091;
(statearr_110104_110131[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110091);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e110103;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__110132 = state_110091;
state_110091 = G__110132;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
shared$connection_handler$state_machine__86625__auto__ = function(state_110091){
switch(arguments.length){
case 0:
return shared$connection_handler$state_machine__86625__auto____0.call(this);
case 1:
return shared$connection_handler$state_machine__86625__auto____1.call(this,state_110091);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$connection_handler$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = shared$connection_handler$state_machine__86625__auto____0;
shared$connection_handler$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = shared$connection_handler$state_machine__86625__auto____1;
return shared$connection_handler$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_110105 = f__86676__auto__.call(null);
(statearr_110105[(6)] = c__86675__auto__);

return statearr_110105;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
})));
});

shared.connection_handler.connect_p.cljs$lang$maxFixedArity = 2;

/**
 * Closes a connection
 */
shared.connection_handler.close = (function shared$connection_handler$close(conn){
return fluree.db.connection.close_BANG_.call(null,conn);
});
/**
 * Returns open-api? setting from connection object
 */
shared.connection_handler.open_api_QMARK_ = (function shared$connection_handler$open_api_QMARK_(conn){
return new cljs.core.Keyword(null,"open-api?","open-api?",-789180347).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018).cljs$core$IFn$_invoke$arity$1(conn)));
});
/**
 * Returns true when the connection is properly configured to access the server.
 *   If jwt tokens are used; will also verify that the token has not expired.
 *   Otherwise, throws an error.
 */
shared.connection_handler.check_connection = (function shared$connection_handler$check_connection(var_args){
var G__110134 = arguments.length;
switch (G__110134) {
case 1:
return shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$1 = (function (conn){
return shared.connection_handler.check_connection.call(null,conn,null);
});

shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2 = (function (conn,opts){
var open_api_QMARK_ = new cljs.core.Keyword(null,"open-api?","open-api?",-789180347).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018).cljs$core$IFn$_invoke$arity$1(conn)));
var token = new cljs.core.Keyword(null,"jwt","jwt",1504015441).cljs$core$IFn$_invoke$arity$1(opts);
var has_auth_QMARK_ = (function (){var or__4131__auto__ = new cljs.core.Keyword(null,"auth","auth",1389754926).cljs$core$IFn$_invoke$arity$1(opts);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var or__4131__auto____$1 = new cljs.core.Keyword(null,"auth-id","auth-id",444160740).cljs$core$IFn$_invoke$arity$1(opts);
if(cljs.core.truth_(or__4131__auto____$1)){
return or__4131__auto____$1;
} else {
return token;
}
}
})();
var _ = ((((cljs.core.not.call(null,open_api_QMARK_)) && (cljs.core.not.call(null,has_auth_QMARK_))))?(function(){throw cljs.core.ex_info.call(null,"To access the server, either open-api must be true or a valid auth must be available.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(401),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)], null))})():null);
var ___$1 = (cljs.core.truth_(token)?shared.connection_handler.validate_token.call(null,conn,token):null);
return true;
});

shared.connection_handler.check_connection.cljs$lang$maxFixedArity = 2;

/**
 * Listens to all events of a given ledger. Supply a ledger identity,
 *   any key, and a two-argument function that will be called with each event.
 * 
 *   The key is any arbitrary key, and is only used to close the listener via close-listener,
 *   otherwise it is opaque to the listener.
 * 
 *   The callback function's first argument is the event header/metadata and the second argument
 *   is the event data itself.
 */
shared.connection_handler.listen = (function shared$connection_handler$listen(conn,ledger,key,callback){
var vec__110136 = fluree.db.session.resolve_ledger.call(null,conn,ledger);
var network = cljs.core.nth.call(null,vec__110136,(0),null);
var ledger_id = cljs.core.nth.call(null,vec__110136,(1),null);
var cb_STAR_ = ((function (vec__110136,network,ledger_id){
return (function (header,data){
return callback.call(null,cljs.core.clj__GT_js.call(null,header),cljs.core.clj__GT_js.call(null,data));
});})(vec__110136,network,ledger_id))
;
return fluree.db.connection.add_listener.call(null,conn,network,ledger_id,key,cb_STAR_);
});
/**
 * Closes a listener.
 */
shared.connection_handler.close_listener = (function shared$connection_handler$close_listener(conn,ledger,key){
var vec__110139 = fluree.db.session.resolve_ledger.call(null,conn,ledger);
var network = cljs.core.nth.call(null,vec__110139,(0),null);
var ledger_id = cljs.core.nth.call(null,vec__110139,(1),null);
return fluree.db.connection.remove_listener.call(null,conn,network,ledger_id,key);
});
/**
 * Return a list of listeners currently registered for each ledger along with their respective keys.
 */
shared.connection_handler.listeners = (function shared$connection_handler$listeners(conn){
return cljs.core.clj__GT_js.call(null,fluree.db.connection.listeners.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(conn)));
});
/**
 * Returns true when the ledger server/group supports password authentication
 */
shared.connection_handler.password_enabled_QMARK_ = (function shared$connection_handler$password_enabled_QMARK_(conn){
return new cljs.core.Keyword(null,"password-enabled?","password-enabled?",-456274989).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018).cljs$core$IFn$_invoke$arity$1(conn)));
});
/**
 * Generates a password auth record for an existing role, or a user.
 *   The user may exist, or if createUser? is true, the user is created.
 * 
 *   Returns a promise that eventually contains the token or an exception
 */
shared.connection_handler.password_generate = (function shared$connection_handler$password_generate(conn,ledger,password,map_data){
return (new Promise((function (resolve,reject){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_110189){
var state_val_110190 = (state_110189[(1)]);
if((state_val_110190 === (7))){
var inst_110157 = (state_110189[(2)]);
var state_110189__$1 = (function (){var statearr_110191 = state_110189;
(statearr_110191[(7)] = inst_110157);

return statearr_110191;
})();
if(cljs.core.truth_(ledger)){
var statearr_110192_110213 = state_110189__$1;
(statearr_110192_110213[(1)] = (8));

} else {
var statearr_110193_110214 = state_110189__$1;
(statearr_110193_110214[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (1))){
var state_110189__$1 = state_110189;
var statearr_110194_110215 = state_110189__$1;
(statearr_110194_110215[(2)] = null);

(statearr_110194_110215[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_110189,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_110148 = shared.connection_handler.password_enabled_QMARK_.call(null,conn);
var state_110189__$1 = state_110189;
if(cljs.core.truth_(inst_110148)){
var statearr_110195_110216 = state_110189__$1;
(statearr_110195_110216[(1)] = (5));

} else {
var statearr_110196_110217 = state_110189__$1;
(statearr_110196_110217[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (13))){
var inst_110175 = (state_110189[(2)]);
var inst_110176 = cljs.core.assoc.call(null,map_data,new cljs.core.Keyword(null,"ledger","ledger",561720706),ledger,new cljs.core.Keyword(null,"password","password",417022471),password);
var inst_110177 = fluree.db.util.core.without_nils.call(null,inst_110176);
var inst_110178 = cljs.core.async.promise_chan.call(null);
var inst_110179 = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(conn);
var inst_110180 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_110181 = [new cljs.core.Keyword(null,"pw-generate","pw-generate",-1834816603),inst_110177,inst_110178,null];
var inst_110182 = (new cljs.core.PersistentVector(null,4,(5),inst_110180,inst_110181,null));
var inst_110183 = cljs.core.async.put_BANG_.call(null,inst_110179,inst_110182);
var inst_110184 = (function (){var _ = inst_110175;
var data = inst_110177;
var pc = inst_110178;
return ((function (_,data,pc,inst_110175,inst_110176,inst_110177,inst_110178,inst_110179,inst_110180,inst_110181,inst_110182,inst_110183,state_val_110190,c__86675__auto__){
return (function (result){
if(cljs.core.truth_((((result == null))?(function(){throw cljs.core.ex_info.call(null,"The password auth could not be generated.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)], null))})():null))){
if(cljs.core.truth_(new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(result))){
return reject.call(null,cljs.core.clj__GT_js.call(null,result));
} else {
return null;
}
} else {
if((result instanceof cljs.core.ExceptionInfo)){
var err_data = cljs.core.ex_data.call(null,result);
var err_resp = new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"status","status",-1997798413),(function (){var or__4131__auto__ = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (400);
}
})(),new cljs.core.Keyword(null,"message","message",-406056002),cljs.core.ex_message.call(null,result),new cljs.core.Keyword(null,"error","error",-978969032),(function (){var or__4131__auto__ = new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926);
}
})()], null);
return reject.call(null,cljs.core.clj__GT_js.call(null,err_resp));
} else {
return resolve.call(null,cljs.core.clj__GT_js.call(null,result));

}
}
});
;})(_,data,pc,inst_110175,inst_110176,inst_110177,inst_110178,inst_110179,inst_110180,inst_110181,inst_110182,inst_110183,state_val_110190,c__86675__auto__))
})();
var inst_110185 = cljs.core.async.take_BANG_.call(null,inst_110178,inst_110184);
var state_110189__$1 = (function (){var statearr_110197 = state_110189;
(statearr_110197[(8)] = inst_110183);

return statearr_110197;
})();
var statearr_110198_110218 = state_110189__$1;
(statearr_110198_110218[(2)] = inst_110185);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110189__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (6))){
var inst_110151 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_110152 = [(401),new cljs.core.Keyword("db","no-password-auth","db/no-password-auth",1344949614)];
var inst_110153 = cljs.core.PersistentHashMap.fromArrays(inst_110151,inst_110152);
var inst_110154 = cljs.core.ex_info.call(null,"Password authentication is not enabled.",inst_110153);
var inst_110155 = (function(){throw inst_110154})();
var state_110189__$1 = state_110189;
var statearr_110199_110219 = state_110189__$1;
(statearr_110199_110219[(2)] = inst_110155);

(statearr_110199_110219[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (3))){
var inst_110142 = (state_110189[(2)]);
var inst_110143 = cljs.core.clj__GT_js.call(null,inst_110142);
var inst_110144 = reject.call(null,inst_110143);
var state_110189__$1 = state_110189;
var statearr_110200_110220 = state_110189__$1;
(statearr_110200_110220[(2)] = inst_110144);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110189__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (12))){
var inst_110169 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_110170 = [(400),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)];
var inst_110171 = cljs.core.PersistentHashMap.fromArrays(inst_110169,inst_110170);
var inst_110172 = cljs.core.ex_info.call(null,"A password must be supplied.",inst_110171);
var inst_110173 = (function(){throw inst_110172})();
var state_110189__$1 = state_110189;
var statearr_110201_110221 = state_110189__$1;
(statearr_110201_110221[(2)] = inst_110173);

(statearr_110201_110221[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (2))){
var inst_110187 = (state_110189[(2)]);
var state_110189__$1 = state_110189;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_110189__$1,inst_110187);
} else {
if((state_val_110190 === (11))){
var state_110189__$1 = state_110189;
var statearr_110202_110222 = state_110189__$1;
(statearr_110202_110222[(2)] = null);

(statearr_110202_110222[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (9))){
var inst_110160 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_110161 = [(400),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)];
var inst_110162 = cljs.core.PersistentHashMap.fromArrays(inst_110160,inst_110161);
var inst_110163 = cljs.core.ex_info.call(null,"A ledger must be supplied.",inst_110162);
var inst_110164 = (function(){throw inst_110163})();
var state_110189__$1 = state_110189;
var statearr_110203_110223 = state_110189__$1;
(statearr_110203_110223[(2)] = inst_110164);

(statearr_110203_110223[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (5))){
var state_110189__$1 = state_110189;
var statearr_110204_110224 = state_110189__$1;
(statearr_110204_110224[(2)] = null);

(statearr_110204_110224[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (10))){
var inst_110166 = (state_110189[(2)]);
var state_110189__$1 = (function (){var statearr_110205 = state_110189;
(statearr_110205[(9)] = inst_110166);

return statearr_110205;
})();
if(cljs.core.truth_(password)){
var statearr_110206_110225 = state_110189__$1;
(statearr_110206_110225[(1)] = (11));

} else {
var statearr_110207_110226 = state_110189__$1;
(statearr_110207_110226[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110190 === (8))){
var state_110189__$1 = state_110189;
var statearr_110208_110227 = state_110189__$1;
(statearr_110208_110227[(2)] = null);

(statearr_110208_110227[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var shared$connection_handler$password_generate_$_state_machine__86625__auto__ = null;
var shared$connection_handler$password_generate_$_state_machine__86625__auto____0 = (function (){
var statearr_110209 = [null,null,null,null,null,null,null,null,null,null];
(statearr_110209[(0)] = shared$connection_handler$password_generate_$_state_machine__86625__auto__);

(statearr_110209[(1)] = (1));

return statearr_110209;
});
var shared$connection_handler$password_generate_$_state_machine__86625__auto____1 = (function (state_110189){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_110189);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e110210){if((e110210 instanceof Object)){
var ex__86628__auto__ = e110210;
var statearr_110211_110228 = state_110189;
(statearr_110211_110228[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110189);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e110210;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__110229 = state_110189;
state_110189 = G__110229;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
shared$connection_handler$password_generate_$_state_machine__86625__auto__ = function(state_110189){
switch(arguments.length){
case 0:
return shared$connection_handler$password_generate_$_state_machine__86625__auto____0.call(this);
case 1:
return shared$connection_handler$password_generate_$_state_machine__86625__auto____1.call(this,state_110189);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$connection_handler$password_generate_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = shared$connection_handler$password_generate_$_state_machine__86625__auto____0;
shared$connection_handler$password_generate_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = shared$connection_handler$password_generate_$_state_machine__86625__auto____1;
return shared$connection_handler$password_generate_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_110212 = f__86676__auto__.call(null);
(statearr_110212[(6)] = c__86675__auto__);

return statearr_110212;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
})));
});
/**
 * Returns a JWT token if successful.
 *   Must supply ledger, password and either user or auth identifier.
 *   Expire is optional
 *   - ledger   - ledger identifier
 *   - password - plain-text password
 *   - user     - _user/username (TODO: should allow any _user ident in the future)
 *   - auth     - _auth/id (TODO: should allow any _auth ident in the future)
 *   - expire   - requested time to expire in milliseconds
 */
shared.connection_handler.password_login = (function shared$connection_handler$password_login(var_args){
var G__110231 = arguments.length;
switch (G__110231) {
case 4:
return shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 6:
return shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,password,user){
return shared.connection_handler.password_login.call(null,conn,ledger,password,user,null,null);
});

shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$6 = (function (conn,ledger,password,user,auth,expire){
return (new Promise((function (resolve,reject){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_110294){
var state_val_110295 = (state_110294[(1)]);
if((state_val_110295 === (7))){
var inst_110247 = (state_110294[(2)]);
var state_110294__$1 = (function (){var statearr_110296 = state_110294;
(statearr_110296[(7)] = inst_110247);

return statearr_110296;
})();
if(cljs.core.truth_(ledger)){
var statearr_110297_110328 = state_110294__$1;
(statearr_110297_110328[(1)] = (8));

} else {
var statearr_110298_110329 = state_110294__$1;
(statearr_110298_110329[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (1))){
var state_110294__$1 = state_110294;
var statearr_110299_110330 = state_110294__$1;
(statearr_110299_110330[(2)] = null);

(statearr_110299_110330[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_110294,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_110238 = shared.connection_handler.password_enabled_QMARK_.call(null,conn);
var state_110294__$1 = state_110294;
if(cljs.core.truth_(inst_110238)){
var statearr_110300_110331 = state_110294__$1;
(statearr_110300_110331[(1)] = (5));

} else {
var statearr_110301_110332 = state_110294__$1;
(statearr_110301_110332[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (15))){
var state_110294__$1 = state_110294;
var statearr_110302_110333 = state_110294__$1;
(statearr_110302_110333[(2)] = auth);

(statearr_110302_110333[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (13))){
var inst_110265 = (state_110294[(2)]);
var state_110294__$1 = (function (){var statearr_110303 = state_110294;
(statearr_110303[(8)] = inst_110265);

return statearr_110303;
})();
if(cljs.core.truth_(user)){
var statearr_110304_110334 = state_110294__$1;
(statearr_110304_110334[(1)] = (14));

} else {
var statearr_110305_110335 = state_110294__$1;
(statearr_110305_110335[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (6))){
var inst_110241 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_110242 = [(401),new cljs.core.Keyword("db","no-password-auth","db/no-password-auth",1344949614)];
var inst_110243 = cljs.core.PersistentHashMap.fromArrays(inst_110241,inst_110242);
var inst_110244 = cljs.core.ex_info.call(null,"Password authentication is not enabled.",inst_110243);
var inst_110245 = (function(){throw inst_110244})();
var state_110294__$1 = state_110294;
var statearr_110306_110336 = state_110294__$1;
(statearr_110306_110336[(2)] = inst_110245);

(statearr_110306_110336[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (17))){
var state_110294__$1 = state_110294;
var statearr_110307_110337 = state_110294__$1;
(statearr_110307_110337[(2)] = null);

(statearr_110307_110337[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (3))){
var inst_110232 = (state_110294[(2)]);
var inst_110233 = cljs.core.clj__GT_js.call(null,inst_110232);
var inst_110234 = reject.call(null,inst_110233);
var state_110294__$1 = state_110294;
var statearr_110308_110338 = state_110294__$1;
(statearr_110308_110338[(2)] = inst_110234);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110294__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (12))){
var inst_110259 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_110260 = [(400),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)];
var inst_110261 = cljs.core.PersistentHashMap.fromArrays(inst_110259,inst_110260);
var inst_110262 = cljs.core.ex_info.call(null,"A password must be supplied in the provided JSON.",inst_110261);
var inst_110263 = (function(){throw inst_110262})();
var state_110294__$1 = state_110294;
var statearr_110309_110339 = state_110294__$1;
(statearr_110309_110339[(2)] = inst_110263);

(statearr_110309_110339[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (2))){
var inst_110292 = (state_110294[(2)]);
var state_110294__$1 = state_110294;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_110294__$1,inst_110292);
} else {
if((state_val_110295 === (19))){
var inst_110278 = (state_110294[(2)]);
var inst_110279 = [new cljs.core.Keyword(null,"ledger","ledger",561720706),new cljs.core.Keyword(null,"password","password",417022471),new cljs.core.Keyword(null,"user","user",1532431356),new cljs.core.Keyword(null,"auth","auth",1389754926),new cljs.core.Keyword(null,"expire","expire",-70657108)];
var inst_110280 = [ledger,password,user,auth,expire];
var inst_110281 = cljs.core.PersistentHashMap.fromArrays(inst_110279,inst_110280);
var inst_110282 = fluree.db.util.core.without_nils.call(null,inst_110281);
var inst_110283 = cljs.core.async.promise_chan.call(null);
var inst_110284 = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(conn);
var inst_110285 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_110286 = [new cljs.core.Keyword(null,"pw-login","pw-login",-335915426),inst_110282,inst_110283,null];
var inst_110287 = (new cljs.core.PersistentVector(null,4,(5),inst_110285,inst_110286,null));
var inst_110288 = cljs.core.async.put_BANG_.call(null,inst_110284,inst_110287);
var inst_110289 = (function (){var _ = inst_110278;
var data = inst_110282;
var pc = inst_110283;
return ((function (_,data,pc,inst_110278,inst_110279,inst_110280,inst_110281,inst_110282,inst_110283,inst_110284,inst_110285,inst_110286,inst_110287,inst_110288,state_val_110295,c__86675__auto__){
return (function (result){
if(cljs.core.truth_((((result == null))?(function(){throw cljs.core.ex_info.call(null,"A token could not be generated for the identity and password combination.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)], null))})():null))){
if(cljs.core.truth_(new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(result))){
return reject.call(null,cljs.core.clj__GT_js.call(null,result));
} else {
return null;
}
} else {
if((result instanceof cljs.core.ExceptionInfo)){
var err_data = cljs.core.ex_data.call(null,result);
var err_resp = new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"status","status",-1997798413),(function (){var or__4131__auto__ = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (400);
}
})(),new cljs.core.Keyword(null,"message","message",-406056002),cljs.core.ex_message.call(null,result),new cljs.core.Keyword(null,"error","error",-978969032),(function (){var or__4131__auto__ = new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926);
}
})()], null);
return reject.call(null,cljs.core.clj__GT_js.call(null,err_resp));
} else {
return resolve.call(null,cljs.core.clj__GT_js.call(null,result));

}
}
});
;})(_,data,pc,inst_110278,inst_110279,inst_110280,inst_110281,inst_110282,inst_110283,inst_110284,inst_110285,inst_110286,inst_110287,inst_110288,state_val_110295,c__86675__auto__))
})();
var inst_110290 = cljs.core.async.take_BANG_.call(null,inst_110283,inst_110289);
var state_110294__$1 = (function (){var statearr_110310 = state_110294;
(statearr_110310[(9)] = inst_110288);

return statearr_110310;
})();
var statearr_110311_110340 = state_110294__$1;
(statearr_110311_110340[(2)] = inst_110290);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110294__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (11))){
var state_110294__$1 = state_110294;
var statearr_110312_110341 = state_110294__$1;
(statearr_110312_110341[(2)] = null);

(statearr_110312_110341[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (9))){
var inst_110250 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_110251 = [(400),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)];
var inst_110252 = cljs.core.PersistentHashMap.fromArrays(inst_110250,inst_110251);
var inst_110253 = cljs.core.ex_info.call(null,"A ledger must be supplied in the provided JSON.",inst_110252);
var inst_110254 = (function(){throw inst_110253})();
var state_110294__$1 = state_110294;
var statearr_110313_110342 = state_110294__$1;
(statearr_110313_110342[(2)] = inst_110254);

(statearr_110313_110342[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (5))){
var state_110294__$1 = state_110294;
var statearr_110314_110343 = state_110294__$1;
(statearr_110314_110343[(2)] = null);

(statearr_110314_110343[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (14))){
var state_110294__$1 = state_110294;
var statearr_110315_110344 = state_110294__$1;
(statearr_110315_110344[(2)] = user);

(statearr_110315_110344[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (16))){
var inst_110269 = (state_110294[(2)]);
var state_110294__$1 = state_110294;
if(cljs.core.truth_(inst_110269)){
var statearr_110316_110345 = state_110294__$1;
(statearr_110316_110345[(1)] = (17));

} else {
var statearr_110317_110346 = state_110294__$1;
(statearr_110317_110346[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (10))){
var inst_110256 = (state_110294[(2)]);
var state_110294__$1 = (function (){var statearr_110318 = state_110294;
(statearr_110318[(10)] = inst_110256);

return statearr_110318;
})();
if(cljs.core.truth_(password)){
var statearr_110319_110347 = state_110294__$1;
(statearr_110319_110347[(1)] = (11));

} else {
var statearr_110320_110348 = state_110294__$1;
(statearr_110320_110348[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (18))){
var inst_110272 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_110273 = [(400),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)];
var inst_110274 = cljs.core.PersistentHashMap.fromArrays(inst_110272,inst_110273);
var inst_110275 = cljs.core.ex_info.call(null,"A user identity or auth identity must be supplied.",inst_110274);
var inst_110276 = (function(){throw inst_110275})();
var state_110294__$1 = state_110294;
var statearr_110321_110349 = state_110294__$1;
(statearr_110321_110349[(2)] = inst_110276);

(statearr_110321_110349[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110295 === (8))){
var state_110294__$1 = state_110294;
var statearr_110322_110350 = state_110294__$1;
(statearr_110322_110350[(2)] = null);

(statearr_110322_110350[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var shared$connection_handler$state_machine__86625__auto__ = null;
var shared$connection_handler$state_machine__86625__auto____0 = (function (){
var statearr_110323 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_110323[(0)] = shared$connection_handler$state_machine__86625__auto__);

(statearr_110323[(1)] = (1));

return statearr_110323;
});
var shared$connection_handler$state_machine__86625__auto____1 = (function (state_110294){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_110294);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e110324){if((e110324 instanceof Object)){
var ex__86628__auto__ = e110324;
var statearr_110325_110351 = state_110294;
(statearr_110325_110351[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110294);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e110324;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__110352 = state_110294;
state_110294 = G__110352;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
shared$connection_handler$state_machine__86625__auto__ = function(state_110294){
switch(arguments.length){
case 0:
return shared$connection_handler$state_machine__86625__auto____0.call(this);
case 1:
return shared$connection_handler$state_machine__86625__auto____1.call(this,state_110294);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$connection_handler$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = shared$connection_handler$state_machine__86625__auto____0;
shared$connection_handler$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = shared$connection_handler$state_machine__86625__auto____1;
return shared$connection_handler$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_110326 = f__86676__auto__.call(null);
(statearr_110326[(6)] = c__86675__auto__);

return statearr_110326;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
})));
});

shared.connection_handler.password_login.cljs$lang$maxFixedArity = 6;

/**
 * Renews a JWT token if successful.
 * 
 *   Returns a promise that eventually contains the token or an exception
 */
shared.connection_handler.renew_token = (function shared$connection_handler$renew_token(var_args){
var G__110354 = arguments.length;
switch (G__110354) {
case 2:
return shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$2 = (function (conn,jwt){
return shared.connection_handler.renew_token.call(null,conn,jwt,null);
});

shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$3 = (function (conn,jwt,expire){
return (new Promise((function (resolve,reject){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_110386){
var state_val_110387 = (state_110386[(1)]);
if((state_val_110387 === (1))){
var state_110386__$1 = state_110386;
var statearr_110388_110401 = state_110386__$1;
(statearr_110388_110401[(2)] = null);

(statearr_110388_110401[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110387 === (2))){
var inst_110384 = (state_110386[(2)]);
var state_110386__$1 = state_110386;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_110386__$1,inst_110384);
} else {
if((state_val_110387 === (3))){
var inst_110355 = (state_110386[(2)]);
var inst_110356 = cljs.core.clj__GT_js.call(null,inst_110355);
var inst_110357 = reject.call(null,inst_110356);
var state_110386__$1 = state_110386;
var statearr_110389_110402 = state_110386__$1;
(statearr_110389_110402[(2)] = inst_110357);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110386__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110387 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_110386,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_110361 = shared.connection_handler.password_enabled_QMARK_.call(null,conn);
var state_110386__$1 = state_110386;
if(cljs.core.truth_(inst_110361)){
var statearr_110390_110403 = state_110386__$1;
(statearr_110390_110403[(1)] = (5));

} else {
var statearr_110391_110404 = state_110386__$1;
(statearr_110391_110404[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110387 === (5))){
var state_110386__$1 = state_110386;
var statearr_110392_110405 = state_110386__$1;
(statearr_110392_110405[(2)] = null);

(statearr_110392_110405[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110387 === (6))){
var inst_110364 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_110365 = [(401),new cljs.core.Keyword("db","no-password-auth","db/no-password-auth",1344949614)];
var inst_110366 = cljs.core.PersistentHashMap.fromArrays(inst_110364,inst_110365);
var inst_110367 = cljs.core.ex_info.call(null,"Password authentication is not enabled.",inst_110366);
var inst_110368 = (function(){throw inst_110367})();
var state_110386__$1 = state_110386;
var statearr_110393_110406 = state_110386__$1;
(statearr_110393_110406[(2)] = inst_110368);

(statearr_110393_110406[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_110387 === (7))){
var inst_110370 = (state_110386[(2)]);
var inst_110371 = [new cljs.core.Keyword(null,"jwt","jwt",1504015441),new cljs.core.Keyword(null,"expire","expire",-70657108)];
var inst_110372 = [jwt,expire];
var inst_110373 = cljs.core.PersistentHashMap.fromArrays(inst_110371,inst_110372);
var inst_110374 = fluree.db.util.core.without_nils.call(null,inst_110373);
var inst_110375 = cljs.core.async.promise_chan.call(null);
var inst_110376 = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(conn);
var inst_110377 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_110378 = [new cljs.core.Keyword(null,"pw-renew","pw-renew",2082701857),inst_110374,inst_110375,null];
var inst_110379 = (new cljs.core.PersistentVector(null,4,(5),inst_110377,inst_110378,null));
var inst_110380 = cljs.core.async.put_BANG_.call(null,inst_110376,inst_110379);
var inst_110381 = (function (){var _ = inst_110370;
var data = inst_110374;
var pc = inst_110375;
return ((function (_,data,pc,inst_110370,inst_110371,inst_110372,inst_110373,inst_110374,inst_110375,inst_110376,inst_110377,inst_110378,inst_110379,inst_110380,state_val_110387,c__86675__auto__){
return (function (result){
if(cljs.core.truth_((((result == null))?(function(){throw cljs.core.ex_info.call(null,"The token could not be renewed.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)], null))})():null))){
if(cljs.core.truth_(new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(result))){
return reject.call(null,cljs.core.clj__GT_js.call(null,result));
} else {
return null;
}
} else {
return resolve.call(null,cljs.core.clj__GT_js.call(null,result));

}
});
;})(_,data,pc,inst_110370,inst_110371,inst_110372,inst_110373,inst_110374,inst_110375,inst_110376,inst_110377,inst_110378,inst_110379,inst_110380,state_val_110387,c__86675__auto__))
})();
var inst_110382 = cljs.core.async.take_BANG_.call(null,inst_110375,inst_110381);
var state_110386__$1 = (function (){var statearr_110394 = state_110386;
(statearr_110394[(7)] = inst_110380);

return statearr_110394;
})();
var statearr_110395_110407 = state_110386__$1;
(statearr_110395_110407[(2)] = inst_110382);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110386__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var shared$connection_handler$state_machine__86625__auto__ = null;
var shared$connection_handler$state_machine__86625__auto____0 = (function (){
var statearr_110396 = [null,null,null,null,null,null,null,null];
(statearr_110396[(0)] = shared$connection_handler$state_machine__86625__auto__);

(statearr_110396[(1)] = (1));

return statearr_110396;
});
var shared$connection_handler$state_machine__86625__auto____1 = (function (state_110386){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_110386);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e110397){if((e110397 instanceof Object)){
var ex__86628__auto__ = e110397;
var statearr_110398_110408 = state_110386;
(statearr_110398_110408[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_110386);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e110397;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__110409 = state_110386;
state_110386 = G__110409;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
shared$connection_handler$state_machine__86625__auto__ = function(state_110386){
switch(arguments.length){
case 0:
return shared$connection_handler$state_machine__86625__auto____0.call(this);
case 1:
return shared$connection_handler$state_machine__86625__auto____1.call(this,state_110386);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$connection_handler$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = shared$connection_handler$state_machine__86625__auto____0;
shared$connection_handler$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = shared$connection_handler$state_machine__86625__auto____1;
return shared$connection_handler$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_110399 = f__86676__auto__.call(null);
(statearr_110399[(6)] = c__86675__auto__);

return statearr_110399;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
})));
});

shared.connection_handler.renew_token.cljs$lang$maxFixedArity = 3;

