// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('tailrecursion.priority_map');
goog.require('cljs.core');
goog.require('cljs.core');
goog.require('cljs.reader');

/**
* @constructor
 * @implements {cljs.core.IReversible}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.IFn}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.IEmptyableCollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISorted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IStack}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
tailrecursion.priority_map.PersistentPriorityMap = (function (priority__GT_set_of_items,item__GT_priority,meta,keyfn,__hash){
this.priority__GT_set_of_items = priority__GT_set_of_items;
this.item__GT_priority = item__GT_priority;
this.meta = meta;
this.keyfn = keyfn;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2565220111;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this$,item){
var self__ = this;
var this$__$1 = this;
return cljs.core.get.call(null,self__.item__GT_priority,item);
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (coll,item,not_found){
var self__ = this;
var coll__$1 = this;
return cljs.core.get.call(null,self__.item__GT_priority,item,not_found);
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (coll,writer,opts){
var self__ = this;
var coll__$1 = this;
var pr_pair = ((function (coll__$1){
return (function (keyval){
return cljs.core.pr_sequential_writer.call(null,writer,cljs.core.pr_writer,""," ","",opts,keyval);
});})(coll__$1))
;
return cljs.core.pr_sequential_writer.call(null,writer,pr_pair,"#tailrecursion.priority-map {",", ","}",opts,coll__$1);
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return self__.meta;
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return cljs.core.count.call(null,self__.item__GT_priority);
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IStack$_peek$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
if((cljs.core.count.call(null,self__.item__GT_priority) === (0))){
return null;
} else {
var f = cljs.core.first.call(null,self__.priority__GT_set_of_items);
var item = cljs.core.first.call(null,cljs.core.val.call(null,f));
if(cljs.core.truth_(self__.keyfn)){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,cljs.core.key.call(null,f)], null);
}
}
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IStack$_pop$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
if((cljs.core.count.call(null,self__.item__GT_priority) === (0))){
throw (new Error("Can't pop empty priority map"));
} else {
var f = cljs.core.first.call(null,self__.priority__GT_set_of_items);
var item_set = cljs.core.val.call(null,f);
var item = cljs.core.first.call(null,item_set);
var priority_key = cljs.core.key.call(null,f);
if(cljs.core._EQ_.call(null,cljs.core.count.call(null,item_set),(1))){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.dissoc.call(null,self__.priority__GT_set_of_items,priority_key),cljs.core.dissoc.call(null,self__.item__GT_priority,item),self__.meta,self__.keyfn,null));
} else {
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.assoc.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.disj.call(null,item_set,item)),cljs.core.dissoc.call(null,self__.item__GT_priority,item),self__.meta,self__.keyfn,null));
}
}
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IReversible$_rseq$arity$1 = (function (coll){
var self__ = this;
var coll__$1 = this;
if(cljs.core.truth_(self__.keyfn)){
return cljs.core.seq.call(null,(function (){var iter__4523__auto__ = ((function (coll__$1){
return (function tailrecursion$priority_map$iter__112697(s__112698){
return (new cljs.core.LazySeq(null,((function (coll__$1){
return (function (){
var s__112698__$1 = s__112698;
while(true){
var temp__5735__auto__ = cljs.core.seq.call(null,s__112698__$1);
if(temp__5735__auto__){
var xs__6292__auto__ = temp__5735__auto__;
var vec__112703 = cljs.core.first.call(null,xs__6292__auto__);
var priority = cljs.core.nth.call(null,vec__112703,(0),null);
var item_set = cljs.core.nth.call(null,vec__112703,(1),null);
var iterys__4519__auto__ = ((function (s__112698__$1,vec__112703,priority,item_set,xs__6292__auto__,temp__5735__auto__,coll__$1){
return (function tailrecursion$priority_map$iter__112697_$_iter__112699(s__112700){
return (new cljs.core.LazySeq(null,((function (s__112698__$1,vec__112703,priority,item_set,xs__6292__auto__,temp__5735__auto__,coll__$1){
return (function (){
var s__112700__$1 = s__112700;
while(true){
var temp__5735__auto____$1 = cljs.core.seq.call(null,s__112700__$1);
if(temp__5735__auto____$1){
var s__112700__$2 = temp__5735__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__112700__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__112700__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__112702 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__112701 = (0);
while(true){
if((i__112701 < size__4522__auto__)){
var item = cljs.core._nth.call(null,c__4521__auto__,i__112701);
cljs.core.chunk_append.call(null,b__112702,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null));

var G__112751 = (i__112701 + (1));
i__112701 = G__112751;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112702),tailrecursion$priority_map$iter__112697_$_iter__112699.call(null,cljs.core.chunk_rest.call(null,s__112700__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112702),null);
}
} else {
var item = cljs.core.first.call(null,s__112700__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null),tailrecursion$priority_map$iter__112697_$_iter__112699.call(null,cljs.core.rest.call(null,s__112700__$2)));
}
} else {
return null;
}
break;
}
});})(s__112698__$1,vec__112703,priority,item_set,xs__6292__auto__,temp__5735__auto__,coll__$1))
,null,null));
});})(s__112698__$1,vec__112703,priority,item_set,xs__6292__auto__,temp__5735__auto__,coll__$1))
;
var fs__4520__auto__ = cljs.core.seq.call(null,iterys__4519__auto__.call(null,item_set));
if(fs__4520__auto__){
return cljs.core.concat.call(null,fs__4520__auto__,tailrecursion$priority_map$iter__112697.call(null,cljs.core.rest.call(null,s__112698__$1)));
} else {
var G__112752 = cljs.core.rest.call(null,s__112698__$1);
s__112698__$1 = G__112752;
continue;
}
} else {
return null;
}
break;
}
});})(coll__$1))
,null,null));
});})(coll__$1))
;
return iter__4523__auto__.call(null,cljs.core.rseq.call(null,self__.priority__GT_set_of_items));
})());
} else {
return cljs.core.seq.call(null,(function (){var iter__4523__auto__ = ((function (coll__$1){
return (function tailrecursion$priority_map$iter__112706(s__112707){
return (new cljs.core.LazySeq(null,((function (coll__$1){
return (function (){
var s__112707__$1 = s__112707;
while(true){
var temp__5735__auto__ = cljs.core.seq.call(null,s__112707__$1);
if(temp__5735__auto__){
var xs__6292__auto__ = temp__5735__auto__;
var vec__112712 = cljs.core.first.call(null,xs__6292__auto__);
var priority = cljs.core.nth.call(null,vec__112712,(0),null);
var item_set = cljs.core.nth.call(null,vec__112712,(1),null);
var iterys__4519__auto__ = ((function (s__112707__$1,vec__112712,priority,item_set,xs__6292__auto__,temp__5735__auto__,coll__$1){
return (function tailrecursion$priority_map$iter__112706_$_iter__112708(s__112709){
return (new cljs.core.LazySeq(null,((function (s__112707__$1,vec__112712,priority,item_set,xs__6292__auto__,temp__5735__auto__,coll__$1){
return (function (){
var s__112709__$1 = s__112709;
while(true){
var temp__5735__auto____$1 = cljs.core.seq.call(null,s__112709__$1);
if(temp__5735__auto____$1){
var s__112709__$2 = temp__5735__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__112709__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__112709__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__112711 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__112710 = (0);
while(true){
if((i__112710 < size__4522__auto__)){
var item = cljs.core._nth.call(null,c__4521__auto__,i__112710);
cljs.core.chunk_append.call(null,b__112711,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null));

var G__112753 = (i__112710 + (1));
i__112710 = G__112753;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112711),tailrecursion$priority_map$iter__112706_$_iter__112708.call(null,cljs.core.chunk_rest.call(null,s__112709__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112711),null);
}
} else {
var item = cljs.core.first.call(null,s__112709__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null),tailrecursion$priority_map$iter__112706_$_iter__112708.call(null,cljs.core.rest.call(null,s__112709__$2)));
}
} else {
return null;
}
break;
}
});})(s__112707__$1,vec__112712,priority,item_set,xs__6292__auto__,temp__5735__auto__,coll__$1))
,null,null));
});})(s__112707__$1,vec__112712,priority,item_set,xs__6292__auto__,temp__5735__auto__,coll__$1))
;
var fs__4520__auto__ = cljs.core.seq.call(null,iterys__4519__auto__.call(null,item_set));
if(fs__4520__auto__){
return cljs.core.concat.call(null,fs__4520__auto__,tailrecursion$priority_map$iter__112706.call(null,cljs.core.rest.call(null,s__112707__$1)));
} else {
var G__112754 = cljs.core.rest.call(null,s__112707__$1);
s__112707__$1 = G__112754;
continue;
}
} else {
return null;
}
break;
}
});})(coll__$1))
,null,null));
});})(coll__$1))
;
return iter__4523__auto__.call(null,cljs.core.rseq.call(null,self__.priority__GT_set_of_items));
})());
}
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IHash$_hash$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = cljs.core.hash_unordered_coll.call(null,this$__$1);
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this$,other){
var self__ = this;
var this$__$1 = this;
return cljs.core._equiv.call(null,self__.item__GT_priority,other);
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IEmptyableCollection$_empty$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return cljs.core.with_meta.call(null,tailrecursion.priority_map.PersistentPriorityMap.EMPTY,self__.meta);
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this$,item){
var self__ = this;
var this$__$1 = this;
var priority = self__.item__GT_priority.call(null,item,new cljs.core.Keyword("tailrecursion.priority-map","not-found","tailrecursion.priority-map/not-found",-436727517));
if(cljs.core._EQ_.call(null,priority,new cljs.core.Keyword("tailrecursion.priority-map","not-found","tailrecursion.priority-map/not-found",-436727517))){
return this$__$1;
} else {
var priority_key = self__.keyfn.call(null,priority);
var item_set = self__.priority__GT_set_of_items.call(null,priority_key);
if(cljs.core._EQ_.call(null,cljs.core.count.call(null,item_set),(1))){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.dissoc.call(null,self__.priority__GT_set_of_items,priority_key),cljs.core.dissoc.call(null,self__.item__GT_priority,item),self__.meta,self__.keyfn,null));
} else {
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.assoc.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.disj.call(null,item_set,item)),cljs.core.dissoc.call(null,self__.item__GT_priority,item),self__.meta,self__.keyfn,null));
}
}
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this$,item,priority){
var self__ = this;
var this$__$1 = this;
var temp__5733__auto__ = cljs.core.get.call(null,self__.item__GT_priority,item,null);
if(cljs.core.truth_(temp__5733__auto__)){
var current_priority = temp__5733__auto__;
if(cljs.core._EQ_.call(null,current_priority,priority)){
return this$__$1;
} else {
var priority_key = self__.keyfn.call(null,priority);
var current_priority_key = self__.keyfn.call(null,current_priority);
var item_set = cljs.core.get.call(null,self__.priority__GT_set_of_items,current_priority_key);
if(cljs.core._EQ_.call(null,cljs.core.count.call(null,item_set),(1))){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.assoc.call(null,cljs.core.dissoc.call(null,self__.priority__GT_set_of_items,current_priority_key),priority_key,cljs.core.conj.call(null,cljs.core.get.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.PersistentHashSet.EMPTY),item)),cljs.core.assoc.call(null,self__.item__GT_priority,item,priority),self__.meta,self__.keyfn,null));
} else {
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.assoc.call(null,self__.priority__GT_set_of_items,current_priority_key,cljs.core.disj.call(null,cljs.core.get.call(null,self__.priority__GT_set_of_items,current_priority_key),item),priority_key,cljs.core.conj.call(null,cljs.core.get.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.PersistentHashSet.EMPTY),item)),cljs.core.assoc.call(null,self__.item__GT_priority,item,priority),self__.meta,self__.keyfn,null));
}
}
} else {
var priority_key = self__.keyfn.call(null,priority);
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.assoc.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.conj.call(null,cljs.core.get.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.PersistentHashSet.EMPTY),item)),cljs.core.assoc.call(null,self__.item__GT_priority,item,priority),self__.meta,self__.keyfn,null));
}
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this$,item){
var self__ = this;
var this$__$1 = this;
return cljs.core.contains_QMARK_.call(null,self__.item__GT_priority,item);
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
if(cljs.core.truth_(self__.keyfn)){
return cljs.core.seq.call(null,(function (){var iter__4523__auto__ = ((function (this$__$1){
return (function tailrecursion$priority_map$iter__112715(s__112716){
return (new cljs.core.LazySeq(null,((function (this$__$1){
return (function (){
var s__112716__$1 = s__112716;
while(true){
var temp__5735__auto__ = cljs.core.seq.call(null,s__112716__$1);
if(temp__5735__auto__){
var xs__6292__auto__ = temp__5735__auto__;
var vec__112721 = cljs.core.first.call(null,xs__6292__auto__);
var priority = cljs.core.nth.call(null,vec__112721,(0),null);
var item_set = cljs.core.nth.call(null,vec__112721,(1),null);
var iterys__4519__auto__ = ((function (s__112716__$1,vec__112721,priority,item_set,xs__6292__auto__,temp__5735__auto__,this$__$1){
return (function tailrecursion$priority_map$iter__112715_$_iter__112717(s__112718){
return (new cljs.core.LazySeq(null,((function (s__112716__$1,vec__112721,priority,item_set,xs__6292__auto__,temp__5735__auto__,this$__$1){
return (function (){
var s__112718__$1 = s__112718;
while(true){
var temp__5735__auto____$1 = cljs.core.seq.call(null,s__112718__$1);
if(temp__5735__auto____$1){
var s__112718__$2 = temp__5735__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__112718__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__112718__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__112720 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__112719 = (0);
while(true){
if((i__112719 < size__4522__auto__)){
var item = cljs.core._nth.call(null,c__4521__auto__,i__112719);
cljs.core.chunk_append.call(null,b__112720,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null));

var G__112755 = (i__112719 + (1));
i__112719 = G__112755;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112720),tailrecursion$priority_map$iter__112715_$_iter__112717.call(null,cljs.core.chunk_rest.call(null,s__112718__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112720),null);
}
} else {
var item = cljs.core.first.call(null,s__112718__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null),tailrecursion$priority_map$iter__112715_$_iter__112717.call(null,cljs.core.rest.call(null,s__112718__$2)));
}
} else {
return null;
}
break;
}
});})(s__112716__$1,vec__112721,priority,item_set,xs__6292__auto__,temp__5735__auto__,this$__$1))
,null,null));
});})(s__112716__$1,vec__112721,priority,item_set,xs__6292__auto__,temp__5735__auto__,this$__$1))
;
var fs__4520__auto__ = cljs.core.seq.call(null,iterys__4519__auto__.call(null,item_set));
if(fs__4520__auto__){
return cljs.core.concat.call(null,fs__4520__auto__,tailrecursion$priority_map$iter__112715.call(null,cljs.core.rest.call(null,s__112716__$1)));
} else {
var G__112756 = cljs.core.rest.call(null,s__112716__$1);
s__112716__$1 = G__112756;
continue;
}
} else {
return null;
}
break;
}
});})(this$__$1))
,null,null));
});})(this$__$1))
;
return iter__4523__auto__.call(null,self__.priority__GT_set_of_items);
})());
} else {
return cljs.core.seq.call(null,(function (){var iter__4523__auto__ = ((function (this$__$1){
return (function tailrecursion$priority_map$iter__112724(s__112725){
return (new cljs.core.LazySeq(null,((function (this$__$1){
return (function (){
var s__112725__$1 = s__112725;
while(true){
var temp__5735__auto__ = cljs.core.seq.call(null,s__112725__$1);
if(temp__5735__auto__){
var xs__6292__auto__ = temp__5735__auto__;
var vec__112730 = cljs.core.first.call(null,xs__6292__auto__);
var priority = cljs.core.nth.call(null,vec__112730,(0),null);
var item_set = cljs.core.nth.call(null,vec__112730,(1),null);
var iterys__4519__auto__ = ((function (s__112725__$1,vec__112730,priority,item_set,xs__6292__auto__,temp__5735__auto__,this$__$1){
return (function tailrecursion$priority_map$iter__112724_$_iter__112726(s__112727){
return (new cljs.core.LazySeq(null,((function (s__112725__$1,vec__112730,priority,item_set,xs__6292__auto__,temp__5735__auto__,this$__$1){
return (function (){
var s__112727__$1 = s__112727;
while(true){
var temp__5735__auto____$1 = cljs.core.seq.call(null,s__112727__$1);
if(temp__5735__auto____$1){
var s__112727__$2 = temp__5735__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__112727__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__112727__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__112729 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__112728 = (0);
while(true){
if((i__112728 < size__4522__auto__)){
var item = cljs.core._nth.call(null,c__4521__auto__,i__112728);
cljs.core.chunk_append.call(null,b__112729,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null));

var G__112757 = (i__112728 + (1));
i__112728 = G__112757;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112729),tailrecursion$priority_map$iter__112724_$_iter__112726.call(null,cljs.core.chunk_rest.call(null,s__112727__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112729),null);
}
} else {
var item = cljs.core.first.call(null,s__112727__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null),tailrecursion$priority_map$iter__112724_$_iter__112726.call(null,cljs.core.rest.call(null,s__112727__$2)));
}
} else {
return null;
}
break;
}
});})(s__112725__$1,vec__112730,priority,item_set,xs__6292__auto__,temp__5735__auto__,this$__$1))
,null,null));
});})(s__112725__$1,vec__112730,priority,item_set,xs__6292__auto__,temp__5735__auto__,this$__$1))
;
var fs__4520__auto__ = cljs.core.seq.call(null,iterys__4519__auto__.call(null,item_set));
if(fs__4520__auto__){
return cljs.core.concat.call(null,fs__4520__auto__,tailrecursion$priority_map$iter__112724.call(null,cljs.core.rest.call(null,s__112725__$1)));
} else {
var G__112758 = cljs.core.rest.call(null,s__112725__$1);
s__112725__$1 = G__112758;
continue;
}
} else {
return null;
}
break;
}
});})(this$__$1))
,null,null));
});})(this$__$1))
;
return iter__4523__auto__.call(null,self__.priority__GT_set_of_items);
})());
}
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this$,meta__$1){
var self__ = this;
var this$__$1 = this;
return (new tailrecursion.priority_map.PersistentPriorityMap(self__.priority__GT_set_of_items,self__.item__GT_priority,meta__$1,self__.keyfn,self__.__hash));
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this$,entry){
var self__ = this;
var this$__$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry)){
return cljs.core._assoc.call(null,this$__$1,cljs.core._nth.call(null,entry,(0)),cljs.core._nth.call(null,entry,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this$__$1,entry);
}
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.call = (function() {
var G__112759 = null;
var G__112759__2 = (function (self__,item){
var self__ = this;
var self____$1 = this;
var this$ = self____$1;
return cljs.core._lookup.call(null,this$,item);
});
var G__112759__3 = (function (self__,item,not_found){
var self__ = this;
var self____$1 = this;
var this$ = self____$1;
return cljs.core._lookup.call(null,this$,item,not_found);
});
G__112759 = function(self__,item,not_found){
switch(arguments.length){
case 2:
return G__112759__2.call(this,self__,item);
case 3:
return G__112759__3.call(this,self__,item,not_found);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
G__112759.cljs$core$IFn$_invoke$arity$2 = G__112759__2;
G__112759.cljs$core$IFn$_invoke$arity$3 = G__112759__3;
return G__112759;
})()
;

tailrecursion.priority_map.PersistentPriorityMap.prototype.apply = (function (self__,args112696){
var self__ = this;
var self____$1 = this;
return self____$1.call.apply(self____$1,[self____$1].concat(cljs.core.aclone.call(null,args112696)));
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IFn$_invoke$arity$1 = (function (item){
var self__ = this;
var this$ = this;
return cljs.core._lookup.call(null,this$,item);
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IFn$_invoke$arity$2 = (function (item,not_found){
var self__ = this;
var this$ = this;
return cljs.core._lookup.call(null,this$,item,not_found);
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ISorted$_sorted_seq$arity$2 = (function (this$,ascending_QMARK_){
var self__ = this;
var this$__$1 = this;
return (cljs.core.truth_(ascending_QMARK_)?cljs.core.seq:cljs.core.rseq).call(null,this$__$1);
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ISorted$_sorted_seq_from$arity$3 = (function (this$,k,ascending_QMARK_){
var self__ = this;
var this$__$1 = this;
var sets = (cljs.core.truth_(ascending_QMARK_)?cljs.core.subseq.call(null,self__.priority__GT_set_of_items,cljs.core._GT__EQ_,k):cljs.core.rsubseq.call(null,self__.priority__GT_set_of_items,cljs.core._LT__EQ_,k));
if(cljs.core.truth_(self__.keyfn)){
return cljs.core.seq.call(null,(function (){var iter__4523__auto__ = ((function (sets,this$__$1){
return (function tailrecursion$priority_map$iter__112733(s__112734){
return (new cljs.core.LazySeq(null,((function (sets,this$__$1){
return (function (){
var s__112734__$1 = s__112734;
while(true){
var temp__5735__auto__ = cljs.core.seq.call(null,s__112734__$1);
if(temp__5735__auto__){
var xs__6292__auto__ = temp__5735__auto__;
var vec__112739 = cljs.core.first.call(null,xs__6292__auto__);
var priority = cljs.core.nth.call(null,vec__112739,(0),null);
var item_set = cljs.core.nth.call(null,vec__112739,(1),null);
var iterys__4519__auto__ = ((function (s__112734__$1,vec__112739,priority,item_set,xs__6292__auto__,temp__5735__auto__,sets,this$__$1){
return (function tailrecursion$priority_map$iter__112733_$_iter__112735(s__112736){
return (new cljs.core.LazySeq(null,((function (s__112734__$1,vec__112739,priority,item_set,xs__6292__auto__,temp__5735__auto__,sets,this$__$1){
return (function (){
var s__112736__$1 = s__112736;
while(true){
var temp__5735__auto____$1 = cljs.core.seq.call(null,s__112736__$1);
if(temp__5735__auto____$1){
var s__112736__$2 = temp__5735__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__112736__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__112736__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__112738 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__112737 = (0);
while(true){
if((i__112737 < size__4522__auto__)){
var item = cljs.core._nth.call(null,c__4521__auto__,i__112737);
cljs.core.chunk_append.call(null,b__112738,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null));

var G__112760 = (i__112737 + (1));
i__112737 = G__112760;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112738),tailrecursion$priority_map$iter__112733_$_iter__112735.call(null,cljs.core.chunk_rest.call(null,s__112736__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112738),null);
}
} else {
var item = cljs.core.first.call(null,s__112736__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null),tailrecursion$priority_map$iter__112733_$_iter__112735.call(null,cljs.core.rest.call(null,s__112736__$2)));
}
} else {
return null;
}
break;
}
});})(s__112734__$1,vec__112739,priority,item_set,xs__6292__auto__,temp__5735__auto__,sets,this$__$1))
,null,null));
});})(s__112734__$1,vec__112739,priority,item_set,xs__6292__auto__,temp__5735__auto__,sets,this$__$1))
;
var fs__4520__auto__ = cljs.core.seq.call(null,iterys__4519__auto__.call(null,item_set));
if(fs__4520__auto__){
return cljs.core.concat.call(null,fs__4520__auto__,tailrecursion$priority_map$iter__112733.call(null,cljs.core.rest.call(null,s__112734__$1)));
} else {
var G__112761 = cljs.core.rest.call(null,s__112734__$1);
s__112734__$1 = G__112761;
continue;
}
} else {
return null;
}
break;
}
});})(sets,this$__$1))
,null,null));
});})(sets,this$__$1))
;
return iter__4523__auto__.call(null,sets);
})());
} else {
return cljs.core.seq.call(null,(function (){var iter__4523__auto__ = ((function (sets,this$__$1){
return (function tailrecursion$priority_map$iter__112742(s__112743){
return (new cljs.core.LazySeq(null,((function (sets,this$__$1){
return (function (){
var s__112743__$1 = s__112743;
while(true){
var temp__5735__auto__ = cljs.core.seq.call(null,s__112743__$1);
if(temp__5735__auto__){
var xs__6292__auto__ = temp__5735__auto__;
var vec__112748 = cljs.core.first.call(null,xs__6292__auto__);
var priority = cljs.core.nth.call(null,vec__112748,(0),null);
var item_set = cljs.core.nth.call(null,vec__112748,(1),null);
var iterys__4519__auto__ = ((function (s__112743__$1,vec__112748,priority,item_set,xs__6292__auto__,temp__5735__auto__,sets,this$__$1){
return (function tailrecursion$priority_map$iter__112742_$_iter__112744(s__112745){
return (new cljs.core.LazySeq(null,((function (s__112743__$1,vec__112748,priority,item_set,xs__6292__auto__,temp__5735__auto__,sets,this$__$1){
return (function (){
var s__112745__$1 = s__112745;
while(true){
var temp__5735__auto____$1 = cljs.core.seq.call(null,s__112745__$1);
if(temp__5735__auto____$1){
var s__112745__$2 = temp__5735__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__112745__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__112745__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__112747 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__112746 = (0);
while(true){
if((i__112746 < size__4522__auto__)){
var item = cljs.core._nth.call(null,c__4521__auto__,i__112746);
cljs.core.chunk_append.call(null,b__112747,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null));

var G__112762 = (i__112746 + (1));
i__112746 = G__112762;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112747),tailrecursion$priority_map$iter__112742_$_iter__112744.call(null,cljs.core.chunk_rest.call(null,s__112745__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__112747),null);
}
} else {
var item = cljs.core.first.call(null,s__112745__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null),tailrecursion$priority_map$iter__112742_$_iter__112744.call(null,cljs.core.rest.call(null,s__112745__$2)));
}
} else {
return null;
}
break;
}
});})(s__112743__$1,vec__112748,priority,item_set,xs__6292__auto__,temp__5735__auto__,sets,this$__$1))
,null,null));
});})(s__112743__$1,vec__112748,priority,item_set,xs__6292__auto__,temp__5735__auto__,sets,this$__$1))
;
var fs__4520__auto__ = cljs.core.seq.call(null,iterys__4519__auto__.call(null,item_set));
if(fs__4520__auto__){
return cljs.core.concat.call(null,fs__4520__auto__,tailrecursion$priority_map$iter__112742.call(null,cljs.core.rest.call(null,s__112743__$1)));
} else {
var G__112763 = cljs.core.rest.call(null,s__112743__$1);
s__112743__$1 = G__112763;
continue;
}
} else {
return null;
}
break;
}
});})(sets,this$__$1))
,null,null));
});})(sets,this$__$1))
;
return iter__4523__auto__.call(null,sets);
})());
}
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ISorted$_entry_key$arity$2 = (function (this$,entry){
var self__ = this;
var this$__$1 = this;
return self__.keyfn.call(null,cljs.core.val.call(null,entry));
});

tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ISorted$_comparator$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return cljs.core.compare;
});

tailrecursion.priority_map.PersistentPriorityMap.getBasis = (function (){
return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"priority->set-of-items","priority->set-of-items",-1256537211,null),new cljs.core.Symbol(null,"item->priority","item->priority",-899999435,null),new cljs.core.Symbol(null,"meta","meta",-1154898805,null),new cljs.core.Symbol(null,"keyfn","keyfn",-1874375437,null),cljs.core.with_meta(new cljs.core.Symbol(null,"__hash","__hash",-1328796629,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"mutable","mutable",875778266),true], null))], null);
});

tailrecursion.priority_map.PersistentPriorityMap.cljs$lang$type = true;

tailrecursion.priority_map.PersistentPriorityMap.cljs$lang$ctorStr = "tailrecursion.priority-map/PersistentPriorityMap";

tailrecursion.priority_map.PersistentPriorityMap.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"tailrecursion.priority-map/PersistentPriorityMap");
});

/**
 * Positional factory function for tailrecursion.priority-map/PersistentPriorityMap.
 */
tailrecursion.priority_map.__GT_PersistentPriorityMap = (function tailrecursion$priority_map$__GT_PersistentPriorityMap(priority__GT_set_of_items,item__GT_priority,meta,keyfn,__hash){
return (new tailrecursion.priority_map.PersistentPriorityMap(priority__GT_set_of_items,item__GT_priority,meta,keyfn,__hash));
});

tailrecursion.priority_map.PersistentPriorityMap.EMPTY = (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.sorted_map.call(null),cljs.core.PersistentArrayMap.EMPTY,cljs.core.PersistentArrayMap.EMPTY,cljs.core.identity,null));
tailrecursion.priority_map.pm_empty_by = (function tailrecursion$priority_map$pm_empty_by(comparator){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.sorted_map_by.call(null,comparator),cljs.core.PersistentArrayMap.EMPTY,cljs.core.PersistentArrayMap.EMPTY,cljs.core.identity,null));
});
tailrecursion.priority_map.pm_empty_keyfn = (function tailrecursion$priority_map$pm_empty_keyfn(var_args){
var G__112765 = arguments.length;
switch (G__112765) {
case 1:
return tailrecursion.priority_map.pm_empty_keyfn.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return tailrecursion.priority_map.pm_empty_keyfn.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

tailrecursion.priority_map.pm_empty_keyfn.cljs$core$IFn$_invoke$arity$1 = (function (keyfn){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.sorted_map.call(null),cljs.core.PersistentArrayMap.EMPTY,cljs.core.PersistentArrayMap.EMPTY,keyfn,null));
});

tailrecursion.priority_map.pm_empty_keyfn.cljs$core$IFn$_invoke$arity$2 = (function (keyfn,comparator){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.sorted_map_by.call(null,comparator),cljs.core.PersistentArrayMap.EMPTY,cljs.core.PersistentArrayMap.EMPTY,keyfn,null));
});

tailrecursion.priority_map.pm_empty_keyfn.cljs$lang$maxFixedArity = 2;

tailrecursion.priority_map.read_priority_map = (function tailrecursion$priority_map$read_priority_map(elems){
if(cljs.core.map_QMARK_.call(null,elems)){
return cljs.core.into.call(null,tailrecursion.priority_map.PersistentPriorityMap.EMPTY,elems);
} else {
throw Error("Priority map literal expects a map for its elements.");
}
});
cljs.reader.register_tag_parser_BANG_.call(null,"tailrecursion.priority-map",tailrecursion.priority_map.read_priority_map);
/**
 * keyval => key val
 *   Returns a new priority map with supplied mappings.
 */
tailrecursion.priority_map.priority_map = (function tailrecursion$priority_map$priority_map(var_args){
var args__4736__auto__ = [];
var len__4730__auto___112768 = arguments.length;
var i__4731__auto___112769 = (0);
while(true){
if((i__4731__auto___112769 < len__4730__auto___112768)){
args__4736__auto__.push((arguments[i__4731__auto___112769]));

var G__112770 = (i__4731__auto___112769 + (1));
i__4731__auto___112769 = G__112770;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return tailrecursion.priority_map.priority_map.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

tailrecursion.priority_map.priority_map.cljs$core$IFn$_invoke$arity$variadic = (function (keyvals){
var in$ = cljs.core.seq.call(null,keyvals);
var out = tailrecursion.priority_map.PersistentPriorityMap.EMPTY;
while(true){
if(in$){
var G__112771 = cljs.core.nnext.call(null,in$);
var G__112772 = cljs.core.assoc.call(null,out,cljs.core.first.call(null,in$),cljs.core.second.call(null,in$));
in$ = G__112771;
out = G__112772;
continue;
} else {
return out;
}
break;
}
});

tailrecursion.priority_map.priority_map.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
tailrecursion.priority_map.priority_map.cljs$lang$applyTo = (function (seq112767){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq112767));
});

/**
 * keyval => key val
 *   Returns a new priority map with supplied
 *   mappings, using the supplied comparator.
 */
tailrecursion.priority_map.priority_map_by = (function tailrecursion$priority_map$priority_map_by(var_args){
var args__4736__auto__ = [];
var len__4730__auto___112775 = arguments.length;
var i__4731__auto___112776 = (0);
while(true){
if((i__4731__auto___112776 < len__4730__auto___112775)){
args__4736__auto__.push((arguments[i__4731__auto___112776]));

var G__112777 = (i__4731__auto___112776 + (1));
i__4731__auto___112776 = G__112777;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return tailrecursion.priority_map.priority_map_by.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

tailrecursion.priority_map.priority_map_by.cljs$core$IFn$_invoke$arity$variadic = (function (comparator,keyvals){
var in$ = cljs.core.seq.call(null,keyvals);
var out = tailrecursion.priority_map.pm_empty_by.call(null,comparator);
while(true){
if(in$){
var G__112778 = cljs.core.nnext.call(null,in$);
var G__112779 = cljs.core.assoc.call(null,out,cljs.core.first.call(null,in$),cljs.core.second.call(null,in$));
in$ = G__112778;
out = G__112779;
continue;
} else {
return out;
}
break;
}
});

tailrecursion.priority_map.priority_map_by.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
tailrecursion.priority_map.priority_map_by.cljs$lang$applyTo = (function (seq112773){
var G__112774 = cljs.core.first.call(null,seq112773);
var seq112773__$1 = cljs.core.next.call(null,seq112773);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__112774,seq112773__$1);
});

/**
 * keyval => key val
 *   Returns a new priority map with supplied
 *   mappings, using the supplied keyfn.
 */
tailrecursion.priority_map.priority_map_keyfn = (function tailrecursion$priority_map$priority_map_keyfn(var_args){
var args__4736__auto__ = [];
var len__4730__auto___112782 = arguments.length;
var i__4731__auto___112783 = (0);
while(true){
if((i__4731__auto___112783 < len__4730__auto___112782)){
args__4736__auto__.push((arguments[i__4731__auto___112783]));

var G__112784 = (i__4731__auto___112783 + (1));
i__4731__auto___112783 = G__112784;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return tailrecursion.priority_map.priority_map_keyfn.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

tailrecursion.priority_map.priority_map_keyfn.cljs$core$IFn$_invoke$arity$variadic = (function (keyfn,keyvals){
var in$ = cljs.core.seq.call(null,keyvals);
var out = tailrecursion.priority_map.pm_empty_keyfn.call(null,keyfn);
while(true){
if(in$){
var G__112785 = cljs.core.nnext.call(null,in$);
var G__112786 = cljs.core.assoc.call(null,out,cljs.core.first.call(null,in$),cljs.core.second.call(null,in$));
in$ = G__112785;
out = G__112786;
continue;
} else {
return out;
}
break;
}
});

tailrecursion.priority_map.priority_map_keyfn.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
tailrecursion.priority_map.priority_map_keyfn.cljs$lang$applyTo = (function (seq112780){
var G__112781 = cljs.core.first.call(null,seq112780);
var seq112780__$1 = cljs.core.next.call(null,seq112780);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__112781,seq112780__$1);
});

/**
 * keyval => key val
 *   Returns a new priority map with supplied
 *   mappings, using the supplied keyfn and comparator.
 */
tailrecursion.priority_map.priority_map_keyfn_by = (function tailrecursion$priority_map$priority_map_keyfn_by(var_args){
var args__4736__auto__ = [];
var len__4730__auto___112790 = arguments.length;
var i__4731__auto___112791 = (0);
while(true){
if((i__4731__auto___112791 < len__4730__auto___112790)){
args__4736__auto__.push((arguments[i__4731__auto___112791]));

var G__112792 = (i__4731__auto___112791 + (1));
i__4731__auto___112791 = G__112792;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((2) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((2)),(0),null)):null);
return tailrecursion.priority_map.priority_map_keyfn_by.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4737__auto__);
});

tailrecursion.priority_map.priority_map_keyfn_by.cljs$core$IFn$_invoke$arity$variadic = (function (keyfn,comparator,keyvals){
var in$ = cljs.core.seq.call(null,keyvals);
var out = tailrecursion.priority_map.pm_empty_keyfn.call(null,keyfn,comparator);
while(true){
if(in$){
var G__112793 = cljs.core.nnext.call(null,in$);
var G__112794 = cljs.core.assoc.call(null,out,cljs.core.first.call(null,in$),cljs.core.second.call(null,in$));
in$ = G__112793;
out = G__112794;
continue;
} else {
return out;
}
break;
}
});

tailrecursion.priority_map.priority_map_keyfn_by.cljs$lang$maxFixedArity = (2);

/** @this {Function} */
tailrecursion.priority_map.priority_map_keyfn_by.cljs$lang$applyTo = (function (seq112787){
var G__112788 = cljs.core.first.call(null,seq112787);
var seq112787__$1 = cljs.core.next.call(null,seq112787);
var G__112789 = cljs.core.first.call(null,seq112787__$1);
var seq112787__$2 = cljs.core.next.call(null,seq112787__$1);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__112788,G__112789,seq112787__$2);
});

