// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.index');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('clojure.data.avl');
goog.require('fluree.db.dbproto');
goog.require('cljs.core.async');
goog.require('fluree.db.util.async');
goog.require('fluree.db.util.log');

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.IndexConfig = (function (index_type,comparator,historyComparator,__meta,__extmap,__hash){
this.index_type = index_type;
this.comparator = comparator;
this.historyComparator = historyComparator;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.index.IndexConfig.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.index.IndexConfig.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k105166,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__105170 = k105166;
var G__105170__$1 = (((G__105170 instanceof cljs.core.Keyword))?G__105170.fqn:null);
switch (G__105170__$1) {
case "index-type":
return self__.index_type;

break;
case "comparator":
return self__.comparator;

break;
case "historyComparator":
return self__.historyComparator;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k105166,else__4388__auto__);

}
});

fluree.db.index.IndexConfig.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__105171){
var vec__105172 = p__105171;
var k__4408__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105172,(0),null);
var v__4409__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105172,(1),null);
return (f__4405__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4405__auto__.cljs$core$IFn$_invoke$arity$3(ret__4407__auto__,k__4408__auto__,v__4409__auto__) : f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__));
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.index.IndexConfig.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer(writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer(writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.index.IndexConfig{",", ","}",opts__4401__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$index_DASH_type,self__.index_type],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$comparator,self__.comparator],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$historyComparator,self__.historyComparator],null))], null),self__.__extmap));
});

fluree.db.index.IndexConfig.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__105165){
var self__ = this;
var G__105165__$1 = this;
return (new cljs.core.RecordIter((0),G__105165__$1,3,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$index_DASH_type,cljs.core.cst$kw$comparator,cljs.core.cst$kw$historyComparator], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
});

fluree.db.index.IndexConfig.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.index.IndexConfig.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.index.IndexConfig.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (3 + cljs.core.count(self__.__extmap));
});

fluree.db.index.IndexConfig.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = (function (){var fexpr__105175 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (1512230614 ^ cljs.core.hash_unordered_coll(coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
;
return fexpr__105175(this__4381__auto____$1);
})();
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.index.IndexConfig.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this105167,other105168){
var self__ = this;
var this105167__$1 = this;
return (((!((other105168 == null)))) && ((this105167__$1.constructor === other105168.constructor)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105167__$1.index_type,other105168.index_type)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105167__$1.comparator,other105168.comparator)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105167__$1.historyComparator,other105168.historyComparator)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105167__$1.__extmap,other105168.__extmap)));
});

fluree.db.index.IndexConfig.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$historyComparator,null,cljs.core.cst$kw$comparator,null,cljs.core.cst$kw$index_DASH_type,null], null), null),k__4395__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.index.IndexConfig.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__105165){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__105176 = cljs.core.keyword_identical_QMARK_;
var expr__105177 = k__4393__auto__;
if(cljs.core.truth_((function (){var G__105179 = cljs.core.cst$kw$index_DASH_type;
var G__105180 = expr__105177;
return (pred__105176.cljs$core$IFn$_invoke$arity$2 ? pred__105176.cljs$core$IFn$_invoke$arity$2(G__105179,G__105180) : pred__105176.call(null,G__105179,G__105180));
})())){
return (new fluree.db.index.IndexConfig(G__105165,self__.comparator,self__.historyComparator,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105181 = cljs.core.cst$kw$comparator;
var G__105182 = expr__105177;
return (pred__105176.cljs$core$IFn$_invoke$arity$2 ? pred__105176.cljs$core$IFn$_invoke$arity$2(G__105181,G__105182) : pred__105176.call(null,G__105181,G__105182));
})())){
return (new fluree.db.index.IndexConfig(self__.index_type,G__105165,self__.historyComparator,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105183 = cljs.core.cst$kw$historyComparator;
var G__105184 = expr__105177;
return (pred__105176.cljs$core$IFn$_invoke$arity$2 ? pred__105176.cljs$core$IFn$_invoke$arity$2(G__105183,G__105184) : pred__105176.call(null,G__105183,G__105184));
})())){
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,G__105165,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4393__auto__,G__105165),null));
}
}
}
});

fluree.db.index.IndexConfig.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(cljs.core.cst$kw$index_DASH_type,self__.index_type,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$comparator,self__.comparator,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$historyComparator,self__.historyComparator,null))], null),self__.__extmap));
});

fluree.db.index.IndexConfig.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__105165){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,G__105165,self__.__extmap,self__.__hash));
});

fluree.db.index.IndexConfig.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.index.IndexConfig.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$index_DASH_type,cljs.core.cst$sym$comparator,cljs.core.cst$sym$historyComparator], null);
});

fluree.db.index.IndexConfig.cljs$lang$type = true;

fluree.db.index.IndexConfig.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.index/IndexConfig",null,(1),null));
});

fluree.db.index.IndexConfig.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write(writer__4429__auto__,"fluree.db.index/IndexConfig");
});

/**
 * Positional factory function for fluree.db.index/IndexConfig.
 */
fluree.db.index.__GT_IndexConfig = (function fluree$db$index$__GT_IndexConfig(index_type,comparator,historyComparator){
return (new fluree.db.index.IndexConfig(index_type,comparator,historyComparator,null,null,null));
});

/**
 * Factory function for fluree.db.index/IndexConfig, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_IndexConfig = (function fluree$db$index$map__GT_IndexConfig(G__105169){
var extmap__4424__auto__ = (function (){var G__105185 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__105169,cljs.core.cst$kw$index_DASH_type,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$comparator,cljs.core.cst$kw$historyComparator], 0));
if(cljs.core.record_QMARK_(G__105169)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__105185);
} else {
return G__105185;
}
})();
return (new fluree.db.index.IndexConfig(cljs.core.cst$kw$index_DASH_type.cljs$core$IFn$_invoke$arity$1(G__105169),cljs.core.cst$kw$comparator.cljs$core$IFn$_invoke$arity$1(G__105169),cljs.core.cst$kw$historyComparator.cljs$core$IFn$_invoke$arity$1(G__105169),null,cljs.core.not_empty(extmap__4424__auto__),null));
});


/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {fluree.db.dbproto.INode}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.IndexNode = (function (block,t,rhs,children,config,leftmost_QMARK_,__meta,__extmap,__hash){
this.block = block;
this.t = t;
this.rhs = rhs;
this.children = children;
this.config = config;
this.leftmost_QMARK_ = leftmost_QMARK_;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.index.IndexNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.index.IndexNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k105188,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__105192 = k105188;
var G__105192__$1 = (((G__105192 instanceof cljs.core.Keyword))?G__105192.fqn:null);
switch (G__105192__$1) {
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "rhs":
return self__.rhs;

break;
case "children":
return self__.children;

break;
case "config":
return self__.config;

break;
case "leftmost?":
return self__.leftmost_QMARK_;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k105188,else__4388__auto__);

}
});

fluree.db.index.IndexNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__105193){
var vec__105194 = p__105193;
var k__4408__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105194,(0),null);
var v__4409__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105194,(1),null);
return (f__4405__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4405__auto__.cljs$core$IFn$_invoke$arity$3(ret__4407__auto__,k__4408__auto__,v__4409__auto__) : f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__));
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.index.IndexNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer(writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer(writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.index.IndexNode{",", ","}",opts__4401__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$block,self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$t,self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$rhs,self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$children,self__.children],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$config,self__.config],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$leftmost_QMARK_,self__.leftmost_QMARK_],null))], null),self__.__extmap));
});

fluree.db.index.IndexNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__105187){
var self__ = this;
var G__105187__$1 = this;
return (new cljs.core.RecordIter((0),G__105187__$1,6,new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$block,cljs.core.cst$kw$t,cljs.core.cst$kw$rhs,cljs.core.cst$kw$children,cljs.core.cst$kw$config,cljs.core.cst$kw$leftmost_QMARK_], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,this$__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,this$__$1){
return (function (state_105198){
var state_val_105199 = (state_105198[(1)]);
if((state_val_105199 === (1))){
var state_105198__$1 = state_105198;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105198__$1,this$__$1);
} else {
return null;
}
});})(c__99809__auto__,this$__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,this$__$1){
return (function() {
var fluree$db$index$state_machine__99703__auto__ = null;
var fluree$db$index$state_machine__99703__auto____0 = (function (){
var statearr_105200 = [null,null,null,null,null,null,null];
(statearr_105200[(0)] = fluree$db$index$state_machine__99703__auto__);

(statearr_105200[(1)] = (1));

return statearr_105200;
});
var fluree$db$index$state_machine__99703__auto____1 = (function (state_105198){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105198);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105201){if((e105201 instanceof Object)){
var ex__99706__auto__ = e105201;
var statearr_105202_105292 = state_105198;
(statearr_105202_105292[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105198);

return cljs.core.cst$kw$recur;
} else {
throw e105201;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105293 = state_105198;
state_105198 = G__105293;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$index$state_machine__99703__auto__ = function(state_105198){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__99703__auto____1.call(this,state_105198);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__99703__auto____0;
fluree$db$index$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__99703__auto____1;
return fluree$db$index$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,this$__$1))
})();
var state__99811__auto__ = (function (){var statearr_105203 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105203[(6)] = c__99809__auto__);

return statearr_105203;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,this$__$1))
);

return c__99809__auto__;
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.key(cljs.core.first(self__.children));
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
});

fluree.db.index.IndexNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.index.IndexNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.index.IndexNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (6 + cljs.core.count(self__.__extmap));
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
return cljs.core.val((function (){var or__4131__auto__ = clojure.data.avl.nearest(self__.children,cljs.core._LT__EQ_,flake);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.first(self__.children);
}
})());
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_after$arity$2 = (function (_,flake){
var self__ = this;
var ___$1 = this;
return cljs.core.val((function (){var or__4131__auto__ = clojure.data.avl.nearest(self__.children,cljs.core._GT_,flake);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.last(self__.children);
}
})());
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_leaf$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,this$__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,this$__$1){
return (function (state_105225){
var state_val_105226 = (state_105225[(1)]);
if((state_val_105226 === (7))){
var inst_105221 = (state_105225[(2)]);
var state_105225__$1 = state_105225;
var statearr_105227_105294 = state_105225__$1;
(statearr_105227_105294[(2)] = inst_105221);


cljs.core.async.impl.ioc_helpers.process_exception(state_105225__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105226 === (1))){
var state_105225__$1 = state_105225;
var statearr_105228_105295 = state_105225__$1;
(statearr_105228_105295[(2)] = null);

(statearr_105228_105295[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105226 === (4))){
var inst_105208 = (state_105225[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105225,(3),Error,null,(2));
var inst_105208__$1 = this$__$1.fluree$db$dbproto$INode$_lookup$arity$2(null,flake);
var inst_105209 = cljs.core.cst$kw$leaf.cljs$core$IFn$_invoke$arity$1(inst_105208__$1);
var state_105225__$1 = (function (){var statearr_105229 = state_105225;
(statearr_105229[(7)] = inst_105208__$1);

return statearr_105229;
})();
if(cljs.core.truth_(inst_105209)){
var statearr_105230_105296 = state_105225__$1;
(statearr_105230_105296[(1)] = (5));

} else {
var statearr_105231_105297 = state_105225__$1;
(statearr_105231_105297[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105226 === (6))){
var inst_105208 = (state_105225[(7)]);
var inst_105212 = fluree.db.dbproto._resolve(inst_105208);
var state_105225__$1 = state_105225;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105225__$1,(9),inst_105212);
} else {
if((state_val_105226 === (3))){
var inst_105204 = (state_105225[(2)]);
var state_105225__$1 = state_105225;
var statearr_105232_105298 = state_105225__$1;
(statearr_105232_105298[(2)] = inst_105204);


cljs.core.async.impl.ioc_helpers.process_exception(state_105225__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105226 === (2))){
var inst_105223 = (state_105225[(2)]);
var state_105225__$1 = state_105225;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105225__$1,inst_105223);
} else {
if((state_val_105226 === (9))){
var inst_105214 = (state_105225[(2)]);
var inst_105215 = fluree.db.util.async.throw_err(inst_105214);
var inst_105216 = fluree.db.dbproto._lookup_leaf(inst_105215,flake);
var state_105225__$1 = state_105225;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105225__$1,(8),inst_105216);
} else {
if((state_val_105226 === (5))){
var inst_105208 = (state_105225[(7)]);
var state_105225__$1 = state_105225;
var statearr_105233_105299 = state_105225__$1;
(statearr_105233_105299[(2)] = inst_105208);

(statearr_105233_105299[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105226 === (8))){
var inst_105218 = (state_105225[(2)]);
var inst_105219 = fluree.db.util.async.throw_err(inst_105218);
var state_105225__$1 = state_105225;
var statearr_105234_105300 = state_105225__$1;
(statearr_105234_105300[(2)] = inst_105219);

(statearr_105234_105300[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,this$__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,this$__$1){
return (function() {
var fluree$db$index$state_machine__99703__auto__ = null;
var fluree$db$index$state_machine__99703__auto____0 = (function (){
var statearr_105235 = [null,null,null,null,null,null,null,null];
(statearr_105235[(0)] = fluree$db$index$state_machine__99703__auto__);

(statearr_105235[(1)] = (1));

return statearr_105235;
});
var fluree$db$index$state_machine__99703__auto____1 = (function (state_105225){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105225);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105236){if((e105236 instanceof Object)){
var ex__99706__auto__ = e105236;
var statearr_105237_105301 = state_105225;
(statearr_105237_105301[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105225);

return cljs.core.cst$kw$recur;
} else {
throw e105236;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105302 = state_105225;
state_105225 = G__105302;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$index$state_machine__99703__auto__ = function(state_105225){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__99703__auto____1.call(this,state_105225);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__99703__auto____0;
fluree$db$index$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__99703__auto____1;
return fluree$db$index$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,this$__$1))
})();
var state__99811__auto__ = (function (){var statearr_105238 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105238[(6)] = c__99809__auto__);

return statearr_105238;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,this$__$1))
);

return c__99809__auto__;
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_leaf_after$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,this$__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,this$__$1){
return (function (state_105260){
var state_val_105261 = (state_105260[(1)]);
if((state_val_105261 === (7))){
var inst_105256 = (state_105260[(2)]);
var state_105260__$1 = state_105260;
var statearr_105262_105303 = state_105260__$1;
(statearr_105262_105303[(2)] = inst_105256);


cljs.core.async.impl.ioc_helpers.process_exception(state_105260__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105261 === (1))){
var state_105260__$1 = state_105260;
var statearr_105263_105304 = state_105260__$1;
(statearr_105263_105304[(2)] = null);

(statearr_105263_105304[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105261 === (4))){
var inst_105243 = (state_105260[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105260,(3),Error,null,(2));
var inst_105243__$1 = this$__$1.fluree$db$dbproto$INode$_lookup_after$arity$2(null,flake);
var inst_105244 = cljs.core.cst$kw$leaf.cljs$core$IFn$_invoke$arity$1(inst_105243__$1);
var state_105260__$1 = (function (){var statearr_105264 = state_105260;
(statearr_105264[(7)] = inst_105243__$1);

return statearr_105264;
})();
if(cljs.core.truth_(inst_105244)){
var statearr_105265_105305 = state_105260__$1;
(statearr_105265_105305[(1)] = (5));

} else {
var statearr_105266_105306 = state_105260__$1;
(statearr_105266_105306[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105261 === (6))){
var inst_105243 = (state_105260[(7)]);
var inst_105247 = fluree.db.dbproto._resolve(inst_105243);
var state_105260__$1 = state_105260;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105260__$1,(9),inst_105247);
} else {
if((state_val_105261 === (3))){
var inst_105239 = (state_105260[(2)]);
var state_105260__$1 = state_105260;
var statearr_105267_105307 = state_105260__$1;
(statearr_105267_105307[(2)] = inst_105239);


cljs.core.async.impl.ioc_helpers.process_exception(state_105260__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105261 === (2))){
var inst_105258 = (state_105260[(2)]);
var state_105260__$1 = state_105260;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105260__$1,inst_105258);
} else {
if((state_val_105261 === (9))){
var inst_105249 = (state_105260[(2)]);
var inst_105250 = fluree.db.util.async.throw_err(inst_105249);
var inst_105251 = fluree.db.dbproto._lookup_leaf_after(inst_105250,flake);
var state_105260__$1 = state_105260;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105260__$1,(8),inst_105251);
} else {
if((state_val_105261 === (5))){
var inst_105243 = (state_105260[(7)]);
var state_105260__$1 = state_105260;
var statearr_105268_105308 = state_105260__$1;
(statearr_105268_105308[(2)] = inst_105243);

(statearr_105268_105308[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105261 === (8))){
var inst_105253 = (state_105260[(2)]);
var inst_105254 = fluree.db.util.async.throw_err(inst_105253);
var state_105260__$1 = state_105260;
var statearr_105269_105309 = state_105260__$1;
(statearr_105269_105309[(2)] = inst_105254);

(statearr_105269_105309[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,this$__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,this$__$1){
return (function() {
var fluree$db$index$state_machine__99703__auto__ = null;
var fluree$db$index$state_machine__99703__auto____0 = (function (){
var statearr_105270 = [null,null,null,null,null,null,null,null];
(statearr_105270[(0)] = fluree$db$index$state_machine__99703__auto__);

(statearr_105270[(1)] = (1));

return statearr_105270;
});
var fluree$db$index$state_machine__99703__auto____1 = (function (state_105260){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105260);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105271){if((e105271 instanceof Object)){
var ex__99706__auto__ = e105271;
var statearr_105272_105310 = state_105260;
(statearr_105272_105310[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105260);

return cljs.core.cst$kw$recur;
} else {
throw e105271;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105311 = state_105260;
state_105260 = G__105311;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$index$state_machine__99703__auto__ = function(state_105260){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__99703__auto____1.call(this,state_105260);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__99703__auto____0;
fluree$db$index$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__99703__auto____1;
return fluree$db$index$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,this$__$1))
})();
var state__99811__auto__ = (function (){var statearr_105273 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105273[(6)] = c__99809__auto__);

return statearr_105273;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,this$__$1))
);

return c__99809__auto__;
});

fluree.db.index.IndexNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = (function (){var fexpr__105274 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (659789215 ^ cljs.core.hash_unordered_coll(coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
;
return fexpr__105274(this__4381__auto____$1);
})();
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.index.IndexNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this105189,other105190){
var self__ = this;
var this105189__$1 = this;
return (((!((other105190 == null)))) && ((this105189__$1.constructor === other105190.constructor)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105189__$1.block,other105190.block)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105189__$1.t,other105190.t)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105189__$1.rhs,other105190.rhs)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105189__$1.children,other105190.children)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105189__$1.config,other105190.config)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105189__$1.leftmost_QMARK_,other105190.leftmost_QMARK_)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105189__$1.__extmap,other105190.__extmap)));
});

fluree.db.index.IndexNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 6, [cljs.core.cst$kw$children,null,cljs.core.cst$kw$block,null,cljs.core.cst$kw$config,null,cljs.core.cst$kw$leftmost_QMARK_,null,cljs.core.cst$kw$t,null,cljs.core.cst$kw$rhs,null], null), null),k__4395__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.index.IndexNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__105187){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__105275 = cljs.core.keyword_identical_QMARK_;
var expr__105276 = k__4393__auto__;
if(cljs.core.truth_((function (){var G__105278 = cljs.core.cst$kw$block;
var G__105279 = expr__105276;
return (pred__105275.cljs$core$IFn$_invoke$arity$2 ? pred__105275.cljs$core$IFn$_invoke$arity$2(G__105278,G__105279) : pred__105275.call(null,G__105278,G__105279));
})())){
return (new fluree.db.index.IndexNode(G__105187,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105280 = cljs.core.cst$kw$t;
var G__105281 = expr__105276;
return (pred__105275.cljs$core$IFn$_invoke$arity$2 ? pred__105275.cljs$core$IFn$_invoke$arity$2(G__105280,G__105281) : pred__105275.call(null,G__105280,G__105281));
})())){
return (new fluree.db.index.IndexNode(self__.block,G__105187,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105282 = cljs.core.cst$kw$rhs;
var G__105283 = expr__105276;
return (pred__105275.cljs$core$IFn$_invoke$arity$2 ? pred__105275.cljs$core$IFn$_invoke$arity$2(G__105282,G__105283) : pred__105275.call(null,G__105282,G__105283));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,G__105187,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105284 = cljs.core.cst$kw$children;
var G__105285 = expr__105276;
return (pred__105275.cljs$core$IFn$_invoke$arity$2 ? pred__105275.cljs$core$IFn$_invoke$arity$2(G__105284,G__105285) : pred__105275.call(null,G__105284,G__105285));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,G__105187,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105286 = cljs.core.cst$kw$config;
var G__105287 = expr__105276;
return (pred__105275.cljs$core$IFn$_invoke$arity$2 ? pred__105275.cljs$core$IFn$_invoke$arity$2(G__105286,G__105287) : pred__105275.call(null,G__105286,G__105287));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,G__105187,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105288 = cljs.core.cst$kw$leftmost_QMARK_;
var G__105289 = expr__105276;
return (pred__105275.cljs$core$IFn$_invoke$arity$2 ? pred__105275.cljs$core$IFn$_invoke$arity$2(G__105288,G__105289) : pred__105275.call(null,G__105288,G__105289));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,G__105187,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4393__auto__,G__105187),null));
}
}
}
}
}
}
});

fluree.db.index.IndexNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(cljs.core.cst$kw$block,self__.block,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$t,self__.t,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$rhs,self__.rhs,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$children,self__.children,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$config,self__.config,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$leftmost_QMARK_,self__.leftmost_QMARK_,null))], null),self__.__extmap));
});

fluree.db.index.IndexNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__105187){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,G__105187,self__.__extmap,self__.__hash));
});

fluree.db.index.IndexNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.index.IndexNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$block,cljs.core.cst$sym$t,cljs.core.cst$sym$rhs,cljs.core.cst$sym$children,cljs.core.cst$sym$config,cljs.core.cst$sym$leftmost_QMARK_], null);
});

fluree.db.index.IndexNode.cljs$lang$type = true;

fluree.db.index.IndexNode.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.index/IndexNode",null,(1),null));
});

fluree.db.index.IndexNode.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write(writer__4429__auto__,"fluree.db.index/IndexNode");
});

/**
 * Positional factory function for fluree.db.index/IndexNode.
 */
fluree.db.index.__GT_IndexNode = (function fluree$db$index$__GT_IndexNode(block,t,rhs,children,config,leftmost_QMARK_){
return (new fluree.db.index.IndexNode(block,t,rhs,children,config,leftmost_QMARK_,null,null,null));
});

/**
 * Factory function for fluree.db.index/IndexNode, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_IndexNode = (function fluree$db$index$map__GT_IndexNode(G__105191){
var extmap__4424__auto__ = (function (){var G__105290 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__105191,cljs.core.cst$kw$block,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$t,cljs.core.cst$kw$rhs,cljs.core.cst$kw$children,cljs.core.cst$kw$config,cljs.core.cst$kw$leftmost_QMARK_], 0));
if(cljs.core.record_QMARK_(G__105191)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__105290);
} else {
return G__105290;
}
})();
return (new fluree.db.index.IndexNode(cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(G__105191),cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(G__105191),cljs.core.cst$kw$rhs.cljs$core$IFn$_invoke$arity$1(G__105191),cljs.core.cst$kw$children.cljs$core$IFn$_invoke$arity$1(G__105191),cljs.core.cst$kw$config.cljs$core$IFn$_invoke$arity$1(G__105191),cljs.core.cst$kw$leftmost_QMARK_.cljs$core$IFn$_invoke$arity$1(G__105191),null,cljs.core.not_empty(extmap__4424__auto__),null));
});

fluree.db.index.index_node_QMARK_ = (function fluree$db$index$index_node_QMARK_(node){
return (node instanceof fluree.db.index.IndexNode);
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {fluree.db.dbproto.INode}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.DataNode = (function (block,t,flakes,rhs,config,__meta,__extmap,__hash){
this.block = block;
this.t = t;
this.flakes = flakes;
this.rhs = rhs;
this.config = config;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.index.DataNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.index.DataNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k105313,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__105317 = k105313;
var G__105317__$1 = (((G__105317 instanceof cljs.core.Keyword))?G__105317.fqn:null);
switch (G__105317__$1) {
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "flakes":
return self__.flakes;

break;
case "rhs":
return self__.rhs;

break;
case "config":
return self__.config;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k105313,else__4388__auto__);

}
});

fluree.db.index.DataNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__105318){
var vec__105319 = p__105318;
var k__4408__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105319,(0),null);
var v__4409__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105319,(1),null);
return (f__4405__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4405__auto__.cljs$core$IFn$_invoke$arity$3(ret__4407__auto__,k__4408__auto__,v__4409__auto__) : f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__));
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.index.DataNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer(writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer(writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.index.DataNode{",", ","}",opts__4401__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$block,self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$t,self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$flakes,self__.flakes],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$rhs,self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$config,self__.config],null))], null),self__.__extmap));
});

fluree.db.index.DataNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__105312){
var self__ = this;
var G__105312__$1 = this;
return (new cljs.core.RecordIter((0),G__105312__$1,5,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$block,cljs.core.cst$kw$t,cljs.core.cst$kw$flakes,cljs.core.cst$kw$rhs,cljs.core.cst$kw$config], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,this$__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,this$__$1){
return (function (state_105323){
var state_val_105324 = (state_105323[(1)]);
if((state_val_105324 === (1))){
var state_105323__$1 = state_105323;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105323__$1,this$__$1);
} else {
return null;
}
});})(c__99809__auto__,this$__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,this$__$1){
return (function() {
var fluree$db$index$state_machine__99703__auto__ = null;
var fluree$db$index$state_machine__99703__auto____0 = (function (){
var statearr_105325 = [null,null,null,null,null,null,null];
(statearr_105325[(0)] = fluree$db$index$state_machine__99703__auto__);

(statearr_105325[(1)] = (1));

return statearr_105325;
});
var fluree$db$index$state_machine__99703__auto____1 = (function (state_105323){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105323);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105326){if((e105326 instanceof Object)){
var ex__99706__auto__ = e105326;
var statearr_105327_105356 = state_105323;
(statearr_105327_105356[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105323);

return cljs.core.cst$kw$recur;
} else {
throw e105326;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105357 = state_105323;
state_105323 = G__105357;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$index$state_machine__99703__auto__ = function(state_105323){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__99703__auto____1.call(this,state_105323);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__99703__auto____0;
fluree$db$index$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__99703__auto____1;
return fluree$db$index$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,this$__$1))
})();
var state__99811__auto__ = (function (){var statearr_105328 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105328[(6)] = c__99809__auto__);

return statearr_105328;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,this$__$1))
);

return c__99809__auto__;
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_resolve_history$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("-resolve-history called on DATA NODE!!!",cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.first(self__.flakes);
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
});

fluree.db.index.DataNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.index.DataNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.index.DataNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (5 + cljs.core.count(self__.__extmap));
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$_lookup$arity$2 = (function (root,flake){
var self__ = this;
var root__$1 = this;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("-lookup was called on a data node, which shouldn't happen!",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error], null));
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$_lookup_leaf$arity$2 = (function (root,flake){
var self__ = this;
var root__$1 = this;
fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["-lookup-leaf was called on a data node, which shouldn't happen!"], 0));

var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,root__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,root__$1){
return (function (state_105334){
var state_val_105335 = (state_105334[(1)]);
if((state_val_105335 === (1))){
var inst_105329 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_105330 = [(500),cljs.core.cst$kw$db_SLASH_unexpected_DASH_error];
var inst_105331 = cljs.core.PersistentHashMap.fromArrays(inst_105329,inst_105330);
var inst_105332 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("-lookup-leaf was called on a data node, which shouldn't happen!",inst_105331);
var state_105334__$1 = state_105334;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105334__$1,inst_105332);
} else {
return null;
}
});})(c__99809__auto__,root__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,root__$1){
return (function() {
var fluree$db$index$state_machine__99703__auto__ = null;
var fluree$db$index$state_machine__99703__auto____0 = (function (){
var statearr_105336 = [null,null,null,null,null,null,null];
(statearr_105336[(0)] = fluree$db$index$state_machine__99703__auto__);

(statearr_105336[(1)] = (1));

return statearr_105336;
});
var fluree$db$index$state_machine__99703__auto____1 = (function (state_105334){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105334);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105337){if((e105337 instanceof Object)){
var ex__99706__auto__ = e105337;
var statearr_105338_105358 = state_105334;
(statearr_105338_105358[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105334);

return cljs.core.cst$kw$recur;
} else {
throw e105337;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105359 = state_105334;
state_105334 = G__105359;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$index$state_machine__99703__auto__ = function(state_105334){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__99703__auto____1.call(this,state_105334);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__99703__auto____0;
fluree$db$index$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__99703__auto____1;
return fluree$db$index$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,root__$1))
})();
var state__99811__auto__ = (function (){var statearr_105339 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105339[(6)] = c__99809__auto__);

return statearr_105339;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,root__$1))
);

return c__99809__auto__;
});

fluree.db.index.DataNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = (function (){var fexpr__105340 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (1312629141 ^ cljs.core.hash_unordered_coll(coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
;
return fexpr__105340(this__4381__auto____$1);
})();
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.index.DataNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this105314,other105315){
var self__ = this;
var this105314__$1 = this;
return (((!((other105315 == null)))) && ((this105314__$1.constructor === other105315.constructor)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105314__$1.block,other105315.block)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105314__$1.t,other105315.t)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105314__$1.flakes,other105315.flakes)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105314__$1.rhs,other105315.rhs)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105314__$1.config,other105315.config)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this105314__$1.__extmap,other105315.__extmap)));
});

fluree.db.index.DataNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 5, [cljs.core.cst$kw$block,null,cljs.core.cst$kw$config,null,cljs.core.cst$kw$t,null,cljs.core.cst$kw$flakes,null,cljs.core.cst$kw$rhs,null], null), null),k__4395__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.index.DataNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__105312){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__105341 = cljs.core.keyword_identical_QMARK_;
var expr__105342 = k__4393__auto__;
if(cljs.core.truth_((function (){var G__105344 = cljs.core.cst$kw$block;
var G__105345 = expr__105342;
return (pred__105341.cljs$core$IFn$_invoke$arity$2 ? pred__105341.cljs$core$IFn$_invoke$arity$2(G__105344,G__105345) : pred__105341.call(null,G__105344,G__105345));
})())){
return (new fluree.db.index.DataNode(G__105312,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105346 = cljs.core.cst$kw$t;
var G__105347 = expr__105342;
return (pred__105341.cljs$core$IFn$_invoke$arity$2 ? pred__105341.cljs$core$IFn$_invoke$arity$2(G__105346,G__105347) : pred__105341.call(null,G__105346,G__105347));
})())){
return (new fluree.db.index.DataNode(self__.block,G__105312,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105348 = cljs.core.cst$kw$flakes;
var G__105349 = expr__105342;
return (pred__105341.cljs$core$IFn$_invoke$arity$2 ? pred__105341.cljs$core$IFn$_invoke$arity$2(G__105348,G__105349) : pred__105341.call(null,G__105348,G__105349));
})())){
return (new fluree.db.index.DataNode(self__.block,self__.t,G__105312,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105350 = cljs.core.cst$kw$rhs;
var G__105351 = expr__105342;
return (pred__105341.cljs$core$IFn$_invoke$arity$2 ? pred__105341.cljs$core$IFn$_invoke$arity$2(G__105350,G__105351) : pred__105341.call(null,G__105350,G__105351));
})())){
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,G__105312,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__105352 = cljs.core.cst$kw$config;
var G__105353 = expr__105342;
return (pred__105341.cljs$core$IFn$_invoke$arity$2 ? pred__105341.cljs$core$IFn$_invoke$arity$2(G__105352,G__105353) : pred__105341.call(null,G__105352,G__105353));
})())){
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,G__105312,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4393__auto__,G__105312),null));
}
}
}
}
}
});

fluree.db.index.DataNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(cljs.core.cst$kw$block,self__.block,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$t,self__.t,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$flakes,self__.flakes,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$rhs,self__.rhs,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$config,self__.config,null))], null),self__.__extmap));
});

fluree.db.index.DataNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__105312){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,G__105312,self__.__extmap,self__.__hash));
});

fluree.db.index.DataNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.index.DataNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$block,cljs.core.cst$sym$t,cljs.core.cst$sym$flakes,cljs.core.cst$sym$rhs,cljs.core.cst$sym$config], null);
});

fluree.db.index.DataNode.cljs$lang$type = true;

fluree.db.index.DataNode.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.index/DataNode",null,(1),null));
});

fluree.db.index.DataNode.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write(writer__4429__auto__,"fluree.db.index/DataNode");
});

/**
 * Positional factory function for fluree.db.index/DataNode.
 */
fluree.db.index.__GT_DataNode = (function fluree$db$index$__GT_DataNode(block,t,flakes,rhs,config){
return (new fluree.db.index.DataNode(block,t,flakes,rhs,config,null,null,null));
});

/**
 * Factory function for fluree.db.index/DataNode, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_DataNode = (function fluree$db$index$map__GT_DataNode(G__105316){
var extmap__4424__auto__ = (function (){var G__105354 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__105316,cljs.core.cst$kw$block,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$t,cljs.core.cst$kw$flakes,cljs.core.cst$kw$rhs,cljs.core.cst$kw$config], 0));
if(cljs.core.record_QMARK_(G__105316)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__105354);
} else {
return G__105354;
}
})();
return (new fluree.db.index.DataNode(cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(G__105316),cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(G__105316),cljs.core.cst$kw$flakes.cljs$core$IFn$_invoke$arity$1(G__105316),cljs.core.cst$kw$rhs.cljs$core$IFn$_invoke$arity$1(G__105316),cljs.core.cst$kw$config.cljs$core$IFn$_invoke$arity$1(G__105316),null,cljs.core.not_empty(extmap__4424__auto__),null));
});

/**
 * Creates a new data node
 */
fluree.db.index.data_node = (function fluree$db$index$data_node(block_id,t,flakes,rhs,config){
return fluree.db.index.__GT_DataNode(block_id,t,flakes,rhs,config);
});
fluree.db.index.data_node_QMARK_ = (function fluree$db$index$data_node_QMARK_(node){
return (node instanceof fluree.db.index.DataNode);
});
