// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.query.schema');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('fluree.db.flake');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.constants');
goog.require('fluree.db.util.async');
goog.require('fluree.db.query.range');
goog.require('cljs.core.async');
goog.require('fluree.db.util.log');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.schema');
/**
 * Takes an predicate name (string) and returns the namespace portion of it as a keyword.
 */
fluree.db.query.schema.pred_name__GT_keyword = (function fluree$db$query$schema$pred_name__GT_keyword(pred_name){
if(typeof pred_name === 'string'){
return cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(cljs.core.re_find(/[^\/]+$/,pred_name));
} else {
return null;
}
});
/**
 * Converts a tag sid for a _predicate/type attributes into a keyword of just the 'name'.
 */
fluree.db.query.schema.convert_type_to_kw = (function fluree$db$query$schema$convert_type_to_kw(type_tag_sid,db){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_104155){
var state_val_104156 = (state_104155[(1)]);
if((state_val_104156 === (1))){
var state_104155__$1 = state_104155;
var statearr_104157_104164 = state_104155__$1;
(statearr_104157_104164[(2)] = null);

(statearr_104157_104164[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104156 === (2))){
var inst_104153 = (state_104155[(2)]);
var state_104155__$1 = state_104155;
return cljs.core.async.impl.ioc_helpers.return_chan(state_104155__$1,inst_104153);
} else {
if((state_val_104156 === (3))){
var inst_104143 = (state_104155[(2)]);
var state_104155__$1 = state_104155;
var statearr_104158_104165 = state_104155__$1;
(statearr_104158_104165[(2)] = inst_104143);


cljs.core.async.impl.ioc_helpers.process_exception(state_104155__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_104156 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_104155,(3),Error,null,(2));
var inst_104147 = fluree.db.dbproto._tag.cljs$core$IFn$_invoke$arity$3(db,type_tag_sid,"_predicate/type");
var state_104155__$1 = state_104155;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_104155__$1,(5),inst_104147);
} else {
if((state_val_104156 === (5))){
var inst_104149 = (state_104155[(2)]);
var inst_104150 = fluree.db.util.async.throw_err(inst_104149);
var inst_104151 = cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(inst_104150);
var state_104155__$1 = state_104155;
var statearr_104159_104166 = state_104155__$1;
(statearr_104159_104166[(2)] = inst_104151);


cljs.core.async.impl.ioc_helpers.process_exception(state_104155__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto__ = null;
var fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto____0 = (function (){
var statearr_104160 = [null,null,null,null,null,null,null];
(statearr_104160[(0)] = fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto__);

(statearr_104160[(1)] = (1));

return statearr_104160;
});
var fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto____1 = (function (state_104155){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_104155);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e104161){if((e104161 instanceof Object)){
var ex__99706__auto__ = e104161;
var statearr_104162_104167 = state_104155;
(statearr_104162_104167[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_104155);

return cljs.core.cst$kw$recur;
} else {
throw e104161;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__104168 = state_104155;
state_104155 = G__104168;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto__ = function(state_104155){
switch(arguments.length){
case 0:
return fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto____1.call(this,state_104155);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto____0;
fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto____1;
return fluree$db$query$schema$convert_type_to_kw_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_104163 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_104163[(6)] = c__99809__auto__);

return statearr_104163;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.query.schema.pred_objects_unique_QMARK_ = (function fluree$db$query$schema$pred_objects_unique_QMARK_(db,pred_id){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_104197){
var state_val_104198 = (state_104197[(1)]);
if((state_val_104198 === (7))){
var inst_104182 = (state_104197[(7)]);
var state_104197__$1 = state_104197;
var statearr_104199_104216 = state_104197__$1;
(statearr_104199_104216[(2)] = inst_104182);

(statearr_104199_104216[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104198 === (1))){
var state_104197__$1 = state_104197;
var statearr_104200_104217 = state_104197__$1;
(statearr_104200_104217[(2)] = null);

(statearr_104200_104217[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104198 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_104197,(3),Error,null,(2));
var inst_104174 = (function (){return ((function (_,state_val_104198,c__99809__auto__){
return (function (p1__104169_SHARP_){
return p1__104169_SHARP_.o;
});
;})(_,state_val_104198,c__99809__auto__))
})();
var inst_104175 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104176 = [pred_id];
var inst_104177 = (new cljs.core.PersistentVector(null,1,(5),inst_104175,inst_104176,null));
var inst_104178 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(db,cljs.core.cst$kw$psot,cljs.core._EQ_,inst_104177);
var state_104197__$1 = (function (){var statearr_104201 = state_104197;
(statearr_104201[(8)] = inst_104174);

return statearr_104201;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_104197__$1,(5),inst_104178);
} else {
if((state_val_104198 === (6))){
var inst_104182 = (state_104197[(7)]);
var inst_104184 = cljs.core.empty_QMARK_(inst_104182);
var inst_104185 = (!(inst_104184));
var state_104197__$1 = state_104197;
var statearr_104202_104218 = state_104197__$1;
(statearr_104202_104218[(2)] = inst_104185);

(statearr_104202_104218[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104198 === (3))){
var inst_104170 = (state_104197[(2)]);
var state_104197__$1 = state_104197;
var statearr_104203_104219 = state_104197__$1;
(statearr_104203_104219[(2)] = inst_104170);


cljs.core.async.impl.ioc_helpers.process_exception(state_104197__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_104198 === (2))){
var inst_104195 = (state_104197[(2)]);
var state_104197__$1 = state_104197;
return cljs.core.async.impl.ioc_helpers.return_chan(state_104197__$1,inst_104195);
} else {
if((state_val_104198 === (11))){
var inst_104193 = (state_104197[(2)]);
var state_104197__$1 = state_104197;
var statearr_104204_104220 = state_104197__$1;
(statearr_104204_104220[(2)] = inst_104193);


cljs.core.async.impl.ioc_helpers.process_exception(state_104197__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_104198 === (9))){
var inst_104182 = (state_104197[(7)]);
var inst_104190 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.distinct_QMARK_,inst_104182);
var state_104197__$1 = state_104197;
var statearr_104205_104221 = state_104197__$1;
(statearr_104205_104221[(2)] = inst_104190);

(statearr_104205_104221[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104198 === (5))){
var inst_104174 = (state_104197[(8)]);
var inst_104182 = (state_104197[(7)]);
var inst_104180 = (state_104197[(2)]);
var inst_104181 = fluree.db.util.async.throw_err(inst_104180);
var inst_104182__$1 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_104174,inst_104181);
var state_104197__$1 = (function (){var statearr_104206 = state_104197;
(statearr_104206[(7)] = inst_104182__$1);

return statearr_104206;
})();
if(cljs.core.truth_(inst_104182__$1)){
var statearr_104207_104222 = state_104197__$1;
(statearr_104207_104222[(1)] = (6));

} else {
var statearr_104208_104223 = state_104197__$1;
(statearr_104208_104223[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104198 === (10))){
var state_104197__$1 = state_104197;
var statearr_104209_104224 = state_104197__$1;
(statearr_104209_104224[(2)] = true);

(statearr_104209_104224[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104198 === (8))){
var inst_104188 = (state_104197[(2)]);
var state_104197__$1 = state_104197;
if(cljs.core.truth_(inst_104188)){
var statearr_104210_104225 = state_104197__$1;
(statearr_104210_104225[(1)] = (9));

} else {
var statearr_104211_104226 = state_104197__$1;
(statearr_104211_104226[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto__ = null;
var fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto____0 = (function (){
var statearr_104212 = [null,null,null,null,null,null,null,null,null];
(statearr_104212[(0)] = fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto__);

(statearr_104212[(1)] = (1));

return statearr_104212;
});
var fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto____1 = (function (state_104197){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_104197);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e104213){if((e104213 instanceof Object)){
var ex__99706__auto__ = e104213;
var statearr_104214_104227 = state_104197;
(statearr_104214_104227[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_104197);

return cljs.core.cst$kw$recur;
} else {
throw e104213;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__104228 = state_104197;
state_104197 = G__104228;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto__ = function(state_104197){
switch(arguments.length){
case 0:
return fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto____1.call(this,state_104197);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto____0;
fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto____1;
return fluree$db$query$schema$pred_objects_unique_QMARK__$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_104215 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_104215[(6)] = c__99809__auto__);

return statearr_104215;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns a map of predicate changes with their respective old
 *   value and new value, both the key and value of the map are two-tuples as follows:
 *   {subid  {:new?  true
 *        :type  {:old :int :new :long}
 *        :index {:old nil  :new true }}}
 * 
 *   If the predicate being changed is the :type, it resolves the type _tag to its short keyword name
 * 
 *   When an old value does not exist, old-val is nil.
 *   If they subject being created is completely new, :new? true 
 */
fluree.db.query.schema.new_pred_changes = (function fluree$db$query$schema$new_pred_changes(db,tempids,flakes){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_104302){
var state_val_104303 = (state_104302[(1)]);
if((state_val_104303 === (7))){
var inst_104253 = (state_104302[(7)]);
var state_104302__$1 = state_104302;
var statearr_104304_104331 = state_104302__$1;
(statearr_104304_104331[(2)] = inst_104253);

(statearr_104304_104331[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (1))){
var state_104302__$1 = state_104302;
var statearr_104305_104332 = state_104302__$1;
(statearr_104305_104332[(2)] = null);

(statearr_104305_104332[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_104302,(3),Error,null,(2));
var inst_104235 = cljs.core.filter.cljs$core$IFn$_invoke$arity$2(fluree.db.util.schema.is_pred_flake_QMARK_,flakes);
var inst_104236 = cljs.core.PersistentHashSet.EMPTY;
var inst_104237 = cljs.core.vals(tempids);
var inst_104238 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_104236,inst_104237);
var inst_104239 = (function (){var pred_flakes = inst_104235;
var is_new_QMARK_ = inst_104238;
return ((function (pred_flakes,is_new_QMARK_,_,inst_104235,inst_104236,inst_104237,inst_104238,state_val_104303,c__99809__auto__){
return (function (p1__104229_SHARP_,p2__104230_SHARP_){
return cljs.core.assoc_in(p1__104229_SHARP_,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p2__104230_SHARP_.s,cljs.core.cst$kw$new_QMARK_], null),cljs.core.boolean$((function (){var G__104306 = p2__104230_SHARP_.s;
return (is_new_QMARK_.cljs$core$IFn$_invoke$arity$1 ? is_new_QMARK_.cljs$core$IFn$_invoke$arity$1(G__104306) : is_new_QMARK_.call(null,G__104306));
})()));
});
;})(pred_flakes,is_new_QMARK_,_,inst_104235,inst_104236,inst_104237,inst_104238,state_val_104303,c__99809__auto__))
})();
var inst_104240 = cljs.core.PersistentHashMap.EMPTY;
var inst_104241 = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(inst_104239,inst_104240,inst_104235);
var inst_104249 = cljs.core.seq(inst_104235);
var inst_104250 = cljs.core.first(inst_104249);
var inst_104251 = cljs.core.next(inst_104249);
var inst_104252 = inst_104235;
var inst_104253 = inst_104241;
var state_104302__$1 = (function (){var statearr_104307 = state_104302;
(statearr_104307[(8)] = inst_104251);

(statearr_104307[(9)] = inst_104252);

(statearr_104307[(7)] = inst_104253);

(statearr_104307[(10)] = inst_104250);

return statearr_104307;
})();
var statearr_104308_104333 = state_104302__$1;
(statearr_104308_104333[(2)] = null);

(statearr_104308_104333[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (15))){
var inst_104266 = (state_104302[(11)]);
var inst_104279 = (state_104302[(12)]);
var inst_104253 = (state_104302[(7)]);
var inst_104259 = (state_104302[(13)]);
var inst_104287 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104288 = inst_104259.s;
var inst_104289 = [inst_104288,inst_104266,cljs.core.cst$kw$new];
var inst_104290 = (new cljs.core.PersistentVector(null,3,(5),inst_104287,inst_104289,null));
var inst_104291 = cljs.core.assoc_in(inst_104253,inst_104290,inst_104279);
var state_104302__$1 = state_104302;
var statearr_104309_104334 = state_104302__$1;
(statearr_104309_104334[(2)] = inst_104291);

(statearr_104309_104334[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (13))){
var inst_104274 = (state_104302[(2)]);
var inst_104275 = fluree.db.util.async.throw_err(inst_104274);
var state_104302__$1 = state_104302;
var statearr_104310_104335 = state_104302__$1;
(statearr_104310_104335[(2)] = inst_104275);

(statearr_104310_104335[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (6))){
var inst_104298 = (state_104302[(2)]);
var state_104302__$1 = state_104302;
var statearr_104311_104336 = state_104302__$1;
(statearr_104311_104336[(2)] = inst_104298);


cljs.core.async.impl.ioc_helpers.process_exception(state_104302__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (3))){
var inst_104231 = (state_104302[(2)]);
var state_104302__$1 = state_104302;
var statearr_104312_104337 = state_104302__$1;
(statearr_104312_104337[(2)] = inst_104231);


cljs.core.async.impl.ioc_helpers.process_exception(state_104302__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (12))){
var inst_104268 = (state_104302[(14)]);
var inst_104279 = (state_104302[(2)]);
var state_104302__$1 = (function (){var statearr_104313 = state_104302;
(statearr_104313[(12)] = inst_104279);

return statearr_104313;
})();
if(cljs.core.truth_(inst_104268)){
var statearr_104314_104338 = state_104302__$1;
(statearr_104314_104338[(1)] = (14));

} else {
var statearr_104315_104339 = state_104302__$1;
(statearr_104315_104339[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (2))){
var inst_104300 = (state_104302[(2)]);
var state_104302__$1 = state_104302;
return cljs.core.async.impl.ioc_helpers.return_chan(state_104302__$1,inst_104300);
} else {
if((state_val_104303 === (11))){
var inst_104259 = (state_104302[(13)]);
var inst_104277 = inst_104259.o;
var state_104302__$1 = state_104302;
var statearr_104316_104340 = state_104302__$1;
(statearr_104316_104340[(2)] = inst_104277);

(statearr_104316_104340[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (9))){
var inst_104296 = (state_104302[(2)]);
var state_104302__$1 = state_104302;
var statearr_104317_104341 = state_104302__$1;
(statearr_104317_104341[(2)] = inst_104296);

(statearr_104317_104341[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (5))){
var inst_104252 = (state_104302[(9)]);
var inst_104259 = (state_104302[(13)]);
var inst_104258 = cljs.core.seq(inst_104252);
var inst_104259__$1 = cljs.core.first(inst_104258);
var inst_104260 = cljs.core.next(inst_104258);
var inst_104261 = cljs.core.not(inst_104259__$1);
var state_104302__$1 = (function (){var statearr_104318 = state_104302;
(statearr_104318[(15)] = inst_104260);

(statearr_104318[(13)] = inst_104259__$1);

return statearr_104318;
})();
if(inst_104261){
var statearr_104319_104342 = state_104302__$1;
(statearr_104319_104342[(1)] = (7));

} else {
var statearr_104320_104343 = state_104302__$1;
(statearr_104320_104343[(1)] = (8));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (14))){
var inst_104266 = (state_104302[(11)]);
var inst_104279 = (state_104302[(12)]);
var inst_104253 = (state_104302[(7)]);
var inst_104259 = (state_104302[(13)]);
var inst_104281 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104282 = inst_104259.s;
var inst_104283 = [inst_104282,inst_104266,cljs.core.cst$kw$old];
var inst_104284 = (new cljs.core.PersistentVector(null,3,(5),inst_104281,inst_104283,null));
var inst_104285 = cljs.core.assoc_in(inst_104253,inst_104284,inst_104279);
var state_104302__$1 = state_104302;
var statearr_104321_104344 = state_104302__$1;
(statearr_104321_104344[(2)] = inst_104285);

(statearr_104321_104344[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (16))){
var inst_104260 = (state_104302[(15)]);
var inst_104293 = (state_104302[(2)]);
var inst_104252 = inst_104260;
var inst_104253 = inst_104293;
var state_104302__$1 = (function (){var statearr_104322 = state_104302;
(statearr_104322[(9)] = inst_104252);

(statearr_104322[(7)] = inst_104253);

return statearr_104322;
})();
var statearr_104323_104345 = state_104302__$1;
(statearr_104323_104345[(2)] = null);

(statearr_104323_104345[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104303 === (10))){
var inst_104259 = (state_104302[(13)]);
var inst_104271 = inst_104259.o;
var inst_104272 = fluree.db.query.schema.convert_type_to_kw(inst_104271,db);
var state_104302__$1 = state_104302;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_104302__$1,(13),inst_104272);
} else {
if((state_val_104303 === (8))){
var inst_104266 = (state_104302[(11)]);
var inst_104259 = (state_104302[(13)]);
var inst_104264 = inst_104259.p;
var inst_104265 = fluree.db.dbproto._p_prop(db,cljs.core.cst$kw$name,inst_104264);
var inst_104266__$1 = fluree.db.query.schema.pred_name__GT_keyword(inst_104265);
var inst_104267 = inst_104259.op;
var inst_104268 = inst_104267 === false;
var inst_104269 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$type,inst_104266__$1);
var state_104302__$1 = (function (){var statearr_104324 = state_104302;
(statearr_104324[(11)] = inst_104266__$1);

(statearr_104324[(14)] = inst_104268);

return statearr_104324;
})();
if(inst_104269){
var statearr_104325_104346 = state_104302__$1;
(statearr_104325_104346[(1)] = (10));

} else {
var statearr_104326_104347 = state_104302__$1;
(statearr_104326_104347[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto__ = null;
var fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto____0 = (function (){
var statearr_104327 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_104327[(0)] = fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto__);

(statearr_104327[(1)] = (1));

return statearr_104327;
});
var fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto____1 = (function (state_104302){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_104302);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e104328){if((e104328 instanceof Object)){
var ex__99706__auto__ = e104328;
var statearr_104329_104348 = state_104302;
(statearr_104329_104348[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_104302);

return cljs.core.cst$kw$recur;
} else {
throw e104328;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__104349 = state_104302;
state_104302 = G__104349;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto__ = function(state_104302){
switch(arguments.length){
case 0:
return fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto____1.call(this,state_104302);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto____0;
fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto____1;
return fluree$db$query$schema$new_pred_changes_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_104330 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_104330[(6)] = c__99809__auto__);

return statearr_104330;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Throw an error if schema update attempt is invalid.
 */
fluree.db.query.schema.type_error = (function fluree$db$query$schema$type_error(var_args){
var G__104351 = arguments.length;
switch (G__104351) {
case 3:
return fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3 = (function (current_type,new_type,throw_QMARK_){
return fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$4(null,current_type,new_type,throw_QMARK_);
});

fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$4 = (function (db,current_type,new_type,throw_QMARK_){
var message = ["Cannot convert an _predicate from ",cljs.core.name(current_type)," to ",cljs.core.name(new_type),"."].join('');
if(cljs.core.truth_(throw_QMARK_)){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(message,new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_tx], null));
} else {
return db;
}
});

fluree.db.query.schema.type_error.cljs$lang$maxFixedArity = 4;

/**
 * Accepts a db (should have root permissions) and a map of predicate changes as produced by new-pred-changes.
 *   Returns a db with updated idxs if relevant, i.e. if non-unique predicate converted to unique
 *   If optional throw? parameter is true, will throw with an ex-info error.
 */
fluree.db.query.schema.predicate_change_error = (function fluree$db$query$schema$predicate_change_error(var_args){
var G__104354 = arguments.length;
switch (G__104354) {
case 2:
return fluree.db.query.schema.predicate_change_error.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.query.schema.predicate_change_error.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.schema.predicate_change_error.cljs$core$IFn$_invoke$arity$2 = (function (pred_changes,db){
return fluree.db.query.schema.predicate_change_error.cljs$core$IFn$_invoke$arity$3(pred_changes,db,false);
});

fluree.db.query.schema.predicate_change_error.cljs$core$IFn$_invoke$arity$3 = (function (pred_changes,db,throw_QMARK_){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_104658){
var state_val_104659 = (state_104658[(1)]);
if((state_val_104659 === (65))){
var inst_104522 = (state_104658[(7)]);
var state_104658__$1 = state_104658;
var G__104660_104825 = inst_104522;
var G__104660_104826__$1 = (((G__104660_104825 instanceof cljs.core.Keyword))?G__104660_104825.fqn:null);
switch (G__104660_104826__$1) {
case "long":
var statearr_104661_104828 = state_104658__$1;
(statearr_104661_104828[(1)] = (69));


break;
case "bigint":
var statearr_104662_104829 = state_104658__$1;
(statearr_104662_104829[(1)] = (73));


break;
case "double":
var statearr_104663_104830 = state_104658__$1;
(statearr_104663_104830[(1)] = (77));


break;
case "float":
var statearr_104664_104831 = state_104658__$1;
(statearr_104664_104831[(1)] = (81));


break;
case "bigdec":
var statearr_104665_104832 = state_104658__$1;
(statearr_104665_104832[(1)] = (85));


break;
case "string":
var statearr_104666_104833 = state_104658__$1;
(statearr_104666_104833[(1)] = (89));


break;
case "instant":
var statearr_104667_104834 = state_104658__$1;
(statearr_104667_104834[(1)] = (93));


break;
default:
var statearr_104668_104835 = state_104658__$1;
(statearr_104668_104835[(1)] = (97));



}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (70))){
var inst_104489 = (state_104658[(8)]);
var state_104658__$1 = state_104658;
var statearr_104669_104836 = state_104658__$1;
(statearr_104669_104836[(2)] = inst_104489);

(statearr_104669_104836[(1)] = (72));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (62))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104531 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3(inst_104521,inst_104522,throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104670_104837 = state_104658__$1;
(statearr_104670_104837[(2)] = inst_104531);

(statearr_104670_104837[(1)] = (64));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (74))){
var inst_104489 = (state_104658[(8)]);
var state_104658__$1 = state_104658;
var statearr_104671_104838 = state_104658__$1;
(statearr_104671_104838[(2)] = inst_104489);

(statearr_104671_104838[(1)] = (76));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (7))){
var inst_104378 = (state_104658[(10)]);
var state_104658__$1 = state_104658;
var statearr_104672_104839 = state_104658__$1;
(statearr_104672_104839[(2)] = inst_104378);

(statearr_104672_104839[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (59))){
var inst_104489 = (state_104658[(8)]);
var state_104658__$1 = state_104658;
var statearr_104673_104840 = state_104658__$1;
(statearr_104673_104840[(2)] = inst_104489);

(statearr_104673_104840[(1)] = (61));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (86))){
var inst_104489 = (state_104658[(8)]);
var state_104658__$1 = state_104658;
var statearr_104674_104841 = state_104658__$1;
(statearr_104674_104841[(2)] = inst_104489);

(statearr_104674_104841[(1)] = (88));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (20))){
var inst_104413 = (state_104658[(11)]);
var state_104658__$1 = state_104658;
var statearr_104675_104842 = state_104658__$1;
(statearr_104675_104842[(2)] = inst_104413);

(statearr_104675_104842[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (72))){
var inst_104542 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104676_104843 = state_104658__$1;
(statearr_104676_104843[(2)] = inst_104542);

(statearr_104676_104843[(1)] = (68));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (58))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104520 = (state_104658[(2)]);
var inst_104521__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_104520,cljs.core.cst$kw$old);
var inst_104522__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_104520,cljs.core.cst$kw$new);
var inst_104523 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_104522__$1,inst_104521__$1);
var state_104658__$1 = (function (){var statearr_104677 = state_104658;
(statearr_104677[(9)] = inst_104521__$1);

(statearr_104677[(7)] = inst_104522__$1);

return statearr_104677;
})();
if(inst_104523){
var statearr_104678_104844 = state_104658__$1;
(statearr_104678_104844[(1)] = (59));

} else {
var statearr_104679_104845 = state_104658__$1;
(statearr_104679_104845[(1)] = (60));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (60))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104526 = [cljs.core.cst$kw$bigint,null,cljs.core.cst$kw$string,null,cljs.core.cst$kw$bigdec,null];
var inst_104527 = (inst_104522.cljs$core$IFn$_invoke$arity$5 ? inst_104522.cljs$core$IFn$_invoke$arity$5(cljs.core.PersistentArrayMap,null,3,inst_104526,null) : inst_104522.call(null,cljs.core.PersistentArrayMap,null,3,inst_104526,null));
var inst_104528 = (inst_104522.cljs$core$IFn$_invoke$arity$4 ? inst_104522.cljs$core$IFn$_invoke$arity$4(cljs.core.PersistentHashSet,null,inst_104527,null) : inst_104522.call(null,cljs.core.PersistentHashSet,null,inst_104527,null));
var inst_104529 = (inst_104528.cljs$core$IFn$_invoke$arity$1 ? inst_104528.cljs$core$IFn$_invoke$arity$1(inst_104521) : inst_104528.call(null,inst_104521));
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104529)){
var statearr_104680_104846 = state_104658__$1;
(statearr_104680_104846[(1)] = (62));

} else {
var statearr_104681_104847 = state_104658__$1;
(statearr_104681_104847[(1)] = (63));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (27))){
var inst_104439 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104682_104848 = state_104658__$1;
(statearr_104682_104848[(2)] = inst_104439);

(statearr_104682_104848[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (1))){
var state_104658__$1 = state_104658;
var statearr_104683_104849 = state_104658__$1;
(statearr_104683_104849[(2)] = null);

(statearr_104683_104849[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (69))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104534 = [cljs.core.cst$kw$instant,null,cljs.core.cst$kw$int,null];
var inst_104535 = (inst_104522.cljs$core$IFn$_invoke$arity$5 ? inst_104522.cljs$core$IFn$_invoke$arity$5(cljs.core.PersistentArrayMap,null,2,inst_104534,null) : inst_104522.call(null,cljs.core.PersistentArrayMap,null,2,inst_104534,null));
var inst_104536 = (inst_104522.cljs$core$IFn$_invoke$arity$4 ? inst_104522.cljs$core$IFn$_invoke$arity$4(cljs.core.PersistentHashSet,null,inst_104535,null) : inst_104522.call(null,cljs.core.PersistentHashSet,null,inst_104535,null));
var inst_104537 = (inst_104536.cljs$core$IFn$_invoke$arity$1 ? inst_104536.cljs$core$IFn$_invoke$arity$1(inst_104521) : inst_104536.call(null,inst_104521));
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104537)){
var statearr_104684_104850 = state_104658__$1;
(statearr_104684_104850[(1)] = (70));

} else {
var statearr_104685_104851 = state_104658__$1;
(statearr_104685_104851[(1)] = (71));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (101))){
var inst_104390 = (state_104658[(12)]);
var inst_104623 = cljs.core.cst$kw$component.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104624 = cljs.core.cst$kw$new.cljs$core$IFn$_invoke$arity$1(inst_104623);
var inst_104625 = inst_104624 === true;
var inst_104626 = cljs.core.cst$kw$type.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104627 = cljs.core.cst$kw$new.cljs$core$IFn$_invoke$arity$1(inst_104626);
var inst_104628 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$ref,inst_104627);
var inst_104629 = (!(inst_104628));
var inst_104630 = ((inst_104625) && (inst_104629));
var state_104658__$1 = state_104658;
var statearr_104686_104852 = state_104658__$1;
(statearr_104686_104852[(2)] = inst_104630);

(statearr_104686_104852[(1)] = (103));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (24))){
var inst_104443 = (state_104658[(13)]);
var inst_104390 = (state_104658[(12)]);
var inst_104442 = (state_104658[(2)]);
var inst_104443__$1 = cljs.core.cst$kw$component.cljs$core$IFn$_invoke$arity$1(inst_104390);
var state_104658__$1 = (function (){var statearr_104687 = state_104658;
(statearr_104687[(14)] = inst_104442);

(statearr_104687[(13)] = inst_104443__$1);

return statearr_104687;
})();
if(cljs.core.truth_(inst_104443__$1)){
var statearr_104688_104853 = state_104658__$1;
(statearr_104688_104853[(1)] = (28));

} else {
var statearr_104689_104854 = state_104658__$1;
(statearr_104689_104854[(1)] = (29));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (102))){
var inst_104621 = (state_104658[(15)]);
var state_104658__$1 = state_104658;
var statearr_104690_104855 = state_104658__$1;
(statearr_104690_104855[(2)] = inst_104621);

(statearr_104690_104855[(1)] = (103));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (55))){
var inst_104512 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104691_104856 = state_104658__$1;
(statearr_104691_104856[(2)] = inst_104512);

(statearr_104691_104856[(1)] = (52));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (85))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104574 = [cljs.core.cst$kw$long,null,cljs.core.cst$kw$double,null,cljs.core.cst$kw$int,null,cljs.core.cst$kw$bigint,null,cljs.core.cst$kw$float,null];
var inst_104575 = (inst_104522.cljs$core$IFn$_invoke$arity$5 ? inst_104522.cljs$core$IFn$_invoke$arity$5(cljs.core.PersistentArrayMap,null,5,inst_104574,null) : inst_104522.call(null,cljs.core.PersistentArrayMap,null,5,inst_104574,null));
var inst_104576 = (inst_104522.cljs$core$IFn$_invoke$arity$4 ? inst_104522.cljs$core$IFn$_invoke$arity$4(cljs.core.PersistentHashSet,null,inst_104575,null) : inst_104522.call(null,cljs.core.PersistentHashSet,null,inst_104575,null));
var inst_104577 = (inst_104576.cljs$core$IFn$_invoke$arity$1 ? inst_104576.cljs$core$IFn$_invoke$arity$1(inst_104521) : inst_104576.call(null,inst_104521));
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104577)){
var statearr_104692_104857 = state_104658__$1;
(statearr_104692_104857[(1)] = (86));

} else {
var statearr_104693_104858 = state_104658__$1;
(statearr_104693_104858[(1)] = (87));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (39))){
var inst_104458 = (state_104658[(16)]);
var state_104658__$1 = state_104658;
var statearr_104694_104859 = state_104658__$1;
(statearr_104694_104859[(2)] = inst_104458);

(statearr_104694_104859[(1)] = (40));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (88))){
var inst_104582 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104695_104860 = state_104658__$1;
(statearr_104695_104860[(2)] = inst_104582);

(statearr_104695_104860[(1)] = (68));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (46))){
var inst_104496 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104496)){
var statearr_104696_104861 = state_104658__$1;
(statearr_104696_104861[(1)] = (47));

} else {
var statearr_104697_104862 = state_104658__$1;
(statearr_104697_104862[(1)] = (48));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_104658,(3),Error,null,(2));
var inst_104372 = cljs.core.seq(pred_changes);
var inst_104373 = cljs.core.first(inst_104372);
var inst_104374 = cljs.core.next(inst_104372);
var inst_104375 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_104373,(0),null);
var inst_104376 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_104373,(1),null);
var inst_104377 = pred_changes;
var inst_104378 = db;
var state_104658__$1 = (function (){var statearr_104698 = state_104658;
(statearr_104698[(10)] = inst_104378);

(statearr_104698[(17)] = inst_104375);

(statearr_104698[(18)] = inst_104377);

(statearr_104698[(19)] = inst_104376);

(statearr_104698[(20)] = inst_104374);

return statearr_104698;
})();
var statearr_104699_104863 = state_104658__$1;
(statearr_104699_104863[(2)] = null);

(statearr_104699_104863[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (77))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104554 = [cljs.core.cst$kw$long,null,cljs.core.cst$kw$int,null,cljs.core.cst$kw$float,null];
var inst_104555 = (inst_104522.cljs$core$IFn$_invoke$arity$5 ? inst_104522.cljs$core$IFn$_invoke$arity$5(cljs.core.PersistentArrayMap,null,3,inst_104554,null) : inst_104522.call(null,cljs.core.PersistentArrayMap,null,3,inst_104554,null));
var inst_104556 = (inst_104522.cljs$core$IFn$_invoke$arity$4 ? inst_104522.cljs$core$IFn$_invoke$arity$4(cljs.core.PersistentHashSet,null,inst_104555,null) : inst_104522.call(null,cljs.core.PersistentHashSet,null,inst_104555,null));
var inst_104557 = (inst_104556.cljs$core$IFn$_invoke$arity$1 ? inst_104556.cljs$core$IFn$_invoke$arity$1(inst_104521) : inst_104556.call(null,inst_104521));
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104557)){
var statearr_104700_104864 = state_104658__$1;
(statearr_104700_104864[(1)] = (78));

} else {
var statearr_104701_104865 = state_104658__$1;
(statearr_104701_104865[(1)] = (79));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (106))){
var inst_104388 = (state_104658[(21)]);
var inst_104649 = (state_104658[(2)]);
var inst_104377 = inst_104388;
var inst_104378 = inst_104649;
var state_104658__$1 = (function (){var statearr_104702 = state_104658;
(statearr_104702[(10)] = inst_104378);

(statearr_104702[(18)] = inst_104377);

return statearr_104702;
})();
var statearr_104703_104866 = state_104658__$1;
(statearr_104703_104866[(2)] = null);

(statearr_104703_104866[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (95))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104600 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3(inst_104521,inst_104522,throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104704_104867 = state_104658__$1;
(statearr_104704_104867[(2)] = inst_104600);

(statearr_104704_104867[(1)] = (96));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (54))){
var state_104658__$1 = state_104658;
var statearr_104705_104868 = state_104658__$1;
(statearr_104705_104868[(2)] = false);

(statearr_104705_104868[(1)] = (55));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (92))){
var inst_104592 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104706_104869 = state_104658__$1;
(statearr_104706_104869[(2)] = inst_104592);

(statearr_104706_104869[(1)] = (68));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (104))){
var state_104658__$1 = state_104658;
if(cljs.core.truth_(throw_QMARK_)){
var statearr_104707_104870 = state_104658__$1;
(statearr_104707_104870[(1)] = (107));

} else {
var statearr_104708_104871 = state_104658__$1;
(statearr_104708_104871[(1)] = (108));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (15))){
var inst_104390 = (state_104658[(12)]);
var inst_104411 = (state_104658[(22)]);
var inst_104410 = (state_104658[(2)]);
var inst_104411__$1 = cljs.core.cst$kw$unique.cljs$core$IFn$_invoke$arity$1(inst_104390);
var state_104658__$1 = (function (){var statearr_104709 = state_104658;
(statearr_104709[(23)] = inst_104410);

(statearr_104709[(22)] = inst_104411__$1);

return statearr_104709;
})();
if(cljs.core.truth_(inst_104411__$1)){
var statearr_104710_104872 = state_104658__$1;
(statearr_104710_104872[(1)] = (16));

} else {
var statearr_104711_104873 = state_104658__$1;
(statearr_104711_104873[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (48))){
var inst_104489 = (state_104658[(8)]);
var state_104658__$1 = state_104658;
var statearr_104712_104874 = state_104658__$1;
(statearr_104712_104874[(2)] = inst_104489);

(statearr_104712_104874[(1)] = (49));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (50))){
var inst_104499 = (state_104658[(24)]);
var inst_104504 = inst_104499.cljs$lang$protocol_mask$partition0$;
var inst_104505 = (inst_104504 & (64));
var inst_104506 = inst_104499.cljs$core$ISeq$;
var inst_104507 = (cljs.core.PROTOCOL_SENTINEL === inst_104506);
var inst_104508 = ((inst_104505) || (inst_104507));
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104508)){
var statearr_104713_104875 = state_104658__$1;
(statearr_104713_104875[(1)] = (53));

} else {
var statearr_104714_104876 = state_104658__$1;
(statearr_104714_104876[(1)] = (54));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (75))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104550 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3(inst_104521,inst_104522,throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104715_104877 = state_104658__$1;
(statearr_104715_104877[(2)] = inst_104550);

(statearr_104715_104877[(1)] = (76));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (99))){
var inst_104619 = (state_104658[(25)]);
var state_104658__$1 = state_104658;
var statearr_104716_104878 = state_104658__$1;
(statearr_104716_104878[(2)] = inst_104619);

(statearr_104716_104878[(1)] = (100));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (21))){
var inst_104426 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104717_104879 = state_104658__$1;
(statearr_104717_104879[(2)] = inst_104426);

(statearr_104717_104879[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (31))){
var inst_104442 = (state_104658[(14)]);
var inst_104455 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$4(inst_104442,"a component","a non-component",throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104718_104880 = state_104658__$1;
(statearr_104718_104880[(2)] = inst_104455);

(statearr_104718_104880[(1)] = (33));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (32))){
var inst_104442 = (state_104658[(14)]);
var state_104658__$1 = state_104658;
var statearr_104719_104881 = state_104658__$1;
(statearr_104719_104881[(2)] = inst_104442);

(statearr_104719_104881[(1)] = (33));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (40))){
var inst_104490 = (state_104658[(26)]);
var inst_104390 = (state_104658[(12)]);
var inst_104489 = (state_104658[(2)]);
var inst_104490__$1 = cljs.core.cst$kw$type.cljs$core$IFn$_invoke$arity$1(inst_104390);
var state_104658__$1 = (function (){var statearr_104720 = state_104658;
(statearr_104720[(8)] = inst_104489);

(statearr_104720[(26)] = inst_104490__$1);

return statearr_104720;
})();
if(cljs.core.truth_(inst_104490__$1)){
var statearr_104721_104882 = state_104658__$1;
(statearr_104721_104882[(1)] = (44));

} else {
var statearr_104722_104883 = state_104658__$1;
(statearr_104722_104883[(1)] = (45));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (91))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104590 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3(inst_104521,inst_104522,throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104723_104884 = state_104658__$1;
(statearr_104723_104884[(2)] = inst_104590);

(statearr_104723_104884[(1)] = (92));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (108))){
var inst_104617 = (state_104658[(27)]);
var state_104658__$1 = state_104658;
var statearr_104724_104885 = state_104658__$1;
(statearr_104724_104885[(2)] = inst_104617);

(statearr_104724_104885[(1)] = (109));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (56))){
var inst_104499 = (state_104658[(24)]);
var inst_104517 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_104499);
var state_104658__$1 = state_104658;
var statearr_104725_104886 = state_104658__$1;
(statearr_104725_104886[(2)] = inst_104517);

(statearr_104725_104886[(1)] = (58));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (33))){
var inst_104459 = (state_104658[(28)]);
var inst_104390 = (state_104658[(12)]);
var inst_104458 = (state_104658[(2)]);
var inst_104459__$1 = cljs.core.cst$kw$unique.cljs$core$IFn$_invoke$arity$1(inst_104390);
var state_104658__$1 = (function (){var statearr_104726 = state_104658;
(statearr_104726[(28)] = inst_104459__$1);

(statearr_104726[(16)] = inst_104458);

return statearr_104726;
})();
if(cljs.core.truth_(inst_104459__$1)){
var statearr_104727_104887 = state_104658__$1;
(statearr_104727_104887[(1)] = (34));

} else {
var statearr_104728_104888 = state_104658__$1;
(statearr_104728_104888[(1)] = (35));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (13))){
var inst_104378 = (state_104658[(10)]);
var inst_104407 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$4(inst_104378,"multi-cardinality","single-cardinality",throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104729_104889 = state_104658__$1;
(statearr_104729_104889[(2)] = inst_104407);

(statearr_104729_104889[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (22))){
var state_104658__$1 = state_104658;
if(cljs.core.truth_(throw_QMARK_)){
var statearr_104730_104890 = state_104658__$1;
(statearr_104730_104890[(1)] = (25));

} else {
var statearr_104731_104891 = state_104658__$1;
(statearr_104731_104891[(1)] = (26));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (90))){
var inst_104489 = (state_104658[(8)]);
var state_104658__$1 = state_104658;
var statearr_104732_104892 = state_104658__$1;
(statearr_104732_104892[(2)] = inst_104489);

(statearr_104732_104892[(1)] = (92));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (109))){
var inst_104646 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104733_104893 = state_104658__$1;
(statearr_104733_104893[(2)] = inst_104646);

(statearr_104733_104893[(1)] = (106));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (36))){
var inst_104474 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104474)){
var statearr_104734_104894 = state_104658__$1;
(statearr_104734_104894[(1)] = (38));

} else {
var statearr_104735_104895 = state_104658__$1;
(statearr_104735_104895[(1)] = (39));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (41))){
var inst_104378 = (state_104658[(10)]);
var inst_104389 = (state_104658[(29)]);
var inst_104477 = fluree.db.dbproto._p_prop(inst_104378,cljs.core.cst$kw$name,inst_104389);
var inst_104478 = ["The _predicate ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_104477)," cannot be set to unique, because there are existing non-unique values."].join('');
var inst_104479 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_104480 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_tx];
var inst_104481 = cljs.core.PersistentHashMap.fromArrays(inst_104479,inst_104480);
var inst_104482 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_104478,inst_104481);
var inst_104483 = (function(){throw inst_104482})();
var state_104658__$1 = state_104658;
var statearr_104736_104896 = state_104658__$1;
(statearr_104736_104896[(2)] = inst_104483);

(statearr_104736_104896[(1)] = (43));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (89))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104584 = [cljs.core.cst$kw$geojson,null,cljs.core.cst$kw$bytes,null,cljs.core.cst$kw$uri,null,cljs.core.cst$kw$uuid,null,cljs.core.cst$kw$json,null];
var inst_104585 = (inst_104522.cljs$core$IFn$_invoke$arity$5 ? inst_104522.cljs$core$IFn$_invoke$arity$5(cljs.core.PersistentArrayMap,null,5,inst_104584,null) : inst_104522.call(null,cljs.core.PersistentArrayMap,null,5,inst_104584,null));
var inst_104586 = (inst_104522.cljs$core$IFn$_invoke$arity$4 ? inst_104522.cljs$core$IFn$_invoke$arity$4(cljs.core.PersistentHashSet,null,inst_104585,null) : inst_104522.call(null,cljs.core.PersistentHashSet,null,inst_104585,null));
var inst_104587 = (inst_104586.cljs$core$IFn$_invoke$arity$1 ? inst_104586.cljs$core$IFn$_invoke$arity$1(inst_104521) : inst_104586.call(null,inst_104521));
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104587)){
var statearr_104737_104897 = state_104658__$1;
(statearr_104737_104897[(1)] = (90));

} else {
var statearr_104738_104898 = state_104658__$1;
(statearr_104738_104898[(1)] = (91));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (100))){
var inst_104636 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104636)){
var statearr_104739_104899 = state_104658__$1;
(statearr_104739_104899[(1)] = (104));

} else {
var statearr_104740_104900 = state_104658__$1;
(statearr_104740_104900[(1)] = (105));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (43))){
var inst_104486 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104741_104901 = state_104658__$1;
(statearr_104741_104901[(2)] = inst_104486);

(statearr_104741_104901[(1)] = (40));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (61))){
var inst_104614 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104742_104902 = state_104658__$1;
(statearr_104742_104902[(2)] = inst_104614);

(statearr_104742_104902[(1)] = (49));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (29))){
var inst_104443 = (state_104658[(13)]);
var state_104658__$1 = state_104658;
var statearr_104743_104903 = state_104658__$1;
(statearr_104743_104903[(2)] = inst_104443);

(statearr_104743_104903[(1)] = (30));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (44))){
var inst_104390 = (state_104658[(12)]);
var inst_104492 = cljs.core.cst$kw$type.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104493 = cljs.core.cst$kw$old.cljs$core$IFn$_invoke$arity$1(inst_104492);
var state_104658__$1 = state_104658;
var statearr_104744_104904 = state_104658__$1;
(statearr_104744_104904[(2)] = inst_104493);

(statearr_104744_104904[(1)] = (46));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (93))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104594 = [cljs.core.cst$kw$long,null,cljs.core.cst$kw$int,null];
var inst_104595 = (inst_104522.cljs$core$IFn$_invoke$arity$5 ? inst_104522.cljs$core$IFn$_invoke$arity$5(cljs.core.PersistentArrayMap,null,2,inst_104594,null) : inst_104522.call(null,cljs.core.PersistentArrayMap,null,2,inst_104594,null));
var inst_104596 = (inst_104522.cljs$core$IFn$_invoke$arity$4 ? inst_104522.cljs$core$IFn$_invoke$arity$4(cljs.core.PersistentHashSet,null,inst_104595,null) : inst_104522.call(null,cljs.core.PersistentHashSet,null,inst_104595,null));
var inst_104597 = (inst_104596.cljs$core$IFn$_invoke$arity$1 ? inst_104596.cljs$core$IFn$_invoke$arity$1(inst_104521) : inst_104596.call(null,inst_104521));
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104597)){
var statearr_104745_104905 = state_104658__$1;
(statearr_104745_104905[(1)] = (94));

} else {
var statearr_104746_104906 = state_104658__$1;
(statearr_104746_104906[(1)] = (95));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (6))){
var inst_104654 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104747_104907 = state_104658__$1;
(statearr_104747_104907[(2)] = inst_104654);


cljs.core.async.impl.ioc_helpers.process_exception(state_104658__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (28))){
var inst_104390 = (state_104658[(12)]);
var inst_104445 = cljs.core.cst$kw$new_QMARK_.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104446 = cljs.core.not(inst_104445);
var inst_104447 = cljs.core.cst$kw$component.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104448 = cljs.core.cst$kw$new.cljs$core$IFn$_invoke$arity$1(inst_104447);
var inst_104449 = inst_104448 === true;
var inst_104450 = ((inst_104446) && (inst_104449));
var state_104658__$1 = state_104658;
var statearr_104748_104908 = state_104658__$1;
(statearr_104748_104908[(2)] = inst_104450);

(statearr_104748_104908[(1)] = (30));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (64))){
var inst_104612 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104749_104909 = state_104658__$1;
(statearr_104749_104909[(2)] = inst_104612);

(statearr_104749_104909[(1)] = (61));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (103))){
var inst_104633 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104750_104910 = state_104658__$1;
(statearr_104750_104910[(2)] = inst_104633);

(statearr_104750_104910[(1)] = (100));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (51))){
var state_104658__$1 = state_104658;
var statearr_104751_104911 = state_104658__$1;
(statearr_104751_104911[(2)] = false);

(statearr_104751_104911[(1)] = (52));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (25))){
var inst_104432 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_104433 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_tx];
var inst_104434 = cljs.core.PersistentHashMap.fromArrays(inst_104432,inst_104433);
var inst_104435 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("A boolean _predicate cannot be unique.",inst_104434);
var inst_104436 = (function(){throw inst_104435})();
var state_104658__$1 = state_104658;
var statearr_104752_104912 = state_104658__$1;
(statearr_104752_104912[(2)] = inst_104436);

(statearr_104752_104912[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (34))){
var inst_104378 = (state_104658[(10)]);
var inst_104390 = (state_104658[(12)]);
var inst_104389 = (state_104658[(29)]);
var inst_104461 = cljs.core.cst$kw$new_QMARK_.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104462 = cljs.core.not(inst_104461);
var inst_104463 = cljs.core.cst$kw$unique.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104464 = cljs.core.cst$kw$new.cljs$core$IFn$_invoke$arity$1(inst_104463);
var inst_104465 = inst_104464 === true;
var inst_104466 = fluree.db.query.schema.pred_objects_unique_QMARK_(inst_104378,inst_104389);
var state_104658__$1 = (function (){var statearr_104753 = state_104658;
(statearr_104753[(30)] = inst_104462);

(statearr_104753[(31)] = inst_104465);

return statearr_104753;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_104658__$1,(37),inst_104466);
} else {
if((state_val_104659 === (17))){
var inst_104411 = (state_104658[(22)]);
var state_104658__$1 = state_104658;
var statearr_104754_104913 = state_104658__$1;
(statearr_104754_104913[(2)] = inst_104411);

(statearr_104754_104913[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (3))){
var inst_104355 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104755_104914 = state_104658__$1;
(statearr_104755_104914[(2)] = inst_104355);


cljs.core.async.impl.ioc_helpers.process_exception(state_104658__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (12))){
var inst_104405 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104405)){
var statearr_104756_104915 = state_104658__$1;
(statearr_104756_104915[(1)] = (13));

} else {
var statearr_104757_104916 = state_104658__$1;
(statearr_104757_104916[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (2))){
var inst_104656 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
return cljs.core.async.impl.ioc_helpers.return_chan(state_104658__$1,inst_104656);
} else {
if((state_val_104659 === (66))){
var state_104658__$1 = state_104658;
var statearr_104758_104917 = state_104658__$1;
(statearr_104758_104917[(2)] = null);

(statearr_104758_104917[(1)] = (67));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (107))){
var inst_104639 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_104640 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_tx];
var inst_104641 = cljs.core.PersistentHashMap.fromArrays(inst_104639,inst_104640);
var inst_104642 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("A component _predicate must be of type \"ref.\"",inst_104641);
var inst_104643 = (function(){throw inst_104642})();
var state_104658__$1 = state_104658;
var statearr_104759_104918 = state_104658__$1;
(statearr_104759_104918[(2)] = inst_104643);

(statearr_104759_104918[(1)] = (109));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (23))){
var inst_104410 = (state_104658[(23)]);
var state_104658__$1 = state_104658;
var statearr_104760_104919 = state_104658__$1;
(statearr_104760_104919[(2)] = inst_104410);

(statearr_104760_104919[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (47))){
var inst_104499 = (state_104658[(24)]);
var inst_104390 = (state_104658[(12)]);
var inst_104499__$1 = cljs.core.cst$kw$type.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104501 = (inst_104499__$1 == null);
var inst_104502 = cljs.core.not(inst_104501);
var state_104658__$1 = (function (){var statearr_104761 = state_104658;
(statearr_104761[(24)] = inst_104499__$1);

return statearr_104761;
})();
if(inst_104502){
var statearr_104762_104920 = state_104658__$1;
(statearr_104762_104920[(1)] = (50));

} else {
var statearr_104763_104921 = state_104658__$1;
(statearr_104763_104921[(1)] = (51));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (35))){
var inst_104459 = (state_104658[(28)]);
var state_104658__$1 = state_104658;
var statearr_104764_104922 = state_104658__$1;
(statearr_104764_104922[(2)] = inst_104459);

(statearr_104764_104922[(1)] = (36));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (82))){
var inst_104489 = (state_104658[(8)]);
var state_104658__$1 = state_104658;
var statearr_104765_104923 = state_104658__$1;
(statearr_104765_104923[(2)] = inst_104489);

(statearr_104765_104923[(1)] = (84));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (76))){
var inst_104552 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104766_104924 = state_104658__$1;
(statearr_104766_104924[(2)] = inst_104552);

(statearr_104766_104924[(1)] = (68));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (97))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104604 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3(inst_104521,inst_104522,throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104767_104925 = state_104658__$1;
(statearr_104767_104925[(2)] = inst_104604);

(statearr_104767_104925[(1)] = (68));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (19))){
var inst_104390 = (state_104658[(12)]);
var inst_104415 = cljs.core.cst$kw$new_QMARK_.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104416 = inst_104415 === true;
var inst_104417 = cljs.core.cst$kw$type.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104418 = cljs.core.cst$kw$new.cljs$core$IFn$_invoke$arity$1(inst_104417);
var inst_104419 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$boolean,inst_104418);
var inst_104420 = cljs.core.cst$kw$unique.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104421 = cljs.core.cst$kw$new.cljs$core$IFn$_invoke$arity$1(inst_104420);
var inst_104422 = inst_104421 === true;
var inst_104423 = ((inst_104416) && (inst_104419) && (inst_104422));
var state_104658__$1 = state_104658;
var statearr_104768_104926 = state_104658__$1;
(statearr_104768_104926[(2)] = inst_104423);

(statearr_104768_104926[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (57))){
var inst_104499 = (state_104658[(24)]);
var state_104658__$1 = state_104658;
var statearr_104769_104927 = state_104658__$1;
(statearr_104769_104927[(2)] = inst_104499);

(statearr_104769_104927[(1)] = (58));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (68))){
var inst_104607 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104770_104928 = state_104658__$1;
(statearr_104770_104928[(2)] = inst_104607);

(statearr_104770_104928[(1)] = (67));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (11))){
var inst_104394 = (state_104658[(32)]);
var state_104658__$1 = state_104658;
var statearr_104771_104929 = state_104658__$1;
(statearr_104771_104929[(2)] = inst_104394);

(statearr_104771_104929[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (9))){
var inst_104652 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104772_104930 = state_104658__$1;
(statearr_104772_104930[(2)] = inst_104652);

(statearr_104772_104930[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (5))){
var inst_104377 = (state_104658[(18)]);
var inst_104389 = (state_104658[(29)]);
var inst_104386 = cljs.core.seq(inst_104377);
var inst_104387 = cljs.core.first(inst_104386);
var inst_104388 = cljs.core.next(inst_104386);
var inst_104389__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_104387,(0),null);
var inst_104390 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_104387,(1),null);
var inst_104391 = cljs.core.not(inst_104389__$1);
var state_104658__$1 = (function (){var statearr_104773 = state_104658;
(statearr_104773[(21)] = inst_104388);

(statearr_104773[(12)] = inst_104390);

(statearr_104773[(29)] = inst_104389__$1);

return statearr_104773;
})();
if(inst_104391){
var statearr_104774_104931 = state_104658__$1;
(statearr_104774_104931[(1)] = (7));

} else {
var statearr_104775_104932 = state_104658__$1;
(statearr_104775_104932[(1)] = (8));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (83))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104570 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3(inst_104521,inst_104522,throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104776_104933 = state_104658__$1;
(statearr_104776_104933[(2)] = inst_104570);

(statearr_104776_104933[(1)] = (84));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (14))){
var inst_104378 = (state_104658[(10)]);
var state_104658__$1 = state_104658;
var statearr_104777_104934 = state_104658__$1;
(statearr_104777_104934[(2)] = inst_104378);

(statearr_104777_104934[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (45))){
var inst_104490 = (state_104658[(26)]);
var state_104658__$1 = state_104658;
var statearr_104778_104935 = state_104658__$1;
(statearr_104778_104935[(2)] = inst_104490);

(statearr_104778_104935[(1)] = (46));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (53))){
var state_104658__$1 = state_104658;
var statearr_104779_104936 = state_104658__$1;
(statearr_104779_104936[(2)] = true);

(statearr_104779_104936[(1)] = (55));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (78))){
var inst_104489 = (state_104658[(8)]);
var state_104658__$1 = state_104658;
var statearr_104780_104937 = state_104658__$1;
(statearr_104780_104937[(2)] = inst_104489);

(statearr_104780_104937[(1)] = (80));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (26))){
var inst_104410 = (state_104658[(23)]);
var state_104658__$1 = state_104658;
var statearr_104781_104938 = state_104658__$1;
(statearr_104781_104938[(2)] = inst_104410);

(statearr_104781_104938[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (16))){
var inst_104413 = (state_104658[(11)]);
var inst_104390 = (state_104658[(12)]);
var inst_104413__$1 = cljs.core.cst$kw$type.cljs$core$IFn$_invoke$arity$1(inst_104390);
var state_104658__$1 = (function (){var statearr_104782 = state_104658;
(statearr_104782[(11)] = inst_104413__$1);

return statearr_104782;
})();
if(cljs.core.truth_(inst_104413__$1)){
var statearr_104783_104939 = state_104658__$1;
(statearr_104783_104939[(1)] = (19));

} else {
var statearr_104784_104940 = state_104658__$1;
(statearr_104784_104940[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (81))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104564 = [cljs.core.cst$kw$long,null,cljs.core.cst$kw$int,null,cljs.core.cst$kw$float,null];
var inst_104565 = (inst_104522.cljs$core$IFn$_invoke$arity$5 ? inst_104522.cljs$core$IFn$_invoke$arity$5(cljs.core.PersistentArrayMap,null,3,inst_104564,null) : inst_104522.call(null,cljs.core.PersistentArrayMap,null,3,inst_104564,null));
var inst_104566 = (inst_104522.cljs$core$IFn$_invoke$arity$4 ? inst_104522.cljs$core$IFn$_invoke$arity$4(cljs.core.PersistentHashSet,null,inst_104565,null) : inst_104522.call(null,cljs.core.PersistentHashSet,null,inst_104565,null));
var inst_104567 = (inst_104566.cljs$core$IFn$_invoke$arity$1 ? inst_104566.cljs$core$IFn$_invoke$arity$1(inst_104521) : inst_104566.call(null,inst_104521));
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104567)){
var statearr_104785_104941 = state_104658__$1;
(statearr_104785_104941[(1)] = (82));

} else {
var statearr_104786_104942 = state_104658__$1;
(statearr_104786_104942[(1)] = (83));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (79))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104560 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3(inst_104521,inst_104522,throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104787_104943 = state_104658__$1;
(statearr_104787_104943[(2)] = inst_104560);

(statearr_104787_104943[(1)] = (80));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (38))){
var state_104658__$1 = state_104658;
if(cljs.core.truth_(throw_QMARK_)){
var statearr_104788_104944 = state_104658__$1;
(statearr_104788_104944[(1)] = (41));

} else {
var statearr_104789_104945 = state_104658__$1;
(statearr_104789_104945[(1)] = (42));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (98))){
var inst_104390 = (state_104658[(12)]);
var inst_104621 = (state_104658[(15)]);
var inst_104621__$1 = cljs.core.cst$kw$component.cljs$core$IFn$_invoke$arity$1(inst_104390);
var state_104658__$1 = (function (){var statearr_104790 = state_104658;
(statearr_104790[(15)] = inst_104621__$1);

return statearr_104790;
})();
if(cljs.core.truth_(inst_104621__$1)){
var statearr_104791_104946 = state_104658__$1;
(statearr_104791_104946[(1)] = (101));

} else {
var statearr_104792_104947 = state_104658__$1;
(statearr_104792_104947[(1)] = (102));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (87))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104580 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3(inst_104521,inst_104522,throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104793_104948 = state_104658__$1;
(statearr_104793_104948[(2)] = inst_104580);

(statearr_104793_104948[(1)] = (88));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (30))){
var inst_104453 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104453)){
var statearr_104794_104949 = state_104658__$1;
(statearr_104794_104949[(1)] = (31));

} else {
var statearr_104795_104950 = state_104658__$1;
(statearr_104795_104950[(1)] = (32));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (73))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104544 = [cljs.core.cst$kw$long,null,cljs.core.cst$kw$instant,null,cljs.core.cst$kw$int,null];
var inst_104545 = (inst_104522.cljs$core$IFn$_invoke$arity$5 ? inst_104522.cljs$core$IFn$_invoke$arity$5(cljs.core.PersistentArrayMap,null,3,inst_104544,null) : inst_104522.call(null,cljs.core.PersistentArrayMap,null,3,inst_104544,null));
var inst_104546 = (inst_104522.cljs$core$IFn$_invoke$arity$4 ? inst_104522.cljs$core$IFn$_invoke$arity$4(cljs.core.PersistentHashSet,null,inst_104545,null) : inst_104522.call(null,cljs.core.PersistentHashSet,null,inst_104545,null));
var inst_104547 = (inst_104546.cljs$core$IFn$_invoke$arity$1 ? inst_104546.cljs$core$IFn$_invoke$arity$1(inst_104521) : inst_104546.call(null,inst_104521));
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104547)){
var statearr_104796_104951 = state_104658__$1;
(statearr_104796_104951[(1)] = (74));

} else {
var statearr_104797_104952 = state_104658__$1;
(statearr_104797_104952[(1)] = (75));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (96))){
var inst_104602 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104798_104953 = state_104658__$1;
(statearr_104798_104953[(2)] = inst_104602);

(statearr_104798_104953[(1)] = (68));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (10))){
var inst_104390 = (state_104658[(12)]);
var inst_104396 = cljs.core.cst$kw$multi.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104397 = cljs.core.cst$kw$new.cljs$core$IFn$_invoke$arity$1(inst_104396);
var inst_104398 = inst_104397 === false;
var inst_104399 = cljs.core.cst$kw$multi.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104400 = cljs.core.cst$kw$old.cljs$core$IFn$_invoke$arity$1(inst_104399);
var inst_104401 = inst_104400 === true;
var inst_104402 = ((inst_104398) && (inst_104401));
var state_104658__$1 = state_104658;
var statearr_104799_104954 = state_104658__$1;
(statearr_104799_104954[(2)] = inst_104402);

(statearr_104799_104954[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (18))){
var inst_104429 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104429)){
var statearr_104800_104955 = state_104658__$1;
(statearr_104800_104955[(1)] = (22));

} else {
var statearr_104801_104956 = state_104658__$1;
(statearr_104801_104956[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (105))){
var inst_104617 = (state_104658[(27)]);
var state_104658__$1 = state_104658;
var statearr_104802_104957 = state_104658__$1;
(statearr_104802_104957[(2)] = inst_104617);

(statearr_104802_104957[(1)] = (106));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (52))){
var inst_104515 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
if(cljs.core.truth_(inst_104515)){
var statearr_104803_104958 = state_104658__$1;
(statearr_104803_104958[(1)] = (56));

} else {
var statearr_104804_104959 = state_104658__$1;
(statearr_104804_104959[(1)] = (57));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (67))){
var inst_104610 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104805_104960 = state_104658__$1;
(statearr_104805_104960[(2)] = inst_104610);

(statearr_104805_104960[(1)] = (64));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (71))){
var inst_104521 = (state_104658[(9)]);
var inst_104522 = (state_104658[(7)]);
var inst_104540 = fluree.db.query.schema.type_error.cljs$core$IFn$_invoke$arity$3(inst_104521,inst_104522,throw_QMARK_);
var state_104658__$1 = state_104658;
var statearr_104806_104961 = state_104658__$1;
(statearr_104806_104961[(2)] = inst_104540);

(statearr_104806_104961[(1)] = (72));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (42))){
var inst_104458 = (state_104658[(16)]);
var state_104658__$1 = state_104658;
var statearr_104807_104962 = state_104658__$1;
(statearr_104807_104962[(2)] = inst_104458);

(statearr_104807_104962[(1)] = (43));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (80))){
var inst_104562 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104808_104963 = state_104658__$1;
(statearr_104808_104963[(2)] = inst_104562);

(statearr_104808_104963[(1)] = (68));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (37))){
var inst_104462 = (state_104658[(30)]);
var inst_104465 = (state_104658[(31)]);
var inst_104468 = (state_104658[(2)]);
var inst_104469 = fluree.db.util.async.throw_err(inst_104468);
var inst_104470 = cljs.core.not(inst_104469);
var inst_104471 = ((inst_104462) && (inst_104465) && (inst_104470));
var state_104658__$1 = state_104658;
var statearr_104809_104964 = state_104658__$1;
(statearr_104809_104964[(2)] = inst_104471);

(statearr_104809_104964[(1)] = (36));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (63))){
var state_104658__$1 = state_104658;
var statearr_104810_104965 = state_104658__$1;
(statearr_104810_104965[(1)] = (65));



return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (94))){
var inst_104489 = (state_104658[(8)]);
var state_104658__$1 = state_104658;
var statearr_104812_104966 = state_104658__$1;
(statearr_104812_104966[(2)] = inst_104489);

(statearr_104812_104966[(1)] = (96));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (8))){
var inst_104390 = (state_104658[(12)]);
var inst_104394 = (state_104658[(32)]);
var inst_104394__$1 = cljs.core.cst$kw$multi.cljs$core$IFn$_invoke$arity$1(inst_104390);
var state_104658__$1 = (function (){var statearr_104813 = state_104658;
(statearr_104813[(32)] = inst_104394__$1);

return statearr_104813;
})();
if(cljs.core.truth_(inst_104394__$1)){
var statearr_104814_104967 = state_104658__$1;
(statearr_104814_104967[(1)] = (10));

} else {
var statearr_104815_104968 = state_104658__$1;
(statearr_104815_104968[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (49))){
var inst_104390 = (state_104658[(12)]);
var inst_104619 = (state_104658[(25)]);
var inst_104617 = (state_104658[(2)]);
var inst_104618 = cljs.core.cst$kw$new_QMARK_.cljs$core$IFn$_invoke$arity$1(inst_104390);
var inst_104619__$1 = inst_104618 === true;
var state_104658__$1 = (function (){var statearr_104816 = state_104658;
(statearr_104816[(27)] = inst_104617);

(statearr_104816[(25)] = inst_104619__$1);

return statearr_104816;
})();
if(cljs.core.truth_(inst_104619__$1)){
var statearr_104817_104969 = state_104658__$1;
(statearr_104817_104969[(1)] = (98));

} else {
var statearr_104818_104970 = state_104658__$1;
(statearr_104818_104970[(1)] = (99));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104659 === (84))){
var inst_104572 = (state_104658[(2)]);
var state_104658__$1 = state_104658;
var statearr_104819_104971 = state_104658__$1;
(statearr_104819_104971[(2)] = inst_104572);

(statearr_104819_104971[(1)] = (68));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$schema$state_machine__99703__auto__ = null;
var fluree$db$query$schema$state_machine__99703__auto____0 = (function (){
var statearr_104820 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_104820[(0)] = fluree$db$query$schema$state_machine__99703__auto__);

(statearr_104820[(1)] = (1));

return statearr_104820;
});
var fluree$db$query$schema$state_machine__99703__auto____1 = (function (state_104658){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_104658);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e104821){if((e104821 instanceof Object)){
var ex__99706__auto__ = e104821;
var statearr_104822_104972 = state_104658;
(statearr_104822_104972[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_104658);

return cljs.core.cst$kw$recur;
} else {
throw e104821;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__104973 = state_104658;
state_104658 = G__104973;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$schema$state_machine__99703__auto__ = function(state_104658){
switch(arguments.length){
case 0:
return fluree$db$query$schema$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$schema$state_machine__99703__auto____1.call(this,state_104658);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$schema$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$schema$state_machine__99703__auto____0;
fluree$db$query$schema$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$schema$state_machine__99703__auto____1;
return fluree$db$query$schema$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_104823 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_104823[(6)] = c__99809__auto__);

return statearr_104823;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

fluree.db.query.schema.predicate_change_error.cljs$lang$maxFixedArity = 3;

fluree.db.query.schema.validate_schema_change = (function fluree$db$query$schema$validate_schema_change(db,tempids,flakes){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_104994){
var state_val_104995 = (state_104994[(1)]);
if((state_val_104995 === (7))){
var inst_104981 = (state_104994[(7)]);
var inst_104985 = fluree.db.query.schema.predicate_change_error.cljs$core$IFn$_invoke$arity$3(inst_104981,db,true);
var state_104994__$1 = state_104994;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_104994__$1,(9),inst_104985);
} else {
if((state_val_104995 === (1))){
var state_104994__$1 = state_104994;
var statearr_104996_105008 = state_104994__$1;
(statearr_104996_105008[(2)] = null);

(statearr_104996_105008[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104995 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_104994,(3),Error,null,(2));
var inst_104978 = fluree.db.query.schema.new_pred_changes(db,tempids,flakes);
var state_104994__$1 = state_104994;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_104994__$1,(5),inst_104978);
} else {
if((state_val_104995 === (6))){
var state_104994__$1 = state_104994;
var statearr_104997_105009 = state_104994__$1;
(statearr_104997_105009[(2)] = db);

(statearr_104997_105009[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104995 === (3))){
var inst_104974 = (state_104994[(2)]);
var state_104994__$1 = state_104994;
var statearr_104998_105010 = state_104994__$1;
(statearr_104998_105010[(2)] = inst_104974);


cljs.core.async.impl.ioc_helpers.process_exception(state_104994__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_104995 === (2))){
var inst_104992 = (state_104994[(2)]);
var state_104994__$1 = state_104994;
return cljs.core.async.impl.ioc_helpers.return_chan(state_104994__$1,inst_104992);
} else {
if((state_val_104995 === (9))){
var inst_104987 = (state_104994[(2)]);
var inst_104988 = fluree.db.util.async.throw_err(inst_104987);
var state_104994__$1 = state_104994;
var statearr_104999_105011 = state_104994__$1;
(statearr_104999_105011[(2)] = inst_104988);

(statearr_104999_105011[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_104995 === (5))){
var inst_104981 = (state_104994[(7)]);
var inst_104980 = (state_104994[(2)]);
var inst_104981__$1 = fluree.db.util.async.throw_err(inst_104980);
var inst_104982 = cljs.core.empty_QMARK_(inst_104981__$1);
var state_104994__$1 = (function (){var statearr_105000 = state_104994;
(statearr_105000[(7)] = inst_104981__$1);

return statearr_105000;
})();
if(inst_104982){
var statearr_105001_105012 = state_104994__$1;
(statearr_105001_105012[(1)] = (6));

} else {
var statearr_105002_105013 = state_104994__$1;
(statearr_105002_105013[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_104995 === (8))){
var inst_104990 = (state_104994[(2)]);
var state_104994__$1 = state_104994;
var statearr_105003_105014 = state_104994__$1;
(statearr_105003_105014[(2)] = inst_104990);


cljs.core.async.impl.ioc_helpers.process_exception(state_104994__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto__ = null;
var fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto____0 = (function (){
var statearr_105004 = [null,null,null,null,null,null,null,null];
(statearr_105004[(0)] = fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto__);

(statearr_105004[(1)] = (1));

return statearr_105004;
});
var fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto____1 = (function (state_104994){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_104994);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105005){if((e105005 instanceof Object)){
var ex__99706__auto__ = e105005;
var statearr_105006_105015 = state_104994;
(statearr_105006_105015[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_104994);

return cljs.core.cst$kw$recur;
} else {
throw e105005;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105016 = state_104994;
state_104994 = G__105016;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto__ = function(state_104994){
switch(arguments.length){
case 0:
return fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto____1.call(this,state_104994);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto____0;
fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto____1;
return fluree$db$query$schema$validate_schema_change_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105007 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105007[(6)] = c__99809__auto__);

return statearr_105007;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.query.schema.predicate_re = /(?:([^\/]+)\/)([^\/]+)/;
fluree.db.query.schema.pred_reverse_ref_re = /(?:([^\/]+)\/)_([^\/]+)/;
/**
 * Reverse refs must be strings that include a '/_' in them, which characters before and after.
 */
fluree.db.query.schema.reverse_ref_QMARK_ = (function fluree$db$query$schema$reverse_ref_QMARK_(var_args){
var G__105018 = arguments.length;
switch (G__105018) {
case 1:
return fluree.db.query.schema.reverse_ref_QMARK_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.query.schema.reverse_ref_QMARK_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.schema.reverse_ref_QMARK_.cljs$core$IFn$_invoke$arity$1 = (function (predicate_name){
return fluree.db.query.schema.reverse_ref_QMARK_.cljs$core$IFn$_invoke$arity$2(predicate_name,false);
});

fluree.db.query.schema.reverse_ref_QMARK_.cljs$core$IFn$_invoke$arity$2 = (function (predicate_name,throw_QMARK_){
if(typeof predicate_name === 'string'){
return cljs.core.boolean$(cljs.core.re_matches(fluree.db.query.schema.pred_reverse_ref_re,predicate_name));
} else {
if(cljs.core.truth_(throw_QMARK_)){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Bad predicate name, should be string: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([predicate_name], 0))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_predicate], null));
} else {
return false;
}
}
});

fluree.db.query.schema.reverse_ref_QMARK_.cljs$lang$maxFixedArity = 2;

/**
 * Reverses an predicate name.
 */
fluree.db.query.schema.reverse_ref = (function fluree$db$query$schema$reverse_ref(predicate_name){
if(typeof predicate_name === 'string'){
var vec__105020 = cljs.core.re_matches(/(?:([^\/]+)\/)?([^\/]+)/,predicate_name);
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105020,(0),null);
var ns = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105020,(1),null);
var name = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105020,(2),null);
if(cljs.core.truth_(ns)){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("_",cljs.core.nth.cljs$core$IFn$_invoke$arity$2(name,(0)))){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(ns),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.subs.cljs$core$IFn$_invoke$arity$2(name,(1)))].join('');
} else {
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(ns),"/_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join('');
}
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Bad predicate name, does not contain a namespace portion: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([predicate_name], 0))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_predicate], null));
}
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Bad predicate name, should be string: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([predicate_name], 0))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_predicate], null));
}
});
fluree.db.query.schema.type_sid__GT_type = cljs.core.PersistentHashMap.fromArrays([fluree.db.flake.__GT_sid((3),(2)),fluree.db.flake.__GT_sid((3),(9)),fluree.db.flake.__GT_sid((3),(14)),fluree.db.flake.__GT_sid((3),(16)),fluree.db.flake.__GT_sid((3),(8)),fluree.db.flake.__GT_sid((3),(4)),fluree.db.flake.__GT_sid((3),(5)),fluree.db.flake.__GT_sid((3),(15)),fluree.db.flake.__GT_sid((3),(17)),fluree.db.flake.__GT_sid((3),(11)),fluree.db.flake.__GT_sid((3),(12)),fluree.db.flake.__GT_sid((3),(1)),fluree.db.flake.__GT_sid((3),(10)),fluree.db.flake.__GT_sid((3),(6)),fluree.db.flake.__GT_sid((3),(7)),fluree.db.flake.__GT_sid((3),(13))],[cljs.core.cst$kw$ref,cljs.core.cst$kw$int,cljs.core.cst$kw$bigdec,cljs.core.cst$kw$json,cljs.core.cst$kw$bytes,cljs.core.cst$kw$boolean,cljs.core.cst$kw$instant,cljs.core.cst$kw$tag,cljs.core.cst$kw$geojson,cljs.core.cst$kw$bigint,cljs.core.cst$kw$float,cljs.core.cst$kw$string,cljs.core.cst$kw$long,cljs.core.cst$kw$uuid,cljs.core.cst$kw$uri,cljs.core.cst$kw$double]);
fluree.db.query.schema.lang_sid__GT_lang = cljs.core.PersistentHashMap.fromArrays([fluree.db.flake.__GT_sid((3),(62)),fluree.db.flake.__GT_sid((3),(68)),fluree.db.flake.__GT_sid((3),(67)),fluree.db.flake.__GT_sid((3),(69)),fluree.db.flake.__GT_sid((3),(63)),fluree.db.flake.__GT_sid((3),(70)),fluree.db.flake.__GT_sid((3),(65)),fluree.db.flake.__GT_sid((3),(66)),fluree.db.flake.__GT_sid((3),(64)),fluree.db.flake.__GT_sid((3),(61))],[cljs.core.cst$kw$bn,cljs.core.cst$kw$hi,cljs.core.cst$kw$fr,cljs.core.cst$kw$id,cljs.core.cst$kw$br,cljs.core.cst$kw$ru,cljs.core.cst$kw$en,cljs.core.cst$kw$es,cljs.core.cst$kw$cn,cljs.core.cst$kw$ar]);
fluree.db.query.schema.flake__GT_pred_map = (function fluree$db$query$schema$flake__GT_pred_map(flakes){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc,flake){
var p = flake.p;
var o = flake.o;
var existing_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(acc,p);
if(cljs.core.truth_((function (){var and__4120__auto__ = existing_QMARK_;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.vector_QMARK_(existing_QMARK_);
} else {
return and__4120__auto__;
}
})())){
return cljs.core.update.cljs$core$IFn$_invoke$arity$4(acc,p,cljs.core.conj,o);
} else {
if(cljs.core.truth_(existing_QMARK_)){
return cljs.core.update.cljs$core$IFn$_invoke$arity$4(acc,p,((function (p,o,existing_QMARK_){
return (function (p1__105023_SHARP_,p2__105024_SHARP_){
return cljs.core.vec(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__105023_SHARP_,p2__105024_SHARP_], null));
});})(p,o,existing_QMARK_))
,o);
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(acc,p,o);

}
}
}),cljs.core.PersistentArrayMap.EMPTY,flakes);
});
/**
 * Returns a map of the schema for a db to allow quick lookups of schema properties.
 *   Schema is a map with two keys:
 *   - :coll - collection info, mapping cid->name and name->cid all within the same map
 *   - :pred - predicate info, mapping pid->properties and name->properties for quick lookup based on id or name respectively
 *   
 */
fluree.db.query.schema.schema_map = (function fluree$db$query$schema$schema_map(db){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_105087){
var state_val_105088 = (state_105087[(1)]);
if((state_val_105088 === (1))){
var state_105087__$1 = state_105087;
var statearr_105089_105100 = state_105087__$1;
(statearr_105089_105100[(2)] = null);

(statearr_105089_105100[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105088 === (2))){
var inst_105085 = (state_105087[(2)]);
var state_105087__$1 = state_105087;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105087__$1,inst_105085);
} else {
if((state_val_105088 === (3))){
var inst_105030 = (state_105087[(2)]);
var state_105087__$1 = state_105087;
var statearr_105090_105101 = state_105087__$1;
(statearr_105090_105101[(2)] = inst_105030);


cljs.core.async.impl.ioc_helpers.process_exception(state_105087__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105088 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105087,(3),Error,null,(2));
var inst_105040 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105041 = fluree.db.flake.max_subject_id((1));
var inst_105042 = [inst_105041];
var inst_105043 = (new cljs.core.PersistentVector(null,1,(5),inst_105040,inst_105042,null));
var inst_105044 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105045 = [(0)];
var inst_105046 = (new cljs.core.PersistentVector(null,1,(5),inst_105044,inst_105045,null));
var inst_105047 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$6(db,cljs.core.cst$kw$spot,cljs.core._GT__EQ_,inst_105043,cljs.core._LT__EQ_,inst_105046);
var state_105087__$1 = state_105087;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105087__$1,(5),inst_105047);
} else {
if((state_val_105088 === (5))){
var inst_105049 = (state_105087[(2)]);
var inst_105050 = fluree.db.util.async.throw_err(inst_105049);
var inst_105051 = (function (){var schema_flakes = inst_105050;
return ((function (schema_flakes,inst_105049,inst_105050,state_val_105088,c__99809__auto__){
return (function (p1__105025_SHARP_){
return (p1__105025_SHARP_.s <= fluree.db.flake.MAX_COLL_SUBJECTS);
});
;})(schema_flakes,inst_105049,inst_105050,state_val_105088,c__99809__auto__))
})();
var inst_105052 = cljs.core.partition_by.cljs$core$IFn$_invoke$arity$2(inst_105051,inst_105050);
var inst_105053 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_105052,(0),null);
var inst_105054 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_105052,(1),null);
var inst_105055 = (function (){var schema_flakes = inst_105050;
var vec__105034 = inst_105052;
var collection_flakes = inst_105053;
var predicate_flakes = inst_105054;
return ((function (schema_flakes,vec__105034,collection_flakes,predicate_flakes,inst_105049,inst_105050,inst_105051,inst_105052,inst_105053,inst_105054,state_val_105088,c__99809__auto__){
return (function (acc,coll_flakes){
var sid = cljs.core.first(coll_flakes).s;
var id = fluree.db.flake.sid__GT_i(sid);
var p__GT_v = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (sid,id,schema_flakes,vec__105034,collection_flakes,predicate_flakes,inst_105049,inst_105050,inst_105051,inst_105052,inst_105053,inst_105054,state_val_105088,c__99809__auto__){
return (function (p1__105027_SHARP_,p2__105028_SHARP_){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__105027_SHARP_,p2__105028_SHARP_.p,p2__105028_SHARP_.o);
});})(sid,id,schema_flakes,vec__105034,collection_flakes,predicate_flakes,inst_105049,inst_105050,inst_105051,inst_105052,inst_105053,inst_105054,state_val_105088,c__99809__auto__))
,cljs.core.PersistentArrayMap.EMPTY,coll_flakes);
var c_name = cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(40));
var spec = cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(43));
var specDoc = cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(44));
var c_props = new cljs.core.PersistentArrayMap(null, 5, [cljs.core.cst$kw$name,c_name,cljs.core.cst$kw$sid,sid,cljs.core.cst$kw$spec,spec,cljs.core.cst$kw$specDoc,specDoc,cljs.core.cst$kw$id,id], null);
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(acc,id,c_props,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([c_name,c_props], 0));
});
;})(schema_flakes,vec__105034,collection_flakes,predicate_flakes,inst_105049,inst_105050,inst_105051,inst_105052,inst_105053,inst_105054,state_val_105088,c__99809__auto__))
})();
var inst_105056 = [(-1),"_tx"];
var inst_105057 = [cljs.core.cst$kw$name,cljs.core.cst$kw$id,cljs.core.cst$kw$sid];
var inst_105058 = ["_tx",(-1),(-1)];
var inst_105059 = cljs.core.PersistentHashMap.fromArrays(inst_105057,inst_105058);
var inst_105060 = [cljs.core.cst$kw$name,cljs.core.cst$kw$id,cljs.core.cst$kw$sid];
var inst_105061 = ["_tx",(-1),(-1)];
var inst_105062 = cljs.core.PersistentHashMap.fromArrays(inst_105060,inst_105061);
var inst_105063 = [inst_105059,inst_105062];
var inst_105064 = cljs.core.PersistentHashMap.fromArrays(inst_105056,inst_105063);
var inst_105065 = (function (){var schema_flakes = inst_105050;
var vec__105034 = inst_105052;
var collection_flakes = inst_105053;
var predicate_flakes = inst_105054;
return ((function (schema_flakes,vec__105034,collection_flakes,predicate_flakes,inst_105049,inst_105050,inst_105051,inst_105052,inst_105053,inst_105054,inst_105055,inst_105056,inst_105057,inst_105058,inst_105059,inst_105060,inst_105061,inst_105062,inst_105063,inst_105064,state_val_105088,c__99809__auto__){
return (function (p1__105026_SHARP_){
return p1__105026_SHARP_.s;
});
;})(schema_flakes,vec__105034,collection_flakes,predicate_flakes,inst_105049,inst_105050,inst_105051,inst_105052,inst_105053,inst_105054,inst_105055,inst_105056,inst_105057,inst_105058,inst_105059,inst_105060,inst_105061,inst_105062,inst_105063,inst_105064,state_val_105088,c__99809__auto__))
})();
var inst_105066 = cljs.core.partition_by.cljs$core$IFn$_invoke$arity$2(inst_105065,inst_105053);
var inst_105067 = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(inst_105055,inst_105064,inst_105066);
var inst_105069 = (function (){var schema_flakes = inst_105050;
var vec__105034 = inst_105052;
var collection_flakes = inst_105053;
var predicate_flakes = inst_105054;
var coll = inst_105067;
return ((function (schema_flakes,vec__105034,collection_flakes,predicate_flakes,coll,inst_105049,inst_105050,inst_105051,inst_105052,inst_105053,inst_105054,inst_105055,inst_105056,inst_105057,inst_105058,inst_105059,inst_105060,inst_105061,inst_105062,inst_105063,inst_105064,inst_105065,inst_105066,inst_105067,state_val_105088,c__99809__auto__){
return (function (p__105068,pred_flakes){
var vec__105091 = p__105068;
var pred = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105091,(0),null);
var fullText = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__105091,(1),null);
var id = cljs.core.first(pred_flakes).s;
var p__GT_v = fluree.db.query.schema.flake__GT_pred_map(pred_flakes);
var p_name = cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(10));
var p_type = cljs.core.get.cljs$core$IFn$_invoke$arity$2(fluree.db.query.schema.type_sid__GT_type,cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(12)));
var ref_QMARK_ = cljs.core.boolean$((function (){var fexpr__105094 = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$ref,null,cljs.core.cst$kw$tag,null], null), null);
return (fexpr__105094.cljs$core$IFn$_invoke$arity$1 ? fexpr__105094.cljs$core$IFn$_invoke$arity$1(p_type) : fexpr__105094.call(null,p_type));
})());
var idx_QMARK_ = cljs.core.boolean$((function (){var or__4131__auto__ = ref_QMARK_;
if(or__4131__auto__){
return or__4131__auto__;
} else {
var or__4131__auto____$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(15));
if(cljs.core.truth_(or__4131__auto____$1)){
return or__4131__auto____$1;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(13));
}
}
})());
var fullText_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(27));
var p_props = cljs.core.PersistentHashMap.fromArrays([cljs.core.cst$kw$unique,cljs.core.cst$kw$restrictCollection,cljs.core.cst$kw$index,cljs.core.cst$kw$name,cljs.core.cst$kw$noHistory,cljs.core.cst$kw$type,cljs.core.cst$kw$txSpec,cljs.core.cst$kw$component,cljs.core.cst$kw$txSpecDoc,cljs.core.cst$kw$spec,cljs.core.cst$kw$multi,cljs.core.cst$kw$id,cljs.core.cst$kw$specDoc,cljs.core.cst$kw$idx_QMARK_,cljs.core.cst$kw$ref_QMARK_,cljs.core.cst$kw$upsert,cljs.core.cst$kw$restrictTag,cljs.core.cst$kw$fullText],[cljs.core.boolean$(cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(13))),cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(19)),cljs.core.boolean$(cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(15))),p_name,cljs.core.boolean$(cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(18))),p_type,cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(24)),cljs.core.boolean$(cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(17))),cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(25)),cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(20)),cljs.core.boolean$(cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(14))),id,cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(23)),idx_QMARK_,ref_QMARK_,cljs.core.boolean$(cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(16))),cljs.core.get.cljs$core$IFn$_invoke$arity$2(p__GT_v,(26)),fullText_QMARK_]);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(pred,id,p_props,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([p_name,p_props], 0)),(cljs.core.truth_(fullText_QMARK_)?cljs.core.conj.cljs$core$IFn$_invoke$arity$2(fullText,id):fullText)], null);
});
;})(schema_flakes,vec__105034,collection_flakes,predicate_flakes,coll,inst_105049,inst_105050,inst_105051,inst_105052,inst_105053,inst_105054,inst_105055,inst_105056,inst_105057,inst_105058,inst_105059,inst_105060,inst_105061,inst_105062,inst_105063,inst_105064,inst_105065,inst_105066,inst_105067,state_val_105088,c__99809__auto__))
})();
var inst_105070 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105071 = cljs.core.PersistentHashMap.EMPTY;
var inst_105072 = cljs.core.PersistentHashSet.EMPTY;
var inst_105073 = [inst_105071,inst_105072];
var inst_105074 = (new cljs.core.PersistentVector(null,2,(5),inst_105070,inst_105073,null));
var inst_105075 = (function (){var schema_flakes = inst_105050;
var vec__105034 = inst_105052;
var collection_flakes = inst_105053;
var predicate_flakes = inst_105054;
var coll = inst_105067;
return ((function (schema_flakes,vec__105034,collection_flakes,predicate_flakes,coll,inst_105049,inst_105050,inst_105051,inst_105052,inst_105053,inst_105054,inst_105055,inst_105056,inst_105057,inst_105058,inst_105059,inst_105060,inst_105061,inst_105062,inst_105063,inst_105064,inst_105065,inst_105066,inst_105067,inst_105069,inst_105070,inst_105071,inst_105072,inst_105073,inst_105074,state_val_105088,c__99809__auto__){
return (function (p1__105029_SHARP_){
return p1__105029_SHARP_.s;
});
;})(schema_flakes,vec__105034,collection_flakes,predicate_flakes,coll,inst_105049,inst_105050,inst_105051,inst_105052,inst_105053,inst_105054,inst_105055,inst_105056,inst_105057,inst_105058,inst_105059,inst_105060,inst_105061,inst_105062,inst_105063,inst_105064,inst_105065,inst_105066,inst_105067,inst_105069,inst_105070,inst_105071,inst_105072,inst_105073,inst_105074,state_val_105088,c__99809__auto__))
})();
var inst_105076 = cljs.core.partition_by.cljs$core$IFn$_invoke$arity$2(inst_105075,inst_105054);
var inst_105077 = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(inst_105069,inst_105074,inst_105076);
var inst_105078 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_105077,(0),null);
var inst_105079 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_105077,(1),null);
var inst_105080 = [cljs.core.cst$kw$t,cljs.core.cst$kw$coll,cljs.core.cst$kw$pred,cljs.core.cst$kw$fullText];
var inst_105081 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(db);
var inst_105082 = [inst_105081,inst_105067,inst_105078,inst_105079];
var inst_105083 = cljs.core.PersistentHashMap.fromArrays(inst_105080,inst_105082);
var state_105087__$1 = state_105087;
var statearr_105095_105102 = state_105087__$1;
(statearr_105095_105102[(2)] = inst_105083);


cljs.core.async.impl.ioc_helpers.process_exception(state_105087__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$schema$schema_map_$_state_machine__99703__auto__ = null;
var fluree$db$query$schema$schema_map_$_state_machine__99703__auto____0 = (function (){
var statearr_105096 = [null,null,null,null,null,null,null];
(statearr_105096[(0)] = fluree$db$query$schema$schema_map_$_state_machine__99703__auto__);

(statearr_105096[(1)] = (1));

return statearr_105096;
});
var fluree$db$query$schema$schema_map_$_state_machine__99703__auto____1 = (function (state_105087){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105087);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105097){if((e105097 instanceof Object)){
var ex__99706__auto__ = e105097;
var statearr_105098_105103 = state_105087;
(statearr_105098_105103[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105087);

return cljs.core.cst$kw$recur;
} else {
throw e105097;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105104 = state_105087;
state_105087 = G__105104;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$schema$schema_map_$_state_machine__99703__auto__ = function(state_105087){
switch(arguments.length){
case 0:
return fluree$db$query$schema$schema_map_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$schema$schema_map_$_state_machine__99703__auto____1.call(this,state_105087);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$schema$schema_map_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$schema$schema_map_$_state_machine__99703__auto____0;
fluree$db$query$schema$schema_map_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$schema$schema_map_$_state_machine__99703__auto____1;
return fluree$db$query$schema$schema_map_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105099 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105099[(6)] = c__99809__auto__);

return statearr_105099;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.query.schema.setting_map = (function fluree$db$query$schema$setting_map(db){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_105140){
var state_val_105141 = (state_105140[(1)]);
if((state_val_105141 === (1))){
var state_105140__$1 = state_105140;
var statearr_105142_105153 = state_105140__$1;
(statearr_105142_105153[(2)] = null);

(statearr_105142_105153[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105141 === (2))){
var inst_105138 = (state_105140[(2)]);
var state_105140__$1 = state_105140;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105140__$1,inst_105138);
} else {
if((state_val_105141 === (3))){
var inst_105105 = (state_105140[(2)]);
var state_105140__$1 = state_105140;
var statearr_105143_105154 = state_105140__$1;
(statearr_105143_105154[(2)] = inst_105105);


cljs.core.async.impl.ioc_helpers.process_exception(state_105140__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105141 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105140,(3),Error,null,(2));
var state_105140__$1 = state_105140;
var statearr_105144_105155 = state_105140__$1;
(statearr_105144_105155[(2)] = null);

(statearr_105144_105155[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105141 === (5))){
var inst_105124 = (state_105140[(2)]);
var inst_105125 = fluree.db.query.schema.flake__GT_pred_map(inst_105124);
var inst_105126 = [cljs.core.cst$kw$passwords,cljs.core.cst$kw$anonymous,cljs.core.cst$kw$language,cljs.core.cst$kw$ledgers,cljs.core.cst$kw$txMax,cljs.core.cst$kw$consensus];
var inst_105127 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105125,(114));
var inst_105128 = cljs.core.boolean$(inst_105127);
var inst_105129 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105125,(110));
var inst_105130 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105125,(117));
var inst_105131 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(fluree.db.query.schema.lang_sid__GT_lang,inst_105130);
var inst_105132 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105125,(111));
var inst_105133 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105125,(115));
var inst_105134 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105125,(112));
var inst_105135 = [inst_105128,inst_105129,inst_105131,inst_105132,inst_105133,inst_105134];
var inst_105136 = cljs.core.PersistentHashMap.fromArrays(inst_105126,inst_105135);
var state_105140__$1 = state_105140;
var statearr_105145_105156 = state_105140__$1;
(statearr_105145_105156[(2)] = inst_105136);


cljs.core.async.impl.ioc_helpers.process_exception(state_105140__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105141 === (6))){
var inst_105109 = (state_105140[(2)]);
var state_105140__$1 = (function (){var statearr_105146 = state_105140;
(statearr_105146[(7)] = inst_105109);

return statearr_105146;
})();
var statearr_105147_105157 = state_105140__$1;
(statearr_105147_105157[(2)] = null);


cljs.core.async.impl.ioc_helpers.process_exception(state_105140__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105141 === (7))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105140,(6),cljs.core.cst$kw$default,null,(5));
var inst_105113 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105114 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105115 = ["_setting/id","root"];
var inst_105116 = (new cljs.core.PersistentVector(null,2,(5),inst_105114,inst_105115,null));
var inst_105117 = [inst_105116];
var inst_105118 = (new cljs.core.PersistentVector(null,1,(5),inst_105113,inst_105117,null));
var inst_105119 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(db,cljs.core.cst$kw$spot,cljs.core._EQ_,inst_105118);
var state_105140__$1 = state_105140;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105140__$1,(8),inst_105119);
} else {
if((state_val_105141 === (8))){
var inst_105121 = (state_105140[(2)]);
var inst_105122 = fluree.db.util.async.throw_err(inst_105121);
var state_105140__$1 = state_105140;
var statearr_105148_105158 = state_105140__$1;
(statearr_105148_105158[(2)] = inst_105122);


cljs.core.async.impl.ioc_helpers.process_exception(state_105140__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$schema$setting_map_$_state_machine__99703__auto__ = null;
var fluree$db$query$schema$setting_map_$_state_machine__99703__auto____0 = (function (){
var statearr_105149 = [null,null,null,null,null,null,null,null];
(statearr_105149[(0)] = fluree$db$query$schema$setting_map_$_state_machine__99703__auto__);

(statearr_105149[(1)] = (1));

return statearr_105149;
});
var fluree$db$query$schema$setting_map_$_state_machine__99703__auto____1 = (function (state_105140){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105140);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105150){if((e105150 instanceof Object)){
var ex__99706__auto__ = e105150;
var statearr_105151_105159 = state_105140;
(statearr_105151_105159[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105140);

return cljs.core.cst$kw$recur;
} else {
throw e105150;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105160 = state_105140;
state_105140 = G__105160;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$schema$setting_map_$_state_machine__99703__auto__ = function(state_105140){
switch(arguments.length){
case 0:
return fluree$db$query$schema$setting_map_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$schema$setting_map_$_state_machine__99703__auto____1.call(this,state_105140);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$schema$setting_map_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$schema$setting_map_$_state_machine__99703__auto____0;
fluree$db$query$schema$setting_map_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$schema$setting_map_$_state_machine__99703__auto____1;
return fluree$db$query$schema$setting_map_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105152 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105152[(6)] = c__99809__auto__);

return statearr_105152;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns schema version from a db, which is the :t when the schema was last updated.
 */
fluree.db.query.schema.version = (function fluree$db$query$schema$version(db){
return cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(db,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$schema,cljs.core.cst$kw$t], null));
});
