// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.session');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('fluree.db.graphdb');
goog.require('cljs.core.async');
goog.require('cljs.cache');
goog.require('clojure.string');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.storage.core');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.log');
goog.require('fluree.db.operations');
goog.require('fluree.db.flake');
goog.require('fluree.db.constants');
goog.require('fluree.db.util.async');
goog.require('fluree.db.query.schema');



/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.session.DbSession = (function (conn,network,dbid,db_name,update_chan,transact_chan,state,schema_cache,blank_db,close,id,__meta,__extmap,__hash){
this.conn = conn;
this.network = network;
this.dbid = dbid;
this.db_name = db_name;
this.update_chan = update_chan;
this.transact_chan = transact_chan;
this.state = state;
this.schema_cache = schema_cache;
this.blank_db = blank_db;
this.close = close;
this.id = id;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.session.DbSession.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.session.DbSession.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k116400,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__116404 = k116400;
var G__116404__$1 = (((G__116404 instanceof cljs.core.Keyword))?G__116404.fqn:null);
switch (G__116404__$1) {
case "conn":
return self__.conn;

break;
case "network":
return self__.network;

break;
case "dbid":
return self__.dbid;

break;
case "db-name":
return self__.db_name;

break;
case "update-chan":
return self__.update_chan;

break;
case "transact-chan":
return self__.transact_chan;

break;
case "state":
return self__.state;

break;
case "schema-cache":
return self__.schema_cache;

break;
case "blank-db":
return self__.blank_db;

break;
case "close":
return self__.close;

break;
case "id":
return self__.id;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k116400,else__4388__auto__);

}
});

fluree.db.session.DbSession.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__116405){
var vec__116406 = p__116405;
var k__4408__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116406,(0),null);
var v__4409__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116406,(1),null);
return (f__4405__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4405__auto__.cljs$core$IFn$_invoke$arity$3(ret__4407__auto__,k__4408__auto__,v__4409__auto__) : f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__));
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.session.DbSession.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer(writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer(writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.session.DbSession{",", ","}",opts__4401__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$conn,self__.conn],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$network,self__.network],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$dbid,self__.dbid],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$db_DASH_name,self__.db_name],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$update_DASH_chan,self__.update_chan],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$transact_DASH_chan,self__.transact_chan],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$state,self__.state],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$schema_DASH_cache,self__.schema_cache],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$blank_DASH_db,self__.blank_db],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$close,self__.close],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$id,self__.id],null))], null),self__.__extmap));
});

fluree.db.session.DbSession.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__116399){
var self__ = this;
var G__116399__$1 = this;
return (new cljs.core.RecordIter((0),G__116399__$1,11,new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$conn,cljs.core.cst$kw$network,cljs.core.cst$kw$dbid,cljs.core.cst$kw$db_DASH_name,cljs.core.cst$kw$update_DASH_chan,cljs.core.cst$kw$transact_DASH_chan,cljs.core.cst$kw$state,cljs.core.cst$kw$schema_DASH_cache,cljs.core.cst$kw$blank_DASH_db,cljs.core.cst$kw$close,cljs.core.cst$kw$id], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
});

fluree.db.session.DbSession.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.session.DbSession.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.session.DbSession.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (11 + cljs.core.count(self__.__extmap));
});

fluree.db.session.DbSession.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = (function (){var fexpr__116409 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (1635626254 ^ cljs.core.hash_unordered_coll(coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
;
return fexpr__116409(this__4381__auto____$1);
})();
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.session.DbSession.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this116401,other116402){
var self__ = this;
var this116401__$1 = this;
return (((!((other116402 == null)))) && ((this116401__$1.constructor === other116402.constructor)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.conn,other116402.conn)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.network,other116402.network)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.dbid,other116402.dbid)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.db_name,other116402.db_name)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.update_chan,other116402.update_chan)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.transact_chan,other116402.transact_chan)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.state,other116402.state)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.schema_cache,other116402.schema_cache)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.blank_db,other116402.blank_db)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.close,other116402.close)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.id,other116402.id)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this116401__$1.__extmap,other116402.__extmap)));
});

fluree.db.session.DbSession.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 11, [cljs.core.cst$kw$dbid,null,cljs.core.cst$kw$update_DASH_chan,null,cljs.core.cst$kw$db_DASH_name,null,cljs.core.cst$kw$state,null,cljs.core.cst$kw$close,null,cljs.core.cst$kw$id,null,cljs.core.cst$kw$schema_DASH_cache,null,cljs.core.cst$kw$transact_DASH_chan,null,cljs.core.cst$kw$network,null,cljs.core.cst$kw$blank_DASH_db,null,cljs.core.cst$kw$conn,null], null), null),k__4395__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.session.DbSession.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__116399){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__116410 = cljs.core.keyword_identical_QMARK_;
var expr__116411 = k__4393__auto__;
if(cljs.core.truth_((function (){var G__116413 = cljs.core.cst$kw$conn;
var G__116414 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116413,G__116414) : pred__116410.call(null,G__116413,G__116414));
})())){
return (new fluree.db.session.DbSession(G__116399,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__116415 = cljs.core.cst$kw$network;
var G__116416 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116415,G__116416) : pred__116410.call(null,G__116415,G__116416));
})())){
return (new fluree.db.session.DbSession(self__.conn,G__116399,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__116417 = cljs.core.cst$kw$dbid;
var G__116418 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116417,G__116418) : pred__116410.call(null,G__116417,G__116418));
})())){
return (new fluree.db.session.DbSession(self__.conn,self__.network,G__116399,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__116419 = cljs.core.cst$kw$db_DASH_name;
var G__116420 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116419,G__116420) : pred__116410.call(null,G__116419,G__116420));
})())){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,G__116399,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__116421 = cljs.core.cst$kw$update_DASH_chan;
var G__116422 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116421,G__116422) : pred__116410.call(null,G__116421,G__116422));
})())){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,G__116399,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__116423 = cljs.core.cst$kw$transact_DASH_chan;
var G__116424 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116423,G__116424) : pred__116410.call(null,G__116423,G__116424));
})())){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,G__116399,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__116425 = cljs.core.cst$kw$state;
var G__116426 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116425,G__116426) : pred__116410.call(null,G__116425,G__116426));
})())){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,G__116399,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__116427 = cljs.core.cst$kw$schema_DASH_cache;
var G__116428 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116427,G__116428) : pred__116410.call(null,G__116427,G__116428));
})())){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,G__116399,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__116429 = cljs.core.cst$kw$blank_DASH_db;
var G__116430 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116429,G__116430) : pred__116410.call(null,G__116429,G__116430));
})())){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,G__116399,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__116431 = cljs.core.cst$kw$close;
var G__116432 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116431,G__116432) : pred__116410.call(null,G__116431,G__116432));
})())){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,G__116399,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__116433 = cljs.core.cst$kw$id;
var G__116434 = expr__116411;
return (pred__116410.cljs$core$IFn$_invoke$arity$2 ? pred__116410.cljs$core$IFn$_invoke$arity$2(G__116433,G__116434) : pred__116410.call(null,G__116433,G__116434));
})())){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,G__116399,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4393__auto__,G__116399),null));
}
}
}
}
}
}
}
}
}
}
}
});

fluree.db.session.DbSession.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(cljs.core.cst$kw$conn,self__.conn,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$network,self__.network,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$dbid,self__.dbid,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$db_DASH_name,self__.db_name,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$update_DASH_chan,self__.update_chan,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$transact_DASH_chan,self__.transact_chan,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$state,self__.state,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$schema_DASH_cache,self__.schema_cache,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$blank_DASH_db,self__.blank_db,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$close,self__.close,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$id,self__.id,null))], null),self__.__extmap));
});

fluree.db.session.DbSession.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__116399){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,G__116399,self__.__extmap,self__.__hash));
});

fluree.db.session.DbSession.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.session.DbSession.getBasis = (function (){
return new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$conn,cljs.core.cst$sym$network,cljs.core.cst$sym$dbid,cljs.core.cst$sym$db_DASH_name,cljs.core.cst$sym$update_DASH_chan,cljs.core.cst$sym$transact_DASH_chan,cljs.core.cst$sym$state,cljs.core.cst$sym$schema_DASH_cache,cljs.core.cst$sym$blank_DASH_db,cljs.core.cst$sym$close,cljs.core.cst$sym$id], null);
});

fluree.db.session.DbSession.cljs$lang$type = true;

fluree.db.session.DbSession.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.session/DbSession",null,(1),null));
});

fluree.db.session.DbSession.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write(writer__4429__auto__,"fluree.db.session/DbSession");
});

/**
 * Positional factory function for fluree.db.session/DbSession.
 */
fluree.db.session.__GT_DbSession = (function fluree$db$session$__GT_DbSession(conn,network,dbid,db_name,update_chan,transact_chan,state,schema_cache,blank_db,close,id){
return (new fluree.db.session.DbSession(conn,network,dbid,db_name,update_chan,transact_chan,state,schema_cache,blank_db,close,id,null,null,null));
});

/**
 * Factory function for fluree.db.session/DbSession, taking a map of keywords to field values.
 */
fluree.db.session.map__GT_DbSession = (function fluree$db$session$map__GT_DbSession(G__116403){
var extmap__4424__auto__ = (function (){var G__116435 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__116403,cljs.core.cst$kw$conn,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$network,cljs.core.cst$kw$dbid,cljs.core.cst$kw$db_DASH_name,cljs.core.cst$kw$update_DASH_chan,cljs.core.cst$kw$transact_DASH_chan,cljs.core.cst$kw$state,cljs.core.cst$kw$schema_DASH_cache,cljs.core.cst$kw$blank_DASH_db,cljs.core.cst$kw$close,cljs.core.cst$kw$id], 0));
if(cljs.core.record_QMARK_(G__116403)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__116435);
} else {
return G__116435;
}
})();
return (new fluree.db.session.DbSession(cljs.core.cst$kw$conn.cljs$core$IFn$_invoke$arity$1(G__116403),cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(G__116403),cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(G__116403),cljs.core.cst$kw$db_DASH_name.cljs$core$IFn$_invoke$arity$1(G__116403),cljs.core.cst$kw$update_DASH_chan.cljs$core$IFn$_invoke$arity$1(G__116403),cljs.core.cst$kw$transact_DASH_chan.cljs$core$IFn$_invoke$arity$1(G__116403),cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(G__116403),cljs.core.cst$kw$schema_DASH_cache.cljs$core$IFn$_invoke$arity$1(G__116403),cljs.core.cst$kw$blank_DASH_db.cljs$core$IFn$_invoke$arity$1(G__116403),cljs.core.cst$kw$close.cljs$core$IFn$_invoke$arity$1(G__116403),cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(G__116403),null,cljs.core.not_empty(extmap__4424__auto__),null));
});

fluree.db.session.cache_factory = (function fluree$db$session$cache_factory(){
return cljs.core.PersistentArrayMap.EMPTY;
});
fluree.db.session.session_cache = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(fluree.db.session.cache_factory());
/**
 * Only replaces cache if an existing conn is not already present.
 *   Returns the cached connection.
 */
fluree.db.session.cache_BANG_ = (function fluree$db$session$cache_BANG_(session){
var map__116437 = session;
var map__116437__$1 = (((((!((map__116437 == null))))?(((((map__116437.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116437.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__116437):map__116437);
var network = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116437__$1,cljs.core.cst$kw$network);
var dbid = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116437__$1,cljs.core.cst$kw$dbid);
var cache_key = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null);
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(fluree.db.session.session_cache,((function (map__116437,map__116437__$1,network,dbid,cache_key){
return (function (c){
if(cljs.core.truth_(cljs.core.get.cljs$core$IFn$_invoke$arity$2(c,cache_key))){
return c;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(c,cache_key,session);
}
});})(map__116437,map__116437__$1,network,dbid,cache_key))
);

return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(fluree.db.session.session_cache),cache_key);
});
/**
 * Retrieves session from cache.
 */
fluree.db.session.from_cache = (function fluree$db$session$from_cache(network,dbid){
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(fluree.db.session.session_cache),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null));
});
/**
 * Removes a specific session from cache.
 */
fluree.db.session.remove_cache_BANG_ = (function fluree$db$session$remove_cache_BANG_(network,dbid){
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(fluree.db.session.session_cache,cljs.core.dissoc,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null));
});
/**
 * Clears entire session cache. Should not be used under normal circumstances as sessions will not be properly closed.
 */
fluree.db.session.reset_cache_BANG_ = (function fluree$db$session$reset_cache_BANG_(){
return cljs.core.reset_BANG_(fluree.db.session.session_cache,fluree.db.session.cache_factory());
});
fluree.db.session.full_load_existing_db = (function fluree$db$session$full_load_existing_db(session){
var pc = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__99809__auto___116644 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___116644,pc){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___116644,pc){
return (function (state_116578){
var state_val_116579 = (state_116578[(1)]);
if((state_val_116579 === (7))){
var inst_116461 = (state_116578[(2)]);
var state_116578__$1 = state_116578;
if(cljs.core.truth_(inst_116461)){
var statearr_116580_116645 = state_116578__$1;
(statearr_116580_116645[(1)] = (11));

} else {
var statearr_116581_116646 = state_116578__$1;
(statearr_116581_116646[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (20))){
var inst_116488 = (state_116578[(2)]);
var inst_116489 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_116490 = [(400),cljs.core.cst$kw$db_SLASH_unavailable];
var inst_116491 = cljs.core.PersistentHashMap.fromArrays(inst_116489,inst_116490);
var inst_116492 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_116488,inst_116491);
var inst_116493 = (function(){throw inst_116492})();
var state_116578__$1 = state_116578;
var statearr_116582_116647 = state_116578__$1;
(statearr_116582_116647[(2)] = inst_116493);

(statearr_116582_116647[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (27))){
var inst_116506 = (state_116578[(7)]);
var state_116578__$1 = state_116578;
var statearr_116583_116648 = state_116578__$1;
(statearr_116583_116648[(2)] = inst_116506);

(statearr_116583_116648[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (1))){
var state_116578__$1 = state_116578;
var statearr_116584_116649 = state_116578__$1;
(statearr_116584_116649[(2)] = null);

(statearr_116584_116649[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (24))){
var inst_116563 = (state_116578[(8)]);
var inst_116563__$1 = (state_116578[(2)]);
var inst_116564 = fluree.db.query.schema.schema_map(inst_116563__$1);
var state_116578__$1 = (function (){var statearr_116585 = state_116578;
(statearr_116585[(8)] = inst_116563__$1);

return statearr_116585;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116578__$1,(44),inst_116564);
} else {
if((state_val_116579 === (39))){
var inst_116530 = (state_116578[(2)]);
var state_116578__$1 = state_116578;
var statearr_116586_116650 = state_116578__$1;
(statearr_116586_116650[(2)] = inst_116530);

(statearr_116586_116650[(1)] = (36));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_116578,(3),cljs.core.cst$kw$default,null,(2));
var inst_116445 = cljs.core.cst$kw$blank_DASH_db.cljs$core$IFn$_invoke$arity$1(session);
var inst_116447 = (session == null);
var inst_116448 = cljs.core.not(inst_116447);
var state_116578__$1 = (function (){var statearr_116587 = state_116578;
(statearr_116587[(9)] = inst_116445);

return statearr_116587;
})();
if(inst_116448){
var statearr_116588_116651 = state_116578__$1;
(statearr_116588_116651[(1)] = (5));

} else {
var statearr_116589_116652 = state_116578__$1;
(statearr_116589_116652[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (15))){
var inst_116476 = (state_116578[(10)]);
var inst_116481 = cljs.core.empty_QMARK_(inst_116476);
var state_116578__$1 = state_116578;
if(inst_116481){
var statearr_116590_116653 = state_116578__$1;
(statearr_116590_116653[(1)] = (18));

} else {
var statearr_116591_116654 = state_116578__$1;
(statearr_116591_116654[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (21))){
var inst_116501 = (state_116578[(11)]);
var inst_116476 = (state_116578[(10)]);
var inst_116500 = (state_116578[(2)]);
var inst_116501__$1 = fluree.db.util.async.throw_err(inst_116500);
var inst_116502 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(inst_116476);
var state_116578__$1 = (function (){var statearr_116592 = state_116578;
(statearr_116592[(11)] = inst_116501__$1);

(statearr_116592[(12)] = inst_116502);

return statearr_116592;
})();
if(cljs.core.truth_(inst_116501__$1)){
var statearr_116593_116655 = state_116578__$1;
(statearr_116593_116655[(1)] = (22));

} else {
var statearr_116594_116656 = state_116578__$1;
(statearr_116594_116656[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (31))){
var inst_116515 = (state_116578[(13)]);
var inst_116519 = (inst_116515 == null);
var inst_116520 = cljs.core.not(inst_116519);
var state_116578__$1 = state_116578;
if(inst_116520){
var statearr_116595_116657 = state_116578__$1;
(statearr_116595_116657[(1)] = (34));

} else {
var statearr_116596_116658 = state_116578__$1;
(statearr_116596_116658[(1)] = (35));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (32))){
var inst_116468 = (state_116578[(14)]);
var inst_116507 = (state_116578[(15)]);
var inst_116469 = (state_116578[(16)]);
var inst_116549 = ["Error reading block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116507)," for db: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116468),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116469),"."].join('');
var inst_116550 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_116551 = [(500),cljs.core.cst$kw$db_SLASH_unexpected_DASH_error];
var inst_116552 = cljs.core.PersistentHashMap.fromArrays(inst_116550,inst_116551);
var inst_116553 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_116549,inst_116552);
var inst_116554 = (function(){throw inst_116553})();
var state_116578__$1 = state_116578;
var statearr_116597_116659 = state_116578__$1;
(statearr_116597_116659[(2)] = inst_116554);

(statearr_116597_116659[(1)] = (33));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (40))){
var inst_116515 = (state_116578[(13)]);
var inst_116535 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_116515);
var state_116578__$1 = state_116578;
var statearr_116598_116660 = state_116578__$1;
(statearr_116598_116660[(2)] = inst_116535);

(statearr_116598_116660[(1)] = (42));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (33))){
var inst_116556 = (state_116578[(2)]);
var state_116578__$1 = state_116578;
var statearr_116599_116661 = state_116578__$1;
(statearr_116599_116661[(2)] = inst_116556);

(statearr_116599_116661[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (13))){
var inst_116468 = (state_116578[(14)]);
var inst_116467 = (state_116578[(17)]);
var inst_116469 = (state_116578[(16)]);
var inst_116466 = (state_116578[(2)]);
var inst_116467__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_116466,cljs.core.cst$kw$conn);
var inst_116468__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_116466,cljs.core.cst$kw$network);
var inst_116469__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_116466,cljs.core.cst$kw$dbid);
var inst_116470 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_116471 = [inst_116468__$1,inst_116469__$1];
var inst_116472 = (new cljs.core.PersistentVector(null,2,(5),inst_116470,inst_116471,null));
var inst_116473 = fluree.db.operations.ledger_info_async(inst_116467__$1,inst_116472);
var state_116578__$1 = (function (){var statearr_116600 = state_116578;
(statearr_116600[(14)] = inst_116468__$1);

(statearr_116600[(17)] = inst_116467__$1);

(statearr_116600[(16)] = inst_116469__$1);

return statearr_116600;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116578__$1,(14),inst_116473);
} else {
if((state_val_116579 === (22))){
var inst_116501 = (state_116578[(11)]);
var inst_116504 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(inst_116501);
var inst_116505 = (inst_116504 + (1));
var inst_116506 = inst_116501;
var inst_116507 = inst_116505;
var state_116578__$1 = (function (){var statearr_116601 = state_116578;
(statearr_116601[(7)] = inst_116506);

(statearr_116601[(15)] = inst_116507);

return statearr_116601;
})();
var statearr_116602_116662 = state_116578__$1;
(statearr_116602_116662[(2)] = null);

(statearr_116602_116662[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (36))){
var inst_116533 = (state_116578[(2)]);
var state_116578__$1 = state_116578;
if(cljs.core.truth_(inst_116533)){
var statearr_116603_116663 = state_116578__$1;
(statearr_116603_116663[(1)] = (40));

} else {
var statearr_116604_116664 = state_116578__$1;
(statearr_116604_116664[(1)] = (41));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (41))){
var inst_116515 = (state_116578[(13)]);
var state_116578__$1 = state_116578;
var statearr_116605_116665 = state_116578__$1;
(statearr_116605_116665[(2)] = inst_116515);

(statearr_116605_116665[(1)] = (42));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (43))){
var inst_116507 = (state_116578[(15)]);
var inst_116544 = (state_116578[(2)]);
var inst_116545 = fluree.db.util.async.throw_err(inst_116544);
var inst_116546 = (inst_116507 + (1));
var inst_116506 = inst_116545;
var inst_116507__$1 = inst_116546;
var state_116578__$1 = (function (){var statearr_116606 = state_116578;
(statearr_116606[(7)] = inst_116506);

(statearr_116606[(15)] = inst_116507__$1);

return statearr_116606;
})();
var statearr_116607_116666 = state_116578__$1;
(statearr_116607_116666[(2)] = null);

(statearr_116607_116666[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (29))){
var inst_116558 = (state_116578[(2)]);
var state_116578__$1 = state_116578;
var statearr_116608_116667 = state_116578__$1;
(statearr_116608_116667[(2)] = inst_116558);

(statearr_116608_116667[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (44))){
var inst_116563 = (state_116578[(8)]);
var inst_116568 = (state_116578[(18)]);
var inst_116566 = (state_116578[(2)]);
var inst_116567 = fluree.db.util.async.throw_err(inst_116566);
var inst_116568__$1 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_116563,cljs.core.cst$kw$schema,inst_116567);
var inst_116569 = fluree.db.query.schema.setting_map(inst_116568__$1);
var state_116578__$1 = (function (){var statearr_116609 = state_116578;
(statearr_116609[(18)] = inst_116568__$1);

return statearr_116609;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116578__$1,(45),inst_116569);
} else {
if((state_val_116579 === (6))){
var state_116578__$1 = state_116578;
var statearr_116610_116668 = state_116578__$1;
(statearr_116610_116668[(2)] = false);

(statearr_116610_116668[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (28))){
var inst_116468 = (state_116578[(14)]);
var inst_116507 = (state_116578[(15)]);
var inst_116467 = (state_116578[(17)]);
var inst_116469 = (state_116578[(16)]);
var inst_116512 = fluree.db.storage.core.read_block(inst_116467,inst_116468,inst_116469,inst_116507);
var state_116578__$1 = state_116578;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116578__$1,(30),inst_116512);
} else {
if((state_val_116579 === (25))){
var inst_116507 = (state_116578[(15)]);
var inst_116502 = (state_116578[(12)]);
var inst_116509 = (inst_116507 > inst_116502);
var state_116578__$1 = state_116578;
if(cljs.core.truth_(inst_116509)){
var statearr_116611_116669 = state_116578__$1;
(statearr_116611_116669[(1)] = (27));

} else {
var statearr_116612_116670 = state_116578__$1;
(statearr_116612_116670[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (34))){
var inst_116515 = (state_116578[(13)]);
var inst_116522 = inst_116515.cljs$lang$protocol_mask$partition0$;
var inst_116523 = (inst_116522 & (64));
var inst_116524 = inst_116515.cljs$core$ISeq$;
var inst_116525 = (cljs.core.PROTOCOL_SENTINEL === inst_116524);
var inst_116526 = ((inst_116523) || (inst_116525));
var state_116578__$1 = state_116578;
if(cljs.core.truth_(inst_116526)){
var statearr_116613_116671 = state_116578__$1;
(statearr_116613_116671[(1)] = (37));

} else {
var statearr_116614_116672 = state_116578__$1;
(statearr_116614_116672[(1)] = (38));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (17))){
var inst_116468 = (state_116578[(14)]);
var inst_116445 = (state_116578[(9)]);
var inst_116467 = (state_116578[(17)]);
var inst_116476 = (state_116578[(10)]);
var inst_116469 = (state_116578[(16)]);
var inst_116496 = (state_116578[(2)]);
var inst_116497 = cljs.core.cst$kw$index.cljs$core$IFn$_invoke$arity$1(inst_116476);
var inst_116498 = fluree.db.storage.core.reify_db(inst_116467,inst_116468,inst_116469,inst_116445,inst_116497);
var state_116578__$1 = (function (){var statearr_116615 = state_116578;
(statearr_116615[(19)] = inst_116496);

return statearr_116615;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116578__$1,(21),inst_116498);
} else {
if((state_val_116579 === (3))){
var inst_116439 = (state_116578[(2)]);
var inst_116440 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pc,inst_116439);
var state_116578__$1 = state_116578;
var statearr_116616_116673 = state_116578__$1;
(statearr_116616_116673[(2)] = inst_116440);


cljs.core.async.impl.ioc_helpers.process_exception(state_116578__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (12))){
var state_116578__$1 = state_116578;
var statearr_116617_116674 = state_116578__$1;
(statearr_116617_116674[(2)] = session);

(statearr_116617_116674[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (2))){
var inst_116576 = (state_116578[(2)]);
var state_116578__$1 = state_116578;
return cljs.core.async.impl.ioc_helpers.return_chan(state_116578__$1,inst_116576);
} else {
if((state_val_116579 === (23))){
var state_116578__$1 = state_116578;
var statearr_116618_116675 = state_116578__$1;
(statearr_116618_116675[(2)] = null);

(statearr_116618_116675[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (35))){
var state_116578__$1 = state_116578;
var statearr_116619_116676 = state_116578__$1;
(statearr_116619_116676[(2)] = false);

(statearr_116619_116676[(1)] = (36));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (19))){
var inst_116468 = (state_116578[(14)]);
var inst_116476 = (state_116578[(10)]);
var inst_116469 = (state_116578[(16)]);
var inst_116485 = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(inst_116476);
var inst_116486 = ["Database ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116468),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116469)," is not currently available. Status is: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116485),"."].join('');
var state_116578__$1 = state_116578;
var statearr_116620_116677 = state_116578__$1;
(statearr_116620_116677[(2)] = inst_116486);

(statearr_116620_116677[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (11))){
var inst_116463 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,session);
var state_116578__$1 = state_116578;
var statearr_116621_116678 = state_116578__$1;
(statearr_116621_116678[(2)] = inst_116463);

(statearr_116621_116678[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (9))){
var state_116578__$1 = state_116578;
var statearr_116622_116679 = state_116578__$1;
(statearr_116622_116679[(2)] = false);

(statearr_116622_116679[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (5))){
var inst_116450 = session.cljs$lang$protocol_mask$partition0$;
var inst_116451 = (inst_116450 & (64));
var inst_116452 = session.cljs$core$ISeq$;
var inst_116453 = (cljs.core.PROTOCOL_SENTINEL === inst_116452);
var inst_116454 = ((inst_116451) || (inst_116453));
var state_116578__$1 = state_116578;
if(cljs.core.truth_(inst_116454)){
var statearr_116623_116680 = state_116578__$1;
(statearr_116623_116680[(1)] = (8));

} else {
var statearr_116624_116681 = state_116578__$1;
(statearr_116624_116681[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (14))){
var inst_116476 = (state_116578[(10)]);
var inst_116475 = (state_116578[(2)]);
var inst_116476__$1 = fluree.db.util.async.throw_err(inst_116475);
var inst_116477 = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(inst_116476__$1);
var inst_116478 = cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(inst_116477);
var inst_116479 = cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$ready,inst_116478);
var state_116578__$1 = (function (){var statearr_116625 = state_116578;
(statearr_116625[(10)] = inst_116476__$1);

return statearr_116625;
})();
if(inst_116479){
var statearr_116626_116682 = state_116578__$1;
(statearr_116626_116682[(1)] = (15));

} else {
var statearr_116627_116683 = state_116578__$1;
(statearr_116627_116683[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (45))){
var inst_116568 = (state_116578[(18)]);
var inst_116571 = (state_116578[(2)]);
var inst_116572 = fluree.db.util.async.throw_err(inst_116571);
var inst_116573 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_116568,cljs.core.cst$kw$settings,inst_116572);
var inst_116574 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pc,inst_116573);
var state_116578__$1 = state_116578;
var statearr_116628_116684 = state_116578__$1;
(statearr_116628_116684[(2)] = inst_116574);


cljs.core.async.impl.ioc_helpers.process_exception(state_116578__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (26))){
var inst_116560 = (state_116578[(2)]);
var state_116578__$1 = state_116578;
var statearr_116629_116685 = state_116578__$1;
(statearr_116629_116685[(2)] = inst_116560);

(statearr_116629_116685[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (16))){
var state_116578__$1 = state_116578;
var statearr_116630_116686 = state_116578__$1;
(statearr_116630_116686[(2)] = null);

(statearr_116630_116686[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (38))){
var state_116578__$1 = state_116578;
var statearr_116631_116687 = state_116578__$1;
(statearr_116631_116687[(2)] = false);

(statearr_116631_116687[(1)] = (39));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (30))){
var inst_116515 = (state_116578[(13)]);
var inst_116514 = (state_116578[(2)]);
var inst_116515__$1 = fluree.db.util.async.throw_err(inst_116514);
var state_116578__$1 = (function (){var statearr_116632 = state_116578;
(statearr_116632[(13)] = inst_116515__$1);

return statearr_116632;
})();
if(cljs.core.truth_(inst_116515__$1)){
var statearr_116633_116688 = state_116578__$1;
(statearr_116633_116688[(1)] = (31));

} else {
var statearr_116634_116689 = state_116578__$1;
(statearr_116634_116689[(1)] = (32));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (10))){
var inst_116458 = (state_116578[(2)]);
var state_116578__$1 = state_116578;
var statearr_116635_116690 = state_116578__$1;
(statearr_116635_116690[(2)] = inst_116458);

(statearr_116635_116690[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (18))){
var inst_116468 = (state_116578[(14)]);
var inst_116469 = (state_116578[(16)]);
var inst_116483 = ["Database ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116468),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116469)," is not found on this ledger group."].join('');
var state_116578__$1 = state_116578;
var statearr_116636_116691 = state_116578__$1;
(statearr_116636_116691[(2)] = inst_116483);

(statearr_116636_116691[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (42))){
var inst_116506 = (state_116578[(7)]);
var inst_116538 = (state_116578[(2)]);
var inst_116539 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_116538,cljs.core.cst$kw$flakes);
var inst_116540 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_116538,cljs.core.cst$kw$block);
var inst_116541 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_116538,cljs.core.cst$kw$t);
var inst_116542 = fluree.db.dbproto._with(inst_116506,inst_116540,inst_116539);
var state_116578__$1 = (function (){var statearr_116637 = state_116578;
(statearr_116637[(20)] = inst_116541);

return statearr_116637;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116578__$1,(43),inst_116542);
} else {
if((state_val_116579 === (37))){
var state_116578__$1 = state_116578;
var statearr_116638_116692 = state_116578__$1;
(statearr_116638_116692[(2)] = true);

(statearr_116638_116692[(1)] = (39));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116579 === (8))){
var state_116578__$1 = state_116578;
var statearr_116639_116693 = state_116578__$1;
(statearr_116639_116693[(2)] = true);

(statearr_116639_116693[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___116644,pc))
;
return ((function (switch__99702__auto__,c__99809__auto___116644,pc){
return (function() {
var fluree$db$session$full_load_existing_db_$_state_machine__99703__auto__ = null;
var fluree$db$session$full_load_existing_db_$_state_machine__99703__auto____0 = (function (){
var statearr_116640 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_116640[(0)] = fluree$db$session$full_load_existing_db_$_state_machine__99703__auto__);

(statearr_116640[(1)] = (1));

return statearr_116640;
});
var fluree$db$session$full_load_existing_db_$_state_machine__99703__auto____1 = (function (state_116578){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_116578);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e116641){if((e116641 instanceof Object)){
var ex__99706__auto__ = e116641;
var statearr_116642_116694 = state_116578;
(statearr_116642_116694[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_116578);

return cljs.core.cst$kw$recur;
} else {
throw e116641;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__116695 = state_116578;
state_116578 = G__116695;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$session$full_load_existing_db_$_state_machine__99703__auto__ = function(state_116578){
switch(arguments.length){
case 0:
return fluree$db$session$full_load_existing_db_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$session$full_load_existing_db_$_state_machine__99703__auto____1.call(this,state_116578);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$session$full_load_existing_db_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$session$full_load_existing_db_$_state_machine__99703__auto____0;
fluree$db$session$full_load_existing_db_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$session$full_load_existing_db_$_state_machine__99703__auto____1;
return fluree$db$session$full_load_existing_db_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___116644,pc))
})();
var state__99811__auto__ = (function (){var statearr_116643 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_116643[(6)] = c__99809__auto___116644);

return statearr_116643;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___116644,pc))
);


return pc;
});
/**
 * Performs a compare and set! to update db, but only does so if
 *   existing db promise-chan is the same as old-db-ch.
 * 
 *   Returns true if successful, false if it did not replace.
 */
fluree.db.session.cas_db_BANG_ = (function fluree$db$session$cas_db_BANG_(session,old_db_ch,new_db_ch){
var new_state = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),(function (state){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(old_db_ch,cljs.core.cst$kw$db_SLASH_db.cljs$core$IFn$_invoke$arity$1(state))){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(state,cljs.core.cst$kw$db_SLASH_db,new_db_ch);
} else {
return state;
}
}));
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new_db_ch,cljs.core.cst$kw$db_SLASH_db.cljs$core$IFn$_invoke$arity$1(new_state));
});
/**
 * Clears db from cache, forcing a new full load next time db is requested.
 */
fluree.db.session.clear_db_BANG_ = (function fluree$db$session$clear_db_BANG_(session){
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),cljs.core.assoc,cljs.core.cst$kw$db_SLASH_db,null);
});
/**
 * Clears any current db that is cached and forces a db reload.
 */
fluree.db.session.reload_db_BANG_ = (function fluree$db$session$reload_db_BANG_(session){
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),cljs.core.assoc,cljs.core.cst$kw$db_SLASH_db,fluree.db.session.full_load_existing_db(session));
});
/**
 * Returns block currently being indexed (truthy), or nil (falsey) if not currently indexing.
 */
fluree.db.session.indexing_QMARK_ = (function fluree$db$session$indexing_QMARK_(session){
return cljs.core.cst$kw$db_SLASH_indexing.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session)));
});
/**
 * Returns block of last indexed block, but only for indexing done by this server.
 */
fluree.db.session.indexed = (function fluree$db$session$indexed(session){
return cljs.core.cst$kw$db_SLASH_indexed.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session)));
});
/**
 * Attempts to acquire indexing lock, and if successful returns true, else false.
 */
fluree.db.session.acquire_indexing_lock_BANG_ = (function fluree$db$session$acquire_indexing_lock_BANG_(session,block){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),(function (s){
var G__116696 = s;
if((cljs.core.cst$kw$db_SLASH_indexing.cljs$core$IFn$_invoke$arity$1(s) == null)){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(G__116696,cljs.core.cst$kw$db_SLASH_indexing,block);
} else {
return G__116696;
}
}));

return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(block,fluree.db.session.indexing_QMARK_(session));
});
/**
 * Releases indexing lock, and updates the last indexed value on the connection with provided block number.
 */
fluree.db.session.release_indexing_lock_BANG_ = (function fluree$db$session$release_indexing_lock_BANG_(session,block){
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$variadic(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),cljs.core.assoc,cljs.core.cst$kw$db_SLASH_indexing,null,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$db_SLASH_indexed,block], 0));
});
fluree.db.session.alias__GT_id_cache = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.cache.lru_cache_factory(new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$threshold,(100)], null)));
/**
 * Returns ledger id from alias.
 */
fluree.db.session.ledger_alias__GT_id = (function fluree$db$session$ledger_alias__GT_id(conn,network,alias){
var or__4131__auto__ = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(fluree.db.session.alias__GT_id_cache),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,alias], null));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var dbid = alias;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(fluree.db.session.alias__GT_id_cache,cljs.core.assoc_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,alias], null),dbid);

return dbid;
}
});
/**
 * Resolves a ledger identity in the form of 'network/alias' and returns a
 *   two-tuple of [network ledger-id].
 * 
 *   An alias lookup is always performed first, and if an alias doesn't exist it is assumed
 *   the provided name is a ledger-id.
 * 
 *   If you are providing a ledger-id, and wish to skip an alias lookup, a prefix of '$'
 *   can be used for the name portion of the ledger.
 * 
 *   i.e.
 *   - testnet/testledger - Look for ledger with an alias testledger on network testnet.
 *   - testnet/$testledger - look for a ledger with id testledger on network testnet (skip alias lookup).
 *   - [testnet testledger] - already in form of [network ledger-id]
 */
fluree.db.session.resolve_ledger = (function fluree$db$session$resolve_ledger(conn,ledger){
if(cljs.core.sequential_QMARK_(ledger)){
return ledger;
} else {
var ledger__$1 = cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(ledger);
var network = cljs.core.namespace(ledger__$1);
var maybe_alias = cljs.core.name(ledger__$1);
var _ = (cljs.core.truth_((function (){var and__4120__auto__ = network;
if(cljs.core.truth_(and__4120__auto__)){
return maybe_alias;
} else {
return and__4120__auto__;
}
})())?null:(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid ledger identity: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([ledger__$1], 0))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_db], null))})());
if(clojure.string.starts_with_QMARK_(maybe_alias,"$")){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,cljs.core.subs.cljs$core$IFn$_invoke$arity$2(maybe_alias,(1))], null);
} else {
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,fluree.db.session.ledger_alias__GT_id(conn,network,maybe_alias),maybe_alias], null);
}
}
});
if((typeof fluree !== 'undefined') && (typeof fluree.db !== 'undefined') && (typeof fluree.db.session !== 'undefined') && (typeof fluree.db.session.process_ledger_update !== 'undefined')){
} else {
fluree.db.session.process_ledger_update = (function (){var method_table__4613__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4614__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4615__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4616__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4617__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$3(cljs.core.PersistentArrayMap.EMPTY,cljs.core.cst$kw$hierarchy,(function (){var fexpr__116697 = cljs.core.get_global_hierarchy;
return (fexpr__116697.cljs$core$IFn$_invoke$arity$0 ? fexpr__116697.cljs$core$IFn$_invoke$arity$0() : fexpr__116697.call(null));
})());
return (new cljs.core.MultiFn(cljs.core.symbol.cljs$core$IFn$_invoke$arity$2("fluree.db.session","process-ledger-update"),((function (method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__){
return (function (_,event_type,___$1){
return event_type;
});})(method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__))
,cljs.core.cst$kw$default,hierarchy__4617__auto__,method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__));
})();
}
fluree.db.session.process_ledger_update.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$block,(function (session,event_type,p__116699){
var map__116700 = p__116699;
var map__116700__$1 = (((((!((map__116700 == null))))?(((((map__116700.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116700.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__116700):map__116700);
var data = map__116700__$1;
var block = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116700__$1,cljs.core.cst$kw$block);
var t = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116700__$1,cljs.core.cst$kw$t);
var flakes = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116700__$1,cljs.core.cst$kw$flakes);
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,map__116700,map__116700__$1,data,block,t,flakes){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,map__116700,map__116700__$1,data,block,t,flakes){
return (function (state_116746){
var state_val_116747 = (state_116746[(1)]);
if((state_val_116747 === (7))){
var inst_116710 = (state_116746[(7)]);
var inst_116718 = ((1) + inst_116710);
var inst_116719 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(block,inst_116718);
var state_116746__$1 = state_116746;
if(inst_116719){
var statearr_116748_116771 = state_116746__$1;
(statearr_116748_116771[(1)] = (9));

} else {
var statearr_116749_116772 = state_116746__$1;
(statearr_116749_116772[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (1))){
var state_116746__$1 = state_116746;
var statearr_116750_116773 = state_116746__$1;
(statearr_116750_116773[(2)] = null);

(statearr_116750_116773[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (4))){
var inst_116706 = (state_116746[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_116746,(3),Error,null,(2));
var inst_116706__$1 = (fluree.db.session.current_db.cljs$core$IFn$_invoke$arity$1 ? fluree.db.session.current_db.cljs$core$IFn$_invoke$arity$1(session) : fluree.db.session.current_db.call(null,session));
var state_116746__$1 = (function (){var statearr_116751 = state_116746;
(statearr_116751[(8)] = inst_116706__$1);

return statearr_116751;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116746__$1,(5),inst_116706__$1);
} else {
if((state_val_116747 === (13))){
var state_116746__$1 = state_116746;
var statearr_116752_116774 = state_116746__$1;
(statearr_116752_116774[(2)] = null);

(statearr_116752_116774[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (6))){
var inst_116713 = cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(session);
var inst_116714 = cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(session);
var inst_116715 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116713),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116714),": Received block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),", but DB is already more current. No-op."].join('');
var inst_116716 = fluree.db.util.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_116715], 0));
var state_116746__$1 = state_116746;
var statearr_116753_116775 = state_116746__$1;
(statearr_116753_116775[(2)] = inst_116716);

(statearr_116753_116775[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (3))){
var inst_116702 = (state_116746[(2)]);
var state_116746__$1 = state_116746;
var statearr_116754_116776 = state_116746__$1;
(statearr_116754_116776[(2)] = inst_116702);


cljs.core.async.impl.ioc_helpers.process_exception(state_116746__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (12))){
var inst_116710 = (state_116746[(7)]);
var inst_116731 = cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(session);
var inst_116732 = cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(session);
var inst_116733 = ["Missing block(s): ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116731),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116732),". Received block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),", but latest local block is: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116710),". Forcing a db reload."].join('');
var inst_116734 = fluree.db.util.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_116733], 0));
var inst_116735 = fluree.db.session.reload_db_BANG_(session);
var state_116746__$1 = (function (){var statearr_116755 = state_116746;
(statearr_116755[(9)] = inst_116734);

return statearr_116755;
})();
var statearr_116756_116777 = state_116746__$1;
(statearr_116756_116777[(2)] = inst_116735);

(statearr_116756_116777[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (2))){
var inst_116744 = (state_116746[(2)]);
var state_116746__$1 = state_116746;
return cljs.core.async.impl.ioc_helpers.return_chan(state_116746__$1,inst_116744);
} else {
if((state_val_116747 === (11))){
var inst_116740 = (state_116746[(2)]);
var state_116746__$1 = state_116746;
var statearr_116757_116778 = state_116746__$1;
(statearr_116757_116778[(2)] = inst_116740);

(statearr_116757_116778[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (9))){
var inst_116706 = (state_116746[(8)]);
var inst_116709 = (state_116746[(10)]);
var inst_116710 = (state_116746[(7)]);
var inst_116721 = cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(session);
var inst_116722 = cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(session);
var inst_116723 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116721),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116722),": Received block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),", DB at that block, update cached db with flakes."].join('');
var inst_116724 = fluree.db.util.log.trace.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_116723], 0));
var inst_116725 = (function (){var current_db_ch = inst_116706;
var current_db = inst_116709;
var current_block = inst_116710;
return ((function (current_db_ch,current_db,current_block,inst_116706,inst_116709,inst_116710,inst_116721,inst_116722,inst_116723,inst_116724,state_val_116747,c__99809__auto__,map__116700,map__116700__$1,data,block,t,flakes){
return (function (p1__116698_SHARP_){
if((p1__116698_SHARP_ instanceof fluree.db.flake.Flake)){
return p1__116698_SHARP_;
} else {
return fluree.db.flake.parts__GT_Flake.cljs$core$IFn$_invoke$arity$1(p1__116698_SHARP_);
}
});
;})(current_db_ch,current_db,current_block,inst_116706,inst_116709,inst_116710,inst_116721,inst_116722,inst_116723,inst_116724,state_val_116747,c__99809__auto__,map__116700,map__116700__$1,data,block,t,flakes))
})();
var inst_116726 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_116725,flakes);
var inst_116727 = fluree.db.dbproto._with(inst_116709,block,inst_116726);
var inst_116728 = fluree.db.session.cas_db_BANG_(session,inst_116706,inst_116727);
var state_116746__$1 = (function (){var statearr_116758 = state_116746;
(statearr_116758[(11)] = inst_116724);

return statearr_116758;
})();
var statearr_116759_116779 = state_116746__$1;
(statearr_116759_116779[(2)] = inst_116728);

(statearr_116759_116779[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (5))){
var inst_116709 = (state_116746[(10)]);
var inst_116710 = (state_116746[(7)]);
var inst_116708 = (state_116746[(2)]);
var inst_116709__$1 = fluree.db.util.async.throw_err(inst_116708);
var inst_116710__$1 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(inst_116709__$1);
var inst_116711 = (block <= inst_116710__$1);
var state_116746__$1 = (function (){var statearr_116760 = state_116746;
(statearr_116760[(10)] = inst_116709__$1);

(statearr_116760[(7)] = inst_116710__$1);

return statearr_116760;
})();
if(cljs.core.truth_(inst_116711)){
var statearr_116761_116780 = state_116746__$1;
(statearr_116761_116780[(1)] = (6));

} else {
var statearr_116762_116781 = state_116746__$1;
(statearr_116762_116781[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (14))){
var inst_116738 = (state_116746[(2)]);
var state_116746__$1 = state_116746;
var statearr_116763_116782 = state_116746__$1;
(statearr_116763_116782[(2)] = inst_116738);

(statearr_116763_116782[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (10))){
var state_116746__$1 = state_116746;
var statearr_116764_116783 = state_116746__$1;
(statearr_116764_116783[(1)] = (12));



return cljs.core.cst$kw$recur;
} else {
if((state_val_116747 === (8))){
var inst_116742 = (state_116746[(2)]);
var state_116746__$1 = state_116746;
var statearr_116766_116784 = state_116746__$1;
(statearr_116766_116784[(2)] = inst_116742);


cljs.core.async.impl.ioc_helpers.process_exception(state_116746__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,map__116700,map__116700__$1,data,block,t,flakes))
;
return ((function (switch__99702__auto__,c__99809__auto__,map__116700,map__116700__$1,data,block,t,flakes){
return (function() {
var fluree$db$session$state_machine__99703__auto__ = null;
var fluree$db$session$state_machine__99703__auto____0 = (function (){
var statearr_116767 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_116767[(0)] = fluree$db$session$state_machine__99703__auto__);

(statearr_116767[(1)] = (1));

return statearr_116767;
});
var fluree$db$session$state_machine__99703__auto____1 = (function (state_116746){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_116746);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e116768){if((e116768 instanceof Object)){
var ex__99706__auto__ = e116768;
var statearr_116769_116785 = state_116746;
(statearr_116769_116785[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_116746);

return cljs.core.cst$kw$recur;
} else {
throw e116768;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__116786 = state_116746;
state_116746 = G__116786;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$session$state_machine__99703__auto__ = function(state_116746){
switch(arguments.length){
case 0:
return fluree$db$session$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$session$state_machine__99703__auto____1.call(this,state_116746);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$session$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$session$state_machine__99703__auto____0;
fluree$db$session$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$session$state_machine__99703__auto____1;
return fluree$db$session$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,map__116700,map__116700__$1,data,block,t,flakes))
})();
var state__99811__auto__ = (function (){var statearr_116770 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_116770[(6)] = c__99809__auto__);

return statearr_116770;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,map__116700,map__116700__$1,data,block,t,flakes))
);

return c__99809__auto__;
}));
fluree.db.session.process_ledger_update.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$new_DASH_index,(function (session,header,block){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_116793){
var state_val_116794 = (state_116793[(1)]);
if((state_val_116794 === (1))){
var inst_116787 = fluree.db.session.clear_db_BANG_(session);
var inst_116788 = cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(session);
var inst_116789 = cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(session);
var inst_116790 = ["Database ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116788),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116789)," re-indexed as of block: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),"."].join('');
var inst_116791 = fluree.db.util.log.debug.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_116790], 0));
var state_116793__$1 = (function (){var statearr_116795 = state_116793;
(statearr_116795[(7)] = inst_116787);

(statearr_116795[(8)] = inst_116791);

return statearr_116795;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_116793__$1,true);
} else {
return null;
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$session$state_machine__99703__auto__ = null;
var fluree$db$session$state_machine__99703__auto____0 = (function (){
var statearr_116796 = [null,null,null,null,null,null,null,null,null];
(statearr_116796[(0)] = fluree$db$session$state_machine__99703__auto__);

(statearr_116796[(1)] = (1));

return statearr_116796;
});
var fluree$db$session$state_machine__99703__auto____1 = (function (state_116793){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_116793);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e116797){if((e116797 instanceof Object)){
var ex__99706__auto__ = e116797;
var statearr_116798_116800 = state_116793;
(statearr_116798_116800[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_116793);

return cljs.core.cst$kw$recur;
} else {
throw e116797;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__116801 = state_116793;
state_116793 = G__116801;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$session$state_machine__99703__auto__ = function(state_116793){
switch(arguments.length){
case 0:
return fluree$db$session$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$session$state_machine__99703__auto____1.call(this,state_116793);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$session$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$session$state_machine__99703__auto____0;
fluree$db$session$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$session$state_machine__99703__auto____1;
return fluree$db$session$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_116799 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_116799[(6)] = c__99809__auto__);

return statearr_116799;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
}));
fluree.db.session.closed_QMARK_ = (function fluree$db$session$closed_QMARK_(session){
return cljs.core.cst$kw$closed_QMARK_.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session)));
});
/**
 * Properly shuts down a session.
 *   Returns true if shut down, false if it was already shut down.
 * 
 *   Calling with a session will shut down session, calling with
 *   two arity network + dbid will see if a session is in cache and
 *   then perform the shutdown on the cached session, else will return
 *   false.
 */
fluree.db.session.close = (function fluree$db$session$close(var_args){
var G__116803 = arguments.length;
switch (G__116803) {
case 1:
return fluree.db.session.close.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.session.close.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.session.close.cljs$core$IFn$_invoke$arity$1 = (function (session){
if(cljs.core.truth_(fluree.db.session.closed_QMARK_(session))){
return false;
} else {
var map__116804 = session;
var map__116804__$1 = (((((!((map__116804 == null))))?(((((map__116804.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116804.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__116804):map__116804);
var conn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116804__$1,cljs.core.cst$kw$conn);
var update_chan = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116804__$1,cljs.core.cst$kw$update_DASH_chan);
var transact_chan = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116804__$1,cljs.core.cst$kw$transact_DASH_chan);
var state = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116804__$1,cljs.core.cst$kw$state);
var network = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116804__$1,cljs.core.cst$kw$network);
var dbid = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116804__$1,cljs.core.cst$kw$dbid);
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116804__$1,cljs.core.cst$kw$id);
var closed_QMARK_ = fluree.db.session.closed_QMARK_(session);
if(cljs.core.truth_(closed_QMARK_)){
fluree.db.session.remove_cache_BANG_(network,dbid);

return false;
} else {
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(state,cljs.core.assoc,cljs.core.cst$kw$closed_QMARK_,true);

var fexpr__116806_116809 = cljs.core.cst$kw$remove_DASH_listener.cljs$core$IFn$_invoke$arity$1(conn);
(fexpr__116806_116809.cljs$core$IFn$_invoke$arity$3 ? fexpr__116806_116809.cljs$core$IFn$_invoke$arity$3(network,dbid,id) : fexpr__116806_116809.call(null,network,dbid,id));

cljs.core.async.close_BANG_(update_chan);

if(cljs.core.truth_(transact_chan)){
cljs.core.async.close_BANG_(transact_chan);
} else {
}

fluree.db.session.remove_cache_BANG_(network,dbid);

if(cljs.core.fn_QMARK_(cljs.core.cst$kw$close.cljs$core$IFn$_invoke$arity$1(session))){
var fexpr__116807_116810 = cljs.core.cst$kw$close.cljs$core$IFn$_invoke$arity$1(session);
(fexpr__116807_116810.cljs$core$IFn$_invoke$arity$0 ? fexpr__116807_116810.cljs$core$IFn$_invoke$arity$0() : fexpr__116807_116810.call(null));
} else {
}

return true;
}
}
});

fluree.db.session.close.cljs$core$IFn$_invoke$arity$2 = (function (network,dbid){
var temp__5733__auto__ = fluree.db.session.from_cache(network,dbid);
if(cljs.core.truth_(temp__5733__auto__)){
var session = temp__5733__auto__;
return fluree.db.session.close.cljs$core$IFn$_invoke$arity$1(session);
} else {
return false;
}
});

fluree.db.session.close.cljs$lang$maxFixedArity = 2;

/**
 * Creates loop that takes new blocks / index commands and processes them in order
 *   ensuring the consistency of the database.
 */
fluree.db.session.process_ledger_updates = (function fluree$db$session$process_ledger_updates(conn,network,ledger_id,update_chan){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_116860){
var state_val_116861 = (state_116860[(1)]);
if((state_val_116861 === (7))){
var inst_116856 = (state_116860[(2)]);
var state_116860__$1 = state_116860;
var statearr_116862_116886 = state_116860__$1;
(statearr_116862_116886[(2)] = inst_116856);

(statearr_116862_116886[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (1))){
var state_116860__$1 = state_116860;
var statearr_116863_116887 = state_116860__$1;
(statearr_116863_116887[(2)] = null);

(statearr_116863_116887[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (4))){
var inst_116814 = (state_116860[(7)]);
var inst_116813 = (state_116860[(2)]);
var inst_116814__$1 = fluree.db.util.async.throw_err(inst_116813);
var inst_116815 = fluree.db.session.from_cache(network,ledger_id);
var inst_116816 = (inst_116814__$1 == null);
var state_116860__$1 = (function (){var statearr_116864 = state_116860;
(statearr_116864[(8)] = inst_116815);

(statearr_116864[(7)] = inst_116814__$1);

return statearr_116864;
})();
if(cljs.core.truth_(inst_116816)){
var statearr_116865_116888 = state_116860__$1;
(statearr_116865_116888[(1)] = (5));

} else {
var statearr_116866_116889 = state_116860__$1;
(statearr_116866_116889[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (15))){
var inst_116814 = (state_116860[(7)]);
var inst_116829 = (state_116860[(2)]);
var inst_116830 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_116829,"Exception processing ledger updates for message: ",inst_116814], 0));
var state_116860__$1 = state_116860;
var statearr_116867_116890 = state_116860__$1;
(statearr_116867_116890[(2)] = inst_116830);


cljs.core.async.impl.ioc_helpers.process_exception(state_116860__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (13))){
var inst_116852 = (state_116860[(2)]);
var state_116860__$1 = state_116860;
var statearr_116868_116891 = state_116860__$1;
(statearr_116868_116891[(2)] = inst_116852);

(statearr_116868_116891[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (6))){
var inst_116815 = (state_116860[(8)]);
var inst_116821 = (inst_116815 == null);
var state_116860__$1 = state_116860;
if(cljs.core.truth_(inst_116821)){
var statearr_116869_116892 = state_116860__$1;
(statearr_116869_116892[(1)] = (8));

} else {
var statearr_116870_116893 = state_116860__$1;
(statearr_116870_116893[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (17))){
var inst_116845 = (state_116860[(2)]);
var inst_116846 = fluree.db.util.async.throw_err(inst_116845);
var state_116860__$1 = state_116860;
var statearr_116871_116894 = state_116860__$1;
(statearr_116871_116894[(2)] = inst_116846);


cljs.core.async.impl.ioc_helpers.process_exception(state_116860__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (3))){
var inst_116858 = (state_116860[(2)]);
var state_116860__$1 = state_116860;
return cljs.core.async.impl.ioc_helpers.return_chan(state_116860__$1,inst_116858);
} else {
if((state_val_116861 === (12))){
var state_116860__$1 = state_116860;
var statearr_116872_116895 = state_116860__$1;
(statearr_116872_116895[(2)] = null);

(statearr_116872_116895[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (2))){
var state_116860__$1 = state_116860;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116860__$1,(4),update_chan);
} else {
if((state_val_116861 === (11))){
var state_116860__$1 = state_116860;
var statearr_116873_116896 = state_116860__$1;
(statearr_116873_116896[(2)] = null);

(statearr_116873_116896[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (9))){
var state_116860__$1 = state_116860;
var statearr_116874_116897 = state_116860__$1;
(statearr_116874_116897[(1)] = (11));



return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (5))){
var inst_116818 = ["Channel closed for session updates for: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"."].join('');
var inst_116819 = fluree.db.util.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_116818], 0));
var state_116860__$1 = state_116860;
var statearr_116876_116898 = state_116860__$1;
(statearr_116876_116898[(2)] = inst_116819);

(statearr_116876_116898[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (14))){
var inst_116848 = (state_116860[(2)]);
var state_116860__$1 = (function (){var statearr_116877 = state_116860;
(statearr_116877[(9)] = inst_116848);

return statearr_116877;
})();
var statearr_116878_116899 = state_116860__$1;
(statearr_116878_116899[(2)] = null);

(statearr_116878_116899[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (16))){
var inst_116815 = (state_116860[(8)]);
var inst_116814 = (state_116860[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_116860,(15),cljs.core.cst$kw$default,null,(14));
var inst_116837 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_116814,(0),null);
var inst_116838 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_116814,(1),null);
var inst_116839 = ["[process-ledger-updates[",cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"]: "].join('');
var inst_116840 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_116814], 0));
var inst_116841 = fluree.db.util.core.trunc(inst_116840,(200));
var inst_116842 = fluree.db.util.log.trace.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_116839,inst_116841], 0));
var inst_116843 = (fluree.db.session.process_ledger_update.cljs$core$IFn$_invoke$arity$3 ? fluree.db.session.process_ledger_update.cljs$core$IFn$_invoke$arity$3(inst_116815,inst_116837,inst_116838) : fluree.db.session.process_ledger_update.call(null,inst_116815,inst_116837,inst_116838));
var state_116860__$1 = (function (){var statearr_116879 = state_116860;
(statearr_116879[(10)] = inst_116842);

return statearr_116879;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116860__$1,(17),inst_116843);
} else {
if((state_val_116861 === (10))){
var inst_116854 = (state_116860[(2)]);
var state_116860__$1 = state_116860;
var statearr_116880_116900 = state_116860__$1;
(statearr_116880_116900[(2)] = inst_116854);

(statearr_116880_116900[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116861 === (8))){
var inst_116814 = (state_116860[(7)]);
var inst_116823 = cljs.core.first(inst_116814);
var inst_116824 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_116823], 0));
var inst_116825 = ["Ledger update received for session that is no longer open: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),". Message: ",inst_116824].join('');
var inst_116826 = fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_116825], 0));
var state_116860__$1 = state_116860;
var statearr_116881_116901 = state_116860__$1;
(statearr_116881_116901[(2)] = inst_116826);

(statearr_116881_116901[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$session$process_ledger_updates_$_state_machine__99703__auto__ = null;
var fluree$db$session$process_ledger_updates_$_state_machine__99703__auto____0 = (function (){
var statearr_116882 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_116882[(0)] = fluree$db$session$process_ledger_updates_$_state_machine__99703__auto__);

(statearr_116882[(1)] = (1));

return statearr_116882;
});
var fluree$db$session$process_ledger_updates_$_state_machine__99703__auto____1 = (function (state_116860){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_116860);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e116883){if((e116883 instanceof Object)){
var ex__99706__auto__ = e116883;
var statearr_116884_116902 = state_116860;
(statearr_116884_116902[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_116860);

return cljs.core.cst$kw$recur;
} else {
throw e116883;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__116903 = state_116860;
state_116860 = G__116903;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$session$process_ledger_updates_$_state_machine__99703__auto__ = function(state_116860){
switch(arguments.length){
case 0:
return fluree$db$session$process_ledger_updates_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$session$process_ledger_updates_$_state_machine__99703__auto____1.call(this,state_116860);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$session$process_ledger_updates_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$session$process_ledger_updates_$_state_machine__99703__auto____0;
fluree$db$session$process_ledger_updates_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$session$process_ledger_updates_$_state_machine__99703__auto____1;
return fluree$db$session$process_ledger_updates_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_116885 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_116885[(6)] = c__99809__auto__);

return statearr_116885;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Creates a connection without first checking if db exists. Only useful if reloading
 *   and replacing an existing DB.
 */
fluree.db.session.session_factory = (function fluree$db$session$session_factory(p__116904){
var map__116905 = p__116904;
var map__116905__$1 = (((((!((map__116905 == null))))?(((((map__116905.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116905.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__116905):map__116905);
var network = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116905__$1,cljs.core.cst$kw$network);
var conn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116905__$1,cljs.core.cst$kw$conn);
var dbid = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116905__$1,cljs.core.cst$kw$dbid);
var db = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116905__$1,cljs.core.cst$kw$db);
var transactor_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116905__$1,cljs.core.cst$kw$transactor_QMARK_);
var db_name = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116905__$1,cljs.core.cst$kw$db_DASH_name);
var state = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116905__$1,cljs.core.cst$kw$state);
var close = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116905__$1,cljs.core.cst$kw$close);
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116905__$1,cljs.core.cst$kw$id);
var schema_cache = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var update_chan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var transact_chan = (cljs.core.truth_(transactor_QMARK_)?cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0():null);
var state__$1 = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([state,new cljs.core.PersistentArrayMap(null, 7, [cljs.core.cst$kw$req_SLASH_sync,cljs.core.PersistentArrayMap.EMPTY,cljs.core.cst$kw$req_SLASH_count,(0),cljs.core.cst$kw$req_SLASH_last,null,cljs.core.cst$kw$db_SLASH_pending_DASH_tx,cljs.core.PersistentArrayMap.EMPTY,cljs.core.cst$kw$db_SLASH_db,(cljs.core.truth_(db)?cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(db,cljs.core.cst$kw$schema_DASH_cache,schema_cache):null),cljs.core.cst$kw$db_SLASH_indexing,null,cljs.core.cst$kw$closed_QMARK_,false], null)], 0)));
var session = fluree.db.session.map__GT_DbSession(cljs.core.PersistentHashMap.fromArrays([cljs.core.cst$kw$dbid,cljs.core.cst$kw$update_DASH_chan,cljs.core.cst$kw$db_DASH_name,cljs.core.cst$kw$state,cljs.core.cst$kw$close,cljs.core.cst$kw$id,cljs.core.cst$kw$schema_DASH_cache,cljs.core.cst$kw$transact_DASH_chan,cljs.core.cst$kw$network,cljs.core.cst$kw$blank_DASH_db,cljs.core.cst$kw$conn],[dbid,update_chan,db_name,state__$1,close,id,schema_cache,transact_chan,network,null,conn]));
var current_db_fn = ((function (schema_cache,update_chan,transact_chan,state__$1,session,map__116905,map__116905__$1,network,conn,dbid,db,transactor_QMARK_,db_name,state,close,id){
return (function (){
return (fluree.db.session.current_db.cljs$core$IFn$_invoke$arity$1 ? fluree.db.session.current_db.cljs$core$IFn$_invoke$arity$1(session) : fluree.db.session.current_db.call(null,session));
});})(schema_cache,update_chan,transact_chan,state__$1,session,map__116905,map__116905__$1,network,conn,dbid,db,transactor_QMARK_,db_name,state,close,id))
;
var blank_db = fluree.db.graphdb.blank_db(conn,network,dbid,schema_cache,current_db_fn);
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(session,cljs.core.cst$kw$blank_DASH_db,blank_db);
});
/**
 * Blocks can have multiple transactions. If we are monitoring a single transaction
 *   we take a full block response and return a map with just that transaction's details.
 *   If the entire block details are desired, the block can be used to retrieve them.
 * 
 *   If throw? is true, throws an exception if non-2xx response.
 */
fluree.db.session.block_response__GT_tx_response = (function fluree$db$session$block_response__GT_tx_response(block_result,txid){
var map__116910 = block_result;
var map__116910__$1 = (((((!((map__116910 == null))))?(((((map__116910.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116910.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__116910):map__116910);
var block = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116910__$1,cljs.core.cst$kw$block);
var hash = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116910__$1,cljs.core.cst$kw$hash);
var instant = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116910__$1,cljs.core.cst$kw$instant);
var txns = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116910__$1,cljs.core.cst$kw$txns);
var flakes = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116910__$1,cljs.core.cst$kw$flakes);
var tx_result = (function (){var or__4131__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(txns,cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(txid));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(txns,txid);
}
})();
var _ = (cljs.core.truth_(tx_result)?null:(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Unexpected error, unable to get tx results for txid ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(txid)," out of block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),"."].join(''),new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error,cljs.core.cst$kw$block,cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([block_result], 0))], null))})());
var map__116911 = tx_result;
var map__116911__$1 = (((((!((map__116911 == null))))?(((((map__116911.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116911.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__116911):map__116911);
var t = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116911__$1,cljs.core.cst$kw$t);
var status = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116911__$1,cljs.core.cst$kw$status);
var t_filter = (((cljs.core.first(flakes) instanceof fluree.db.flake.Flake))?((function (map__116910,map__116910__$1,block,hash,instant,txns,flakes,tx_result,_,map__116911,map__116911__$1,t,status){
return (function (p1__116907_SHARP_){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(t,p1__116907_SHARP_.t);
});})(map__116910,map__116910__$1,block,hash,instant,txns,flakes,tx_result,_,map__116911,map__116911__$1,t,status))
:((function (map__116910,map__116910__$1,block,hash,instant,txns,flakes,tx_result,_,map__116911,map__116911__$1,t,status){
return (function (p1__116908_SHARP_){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(t,cljs.core.nth.cljs$core$IFn$_invoke$arity$2(p1__116908_SHARP_,(3)));
});})(map__116910,map__116910__$1,block,hash,instant,txns,flakes,tx_result,_,map__116911,map__116911__$1,t,status))
);
var response = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(tx_result,cljs.core.cst$kw$block,block,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$hash,hash,cljs.core.cst$kw$instant,instant,cljs.core.cst$kw$flakes,cljs.core.filter.cljs$core$IFn$_invoke$arity$2(t_filter,flakes)], 0));
if((cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(response) < (300))){
return response;
} else {
var error_msg = cljs.core.some(((function (map__116910,map__116910__$1,block,hash,instant,txns,flakes,tx_result,_,map__116911,map__116911__$1,t,status,t_filter,response){
return (function (p1__116909_SHARP_){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((109),cljs.core.second(p1__116909_SHARP_))){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(p1__116909_SHARP_,(2));
} else {
return null;
}
});})(map__116910,map__116910__$1,block,hash,instant,txns,flakes,tx_result,_,map__116911,map__116911__$1,t,status,t_filter,response))
,cljs.core.cst$kw$flakes.cljs$core$IFn$_invoke$arity$1(response));
var vec__116914 = (cljs.core.truth_(error_msg)?cljs.core.re_find(/^([0-9]+) ([^ ]+) (.+)/,error_msg):null);
var ___$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116914,(0),null);
var status__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116914,(1),null);
var error = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116914,(2),null);
var message = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116914,(3),null);
return cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2((function (){var or__4131__auto__ = message;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "Unknown error.";
}
})(),new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$status,cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(response),cljs.core.cst$kw$error,cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(error),cljs.core.cst$kw$meta,response], null));
}
});
/**
 * Creates new session and caches it.
 * 
 *   Will tolerate race conditions, and if this call successfully created the session
 *   it will attach an extra key, :new? true, to the session.
 * 
 *   If another process created the session first, will return the other process' session.
 */
fluree.db.session.create_and_cache_session = (function fluree$db$session$create_and_cache_session(opts){
var _ = fluree.db.util.log.trace.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Create and cache session. Opt keys: ",cljs.core.keys(opts)], 0));
var id = fluree.db.util.core.random_uuid();
var session = fluree.db.session.session_factory(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(opts,cljs.core.cst$kw$id,id));
var session_STAR_ = fluree.db.session.cache_BANG_(session);
var new_QMARK_ = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(id,cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(session_STAR_));
if(new_QMARK_){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(session_STAR_,cljs.core.cst$kw$new_QMARK_,true);
} else {
return session_STAR_;
}
});
/**
 * Returns connection to the given ledger, and ensures it is cached.
 * 
 *   If 'state' is provided, it will get merged into the connection's state.
 *   Use namespaced keys, so as to not to create a conflict with system state keys.
 * 
 *   Options supported:
 *   - connect? - attempts to create a streaming connection to db - will fail if db does not exist
 *           - ensure is 'false' if trying to create a new db that does not yet exist.
 *   - state    - initial state map to use
 *   - auth     - the auth
 *   - jwt      - jwt from password login
 *   
 */
fluree.db.session.session = (function fluree$db$session$session(var_args){
var G__116918 = arguments.length;
switch (G__116918) {
case 2:
return fluree.db.session.session.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.session.session.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.session.session.cljs$core$IFn$_invoke$arity$2 = (function (conn,ledger){
return fluree.db.session.session.cljs$core$IFn$_invoke$arity$3(conn,ledger,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.session.session.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,p__116919){
var map__116920 = p__116919;
var map__116920__$1 = (((((!((map__116920 == null))))?(((((map__116920.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116920.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__116920):map__116920);
var state = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116920__$1,cljs.core.cst$kw$state);
var connect_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116920__$1,cljs.core.cst$kw$connect_QMARK_);
var auth = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116920__$1,cljs.core.cst$kw$auth);
var jwt = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__116920__$1,cljs.core.cst$kw$jwt);
var vec__116922 = fluree.db.session.resolve_ledger(conn,ledger);
var network = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116922,(0),null);
var ledger_id = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116922,(1),null);
var ledger_alias = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116922,(2),null);
var connect_QMARK___$1 = ((connect_QMARK_ === false)?false:true);
var transactor_QMARK_ = cljs.core.cst$kw$transactor_QMARK_.cljs$core$IFn$_invoke$arity$1(conn);
var opts = fluree.db.util.core.without_nils(new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$auth,auth,cljs.core.cst$kw$jwt,jwt], null));
var or__4131__auto__ = fluree.db.session.from_cache(network,ledger_id);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var session = fluree.db.session.create_and_cache_session(new cljs.core.PersistentArrayMap(null, 8, [cljs.core.cst$kw$network,network,cljs.core.cst$kw$dbid,ledger_id,cljs.core.cst$kw$db_DASH_name,null,cljs.core.cst$kw$auth,auth,cljs.core.cst$kw$jwt,jwt,cljs.core.cst$kw$conn,conn,cljs.core.cst$kw$state,(function (){var or__4131__auto____$1 = state;
if(cljs.core.truth_(or__4131__auto____$1)){
return or__4131__auto____$1;
} else {
return cljs.core.PersistentArrayMap.EMPTY;
}
})(),cljs.core.cst$kw$transactor_QMARK_,transactor_QMARK_], null));
var new_QMARK_ = cljs.core.cst$kw$new_QMARK_.cljs$core$IFn$_invoke$arity$1(session) === true;
if(new_QMARK_){
if(connect_QMARK___$1){
fluree.db.operations.subscribe.cljs$core$IFn$_invoke$arity$2(session,opts);

var G__116926_117045 = network;
var G__116927_117046 = ledger_id;
var G__116928_117047 = cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(session);
var G__116929_117048 = ((function (G__116926_117045,G__116927_117046,G__116928_117047,session,new_QMARK_,or__4131__auto__,vec__116922,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__116920,map__116920__$1,state,connect_QMARK_,auth,jwt){
return (function (event_type,event_data){
cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$update_DASH_chan.cljs$core$IFn$_invoke$arity$1(session),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [event_type,event_data], null));

if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$block,event_type)){
var temp__5735__auto__ = cljs.core.not_empty(cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session)),cljs.core.cst$kw$db_SLASH_pending_DASH_tx));
if(cljs.core.truth_(temp__5735__auto__)){
var tx_callbacks = temp__5735__auto__;
var tids = cljs.core.keys(cljs.core.cst$kw$txns.cljs$core$IFn$_invoke$arity$1(event_data));
var seq__116930 = cljs.core.seq(tids);
var chunk__116931 = null;
var count__116932 = (0);
var i__116933 = (0);
while(true){
if((i__116933 < count__116932)){
var tid = chunk__116931.cljs$core$IIndexed$_nth$arity$2(null,i__116933);
var temp__5735__auto___117050__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(tx_callbacks,fluree.db.util.core.keyword__GT_str(tid));
if(cljs.core.truth_(temp__5735__auto___117050__$1)){
var keyed_callbacks_117051 = temp__5735__auto___117050__$1;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$variadic(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),cljs.core.update,cljs.core.cst$kw$db_SLASH_pending_DASH_tx,cljs.core.dissoc,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([fluree.db.util.core.keyword__GT_str(tid)], 0));

var tx_response_117052 = fluree.db.session.block_response__GT_tx_response(event_data,tid);
var seq__116974_117053 = cljs.core.seq(keyed_callbacks_117051);
var chunk__116975_117054 = null;
var count__116976_117055 = (0);
var i__116977_117056 = (0);
while(true){
if((i__116977_117056 < count__116976_117055)){
var vec__116986_117057 = chunk__116975_117054.cljs$core$IIndexed$_nth$arity$2(null,i__116977_117056);
var k_117058 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116986_117057,(0),null);
var f_117059 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116986_117057,(1),null);
try{(f_117059.cljs$core$IFn$_invoke$arity$1 ? f_117059.cljs$core$IFn$_invoke$arity$1(tx_response_117052) : f_117059.call(null,tx_response_117052));
}catch (e116989){var e_117060 = e116989;
fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([e_117060,["Error processing transaction callback for tid: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tid),"."].join('')], 0));
}

var G__117061 = seq__116974_117053;
var G__117062 = chunk__116975_117054;
var G__117063 = count__116976_117055;
var G__117064 = (i__116977_117056 + (1));
seq__116974_117053 = G__117061;
chunk__116975_117054 = G__117062;
count__116976_117055 = G__117063;
i__116977_117056 = G__117064;
continue;
} else {
var temp__5735__auto___117065__$2 = cljs.core.seq(seq__116974_117053);
if(temp__5735__auto___117065__$2){
var seq__116974_117066__$1 = temp__5735__auto___117065__$2;
if(cljs.core.chunked_seq_QMARK_(seq__116974_117066__$1)){
var c__4550__auto___117067 = cljs.core.chunk_first(seq__116974_117066__$1);
var G__117068 = cljs.core.chunk_rest(seq__116974_117066__$1);
var G__117069 = c__4550__auto___117067;
var G__117070 = cljs.core.count(c__4550__auto___117067);
var G__117071 = (0);
seq__116974_117053 = G__117068;
chunk__116975_117054 = G__117069;
count__116976_117055 = G__117070;
i__116977_117056 = G__117071;
continue;
} else {
var vec__116990_117072 = cljs.core.first(seq__116974_117066__$1);
var k_117073 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116990_117072,(0),null);
var f_117074 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__116990_117072,(1),null);
try{(f_117074.cljs$core$IFn$_invoke$arity$1 ? f_117074.cljs$core$IFn$_invoke$arity$1(tx_response_117052) : f_117074.call(null,tx_response_117052));
}catch (e116993){var e_117075 = e116993;
fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([e_117075,["Error processing transaction callback for tid: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tid),"."].join('')], 0));
}

var G__117076 = cljs.core.next(seq__116974_117066__$1);
var G__117077 = null;
var G__117078 = (0);
var G__117079 = (0);
seq__116974_117053 = G__117076;
chunk__116975_117054 = G__117077;
count__116976_117055 = G__117078;
i__116977_117056 = G__117079;
continue;
}
} else {
}
}
break;
}
} else {
}


var G__117080 = seq__116930;
var G__117081 = chunk__116931;
var G__117082 = count__116932;
var G__117083 = (i__116933 + (1));
seq__116930 = G__117080;
chunk__116931 = G__117081;
count__116932 = G__117082;
i__116933 = G__117083;
continue;
} else {
var temp__5735__auto____$1 = cljs.core.seq(seq__116930);
if(temp__5735__auto____$1){
var seq__116930__$1 = temp__5735__auto____$1;
if(cljs.core.chunked_seq_QMARK_(seq__116930__$1)){
var c__4550__auto__ = cljs.core.chunk_first(seq__116930__$1);
var G__117084 = cljs.core.chunk_rest(seq__116930__$1);
var G__117085 = c__4550__auto__;
var G__117086 = cljs.core.count(c__4550__auto__);
var G__117087 = (0);
seq__116930 = G__117084;
chunk__116931 = G__117085;
count__116932 = G__117086;
i__116933 = G__117087;
continue;
} else {
var tid = cljs.core.first(seq__116930__$1);
var temp__5735__auto___117088__$2 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(tx_callbacks,fluree.db.util.core.keyword__GT_str(tid));
if(cljs.core.truth_(temp__5735__auto___117088__$2)){
var keyed_callbacks_117089 = temp__5735__auto___117088__$2;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$variadic(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),cljs.core.update,cljs.core.cst$kw$db_SLASH_pending_DASH_tx,cljs.core.dissoc,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([fluree.db.util.core.keyword__GT_str(tid)], 0));

var tx_response_117090 = fluree.db.session.block_response__GT_tx_response(event_data,tid);
var seq__116994_117091 = cljs.core.seq(keyed_callbacks_117089);
var chunk__116995_117092 = null;
var count__116996_117093 = (0);
var i__116997_117094 = (0);
while(true){
if((i__116997_117094 < count__116996_117093)){
var vec__117006_117095 = chunk__116995_117092.cljs$core$IIndexed$_nth$arity$2(null,i__116997_117094);
var k_117096 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117006_117095,(0),null);
var f_117097 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117006_117095,(1),null);
try{(f_117097.cljs$core$IFn$_invoke$arity$1 ? f_117097.cljs$core$IFn$_invoke$arity$1(tx_response_117090) : f_117097.call(null,tx_response_117090));
}catch (e117009){var e_117098 = e117009;
fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([e_117098,["Error processing transaction callback for tid: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tid),"."].join('')], 0));
}

var G__117099 = seq__116994_117091;
var G__117100 = chunk__116995_117092;
var G__117101 = count__116996_117093;
var G__117102 = (i__116997_117094 + (1));
seq__116994_117091 = G__117099;
chunk__116995_117092 = G__117100;
count__116996_117093 = G__117101;
i__116997_117094 = G__117102;
continue;
} else {
var temp__5735__auto___117103__$3 = cljs.core.seq(seq__116994_117091);
if(temp__5735__auto___117103__$3){
var seq__116994_117104__$1 = temp__5735__auto___117103__$3;
if(cljs.core.chunked_seq_QMARK_(seq__116994_117104__$1)){
var c__4550__auto___117105 = cljs.core.chunk_first(seq__116994_117104__$1);
var G__117106 = cljs.core.chunk_rest(seq__116994_117104__$1);
var G__117107 = c__4550__auto___117105;
var G__117108 = cljs.core.count(c__4550__auto___117105);
var G__117109 = (0);
seq__116994_117091 = G__117106;
chunk__116995_117092 = G__117107;
count__116996_117093 = G__117108;
i__116997_117094 = G__117109;
continue;
} else {
var vec__117010_117110 = cljs.core.first(seq__116994_117104__$1);
var k_117111 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117010_117110,(0),null);
var f_117112 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117010_117110,(1),null);
try{(f_117112.cljs$core$IFn$_invoke$arity$1 ? f_117112.cljs$core$IFn$_invoke$arity$1(tx_response_117090) : f_117112.call(null,tx_response_117090));
}catch (e117013){var e_117113 = e117013;
fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([e_117113,["Error processing transaction callback for tid: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tid),"."].join('')], 0));
}

var G__117114 = cljs.core.next(seq__116994_117104__$1);
var G__117115 = null;
var G__117116 = (0);
var G__117117 = (0);
seq__116994_117091 = G__117114;
chunk__116995_117092 = G__117115;
count__116996_117093 = G__117116;
i__116997_117094 = G__117117;
continue;
}
} else {
}
}
break;
}
} else {
}


var G__117118 = cljs.core.next(seq__116930__$1);
var G__117119 = null;
var G__117120 = (0);
var G__117121 = (0);
seq__116930 = G__117118;
chunk__116931 = G__117119;
count__116932 = G__117120;
i__116933 = G__117121;
continue;
}
} else {
return null;
}
}
break;
}
} else {
return null;
}
} else {
return null;
}
});})(G__116926_117045,G__116927_117046,G__116928_117047,session,new_QMARK_,or__4131__auto__,vec__116922,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__116920,map__116920__$1,state,connect_QMARK_,auth,jwt))
;
var fexpr__116925_117049 = cljs.core.cst$kw$add_DASH_listener.cljs$core$IFn$_invoke$arity$1(conn);
(fexpr__116925_117049.cljs$core$IFn$_invoke$arity$4 ? fexpr__116925_117049.cljs$core$IFn$_invoke$arity$4(G__116926_117045,G__116927_117046,G__116928_117047,G__116929_117048) : fexpr__116925_117049.call(null,G__116926_117045,G__116927_117046,G__116928_117047,G__116929_117048));

fluree.db.session.process_ledger_updates(conn,network,ledger_id,cljs.core.cst$kw$update_DASH_chan.cljs$core$IFn$_invoke$arity$1(session));
} else {
}

if(cljs.core.truth_(transactor_QMARK_)){
var transact_handler_117122 = cljs.core.cst$kw$transact_DASH_handler.cljs$core$IFn$_invoke$arity$1(conn);
var c__99809__auto___117123 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___117123,transact_handler_117122,session,new_QMARK_,or__4131__auto__,vec__116922,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__116920,map__116920__$1,state,connect_QMARK_,auth,jwt){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___117123,transact_handler_117122,session,new_QMARK_,or__4131__auto__,vec__116922,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__116920,map__116920__$1,state,connect_QMARK_,auth,jwt){
return (function (state_117030){
var state_val_117031 = (state_117030[(1)]);
if((state_val_117031 === (1))){
var state_117030__$1 = state_117030;
var statearr_117032_117124 = state_117030__$1;
(statearr_117032_117124[(2)] = null);

(statearr_117032_117124[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117031 === (2))){
var inst_117015 = cljs.core.cst$kw$transact_DASH_chan.cljs$core$IFn$_invoke$arity$1(session);
var state_117030__$1 = state_117030;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_117030__$1,(4),inst_117015);
} else {
if((state_val_117031 === (3))){
var inst_117028 = (state_117030[(2)]);
var state_117030__$1 = state_117030;
return cljs.core.async.impl.ioc_helpers.return_chan(state_117030__$1,inst_117028);
} else {
if((state_val_117031 === (4))){
var inst_117017 = (state_117030[(7)]);
var inst_117017__$1 = (state_117030[(2)]);
var inst_117018 = (inst_117017__$1 == null);
var state_117030__$1 = (function (){var statearr_117033 = state_117030;
(statearr_117033[(7)] = inst_117017__$1);

return statearr_117033;
})();
if(cljs.core.truth_(inst_117018)){
var statearr_117034_117125 = state_117030__$1;
(statearr_117034_117125[(1)] = (5));

} else {
var statearr_117035_117126 = state_117030__$1;
(statearr_117035_117126[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117031 === (5))){
var inst_117020 = ["Transactor session closing for db: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"[",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_alias),"]"].join('');
var inst_117021 = fluree.db.util.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_117020], 0));
var state_117030__$1 = state_117030;
var statearr_117036_117127 = state_117030__$1;
(statearr_117036_117127[(2)] = inst_117021);

(statearr_117036_117127[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117031 === (6))){
var inst_117017 = (state_117030[(7)]);
var inst_117023 = (transact_handler_117122.cljs$core$IFn$_invoke$arity$2 ? transact_handler_117122.cljs$core$IFn$_invoke$arity$2(conn,inst_117017) : transact_handler_117122.call(null,conn,inst_117017));
var state_117030__$1 = (function (){var statearr_117037 = state_117030;
(statearr_117037[(8)] = inst_117023);

return statearr_117037;
})();
var statearr_117038_117128 = state_117030__$1;
(statearr_117038_117128[(2)] = null);

(statearr_117038_117128[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117031 === (7))){
var inst_117026 = (state_117030[(2)]);
var state_117030__$1 = state_117030;
var statearr_117039_117129 = state_117030__$1;
(statearr_117039_117129[(2)] = inst_117026);

(statearr_117039_117129[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(c__99809__auto___117123,transact_handler_117122,session,new_QMARK_,or__4131__auto__,vec__116922,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__116920,map__116920__$1,state,connect_QMARK_,auth,jwt))
;
return ((function (switch__99702__auto__,c__99809__auto___117123,transact_handler_117122,session,new_QMARK_,or__4131__auto__,vec__116922,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__116920,map__116920__$1,state,connect_QMARK_,auth,jwt){
return (function() {
var fluree$db$session$state_machine__99703__auto__ = null;
var fluree$db$session$state_machine__99703__auto____0 = (function (){
var statearr_117040 = [null,null,null,null,null,null,null,null,null];
(statearr_117040[(0)] = fluree$db$session$state_machine__99703__auto__);

(statearr_117040[(1)] = (1));

return statearr_117040;
});
var fluree$db$session$state_machine__99703__auto____1 = (function (state_117030){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_117030);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e117041){if((e117041 instanceof Object)){
var ex__99706__auto__ = e117041;
var statearr_117042_117130 = state_117030;
(statearr_117042_117130[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_117030);

return cljs.core.cst$kw$recur;
} else {
throw e117041;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__117131 = state_117030;
state_117030 = G__117131;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$session$state_machine__99703__auto__ = function(state_117030){
switch(arguments.length){
case 0:
return fluree$db$session$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$session$state_machine__99703__auto____1.call(this,state_117030);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$session$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$session$state_machine__99703__auto____0;
fluree$db$session$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$session$state_machine__99703__auto____1;
return fluree$db$session$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___117123,transact_handler_117122,session,new_QMARK_,or__4131__auto__,vec__116922,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__116920,map__116920__$1,state,connect_QMARK_,auth,jwt))
})();
var state__99811__auto__ = (function (){var statearr_117043 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_117043[(6)] = c__99809__auto___117123);

return statearr_117043;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___117123,transact_handler_117122,session,new_QMARK_,or__4131__auto__,vec__116922,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__116920,map__116920__$1,state,connect_QMARK_,auth,jwt))
);

} else {
}
} else {
}

return session;
}
});

fluree.db.session.session.cljs$lang$maxFixedArity = 3;

/**
 * Gets the latest db from the central DB atom if available, or loads it from scratch.
 *   DB is returned as a core async promise channel.
 */
fluree.db.session.current_db = (function fluree$db$session$current_db(session){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),(function (p1__117132_SHARP_){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(p1__117132_SHARP_,cljs.core.cst$kw$req_SLASH_last,fluree.db.util.core.current_time_millis(),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$req_SLASH_count,(cljs.core.cst$kw$req_SLASH_count.cljs$core$IFn$_invoke$arity$1(p1__117132_SHARP_) + (1))], 0));
}));

var db = cljs.core.cst$kw$db_SLASH_db.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session)));
if((db == null)){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$schema_DASH_cache.cljs$core$IFn$_invoke$arity$1(session),cljs.core.empty);

cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),((function (db){
return (function (p1__117133_SHARP_){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__117133_SHARP_,cljs.core.cst$kw$db_SLASH_db,fluree.db.session.full_load_existing_db(session));
});})(db))
);

return cljs.core.cst$kw$db_SLASH_db.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session)));
} else {
return db;
}
});
/**
 * Creates a session and returns a blank db.
 */
fluree.db.session.blank_db = (function fluree$db$session$blank_db(conn,ledger){
var session = fluree.db.session.session.cljs$core$IFn$_invoke$arity$3(conn,ledger,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$connect_QMARK_,false], null));
return cljs.core.cst$kw$blank_DASH_db.cljs$core$IFn$_invoke$arity$1(session);
});
/**
 * Returns core async channel containing current db
 */
fluree.db.session.db = (function fluree$db$session$db(conn,ledger,opts){
var session = fluree.db.session.session.cljs$core$IFn$_invoke$arity$3(conn,ledger,opts);
return fluree.db.session.current_db(session);
});
/**
 * Useful for a shutdown process. Closes all sessions for a given connection-id.
 *   If no connection given, closes all sessions.
 */
fluree.db.session.close_all_sessions = (function fluree$db$session$close_all_sessions(var_args){
var G__117136 = arguments.length;
switch (G__117136) {
case 0:
return fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$0 = (function (){
return fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$1(null);
});

fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$1 = (function (conn_id){
var sessions = (function (){var G__117137 = cljs.core.vals(cljs.core.deref(fluree.db.session.session_cache));
if(cljs.core.truth_(conn_id)){
return cljs.core.filter.cljs$core$IFn$_invoke$arity$2(((function (G__117137){
return (function (p1__117134_SHARP_){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(conn_id,cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(p1__117134_SHARP_,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$conn,cljs.core.cst$kw$id], null)));
});})(G__117137))
,G__117137);
} else {
return G__117137;
}
})();
var seq__117138 = cljs.core.seq(sessions);
var chunk__117139 = null;
var count__117140 = (0);
var i__117141 = (0);
while(true){
if((i__117141 < count__117140)){
var session = chunk__117139.cljs$core$IIndexed$_nth$arity$2(null,i__117141);
fluree.db.session.close.cljs$core$IFn$_invoke$arity$1(session);


var G__117143 = seq__117138;
var G__117144 = chunk__117139;
var G__117145 = count__117140;
var G__117146 = (i__117141 + (1));
seq__117138 = G__117143;
chunk__117139 = G__117144;
count__117140 = G__117145;
i__117141 = G__117146;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq(seq__117138);
if(temp__5735__auto__){
var seq__117138__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__117138__$1)){
var c__4550__auto__ = cljs.core.chunk_first(seq__117138__$1);
var G__117147 = cljs.core.chunk_rest(seq__117138__$1);
var G__117148 = c__4550__auto__;
var G__117149 = cljs.core.count(c__4550__auto__);
var G__117150 = (0);
seq__117138 = G__117147;
chunk__117139 = G__117148;
count__117140 = G__117149;
i__117141 = G__117150;
continue;
} else {
var session = cljs.core.first(seq__117138__$1);
fluree.db.session.close.cljs$core$IFn$_invoke$arity$1(session);


var G__117151 = cljs.core.next(seq__117138__$1);
var G__117152 = null;
var G__117153 = (0);
var G__117154 = (0);
seq__117138 = G__117151;
chunk__117139 = G__117152;
count__117140 = G__117153;
i__117141 = G__117154;
continue;
}
} else {
return null;
}
}
break;
}
});

fluree.db.session.close_all_sessions.cljs$lang$maxFixedArity = 1;

/**
 * Adds a callback function to call when we see a completed transaction in a block
 *   for the given tid.
 * 
 *   Key is any arbitrary key provided that allows the callback to be unregistered later
 *   with monitor-tx-remove. It must be unique.
 */
fluree.db.session.monitor_tx = (function fluree$db$session$monitor_tx(session,tid,key,f){
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),cljs.core.update_in,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$db_SLASH_pending_DASH_tx,tid,key], null),(function (x){
if(cljs.core.truth_(x)){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Key provided to monitor-tx must be unique.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_request], null));
} else {
}

return f;
}));
});
/**
 * Removes callback from supplied transaction id and key.
 * 
 *   Will return true if callback successfully removed, else false if
 *   callback didn't exist.
 */
fluree.db.session.monitor_tx_remove = (function fluree$db$session$monitor_tx_remove(session,tid,key){
if(cljs.core.truth_(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session)),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$db_SLASH_pending_DASH_tx,tid,key], null)))){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(session),cljs.core.update,cljs.core.cst$kw$db_SLASH_pending_DASH_tx,(function (pending_txs){
var updated = cljs.core.update.cljs$core$IFn$_invoke$arity$4(pending_txs,tid,cljs.core.dissoc,key);
if(cljs.core.empty_QMARK_(cljs.core.get.cljs$core$IFn$_invoke$arity$2(updated,tid))){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(updated,tid);
} else {
return updated;
}
}));

return true;
} else {
return false;
}
});
