// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.util.async');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('cljs.core.async');
fluree.db.util.async.throw_err = (function fluree$db$util$async$throw_err(e){
if((e instanceof Error)){
throw e;
} else {
}

return e;
});
/**
 * Helper method that checks if x is Exception and if yes, wraps it in a new
 *   exception, passing though ex-data if any, and throws it. The wrapping is done
 *   to maintain a full stack trace when jumping between multiple contexts.
 */
fluree.db.util.async.throw_if_exception = (function fluree$db$util$async$throw_if_exception(x){
if((x instanceof Error)){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$3(cljs.core.str.cljs$core$IFn$_invoke$arity$1(x),(function (){var or__4131__auto__ = cljs.core.ex_data(x);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.PersistentArrayMap.EMPTY;
}
})(),x);
} else {
return x;
}
});
/**
 * Takes a sequence of single-value chans and returns the conjoined into collection.
 *   Realizes entire channel sequence first, and if an error value exists returns just the exception.
 */
fluree.db.util.async.merge_into_QMARK_ = (function fluree$db$util$async$merge_into_QMARK_(coll,chs){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_101860){
var state_val_101861 = (state_101860[(1)]);
if((state_val_101861 === (7))){
var inst_101837 = (state_101860[(7)]);
var state_101860__$1 = state_101860;
var statearr_101862_101878 = state_101860__$1;
(statearr_101862_101878[(2)] = inst_101837);

(statearr_101862_101878[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101861 === (1))){
var state_101860__$1 = state_101860;
var statearr_101863_101879 = state_101860__$1;
(statearr_101863_101879[(2)] = null);

(statearr_101863_101879[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101861 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_101860,(3),cljs.core.cst$kw$default,null,(2));
var inst_101833 = cljs.core.seq(chs);
var inst_101834 = cljs.core.first(inst_101833);
var inst_101835 = cljs.core.next(inst_101833);
var inst_101836 = chs;
var inst_101837 = coll;
var state_101860__$1 = (function (){var statearr_101864 = state_101860;
(statearr_101864[(8)] = inst_101836);

(statearr_101864[(9)] = inst_101834);

(statearr_101864[(7)] = inst_101837);

(statearr_101864[(10)] = inst_101835);

return statearr_101864;
})();
var statearr_101865_101880 = state_101860__$1;
(statearr_101865_101880[(2)] = null);

(statearr_101865_101880[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101861 === (6))){
var inst_101856 = (state_101860[(2)]);
var state_101860__$1 = state_101860;
var statearr_101866_101881 = state_101860__$1;
(statearr_101866_101881[(2)] = inst_101856);


cljs.core.async.impl.ioc_helpers.process_exception(state_101860__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_101861 === (3))){
var inst_101822 = (state_101860[(2)]);
var state_101860__$1 = state_101860;
var statearr_101867_101882 = state_101860__$1;
(statearr_101867_101882[(2)] = inst_101822);


cljs.core.async.impl.ioc_helpers.process_exception(state_101860__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_101861 === (2))){
var inst_101858 = (state_101860[(2)]);
var state_101860__$1 = state_101860;
return cljs.core.async.impl.ioc_helpers.return_chan(state_101860__$1,inst_101858);
} else {
if((state_val_101861 === (9))){
var inst_101854 = (state_101860[(2)]);
var state_101860__$1 = state_101860;
var statearr_101868_101883 = state_101860__$1;
(statearr_101868_101883[(2)] = inst_101854);

(statearr_101868_101883[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101861 === (5))){
var inst_101836 = (state_101860[(8)]);
var inst_101843 = (state_101860[(11)]);
var inst_101842 = cljs.core.seq(inst_101836);
var inst_101843__$1 = cljs.core.first(inst_101842);
var inst_101844 = cljs.core.next(inst_101842);
var inst_101845 = cljs.core.not(inst_101843__$1);
var state_101860__$1 = (function (){var statearr_101869 = state_101860;
(statearr_101869[(11)] = inst_101843__$1);

(statearr_101869[(12)] = inst_101844);

return statearr_101869;
})();
if(inst_101845){
var statearr_101870_101884 = state_101860__$1;
(statearr_101870_101884[(1)] = (7));

} else {
var statearr_101871_101885 = state_101860__$1;
(statearr_101871_101885[(1)] = (8));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101861 === (10))){
var inst_101837 = (state_101860[(7)]);
var inst_101844 = (state_101860[(12)]);
var inst_101849 = (state_101860[(2)]);
var inst_101850 = fluree.db.util.async.throw_err(inst_101849);
var inst_101851 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(inst_101837,inst_101850);
var inst_101836 = inst_101844;
var inst_101837__$1 = inst_101851;
var state_101860__$1 = (function (){var statearr_101872 = state_101860;
(statearr_101872[(8)] = inst_101836);

(statearr_101872[(7)] = inst_101837__$1);

return statearr_101872;
})();
var statearr_101873_101886 = state_101860__$1;
(statearr_101873_101886[(2)] = null);

(statearr_101873_101886[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101861 === (8))){
var inst_101843 = (state_101860[(11)]);
var state_101860__$1 = state_101860;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_101860__$1,(10),inst_101843);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto__ = null;
var fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto____0 = (function (){
var statearr_101874 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_101874[(0)] = fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto__);

(statearr_101874[(1)] = (1));

return statearr_101874;
});
var fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto____1 = (function (state_101860){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_101860);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101875){if((e101875 instanceof Object)){
var ex__99706__auto__ = e101875;
var statearr_101876_101887 = state_101860;
(statearr_101876_101887[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_101860);

return cljs.core.cst$kw$recur;
} else {
throw e101875;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101888 = state_101860;
state_101860 = G__101888;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto__ = function(state_101860){
switch(arguments.length){
case 0:
return fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto____1.call(this,state_101860);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto____0;
fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto____1;
return fluree$db$util$async$merge_into_QMARK__$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_101877 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101877[(6)] = c__99809__auto__);

return statearr_101877;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Like async/into, but checks each item for an error response and returns exception
 *   onto the response channel insted of results if thee is one.
 */
fluree.db.util.async.into_QMARK_ = (function fluree$db$util$async$into_QMARK_(coll,chan){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_101910){
var state_val_101911 = (state_101910[(1)]);
if((state_val_101911 === (7))){
var inst_101897 = (state_101910[(7)]);
var inst_101896 = (state_101910[(2)]);
var inst_101897__$1 = fluree.db.util.async.throw_err(inst_101896);
var inst_101898 = (inst_101897__$1 == null);
var state_101910__$1 = (function (){var statearr_101912 = state_101910;
(statearr_101912[(7)] = inst_101897__$1);

return statearr_101912;
})();
if(cljs.core.truth_(inst_101898)){
var statearr_101913_101928 = state_101910__$1;
(statearr_101913_101928[(1)] = (8));

} else {
var statearr_101914_101929 = state_101910__$1;
(statearr_101914_101929[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101911 === (1))){
var state_101910__$1 = state_101910;
var statearr_101915_101930 = state_101910__$1;
(statearr_101915_101930[(2)] = null);

(statearr_101915_101930[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101911 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_101910,(3),cljs.core.cst$kw$default,null,(2));
var inst_101893 = coll;
var state_101910__$1 = (function (){var statearr_101916 = state_101910;
(statearr_101916[(8)] = inst_101893);

return statearr_101916;
})();
var statearr_101917_101931 = state_101910__$1;
(statearr_101917_101931[(2)] = null);

(statearr_101917_101931[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101911 === (6))){
var inst_101906 = (state_101910[(2)]);
var state_101910__$1 = state_101910;
var statearr_101918_101932 = state_101910__$1;
(statearr_101918_101932[(2)] = inst_101906);


cljs.core.async.impl.ioc_helpers.process_exception(state_101910__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_101911 === (3))){
var inst_101889 = (state_101910[(2)]);
var state_101910__$1 = state_101910;
var statearr_101919_101933 = state_101910__$1;
(statearr_101919_101933[(2)] = inst_101889);


cljs.core.async.impl.ioc_helpers.process_exception(state_101910__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_101911 === (2))){
var inst_101908 = (state_101910[(2)]);
var state_101910__$1 = state_101910;
return cljs.core.async.impl.ioc_helpers.return_chan(state_101910__$1,inst_101908);
} else {
if((state_val_101911 === (9))){
var inst_101897 = (state_101910[(7)]);
var inst_101893 = (state_101910[(8)]);
var inst_101901 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(inst_101893,inst_101897);
var inst_101893__$1 = inst_101901;
var state_101910__$1 = (function (){var statearr_101920 = state_101910;
(statearr_101920[(8)] = inst_101893__$1);

return statearr_101920;
})();
var statearr_101921_101934 = state_101910__$1;
(statearr_101921_101934[(2)] = null);

(statearr_101921_101934[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101911 === (5))){
var state_101910__$1 = state_101910;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_101910__$1,(7),chan);
} else {
if((state_val_101911 === (10))){
var inst_101904 = (state_101910[(2)]);
var state_101910__$1 = state_101910;
var statearr_101922_101935 = state_101910__$1;
(statearr_101922_101935[(2)] = inst_101904);

(statearr_101922_101935[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101911 === (8))){
var inst_101893 = (state_101910[(8)]);
var state_101910__$1 = state_101910;
var statearr_101923_101936 = state_101910__$1;
(statearr_101923_101936[(2)] = inst_101893);

(statearr_101923_101936[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$util$async$into_QMARK__$_state_machine__99703__auto__ = null;
var fluree$db$util$async$into_QMARK__$_state_machine__99703__auto____0 = (function (){
var statearr_101924 = [null,null,null,null,null,null,null,null,null];
(statearr_101924[(0)] = fluree$db$util$async$into_QMARK__$_state_machine__99703__auto__);

(statearr_101924[(1)] = (1));

return statearr_101924;
});
var fluree$db$util$async$into_QMARK__$_state_machine__99703__auto____1 = (function (state_101910){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_101910);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101925){if((e101925 instanceof Object)){
var ex__99706__auto__ = e101925;
var statearr_101926_101937 = state_101910;
(statearr_101926_101937[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_101910);

return cljs.core.cst$kw$recur;
} else {
throw e101925;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101938 = state_101910;
state_101910 = G__101938;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$util$async$into_QMARK__$_state_machine__99703__auto__ = function(state_101910){
switch(arguments.length){
case 0:
return fluree$db$util$async$into_QMARK__$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$util$async$into_QMARK__$_state_machine__99703__auto____1.call(this,state_101910);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$util$async$into_QMARK__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$util$async$into_QMARK__$_state_machine__99703__auto____0;
fluree$db$util$async$into_QMARK__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$util$async$into_QMARK__$_state_machine__99703__auto____1;
return fluree$db$util$async$into_QMARK__$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_101927 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101927[(6)] = c__99809__auto__);

return statearr_101927;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns true if core async channel.
 */
fluree.db.util.async.channel_QMARK_ = (function fluree$db$util$async$channel_QMARK_(x){
if((!((x == null)))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === x.cljs$core$async$impl$protocols$Channel$)))){
return true;
} else {
if((!x.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.Channel,x);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.Channel,x);
}
});
