// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('shared.connection_handler');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('cljs.core.async');
goog.require('alphabase.core');
goog.require('fluree.db.connection');
goog.require('fluree.db.session');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.log');
goog.require('fluree.db.token_auth');
/**
 * Verifies that the jwt token has not expired.
 * 
 *   Only returns when token is valid.  Otherwise, an exception is thrown.
 */
shared.connection_handler.validate_token = (function shared$connection_handler$validate_token(conn,jwt){
var secret = alphabase.core.base_to_byte_array.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$jwt_DASH_secret.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$flureedb_DASH_settings.cljs$core$IFn$_invoke$arity$1(conn))),cljs.core.cst$kw$hex);
return fluree.db.token_auth.verify_jwt(secret,jwt);
});
/**
 * Connect to a ledger server using URL address. If using a ledger group, multiple addresses can be
 * supplied, separated by commas.
 */
shared.connection_handler.connect = (function shared$connection_handler$connect(var_args){
var G__118439 = arguments.length;
switch (G__118439) {
case 1:
return shared.connection_handler.connect.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shared.connection_handler.connect.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.connection_handler.connect.cljs$core$IFn$_invoke$arity$1 = (function (servers_string){
return shared.connection_handler.connect.cljs$core$IFn$_invoke$arity$2(servers_string,null);
});

shared.connection_handler.connect.cljs$core$IFn$_invoke$arity$2 = (function (servers_string,opts){
var conn = cljs.core.assoc_in(fluree.db.connection.connect.cljs$core$IFn$_invoke$arity$variadic(servers_string,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([opts], 0)),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$flureedb_DASH_settings], null),cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY));
var pc = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var _ = (function (){var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,conn,pc){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,conn,pc){
return (function (state_118448){
var state_val_118449 = (state_118448[(1)]);
if((state_val_118449 === (1))){
var inst_118440 = cljs.core.cst$kw$req_DASH_chan.cljs$core$IFn$_invoke$arity$1(conn);
var inst_118441 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_118442 = [cljs.core.cst$kw$settings,null,pc,null];
var inst_118443 = (new cljs.core.PersistentVector(null,4,(5),inst_118441,inst_118442,null));
var inst_118444 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(inst_118440,inst_118443);
var inst_118445 = (function (){return ((function (inst_118440,inst_118441,inst_118442,inst_118443,inst_118444,state_val_118449,c__99809__auto__,conn,pc){
return (function (x){
if((x == null)){
return null;
} else {
var seq__118450 = cljs.core.seq(cljs.core.keys(x));
var chunk__118451 = null;
var count__118452 = (0);
var i__118453 = (0);
while(true){
if((i__118453 < count__118452)){
var k = chunk__118451.cljs$core$IIndexed$_nth$arity$2(null,i__118453);
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(cljs.core.cst$kw$flureedb_DASH_settings.cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [k], null),cljs.core.get.cljs$core$IFn$_invoke$arity$3(x,k,null));


var G__118460 = seq__118450;
var G__118461 = chunk__118451;
var G__118462 = count__118452;
var G__118463 = (i__118453 + (1));
seq__118450 = G__118460;
chunk__118451 = G__118461;
count__118452 = G__118462;
i__118453 = G__118463;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq(seq__118450);
if(temp__5735__auto__){
var seq__118450__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__118450__$1)){
var c__4550__auto__ = cljs.core.chunk_first(seq__118450__$1);
var G__118464 = cljs.core.chunk_rest(seq__118450__$1);
var G__118465 = c__4550__auto__;
var G__118466 = cljs.core.count(c__4550__auto__);
var G__118467 = (0);
seq__118450 = G__118464;
chunk__118451 = G__118465;
count__118452 = G__118466;
i__118453 = G__118467;
continue;
} else {
var k = cljs.core.first(seq__118450__$1);
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(cljs.core.cst$kw$flureedb_DASH_settings.cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [k], null),cljs.core.get.cljs$core$IFn$_invoke$arity$3(x,k,null));


var G__118468 = cljs.core.next(seq__118450__$1);
var G__118469 = null;
var G__118470 = (0);
var G__118471 = (0);
seq__118450 = G__118468;
chunk__118451 = G__118469;
count__118452 = G__118470;
i__118453 = G__118471;
continue;
}
} else {
return null;
}
}
break;
}
}
});
;})(inst_118440,inst_118441,inst_118442,inst_118443,inst_118444,state_val_118449,c__99809__auto__,conn,pc))
})();
var inst_118446 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(pc,inst_118445);
var state_118448__$1 = (function (){var statearr_118454 = state_118448;
(statearr_118454[(7)] = inst_118444);

return statearr_118454;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_118448__$1,inst_118446);
} else {
return null;
}
});})(c__99809__auto__,conn,pc))
;
return ((function (switch__99702__auto__,c__99809__auto__,conn,pc){
return (function() {
var shared$connection_handler$state_machine__99703__auto__ = null;
var shared$connection_handler$state_machine__99703__auto____0 = (function (){
var statearr_118455 = [null,null,null,null,null,null,null,null];
(statearr_118455[(0)] = shared$connection_handler$state_machine__99703__auto__);

(statearr_118455[(1)] = (1));

return statearr_118455;
});
var shared$connection_handler$state_machine__99703__auto____1 = (function (state_118448){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_118448);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e118456){if((e118456 instanceof Object)){
var ex__99706__auto__ = e118456;
var statearr_118457_118472 = state_118448;
(statearr_118457_118472[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_118448);

return cljs.core.cst$kw$recur;
} else {
throw e118456;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__118473 = state_118448;
state_118448 = G__118473;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$connection_handler$state_machine__99703__auto__ = function(state_118448){
switch(arguments.length){
case 0:
return shared$connection_handler$state_machine__99703__auto____0.call(this);
case 1:
return shared$connection_handler$state_machine__99703__auto____1.call(this,state_118448);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$connection_handler$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$connection_handler$state_machine__99703__auto____0;
shared$connection_handler$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$connection_handler$state_machine__99703__auto____1;
return shared$connection_handler$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,conn,pc))
})();
var state__99811__auto__ = (function (){var statearr_118458 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_118458[(6)] = c__99809__auto__);

return statearr_118458;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,conn,pc))
);

return c__99809__auto__;
})();
return conn;
});

shared.connection_handler.connect.cljs$lang$maxFixedArity = 2;

/**
 * Connect to a ledger server using URL address. If using a ledger group, multiple addresses can be
 * supplied, separated by commas.
 * 
 * Returns a promise that eventually contains the connection object.
 */
shared.connection_handler.connect_p = (function shared$connection_handler$connect_p(var_args){
var G__118475 = arguments.length;
switch (G__118475) {
case 1:
return shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$1 = (function (servers_string){
return shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$2(servers_string,null);
});

shared.connection_handler.connect_p.cljs$core$IFn$_invoke$arity$2 = (function (servers_string,opts){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_118500){
var state_val_118501 = (state_118500[(1)]);
if((state_val_118501 === (1))){
var state_118500__$1 = state_118500;
var statearr_118502_118516 = state_118500__$1;
(statearr_118502_118516[(2)] = null);

(statearr_118502_118516[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118501 === (2))){
var inst_118498 = (state_118500[(2)]);
var state_118500__$1 = state_118500;
return cljs.core.async.impl.ioc_helpers.return_chan(state_118500__$1,inst_118498);
} else {
if((state_val_118501 === (3))){
var inst_118476 = (state_118500[(2)]);
var inst_118477 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_118476], 0));
var inst_118478 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_118476) : reject.call(null,inst_118476));
var state_118500__$1 = (function (){var statearr_118503 = state_118500;
(statearr_118503[(7)] = inst_118477);

return statearr_118503;
})();
var statearr_118504_118517 = state_118500__$1;
(statearr_118504_118517[(2)] = inst_118478);


cljs.core.async.impl.ioc_helpers.process_exception(state_118500__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_118501 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_118500,(3),cljs.core.cst$kw$default,null,(2));
var inst_118482 = fluree.db.connection.connect.cljs$core$IFn$_invoke$arity$variadic(servers_string,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([opts], 0));
var inst_118483 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_118484 = [cljs.core.cst$kw$flureedb_DASH_settings];
var inst_118485 = (new cljs.core.PersistentVector(null,1,(5),inst_118483,inst_118484,null));
var inst_118486 = cljs.core.PersistentHashMap.EMPTY;
var inst_118487 = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(inst_118486);
var inst_118488 = cljs.core.assoc_in(inst_118482,inst_118485,inst_118487);
var inst_118489 = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var inst_118490 = cljs.core.cst$kw$req_DASH_chan.cljs$core$IFn$_invoke$arity$1(inst_118488);
var inst_118491 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_118492 = [cljs.core.cst$kw$settings,null,inst_118489,null];
var inst_118493 = (new cljs.core.PersistentVector(null,4,(5),inst_118491,inst_118492,null));
var inst_118494 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(inst_118490,inst_118493);
var inst_118495 = (function (){var conn = inst_118488;
var pc = inst_118489;
return ((function (conn,pc,_,inst_118482,inst_118483,inst_118484,inst_118485,inst_118486,inst_118487,inst_118488,inst_118489,inst_118490,inst_118491,inst_118492,inst_118493,inst_118494,state_val_118501,c__99809__auto__){
return (function (x){
if((x == null)){
} else {
var seq__118505_118518 = cljs.core.seq(cljs.core.keys(x));
var chunk__118506_118519 = null;
var count__118507_118520 = (0);
var i__118508_118521 = (0);
while(true){
if((i__118508_118521 < count__118507_118520)){
var k_118522 = chunk__118506_118519.cljs$core$IIndexed$_nth$arity$2(null,i__118508_118521);
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(cljs.core.cst$kw$flureedb_DASH_settings.cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [k_118522], null),cljs.core.get.cljs$core$IFn$_invoke$arity$3(x,k_118522,null));


var G__118523 = seq__118505_118518;
var G__118524 = chunk__118506_118519;
var G__118525 = count__118507_118520;
var G__118526 = (i__118508_118521 + (1));
seq__118505_118518 = G__118523;
chunk__118506_118519 = G__118524;
count__118507_118520 = G__118525;
i__118508_118521 = G__118526;
continue;
} else {
var temp__5735__auto___118527 = cljs.core.seq(seq__118505_118518);
if(temp__5735__auto___118527){
var seq__118505_118528__$1 = temp__5735__auto___118527;
if(cljs.core.chunked_seq_QMARK_(seq__118505_118528__$1)){
var c__4550__auto___118529 = cljs.core.chunk_first(seq__118505_118528__$1);
var G__118530 = cljs.core.chunk_rest(seq__118505_118528__$1);
var G__118531 = c__4550__auto___118529;
var G__118532 = cljs.core.count(c__4550__auto___118529);
var G__118533 = (0);
seq__118505_118518 = G__118530;
chunk__118506_118519 = G__118531;
count__118507_118520 = G__118532;
i__118508_118521 = G__118533;
continue;
} else {
var k_118534 = cljs.core.first(seq__118505_118528__$1);
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(cljs.core.cst$kw$flureedb_DASH_settings.cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [k_118534], null),cljs.core.get.cljs$core$IFn$_invoke$arity$3(x,k_118534,null));


var G__118535 = cljs.core.next(seq__118505_118528__$1);
var G__118536 = null;
var G__118537 = (0);
var G__118538 = (0);
seq__118505_118518 = G__118535;
chunk__118506_118519 = G__118536;
count__118507_118520 = G__118537;
i__118508_118521 = G__118538;
continue;
}
} else {
}
}
break;
}
}

return (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(conn) : resolve.call(null,conn));
});
;})(conn,pc,_,inst_118482,inst_118483,inst_118484,inst_118485,inst_118486,inst_118487,inst_118488,inst_118489,inst_118490,inst_118491,inst_118492,inst_118493,inst_118494,state_val_118501,c__99809__auto__))
})();
var inst_118496 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_118489,inst_118495);
var state_118500__$1 = (function (){var statearr_118509 = state_118500;
(statearr_118509[(8)] = inst_118494);

return statearr_118509;
})();
var statearr_118510_118539 = state_118500__$1;
(statearr_118510_118539[(2)] = inst_118496);


cljs.core.async.impl.ioc_helpers.process_exception(state_118500__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$connection_handler$state_machine__99703__auto__ = null;
var shared$connection_handler$state_machine__99703__auto____0 = (function (){
var statearr_118511 = [null,null,null,null,null,null,null,null,null];
(statearr_118511[(0)] = shared$connection_handler$state_machine__99703__auto__);

(statearr_118511[(1)] = (1));

return statearr_118511;
});
var shared$connection_handler$state_machine__99703__auto____1 = (function (state_118500){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_118500);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e118512){if((e118512 instanceof Object)){
var ex__99706__auto__ = e118512;
var statearr_118513_118540 = state_118500;
(statearr_118513_118540[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_118500);

return cljs.core.cst$kw$recur;
} else {
throw e118512;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__118541 = state_118500;
state_118500 = G__118541;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$connection_handler$state_machine__99703__auto__ = function(state_118500){
switch(arguments.length){
case 0:
return shared$connection_handler$state_machine__99703__auto____0.call(this);
case 1:
return shared$connection_handler$state_machine__99703__auto____1.call(this,state_118500);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$connection_handler$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$connection_handler$state_machine__99703__auto____0;
shared$connection_handler$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$connection_handler$state_machine__99703__auto____1;
return shared$connection_handler$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_118514 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_118514[(6)] = c__99809__auto__);

return statearr_118514;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

shared.connection_handler.connect_p.cljs$lang$maxFixedArity = 2;

/**
 * Closes a connection
 */
shared.connection_handler.close = (function shared$connection_handler$close(conn){
return fluree.db.connection.close_BANG_(conn);
});
/**
 * Returns open-api? setting from connection object
 */
shared.connection_handler.open_api_QMARK_ = (function shared$connection_handler$open_api_QMARK_(conn){
return cljs.core.cst$kw$open_DASH_api_QMARK_.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$flureedb_DASH_settings.cljs$core$IFn$_invoke$arity$1(conn)));
});
/**
 * Returns true when the connection is properly configured to access the server.
 *   If jwt tokens are used; will also verify that the token has not expired.
 *   Otherwise, throws an error.
 */
shared.connection_handler.check_connection = (function shared$connection_handler$check_connection(var_args){
var G__118543 = arguments.length;
switch (G__118543) {
case 1:
return shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$1 = (function (conn){
return shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2(conn,null);
});

shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2 = (function (conn,opts){
var open_api_QMARK_ = cljs.core.cst$kw$open_DASH_api_QMARK_.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$flureedb_DASH_settings.cljs$core$IFn$_invoke$arity$1(conn)));
var token = cljs.core.cst$kw$jwt.cljs$core$IFn$_invoke$arity$1(opts);
var has_auth_QMARK_ = (function (){var or__4131__auto__ = cljs.core.cst$kw$auth.cljs$core$IFn$_invoke$arity$1(opts);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var or__4131__auto____$1 = cljs.core.cst$kw$auth_DASH_id.cljs$core$IFn$_invoke$arity$1(opts);
if(cljs.core.truth_(or__4131__auto____$1)){
return or__4131__auto____$1;
} else {
return token;
}
}
})();
var _ = ((((cljs.core.not(open_api_QMARK_)) && (cljs.core.not(has_auth_QMARK_))))?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("To access the server, either open-api must be true or a valid auth must be available.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(401),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_request], null))})():null);
var ___$1 = (cljs.core.truth_(token)?shared.connection_handler.validate_token(conn,token):null);
return true;
});

shared.connection_handler.check_connection.cljs$lang$maxFixedArity = 2;

/**
 * Listens to all events of a given ledger. Supply a ledger identity,
 *   any key, and a two-argument function that will be called with each event.
 * 
 *   The key is any arbitrary key, and is only used to close the listener via close-listener,
 *   otherwise it is opaque to the listener.
 * 
 *   The callback function's first argument is the event header/metadata and the second argument
 *   is the event data itself.
 */
shared.connection_handler.listen = (function shared$connection_handler$listen(conn,ledger,key,callback){
var vec__118545 = fluree.db.session.resolve_ledger(conn,ledger);
var network = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__118545,(0),null);
var ledger_id = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__118545,(1),null);
var cb_STAR_ = ((function (vec__118545,network,ledger_id){
return (function (header,data){
var G__118548 = cljs.core.clj__GT_js(header);
var G__118549 = cljs.core.clj__GT_js(data);
return (callback.cljs$core$IFn$_invoke$arity$2 ? callback.cljs$core$IFn$_invoke$arity$2(G__118548,G__118549) : callback.call(null,G__118548,G__118549));
});})(vec__118545,network,ledger_id))
;
return fluree.db.connection.add_listener(conn,network,ledger_id,key,cb_STAR_);
});
/**
 * Closes a listener.
 */
shared.connection_handler.close_listener = (function shared$connection_handler$close_listener(conn,ledger,key){
var vec__118550 = fluree.db.session.resolve_ledger(conn,ledger);
var network = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__118550,(0),null);
var ledger_id = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__118550,(1),null);
return fluree.db.connection.remove_listener(conn,network,ledger_id,key);
});
/**
 * Return a list of listeners currently registered for each ledger along with their respective keys.
 */
shared.connection_handler.listeners = (function shared$connection_handler$listeners(conn){
return cljs.core.clj__GT_js(fluree.db.connection.listeners(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(conn)));
});
/**
 * Returns true when the ledger server/group supports password authentication
 */
shared.connection_handler.password_enabled_QMARK_ = (function shared$connection_handler$password_enabled_QMARK_(conn){
return cljs.core.cst$kw$password_DASH_enabled_QMARK_.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$flureedb_DASH_settings.cljs$core$IFn$_invoke$arity$1(conn)));
});
/**
 * Generates a password auth record for an existing role, or a user.
 *   The user may exist, or if createUser? is true, the user is created.
 * 
 *   Returns a promise that eventually contains the token or an exception
 */
shared.connection_handler.password_generate = (function shared$connection_handler$password_generate(conn,ledger,password,map_data){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_118600){
var state_val_118601 = (state_118600[(1)]);
if((state_val_118601 === (7))){
var inst_118568 = (state_118600[(2)]);
var state_118600__$1 = (function (){var statearr_118602 = state_118600;
(statearr_118602[(7)] = inst_118568);

return statearr_118602;
})();
if(cljs.core.truth_(ledger)){
var statearr_118603_118627 = state_118600__$1;
(statearr_118603_118627[(1)] = (8));

} else {
var statearr_118604_118628 = state_118600__$1;
(statearr_118604_118628[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (1))){
var state_118600__$1 = state_118600;
var statearr_118605_118629 = state_118600__$1;
(statearr_118605_118629[(2)] = null);

(statearr_118605_118629[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_118600,(3),cljs.core.cst$kw$default,null,(2));
var inst_118559 = shared.connection_handler.password_enabled_QMARK_(conn);
var state_118600__$1 = state_118600;
if(cljs.core.truth_(inst_118559)){
var statearr_118606_118630 = state_118600__$1;
(statearr_118606_118630[(1)] = (5));

} else {
var statearr_118607_118631 = state_118600__$1;
(statearr_118607_118631[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (13))){
var inst_118586 = (state_118600[(2)]);
var inst_118587 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(map_data,cljs.core.cst$kw$ledger,ledger,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$password,password], 0));
var inst_118588 = fluree.db.util.core.without_nils(inst_118587);
var inst_118589 = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var inst_118590 = cljs.core.cst$kw$req_DASH_chan.cljs$core$IFn$_invoke$arity$1(conn);
var inst_118591 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_118592 = [cljs.core.cst$kw$pw_DASH_generate,inst_118588,inst_118589,null];
var inst_118593 = (new cljs.core.PersistentVector(null,4,(5),inst_118591,inst_118592,null));
var inst_118594 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(inst_118590,inst_118593);
var inst_118595 = (function (){var _ = inst_118586;
var data = inst_118588;
var pc = inst_118589;
return ((function (_,data,pc,inst_118586,inst_118587,inst_118588,inst_118589,inst_118590,inst_118591,inst_118592,inst_118593,inst_118594,state_val_118601,c__99809__auto__){
return (function (result){
if(cljs.core.truth_((((result == null))?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("The password auth could not be generated.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_request], null))})():null))){
if(cljs.core.truth_(cljs.core.cst$kw$error.cljs$core$IFn$_invoke$arity$1(result))){
var G__118608 = cljs.core.clj__GT_js(result);
return (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(G__118608) : reject.call(null,G__118608));
} else {
return null;
}
} else {
if((result instanceof cljs.core.ExceptionInfo)){
var err_data = cljs.core.ex_data(result);
var err_resp = new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$status,(function (){var or__4131__auto__ = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (400);
}
})(),cljs.core.cst$kw$message,cljs.core.ex_message(result),cljs.core.cst$kw$error,(function (){var or__4131__auto__ = cljs.core.cst$kw$error.cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.cst$kw$db_SLASH_invalid_DASH_request;
}
})()], null);
var G__118609 = cljs.core.clj__GT_js(err_resp);
return (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(G__118609) : reject.call(null,G__118609));
} else {
var G__118610 = cljs.core.clj__GT_js(result);
return (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(G__118610) : resolve.call(null,G__118610));

}
}
});
;})(_,data,pc,inst_118586,inst_118587,inst_118588,inst_118589,inst_118590,inst_118591,inst_118592,inst_118593,inst_118594,state_val_118601,c__99809__auto__))
})();
var inst_118596 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_118589,inst_118595);
var state_118600__$1 = (function (){var statearr_118611 = state_118600;
(statearr_118611[(8)] = inst_118594);

return statearr_118611;
})();
var statearr_118612_118632 = state_118600__$1;
(statearr_118612_118632[(2)] = inst_118596);


cljs.core.async.impl.ioc_helpers.process_exception(state_118600__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (6))){
var inst_118562 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_118563 = [(401),cljs.core.cst$kw$db_SLASH_no_DASH_password_DASH_auth];
var inst_118564 = cljs.core.PersistentHashMap.fromArrays(inst_118562,inst_118563);
var inst_118565 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Password authentication is not enabled.",inst_118564);
var inst_118566 = (function(){throw inst_118565})();
var state_118600__$1 = state_118600;
var statearr_118613_118633 = state_118600__$1;
(statearr_118613_118633[(2)] = inst_118566);

(statearr_118613_118633[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (3))){
var inst_118553 = (state_118600[(2)]);
var inst_118554 = cljs.core.clj__GT_js(inst_118553);
var inst_118555 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_118554) : reject.call(null,inst_118554));
var state_118600__$1 = state_118600;
var statearr_118614_118634 = state_118600__$1;
(statearr_118614_118634[(2)] = inst_118555);


cljs.core.async.impl.ioc_helpers.process_exception(state_118600__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (12))){
var inst_118580 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_118581 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_request];
var inst_118582 = cljs.core.PersistentHashMap.fromArrays(inst_118580,inst_118581);
var inst_118583 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("A password must be supplied.",inst_118582);
var inst_118584 = (function(){throw inst_118583})();
var state_118600__$1 = state_118600;
var statearr_118615_118635 = state_118600__$1;
(statearr_118615_118635[(2)] = inst_118584);

(statearr_118615_118635[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (2))){
var inst_118598 = (state_118600[(2)]);
var state_118600__$1 = state_118600;
return cljs.core.async.impl.ioc_helpers.return_chan(state_118600__$1,inst_118598);
} else {
if((state_val_118601 === (11))){
var state_118600__$1 = state_118600;
var statearr_118616_118636 = state_118600__$1;
(statearr_118616_118636[(2)] = null);

(statearr_118616_118636[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (9))){
var inst_118571 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_118572 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_request];
var inst_118573 = cljs.core.PersistentHashMap.fromArrays(inst_118571,inst_118572);
var inst_118574 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("A ledger must be supplied.",inst_118573);
var inst_118575 = (function(){throw inst_118574})();
var state_118600__$1 = state_118600;
var statearr_118617_118637 = state_118600__$1;
(statearr_118617_118637[(2)] = inst_118575);

(statearr_118617_118637[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (5))){
var state_118600__$1 = state_118600;
var statearr_118618_118638 = state_118600__$1;
(statearr_118618_118638[(2)] = null);

(statearr_118618_118638[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (10))){
var inst_118577 = (state_118600[(2)]);
var state_118600__$1 = (function (){var statearr_118619 = state_118600;
(statearr_118619[(9)] = inst_118577);

return statearr_118619;
})();
if(cljs.core.truth_(password)){
var statearr_118620_118639 = state_118600__$1;
(statearr_118620_118639[(1)] = (11));

} else {
var statearr_118621_118640 = state_118600__$1;
(statearr_118621_118640[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118601 === (8))){
var state_118600__$1 = state_118600;
var statearr_118622_118641 = state_118600__$1;
(statearr_118622_118641[(2)] = null);

(statearr_118622_118641[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$connection_handler$password_generate_$_state_machine__99703__auto__ = null;
var shared$connection_handler$password_generate_$_state_machine__99703__auto____0 = (function (){
var statearr_118623 = [null,null,null,null,null,null,null,null,null,null];
(statearr_118623[(0)] = shared$connection_handler$password_generate_$_state_machine__99703__auto__);

(statearr_118623[(1)] = (1));

return statearr_118623;
});
var shared$connection_handler$password_generate_$_state_machine__99703__auto____1 = (function (state_118600){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_118600);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e118624){if((e118624 instanceof Object)){
var ex__99706__auto__ = e118624;
var statearr_118625_118642 = state_118600;
(statearr_118625_118642[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_118600);

return cljs.core.cst$kw$recur;
} else {
throw e118624;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__118643 = state_118600;
state_118600 = G__118643;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$connection_handler$password_generate_$_state_machine__99703__auto__ = function(state_118600){
switch(arguments.length){
case 0:
return shared$connection_handler$password_generate_$_state_machine__99703__auto____0.call(this);
case 1:
return shared$connection_handler$password_generate_$_state_machine__99703__auto____1.call(this,state_118600);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$connection_handler$password_generate_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$connection_handler$password_generate_$_state_machine__99703__auto____0;
shared$connection_handler$password_generate_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$connection_handler$password_generate_$_state_machine__99703__auto____1;
return shared$connection_handler$password_generate_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_118626 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_118626[(6)] = c__99809__auto__);

return statearr_118626;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});
/**
 * Returns a JWT token if successful.
 *   Must supply ledger, password and either user or auth identifier.
 *   Expire is optional
 *   - ledger   - ledger identifier
 *   - password - plain-text password
 *   - user     - _user/username (TODO: should allow any _user ident in the future)
 *   - auth     - _auth/id (TODO: should allow any _auth ident in the future)
 *   - expire   - requested time to expire in milliseconds
 */
shared.connection_handler.password_login = (function shared$connection_handler$password_login(var_args){
var G__118645 = arguments.length;
switch (G__118645) {
case 4:
return shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 6:
return shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,password,user){
return shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$6(conn,ledger,password,user,null,null);
});

shared.connection_handler.password_login.cljs$core$IFn$_invoke$arity$6 = (function (conn,ledger,password,user,auth,expire){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_118708){
var state_val_118709 = (state_118708[(1)]);
if((state_val_118709 === (7))){
var inst_118661 = (state_118708[(2)]);
var state_118708__$1 = (function (){var statearr_118710 = state_118708;
(statearr_118710[(7)] = inst_118661);

return statearr_118710;
})();
if(cljs.core.truth_(ledger)){
var statearr_118711_118745 = state_118708__$1;
(statearr_118711_118745[(1)] = (8));

} else {
var statearr_118712_118746 = state_118708__$1;
(statearr_118712_118746[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (1))){
var state_118708__$1 = state_118708;
var statearr_118713_118747 = state_118708__$1;
(statearr_118713_118747[(2)] = null);

(statearr_118713_118747[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_118708,(3),cljs.core.cst$kw$default,null,(2));
var inst_118652 = shared.connection_handler.password_enabled_QMARK_(conn);
var state_118708__$1 = state_118708;
if(cljs.core.truth_(inst_118652)){
var statearr_118714_118748 = state_118708__$1;
(statearr_118714_118748[(1)] = (5));

} else {
var statearr_118715_118749 = state_118708__$1;
(statearr_118715_118749[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (15))){
var state_118708__$1 = state_118708;
var statearr_118716_118750 = state_118708__$1;
(statearr_118716_118750[(2)] = auth);

(statearr_118716_118750[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (13))){
var inst_118679 = (state_118708[(2)]);
var state_118708__$1 = (function (){var statearr_118717 = state_118708;
(statearr_118717[(8)] = inst_118679);

return statearr_118717;
})();
if(cljs.core.truth_(user)){
var statearr_118718_118751 = state_118708__$1;
(statearr_118718_118751[(1)] = (14));

} else {
var statearr_118719_118752 = state_118708__$1;
(statearr_118719_118752[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (6))){
var inst_118655 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_118656 = [(401),cljs.core.cst$kw$db_SLASH_no_DASH_password_DASH_auth];
var inst_118657 = cljs.core.PersistentHashMap.fromArrays(inst_118655,inst_118656);
var inst_118658 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Password authentication is not enabled.",inst_118657);
var inst_118659 = (function(){throw inst_118658})();
var state_118708__$1 = state_118708;
var statearr_118720_118753 = state_118708__$1;
(statearr_118720_118753[(2)] = inst_118659);

(statearr_118720_118753[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (17))){
var state_118708__$1 = state_118708;
var statearr_118721_118754 = state_118708__$1;
(statearr_118721_118754[(2)] = null);

(statearr_118721_118754[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (3))){
var inst_118646 = (state_118708[(2)]);
var inst_118647 = cljs.core.clj__GT_js(inst_118646);
var inst_118648 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_118647) : reject.call(null,inst_118647));
var state_118708__$1 = state_118708;
var statearr_118722_118755 = state_118708__$1;
(statearr_118722_118755[(2)] = inst_118648);


cljs.core.async.impl.ioc_helpers.process_exception(state_118708__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (12))){
var inst_118673 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_118674 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_request];
var inst_118675 = cljs.core.PersistentHashMap.fromArrays(inst_118673,inst_118674);
var inst_118676 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("A password must be supplied in the provided JSON.",inst_118675);
var inst_118677 = (function(){throw inst_118676})();
var state_118708__$1 = state_118708;
var statearr_118723_118756 = state_118708__$1;
(statearr_118723_118756[(2)] = inst_118677);

(statearr_118723_118756[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (2))){
var inst_118706 = (state_118708[(2)]);
var state_118708__$1 = state_118708;
return cljs.core.async.impl.ioc_helpers.return_chan(state_118708__$1,inst_118706);
} else {
if((state_val_118709 === (19))){
var inst_118692 = (state_118708[(2)]);
var inst_118693 = [cljs.core.cst$kw$ledger,cljs.core.cst$kw$password,cljs.core.cst$kw$user,cljs.core.cst$kw$auth,cljs.core.cst$kw$expire];
var inst_118694 = [ledger,password,user,auth,expire];
var inst_118695 = cljs.core.PersistentHashMap.fromArrays(inst_118693,inst_118694);
var inst_118696 = fluree.db.util.core.without_nils(inst_118695);
var inst_118697 = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var inst_118698 = cljs.core.cst$kw$req_DASH_chan.cljs$core$IFn$_invoke$arity$1(conn);
var inst_118699 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_118700 = [cljs.core.cst$kw$pw_DASH_login,inst_118696,inst_118697,null];
var inst_118701 = (new cljs.core.PersistentVector(null,4,(5),inst_118699,inst_118700,null));
var inst_118702 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(inst_118698,inst_118701);
var inst_118703 = (function (){var _ = inst_118692;
var data = inst_118696;
var pc = inst_118697;
return ((function (_,data,pc,inst_118692,inst_118693,inst_118694,inst_118695,inst_118696,inst_118697,inst_118698,inst_118699,inst_118700,inst_118701,inst_118702,state_val_118709,c__99809__auto__){
return (function (result){
if(cljs.core.truth_((((result == null))?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("A token could not be generated for the identity and password combination.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_request], null))})():null))){
if(cljs.core.truth_(cljs.core.cst$kw$error.cljs$core$IFn$_invoke$arity$1(result))){
var G__118724 = cljs.core.clj__GT_js(result);
return (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(G__118724) : reject.call(null,G__118724));
} else {
return null;
}
} else {
if((result instanceof cljs.core.ExceptionInfo)){
var err_data = cljs.core.ex_data(result);
var err_resp = new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$status,(function (){var or__4131__auto__ = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (400);
}
})(),cljs.core.cst$kw$message,cljs.core.ex_message(result),cljs.core.cst$kw$error,(function (){var or__4131__auto__ = cljs.core.cst$kw$error.cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.cst$kw$db_SLASH_invalid_DASH_request;
}
})()], null);
var G__118725 = cljs.core.clj__GT_js(err_resp);
return (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(G__118725) : reject.call(null,G__118725));
} else {
var G__118726 = cljs.core.clj__GT_js(result);
return (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(G__118726) : resolve.call(null,G__118726));

}
}
});
;})(_,data,pc,inst_118692,inst_118693,inst_118694,inst_118695,inst_118696,inst_118697,inst_118698,inst_118699,inst_118700,inst_118701,inst_118702,state_val_118709,c__99809__auto__))
})();
var inst_118704 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_118697,inst_118703);
var state_118708__$1 = (function (){var statearr_118727 = state_118708;
(statearr_118727[(9)] = inst_118702);

return statearr_118727;
})();
var statearr_118728_118757 = state_118708__$1;
(statearr_118728_118757[(2)] = inst_118704);


cljs.core.async.impl.ioc_helpers.process_exception(state_118708__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (11))){
var state_118708__$1 = state_118708;
var statearr_118729_118758 = state_118708__$1;
(statearr_118729_118758[(2)] = null);

(statearr_118729_118758[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (9))){
var inst_118664 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_118665 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_request];
var inst_118666 = cljs.core.PersistentHashMap.fromArrays(inst_118664,inst_118665);
var inst_118667 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("A ledger must be supplied in the provided JSON.",inst_118666);
var inst_118668 = (function(){throw inst_118667})();
var state_118708__$1 = state_118708;
var statearr_118730_118759 = state_118708__$1;
(statearr_118730_118759[(2)] = inst_118668);

(statearr_118730_118759[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (5))){
var state_118708__$1 = state_118708;
var statearr_118731_118760 = state_118708__$1;
(statearr_118731_118760[(2)] = null);

(statearr_118731_118760[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (14))){
var state_118708__$1 = state_118708;
var statearr_118732_118761 = state_118708__$1;
(statearr_118732_118761[(2)] = user);

(statearr_118732_118761[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (16))){
var inst_118683 = (state_118708[(2)]);
var state_118708__$1 = state_118708;
if(cljs.core.truth_(inst_118683)){
var statearr_118733_118762 = state_118708__$1;
(statearr_118733_118762[(1)] = (17));

} else {
var statearr_118734_118763 = state_118708__$1;
(statearr_118734_118763[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (10))){
var inst_118670 = (state_118708[(2)]);
var state_118708__$1 = (function (){var statearr_118735 = state_118708;
(statearr_118735[(10)] = inst_118670);

return statearr_118735;
})();
if(cljs.core.truth_(password)){
var statearr_118736_118764 = state_118708__$1;
(statearr_118736_118764[(1)] = (11));

} else {
var statearr_118737_118765 = state_118708__$1;
(statearr_118737_118765[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (18))){
var inst_118686 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_118687 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_request];
var inst_118688 = cljs.core.PersistentHashMap.fromArrays(inst_118686,inst_118687);
var inst_118689 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("A user identity or auth identity must be supplied.",inst_118688);
var inst_118690 = (function(){throw inst_118689})();
var state_118708__$1 = state_118708;
var statearr_118738_118766 = state_118708__$1;
(statearr_118738_118766[(2)] = inst_118690);

(statearr_118738_118766[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118709 === (8))){
var state_118708__$1 = state_118708;
var statearr_118739_118767 = state_118708__$1;
(statearr_118739_118767[(2)] = null);

(statearr_118739_118767[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$connection_handler$state_machine__99703__auto__ = null;
var shared$connection_handler$state_machine__99703__auto____0 = (function (){
var statearr_118740 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_118740[(0)] = shared$connection_handler$state_machine__99703__auto__);

(statearr_118740[(1)] = (1));

return statearr_118740;
});
var shared$connection_handler$state_machine__99703__auto____1 = (function (state_118708){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_118708);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e118741){if((e118741 instanceof Object)){
var ex__99706__auto__ = e118741;
var statearr_118742_118768 = state_118708;
(statearr_118742_118768[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_118708);

return cljs.core.cst$kw$recur;
} else {
throw e118741;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__118769 = state_118708;
state_118708 = G__118769;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$connection_handler$state_machine__99703__auto__ = function(state_118708){
switch(arguments.length){
case 0:
return shared$connection_handler$state_machine__99703__auto____0.call(this);
case 1:
return shared$connection_handler$state_machine__99703__auto____1.call(this,state_118708);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$connection_handler$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$connection_handler$state_machine__99703__auto____0;
shared$connection_handler$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$connection_handler$state_machine__99703__auto____1;
return shared$connection_handler$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_118743 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_118743[(6)] = c__99809__auto__);

return statearr_118743;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

shared.connection_handler.password_login.cljs$lang$maxFixedArity = 6;

/**
 * Renews a JWT token if successful.
 * 
 *   Returns a promise that eventually contains the token or an exception
 */
shared.connection_handler.renew_token = (function shared$connection_handler$renew_token(var_args){
var G__118771 = arguments.length;
switch (G__118771) {
case 2:
return shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$2 = (function (conn,jwt){
return shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$3(conn,jwt,null);
});

shared.connection_handler.renew_token.cljs$core$IFn$_invoke$arity$3 = (function (conn,jwt,expire){
return (new Promise((function (resolve,reject){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_118803){
var state_val_118804 = (state_118803[(1)]);
if((state_val_118804 === (1))){
var state_118803__$1 = state_118803;
var statearr_118805_118820 = state_118803__$1;
(statearr_118805_118820[(2)] = null);

(statearr_118805_118820[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118804 === (2))){
var inst_118801 = (state_118803[(2)]);
var state_118803__$1 = state_118803;
return cljs.core.async.impl.ioc_helpers.return_chan(state_118803__$1,inst_118801);
} else {
if((state_val_118804 === (3))){
var inst_118772 = (state_118803[(2)]);
var inst_118773 = cljs.core.clj__GT_js(inst_118772);
var inst_118774 = (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(inst_118773) : reject.call(null,inst_118773));
var state_118803__$1 = state_118803;
var statearr_118806_118821 = state_118803__$1;
(statearr_118806_118821[(2)] = inst_118774);


cljs.core.async.impl.ioc_helpers.process_exception(state_118803__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_118804 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_118803,(3),cljs.core.cst$kw$default,null,(2));
var inst_118778 = shared.connection_handler.password_enabled_QMARK_(conn);
var state_118803__$1 = state_118803;
if(cljs.core.truth_(inst_118778)){
var statearr_118807_118822 = state_118803__$1;
(statearr_118807_118822[(1)] = (5));

} else {
var statearr_118808_118823 = state_118803__$1;
(statearr_118808_118823[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118804 === (5))){
var state_118803__$1 = state_118803;
var statearr_118809_118824 = state_118803__$1;
(statearr_118809_118824[(2)] = null);

(statearr_118809_118824[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118804 === (6))){
var inst_118781 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_118782 = [(401),cljs.core.cst$kw$db_SLASH_no_DASH_password_DASH_auth];
var inst_118783 = cljs.core.PersistentHashMap.fromArrays(inst_118781,inst_118782);
var inst_118784 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Password authentication is not enabled.",inst_118783);
var inst_118785 = (function(){throw inst_118784})();
var state_118803__$1 = state_118803;
var statearr_118810_118825 = state_118803__$1;
(statearr_118810_118825[(2)] = inst_118785);

(statearr_118810_118825[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118804 === (7))){
var inst_118787 = (state_118803[(2)]);
var inst_118788 = [cljs.core.cst$kw$jwt,cljs.core.cst$kw$expire];
var inst_118789 = [jwt,expire];
var inst_118790 = cljs.core.PersistentHashMap.fromArrays(inst_118788,inst_118789);
var inst_118791 = fluree.db.util.core.without_nils(inst_118790);
var inst_118792 = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var inst_118793 = cljs.core.cst$kw$req_DASH_chan.cljs$core$IFn$_invoke$arity$1(conn);
var inst_118794 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_118795 = [cljs.core.cst$kw$pw_DASH_renew,inst_118791,inst_118792,null];
var inst_118796 = (new cljs.core.PersistentVector(null,4,(5),inst_118794,inst_118795,null));
var inst_118797 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(inst_118793,inst_118796);
var inst_118798 = (function (){var _ = inst_118787;
var data = inst_118791;
var pc = inst_118792;
return ((function (_,data,pc,inst_118787,inst_118788,inst_118789,inst_118790,inst_118791,inst_118792,inst_118793,inst_118794,inst_118795,inst_118796,inst_118797,state_val_118804,c__99809__auto__){
return (function (result){
if(cljs.core.truth_((((result == null))?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("The token could not be renewed.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_request], null))})():null))){
if(cljs.core.truth_(cljs.core.cst$kw$error.cljs$core$IFn$_invoke$arity$1(result))){
var G__118811 = cljs.core.clj__GT_js(result);
return (reject.cljs$core$IFn$_invoke$arity$1 ? reject.cljs$core$IFn$_invoke$arity$1(G__118811) : reject.call(null,G__118811));
} else {
return null;
}
} else {
var G__118812 = cljs.core.clj__GT_js(result);
return (resolve.cljs$core$IFn$_invoke$arity$1 ? resolve.cljs$core$IFn$_invoke$arity$1(G__118812) : resolve.call(null,G__118812));

}
});
;})(_,data,pc,inst_118787,inst_118788,inst_118789,inst_118790,inst_118791,inst_118792,inst_118793,inst_118794,inst_118795,inst_118796,inst_118797,state_val_118804,c__99809__auto__))
})();
var inst_118799 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_118792,inst_118798);
var state_118803__$1 = (function (){var statearr_118813 = state_118803;
(statearr_118813[(7)] = inst_118797);

return statearr_118813;
})();
var statearr_118814_118826 = state_118803__$1;
(statearr_118814_118826[(2)] = inst_118799);


cljs.core.async.impl.ioc_helpers.process_exception(state_118803__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$connection_handler$state_machine__99703__auto__ = null;
var shared$connection_handler$state_machine__99703__auto____0 = (function (){
var statearr_118815 = [null,null,null,null,null,null,null,null];
(statearr_118815[(0)] = shared$connection_handler$state_machine__99703__auto__);

(statearr_118815[(1)] = (1));

return statearr_118815;
});
var shared$connection_handler$state_machine__99703__auto____1 = (function (state_118803){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_118803);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e118816){if((e118816 instanceof Object)){
var ex__99706__auto__ = e118816;
var statearr_118817_118827 = state_118803;
(statearr_118817_118827[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_118803);

return cljs.core.cst$kw$recur;
} else {
throw e118816;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__118828 = state_118803;
state_118803 = G__118828;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$connection_handler$state_machine__99703__auto__ = function(state_118803){
switch(arguments.length){
case 0:
return shared$connection_handler$state_machine__99703__auto____0.call(this);
case 1:
return shared$connection_handler$state_machine__99703__auto____1.call(this,state_118803);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$connection_handler$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$connection_handler$state_machine__99703__auto____0;
shared$connection_handler$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$connection_handler$state_machine__99703__auto____1;
return shared$connection_handler$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_118818 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_118818[(6)] = c__99809__auto__);

return statearr_118818;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
})));
});

shared.connection_handler.renew_token.cljs$lang$maxFixedArity = 3;

