// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.dbfunctions.internal');
goog.require('cljs.core');
goog.require('cljs.tools.reader.edn');
goog.require('fluree.db.query.fql');
goog.require('fluree.db.util.core');
goog.require('cljs.core.async');
goog.require('fluree.db.util.log');
goog.require('fluree.db.util.async');
goog.require('fluree.db.dbproto');
goog.require('clojure.string');
fluree.db.dbfunctions.internal.parse_select_map = (function fluree$db$dbfunctions$internal$parse_select_map(param_str){
var parsed_param = ((typeof param_str === 'string')?cljs.tools.reader.edn.read_string.call(null,param_str):param_str);
if(cljs.core.map_QMARK_.call(null,parsed_param)){
var key = cljs.core.first.call(null,cljs.core.keys.call(null,parsed_param));
var key_SINGLEQUOTE_ = ((typeof key === 'string')?key:(((cljs.core.namespace.call(null,key) == null))?cljs.core.name.call(null,key):[cljs.core.namespace.call(null,key),"/",cljs.core.name.call(null,key)].join('')));
var value = cljs.core.first.call(null,cljs.core.vals.call(null,parsed_param));
var value_SINGLEQUOTE_ = fluree.db.dbfunctions.internal.parse_select_map.call(null,value);
var value_SINGLEQUOTE__SINGLEQUOTE_ = ((cljs.core.coll_QMARK_.call(null,value_SINGLEQUOTE_))?cljs.core.into.call(null,cljs.core.PersistentVector.EMPTY,value_SINGLEQUOTE_):value_SINGLEQUOTE_);
return cljs.core.assoc.call(null,cljs.core.PersistentArrayMap.EMPTY,key_SINGLEQUOTE_,value_SINGLEQUOTE__SINGLEQUOTE_);
} else {
if(typeof parsed_param === 'string'){
return parsed_param;
} else {
if((((parsed_param instanceof cljs.core.Symbol)) || (cljs.core.var_QMARK_.call(null,parsed_param)))){
if((cljs.core.namespace.call(null,parsed_param) == null)){
return cljs.core.name.call(null,parsed_param);
} else {
return [cljs.core.namespace.call(null,parsed_param),"/",cljs.core.name.call(null,parsed_param)].join('');
}
} else {
if(cljs.core.vector_QMARK_.call(null,parsed_param)){
return cljs.core.mapv.call(null,fluree.db.dbfunctions.internal.parse_select_map,parsed_param);
} else {
throw cljs.core.ex_info.call(null,["The query path is not properly formatted: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(parsed_param)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-fn","db/invalid-fn",-107800799)], null));

}
}
}
}
});
fluree.db.dbfunctions.internal.function_error = (function fluree$db$dbfunctions$internal$function_error(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104566 = arguments.length;
var i__4731__auto___104567 = (0);
while(true){
if((i__4731__auto___104567 < len__4730__auto___104566)){
args__4736__auto__.push((arguments[i__4731__auto___104567]));

var G__104568 = (i__4731__auto___104567 + (1));
i__4731__auto___104567 = G__104568;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((2) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((2)),(0),null)):null);
return fluree.db.dbfunctions.internal.function_error.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4737__auto__);
});

fluree.db.dbfunctions.internal.function_error.cljs$core$IFn$_invoke$arity$variadic = (function (e,function_name,args){
fluree.db.util.log.error.call(null,e,"Function Error: ",function_name,"args: ",cljs.core.pr_str.call(null,args));

throw cljs.core.ex_info.call(null,["Error in database function: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(function_name),": ",cljs.core.str.cljs$core$IFn$_invoke$arity$1((((e.getMessage() == null))?e.getClass():e.getMessage())),". Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(((cljs.core.coll_QMARK_.call(null,args))?clojure.string.join.call(null," ",args):args))].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-fn","db/invalid-fn",-107800799)], null));
});

fluree.db.dbfunctions.internal.function_error.cljs$lang$maxFixedArity = (2);

/** @this {Function} */
fluree.db.dbfunctions.internal.function_error.cljs$lang$applyTo = (function (seq104563){
var G__104564 = cljs.core.first.call(null,seq104563);
var seq104563__$1 = cljs.core.next.call(null,seq104563);
var G__104565 = cljs.core.first.call(null,seq104563__$1);
var seq104563__$2 = cljs.core.next.call(null,seq104563__$1);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__104564,G__104565,seq104563__$2);
});

/**
 * Coerce to boolean. Everything except `false' and `nil' is true in boolean context.
 */
fluree.db.dbfunctions.internal.boolean$ = (function fluree$db$dbfunctions$internal$boolean(x){
try{return cljs.core.boolean$.call(null,x);
}catch (e104569){var e = e104569;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"boolean",x);
}});
fluree.db.dbfunctions.internal.nil_QMARK_ = (function fluree$db$dbfunctions$internal$nil_QMARK_(arg){
try{return (arg == null);
}catch (e104570){var e = e104570;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"nil?",arg);
}});
fluree.db.dbfunctions.internal.not = (function fluree$db$dbfunctions$internal$not(arg){
try{return cljs.core.not.call(null,arg);
}catch (e104571){var e = e104571;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"not",arg);
}});
fluree.db.dbfunctions.internal.empty_QMARK_ = (function fluree$db$dbfunctions$internal$empty_QMARK_(arg){
try{return ((cljs.core.empty_QMARK_.call(null,arg)) || (cljs.core._EQ_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [null,null], null), null),arg)));
}catch (e104572){var e = e104572;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"empty?",arg);
}});
/**
 * Like clojure.core/if
 */
fluree.db.dbfunctions.internal.if_else = (function fluree$db$dbfunctions$internal$if_else(test,true_res,false_res){
try{if(cljs.core.truth_(test)){
return true_res;
} else {
return false_res;

}
}catch (e104573){var e = e104573;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"if-else",test,true_res,false_res);
}});
/**
 * Returns true if all true
 */
fluree.db.dbfunctions.internal.and = (function fluree$db$dbfunctions$internal$and(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104576 = arguments.length;
var i__4731__auto___104577 = (0);
while(true){
if((i__4731__auto___104577 < len__4730__auto___104576)){
args__4736__auto__.push((arguments[i__4731__auto___104577]));

var G__104578 = (i__4731__auto___104577 + (1));
i__4731__auto___104577 = G__104578;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal.and.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal.and.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{var coerced_coll = cljs.core.map.call(null,fluree.db.dbfunctions.internal.boolean$,args);
if(cljs.core.truth_(fluree.db.dbfunctions.internal.nil_QMARK_.call(null,args))){
return false;
} else {
return fluree.db.dbfunctions.internal.boolean$.call(null,cljs.core.every_QMARK_.call(null,cljs.core.true_QMARK_,coerced_coll));
}
}catch (e104575){var e = e104575;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"and",args);
}});

fluree.db.dbfunctions.internal.and.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal.and.cljs$lang$applyTo = (function (seq104574){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104574));
});

/**
 * Returns true if any true
 */
fluree.db.dbfunctions.internal.or = (function fluree$db$dbfunctions$internal$or(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104581 = arguments.length;
var i__4731__auto___104582 = (0);
while(true){
if((i__4731__auto___104582 < len__4730__auto___104581)){
args__4736__auto__.push((arguments[i__4731__auto___104582]));

var G__104583 = (i__4731__auto___104582 + (1));
i__4731__auto___104582 = G__104583;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal.or.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal.or.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{var coerced_coll = cljs.core.map.call(null,fluree.db.dbfunctions.internal.boolean$,args);
if(cljs.core.truth_(fluree.db.dbfunctions.internal.nil_QMARK_.call(null,args))){
return false;
} else {
return fluree.db.dbfunctions.internal.boolean$.call(null,cljs.core.some.call(null,cljs.core.true_QMARK_,coerced_coll));
}
}catch (e104580){var e = e104580;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"or",args);
}});

fluree.db.dbfunctions.internal.or.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal.or.cljs$lang$applyTo = (function (seq104579){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104579));
});

/**
 * Returns the number of items in the collection. (count nil) returns 0.  Also works on strings, arrays, and Java Collections and Maps
 */
fluree.db.dbfunctions.internal.count = (function fluree$db$dbfunctions$internal$count(coll){
try{return cljs.core.count.call(null,coll);
}catch (e104584){var e = e104584;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"count",coll);
}});
/**
 * Like clojure.core/str
 */
fluree.db.dbfunctions.internal.str = (function fluree$db$dbfunctions$internal$str(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104587 = arguments.length;
var i__4731__auto___104588 = (0);
while(true){
if((i__4731__auto___104588 < len__4730__auto___104587)){
args__4736__auto__.push((arguments[i__4731__auto___104588]));

var G__104589 = (i__4731__auto___104588 + (1));
i__4731__auto___104588 = G__104589;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal.str.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal.str.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core.str,args);
}catch (e104586){var e = e104586;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"str",args);
}});

fluree.db.dbfunctions.internal.str.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal.str.cljs$lang$applyTo = (function (seq104585){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104585));
});

/**
 * Like clojure.core/lower-case
 */
fluree.db.dbfunctions.internal.lower_case = (function fluree$db$dbfunctions$internal$lower_case(str){
try{return clojure.string.lower_case.call(null,str);
}catch (e104590){var e = e104590;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"lower-case",str);
}});
/**
 * Like clojure.core/upper-case
 */
fluree.db.dbfunctions.internal.upper_case = (function fluree$db$dbfunctions$internal$upper_case(str){
try{return clojure.string.upper_case.call(null,str);
}catch (e104591){var e = e104591;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"upper-case",str);
}});
/**
 * Like clojure.core/max, but applies max on a sequence
 */
fluree.db.dbfunctions.internal.max = (function fluree$db$dbfunctions$internal$max(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104594 = arguments.length;
var i__4731__auto___104595 = (0);
while(true){
if((i__4731__auto___104595 < len__4730__auto___104594)){
args__4736__auto__.push((arguments[i__4731__auto___104595]));

var G__104596 = (i__4731__auto___104595 + (1));
i__4731__auto___104595 = G__104596;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal.max.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal.max.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core.max,cljs.core.remove.call(null,fluree.db.dbfunctions.internal.nil_QMARK_,args));
}catch (e104593){var e = e104593;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"max",args);
}});

fluree.db.dbfunctions.internal.max.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal.max.cljs$lang$applyTo = (function (seq104592){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104592));
});

/**
 * Like clojure.core/min, but applies min on a sequence
 */
fluree.db.dbfunctions.internal.min = (function fluree$db$dbfunctions$internal$min(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104599 = arguments.length;
var i__4731__auto___104600 = (0);
while(true){
if((i__4731__auto___104600 < len__4730__auto___104599)){
args__4736__auto__.push((arguments[i__4731__auto___104600]));

var G__104601 = (i__4731__auto___104600 + (1));
i__4731__auto___104600 = G__104601;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal.min.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal.min.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core.min,cljs.core.remove.call(null,fluree.db.dbfunctions.internal.nil_QMARK_,args));
}catch (e104598){var e = e104598;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"min",args);
}});

fluree.db.dbfunctions.internal.min.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal.min.cljs$lang$applyTo = (function (seq104597){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104597));
});

/**
 * Like clojure.core/>, but applies > on a sequence
 */
fluree.db.dbfunctions.internal._GT_ = (function fluree$db$dbfunctions$internal$_GT_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104604 = arguments.length;
var i__4731__auto___104605 = (0);
while(true){
if((i__4731__auto___104605 < len__4730__auto___104604)){
args__4736__auto__.push((arguments[i__4731__auto___104605]));

var G__104606 = (i__4731__auto___104605 + (1));
i__4731__auto___104605 = G__104606;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal._GT_.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal._GT_.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core._GT_,args);
}catch (e104603){var e = e104603;
return fluree.db.dbfunctions.internal.function_error.call(null,e,">",args);
}});

fluree.db.dbfunctions.internal._GT_.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal._GT_.cljs$lang$applyTo = (function (seq104602){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104602));
});

/**
 * Like clojure.core/>=, but applies > on a sequence
 */
fluree.db.dbfunctions.internal._GT__EQ_ = (function fluree$db$dbfunctions$internal$_GT__EQ_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104609 = arguments.length;
var i__4731__auto___104610 = (0);
while(true){
if((i__4731__auto___104610 < len__4730__auto___104609)){
args__4736__auto__.push((arguments[i__4731__auto___104610]));

var G__104611 = (i__4731__auto___104610 + (1));
i__4731__auto___104610 = G__104611;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal._GT__EQ_.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal._GT__EQ_.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core._GT__EQ_,args);
}catch (e104608){var e = e104608;
return fluree.db.dbfunctions.internal.function_error.call(null,e,">=",args);
}});

fluree.db.dbfunctions.internal._GT__EQ_.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal._GT__EQ_.cljs$lang$applyTo = (function (seq104607){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104607));
});

/**
 * Like clojure.core/>, but applies < on a sequence
 */
fluree.db.dbfunctions.internal._LT_ = (function fluree$db$dbfunctions$internal$_LT_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104614 = arguments.length;
var i__4731__auto___104615 = (0);
while(true){
if((i__4731__auto___104615 < len__4730__auto___104614)){
args__4736__auto__.push((arguments[i__4731__auto___104615]));

var G__104616 = (i__4731__auto___104615 + (1));
i__4731__auto___104615 = G__104616;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal._LT_.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal._LT_.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core._LT_,args);
}catch (e104613){var e = e104613;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"<",args);
}});

fluree.db.dbfunctions.internal._LT_.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal._LT_.cljs$lang$applyTo = (function (seq104612){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104612));
});

/**
 * Like clojure.core/>, but applies < on a sequence
 */
fluree.db.dbfunctions.internal._LT__EQ_ = (function fluree$db$dbfunctions$internal$_LT__EQ_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104619 = arguments.length;
var i__4731__auto___104620 = (0);
while(true){
if((i__4731__auto___104620 < len__4730__auto___104619)){
args__4736__auto__.push((arguments[i__4731__auto___104620]));

var G__104621 = (i__4731__auto___104620 + (1));
i__4731__auto___104620 = G__104621;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal._LT__EQ_.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal._LT__EQ_.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core._LT__EQ_,args);
}catch (e104618){var e = e104618;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"<=",args);
}});

fluree.db.dbfunctions.internal._LT__EQ_.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal._LT__EQ_.cljs$lang$applyTo = (function (seq104617){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104617));
});

/**
 * Executes a database query, but returns the :results directly.
 */
fluree.db.dbfunctions.internal.query = (function fluree$db$dbfunctions$internal$query(var_args){
var G__104623 = arguments.length;
switch (G__104623) {
case 3:
return fluree.db.dbfunctions.internal.query.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 6:
return fluree.db.dbfunctions.internal.query.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.dbfunctions.internal.query.cljs$core$IFn$_invoke$arity$3 = (function (db,query_map,opts){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_104646){
var state_val_104647 = (state_104646[(1)]);
if((state_val_104647 === (1))){
var state_104646__$1 = state_104646;
var statearr_104648_104727 = state_104646__$1;
(statearr_104648_104727[(2)] = null);

(statearr_104648_104727[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104647 === (2))){
var inst_104644 = (state_104646[(2)]);
var state_104646__$1 = state_104646;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_104646__$1,inst_104644);
} else {
if((state_val_104647 === (3))){
var inst_104624 = (state_104646[(2)]);
var state_104646__$1 = state_104646;
var statearr_104649_104728 = state_104646__$1;
(statearr_104649_104728[(2)] = inst_104624);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104646__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104647 === (4))){
var inst_104628 = (state_104646[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_104646,(3),Error,null,(2));
var inst_104628__$1 = cljs.core.volatile_BANG_.call(null,(0));
var inst_104629 = cljs.core.assoc.call(null,opts,new cljs.core.Keyword(null,"fuel","fuel",10405485),inst_104628__$1,new cljs.core.Keyword(null,"max-fuel","max-fuel",994681012),(100000));
var inst_104630 = fluree.db.query.fql.query.call(null,db,query_map,inst_104629);
var state_104646__$1 = (function (){var statearr_104650 = state_104646;
(statearr_104650[(7)] = inst_104628__$1);

return statearr_104650;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_104646__$1,(5),inst_104630);
} else {
if((state_val_104647 === (5))){
var inst_104632 = (state_104646[(8)]);
var inst_104632__$1 = (state_104646[(2)]);
var inst_104633 = fluree.db.util.core.exception_QMARK_.call(null,inst_104632__$1);
var state_104646__$1 = (function (){var statearr_104651 = state_104646;
(statearr_104651[(8)] = inst_104632__$1);

return statearr_104651;
})();
if(inst_104633){
var statearr_104652_104729 = state_104646__$1;
(statearr_104652_104729[(1)] = (6));

} else {
var statearr_104653_104730 = state_104646__$1;
(statearr_104653_104730[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104647 === (6))){
var inst_104632 = (state_104646[(8)]);
var inst_104635 = fluree.db.dbfunctions.internal.function_error.call(null,inst_104632,"query",query_map);
var state_104646__$1 = state_104646;
var statearr_104654_104731 = state_104646__$1;
(statearr_104654_104731[(2)] = inst_104635);

(statearr_104654_104731[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104647 === (7))){
var inst_104628 = (state_104646[(7)]);
var inst_104632 = (state_104646[(8)]);
var inst_104637 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104638 = cljs.core.deref.call(null,inst_104628);
var inst_104639 = [inst_104632,inst_104638];
var inst_104640 = (new cljs.core.PersistentVector(null,2,(5),inst_104637,inst_104639,null));
var state_104646__$1 = state_104646;
var statearr_104655_104732 = state_104646__$1;
(statearr_104655_104732[(2)] = inst_104640);

(statearr_104655_104732[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104647 === (8))){
var inst_104642 = (state_104646[(2)]);
var state_104646__$1 = state_104646;
var statearr_104656_104733 = state_104646__$1;
(statearr_104656_104733[(2)] = inst_104642);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104646__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$dbfunctions$internal$state_machine__86625__auto__ = null;
var fluree$db$dbfunctions$internal$state_machine__86625__auto____0 = (function (){
var statearr_104657 = [null,null,null,null,null,null,null,null,null];
(statearr_104657[(0)] = fluree$db$dbfunctions$internal$state_machine__86625__auto__);

(statearr_104657[(1)] = (1));

return statearr_104657;
});
var fluree$db$dbfunctions$internal$state_machine__86625__auto____1 = (function (state_104646){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_104646);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e104658){if((e104658 instanceof Object)){
var ex__86628__auto__ = e104658;
var statearr_104659_104734 = state_104646;
(statearr_104659_104734[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104646);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e104658;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__104735 = state_104646;
state_104646 = G__104735;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$dbfunctions$internal$state_machine__86625__auto__ = function(state_104646){
switch(arguments.length){
case 0:
return fluree$db$dbfunctions$internal$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$dbfunctions$internal$state_machine__86625__auto____1.call(this,state_104646);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$dbfunctions$internal$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$dbfunctions$internal$state_machine__86625__auto____0;
fluree$db$dbfunctions$internal$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$dbfunctions$internal$state_machine__86625__auto____1;
return fluree$db$dbfunctions$internal$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_104660 = f__86676__auto__.call(null);
(statearr_104660[(6)] = c__86675__auto__);

return statearr_104660;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.dbfunctions.internal.query.cljs$core$IFn$_invoke$arity$6 = (function (db,select,from,where,block,limit){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_104705){
var state_val_104706 = (state_104705[(1)]);
if((state_val_104706 === (7))){
var inst_104688 = (state_104705[(7)]);
var inst_104687 = (state_104705[(2)]);
var inst_104688__$1 = cljs.core.volatile_BANG_.call(null,(0));
var inst_104689 = [new cljs.core.Keyword(null,"fuel","fuel",10405485),new cljs.core.Keyword(null,"max-fuel","max-fuel",994681012)];
var inst_104690 = [inst_104688__$1,(100000)];
var inst_104691 = cljs.core.PersistentHashMap.fromArrays(inst_104689,inst_104690);
var inst_104692 = fluree.db.query.fql.query.call(null,db,inst_104687,inst_104691);
var state_104705__$1 = (function (){var statearr_104707 = state_104705;
(statearr_104707[(7)] = inst_104688__$1);

return statearr_104707;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_104705__$1,(8),inst_104692);
} else {
if((state_val_104706 === (1))){
var inst_104661 = typeof select === 'string';
var state_104705__$1 = state_104705;
if(cljs.core.truth_(inst_104661)){
var statearr_104708_104736 = state_104705__$1;
(statearr_104708_104736[(1)] = (2));

} else {
var statearr_104709_104737 = state_104705__$1;
(statearr_104709_104737[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104706 === (4))){
var inst_104670 = (state_104705[(8)]);
var inst_104666 = (state_104705[(2)]);
var inst_104667 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"from","from",1815293044),new cljs.core.Keyword(null,"where","where",-2044795965),new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"limit","limit",-1355822363)];
var inst_104668 = [inst_104666,from,where,block,limit];
var inst_104669 = cljs.core.PersistentHashMap.fromArrays(inst_104667,inst_104668);
var inst_104670__$1 = fluree.db.util.core.without_nils.call(null,inst_104669);
var inst_104671 = new cljs.core.Keyword(null,"where","where",-2044795965).cljs$core$IFn$_invoke$arity$1(inst_104670__$1);
var inst_104672 = new cljs.core.Keyword(null,"where","where",-2044795965).cljs$core$IFn$_invoke$arity$1(inst_104670__$1);
var inst_104673 = cljs.core.first.call(null,inst_104672);
var inst_104674 = fluree.db.dbfunctions.internal.str.call(null,inst_104673);
var inst_104675 = cljs.core._EQ_.call(null,"[",inst_104674);
var inst_104676 = new cljs.core.Keyword(null,"where","where",-2044795965).cljs$core$IFn$_invoke$arity$1(inst_104670__$1);
var inst_104677 = cljs.core.last.call(null,inst_104676);
var inst_104678 = fluree.db.dbfunctions.internal.str.call(null,inst_104677);
var inst_104679 = cljs.core._EQ_.call(null,"]",inst_104678);
var inst_104680 = fluree.db.dbfunctions.internal.and.call(null,inst_104671,inst_104675,inst_104679);
var state_104705__$1 = (function (){var statearr_104710 = state_104705;
(statearr_104710[(8)] = inst_104670__$1);

return statearr_104710;
})();
if(cljs.core.truth_(inst_104680)){
var statearr_104711_104738 = state_104705__$1;
(statearr_104711_104738[(1)] = (5));

} else {
var statearr_104712_104739 = state_104705__$1;
(statearr_104712_104739[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104706 === (6))){
var inst_104670 = (state_104705[(8)]);
var state_104705__$1 = state_104705;
var statearr_104713_104740 = state_104705__$1;
(statearr_104713_104740[(2)] = inst_104670);

(statearr_104713_104740[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104706 === (3))){
var state_104705__$1 = state_104705;
var statearr_104714_104741 = state_104705__$1;
(statearr_104714_104741[(2)] = select);

(statearr_104714_104741[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104706 === (2))){
var inst_104663 = fluree.db.dbfunctions.internal.parse_select_map.call(null,select);
var state_104705__$1 = state_104705;
var statearr_104715_104742 = state_104705__$1;
(statearr_104715_104742[(2)] = inst_104663);

(statearr_104715_104742[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104706 === (11))){
var inst_104703 = (state_104705[(2)]);
var state_104705__$1 = state_104705;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_104705__$1,inst_104703);
} else {
if((state_val_104706 === (9))){
var inst_104694 = (state_104705[(9)]);
var state_104705__$1 = state_104705;
var statearr_104716_104743 = state_104705__$1;
(statearr_104716_104743[(2)] = inst_104694);

(statearr_104716_104743[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104706 === (5))){
var inst_104670 = (state_104705[(8)]);
var inst_104682 = new cljs.core.Keyword(null,"where","where",-2044795965).cljs$core$IFn$_invoke$arity$1(inst_104670);
var inst_104683 = cljs.reader.read_string.call(null,inst_104682);
var inst_104684 = cljs.core.assoc.call(null,inst_104670,new cljs.core.Keyword(null,"where","where",-2044795965),inst_104683);
var state_104705__$1 = state_104705;
var statearr_104717_104744 = state_104705__$1;
(statearr_104717_104744[(2)] = inst_104684);

(statearr_104717_104744[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104706 === (10))){
var inst_104694 = (state_104705[(9)]);
var inst_104688 = (state_104705[(7)]);
var inst_104698 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104699 = cljs.core.deref.call(null,inst_104688);
var inst_104700 = [inst_104694,inst_104699];
var inst_104701 = (new cljs.core.PersistentVector(null,2,(5),inst_104698,inst_104700,null));
var state_104705__$1 = state_104705;
var statearr_104718_104745 = state_104705__$1;
(statearr_104718_104745[(2)] = inst_104701);

(statearr_104718_104745[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104706 === (8))){
var inst_104694 = (state_104705[(9)]);
var inst_104694__$1 = (state_104705[(2)]);
var inst_104695 = fluree.db.util.core.exception_QMARK_.call(null,inst_104694__$1);
var state_104705__$1 = (function (){var statearr_104719 = state_104705;
(statearr_104719[(9)] = inst_104694__$1);

return statearr_104719;
})();
if(inst_104695){
var statearr_104720_104746 = state_104705__$1;
(statearr_104720_104746[(1)] = (9));

} else {
var statearr_104721_104747 = state_104705__$1;
(statearr_104721_104747[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$dbfunctions$internal$state_machine__86625__auto__ = null;
var fluree$db$dbfunctions$internal$state_machine__86625__auto____0 = (function (){
var statearr_104722 = [null,null,null,null,null,null,null,null,null,null];
(statearr_104722[(0)] = fluree$db$dbfunctions$internal$state_machine__86625__auto__);

(statearr_104722[(1)] = (1));

return statearr_104722;
});
var fluree$db$dbfunctions$internal$state_machine__86625__auto____1 = (function (state_104705){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_104705);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e104723){if((e104723 instanceof Object)){
var ex__86628__auto__ = e104723;
var statearr_104724_104748 = state_104705;
(statearr_104724_104748[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104705);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e104723;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__104749 = state_104705;
state_104705 = G__104749;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$dbfunctions$internal$state_machine__86625__auto__ = function(state_104705){
switch(arguments.length){
case 0:
return fluree$db$dbfunctions$internal$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$dbfunctions$internal$state_machine__86625__auto____1.call(this,state_104705);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$dbfunctions$internal$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$dbfunctions$internal$state_machine__86625__auto____0;
fluree$db$dbfunctions$internal$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$dbfunctions$internal$state_machine__86625__auto____1;
return fluree$db$dbfunctions$internal$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_104725 = f__86676__auto__.call(null);
(statearr_104725[(6)] = c__86675__auto__);

return statearr_104725;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.dbfunctions.internal.query.cljs$lang$maxFixedArity = 6;

fluree.db.dbfunctions.internal.pred_reverse_ref_re = /(?:([^\/]+)\/)_([^\/]+)/;
/**
 * Reverse refs must be strings that include a '/_' in them, which characters before and after.
 */
fluree.db.dbfunctions.internal.reverse_ref_QMARK_ = (function fluree$db$dbfunctions$internal$reverse_ref_QMARK_(predicate_name){
if(typeof predicate_name === 'string'){
return fluree.db.dbfunctions.internal.boolean$.call(null,cljs.core.re_matches.call(null,fluree.db.dbfunctions.internal.pred_reverse_ref_re,predicate_name));
} else {
throw cljs.core.ex_info.call(null,fluree.db.dbfunctions.internal.str.call(null,"Bad predicate name, should be string: ",cljs.core.pr_str.call(null,predicate_name)),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-predicate","db/invalid-predicate",1598480850)], null));
}
});
fluree.db.dbfunctions.internal.unreverse_var = (function fluree$db$dbfunctions$internal$unreverse_var(var$){
var vec__104750 = clojure.string.split.call(null,var$,/\//);
var coll = cljs.core.nth.call(null,vec__104750,(0),null);
var pred = cljs.core.nth.call(null,vec__104750,(1),null);
var pred__$1 = cljs.core.subs.call(null,pred,(1));
return fluree.db.dbfunctions.internal.str.call(null,coll,"/",pred__$1);
});
fluree.db.dbfunctions.internal.build_where_single_path = (function fluree$db$dbfunctions$internal$build_where_single_path(startSubject,var$,endSubject){
var start_clause = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [startSubject,var$,"?var1"], null);
var bridge_clause = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["?var2",var$,"?var1"], null);
var end_clause = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["?var2",var$,endSubject], null);
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [start_clause,bridge_clause,end_clause], null);
});
fluree.db.dbfunctions.internal.build_where_clause = (function fluree$db$dbfunctions$internal$build_where_clause(startSubject,path,endSubject){
var G__104756 = path;
var vec__104757 = G__104756;
var seq__104758 = cljs.core.seq.call(null,vec__104757);
var first__104759 = cljs.core.first.call(null,seq__104758);
var seq__104758__$1 = cljs.core.next.call(null,seq__104758);
var var$ = first__104759;
var r = seq__104758__$1;
var n = (1);
var where_clauses = cljs.core.PersistentVector.EMPTY;
var G__104756__$1 = G__104756;
var n__$1 = n;
var where_clauses__$1 = where_clauses;
while(true){
var vec__104763 = G__104756__$1;
var seq__104764 = cljs.core.seq.call(null,vec__104763);
var first__104765 = cljs.core.first.call(null,seq__104764);
var seq__104764__$1 = cljs.core.next.call(null,seq__104764);
var var$__$1 = first__104765;
var r__$1 = seq__104764__$1;
var n__$2 = n__$1;
var where_clauses__$2 = where_clauses__$1;
if(cljs.core.truth_(fluree.db.dbfunctions.internal.and.call(null,fluree.db.dbfunctions.internal.empty_QMARK_.call(null,where_clauses__$2),fluree.db.dbfunctions.internal.nil_QMARK_.call(null,r__$1)))){
var reverse_QMARK_ = fluree.db.dbfunctions.internal.reverse_ref_QMARK_.call(null,var$__$1);
if(cljs.core.truth_(reverse_QMARK_)){
return fluree.db.dbfunctions.internal.build_where_single_path.call(null,endSubject,fluree.db.dbfunctions.internal.unreverse_var.call(null,var$__$1),startSubject);
} else {
return fluree.db.dbfunctions.internal.build_where_single_path.call(null,startSubject,var$__$1,endSubject);
}
} else {
if(cljs.core.truth_(fluree.db.dbfunctions.internal.empty_QMARK_.call(null,where_clauses__$2))){
var reverse_QMARK_ = fluree.db.dbfunctions.internal.reverse_ref_QMARK_.call(null,var$__$1);
var next_clauses = (cljs.core.truth_(reverse_QMARK_)?new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [fluree.db.dbfunctions.internal.str.call(null,"?var",n__$2),fluree.db.dbfunctions.internal.unreverse_var.call(null,var$__$1),startSubject], null)], null):new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [startSubject,var$__$1,fluree.db.dbfunctions.internal.str.call(null,"?var",n__$2)], null)], null));
var G__104766 = r__$1;
var G__104767 = n__$2;
var G__104768 = next_clauses;
G__104756__$1 = G__104766;
n__$1 = G__104767;
where_clauses__$1 = G__104768;
continue;
} else {
if(r__$1){
var next_n = (n__$2 + (1));
var reverse_QMARK_ = fluree.db.dbfunctions.internal.reverse_ref_QMARK_.call(null,var$__$1);
var next_clause = (cljs.core.truth_(reverse_QMARK_)?new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [fluree.db.dbfunctions.internal.str.call(null,"?var",next_n),fluree.db.dbfunctions.internal.unreverse_var.call(null,var$__$1),fluree.db.dbfunctions.internal.str.call(null,"?var",n__$2)], null):new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [fluree.db.dbfunctions.internal.str.call(null,"?var",n__$2),var$__$1,fluree.db.dbfunctions.internal.str.call(null,"?var",next_n)], null));
var G__104769 = r__$1;
var G__104770 = next_n;
var G__104771 = cljs.core.conj.call(null,where_clauses__$2,next_clause);
G__104756__$1 = G__104769;
n__$1 = G__104770;
where_clauses__$1 = G__104771;
continue;
} else {
var reverse_QMARK_ = fluree.db.dbfunctions.internal.reverse_ref_QMARK_.call(null,var$__$1);
var last_clause = (cljs.core.truth_(reverse_QMARK_)?new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [endSubject,fluree.db.dbfunctions.internal.unreverse_var.call(null,var$__$1),fluree.db.dbfunctions.internal.str.call(null,"?var",n__$2)], null):new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [fluree.db.dbfunctions.internal.str.call(null,"?var",n__$2),var$__$1,endSubject], null));
return cljs.core.conj.call(null,where_clauses__$2,last_clause);

}
}
}
break;
}
});
fluree.db.dbfunctions.internal.relationship_QMARK_ = (function fluree$db$dbfunctions$internal$relationship_QMARK_(db,startSubject,path,endSubject){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_104803){
var state_val_104804 = (state_104803[(1)]);
if((state_val_104804 === (7))){
var inst_104783 = (state_104803[(7)]);
var inst_104783__$1 = (state_104803[(2)]);
var inst_104784 = fluree.db.dbfunctions.internal.build_where_clause.call(null,startSubject,inst_104783__$1,endSubject);
var inst_104785 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"where","where",-2044795965)];
var inst_104786 = ["?var1",inst_104784];
var inst_104787 = cljs.core.PersistentHashMap.fromArrays(inst_104785,inst_104786);
var state_104803__$1 = (function (){var statearr_104805 = state_104803;
(statearr_104805[(8)] = inst_104787);

(statearr_104805[(7)] = inst_104783__$1);

return statearr_104805;
})();
var statearr_104806_104820 = state_104803__$1;
(statearr_104806_104820[(2)] = null);

(statearr_104806_104820[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104804 === (1))){
var state_104803__$1 = state_104803;
var statearr_104807_104821 = state_104803__$1;
(statearr_104807_104821[(2)] = null);

(statearr_104807_104821[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104804 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_104803,(3),Error,null,(2));
var inst_104776 = cljs.core.vector_QMARK_.call(null,path);
var state_104803__$1 = state_104803;
if(inst_104776){
var statearr_104808_104822 = state_104803__$1;
(statearr_104808_104822[(1)] = (5));

} else {
var statearr_104809_104823 = state_104803__$1;
(statearr_104809_104823[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104804 === (6))){
var inst_104779 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104780 = [path];
var inst_104781 = (new cljs.core.PersistentVector(null,1,(5),inst_104779,inst_104780,null));
var state_104803__$1 = state_104803;
var statearr_104810_104824 = state_104803__$1;
(statearr_104810_104824[(2)] = inst_104781);

(statearr_104810_104824[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104804 === (3))){
var inst_104772 = (state_104803[(2)]);
var state_104803__$1 = state_104803;
var statearr_104811_104825 = state_104803__$1;
(statearr_104811_104825[(2)] = inst_104772);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104803__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104804 === (2))){
var inst_104801 = (state_104803[(2)]);
var state_104803__$1 = state_104803;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_104803__$1,inst_104801);
} else {
if((state_val_104804 === (11))){
var inst_104796 = (state_104803[(2)]);
var inst_104797 = fluree.db.util.async.throw_err.call(null,inst_104796);
var state_104803__$1 = state_104803;
var statearr_104812_104826 = state_104803__$1;
(statearr_104812_104826[(2)] = inst_104797);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104803__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104804 === (9))){
var inst_104783 = (state_104803[(7)]);
var inst_104788 = (state_104803[(2)]);
var inst_104789 = fluree.db.dbfunctions.internal.function_error.call(null,inst_104788,"relationship?",startSubject,inst_104783,endSubject);
var state_104803__$1 = state_104803;
var statearr_104813_104827 = state_104803__$1;
(statearr_104813_104827[(2)] = inst_104789);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104803__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104804 === (5))){
var state_104803__$1 = state_104803;
var statearr_104814_104828 = state_104803__$1;
(statearr_104814_104828[(2)] = path);

(statearr_104814_104828[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104804 === (10))){
var inst_104787 = (state_104803[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_104803,(9),new cljs.core.Keyword(null,"default","default",-1987822328),null,(8));
var inst_104793 = cljs.core.PersistentHashMap.EMPTY;
var inst_104794 = fluree.db.dbfunctions.internal.query.call(null,db,inst_104787,inst_104793);
var state_104803__$1 = state_104803;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_104803__$1,(11),inst_104794);
} else {
if((state_val_104804 === (8))){
var inst_104799 = (state_104803[(2)]);
var state_104803__$1 = state_104803;
var statearr_104815_104829 = state_104803__$1;
(statearr_104815_104829[(2)] = inst_104799);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104803__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto__ = null;
var fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto____0 = (function (){
var statearr_104816 = [null,null,null,null,null,null,null,null,null];
(statearr_104816[(0)] = fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto__);

(statearr_104816[(1)] = (1));

return statearr_104816;
});
var fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto____1 = (function (state_104803){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_104803);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e104817){if((e104817 instanceof Object)){
var ex__86628__auto__ = e104817;
var statearr_104818_104830 = state_104803;
(statearr_104818_104830[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104803);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e104817;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__104831 = state_104803;
state_104803 = G__104831;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto__ = function(state_104803){
switch(arguments.length){
case 0:
return fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto____1.call(this,state_104803);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto____0;
fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto____1;
return fluree$db$dbfunctions$internal$relationship_QMARK__$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_104819 = f__86676__auto__.call(null);
(statearr_104819[(6)] = c__86675__auto__);

return statearr_104819;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Increments by 1. nil is treated as zero.
 */
fluree.db.dbfunctions.internal.inc = (function fluree$db$dbfunctions$internal$inc(n){
try{if(cljs.core.truth_(fluree.db.dbfunctions.internal.nil_QMARK_.call(null,n))){
return (1);
} else {
return (n + (1));
}
}catch (e104832){var e = e104832;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"inc",n);
}});
/**
 * Decrements by 1. nil is treated as zero.
 */
fluree.db.dbfunctions.internal.dec = (function fluree$db$dbfunctions$internal$dec(n){
try{if(cljs.core.truth_(fluree.db.dbfunctions.internal.nil_QMARK_.call(null,n))){
return (-1);
} else {
return (n - (1));
}
}catch (e104833){var e = e104833;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"dec",n);
}});
fluree.db.dbfunctions.internal.get = (function fluree$db$dbfunctions$internal$get(m,k){
try{var or__4131__auto__ = cljs.core.get.call(null,m,k);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.get.call(null,m,cljs.core.keyword.call(null,k));
}
}catch (e104834){var e = e104834;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"get",m,k);
}});
/**
 * Returns current epoch milliseconds.
 */
fluree.db.dbfunctions.internal.now = (function fluree$db$dbfunctions$internal$now(){
try{return fluree.db.util.core.current_time_millis.call(null);
}catch (e104835){var e = e104835;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"now");
}});
/**
 * Returns sum of all arguments in a sequence.
 */
fluree.db.dbfunctions.internal._PLUS_ = (function fluree$db$dbfunctions$internal$_PLUS_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104838 = arguments.length;
var i__4731__auto___104839 = (0);
while(true){
if((i__4731__auto___104839 < len__4730__auto___104838)){
args__4736__auto__.push((arguments[i__4731__auto___104839]));

var G__104840 = (i__4731__auto___104839 + (1));
i__4731__auto___104839 = G__104840;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal._PLUS_.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal._PLUS_.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core._PLUS_,args);
}catch (e104837){var e = e104837;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"+",args);
}});

fluree.db.dbfunctions.internal._PLUS_.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal._PLUS_.cljs$lang$applyTo = (function (seq104836){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104836));
});

/**
 * Returns difference of all the numbers in the sequence with the first number as the minuend.
 */
fluree.db.dbfunctions.internal._ = (function fluree$db$dbfunctions$internal$_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104843 = arguments.length;
var i__4731__auto___104844 = (0);
while(true){
if((i__4731__auto___104844 < len__4730__auto___104843)){
args__4736__auto__.push((arguments[i__4731__auto___104844]));

var G__104845 = (i__4731__auto___104844 + (1));
i__4731__auto___104844 = G__104845;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal._.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal._.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core._,args);
}catch (e104842){var e = e104842;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"-",args);
}});

fluree.db.dbfunctions.internal._.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal._.cljs$lang$applyTo = (function (seq104841){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104841));
});

/**
 * Returns product of all the numbers in the sequence.
 */
fluree.db.dbfunctions.internal._STAR_ = (function fluree$db$dbfunctions$internal$_STAR_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104848 = arguments.length;
var i__4731__auto___104849 = (0);
while(true){
if((i__4731__auto___104849 < len__4730__auto___104848)){
args__4736__auto__.push((arguments[i__4731__auto___104849]));

var G__104850 = (i__4731__auto___104849 + (1));
i__4731__auto___104849 = G__104850;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal._STAR_.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal._STAR_.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{if(cljs.core.truth_((function (){var or__4131__auto__ = fluree.db.dbfunctions.internal.nil_QMARK_.call(null,args);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return fluree.db.dbfunctions.internal.empty_QMARK_.call(null,args);
}
})())){
return (1);
} else {
return cljs.core.apply.call(null,cljs.core._STAR_,args);
}
}catch (e104847){var e = e104847;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"*",args);
}});

fluree.db.dbfunctions.internal._STAR_.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal._STAR_.cljs$lang$applyTo = (function (seq104846){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104846));
});

/**
 * If no denominators are supplied, returns 1/numerator, else returns numerator divided by all of the denominators. Takes a sequence
 */
fluree.db.dbfunctions.internal._SLASH_ = (function fluree$db$dbfunctions$internal$_SLASH_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104853 = arguments.length;
var i__4731__auto___104854 = (0);
while(true){
if((i__4731__auto___104854 < len__4730__auto___104853)){
args__4736__auto__.push((arguments[i__4731__auto___104854]));

var G__104855 = (i__4731__auto___104854 + (1));
i__4731__auto___104854 = G__104855;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal._SLASH_.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal._SLASH_.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{if(cljs.core.truth_(fluree.db.dbfunctions.internal.nil_QMARK_.call(null,args))){
throw cljs.core.ex_info.call(null,"Function / takes at least one argument",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-fn","db/invalid-fn",-107800799)], null));
} else {
return cljs.core.apply.call(null,cljs.core._SLASH_,args);
}
}catch (e104852){var e = e104852;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"/",args);
}});

fluree.db.dbfunctions.internal._SLASH_.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal._SLASH_.cljs$lang$applyTo = (function (seq104851){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104851));
});

/**
 * Quot[ient] of dividing numerator by denominator.
 */
fluree.db.dbfunctions.internal.quot = (function fluree$db$dbfunctions$internal$quot(n,d){
try{return cljs.core.quot.call(null,n,d);
}catch (e104856){var e = e104856;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"quot",n,d);
}});
/**
 * Modulus of num and div. Truncates toward negative infinity.
 */
fluree.db.dbfunctions.internal.mod = (function fluree$db$dbfunctions$internal$mod(n,d){
try{return cljs.core.mod.call(null,n,d);
}catch (e104857){var e = e104857;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"mod",n,d);
}});
/**
 * Remainder of dividing numerator by denominator.
 */
fluree.db.dbfunctions.internal.rem = (function fluree$db$dbfunctions$internal$rem(n,d){
try{return cljs.core.rem.call(null,n,d);
}catch (e104858){var e = e104858;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"rem",n,d);
}});
/**
 * Returns the ceiling of a number, as integer.
 */
fluree.db.dbfunctions.internal.ceil = (function fluree$db$dbfunctions$internal$ceil(num){
try{return (Math.ceil(num) | (0));
}catch (e104859){var e = e104859;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"ceil",num);
}});
/**
 * Returns the floor of a number, as integer.
 */
fluree.db.dbfunctions.internal.floor = (function fluree$db$dbfunctions$internal$floor(num){
try{return (Math.floor(num) | (0));
}catch (e104860){var e = e104860;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"floor",num);
}});
/**
 * Follows an subject down the provided path and returns a set of all matching subjects.
 */
fluree.db.dbfunctions.internal.get_all = (function fluree$db$dbfunctions$internal$get_all(start_subject,path){
try{var G__104866 = path;
var vec__104867 = G__104866;
var seq__104868 = cljs.core.seq.call(null,vec__104867);
var first__104869 = cljs.core.first.call(null,seq__104868);
var seq__104868__$1 = cljs.core.next.call(null,seq__104868);
var pred = first__104869;
var r = seq__104868__$1;
var subjects = cljs.core.PersistentHashSet.createAsIfByAssoc([start_subject]);
var G__104866__$1 = G__104866;
var subjects__$1 = subjects;
while(true){
var vec__104873 = G__104866__$1;
var seq__104874 = cljs.core.seq.call(null,vec__104873);
var first__104875 = cljs.core.first.call(null,seq__104874);
var seq__104874__$1 = cljs.core.next.call(null,seq__104874);
var pred__$1 = first__104875;
var r__$1 = seq__104874__$1;
var subjects__$2 = subjects__$1;
var next_subjects = cljs.core.reduce.call(null,((function (G__104866__$1,subjects__$1,vec__104873,seq__104874,first__104875,seq__104874__$1,pred__$1,r__$1,subjects__$2,G__104866,vec__104867,seq__104868,first__104869,seq__104868__$1,pred,r,subjects){
return (function (acc,subject){
var sub_subjects = ((cljs.core.vector_QMARK_.call(null,subject))?cljs.core.mapv.call(null,((function (G__104866__$1,subjects__$1,vec__104873,seq__104874,first__104875,seq__104874__$1,pred__$1,r__$1,subjects__$2,G__104866,vec__104867,seq__104868,first__104869,seq__104868__$1,pred,r,subjects){
return (function (p1__104861_SHARP_){
return fluree.db.dbfunctions.internal.get.call(null,p1__104861_SHARP_,pred__$1);
});})(G__104866__$1,subjects__$1,vec__104873,seq__104874,first__104875,seq__104874__$1,pred__$1,r__$1,subjects__$2,G__104866,vec__104867,seq__104868,first__104869,seq__104868__$1,pred,r,subjects))
,subject):fluree.db.dbfunctions.internal.get.call(null,subject,pred__$1));
if(((cljs.core.vector_QMARK_.call(null,sub_subjects)) || (cljs.core.set_QMARK_.call(null,sub_subjects)))){
return cljs.core.into.call(null,acc,sub_subjects);
} else {
return cljs.core.conj.call(null,acc,sub_subjects);
}
});})(G__104866__$1,subjects__$1,vec__104873,seq__104874,first__104875,seq__104874__$1,pred__$1,r__$1,subjects__$2,G__104866,vec__104867,seq__104868,first__104869,seq__104868__$1,pred,r,subjects))
,cljs.core.PersistentHashSet.EMPTY,subjects__$2);
if(cljs.core.truth_((function (){var and__4120__auto__ = r__$1;
if(and__4120__auto__){
return cljs.core.not_empty.call(null,next_subjects);
} else {
return and__4120__auto__;
}
})())){
var G__104876 = r__$1;
var G__104877 = next_subjects;
G__104866__$1 = G__104876;
subjects__$1 = G__104877;
continue;
} else {
return cljs.core.set.call(null,cljs.core.remove.call(null,fluree.db.dbfunctions.internal.nil_QMARK_,next_subjects));
}
break;
}
}catch (e104862){var e = e104862;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"get-all",start_subject,path);
}});
/**
 * Returns the value in a nested structure
 */
fluree.db.dbfunctions.internal.get_in = (function fluree$db$dbfunctions$internal$get_in(m,ks){
try{return fluree.db.dbfunctions.internal.get_all.call(null,m,ks);
}catch (e104878){var e = e104878;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"get-in",m,ks);
}});
/**
 * Returns true if key is present.
 */
fluree.db.dbfunctions.internal.contains_QMARK_ = (function fluree$db$dbfunctions$internal$contains_QMARK_(coll,key){
try{return cljs.core.contains_QMARK_.call(null,coll,key);
}catch (e104879){var e = e104879;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"contains?",coll,key);
}});
/**
 * Returns a hash-set of args.
 */
fluree.db.dbfunctions.internal.hash_set = (function fluree$db$dbfunctions$internal$hash_set(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104882 = arguments.length;
var i__4731__auto___104883 = (0);
while(true){
if((i__4731__auto___104883 < len__4730__auto___104882)){
args__4736__auto__.push((arguments[i__4731__auto___104883]));

var G__104884 = (i__4731__auto___104883 + (1));
i__4731__auto___104883 = G__104884;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal.hash_set.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal.hash_set.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core.hash_set,args);
}catch (e104881){var e = e104881;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"hash-set",args);
}});

fluree.db.dbfunctions.internal.hash_set.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal.hash_set.cljs$lang$applyTo = (function (seq104880){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104880));
});

/**
 * Returns true if key is present.
 */
fluree.db.dbfunctions.internal.nth = (function fluree$db$dbfunctions$internal$nth(coll,key){
try{var coll_SINGLEQUOTE_ = ((cljs.core.set_QMARK_.call(null,coll))?cljs.core.into.call(null,cljs.core.PersistentVector.EMPTY,coll):coll);
return cljs.core.nth.call(null,coll_SINGLEQUOTE_,key);
}catch (e104885){var e = e104885;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"nth",coll,key);
}});
/**
 * Return true if arguments in sequence equal each other.
 */
fluree.db.dbfunctions.internal._EQ__EQ_ = (function fluree$db$dbfunctions$internal$_EQ__EQ_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104888 = arguments.length;
var i__4731__auto___104889 = (0);
while(true){
if((i__4731__auto___104889 < len__4730__auto___104888)){
args__4736__auto__.push((arguments[i__4731__auto___104889]));

var G__104890 = (i__4731__auto___104889 + (1));
i__4731__auto___104889 = G__104890;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return fluree.db.dbfunctions.internal._EQ__EQ_.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

fluree.db.dbfunctions.internal._EQ__EQ_.cljs$core$IFn$_invoke$arity$variadic = (function (args){
try{return cljs.core.apply.call(null,cljs.core._EQ_,args);
}catch (e104887){var e = e104887;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"==",args);
}});

fluree.db.dbfunctions.internal._EQ__EQ_.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
fluree.db.dbfunctions.internal._EQ__EQ_.cljs$lang$applyTo = (function (seq104886){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq104886));
});

/**
 * Returns the next regex match, if any, of string to pattern, using java.util.regex.Matcher.find().  Uses re-groups to return the groups.
 */
fluree.db.dbfunctions.internal.re_find = (function fluree$db$dbfunctions$internal$re_find(pattern,string){
try{return cljs.core.re_find.call(null,cljs.core.re_pattern.call(null,pattern),string);
}catch (e104891){var e = e104891;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"re-find",pattern,string);
}});
fluree.db.dbfunctions.internal._QMARK_pO = (function fluree$db$dbfunctions$internal$_QMARK_pO(_QMARK_ctx){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_104940){
var state_val_104941 = (state_104940[(1)]);
if((state_val_104941 === (7))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_104940,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_104903 = new cljs.core.Keyword(null,"sid","sid",1815016414).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_104904 = typeof inst_104903 === 'string';
var state_104940__$1 = state_104940;
if(cljs.core.truth_(inst_104904)){
var statearr_104942_104962 = state_104940__$1;
(statearr_104942_104962[(1)] = (8));

} else {
var statearr_104943_104963 = state_104940__$1;
(statearr_104943_104963[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (1))){
var state_104940__$1 = state_104940;
var statearr_104944_104964 = state_104940__$1;
(statearr_104944_104964[(2)] = null);

(statearr_104944_104964[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (4))){
var inst_104899 = (state_104940[(2)]);
var state_104940__$1 = state_104940;
var statearr_104945_104965 = state_104940__$1;
(statearr_104945_104965[(2)] = inst_104899);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104940__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (13))){
var inst_104925 = (state_104940[(7)]);
var inst_104929 = inst_104925.o;
var state_104940__$1 = state_104940;
var statearr_104946_104966 = state_104940__$1;
(statearr_104946_104966[(2)] = inst_104929);

(statearr_104946_104966[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (6))){
var inst_104892 = (state_104940[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_104940,(5),new cljs.core.Keyword(null,"default","default",-1987822328),null,(4));
var inst_104897 = fluree.db.dbfunctions.internal.function_error.call(null,inst_104892,"?pO","Context Object");
var state_104940__$1 = state_104940;
var statearr_104947_104967 = state_104940__$1;
(statearr_104947_104967[(2)] = inst_104897);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104940__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (3))){
var inst_104892 = (state_104940[(2)]);
var state_104940__$1 = (function (){var statearr_104948 = state_104940;
(statearr_104948[(8)] = inst_104892);

return statearr_104948;
})();
var statearr_104949_104968 = state_104940__$1;
(statearr_104949_104968[(2)] = null);

(statearr_104949_104968[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (12))){
var state_104940__$1 = state_104940;
var statearr_104950_104969 = state_104940__$1;
(statearr_104950_104969[(2)] = null);

(statearr_104950_104969[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (2))){
var inst_104938 = (state_104940[(2)]);
var state_104940__$1 = state_104940;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_104940__$1,inst_104938);
} else {
if((state_val_104941 === (11))){
var inst_104925 = (state_104940[(7)]);
var inst_104921 = (state_104940[(2)]);
var inst_104922 = fluree.db.util.async.throw_err.call(null,inst_104921);
var inst_104923 = fluree.db.dbfunctions.internal.count.call(null,inst_104922);
var inst_104925__$1 = cljs.core.first.call(null,inst_104922);
var inst_104926 = (inst_104925__$1 == null);
var state_104940__$1 = (function (){var statearr_104951 = state_104940;
(statearr_104951[(9)] = inst_104923);

(statearr_104951[(7)] = inst_104925__$1);

return statearr_104951;
})();
if(cljs.core.truth_(inst_104926)){
var statearr_104952_104970 = state_104940__$1;
(statearr_104952_104970[(1)] = (12));

} else {
var statearr_104953_104971 = state_104940__$1;
(statearr_104953_104971[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (9))){
var inst_104910 = new cljs.core.Keyword(null,"db","db",993250759).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_104911 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(inst_104910);
var inst_104912 = fluree.db.dbfunctions.internal.inc.call(null,inst_104911);
var inst_104913 = cljs.core.assoc.call(null,inst_104910,new cljs.core.Keyword(null,"t","t",-1397832519),inst_104912);
var inst_104914 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104915 = new cljs.core.Keyword(null,"sid","sid",1815016414).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_104916 = new cljs.core.Keyword(null,"pid","pid",1018387698).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_104917 = [inst_104915,inst_104916];
var inst_104918 = (new cljs.core.PersistentVector(null,2,(5),inst_104914,inst_104917,null));
var inst_104919 = fluree.db.dbproto._search.call(null,inst_104913,inst_104918);
var state_104940__$1 = state_104940;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_104940__$1,(11),inst_104919);
} else {
if((state_val_104941 === (5))){
var inst_104893 = (state_104940[(2)]);
var state_104940__$1 = state_104940;
var statearr_104954_104972 = state_104940__$1;
(statearr_104954_104972[(2)] = inst_104893);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104940__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (14))){
var inst_104923 = (state_104940[(9)]);
var inst_104931 = (state_104940[(2)]);
var inst_104932 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104933 = [inst_104931,inst_104923];
var inst_104934 = (new cljs.core.PersistentVector(null,2,(5),inst_104932,inst_104933,null));
var state_104940__$1 = state_104940;
var statearr_104955_104973 = state_104940__$1;
(statearr_104955_104973[(2)] = inst_104934);

(statearr_104955_104973[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (10))){
var inst_104936 = (state_104940[(2)]);
var state_104940__$1 = state_104940;
var statearr_104956_104974 = state_104940__$1;
(statearr_104956_104974[(2)] = inst_104936);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104940__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104941 === (8))){
var inst_104906 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104907 = [null,(0)];
var inst_104908 = (new cljs.core.PersistentVector(null,2,(5),inst_104906,inst_104907,null));
var state_104940__$1 = state_104940;
var statearr_104957_104975 = state_104940__$1;
(statearr_104957_104975[(2)] = inst_104908);

(statearr_104957_104975[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto__ = null;
var fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto____0 = (function (){
var statearr_104958 = [null,null,null,null,null,null,null,null,null,null];
(statearr_104958[(0)] = fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto__);

(statearr_104958[(1)] = (1));

return statearr_104958;
});
var fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto____1 = (function (state_104940){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_104940);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e104959){if((e104959 instanceof Object)){
var ex__86628__auto__ = e104959;
var statearr_104960_104976 = state_104940;
(statearr_104960_104976[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104940);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e104959;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__104977 = state_104940;
state_104940 = G__104977;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto__ = function(state_104940){
switch(arguments.length){
case 0:
return fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto____1.call(this,state_104940);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto____0;
fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto____1;
return fluree$db$dbfunctions$internal$_QMARK_pO_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_104961 = f__86676__auto__.call(null);
(statearr_104961[(6)] = c__86675__auto__);

return statearr_104961;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.dbfunctions.internal.max_pred_val = (function fluree$db$dbfunctions$internal$max_pred_val(db,pred_name,opts){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_105023){
var state_val_105024 = (state_105023[(1)]);
if((state_val_105024 === (7))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_105023,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_104992 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"where","where",-2044795965)];
var inst_104993 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104994 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104995 = [null,pred_name,"?o"];
var inst_104996 = (new cljs.core.PersistentVector(null,3,(5),inst_104994,inst_104995,null));
var inst_104997 = [inst_104996];
var inst_104998 = (new cljs.core.PersistentVector(null,1,(5),inst_104993,inst_104997,null));
var inst_104999 = ["?o",inst_104998];
var inst_105000 = cljs.core.PersistentHashMap.fromArrays(inst_104992,inst_104999);
var inst_105001 = fluree.db.dbfunctions.internal.query.call(null,db,inst_105000,opts);
var state_105023__$1 = state_105023;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_105023__$1,(8),inst_105001);
} else {
if((state_val_105024 === (1))){
var state_105023__$1 = state_105023;
var statearr_105025_105041 = state_105023__$1;
(statearr_105025_105041[(2)] = null);

(statearr_105025_105041[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105024 === (4))){
var inst_104985 = (state_105023[(2)]);
var state_105023__$1 = state_105023;
var statearr_105026_105042 = state_105023__$1;
(statearr_105026_105042[(2)] = inst_104985);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105023__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105024 === (6))){
var inst_104978 = (state_105023[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_105023,(5),new cljs.core.Keyword(null,"default","default",-1987822328),null,(4));
var inst_104983 = fluree.db.dbfunctions.internal.function_error.call(null,inst_104978,"max-pred-val",pred_name);
var state_105023__$1 = state_105023;
var statearr_105027_105043 = state_105023__$1;
(statearr_105027_105043[(2)] = inst_104983);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105023__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105024 === (3))){
var inst_104978 = (state_105023[(2)]);
var state_105023__$1 = (function (){var statearr_105028 = state_105023;
(statearr_105028[(7)] = inst_104978);

return statearr_105028;
})();
var statearr_105029_105044 = state_105023__$1;
(statearr_105029_105044[(2)] = null);

(statearr_105029_105044[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105024 === (2))){
var inst_105021 = (state_105023[(2)]);
var state_105023__$1 = state_105023;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_105023__$1,inst_105021);
} else {
if((state_val_105024 === (11))){
var inst_105019 = (state_105023[(2)]);
var state_105023__$1 = state_105023;
var statearr_105030_105045 = state_105023__$1;
(statearr_105030_105045[(2)] = inst_105019);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105023__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105024 === (9))){
var inst_105005 = (state_105023[(8)]);
var inst_105006 = (state_105023[(9)]);
var inst_105010 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105011 = cljs.core.apply.call(null,fluree.db.dbfunctions.internal.max,inst_105005);
var inst_105012 = [inst_105011,inst_105006];
var inst_105013 = (new cljs.core.PersistentVector(null,2,(5),inst_105010,inst_105012,null));
var state_105023__$1 = state_105023;
var statearr_105031_105046 = state_105023__$1;
(statearr_105031_105046[(2)] = inst_105013);

(statearr_105031_105046[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105024 === (5))){
var inst_104979 = (state_105023[(2)]);
var state_105023__$1 = state_105023;
var statearr_105032_105047 = state_105023__$1;
(statearr_105032_105047[(2)] = inst_104979);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105023__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105024 === (10))){
var inst_105006 = (state_105023[(9)]);
var inst_105015 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105016 = [null,inst_105006];
var inst_105017 = (new cljs.core.PersistentVector(null,2,(5),inst_105015,inst_105016,null));
var state_105023__$1 = state_105023;
var statearr_105033_105048 = state_105023__$1;
(statearr_105033_105048[(2)] = inst_105017);

(statearr_105033_105048[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105024 === (8))){
var inst_105005 = (state_105023[(8)]);
var inst_105003 = (state_105023[(2)]);
var inst_105004 = fluree.db.util.async.throw_err.call(null,inst_105003);
var inst_105005__$1 = cljs.core.nth.call(null,inst_105004,(0),null);
var inst_105006 = cljs.core.nth.call(null,inst_105004,(1),null);
var inst_105007 = fluree.db.dbfunctions.internal.empty_QMARK_.call(null,inst_105005__$1);
var inst_105008 = cljs.core.not.call(null,inst_105007);
var state_105023__$1 = (function (){var statearr_105034 = state_105023;
(statearr_105034[(8)] = inst_105005__$1);

(statearr_105034[(9)] = inst_105006);

return statearr_105034;
})();
if(inst_105008){
var statearr_105035_105049 = state_105023__$1;
(statearr_105035_105049[(1)] = (9));

} else {
var statearr_105036_105050 = state_105023__$1;
(statearr_105036_105050[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto__ = null;
var fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto____0 = (function (){
var statearr_105037 = [null,null,null,null,null,null,null,null,null,null];
(statearr_105037[(0)] = fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto__);

(statearr_105037[(1)] = (1));

return statearr_105037;
});
var fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto____1 = (function (state_105023){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_105023);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e105038){if((e105038 instanceof Object)){
var ex__86628__auto__ = e105038;
var statearr_105039_105051 = state_105023;
(statearr_105039_105051[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105023);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e105038;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__105052 = state_105023;
state_105023 = G__105052;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto__ = function(state_105023){
switch(arguments.length){
case 0:
return fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto____1.call(this,state_105023);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto____0;
fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto____1;
return fluree$db$dbfunctions$internal$max_pred_val_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_105040 = f__86676__auto__.call(null);
(statearr_105040[(6)] = c__86675__auto__);

return statearr_105040;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.dbfunctions.internal.valid_email_QMARK_ = (function fluree$db$dbfunctions$internal$valid_email_QMARK_(email){
try{var pattern = /[a-z0-9!#$%&'*+\/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+\/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/;
return cljs.core.boolean$.call(null,(function (){var and__4120__auto__ = typeof email === 'string';
if(and__4120__auto__){
return cljs.core.re_matches.call(null,pattern,email);
} else {
return and__4120__auto__;
}
})());
}catch (e105053){var e = e105053;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"valid-email?",email);
}});
/**
 * Retrieves all P-O Pairs for subject, potential additional params if specified.
 */
fluree.db.dbfunctions.internal._QMARK_s = (function fluree$db$dbfunctions$internal$_QMARK_s(var_args){
var G__105055 = arguments.length;
switch (G__105055) {
case 1:
return fluree.db.dbfunctions.internal._QMARK_s.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.dbfunctions.internal._QMARK_s.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.dbfunctions.internal._QMARK_s.cljs$core$IFn$_invoke$arity$1 = (function (_QMARK_ctx){
return fluree.db.dbfunctions.internal._QMARK_s.call(null,_QMARK_ctx,null);
});

fluree.db.dbfunctions.internal._QMARK_s.cljs$core$IFn$_invoke$arity$2 = (function (_QMARK_ctx,additional_params){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_105119){
var state_val_105120 = (state_105119[(1)]);
if((state_val_105120 === (7))){
var inst_105067 = (state_105119[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_105119,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_105067__$1 = new cljs.core.Keyword(null,"s","s",1705939918).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var state_105119__$1 = (function (){var statearr_105121 = state_105119;
(statearr_105121[(7)] = inst_105067__$1);

return statearr_105121;
})();
if(cljs.core.truth_(inst_105067__$1)){
var statearr_105122_105152 = state_105119__$1;
(statearr_105122_105152[(1)] = (8));

} else {
var statearr_105123_105153 = state_105119__$1;
(statearr_105123_105153[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (20))){
var inst_105107 = (state_105119[(2)]);
var inst_105108 = fluree.db.util.async.throw_err.call(null,inst_105107);
var inst_105109 = cljs.core.nth.call(null,inst_105108,(0),null);
var inst_105110 = cljs.core.nth.call(null,inst_105108,(1),null);
var inst_105111 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105112 = [inst_105109,inst_105110];
var inst_105113 = (new cljs.core.PersistentVector(null,2,(5),inst_105111,inst_105112,null));
var state_105119__$1 = state_105119;
var statearr_105124_105154 = state_105119__$1;
(statearr_105124_105154[(2)] = inst_105113);

(statearr_105124_105154[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (1))){
var state_105119__$1 = state_105119;
var statearr_105125_105155 = state_105119__$1;
(statearr_105125_105155[(2)] = null);

(statearr_105125_105155[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (4))){
var inst_105063 = (state_105119[(2)]);
var state_105119__$1 = state_105119;
var statearr_105126_105156 = state_105119__$1;
(statearr_105126_105156[(2)] = inst_105063);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105119__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (15))){
var inst_105083 = new cljs.core.Keyword(null,"s","s",1705939918).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_105084 = fluree.db.dbfunctions.internal.get.call(null,inst_105083,new cljs.core.Keyword(null,"_id","_id",-789960287));
var state_105119__$1 = state_105119;
var statearr_105127_105157 = state_105119__$1;
(statearr_105127_105157[(2)] = inst_105084);

(statearr_105127_105157[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (13))){
var inst_105115 = (state_105119[(2)]);
var state_105119__$1 = state_105119;
var statearr_105128_105158 = state_105119__$1;
(statearr_105128_105158[(2)] = inst_105115);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105119__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (6))){
var inst_105056 = (state_105119[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_105119,(5),new cljs.core.Keyword(null,"default","default",-1987822328),null,(4));
var inst_105061 = fluree.db.dbfunctions.internal.function_error.call(null,inst_105056,"?s","Context Object",additional_params);
var state_105119__$1 = state_105119;
var statearr_105129_105159 = state_105119__$1;
(statearr_105129_105159[(2)] = inst_105061);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105119__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (17))){
var inst_105088 = cljs.core.PersistentVector.EMPTY;
var inst_105089 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105090 = ["*"];
var inst_105091 = (new cljs.core.PersistentVector(null,1,(5),inst_105089,inst_105090,null));
var inst_105092 = fluree.db.dbfunctions.internal.parse_select_map.call(null,additional_params);
var inst_105093 = cljs.core.concat.call(null,inst_105091,inst_105092);
var inst_105094 = cljs.core.into.call(null,inst_105088,inst_105093);
var state_105119__$1 = state_105119;
var statearr_105130_105160 = state_105119__$1;
(statearr_105130_105160[(2)] = inst_105094);

(statearr_105130_105160[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (3))){
var inst_105056 = (state_105119[(2)]);
var state_105119__$1 = (function (){var statearr_105131 = state_105119;
(statearr_105131[(8)] = inst_105056);

return statearr_105131;
})();
var statearr_105132_105161 = state_105119__$1;
(statearr_105132_105161[(2)] = null);

(statearr_105132_105161[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (12))){
var inst_105080 = (state_105119[(9)]);
var inst_105079 = new cljs.core.Keyword(null,"db","db",993250759).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_105080__$1 = new cljs.core.Keyword(null,"sid","sid",1815016414).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var state_105119__$1 = (function (){var statearr_105133 = state_105119;
(statearr_105133[(9)] = inst_105080__$1);

(statearr_105133[(10)] = inst_105079);

return statearr_105133;
})();
if(cljs.core.truth_(inst_105080__$1)){
var statearr_105134_105162 = state_105119__$1;
(statearr_105134_105162[(1)] = (14));

} else {
var statearr_105135_105163 = state_105119__$1;
(statearr_105135_105163[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (2))){
var inst_105117 = (state_105119[(2)]);
var state_105119__$1 = state_105119;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_105119__$1,inst_105117);
} else {
if((state_val_105120 === (19))){
var inst_105086 = (state_105119[(11)]);
var inst_105079 = (state_105119[(10)]);
var inst_105100 = (state_105119[(2)]);
var inst_105101 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"from","from",1815293044)];
var inst_105102 = [inst_105100,inst_105086];
var inst_105103 = cljs.core.PersistentHashMap.fromArrays(inst_105101,inst_105102);
var inst_105104 = cljs.core.PersistentHashMap.EMPTY;
var inst_105105 = fluree.db.dbfunctions.internal.query.call(null,inst_105079,inst_105103,inst_105104);
var state_105119__$1 = state_105119;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_105119__$1,(20),inst_105105);
} else {
if((state_val_105120 === (11))){
var inst_105074 = new cljs.core.Keyword(null,"s","s",1705939918).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var state_105119__$1 = state_105119;
var statearr_105136_105164 = state_105119__$1;
(statearr_105136_105164[(2)] = inst_105074);

(statearr_105136_105164[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (9))){
var inst_105067 = (state_105119[(7)]);
var state_105119__$1 = state_105119;
var statearr_105137_105165 = state_105119__$1;
(statearr_105137_105165[(2)] = inst_105067);

(statearr_105137_105165[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (5))){
var inst_105057 = (state_105119[(2)]);
var state_105119__$1 = state_105119;
var statearr_105138_105166 = state_105119__$1;
(statearr_105138_105166[(2)] = inst_105057);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105119__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (14))){
var inst_105080 = (state_105119[(9)]);
var state_105119__$1 = state_105119;
var statearr_105139_105167 = state_105119__$1;
(statearr_105139_105167[(2)] = inst_105080);

(statearr_105139_105167[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (16))){
var inst_105086 = (state_105119[(2)]);
var state_105119__$1 = (function (){var statearr_105140 = state_105119;
(statearr_105140[(11)] = inst_105086);

return statearr_105140;
})();
if(cljs.core.truth_(additional_params)){
var statearr_105141_105168 = state_105119__$1;
(statearr_105141_105168[(1)] = (17));

} else {
var statearr_105142_105169 = state_105119__$1;
(statearr_105142_105169[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (10))){
var inst_105072 = (state_105119[(2)]);
var state_105119__$1 = state_105119;
if(cljs.core.truth_(inst_105072)){
var statearr_105143_105170 = state_105119__$1;
(statearr_105143_105170[(1)] = (11));

} else {
var statearr_105144_105171 = state_105119__$1;
(statearr_105144_105171[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (18))){
var inst_105096 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105097 = ["*"];
var inst_105098 = (new cljs.core.PersistentVector(null,1,(5),inst_105096,inst_105097,null));
var state_105119__$1 = state_105119;
var statearr_105145_105172 = state_105119__$1;
(statearr_105145_105172[(2)] = inst_105098);

(statearr_105145_105172[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105120 === (8))){
var inst_105069 = fluree.db.dbfunctions.internal.empty_QMARK_.call(null,additional_params);
var state_105119__$1 = state_105119;
var statearr_105146_105173 = state_105119__$1;
(statearr_105146_105173[(2)] = inst_105069);

(statearr_105146_105173[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$dbfunctions$internal$state_machine__86625__auto__ = null;
var fluree$db$dbfunctions$internal$state_machine__86625__auto____0 = (function (){
var statearr_105147 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_105147[(0)] = fluree$db$dbfunctions$internal$state_machine__86625__auto__);

(statearr_105147[(1)] = (1));

return statearr_105147;
});
var fluree$db$dbfunctions$internal$state_machine__86625__auto____1 = (function (state_105119){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_105119);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e105148){if((e105148 instanceof Object)){
var ex__86628__auto__ = e105148;
var statearr_105149_105174 = state_105119;
(statearr_105149_105174[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105119);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e105148;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__105175 = state_105119;
state_105119 = G__105175;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$dbfunctions$internal$state_machine__86625__auto__ = function(state_105119){
switch(arguments.length){
case 0:
return fluree$db$dbfunctions$internal$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$dbfunctions$internal$state_machine__86625__auto____1.call(this,state_105119);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$dbfunctions$internal$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$dbfunctions$internal$state_machine__86625__auto____0;
fluree$db$dbfunctions$internal$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$dbfunctions$internal$state_machine__86625__auto____1;
return fluree$db$dbfunctions$internal$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_105150 = f__86676__auto__.call(null);
(statearr_105150[(6)] = c__86675__auto__);

return statearr_105150;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.dbfunctions.internal._QMARK_s.cljs$lang$maxFixedArity = 2;

/**
 * Retrieves all P-O Pairs for predicate, potential additional params if specified
 */
fluree.db.dbfunctions.internal._QMARK_p = (function fluree$db$dbfunctions$internal$_QMARK_p(var_args){
var G__105177 = arguments.length;
switch (G__105177) {
case 1:
return fluree.db.dbfunctions.internal._QMARK_p.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.dbfunctions.internal._QMARK_p.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.dbfunctions.internal._QMARK_p.cljs$core$IFn$_invoke$arity$1 = (function (_QMARK_ctx){
return fluree.db.dbfunctions.internal._QMARK_p.call(null,_QMARK_ctx,null);
});

fluree.db.dbfunctions.internal._QMARK_p.cljs$core$IFn$_invoke$arity$2 = (function (_QMARK_ctx,additional_params){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_105218){
var state_val_105219 = (state_105218[(1)]);
if((state_val_105219 === (1))){
var state_105218__$1 = state_105218;
var statearr_105220_105233 = state_105218__$1;
(statearr_105220_105233[(2)] = null);

(statearr_105220_105233[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105219 === (2))){
var inst_105216 = (state_105218[(2)]);
var state_105218__$1 = state_105218;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_105218__$1,inst_105216);
} else {
if((state_val_105219 === (3))){
var inst_105178 = (state_105218[(2)]);
var inst_105179 = fluree.db.dbfunctions.internal.function_error.call(null,inst_105178,"?p","Context Object",additional_params);
var state_105218__$1 = state_105218;
var statearr_105221_105234 = state_105218__$1;
(statearr_105221_105234[(2)] = inst_105179);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105218__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105219 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_105218,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_105186 = new cljs.core.Keyword(null,"db","db",993250759).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_105187 = new cljs.core.Keyword(null,"pid","pid",1018387698).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var state_105218__$1 = (function (){var statearr_105222 = state_105218;
(statearr_105222[(7)] = inst_105187);

(statearr_105222[(8)] = inst_105186);

return statearr_105222;
})();
if(cljs.core.truth_(additional_params)){
var statearr_105223_105235 = state_105218__$1;
(statearr_105223_105235[(1)] = (5));

} else {
var statearr_105224_105236 = state_105218__$1;
(statearr_105224_105236[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105219 === (5))){
var inst_105189 = cljs.core.PersistentVector.EMPTY;
var inst_105190 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105191 = ["*"];
var inst_105192 = (new cljs.core.PersistentVector(null,1,(5),inst_105190,inst_105191,null));
var inst_105193 = fluree.db.dbfunctions.internal.parse_select_map.call(null,additional_params);
var inst_105194 = cljs.core.concat.call(null,inst_105192,inst_105193);
var inst_105195 = cljs.core.into.call(null,inst_105189,inst_105194);
var state_105218__$1 = state_105218;
var statearr_105225_105237 = state_105218__$1;
(statearr_105225_105237[(2)] = inst_105195);

(statearr_105225_105237[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105219 === (6))){
var inst_105197 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105198 = ["*"];
var inst_105199 = (new cljs.core.PersistentVector(null,1,(5),inst_105197,inst_105198,null));
var state_105218__$1 = state_105218;
var statearr_105226_105238 = state_105218__$1;
(statearr_105226_105238[(2)] = inst_105199);

(statearr_105226_105238[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105219 === (7))){
var inst_105187 = (state_105218[(7)]);
var inst_105186 = (state_105218[(8)]);
var inst_105201 = (state_105218[(2)]);
var inst_105202 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"from","from",1815293044)];
var inst_105203 = [inst_105201,inst_105187];
var inst_105204 = cljs.core.PersistentHashMap.fromArrays(inst_105202,inst_105203);
var inst_105205 = cljs.core.PersistentHashMap.EMPTY;
var inst_105206 = fluree.db.dbfunctions.internal.query.call(null,inst_105186,inst_105204,inst_105205);
var state_105218__$1 = state_105218;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_105218__$1,(8),inst_105206);
} else {
if((state_val_105219 === (8))){
var inst_105208 = (state_105218[(2)]);
var inst_105209 = fluree.db.util.async.throw_err.call(null,inst_105208);
var inst_105210 = cljs.core.nth.call(null,inst_105209,(0),null);
var inst_105211 = cljs.core.nth.call(null,inst_105209,(1),null);
var inst_105212 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105213 = [inst_105210,inst_105211];
var inst_105214 = (new cljs.core.PersistentVector(null,2,(5),inst_105212,inst_105213,null));
var state_105218__$1 = state_105218;
var statearr_105227_105239 = state_105218__$1;
(statearr_105227_105239[(2)] = inst_105214);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105218__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$dbfunctions$internal$state_machine__86625__auto__ = null;
var fluree$db$dbfunctions$internal$state_machine__86625__auto____0 = (function (){
var statearr_105228 = [null,null,null,null,null,null,null,null,null];
(statearr_105228[(0)] = fluree$db$dbfunctions$internal$state_machine__86625__auto__);

(statearr_105228[(1)] = (1));

return statearr_105228;
});
var fluree$db$dbfunctions$internal$state_machine__86625__auto____1 = (function (state_105218){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_105218);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e105229){if((e105229 instanceof Object)){
var ex__86628__auto__ = e105229;
var statearr_105230_105240 = state_105218;
(statearr_105230_105240[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105218);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e105229;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__105241 = state_105218;
state_105218 = G__105241;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$dbfunctions$internal$state_machine__86625__auto__ = function(state_105218){
switch(arguments.length){
case 0:
return fluree$db$dbfunctions$internal$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$dbfunctions$internal$state_machine__86625__auto____1.call(this,state_105218);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$dbfunctions$internal$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$dbfunctions$internal$state_machine__86625__auto____0;
fluree$db$dbfunctions$internal$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$dbfunctions$internal$state_machine__86625__auto____1;
return fluree$db$dbfunctions$internal$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_105231 = f__86676__auto__.call(null);
(statearr_105231[(6)] = c__86675__auto__);

return statearr_105231;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.dbfunctions.internal._QMARK_p.cljs$lang$maxFixedArity = 2;

fluree.db.dbfunctions.internal._QMARK_user_id_from_auth = (function fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth(_QMARK_ctx){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_105282){
var state_val_105283 = (state_105282[(1)]);
if((state_val_105283 === (1))){
var state_105282__$1 = state_105282;
var statearr_105284_105291 = state_105282__$1;
(statearr_105284_105291[(2)] = null);

(statearr_105284_105291[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105283 === (2))){
var inst_105280 = (state_105282[(2)]);
var state_105282__$1 = state_105282;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_105282__$1,inst_105280);
} else {
if((state_val_105283 === (3))){
var inst_105242 = (state_105282[(2)]);
var inst_105243 = fluree.db.dbfunctions.internal.function_error.call(null,inst_105242,"?user_id-from-auth","Context Object");
var state_105282__$1 = state_105282;
var statearr_105285_105292 = state_105282__$1;
(statearr_105285_105292[(2)] = inst_105243);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105282__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105283 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_105282,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_105250 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"from","from",1815293044)];
var inst_105251 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105252 = ["_user/_auth"];
var inst_105253 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105254 = ["*"];
var inst_105255 = (new cljs.core.PersistentVector(null,1,(5),inst_105253,inst_105254,null));
var inst_105256 = [inst_105255];
var inst_105257 = cljs.core.PersistentHashMap.fromArrays(inst_105252,inst_105256);
var inst_105258 = [inst_105257];
var inst_105259 = (new cljs.core.PersistentVector(null,1,(5),inst_105251,inst_105258,null));
var inst_105260 = new cljs.core.Keyword(null,"auth_id","auth_id",1917762333).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_105261 = [inst_105259,inst_105260];
var inst_105262 = cljs.core.PersistentHashMap.fromArrays(inst_105250,inst_105261);
var inst_105263 = new cljs.core.Keyword(null,"db","db",993250759).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_105264 = cljs.core.PersistentHashMap.EMPTY;
var inst_105265 = fluree.db.dbfunctions.internal.query.call(null,inst_105263,inst_105262,inst_105264);
var state_105282__$1 = state_105282;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_105282__$1,(5),inst_105265);
} else {
if((state_val_105283 === (5))){
var inst_105267 = (state_105282[(2)]);
var inst_105268 = fluree.db.util.async.throw_err.call(null,inst_105267);
var inst_105269 = cljs.core.nth.call(null,inst_105268,(0),null);
var inst_105270 = cljs.core.nth.call(null,inst_105268,(1),null);
var inst_105271 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105272 = ["_user/_auth","_id"];
var inst_105273 = (new cljs.core.PersistentVector(null,2,(5),inst_105271,inst_105272,null));
var inst_105274 = fluree.db.dbfunctions.internal.get_in.call(null,inst_105269,inst_105273);
var inst_105275 = cljs.core.first.call(null,inst_105274);
var inst_105276 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105277 = [inst_105275,inst_105270];
var inst_105278 = (new cljs.core.PersistentVector(null,2,(5),inst_105276,inst_105277,null));
var state_105282__$1 = state_105282;
var statearr_105286_105293 = state_105282__$1;
(statearr_105286_105293[(2)] = inst_105278);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105282__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto__ = null;
var fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto____0 = (function (){
var statearr_105287 = [null,null,null,null,null,null,null];
(statearr_105287[(0)] = fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto__);

(statearr_105287[(1)] = (1));

return statearr_105287;
});
var fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto____1 = (function (state_105282){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_105282);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e105288){if((e105288 instanceof Object)){
var ex__86628__auto__ = e105288;
var statearr_105289_105294 = state_105282;
(statearr_105289_105294[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105282);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e105288;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__105295 = state_105282;
state_105282 = G__105295;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto__ = function(state_105282){
switch(arguments.length){
case 0:
return fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto____1.call(this,state_105282);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto____0;
fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto____1;
return fluree$db$dbfunctions$internal$_QMARK_user_id_from_auth_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_105290 = f__86676__auto__.call(null);
(statearr_105290[(6)] = c__86675__auto__);

return statearr_105290;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.dbfunctions.internal._QMARK_auth_id = (function fluree$db$dbfunctions$internal$_QMARK_auth_id(_QMARK_ctx){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_105309){
var state_val_105310 = (state_105309[(1)]);
if((state_val_105310 === (1))){
var state_105309__$1 = state_105309;
var statearr_105311_105318 = state_105309__$1;
(statearr_105311_105318[(2)] = null);

(statearr_105311_105318[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105310 === (2))){
var inst_105307 = (state_105309[(2)]);
var state_105309__$1 = state_105309;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_105309__$1,inst_105307);
} else {
if((state_val_105310 === (3))){
var inst_105296 = (state_105309[(2)]);
var state_105309__$1 = state_105309;
var statearr_105312_105319 = state_105309__$1;
(statearr_105312_105319[(2)] = inst_105296);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105309__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_105310 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_105309,(3),Error,null,(2));
var inst_105300 = new cljs.core.Keyword(null,"auth_id","auth_id",1917762333).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_105301 = new cljs.core.Keyword(null,"db","db",993250759).cljs$core$IFn$_invoke$arity$1(_QMARK_ctx);
var inst_105302 = fluree.db.dbproto._subid.call(null,inst_105301,inst_105300);
var state_105309__$1 = state_105309;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_105309__$1,(5),inst_105302);
} else {
if((state_val_105310 === (5))){
var inst_105304 = (state_105309[(2)]);
var inst_105305 = fluree.db.util.async.throw_err.call(null,inst_105304);
var state_105309__$1 = state_105309;
var statearr_105313_105320 = state_105309__$1;
(statearr_105313_105320[(2)] = inst_105305);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105309__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto__ = null;
var fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto____0 = (function (){
var statearr_105314 = [null,null,null,null,null,null,null];
(statearr_105314[(0)] = fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto__);

(statearr_105314[(1)] = (1));

return statearr_105314;
});
var fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto____1 = (function (state_105309){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_105309);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e105315){if((e105315 instanceof Object)){
var ex__86628__auto__ = e105315;
var statearr_105316_105321 = state_105309;
(statearr_105316_105321[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_105309);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e105315;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__105322 = state_105309;
state_105309 = G__105322;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto__ = function(state_105309){
switch(arguments.length){
case 0:
return fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto____1.call(this,state_105309);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto____0;
fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto____1;
return fluree$db$dbfunctions$internal$_QMARK_auth_id_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_105317 = f__86676__auto__.call(null);
(statearr_105317[(6)] = c__86675__auto__);

return statearr_105317;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Given an array of flakes, returns the sum of the objects of the true flakes
 */
fluree.db.dbfunctions.internal.objT = (function fluree$db$dbfunctions$internal$objT(flakes){
try{var trueF = cljs.core.filterv.call(null,(function (p1__105323_SHARP_){
return p1__105323_SHARP_.op === true;
}),flakes);
var objs = cljs.core.map.call(null,((function (trueF){
return (function (p1__105324_SHARP_){
return p1__105324_SHARP_.o;
});})(trueF))
,trueF);
var sum = cljs.core.reduce.call(null,cljs.core._PLUS_,objs);
return sum;
}catch (e105325){var e = e105325;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"objT",flakes);
}});
/**
 * Given an array of flakes, returns the sum of the objects of the false flakes
 */
fluree.db.dbfunctions.internal.objF = (function fluree$db$dbfunctions$internal$objF(flakes){
try{var falseF = cljs.core.filterv.call(null,(function (p1__105326_SHARP_){
return p1__105326_SHARP_.op === false;
}),flakes);
var objs = cljs.core.map.call(null,((function (falseF){
return (function (p1__105327_SHARP_){
return p1__105327_SHARP_.o;
});})(falseF))
,falseF);
var sum = cljs.core.reduce.call(null,cljs.core._PLUS_,objs);
return sum;
}catch (e105328){var e = e105328;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"objF",flakes);
}});
fluree.db.dbfunctions.internal.rand = (function fluree$db$dbfunctions$internal$rand(instant,max_SINGLEQUOTE_){
try{var base = (new java.util.Random(instant)).nextDouble();
var num = (Math.floor(fluree.db.dbfunctions.internal._STAR_.call(null,base,max_SINGLEQUOTE_)) | (0));
return num;
}catch (e105329){var e = e105329;
return fluree.db.dbfunctions.internal.function_error.call(null,e,"rand",instant,max_SINGLEQUOTE_);
}});
