// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.index');
goog.require('cljs.core');
goog.require('clojure.data.avl');
goog.require('fluree.db.dbproto');
goog.require('cljs.core.async');
goog.require('fluree.db.util.async');
goog.require('fluree.db.util.log');

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.IndexConfig = (function (index_type,comparator,historyComparator,__meta,__extmap,__hash){
this.index_type = index_type;
this.comparator = comparator;
this.historyComparator = historyComparator;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.index.IndexConfig.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.index.IndexConfig.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k91670,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__91674 = k91670;
var G__91674__$1 = (((G__91674 instanceof cljs.core.Keyword))?G__91674.fqn:null);
switch (G__91674__$1) {
case "index-type":
return self__.index_type;

break;
case "comparator":
return self__.comparator;

break;
case "historyComparator":
return self__.historyComparator;

break;
default:
return cljs.core.get.call(null,self__.__extmap,k91670,else__4388__auto__);

}
});

fluree.db.index.IndexConfig.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.call(null,((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__91675){
var vec__91676 = p__91675;
var k__4408__auto__ = cljs.core.nth.call(null,vec__91676,(0),null);
var v__4409__auto__ = cljs.core.nth.call(null,vec__91676,(1),null);
return f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__);
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.index.IndexConfig.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.index.IndexConfig{",", ","}",opts__4401__auto__,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"index-type","index-type",500383962),self__.index_type],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"comparator","comparator",2144896662),self__.comparator],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),self__.historyComparator],null))], null),self__.__extmap));
});

fluree.db.index.IndexConfig.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__91669){
var self__ = this;
var G__91669__$1 = this;
return (new cljs.core.RecordIter((0),G__91669__$1,3,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"index-type","index-type",500383962),new cljs.core.Keyword(null,"comparator","comparator",2144896662),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
});

fluree.db.index.IndexConfig.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.index.IndexConfig.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.index.IndexConfig.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (3 + cljs.core.count.call(null,self__.__extmap));
});

fluree.db.index.IndexConfig.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (1512230614 ^ cljs.core.hash_unordered_coll.call(null,coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
.call(null,this__4381__auto____$1);
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.index.IndexConfig.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this91671,other91672){
var self__ = this;
var this91671__$1 = this;
return (((!((other91672 == null)))) && ((this91671__$1.constructor === other91672.constructor)) && (cljs.core._EQ_.call(null,this91671__$1.index_type,other91672.index_type)) && (cljs.core._EQ_.call(null,this91671__$1.comparator,other91672.comparator)) && (cljs.core._EQ_.call(null,this91671__$1.historyComparator,other91672.historyComparator)) && (cljs.core._EQ_.call(null,this91671__$1.__extmap,other91672.__extmap)));
});

fluree.db.index.IndexConfig.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),null,new cljs.core.Keyword(null,"comparator","comparator",2144896662),null,new cljs.core.Keyword(null,"index-type","index-type",500383962),null], null), null),k__4395__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.index.IndexConfig.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__91669){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__91679 = cljs.core.keyword_identical_QMARK_;
var expr__91680 = k__4393__auto__;
if(cljs.core.truth_(pred__91679.call(null,new cljs.core.Keyword(null,"index-type","index-type",500383962),expr__91680))){
return (new fluree.db.index.IndexConfig(G__91669,self__.comparator,self__.historyComparator,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91679.call(null,new cljs.core.Keyword(null,"comparator","comparator",2144896662),expr__91680))){
return (new fluree.db.index.IndexConfig(self__.index_type,G__91669,self__.historyComparator,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91679.call(null,new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),expr__91680))){
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,G__91669,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4393__auto__,G__91669),null));
}
}
}
});

fluree.db.index.IndexConfig.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"index-type","index-type",500383962),self__.index_type,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"comparator","comparator",2144896662),self__.comparator,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),self__.historyComparator,null))], null),self__.__extmap));
});

fluree.db.index.IndexConfig.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__91669){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,G__91669,self__.__extmap,self__.__hash));
});

fluree.db.index.IndexConfig.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4391__auto__,(0)),cljs.core._nth.call(null,entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.index.IndexConfig.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"index-type","index-type",2140915489,null),new cljs.core.Symbol(null,"comparator","comparator",-509539107,null),new cljs.core.Symbol(null,"historyComparator","historyComparator",236913869,null)], null);
});

fluree.db.index.IndexConfig.cljs$lang$type = true;

fluree.db.index.IndexConfig.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.index/IndexConfig",null,(1),null));
});

fluree.db.index.IndexConfig.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write.call(null,writer__4429__auto__,"fluree.db.index/IndexConfig");
});

/**
 * Positional factory function for fluree.db.index/IndexConfig.
 */
fluree.db.index.__GT_IndexConfig = (function fluree$db$index$__GT_IndexConfig(index_type,comparator,historyComparator){
return (new fluree.db.index.IndexConfig(index_type,comparator,historyComparator,null,null,null));
});

/**
 * Factory function for fluree.db.index/IndexConfig, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_IndexConfig = (function fluree$db$index$map__GT_IndexConfig(G__91673){
var extmap__4424__auto__ = (function (){var G__91682 = cljs.core.dissoc.call(null,G__91673,new cljs.core.Keyword(null,"index-type","index-type",500383962),new cljs.core.Keyword(null,"comparator","comparator",2144896662),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658));
if(cljs.core.record_QMARK_.call(null,G__91673)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__91682);
} else {
return G__91682;
}
})();
return (new fluree.db.index.IndexConfig(new cljs.core.Keyword(null,"index-type","index-type",500383962).cljs$core$IFn$_invoke$arity$1(G__91673),new cljs.core.Keyword(null,"comparator","comparator",2144896662).cljs$core$IFn$_invoke$arity$1(G__91673),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658).cljs$core$IFn$_invoke$arity$1(G__91673),null,cljs.core.not_empty.call(null,extmap__4424__auto__),null));
});


/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {fluree.db.dbproto.INode}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.IndexNode = (function (block,t,rhs,children,config,leftmost_QMARK_,__meta,__extmap,__hash){
this.block = block;
this.t = t;
this.rhs = rhs;
this.children = children;
this.config = config;
this.leftmost_QMARK_ = leftmost_QMARK_;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.index.IndexNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.index.IndexNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k91685,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__91689 = k91685;
var G__91689__$1 = (((G__91689 instanceof cljs.core.Keyword))?G__91689.fqn:null);
switch (G__91689__$1) {
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "rhs":
return self__.rhs;

break;
case "children":
return self__.children;

break;
case "config":
return self__.config;

break;
case "leftmost?":
return self__.leftmost_QMARK_;

break;
default:
return cljs.core.get.call(null,self__.__extmap,k91685,else__4388__auto__);

}
});

fluree.db.index.IndexNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.call(null,((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__91690){
var vec__91691 = p__91690;
var k__4408__auto__ = cljs.core.nth.call(null,vec__91691,(0),null);
var v__4409__auto__ = cljs.core.nth.call(null,vec__91691,(1),null);
return f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__);
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.index.IndexNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.index.IndexNode{",", ","}",opts__4401__auto__,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"block","block",664686210),self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"t","t",-1397832519),self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"children","children",-940561982),self__.children],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"config","config",994861415),self__.config],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),self__.leftmost_QMARK_],null))], null),self__.__extmap));
});

fluree.db.index.IndexNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__91684){
var self__ = this;
var G__91684__$1 = this;
return (new cljs.core.RecordIter((0),G__91684__$1,6,new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,this$__$1){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,this$__$1){
return (function (state_91695){
var state_val_91696 = (state_91695[(1)]);
if((state_val_91696 === (1))){
var state_91695__$1 = state_91695;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_91695__$1,this$__$1);
} else {
return null;
}
});})(c__86675__auto__,this$__$1))
;
return ((function (switch__86624__auto__,c__86675__auto__,this$__$1){
return (function() {
var fluree$db$index$state_machine__86625__auto__ = null;
var fluree$db$index$state_machine__86625__auto____0 = (function (){
var statearr_91697 = [null,null,null,null,null,null,null];
(statearr_91697[(0)] = fluree$db$index$state_machine__86625__auto__);

(statearr_91697[(1)] = (1));

return statearr_91697;
});
var fluree$db$index$state_machine__86625__auto____1 = (function (state_91695){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_91695);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e91698){if((e91698 instanceof Object)){
var ex__86628__auto__ = e91698;
var statearr_91699_91776 = state_91695;
(statearr_91699_91776[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91695);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e91698;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__91777 = state_91695;
state_91695 = G__91777;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$index$state_machine__86625__auto__ = function(state_91695){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__86625__auto____1.call(this,state_91695);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__86625__auto____0;
fluree$db$index$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__86625__auto____1;
return fluree$db$index$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,this$__$1))
})();
var state__86677__auto__ = (function (){var statearr_91700 = f__86676__auto__.call(null);
(statearr_91700[(6)] = c__86675__auto__);

return statearr_91700;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,this$__$1))
);

return c__86675__auto__;
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.key.call(null,cljs.core.first.call(null,self__.children));
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
});

fluree.db.index.IndexNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.index.IndexNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.index.IndexNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (6 + cljs.core.count.call(null,self__.__extmap));
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
return cljs.core.val.call(null,(function (){var or__4131__auto__ = clojure.data.avl.nearest.call(null,self__.children,cljs.core._LT__EQ_,flake);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.first.call(null,self__.children);
}
})());
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_after$arity$2 = (function (_,flake){
var self__ = this;
var ___$1 = this;
return cljs.core.val.call(null,(function (){var or__4131__auto__ = clojure.data.avl.nearest.call(null,self__.children,cljs.core._GT_,flake);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.last.call(null,self__.children);
}
})());
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_leaf$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,this$__$1){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,this$__$1){
return (function (state_91722){
var state_val_91723 = (state_91722[(1)]);
if((state_val_91723 === (7))){
var inst_91718 = (state_91722[(2)]);
var state_91722__$1 = state_91722;
var statearr_91724_91778 = state_91722__$1;
(statearr_91724_91778[(2)] = inst_91718);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91722__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91723 === (1))){
var state_91722__$1 = state_91722;
var statearr_91725_91779 = state_91722__$1;
(statearr_91725_91779[(2)] = null);

(statearr_91725_91779[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91723 === (4))){
var inst_91705 = (state_91722[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_91722,(3),Error,null,(2));
var inst_91705__$1 = fluree.db.dbproto._lookup.call(null,this$__$1,flake);
var inst_91706 = new cljs.core.Keyword(null,"leaf","leaf",1306118732).cljs$core$IFn$_invoke$arity$1(inst_91705__$1);
var state_91722__$1 = (function (){var statearr_91726 = state_91722;
(statearr_91726[(7)] = inst_91705__$1);

return statearr_91726;
})();
if(cljs.core.truth_(inst_91706)){
var statearr_91727_91780 = state_91722__$1;
(statearr_91727_91780[(1)] = (5));

} else {
var statearr_91728_91781 = state_91722__$1;
(statearr_91728_91781[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91723 === (6))){
var inst_91705 = (state_91722[(7)]);
var inst_91709 = fluree.db.dbproto._resolve.call(null,inst_91705);
var state_91722__$1 = state_91722;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_91722__$1,(9),inst_91709);
} else {
if((state_val_91723 === (3))){
var inst_91701 = (state_91722[(2)]);
var state_91722__$1 = state_91722;
var statearr_91729_91782 = state_91722__$1;
(statearr_91729_91782[(2)] = inst_91701);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91722__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91723 === (2))){
var inst_91720 = (state_91722[(2)]);
var state_91722__$1 = state_91722;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_91722__$1,inst_91720);
} else {
if((state_val_91723 === (9))){
var inst_91711 = (state_91722[(2)]);
var inst_91712 = fluree.db.util.async.throw_err.call(null,inst_91711);
var inst_91713 = fluree.db.dbproto._lookup_leaf.call(null,inst_91712,flake);
var state_91722__$1 = state_91722;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_91722__$1,(8),inst_91713);
} else {
if((state_val_91723 === (5))){
var inst_91705 = (state_91722[(7)]);
var state_91722__$1 = state_91722;
var statearr_91730_91783 = state_91722__$1;
(statearr_91730_91783[(2)] = inst_91705);

(statearr_91730_91783[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91723 === (8))){
var inst_91715 = (state_91722[(2)]);
var inst_91716 = fluree.db.util.async.throw_err.call(null,inst_91715);
var state_91722__$1 = state_91722;
var statearr_91731_91784 = state_91722__$1;
(statearr_91731_91784[(2)] = inst_91716);

(statearr_91731_91784[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,this$__$1))
;
return ((function (switch__86624__auto__,c__86675__auto__,this$__$1){
return (function() {
var fluree$db$index$state_machine__86625__auto__ = null;
var fluree$db$index$state_machine__86625__auto____0 = (function (){
var statearr_91732 = [null,null,null,null,null,null,null,null];
(statearr_91732[(0)] = fluree$db$index$state_machine__86625__auto__);

(statearr_91732[(1)] = (1));

return statearr_91732;
});
var fluree$db$index$state_machine__86625__auto____1 = (function (state_91722){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_91722);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e91733){if((e91733 instanceof Object)){
var ex__86628__auto__ = e91733;
var statearr_91734_91785 = state_91722;
(statearr_91734_91785[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91722);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e91733;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__91786 = state_91722;
state_91722 = G__91786;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$index$state_machine__86625__auto__ = function(state_91722){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__86625__auto____1.call(this,state_91722);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__86625__auto____0;
fluree$db$index$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__86625__auto____1;
return fluree$db$index$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,this$__$1))
})();
var state__86677__auto__ = (function (){var statearr_91735 = f__86676__auto__.call(null);
(statearr_91735[(6)] = c__86675__auto__);

return statearr_91735;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,this$__$1))
);

return c__86675__auto__;
});

fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_leaf_after$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,this$__$1){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,this$__$1){
return (function (state_91757){
var state_val_91758 = (state_91757[(1)]);
if((state_val_91758 === (7))){
var inst_91753 = (state_91757[(2)]);
var state_91757__$1 = state_91757;
var statearr_91759_91787 = state_91757__$1;
(statearr_91759_91787[(2)] = inst_91753);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91757__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91758 === (1))){
var state_91757__$1 = state_91757;
var statearr_91760_91788 = state_91757__$1;
(statearr_91760_91788[(2)] = null);

(statearr_91760_91788[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91758 === (4))){
var inst_91740 = (state_91757[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_91757,(3),Error,null,(2));
var inst_91740__$1 = fluree.db.dbproto._lookup_after.call(null,this$__$1,flake);
var inst_91741 = new cljs.core.Keyword(null,"leaf","leaf",1306118732).cljs$core$IFn$_invoke$arity$1(inst_91740__$1);
var state_91757__$1 = (function (){var statearr_91761 = state_91757;
(statearr_91761[(7)] = inst_91740__$1);

return statearr_91761;
})();
if(cljs.core.truth_(inst_91741)){
var statearr_91762_91789 = state_91757__$1;
(statearr_91762_91789[(1)] = (5));

} else {
var statearr_91763_91790 = state_91757__$1;
(statearr_91763_91790[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91758 === (6))){
var inst_91740 = (state_91757[(7)]);
var inst_91744 = fluree.db.dbproto._resolve.call(null,inst_91740);
var state_91757__$1 = state_91757;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_91757__$1,(9),inst_91744);
} else {
if((state_val_91758 === (3))){
var inst_91736 = (state_91757[(2)]);
var state_91757__$1 = state_91757;
var statearr_91764_91791 = state_91757__$1;
(statearr_91764_91791[(2)] = inst_91736);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91757__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91758 === (2))){
var inst_91755 = (state_91757[(2)]);
var state_91757__$1 = state_91757;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_91757__$1,inst_91755);
} else {
if((state_val_91758 === (9))){
var inst_91746 = (state_91757[(2)]);
var inst_91747 = fluree.db.util.async.throw_err.call(null,inst_91746);
var inst_91748 = fluree.db.dbproto._lookup_leaf_after.call(null,inst_91747,flake);
var state_91757__$1 = state_91757;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_91757__$1,(8),inst_91748);
} else {
if((state_val_91758 === (5))){
var inst_91740 = (state_91757[(7)]);
var state_91757__$1 = state_91757;
var statearr_91765_91792 = state_91757__$1;
(statearr_91765_91792[(2)] = inst_91740);

(statearr_91765_91792[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91758 === (8))){
var inst_91750 = (state_91757[(2)]);
var inst_91751 = fluree.db.util.async.throw_err.call(null,inst_91750);
var state_91757__$1 = state_91757;
var statearr_91766_91793 = state_91757__$1;
(statearr_91766_91793[(2)] = inst_91751);

(statearr_91766_91793[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,this$__$1))
;
return ((function (switch__86624__auto__,c__86675__auto__,this$__$1){
return (function() {
var fluree$db$index$state_machine__86625__auto__ = null;
var fluree$db$index$state_machine__86625__auto____0 = (function (){
var statearr_91767 = [null,null,null,null,null,null,null,null];
(statearr_91767[(0)] = fluree$db$index$state_machine__86625__auto__);

(statearr_91767[(1)] = (1));

return statearr_91767;
});
var fluree$db$index$state_machine__86625__auto____1 = (function (state_91757){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_91757);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e91768){if((e91768 instanceof Object)){
var ex__86628__auto__ = e91768;
var statearr_91769_91794 = state_91757;
(statearr_91769_91794[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91757);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e91768;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__91795 = state_91757;
state_91757 = G__91795;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$index$state_machine__86625__auto__ = function(state_91757){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__86625__auto____1.call(this,state_91757);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__86625__auto____0;
fluree$db$index$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__86625__auto____1;
return fluree$db$index$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,this$__$1))
})();
var state__86677__auto__ = (function (){var statearr_91770 = f__86676__auto__.call(null);
(statearr_91770[(6)] = c__86675__auto__);

return statearr_91770;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,this$__$1))
);

return c__86675__auto__;
});

fluree.db.index.IndexNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (659789215 ^ cljs.core.hash_unordered_coll.call(null,coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
.call(null,this__4381__auto____$1);
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.index.IndexNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this91686,other91687){
var self__ = this;
var this91686__$1 = this;
return (((!((other91687 == null)))) && ((this91686__$1.constructor === other91687.constructor)) && (cljs.core._EQ_.call(null,this91686__$1.block,other91687.block)) && (cljs.core._EQ_.call(null,this91686__$1.t,other91687.t)) && (cljs.core._EQ_.call(null,this91686__$1.rhs,other91687.rhs)) && (cljs.core._EQ_.call(null,this91686__$1.children,other91687.children)) && (cljs.core._EQ_.call(null,this91686__$1.config,other91687.config)) && (cljs.core._EQ_.call(null,this91686__$1.leftmost_QMARK_,other91687.leftmost_QMARK_)) && (cljs.core._EQ_.call(null,this91686__$1.__extmap,other91687.__extmap)));
});

fluree.db.index.IndexNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"children","children",-940561982),null,new cljs.core.Keyword(null,"block","block",664686210),null,new cljs.core.Keyword(null,"config","config",994861415),null,new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),null,new cljs.core.Keyword(null,"t","t",-1397832519),null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),null], null), null),k__4395__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.index.IndexNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__91684){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__91771 = cljs.core.keyword_identical_QMARK_;
var expr__91772 = k__4393__auto__;
if(cljs.core.truth_(pred__91771.call(null,new cljs.core.Keyword(null,"block","block",664686210),expr__91772))){
return (new fluree.db.index.IndexNode(G__91684,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91771.call(null,new cljs.core.Keyword(null,"t","t",-1397832519),expr__91772))){
return (new fluree.db.index.IndexNode(self__.block,G__91684,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91771.call(null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),expr__91772))){
return (new fluree.db.index.IndexNode(self__.block,self__.t,G__91684,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91771.call(null,new cljs.core.Keyword(null,"children","children",-940561982),expr__91772))){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,G__91684,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91771.call(null,new cljs.core.Keyword(null,"config","config",994861415),expr__91772))){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,G__91684,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91771.call(null,new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),expr__91772))){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,G__91684,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4393__auto__,G__91684),null));
}
}
}
}
}
}
});

fluree.db.index.IndexNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"block","block",664686210),self__.block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"t","t",-1397832519),self__.t,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"children","children",-940561982),self__.children,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"config","config",994861415),self__.config,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),self__.leftmost_QMARK_,null))], null),self__.__extmap));
});

fluree.db.index.IndexNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__91684){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,G__91684,self__.__extmap,self__.__hash));
});

fluree.db.index.IndexNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4391__auto__,(0)),cljs.core._nth.call(null,entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.index.IndexNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"block","block",-1989749559,null),new cljs.core.Symbol(null,"t","t",242699008,null),new cljs.core.Symbol(null,"rhs","rhs",1411174788,null),new cljs.core.Symbol(null,"children","children",699969545,null),new cljs.core.Symbol(null,"config","config",-1659574354,null),new cljs.core.Symbol(null,"leftmost?","leftmost?",-31657032,null)], null);
});

fluree.db.index.IndexNode.cljs$lang$type = true;

fluree.db.index.IndexNode.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.index/IndexNode",null,(1),null));
});

fluree.db.index.IndexNode.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write.call(null,writer__4429__auto__,"fluree.db.index/IndexNode");
});

/**
 * Positional factory function for fluree.db.index/IndexNode.
 */
fluree.db.index.__GT_IndexNode = (function fluree$db$index$__GT_IndexNode(block,t,rhs,children,config,leftmost_QMARK_){
return (new fluree.db.index.IndexNode(block,t,rhs,children,config,leftmost_QMARK_,null,null,null));
});

/**
 * Factory function for fluree.db.index/IndexNode, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_IndexNode = (function fluree$db$index$map__GT_IndexNode(G__91688){
var extmap__4424__auto__ = (function (){var G__91774 = cljs.core.dissoc.call(null,G__91688,new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559));
if(cljs.core.record_QMARK_.call(null,G__91688)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__91774);
} else {
return G__91774;
}
})();
return (new fluree.db.index.IndexNode(new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(G__91688),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(G__91688),new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(G__91688),new cljs.core.Keyword(null,"children","children",-940561982).cljs$core$IFn$_invoke$arity$1(G__91688),new cljs.core.Keyword(null,"config","config",994861415).cljs$core$IFn$_invoke$arity$1(G__91688),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559).cljs$core$IFn$_invoke$arity$1(G__91688),null,cljs.core.not_empty.call(null,extmap__4424__auto__),null));
});

fluree.db.index.index_node_QMARK_ = (function fluree$db$index$index_node_QMARK_(node){
return (node instanceof fluree.db.index.IndexNode);
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {fluree.db.dbproto.INode}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.DataNode = (function (block,t,flakes,rhs,config,__meta,__extmap,__hash){
this.block = block;
this.t = t;
this.flakes = flakes;
this.rhs = rhs;
this.config = config;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.index.DataNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.index.DataNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k91797,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__91801 = k91797;
var G__91801__$1 = (((G__91801 instanceof cljs.core.Keyword))?G__91801.fqn:null);
switch (G__91801__$1) {
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "flakes":
return self__.flakes;

break;
case "rhs":
return self__.rhs;

break;
case "config":
return self__.config;

break;
default:
return cljs.core.get.call(null,self__.__extmap,k91797,else__4388__auto__);

}
});

fluree.db.index.DataNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.call(null,((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__91802){
var vec__91803 = p__91802;
var k__4408__auto__ = cljs.core.nth.call(null,vec__91803,(0),null);
var v__4409__auto__ = cljs.core.nth.call(null,vec__91803,(1),null);
return f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__);
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.index.DataNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.index.DataNode{",", ","}",opts__4401__auto__,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"block","block",664686210),self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"t","t",-1397832519),self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"flakes","flakes",1977895739),self__.flakes],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"config","config",994861415),self__.config],null))], null),self__.__extmap));
});

fluree.db.index.DataNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__91796){
var self__ = this;
var G__91796__$1 = this;
return (new cljs.core.RecordIter((0),G__91796__$1,5,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"config","config",994861415)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,this$__$1){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,this$__$1){
return (function (state_91807){
var state_val_91808 = (state_91807[(1)]);
if((state_val_91808 === (1))){
var state_91807__$1 = state_91807;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_91807__$1,this$__$1);
} else {
return null;
}
});})(c__86675__auto__,this$__$1))
;
return ((function (switch__86624__auto__,c__86675__auto__,this$__$1){
return (function() {
var fluree$db$index$state_machine__86625__auto__ = null;
var fluree$db$index$state_machine__86625__auto____0 = (function (){
var statearr_91809 = [null,null,null,null,null,null,null];
(statearr_91809[(0)] = fluree$db$index$state_machine__86625__auto__);

(statearr_91809[(1)] = (1));

return statearr_91809;
});
var fluree$db$index$state_machine__86625__auto____1 = (function (state_91807){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_91807);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e91810){if((e91810 instanceof Object)){
var ex__86628__auto__ = e91810;
var statearr_91811_91829 = state_91807;
(statearr_91811_91829[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91807);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e91810;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__91830 = state_91807;
state_91807 = G__91830;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$index$state_machine__86625__auto__ = function(state_91807){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__86625__auto____1.call(this,state_91807);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__86625__auto____0;
fluree$db$index$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__86625__auto____1;
return fluree$db$index$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,this$__$1))
})();
var state__86677__auto__ = (function (){var statearr_91812 = f__86676__auto__.call(null);
(statearr_91812[(6)] = c__86675__auto__);

return statearr_91812;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,this$__$1))
);

return c__86675__auto__;
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_resolve_history$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.call(null,"-resolve-history called on DATA NODE!!!",cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.first.call(null,self__.flakes);
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
});

fluree.db.index.DataNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.index.DataNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.index.DataNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (5 + cljs.core.count.call(null,self__.__extmap));
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$_lookup$arity$2 = (function (root,flake){
var self__ = this;
var root__$1 = this;
throw cljs.core.ex_info.call(null,"-lookup was called on a data node, which shouldn't happen!",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(500),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)], null));
});

fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$_lookup_leaf$arity$2 = (function (root,flake){
var self__ = this;
var root__$1 = this;
fluree.db.util.log.error.call(null,"-lookup-leaf was called on a data node, which shouldn't happen!");

var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,root__$1){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,root__$1){
return (function (state_91818){
var state_val_91819 = (state_91818[(1)]);
if((state_val_91819 === (1))){
var inst_91813 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_91814 = [(500),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)];
var inst_91815 = cljs.core.PersistentHashMap.fromArrays(inst_91813,inst_91814);
var inst_91816 = cljs.core.ex_info.call(null,"-lookup-leaf was called on a data node, which shouldn't happen!",inst_91815);
var state_91818__$1 = state_91818;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_91818__$1,inst_91816);
} else {
return null;
}
});})(c__86675__auto__,root__$1))
;
return ((function (switch__86624__auto__,c__86675__auto__,root__$1){
return (function() {
var fluree$db$index$state_machine__86625__auto__ = null;
var fluree$db$index$state_machine__86625__auto____0 = (function (){
var statearr_91820 = [null,null,null,null,null,null,null];
(statearr_91820[(0)] = fluree$db$index$state_machine__86625__auto__);

(statearr_91820[(1)] = (1));

return statearr_91820;
});
var fluree$db$index$state_machine__86625__auto____1 = (function (state_91818){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_91818);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e91821){if((e91821 instanceof Object)){
var ex__86628__auto__ = e91821;
var statearr_91822_91831 = state_91818;
(statearr_91822_91831[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91818);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e91821;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__91832 = state_91818;
state_91818 = G__91832;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$index$state_machine__86625__auto__ = function(state_91818){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__86625__auto____1.call(this,state_91818);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__86625__auto____0;
fluree$db$index$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__86625__auto____1;
return fluree$db$index$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,root__$1))
})();
var state__86677__auto__ = (function (){var statearr_91823 = f__86676__auto__.call(null);
(statearr_91823[(6)] = c__86675__auto__);

return statearr_91823;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,root__$1))
);

return c__86675__auto__;
});

fluree.db.index.DataNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (1312629141 ^ cljs.core.hash_unordered_coll.call(null,coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
.call(null,this__4381__auto____$1);
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.index.DataNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this91798,other91799){
var self__ = this;
var this91798__$1 = this;
return (((!((other91799 == null)))) && ((this91798__$1.constructor === other91799.constructor)) && (cljs.core._EQ_.call(null,this91798__$1.block,other91799.block)) && (cljs.core._EQ_.call(null,this91798__$1.t,other91799.t)) && (cljs.core._EQ_.call(null,this91798__$1.flakes,other91799.flakes)) && (cljs.core._EQ_.call(null,this91798__$1.rhs,other91799.rhs)) && (cljs.core._EQ_.call(null,this91798__$1.config,other91799.config)) && (cljs.core._EQ_.call(null,this91798__$1.__extmap,other91799.__extmap)));
});

fluree.db.index.DataNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"block","block",664686210),null,new cljs.core.Keyword(null,"config","config",994861415),null,new cljs.core.Keyword(null,"t","t",-1397832519),null,new cljs.core.Keyword(null,"flakes","flakes",1977895739),null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),null], null), null),k__4395__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.index.DataNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__91796){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__91824 = cljs.core.keyword_identical_QMARK_;
var expr__91825 = k__4393__auto__;
if(cljs.core.truth_(pred__91824.call(null,new cljs.core.Keyword(null,"block","block",664686210),expr__91825))){
return (new fluree.db.index.DataNode(G__91796,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91824.call(null,new cljs.core.Keyword(null,"t","t",-1397832519),expr__91825))){
return (new fluree.db.index.DataNode(self__.block,G__91796,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91824.call(null,new cljs.core.Keyword(null,"flakes","flakes",1977895739),expr__91825))){
return (new fluree.db.index.DataNode(self__.block,self__.t,G__91796,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91824.call(null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),expr__91825))){
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,G__91796,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__91824.call(null,new cljs.core.Keyword(null,"config","config",994861415),expr__91825))){
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,G__91796,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4393__auto__,G__91796),null));
}
}
}
}
}
});

fluree.db.index.DataNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"block","block",664686210),self__.block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"t","t",-1397832519),self__.t,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"flakes","flakes",1977895739),self__.flakes,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"config","config",994861415),self__.config,null))], null),self__.__extmap));
});

fluree.db.index.DataNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__91796){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,G__91796,self__.__extmap,self__.__hash));
});

fluree.db.index.DataNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4391__auto__,(0)),cljs.core._nth.call(null,entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.index.DataNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"block","block",-1989749559,null),new cljs.core.Symbol(null,"t","t",242699008,null),new cljs.core.Symbol(null,"flakes","flakes",-676540030,null),new cljs.core.Symbol(null,"rhs","rhs",1411174788,null),new cljs.core.Symbol(null,"config","config",-1659574354,null)], null);
});

fluree.db.index.DataNode.cljs$lang$type = true;

fluree.db.index.DataNode.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.index/DataNode",null,(1),null));
});

fluree.db.index.DataNode.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write.call(null,writer__4429__auto__,"fluree.db.index/DataNode");
});

/**
 * Positional factory function for fluree.db.index/DataNode.
 */
fluree.db.index.__GT_DataNode = (function fluree$db$index$__GT_DataNode(block,t,flakes,rhs,config){
return (new fluree.db.index.DataNode(block,t,flakes,rhs,config,null,null,null));
});

/**
 * Factory function for fluree.db.index/DataNode, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_DataNode = (function fluree$db$index$map__GT_DataNode(G__91800){
var extmap__4424__auto__ = (function (){var G__91827 = cljs.core.dissoc.call(null,G__91800,new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"config","config",994861415));
if(cljs.core.record_QMARK_.call(null,G__91800)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__91827);
} else {
return G__91827;
}
})();
return (new fluree.db.index.DataNode(new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(G__91800),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(G__91800),new cljs.core.Keyword(null,"flakes","flakes",1977895739).cljs$core$IFn$_invoke$arity$1(G__91800),new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(G__91800),new cljs.core.Keyword(null,"config","config",994861415).cljs$core$IFn$_invoke$arity$1(G__91800),null,cljs.core.not_empty.call(null,extmap__4424__auto__),null));
});

/**
 * Creates a new data node
 */
fluree.db.index.data_node = (function fluree$db$index$data_node(block_id,t,flakes,rhs,config){
return fluree.db.index.__GT_DataNode.call(null,block_id,t,flakes,rhs,config);
});
fluree.db.index.data_node_QMARK_ = (function fluree$db$index$data_node_QMARK_(node){
return (node instanceof fluree.db.index.DataNode);
});
