// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.query.analytical_wikidata');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.xhttp');
goog.require('fluree.db.util.log');
goog.require('cljs.core.async');
goog.require('fluree.db.util.async');
fluree.db.query.analytical_wikidata.variable_QMARK_ = (function fluree$db$query$analytical_wikidata$variable_QMARK_(form){
if(((((typeof form === 'string') || ((form instanceof cljs.core.Symbol)))) && (cljs.core._EQ_.call(null,cljs.core.first.call(null,cljs.core.name.call(null,form)),"?")))){
return cljs.core.symbol.call(null,form);
} else {
return null;
}
});
/**
 * Takes replacement vars, retrieves values from ctx, and puts into Wikidata VALUES statement,
 *   i.e. VALUES (?name ?countryName) {("Vincent van Gogh" "Kingdom of the Netherlands") ("Edvard Munch" "Norway")}
 */
fluree.db.query.analytical_wikidata.replacementVars__GT_ValuesSmt = (function fluree$db$query$analytical_wikidata$replacementVars__GT_ValuesSmt(vars,values){
var value_groups = cljs.core.map.call(null,(function (value_group){
var stringified = cljs.core.map.call(null,(function (p1__88491_SHARP_){
return ["\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__88491_SHARP_),"\""].join('');
}),value_group);
var joined_group = clojure.string.join.call(null," ",stringified);
return [" ( ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(joined_group)," ) "].join('');
}),values);
var value_group_str = clojure.string.join.call(null," ",value_groups);
return ["VALUES ( ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null," ",vars))," ) { ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(value_group_str)," } "].join('');
});
fluree.db.query.analytical_wikidata.get_next_wd_clauses = (function fluree$db$query$analytical_wikidata$get_next_wd_clauses(coll){
var G__88495 = coll;
var vec__88496 = G__88495;
var seq__88497 = cljs.core.seq.call(null,vec__88496);
var first__88498 = cljs.core.first.call(null,seq__88497);
var seq__88497__$1 = cljs.core.next.call(null,seq__88497);
var clause = first__88498;
var r = seq__88497__$1;
var res = cljs.core.PersistentVector.EMPTY;
var G__88495__$1 = G__88495;
var res__$1 = res;
while(true){
var vec__88502 = G__88495__$1;
var seq__88503 = cljs.core.seq.call(null,vec__88502);
var first__88504 = cljs.core.first.call(null,seq__88503);
var seq__88503__$1 = cljs.core.next.call(null,seq__88503);
var clause__$1 = first__88504;
var r__$1 = seq__88503__$1;
var res__$2 = res__$1;
if(cljs.core.truth_(clause__$1)){
if(cljs.core._EQ_.call(null,"$wd",cljs.core.first.call(null,clause__$1))){
var G__88505 = r__$1;
var G__88506 = cljs.core.conj.call(null,res__$2,clause__$1);
G__88495__$1 = G__88505;
res__$1 = G__88506;
continue;
} else {
return res__$2;
}
} else {
return res__$2;
}
break;
}
});
fluree.db.query.analytical_wikidata.get_all_wd_clauses = (function fluree$db$query$analytical_wikidata$get_all_wd_clauses(coll){
var G__88510 = coll;
var vec__88511 = G__88510;
var seq__88512 = cljs.core.seq.call(null,vec__88511);
var first__88513 = cljs.core.first.call(null,seq__88512);
var seq__88512__$1 = cljs.core.next.call(null,seq__88512);
var clause = first__88513;
var r = seq__88512__$1;
var res = cljs.core.PersistentVector.EMPTY;
var G__88510__$1 = G__88510;
var res__$1 = res;
while(true){
var vec__88517 = G__88510__$1;
var seq__88518 = cljs.core.seq.call(null,vec__88517);
var first__88519 = cljs.core.first.call(null,seq__88518);
var seq__88518__$1 = cljs.core.next.call(null,seq__88518);
var clause__$1 = first__88519;
var r__$1 = seq__88518__$1;
var res__$2 = res__$1;
if(cljs.core.truth_(clause__$1)){
if(cljs.core._EQ_.call(null,"$wd",cljs.core.first.call(null,clause__$1))){
var G__88520 = r__$1;
var G__88521 = cljs.core.conj.call(null,res__$2,cljs.core.rest.call(null,clause__$1));
G__88510__$1 = G__88520;
res__$1 = G__88521;
continue;
} else {
var G__88522 = r__$1;
var G__88523 = res__$2;
G__88510__$1 = G__88522;
res__$1 = G__88523;
continue;
}
} else {
return res__$2;
}
break;
}
});
fluree.db.query.analytical_wikidata.drop_all_wd_clauses = (function fluree$db$query$analytical_wikidata$drop_all_wd_clauses(coll){
var G__88527 = coll;
var vec__88528 = G__88527;
var seq__88529 = cljs.core.seq.call(null,vec__88528);
var first__88530 = cljs.core.first.call(null,seq__88529);
var seq__88529__$1 = cljs.core.next.call(null,seq__88529);
var clause = first__88530;
var r = seq__88529__$1;
var res = cljs.core.PersistentVector.EMPTY;
var G__88527__$1 = G__88527;
var res__$1 = res;
while(true){
var vec__88534 = G__88527__$1;
var seq__88535 = cljs.core.seq.call(null,vec__88534);
var first__88536 = cljs.core.first.call(null,seq__88535);
var seq__88535__$1 = cljs.core.next.call(null,seq__88535);
var clause__$1 = first__88536;
var r__$1 = seq__88535__$1;
var res__$2 = res__$1;
if(cljs.core.truth_(clause__$1)){
if(cljs.core._EQ_.call(null,"$wd",cljs.core.first.call(null,clause__$1))){
var G__88537 = r__$1;
var G__88538 = res__$2;
G__88527__$1 = G__88537;
res__$1 = G__88538;
continue;
} else {
var G__88539 = r__$1;
var G__88540 = cljs.core.conj.call(null,res__$2,clause__$1);
G__88527__$1 = G__88539;
res__$1 = G__88540;
continue;
}
} else {
return res__$2;
}
break;
}
});
fluree.db.query.analytical_wikidata.wikiDataVar_QMARK_ = (function fluree$db$query$analytical_wikidata$wikiDataVar_QMARK_(string){
if(cljs.core.truth_((function (){var and__4120__auto__ = typeof string === 'string';
if(and__4120__auto__){
return cljs.core.re_matches.call(null,/^wd(t)*:(P|Q)\d+$/,string);
} else {
return and__4120__auto__;
}
})())){
cljs.core.symbol.call(null,string);
} else {
if(typeof string === 'string'){
["\"",string,"\""].join('');
} else {
}
}


return string;
});
fluree.db.query.analytical_wikidata.ad_hoc_clause_to_wikidata = (function fluree$db$query$analytical_wikidata$ad_hoc_clause_to_wikidata(clause,optional_QMARK_){
var clause_str = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null," ",cljs.core.map.call(null,fluree.db.query.analytical_wikidata.wikiDataVar_QMARK_,clause))),"."].join('');
if(cljs.core.truth_(optional_QMARK_)){
return ["OPTIONAL {",clause_str,"}"].join('');
} else {
return clause_str;
}
});
fluree.db.query.analytical_wikidata.parse_prefixes = (function fluree$db$query$analytical_wikidata$parse_prefixes(prefixes){
return cljs.core.reduce.call(null,(function (acc_str,prefix){
var pfx = cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(fluree.db.util.core.keyword__GT_str.call(null,cljs.core.key.call(null,prefix))),":"].join(''));
var source = cljs.core.symbol.call(null,cljs.core.val.call(null,prefix));
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(acc_str)," PREFIX ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(pfx)," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(source)," \n "].join('');
}),"",prefixes);
});
fluree.db.query.analytical_wikidata.generateWikiDataQuery = (function fluree$db$query$analytical_wikidata$generateWikiDataQuery(q_map,clauses,select_vars,value_clause,optional_clauses){
var _ = (cljs.core.truth_(new cljs.core.Keyword(null,"wikidataOpts","wikidataOpts",646884132).cljs$core$IFn$_invoke$arity$1(q_map))?fluree.db.util.log.warn.call(null,["The Wikidata query option map should be included in the opts map. Top-level options are being deprecated. Provided: ",cljs.core.pr_str.call(null,q_map)].join('')):null);
var opts = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"limit","limit",-1355822363),(100),new cljs.core.Keyword(null,"offset","offset",296498311),(0),new cljs.core.Keyword(null,"distinct","distinct",-1788879121),false,new cljs.core.Keyword(null,"language","language",-1591107564),"en"], null),new cljs.core.Keyword(null,"wikidataOpts","wikidataOpts",646884132).cljs$core$IFn$_invoke$arity$1(q_map),cljs.core.get_in.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"opts","opts",155075701),new cljs.core.Keyword(null,"wikidataOpts","wikidataOpts",646884132)], null),q_map));
var map__88544 = opts;
var map__88544__$1 = (((((!((map__88544 == null))))?(((((map__88544.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__88544.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__88544):map__88544);
var limit = cljs.core.get.call(null,map__88544__$1,new cljs.core.Keyword(null,"limit","limit",-1355822363));
var offset = cljs.core.get.call(null,map__88544__$1,new cljs.core.Keyword(null,"offset","offset",296498311));
var distinct = cljs.core.get.call(null,map__88544__$1,new cljs.core.Keyword(null,"distinct","distinct",-1788879121));
var language = cljs.core.get.call(null,map__88544__$1,new cljs.core.Keyword(null,"language","language",-1591107564));
var prefixes = cljs.core.get.call(null,map__88544__$1,new cljs.core.Keyword(null,"prefixes","prefixes",1192472197));
var prefixes__$1 = (cljs.core.truth_(prefixes)?fluree.db.query.analytical_wikidata.parse_prefixes.call(null,prefixes):null);
var select_smt = ["SELECT ",(cljs.core.truth_(distinct)?"DISTINCT ":null)," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null," ",cljs.core.map.call(null,((function (_,opts,map__88544,map__88544__$1,limit,offset,distinct,language,prefixes,prefixes__$1){
return (function (p1__88541_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__88541_SHARP_),"Label"].join('');
});})(_,opts,map__88544,map__88544__$1,limit,offset,distinct,language,prefixes,prefixes__$1))
,select_vars)))," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null," ",select_vars))].join('');
var where_smt = clojure.string.join.call(null," ",cljs.core.mapv.call(null,((function (_,opts,map__88544,map__88544__$1,limit,offset,distinct,language,prefixes,prefixes__$1,select_smt){
return (function (p1__88542_SHARP_){
return fluree.db.query.analytical_wikidata.ad_hoc_clause_to_wikidata.call(null,p1__88542_SHARP_,false);
});})(_,opts,map__88544,map__88544__$1,limit,offset,distinct,language,prefixes,prefixes__$1,select_smt))
,clauses));
var optional_smt = clojure.string.join.call(null," ",cljs.core.mapv.call(null,((function (_,opts,map__88544,map__88544__$1,limit,offset,distinct,language,prefixes,prefixes__$1,select_smt,where_smt){
return (function (p1__88543_SHARP_){
return fluree.db.query.analytical_wikidata.ad_hoc_clause_to_wikidata.call(null,p1__88543_SHARP_,true);
});})(_,opts,map__88544,map__88544__$1,limit,offset,distinct,language,prefixes,prefixes__$1,select_smt,where_smt))
,optional_clauses));
var serviceLabel = ["SERVICE wikibase:label { bd:serviceParam wikibase:language \"",cljs.core.str.cljs$core$IFn$_invoke$arity$1((function (){var or__4131__auto__ = language;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "en";
}
})()),"\" . }"].join('');
var full_query = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(prefixes__$1)," ",select_smt," WHERE { ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(value_clause)," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(where_smt)," ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(optional_smt)," ",serviceLabel," } ",(cljs.core.truth_(limit)?["\n                          LIMIT ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(limit)].join(''):null)," OFFSET ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(offset)].join('');
return full_query;
});
fluree.db.query.analytical_wikidata.wikidataURL = "https://query.wikidata.org/bigdata/namespace/wdq/sparql?format=json&query=";
fluree.db.query.analytical_wikidata.submit_wikidata_query = (function fluree$db$query$analytical_wikidata$submit_wikidata_query(query){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_88559){
var state_val_88560 = (state_88559[(1)]);
if((state_val_88560 === (1))){
var inst_88546 = fluree.db.util.core.url_encode.call(null,query);
var inst_88547 = [fluree.db.query.analytical_wikidata.wikidataURL,cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_88546)].join('');
var inst_88548 = ["User-Agent","Accept"];
var inst_88549 = ["Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/50.0.2661.102 Safari/537.36","application/sparql-results+json"];
var inst_88550 = cljs.core.PersistentHashMap.fromArrays(inst_88548,inst_88549);
var inst_88551 = [new cljs.core.Keyword(null,"headers","headers",-835030129),new cljs.core.Keyword(null,"request-timeout","request-timeout",-2047539823),new cljs.core.Keyword(null,"output-format","output-format",-1826382676)];
var inst_88552 = [inst_88550,(30000),new cljs.core.Keyword(null,"wikidata","wikidata",2100084440)];
var inst_88553 = cljs.core.PersistentHashMap.fromArrays(inst_88551,inst_88552);
var inst_88554 = fluree.db.util.xhttp.get.call(null,inst_88547,inst_88553);
var state_88559__$1 = state_88559;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_88559__$1,(2),inst_88554);
} else {
if((state_val_88560 === (2))){
var inst_88556 = (state_88559[(2)]);
var inst_88557 = fluree.db.util.async.throw_err.call(null,inst_88556);
var state_88559__$1 = state_88559;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_88559__$1,inst_88557);
} else {
return null;
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto__ = null;
var fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto____0 = (function (){
var statearr_88561 = [null,null,null,null,null,null,null];
(statearr_88561[(0)] = fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto__);

(statearr_88561[(1)] = (1));

return statearr_88561;
});
var fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto____1 = (function (state_88559){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_88559);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e88562){if((e88562 instanceof Object)){
var ex__86628__auto__ = e88562;
var statearr_88563_88565 = state_88559;
(statearr_88563_88565[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88559);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e88562;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__88566 = state_88559;
state_88559 = G__88566;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto__ = function(state_88559){
switch(arguments.length){
case 0:
return fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto____1.call(this,state_88559);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto____0;
fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto____1;
return fluree$db$query$analytical_wikidata$submit_wikidata_query_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_88564 = f__86676__auto__.call(null);
(statearr_88564[(6)] = c__86675__auto__);

return statearr_88564;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.query.analytical_wikidata.submit_PLUS_parse_wikidata_query = (function fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query(query){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_88584){
var state_val_88585 = (state_88584[(1)]);
if((state_val_88585 === (1))){
var inst_88567 = fluree.db.query.analytical_wikidata.submit_wikidata_query.call(null,query);
var state_88584__$1 = state_88584;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_88584__$1,(2),inst_88567);
} else {
if((state_val_88585 === (2))){
var inst_88570 = (state_88584[(7)]);
var inst_88569 = (state_88584[(2)]);
var inst_88570__$1 = fluree.db.util.async.throw_err.call(null,inst_88569);
var inst_88571 = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(inst_88570__$1);
var inst_88572 = cljs.core.not_EQ_.call(null,(200),inst_88571);
var state_88584__$1 = (function (){var statearr_88586 = state_88584;
(statearr_88586[(7)] = inst_88570__$1);

return statearr_88586;
})();
if(inst_88572){
var statearr_88587_88595 = state_88584__$1;
(statearr_88587_88595[(1)] = (3));

} else {
var statearr_88588_88596 = state_88584__$1;
(statearr_88588_88596[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88585 === (3))){
var inst_88570 = (state_88584[(7)]);
var state_88584__$1 = state_88584;
var statearr_88589_88597 = state_88584__$1;
(statearr_88589_88597[(2)] = inst_88570);

(statearr_88589_88597[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88585 === (4))){
var inst_88570 = (state_88584[(7)]);
var inst_88575 = (function (){var body = inst_88570;
return ((function (body,inst_88570,state_val_88585,c__86675__auto__){
return (function (item){
return cljs.core.reduce.call(null,((function (body,inst_88570,state_val_88585,c__86675__auto__){
return (function (acc,k_v){
return cljs.core.assoc.call(null,acc,cljs.core.key.call(null,k_v),new cljs.core.Keyword(null,"value","value",305978217).cljs$core$IFn$_invoke$arity$1(cljs.core.val.call(null,k_v)));
});})(body,inst_88570,state_val_88585,c__86675__auto__))
,cljs.core.PersistentArrayMap.EMPTY,item);
});
;})(body,inst_88570,state_val_88585,c__86675__auto__))
})();
var inst_88576 = cljs.core.second.call(null,inst_88570);
var inst_88577 = cljs.core.second.call(null,inst_88576);
var inst_88578 = cljs.core.first.call(null,inst_88577);
var inst_88579 = cljs.core.second.call(null,inst_88578);
var inst_88580 = cljs.core.mapv.call(null,inst_88575,inst_88579);
var state_88584__$1 = state_88584;
var statearr_88590_88598 = state_88584__$1;
(statearr_88590_88598[(2)] = inst_88580);

(statearr_88590_88598[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88585 === (5))){
var inst_88582 = (state_88584[(2)]);
var state_88584__$1 = state_88584;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_88584__$1,inst_88582);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto__ = null;
var fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto____0 = (function (){
var statearr_88591 = [null,null,null,null,null,null,null,null];
(statearr_88591[(0)] = fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto__);

(statearr_88591[(1)] = (1));

return statearr_88591;
});
var fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto____1 = (function (state_88584){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_88584);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e88592){if((e88592 instanceof Object)){
var ex__86628__auto__ = e88592;
var statearr_88593_88599 = state_88584;
(statearr_88593_88599[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88584);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e88592;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__88600 = state_88584;
state_88584 = G__88600;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto__ = function(state_88584){
switch(arguments.length){
case 0:
return fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto____1.call(this,state_88584);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto____0;
fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto____1;
return fluree$db$query$analytical_wikidata$submit_PLUS_parse_wikidata_query_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_88594 = f__86676__auto__.call(null);
(statearr_88594[(6)] = c__86675__auto__);

return statearr_88594;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.query.analytical_wikidata.wikiDataResp__GT_tuples = (function fluree$db$query$analytical_wikidata$wikiDataResp__GT_tuples(wikidataRes,vars){
var labelVars = cljs.core.map.call(null,(function (p1__88601_SHARP_){
return cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__88601_SHARP_),"Label"].join(''));
}),vars);
var headers = cljs.core.concat.call(null,cljs.core.into.call(null,cljs.core.PersistentVector.EMPTY,vars),labelVars);
var headers_as_kws = cljs.core.map.call(null,((function (labelVars,headers){
return (function (p1__88602_SHARP_){
return fluree.db.util.core.str__GT_keyword.call(null,cljs.core.subs.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(p1__88602_SHARP_),(1)));
});})(labelVars,headers))
,headers);
var results = new cljs.core.Keyword(null,"bindings","bindings",1271397192).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"results","results",-1134170113).cljs$core$IFn$_invoke$arity$1(wikidataRes));
var tuples = cljs.core.map.call(null,((function (labelVars,headers,headers_as_kws,results){
return (function (res){
return cljs.core.map.call(null,((function (labelVars,headers,headers_as_kws,results){
return (function (p1__88603_SHARP_){
return new cljs.core.Keyword(null,"value","value",305978217).cljs$core$IFn$_invoke$arity$1(p1__88603_SHARP_.call(null,res));
});})(labelVars,headers,headers_as_kws,results))
,headers_as_kws);
});})(labelVars,headers,headers_as_kws,results))
,results);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"headers","headers",-835030129),headers,new cljs.core.Keyword(null,"vars","vars",-2046957217),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"tuples","tuples",-676032639),tuples], null);
});
fluree.db.query.analytical_wikidata.get_wikidata_tuples = (function fluree$db$query$analytical_wikidata$get_wikidata_tuples(q_map,clauses,matching_vars,matching_vals,all_vars,optional_clauses){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_88638){
var state_val_88639 = (state_88638[(1)]);
if((state_val_88639 === (7))){
var inst_88613 = (state_88638[(2)]);
var inst_88614 = fluree.db.query.analytical_wikidata.generateWikiDataQuery.call(null,q_map,clauses,all_vars,inst_88613,optional_clauses);
var inst_88615 = fluree.db.query.analytical_wikidata.submit_PLUS_parse_wikidata_query.call(null,inst_88614);
var state_88638__$1 = state_88638;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_88638__$1,(8),inst_88615);
} else {
if((state_val_88639 === (1))){
var state_88638__$1 = state_88638;
var statearr_88640_88656 = state_88638__$1;
(statearr_88640_88656[(2)] = null);

(statearr_88640_88656[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88639 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_88638,(3),Error,null,(2));
var inst_88608 = cljs.core.empty_QMARK_.call(null,matching_vars);
var state_88638__$1 = state_88638;
if(inst_88608){
var statearr_88641_88657 = state_88638__$1;
(statearr_88641_88657[(1)] = (5));

} else {
var statearr_88642_88658 = state_88638__$1;
(statearr_88642_88658[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88639 === (6))){
var inst_88611 = fluree.db.query.analytical_wikidata.replacementVars__GT_ValuesSmt.call(null,matching_vars,matching_vals);
var state_88638__$1 = state_88638;
var statearr_88643_88659 = state_88638__$1;
(statearr_88643_88659[(2)] = inst_88611);

(statearr_88643_88659[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88639 === (3))){
var inst_88604 = (state_88638[(2)]);
var state_88638__$1 = state_88638;
var statearr_88644_88660 = state_88638__$1;
(statearr_88644_88660[(2)] = inst_88604);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88638__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88639 === (2))){
var inst_88636 = (state_88638[(2)]);
var state_88638__$1 = state_88638;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_88638__$1,inst_88636);
} else {
if((state_val_88639 === (11))){
var inst_88634 = (state_88638[(2)]);
var state_88638__$1 = state_88638;
var statearr_88645_88661 = state_88638__$1;
(statearr_88645_88661[(2)] = inst_88634);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88638__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88639 === (9))){
var inst_88618 = (state_88638[(7)]);
var inst_88622 = new cljs.core.Keyword(null,"message","message",-406056002).cljs$core$IFn$_invoke$arity$1(inst_88618);
var inst_88623 = cljs.core.subs.call(null,inst_88622,(0),(1000));
var inst_88624 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_88625 = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(inst_88618);
var inst_88626 = new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(inst_88618);
var inst_88627 = [inst_88625,inst_88626];
var inst_88628 = cljs.core.PersistentHashMap.fromArrays(inst_88624,inst_88627);
var inst_88629 = cljs.core.ex_info.call(null,inst_88623,inst_88628);
var inst_88630 = (function(){throw inst_88629})();
var state_88638__$1 = state_88638;
var statearr_88646_88662 = state_88638__$1;
(statearr_88646_88662[(2)] = inst_88630);

(statearr_88646_88662[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88639 === (5))){
var state_88638__$1 = state_88638;
var statearr_88647_88663 = state_88638__$1;
(statearr_88647_88663[(2)] = null);

(statearr_88647_88663[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88639 === (10))){
var inst_88618 = (state_88638[(7)]);
var inst_88632 = fluree.db.query.analytical_wikidata.wikiDataResp__GT_tuples.call(null,inst_88618,all_vars);
var state_88638__$1 = state_88638;
var statearr_88648_88664 = state_88638__$1;
(statearr_88648_88664[(2)] = inst_88632);

(statearr_88648_88664[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88639 === (8))){
var inst_88618 = (state_88638[(7)]);
var inst_88617 = (state_88638[(2)]);
var inst_88618__$1 = fluree.db.util.async.throw_err.call(null,inst_88617);
var inst_88619 = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(inst_88618__$1);
var inst_88620 = cljs.core._EQ_.call(null,(400),inst_88619);
var state_88638__$1 = (function (){var statearr_88649 = state_88638;
(statearr_88649[(7)] = inst_88618__$1);

return statearr_88649;
})();
if(inst_88620){
var statearr_88650_88665 = state_88638__$1;
(statearr_88650_88665[(1)] = (9));

} else {
var statearr_88651_88666 = state_88638__$1;
(statearr_88651_88666[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto__ = null;
var fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto____0 = (function (){
var statearr_88652 = [null,null,null,null,null,null,null,null];
(statearr_88652[(0)] = fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto__);

(statearr_88652[(1)] = (1));

return statearr_88652;
});
var fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto____1 = (function (state_88638){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_88638);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e88653){if((e88653 instanceof Object)){
var ex__86628__auto__ = e88653;
var statearr_88654_88667 = state_88638;
(statearr_88654_88667[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88638);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e88653;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__88668 = state_88638;
state_88638 = G__88668;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto__ = function(state_88638){
switch(arguments.length){
case 0:
return fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto____1.call(this,state_88638);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto____0;
fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto____1;
return fluree$db$query$analytical_wikidata$get_wikidata_tuples_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_88655 = f__86676__auto__.call(null);
(statearr_88655[(6)] = c__86675__auto__);

return statearr_88655;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
