// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.session');
goog.require('cljs.core');
goog.require('fluree.db.graphdb');
goog.require('cljs.core.async');
goog.require('cljs.cache');
goog.require('clojure.string');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.storage.core');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.log');
goog.require('fluree.db.operations');
goog.require('fluree.db.flake');
goog.require('fluree.db.constants');
goog.require('fluree.db.util.async');
goog.require('fluree.db.query.schema');



/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.session.DbSession = (function (conn,network,dbid,db_name,update_chan,transact_chan,state,schema_cache,blank_db,close,id,__meta,__extmap,__hash){
this.conn = conn;
this.network = network;
this.dbid = dbid;
this.db_name = db_name;
this.update_chan = update_chan;
this.transact_chan = transact_chan;
this.state = state;
this.schema_cache = schema_cache;
this.blank_db = blank_db;
this.close = close;
this.id = id;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.session.DbSession.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.session.DbSession.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k102072,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__102076 = k102072;
var G__102076__$1 = (((G__102076 instanceof cljs.core.Keyword))?G__102076.fqn:null);
switch (G__102076__$1) {
case "conn":
return self__.conn;

break;
case "network":
return self__.network;

break;
case "dbid":
return self__.dbid;

break;
case "db-name":
return self__.db_name;

break;
case "update-chan":
return self__.update_chan;

break;
case "transact-chan":
return self__.transact_chan;

break;
case "state":
return self__.state;

break;
case "schema-cache":
return self__.schema_cache;

break;
case "blank-db":
return self__.blank_db;

break;
case "close":
return self__.close;

break;
case "id":
return self__.id;

break;
default:
return cljs.core.get.call(null,self__.__extmap,k102072,else__4388__auto__);

}
});

fluree.db.session.DbSession.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.call(null,((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__102077){
var vec__102078 = p__102077;
var k__4408__auto__ = cljs.core.nth.call(null,vec__102078,(0),null);
var v__4409__auto__ = cljs.core.nth.call(null,vec__102078,(1),null);
return f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__);
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.session.DbSession.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.session.DbSession{",", ","}",opts__4401__auto__,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"conn","conn",278309663),self__.conn],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"network","network",2050004697),self__.network],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"dbid","dbid",-196647356),self__.dbid],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"db-name","db-name",1157928745),self__.db_name],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"update-chan","update-chan",-863760792),self__.update_chan],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"transact-chan","transact-chan",-1273648840),self__.transact_chan],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"state","state",-1988618099),self__.state],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),self__.schema_cache],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"blank-db","blank-db",-475098534),self__.blank_db],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"close","close",1835149582),self__.close],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"id","id",-1388402092),self__.id],null))], null),self__.__extmap));
});

fluree.db.session.DbSession.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__102071){
var self__ = this;
var G__102071__$1 = this;
return (new cljs.core.RecordIter((0),G__102071__$1,11,new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"conn","conn",278309663),new cljs.core.Keyword(null,"network","network",2050004697),new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"db-name","db-name",1157928745),new cljs.core.Keyword(null,"update-chan","update-chan",-863760792),new cljs.core.Keyword(null,"transact-chan","transact-chan",-1273648840),new cljs.core.Keyword(null,"state","state",-1988618099),new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),new cljs.core.Keyword(null,"blank-db","blank-db",-475098534),new cljs.core.Keyword(null,"close","close",1835149582),new cljs.core.Keyword(null,"id","id",-1388402092)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
});

fluree.db.session.DbSession.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.session.DbSession.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.session.DbSession.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (11 + cljs.core.count.call(null,self__.__extmap));
});

fluree.db.session.DbSession.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (1635626254 ^ cljs.core.hash_unordered_coll.call(null,coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
.call(null,this__4381__auto____$1);
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.session.DbSession.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this102073,other102074){
var self__ = this;
var this102073__$1 = this;
return (((!((other102074 == null)))) && ((this102073__$1.constructor === other102074.constructor)) && (cljs.core._EQ_.call(null,this102073__$1.conn,other102074.conn)) && (cljs.core._EQ_.call(null,this102073__$1.network,other102074.network)) && (cljs.core._EQ_.call(null,this102073__$1.dbid,other102074.dbid)) && (cljs.core._EQ_.call(null,this102073__$1.db_name,other102074.db_name)) && (cljs.core._EQ_.call(null,this102073__$1.update_chan,other102074.update_chan)) && (cljs.core._EQ_.call(null,this102073__$1.transact_chan,other102074.transact_chan)) && (cljs.core._EQ_.call(null,this102073__$1.state,other102074.state)) && (cljs.core._EQ_.call(null,this102073__$1.schema_cache,other102074.schema_cache)) && (cljs.core._EQ_.call(null,this102073__$1.blank_db,other102074.blank_db)) && (cljs.core._EQ_.call(null,this102073__$1.close,other102074.close)) && (cljs.core._EQ_.call(null,this102073__$1.id,other102074.id)) && (cljs.core._EQ_.call(null,this102073__$1.__extmap,other102074.__extmap)));
});

fluree.db.session.DbSession.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 11, [new cljs.core.Keyword(null,"dbid","dbid",-196647356),null,new cljs.core.Keyword(null,"update-chan","update-chan",-863760792),null,new cljs.core.Keyword(null,"db-name","db-name",1157928745),null,new cljs.core.Keyword(null,"state","state",-1988618099),null,new cljs.core.Keyword(null,"close","close",1835149582),null,new cljs.core.Keyword(null,"id","id",-1388402092),null,new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),null,new cljs.core.Keyword(null,"transact-chan","transact-chan",-1273648840),null,new cljs.core.Keyword(null,"network","network",2050004697),null,new cljs.core.Keyword(null,"blank-db","blank-db",-475098534),null,new cljs.core.Keyword(null,"conn","conn",278309663),null], null), null),k__4395__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.session.DbSession.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__102071){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__102081 = cljs.core.keyword_identical_QMARK_;
var expr__102082 = k__4393__auto__;
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"conn","conn",278309663),expr__102082))){
return (new fluree.db.session.DbSession(G__102071,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"network","network",2050004697),expr__102082))){
return (new fluree.db.session.DbSession(self__.conn,G__102071,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"dbid","dbid",-196647356),expr__102082))){
return (new fluree.db.session.DbSession(self__.conn,self__.network,G__102071,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"db-name","db-name",1157928745),expr__102082))){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,G__102071,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"update-chan","update-chan",-863760792),expr__102082))){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,G__102071,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"transact-chan","transact-chan",-1273648840),expr__102082))){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,G__102071,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"state","state",-1988618099),expr__102082))){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,G__102071,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),expr__102082))){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,G__102071,self__.blank_db,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"blank-db","blank-db",-475098534),expr__102082))){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,G__102071,self__.close,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"close","close",1835149582),expr__102082))){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,G__102071,self__.id,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__102081.call(null,new cljs.core.Keyword(null,"id","id",-1388402092),expr__102082))){
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,G__102071,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4393__auto__,G__102071),null));
}
}
}
}
}
}
}
}
}
}
}
});

fluree.db.session.DbSession.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"conn","conn",278309663),self__.conn,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"network","network",2050004697),self__.network,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"dbid","dbid",-196647356),self__.dbid,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"db-name","db-name",1157928745),self__.db_name,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"update-chan","update-chan",-863760792),self__.update_chan,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"transact-chan","transact-chan",-1273648840),self__.transact_chan,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"state","state",-1988618099),self__.state,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),self__.schema_cache,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"blank-db","blank-db",-475098534),self__.blank_db,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"close","close",1835149582),self__.close,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"id","id",-1388402092),self__.id,null))], null),self__.__extmap));
});

fluree.db.session.DbSession.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__102071){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.session.DbSession(self__.conn,self__.network,self__.dbid,self__.db_name,self__.update_chan,self__.transact_chan,self__.state,self__.schema_cache,self__.blank_db,self__.close,self__.id,G__102071,self__.__extmap,self__.__hash));
});

fluree.db.session.DbSession.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4391__auto__,(0)),cljs.core._nth.call(null,entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.session.DbSession.getBasis = (function (){
return new cljs.core.PersistentVector(null, 11, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"conn","conn",1918841190,null),new cljs.core.Symbol(null,"network","network",-604431072,null),new cljs.core.Symbol(null,"dbid","dbid",1443884171,null),new cljs.core.Symbol(null,"db-name","db-name",-1496507024,null),new cljs.core.Symbol(null,"update-chan","update-chan",776770735,null),new cljs.core.Symbol(null,"transact-chan","transact-chan",366882687,null),new cljs.core.Symbol(null,"state","state",-348086572,null),new cljs.core.Symbol(null,"schema-cache","schema-cache",1403970302,null),new cljs.core.Symbol(null,"blank-db","blank-db",1165432993,null),new cljs.core.Symbol(null,"close","close",-819286187,null),new cljs.core.Symbol(null,"id","id",252129435,null)], null);
});

fluree.db.session.DbSession.cljs$lang$type = true;

fluree.db.session.DbSession.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.session/DbSession",null,(1),null));
});

fluree.db.session.DbSession.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write.call(null,writer__4429__auto__,"fluree.db.session/DbSession");
});

/**
 * Positional factory function for fluree.db.session/DbSession.
 */
fluree.db.session.__GT_DbSession = (function fluree$db$session$__GT_DbSession(conn,network,dbid,db_name,update_chan,transact_chan,state,schema_cache,blank_db,close,id){
return (new fluree.db.session.DbSession(conn,network,dbid,db_name,update_chan,transact_chan,state,schema_cache,blank_db,close,id,null,null,null));
});

/**
 * Factory function for fluree.db.session/DbSession, taking a map of keywords to field values.
 */
fluree.db.session.map__GT_DbSession = (function fluree$db$session$map__GT_DbSession(G__102075){
var extmap__4424__auto__ = (function (){var G__102084 = cljs.core.dissoc.call(null,G__102075,new cljs.core.Keyword(null,"conn","conn",278309663),new cljs.core.Keyword(null,"network","network",2050004697),new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"db-name","db-name",1157928745),new cljs.core.Keyword(null,"update-chan","update-chan",-863760792),new cljs.core.Keyword(null,"transact-chan","transact-chan",-1273648840),new cljs.core.Keyword(null,"state","state",-1988618099),new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),new cljs.core.Keyword(null,"blank-db","blank-db",-475098534),new cljs.core.Keyword(null,"close","close",1835149582),new cljs.core.Keyword(null,"id","id",-1388402092));
if(cljs.core.record_QMARK_.call(null,G__102075)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__102084);
} else {
return G__102084;
}
})();
return (new fluree.db.session.DbSession(new cljs.core.Keyword(null,"conn","conn",278309663).cljs$core$IFn$_invoke$arity$1(G__102075),new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(G__102075),new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(G__102075),new cljs.core.Keyword(null,"db-name","db-name",1157928745).cljs$core$IFn$_invoke$arity$1(G__102075),new cljs.core.Keyword(null,"update-chan","update-chan",-863760792).cljs$core$IFn$_invoke$arity$1(G__102075),new cljs.core.Keyword(null,"transact-chan","transact-chan",-1273648840).cljs$core$IFn$_invoke$arity$1(G__102075),new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(G__102075),new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225).cljs$core$IFn$_invoke$arity$1(G__102075),new cljs.core.Keyword(null,"blank-db","blank-db",-475098534).cljs$core$IFn$_invoke$arity$1(G__102075),new cljs.core.Keyword(null,"close","close",1835149582).cljs$core$IFn$_invoke$arity$1(G__102075),new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(G__102075),null,cljs.core.not_empty.call(null,extmap__4424__auto__),null));
});

fluree.db.session.cache_factory = (function fluree$db$session$cache_factory(){
return cljs.core.PersistentArrayMap.EMPTY;
});
fluree.db.session.session_cache = cljs.core.atom.call(null,fluree.db.session.cache_factory.call(null));
/**
 * Only replaces cache if an existing conn is not already present.
 *   Returns the cached connection.
 */
fluree.db.session.cache_BANG_ = (function fluree$db$session$cache_BANG_(session){
var map__102086 = session;
var map__102086__$1 = (((((!((map__102086 == null))))?(((((map__102086.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__102086.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__102086):map__102086);
var network = cljs.core.get.call(null,map__102086__$1,new cljs.core.Keyword(null,"network","network",2050004697));
var dbid = cljs.core.get.call(null,map__102086__$1,new cljs.core.Keyword(null,"dbid","dbid",-196647356));
var cache_key = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null);
cljs.core.swap_BANG_.call(null,fluree.db.session.session_cache,((function (map__102086,map__102086__$1,network,dbid,cache_key){
return (function (c){
if(cljs.core.truth_(cljs.core.get.call(null,c,cache_key))){
return c;
} else {
return cljs.core.assoc.call(null,c,cache_key,session);
}
});})(map__102086,map__102086__$1,network,dbid,cache_key))
);

return cljs.core.get.call(null,cljs.core.deref.call(null,fluree.db.session.session_cache),cache_key);
});
/**
 * Retrieves session from cache.
 */
fluree.db.session.from_cache = (function fluree$db$session$from_cache(network,dbid){
return cljs.core.get.call(null,cljs.core.deref.call(null,fluree.db.session.session_cache),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null));
});
/**
 * Removes a specific session from cache.
 */
fluree.db.session.remove_cache_BANG_ = (function fluree$db$session$remove_cache_BANG_(network,dbid){
return cljs.core.swap_BANG_.call(null,fluree.db.session.session_cache,cljs.core.dissoc,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null));
});
/**
 * Clears entire session cache. Should not be used under normal circumstances as sessions will not be properly closed.
 */
fluree.db.session.reset_cache_BANG_ = (function fluree$db$session$reset_cache_BANG_(){
return cljs.core.reset_BANG_.call(null,fluree.db.session.session_cache,fluree.db.session.cache_factory.call(null));
});
fluree.db.session.full_load_existing_db = (function fluree$db$session$full_load_existing_db(session){
var pc = cljs.core.async.promise_chan.call(null);
var c__86675__auto___102293 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___102293,pc){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___102293,pc){
return (function (state_102227){
var state_val_102228 = (state_102227[(1)]);
if((state_val_102228 === (7))){
var inst_102110 = (state_102227[(2)]);
var state_102227__$1 = state_102227;
if(cljs.core.truth_(inst_102110)){
var statearr_102229_102294 = state_102227__$1;
(statearr_102229_102294[(1)] = (11));

} else {
var statearr_102230_102295 = state_102227__$1;
(statearr_102230_102295[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (20))){
var inst_102137 = (state_102227[(2)]);
var inst_102138 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_102139 = [(400),new cljs.core.Keyword("db","unavailable","db/unavailable",1529908237)];
var inst_102140 = cljs.core.PersistentHashMap.fromArrays(inst_102138,inst_102139);
var inst_102141 = cljs.core.ex_info.call(null,inst_102137,inst_102140);
var inst_102142 = (function(){throw inst_102141})();
var state_102227__$1 = state_102227;
var statearr_102231_102296 = state_102227__$1;
(statearr_102231_102296[(2)] = inst_102142);

(statearr_102231_102296[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (27))){
var inst_102155 = (state_102227[(7)]);
var state_102227__$1 = state_102227;
var statearr_102232_102297 = state_102227__$1;
(statearr_102232_102297[(2)] = inst_102155);

(statearr_102232_102297[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (1))){
var state_102227__$1 = state_102227;
var statearr_102233_102298 = state_102227__$1;
(statearr_102233_102298[(2)] = null);

(statearr_102233_102298[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (24))){
var inst_102212 = (state_102227[(8)]);
var inst_102212__$1 = (state_102227[(2)]);
var inst_102213 = fluree.db.query.schema.schema_map.call(null,inst_102212__$1);
var state_102227__$1 = (function (){var statearr_102234 = state_102227;
(statearr_102234[(8)] = inst_102212__$1);

return statearr_102234;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_102227__$1,(44),inst_102213);
} else {
if((state_val_102228 === (39))){
var inst_102179 = (state_102227[(2)]);
var state_102227__$1 = state_102227;
var statearr_102235_102299 = state_102227__$1;
(statearr_102235_102299[(2)] = inst_102179);

(statearr_102235_102299[(1)] = (36));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_102227,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_102094 = new cljs.core.Keyword(null,"blank-db","blank-db",-475098534).cljs$core$IFn$_invoke$arity$1(session);
var inst_102096 = (session == null);
var inst_102097 = cljs.core.not.call(null,inst_102096);
var state_102227__$1 = (function (){var statearr_102236 = state_102227;
(statearr_102236[(9)] = inst_102094);

return statearr_102236;
})();
if(inst_102097){
var statearr_102237_102300 = state_102227__$1;
(statearr_102237_102300[(1)] = (5));

} else {
var statearr_102238_102301 = state_102227__$1;
(statearr_102238_102301[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (15))){
var inst_102125 = (state_102227[(10)]);
var inst_102130 = cljs.core.empty_QMARK_.call(null,inst_102125);
var state_102227__$1 = state_102227;
if(inst_102130){
var statearr_102239_102302 = state_102227__$1;
(statearr_102239_102302[(1)] = (18));

} else {
var statearr_102240_102303 = state_102227__$1;
(statearr_102240_102303[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (21))){
var inst_102125 = (state_102227[(10)]);
var inst_102150 = (state_102227[(11)]);
var inst_102149 = (state_102227[(2)]);
var inst_102150__$1 = fluree.db.util.async.throw_err.call(null,inst_102149);
var inst_102151 = new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(inst_102125);
var state_102227__$1 = (function (){var statearr_102241 = state_102227;
(statearr_102241[(12)] = inst_102151);

(statearr_102241[(11)] = inst_102150__$1);

return statearr_102241;
})();
if(cljs.core.truth_(inst_102150__$1)){
var statearr_102242_102304 = state_102227__$1;
(statearr_102242_102304[(1)] = (22));

} else {
var statearr_102243_102305 = state_102227__$1;
(statearr_102243_102305[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (31))){
var inst_102164 = (state_102227[(13)]);
var inst_102168 = (inst_102164 == null);
var inst_102169 = cljs.core.not.call(null,inst_102168);
var state_102227__$1 = state_102227;
if(inst_102169){
var statearr_102244_102306 = state_102227__$1;
(statearr_102244_102306[(1)] = (34));

} else {
var statearr_102245_102307 = state_102227__$1;
(statearr_102245_102307[(1)] = (35));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (32))){
var inst_102118 = (state_102227[(14)]);
var inst_102117 = (state_102227[(15)]);
var inst_102156 = (state_102227[(16)]);
var inst_102198 = ["Error reading block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102156)," for db: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102117),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102118),"."].join('');
var inst_102199 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_102200 = [(500),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)];
var inst_102201 = cljs.core.PersistentHashMap.fromArrays(inst_102199,inst_102200);
var inst_102202 = cljs.core.ex_info.call(null,inst_102198,inst_102201);
var inst_102203 = (function(){throw inst_102202})();
var state_102227__$1 = state_102227;
var statearr_102246_102308 = state_102227__$1;
(statearr_102246_102308[(2)] = inst_102203);

(statearr_102246_102308[(1)] = (33));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (40))){
var inst_102164 = (state_102227[(13)]);
var inst_102184 = cljs.core.apply.call(null,cljs.core.hash_map,inst_102164);
var state_102227__$1 = state_102227;
var statearr_102247_102309 = state_102227__$1;
(statearr_102247_102309[(2)] = inst_102184);

(statearr_102247_102309[(1)] = (42));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (33))){
var inst_102205 = (state_102227[(2)]);
var state_102227__$1 = state_102227;
var statearr_102248_102310 = state_102227__$1;
(statearr_102248_102310[(2)] = inst_102205);

(statearr_102248_102310[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (13))){
var inst_102118 = (state_102227[(14)]);
var inst_102116 = (state_102227[(17)]);
var inst_102117 = (state_102227[(15)]);
var inst_102115 = (state_102227[(2)]);
var inst_102116__$1 = cljs.core.get.call(null,inst_102115,new cljs.core.Keyword(null,"conn","conn",278309663));
var inst_102117__$1 = cljs.core.get.call(null,inst_102115,new cljs.core.Keyword(null,"network","network",2050004697));
var inst_102118__$1 = cljs.core.get.call(null,inst_102115,new cljs.core.Keyword(null,"dbid","dbid",-196647356));
var inst_102119 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_102120 = [inst_102117__$1,inst_102118__$1];
var inst_102121 = (new cljs.core.PersistentVector(null,2,(5),inst_102119,inst_102120,null));
var inst_102122 = fluree.db.operations.ledger_info_async.call(null,inst_102116__$1,inst_102121);
var state_102227__$1 = (function (){var statearr_102249 = state_102227;
(statearr_102249[(14)] = inst_102118__$1);

(statearr_102249[(17)] = inst_102116__$1);

(statearr_102249[(15)] = inst_102117__$1);

return statearr_102249;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_102227__$1,(14),inst_102122);
} else {
if((state_val_102228 === (22))){
var inst_102150 = (state_102227[(11)]);
var inst_102153 = new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(inst_102150);
var inst_102154 = (inst_102153 + (1));
var inst_102155 = inst_102150;
var inst_102156 = inst_102154;
var state_102227__$1 = (function (){var statearr_102250 = state_102227;
(statearr_102250[(16)] = inst_102156);

(statearr_102250[(7)] = inst_102155);

return statearr_102250;
})();
var statearr_102251_102311 = state_102227__$1;
(statearr_102251_102311[(2)] = null);

(statearr_102251_102311[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (36))){
var inst_102182 = (state_102227[(2)]);
var state_102227__$1 = state_102227;
if(cljs.core.truth_(inst_102182)){
var statearr_102252_102312 = state_102227__$1;
(statearr_102252_102312[(1)] = (40));

} else {
var statearr_102253_102313 = state_102227__$1;
(statearr_102253_102313[(1)] = (41));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (41))){
var inst_102164 = (state_102227[(13)]);
var state_102227__$1 = state_102227;
var statearr_102254_102314 = state_102227__$1;
(statearr_102254_102314[(2)] = inst_102164);

(statearr_102254_102314[(1)] = (42));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (43))){
var inst_102156 = (state_102227[(16)]);
var inst_102193 = (state_102227[(2)]);
var inst_102194 = fluree.db.util.async.throw_err.call(null,inst_102193);
var inst_102195 = (inst_102156 + (1));
var inst_102155 = inst_102194;
var inst_102156__$1 = inst_102195;
var state_102227__$1 = (function (){var statearr_102255 = state_102227;
(statearr_102255[(16)] = inst_102156__$1);

(statearr_102255[(7)] = inst_102155);

return statearr_102255;
})();
var statearr_102256_102315 = state_102227__$1;
(statearr_102256_102315[(2)] = null);

(statearr_102256_102315[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (29))){
var inst_102207 = (state_102227[(2)]);
var state_102227__$1 = state_102227;
var statearr_102257_102316 = state_102227__$1;
(statearr_102257_102316[(2)] = inst_102207);

(statearr_102257_102316[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (44))){
var inst_102212 = (state_102227[(8)]);
var inst_102217 = (state_102227[(18)]);
var inst_102215 = (state_102227[(2)]);
var inst_102216 = fluree.db.util.async.throw_err.call(null,inst_102215);
var inst_102217__$1 = cljs.core.assoc.call(null,inst_102212,new cljs.core.Keyword(null,"schema","schema",-1582001791),inst_102216);
var inst_102218 = fluree.db.query.schema.setting_map.call(null,inst_102217__$1);
var state_102227__$1 = (function (){var statearr_102258 = state_102227;
(statearr_102258[(18)] = inst_102217__$1);

return statearr_102258;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_102227__$1,(45),inst_102218);
} else {
if((state_val_102228 === (6))){
var state_102227__$1 = state_102227;
var statearr_102259_102317 = state_102227__$1;
(statearr_102259_102317[(2)] = false);

(statearr_102259_102317[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (28))){
var inst_102118 = (state_102227[(14)]);
var inst_102116 = (state_102227[(17)]);
var inst_102117 = (state_102227[(15)]);
var inst_102156 = (state_102227[(16)]);
var inst_102161 = fluree.db.storage.core.read_block.call(null,inst_102116,inst_102117,inst_102118,inst_102156);
var state_102227__$1 = state_102227;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_102227__$1,(30),inst_102161);
} else {
if((state_val_102228 === (25))){
var inst_102151 = (state_102227[(12)]);
var inst_102156 = (state_102227[(16)]);
var inst_102158 = (inst_102156 > inst_102151);
var state_102227__$1 = state_102227;
if(cljs.core.truth_(inst_102158)){
var statearr_102260_102318 = state_102227__$1;
(statearr_102260_102318[(1)] = (27));

} else {
var statearr_102261_102319 = state_102227__$1;
(statearr_102261_102319[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (34))){
var inst_102164 = (state_102227[(13)]);
var inst_102171 = inst_102164.cljs$lang$protocol_mask$partition0$;
var inst_102172 = (inst_102171 & (64));
var inst_102173 = inst_102164.cljs$core$ISeq$;
var inst_102174 = (cljs.core.PROTOCOL_SENTINEL === inst_102173);
var inst_102175 = ((inst_102172) || (inst_102174));
var state_102227__$1 = state_102227;
if(cljs.core.truth_(inst_102175)){
var statearr_102262_102320 = state_102227__$1;
(statearr_102262_102320[(1)] = (37));

} else {
var statearr_102263_102321 = state_102227__$1;
(statearr_102263_102321[(1)] = (38));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (17))){
var inst_102125 = (state_102227[(10)]);
var inst_102118 = (state_102227[(14)]);
var inst_102116 = (state_102227[(17)]);
var inst_102117 = (state_102227[(15)]);
var inst_102094 = (state_102227[(9)]);
var inst_102145 = (state_102227[(2)]);
var inst_102146 = new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(inst_102125);
var inst_102147 = fluree.db.storage.core.reify_db.call(null,inst_102116,inst_102117,inst_102118,inst_102094,inst_102146);
var state_102227__$1 = (function (){var statearr_102264 = state_102227;
(statearr_102264[(19)] = inst_102145);

return statearr_102264;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_102227__$1,(21),inst_102147);
} else {
if((state_val_102228 === (3))){
var inst_102088 = (state_102227[(2)]);
var inst_102089 = cljs.core.async.put_BANG_.call(null,pc,inst_102088);
var state_102227__$1 = state_102227;
var statearr_102265_102322 = state_102227__$1;
(statearr_102265_102322[(2)] = inst_102089);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102227__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (12))){
var state_102227__$1 = state_102227;
var statearr_102266_102323 = state_102227__$1;
(statearr_102266_102323[(2)] = session);

(statearr_102266_102323[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (2))){
var inst_102225 = (state_102227[(2)]);
var state_102227__$1 = state_102227;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_102227__$1,inst_102225);
} else {
if((state_val_102228 === (23))){
var state_102227__$1 = state_102227;
var statearr_102267_102324 = state_102227__$1;
(statearr_102267_102324[(2)] = null);

(statearr_102267_102324[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (35))){
var state_102227__$1 = state_102227;
var statearr_102268_102325 = state_102227__$1;
(statearr_102268_102325[(2)] = false);

(statearr_102268_102325[(1)] = (36));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (19))){
var inst_102125 = (state_102227[(10)]);
var inst_102118 = (state_102227[(14)]);
var inst_102117 = (state_102227[(15)]);
var inst_102134 = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(inst_102125);
var inst_102135 = ["Database ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102117),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102118)," is not currently available. Status is: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102134),"."].join('');
var state_102227__$1 = state_102227;
var statearr_102269_102326 = state_102227__$1;
(statearr_102269_102326[(2)] = inst_102135);

(statearr_102269_102326[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (11))){
var inst_102112 = cljs.core.apply.call(null,cljs.core.hash_map,session);
var state_102227__$1 = state_102227;
var statearr_102270_102327 = state_102227__$1;
(statearr_102270_102327[(2)] = inst_102112);

(statearr_102270_102327[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (9))){
var state_102227__$1 = state_102227;
var statearr_102271_102328 = state_102227__$1;
(statearr_102271_102328[(2)] = false);

(statearr_102271_102328[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (5))){
var inst_102099 = session.cljs$lang$protocol_mask$partition0$;
var inst_102100 = (inst_102099 & (64));
var inst_102101 = session.cljs$core$ISeq$;
var inst_102102 = (cljs.core.PROTOCOL_SENTINEL === inst_102101);
var inst_102103 = ((inst_102100) || (inst_102102));
var state_102227__$1 = state_102227;
if(cljs.core.truth_(inst_102103)){
var statearr_102272_102329 = state_102227__$1;
(statearr_102272_102329[(1)] = (8));

} else {
var statearr_102273_102330 = state_102227__$1;
(statearr_102273_102330[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (14))){
var inst_102125 = (state_102227[(10)]);
var inst_102124 = (state_102227[(2)]);
var inst_102125__$1 = fluree.db.util.async.throw_err.call(null,inst_102124);
var inst_102126 = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(inst_102125__$1);
var inst_102127 = cljs.core.keyword.call(null,inst_102126);
var inst_102128 = cljs.core.not_EQ_.call(null,new cljs.core.Keyword(null,"ready","ready",1086465795),inst_102127);
var state_102227__$1 = (function (){var statearr_102274 = state_102227;
(statearr_102274[(10)] = inst_102125__$1);

return statearr_102274;
})();
if(inst_102128){
var statearr_102275_102331 = state_102227__$1;
(statearr_102275_102331[(1)] = (15));

} else {
var statearr_102276_102332 = state_102227__$1;
(statearr_102276_102332[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (45))){
var inst_102217 = (state_102227[(18)]);
var inst_102220 = (state_102227[(2)]);
var inst_102221 = fluree.db.util.async.throw_err.call(null,inst_102220);
var inst_102222 = cljs.core.assoc.call(null,inst_102217,new cljs.core.Keyword(null,"settings","settings",1556144875),inst_102221);
var inst_102223 = cljs.core.async.put_BANG_.call(null,pc,inst_102222);
var state_102227__$1 = state_102227;
var statearr_102277_102333 = state_102227__$1;
(statearr_102277_102333[(2)] = inst_102223);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102227__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (26))){
var inst_102209 = (state_102227[(2)]);
var state_102227__$1 = state_102227;
var statearr_102278_102334 = state_102227__$1;
(statearr_102278_102334[(2)] = inst_102209);

(statearr_102278_102334[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (16))){
var state_102227__$1 = state_102227;
var statearr_102279_102335 = state_102227__$1;
(statearr_102279_102335[(2)] = null);

(statearr_102279_102335[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (38))){
var state_102227__$1 = state_102227;
var statearr_102280_102336 = state_102227__$1;
(statearr_102280_102336[(2)] = false);

(statearr_102280_102336[(1)] = (39));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (30))){
var inst_102164 = (state_102227[(13)]);
var inst_102163 = (state_102227[(2)]);
var inst_102164__$1 = fluree.db.util.async.throw_err.call(null,inst_102163);
var state_102227__$1 = (function (){var statearr_102281 = state_102227;
(statearr_102281[(13)] = inst_102164__$1);

return statearr_102281;
})();
if(cljs.core.truth_(inst_102164__$1)){
var statearr_102282_102337 = state_102227__$1;
(statearr_102282_102337[(1)] = (31));

} else {
var statearr_102283_102338 = state_102227__$1;
(statearr_102283_102338[(1)] = (32));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (10))){
var inst_102107 = (state_102227[(2)]);
var state_102227__$1 = state_102227;
var statearr_102284_102339 = state_102227__$1;
(statearr_102284_102339[(2)] = inst_102107);

(statearr_102284_102339[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (18))){
var inst_102118 = (state_102227[(14)]);
var inst_102117 = (state_102227[(15)]);
var inst_102132 = ["Database ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102117),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102118)," is not found on this ledger group."].join('');
var state_102227__$1 = state_102227;
var statearr_102285_102340 = state_102227__$1;
(statearr_102285_102340[(2)] = inst_102132);

(statearr_102285_102340[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (42))){
var inst_102155 = (state_102227[(7)]);
var inst_102187 = (state_102227[(2)]);
var inst_102188 = cljs.core.get.call(null,inst_102187,new cljs.core.Keyword(null,"flakes","flakes",1977895739));
var inst_102189 = cljs.core.get.call(null,inst_102187,new cljs.core.Keyword(null,"block","block",664686210));
var inst_102190 = cljs.core.get.call(null,inst_102187,new cljs.core.Keyword(null,"t","t",-1397832519));
var inst_102191 = fluree.db.dbproto._with.call(null,inst_102155,inst_102189,inst_102188);
var state_102227__$1 = (function (){var statearr_102286 = state_102227;
(statearr_102286[(20)] = inst_102190);

return statearr_102286;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_102227__$1,(43),inst_102191);
} else {
if((state_val_102228 === (37))){
var state_102227__$1 = state_102227;
var statearr_102287_102341 = state_102227__$1;
(statearr_102287_102341[(2)] = true);

(statearr_102287_102341[(1)] = (39));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102228 === (8))){
var state_102227__$1 = state_102227;
var statearr_102288_102342 = state_102227__$1;
(statearr_102288_102342[(2)] = true);

(statearr_102288_102342[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto___102293,pc))
;
return ((function (switch__86624__auto__,c__86675__auto___102293,pc){
return (function() {
var fluree$db$session$full_load_existing_db_$_state_machine__86625__auto__ = null;
var fluree$db$session$full_load_existing_db_$_state_machine__86625__auto____0 = (function (){
var statearr_102289 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_102289[(0)] = fluree$db$session$full_load_existing_db_$_state_machine__86625__auto__);

(statearr_102289[(1)] = (1));

return statearr_102289;
});
var fluree$db$session$full_load_existing_db_$_state_machine__86625__auto____1 = (function (state_102227){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_102227);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e102290){if((e102290 instanceof Object)){
var ex__86628__auto__ = e102290;
var statearr_102291_102343 = state_102227;
(statearr_102291_102343[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102227);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e102290;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__102344 = state_102227;
state_102227 = G__102344;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$session$full_load_existing_db_$_state_machine__86625__auto__ = function(state_102227){
switch(arguments.length){
case 0:
return fluree$db$session$full_load_existing_db_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$session$full_load_existing_db_$_state_machine__86625__auto____1.call(this,state_102227);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$session$full_load_existing_db_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$session$full_load_existing_db_$_state_machine__86625__auto____0;
fluree$db$session$full_load_existing_db_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$session$full_load_existing_db_$_state_machine__86625__auto____1;
return fluree$db$session$full_load_existing_db_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___102293,pc))
})();
var state__86677__auto__ = (function (){var statearr_102292 = f__86676__auto__.call(null);
(statearr_102292[(6)] = c__86675__auto___102293);

return statearr_102292;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___102293,pc))
);


return pc;
});
/**
 * Performs a compare and set! to update db, but only does so if
 *   existing db promise-chan is the same as old-db-ch.
 * 
 *   Returns true if successful, false if it did not replace.
 */
fluree.db.session.cas_db_BANG_ = (function fluree$db$session$cas_db_BANG_(session,old_db_ch,new_db_ch){
var new_state = cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),(function (state){
if(cljs.core._EQ_.call(null,old_db_ch,new cljs.core.Keyword("db","db","db/db",993247817).cljs$core$IFn$_invoke$arity$1(state))){
return cljs.core.assoc.call(null,state,new cljs.core.Keyword("db","db","db/db",993247817),new_db_ch);
} else {
return state;
}
}));
return cljs.core._EQ_.call(null,new_db_ch,new cljs.core.Keyword("db","db","db/db",993247817).cljs$core$IFn$_invoke$arity$1(new_state));
});
/**
 * Clears db from cache, forcing a new full load next time db is requested.
 */
fluree.db.session.clear_db_BANG_ = (function fluree$db$session$clear_db_BANG_(session){
return cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),cljs.core.assoc,new cljs.core.Keyword("db","db","db/db",993247817),null);
});
/**
 * Clears any current db that is cached and forces a db reload.
 */
fluree.db.session.reload_db_BANG_ = (function fluree$db$session$reload_db_BANG_(session){
return cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),cljs.core.assoc,new cljs.core.Keyword("db","db","db/db",993247817),fluree.db.session.full_load_existing_db.call(null,session));
});
/**
 * Returns block currently being indexed (truthy), or nil (falsey) if not currently indexing.
 */
fluree.db.session.indexing_QMARK_ = (function fluree$db$session$indexing_QMARK_(session){
return new cljs.core.Keyword("db","indexing","db/indexing",1754750058).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session)));
});
/**
 * Returns block of last indexed block, but only for indexing done by this server.
 */
fluree.db.session.indexed = (function fluree$db$session$indexed(session){
return new cljs.core.Keyword("db","indexed","db/indexed",390759770).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session)));
});
/**
 * Attempts to acquire indexing lock, and if successful returns true, else false.
 */
fluree.db.session.acquire_indexing_lock_BANG_ = (function fluree$db$session$acquire_indexing_lock_BANG_(session,block){
cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),(function (s){
var G__102345 = s;
if((new cljs.core.Keyword("db","indexing","db/indexing",1754750058).cljs$core$IFn$_invoke$arity$1(s) == null)){
return cljs.core.assoc.call(null,G__102345,new cljs.core.Keyword("db","indexing","db/indexing",1754750058),block);
} else {
return G__102345;
}
}));

return cljs.core._EQ_.call(null,block,fluree.db.session.indexing_QMARK_.call(null,session));
});
/**
 * Releases indexing lock, and updates the last indexed value on the connection with provided block number.
 */
fluree.db.session.release_indexing_lock_BANG_ = (function fluree$db$session$release_indexing_lock_BANG_(session,block){
return cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),cljs.core.assoc,new cljs.core.Keyword("db","indexing","db/indexing",1754750058),null,new cljs.core.Keyword("db","indexed","db/indexed",390759770),block);
});
fluree.db.session.alias__GT_id_cache = cljs.core.atom.call(null,cljs.cache.lru_cache_factory.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"threshold","threshold",204221583),(100)], null)));
/**
 * Returns ledger id from alias.
 */
fluree.db.session.ledger_alias__GT_id = (function fluree$db$session$ledger_alias__GT_id(conn,network,alias){
var or__4131__auto__ = cljs.core.get_in.call(null,cljs.core.deref.call(null,fluree.db.session.alias__GT_id_cache),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,alias], null));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var dbid = alias;
cljs.core.swap_BANG_.call(null,fluree.db.session.alias__GT_id_cache,cljs.core.assoc_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,alias], null),dbid);

return dbid;
}
});
/**
 * Resolves a ledger identity in the form of 'network/alias' and returns a
 *   two-tuple of [network ledger-id].
 * 
 *   An alias lookup is always performed first, and if an alias doesn't exist it is assumed
 *   the provided name is a ledger-id.
 * 
 *   If you are providing a ledger-id, and wish to skip an alias lookup, a prefix of '$'
 *   can be used for the name portion of the ledger.
 * 
 *   i.e.
 *   - testnet/testledger - Look for ledger with an alias testledger on network testnet.
 *   - testnet/$testledger - look for a ledger with id testledger on network testnet (skip alias lookup).
 *   - [testnet testledger] - already in form of [network ledger-id]
 */
fluree.db.session.resolve_ledger = (function fluree$db$session$resolve_ledger(conn,ledger){
if(cljs.core.sequential_QMARK_.call(null,ledger)){
return ledger;
} else {
var ledger__$1 = cljs.core.keyword.call(null,ledger);
var network = cljs.core.namespace.call(null,ledger__$1);
var maybe_alias = cljs.core.name.call(null,ledger__$1);
var _ = (cljs.core.truth_((function (){var and__4120__auto__ = network;
if(cljs.core.truth_(and__4120__auto__)){
return maybe_alias;
} else {
return and__4120__auto__;
}
})())?null:(function(){throw cljs.core.ex_info.call(null,["Invalid ledger identity: ",cljs.core.pr_str.call(null,ledger__$1)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-db","db/invalid-db",1792041482)], null))})());
if(clojure.string.starts_with_QMARK_.call(null,maybe_alias,"$")){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,cljs.core.subs.call(null,maybe_alias,(1))], null);
} else {
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,fluree.db.session.ledger_alias__GT_id.call(null,conn,network,maybe_alias),maybe_alias], null);
}
}
});
if((typeof fluree !== 'undefined') && (typeof fluree.db !== 'undefined') && (typeof fluree.db.session !== 'undefined') && (typeof fluree.db.session.process_ledger_update !== 'undefined')){
} else {
fluree.db.session.process_ledger_update = (function (){var method_table__4613__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4614__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4615__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4616__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4617__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"fluree.db.session","process-ledger-update"),((function (method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__){
return (function (_,event_type,___$1){
return event_type;
});})(method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__))
,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4617__auto__,method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__));
})();
}
cljs.core._add_method.call(null,fluree.db.session.process_ledger_update,new cljs.core.Keyword(null,"block","block",664686210),(function (session,event_type,p__102347){
var map__102348 = p__102347;
var map__102348__$1 = (((((!((map__102348 == null))))?(((((map__102348.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__102348.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__102348):map__102348);
var data = map__102348__$1;
var block = cljs.core.get.call(null,map__102348__$1,new cljs.core.Keyword(null,"block","block",664686210));
var t = cljs.core.get.call(null,map__102348__$1,new cljs.core.Keyword(null,"t","t",-1397832519));
var flakes = cljs.core.get.call(null,map__102348__$1,new cljs.core.Keyword(null,"flakes","flakes",1977895739));
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,map__102348,map__102348__$1,data,block,t,flakes){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,map__102348,map__102348__$1,data,block,t,flakes){
return (function (state_102394){
var state_val_102395 = (state_102394[(1)]);
if((state_val_102395 === (7))){
var inst_102358 = (state_102394[(7)]);
var inst_102366 = ((1) + inst_102358);
var inst_102367 = cljs.core._EQ_.call(null,block,inst_102366);
var state_102394__$1 = state_102394;
if(inst_102367){
var statearr_102396_102419 = state_102394__$1;
(statearr_102396_102419[(1)] = (9));

} else {
var statearr_102397_102420 = state_102394__$1;
(statearr_102397_102420[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (1))){
var state_102394__$1 = state_102394;
var statearr_102398_102421 = state_102394__$1;
(statearr_102398_102421[(2)] = null);

(statearr_102398_102421[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (4))){
var inst_102354 = (state_102394[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_102394,(3),Error,null,(2));
var inst_102354__$1 = fluree.db.session.current_db.call(null,session);
var state_102394__$1 = (function (){var statearr_102399 = state_102394;
(statearr_102399[(8)] = inst_102354__$1);

return statearr_102399;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_102394__$1,(5),inst_102354__$1);
} else {
if((state_val_102395 === (13))){
var state_102394__$1 = state_102394;
var statearr_102400_102422 = state_102394__$1;
(statearr_102400_102422[(2)] = null);

(statearr_102400_102422[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (6))){
var inst_102361 = new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(session);
var inst_102362 = new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(session);
var inst_102363 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102361),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102362),": Received block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),", but DB is already more current. No-op."].join('');
var inst_102364 = fluree.db.util.log.info.call(null,inst_102363);
var state_102394__$1 = state_102394;
var statearr_102401_102423 = state_102394__$1;
(statearr_102401_102423[(2)] = inst_102364);

(statearr_102401_102423[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (3))){
var inst_102350 = (state_102394[(2)]);
var state_102394__$1 = state_102394;
var statearr_102402_102424 = state_102394__$1;
(statearr_102402_102424[(2)] = inst_102350);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102394__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (12))){
var inst_102358 = (state_102394[(7)]);
var inst_102379 = new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(session);
var inst_102380 = new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(session);
var inst_102381 = ["Missing block(s): ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102379),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102380),". Received block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),", but latest local block is: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102358),". Forcing a db reload."].join('');
var inst_102382 = fluree.db.util.log.info.call(null,inst_102381);
var inst_102383 = fluree.db.session.reload_db_BANG_.call(null,session);
var state_102394__$1 = (function (){var statearr_102403 = state_102394;
(statearr_102403[(9)] = inst_102382);

return statearr_102403;
})();
var statearr_102404_102425 = state_102394__$1;
(statearr_102404_102425[(2)] = inst_102383);

(statearr_102404_102425[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (2))){
var inst_102392 = (state_102394[(2)]);
var state_102394__$1 = state_102394;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_102394__$1,inst_102392);
} else {
if((state_val_102395 === (11))){
var inst_102388 = (state_102394[(2)]);
var state_102394__$1 = state_102394;
var statearr_102405_102426 = state_102394__$1;
(statearr_102405_102426[(2)] = inst_102388);

(statearr_102405_102426[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (9))){
var inst_102354 = (state_102394[(8)]);
var inst_102358 = (state_102394[(7)]);
var inst_102357 = (state_102394[(10)]);
var inst_102369 = new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(session);
var inst_102370 = new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(session);
var inst_102371 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102369),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102370),": Received block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),", DB at that block, update cached db with flakes."].join('');
var inst_102372 = fluree.db.util.log.trace.call(null,inst_102371);
var inst_102373 = (function (){var current_db_ch = inst_102354;
var current_db = inst_102357;
var current_block = inst_102358;
return ((function (current_db_ch,current_db,current_block,inst_102354,inst_102358,inst_102357,inst_102369,inst_102370,inst_102371,inst_102372,state_val_102395,c__86675__auto__,map__102348,map__102348__$1,data,block,t,flakes){
return (function (p1__102346_SHARP_){
if((p1__102346_SHARP_ instanceof fluree.db.flake.Flake)){
return p1__102346_SHARP_;
} else {
return fluree.db.flake.parts__GT_Flake.call(null,p1__102346_SHARP_);
}
});
;})(current_db_ch,current_db,current_block,inst_102354,inst_102358,inst_102357,inst_102369,inst_102370,inst_102371,inst_102372,state_val_102395,c__86675__auto__,map__102348,map__102348__$1,data,block,t,flakes))
})();
var inst_102374 = cljs.core.map.call(null,inst_102373,flakes);
var inst_102375 = fluree.db.dbproto._with.call(null,inst_102357,block,inst_102374);
var inst_102376 = fluree.db.session.cas_db_BANG_.call(null,session,inst_102354,inst_102375);
var state_102394__$1 = (function (){var statearr_102406 = state_102394;
(statearr_102406[(11)] = inst_102372);

return statearr_102406;
})();
var statearr_102407_102427 = state_102394__$1;
(statearr_102407_102427[(2)] = inst_102376);

(statearr_102407_102427[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (5))){
var inst_102358 = (state_102394[(7)]);
var inst_102357 = (state_102394[(10)]);
var inst_102356 = (state_102394[(2)]);
var inst_102357__$1 = fluree.db.util.async.throw_err.call(null,inst_102356);
var inst_102358__$1 = new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(inst_102357__$1);
var inst_102359 = (block <= inst_102358__$1);
var state_102394__$1 = (function (){var statearr_102408 = state_102394;
(statearr_102408[(7)] = inst_102358__$1);

(statearr_102408[(10)] = inst_102357__$1);

return statearr_102408;
})();
if(cljs.core.truth_(inst_102359)){
var statearr_102409_102428 = state_102394__$1;
(statearr_102409_102428[(1)] = (6));

} else {
var statearr_102410_102429 = state_102394__$1;
(statearr_102410_102429[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (14))){
var inst_102386 = (state_102394[(2)]);
var state_102394__$1 = state_102394;
var statearr_102411_102430 = state_102394__$1;
(statearr_102411_102430[(2)] = inst_102386);

(statearr_102411_102430[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (10))){
var state_102394__$1 = state_102394;
var statearr_102412_102431 = state_102394__$1;
(statearr_102412_102431[(1)] = (12));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102395 === (8))){
var inst_102390 = (state_102394[(2)]);
var state_102394__$1 = state_102394;
var statearr_102414_102432 = state_102394__$1;
(statearr_102414_102432[(2)] = inst_102390);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102394__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,map__102348,map__102348__$1,data,block,t,flakes))
;
return ((function (switch__86624__auto__,c__86675__auto__,map__102348,map__102348__$1,data,block,t,flakes){
return (function() {
var fluree$db$session$state_machine__86625__auto__ = null;
var fluree$db$session$state_machine__86625__auto____0 = (function (){
var statearr_102415 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_102415[(0)] = fluree$db$session$state_machine__86625__auto__);

(statearr_102415[(1)] = (1));

return statearr_102415;
});
var fluree$db$session$state_machine__86625__auto____1 = (function (state_102394){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_102394);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e102416){if((e102416 instanceof Object)){
var ex__86628__auto__ = e102416;
var statearr_102417_102433 = state_102394;
(statearr_102417_102433[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102394);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e102416;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__102434 = state_102394;
state_102394 = G__102434;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$session$state_machine__86625__auto__ = function(state_102394){
switch(arguments.length){
case 0:
return fluree$db$session$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$session$state_machine__86625__auto____1.call(this,state_102394);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$session$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$session$state_machine__86625__auto____0;
fluree$db$session$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$session$state_machine__86625__auto____1;
return fluree$db$session$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,map__102348,map__102348__$1,data,block,t,flakes))
})();
var state__86677__auto__ = (function (){var statearr_102418 = f__86676__auto__.call(null);
(statearr_102418[(6)] = c__86675__auto__);

return statearr_102418;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,map__102348,map__102348__$1,data,block,t,flakes))
);

return c__86675__auto__;
}));
cljs.core._add_method.call(null,fluree.db.session.process_ledger_update,new cljs.core.Keyword(null,"new-index","new-index",518435631),(function (session,header,block){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_102441){
var state_val_102442 = (state_102441[(1)]);
if((state_val_102442 === (1))){
var inst_102435 = fluree.db.session.clear_db_BANG_.call(null,session);
var inst_102436 = new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(session);
var inst_102437 = new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(session);
var inst_102438 = ["Database ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102436),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_102437)," re-indexed as of block: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),"."].join('');
var inst_102439 = fluree.db.util.log.debug.call(null,inst_102438);
var state_102441__$1 = (function (){var statearr_102443 = state_102441;
(statearr_102443[(7)] = inst_102439);

(statearr_102443[(8)] = inst_102435);

return statearr_102443;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_102441__$1,true);
} else {
return null;
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$session$state_machine__86625__auto__ = null;
var fluree$db$session$state_machine__86625__auto____0 = (function (){
var statearr_102444 = [null,null,null,null,null,null,null,null,null];
(statearr_102444[(0)] = fluree$db$session$state_machine__86625__auto__);

(statearr_102444[(1)] = (1));

return statearr_102444;
});
var fluree$db$session$state_machine__86625__auto____1 = (function (state_102441){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_102441);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e102445){if((e102445 instanceof Object)){
var ex__86628__auto__ = e102445;
var statearr_102446_102448 = state_102441;
(statearr_102446_102448[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102441);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e102445;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__102449 = state_102441;
state_102441 = G__102449;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$session$state_machine__86625__auto__ = function(state_102441){
switch(arguments.length){
case 0:
return fluree$db$session$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$session$state_machine__86625__auto____1.call(this,state_102441);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$session$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$session$state_machine__86625__auto____0;
fluree$db$session$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$session$state_machine__86625__auto____1;
return fluree$db$session$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_102447 = f__86676__auto__.call(null);
(statearr_102447[(6)] = c__86675__auto__);

return statearr_102447;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
}));
fluree.db.session.closed_QMARK_ = (function fluree$db$session$closed_QMARK_(session){
return new cljs.core.Keyword(null,"closed?","closed?",-1408769040).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session)));
});
/**
 * Properly shuts down a session.
 *   Returns true if shut down, false if it was already shut down.
 * 
 *   Calling with a session will shut down session, calling with
 *   two arity network + dbid will see if a session is in cache and
 *   then perform the shutdown on the cached session, else will return
 *   false.
 */
fluree.db.session.close = (function fluree$db$session$close(var_args){
var G__102451 = arguments.length;
switch (G__102451) {
case 1:
return fluree.db.session.close.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.session.close.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.session.close.cljs$core$IFn$_invoke$arity$1 = (function (session){
if(cljs.core.truth_(fluree.db.session.closed_QMARK_.call(null,session))){
return false;
} else {
var map__102452 = session;
var map__102452__$1 = (((((!((map__102452 == null))))?(((((map__102452.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__102452.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__102452):map__102452);
var conn = cljs.core.get.call(null,map__102452__$1,new cljs.core.Keyword(null,"conn","conn",278309663));
var update_chan = cljs.core.get.call(null,map__102452__$1,new cljs.core.Keyword(null,"update-chan","update-chan",-863760792));
var transact_chan = cljs.core.get.call(null,map__102452__$1,new cljs.core.Keyword(null,"transact-chan","transact-chan",-1273648840));
var state = cljs.core.get.call(null,map__102452__$1,new cljs.core.Keyword(null,"state","state",-1988618099));
var network = cljs.core.get.call(null,map__102452__$1,new cljs.core.Keyword(null,"network","network",2050004697));
var dbid = cljs.core.get.call(null,map__102452__$1,new cljs.core.Keyword(null,"dbid","dbid",-196647356));
var id = cljs.core.get.call(null,map__102452__$1,new cljs.core.Keyword(null,"id","id",-1388402092));
var closed_QMARK_ = fluree.db.session.closed_QMARK_.call(null,session);
if(cljs.core.truth_(closed_QMARK_)){
fluree.db.session.remove_cache_BANG_.call(null,network,dbid);

return false;
} else {
cljs.core.swap_BANG_.call(null,state,cljs.core.assoc,new cljs.core.Keyword(null,"closed?","closed?",-1408769040),true);

new cljs.core.Keyword(null,"remove-listener","remove-listener",-418647802).cljs$core$IFn$_invoke$arity$1(conn).call(null,network,dbid,id);

cljs.core.async.close_BANG_.call(null,update_chan);

if(cljs.core.truth_(transact_chan)){
cljs.core.async.close_BANG_.call(null,transact_chan);
} else {
}

fluree.db.session.remove_cache_BANG_.call(null,network,dbid);

if(cljs.core.fn_QMARK_.call(null,new cljs.core.Keyword(null,"close","close",1835149582).cljs$core$IFn$_invoke$arity$1(session))){
new cljs.core.Keyword(null,"close","close",1835149582).cljs$core$IFn$_invoke$arity$1(session).call(null);
} else {
}

return true;
}
}
});

fluree.db.session.close.cljs$core$IFn$_invoke$arity$2 = (function (network,dbid){
var temp__5733__auto__ = fluree.db.session.from_cache.call(null,network,dbid);
if(cljs.core.truth_(temp__5733__auto__)){
var session = temp__5733__auto__;
return fluree.db.session.close.call(null,session);
} else {
return false;
}
});

fluree.db.session.close.cljs$lang$maxFixedArity = 2;

/**
 * Creates loop that takes new blocks / index commands and processes them in order
 *   ensuring the consistency of the database.
 */
fluree.db.session.process_ledger_updates = (function fluree$db$session$process_ledger_updates(conn,network,ledger_id,update_chan){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_102504){
var state_val_102505 = (state_102504[(1)]);
if((state_val_102505 === (7))){
var inst_102500 = (state_102504[(2)]);
var state_102504__$1 = state_102504;
var statearr_102506_102530 = state_102504__$1;
(statearr_102506_102530[(2)] = inst_102500);

(statearr_102506_102530[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (1))){
var state_102504__$1 = state_102504;
var statearr_102507_102531 = state_102504__$1;
(statearr_102507_102531[(2)] = null);

(statearr_102507_102531[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (4))){
var inst_102458 = (state_102504[(7)]);
var inst_102457 = (state_102504[(2)]);
var inst_102458__$1 = fluree.db.util.async.throw_err.call(null,inst_102457);
var inst_102459 = fluree.db.session.from_cache.call(null,network,ledger_id);
var inst_102460 = (inst_102458__$1 == null);
var state_102504__$1 = (function (){var statearr_102508 = state_102504;
(statearr_102508[(7)] = inst_102458__$1);

(statearr_102508[(8)] = inst_102459);

return statearr_102508;
})();
if(cljs.core.truth_(inst_102460)){
var statearr_102509_102532 = state_102504__$1;
(statearr_102509_102532[(1)] = (5));

} else {
var statearr_102510_102533 = state_102504__$1;
(statearr_102510_102533[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (15))){
var inst_102458 = (state_102504[(7)]);
var inst_102473 = (state_102504[(2)]);
var inst_102474 = fluree.db.util.log.error.call(null,inst_102473,"Exception processing ledger updates for message: ",inst_102458);
var state_102504__$1 = state_102504;
var statearr_102511_102534 = state_102504__$1;
(statearr_102511_102534[(2)] = inst_102474);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102504__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (13))){
var inst_102496 = (state_102504[(2)]);
var state_102504__$1 = state_102504;
var statearr_102512_102535 = state_102504__$1;
(statearr_102512_102535[(2)] = inst_102496);

(statearr_102512_102535[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (6))){
var inst_102459 = (state_102504[(8)]);
var inst_102465 = (inst_102459 == null);
var state_102504__$1 = state_102504;
if(cljs.core.truth_(inst_102465)){
var statearr_102513_102536 = state_102504__$1;
(statearr_102513_102536[(1)] = (8));

} else {
var statearr_102514_102537 = state_102504__$1;
(statearr_102514_102537[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (17))){
var inst_102489 = (state_102504[(2)]);
var inst_102490 = fluree.db.util.async.throw_err.call(null,inst_102489);
var state_102504__$1 = state_102504;
var statearr_102515_102538 = state_102504__$1;
(statearr_102515_102538[(2)] = inst_102490);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102504__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (3))){
var inst_102502 = (state_102504[(2)]);
var state_102504__$1 = state_102504;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_102504__$1,inst_102502);
} else {
if((state_val_102505 === (12))){
var state_102504__$1 = state_102504;
var statearr_102516_102539 = state_102504__$1;
(statearr_102516_102539[(2)] = null);

(statearr_102516_102539[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (2))){
var state_102504__$1 = state_102504;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_102504__$1,(4),update_chan);
} else {
if((state_val_102505 === (11))){
var state_102504__$1 = state_102504;
var statearr_102517_102540 = state_102504__$1;
(statearr_102517_102540[(2)] = null);

(statearr_102517_102540[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (9))){
var state_102504__$1 = state_102504;
var statearr_102518_102541 = state_102504__$1;
(statearr_102518_102541[(1)] = (11));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (5))){
var inst_102462 = ["Channel closed for session updates for: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"."].join('');
var inst_102463 = fluree.db.util.log.info.call(null,inst_102462);
var state_102504__$1 = state_102504;
var statearr_102520_102542 = state_102504__$1;
(statearr_102520_102542[(2)] = inst_102463);

(statearr_102520_102542[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (14))){
var inst_102492 = (state_102504[(2)]);
var state_102504__$1 = (function (){var statearr_102521 = state_102504;
(statearr_102521[(9)] = inst_102492);

return statearr_102521;
})();
var statearr_102522_102543 = state_102504__$1;
(statearr_102522_102543[(2)] = null);

(statearr_102522_102543[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (16))){
var inst_102458 = (state_102504[(7)]);
var inst_102459 = (state_102504[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_102504,(15),new cljs.core.Keyword(null,"default","default",-1987822328),null,(14));
var inst_102481 = cljs.core.nth.call(null,inst_102458,(0),null);
var inst_102482 = cljs.core.nth.call(null,inst_102458,(1),null);
var inst_102483 = ["[process-ledger-updates[",cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"]: "].join('');
var inst_102484 = cljs.core.pr_str.call(null,inst_102458);
var inst_102485 = fluree.db.util.core.trunc.call(null,inst_102484,(200));
var inst_102486 = fluree.db.util.log.trace.call(null,inst_102483,inst_102485);
var inst_102487 = fluree.db.session.process_ledger_update.call(null,inst_102459,inst_102481,inst_102482);
var state_102504__$1 = (function (){var statearr_102523 = state_102504;
(statearr_102523[(10)] = inst_102486);

return statearr_102523;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_102504__$1,(17),inst_102487);
} else {
if((state_val_102505 === (10))){
var inst_102498 = (state_102504[(2)]);
var state_102504__$1 = state_102504;
var statearr_102524_102544 = state_102504__$1;
(statearr_102524_102544[(2)] = inst_102498);

(statearr_102524_102544[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102505 === (8))){
var inst_102458 = (state_102504[(7)]);
var inst_102467 = cljs.core.first.call(null,inst_102458);
var inst_102468 = cljs.core.pr_str.call(null,inst_102467);
var inst_102469 = ["Ledger update received for session that is no longer open: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),". Message: ",inst_102468].join('');
var inst_102470 = fluree.db.util.log.warn.call(null,inst_102469);
var state_102504__$1 = state_102504;
var statearr_102525_102545 = state_102504__$1;
(statearr_102525_102545[(2)] = inst_102470);

(statearr_102525_102545[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$session$process_ledger_updates_$_state_machine__86625__auto__ = null;
var fluree$db$session$process_ledger_updates_$_state_machine__86625__auto____0 = (function (){
var statearr_102526 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_102526[(0)] = fluree$db$session$process_ledger_updates_$_state_machine__86625__auto__);

(statearr_102526[(1)] = (1));

return statearr_102526;
});
var fluree$db$session$process_ledger_updates_$_state_machine__86625__auto____1 = (function (state_102504){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_102504);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e102527){if((e102527 instanceof Object)){
var ex__86628__auto__ = e102527;
var statearr_102528_102546 = state_102504;
(statearr_102528_102546[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102504);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e102527;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__102547 = state_102504;
state_102504 = G__102547;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$session$process_ledger_updates_$_state_machine__86625__auto__ = function(state_102504){
switch(arguments.length){
case 0:
return fluree$db$session$process_ledger_updates_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$session$process_ledger_updates_$_state_machine__86625__auto____1.call(this,state_102504);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$session$process_ledger_updates_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$session$process_ledger_updates_$_state_machine__86625__auto____0;
fluree$db$session$process_ledger_updates_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$session$process_ledger_updates_$_state_machine__86625__auto____1;
return fluree$db$session$process_ledger_updates_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_102529 = f__86676__auto__.call(null);
(statearr_102529[(6)] = c__86675__auto__);

return statearr_102529;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Creates a connection without first checking if db exists. Only useful if reloading
 *   and replacing an existing DB.
 */
fluree.db.session.session_factory = (function fluree$db$session$session_factory(p__102548){
var map__102549 = p__102548;
var map__102549__$1 = (((((!((map__102549 == null))))?(((((map__102549.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__102549.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__102549):map__102549);
var network = cljs.core.get.call(null,map__102549__$1,new cljs.core.Keyword(null,"network","network",2050004697));
var conn = cljs.core.get.call(null,map__102549__$1,new cljs.core.Keyword(null,"conn","conn",278309663));
var dbid = cljs.core.get.call(null,map__102549__$1,new cljs.core.Keyword(null,"dbid","dbid",-196647356));
var db = cljs.core.get.call(null,map__102549__$1,new cljs.core.Keyword(null,"db","db",993250759));
var transactor_QMARK_ = cljs.core.get.call(null,map__102549__$1,new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057));
var db_name = cljs.core.get.call(null,map__102549__$1,new cljs.core.Keyword(null,"db-name","db-name",1157928745));
var state = cljs.core.get.call(null,map__102549__$1,new cljs.core.Keyword(null,"state","state",-1988618099));
var close = cljs.core.get.call(null,map__102549__$1,new cljs.core.Keyword(null,"close","close",1835149582));
var id = cljs.core.get.call(null,map__102549__$1,new cljs.core.Keyword(null,"id","id",-1388402092));
var schema_cache = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var update_chan = cljs.core.async.chan.call(null);
var transact_chan = (cljs.core.truth_(transactor_QMARK_)?cljs.core.async.chan.call(null):null);
var state__$1 = cljs.core.atom.call(null,cljs.core.merge.call(null,state,new cljs.core.PersistentArrayMap(null, 7, [new cljs.core.Keyword("req","sync","req/sync",-624297648),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword("req","count","req/count",2145574363),(0),new cljs.core.Keyword("req","last","req/last",1105783038),null,new cljs.core.Keyword("db","pending-tx","db/pending-tx",877151620),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword("db","db","db/db",993247817),(cljs.core.truth_(db)?cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),schema_cache):null),new cljs.core.Keyword("db","indexing","db/indexing",1754750058),null,new cljs.core.Keyword(null,"closed?","closed?",-1408769040),false], null)));
var session = fluree.db.session.map__GT_DbSession.call(null,cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"update-chan","update-chan",-863760792),new cljs.core.Keyword(null,"db-name","db-name",1157928745),new cljs.core.Keyword(null,"state","state",-1988618099),new cljs.core.Keyword(null,"close","close",1835149582),new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),new cljs.core.Keyword(null,"transact-chan","transact-chan",-1273648840),new cljs.core.Keyword(null,"network","network",2050004697),new cljs.core.Keyword(null,"blank-db","blank-db",-475098534),new cljs.core.Keyword(null,"conn","conn",278309663)],[dbid,update_chan,db_name,state__$1,close,id,schema_cache,transact_chan,network,null,conn]));
var current_db_fn = ((function (schema_cache,update_chan,transact_chan,state__$1,session,map__102549,map__102549__$1,network,conn,dbid,db,transactor_QMARK_,db_name,state,close,id){
return (function (){
return fluree.db.session.current_db.call(null,session);
});})(schema_cache,update_chan,transact_chan,state__$1,session,map__102549,map__102549__$1,network,conn,dbid,db,transactor_QMARK_,db_name,state,close,id))
;
var blank_db = fluree.db.graphdb.blank_db.call(null,conn,network,dbid,schema_cache,current_db_fn);
return cljs.core.assoc.call(null,session,new cljs.core.Keyword(null,"blank-db","blank-db",-475098534),blank_db);
});
/**
 * Blocks can have multiple transactions. If we are monitoring a single transaction
 *   we take a full block response and return a map with just that transaction's details.
 *   If the entire block details are desired, the block can be used to retrieve them.
 * 
 *   If throw? is true, throws an exception if non-2xx response.
 */
fluree.db.session.block_response__GT_tx_response = (function fluree$db$session$block_response__GT_tx_response(block_result,txid){
var map__102554 = block_result;
var map__102554__$1 = (((((!((map__102554 == null))))?(((((map__102554.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__102554.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__102554):map__102554);
var block = cljs.core.get.call(null,map__102554__$1,new cljs.core.Keyword(null,"block","block",664686210));
var hash = cljs.core.get.call(null,map__102554__$1,new cljs.core.Keyword(null,"hash","hash",-13781596));
var instant = cljs.core.get.call(null,map__102554__$1,new cljs.core.Keyword(null,"instant","instant",655498374));
var txns = cljs.core.get.call(null,map__102554__$1,new cljs.core.Keyword(null,"txns","txns",-1492102421));
var flakes = cljs.core.get.call(null,map__102554__$1,new cljs.core.Keyword(null,"flakes","flakes",1977895739));
var tx_result = (function (){var or__4131__auto__ = cljs.core.get.call(null,txns,cljs.core.keyword.call(null,txid));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.get.call(null,txns,txid);
}
})();
var _ = (cljs.core.truth_(tx_result)?null:(function(){throw cljs.core.ex_info.call(null,["Unexpected error, unable to get tx results for txid ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(txid)," out of block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),"."].join(''),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"status","status",-1997798413),(500),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597),new cljs.core.Keyword(null,"block","block",664686210),cljs.core.pr_str.call(null,block_result)], null))})());
var map__102555 = tx_result;
var map__102555__$1 = (((((!((map__102555 == null))))?(((((map__102555.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__102555.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__102555):map__102555);
var t = cljs.core.get.call(null,map__102555__$1,new cljs.core.Keyword(null,"t","t",-1397832519));
var status = cljs.core.get.call(null,map__102555__$1,new cljs.core.Keyword(null,"status","status",-1997798413));
var t_filter = (((cljs.core.first.call(null,flakes) instanceof fluree.db.flake.Flake))?((function (map__102554,map__102554__$1,block,hash,instant,txns,flakes,tx_result,_,map__102555,map__102555__$1,t,status){
return (function (p1__102551_SHARP_){
return cljs.core._EQ_.call(null,t,p1__102551_SHARP_.t);
});})(map__102554,map__102554__$1,block,hash,instant,txns,flakes,tx_result,_,map__102555,map__102555__$1,t,status))
:((function (map__102554,map__102554__$1,block,hash,instant,txns,flakes,tx_result,_,map__102555,map__102555__$1,t,status){
return (function (p1__102552_SHARP_){
return cljs.core._EQ_.call(null,t,cljs.core.nth.call(null,p1__102552_SHARP_,(3)));
});})(map__102554,map__102554__$1,block,hash,instant,txns,flakes,tx_result,_,map__102555,map__102555__$1,t,status))
);
var response = cljs.core.assoc.call(null,tx_result,new cljs.core.Keyword(null,"block","block",664686210),block,new cljs.core.Keyword(null,"hash","hash",-13781596),hash,new cljs.core.Keyword(null,"instant","instant",655498374),instant,new cljs.core.Keyword(null,"flakes","flakes",1977895739),cljs.core.filter.call(null,t_filter,flakes));
if((new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(response) < (300))){
return response;
} else {
var error_msg = cljs.core.some.call(null,((function (map__102554,map__102554__$1,block,hash,instant,txns,flakes,tx_result,_,map__102555,map__102555__$1,t,status,t_filter,response){
return (function (p1__102553_SHARP_){
if(cljs.core._EQ_.call(null,(109),cljs.core.second.call(null,p1__102553_SHARP_))){
return cljs.core.nth.call(null,p1__102553_SHARP_,(2));
} else {
return null;
}
});})(map__102554,map__102554__$1,block,hash,instant,txns,flakes,tx_result,_,map__102555,map__102555__$1,t,status,t_filter,response))
,new cljs.core.Keyword(null,"flakes","flakes",1977895739).cljs$core$IFn$_invoke$arity$1(response));
var vec__102558 = (cljs.core.truth_(error_msg)?cljs.core.re_find.call(null,/^([0-9]+) ([^ ]+) (.+)/,error_msg):null);
var ___$1 = cljs.core.nth.call(null,vec__102558,(0),null);
var status__$1 = cljs.core.nth.call(null,vec__102558,(1),null);
var error = cljs.core.nth.call(null,vec__102558,(2),null);
var message = cljs.core.nth.call(null,vec__102558,(3),null);
return cljs.core.ex_info.call(null,(function (){var or__4131__auto__ = message;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "Unknown error.";
}
})(),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(response),new cljs.core.Keyword(null,"error","error",-978969032),cljs.core.keyword.call(null,error),new cljs.core.Keyword(null,"meta","meta",1499536964),response], null));
}
});
/**
 * Creates new session and caches it.
 * 
 *   Will tolerate race conditions, and if this call successfully created the session
 *   it will attach an extra key, :new? true, to the session.
 * 
 *   If another process created the session first, will return the other process' session.
 */
fluree.db.session.create_and_cache_session = (function fluree$db$session$create_and_cache_session(opts){
var _ = fluree.db.util.log.trace.call(null,"Create and cache session. Opt keys: ",cljs.core.keys.call(null,opts));
var id = fluree.db.util.core.random_uuid.call(null);
var session = fluree.db.session.session_factory.call(null,cljs.core.assoc.call(null,opts,new cljs.core.Keyword(null,"id","id",-1388402092),id));
var session_STAR_ = fluree.db.session.cache_BANG_.call(null,session);
var new_QMARK_ = cljs.core._EQ_.call(null,id,new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(session_STAR_));
if(new_QMARK_){
return cljs.core.assoc.call(null,session_STAR_,new cljs.core.Keyword(null,"new?","new?",777958557),true);
} else {
return session_STAR_;
}
});
/**
 * Returns connection to the given ledger, and ensures it is cached.
 * 
 *   If 'state' is provided, it will get merged into the connection's state.
 *   Use namespaced keys, so as to not to create a conflict with system state keys.
 * 
 *   Options supported:
 *   - connect? - attempts to create a streaming connection to db - will fail if db does not exist
 *           - ensure is 'false' if trying to create a new db that does not yet exist.
 *   - state    - initial state map to use
 *   - auth     - the auth
 *   - jwt      - jwt from password login
 *   
 */
fluree.db.session.session = (function fluree$db$session$session(var_args){
var G__102562 = arguments.length;
switch (G__102562) {
case 2:
return fluree.db.session.session.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.session.session.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.session.session.cljs$core$IFn$_invoke$arity$2 = (function (conn,ledger){
return fluree.db.session.session.call(null,conn,ledger,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.session.session.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,p__102563){
var map__102564 = p__102563;
var map__102564__$1 = (((((!((map__102564 == null))))?(((((map__102564.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__102564.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__102564):map__102564);
var state = cljs.core.get.call(null,map__102564__$1,new cljs.core.Keyword(null,"state","state",-1988618099));
var connect_QMARK_ = cljs.core.get.call(null,map__102564__$1,new cljs.core.Keyword(null,"connect?","connect?",1326309520));
var auth = cljs.core.get.call(null,map__102564__$1,new cljs.core.Keyword(null,"auth","auth",1389754926));
var jwt = cljs.core.get.call(null,map__102564__$1,new cljs.core.Keyword(null,"jwt","jwt",1504015441));
var vec__102566 = fluree.db.session.resolve_ledger.call(null,conn,ledger);
var network = cljs.core.nth.call(null,vec__102566,(0),null);
var ledger_id = cljs.core.nth.call(null,vec__102566,(1),null);
var ledger_alias = cljs.core.nth.call(null,vec__102566,(2),null);
var connect_QMARK___$1 = ((connect_QMARK_ === false)?false:true);
var transactor_QMARK_ = new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057).cljs$core$IFn$_invoke$arity$1(conn);
var opts = fluree.db.util.core.without_nils.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"auth","auth",1389754926),auth,new cljs.core.Keyword(null,"jwt","jwt",1504015441),jwt], null));
var or__4131__auto__ = fluree.db.session.from_cache.call(null,network,ledger_id);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var session = fluree.db.session.create_and_cache_session.call(null,new cljs.core.PersistentArrayMap(null, 8, [new cljs.core.Keyword(null,"network","network",2050004697),network,new cljs.core.Keyword(null,"dbid","dbid",-196647356),ledger_id,new cljs.core.Keyword(null,"db-name","db-name",1157928745),null,new cljs.core.Keyword(null,"auth","auth",1389754926),auth,new cljs.core.Keyword(null,"jwt","jwt",1504015441),jwt,new cljs.core.Keyword(null,"conn","conn",278309663),conn,new cljs.core.Keyword(null,"state","state",-1988618099),(function (){var or__4131__auto____$1 = state;
if(cljs.core.truth_(or__4131__auto____$1)){
return or__4131__auto____$1;
} else {
return cljs.core.PersistentArrayMap.EMPTY;
}
})(),new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057),transactor_QMARK_], null));
var new_QMARK_ = new cljs.core.Keyword(null,"new?","new?",777958557).cljs$core$IFn$_invoke$arity$1(session) === true;
if(new_QMARK_){
if(connect_QMARK___$1){
fluree.db.operations.subscribe.call(null,session,opts);

new cljs.core.Keyword(null,"add-listener","add-listener",313698051).cljs$core$IFn$_invoke$arity$1(conn).call(null,network,ledger_id,new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(session),((function (session,new_QMARK_,or__4131__auto__,vec__102566,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__102564,map__102564__$1,state,connect_QMARK_,auth,jwt){
return (function (event_type,event_data){
cljs.core.async.put_BANG_.call(null,new cljs.core.Keyword(null,"update-chan","update-chan",-863760792).cljs$core$IFn$_invoke$arity$1(session),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [event_type,event_data], null));

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"block","block",664686210),event_type)){
var temp__5735__auto__ = cljs.core.not_empty.call(null,cljs.core.get.call(null,cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session)),new cljs.core.Keyword("db","pending-tx","db/pending-tx",877151620)));
if(cljs.core.truth_(temp__5735__auto__)){
var tx_callbacks = temp__5735__auto__;
var tids = cljs.core.keys.call(null,new cljs.core.Keyword(null,"txns","txns",-1492102421).cljs$core$IFn$_invoke$arity$1(event_data));
var seq__102569 = cljs.core.seq.call(null,tids);
var chunk__102570 = null;
var count__102571 = (0);
var i__102572 = (0);
while(true){
if((i__102572 < count__102571)){
var tid = cljs.core._nth.call(null,chunk__102570,i__102572);
var temp__5735__auto___102684__$1 = cljs.core.get.call(null,tx_callbacks,fluree.db.util.core.keyword__GT_str.call(null,tid));
if(cljs.core.truth_(temp__5735__auto___102684__$1)){
var keyed_callbacks_102685 = temp__5735__auto___102684__$1;
cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),cljs.core.update,new cljs.core.Keyword("db","pending-tx","db/pending-tx",877151620),cljs.core.dissoc,fluree.db.util.core.keyword__GT_str.call(null,tid));

var tx_response_102686 = fluree.db.session.block_response__GT_tx_response.call(null,event_data,tid);
var seq__102613_102687 = cljs.core.seq.call(null,keyed_callbacks_102685);
var chunk__102614_102688 = null;
var count__102615_102689 = (0);
var i__102616_102690 = (0);
while(true){
if((i__102616_102690 < count__102615_102689)){
var vec__102625_102691 = cljs.core._nth.call(null,chunk__102614_102688,i__102616_102690);
var k_102692 = cljs.core.nth.call(null,vec__102625_102691,(0),null);
var f_102693 = cljs.core.nth.call(null,vec__102625_102691,(1),null);
try{f_102693.call(null,tx_response_102686);
}catch (e102628){var e_102694 = e102628;
fluree.db.util.log.error.call(null,e_102694,["Error processing transaction callback for tid: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tid),"."].join(''));
}

var G__102695 = seq__102613_102687;
var G__102696 = chunk__102614_102688;
var G__102697 = count__102615_102689;
var G__102698 = (i__102616_102690 + (1));
seq__102613_102687 = G__102695;
chunk__102614_102688 = G__102696;
count__102615_102689 = G__102697;
i__102616_102690 = G__102698;
continue;
} else {
var temp__5735__auto___102699__$2 = cljs.core.seq.call(null,seq__102613_102687);
if(temp__5735__auto___102699__$2){
var seq__102613_102700__$1 = temp__5735__auto___102699__$2;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__102613_102700__$1)){
var c__4550__auto___102701 = cljs.core.chunk_first.call(null,seq__102613_102700__$1);
var G__102702 = cljs.core.chunk_rest.call(null,seq__102613_102700__$1);
var G__102703 = c__4550__auto___102701;
var G__102704 = cljs.core.count.call(null,c__4550__auto___102701);
var G__102705 = (0);
seq__102613_102687 = G__102702;
chunk__102614_102688 = G__102703;
count__102615_102689 = G__102704;
i__102616_102690 = G__102705;
continue;
} else {
var vec__102629_102706 = cljs.core.first.call(null,seq__102613_102700__$1);
var k_102707 = cljs.core.nth.call(null,vec__102629_102706,(0),null);
var f_102708 = cljs.core.nth.call(null,vec__102629_102706,(1),null);
try{f_102708.call(null,tx_response_102686);
}catch (e102632){var e_102709 = e102632;
fluree.db.util.log.error.call(null,e_102709,["Error processing transaction callback for tid: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tid),"."].join(''));
}

var G__102710 = cljs.core.next.call(null,seq__102613_102700__$1);
var G__102711 = null;
var G__102712 = (0);
var G__102713 = (0);
seq__102613_102687 = G__102710;
chunk__102614_102688 = G__102711;
count__102615_102689 = G__102712;
i__102616_102690 = G__102713;
continue;
}
} else {
}
}
break;
}
} else {
}


var G__102714 = seq__102569;
var G__102715 = chunk__102570;
var G__102716 = count__102571;
var G__102717 = (i__102572 + (1));
seq__102569 = G__102714;
chunk__102570 = G__102715;
count__102571 = G__102716;
i__102572 = G__102717;
continue;
} else {
var temp__5735__auto____$1 = cljs.core.seq.call(null,seq__102569);
if(temp__5735__auto____$1){
var seq__102569__$1 = temp__5735__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__102569__$1)){
var c__4550__auto__ = cljs.core.chunk_first.call(null,seq__102569__$1);
var G__102718 = cljs.core.chunk_rest.call(null,seq__102569__$1);
var G__102719 = c__4550__auto__;
var G__102720 = cljs.core.count.call(null,c__4550__auto__);
var G__102721 = (0);
seq__102569 = G__102718;
chunk__102570 = G__102719;
count__102571 = G__102720;
i__102572 = G__102721;
continue;
} else {
var tid = cljs.core.first.call(null,seq__102569__$1);
var temp__5735__auto___102722__$2 = cljs.core.get.call(null,tx_callbacks,fluree.db.util.core.keyword__GT_str.call(null,tid));
if(cljs.core.truth_(temp__5735__auto___102722__$2)){
var keyed_callbacks_102723 = temp__5735__auto___102722__$2;
cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),cljs.core.update,new cljs.core.Keyword("db","pending-tx","db/pending-tx",877151620),cljs.core.dissoc,fluree.db.util.core.keyword__GT_str.call(null,tid));

var tx_response_102724 = fluree.db.session.block_response__GT_tx_response.call(null,event_data,tid);
var seq__102633_102725 = cljs.core.seq.call(null,keyed_callbacks_102723);
var chunk__102634_102726 = null;
var count__102635_102727 = (0);
var i__102636_102728 = (0);
while(true){
if((i__102636_102728 < count__102635_102727)){
var vec__102645_102729 = cljs.core._nth.call(null,chunk__102634_102726,i__102636_102728);
var k_102730 = cljs.core.nth.call(null,vec__102645_102729,(0),null);
var f_102731 = cljs.core.nth.call(null,vec__102645_102729,(1),null);
try{f_102731.call(null,tx_response_102724);
}catch (e102648){var e_102732 = e102648;
fluree.db.util.log.error.call(null,e_102732,["Error processing transaction callback for tid: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tid),"."].join(''));
}

var G__102733 = seq__102633_102725;
var G__102734 = chunk__102634_102726;
var G__102735 = count__102635_102727;
var G__102736 = (i__102636_102728 + (1));
seq__102633_102725 = G__102733;
chunk__102634_102726 = G__102734;
count__102635_102727 = G__102735;
i__102636_102728 = G__102736;
continue;
} else {
var temp__5735__auto___102737__$3 = cljs.core.seq.call(null,seq__102633_102725);
if(temp__5735__auto___102737__$3){
var seq__102633_102738__$1 = temp__5735__auto___102737__$3;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__102633_102738__$1)){
var c__4550__auto___102739 = cljs.core.chunk_first.call(null,seq__102633_102738__$1);
var G__102740 = cljs.core.chunk_rest.call(null,seq__102633_102738__$1);
var G__102741 = c__4550__auto___102739;
var G__102742 = cljs.core.count.call(null,c__4550__auto___102739);
var G__102743 = (0);
seq__102633_102725 = G__102740;
chunk__102634_102726 = G__102741;
count__102635_102727 = G__102742;
i__102636_102728 = G__102743;
continue;
} else {
var vec__102649_102744 = cljs.core.first.call(null,seq__102633_102738__$1);
var k_102745 = cljs.core.nth.call(null,vec__102649_102744,(0),null);
var f_102746 = cljs.core.nth.call(null,vec__102649_102744,(1),null);
try{f_102746.call(null,tx_response_102724);
}catch (e102652){var e_102747 = e102652;
fluree.db.util.log.error.call(null,e_102747,["Error processing transaction callback for tid: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tid),"."].join(''));
}

var G__102748 = cljs.core.next.call(null,seq__102633_102738__$1);
var G__102749 = null;
var G__102750 = (0);
var G__102751 = (0);
seq__102633_102725 = G__102748;
chunk__102634_102726 = G__102749;
count__102635_102727 = G__102750;
i__102636_102728 = G__102751;
continue;
}
} else {
}
}
break;
}
} else {
}


var G__102752 = cljs.core.next.call(null,seq__102569__$1);
var G__102753 = null;
var G__102754 = (0);
var G__102755 = (0);
seq__102569 = G__102752;
chunk__102570 = G__102753;
count__102571 = G__102754;
i__102572 = G__102755;
continue;
}
} else {
return null;
}
}
break;
}
} else {
return null;
}
} else {
return null;
}
});})(session,new_QMARK_,or__4131__auto__,vec__102566,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__102564,map__102564__$1,state,connect_QMARK_,auth,jwt))
);

fluree.db.session.process_ledger_updates.call(null,conn,network,ledger_id,new cljs.core.Keyword(null,"update-chan","update-chan",-863760792).cljs$core$IFn$_invoke$arity$1(session));
} else {
}

if(cljs.core.truth_(transactor_QMARK_)){
var transact_handler_102756 = new cljs.core.Keyword(null,"transact-handler","transact-handler",-745499037).cljs$core$IFn$_invoke$arity$1(conn);
var c__86675__auto___102757 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___102757,transact_handler_102756,session,new_QMARK_,or__4131__auto__,vec__102566,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__102564,map__102564__$1,state,connect_QMARK_,auth,jwt){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___102757,transact_handler_102756,session,new_QMARK_,or__4131__auto__,vec__102566,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__102564,map__102564__$1,state,connect_QMARK_,auth,jwt){
return (function (state_102669){
var state_val_102670 = (state_102669[(1)]);
if((state_val_102670 === (1))){
var state_102669__$1 = state_102669;
var statearr_102671_102758 = state_102669__$1;
(statearr_102671_102758[(2)] = null);

(statearr_102671_102758[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102670 === (2))){
var inst_102654 = new cljs.core.Keyword(null,"transact-chan","transact-chan",-1273648840).cljs$core$IFn$_invoke$arity$1(session);
var state_102669__$1 = state_102669;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_102669__$1,(4),inst_102654);
} else {
if((state_val_102670 === (3))){
var inst_102667 = (state_102669[(2)]);
var state_102669__$1 = state_102669;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_102669__$1,inst_102667);
} else {
if((state_val_102670 === (4))){
var inst_102656 = (state_102669[(7)]);
var inst_102656__$1 = (state_102669[(2)]);
var inst_102657 = (inst_102656__$1 == null);
var state_102669__$1 = (function (){var statearr_102672 = state_102669;
(statearr_102672[(7)] = inst_102656__$1);

return statearr_102672;
})();
if(cljs.core.truth_(inst_102657)){
var statearr_102673_102759 = state_102669__$1;
(statearr_102673_102759[(1)] = (5));

} else {
var statearr_102674_102760 = state_102669__$1;
(statearr_102674_102760[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102670 === (5))){
var inst_102659 = ["Transactor session closing for db: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"[",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_alias),"]"].join('');
var inst_102660 = fluree.db.util.log.info.call(null,inst_102659);
var state_102669__$1 = state_102669;
var statearr_102675_102761 = state_102669__$1;
(statearr_102675_102761[(2)] = inst_102660);

(statearr_102675_102761[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102670 === (6))){
var inst_102656 = (state_102669[(7)]);
var inst_102662 = transact_handler_102756.call(null,conn,inst_102656);
var state_102669__$1 = (function (){var statearr_102676 = state_102669;
(statearr_102676[(8)] = inst_102662);

return statearr_102676;
})();
var statearr_102677_102762 = state_102669__$1;
(statearr_102677_102762[(2)] = null);

(statearr_102677_102762[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_102670 === (7))){
var inst_102665 = (state_102669[(2)]);
var state_102669__$1 = state_102669;
var statearr_102678_102763 = state_102669__$1;
(statearr_102678_102763[(2)] = inst_102665);

(statearr_102678_102763[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__86675__auto___102757,transact_handler_102756,session,new_QMARK_,or__4131__auto__,vec__102566,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__102564,map__102564__$1,state,connect_QMARK_,auth,jwt))
;
return ((function (switch__86624__auto__,c__86675__auto___102757,transact_handler_102756,session,new_QMARK_,or__4131__auto__,vec__102566,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__102564,map__102564__$1,state,connect_QMARK_,auth,jwt){
return (function() {
var fluree$db$session$state_machine__86625__auto__ = null;
var fluree$db$session$state_machine__86625__auto____0 = (function (){
var statearr_102679 = [null,null,null,null,null,null,null,null,null];
(statearr_102679[(0)] = fluree$db$session$state_machine__86625__auto__);

(statearr_102679[(1)] = (1));

return statearr_102679;
});
var fluree$db$session$state_machine__86625__auto____1 = (function (state_102669){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_102669);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e102680){if((e102680 instanceof Object)){
var ex__86628__auto__ = e102680;
var statearr_102681_102764 = state_102669;
(statearr_102681_102764[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_102669);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e102680;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__102765 = state_102669;
state_102669 = G__102765;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$session$state_machine__86625__auto__ = function(state_102669){
switch(arguments.length){
case 0:
return fluree$db$session$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$session$state_machine__86625__auto____1.call(this,state_102669);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$session$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$session$state_machine__86625__auto____0;
fluree$db$session$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$session$state_machine__86625__auto____1;
return fluree$db$session$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___102757,transact_handler_102756,session,new_QMARK_,or__4131__auto__,vec__102566,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__102564,map__102564__$1,state,connect_QMARK_,auth,jwt))
})();
var state__86677__auto__ = (function (){var statearr_102682 = f__86676__auto__.call(null);
(statearr_102682[(6)] = c__86675__auto___102757);

return statearr_102682;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___102757,transact_handler_102756,session,new_QMARK_,or__4131__auto__,vec__102566,network,ledger_id,ledger_alias,connect_QMARK___$1,transactor_QMARK_,opts,map__102564,map__102564__$1,state,connect_QMARK_,auth,jwt))
);

} else {
}
} else {
}

return session;
}
});

fluree.db.session.session.cljs$lang$maxFixedArity = 3;

/**
 * Gets the latest db from the central DB atom if available, or loads it from scratch.
 *   DB is returned as a core async promise channel.
 */
fluree.db.session.current_db = (function fluree$db$session$current_db(session){
cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),(function (p1__102766_SHARP_){
return cljs.core.assoc.call(null,p1__102766_SHARP_,new cljs.core.Keyword("req","last","req/last",1105783038),fluree.db.util.core.current_time_millis.call(null),new cljs.core.Keyword("req","count","req/count",2145574363),(new cljs.core.Keyword("req","count","req/count",2145574363).cljs$core$IFn$_invoke$arity$1(p1__102766_SHARP_) + (1)));
}));

var db = new cljs.core.Keyword("db","db","db/db",993247817).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session)));
if((db == null)){
cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225).cljs$core$IFn$_invoke$arity$1(session),cljs.core.empty);

cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),((function (db){
return (function (p1__102767_SHARP_){
return cljs.core.assoc.call(null,p1__102767_SHARP_,new cljs.core.Keyword("db","db","db/db",993247817),fluree.db.session.full_load_existing_db.call(null,session));
});})(db))
);

return new cljs.core.Keyword("db","db","db/db",993247817).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session)));
} else {
return db;
}
});
/**
 * Creates a session and returns a blank db.
 */
fluree.db.session.blank_db = (function fluree$db$session$blank_db(conn,ledger){
var session = fluree.db.session.session.call(null,conn,ledger,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"connect?","connect?",1326309520),false], null));
return new cljs.core.Keyword(null,"blank-db","blank-db",-475098534).cljs$core$IFn$_invoke$arity$1(session);
});
/**
 * Returns core async channel containing current db
 */
fluree.db.session.db = (function fluree$db$session$db(conn,ledger,opts){
var session = fluree.db.session.session.call(null,conn,ledger,opts);
return fluree.db.session.current_db.call(null,session);
});
/**
 * Useful for a shutdown process. Closes all sessions for a given connection-id.
 *   If no connection given, closes all sessions.
 */
fluree.db.session.close_all_sessions = (function fluree$db$session$close_all_sessions(var_args){
var G__102770 = arguments.length;
switch (G__102770) {
case 0:
return fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$0 = (function (){
return fluree.db.session.close_all_sessions.call(null,null);
});

fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$1 = (function (conn_id){
var sessions = (function (){var G__102771 = cljs.core.vals.call(null,cljs.core.deref.call(null,fluree.db.session.session_cache));
if(cljs.core.truth_(conn_id)){
return cljs.core.filter.call(null,((function (G__102771){
return (function (p1__102768_SHARP_){
return cljs.core._EQ_.call(null,conn_id,cljs.core.get_in.call(null,p1__102768_SHARP_,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"conn","conn",278309663),new cljs.core.Keyword(null,"id","id",-1388402092)], null)));
});})(G__102771))
,G__102771);
} else {
return G__102771;
}
})();
var seq__102772 = cljs.core.seq.call(null,sessions);
var chunk__102773 = null;
var count__102774 = (0);
var i__102775 = (0);
while(true){
if((i__102775 < count__102774)){
var session = cljs.core._nth.call(null,chunk__102773,i__102775);
fluree.db.session.close.call(null,session);


var G__102777 = seq__102772;
var G__102778 = chunk__102773;
var G__102779 = count__102774;
var G__102780 = (i__102775 + (1));
seq__102772 = G__102777;
chunk__102773 = G__102778;
count__102774 = G__102779;
i__102775 = G__102780;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq.call(null,seq__102772);
if(temp__5735__auto__){
var seq__102772__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__102772__$1)){
var c__4550__auto__ = cljs.core.chunk_first.call(null,seq__102772__$1);
var G__102781 = cljs.core.chunk_rest.call(null,seq__102772__$1);
var G__102782 = c__4550__auto__;
var G__102783 = cljs.core.count.call(null,c__4550__auto__);
var G__102784 = (0);
seq__102772 = G__102781;
chunk__102773 = G__102782;
count__102774 = G__102783;
i__102775 = G__102784;
continue;
} else {
var session = cljs.core.first.call(null,seq__102772__$1);
fluree.db.session.close.call(null,session);


var G__102785 = cljs.core.next.call(null,seq__102772__$1);
var G__102786 = null;
var G__102787 = (0);
var G__102788 = (0);
seq__102772 = G__102785;
chunk__102773 = G__102786;
count__102774 = G__102787;
i__102775 = G__102788;
continue;
}
} else {
return null;
}
}
break;
}
});

fluree.db.session.close_all_sessions.cljs$lang$maxFixedArity = 1;

/**
 * Adds a callback function to call when we see a completed transaction in a block
 *   for the given tid.
 * 
 *   Key is any arbitrary key provided that allows the callback to be unregistered later
 *   with monitor-tx-remove. It must be unique.
 */
fluree.db.session.monitor_tx = (function fluree$db$session$monitor_tx(session,tid,key,f){
return cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),cljs.core.update_in,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("db","pending-tx","db/pending-tx",877151620),tid,key], null),(function (x){
if(cljs.core.truth_(x)){
throw cljs.core.ex_info.call(null,"Key provided to monitor-tx must be unique.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)], null));
} else {
}

return f;
}));
});
/**
 * Removes callback from supplied transaction id and key.
 * 
 *   Will return true if callback successfully removed, else false if
 *   callback didn't exist.
 */
fluree.db.session.monitor_tx_remove = (function fluree$db$session$monitor_tx_remove(session,tid,key){
if(cljs.core.truth_(cljs.core.get_in.call(null,cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session)),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword("db","pending-tx","db/pending-tx",877151620),tid,key], null)))){
cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(session),cljs.core.update,new cljs.core.Keyword("db","pending-tx","db/pending-tx",877151620),(function (pending_txs){
var updated = cljs.core.update.call(null,pending_txs,tid,cljs.core.dissoc,key);
if(cljs.core.empty_QMARK_.call(null,cljs.core.get.call(null,updated,tid))){
return cljs.core.dissoc.call(null,updated,tid);
} else {
return updated;
}
}));

return true;
} else {
return false;
}
});
