// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.spec');
goog.require('cljs.core');
goog.require('fluree.db.util.json');
goog.require('alphabase.core');
goog.require('fluree.db.util.core');
fluree.db.spec.EMAIL = /[a-z0-9!#$%&'*+\/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+\/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/;
fluree.db.spec.safe_name = (function fluree$db$spec$safe_name(x){
try{return cljs.core.name.call(null,x);
}catch (e96229){var e = e96229;
return cljs.core.str.cljs$core$IFn$_invoke$arity$1(x);
}});
/**
 * (type-check type object) transforms a object to match the type. If it cannot be transformed, it throws an ex-info with a map from paths into the object to errors encountered at those paths.
 */
fluree.db.spec.type_check = (function fluree$db$spec$type_check(var_args){
var G__96232 = arguments.length;
switch (G__96232) {
case 2:
return fluree.db.spec.type_check.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return fluree.db.spec.type_check.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.spec.type_check.cljs$core$IFn$_invoke$arity$2 = (function (object,spec){
var errors = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var conformed = fluree.db.spec.type_check.call(null,object,spec,cljs.core.PersistentVector.EMPTY,errors);
var error_seq = cljs.core.reduce_kv.call(null,((function (errors,conformed){
return (function (e,k,v){
return cljs.core.conj.call(null,e,cljs.core.assoc.call(null,v,new cljs.core.Keyword(null,"path","path",-188191168),k));
});})(errors,conformed))
,cljs.core.PersistentVector.EMPTY,cljs.core.deref.call(null,errors));
if(cljs.core.empty_QMARK_.call(null,error_seq)){
return conformed;
} else {
throw cljs.core.ex_info.call(null,["Could not conform object: ",cljs.core.pr_str.call(null,object)," to type ",cljs.core.pr_str.call(null,spec)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"body","body",-2049205669),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"message","message",-406056002),cljs.core.apply.call(null,cljs.core.print_str,"Validation error.",cljs.core.mapv.call(null,((function (errors,conformed,error_seq){
return (function (p1__96230_SHARP_){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"message","message",-406056002).cljs$core$IFn$_invoke$arity$1(p1__96230_SHARP_))," at ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.mapv.call(null,fluree.db.spec.safe_name,new cljs.core.Keyword(null,"path","path",-188191168).cljs$core$IFn$_invoke$arity$1(p1__96230_SHARP_))),". Expected ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fluree.db.spec.safe_name.call(null,new cljs.core.Keyword(null,"spec","spec",347520401).cljs$core$IFn$_invoke$arity$1(p1__96230_SHARP_)))," but got \"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"object","object",1474613949).cljs$core$IFn$_invoke$arity$1(p1__96230_SHARP_)),"\"."].join('');
});})(errors,conformed,error_seq))
,error_seq)),new cljs.core.Keyword(null,"errors","errors",-908790718),error_seq], null)], null));
}
});

fluree.db.spec.type_check.cljs$core$IFn$_invoke$arity$4 = (function (object,spec,path,errors_atom){
try{var error = (function() { 
var G__96242__delegate = function (p__96234){
var vec__96235 = p__96234;
var message = cljs.core.nth.call(null,vec__96235,(0),null);
throw cljs.core.ex_info.call(null,(function (){var or__4131__auto__ = message;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return "Invalid object";
}
})(),cljs.core.PersistentArrayMap.EMPTY);
};
var G__96242 = function (var_args){
var p__96234 = null;
if (arguments.length > 0) {
var G__96243__i = 0, G__96243__a = new Array(arguments.length -  0);
while (G__96243__i < G__96243__a.length) {G__96243__a[G__96243__i] = arguments[G__96243__i + 0]; ++G__96243__i;}
  p__96234 = new cljs.core.IndexedSeq(G__96243__a,0,null);
} 
return G__96242__delegate.call(this,p__96234);};
G__96242.cljs$lang$maxFixedArity = 0;
G__96242.cljs$lang$applyTo = (function (arglist__96244){
var p__96234 = cljs.core.seq(arglist__96244);
return G__96242__delegate(p__96234);
});
G__96242.cljs$core$IFn$_invoke$arity$variadic = G__96242__delegate;
return G__96242;
})()
;
var spec__$1 = (((spec instanceof cljs.core.Keyword))?cljs.core.name.call(null,spec):spec);
if((spec__$1 == null)){
if((object == null)){
return object;
} else {
return error.call(null);
}
} else {
if(typeof spec__$1 === 'string'){
var optional = spec__$1.endsWith("?");
var base_spec = (cljs.core.truth_(optional)?cljs.core.subs.call(null,spec__$1,(0),(spec__$1.length() - (1))):spec__$1);
if(cljs.core.truth_((function (){var and__4120__auto__ = optional;
if(cljs.core.truth_(and__4120__auto__)){
return (object == null);
} else {
return and__4120__auto__;
}
})())){
return null;
} else {
if(cljs.core._EQ_.call(null,base_spec,"any")){
return object;
} else {
if(cljs.core._EQ_.call(null,base_spec,"boolean")){
if(cljs.core.boolean_QMARK_.call(null,object)){
return object;
} else {
return error.call(null);
}
} else {
if(cljs.core._EQ_.call(null,base_spec,"int")){
return (object | (0));
} else {
if(cljs.core._EQ_.call(null,base_spec,"long")){
if(typeof object === 'number'){
return cljs.core.long$.call(null,object);
} else {
if(typeof object === 'string'){
var i = parseInt(object);
if((((fluree.db.util.core.min_long <= i)) && ((i <= fluree.db.util.core.max_long)))){
return i;
} else {
return error.call(null,["Long ",object," is outside of javascript max integer size of 2^53 - 1."].join(''));
}
} else {
return error.call(null);

}
}
} else {
if(cljs.core._EQ_.call(null,base_spec,"bigint")){
var i = ((typeof object === 'string')?parseInt(object):object);
if((((fluree.db.util.core.min_long <= i)) && ((i <= fluree.db.util.core.max_long)))){
return i;
} else {
return error.call(null,["Bigintegers are not supported in javascript. max integer size of 2^53 - 1, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(object)].join(''));
}
} else {
if(cljs.core._EQ_.call(null,base_spec,"float")){
if(typeof object === 'number'){
return object;
} else {
return error.call(null);
}
} else {
if(cljs.core._EQ_.call(null,base_spec,"double")){
if(typeof object === 'number'){
return object;
} else {
if(typeof object === 'string'){
return parseFloat(object);
} else {
return error.call(null);

}
}
} else {
if(cljs.core._EQ_.call(null,base_spec,"bigdec")){
return error.call(null,["Javascript does not support big decimals. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(object)].join(''));
} else {
if(cljs.core._EQ_.call(null,base_spec,"string")){
if((object instanceof cljs.core.Keyword)){
return cljs.core.subs.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(object),(1));
} else {
return cljs.core.str.cljs$core$IFn$_invoke$arity$1(object);

}
} else {
if(cljs.core._EQ_.call(null,base_spec,"bytes")){
if(typeof object === 'string'){
var uc = object.toLowerCase();
if(cljs.core.truth_(cljs.core.re_matches.call(null,/^[0-9a-f]+$/,uc))){
return uc;
} else {
return error.call(null,"Bytes type must be in hex string form.");
}
} else {
if(cljs.core.sequential_QMARK_.call(null,cljs.core.js__GT_clj.call(null,object))){
return alphabase.core.bytes__GT_hex.call(null,object);
} else {
return error.call(null);

}
}
} else {
if(cljs.core._EQ_.call(null,base_spec,"instant")){
try{return fluree.db.util.core.date__GT_millis.call(null,object);
}catch (e96238){var e = e96238;
return error.call(null);
}} else {
if(cljs.core._EQ_.call(null,base_spec,"uri")){
return cljs.core.str.cljs$core$IFn$_invoke$arity$1(object);
} else {
if(cljs.core._EQ_.call(null,base_spec,"email")){
if(cljs.core.truth_((function (){var and__4120__auto__ = typeof object === 'string';
if(and__4120__auto__){
return cljs.core.re_find.call(null,fluree.db.spec.EMAIL,object);
} else {
return and__4120__auto__;
}
})())){
return object;
} else {
return error.call(null);
}
} else {
if(((cljs.core._EQ_.call(null,base_spec,"tag")) || (cljs.core._EQ_.call(null,base_spec,"ref")))){
return cljs.core.long$.call(null,object);
} else {
if(cljs.core._EQ_.call(null,base_spec,"uuid")){
if(typeof object === 'string'){
return object;
} else {
if(cljs.core.uuid_QMARK_.call(null,object)){
return cljs.core.str.cljs$core$IFn$_invoke$arity$1(object);
} else {
return error.call(null);

}
}
} else {
if(cljs.core._EQ_.call(null,base_spec,"json")){
try{if(typeof object === 'string'){
fluree.db.util.json.parse.call(null,object);

return object;
} else {
return fluree.db.util.json.stringify.call(null,object);
}
}catch (e96239){var _ = e96239;
return error.call(null);
}} else {
if(cljs.core._EQ_.call(null,base_spec,"geojson")){
try{var parsed = ((typeof object === 'string')?fluree.db.util.json.parse.call(null,object):object);
if(cljs.core.truth_(fluree.db.util.json.valid_geojson_QMARK_.call(null,parsed))){
if(typeof object === 'string'){
return object;
} else {
return fluree.db.util.json.stringify.call(null,object);
}
} else {
return error.call(null);
}
}catch (e96240){var _ = e96240;
return error.call(null);
}} else {
return error.call(null,["Unknown base spec ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(base_spec)].join(''));

}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
} else {
return error.call(null,["Unknown type ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(spec__$1)].join(''));

}
}
}catch (e96233){var e = e96233;
cljs.core.swap_BANG_.call(null,errors_atom,cljs.core.assoc,path,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"message","message",-406056002),cljs.core.str.cljs$core$IFn$_invoke$arity$1(e),new cljs.core.Keyword(null,"spec","spec",347520401),spec,new cljs.core.Keyword(null,"object","object",1474613949),object], null));

return object;
}});

fluree.db.spec.type_check.cljs$lang$maxFixedArity = 4;

