// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.util.async');
goog.require('cljs.core');
goog.require('cljs.core.async');
fluree.db.util.async.throw_err = (function fluree$db$util$async$throw_err(e){
if((e instanceof Error)){
throw e;
} else {
}

return e;
});
/**
 * Helper method that checks if x is Exception and if yes, wraps it in a new
 *   exception, passing though ex-data if any, and throws it. The wrapping is done
 *   to maintain a full stack trace when jumping between multiple contexts.
 */
fluree.db.util.async.throw_if_exception = (function fluree$db$util$async$throw_if_exception(x){
if((x instanceof Error)){
throw cljs.core.ex_info.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(x),(function (){var or__4131__auto__ = cljs.core.ex_data.call(null,x);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.PersistentArrayMap.EMPTY;
}
})(),x);
} else {
return x;
}
});
/**
 * Takes a sequence of single-value chans and returns the conjoined into collection.
 *   Realizes entire channel sequence first, and if an error value exists returns just the exception.
 */
fluree.db.util.async.merge_into_QMARK_ = (function fluree$db$util$async$merge_into_QMARK_(coll,chs){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_88258){
var state_val_88259 = (state_88258[(1)]);
if((state_val_88259 === (7))){
var inst_88235 = (state_88258[(7)]);
var state_88258__$1 = state_88258;
var statearr_88260_88276 = state_88258__$1;
(statearr_88260_88276[(2)] = inst_88235);

(statearr_88260_88276[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88259 === (1))){
var state_88258__$1 = state_88258;
var statearr_88261_88277 = state_88258__$1;
(statearr_88261_88277[(2)] = null);

(statearr_88261_88277[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88259 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_88258,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_88231 = cljs.core.seq.call(null,chs);
var inst_88232 = cljs.core.first.call(null,inst_88231);
var inst_88233 = cljs.core.next.call(null,inst_88231);
var inst_88234 = chs;
var inst_88235 = coll;
var state_88258__$1 = (function (){var statearr_88262 = state_88258;
(statearr_88262[(8)] = inst_88234);

(statearr_88262[(7)] = inst_88235);

(statearr_88262[(9)] = inst_88233);

(statearr_88262[(10)] = inst_88232);

return statearr_88262;
})();
var statearr_88263_88278 = state_88258__$1;
(statearr_88263_88278[(2)] = null);

(statearr_88263_88278[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88259 === (6))){
var inst_88254 = (state_88258[(2)]);
var state_88258__$1 = state_88258;
var statearr_88264_88279 = state_88258__$1;
(statearr_88264_88279[(2)] = inst_88254);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88258__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88259 === (3))){
var inst_88220 = (state_88258[(2)]);
var state_88258__$1 = state_88258;
var statearr_88265_88280 = state_88258__$1;
(statearr_88265_88280[(2)] = inst_88220);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88258__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88259 === (2))){
var inst_88256 = (state_88258[(2)]);
var state_88258__$1 = state_88258;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_88258__$1,inst_88256);
} else {
if((state_val_88259 === (9))){
var inst_88252 = (state_88258[(2)]);
var state_88258__$1 = state_88258;
var statearr_88266_88281 = state_88258__$1;
(statearr_88266_88281[(2)] = inst_88252);

(statearr_88266_88281[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88259 === (5))){
var inst_88234 = (state_88258[(8)]);
var inst_88241 = (state_88258[(11)]);
var inst_88240 = cljs.core.seq.call(null,inst_88234);
var inst_88241__$1 = cljs.core.first.call(null,inst_88240);
var inst_88242 = cljs.core.next.call(null,inst_88240);
var inst_88243 = cljs.core.not.call(null,inst_88241__$1);
var state_88258__$1 = (function (){var statearr_88267 = state_88258;
(statearr_88267[(12)] = inst_88242);

(statearr_88267[(11)] = inst_88241__$1);

return statearr_88267;
})();
if(inst_88243){
var statearr_88268_88282 = state_88258__$1;
(statearr_88268_88282[(1)] = (7));

} else {
var statearr_88269_88283 = state_88258__$1;
(statearr_88269_88283[(1)] = (8));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88259 === (10))){
var inst_88242 = (state_88258[(12)]);
var inst_88235 = (state_88258[(7)]);
var inst_88247 = (state_88258[(2)]);
var inst_88248 = fluree.db.util.async.throw_err.call(null,inst_88247);
var inst_88249 = cljs.core.conj.call(null,inst_88235,inst_88248);
var inst_88234 = inst_88242;
var inst_88235__$1 = inst_88249;
var state_88258__$1 = (function (){var statearr_88270 = state_88258;
(statearr_88270[(8)] = inst_88234);

(statearr_88270[(7)] = inst_88235__$1);

return statearr_88270;
})();
var statearr_88271_88284 = state_88258__$1;
(statearr_88271_88284[(2)] = null);

(statearr_88271_88284[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88259 === (8))){
var inst_88241 = (state_88258[(11)]);
var state_88258__$1 = state_88258;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_88258__$1,(10),inst_88241);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto__ = null;
var fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto____0 = (function (){
var statearr_88272 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_88272[(0)] = fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto__);

(statearr_88272[(1)] = (1));

return statearr_88272;
});
var fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto____1 = (function (state_88258){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_88258);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e88273){if((e88273 instanceof Object)){
var ex__86628__auto__ = e88273;
var statearr_88274_88285 = state_88258;
(statearr_88274_88285[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88258);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e88273;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__88286 = state_88258;
state_88258 = G__88286;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto__ = function(state_88258){
switch(arguments.length){
case 0:
return fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto____1.call(this,state_88258);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto____0;
fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto____1;
return fluree$db$util$async$merge_into_QMARK__$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_88275 = f__86676__auto__.call(null);
(statearr_88275[(6)] = c__86675__auto__);

return statearr_88275;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Like async/into, but checks each item for an error response and returns exception
 *   onto the response channel insted of results if thee is one.
 */
fluree.db.util.async.into_QMARK_ = (function fluree$db$util$async$into_QMARK_(coll,chan){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_88308){
var state_val_88309 = (state_88308[(1)]);
if((state_val_88309 === (7))){
var inst_88295 = (state_88308[(7)]);
var inst_88294 = (state_88308[(2)]);
var inst_88295__$1 = fluree.db.util.async.throw_err.call(null,inst_88294);
var inst_88296 = (inst_88295__$1 == null);
var state_88308__$1 = (function (){var statearr_88310 = state_88308;
(statearr_88310[(7)] = inst_88295__$1);

return statearr_88310;
})();
if(cljs.core.truth_(inst_88296)){
var statearr_88311_88326 = state_88308__$1;
(statearr_88311_88326[(1)] = (8));

} else {
var statearr_88312_88327 = state_88308__$1;
(statearr_88312_88327[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88309 === (1))){
var state_88308__$1 = state_88308;
var statearr_88313_88328 = state_88308__$1;
(statearr_88313_88328[(2)] = null);

(statearr_88313_88328[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88309 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_88308,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_88291 = coll;
var state_88308__$1 = (function (){var statearr_88314 = state_88308;
(statearr_88314[(8)] = inst_88291);

return statearr_88314;
})();
var statearr_88315_88329 = state_88308__$1;
(statearr_88315_88329[(2)] = null);

(statearr_88315_88329[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88309 === (6))){
var inst_88304 = (state_88308[(2)]);
var state_88308__$1 = state_88308;
var statearr_88316_88330 = state_88308__$1;
(statearr_88316_88330[(2)] = inst_88304);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88308__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88309 === (3))){
var inst_88287 = (state_88308[(2)]);
var state_88308__$1 = state_88308;
var statearr_88317_88331 = state_88308__$1;
(statearr_88317_88331[(2)] = inst_88287);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88308__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88309 === (2))){
var inst_88306 = (state_88308[(2)]);
var state_88308__$1 = state_88308;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_88308__$1,inst_88306);
} else {
if((state_val_88309 === (9))){
var inst_88291 = (state_88308[(8)]);
var inst_88295 = (state_88308[(7)]);
var inst_88299 = cljs.core.conj.call(null,inst_88291,inst_88295);
var inst_88291__$1 = inst_88299;
var state_88308__$1 = (function (){var statearr_88318 = state_88308;
(statearr_88318[(8)] = inst_88291__$1);

return statearr_88318;
})();
var statearr_88319_88332 = state_88308__$1;
(statearr_88319_88332[(2)] = null);

(statearr_88319_88332[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88309 === (5))){
var state_88308__$1 = state_88308;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_88308__$1,(7),chan);
} else {
if((state_val_88309 === (10))){
var inst_88302 = (state_88308[(2)]);
var state_88308__$1 = state_88308;
var statearr_88320_88333 = state_88308__$1;
(statearr_88320_88333[(2)] = inst_88302);

(statearr_88320_88333[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_88309 === (8))){
var inst_88291 = (state_88308[(8)]);
var state_88308__$1 = state_88308;
var statearr_88321_88334 = state_88308__$1;
(statearr_88321_88334[(2)] = inst_88291);

(statearr_88321_88334[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$util$async$into_QMARK__$_state_machine__86625__auto__ = null;
var fluree$db$util$async$into_QMARK__$_state_machine__86625__auto____0 = (function (){
var statearr_88322 = [null,null,null,null,null,null,null,null,null];
(statearr_88322[(0)] = fluree$db$util$async$into_QMARK__$_state_machine__86625__auto__);

(statearr_88322[(1)] = (1));

return statearr_88322;
});
var fluree$db$util$async$into_QMARK__$_state_machine__86625__auto____1 = (function (state_88308){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_88308);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e88323){if((e88323 instanceof Object)){
var ex__86628__auto__ = e88323;
var statearr_88324_88335 = state_88308;
(statearr_88324_88335[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_88308);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e88323;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__88336 = state_88308;
state_88308 = G__88336;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$util$async$into_QMARK__$_state_machine__86625__auto__ = function(state_88308){
switch(arguments.length){
case 0:
return fluree$db$util$async$into_QMARK__$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$util$async$into_QMARK__$_state_machine__86625__auto____1.call(this,state_88308);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$util$async$into_QMARK__$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$util$async$into_QMARK__$_state_machine__86625__auto____0;
fluree$db$util$async$into_QMARK__$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$util$async$into_QMARK__$_state_machine__86625__auto____1;
return fluree$db$util$async$into_QMARK__$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_88325 = f__86676__auto__.call(null);
(statearr_88325[(6)] = c__86675__auto__);

return statearr_88325;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Returns true if core async channel.
 */
fluree.db.util.async.channel_QMARK_ = (function fluree$db$util$async$channel_QMARK_(x){
if((!((x == null)))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === x.cljs$core$async$impl$protocols$Channel$)))){
return true;
} else {
if((!x.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.Channel,x);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.Channel,x);
}
});
