// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('instaparse.failure');
goog.require('cljs.core');
goog.require('instaparse.print');
/**
 * Takes an index into text, and determines the line and column info
 */
instaparse.failure.index__GT_line_column = (function instaparse$failure$index__GT_line_column(index,text){
var line = (1);
var col = (1);
var counter = (0);
while(true){
if(cljs.core._EQ_.call(null,index,counter)){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"line","line",212345235),line,new cljs.core.Keyword(null,"column","column",2078222095),col], null);
} else {
if(cljs.core._EQ_.call(null,"\n",cljs.core.get.call(null,text,counter))){
var G__120580 = (line + (1));
var G__120581 = (1);
var G__120582 = (counter + (1));
line = G__120580;
col = G__120581;
counter = G__120582;
continue;
} else {
var G__120583 = line;
var G__120584 = (col + (1));
var G__120585 = (counter + (1));
line = G__120583;
col = G__120584;
counter = G__120585;
continue;

}
}
break;
}
});
instaparse.failure.get_line = (function instaparse$failure$get_line(n,text){
var chars = cljs.core.seq.call(null,clojure.string.replace.call(null,text,"\r\n","\n"));
var n__$1 = n;
while(true){
if(cljs.core.empty_QMARK_.call(null,chars)){
return "";
} else {
if(cljs.core._EQ_.call(null,n__$1,(1))){
return cljs.core.apply.call(null,cljs.core.str,cljs.core.take_while.call(null,cljs.core.complement.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, ["\n",null], null), null)),chars));
} else {
if(cljs.core._EQ_.call(null,"\n",cljs.core.first.call(null,chars))){
var G__120586 = cljs.core.next.call(null,chars);
var G__120587 = (n__$1 - (1));
chars = G__120586;
n__$1 = G__120587;
continue;
} else {
var G__120588 = cljs.core.next.call(null,chars);
var G__120589 = n__$1;
chars = G__120588;
n__$1 = G__120589;
continue;

}
}
}
break;
}
});
/**
 * Creates string with caret at nth position, 1-based
 */
instaparse.failure.marker = (function instaparse$failure$marker(n){
if(cljs.core.integer_QMARK_.call(null,n)){
if((n <= (1))){
return "^";
} else {
return cljs.core.apply.call(null,cljs.core.str,cljs.core.concat.call(null,cljs.core.repeat.call(null,(n - (1))," "),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, ["^"], null)));
}
} else {
return null;
}
});
/**
 * Adds text, line, and column info to failure object.
 */
instaparse.failure.augment_failure = (function instaparse$failure$augment_failure(failure,text){
var lc = instaparse.failure.index__GT_line_column.call(null,new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(failure),text);
return cljs.core.merge.call(null,failure,lc,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"text","text",-1790561697),instaparse.failure.get_line.call(null,new cljs.core.Keyword(null,"line","line",212345235).cljs$core$IFn$_invoke$arity$1(lc),text)], null));
});
/**
 * Provides special case for printing negative lookahead reasons
 */
instaparse.failure.print_reason = (function instaparse$failure$print_reason(r){
if(cljs.core.truth_(new cljs.core.Keyword(null,"NOT","NOT",-1689245341).cljs$core$IFn$_invoke$arity$1(r))){
cljs.core.print.call(null,"NOT ");

return cljs.core.print.call(null,new cljs.core.Keyword(null,"NOT","NOT",-1689245341).cljs$core$IFn$_invoke$arity$1(r));
} else {
if(cljs.core.truth_(new cljs.core.Keyword(null,"char-range","char-range",1443391389).cljs$core$IFn$_invoke$arity$1(r))){
return cljs.core.print.call(null,instaparse.print.char_range__GT_str.call(null,r));
} else {
if((r instanceof RegExp)){
return cljs.core.print.call(null,instaparse.print.regexp__GT_str.call(null,r));
} else {
return cljs.core.pr.call(null,r);

}
}
}
});
/**
 * Takes an augmented failure object and prints the error message
 */
instaparse.failure.pprint_failure = (function instaparse$failure$pprint_failure(p__120590){
var map__120591 = p__120590;
var map__120591__$1 = (((((!((map__120591 == null))))?(((((map__120591.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__120591.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__120591):map__120591);
var line = cljs.core.get.call(null,map__120591__$1,new cljs.core.Keyword(null,"line","line",212345235));
var column = cljs.core.get.call(null,map__120591__$1,new cljs.core.Keyword(null,"column","column",2078222095));
var text = cljs.core.get.call(null,map__120591__$1,new cljs.core.Keyword(null,"text","text",-1790561697));
var reason = cljs.core.get.call(null,map__120591__$1,new cljs.core.Keyword(null,"reason","reason",-2070751759));
cljs.core.println.call(null,["Parse error at line ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(line),", column ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(column),":"].join(''));

cljs.core.println.call(null,text);

cljs.core.println.call(null,instaparse.failure.marker.call(null,column));

var full_reasons = cljs.core.distinct.call(null,cljs.core.map.call(null,new cljs.core.Keyword(null,"expecting","expecting",-57706705),cljs.core.filter.call(null,new cljs.core.Keyword(null,"full","full",436801220),reason)));
var partial_reasons = cljs.core.distinct.call(null,cljs.core.map.call(null,new cljs.core.Keyword(null,"expecting","expecting",-57706705),cljs.core.filter.call(null,cljs.core.complement.call(null,new cljs.core.Keyword(null,"full","full",436801220)),reason)));
var total = (cljs.core.count.call(null,full_reasons) + cljs.core.count.call(null,partial_reasons));
if((total === (0))){
} else {
if(cljs.core._EQ_.call(null,(1),total)){
cljs.core.println.call(null,"Expected:");
} else {
cljs.core.println.call(null,"Expected one of:");

}
}

var seq__120593_120601 = cljs.core.seq.call(null,full_reasons);
var chunk__120594_120602 = null;
var count__120595_120603 = (0);
var i__120596_120604 = (0);
while(true){
if((i__120596_120604 < count__120595_120603)){
var r_120605 = cljs.core._nth.call(null,chunk__120594_120602,i__120596_120604);
instaparse.failure.print_reason.call(null,r_120605);

cljs.core.println.call(null," (followed by end-of-string)");


var G__120606 = seq__120593_120601;
var G__120607 = chunk__120594_120602;
var G__120608 = count__120595_120603;
var G__120609 = (i__120596_120604 + (1));
seq__120593_120601 = G__120606;
chunk__120594_120602 = G__120607;
count__120595_120603 = G__120608;
i__120596_120604 = G__120609;
continue;
} else {
var temp__5735__auto___120610 = cljs.core.seq.call(null,seq__120593_120601);
if(temp__5735__auto___120610){
var seq__120593_120611__$1 = temp__5735__auto___120610;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__120593_120611__$1)){
var c__4550__auto___120612 = cljs.core.chunk_first.call(null,seq__120593_120611__$1);
var G__120613 = cljs.core.chunk_rest.call(null,seq__120593_120611__$1);
var G__120614 = c__4550__auto___120612;
var G__120615 = cljs.core.count.call(null,c__4550__auto___120612);
var G__120616 = (0);
seq__120593_120601 = G__120613;
chunk__120594_120602 = G__120614;
count__120595_120603 = G__120615;
i__120596_120604 = G__120616;
continue;
} else {
var r_120617 = cljs.core.first.call(null,seq__120593_120611__$1);
instaparse.failure.print_reason.call(null,r_120617);

cljs.core.println.call(null," (followed by end-of-string)");


var G__120618 = cljs.core.next.call(null,seq__120593_120611__$1);
var G__120619 = null;
var G__120620 = (0);
var G__120621 = (0);
seq__120593_120601 = G__120618;
chunk__120594_120602 = G__120619;
count__120595_120603 = G__120620;
i__120596_120604 = G__120621;
continue;
}
} else {
}
}
break;
}

var seq__120597 = cljs.core.seq.call(null,partial_reasons);
var chunk__120598 = null;
var count__120599 = (0);
var i__120600 = (0);
while(true){
if((i__120600 < count__120599)){
var r = cljs.core._nth.call(null,chunk__120598,i__120600);
instaparse.failure.print_reason.call(null,r);

cljs.core.println.call(null);


var G__120622 = seq__120597;
var G__120623 = chunk__120598;
var G__120624 = count__120599;
var G__120625 = (i__120600 + (1));
seq__120597 = G__120622;
chunk__120598 = G__120623;
count__120599 = G__120624;
i__120600 = G__120625;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq.call(null,seq__120597);
if(temp__5735__auto__){
var seq__120597__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__120597__$1)){
var c__4550__auto__ = cljs.core.chunk_first.call(null,seq__120597__$1);
var G__120626 = cljs.core.chunk_rest.call(null,seq__120597__$1);
var G__120627 = c__4550__auto__;
var G__120628 = cljs.core.count.call(null,c__4550__auto__);
var G__120629 = (0);
seq__120597 = G__120626;
chunk__120598 = G__120627;
count__120599 = G__120628;
i__120600 = G__120629;
continue;
} else {
var r = cljs.core.first.call(null,seq__120597__$1);
instaparse.failure.print_reason.call(null,r);

cljs.core.println.call(null);


var G__120630 = cljs.core.next.call(null,seq__120597__$1);
var G__120631 = null;
var G__120632 = (0);
var G__120633 = (0);
seq__120597 = G__120630;
chunk__120598 = G__120631;
count__120599 = G__120632;
i__120600 = G__120633;
continue;
}
} else {
return null;
}
}
break;
}
});
