// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('shared.password_auth_handler');
goog.require('cljs.core');
goog.require('fluree.db.token_auth');
goog.require('fluree.db.util.core');
goog.require('cljs.core.async');
goog.require('fluree.db.util.log');
goog.require('alphabase.core');
/**
 * Returns true when the ledger server/group supports password authentication
 */
shared.password_auth_handler.password_enabled_QMARK_ = (function shared$password_auth_handler$password_enabled_QMARK_(conn){
return new cljs.core.Keyword(null,"password-enabled?","password-enabled?",-456274989).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018).cljs$core$IFn$_invoke$arity$1(conn)));
});
/**
 * Generates a password auth record for an existing role, or a user.
 *   The user may exist, or if createUser? is true, the user is created.
 * 
 *   Returns a promise that eventually contains the token or an exception
 */
shared.password_auth_handler.password_generate = (function shared$password_auth_handler$password_generate(conn,ledger,password,map_data){
return (new Promise((function (resolve,reject){
var c__97076__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto__){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto__){
return (function (state_128313){
var state_val_128314 = (state_128313[(1)]);
if((state_val_128314 === (7))){
var inst_128281 = (state_128313[(2)]);
var state_128313__$1 = (function (){var statearr_128315 = state_128313;
(statearr_128315[(7)] = inst_128281);

return statearr_128315;
})();
if(cljs.core.truth_(ledger)){
var statearr_128316_128337 = state_128313__$1;
(statearr_128316_128337[(1)] = (8));

} else {
var statearr_128317_128338 = state_128313__$1;
(statearr_128317_128338[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (1))){
var state_128313__$1 = state_128313;
var statearr_128318_128339 = state_128313__$1;
(statearr_128318_128339[(2)] = null);

(statearr_128318_128339[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_128313,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_128272 = shared.password_auth_handler.password_enabled_QMARK_.call(null,conn);
var state_128313__$1 = state_128313;
if(cljs.core.truth_(inst_128272)){
var statearr_128319_128340 = state_128313__$1;
(statearr_128319_128340[(1)] = (5));

} else {
var statearr_128320_128341 = state_128313__$1;
(statearr_128320_128341[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (13))){
var inst_128299 = (state_128313[(2)]);
var inst_128300 = cljs.core.assoc.call(null,map_data,new cljs.core.Keyword(null,"ledger","ledger",561720706),ledger,new cljs.core.Keyword(null,"password","password",417022471),password);
var inst_128301 = fluree.db.util.core.without_nils.call(null,inst_128300);
var inst_128302 = cljs.core.async.promise_chan.call(null);
var inst_128303 = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(conn);
var inst_128304 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_128305 = [new cljs.core.Keyword(null,"pw-generate","pw-generate",-1834816603),inst_128301,inst_128302,null];
var inst_128306 = (new cljs.core.PersistentVector(null,4,(5),inst_128304,inst_128305,null));
var inst_128307 = cljs.core.async.put_BANG_.call(null,inst_128303,inst_128306);
var inst_128308 = (function (){var _ = inst_128299;
var data = inst_128301;
var pc = inst_128302;
return ((function (_,data,pc,inst_128299,inst_128300,inst_128301,inst_128302,inst_128303,inst_128304,inst_128305,inst_128306,inst_128307,state_val_128314,c__97076__auto__){
return (function (result){
if(cljs.core.truth_((((result == null))?(function(){throw cljs.core.ex_info.call(null,"The password auth could not be generated.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)], null))})():null))){
if(cljs.core.truth_(new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(result))){
return reject.call(null,cljs.core.clj__GT_js.call(null,result));
} else {
return null;
}
} else {
if((result instanceof cljs.core.ExceptionInfo)){
var err_data = cljs.core.ex_data.call(null,result);
var err_resp = new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"status","status",-1997798413),(function (){var or__4131__auto__ = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (400);
}
})(),new cljs.core.Keyword(null,"message","message",-406056002),cljs.core.ex_message.call(null,result),new cljs.core.Keyword(null,"error","error",-978969032),(function (){var or__4131__auto__ = new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926);
}
})()], null);
return reject.call(null,cljs.core.clj__GT_js.call(null,err_resp));
} else {
return resolve.call(null,cljs.core.clj__GT_js.call(null,result));

}
}
});
;})(_,data,pc,inst_128299,inst_128300,inst_128301,inst_128302,inst_128303,inst_128304,inst_128305,inst_128306,inst_128307,state_val_128314,c__97076__auto__))
})();
var inst_128309 = cljs.core.async.take_BANG_.call(null,inst_128302,inst_128308);
var state_128313__$1 = (function (){var statearr_128321 = state_128313;
(statearr_128321[(8)] = inst_128307);

return statearr_128321;
})();
var statearr_128322_128342 = state_128313__$1;
(statearr_128322_128342[(2)] = inst_128309);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_128313__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (6))){
var inst_128275 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_128276 = [(401),new cljs.core.Keyword("db","no-password-auth","db/no-password-auth",1344949614)];
var inst_128277 = cljs.core.PersistentHashMap.fromArrays(inst_128275,inst_128276);
var inst_128278 = cljs.core.ex_info.call(null,"Password authentication is not enabled.",inst_128277);
var inst_128279 = (function(){throw inst_128278})();
var state_128313__$1 = state_128313;
var statearr_128323_128343 = state_128313__$1;
(statearr_128323_128343[(2)] = inst_128279);

(statearr_128323_128343[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (3))){
var inst_128266 = (state_128313[(2)]);
var inst_128267 = cljs.core.clj__GT_js.call(null,inst_128266);
var inst_128268 = reject.call(null,inst_128267);
var state_128313__$1 = state_128313;
var statearr_128324_128344 = state_128313__$1;
(statearr_128324_128344[(2)] = inst_128268);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_128313__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (12))){
var inst_128293 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_128294 = [(400),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)];
var inst_128295 = cljs.core.PersistentHashMap.fromArrays(inst_128293,inst_128294);
var inst_128296 = cljs.core.ex_info.call(null,"A password must be supplied.",inst_128295);
var inst_128297 = (function(){throw inst_128296})();
var state_128313__$1 = state_128313;
var statearr_128325_128345 = state_128313__$1;
(statearr_128325_128345[(2)] = inst_128297);

(statearr_128325_128345[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (2))){
var inst_128311 = (state_128313[(2)]);
var state_128313__$1 = state_128313;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_128313__$1,inst_128311);
} else {
if((state_val_128314 === (11))){
var state_128313__$1 = state_128313;
var statearr_128326_128346 = state_128313__$1;
(statearr_128326_128346[(2)] = null);

(statearr_128326_128346[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (9))){
var inst_128284 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_128285 = [(400),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)];
var inst_128286 = cljs.core.PersistentHashMap.fromArrays(inst_128284,inst_128285);
var inst_128287 = cljs.core.ex_info.call(null,"A password must be supplied.",inst_128286);
var inst_128288 = (function(){throw inst_128287})();
var state_128313__$1 = state_128313;
var statearr_128327_128347 = state_128313__$1;
(statearr_128327_128347[(2)] = inst_128288);

(statearr_128327_128347[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (5))){
var state_128313__$1 = state_128313;
var statearr_128328_128348 = state_128313__$1;
(statearr_128328_128348[(2)] = null);

(statearr_128328_128348[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (10))){
var inst_128290 = (state_128313[(2)]);
var state_128313__$1 = (function (){var statearr_128329 = state_128313;
(statearr_128329[(9)] = inst_128290);

return statearr_128329;
})();
if(cljs.core.truth_(password)){
var statearr_128330_128349 = state_128313__$1;
(statearr_128330_128349[(1)] = (11));

} else {
var statearr_128331_128350 = state_128313__$1;
(statearr_128331_128350[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128314 === (8))){
var state_128313__$1 = state_128313;
var statearr_128332_128351 = state_128313__$1;
(statearr_128332_128351[(2)] = null);

(statearr_128332_128351[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto__))
;
return ((function (switch__96981__auto__,c__97076__auto__){
return (function() {
var shared$password_auth_handler$password_generate_$_state_machine__96982__auto__ = null;
var shared$password_auth_handler$password_generate_$_state_machine__96982__auto____0 = (function (){
var statearr_128333 = [null,null,null,null,null,null,null,null,null,null];
(statearr_128333[(0)] = shared$password_auth_handler$password_generate_$_state_machine__96982__auto__);

(statearr_128333[(1)] = (1));

return statearr_128333;
});
var shared$password_auth_handler$password_generate_$_state_machine__96982__auto____1 = (function (state_128313){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_128313);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e128334){if((e128334 instanceof Object)){
var ex__96985__auto__ = e128334;
var statearr_128335_128352 = state_128313;
(statearr_128335_128352[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_128313);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e128334;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__128353 = state_128313;
state_128313 = G__128353;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
shared$password_auth_handler$password_generate_$_state_machine__96982__auto__ = function(state_128313){
switch(arguments.length){
case 0:
return shared$password_auth_handler$password_generate_$_state_machine__96982__auto____0.call(this);
case 1:
return shared$password_auth_handler$password_generate_$_state_machine__96982__auto____1.call(this,state_128313);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$password_auth_handler$password_generate_$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = shared$password_auth_handler$password_generate_$_state_machine__96982__auto____0;
shared$password_auth_handler$password_generate_$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = shared$password_auth_handler$password_generate_$_state_machine__96982__auto____1;
return shared$password_auth_handler$password_generate_$_state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto__))
})();
var state__97078__auto__ = (function (){var statearr_128336 = f__97077__auto__.call(null);
(statearr_128336[(6)] = c__97076__auto__);

return statearr_128336;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto__))
);

return c__97076__auto__;
})));
});
/**
 * Returns a JWT token if successful.
 *   Must supply ledger, password and either user or auth identifier.
 *   Expire is optional
 *   - ledger   - ledger identifier
 *   - password - plain-text password
 *   - user     - _user/username (TODO: should allow any _user ident in the future)
 *   - auth     - _auth/id (TODO: should allow any _auth ident in the future)
 *   - expire   - requested time to expire in milliseconds
 */
shared.password_auth_handler.password_login = (function shared$password_auth_handler$password_login(var_args){
var G__128355 = arguments.length;
switch (G__128355) {
case 4:
return shared.password_auth_handler.password_login.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 6:
return shared.password_auth_handler.password_login.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.password_auth_handler.password_login.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,password,user){
return shared.password_auth_handler.password_login.call(null,conn,ledger,password,user,null,null);
});

shared.password_auth_handler.password_login.cljs$core$IFn$_invoke$arity$6 = (function (conn,ledger,password,user,auth,expire){
return (new Promise((function (resolve,reject){
var c__97076__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto__){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto__){
return (function (state_128418){
var state_val_128419 = (state_128418[(1)]);
if((state_val_128419 === (7))){
var inst_128371 = (state_128418[(2)]);
var state_128418__$1 = (function (){var statearr_128420 = state_128418;
(statearr_128420[(7)] = inst_128371);

return statearr_128420;
})();
if(cljs.core.truth_(ledger)){
var statearr_128421_128452 = state_128418__$1;
(statearr_128421_128452[(1)] = (8));

} else {
var statearr_128422_128453 = state_128418__$1;
(statearr_128422_128453[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (1))){
var state_128418__$1 = state_128418;
var statearr_128423_128454 = state_128418__$1;
(statearr_128423_128454[(2)] = null);

(statearr_128423_128454[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_128418,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_128362 = shared.password_auth_handler.password_enabled_QMARK_.call(null,conn);
var state_128418__$1 = state_128418;
if(cljs.core.truth_(inst_128362)){
var statearr_128424_128455 = state_128418__$1;
(statearr_128424_128455[(1)] = (5));

} else {
var statearr_128425_128456 = state_128418__$1;
(statearr_128425_128456[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (15))){
var state_128418__$1 = state_128418;
var statearr_128426_128457 = state_128418__$1;
(statearr_128426_128457[(2)] = auth);

(statearr_128426_128457[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (13))){
var inst_128389 = (state_128418[(2)]);
var state_128418__$1 = (function (){var statearr_128427 = state_128418;
(statearr_128427[(8)] = inst_128389);

return statearr_128427;
})();
if(cljs.core.truth_(user)){
var statearr_128428_128458 = state_128418__$1;
(statearr_128428_128458[(1)] = (14));

} else {
var statearr_128429_128459 = state_128418__$1;
(statearr_128429_128459[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (6))){
var inst_128365 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_128366 = [(401),new cljs.core.Keyword("db","no-password-auth","db/no-password-auth",1344949614)];
var inst_128367 = cljs.core.PersistentHashMap.fromArrays(inst_128365,inst_128366);
var inst_128368 = cljs.core.ex_info.call(null,"Password authentication is not enabled.",inst_128367);
var inst_128369 = (function(){throw inst_128368})();
var state_128418__$1 = state_128418;
var statearr_128430_128460 = state_128418__$1;
(statearr_128430_128460[(2)] = inst_128369);

(statearr_128430_128460[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (17))){
var state_128418__$1 = state_128418;
var statearr_128431_128461 = state_128418__$1;
(statearr_128431_128461[(2)] = null);

(statearr_128431_128461[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (3))){
var inst_128356 = (state_128418[(2)]);
var inst_128357 = cljs.core.clj__GT_js.call(null,inst_128356);
var inst_128358 = reject.call(null,inst_128357);
var state_128418__$1 = state_128418;
var statearr_128432_128462 = state_128418__$1;
(statearr_128432_128462[(2)] = inst_128358);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_128418__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (12))){
var inst_128383 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_128384 = [(400),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)];
var inst_128385 = cljs.core.PersistentHashMap.fromArrays(inst_128383,inst_128384);
var inst_128386 = cljs.core.ex_info.call(null,"A password must be supplied in the provided JSON.",inst_128385);
var inst_128387 = (function(){throw inst_128386})();
var state_128418__$1 = state_128418;
var statearr_128433_128463 = state_128418__$1;
(statearr_128433_128463[(2)] = inst_128387);

(statearr_128433_128463[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (2))){
var inst_128416 = (state_128418[(2)]);
var state_128418__$1 = state_128418;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_128418__$1,inst_128416);
} else {
if((state_val_128419 === (19))){
var inst_128402 = (state_128418[(2)]);
var inst_128403 = [new cljs.core.Keyword(null,"ledger","ledger",561720706),new cljs.core.Keyword(null,"password","password",417022471),new cljs.core.Keyword(null,"user","user",1532431356),new cljs.core.Keyword(null,"auth","auth",1389754926),new cljs.core.Keyword(null,"expire","expire",-70657108)];
var inst_128404 = [ledger,password,user,auth,expire];
var inst_128405 = cljs.core.PersistentHashMap.fromArrays(inst_128403,inst_128404);
var inst_128406 = fluree.db.util.core.without_nils.call(null,inst_128405);
var inst_128407 = cljs.core.async.promise_chan.call(null);
var inst_128408 = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(conn);
var inst_128409 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_128410 = [new cljs.core.Keyword(null,"pw-login","pw-login",-335915426),inst_128406,inst_128407,null];
var inst_128411 = (new cljs.core.PersistentVector(null,4,(5),inst_128409,inst_128410,null));
var inst_128412 = cljs.core.async.put_BANG_.call(null,inst_128408,inst_128411);
var inst_128413 = (function (){var _ = inst_128402;
var data = inst_128406;
var pc = inst_128407;
return ((function (_,data,pc,inst_128402,inst_128403,inst_128404,inst_128405,inst_128406,inst_128407,inst_128408,inst_128409,inst_128410,inst_128411,inst_128412,state_val_128419,c__97076__auto__){
return (function (result){
if(cljs.core.truth_((((result == null))?(function(){throw cljs.core.ex_info.call(null,"A token could not be generated for the identity and password combination.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)], null))})():null))){
if(cljs.core.truth_(new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(result))){
return reject.call(null,cljs.core.clj__GT_js.call(null,result));
} else {
return null;
}
} else {
if((result instanceof cljs.core.ExceptionInfo)){
var err_data = cljs.core.ex_data.call(null,result);
var err_resp = new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"status","status",-1997798413),(function (){var or__4131__auto__ = new cljs.core.Keyword(null,"status","status",-1997798413).cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (400);
}
})(),new cljs.core.Keyword(null,"message","message",-406056002),cljs.core.ex_message.call(null,result),new cljs.core.Keyword(null,"error","error",-978969032),(function (){var or__4131__auto__ = new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(err_data);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926);
}
})()], null);
return reject.call(null,cljs.core.clj__GT_js.call(null,err_resp));
} else {
return resolve.call(null,cljs.core.clj__GT_js.call(null,result));

}
}
});
;})(_,data,pc,inst_128402,inst_128403,inst_128404,inst_128405,inst_128406,inst_128407,inst_128408,inst_128409,inst_128410,inst_128411,inst_128412,state_val_128419,c__97076__auto__))
})();
var inst_128414 = cljs.core.async.take_BANG_.call(null,inst_128407,inst_128413);
var state_128418__$1 = (function (){var statearr_128434 = state_128418;
(statearr_128434[(9)] = inst_128412);

return statearr_128434;
})();
var statearr_128435_128464 = state_128418__$1;
(statearr_128435_128464[(2)] = inst_128414);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_128418__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (11))){
var state_128418__$1 = state_128418;
var statearr_128436_128465 = state_128418__$1;
(statearr_128436_128465[(2)] = null);

(statearr_128436_128465[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (9))){
var inst_128374 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_128375 = [(400),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)];
var inst_128376 = cljs.core.PersistentHashMap.fromArrays(inst_128374,inst_128375);
var inst_128377 = cljs.core.ex_info.call(null,"A ledger must be supplied in the provided JSON.",inst_128376);
var inst_128378 = (function(){throw inst_128377})();
var state_128418__$1 = state_128418;
var statearr_128437_128466 = state_128418__$1;
(statearr_128437_128466[(2)] = inst_128378);

(statearr_128437_128466[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (5))){
var state_128418__$1 = state_128418;
var statearr_128438_128467 = state_128418__$1;
(statearr_128438_128467[(2)] = null);

(statearr_128438_128467[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (14))){
var state_128418__$1 = state_128418;
var statearr_128439_128468 = state_128418__$1;
(statearr_128439_128468[(2)] = user);

(statearr_128439_128468[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (16))){
var inst_128393 = (state_128418[(2)]);
var state_128418__$1 = state_128418;
if(cljs.core.truth_(inst_128393)){
var statearr_128440_128469 = state_128418__$1;
(statearr_128440_128469[(1)] = (17));

} else {
var statearr_128441_128470 = state_128418__$1;
(statearr_128441_128470[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (10))){
var inst_128380 = (state_128418[(2)]);
var state_128418__$1 = (function (){var statearr_128442 = state_128418;
(statearr_128442[(10)] = inst_128380);

return statearr_128442;
})();
if(cljs.core.truth_(password)){
var statearr_128443_128471 = state_128418__$1;
(statearr_128443_128471[(1)] = (11));

} else {
var statearr_128444_128472 = state_128418__$1;
(statearr_128444_128472[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (18))){
var inst_128396 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_128397 = [(400),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)];
var inst_128398 = cljs.core.PersistentHashMap.fromArrays(inst_128396,inst_128397);
var inst_128399 = cljs.core.ex_info.call(null,"A user identity or auth identity must be supplied.",inst_128398);
var inst_128400 = (function(){throw inst_128399})();
var state_128418__$1 = state_128418;
var statearr_128445_128473 = state_128418__$1;
(statearr_128445_128473[(2)] = inst_128400);

(statearr_128445_128473[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128419 === (8))){
var state_128418__$1 = state_128418;
var statearr_128446_128474 = state_128418__$1;
(statearr_128446_128474[(2)] = null);

(statearr_128446_128474[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto__))
;
return ((function (switch__96981__auto__,c__97076__auto__){
return (function() {
var shared$password_auth_handler$state_machine__96982__auto__ = null;
var shared$password_auth_handler$state_machine__96982__auto____0 = (function (){
var statearr_128447 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_128447[(0)] = shared$password_auth_handler$state_machine__96982__auto__);

(statearr_128447[(1)] = (1));

return statearr_128447;
});
var shared$password_auth_handler$state_machine__96982__auto____1 = (function (state_128418){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_128418);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e128448){if((e128448 instanceof Object)){
var ex__96985__auto__ = e128448;
var statearr_128449_128475 = state_128418;
(statearr_128449_128475[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_128418);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e128448;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__128476 = state_128418;
state_128418 = G__128476;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
shared$password_auth_handler$state_machine__96982__auto__ = function(state_128418){
switch(arguments.length){
case 0:
return shared$password_auth_handler$state_machine__96982__auto____0.call(this);
case 1:
return shared$password_auth_handler$state_machine__96982__auto____1.call(this,state_128418);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$password_auth_handler$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = shared$password_auth_handler$state_machine__96982__auto____0;
shared$password_auth_handler$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = shared$password_auth_handler$state_machine__96982__auto____1;
return shared$password_auth_handler$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto__))
})();
var state__97078__auto__ = (function (){var statearr_128450 = f__97077__auto__.call(null);
(statearr_128450[(6)] = c__97076__auto__);

return statearr_128450;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto__))
);

return c__97076__auto__;
})));
});

shared.password_auth_handler.password_login.cljs$lang$maxFixedArity = 6;

/**
 * Renews a JWT token if successful.
 * 
 *   Returns a promise that eventually contains the token or an exception
 */
shared.password_auth_handler.renew_token = (function shared$password_auth_handler$renew_token(var_args){
var G__128478 = arguments.length;
switch (G__128478) {
case 2:
return shared.password_auth_handler.renew_token.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shared.password_auth_handler.renew_token.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.password_auth_handler.renew_token.cljs$core$IFn$_invoke$arity$2 = (function (conn,jwt){
return shared.password_auth_handler.renew_token.call(null,conn,jwt,null);
});

shared.password_auth_handler.renew_token.cljs$core$IFn$_invoke$arity$3 = (function (conn,jwt,expire){
return (new Promise((function (resolve,reject){
var c__97076__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto__){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto__){
return (function (state_128510){
var state_val_128511 = (state_128510[(1)]);
if((state_val_128511 === (1))){
var state_128510__$1 = state_128510;
var statearr_128512_128525 = state_128510__$1;
(statearr_128512_128525[(2)] = null);

(statearr_128512_128525[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128511 === (2))){
var inst_128508 = (state_128510[(2)]);
var state_128510__$1 = state_128510;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_128510__$1,inst_128508);
} else {
if((state_val_128511 === (3))){
var inst_128479 = (state_128510[(2)]);
var inst_128480 = cljs.core.clj__GT_js.call(null,inst_128479);
var inst_128481 = reject.call(null,inst_128480);
var state_128510__$1 = state_128510;
var statearr_128513_128526 = state_128510__$1;
(statearr_128513_128526[(2)] = inst_128481);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_128510__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128511 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_128510,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_128485 = shared.password_auth_handler.password_enabled_QMARK_.call(null,conn);
var state_128510__$1 = state_128510;
if(cljs.core.truth_(inst_128485)){
var statearr_128514_128527 = state_128510__$1;
(statearr_128514_128527[(1)] = (5));

} else {
var statearr_128515_128528 = state_128510__$1;
(statearr_128515_128528[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128511 === (5))){
var state_128510__$1 = state_128510;
var statearr_128516_128529 = state_128510__$1;
(statearr_128516_128529[(2)] = null);

(statearr_128516_128529[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128511 === (6))){
var inst_128488 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_128489 = [(401),new cljs.core.Keyword("db","no-password-auth","db/no-password-auth",1344949614)];
var inst_128490 = cljs.core.PersistentHashMap.fromArrays(inst_128488,inst_128489);
var inst_128491 = cljs.core.ex_info.call(null,"Password authentication is not enabled.",inst_128490);
var inst_128492 = (function(){throw inst_128491})();
var state_128510__$1 = state_128510;
var statearr_128517_128530 = state_128510__$1;
(statearr_128517_128530[(2)] = inst_128492);

(statearr_128517_128530[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_128511 === (7))){
var inst_128494 = (state_128510[(2)]);
var inst_128495 = [new cljs.core.Keyword(null,"jwt","jwt",1504015441),new cljs.core.Keyword(null,"expire","expire",-70657108)];
var inst_128496 = [jwt,expire];
var inst_128497 = cljs.core.PersistentHashMap.fromArrays(inst_128495,inst_128496);
var inst_128498 = fluree.db.util.core.without_nils.call(null,inst_128497);
var inst_128499 = cljs.core.async.promise_chan.call(null);
var inst_128500 = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(conn);
var inst_128501 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_128502 = [new cljs.core.Keyword(null,"pw-renew","pw-renew",2082701857),inst_128498,inst_128499,null];
var inst_128503 = (new cljs.core.PersistentVector(null,4,(5),inst_128501,inst_128502,null));
var inst_128504 = cljs.core.async.put_BANG_.call(null,inst_128500,inst_128503);
var inst_128505 = (function (){var _ = inst_128494;
var data = inst_128498;
var pc = inst_128499;
return ((function (_,data,pc,inst_128494,inst_128495,inst_128496,inst_128497,inst_128498,inst_128499,inst_128500,inst_128501,inst_128502,inst_128503,inst_128504,state_val_128511,c__97076__auto__){
return (function (result){
if(cljs.core.truth_((((result == null))?(function(){throw cljs.core.ex_info.call(null,"The token could not be renewed.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-request","db/invalid-request",-1668472926)], null))})():null))){
if(cljs.core.truth_(new cljs.core.Keyword(null,"error","error",-978969032).cljs$core$IFn$_invoke$arity$1(result))){
return reject.call(null,cljs.core.clj__GT_js.call(null,result));
} else {
return null;
}
} else {
return resolve.call(null,cljs.core.clj__GT_js.call(null,result));

}
});
;})(_,data,pc,inst_128494,inst_128495,inst_128496,inst_128497,inst_128498,inst_128499,inst_128500,inst_128501,inst_128502,inst_128503,inst_128504,state_val_128511,c__97076__auto__))
})();
var inst_128506 = cljs.core.async.take_BANG_.call(null,inst_128499,inst_128505);
var state_128510__$1 = (function (){var statearr_128518 = state_128510;
(statearr_128518[(7)] = inst_128504);

return statearr_128518;
})();
var statearr_128519_128531 = state_128510__$1;
(statearr_128519_128531[(2)] = inst_128506);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_128510__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__97076__auto__))
;
return ((function (switch__96981__auto__,c__97076__auto__){
return (function() {
var shared$password_auth_handler$state_machine__96982__auto__ = null;
var shared$password_auth_handler$state_machine__96982__auto____0 = (function (){
var statearr_128520 = [null,null,null,null,null,null,null,null];
(statearr_128520[(0)] = shared$password_auth_handler$state_machine__96982__auto__);

(statearr_128520[(1)] = (1));

return statearr_128520;
});
var shared$password_auth_handler$state_machine__96982__auto____1 = (function (state_128510){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_128510);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e128521){if((e128521 instanceof Object)){
var ex__96985__auto__ = e128521;
var statearr_128522_128532 = state_128510;
(statearr_128522_128532[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_128510);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e128521;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__128533 = state_128510;
state_128510 = G__128533;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
shared$password_auth_handler$state_machine__96982__auto__ = function(state_128510){
switch(arguments.length){
case 0:
return shared$password_auth_handler$state_machine__96982__auto____0.call(this);
case 1:
return shared$password_auth_handler$state_machine__96982__auto____1.call(this,state_128510);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$password_auth_handler$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = shared$password_auth_handler$state_machine__96982__auto____0;
shared$password_auth_handler$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = shared$password_auth_handler$state_machine__96982__auto____1;
return shared$password_auth_handler$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto__))
})();
var state__97078__auto__ = (function (){var statearr_128523 = f__97077__auto__.call(null);
(statearr_128523[(6)] = c__97076__auto__);

return statearr_128523;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto__))
);

return c__97076__auto__;
})));
});

shared.password_auth_handler.renew_token.cljs$lang$maxFixedArity = 3;

/**
 * Verifies that the jwt token has not expired.
 */
shared.password_auth_handler.verify_token = (function shared$password_auth_handler$verify_token(conn,jwt){
var secret = alphabase.core.string__GT_bytes.call(null,new cljs.core.Keyword(null,"jwt-secret","jwt-secret",-356972172).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"flureedb-settings","flureedb-settings",-113464018).cljs$core$IFn$_invoke$arity$1(conn))));
try{fluree.db.token_auth.verify_jwt.call(null,secret,jwt);

return true;
}catch (e128534){var e = e128534;
fluree.db.util.log.warn.call(null,"verify-token failed with error, ",new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"error","error",-978969032),e], null));

return false;
}});
