// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var G__99869 = arguments.length;
switch (G__99869) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async99870 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async99870 = (function (f,blockable,meta99871){
this.f = f;
this.blockable = blockable;
this.meta99871 = meta99871;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async99870.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_99872,meta99871__$1){
var self__ = this;
var _99872__$1 = this;
return (new cljs.core.async.t_cljs$core$async99870(self__.f,self__.blockable,meta99871__$1));
});

cljs.core.async.t_cljs$core$async99870.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_99872){
var self__ = this;
var _99872__$1 = this;
return self__.meta99871;
});

cljs.core.async.t_cljs$core$async99870.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async99870.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async99870.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async99870.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async99870.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$blockable,cljs.core.cst$sym$meta99871], null);
});

cljs.core.async.t_cljs$core$async99870.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async99870.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async99870";

cljs.core.async.t_cljs$core$async99870.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write(writer__4375__auto__,"cljs.core.async/t_cljs$core$async99870");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async99870.
 */
cljs.core.async.__GT_t_cljs$core$async99870 = (function cljs$core$async$__GT_t_cljs$core$async99870(f__$1,blockable__$1,meta99871){
return (new cljs.core.async.t_cljs$core$async99870(f__$1,blockable__$1,meta99871));
});

}

return (new cljs.core.async.t_cljs$core$async99870(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer(n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer(n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if((!((buff == null)))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$)))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_(cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var G__99876 = arguments.length;
switch (G__99876) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error(["Assert failed: ","buffer must be supplied when transducer is","\n","buf-or-n"].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3(((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer(buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var G__99879 = arguments.length;
switch (G__99879) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1(null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2(xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3(cljs.core.async.impl.buffers.promise_buffer(),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout(msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var G__99882 = arguments.length;
switch (G__99882) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3(port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(ret)){
var val_99884 = cljs.core.deref(ret);
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_99884) : fn1.call(null,val_99884));
} else {
cljs.core.async.impl.dispatch.run(((function (val_99884,ret){
return (function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(val_99884) : fn1.call(null,val_99884));
});})(val_99884,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn1 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn1 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var G__99886 = arguments.length;
switch (G__99886) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__5733__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__5733__auto__)){
var ret = temp__5733__auto__;
return cljs.core.deref(ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4(port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__5733__auto__ = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1(fn1));
if(cljs.core.truth_(temp__5733__auto__)){
var retb = temp__5733__auto__;
var ret = cljs.core.deref(retb);
if(cljs.core.truth_(on_caller_QMARK_)){
(fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
} else {
cljs.core.async.impl.dispatch.run(((function (ret,retb,temp__5733__auto__){
return (function (){
return (fn1.cljs$core$IFn$_invoke$arity$1 ? fn1.cljs$core$IFn$_invoke$arity$1(ret) : fn1.call(null,ret));
});})(ret,retb,temp__5733__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_(port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__4607__auto___99888 = n;
var x_99889 = (0);
while(true){
if((x_99889 < n__4607__auto___99888)){
(a[x_99889] = (0));

var G__99890 = (x_99889 + (1));
x_99889 = G__99890;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(i,n)){
return a;
} else {
var j = cljs.core.rand_int(i);
(a[i] = (a[j]));

(a[j] = i);

var G__99891 = (i + (1));
i = G__99891;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(true);
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async99892 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async99892 = (function (flag,meta99893){
this.flag = flag;
this.meta99893 = meta99893;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async99892.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_99894,meta99893__$1){
var self__ = this;
var _99894__$1 = this;
return (new cljs.core.async.t_cljs$core$async99892(self__.flag,meta99893__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async99892.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_99894){
var self__ = this;
var _99894__$1 = this;
return self__.meta99893;
});})(flag))
;

cljs.core.async.t_cljs$core$async99892.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async99892.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref(self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async99892.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async99892.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async99892.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$flag,cljs.core.cst$sym$meta99893], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async99892.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async99892.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async99892";

cljs.core.async.t_cljs$core$async99892.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write(writer__4375__auto__,"cljs.core.async/t_cljs$core$async99892");
});})(flag))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async99892.
 */
cljs.core.async.__GT_t_cljs$core$async99892 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async99892(flag__$1,meta99893){
return (new cljs.core.async.t_cljs$core$async99892(flag__$1,meta99893));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async99892(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async99895 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async99895 = (function (flag,cb,meta99896){
this.flag = flag;
this.cb = cb;
this.meta99896 = meta99896;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async99895.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_99897,meta99896__$1){
var self__ = this;
var _99897__$1 = this;
return (new cljs.core.async.t_cljs$core$async99895(self__.flag,self__.cb,meta99896__$1));
});

cljs.core.async.t_cljs$core$async99895.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_99897){
var self__ = this;
var _99897__$1 = this;
return self__.meta99896;
});

cljs.core.async.t_cljs$core$async99895.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async99895.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.flag);
});

cljs.core.async.t_cljs$core$async99895.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async99895.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit(self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async99895.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$flag,cljs.core.cst$sym$cb,cljs.core.cst$sym$meta99896], null);
});

cljs.core.async.t_cljs$core$async99895.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async99895.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async99895";

cljs.core.async.t_cljs$core$async99895.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write(writer__4375__auto__,"cljs.core.async/t_cljs$core$async99895");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async99895.
 */
cljs.core.async.__GT_t_cljs$core$async99895 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async99895(flag__$1,cb__$1,meta99896){
return (new cljs.core.async.t_cljs$core$async99895(flag__$1,cb__$1,meta99896));
});

}

return (new cljs.core.async.t_cljs$core$async99895(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag();
var n = cljs.core.count(ports);
var idxs = cljs.core.async.random_array(n);
var priority = cljs.core.cst$kw$priority.cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(ports,idx);
var wport = ((cljs.core.vector_QMARK_(port))?(port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((0)) : port.call(null,(0))):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = (port.cljs$core$IFn$_invoke$arity$1 ? port.cljs$core$IFn$_invoke$arity$1((1)) : port.call(null,(1)));
return cljs.core.async.impl.protocols.put_BANG_(wport,val,cljs.core.async.alt_handler(flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__99898_SHARP_){
var G__99900 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__99898_SHARP_,wport], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__99900) : fret.call(null,G__99900));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.alt_handler(flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__99899_SHARP_){
var G__99901 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__99899_SHARP_,port], null);
return (fret.cljs$core$IFn$_invoke$arity$1 ? fret.cljs$core$IFn$_invoke$arity$1(G__99901) : fret.call(null,G__99901));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref(vbox),(function (){var or__4131__auto__ = wport;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return port;
}
})()], null));
} else {
var G__99902 = (i + (1));
i = G__99902;
continue;
}
} else {
return null;
}
break;
}
})();
var or__4131__auto__ = ret;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
if(cljs.core.contains_QMARK_(opts,cljs.core.cst$kw$default)){
var temp__5735__auto__ = (function (){var and__4120__auto__ = flag.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null);
if(cljs.core.truth_(and__4120__auto__)){
return flag.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);
} else {
return and__4120__auto__;
}
})();
if(cljs.core.truth_(temp__5735__auto__)){
var got = temp__5735__auto__;
return cljs.core.async.impl.channels.box(new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$default.cljs$core$IFn$_invoke$arity$1(opts),cljs.core.cst$kw$default], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___99908 = arguments.length;
var i__4731__auto___99909 = (0);
while(true){
if((i__4731__auto___99909 < len__4730__auto___99908)){
args__4736__auto__.push((arguments[i__4731__auto___99909]));

var G__99910 = (i__4731__auto___99909 + (1));
i__4731__auto___99909 = G__99910;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__99905){
var map__99906 = p__99905;
var map__99906__$1 = (((((!((map__99906 == null))))?(((((map__99906.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__99906.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__99906):map__99906);
var opts = map__99906__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq99903){
var G__99904 = cljs.core.first(seq99903);
var seq99903__$1 = cljs.core.next(seq99903);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__99904,seq99903__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_(port,val,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref(ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_(port,cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2(cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref(ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var G__99912 = arguments.length;
switch (G__99912) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3(from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__99809__auto___99958 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___99958){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___99958){
return (function (state_99936){
var state_val_99937 = (state_99936[(1)]);
if((state_val_99937 === (7))){
var inst_99932 = (state_99936[(2)]);
var state_99936__$1 = state_99936;
var statearr_99938_99959 = state_99936__$1;
(statearr_99938_99959[(2)] = inst_99932);

(statearr_99938_99959[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_99937 === (1))){
var state_99936__$1 = state_99936;
var statearr_99939_99960 = state_99936__$1;
(statearr_99939_99960[(2)] = null);

(statearr_99939_99960[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_99937 === (4))){
var inst_99915 = (state_99936[(7)]);
var inst_99915__$1 = (state_99936[(2)]);
var inst_99916 = (inst_99915__$1 == null);
var state_99936__$1 = (function (){var statearr_99940 = state_99936;
(statearr_99940[(7)] = inst_99915__$1);

return statearr_99940;
})();
if(cljs.core.truth_(inst_99916)){
var statearr_99941_99961 = state_99936__$1;
(statearr_99941_99961[(1)] = (5));

} else {
var statearr_99942_99962 = state_99936__$1;
(statearr_99942_99962[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_99937 === (13))){
var state_99936__$1 = state_99936;
var statearr_99943_99963 = state_99936__$1;
(statearr_99943_99963[(2)] = null);

(statearr_99943_99963[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_99937 === (6))){
var inst_99915 = (state_99936[(7)]);
var state_99936__$1 = state_99936;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_99936__$1,(11),to,inst_99915);
} else {
if((state_val_99937 === (3))){
var inst_99934 = (state_99936[(2)]);
var state_99936__$1 = state_99936;
return cljs.core.async.impl.ioc_helpers.return_chan(state_99936__$1,inst_99934);
} else {
if((state_val_99937 === (12))){
var state_99936__$1 = state_99936;
var statearr_99944_99964 = state_99936__$1;
(statearr_99944_99964[(2)] = null);

(statearr_99944_99964[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_99937 === (2))){
var state_99936__$1 = state_99936;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_99936__$1,(4),from);
} else {
if((state_val_99937 === (11))){
var inst_99925 = (state_99936[(2)]);
var state_99936__$1 = state_99936;
if(cljs.core.truth_(inst_99925)){
var statearr_99945_99965 = state_99936__$1;
(statearr_99945_99965[(1)] = (12));

} else {
var statearr_99946_99966 = state_99936__$1;
(statearr_99946_99966[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_99937 === (9))){
var state_99936__$1 = state_99936;
var statearr_99947_99967 = state_99936__$1;
(statearr_99947_99967[(2)] = null);

(statearr_99947_99967[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_99937 === (5))){
var state_99936__$1 = state_99936;
if(cljs.core.truth_(close_QMARK_)){
var statearr_99948_99968 = state_99936__$1;
(statearr_99948_99968[(1)] = (8));

} else {
var statearr_99949_99969 = state_99936__$1;
(statearr_99949_99969[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_99937 === (14))){
var inst_99930 = (state_99936[(2)]);
var state_99936__$1 = state_99936;
var statearr_99950_99970 = state_99936__$1;
(statearr_99950_99970[(2)] = inst_99930);

(statearr_99950_99970[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_99937 === (10))){
var inst_99922 = (state_99936[(2)]);
var state_99936__$1 = state_99936;
var statearr_99951_99971 = state_99936__$1;
(statearr_99951_99971[(2)] = inst_99922);

(statearr_99951_99971[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_99937 === (8))){
var inst_99919 = cljs.core.async.close_BANG_(to);
var state_99936__$1 = state_99936;
var statearr_99952_99972 = state_99936__$1;
(statearr_99952_99972[(2)] = inst_99919);

(statearr_99952_99972[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___99958))
;
return ((function (switch__99702__auto__,c__99809__auto___99958){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_99953 = [null,null,null,null,null,null,null,null];
(statearr_99953[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_99953[(1)] = (1));

return statearr_99953;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_99936){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_99936);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e99954){if((e99954 instanceof Object)){
var ex__99706__auto__ = e99954;
var statearr_99955_99973 = state_99936;
(statearr_99955_99973[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_99936);

return cljs.core.cst$kw$recur;
} else {
throw e99954;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__99974 = state_99936;
state_99936 = G__99974;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_99936){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_99936);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___99958))
})();
var state__99811__auto__ = (function (){var statearr_99956 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_99956[(6)] = c__99809__auto___99958);

return statearr_99956;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___99958))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var results = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(n);
var process = ((function (jobs,results){
return (function (p__99975){
var vec__99976 = p__99975;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__99976,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__99976,(1),null);
var job = vec__99976;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((1),xf,ex_handler);
var c__99809__auto___100147 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___100147,res,vec__99976,v,p,job,jobs,results){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___100147,res,vec__99976,v,p,job,jobs,results){
return (function (state_99983){
var state_val_99984 = (state_99983[(1)]);
if((state_val_99984 === (1))){
var state_99983__$1 = state_99983;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_99983__$1,(2),res,v);
} else {
if((state_val_99984 === (2))){
var inst_99980 = (state_99983[(2)]);
var inst_99981 = cljs.core.async.close_BANG_(res);
var state_99983__$1 = (function (){var statearr_99985 = state_99983;
(statearr_99985[(7)] = inst_99980);

return statearr_99985;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_99983__$1,inst_99981);
} else {
return null;
}
}
});})(c__99809__auto___100147,res,vec__99976,v,p,job,jobs,results))
;
return ((function (switch__99702__auto__,c__99809__auto___100147,res,vec__99976,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0 = (function (){
var statearr_99986 = [null,null,null,null,null,null,null,null];
(statearr_99986[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__);

(statearr_99986[(1)] = (1));

return statearr_99986;
});
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1 = (function (state_99983){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_99983);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e99987){if((e99987 instanceof Object)){
var ex__99706__auto__ = e99987;
var statearr_99988_100148 = state_99983;
(statearr_99988_100148[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_99983);

return cljs.core.cst$kw$recur;
} else {
throw e99987;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100149 = state_99983;
state_99983 = G__100149;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__ = function(state_99983){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1.call(this,state_99983);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___100147,res,vec__99976,v,p,job,jobs,results))
})();
var state__99811__auto__ = (function (){var statearr_99989 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_99989[(6)] = c__99809__auto___100147);

return statearr_99989;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___100147,res,vec__99976,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__99990){
var vec__99991 = p__99990;
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__99991,(0),null);
var p = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__99991,(1),null);
var job = vec__99991;
if((job == null)){
cljs.core.async.close_BANG_(results);

return null;
} else {
var res = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
(xf.cljs$core$IFn$_invoke$arity$2 ? xf.cljs$core$IFn$_invoke$arity$2(v,res) : xf.call(null,v,res));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(p,res);

return true;
}
});})(jobs,results,process))
;
var n__4607__auto___100150 = n;
var __100151 = (0);
while(true){
if((__100151 < n__4607__auto___100150)){
var G__99994_100152 = type;
var G__99994_100153__$1 = (((G__99994_100152 instanceof cljs.core.Keyword))?G__99994_100152.fqn:null);
switch (G__99994_100153__$1) {
case "compute":
var c__99809__auto___100155 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__100151,c__99809__auto___100155,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (__100151,c__99809__auto___100155,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async){
return (function (state_100007){
var state_val_100008 = (state_100007[(1)]);
if((state_val_100008 === (1))){
var state_100007__$1 = state_100007;
var statearr_100009_100156 = state_100007__$1;
(statearr_100009_100156[(2)] = null);

(statearr_100009_100156[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100008 === (2))){
var state_100007__$1 = state_100007;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100007__$1,(4),jobs);
} else {
if((state_val_100008 === (3))){
var inst_100005 = (state_100007[(2)]);
var state_100007__$1 = state_100007;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100007__$1,inst_100005);
} else {
if((state_val_100008 === (4))){
var inst_99997 = (state_100007[(2)]);
var inst_99998 = process(inst_99997);
var state_100007__$1 = state_100007;
if(cljs.core.truth_(inst_99998)){
var statearr_100010_100157 = state_100007__$1;
(statearr_100010_100157[(1)] = (5));

} else {
var statearr_100011_100158 = state_100007__$1;
(statearr_100011_100158[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100008 === (5))){
var state_100007__$1 = state_100007;
var statearr_100012_100159 = state_100007__$1;
(statearr_100012_100159[(2)] = null);

(statearr_100012_100159[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100008 === (6))){
var state_100007__$1 = state_100007;
var statearr_100013_100160 = state_100007__$1;
(statearr_100013_100160[(2)] = null);

(statearr_100013_100160[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100008 === (7))){
var inst_100003 = (state_100007[(2)]);
var state_100007__$1 = state_100007;
var statearr_100014_100161 = state_100007__$1;
(statearr_100014_100161[(2)] = inst_100003);

(statearr_100014_100161[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(__100151,c__99809__auto___100155,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async))
;
return ((function (__100151,switch__99702__auto__,c__99809__auto___100155,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0 = (function (){
var statearr_100015 = [null,null,null,null,null,null,null];
(statearr_100015[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__);

(statearr_100015[(1)] = (1));

return statearr_100015;
});
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1 = (function (state_100007){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100007);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e100016){if((e100016 instanceof Object)){
var ex__99706__auto__ = e100016;
var statearr_100017_100162 = state_100007;
(statearr_100017_100162[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100007);

return cljs.core.cst$kw$recur;
} else {
throw e100016;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100163 = state_100007;
state_100007 = G__100163;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__ = function(state_100007){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1.call(this,state_100007);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__;
})()
;})(__100151,switch__99702__auto__,c__99809__auto___100155,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async))
})();
var state__99811__auto__ = (function (){var statearr_100018 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_100018[(6)] = c__99809__auto___100155);

return statearr_100018;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(__100151,c__99809__auto___100155,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async))
);


break;
case "async":
var c__99809__auto___100164 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (__100151,c__99809__auto___100164,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (__100151,c__99809__auto___100164,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async){
return (function (state_100031){
var state_val_100032 = (state_100031[(1)]);
if((state_val_100032 === (1))){
var state_100031__$1 = state_100031;
var statearr_100033_100165 = state_100031__$1;
(statearr_100033_100165[(2)] = null);

(statearr_100033_100165[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100032 === (2))){
var state_100031__$1 = state_100031;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100031__$1,(4),jobs);
} else {
if((state_val_100032 === (3))){
var inst_100029 = (state_100031[(2)]);
var state_100031__$1 = state_100031;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100031__$1,inst_100029);
} else {
if((state_val_100032 === (4))){
var inst_100021 = (state_100031[(2)]);
var inst_100022 = async(inst_100021);
var state_100031__$1 = state_100031;
if(cljs.core.truth_(inst_100022)){
var statearr_100034_100166 = state_100031__$1;
(statearr_100034_100166[(1)] = (5));

} else {
var statearr_100035_100167 = state_100031__$1;
(statearr_100035_100167[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100032 === (5))){
var state_100031__$1 = state_100031;
var statearr_100036_100168 = state_100031__$1;
(statearr_100036_100168[(2)] = null);

(statearr_100036_100168[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100032 === (6))){
var state_100031__$1 = state_100031;
var statearr_100037_100169 = state_100031__$1;
(statearr_100037_100169[(2)] = null);

(statearr_100037_100169[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100032 === (7))){
var inst_100027 = (state_100031[(2)]);
var state_100031__$1 = state_100031;
var statearr_100038_100170 = state_100031__$1;
(statearr_100038_100170[(2)] = inst_100027);

(statearr_100038_100170[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(__100151,c__99809__auto___100164,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async))
;
return ((function (__100151,switch__99702__auto__,c__99809__auto___100164,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0 = (function (){
var statearr_100039 = [null,null,null,null,null,null,null];
(statearr_100039[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__);

(statearr_100039[(1)] = (1));

return statearr_100039;
});
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1 = (function (state_100031){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100031);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e100040){if((e100040 instanceof Object)){
var ex__99706__auto__ = e100040;
var statearr_100041_100171 = state_100031;
(statearr_100041_100171[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100031);

return cljs.core.cst$kw$recur;
} else {
throw e100040;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100172 = state_100031;
state_100031 = G__100172;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__ = function(state_100031){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1.call(this,state_100031);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__;
})()
;})(__100151,switch__99702__auto__,c__99809__auto___100164,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async))
})();
var state__99811__auto__ = (function (){var statearr_100042 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_100042[(6)] = c__99809__auto___100164);

return statearr_100042;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(__100151,c__99809__auto___100164,G__99994_100152,G__99994_100153__$1,n__4607__auto___100150,jobs,results,process,async))
);


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__99994_100153__$1)].join('')));

}

var G__100173 = (__100151 + (1));
__100151 = G__100173;
continue;
} else {
}
break;
}

var c__99809__auto___100174 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___100174,jobs,results,process,async){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___100174,jobs,results,process,async){
return (function (state_100064){
var state_val_100065 = (state_100064[(1)]);
if((state_val_100065 === (7))){
var inst_100060 = (state_100064[(2)]);
var state_100064__$1 = state_100064;
var statearr_100066_100175 = state_100064__$1;
(statearr_100066_100175[(2)] = inst_100060);

(statearr_100066_100175[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100065 === (1))){
var state_100064__$1 = state_100064;
var statearr_100067_100176 = state_100064__$1;
(statearr_100067_100176[(2)] = null);

(statearr_100067_100176[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100065 === (4))){
var inst_100045 = (state_100064[(7)]);
var inst_100045__$1 = (state_100064[(2)]);
var inst_100046 = (inst_100045__$1 == null);
var state_100064__$1 = (function (){var statearr_100068 = state_100064;
(statearr_100068[(7)] = inst_100045__$1);

return statearr_100068;
})();
if(cljs.core.truth_(inst_100046)){
var statearr_100069_100177 = state_100064__$1;
(statearr_100069_100177[(1)] = (5));

} else {
var statearr_100070_100178 = state_100064__$1;
(statearr_100070_100178[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100065 === (6))){
var inst_100050 = (state_100064[(8)]);
var inst_100045 = (state_100064[(7)]);
var inst_100050__$1 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_100051 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100052 = [inst_100045,inst_100050__$1];
var inst_100053 = (new cljs.core.PersistentVector(null,2,(5),inst_100051,inst_100052,null));
var state_100064__$1 = (function (){var statearr_100071 = state_100064;
(statearr_100071[(8)] = inst_100050__$1);

return statearr_100071;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_100064__$1,(8),jobs,inst_100053);
} else {
if((state_val_100065 === (3))){
var inst_100062 = (state_100064[(2)]);
var state_100064__$1 = state_100064;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100064__$1,inst_100062);
} else {
if((state_val_100065 === (2))){
var state_100064__$1 = state_100064;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100064__$1,(4),from);
} else {
if((state_val_100065 === (9))){
var inst_100057 = (state_100064[(2)]);
var state_100064__$1 = (function (){var statearr_100072 = state_100064;
(statearr_100072[(9)] = inst_100057);

return statearr_100072;
})();
var statearr_100073_100179 = state_100064__$1;
(statearr_100073_100179[(2)] = null);

(statearr_100073_100179[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100065 === (5))){
var inst_100048 = cljs.core.async.close_BANG_(jobs);
var state_100064__$1 = state_100064;
var statearr_100074_100180 = state_100064__$1;
(statearr_100074_100180[(2)] = inst_100048);

(statearr_100074_100180[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100065 === (8))){
var inst_100050 = (state_100064[(8)]);
var inst_100055 = (state_100064[(2)]);
var state_100064__$1 = (function (){var statearr_100075 = state_100064;
(statearr_100075[(10)] = inst_100055);

return statearr_100075;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_100064__$1,(9),results,inst_100050);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___100174,jobs,results,process,async))
;
return ((function (switch__99702__auto__,c__99809__auto___100174,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0 = (function (){
var statearr_100076 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_100076[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__);

(statearr_100076[(1)] = (1));

return statearr_100076;
});
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1 = (function (state_100064){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100064);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e100077){if((e100077 instanceof Object)){
var ex__99706__auto__ = e100077;
var statearr_100078_100181 = state_100064;
(statearr_100078_100181[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100064);

return cljs.core.cst$kw$recur;
} else {
throw e100077;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100182 = state_100064;
state_100064 = G__100182;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__ = function(state_100064){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1.call(this,state_100064);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___100174,jobs,results,process,async))
})();
var state__99811__auto__ = (function (){var statearr_100079 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_100079[(6)] = c__99809__auto___100174);

return statearr_100079;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___100174,jobs,results,process,async))
);


var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,jobs,results,process,async){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,jobs,results,process,async){
return (function (state_100117){
var state_val_100118 = (state_100117[(1)]);
if((state_val_100118 === (7))){
var inst_100113 = (state_100117[(2)]);
var state_100117__$1 = state_100117;
var statearr_100119_100183 = state_100117__$1;
(statearr_100119_100183[(2)] = inst_100113);

(statearr_100119_100183[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (20))){
var state_100117__$1 = state_100117;
var statearr_100120_100184 = state_100117__$1;
(statearr_100120_100184[(2)] = null);

(statearr_100120_100184[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (1))){
var state_100117__$1 = state_100117;
var statearr_100121_100185 = state_100117__$1;
(statearr_100121_100185[(2)] = null);

(statearr_100121_100185[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (4))){
var inst_100082 = (state_100117[(7)]);
var inst_100082__$1 = (state_100117[(2)]);
var inst_100083 = (inst_100082__$1 == null);
var state_100117__$1 = (function (){var statearr_100122 = state_100117;
(statearr_100122[(7)] = inst_100082__$1);

return statearr_100122;
})();
if(cljs.core.truth_(inst_100083)){
var statearr_100123_100186 = state_100117__$1;
(statearr_100123_100186[(1)] = (5));

} else {
var statearr_100124_100187 = state_100117__$1;
(statearr_100124_100187[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (15))){
var inst_100095 = (state_100117[(8)]);
var state_100117__$1 = state_100117;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_100117__$1,(18),to,inst_100095);
} else {
if((state_val_100118 === (21))){
var inst_100108 = (state_100117[(2)]);
var state_100117__$1 = state_100117;
var statearr_100125_100188 = state_100117__$1;
(statearr_100125_100188[(2)] = inst_100108);

(statearr_100125_100188[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (13))){
var inst_100110 = (state_100117[(2)]);
var state_100117__$1 = (function (){var statearr_100126 = state_100117;
(statearr_100126[(9)] = inst_100110);

return statearr_100126;
})();
var statearr_100127_100189 = state_100117__$1;
(statearr_100127_100189[(2)] = null);

(statearr_100127_100189[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (6))){
var inst_100082 = (state_100117[(7)]);
var state_100117__$1 = state_100117;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100117__$1,(11),inst_100082);
} else {
if((state_val_100118 === (17))){
var inst_100103 = (state_100117[(2)]);
var state_100117__$1 = state_100117;
if(cljs.core.truth_(inst_100103)){
var statearr_100128_100190 = state_100117__$1;
(statearr_100128_100190[(1)] = (19));

} else {
var statearr_100129_100191 = state_100117__$1;
(statearr_100129_100191[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (3))){
var inst_100115 = (state_100117[(2)]);
var state_100117__$1 = state_100117;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100117__$1,inst_100115);
} else {
if((state_val_100118 === (12))){
var inst_100092 = (state_100117[(10)]);
var state_100117__$1 = state_100117;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100117__$1,(14),inst_100092);
} else {
if((state_val_100118 === (2))){
var state_100117__$1 = state_100117;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100117__$1,(4),results);
} else {
if((state_val_100118 === (19))){
var state_100117__$1 = state_100117;
var statearr_100130_100192 = state_100117__$1;
(statearr_100130_100192[(2)] = null);

(statearr_100130_100192[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (11))){
var inst_100092 = (state_100117[(2)]);
var state_100117__$1 = (function (){var statearr_100131 = state_100117;
(statearr_100131[(10)] = inst_100092);

return statearr_100131;
})();
var statearr_100132_100193 = state_100117__$1;
(statearr_100132_100193[(2)] = null);

(statearr_100132_100193[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (9))){
var state_100117__$1 = state_100117;
var statearr_100133_100194 = state_100117__$1;
(statearr_100133_100194[(2)] = null);

(statearr_100133_100194[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (5))){
var state_100117__$1 = state_100117;
if(cljs.core.truth_(close_QMARK_)){
var statearr_100134_100195 = state_100117__$1;
(statearr_100134_100195[(1)] = (8));

} else {
var statearr_100135_100196 = state_100117__$1;
(statearr_100135_100196[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (14))){
var inst_100097 = (state_100117[(11)]);
var inst_100095 = (state_100117[(8)]);
var inst_100095__$1 = (state_100117[(2)]);
var inst_100096 = (inst_100095__$1 == null);
var inst_100097__$1 = cljs.core.not(inst_100096);
var state_100117__$1 = (function (){var statearr_100136 = state_100117;
(statearr_100136[(11)] = inst_100097__$1);

(statearr_100136[(8)] = inst_100095__$1);

return statearr_100136;
})();
if(inst_100097__$1){
var statearr_100137_100197 = state_100117__$1;
(statearr_100137_100197[(1)] = (15));

} else {
var statearr_100138_100198 = state_100117__$1;
(statearr_100138_100198[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (16))){
var inst_100097 = (state_100117[(11)]);
var state_100117__$1 = state_100117;
var statearr_100139_100199 = state_100117__$1;
(statearr_100139_100199[(2)] = inst_100097);

(statearr_100139_100199[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (10))){
var inst_100089 = (state_100117[(2)]);
var state_100117__$1 = state_100117;
var statearr_100140_100200 = state_100117__$1;
(statearr_100140_100200[(2)] = inst_100089);

(statearr_100140_100200[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (18))){
var inst_100100 = (state_100117[(2)]);
var state_100117__$1 = state_100117;
var statearr_100141_100201 = state_100117__$1;
(statearr_100141_100201[(2)] = inst_100100);

(statearr_100141_100201[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100118 === (8))){
var inst_100086 = cljs.core.async.close_BANG_(to);
var state_100117__$1 = state_100117;
var statearr_100142_100202 = state_100117__$1;
(statearr_100142_100202[(2)] = inst_100086);

(statearr_100142_100202[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,jobs,results,process,async))
;
return ((function (switch__99702__auto__,c__99809__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0 = (function (){
var statearr_100143 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_100143[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__);

(statearr_100143[(1)] = (1));

return statearr_100143;
});
var cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1 = (function (state_100117){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100117);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e100144){if((e100144 instanceof Object)){
var ex__99706__auto__ = e100144;
var statearr_100145_100203 = state_100117;
(statearr_100145_100203[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100117);

return cljs.core.cst$kw$recur;
} else {
throw e100144;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100204 = state_100117;
state_100117 = G__100204;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__ = function(state_100117){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1.call(this,state_100117);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__99703__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,jobs,results,process,async))
})();
var state__99811__auto__ = (function (){var statearr_100146 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_100146[(6)] = c__99809__auto__);

return statearr_100146;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,jobs,results,process,async))
);

return c__99809__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var G__100206 = arguments.length;
switch (G__100206) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5(n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_(n,to,af,from,close_QMARK_,null,cljs.core.cst$kw$async);
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var G__100209 = arguments.length;
switch (G__100209) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5(n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6(n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,cljs.core.cst$kw$compute);
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var G__100212 = arguments.length;
switch (G__100212) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4(p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(t_buf_or_n);
var fc = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(f_buf_or_n);
var c__99809__auto___100261 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___100261,tc,fc){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___100261,tc,fc){
return (function (state_100238){
var state_val_100239 = (state_100238[(1)]);
if((state_val_100239 === (7))){
var inst_100234 = (state_100238[(2)]);
var state_100238__$1 = state_100238;
var statearr_100240_100262 = state_100238__$1;
(statearr_100240_100262[(2)] = inst_100234);

(statearr_100240_100262[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100239 === (1))){
var state_100238__$1 = state_100238;
var statearr_100241_100263 = state_100238__$1;
(statearr_100241_100263[(2)] = null);

(statearr_100241_100263[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100239 === (4))){
var inst_100215 = (state_100238[(7)]);
var inst_100215__$1 = (state_100238[(2)]);
var inst_100216 = (inst_100215__$1 == null);
var state_100238__$1 = (function (){var statearr_100242 = state_100238;
(statearr_100242[(7)] = inst_100215__$1);

return statearr_100242;
})();
if(cljs.core.truth_(inst_100216)){
var statearr_100243_100264 = state_100238__$1;
(statearr_100243_100264[(1)] = (5));

} else {
var statearr_100244_100265 = state_100238__$1;
(statearr_100244_100265[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100239 === (13))){
var state_100238__$1 = state_100238;
var statearr_100245_100266 = state_100238__$1;
(statearr_100245_100266[(2)] = null);

(statearr_100245_100266[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100239 === (6))){
var inst_100215 = (state_100238[(7)]);
var inst_100221 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_100215) : p.call(null,inst_100215));
var state_100238__$1 = state_100238;
if(cljs.core.truth_(inst_100221)){
var statearr_100246_100267 = state_100238__$1;
(statearr_100246_100267[(1)] = (9));

} else {
var statearr_100247_100268 = state_100238__$1;
(statearr_100247_100268[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100239 === (3))){
var inst_100236 = (state_100238[(2)]);
var state_100238__$1 = state_100238;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100238__$1,inst_100236);
} else {
if((state_val_100239 === (12))){
var state_100238__$1 = state_100238;
var statearr_100248_100269 = state_100238__$1;
(statearr_100248_100269[(2)] = null);

(statearr_100248_100269[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100239 === (2))){
var state_100238__$1 = state_100238;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100238__$1,(4),ch);
} else {
if((state_val_100239 === (11))){
var inst_100215 = (state_100238[(7)]);
var inst_100225 = (state_100238[(2)]);
var state_100238__$1 = state_100238;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_100238__$1,(8),inst_100225,inst_100215);
} else {
if((state_val_100239 === (9))){
var state_100238__$1 = state_100238;
var statearr_100249_100270 = state_100238__$1;
(statearr_100249_100270[(2)] = tc);

(statearr_100249_100270[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100239 === (5))){
var inst_100218 = cljs.core.async.close_BANG_(tc);
var inst_100219 = cljs.core.async.close_BANG_(fc);
var state_100238__$1 = (function (){var statearr_100250 = state_100238;
(statearr_100250[(8)] = inst_100218);

return statearr_100250;
})();
var statearr_100251_100271 = state_100238__$1;
(statearr_100251_100271[(2)] = inst_100219);

(statearr_100251_100271[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100239 === (14))){
var inst_100232 = (state_100238[(2)]);
var state_100238__$1 = state_100238;
var statearr_100252_100272 = state_100238__$1;
(statearr_100252_100272[(2)] = inst_100232);

(statearr_100252_100272[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100239 === (10))){
var state_100238__$1 = state_100238;
var statearr_100253_100273 = state_100238__$1;
(statearr_100253_100273[(2)] = fc);

(statearr_100253_100273[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100239 === (8))){
var inst_100227 = (state_100238[(2)]);
var state_100238__$1 = state_100238;
if(cljs.core.truth_(inst_100227)){
var statearr_100254_100274 = state_100238__$1;
(statearr_100254_100274[(1)] = (12));

} else {
var statearr_100255_100275 = state_100238__$1;
(statearr_100255_100275[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___100261,tc,fc))
;
return ((function (switch__99702__auto__,c__99809__auto___100261,tc,fc){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_100256 = [null,null,null,null,null,null,null,null,null];
(statearr_100256[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_100256[(1)] = (1));

return statearr_100256;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_100238){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100238);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e100257){if((e100257 instanceof Object)){
var ex__99706__auto__ = e100257;
var statearr_100258_100276 = state_100238;
(statearr_100258_100276[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100238);

return cljs.core.cst$kw$recur;
} else {
throw e100257;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100277 = state_100238;
state_100238 = G__100277;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_100238){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_100238);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___100261,tc,fc))
})();
var state__99811__auto__ = (function (){var statearr_100259 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_100259[(6)] = c__99809__auto___100261);

return statearr_100259;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___100261,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_100298){
var state_val_100299 = (state_100298[(1)]);
if((state_val_100299 === (7))){
var inst_100294 = (state_100298[(2)]);
var state_100298__$1 = state_100298;
var statearr_100300_100318 = state_100298__$1;
(statearr_100300_100318[(2)] = inst_100294);

(statearr_100300_100318[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100299 === (1))){
var inst_100278 = init;
var state_100298__$1 = (function (){var statearr_100301 = state_100298;
(statearr_100301[(7)] = inst_100278);

return statearr_100301;
})();
var statearr_100302_100319 = state_100298__$1;
(statearr_100302_100319[(2)] = null);

(statearr_100302_100319[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100299 === (4))){
var inst_100281 = (state_100298[(8)]);
var inst_100281__$1 = (state_100298[(2)]);
var inst_100282 = (inst_100281__$1 == null);
var state_100298__$1 = (function (){var statearr_100303 = state_100298;
(statearr_100303[(8)] = inst_100281__$1);

return statearr_100303;
})();
if(cljs.core.truth_(inst_100282)){
var statearr_100304_100320 = state_100298__$1;
(statearr_100304_100320[(1)] = (5));

} else {
var statearr_100305_100321 = state_100298__$1;
(statearr_100305_100321[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100299 === (6))){
var inst_100285 = (state_100298[(9)]);
var inst_100278 = (state_100298[(7)]);
var inst_100281 = (state_100298[(8)]);
var inst_100285__$1 = (f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(inst_100278,inst_100281) : f.call(null,inst_100278,inst_100281));
var inst_100286 = cljs.core.reduced_QMARK_(inst_100285__$1);
var state_100298__$1 = (function (){var statearr_100306 = state_100298;
(statearr_100306[(9)] = inst_100285__$1);

return statearr_100306;
})();
if(inst_100286){
var statearr_100307_100322 = state_100298__$1;
(statearr_100307_100322[(1)] = (8));

} else {
var statearr_100308_100323 = state_100298__$1;
(statearr_100308_100323[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100299 === (3))){
var inst_100296 = (state_100298[(2)]);
var state_100298__$1 = state_100298;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100298__$1,inst_100296);
} else {
if((state_val_100299 === (2))){
var state_100298__$1 = state_100298;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100298__$1,(4),ch);
} else {
if((state_val_100299 === (9))){
var inst_100285 = (state_100298[(9)]);
var inst_100278 = inst_100285;
var state_100298__$1 = (function (){var statearr_100309 = state_100298;
(statearr_100309[(7)] = inst_100278);

return statearr_100309;
})();
var statearr_100310_100324 = state_100298__$1;
(statearr_100310_100324[(2)] = null);

(statearr_100310_100324[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100299 === (5))){
var inst_100278 = (state_100298[(7)]);
var state_100298__$1 = state_100298;
var statearr_100311_100325 = state_100298__$1;
(statearr_100311_100325[(2)] = inst_100278);

(statearr_100311_100325[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100299 === (10))){
var inst_100292 = (state_100298[(2)]);
var state_100298__$1 = state_100298;
var statearr_100312_100326 = state_100298__$1;
(statearr_100312_100326[(2)] = inst_100292);

(statearr_100312_100326[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100299 === (8))){
var inst_100285 = (state_100298[(9)]);
var inst_100288 = cljs.core.deref(inst_100285);
var state_100298__$1 = state_100298;
var statearr_100313_100327 = state_100298__$1;
(statearr_100313_100327[(2)] = inst_100288);

(statearr_100313_100327[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__99703__auto__ = null;
var cljs$core$async$reduce_$_state_machine__99703__auto____0 = (function (){
var statearr_100314 = [null,null,null,null,null,null,null,null,null,null];
(statearr_100314[(0)] = cljs$core$async$reduce_$_state_machine__99703__auto__);

(statearr_100314[(1)] = (1));

return statearr_100314;
});
var cljs$core$async$reduce_$_state_machine__99703__auto____1 = (function (state_100298){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100298);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e100315){if((e100315 instanceof Object)){
var ex__99706__auto__ = e100315;
var statearr_100316_100328 = state_100298;
(statearr_100316_100328[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100298);

return cljs.core.cst$kw$recur;
} else {
throw e100315;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100329 = state_100298;
state_100298 = G__100329;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__99703__auto__ = function(state_100298){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__99703__auto____1.call(this,state_100298);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__99703__auto____0;
cljs$core$async$reduce_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__99703__auto____1;
return cljs$core$async$reduce_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_100317 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_100317[(6)] = c__99809__auto__);

return statearr_100317;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = (xform.cljs$core$IFn$_invoke$arity$1 ? xform.cljs$core$IFn$_invoke$arity$1(f) : xform.call(null,f));
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,f__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,f__$1){
return (function (state_100335){
var state_val_100336 = (state_100335[(1)]);
if((state_val_100336 === (1))){
var inst_100330 = cljs.core.async.reduce(f__$1,init,ch);
var state_100335__$1 = state_100335;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100335__$1,(2),inst_100330);
} else {
if((state_val_100336 === (2))){
var inst_100332 = (state_100335[(2)]);
var inst_100333 = (f__$1.cljs$core$IFn$_invoke$arity$1 ? f__$1.cljs$core$IFn$_invoke$arity$1(inst_100332) : f__$1.call(null,inst_100332));
var state_100335__$1 = state_100335;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100335__$1,inst_100333);
} else {
return null;
}
}
});})(c__99809__auto__,f__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,f__$1){
return (function() {
var cljs$core$async$transduce_$_state_machine__99703__auto__ = null;
var cljs$core$async$transduce_$_state_machine__99703__auto____0 = (function (){
var statearr_100337 = [null,null,null,null,null,null,null];
(statearr_100337[(0)] = cljs$core$async$transduce_$_state_machine__99703__auto__);

(statearr_100337[(1)] = (1));

return statearr_100337;
});
var cljs$core$async$transduce_$_state_machine__99703__auto____1 = (function (state_100335){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100335);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e100338){if((e100338 instanceof Object)){
var ex__99706__auto__ = e100338;
var statearr_100339_100341 = state_100335;
(statearr_100339_100341[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100335);

return cljs.core.cst$kw$recur;
} else {
throw e100338;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100342 = state_100335;
state_100335 = G__100342;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__99703__auto__ = function(state_100335){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__99703__auto____1.call(this,state_100335);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$transduce_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__99703__auto____0;
cljs$core$async$transduce_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__99703__auto____1;
return cljs$core$async$transduce_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,f__$1))
})();
var state__99811__auto__ = (function (){var statearr_100340 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_100340[(6)] = c__99809__auto__);

return statearr_100340;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,f__$1))
);

return c__99809__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var G__100344 = arguments.length;
switch (G__100344) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3(ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_100369){
var state_val_100370 = (state_100369[(1)]);
if((state_val_100370 === (7))){
var inst_100351 = (state_100369[(2)]);
var state_100369__$1 = state_100369;
var statearr_100371_100392 = state_100369__$1;
(statearr_100371_100392[(2)] = inst_100351);

(statearr_100371_100392[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100370 === (1))){
var inst_100345 = cljs.core.seq(coll);
var inst_100346 = inst_100345;
var state_100369__$1 = (function (){var statearr_100372 = state_100369;
(statearr_100372[(7)] = inst_100346);

return statearr_100372;
})();
var statearr_100373_100393 = state_100369__$1;
(statearr_100373_100393[(2)] = null);

(statearr_100373_100393[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100370 === (4))){
var inst_100346 = (state_100369[(7)]);
var inst_100349 = cljs.core.first(inst_100346);
var state_100369__$1 = state_100369;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_100369__$1,(7),ch,inst_100349);
} else {
if((state_val_100370 === (13))){
var inst_100363 = (state_100369[(2)]);
var state_100369__$1 = state_100369;
var statearr_100374_100394 = state_100369__$1;
(statearr_100374_100394[(2)] = inst_100363);

(statearr_100374_100394[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100370 === (6))){
var inst_100354 = (state_100369[(2)]);
var state_100369__$1 = state_100369;
if(cljs.core.truth_(inst_100354)){
var statearr_100375_100395 = state_100369__$1;
(statearr_100375_100395[(1)] = (8));

} else {
var statearr_100376_100396 = state_100369__$1;
(statearr_100376_100396[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100370 === (3))){
var inst_100367 = (state_100369[(2)]);
var state_100369__$1 = state_100369;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100369__$1,inst_100367);
} else {
if((state_val_100370 === (12))){
var state_100369__$1 = state_100369;
var statearr_100377_100397 = state_100369__$1;
(statearr_100377_100397[(2)] = null);

(statearr_100377_100397[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100370 === (2))){
var inst_100346 = (state_100369[(7)]);
var state_100369__$1 = state_100369;
if(cljs.core.truth_(inst_100346)){
var statearr_100378_100398 = state_100369__$1;
(statearr_100378_100398[(1)] = (4));

} else {
var statearr_100379_100399 = state_100369__$1;
(statearr_100379_100399[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100370 === (11))){
var inst_100360 = cljs.core.async.close_BANG_(ch);
var state_100369__$1 = state_100369;
var statearr_100380_100400 = state_100369__$1;
(statearr_100380_100400[(2)] = inst_100360);

(statearr_100380_100400[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100370 === (9))){
var state_100369__$1 = state_100369;
if(cljs.core.truth_(close_QMARK_)){
var statearr_100381_100401 = state_100369__$1;
(statearr_100381_100401[(1)] = (11));

} else {
var statearr_100382_100402 = state_100369__$1;
(statearr_100382_100402[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100370 === (5))){
var inst_100346 = (state_100369[(7)]);
var state_100369__$1 = state_100369;
var statearr_100383_100403 = state_100369__$1;
(statearr_100383_100403[(2)] = inst_100346);

(statearr_100383_100403[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100370 === (10))){
var inst_100365 = (state_100369[(2)]);
var state_100369__$1 = state_100369;
var statearr_100384_100404 = state_100369__$1;
(statearr_100384_100404[(2)] = inst_100365);

(statearr_100384_100404[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100370 === (8))){
var inst_100346 = (state_100369[(7)]);
var inst_100356 = cljs.core.next(inst_100346);
var inst_100346__$1 = inst_100356;
var state_100369__$1 = (function (){var statearr_100385 = state_100369;
(statearr_100385[(7)] = inst_100346__$1);

return statearr_100385;
})();
var statearr_100386_100405 = state_100369__$1;
(statearr_100386_100405[(2)] = null);

(statearr_100386_100405[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_100387 = [null,null,null,null,null,null,null,null];
(statearr_100387[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_100387[(1)] = (1));

return statearr_100387;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_100369){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100369);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e100388){if((e100388 instanceof Object)){
var ex__99706__auto__ = e100388;
var statearr_100389_100406 = state_100369;
(statearr_100389_100406[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100369);

return cljs.core.cst$kw$recur;
} else {
throw e100388;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100407 = state_100369;
state_100369 = G__100407;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_100369){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_100369);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_100390 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_100390[(6)] = c__99809__auto__);

return statearr_100390;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(cljs.core.bounded_count((100),coll));
cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2(ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((((!((_ == null)))) && ((!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__4433__auto__ = (((_ == null))?null:_);
var m__4434__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__4434__auto__.call(null,_));
} else {
var m__4431__auto__ = (cljs.core.async.muxch_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$1(_) : m__4431__auto__.call(null,_));
} else {
throw cljs.core.missing_protocol("Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__4434__auto__.call(null,m,ch,close_QMARK_));
} else {
var m__4431__auto__ = (cljs.core.async.tap_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$3(m,ch,close_QMARK_) : m__4431__auto__.call(null,m,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4434__auto__.call(null,m,ch));
} else {
var m__4431__auto__ = (cljs.core.async.untap_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4431__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4434__auto__.call(null,m));
} else {
var m__4431__auto__ = (cljs.core.async.untap_all_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4431__auto__.call(null,m));
} else {
throw cljs.core.missing_protocol("Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async100408 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async100408 = (function (ch,cs,meta100409){
this.ch = ch;
this.cs = cs;
this.meta100409 = meta100409;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async100408.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_100410,meta100409__$1){
var self__ = this;
var _100410__$1 = this;
return (new cljs.core.async.t_cljs$core$async100408(self__.ch,self__.cs,meta100409__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async100408.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_100410){
var self__ = this;
var _100410__$1 = this;
return self__.meta100409;
});})(cs))
;

cljs.core.async.t_cljs$core$async100408.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async100408.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async100408.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async100408.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async100408.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async100408.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async100408.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$ch,cljs.core.cst$sym$cs,cljs.core.cst$sym$meta100409], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async100408.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async100408.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async100408";

cljs.core.async.t_cljs$core$async100408.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write(writer__4375__auto__,"cljs.core.async/t_cljs$core$async100408");
});})(cs))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async100408.
 */
cljs.core.async.__GT_t_cljs$core$async100408 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async100408(ch__$1,cs__$1,meta100409){
return (new cljs.core.async.t_cljs$core$async100408(ch__$1,cs__$1,meta100409));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async100408(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__99809__auto___100630 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___100630,cs,m,dchan,dctr,done){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___100630,cs,m,dchan,dctr,done){
return (function (state_100545){
var state_val_100546 = (state_100545[(1)]);
if((state_val_100546 === (7))){
var inst_100541 = (state_100545[(2)]);
var state_100545__$1 = state_100545;
var statearr_100547_100631 = state_100545__$1;
(statearr_100547_100631[(2)] = inst_100541);

(statearr_100547_100631[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (20))){
var inst_100444 = (state_100545[(7)]);
var inst_100456 = cljs.core.first(inst_100444);
var inst_100457 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_100456,(0),null);
var inst_100458 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_100456,(1),null);
var state_100545__$1 = (function (){var statearr_100548 = state_100545;
(statearr_100548[(8)] = inst_100457);

return statearr_100548;
})();
if(cljs.core.truth_(inst_100458)){
var statearr_100549_100632 = state_100545__$1;
(statearr_100549_100632[(1)] = (22));

} else {
var statearr_100550_100633 = state_100545__$1;
(statearr_100550_100633[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (27))){
var inst_100486 = (state_100545[(9)]);
var inst_100488 = (state_100545[(10)]);
var inst_100413 = (state_100545[(11)]);
var inst_100493 = (state_100545[(12)]);
var inst_100493__$1 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_100486,inst_100488);
var inst_100494 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_100493__$1,inst_100413,done);
var state_100545__$1 = (function (){var statearr_100551 = state_100545;
(statearr_100551[(12)] = inst_100493__$1);

return statearr_100551;
})();
if(cljs.core.truth_(inst_100494)){
var statearr_100552_100634 = state_100545__$1;
(statearr_100552_100634[(1)] = (30));

} else {
var statearr_100553_100635 = state_100545__$1;
(statearr_100553_100635[(1)] = (31));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (1))){
var state_100545__$1 = state_100545;
var statearr_100554_100636 = state_100545__$1;
(statearr_100554_100636[(2)] = null);

(statearr_100554_100636[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (24))){
var inst_100444 = (state_100545[(7)]);
var inst_100463 = (state_100545[(2)]);
var inst_100464 = cljs.core.next(inst_100444);
var inst_100422 = inst_100464;
var inst_100423 = null;
var inst_100424 = (0);
var inst_100425 = (0);
var state_100545__$1 = (function (){var statearr_100555 = state_100545;
(statearr_100555[(13)] = inst_100425);

(statearr_100555[(14)] = inst_100423);

(statearr_100555[(15)] = inst_100424);

(statearr_100555[(16)] = inst_100422);

(statearr_100555[(17)] = inst_100463);

return statearr_100555;
})();
var statearr_100556_100637 = state_100545__$1;
(statearr_100556_100637[(2)] = null);

(statearr_100556_100637[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (39))){
var state_100545__$1 = state_100545;
var statearr_100560_100638 = state_100545__$1;
(statearr_100560_100638[(2)] = null);

(statearr_100560_100638[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (4))){
var inst_100413 = (state_100545[(11)]);
var inst_100413__$1 = (state_100545[(2)]);
var inst_100414 = (inst_100413__$1 == null);
var state_100545__$1 = (function (){var statearr_100561 = state_100545;
(statearr_100561[(11)] = inst_100413__$1);

return statearr_100561;
})();
if(cljs.core.truth_(inst_100414)){
var statearr_100562_100639 = state_100545__$1;
(statearr_100562_100639[(1)] = (5));

} else {
var statearr_100563_100640 = state_100545__$1;
(statearr_100563_100640[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (15))){
var inst_100425 = (state_100545[(13)]);
var inst_100423 = (state_100545[(14)]);
var inst_100424 = (state_100545[(15)]);
var inst_100422 = (state_100545[(16)]);
var inst_100440 = (state_100545[(2)]);
var inst_100441 = (inst_100425 + (1));
var tmp100557 = inst_100423;
var tmp100558 = inst_100424;
var tmp100559 = inst_100422;
var inst_100422__$1 = tmp100559;
var inst_100423__$1 = tmp100557;
var inst_100424__$1 = tmp100558;
var inst_100425__$1 = inst_100441;
var state_100545__$1 = (function (){var statearr_100564 = state_100545;
(statearr_100564[(18)] = inst_100440);

(statearr_100564[(13)] = inst_100425__$1);

(statearr_100564[(14)] = inst_100423__$1);

(statearr_100564[(15)] = inst_100424__$1);

(statearr_100564[(16)] = inst_100422__$1);

return statearr_100564;
})();
var statearr_100565_100641 = state_100545__$1;
(statearr_100565_100641[(2)] = null);

(statearr_100565_100641[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (21))){
var inst_100467 = (state_100545[(2)]);
var state_100545__$1 = state_100545;
var statearr_100569_100642 = state_100545__$1;
(statearr_100569_100642[(2)] = inst_100467);

(statearr_100569_100642[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (31))){
var inst_100493 = (state_100545[(12)]);
var inst_100497 = done(null);
var inst_100498 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_100493);
var state_100545__$1 = (function (){var statearr_100570 = state_100545;
(statearr_100570[(19)] = inst_100497);

return statearr_100570;
})();
var statearr_100571_100643 = state_100545__$1;
(statearr_100571_100643[(2)] = inst_100498);

(statearr_100571_100643[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (32))){
var inst_100486 = (state_100545[(9)]);
var inst_100488 = (state_100545[(10)]);
var inst_100487 = (state_100545[(20)]);
var inst_100485 = (state_100545[(21)]);
var inst_100500 = (state_100545[(2)]);
var inst_100501 = (inst_100488 + (1));
var tmp100566 = inst_100486;
var tmp100567 = inst_100487;
var tmp100568 = inst_100485;
var inst_100485__$1 = tmp100568;
var inst_100486__$1 = tmp100566;
var inst_100487__$1 = tmp100567;
var inst_100488__$1 = inst_100501;
var state_100545__$1 = (function (){var statearr_100572 = state_100545;
(statearr_100572[(22)] = inst_100500);

(statearr_100572[(9)] = inst_100486__$1);

(statearr_100572[(10)] = inst_100488__$1);

(statearr_100572[(20)] = inst_100487__$1);

(statearr_100572[(21)] = inst_100485__$1);

return statearr_100572;
})();
var statearr_100573_100644 = state_100545__$1;
(statearr_100573_100644[(2)] = null);

(statearr_100573_100644[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (40))){
var inst_100513 = (state_100545[(23)]);
var inst_100517 = done(null);
var inst_100518 = m.cljs$core$async$Mult$untap_STAR_$arity$2(null,inst_100513);
var state_100545__$1 = (function (){var statearr_100574 = state_100545;
(statearr_100574[(24)] = inst_100517);

return statearr_100574;
})();
var statearr_100575_100645 = state_100545__$1;
(statearr_100575_100645[(2)] = inst_100518);

(statearr_100575_100645[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (33))){
var inst_100504 = (state_100545[(25)]);
var inst_100506 = cljs.core.chunked_seq_QMARK_(inst_100504);
var state_100545__$1 = state_100545;
if(inst_100506){
var statearr_100576_100646 = state_100545__$1;
(statearr_100576_100646[(1)] = (36));

} else {
var statearr_100577_100647 = state_100545__$1;
(statearr_100577_100647[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (13))){
var inst_100434 = (state_100545[(26)]);
var inst_100437 = cljs.core.async.close_BANG_(inst_100434);
var state_100545__$1 = state_100545;
var statearr_100578_100648 = state_100545__$1;
(statearr_100578_100648[(2)] = inst_100437);

(statearr_100578_100648[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (22))){
var inst_100457 = (state_100545[(8)]);
var inst_100460 = cljs.core.async.close_BANG_(inst_100457);
var state_100545__$1 = state_100545;
var statearr_100579_100649 = state_100545__$1;
(statearr_100579_100649[(2)] = inst_100460);

(statearr_100579_100649[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (36))){
var inst_100504 = (state_100545[(25)]);
var inst_100508 = cljs.core.chunk_first(inst_100504);
var inst_100509 = cljs.core.chunk_rest(inst_100504);
var inst_100510 = cljs.core.count(inst_100508);
var inst_100485 = inst_100509;
var inst_100486 = inst_100508;
var inst_100487 = inst_100510;
var inst_100488 = (0);
var state_100545__$1 = (function (){var statearr_100580 = state_100545;
(statearr_100580[(9)] = inst_100486);

(statearr_100580[(10)] = inst_100488);

(statearr_100580[(20)] = inst_100487);

(statearr_100580[(21)] = inst_100485);

return statearr_100580;
})();
var statearr_100581_100650 = state_100545__$1;
(statearr_100581_100650[(2)] = null);

(statearr_100581_100650[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (41))){
var inst_100504 = (state_100545[(25)]);
var inst_100520 = (state_100545[(2)]);
var inst_100521 = cljs.core.next(inst_100504);
var inst_100485 = inst_100521;
var inst_100486 = null;
var inst_100487 = (0);
var inst_100488 = (0);
var state_100545__$1 = (function (){var statearr_100582 = state_100545;
(statearr_100582[(9)] = inst_100486);

(statearr_100582[(10)] = inst_100488);

(statearr_100582[(20)] = inst_100487);

(statearr_100582[(27)] = inst_100520);

(statearr_100582[(21)] = inst_100485);

return statearr_100582;
})();
var statearr_100583_100651 = state_100545__$1;
(statearr_100583_100651[(2)] = null);

(statearr_100583_100651[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (43))){
var state_100545__$1 = state_100545;
var statearr_100584_100652 = state_100545__$1;
(statearr_100584_100652[(2)] = null);

(statearr_100584_100652[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (29))){
var inst_100529 = (state_100545[(2)]);
var state_100545__$1 = state_100545;
var statearr_100585_100653 = state_100545__$1;
(statearr_100585_100653[(2)] = inst_100529);

(statearr_100585_100653[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (44))){
var inst_100538 = (state_100545[(2)]);
var state_100545__$1 = (function (){var statearr_100586 = state_100545;
(statearr_100586[(28)] = inst_100538);

return statearr_100586;
})();
var statearr_100587_100654 = state_100545__$1;
(statearr_100587_100654[(2)] = null);

(statearr_100587_100654[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (6))){
var inst_100477 = (state_100545[(29)]);
var inst_100476 = cljs.core.deref(cs);
var inst_100477__$1 = cljs.core.keys(inst_100476);
var inst_100478 = cljs.core.count(inst_100477__$1);
var inst_100479 = cljs.core.reset_BANG_(dctr,inst_100478);
var inst_100484 = cljs.core.seq(inst_100477__$1);
var inst_100485 = inst_100484;
var inst_100486 = null;
var inst_100487 = (0);
var inst_100488 = (0);
var state_100545__$1 = (function (){var statearr_100588 = state_100545;
(statearr_100588[(29)] = inst_100477__$1);

(statearr_100588[(9)] = inst_100486);

(statearr_100588[(10)] = inst_100488);

(statearr_100588[(20)] = inst_100487);

(statearr_100588[(30)] = inst_100479);

(statearr_100588[(21)] = inst_100485);

return statearr_100588;
})();
var statearr_100589_100655 = state_100545__$1;
(statearr_100589_100655[(2)] = null);

(statearr_100589_100655[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (28))){
var inst_100504 = (state_100545[(25)]);
var inst_100485 = (state_100545[(21)]);
var inst_100504__$1 = cljs.core.seq(inst_100485);
var state_100545__$1 = (function (){var statearr_100590 = state_100545;
(statearr_100590[(25)] = inst_100504__$1);

return statearr_100590;
})();
if(inst_100504__$1){
var statearr_100591_100656 = state_100545__$1;
(statearr_100591_100656[(1)] = (33));

} else {
var statearr_100592_100657 = state_100545__$1;
(statearr_100592_100657[(1)] = (34));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (25))){
var inst_100488 = (state_100545[(10)]);
var inst_100487 = (state_100545[(20)]);
var inst_100490 = (inst_100488 < inst_100487);
var inst_100491 = inst_100490;
var state_100545__$1 = state_100545;
if(cljs.core.truth_(inst_100491)){
var statearr_100593_100658 = state_100545__$1;
(statearr_100593_100658[(1)] = (27));

} else {
var statearr_100594_100659 = state_100545__$1;
(statearr_100594_100659[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (34))){
var state_100545__$1 = state_100545;
var statearr_100595_100660 = state_100545__$1;
(statearr_100595_100660[(2)] = null);

(statearr_100595_100660[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (17))){
var state_100545__$1 = state_100545;
var statearr_100596_100661 = state_100545__$1;
(statearr_100596_100661[(2)] = null);

(statearr_100596_100661[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (3))){
var inst_100543 = (state_100545[(2)]);
var state_100545__$1 = state_100545;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100545__$1,inst_100543);
} else {
if((state_val_100546 === (12))){
var inst_100472 = (state_100545[(2)]);
var state_100545__$1 = state_100545;
var statearr_100597_100662 = state_100545__$1;
(statearr_100597_100662[(2)] = inst_100472);

(statearr_100597_100662[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (2))){
var state_100545__$1 = state_100545;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100545__$1,(4),ch);
} else {
if((state_val_100546 === (23))){
var state_100545__$1 = state_100545;
var statearr_100598_100663 = state_100545__$1;
(statearr_100598_100663[(2)] = null);

(statearr_100598_100663[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (35))){
var inst_100527 = (state_100545[(2)]);
var state_100545__$1 = state_100545;
var statearr_100599_100664 = state_100545__$1;
(statearr_100599_100664[(2)] = inst_100527);

(statearr_100599_100664[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (19))){
var inst_100444 = (state_100545[(7)]);
var inst_100448 = cljs.core.chunk_first(inst_100444);
var inst_100449 = cljs.core.chunk_rest(inst_100444);
var inst_100450 = cljs.core.count(inst_100448);
var inst_100422 = inst_100449;
var inst_100423 = inst_100448;
var inst_100424 = inst_100450;
var inst_100425 = (0);
var state_100545__$1 = (function (){var statearr_100600 = state_100545;
(statearr_100600[(13)] = inst_100425);

(statearr_100600[(14)] = inst_100423);

(statearr_100600[(15)] = inst_100424);

(statearr_100600[(16)] = inst_100422);

return statearr_100600;
})();
var statearr_100601_100665 = state_100545__$1;
(statearr_100601_100665[(2)] = null);

(statearr_100601_100665[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (11))){
var inst_100422 = (state_100545[(16)]);
var inst_100444 = (state_100545[(7)]);
var inst_100444__$1 = cljs.core.seq(inst_100422);
var state_100545__$1 = (function (){var statearr_100602 = state_100545;
(statearr_100602[(7)] = inst_100444__$1);

return statearr_100602;
})();
if(inst_100444__$1){
var statearr_100603_100666 = state_100545__$1;
(statearr_100603_100666[(1)] = (16));

} else {
var statearr_100604_100667 = state_100545__$1;
(statearr_100604_100667[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (9))){
var inst_100474 = (state_100545[(2)]);
var state_100545__$1 = state_100545;
var statearr_100605_100668 = state_100545__$1;
(statearr_100605_100668[(2)] = inst_100474);

(statearr_100605_100668[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (5))){
var inst_100420 = cljs.core.deref(cs);
var inst_100421 = cljs.core.seq(inst_100420);
var inst_100422 = inst_100421;
var inst_100423 = null;
var inst_100424 = (0);
var inst_100425 = (0);
var state_100545__$1 = (function (){var statearr_100606 = state_100545;
(statearr_100606[(13)] = inst_100425);

(statearr_100606[(14)] = inst_100423);

(statearr_100606[(15)] = inst_100424);

(statearr_100606[(16)] = inst_100422);

return statearr_100606;
})();
var statearr_100607_100669 = state_100545__$1;
(statearr_100607_100669[(2)] = null);

(statearr_100607_100669[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (14))){
var state_100545__$1 = state_100545;
var statearr_100608_100670 = state_100545__$1;
(statearr_100608_100670[(2)] = null);

(statearr_100608_100670[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (45))){
var inst_100535 = (state_100545[(2)]);
var state_100545__$1 = state_100545;
var statearr_100609_100671 = state_100545__$1;
(statearr_100609_100671[(2)] = inst_100535);

(statearr_100609_100671[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (26))){
var inst_100477 = (state_100545[(29)]);
var inst_100531 = (state_100545[(2)]);
var inst_100532 = cljs.core.seq(inst_100477);
var state_100545__$1 = (function (){var statearr_100610 = state_100545;
(statearr_100610[(31)] = inst_100531);

return statearr_100610;
})();
if(inst_100532){
var statearr_100611_100672 = state_100545__$1;
(statearr_100611_100672[(1)] = (42));

} else {
var statearr_100612_100673 = state_100545__$1;
(statearr_100612_100673[(1)] = (43));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (16))){
var inst_100444 = (state_100545[(7)]);
var inst_100446 = cljs.core.chunked_seq_QMARK_(inst_100444);
var state_100545__$1 = state_100545;
if(inst_100446){
var statearr_100613_100674 = state_100545__$1;
(statearr_100613_100674[(1)] = (19));

} else {
var statearr_100614_100675 = state_100545__$1;
(statearr_100614_100675[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (38))){
var inst_100524 = (state_100545[(2)]);
var state_100545__$1 = state_100545;
var statearr_100615_100676 = state_100545__$1;
(statearr_100615_100676[(2)] = inst_100524);

(statearr_100615_100676[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (30))){
var state_100545__$1 = state_100545;
var statearr_100616_100677 = state_100545__$1;
(statearr_100616_100677[(2)] = null);

(statearr_100616_100677[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (10))){
var inst_100425 = (state_100545[(13)]);
var inst_100423 = (state_100545[(14)]);
var inst_100433 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_100423,inst_100425);
var inst_100434 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_100433,(0),null);
var inst_100435 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_100433,(1),null);
var state_100545__$1 = (function (){var statearr_100617 = state_100545;
(statearr_100617[(26)] = inst_100434);

return statearr_100617;
})();
if(cljs.core.truth_(inst_100435)){
var statearr_100618_100678 = state_100545__$1;
(statearr_100618_100678[(1)] = (13));

} else {
var statearr_100619_100679 = state_100545__$1;
(statearr_100619_100679[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (18))){
var inst_100470 = (state_100545[(2)]);
var state_100545__$1 = state_100545;
var statearr_100620_100680 = state_100545__$1;
(statearr_100620_100680[(2)] = inst_100470);

(statearr_100620_100680[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (42))){
var state_100545__$1 = state_100545;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100545__$1,(45),dchan);
} else {
if((state_val_100546 === (37))){
var inst_100513 = (state_100545[(23)]);
var inst_100413 = (state_100545[(11)]);
var inst_100504 = (state_100545[(25)]);
var inst_100513__$1 = cljs.core.first(inst_100504);
var inst_100514 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3(inst_100513__$1,inst_100413,done);
var state_100545__$1 = (function (){var statearr_100621 = state_100545;
(statearr_100621[(23)] = inst_100513__$1);

return statearr_100621;
})();
if(cljs.core.truth_(inst_100514)){
var statearr_100622_100681 = state_100545__$1;
(statearr_100622_100681[(1)] = (39));

} else {
var statearr_100623_100682 = state_100545__$1;
(statearr_100623_100682[(1)] = (40));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100546 === (8))){
var inst_100425 = (state_100545[(13)]);
var inst_100424 = (state_100545[(15)]);
var inst_100427 = (inst_100425 < inst_100424);
var inst_100428 = inst_100427;
var state_100545__$1 = state_100545;
if(cljs.core.truth_(inst_100428)){
var statearr_100624_100683 = state_100545__$1;
(statearr_100624_100683[(1)] = (10));

} else {
var statearr_100625_100684 = state_100545__$1;
(statearr_100625_100684[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___100630,cs,m,dchan,dctr,done))
;
return ((function (switch__99702__auto__,c__99809__auto___100630,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__99703__auto__ = null;
var cljs$core$async$mult_$_state_machine__99703__auto____0 = (function (){
var statearr_100626 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_100626[(0)] = cljs$core$async$mult_$_state_machine__99703__auto__);

(statearr_100626[(1)] = (1));

return statearr_100626;
});
var cljs$core$async$mult_$_state_machine__99703__auto____1 = (function (state_100545){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100545);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e100627){if((e100627 instanceof Object)){
var ex__99706__auto__ = e100627;
var statearr_100628_100685 = state_100545;
(statearr_100628_100685[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100545);

return cljs.core.cst$kw$recur;
} else {
throw e100627;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100686 = state_100545;
state_100545 = G__100686;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__99703__auto__ = function(state_100545){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__99703__auto____1.call(this,state_100545);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__99703__auto____0;
cljs$core$async$mult_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__99703__auto____1;
return cljs$core$async$mult_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___100630,cs,m,dchan,dctr,done))
})();
var state__99811__auto__ = (function (){var statearr_100629 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_100629[(6)] = c__99809__auto___100630);

return statearr_100629;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___100630,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var G__100688 = arguments.length;
switch (G__100688) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_(mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_(mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_(mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4434__auto__.call(null,m,ch));
} else {
var m__4431__auto__ = (cljs.core.async.admix_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4431__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4434__auto__.call(null,m,ch));
} else {
var m__4431__auto__ = (cljs.core.async.unmix_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$2(m,ch) : m__4431__auto__.call(null,m,ch));
} else {
throw cljs.core.missing_protocol("Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4434__auto__.call(null,m));
} else {
var m__4431__auto__ = (cljs.core.async.unmix_all_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$1(m) : m__4431__auto__.call(null,m));
} else {
throw cljs.core.missing_protocol("Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__4434__auto__.call(null,m,state_map));
} else {
var m__4431__auto__ = (cljs.core.async.toggle_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$2(m,state_map) : m__4431__auto__.call(null,m,state_map));
} else {
throw cljs.core.missing_protocol("Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__4434__auto__.call(null,m,mode));
} else {
var m__4431__auto__ = (cljs.core.async.solo_mode_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$2(m,mode) : m__4431__auto__.call(null,m,mode));
} else {
throw cljs.core.missing_protocol("Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___100700 = arguments.length;
var i__4731__auto___100701 = (0);
while(true){
if((i__4731__auto___100701 < len__4730__auto___100700)){
args__4736__auto__.push((arguments[i__4731__auto___100701]));

var G__100702 = (i__4731__auto___100701 + (1));
i__4731__auto___100701 = G__100702;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((3) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4737__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__100694){
var map__100695 = p__100694;
var map__100695__$1 = (((((!((map__100695 == null))))?(((((map__100695.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__100695.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__100695):map__100695);
var opts = map__100695__$1;
var statearr_100697_100703 = state;
(statearr_100697_100703[(1)] = cont_block);


var temp__5735__auto__ = cljs.core.async.do_alts(((function (map__100695,map__100695__$1,opts){
return (function (val){
var statearr_100698_100704 = state;
(statearr_100698_100704[(2)] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state);
});})(map__100695,map__100695__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__5735__auto__)){
var cb = temp__5735__auto__;
var statearr_100699_100705 = state;
(statearr_100699_100705[(2)] = cljs.core.deref(cb));


return cljs.core.cst$kw$recur;
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

/** @this {Function} */
cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq100690){
var G__100691 = cljs.core.first(seq100690);
var seq100690__$1 = cljs.core.next(seq100690);
var G__100692 = cljs.core.first(seq100690__$1);
var seq100690__$2 = cljs.core.next(seq100690__$1);
var G__100693 = cljs.core.first(seq100690__$2);
var seq100690__$3 = cljs.core.next(seq100690__$2);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__100691,G__100692,G__100693,seq100690__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$pause,null,cljs.core.cst$kw$mute,null], null), null);
var attrs = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(solo_modes,cljs.core.cst$kw$solo);
var solo_mode = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.cst$kw$mute);
var change = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv(((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_((attr.cljs$core$IFn$_invoke$arity$1 ? attr.cljs$core$IFn$_invoke$arity$1(v) : attr.call(null,v)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref(cs);
var mode = cljs.core.deref(solo_mode);
var solos = pick(cljs.core.cst$kw$solo,chs);
var pauses = pick(cljs.core.cst$kw$pause,chs);
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$solos,solos,cljs.core.cst$kw$mutes,pick(cljs.core.cst$kw$mute,chs),cljs.core.cst$kw$reads,cljs.core.conj.cljs$core$IFn$_invoke$arity$2(((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(mode,cljs.core.cst$kw$pause)) && ((!(cljs.core.empty_QMARK_(solos))))))?cljs.core.vec(solos):cljs.core.vec(cljs.core.remove.cljs$core$IFn$_invoke$arity$2(pauses,cljs.core.keys(chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async100706 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async100706 = (function (change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta100707){
this.change = change;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta100707 = meta100707;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async100706.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_100708,meta100707__$1){
var self__ = this;
var _100708__$1 = this;
return (new cljs.core.async.t_cljs$core$async100706(self__.change,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta100707__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async100706.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_100708){
var self__ = this;
var _100708__$1 = this;
return self__.meta100707;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async100706.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async100706.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async100706.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async100706.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async100706.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.dissoc,ch);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async100706.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_(self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async100706.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.cs,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(cljs.core.merge_with,cljs.core.merge),state_map);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async100706.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.solo_modes.cljs$core$IFn$_invoke$arity$1 ? self__.solo_modes.cljs$core$IFn$_invoke$arity$1(mode) : self__.solo_modes.call(null,mode)))){
} else {
throw (new Error(["Assert failed: ",["mode must be one of: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.solo_modes)].join(''),"\n","(solo-modes mode)"].join('')));
}

cljs.core.reset_BANG_(self__.solo_mode,mode);

return (self__.changed.cljs$core$IFn$_invoke$arity$0 ? self__.changed.cljs$core$IFn$_invoke$arity$0() : self__.changed.call(null));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async100706.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$change,cljs.core.cst$sym$solo_DASH_mode,cljs.core.cst$sym$pick,cljs.core.cst$sym$cs,cljs.core.cst$sym$calc_DASH_state,cljs.core.cst$sym$out,cljs.core.cst$sym$changed,cljs.core.cst$sym$solo_DASH_modes,cljs.core.cst$sym$attrs,cljs.core.cst$sym$meta100707], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async100706.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async100706.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async100706";

cljs.core.async.t_cljs$core$async100706.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write(writer__4375__auto__,"cljs.core.async/t_cljs$core$async100706");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async100706.
 */
cljs.core.async.__GT_t_cljs$core$async100706 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async100706(change__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta100707){
return (new cljs.core.async.t_cljs$core$async100706(change__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta100707));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async100706(change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__99809__auto___100870 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___100870,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___100870,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_100810){
var state_val_100811 = (state_100810[(1)]);
if((state_val_100811 === (7))){
var inst_100725 = (state_100810[(2)]);
var state_100810__$1 = state_100810;
var statearr_100812_100871 = state_100810__$1;
(statearr_100812_100871[(2)] = inst_100725);

(statearr_100812_100871[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (20))){
var inst_100737 = (state_100810[(7)]);
var state_100810__$1 = state_100810;
var statearr_100813_100872 = state_100810__$1;
(statearr_100813_100872[(2)] = inst_100737);

(statearr_100813_100872[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (27))){
var state_100810__$1 = state_100810;
var statearr_100814_100873 = state_100810__$1;
(statearr_100814_100873[(2)] = null);

(statearr_100814_100873[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (1))){
var inst_100712 = (state_100810[(8)]);
var inst_100712__$1 = calc_state();
var inst_100714 = (inst_100712__$1 == null);
var inst_100715 = cljs.core.not(inst_100714);
var state_100810__$1 = (function (){var statearr_100815 = state_100810;
(statearr_100815[(8)] = inst_100712__$1);

return statearr_100815;
})();
if(inst_100715){
var statearr_100816_100874 = state_100810__$1;
(statearr_100816_100874[(1)] = (2));

} else {
var statearr_100817_100875 = state_100810__$1;
(statearr_100817_100875[(1)] = (3));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (24))){
var inst_100761 = (state_100810[(9)]);
var inst_100770 = (state_100810[(10)]);
var inst_100784 = (state_100810[(11)]);
var inst_100784__$1 = (inst_100761.cljs$core$IFn$_invoke$arity$1 ? inst_100761.cljs$core$IFn$_invoke$arity$1(inst_100770) : inst_100761.call(null,inst_100770));
var state_100810__$1 = (function (){var statearr_100818 = state_100810;
(statearr_100818[(11)] = inst_100784__$1);

return statearr_100818;
})();
if(cljs.core.truth_(inst_100784__$1)){
var statearr_100819_100876 = state_100810__$1;
(statearr_100819_100876[(1)] = (29));

} else {
var statearr_100820_100877 = state_100810__$1;
(statearr_100820_100877[(1)] = (30));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (4))){
var inst_100728 = (state_100810[(2)]);
var state_100810__$1 = state_100810;
if(cljs.core.truth_(inst_100728)){
var statearr_100821_100878 = state_100810__$1;
(statearr_100821_100878[(1)] = (8));

} else {
var statearr_100822_100879 = state_100810__$1;
(statearr_100822_100879[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (15))){
var inst_100755 = (state_100810[(2)]);
var state_100810__$1 = state_100810;
if(cljs.core.truth_(inst_100755)){
var statearr_100823_100880 = state_100810__$1;
(statearr_100823_100880[(1)] = (19));

} else {
var statearr_100824_100881 = state_100810__$1;
(statearr_100824_100881[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (21))){
var inst_100760 = (state_100810[(12)]);
var inst_100760__$1 = (state_100810[(2)]);
var inst_100761 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_100760__$1,cljs.core.cst$kw$solos);
var inst_100762 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_100760__$1,cljs.core.cst$kw$mutes);
var inst_100763 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_100760__$1,cljs.core.cst$kw$reads);
var state_100810__$1 = (function (){var statearr_100825 = state_100810;
(statearr_100825[(9)] = inst_100761);

(statearr_100825[(12)] = inst_100760__$1);

(statearr_100825[(13)] = inst_100762);

return statearr_100825;
})();
return cljs.core.async.ioc_alts_BANG_(state_100810__$1,(22),inst_100763);
} else {
if((state_val_100811 === (31))){
var inst_100792 = (state_100810[(2)]);
var state_100810__$1 = state_100810;
if(cljs.core.truth_(inst_100792)){
var statearr_100826_100882 = state_100810__$1;
(statearr_100826_100882[(1)] = (32));

} else {
var statearr_100827_100883 = state_100810__$1;
(statearr_100827_100883[(1)] = (33));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (32))){
var inst_100769 = (state_100810[(14)]);
var state_100810__$1 = state_100810;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_100810__$1,(35),out,inst_100769);
} else {
if((state_val_100811 === (33))){
var inst_100760 = (state_100810[(12)]);
var inst_100737 = inst_100760;
var state_100810__$1 = (function (){var statearr_100828 = state_100810;
(statearr_100828[(7)] = inst_100737);

return statearr_100828;
})();
var statearr_100829_100884 = state_100810__$1;
(statearr_100829_100884[(2)] = null);

(statearr_100829_100884[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (13))){
var inst_100737 = (state_100810[(7)]);
var inst_100744 = inst_100737.cljs$lang$protocol_mask$partition0$;
var inst_100745 = (inst_100744 & (64));
var inst_100746 = inst_100737.cljs$core$ISeq$;
var inst_100747 = (cljs.core.PROTOCOL_SENTINEL === inst_100746);
var inst_100748 = ((inst_100745) || (inst_100747));
var state_100810__$1 = state_100810;
if(cljs.core.truth_(inst_100748)){
var statearr_100830_100885 = state_100810__$1;
(statearr_100830_100885[(1)] = (16));

} else {
var statearr_100831_100886 = state_100810__$1;
(statearr_100831_100886[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (22))){
var inst_100770 = (state_100810[(10)]);
var inst_100769 = (state_100810[(14)]);
var inst_100768 = (state_100810[(2)]);
var inst_100769__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_100768,(0),null);
var inst_100770__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_100768,(1),null);
var inst_100771 = (inst_100769__$1 == null);
var inst_100772 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_100770__$1,change);
var inst_100773 = ((inst_100771) || (inst_100772));
var state_100810__$1 = (function (){var statearr_100832 = state_100810;
(statearr_100832[(10)] = inst_100770__$1);

(statearr_100832[(14)] = inst_100769__$1);

return statearr_100832;
})();
if(cljs.core.truth_(inst_100773)){
var statearr_100833_100887 = state_100810__$1;
(statearr_100833_100887[(1)] = (23));

} else {
var statearr_100834_100888 = state_100810__$1;
(statearr_100834_100888[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (36))){
var inst_100760 = (state_100810[(12)]);
var inst_100737 = inst_100760;
var state_100810__$1 = (function (){var statearr_100835 = state_100810;
(statearr_100835[(7)] = inst_100737);

return statearr_100835;
})();
var statearr_100836_100889 = state_100810__$1;
(statearr_100836_100889[(2)] = null);

(statearr_100836_100889[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (29))){
var inst_100784 = (state_100810[(11)]);
var state_100810__$1 = state_100810;
var statearr_100837_100890 = state_100810__$1;
(statearr_100837_100890[(2)] = inst_100784);

(statearr_100837_100890[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (6))){
var state_100810__$1 = state_100810;
var statearr_100838_100891 = state_100810__$1;
(statearr_100838_100891[(2)] = false);

(statearr_100838_100891[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (28))){
var inst_100780 = (state_100810[(2)]);
var inst_100781 = calc_state();
var inst_100737 = inst_100781;
var state_100810__$1 = (function (){var statearr_100839 = state_100810;
(statearr_100839[(15)] = inst_100780);

(statearr_100839[(7)] = inst_100737);

return statearr_100839;
})();
var statearr_100840_100892 = state_100810__$1;
(statearr_100840_100892[(2)] = null);

(statearr_100840_100892[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (25))){
var inst_100806 = (state_100810[(2)]);
var state_100810__$1 = state_100810;
var statearr_100841_100893 = state_100810__$1;
(statearr_100841_100893[(2)] = inst_100806);

(statearr_100841_100893[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (34))){
var inst_100804 = (state_100810[(2)]);
var state_100810__$1 = state_100810;
var statearr_100842_100894 = state_100810__$1;
(statearr_100842_100894[(2)] = inst_100804);

(statearr_100842_100894[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (17))){
var state_100810__$1 = state_100810;
var statearr_100843_100895 = state_100810__$1;
(statearr_100843_100895[(2)] = false);

(statearr_100843_100895[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (3))){
var state_100810__$1 = state_100810;
var statearr_100844_100896 = state_100810__$1;
(statearr_100844_100896[(2)] = false);

(statearr_100844_100896[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (12))){
var inst_100808 = (state_100810[(2)]);
var state_100810__$1 = state_100810;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100810__$1,inst_100808);
} else {
if((state_val_100811 === (2))){
var inst_100712 = (state_100810[(8)]);
var inst_100717 = inst_100712.cljs$lang$protocol_mask$partition0$;
var inst_100718 = (inst_100717 & (64));
var inst_100719 = inst_100712.cljs$core$ISeq$;
var inst_100720 = (cljs.core.PROTOCOL_SENTINEL === inst_100719);
var inst_100721 = ((inst_100718) || (inst_100720));
var state_100810__$1 = state_100810;
if(cljs.core.truth_(inst_100721)){
var statearr_100845_100897 = state_100810__$1;
(statearr_100845_100897[(1)] = (5));

} else {
var statearr_100846_100898 = state_100810__$1;
(statearr_100846_100898[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (23))){
var inst_100769 = (state_100810[(14)]);
var inst_100775 = (inst_100769 == null);
var state_100810__$1 = state_100810;
if(cljs.core.truth_(inst_100775)){
var statearr_100847_100899 = state_100810__$1;
(statearr_100847_100899[(1)] = (26));

} else {
var statearr_100848_100900 = state_100810__$1;
(statearr_100848_100900[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (35))){
var inst_100795 = (state_100810[(2)]);
var state_100810__$1 = state_100810;
if(cljs.core.truth_(inst_100795)){
var statearr_100849_100901 = state_100810__$1;
(statearr_100849_100901[(1)] = (36));

} else {
var statearr_100850_100902 = state_100810__$1;
(statearr_100850_100902[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (19))){
var inst_100737 = (state_100810[(7)]);
var inst_100757 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_100737);
var state_100810__$1 = state_100810;
var statearr_100851_100903 = state_100810__$1;
(statearr_100851_100903[(2)] = inst_100757);

(statearr_100851_100903[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (11))){
var inst_100737 = (state_100810[(7)]);
var inst_100741 = (inst_100737 == null);
var inst_100742 = cljs.core.not(inst_100741);
var state_100810__$1 = state_100810;
if(inst_100742){
var statearr_100852_100904 = state_100810__$1;
(statearr_100852_100904[(1)] = (13));

} else {
var statearr_100853_100905 = state_100810__$1;
(statearr_100853_100905[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (9))){
var inst_100712 = (state_100810[(8)]);
var state_100810__$1 = state_100810;
var statearr_100854_100906 = state_100810__$1;
(statearr_100854_100906[(2)] = inst_100712);

(statearr_100854_100906[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (5))){
var state_100810__$1 = state_100810;
var statearr_100855_100907 = state_100810__$1;
(statearr_100855_100907[(2)] = true);

(statearr_100855_100907[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (14))){
var state_100810__$1 = state_100810;
var statearr_100856_100908 = state_100810__$1;
(statearr_100856_100908[(2)] = false);

(statearr_100856_100908[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (26))){
var inst_100770 = (state_100810[(10)]);
var inst_100777 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cs,cljs.core.dissoc,inst_100770);
var state_100810__$1 = state_100810;
var statearr_100857_100909 = state_100810__$1;
(statearr_100857_100909[(2)] = inst_100777);

(statearr_100857_100909[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (16))){
var state_100810__$1 = state_100810;
var statearr_100858_100910 = state_100810__$1;
(statearr_100858_100910[(2)] = true);

(statearr_100858_100910[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (38))){
var inst_100800 = (state_100810[(2)]);
var state_100810__$1 = state_100810;
var statearr_100859_100911 = state_100810__$1;
(statearr_100859_100911[(2)] = inst_100800);

(statearr_100859_100911[(1)] = (34));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (30))){
var inst_100761 = (state_100810[(9)]);
var inst_100770 = (state_100810[(10)]);
var inst_100762 = (state_100810[(13)]);
var inst_100787 = cljs.core.empty_QMARK_(inst_100761);
var inst_100788 = (inst_100762.cljs$core$IFn$_invoke$arity$1 ? inst_100762.cljs$core$IFn$_invoke$arity$1(inst_100770) : inst_100762.call(null,inst_100770));
var inst_100789 = cljs.core.not(inst_100788);
var inst_100790 = ((inst_100787) && (inst_100789));
var state_100810__$1 = state_100810;
var statearr_100860_100912 = state_100810__$1;
(statearr_100860_100912[(2)] = inst_100790);

(statearr_100860_100912[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (10))){
var inst_100712 = (state_100810[(8)]);
var inst_100733 = (state_100810[(2)]);
var inst_100734 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_100733,cljs.core.cst$kw$solos);
var inst_100735 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_100733,cljs.core.cst$kw$mutes);
var inst_100736 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_100733,cljs.core.cst$kw$reads);
var inst_100737 = inst_100712;
var state_100810__$1 = (function (){var statearr_100861 = state_100810;
(statearr_100861[(16)] = inst_100735);

(statearr_100861[(17)] = inst_100734);

(statearr_100861[(18)] = inst_100736);

(statearr_100861[(7)] = inst_100737);

return statearr_100861;
})();
var statearr_100862_100913 = state_100810__$1;
(statearr_100862_100913[(2)] = null);

(statearr_100862_100913[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (18))){
var inst_100752 = (state_100810[(2)]);
var state_100810__$1 = state_100810;
var statearr_100863_100914 = state_100810__$1;
(statearr_100863_100914[(2)] = inst_100752);

(statearr_100863_100914[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (37))){
var state_100810__$1 = state_100810;
var statearr_100864_100915 = state_100810__$1;
(statearr_100864_100915[(2)] = null);

(statearr_100864_100915[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_100811 === (8))){
var inst_100712 = (state_100810[(8)]);
var inst_100730 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_100712);
var state_100810__$1 = state_100810;
var statearr_100865_100916 = state_100810__$1;
(statearr_100865_100916[(2)] = inst_100730);

(statearr_100865_100916[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___100870,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__99702__auto__,c__99809__auto___100870,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__99703__auto__ = null;
var cljs$core$async$mix_$_state_machine__99703__auto____0 = (function (){
var statearr_100866 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_100866[(0)] = cljs$core$async$mix_$_state_machine__99703__auto__);

(statearr_100866[(1)] = (1));

return statearr_100866;
});
var cljs$core$async$mix_$_state_machine__99703__auto____1 = (function (state_100810){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100810);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e100867){if((e100867 instanceof Object)){
var ex__99706__auto__ = e100867;
var statearr_100868_100917 = state_100810;
(statearr_100868_100917[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100810);

return cljs.core.cst$kw$recur;
} else {
throw e100867;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__100918 = state_100810;
state_100810 = G__100918;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__99703__auto__ = function(state_100810){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__99703__auto____1.call(this,state_100810);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__99703__auto____0;
cljs$core$async$mix_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__99703__auto____1;
return cljs$core$async$mix_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___100870,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__99811__auto__ = (function (){var statearr_100869 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_100869[(6)] = c__99809__auto___100870);

return statearr_100869;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___100870,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_(mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_(mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_(mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_(mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_(mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__4433__auto__ = (((p == null))?null:p);
var m__4434__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$4 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__4434__auto__.call(null,p,v,ch,close_QMARK_));
} else {
var m__4431__auto__ = (cljs.core.async.sub_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$4 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$4(p,v,ch,close_QMARK_) : m__4431__auto__.call(null,p,v,ch,close_QMARK_));
} else {
throw cljs.core.missing_protocol("Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__4433__auto__ = (((p == null))?null:p);
var m__4434__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__4434__auto__.call(null,p,v,ch));
} else {
var m__4431__auto__ = (cljs.core.async.unsub_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$3 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$3(p,v,ch) : m__4431__auto__.call(null,p,v,ch));
} else {
throw cljs.core.missing_protocol("Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var G__100920 = arguments.length;
switch (G__100920) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__4433__auto__ = (((p == null))?null:p);
var m__4434__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__4434__auto__.call(null,p));
} else {
var m__4431__auto__ = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$1 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$1(p) : m__4431__auto__.call(null,p));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__4433__auto__ = (((p == null))?null:p);
var m__4434__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return (m__4434__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4434__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__4434__auto__.call(null,p,v));
} else {
var m__4431__auto__ = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return (m__4431__auto__.cljs$core$IFn$_invoke$arity$2 ? m__4431__auto__.cljs$core$IFn$_invoke$arity$2(p,v) : m__4431__auto__.call(null,p,v));
} else {
throw cljs.core.missing_protocol("Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var G__100924 = arguments.length;
switch (G__100924) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3(ch,topic_fn,cljs.core.constantly(null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__4131__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(mults),topic);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(mults,((function (or__4131__auto__,mults){
return (function (p1__100922_SHARP_){
if(cljs.core.truth_((p1__100922_SHARP_.cljs$core$IFn$_invoke$arity$1 ? p1__100922_SHARP_.cljs$core$IFn$_invoke$arity$1(topic) : p1__100922_SHARP_.call(null,topic)))){
return p1__100922_SHARP_;
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(p1__100922_SHARP_,topic,cljs.core.async.mult(cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((buf_fn.cljs$core$IFn$_invoke$arity$1 ? buf_fn.cljs$core$IFn$_invoke$arity$1(topic) : buf_fn.call(null,topic)))));
}
});})(or__4131__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async100925 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async100925 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta100926){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta100926 = meta100926;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async100925.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_100927,meta100926__$1){
var self__ = this;
var _100927__$1 = this;
return (new cljs.core.async.t_cljs$core$async100925(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta100926__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async100925.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_100927){
var self__ = this;
var _100927__$1 = this;
return self__.meta100926;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async100925.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async100925.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async100925.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async100925.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = (self__.ensure_mult.cljs$core$IFn$_invoke$arity$1 ? self__.ensure_mult.cljs$core$IFn$_invoke$arity$1(topic) : self__.ensure_mult.call(null,topic));
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3(m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async100925.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__5735__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(self__.mults),topic);
if(cljs.core.truth_(temp__5735__auto__)){
var m = temp__5735__auto__;
return cljs.core.async.untap(m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async100925.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_(self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async100925.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async100925.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$ch,cljs.core.cst$sym$topic_DASH_fn,cljs.core.cst$sym$buf_DASH_fn,cljs.core.cst$sym$mults,cljs.core.cst$sym$ensure_DASH_mult,cljs.core.cst$sym$meta100926], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async100925.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async100925.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async100925";

cljs.core.async.t_cljs$core$async100925.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write(writer__4375__auto__,"cljs.core.async/t_cljs$core$async100925");
});})(mults,ensure_mult))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async100925.
 */
cljs.core.async.__GT_t_cljs$core$async100925 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async100925(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta100926){
return (new cljs.core.async.t_cljs$core$async100925(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta100926));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async100925(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__99809__auto___101045 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___101045,mults,ensure_mult,p){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___101045,mults,ensure_mult,p){
return (function (state_100999){
var state_val_101000 = (state_100999[(1)]);
if((state_val_101000 === (7))){
var inst_100995 = (state_100999[(2)]);
var state_100999__$1 = state_100999;
var statearr_101001_101046 = state_100999__$1;
(statearr_101001_101046[(2)] = inst_100995);

(statearr_101001_101046[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (20))){
var state_100999__$1 = state_100999;
var statearr_101002_101047 = state_100999__$1;
(statearr_101002_101047[(2)] = null);

(statearr_101002_101047[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (1))){
var state_100999__$1 = state_100999;
var statearr_101003_101048 = state_100999__$1;
(statearr_101003_101048[(2)] = null);

(statearr_101003_101048[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (24))){
var inst_100978 = (state_100999[(7)]);
var inst_100987 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(mults,cljs.core.dissoc,inst_100978);
var state_100999__$1 = state_100999;
var statearr_101004_101049 = state_100999__$1;
(statearr_101004_101049[(2)] = inst_100987);

(statearr_101004_101049[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (4))){
var inst_100930 = (state_100999[(8)]);
var inst_100930__$1 = (state_100999[(2)]);
var inst_100931 = (inst_100930__$1 == null);
var state_100999__$1 = (function (){var statearr_101005 = state_100999;
(statearr_101005[(8)] = inst_100930__$1);

return statearr_101005;
})();
if(cljs.core.truth_(inst_100931)){
var statearr_101006_101050 = state_100999__$1;
(statearr_101006_101050[(1)] = (5));

} else {
var statearr_101007_101051 = state_100999__$1;
(statearr_101007_101051[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (15))){
var inst_100972 = (state_100999[(2)]);
var state_100999__$1 = state_100999;
var statearr_101008_101052 = state_100999__$1;
(statearr_101008_101052[(2)] = inst_100972);

(statearr_101008_101052[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (21))){
var inst_100992 = (state_100999[(2)]);
var state_100999__$1 = (function (){var statearr_101009 = state_100999;
(statearr_101009[(9)] = inst_100992);

return statearr_101009;
})();
var statearr_101010_101053 = state_100999__$1;
(statearr_101010_101053[(2)] = null);

(statearr_101010_101053[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (13))){
var inst_100954 = (state_100999[(10)]);
var inst_100956 = cljs.core.chunked_seq_QMARK_(inst_100954);
var state_100999__$1 = state_100999;
if(inst_100956){
var statearr_101011_101054 = state_100999__$1;
(statearr_101011_101054[(1)] = (16));

} else {
var statearr_101012_101055 = state_100999__$1;
(statearr_101012_101055[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (22))){
var inst_100984 = (state_100999[(2)]);
var state_100999__$1 = state_100999;
if(cljs.core.truth_(inst_100984)){
var statearr_101013_101056 = state_100999__$1;
(statearr_101013_101056[(1)] = (23));

} else {
var statearr_101014_101057 = state_100999__$1;
(statearr_101014_101057[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (6))){
var inst_100930 = (state_100999[(8)]);
var inst_100978 = (state_100999[(7)]);
var inst_100980 = (state_100999[(11)]);
var inst_100978__$1 = (topic_fn.cljs$core$IFn$_invoke$arity$1 ? topic_fn.cljs$core$IFn$_invoke$arity$1(inst_100930) : topic_fn.call(null,inst_100930));
var inst_100979 = cljs.core.deref(mults);
var inst_100980__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_100979,inst_100978__$1);
var state_100999__$1 = (function (){var statearr_101015 = state_100999;
(statearr_101015[(7)] = inst_100978__$1);

(statearr_101015[(11)] = inst_100980__$1);

return statearr_101015;
})();
if(cljs.core.truth_(inst_100980__$1)){
var statearr_101016_101058 = state_100999__$1;
(statearr_101016_101058[(1)] = (19));

} else {
var statearr_101017_101059 = state_100999__$1;
(statearr_101017_101059[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (25))){
var inst_100989 = (state_100999[(2)]);
var state_100999__$1 = state_100999;
var statearr_101018_101060 = state_100999__$1;
(statearr_101018_101060[(2)] = inst_100989);

(statearr_101018_101060[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (17))){
var inst_100954 = (state_100999[(10)]);
var inst_100963 = cljs.core.first(inst_100954);
var inst_100964 = cljs.core.async.muxch_STAR_(inst_100963);
var inst_100965 = cljs.core.async.close_BANG_(inst_100964);
var inst_100966 = cljs.core.next(inst_100954);
var inst_100940 = inst_100966;
var inst_100941 = null;
var inst_100942 = (0);
var inst_100943 = (0);
var state_100999__$1 = (function (){var statearr_101019 = state_100999;
(statearr_101019[(12)] = inst_100943);

(statearr_101019[(13)] = inst_100942);

(statearr_101019[(14)] = inst_100941);

(statearr_101019[(15)] = inst_100940);

(statearr_101019[(16)] = inst_100965);

return statearr_101019;
})();
var statearr_101020_101061 = state_100999__$1;
(statearr_101020_101061[(2)] = null);

(statearr_101020_101061[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (3))){
var inst_100997 = (state_100999[(2)]);
var state_100999__$1 = state_100999;
return cljs.core.async.impl.ioc_helpers.return_chan(state_100999__$1,inst_100997);
} else {
if((state_val_101000 === (12))){
var inst_100974 = (state_100999[(2)]);
var state_100999__$1 = state_100999;
var statearr_101021_101062 = state_100999__$1;
(statearr_101021_101062[(2)] = inst_100974);

(statearr_101021_101062[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (2))){
var state_100999__$1 = state_100999;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_100999__$1,(4),ch);
} else {
if((state_val_101000 === (23))){
var state_100999__$1 = state_100999;
var statearr_101022_101063 = state_100999__$1;
(statearr_101022_101063[(2)] = null);

(statearr_101022_101063[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (19))){
var inst_100930 = (state_100999[(8)]);
var inst_100980 = (state_100999[(11)]);
var inst_100982 = cljs.core.async.muxch_STAR_(inst_100980);
var state_100999__$1 = state_100999;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_100999__$1,(22),inst_100982,inst_100930);
} else {
if((state_val_101000 === (11))){
var inst_100954 = (state_100999[(10)]);
var inst_100940 = (state_100999[(15)]);
var inst_100954__$1 = cljs.core.seq(inst_100940);
var state_100999__$1 = (function (){var statearr_101023 = state_100999;
(statearr_101023[(10)] = inst_100954__$1);

return statearr_101023;
})();
if(inst_100954__$1){
var statearr_101024_101064 = state_100999__$1;
(statearr_101024_101064[(1)] = (13));

} else {
var statearr_101025_101065 = state_100999__$1;
(statearr_101025_101065[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (9))){
var inst_100976 = (state_100999[(2)]);
var state_100999__$1 = state_100999;
var statearr_101026_101066 = state_100999__$1;
(statearr_101026_101066[(2)] = inst_100976);

(statearr_101026_101066[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (5))){
var inst_100937 = cljs.core.deref(mults);
var inst_100938 = cljs.core.vals(inst_100937);
var inst_100939 = cljs.core.seq(inst_100938);
var inst_100940 = inst_100939;
var inst_100941 = null;
var inst_100942 = (0);
var inst_100943 = (0);
var state_100999__$1 = (function (){var statearr_101027 = state_100999;
(statearr_101027[(12)] = inst_100943);

(statearr_101027[(13)] = inst_100942);

(statearr_101027[(14)] = inst_100941);

(statearr_101027[(15)] = inst_100940);

return statearr_101027;
})();
var statearr_101028_101067 = state_100999__$1;
(statearr_101028_101067[(2)] = null);

(statearr_101028_101067[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (14))){
var state_100999__$1 = state_100999;
var statearr_101032_101068 = state_100999__$1;
(statearr_101032_101068[(2)] = null);

(statearr_101032_101068[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (16))){
var inst_100954 = (state_100999[(10)]);
var inst_100958 = cljs.core.chunk_first(inst_100954);
var inst_100959 = cljs.core.chunk_rest(inst_100954);
var inst_100960 = cljs.core.count(inst_100958);
var inst_100940 = inst_100959;
var inst_100941 = inst_100958;
var inst_100942 = inst_100960;
var inst_100943 = (0);
var state_100999__$1 = (function (){var statearr_101033 = state_100999;
(statearr_101033[(12)] = inst_100943);

(statearr_101033[(13)] = inst_100942);

(statearr_101033[(14)] = inst_100941);

(statearr_101033[(15)] = inst_100940);

return statearr_101033;
})();
var statearr_101034_101069 = state_100999__$1;
(statearr_101034_101069[(2)] = null);

(statearr_101034_101069[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (10))){
var inst_100943 = (state_100999[(12)]);
var inst_100942 = (state_100999[(13)]);
var inst_100941 = (state_100999[(14)]);
var inst_100940 = (state_100999[(15)]);
var inst_100948 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_100941,inst_100943);
var inst_100949 = cljs.core.async.muxch_STAR_(inst_100948);
var inst_100950 = cljs.core.async.close_BANG_(inst_100949);
var inst_100951 = (inst_100943 + (1));
var tmp101029 = inst_100942;
var tmp101030 = inst_100941;
var tmp101031 = inst_100940;
var inst_100940__$1 = tmp101031;
var inst_100941__$1 = tmp101030;
var inst_100942__$1 = tmp101029;
var inst_100943__$1 = inst_100951;
var state_100999__$1 = (function (){var statearr_101035 = state_100999;
(statearr_101035[(12)] = inst_100943__$1);

(statearr_101035[(13)] = inst_100942__$1);

(statearr_101035[(17)] = inst_100950);

(statearr_101035[(14)] = inst_100941__$1);

(statearr_101035[(15)] = inst_100940__$1);

return statearr_101035;
})();
var statearr_101036_101070 = state_100999__$1;
(statearr_101036_101070[(2)] = null);

(statearr_101036_101070[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (18))){
var inst_100969 = (state_100999[(2)]);
var state_100999__$1 = state_100999;
var statearr_101037_101071 = state_100999__$1;
(statearr_101037_101071[(2)] = inst_100969);

(statearr_101037_101071[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101000 === (8))){
var inst_100943 = (state_100999[(12)]);
var inst_100942 = (state_100999[(13)]);
var inst_100945 = (inst_100943 < inst_100942);
var inst_100946 = inst_100945;
var state_100999__$1 = state_100999;
if(cljs.core.truth_(inst_100946)){
var statearr_101038_101072 = state_100999__$1;
(statearr_101038_101072[(1)] = (10));

} else {
var statearr_101039_101073 = state_100999__$1;
(statearr_101039_101073[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___101045,mults,ensure_mult,p))
;
return ((function (switch__99702__auto__,c__99809__auto___101045,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_101040 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_101040[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_101040[(1)] = (1));

return statearr_101040;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_100999){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_100999);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101041){if((e101041 instanceof Object)){
var ex__99706__auto__ = e101041;
var statearr_101042_101074 = state_100999;
(statearr_101042_101074[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_100999);

return cljs.core.cst$kw$recur;
} else {
throw e101041;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101075 = state_100999;
state_100999 = G__101075;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_100999){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_100999);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___101045,mults,ensure_mult,p))
})();
var state__99811__auto__ = (function (){var statearr_101043 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101043[(6)] = c__99809__auto___101045);

return statearr_101043;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___101045,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var G__101077 = arguments.length;
switch (G__101077) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4(p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_(p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_(p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var G__101080 = arguments.length;
switch (G__101080) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1(p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2(p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var G__101083 = arguments.length;
switch (G__101083) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3(f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec(chs);
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var cnt = cljs.core.count(chs__$1);
var rets = cljs.core.object_array.cljs$core$IFn$_invoke$arity$1(cnt);
var dchan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var dctr = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(null);
var done = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.cljs$core$IFn$_invoke$arity$1(cnt));
var c__99809__auto___101150 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___101150,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___101150,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_101122){
var state_val_101123 = (state_101122[(1)]);
if((state_val_101123 === (7))){
var state_101122__$1 = state_101122;
var statearr_101124_101151 = state_101122__$1;
(statearr_101124_101151[(2)] = null);

(statearr_101124_101151[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (1))){
var state_101122__$1 = state_101122;
var statearr_101125_101152 = state_101122__$1;
(statearr_101125_101152[(2)] = null);

(statearr_101125_101152[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (4))){
var inst_101086 = (state_101122[(7)]);
var inst_101088 = (inst_101086 < cnt);
var state_101122__$1 = state_101122;
if(cljs.core.truth_(inst_101088)){
var statearr_101126_101153 = state_101122__$1;
(statearr_101126_101153[(1)] = (6));

} else {
var statearr_101127_101154 = state_101122__$1;
(statearr_101127_101154[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (15))){
var inst_101118 = (state_101122[(2)]);
var state_101122__$1 = state_101122;
var statearr_101128_101155 = state_101122__$1;
(statearr_101128_101155[(2)] = inst_101118);

(statearr_101128_101155[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (13))){
var inst_101111 = cljs.core.async.close_BANG_(out);
var state_101122__$1 = state_101122;
var statearr_101129_101156 = state_101122__$1;
(statearr_101129_101156[(2)] = inst_101111);

(statearr_101129_101156[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (6))){
var state_101122__$1 = state_101122;
var statearr_101130_101157 = state_101122__$1;
(statearr_101130_101157[(2)] = null);

(statearr_101130_101157[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (3))){
var inst_101120 = (state_101122[(2)]);
var state_101122__$1 = state_101122;
return cljs.core.async.impl.ioc_helpers.return_chan(state_101122__$1,inst_101120);
} else {
if((state_val_101123 === (12))){
var inst_101108 = (state_101122[(8)]);
var inst_101108__$1 = (state_101122[(2)]);
var inst_101109 = cljs.core.some(cljs.core.nil_QMARK_,inst_101108__$1);
var state_101122__$1 = (function (){var statearr_101131 = state_101122;
(statearr_101131[(8)] = inst_101108__$1);

return statearr_101131;
})();
if(cljs.core.truth_(inst_101109)){
var statearr_101132_101158 = state_101122__$1;
(statearr_101132_101158[(1)] = (13));

} else {
var statearr_101133_101159 = state_101122__$1;
(statearr_101133_101159[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (2))){
var inst_101085 = cljs.core.reset_BANG_(dctr,cnt);
var inst_101086 = (0);
var state_101122__$1 = (function (){var statearr_101134 = state_101122;
(statearr_101134[(7)] = inst_101086);

(statearr_101134[(9)] = inst_101085);

return statearr_101134;
})();
var statearr_101135_101160 = state_101122__$1;
(statearr_101135_101160[(2)] = null);

(statearr_101135_101160[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (11))){
var inst_101086 = (state_101122[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_101122,(10),Object,null,(9));
var inst_101095 = (chs__$1.cljs$core$IFn$_invoke$arity$1 ? chs__$1.cljs$core$IFn$_invoke$arity$1(inst_101086) : chs__$1.call(null,inst_101086));
var inst_101096 = (done.cljs$core$IFn$_invoke$arity$1 ? done.cljs$core$IFn$_invoke$arity$1(inst_101086) : done.call(null,inst_101086));
var inst_101097 = cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2(inst_101095,inst_101096);
var state_101122__$1 = state_101122;
var statearr_101136_101161 = state_101122__$1;
(statearr_101136_101161[(2)] = inst_101097);


cljs.core.async.impl.ioc_helpers.process_exception(state_101122__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (9))){
var inst_101086 = (state_101122[(7)]);
var inst_101099 = (state_101122[(2)]);
var inst_101100 = (inst_101086 + (1));
var inst_101086__$1 = inst_101100;
var state_101122__$1 = (function (){var statearr_101137 = state_101122;
(statearr_101137[(7)] = inst_101086__$1);

(statearr_101137[(10)] = inst_101099);

return statearr_101137;
})();
var statearr_101138_101162 = state_101122__$1;
(statearr_101138_101162[(2)] = null);

(statearr_101138_101162[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (5))){
var inst_101106 = (state_101122[(2)]);
var state_101122__$1 = (function (){var statearr_101139 = state_101122;
(statearr_101139[(11)] = inst_101106);

return statearr_101139;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_101122__$1,(12),dchan);
} else {
if((state_val_101123 === (14))){
var inst_101108 = (state_101122[(8)]);
var inst_101113 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(f,inst_101108);
var state_101122__$1 = state_101122;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101122__$1,(16),out,inst_101113);
} else {
if((state_val_101123 === (16))){
var inst_101115 = (state_101122[(2)]);
var state_101122__$1 = (function (){var statearr_101140 = state_101122;
(statearr_101140[(12)] = inst_101115);

return statearr_101140;
})();
var statearr_101141_101163 = state_101122__$1;
(statearr_101141_101163[(2)] = null);

(statearr_101141_101163[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (10))){
var inst_101090 = (state_101122[(2)]);
var inst_101091 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(dctr,cljs.core.dec);
var state_101122__$1 = (function (){var statearr_101142 = state_101122;
(statearr_101142[(13)] = inst_101090);

return statearr_101142;
})();
var statearr_101143_101164 = state_101122__$1;
(statearr_101143_101164[(2)] = inst_101091);


cljs.core.async.impl.ioc_helpers.process_exception(state_101122__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_101123 === (8))){
var inst_101104 = (state_101122[(2)]);
var state_101122__$1 = state_101122;
var statearr_101144_101165 = state_101122__$1;
(statearr_101144_101165[(2)] = inst_101104);

(statearr_101144_101165[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___101150,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__99702__auto__,c__99809__auto___101150,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_101145 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_101145[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_101145[(1)] = (1));

return statearr_101145;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_101122){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_101122);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101146){if((e101146 instanceof Object)){
var ex__99706__auto__ = e101146;
var statearr_101147_101166 = state_101122;
(statearr_101147_101166[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_101122);

return cljs.core.cst$kw$recur;
} else {
throw e101146;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101167 = state_101122;
state_101122 = G__101167;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_101122){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_101122);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___101150,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__99811__auto__ = (function (){var statearr_101148 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101148[(6)] = c__99809__auto___101150);

return statearr_101148;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___101150,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var G__101170 = arguments.length;
switch (G__101170) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2(chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__99809__auto___101224 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___101224,out){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___101224,out){
return (function (state_101202){
var state_val_101203 = (state_101202[(1)]);
if((state_val_101203 === (7))){
var inst_101182 = (state_101202[(7)]);
var inst_101181 = (state_101202[(8)]);
var inst_101181__$1 = (state_101202[(2)]);
var inst_101182__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_101181__$1,(0),null);
var inst_101183 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_101181__$1,(1),null);
var inst_101184 = (inst_101182__$1 == null);
var state_101202__$1 = (function (){var statearr_101204 = state_101202;
(statearr_101204[(7)] = inst_101182__$1);

(statearr_101204[(9)] = inst_101183);

(statearr_101204[(8)] = inst_101181__$1);

return statearr_101204;
})();
if(cljs.core.truth_(inst_101184)){
var statearr_101205_101225 = state_101202__$1;
(statearr_101205_101225[(1)] = (8));

} else {
var statearr_101206_101226 = state_101202__$1;
(statearr_101206_101226[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101203 === (1))){
var inst_101171 = cljs.core.vec(chs);
var inst_101172 = inst_101171;
var state_101202__$1 = (function (){var statearr_101207 = state_101202;
(statearr_101207[(10)] = inst_101172);

return statearr_101207;
})();
var statearr_101208_101227 = state_101202__$1;
(statearr_101208_101227[(2)] = null);

(statearr_101208_101227[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101203 === (4))){
var inst_101172 = (state_101202[(10)]);
var state_101202__$1 = state_101202;
return cljs.core.async.ioc_alts_BANG_(state_101202__$1,(7),inst_101172);
} else {
if((state_val_101203 === (6))){
var inst_101198 = (state_101202[(2)]);
var state_101202__$1 = state_101202;
var statearr_101209_101228 = state_101202__$1;
(statearr_101209_101228[(2)] = inst_101198);

(statearr_101209_101228[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101203 === (3))){
var inst_101200 = (state_101202[(2)]);
var state_101202__$1 = state_101202;
return cljs.core.async.impl.ioc_helpers.return_chan(state_101202__$1,inst_101200);
} else {
if((state_val_101203 === (2))){
var inst_101172 = (state_101202[(10)]);
var inst_101174 = cljs.core.count(inst_101172);
var inst_101175 = (inst_101174 > (0));
var state_101202__$1 = state_101202;
if(cljs.core.truth_(inst_101175)){
var statearr_101211_101229 = state_101202__$1;
(statearr_101211_101229[(1)] = (4));

} else {
var statearr_101212_101230 = state_101202__$1;
(statearr_101212_101230[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101203 === (11))){
var inst_101172 = (state_101202[(10)]);
var inst_101191 = (state_101202[(2)]);
var tmp101210 = inst_101172;
var inst_101172__$1 = tmp101210;
var state_101202__$1 = (function (){var statearr_101213 = state_101202;
(statearr_101213[(11)] = inst_101191);

(statearr_101213[(10)] = inst_101172__$1);

return statearr_101213;
})();
var statearr_101214_101231 = state_101202__$1;
(statearr_101214_101231[(2)] = null);

(statearr_101214_101231[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101203 === (9))){
var inst_101182 = (state_101202[(7)]);
var state_101202__$1 = state_101202;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101202__$1,(11),out,inst_101182);
} else {
if((state_val_101203 === (5))){
var inst_101196 = cljs.core.async.close_BANG_(out);
var state_101202__$1 = state_101202;
var statearr_101215_101232 = state_101202__$1;
(statearr_101215_101232[(2)] = inst_101196);

(statearr_101215_101232[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101203 === (10))){
var inst_101194 = (state_101202[(2)]);
var state_101202__$1 = state_101202;
var statearr_101216_101233 = state_101202__$1;
(statearr_101216_101233[(2)] = inst_101194);

(statearr_101216_101233[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101203 === (8))){
var inst_101182 = (state_101202[(7)]);
var inst_101183 = (state_101202[(9)]);
var inst_101172 = (state_101202[(10)]);
var inst_101181 = (state_101202[(8)]);
var inst_101186 = (function (){var cs = inst_101172;
var vec__101177 = inst_101181;
var v = inst_101182;
var c = inst_101183;
return ((function (cs,vec__101177,v,c,inst_101182,inst_101183,inst_101172,inst_101181,state_val_101203,c__99809__auto___101224,out){
return (function (p1__101168_SHARP_){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(c,p1__101168_SHARP_);
});
;})(cs,vec__101177,v,c,inst_101182,inst_101183,inst_101172,inst_101181,state_val_101203,c__99809__auto___101224,out))
})();
var inst_101187 = cljs.core.filterv(inst_101186,inst_101172);
var inst_101172__$1 = inst_101187;
var state_101202__$1 = (function (){var statearr_101217 = state_101202;
(statearr_101217[(10)] = inst_101172__$1);

return statearr_101217;
})();
var statearr_101218_101234 = state_101202__$1;
(statearr_101218_101234[(2)] = null);

(statearr_101218_101234[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___101224,out))
;
return ((function (switch__99702__auto__,c__99809__auto___101224,out){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_101219 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_101219[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_101219[(1)] = (1));

return statearr_101219;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_101202){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_101202);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101220){if((e101220 instanceof Object)){
var ex__99706__auto__ = e101220;
var statearr_101221_101235 = state_101202;
(statearr_101221_101235[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_101202);

return cljs.core.cst$kw$recur;
} else {
throw e101220;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101236 = state_101202;
state_101202 = G__101236;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_101202){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_101202);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___101224,out))
})();
var state__99811__auto__ = (function (){var statearr_101222 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101222[(6)] = c__99809__auto___101224);

return statearr_101222;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___101224,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce(cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var G__101238 = arguments.length;
switch (G__101238) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__99809__auto___101283 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___101283,out){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___101283,out){
return (function (state_101262){
var state_val_101263 = (state_101262[(1)]);
if((state_val_101263 === (7))){
var inst_101244 = (state_101262[(7)]);
var inst_101244__$1 = (state_101262[(2)]);
var inst_101245 = (inst_101244__$1 == null);
var inst_101246 = cljs.core.not(inst_101245);
var state_101262__$1 = (function (){var statearr_101264 = state_101262;
(statearr_101264[(7)] = inst_101244__$1);

return statearr_101264;
})();
if(inst_101246){
var statearr_101265_101284 = state_101262__$1;
(statearr_101265_101284[(1)] = (8));

} else {
var statearr_101266_101285 = state_101262__$1;
(statearr_101266_101285[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101263 === (1))){
var inst_101239 = (0);
var state_101262__$1 = (function (){var statearr_101267 = state_101262;
(statearr_101267[(8)] = inst_101239);

return statearr_101267;
})();
var statearr_101268_101286 = state_101262__$1;
(statearr_101268_101286[(2)] = null);

(statearr_101268_101286[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101263 === (4))){
var state_101262__$1 = state_101262;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_101262__$1,(7),ch);
} else {
if((state_val_101263 === (6))){
var inst_101257 = (state_101262[(2)]);
var state_101262__$1 = state_101262;
var statearr_101269_101287 = state_101262__$1;
(statearr_101269_101287[(2)] = inst_101257);

(statearr_101269_101287[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101263 === (3))){
var inst_101259 = (state_101262[(2)]);
var inst_101260 = cljs.core.async.close_BANG_(out);
var state_101262__$1 = (function (){var statearr_101270 = state_101262;
(statearr_101270[(9)] = inst_101259);

return statearr_101270;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_101262__$1,inst_101260);
} else {
if((state_val_101263 === (2))){
var inst_101239 = (state_101262[(8)]);
var inst_101241 = (inst_101239 < n);
var state_101262__$1 = state_101262;
if(cljs.core.truth_(inst_101241)){
var statearr_101271_101288 = state_101262__$1;
(statearr_101271_101288[(1)] = (4));

} else {
var statearr_101272_101289 = state_101262__$1;
(statearr_101272_101289[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101263 === (11))){
var inst_101239 = (state_101262[(8)]);
var inst_101249 = (state_101262[(2)]);
var inst_101250 = (inst_101239 + (1));
var inst_101239__$1 = inst_101250;
var state_101262__$1 = (function (){var statearr_101273 = state_101262;
(statearr_101273[(8)] = inst_101239__$1);

(statearr_101273[(10)] = inst_101249);

return statearr_101273;
})();
var statearr_101274_101290 = state_101262__$1;
(statearr_101274_101290[(2)] = null);

(statearr_101274_101290[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101263 === (9))){
var state_101262__$1 = state_101262;
var statearr_101275_101291 = state_101262__$1;
(statearr_101275_101291[(2)] = null);

(statearr_101275_101291[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101263 === (5))){
var state_101262__$1 = state_101262;
var statearr_101276_101292 = state_101262__$1;
(statearr_101276_101292[(2)] = null);

(statearr_101276_101292[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101263 === (10))){
var inst_101254 = (state_101262[(2)]);
var state_101262__$1 = state_101262;
var statearr_101277_101293 = state_101262__$1;
(statearr_101277_101293[(2)] = inst_101254);

(statearr_101277_101293[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101263 === (8))){
var inst_101244 = (state_101262[(7)]);
var state_101262__$1 = state_101262;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101262__$1,(11),out,inst_101244);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___101283,out))
;
return ((function (switch__99702__auto__,c__99809__auto___101283,out){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_101278 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_101278[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_101278[(1)] = (1));

return statearr_101278;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_101262){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_101262);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101279){if((e101279 instanceof Object)){
var ex__99706__auto__ = e101279;
var statearr_101280_101294 = state_101262;
(statearr_101280_101294[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_101262);

return cljs.core.cst$kw$recur;
} else {
throw e101279;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101295 = state_101262;
state_101262 = G__101295;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_101262){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_101262);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___101283,out))
})();
var state__99811__auto__ = (function (){var statearr_101281 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101281[(6)] = c__99809__auto___101283);

return statearr_101281;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___101283,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async101297 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async101297 = (function (f,ch,meta101298){
this.f = f;
this.ch = ch;
this.meta101298 = meta101298;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async101297.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_101299,meta101298__$1){
var self__ = this;
var _101299__$1 = this;
return (new cljs.core.async.t_cljs$core$async101297(self__.f,self__.ch,meta101298__$1));
});

cljs.core.async.t_cljs$core$async101297.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_101299){
var self__ = this;
var _101299__$1 = this;
return self__.meta101298;
});

cljs.core.async.t_cljs$core$async101297.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async101297.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async101297.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t_cljs$core$async101297.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async101297.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_(self__.ch,(function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async101300 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async101300 = (function (f,ch,meta101298,_,fn1,meta101301){
this.f = f;
this.ch = ch;
this.meta101298 = meta101298;
this._ = _;
this.fn1 = fn1;
this.meta101301 = meta101301;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async101300.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_101302,meta101301__$1){
var self__ = this;
var _101302__$1 = this;
return (new cljs.core.async.t_cljs$core$async101300(self__.f,self__.ch,self__.meta101298,self__._,self__.fn1,meta101301__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async101300.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_101302){
var self__ = this;
var _101302__$1 = this;
return self__.meta101301;
});})(___$1))
;

cljs.core.async.t_cljs$core$async101300.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async101300.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_(self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async101300.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async101300.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit(self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__101296_SHARP_){
var G__101303 = (((p1__101296_SHARP_ == null))?null:(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(p1__101296_SHARP_) : self__.f.call(null,p1__101296_SHARP_)));
return (f1.cljs$core$IFn$_invoke$arity$1 ? f1.cljs$core$IFn$_invoke$arity$1(G__101303) : f1.call(null,G__101303));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async101300.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta101298,cljs.core.with_meta(cljs.core.cst$sym$_,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$tag,cljs.core.cst$sym$cljs$core$async_SLASH_t_cljs$core$async101297], null)),cljs.core.cst$sym$fn1,cljs.core.cst$sym$meta101301], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async101300.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async101300.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async101300";

cljs.core.async.t_cljs$core$async101300.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write(writer__4375__auto__,"cljs.core.async/t_cljs$core$async101300");
});})(___$1))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async101300.
 */
cljs.core.async.__GT_t_cljs$core$async101300 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async101300(f__$1,ch__$1,meta101298__$1,___$2,fn1__$1,meta101301){
return (new cljs.core.async.t_cljs$core$async101300(f__$1,ch__$1,meta101298__$1,___$2,fn1__$1,meta101301));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async101300(self__.f,self__.ch,self__.meta101298,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__4120__auto__ = ret;
if(cljs.core.truth_(and__4120__auto__)){
return (!((cljs.core.deref(ret) == null)));
} else {
return and__4120__auto__;
}
})())){
return cljs.core.async.impl.channels.box((function (){var G__101304 = cljs.core.deref(ret);
return (self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(G__101304) : self__.f.call(null,G__101304));
})());
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async101297.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async101297.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async101297.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta101298], null);
});

cljs.core.async.t_cljs$core$async101297.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async101297.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async101297";

cljs.core.async.t_cljs$core$async101297.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write(writer__4375__auto__,"cljs.core.async/t_cljs$core$async101297");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async101297.
 */
cljs.core.async.__GT_t_cljs$core$async101297 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async101297(f__$1,ch__$1,meta101298){
return (new cljs.core.async.t_cljs$core$async101297(f__$1,ch__$1,meta101298));
});

}

return (new cljs.core.async.t_cljs$core$async101297(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async101305 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async101305 = (function (f,ch,meta101306){
this.f = f;
this.ch = ch;
this.meta101306 = meta101306;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async101305.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_101307,meta101306__$1){
var self__ = this;
var _101307__$1 = this;
return (new cljs.core.async.t_cljs$core$async101305(self__.f,self__.ch,meta101306__$1));
});

cljs.core.async.t_cljs$core$async101305.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_101307){
var self__ = this;
var _101307__$1 = this;
return self__.meta101306;
});

cljs.core.async.t_cljs$core$async101305.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async101305.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async101305.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async101305.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async101305.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async101305.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,(self__.f.cljs$core$IFn$_invoke$arity$1 ? self__.f.cljs$core$IFn$_invoke$arity$1(val) : self__.f.call(null,val)),fn1);
});

cljs.core.async.t_cljs$core$async101305.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$f,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta101306], null);
});

cljs.core.async.t_cljs$core$async101305.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async101305.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async101305";

cljs.core.async.t_cljs$core$async101305.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write(writer__4375__auto__,"cljs.core.async/t_cljs$core$async101305");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async101305.
 */
cljs.core.async.__GT_t_cljs$core$async101305 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async101305(f__$1,ch__$1,meta101306){
return (new cljs.core.async.t_cljs$core$async101305(f__$1,ch__$1,meta101306));
});

}

return (new cljs.core.async.t_cljs$core$async101305(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async101308 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async101308 = (function (p,ch,meta101309){
this.p = p;
this.ch = ch;
this.meta101309 = meta101309;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async101308.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_101310,meta101309__$1){
var self__ = this;
var _101310__$1 = this;
return (new cljs.core.async.t_cljs$core$async101308(self__.p,self__.ch,meta101309__$1));
});

cljs.core.async.t_cljs$core$async101308.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_101310){
var self__ = this;
var _101310__$1 = this;
return self__.meta101309;
});

cljs.core.async.t_cljs$core$async101308.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async101308.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_(self__.ch);
});

cljs.core.async.t_cljs$core$async101308.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_(self__.ch);
});

cljs.core.async.t_cljs$core$async101308.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async101308.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_(self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async101308.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async101308.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_((self__.p.cljs$core$IFn$_invoke$arity$1 ? self__.p.cljs$core$IFn$_invoke$arity$1(val) : self__.p.call(null,val)))){
return cljs.core.async.impl.protocols.put_BANG_(self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box(cljs.core.not(cljs.core.async.impl.protocols.closed_QMARK_(self__.ch)));
}
});

cljs.core.async.t_cljs$core$async101308.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$p,cljs.core.cst$sym$ch,cljs.core.cst$sym$meta101309], null);
});

cljs.core.async.t_cljs$core$async101308.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async101308.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async101308";

cljs.core.async.t_cljs$core$async101308.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write(writer__4375__auto__,"cljs.core.async/t_cljs$core$async101308");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async101308.
 */
cljs.core.async.__GT_t_cljs$core$async101308 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async101308(p__$1,ch__$1,meta101309){
return (new cljs.core.async.t_cljs$core$async101308(p__$1,ch__$1,meta101309));
});

}

return (new cljs.core.async.t_cljs$core$async101308(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_(cljs.core.complement(p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var G__101312 = arguments.length;
switch (G__101312) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__99809__auto___101352 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___101352,out){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___101352,out){
return (function (state_101333){
var state_val_101334 = (state_101333[(1)]);
if((state_val_101334 === (7))){
var inst_101329 = (state_101333[(2)]);
var state_101333__$1 = state_101333;
var statearr_101335_101353 = state_101333__$1;
(statearr_101335_101353[(2)] = inst_101329);

(statearr_101335_101353[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101334 === (1))){
var state_101333__$1 = state_101333;
var statearr_101336_101354 = state_101333__$1;
(statearr_101336_101354[(2)] = null);

(statearr_101336_101354[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101334 === (4))){
var inst_101315 = (state_101333[(7)]);
var inst_101315__$1 = (state_101333[(2)]);
var inst_101316 = (inst_101315__$1 == null);
var state_101333__$1 = (function (){var statearr_101337 = state_101333;
(statearr_101337[(7)] = inst_101315__$1);

return statearr_101337;
})();
if(cljs.core.truth_(inst_101316)){
var statearr_101338_101355 = state_101333__$1;
(statearr_101338_101355[(1)] = (5));

} else {
var statearr_101339_101356 = state_101333__$1;
(statearr_101339_101356[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101334 === (6))){
var inst_101315 = (state_101333[(7)]);
var inst_101320 = (p.cljs$core$IFn$_invoke$arity$1 ? p.cljs$core$IFn$_invoke$arity$1(inst_101315) : p.call(null,inst_101315));
var state_101333__$1 = state_101333;
if(cljs.core.truth_(inst_101320)){
var statearr_101340_101357 = state_101333__$1;
(statearr_101340_101357[(1)] = (8));

} else {
var statearr_101341_101358 = state_101333__$1;
(statearr_101341_101358[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101334 === (3))){
var inst_101331 = (state_101333[(2)]);
var state_101333__$1 = state_101333;
return cljs.core.async.impl.ioc_helpers.return_chan(state_101333__$1,inst_101331);
} else {
if((state_val_101334 === (2))){
var state_101333__$1 = state_101333;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_101333__$1,(4),ch);
} else {
if((state_val_101334 === (11))){
var inst_101323 = (state_101333[(2)]);
var state_101333__$1 = state_101333;
var statearr_101342_101359 = state_101333__$1;
(statearr_101342_101359[(2)] = inst_101323);

(statearr_101342_101359[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101334 === (9))){
var state_101333__$1 = state_101333;
var statearr_101343_101360 = state_101333__$1;
(statearr_101343_101360[(2)] = null);

(statearr_101343_101360[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101334 === (5))){
var inst_101318 = cljs.core.async.close_BANG_(out);
var state_101333__$1 = state_101333;
var statearr_101344_101361 = state_101333__$1;
(statearr_101344_101361[(2)] = inst_101318);

(statearr_101344_101361[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101334 === (10))){
var inst_101326 = (state_101333[(2)]);
var state_101333__$1 = (function (){var statearr_101345 = state_101333;
(statearr_101345[(8)] = inst_101326);

return statearr_101345;
})();
var statearr_101346_101362 = state_101333__$1;
(statearr_101346_101362[(2)] = null);

(statearr_101346_101362[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101334 === (8))){
var inst_101315 = (state_101333[(7)]);
var state_101333__$1 = state_101333;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101333__$1,(11),out,inst_101315);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___101352,out))
;
return ((function (switch__99702__auto__,c__99809__auto___101352,out){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_101347 = [null,null,null,null,null,null,null,null,null];
(statearr_101347[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_101347[(1)] = (1));

return statearr_101347;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_101333){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_101333);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101348){if((e101348 instanceof Object)){
var ex__99706__auto__ = e101348;
var statearr_101349_101363 = state_101333;
(statearr_101349_101363[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_101333);

return cljs.core.cst$kw$recur;
} else {
throw e101348;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101364 = state_101333;
state_101333 = G__101364;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_101333){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_101333);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___101352,out))
})();
var state__99811__auto__ = (function (){var statearr_101350 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101350[(6)] = c__99809__auto___101352);

return statearr_101350;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___101352,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var G__101366 = arguments.length;
switch (G__101366) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3(p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3(cljs.core.complement(p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_101429){
var state_val_101430 = (state_101429[(1)]);
if((state_val_101430 === (7))){
var inst_101425 = (state_101429[(2)]);
var state_101429__$1 = state_101429;
var statearr_101431_101469 = state_101429__$1;
(statearr_101431_101469[(2)] = inst_101425);

(statearr_101431_101469[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (20))){
var inst_101395 = (state_101429[(7)]);
var inst_101406 = (state_101429[(2)]);
var inst_101407 = cljs.core.next(inst_101395);
var inst_101381 = inst_101407;
var inst_101382 = null;
var inst_101383 = (0);
var inst_101384 = (0);
var state_101429__$1 = (function (){var statearr_101432 = state_101429;
(statearr_101432[(8)] = inst_101406);

(statearr_101432[(9)] = inst_101382);

(statearr_101432[(10)] = inst_101383);

(statearr_101432[(11)] = inst_101381);

(statearr_101432[(12)] = inst_101384);

return statearr_101432;
})();
var statearr_101433_101470 = state_101429__$1;
(statearr_101433_101470[(2)] = null);

(statearr_101433_101470[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (1))){
var state_101429__$1 = state_101429;
var statearr_101434_101471 = state_101429__$1;
(statearr_101434_101471[(2)] = null);

(statearr_101434_101471[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (4))){
var inst_101370 = (state_101429[(13)]);
var inst_101370__$1 = (state_101429[(2)]);
var inst_101371 = (inst_101370__$1 == null);
var state_101429__$1 = (function (){var statearr_101435 = state_101429;
(statearr_101435[(13)] = inst_101370__$1);

return statearr_101435;
})();
if(cljs.core.truth_(inst_101371)){
var statearr_101436_101472 = state_101429__$1;
(statearr_101436_101472[(1)] = (5));

} else {
var statearr_101437_101473 = state_101429__$1;
(statearr_101437_101473[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (15))){
var state_101429__$1 = state_101429;
var statearr_101441_101474 = state_101429__$1;
(statearr_101441_101474[(2)] = null);

(statearr_101441_101474[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (21))){
var state_101429__$1 = state_101429;
var statearr_101442_101475 = state_101429__$1;
(statearr_101442_101475[(2)] = null);

(statearr_101442_101475[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (13))){
var inst_101382 = (state_101429[(9)]);
var inst_101383 = (state_101429[(10)]);
var inst_101381 = (state_101429[(11)]);
var inst_101384 = (state_101429[(12)]);
var inst_101391 = (state_101429[(2)]);
var inst_101392 = (inst_101384 + (1));
var tmp101438 = inst_101382;
var tmp101439 = inst_101383;
var tmp101440 = inst_101381;
var inst_101381__$1 = tmp101440;
var inst_101382__$1 = tmp101438;
var inst_101383__$1 = tmp101439;
var inst_101384__$1 = inst_101392;
var state_101429__$1 = (function (){var statearr_101443 = state_101429;
(statearr_101443[(9)] = inst_101382__$1);

(statearr_101443[(14)] = inst_101391);

(statearr_101443[(10)] = inst_101383__$1);

(statearr_101443[(11)] = inst_101381__$1);

(statearr_101443[(12)] = inst_101384__$1);

return statearr_101443;
})();
var statearr_101444_101476 = state_101429__$1;
(statearr_101444_101476[(2)] = null);

(statearr_101444_101476[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (22))){
var state_101429__$1 = state_101429;
var statearr_101445_101477 = state_101429__$1;
(statearr_101445_101477[(2)] = null);

(statearr_101445_101477[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (6))){
var inst_101370 = (state_101429[(13)]);
var inst_101379 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_101370) : f.call(null,inst_101370));
var inst_101380 = cljs.core.seq(inst_101379);
var inst_101381 = inst_101380;
var inst_101382 = null;
var inst_101383 = (0);
var inst_101384 = (0);
var state_101429__$1 = (function (){var statearr_101446 = state_101429;
(statearr_101446[(9)] = inst_101382);

(statearr_101446[(10)] = inst_101383);

(statearr_101446[(11)] = inst_101381);

(statearr_101446[(12)] = inst_101384);

return statearr_101446;
})();
var statearr_101447_101478 = state_101429__$1;
(statearr_101447_101478[(2)] = null);

(statearr_101447_101478[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (17))){
var inst_101395 = (state_101429[(7)]);
var inst_101399 = cljs.core.chunk_first(inst_101395);
var inst_101400 = cljs.core.chunk_rest(inst_101395);
var inst_101401 = cljs.core.count(inst_101399);
var inst_101381 = inst_101400;
var inst_101382 = inst_101399;
var inst_101383 = inst_101401;
var inst_101384 = (0);
var state_101429__$1 = (function (){var statearr_101448 = state_101429;
(statearr_101448[(9)] = inst_101382);

(statearr_101448[(10)] = inst_101383);

(statearr_101448[(11)] = inst_101381);

(statearr_101448[(12)] = inst_101384);

return statearr_101448;
})();
var statearr_101449_101479 = state_101429__$1;
(statearr_101449_101479[(2)] = null);

(statearr_101449_101479[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (3))){
var inst_101427 = (state_101429[(2)]);
var state_101429__$1 = state_101429;
return cljs.core.async.impl.ioc_helpers.return_chan(state_101429__$1,inst_101427);
} else {
if((state_val_101430 === (12))){
var inst_101415 = (state_101429[(2)]);
var state_101429__$1 = state_101429;
var statearr_101450_101480 = state_101429__$1;
(statearr_101450_101480[(2)] = inst_101415);

(statearr_101450_101480[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (2))){
var state_101429__$1 = state_101429;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_101429__$1,(4),in$);
} else {
if((state_val_101430 === (23))){
var inst_101423 = (state_101429[(2)]);
var state_101429__$1 = state_101429;
var statearr_101451_101481 = state_101429__$1;
(statearr_101451_101481[(2)] = inst_101423);

(statearr_101451_101481[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (19))){
var inst_101410 = (state_101429[(2)]);
var state_101429__$1 = state_101429;
var statearr_101452_101482 = state_101429__$1;
(statearr_101452_101482[(2)] = inst_101410);

(statearr_101452_101482[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (11))){
var inst_101395 = (state_101429[(7)]);
var inst_101381 = (state_101429[(11)]);
var inst_101395__$1 = cljs.core.seq(inst_101381);
var state_101429__$1 = (function (){var statearr_101453 = state_101429;
(statearr_101453[(7)] = inst_101395__$1);

return statearr_101453;
})();
if(inst_101395__$1){
var statearr_101454_101483 = state_101429__$1;
(statearr_101454_101483[(1)] = (14));

} else {
var statearr_101455_101484 = state_101429__$1;
(statearr_101455_101484[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (9))){
var inst_101417 = (state_101429[(2)]);
var inst_101418 = cljs.core.async.impl.protocols.closed_QMARK_(out);
var state_101429__$1 = (function (){var statearr_101456 = state_101429;
(statearr_101456[(15)] = inst_101417);

return statearr_101456;
})();
if(cljs.core.truth_(inst_101418)){
var statearr_101457_101485 = state_101429__$1;
(statearr_101457_101485[(1)] = (21));

} else {
var statearr_101458_101486 = state_101429__$1;
(statearr_101458_101486[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (5))){
var inst_101373 = cljs.core.async.close_BANG_(out);
var state_101429__$1 = state_101429;
var statearr_101459_101487 = state_101429__$1;
(statearr_101459_101487[(2)] = inst_101373);

(statearr_101459_101487[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (14))){
var inst_101395 = (state_101429[(7)]);
var inst_101397 = cljs.core.chunked_seq_QMARK_(inst_101395);
var state_101429__$1 = state_101429;
if(inst_101397){
var statearr_101460_101488 = state_101429__$1;
(statearr_101460_101488[(1)] = (17));

} else {
var statearr_101461_101489 = state_101429__$1;
(statearr_101461_101489[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (16))){
var inst_101413 = (state_101429[(2)]);
var state_101429__$1 = state_101429;
var statearr_101462_101490 = state_101429__$1;
(statearr_101462_101490[(2)] = inst_101413);

(statearr_101462_101490[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101430 === (10))){
var inst_101382 = (state_101429[(9)]);
var inst_101384 = (state_101429[(12)]);
var inst_101389 = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(inst_101382,inst_101384);
var state_101429__$1 = state_101429;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101429__$1,(13),out,inst_101389);
} else {
if((state_val_101430 === (18))){
var inst_101395 = (state_101429[(7)]);
var inst_101404 = cljs.core.first(inst_101395);
var state_101429__$1 = state_101429;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101429__$1,(20),out,inst_101404);
} else {
if((state_val_101430 === (8))){
var inst_101383 = (state_101429[(10)]);
var inst_101384 = (state_101429[(12)]);
var inst_101386 = (inst_101384 < inst_101383);
var inst_101387 = inst_101386;
var state_101429__$1 = state_101429;
if(cljs.core.truth_(inst_101387)){
var statearr_101463_101491 = state_101429__$1;
(statearr_101463_101491[(1)] = (10));

} else {
var statearr_101464_101492 = state_101429__$1;
(statearr_101464_101492[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__99703__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__99703__auto____0 = (function (){
var statearr_101465 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_101465[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__99703__auto__);

(statearr_101465[(1)] = (1));

return statearr_101465;
});
var cljs$core$async$mapcat_STAR__$_state_machine__99703__auto____1 = (function (state_101429){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_101429);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101466){if((e101466 instanceof Object)){
var ex__99706__auto__ = e101466;
var statearr_101467_101493 = state_101429;
(statearr_101467_101493[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_101429);

return cljs.core.cst$kw$recur;
} else {
throw e101466;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101494 = state_101429;
state_101429 = G__101494;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__99703__auto__ = function(state_101429){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__99703__auto____1.call(this,state_101429);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__99703__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__99703__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_101468 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101468[(6)] = c__99809__auto__);

return statearr_101468;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var G__101496 = arguments.length;
switch (G__101496) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3(f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var G__101499 = arguments.length;
switch (G__101499) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3(f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
cljs.core.async.mapcat_STAR_(f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var G__101502 = arguments.length;
switch (G__101502) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2(ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__99809__auto___101549 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___101549,out){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___101549,out){
return (function (state_101526){
var state_val_101527 = (state_101526[(1)]);
if((state_val_101527 === (7))){
var inst_101521 = (state_101526[(2)]);
var state_101526__$1 = state_101526;
var statearr_101528_101550 = state_101526__$1;
(statearr_101528_101550[(2)] = inst_101521);

(statearr_101528_101550[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101527 === (1))){
var inst_101503 = null;
var state_101526__$1 = (function (){var statearr_101529 = state_101526;
(statearr_101529[(7)] = inst_101503);

return statearr_101529;
})();
var statearr_101530_101551 = state_101526__$1;
(statearr_101530_101551[(2)] = null);

(statearr_101530_101551[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101527 === (4))){
var inst_101506 = (state_101526[(8)]);
var inst_101506__$1 = (state_101526[(2)]);
var inst_101507 = (inst_101506__$1 == null);
var inst_101508 = cljs.core.not(inst_101507);
var state_101526__$1 = (function (){var statearr_101531 = state_101526;
(statearr_101531[(8)] = inst_101506__$1);

return statearr_101531;
})();
if(inst_101508){
var statearr_101532_101552 = state_101526__$1;
(statearr_101532_101552[(1)] = (5));

} else {
var statearr_101533_101553 = state_101526__$1;
(statearr_101533_101553[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101527 === (6))){
var state_101526__$1 = state_101526;
var statearr_101534_101554 = state_101526__$1;
(statearr_101534_101554[(2)] = null);

(statearr_101534_101554[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101527 === (3))){
var inst_101523 = (state_101526[(2)]);
var inst_101524 = cljs.core.async.close_BANG_(out);
var state_101526__$1 = (function (){var statearr_101535 = state_101526;
(statearr_101535[(9)] = inst_101523);

return statearr_101535;
})();
return cljs.core.async.impl.ioc_helpers.return_chan(state_101526__$1,inst_101524);
} else {
if((state_val_101527 === (2))){
var state_101526__$1 = state_101526;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_101526__$1,(4),ch);
} else {
if((state_val_101527 === (11))){
var inst_101506 = (state_101526[(8)]);
var inst_101515 = (state_101526[(2)]);
var inst_101503 = inst_101506;
var state_101526__$1 = (function (){var statearr_101536 = state_101526;
(statearr_101536[(7)] = inst_101503);

(statearr_101536[(10)] = inst_101515);

return statearr_101536;
})();
var statearr_101537_101555 = state_101526__$1;
(statearr_101537_101555[(2)] = null);

(statearr_101537_101555[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101527 === (9))){
var inst_101506 = (state_101526[(8)]);
var state_101526__$1 = state_101526;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101526__$1,(11),out,inst_101506);
} else {
if((state_val_101527 === (5))){
var inst_101503 = (state_101526[(7)]);
var inst_101506 = (state_101526[(8)]);
var inst_101510 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_101506,inst_101503);
var state_101526__$1 = state_101526;
if(inst_101510){
var statearr_101539_101556 = state_101526__$1;
(statearr_101539_101556[(1)] = (8));

} else {
var statearr_101540_101557 = state_101526__$1;
(statearr_101540_101557[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101527 === (10))){
var inst_101518 = (state_101526[(2)]);
var state_101526__$1 = state_101526;
var statearr_101541_101558 = state_101526__$1;
(statearr_101541_101558[(2)] = inst_101518);

(statearr_101541_101558[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101527 === (8))){
var inst_101503 = (state_101526[(7)]);
var tmp101538 = inst_101503;
var inst_101503__$1 = tmp101538;
var state_101526__$1 = (function (){var statearr_101542 = state_101526;
(statearr_101542[(7)] = inst_101503__$1);

return statearr_101542;
})();
var statearr_101543_101559 = state_101526__$1;
(statearr_101543_101559[(2)] = null);

(statearr_101543_101559[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___101549,out))
;
return ((function (switch__99702__auto__,c__99809__auto___101549,out){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_101544 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_101544[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_101544[(1)] = (1));

return statearr_101544;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_101526){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_101526);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101545){if((e101545 instanceof Object)){
var ex__99706__auto__ = e101545;
var statearr_101546_101560 = state_101526;
(statearr_101546_101560[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_101526);

return cljs.core.cst$kw$recur;
} else {
throw e101545;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101561 = state_101526;
state_101526 = G__101561;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_101526){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_101526);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___101549,out))
})();
var state__99811__auto__ = (function (){var statearr_101547 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101547[(6)] = c__99809__auto___101549);

return statearr_101547;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___101549,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var G__101563 = arguments.length;
switch (G__101563) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3(n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__99809__auto___101629 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___101629,out){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___101629,out){
return (function (state_101601){
var state_val_101602 = (state_101601[(1)]);
if((state_val_101602 === (7))){
var inst_101597 = (state_101601[(2)]);
var state_101601__$1 = state_101601;
var statearr_101603_101630 = state_101601__$1;
(statearr_101603_101630[(2)] = inst_101597);

(statearr_101603_101630[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101602 === (1))){
var inst_101564 = (new Array(n));
var inst_101565 = inst_101564;
var inst_101566 = (0);
var state_101601__$1 = (function (){var statearr_101604 = state_101601;
(statearr_101604[(7)] = inst_101566);

(statearr_101604[(8)] = inst_101565);

return statearr_101604;
})();
var statearr_101605_101631 = state_101601__$1;
(statearr_101605_101631[(2)] = null);

(statearr_101605_101631[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101602 === (4))){
var inst_101569 = (state_101601[(9)]);
var inst_101569__$1 = (state_101601[(2)]);
var inst_101570 = (inst_101569__$1 == null);
var inst_101571 = cljs.core.not(inst_101570);
var state_101601__$1 = (function (){var statearr_101606 = state_101601;
(statearr_101606[(9)] = inst_101569__$1);

return statearr_101606;
})();
if(inst_101571){
var statearr_101607_101632 = state_101601__$1;
(statearr_101607_101632[(1)] = (5));

} else {
var statearr_101608_101633 = state_101601__$1;
(statearr_101608_101633[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101602 === (15))){
var inst_101591 = (state_101601[(2)]);
var state_101601__$1 = state_101601;
var statearr_101609_101634 = state_101601__$1;
(statearr_101609_101634[(2)] = inst_101591);

(statearr_101609_101634[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101602 === (13))){
var state_101601__$1 = state_101601;
var statearr_101610_101635 = state_101601__$1;
(statearr_101610_101635[(2)] = null);

(statearr_101610_101635[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101602 === (6))){
var inst_101566 = (state_101601[(7)]);
var inst_101587 = (inst_101566 > (0));
var state_101601__$1 = state_101601;
if(cljs.core.truth_(inst_101587)){
var statearr_101611_101636 = state_101601__$1;
(statearr_101611_101636[(1)] = (12));

} else {
var statearr_101612_101637 = state_101601__$1;
(statearr_101612_101637[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101602 === (3))){
var inst_101599 = (state_101601[(2)]);
var state_101601__$1 = state_101601;
return cljs.core.async.impl.ioc_helpers.return_chan(state_101601__$1,inst_101599);
} else {
if((state_val_101602 === (12))){
var inst_101565 = (state_101601[(8)]);
var inst_101589 = cljs.core.vec(inst_101565);
var state_101601__$1 = state_101601;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101601__$1,(15),out,inst_101589);
} else {
if((state_val_101602 === (2))){
var state_101601__$1 = state_101601;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_101601__$1,(4),ch);
} else {
if((state_val_101602 === (11))){
var inst_101581 = (state_101601[(2)]);
var inst_101582 = (new Array(n));
var inst_101565 = inst_101582;
var inst_101566 = (0);
var state_101601__$1 = (function (){var statearr_101613 = state_101601;
(statearr_101613[(7)] = inst_101566);

(statearr_101613[(8)] = inst_101565);

(statearr_101613[(10)] = inst_101581);

return statearr_101613;
})();
var statearr_101614_101638 = state_101601__$1;
(statearr_101614_101638[(2)] = null);

(statearr_101614_101638[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101602 === (9))){
var inst_101565 = (state_101601[(8)]);
var inst_101579 = cljs.core.vec(inst_101565);
var state_101601__$1 = state_101601;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101601__$1,(11),out,inst_101579);
} else {
if((state_val_101602 === (5))){
var inst_101566 = (state_101601[(7)]);
var inst_101574 = (state_101601[(11)]);
var inst_101565 = (state_101601[(8)]);
var inst_101569 = (state_101601[(9)]);
var inst_101573 = (inst_101565[inst_101566] = inst_101569);
var inst_101574__$1 = (inst_101566 + (1));
var inst_101575 = (inst_101574__$1 < n);
var state_101601__$1 = (function (){var statearr_101615 = state_101601;
(statearr_101615[(11)] = inst_101574__$1);

(statearr_101615[(12)] = inst_101573);

return statearr_101615;
})();
if(cljs.core.truth_(inst_101575)){
var statearr_101616_101639 = state_101601__$1;
(statearr_101616_101639[(1)] = (8));

} else {
var statearr_101617_101640 = state_101601__$1;
(statearr_101617_101640[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101602 === (14))){
var inst_101594 = (state_101601[(2)]);
var inst_101595 = cljs.core.async.close_BANG_(out);
var state_101601__$1 = (function (){var statearr_101619 = state_101601;
(statearr_101619[(13)] = inst_101594);

return statearr_101619;
})();
var statearr_101620_101641 = state_101601__$1;
(statearr_101620_101641[(2)] = inst_101595);

(statearr_101620_101641[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101602 === (10))){
var inst_101585 = (state_101601[(2)]);
var state_101601__$1 = state_101601;
var statearr_101621_101642 = state_101601__$1;
(statearr_101621_101642[(2)] = inst_101585);

(statearr_101621_101642[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101602 === (8))){
var inst_101574 = (state_101601[(11)]);
var inst_101565 = (state_101601[(8)]);
var tmp101618 = inst_101565;
var inst_101565__$1 = tmp101618;
var inst_101566 = inst_101574;
var state_101601__$1 = (function (){var statearr_101622 = state_101601;
(statearr_101622[(7)] = inst_101566);

(statearr_101622[(8)] = inst_101565__$1);

return statearr_101622;
})();
var statearr_101623_101643 = state_101601__$1;
(statearr_101623_101643[(2)] = null);

(statearr_101623_101643[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___101629,out))
;
return ((function (switch__99702__auto__,c__99809__auto___101629,out){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_101624 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_101624[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_101624[(1)] = (1));

return statearr_101624;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_101601){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_101601);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101625){if((e101625 instanceof Object)){
var ex__99706__auto__ = e101625;
var statearr_101626_101644 = state_101601;
(statearr_101626_101644[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_101601);

return cljs.core.cst$kw$recur;
} else {
throw e101625;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101645 = state_101601;
state_101601 = G__101645;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_101601){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_101601);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___101629,out))
})();
var state__99811__auto__ = (function (){var statearr_101627 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101627[(6)] = c__99809__auto___101629);

return statearr_101627;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___101629,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var G__101647 = arguments.length;
switch (G__101647) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3(f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1(buf_or_n);
var c__99809__auto___101717 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___101717,out){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___101717,out){
return (function (state_101689){
var state_val_101690 = (state_101689[(1)]);
if((state_val_101690 === (7))){
var inst_101685 = (state_101689[(2)]);
var state_101689__$1 = state_101689;
var statearr_101691_101718 = state_101689__$1;
(statearr_101691_101718[(2)] = inst_101685);

(statearr_101691_101718[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101690 === (1))){
var inst_101648 = [];
var inst_101649 = inst_101648;
var inst_101650 = cljs.core.cst$kw$cljs$core$async_SLASH_nothing;
var state_101689__$1 = (function (){var statearr_101692 = state_101689;
(statearr_101692[(7)] = inst_101649);

(statearr_101692[(8)] = inst_101650);

return statearr_101692;
})();
var statearr_101693_101719 = state_101689__$1;
(statearr_101693_101719[(2)] = null);

(statearr_101693_101719[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101690 === (4))){
var inst_101653 = (state_101689[(9)]);
var inst_101653__$1 = (state_101689[(2)]);
var inst_101654 = (inst_101653__$1 == null);
var inst_101655 = cljs.core.not(inst_101654);
var state_101689__$1 = (function (){var statearr_101694 = state_101689;
(statearr_101694[(9)] = inst_101653__$1);

return statearr_101694;
})();
if(inst_101655){
var statearr_101695_101720 = state_101689__$1;
(statearr_101695_101720[(1)] = (5));

} else {
var statearr_101696_101721 = state_101689__$1;
(statearr_101696_101721[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101690 === (15))){
var inst_101679 = (state_101689[(2)]);
var state_101689__$1 = state_101689;
var statearr_101697_101722 = state_101689__$1;
(statearr_101697_101722[(2)] = inst_101679);

(statearr_101697_101722[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101690 === (13))){
var state_101689__$1 = state_101689;
var statearr_101698_101723 = state_101689__$1;
(statearr_101698_101723[(2)] = null);

(statearr_101698_101723[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101690 === (6))){
var inst_101649 = (state_101689[(7)]);
var inst_101674 = inst_101649.length;
var inst_101675 = (inst_101674 > (0));
var state_101689__$1 = state_101689;
if(cljs.core.truth_(inst_101675)){
var statearr_101699_101724 = state_101689__$1;
(statearr_101699_101724[(1)] = (12));

} else {
var statearr_101700_101725 = state_101689__$1;
(statearr_101700_101725[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101690 === (3))){
var inst_101687 = (state_101689[(2)]);
var state_101689__$1 = state_101689;
return cljs.core.async.impl.ioc_helpers.return_chan(state_101689__$1,inst_101687);
} else {
if((state_val_101690 === (12))){
var inst_101649 = (state_101689[(7)]);
var inst_101677 = cljs.core.vec(inst_101649);
var state_101689__$1 = state_101689;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101689__$1,(15),out,inst_101677);
} else {
if((state_val_101690 === (2))){
var state_101689__$1 = state_101689;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_101689__$1,(4),ch);
} else {
if((state_val_101690 === (11))){
var inst_101657 = (state_101689[(10)]);
var inst_101653 = (state_101689[(9)]);
var inst_101667 = (state_101689[(2)]);
var inst_101668 = [];
var inst_101669 = inst_101668.push(inst_101653);
var inst_101649 = inst_101668;
var inst_101650 = inst_101657;
var state_101689__$1 = (function (){var statearr_101701 = state_101689;
(statearr_101701[(7)] = inst_101649);

(statearr_101701[(11)] = inst_101669);

(statearr_101701[(12)] = inst_101667);

(statearr_101701[(8)] = inst_101650);

return statearr_101701;
})();
var statearr_101702_101726 = state_101689__$1;
(statearr_101702_101726[(2)] = null);

(statearr_101702_101726[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101690 === (9))){
var inst_101649 = (state_101689[(7)]);
var inst_101665 = cljs.core.vec(inst_101649);
var state_101689__$1 = state_101689;
return cljs.core.async.impl.ioc_helpers.put_BANG_(state_101689__$1,(11),out,inst_101665);
} else {
if((state_val_101690 === (5))){
var inst_101657 = (state_101689[(10)]);
var inst_101653 = (state_101689[(9)]);
var inst_101650 = (state_101689[(8)]);
var inst_101657__$1 = (f.cljs$core$IFn$_invoke$arity$1 ? f.cljs$core$IFn$_invoke$arity$1(inst_101653) : f.call(null,inst_101653));
var inst_101658 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_101657__$1,inst_101650);
var inst_101659 = cljs.core.keyword_identical_QMARK_(inst_101650,cljs.core.cst$kw$cljs$core$async_SLASH_nothing);
var inst_101660 = ((inst_101658) || (inst_101659));
var state_101689__$1 = (function (){var statearr_101703 = state_101689;
(statearr_101703[(10)] = inst_101657__$1);

return statearr_101703;
})();
if(cljs.core.truth_(inst_101660)){
var statearr_101704_101727 = state_101689__$1;
(statearr_101704_101727[(1)] = (8));

} else {
var statearr_101705_101728 = state_101689__$1;
(statearr_101705_101728[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_101690 === (14))){
var inst_101682 = (state_101689[(2)]);
var inst_101683 = cljs.core.async.close_BANG_(out);
var state_101689__$1 = (function (){var statearr_101707 = state_101689;
(statearr_101707[(13)] = inst_101682);

return statearr_101707;
})();
var statearr_101708_101729 = state_101689__$1;
(statearr_101708_101729[(2)] = inst_101683);

(statearr_101708_101729[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101690 === (10))){
var inst_101672 = (state_101689[(2)]);
var state_101689__$1 = state_101689;
var statearr_101709_101730 = state_101689__$1;
(statearr_101709_101730[(2)] = inst_101672);

(statearr_101709_101730[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_101690 === (8))){
var inst_101657 = (state_101689[(10)]);
var inst_101649 = (state_101689[(7)]);
var inst_101653 = (state_101689[(9)]);
var inst_101662 = inst_101649.push(inst_101653);
var tmp101706 = inst_101649;
var inst_101649__$1 = tmp101706;
var inst_101650 = inst_101657;
var state_101689__$1 = (function (){var statearr_101710 = state_101689;
(statearr_101710[(7)] = inst_101649__$1);

(statearr_101710[(14)] = inst_101662);

(statearr_101710[(8)] = inst_101650);

return statearr_101710;
})();
var statearr_101711_101731 = state_101689__$1;
(statearr_101711_101731[(2)] = null);

(statearr_101711_101731[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___101717,out))
;
return ((function (switch__99702__auto__,c__99809__auto___101717,out){
return (function() {
var cljs$core$async$state_machine__99703__auto__ = null;
var cljs$core$async$state_machine__99703__auto____0 = (function (){
var statearr_101712 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_101712[(0)] = cljs$core$async$state_machine__99703__auto__);

(statearr_101712[(1)] = (1));

return statearr_101712;
});
var cljs$core$async$state_machine__99703__auto____1 = (function (state_101689){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_101689);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e101713){if((e101713 instanceof Object)){
var ex__99706__auto__ = e101713;
var statearr_101714_101732 = state_101689;
(statearr_101714_101732[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_101689);

return cljs.core.cst$kw$recur;
} else {
throw e101713;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__101733 = state_101689;
state_101689 = G__101733;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
cljs$core$async$state_machine__99703__auto__ = function(state_101689){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__99703__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__99703__auto____1.call(this,state_101689);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__99703__auto____0;
cljs$core$async$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__99703__auto____1;
return cljs$core$async$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___101717,out))
})();
var state__99811__auto__ = (function (){var statearr_101715 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_101715[(6)] = c__99809__auto___101717);

return statearr_101715;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___101717,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;

