// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.graphdb');
goog.require('cljs.core');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.storage.core');
goog.require('fluree.db.util.core');
goog.require('fluree.db.query.schema');
goog.require('fluree.db.util.schema');
goog.require('clojure.data.avl');
goog.require('fluree.db.query.fql');
goog.require('fluree.db.index');
goog.require('fluree.db.query.range');
goog.require('fluree.db.constants');
goog.require('fluree.db.flake');
goog.require('fluree.db.util.async');
goog.require('cljs.core.async');
goog.require('fluree.db.util.log');
goog.require('clojure.string');
/**
 * Returns when ledger name is valid.
 *   Otherwise throws.
 */
fluree.db.graphdb.validate_ledger_name = (function fluree$db$graphdb$validate_ledger_name(ledger_id,type){
if(cljs.core.truth_(cljs.core.re_matches.call(null,/^[a-z0-9-]{1,100}/,ledger_id))){
return null;
} else {
throw cljs.core.ex_info.call(null,["Invalid ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(type)," id: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),". Must match a-z0-9- and be no more than 100 characters long."].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-db","db/invalid-db",1792041482)], null));
}
});
/**
 * Returns two-tuple of [network name-or-dbid] if db-ident is valid.
 * 
 *   Will ignore a direct db name reference (prefixed with '_')
 *   Otherwise throws.
 */
fluree.db.graphdb.validate_ledger_ident = (function fluree$db$graphdb$validate_ledger_ident(ledger){
var vec__100707 = cljs.core.re_find.call(null,/^([^\/]+)\/(?:_)?([^\/]+)$/,fluree.db.util.core.keyword__GT_str.call(null,ledger));
var _ = cljs.core.nth.call(null,vec__100707,(0),null);
var network = cljs.core.nth.call(null,vec__100707,(1),null);
var maybe_alias = cljs.core.nth.call(null,vec__100707,(2),null);
if(cljs.core.truth_((function (){var and__4120__auto__ = network;
if(cljs.core.truth_(and__4120__auto__)){
return maybe_alias;
} else {
return and__4120__auto__;
}
})())){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,maybe_alias], null);
} else {
throw cljs.core.ex_info.call(null,["Invalid ledger identity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-ledger-name","db/invalid-ledger-name",-1642293447)], null));
}
});
fluree.db.graphdb.exclude_predicates = cljs.core.PersistentHashSet.createAsIfByAssoc([(107),(108),(106)]);
fluree.db.graphdb.add_predicate_to_idx = (function fluree$db$graphdb$add_predicate_to_idx(db,pred_id){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_100801){
var state_val_100802 = (state_100801[(1)]);
if((state_val_100802 === (7))){
var state_100801__$1 = state_100801;
var statearr_100803_100842 = state_100801__$1;
(statearr_100803_100842[(2)] = false);

(statearr_100803_100842[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (20))){
var inst_100765 = (state_100801[(2)]);
var state_100801__$1 = state_100801;
var statearr_100804_100843 = state_100801__$1;
(statearr_100804_100843[(2)] = inst_100765);

(statearr_100804_100843[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (1))){
var state_100801__$1 = state_100801;
var statearr_100805_100844 = state_100801__$1;
(statearr_100805_100844[(2)] = null);

(statearr_100805_100844[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (24))){
var inst_100778 = ["You cannot add ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(pred_id)," to the index at this point. There are too many affected flakes."].join('');
var inst_100779 = [new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"status","status",-1997798413)];
var inst_100780 = [new cljs.core.Keyword("db","max-novelty-size","db/max-novelty-size",499694493),(400)];
var inst_100781 = cljs.core.PersistentHashMap.fromArrays(inst_100779,inst_100780);
var inst_100782 = cljs.core.ex_info.call(null,inst_100778,inst_100781);
var inst_100783 = (function(){throw inst_100782})();
var state_100801__$1 = state_100801;
var statearr_100806_100845 = state_100801__$1;
(statearr_100806_100845[(2)] = inst_100783);

(statearr_100806_100845[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_100801,(3),Error,null,(2));
var inst_100716 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100717 = [pred_id];
var inst_100718 = (new cljs.core.PersistentVector(null,1,(5),inst_100716,inst_100717,null));
var inst_100719 = fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"psot","psot",2111653059),cljs.core._EQ_,inst_100718);
var state_100801__$1 = state_100801;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_100801__$1,(5),inst_100719);
} else {
if((state_val_100802 === (15))){
var inst_100752 = (state_100801[(7)]);
var inst_100757 = inst_100752.cljs$lang$protocol_mask$partition0$;
var inst_100758 = (inst_100757 & (64));
var inst_100759 = inst_100752.cljs$core$ISeq$;
var inst_100760 = (cljs.core.PROTOCOL_SENTINEL === inst_100759);
var inst_100761 = ((inst_100758) || (inst_100760));
var state_100801__$1 = state_100801;
if(cljs.core.truth_(inst_100761)){
var statearr_100807_100846 = state_100801__$1;
(statearr_100807_100846[(1)] = (18));

} else {
var statearr_100808_100847 = state_100801__$1;
(statearr_100808_100847[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (21))){
var inst_100752 = (state_100801[(7)]);
var inst_100770 = cljs.core.apply.call(null,cljs.core.hash_map,inst_100752);
var state_100801__$1 = state_100801;
var statearr_100809_100848 = state_100801__$1;
(statearr_100809_100848[(2)] = inst_100770);

(statearr_100809_100848[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (13))){
var inst_100723 = (state_100801[(8)]);
var state_100801__$1 = state_100801;
var statearr_100810_100849 = state_100801__$1;
(statearr_100810_100849[(2)] = inst_100723);

(statearr_100810_100849[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (22))){
var inst_100752 = (state_100801[(7)]);
var state_100801__$1 = state_100801;
var statearr_100811_100850 = state_100801__$1;
(statearr_100811_100850[(2)] = inst_100752);

(statearr_100811_100850[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (6))){
var inst_100723 = (state_100801[(8)]);
var inst_100728 = inst_100723.cljs$lang$protocol_mask$partition0$;
var inst_100729 = (inst_100728 & (64));
var inst_100730 = inst_100723.cljs$core$ISeq$;
var inst_100731 = (cljs.core.PROTOCOL_SENTINEL === inst_100730);
var inst_100732 = ((inst_100729) || (inst_100731));
var state_100801__$1 = state_100801;
if(cljs.core.truth_(inst_100732)){
var statearr_100812_100851 = state_100801__$1;
(statearr_100812_100851[(1)] = (9));

} else {
var statearr_100813_100852 = state_100801__$1;
(statearr_100813_100852[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (25))){
var state_100801__$1 = state_100801;
var statearr_100814_100853 = state_100801__$1;
(statearr_100814_100853[(2)] = null);

(statearr_100814_100853[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (17))){
var inst_100768 = (state_100801[(2)]);
var state_100801__$1 = state_100801;
if(cljs.core.truth_(inst_100768)){
var statearr_100815_100854 = state_100801__$1;
(statearr_100815_100854[(1)] = (21));

} else {
var statearr_100816_100855 = state_100801__$1;
(statearr_100816_100855[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (3))){
var inst_100710 = (state_100801[(2)]);
var state_100801__$1 = state_100801;
var statearr_100817_100856 = state_100801__$1;
(statearr_100817_100856[(2)] = inst_100710);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_100801__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (12))){
var inst_100723 = (state_100801[(8)]);
var inst_100741 = cljs.core.apply.call(null,cljs.core.hash_map,inst_100723);
var state_100801__$1 = state_100801;
var statearr_100818_100857 = state_100801__$1;
(statearr_100818_100857[(2)] = inst_100741);

(statearr_100818_100857[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (2))){
var inst_100799 = (state_100801[(2)]);
var state_100801__$1 = state_100801;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_100801__$1,inst_100799);
} else {
if((state_val_100802 === (23))){
var inst_100748 = (state_100801[(9)]);
var inst_100773 = (state_100801[(2)]);
var inst_100774 = cljs.core.get.call(null,inst_100773,new cljs.core.Keyword(null,"novelty-min","novelty-min",556791300));
var inst_100775 = cljs.core.get.call(null,inst_100773,new cljs.core.Keyword(null,"novelty-max","novelty-max",1816916050));
var inst_100776 = (inst_100748 > inst_100775);
var state_100801__$1 = (function (){var statearr_100819 = state_100801;
(statearr_100819[(10)] = inst_100774);

return statearr_100819;
})();
if(cljs.core.truth_(inst_100776)){
var statearr_100820_100858 = state_100801__$1;
(statearr_100820_100858[(1)] = (24));

} else {
var statearr_100821_100859 = state_100801__$1;
(statearr_100821_100859[(1)] = (25));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (19))){
var state_100801__$1 = state_100801;
var statearr_100822_100860 = state_100801__$1;
(statearr_100822_100860[(2)] = false);

(statearr_100822_100860[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (11))){
var inst_100736 = (state_100801[(2)]);
var state_100801__$1 = state_100801;
var statearr_100823_100861 = state_100801__$1;
(statearr_100823_100861[(2)] = inst_100736);

(statearr_100823_100861[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (9))){
var state_100801__$1 = state_100801;
var statearr_100824_100862 = state_100801__$1;
(statearr_100824_100862[(2)] = true);

(statearr_100824_100862[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (5))){
var inst_100723 = (state_100801[(8)]);
var inst_100721 = (state_100801[(2)]);
var inst_100722 = fluree.db.util.async.throw_err.call(null,inst_100721);
var inst_100723__$1 = new cljs.core.Keyword(null,"novelty","novelty",-1590246024).cljs$core$IFn$_invoke$arity$1(db);
var inst_100725 = (inst_100723__$1 == null);
var inst_100726 = cljs.core.not.call(null,inst_100725);
var state_100801__$1 = (function (){var statearr_100825 = state_100801;
(statearr_100825[(11)] = inst_100722);

(statearr_100825[(8)] = inst_100723__$1);

return statearr_100825;
})();
if(inst_100726){
var statearr_100826_100863 = state_100801__$1;
(statearr_100826_100863[(1)] = (6));

} else {
var statearr_100827_100864 = state_100801__$1;
(statearr_100827_100864[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (14))){
var inst_100722 = (state_100801[(11)]);
var inst_100752 = (state_100801[(7)]);
var inst_100744 = (state_100801[(2)]);
var inst_100745 = cljs.core.get.call(null,inst_100744,new cljs.core.Keyword(null,"post","post",269697687));
var inst_100746 = cljs.core.get.call(null,inst_100744,new cljs.core.Keyword(null,"size","size",1098693007));
var inst_100747 = fluree.db.flake.size_bytes.call(null,inst_100722);
var inst_100748 = (inst_100746 + inst_100747);
var inst_100749 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100750 = [new cljs.core.Keyword(null,"conn","conn",278309663),new cljs.core.Keyword(null,"meta","meta",1499536964)];
var inst_100751 = (new cljs.core.PersistentVector(null,2,(5),inst_100749,inst_100750,null));
var inst_100752__$1 = cljs.core.get_in.call(null,db,inst_100751);
var inst_100754 = (inst_100752__$1 == null);
var inst_100755 = cljs.core.not.call(null,inst_100754);
var state_100801__$1 = (function (){var statearr_100828 = state_100801;
(statearr_100828[(12)] = inst_100745);

(statearr_100828[(9)] = inst_100748);

(statearr_100828[(7)] = inst_100752__$1);

return statearr_100828;
})();
if(inst_100755){
var statearr_100829_100865 = state_100801__$1;
(statearr_100829_100865[(1)] = (15));

} else {
var statearr_100830_100866 = state_100801__$1;
(statearr_100830_100866[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (26))){
var inst_100745 = (state_100801[(12)]);
var inst_100722 = (state_100801[(11)]);
var inst_100748 = (state_100801[(9)]);
var inst_100786 = (state_100801[(2)]);
var inst_100787 = cljs.core.into.call(null,inst_100745,inst_100722);
var inst_100788 = new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225).cljs$core$IFn$_invoke$arity$1(db);
var inst_100789 = cljs.core.swap_BANG_.call(null,inst_100788,cljs.core.empty);
var inst_100790 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100791 = [new cljs.core.Keyword(null,"novelty","novelty",-1590246024),new cljs.core.Keyword(null,"post","post",269697687)];
var inst_100792 = (new cljs.core.PersistentVector(null,2,(5),inst_100790,inst_100791,null));
var inst_100793 = cljs.core.assoc_in.call(null,db,inst_100792,inst_100787);
var inst_100794 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100795 = [new cljs.core.Keyword(null,"novelty","novelty",-1590246024),new cljs.core.Keyword(null,"size","size",1098693007)];
var inst_100796 = (new cljs.core.PersistentVector(null,2,(5),inst_100794,inst_100795,null));
var inst_100797 = cljs.core.assoc_in.call(null,inst_100793,inst_100796,inst_100748);
var state_100801__$1 = (function (){var statearr_100831 = state_100801;
(statearr_100831[(13)] = inst_100789);

(statearr_100831[(14)] = inst_100786);

return statearr_100831;
})();
var statearr_100832_100867 = state_100801__$1;
(statearr_100832_100867[(2)] = inst_100797);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_100801__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (16))){
var state_100801__$1 = state_100801;
var statearr_100833_100868 = state_100801__$1;
(statearr_100833_100868[(2)] = false);

(statearr_100833_100868[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (10))){
var state_100801__$1 = state_100801;
var statearr_100834_100869 = state_100801__$1;
(statearr_100834_100869[(2)] = false);

(statearr_100834_100869[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (18))){
var state_100801__$1 = state_100801;
var statearr_100835_100870 = state_100801__$1;
(statearr_100835_100870[(2)] = true);

(statearr_100835_100870[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_100802 === (8))){
var inst_100739 = (state_100801[(2)]);
var state_100801__$1 = state_100801;
if(cljs.core.truth_(inst_100739)){
var statearr_100836_100871 = state_100801__$1;
(statearr_100836_100871[(1)] = (12));

} else {
var statearr_100837_100872 = state_100801__$1;
(statearr_100837_100872[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto__ = null;
var fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto____0 = (function (){
var statearr_100838 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_100838[(0)] = fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto__);

(statearr_100838[(1)] = (1));

return statearr_100838;
});
var fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto____1 = (function (state_100801){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_100801);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e100839){if((e100839 instanceof Object)){
var ex__86628__auto__ = e100839;
var statearr_100840_100873 = state_100801;
(statearr_100840_100873[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_100801);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e100839;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__100874 = state_100801;
state_100801 = G__100874;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto__ = function(state_100801){
switch(arguments.length){
case 0:
return fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto____1.call(this,state_100801);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto____0;
fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto____1;
return fluree$db$graphdb$add_predicate_to_idx_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_100841 = f__86676__auto__.call(null);
(statearr_100841[(6)] = c__86675__auto__);

return statearr_100841;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Processes a single transaction, adding it to the DB.
 *   Assumes flakes are already properly sorted.
 */
fluree.db.graphdb.with_t = (function fluree$db$graphdb$with_t(db,flakes){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_101069){
var state_val_101070 = (state_101069[(1)]);
if((state_val_101070 === (7))){
var inst_100908 = (state_101069[(7)]);
var inst_100900 = (state_101069[(8)]);
var inst_100883 = (state_101069[(9)]);
var inst_100898 = (state_101069[(10)]);
var inst_100914 = (state_101069[(11)]);
var inst_100904 = (state_101069[(12)]);
var inst_100898__$1 = (state_101069[(2)]);
var inst_100899 = (function (){var t = inst_100883;
var _ = inst_100898__$1;
return ((function (t,_,inst_100908,inst_100900,inst_100883,inst_100898,inst_100914,inst_100904,inst_100898__$1,state_val_101070,c__86675__auto__){
return (function (p1__100875_SHARP_){
return cljs.core.not.call(null,fluree.db.graphdb.exclude_predicates.call(null,p1__100875_SHARP_.p));
});
;})(t,_,inst_100908,inst_100900,inst_100883,inst_100898,inst_100914,inst_100904,inst_100898__$1,state_val_101070,c__86675__auto__))
})();
var inst_100900__$1 = cljs.core.filter.call(null,inst_100899,flakes);
var inst_100901 = cljs.core.PersistentHashSet.EMPTY;
var inst_100902 = (function (){var t = inst_100883;
var _ = inst_100898__$1;
var add_flakes = inst_100900__$1;
return ((function (t,_,add_flakes,inst_100908,inst_100900,inst_100883,inst_100898,inst_100914,inst_100904,inst_100898__$1,inst_100899,inst_100900__$1,inst_100901,state_val_101070,c__86675__auto__){
return (function (p1__100876_SHARP_){
return p1__100876_SHARP_.p;
});
;})(t,_,add_flakes,inst_100908,inst_100900,inst_100883,inst_100898,inst_100914,inst_100904,inst_100898__$1,inst_100899,inst_100900__$1,inst_100901,state_val_101070,c__86675__auto__))
})();
var inst_100903 = cljs.core.map.call(null,inst_100902,inst_100900__$1);
var inst_100904__$1 = cljs.core.into.call(null,inst_100901,inst_100903);
var inst_100905 = cljs.core.PersistentHashMap.EMPTY;
var inst_100906 = (function (){var t = inst_100883;
var _ = inst_100898__$1;
var add_flakes = inst_100900__$1;
var add_preds = inst_100904__$1;
return ((function (t,_,add_flakes,add_preds,inst_100908,inst_100900,inst_100883,inst_100898,inst_100914,inst_100904,inst_100898__$1,inst_100899,inst_100900__$1,inst_100901,inst_100902,inst_100903,inst_100904__$1,inst_100905,state_val_101070,c__86675__auto__){
return (function (p){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p,fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"idx?","idx?",-564590377),p)], null);
});
;})(t,_,add_flakes,add_preds,inst_100908,inst_100900,inst_100883,inst_100898,inst_100914,inst_100904,inst_100898__$1,inst_100899,inst_100900__$1,inst_100901,inst_100902,inst_100903,inst_100904__$1,inst_100905,state_val_101070,c__86675__auto__))
})();
var inst_100907 = cljs.core.map.call(null,inst_100906,inst_100904__$1);
var inst_100908__$1 = cljs.core.into.call(null,inst_100905,inst_100907);
var inst_100909 = cljs.core.PersistentHashMap.EMPTY;
var inst_100910 = (function (){var t = inst_100883;
var _ = inst_100898__$1;
var add_flakes = inst_100900__$1;
var add_preds = inst_100904__$1;
var idx_QMARK__map = inst_100908__$1;
return ((function (t,_,add_flakes,add_preds,idx_QMARK__map,inst_100908,inst_100900,inst_100883,inst_100898,inst_100914,inst_100904,inst_100898__$1,inst_100899,inst_100900__$1,inst_100901,inst_100902,inst_100903,inst_100904__$1,inst_100905,inst_100906,inst_100907,inst_100908__$1,inst_100909,state_val_101070,c__86675__auto__){
return (function (p){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p,fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"ref?","ref?",1932693720),p)], null);
});
;})(t,_,add_flakes,add_preds,idx_QMARK__map,inst_100908,inst_100900,inst_100883,inst_100898,inst_100914,inst_100904,inst_100898__$1,inst_100899,inst_100900__$1,inst_100901,inst_100902,inst_100903,inst_100904__$1,inst_100905,inst_100906,inst_100907,inst_100908__$1,inst_100909,state_val_101070,c__86675__auto__))
})();
var inst_100911 = cljs.core.map.call(null,inst_100910,inst_100904__$1);
var inst_100912 = cljs.core.into.call(null,inst_100909,inst_100911);
var inst_100913 = fluree.db.flake.size_bytes.call(null,inst_100900__$1);
var inst_100914__$1 = fluree.db.util.schema.schema_change_QMARK_.call(null,inst_100900__$1);
var inst_100915 = fluree.db.util.schema.setting_change_QMARK_.call(null,inst_100900__$1);
var inst_100916 = new cljs.core.Keyword(null,"ecount","ecount",-879380887).cljs$core$IFn$_invoke$arity$1(db);
var inst_100917 = cljs.core.get.call(null,inst_100916,(0));
var state_101069__$1 = (function (){var statearr_101071 = state_101069;
(statearr_101071[(7)] = inst_100908__$1);

(statearr_101071[(13)] = inst_100915);

(statearr_101071[(8)] = inst_100900__$1);

(statearr_101071[(14)] = inst_100912);

(statearr_101071[(10)] = inst_100898__$1);

(statearr_101071[(11)] = inst_100914__$1);

(statearr_101071[(12)] = inst_100904__$1);

(statearr_101071[(15)] = inst_100917);

(statearr_101071[(16)] = inst_100913);

return statearr_101071;
})();
if(cljs.core.truth_(inst_100914__$1)){
var statearr_101072_101130 = state_101069__$1;
(statearr_101072_101130[(1)] = (8));

} else {
var statearr_101073_101131 = state_101069__$1;
(statearr_101073_101131[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (20))){
var inst_100908 = (state_101069[(7)]);
var inst_100973 = (state_101069[(17)]);
var inst_100996 = (state_101069[(18)]);
var inst_100923 = (state_101069[(19)]);
var inst_100994 = (state_101069[(20)]);
var inst_100915 = (state_101069[(13)]);
var inst_100900 = (state_101069[(8)]);
var inst_100883 = (state_101069[(9)]);
var inst_100912 = (state_101069[(14)]);
var inst_100898 = (state_101069[(10)]);
var inst_100914 = (state_101069[(11)]);
var inst_100992 = (state_101069[(21)]);
var inst_100904 = (state_101069[(12)]);
var inst_101002 = (state_101069[(22)]);
var inst_100991 = (state_101069[(23)]);
var inst_100917 = (state_101069[(15)]);
var inst_100993 = (state_101069[(24)]);
var inst_100995 = (state_101069[(25)]);
var inst_100972 = (state_101069[(26)]);
var inst_100963 = (state_101069[(27)]);
var inst_100913 = (state_101069[(16)]);
var inst_101003 = (state_101069[(28)]);
var inst_101041 = inst_101002.s;
var inst_101042 = fluree.db.flake.sid__GT_cid.call(null,inst_101041);
var inst_101043 = (function (){var flakes_bytes = inst_100913;
var vec__100998 = inst_100991;
var t = inst_100883;
var seq__100999 = inst_101003;
var spot = inst_100992;
var add_flakes = inst_100900;
var G__100967 = inst_100991;
var root_setting_change_QMARK_ = inst_100915;
var ref_QMARK__map = inst_100912;
var r = inst_101003;
var psot = inst_100993;
var vec__100968 = inst_100900;
var add_pred_to_idx_QMARK_ = inst_100923;
var seq__100969 = inst_100973;
var _ = inst_100898;
var cid = inst_101042;
var ecount = inst_100996;
var first__100970 = inst_100972;
var pred_ecount = inst_100917;
var db_STAR_ = inst_100963;
var first__101000 = inst_101002;
var schema_change_QMARK_ = inst_100914;
var add_preds = inst_100904;
var opst = inst_100995;
var idx_QMARK__map = inst_100908;
var post = inst_100994;
var f = inst_101002;
return ((function (flakes_bytes,vec__100998,t,seq__100999,spot,add_flakes,G__100967,root_setting_change_QMARK_,ref_QMARK__map,r,psot,vec__100968,add_pred_to_idx_QMARK_,seq__100969,_,cid,ecount,first__100970,pred_ecount,db_STAR_,first__101000,schema_change_QMARK_,add_preds,opst,idx_QMARK__map,post,f,inst_100908,inst_100973,inst_100996,inst_100923,inst_100994,inst_100915,inst_100900,inst_100883,inst_100912,inst_100898,inst_100914,inst_100992,inst_100904,inst_101002,inst_100991,inst_100917,inst_100993,inst_100995,inst_100972,inst_100963,inst_100913,inst_101003,inst_101041,inst_101042,state_val_101070,c__86675__auto__){
return (function (p1__100877_SHARP_){
if(cljs.core.truth_(p1__100877_SHARP_)){
var x__4219__auto__ = p1__100877_SHARP_;
var y__4220__auto__ = f.s;
return ((x__4219__auto__ > y__4220__auto__) ? x__4219__auto__ : y__4220__auto__);
} else {
return f.s;
}
});
;})(flakes_bytes,vec__100998,t,seq__100999,spot,add_flakes,G__100967,root_setting_change_QMARK_,ref_QMARK__map,r,psot,vec__100968,add_pred_to_idx_QMARK_,seq__100969,_,cid,ecount,first__100970,pred_ecount,db_STAR_,first__101000,schema_change_QMARK_,add_preds,opst,idx_QMARK__map,post,f,inst_100908,inst_100973,inst_100996,inst_100923,inst_100994,inst_100915,inst_100900,inst_100883,inst_100912,inst_100898,inst_100914,inst_100992,inst_100904,inst_101002,inst_100991,inst_100917,inst_100993,inst_100995,inst_100972,inst_100963,inst_100913,inst_101003,inst_101041,inst_101042,state_val_101070,c__86675__auto__))
})();
var inst_101044 = cljs.core.update.call(null,inst_100996,inst_101042,inst_101043);
var inst_101045 = cljs.core.conj.call(null,inst_100992,inst_101002);
var inst_101046 = cljs.core.conj.call(null,inst_100993,inst_101002);
var inst_101047 = inst_101002.p;
var inst_101048 = cljs.core.get.call(null,inst_100908,inst_101047);
var state_101069__$1 = (function (){var statearr_101074 = state_101069;
(statearr_101074[(29)] = inst_101044);

(statearr_101074[(30)] = inst_101045);

(statearr_101074[(31)] = inst_101046);

return statearr_101074;
})();
if(cljs.core.truth_(inst_101048)){
var statearr_101075_101132 = state_101069__$1;
(statearr_101075_101132[(1)] = (33));

} else {
var statearr_101076_101133 = state_101069__$1;
(statearr_101076_101133[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (27))){
var inst_100915 = (state_101069[(13)]);
var inst_101029 = (state_101069[(2)]);
var state_101069__$1 = (function (){var statearr_101077 = state_101069;
(statearr_101077[(32)] = inst_101029);

return statearr_101077;
})();
if(cljs.core.truth_(inst_100915)){
var statearr_101078_101134 = state_101069__$1;
(statearr_101078_101134[(1)] = (29));

} else {
var statearr_101079_101135 = state_101069__$1;
(statearr_101079_101135[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (1))){
var state_101069__$1 = state_101069;
var statearr_101080_101136 = state_101069__$1;
(statearr_101080_101136[(2)] = null);

(statearr_101080_101136[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (24))){
var inst_101020 = (state_101069[(2)]);
var state_101069__$1 = state_101069;
if(cljs.core.truth_(inst_101020)){
var statearr_101081_101137 = state_101069__$1;
(statearr_101081_101137[(1)] = (25));

} else {
var statearr_101082_101138 = state_101069__$1;
(statearr_101082_101138[(1)] = (26));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (4))){
var inst_100883 = (state_101069[(9)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_101069,(3),Error,null,(2));
var inst_100882 = cljs.core.first.call(null,flakes);
var inst_100883__$1 = inst_100882.t;
var inst_100884 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(db);
var inst_100885 = (inst_100884 - (1));
var inst_100886 = cljs.core.not_EQ_.call(null,inst_100883__$1,inst_100885);
var state_101069__$1 = (function (){var statearr_101083 = state_101069;
(statearr_101083[(9)] = inst_100883__$1);

return statearr_101083;
})();
if(inst_100886){
var statearr_101084_101139 = state_101069__$1;
(statearr_101084_101139[(1)] = (5));

} else {
var statearr_101085_101140 = state_101069__$1;
(statearr_101085_101140[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (15))){
var inst_100951 = (state_101069[(2)]);
var state_101069__$1 = state_101069;
var statearr_101086_101141 = state_101069__$1;
(statearr_101086_101141[(2)] = inst_100951);

(statearr_101086_101141[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (21))){
var inst_101063 = (state_101069[(2)]);
var state_101069__$1 = state_101069;
var statearr_101087_101142 = state_101069__$1;
(statearr_101087_101142[(2)] = inst_101063);

(statearr_101087_101142[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (31))){
var inst_101039 = (state_101069[(2)]);
var state_101069__$1 = state_101069;
var statearr_101088_101143 = state_101069__$1;
(statearr_101088_101143[(2)] = inst_101039);

(statearr_101088_101143[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (32))){
var inst_101029 = (state_101069[(32)]);
var inst_101034 = (state_101069[(2)]);
var inst_101035 = fluree.db.util.async.throw_err.call(null,inst_101034);
var inst_101036 = cljs.core.assoc.call(null,inst_101029,new cljs.core.Keyword(null,"settings","settings",1556144875),inst_101035);
var state_101069__$1 = state_101069;
var statearr_101089_101144 = state_101069__$1;
(statearr_101089_101144[(2)] = inst_101036);

(statearr_101089_101144[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (33))){
var inst_100994 = (state_101069[(20)]);
var inst_101002 = (state_101069[(22)]);
var inst_101050 = cljs.core.conj.call(null,inst_100994,inst_101002);
var state_101069__$1 = state_101069;
var statearr_101090_101145 = state_101069__$1;
(statearr_101090_101145[(2)] = inst_101050);

(statearr_101090_101145[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (13))){
var inst_100935 = (state_101069[(33)]);
var inst_100941 = (state_101069[(34)]);
var inst_100944 = fluree.db.graphdb.add_predicate_to_idx.call(null,inst_100935,inst_100941);
var state_101069__$1 = state_101069;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101069__$1,(16),inst_100944);
} else {
if((state_val_101070 === (22))){
var inst_100914 = (state_101069[(11)]);
var state_101069__$1 = state_101069;
var statearr_101091_101146 = state_101069__$1;
(statearr_101091_101146[(2)] = inst_100914);

(statearr_101091_101146[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (36))){
var inst_101002 = (state_101069[(22)]);
var inst_100995 = (state_101069[(25)]);
var inst_101057 = cljs.core.conj.call(null,inst_100995,inst_101002);
var state_101069__$1 = state_101069;
var statearr_101092_101147 = state_101069__$1;
(statearr_101092_101147[(2)] = inst_101057);

(statearr_101092_101147[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (29))){
var inst_101029 = (state_101069[(32)]);
var inst_101032 = fluree.db.query.schema.setting_map.call(null,inst_101029);
var state_101069__$1 = state_101069;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101069__$1,(32),inst_101032);
} else {
if((state_val_101070 === (6))){
var state_101069__$1 = state_101069;
var statearr_101093_101148 = state_101069__$1;
(statearr_101093_101148[(2)] = null);

(statearr_101093_101148[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (28))){
var inst_101014 = (state_101069[(35)]);
var inst_101024 = (state_101069[(2)]);
var inst_101025 = fluree.db.util.async.throw_err.call(null,inst_101024);
var inst_101026 = cljs.core.assoc.call(null,inst_101014,new cljs.core.Keyword(null,"schema","schema",-1582001791),inst_101025);
var state_101069__$1 = state_101069;
var statearr_101094_101149 = state_101069__$1;
(statearr_101094_101149[(2)] = inst_101026);

(statearr_101094_101149[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (25))){
var inst_101014 = (state_101069[(35)]);
var inst_101022 = fluree.db.query.schema.schema_map.call(null,inst_101014);
var state_101069__$1 = state_101069;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101069__$1,(28),inst_101022);
} else {
if((state_val_101070 === (34))){
var inst_100994 = (state_101069[(20)]);
var state_101069__$1 = state_101069;
var statearr_101095_101150 = state_101069__$1;
(statearr_101095_101150[(2)] = inst_100994);

(statearr_101095_101150[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (17))){
var inst_101002 = (state_101069[(22)]);
var inst_100991 = (state_101069[(23)]);
var inst_101001 = cljs.core.seq.call(null,inst_100991);
var inst_101002__$1 = cljs.core.first.call(null,inst_101001);
var inst_101003 = cljs.core.next.call(null,inst_101001);
var inst_101004 = cljs.core.not.call(null,inst_101002__$1);
var state_101069__$1 = (function (){var statearr_101096 = state_101069;
(statearr_101096[(22)] = inst_101002__$1);

(statearr_101096[(28)] = inst_101003);

return statearr_101096;
})();
if(inst_101004){
var statearr_101097_101151 = state_101069__$1;
(statearr_101097_101151[(1)] = (19));

} else {
var statearr_101098_101152 = state_101069__$1;
(statearr_101098_101152[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (3))){
var inst_100878 = (state_101069[(2)]);
var state_101069__$1 = state_101069;
var statearr_101099_101153 = state_101069__$1;
(statearr_101099_101153[(2)] = inst_100878);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101069__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (12))){
var inst_100900 = (state_101069[(8)]);
var inst_100883 = (state_101069[(9)]);
var inst_100963 = (state_101069[(27)]);
var inst_100913 = (state_101069[(16)]);
var inst_100953 = (state_101069[(2)]);
var inst_100954 = cljs.core.assoc.call(null,inst_100953,new cljs.core.Keyword(null,"t","t",-1397832519),inst_100883);
var inst_100955 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100956 = [new cljs.core.Keyword(null,"stats","stats",-85643011),new cljs.core.Keyword(null,"size","size",1098693007)];
var inst_100957 = (new cljs.core.PersistentVector(null,2,(5),inst_100955,inst_100956,null));
var inst_100958 = cljs.core.update_in.call(null,inst_100954,inst_100957,cljs.core._PLUS_,inst_100913);
var inst_100959 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100960 = [new cljs.core.Keyword(null,"stats","stats",-85643011),new cljs.core.Keyword(null,"flakes","flakes",1977895739)];
var inst_100961 = (new cljs.core.PersistentVector(null,2,(5),inst_100959,inst_100960,null));
var inst_100962 = cljs.core.count.call(null,inst_100900);
var inst_100963__$1 = cljs.core.update_in.call(null,inst_100958,inst_100961,cljs.core._PLUS_,inst_100962);
var inst_100971 = cljs.core.seq.call(null,inst_100900);
var inst_100972 = cljs.core.first.call(null,inst_100971);
var inst_100973 = cljs.core.next.call(null,inst_100971);
var inst_100974 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100975 = [new cljs.core.Keyword(null,"novelty","novelty",-1590246024),new cljs.core.Keyword(null,"spot","spot",-1706962147)];
var inst_100976 = (new cljs.core.PersistentVector(null,2,(5),inst_100974,inst_100975,null));
var inst_100977 = cljs.core.get_in.call(null,inst_100963__$1,inst_100976);
var inst_100978 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100979 = [new cljs.core.Keyword(null,"novelty","novelty",-1590246024),new cljs.core.Keyword(null,"psot","psot",2111653059)];
var inst_100980 = (new cljs.core.PersistentVector(null,2,(5),inst_100978,inst_100979,null));
var inst_100981 = cljs.core.get_in.call(null,inst_100963__$1,inst_100980);
var inst_100982 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100983 = [new cljs.core.Keyword(null,"novelty","novelty",-1590246024),new cljs.core.Keyword(null,"post","post",269697687)];
var inst_100984 = (new cljs.core.PersistentVector(null,2,(5),inst_100982,inst_100983,null));
var inst_100985 = cljs.core.get_in.call(null,inst_100963__$1,inst_100984);
var inst_100986 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_100987 = [new cljs.core.Keyword(null,"novelty","novelty",-1590246024),new cljs.core.Keyword(null,"opst","opst",1213963058)];
var inst_100988 = (new cljs.core.PersistentVector(null,2,(5),inst_100986,inst_100987,null));
var inst_100989 = cljs.core.get_in.call(null,inst_100963__$1,inst_100988);
var inst_100990 = new cljs.core.Keyword(null,"ecount","ecount",-879380887).cljs$core$IFn$_invoke$arity$1(db);
var inst_100991 = inst_100900;
var inst_100992 = inst_100977;
var inst_100993 = inst_100981;
var inst_100994 = inst_100985;
var inst_100995 = inst_100989;
var inst_100996 = inst_100990;
var state_101069__$1 = (function (){var statearr_101100 = state_101069;
(statearr_101100[(17)] = inst_100973);

(statearr_101100[(18)] = inst_100996);

(statearr_101100[(20)] = inst_100994);

(statearr_101100[(21)] = inst_100992);

(statearr_101100[(23)] = inst_100991);

(statearr_101100[(24)] = inst_100993);

(statearr_101100[(25)] = inst_100995);

(statearr_101100[(26)] = inst_100972);

(statearr_101100[(27)] = inst_100963__$1);

return statearr_101100;
})();
var statearr_101101_101154 = state_101069__$1;
(statearr_101101_101154[(2)] = null);

(statearr_101101_101154[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (2))){
var inst_101067 = (state_101069[(2)]);
var state_101069__$1 = state_101069;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_101069__$1,inst_101067);
} else {
if((state_val_101070 === (23))){
var inst_101014 = (state_101069[(35)]);
var inst_101017 = new cljs.core.Keyword(null,"schema","schema",-1582001791).cljs$core$IFn$_invoke$arity$1(inst_101014);
var inst_101018 = (inst_101017 == null);
var state_101069__$1 = state_101069;
var statearr_101102_101155 = state_101069__$1;
(statearr_101102_101155[(2)] = inst_101018);

(statearr_101102_101155[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (35))){
var inst_100912 = (state_101069[(14)]);
var inst_101002 = (state_101069[(22)]);
var inst_101053 = (state_101069[(2)]);
var inst_101054 = inst_101002.p;
var inst_101055 = cljs.core.get.call(null,inst_100912,inst_101054);
var state_101069__$1 = (function (){var statearr_101103 = state_101069;
(statearr_101103[(36)] = inst_101053);

return statearr_101103;
})();
if(cljs.core.truth_(inst_101055)){
var statearr_101104_101156 = state_101069__$1;
(statearr_101104_101156[(1)] = (36));

} else {
var statearr_101105_101157 = state_101069__$1;
(statearr_101105_101157[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (19))){
var inst_100996 = (state_101069[(18)]);
var inst_100994 = (state_101069[(20)]);
var inst_100914 = (state_101069[(11)]);
var inst_100992 = (state_101069[(21)]);
var inst_100993 = (state_101069[(24)]);
var inst_100995 = (state_101069[(25)]);
var inst_100963 = (state_101069[(27)]);
var inst_100913 = (state_101069[(16)]);
var inst_101006 = [new cljs.core.Keyword(null,"spot","spot",-1706962147),new cljs.core.Keyword(null,"psot","psot",2111653059),new cljs.core.Keyword(null,"post","post",269697687),new cljs.core.Keyword(null,"opst","opst",1213963058),new cljs.core.Keyword(null,"size","size",1098693007)];
var inst_101007 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_101008 = [new cljs.core.Keyword(null,"novelty","novelty",-1590246024),new cljs.core.Keyword(null,"size","size",1098693007)];
var inst_101009 = (new cljs.core.PersistentVector(null,2,(5),inst_101007,inst_101008,null));
var inst_101010 = cljs.core.get_in.call(null,inst_100963,inst_101009);
var inst_101011 = (inst_100913 + inst_101010);
var inst_101012 = [inst_100992,inst_100993,inst_100994,inst_100995,inst_101011];
var inst_101013 = cljs.core.PersistentHashMap.fromArrays(inst_101006,inst_101012);
var inst_101014 = cljs.core.assoc.call(null,inst_100963,new cljs.core.Keyword(null,"ecount","ecount",-879380887),inst_100996,new cljs.core.Keyword(null,"novelty","novelty",-1590246024),inst_101013);
var state_101069__$1 = (function (){var statearr_101106 = state_101069;
(statearr_101106[(35)] = inst_101014);

return statearr_101106;
})();
if(cljs.core.truth_(inst_100914)){
var statearr_101107_101158 = state_101069__$1;
(statearr_101107_101158[(1)] = (22));

} else {
var statearr_101108_101159 = state_101069__$1;
(statearr_101108_101159[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (11))){
var inst_100934 = (state_101069[(37)]);
var inst_100941 = (state_101069[(34)]);
var inst_100940 = cljs.core.seq.call(null,inst_100934);
var inst_100941__$1 = cljs.core.first.call(null,inst_100940);
var inst_100942 = cljs.core.next.call(null,inst_100940);
var state_101069__$1 = (function (){var statearr_101109 = state_101069;
(statearr_101109[(38)] = inst_100942);

(statearr_101109[(34)] = inst_100941__$1);

return statearr_101109;
})();
if(cljs.core.truth_(inst_100941__$1)){
var statearr_101110_101160 = state_101069__$1;
(statearr_101110_101160[(1)] = (13));

} else {
var statearr_101111_101161 = state_101069__$1;
(statearr_101111_101161[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (9))){
var inst_100921 = cljs.core.PersistentVector.EMPTY;
var state_101069__$1 = state_101069;
var statearr_101112_101162 = state_101069__$1;
(statearr_101112_101162[(2)] = inst_100921);

(statearr_101112_101162[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (5))){
var inst_100883 = (state_101069[(9)]);
var inst_100888 = new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(db);
var inst_100889 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(db);
var inst_100890 = ["Invalid with called for db ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_100888)," because current 't', ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_100889)," is not beyond supplied transaction t: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_100883),"."].join('');
var inst_100891 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_100892 = [(500),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)];
var inst_100893 = cljs.core.PersistentHashMap.fromArrays(inst_100891,inst_100892);
var inst_100894 = cljs.core.ex_info.call(null,inst_100890,inst_100893);
var inst_100895 = (function(){throw inst_100894})();
var state_101069__$1 = state_101069;
var statearr_101113_101163 = state_101069__$1;
(statearr_101113_101163[(2)] = inst_100895);

(statearr_101113_101163[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (14))){
var inst_100935 = (state_101069[(33)]);
var state_101069__$1 = state_101069;
var statearr_101114_101164 = state_101069__$1;
(statearr_101114_101164[(2)] = inst_100935);

(statearr_101114_101164[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (26))){
var inst_101014 = (state_101069[(35)]);
var state_101069__$1 = state_101069;
var statearr_101115_101165 = state_101069__$1;
(statearr_101115_101165[(2)] = inst_101014);

(statearr_101115_101165[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (16))){
var inst_100942 = (state_101069[(38)]);
var inst_100946 = (state_101069[(2)]);
var inst_100947 = fluree.db.util.async.throw_err.call(null,inst_100946);
var inst_100934 = inst_100942;
var inst_100935 = inst_100947;
var state_101069__$1 = (function (){var statearr_101116 = state_101069;
(statearr_101116[(33)] = inst_100935);

(statearr_101116[(37)] = inst_100934);

return statearr_101116;
})();
var statearr_101117_101166 = state_101069__$1;
(statearr_101117_101166[(2)] = null);

(statearr_101117_101166[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (38))){
var inst_101044 = (state_101069[(29)]);
var inst_101045 = (state_101069[(30)]);
var inst_101053 = (state_101069[(36)]);
var inst_101003 = (state_101069[(28)]);
var inst_101046 = (state_101069[(31)]);
var inst_101060 = (state_101069[(2)]);
var inst_100991 = inst_101003;
var inst_100992 = inst_101045;
var inst_100993 = inst_101046;
var inst_100994 = inst_101053;
var inst_100995 = inst_101060;
var inst_100996 = inst_101044;
var state_101069__$1 = (function (){var statearr_101118 = state_101069;
(statearr_101118[(18)] = inst_100996);

(statearr_101118[(20)] = inst_100994);

(statearr_101118[(21)] = inst_100992);

(statearr_101118[(23)] = inst_100991);

(statearr_101118[(24)] = inst_100993);

(statearr_101118[(25)] = inst_100995);

return statearr_101118;
})();
var statearr_101119_101167 = state_101069__$1;
(statearr_101119_101167[(2)] = null);

(statearr_101119_101167[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (30))){
var inst_101029 = (state_101069[(32)]);
var state_101069__$1 = state_101069;
var statearr_101120_101168 = state_101069__$1;
(statearr_101120_101168[(2)] = inst_101029);

(statearr_101120_101168[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (10))){
var inst_100923 = (state_101069[(19)]);
var inst_100923__$1 = (state_101069[(2)]);
var inst_100931 = cljs.core.seq.call(null,inst_100923__$1);
var inst_100932 = cljs.core.first.call(null,inst_100931);
var inst_100933 = cljs.core.next.call(null,inst_100931);
var inst_100934 = inst_100923__$1;
var inst_100935 = db;
var state_101069__$1 = (function (){var statearr_101121 = state_101069;
(statearr_101121[(33)] = inst_100935);

(statearr_101121[(37)] = inst_100934);

(statearr_101121[(19)] = inst_100923__$1);

(statearr_101121[(39)] = inst_100932);

(statearr_101121[(40)] = inst_100933);

return statearr_101121;
})();
var statearr_101122_101169 = state_101069__$1;
(statearr_101122_101169[(2)] = null);

(statearr_101122_101169[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (18))){
var inst_101065 = (state_101069[(2)]);
var state_101069__$1 = state_101069;
var statearr_101123_101170 = state_101069__$1;
(statearr_101123_101170[(2)] = inst_101065);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101069__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (37))){
var inst_100995 = (state_101069[(25)]);
var state_101069__$1 = state_101069;
var statearr_101124_101171 = state_101069__$1;
(statearr_101124_101171[(2)] = inst_100995);

(statearr_101124_101171[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101070 === (8))){
var inst_100900 = (state_101069[(8)]);
var inst_100917 = (state_101069[(15)]);
var inst_100919 = fluree.db.util.schema.add_to_post_preds_QMARK_.call(null,inst_100900,inst_100917);
var state_101069__$1 = state_101069;
var statearr_101125_101172 = state_101069__$1;
(statearr_101125_101172[(2)] = inst_100919);

(statearr_101125_101172[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$graphdb$with_t_$_state_machine__86625__auto__ = null;
var fluree$db$graphdb$with_t_$_state_machine__86625__auto____0 = (function (){
var statearr_101126 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_101126[(0)] = fluree$db$graphdb$with_t_$_state_machine__86625__auto__);

(statearr_101126[(1)] = (1));

return statearr_101126;
});
var fluree$db$graphdb$with_t_$_state_machine__86625__auto____1 = (function (state_101069){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_101069);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e101127){if((e101127 instanceof Object)){
var ex__86628__auto__ = e101127;
var statearr_101128_101173 = state_101069;
(statearr_101128_101173[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101069);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e101127;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__101174 = state_101069;
state_101069 = G__101174;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$graphdb$with_t_$_state_machine__86625__auto__ = function(state_101069){
switch(arguments.length){
case 0:
return fluree$db$graphdb$with_t_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$graphdb$with_t_$_state_machine__86625__auto____1.call(this,state_101069);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$with_t_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$with_t_$_state_machine__86625__auto____0;
fluree$db$graphdb$with_t_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$with_t_$_state_machine__86625__auto____1;
return fluree$db$graphdb$with_t_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_101129 = f__86676__auto__.call(null);
(statearr_101129[(6)] = c__86675__auto__);

return statearr_101129;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Returns db 'with' flakes added as a core async promise channel.
 *   Note this always does a re-sort.
 */
fluree.db.graphdb.with$ = (function fluree$db$graphdb$with(db,block,flakes){
var resp_ch = cljs.core.async.promise_chan.call(null);
var c__86675__auto___101297 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___101297,resp_ch){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___101297,resp_ch){
return (function (state_101259){
var state_val_101260 = (state_101259[(1)]);
if((state_val_101260 === (7))){
var inst_101194 = (state_101259[(2)]);
var inst_101195 = cljs.core.sort.call(null,fluree.db.flake.cmp_flakes_block,flakes);
var inst_101203 = cljs.core.seq.call(null,inst_101195);
var inst_101204 = cljs.core.first.call(null,inst_101203);
var inst_101205 = cljs.core.next.call(null,inst_101203);
var inst_101206 = cljs.core.first.call(null,inst_101195);
var inst_101207 = inst_101206.t;
var inst_101208 = cljs.core.PersistentVector.EMPTY;
var inst_101209 = inst_101195;
var inst_101210 = inst_101207;
var inst_101211 = inst_101208;
var inst_101212 = db;
var state_101259__$1 = (function (){var statearr_101261 = state_101259;
(statearr_101261[(7)] = inst_101209);

(statearr_101261[(8)] = inst_101212);

(statearr_101261[(9)] = inst_101210);

(statearr_101261[(10)] = inst_101205);

(statearr_101261[(11)] = inst_101204);

(statearr_101261[(12)] = inst_101211);

(statearr_101261[(13)] = inst_101194);

return statearr_101261;
})();
var statearr_101262_101298 = state_101259__$1;
(statearr_101262_101298[(2)] = null);

(statearr_101262_101298[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (20))){
var inst_101236 = (state_101259[(14)]);
var inst_101239 = cljs.core.assoc.call(null,inst_101236,new cljs.core.Keyword(null,"block","block",664686210),block);
var state_101259__$1 = state_101259;
var statearr_101263_101299 = state_101259__$1;
(statearr_101263_101299[(2)] = inst_101239);

(statearr_101263_101299[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (1))){
var state_101259__$1 = state_101259;
var statearr_101264_101300 = state_101259__$1;
(statearr_101264_101300[(2)] = null);

(statearr_101264_101300[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_101259,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_101180 = new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(db);
var inst_101181 = (inst_101180 + (1));
var inst_101182 = cljs.core.not_EQ_.call(null,block,inst_101181);
var state_101259__$1 = state_101259;
if(inst_101182){
var statearr_101265_101301 = state_101259__$1;
(statearr_101265_101301[(1)] = (5));

} else {
var statearr_101266_101302 = state_101259__$1;
(statearr_101266_101302[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (15))){
var inst_101252 = (state_101259[(2)]);
var state_101259__$1 = state_101259;
var statearr_101269_101303 = state_101259__$1;
(statearr_101269_101303[(2)] = inst_101252);

(statearr_101269_101303[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (21))){
var inst_101219 = (state_101259[(15)]);
var inst_101236 = (state_101259[(14)]);
var inst_101218 = (state_101259[(16)]);
var inst_101241 = inst_101218.t;
var inst_101242 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_101243 = [inst_101218];
var inst_101244 = (new cljs.core.PersistentVector(null,1,(5),inst_101242,inst_101243,null));
var inst_101209 = inst_101219;
var inst_101210 = inst_101241;
var inst_101211 = inst_101244;
var inst_101212 = inst_101236;
var state_101259__$1 = (function (){var statearr_101270 = state_101259;
(statearr_101270[(7)] = inst_101209);

(statearr_101270[(8)] = inst_101212);

(statearr_101270[(9)] = inst_101210);

(statearr_101270[(12)] = inst_101211);

return statearr_101270;
})();
var statearr_101271_101304 = state_101259__$1;
(statearr_101271_101304[(2)] = null);

(statearr_101271_101304[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (13))){
var inst_101219 = (state_101259[(15)]);
var inst_101212 = (state_101259[(8)]);
var inst_101218 = (state_101259[(16)]);
var inst_101210 = (state_101259[(9)]);
var inst_101211 = (state_101259[(12)]);
var inst_101227 = cljs.core.conj.call(null,inst_101211,inst_101218);
var tmp101267 = inst_101212;
var tmp101268 = inst_101210;
var inst_101209 = inst_101219;
var inst_101210__$1 = tmp101268;
var inst_101211__$1 = inst_101227;
var inst_101212__$1 = tmp101267;
var state_101259__$1 = (function (){var statearr_101272 = state_101259;
(statearr_101272[(7)] = inst_101209);

(statearr_101272[(8)] = inst_101212__$1);

(statearr_101272[(9)] = inst_101210__$1);

(statearr_101272[(12)] = inst_101211__$1);

return statearr_101272;
})();
var statearr_101273_101305 = state_101259__$1;
(statearr_101273_101305[(2)] = null);

(statearr_101273_101305[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (22))){
var inst_101247 = (state_101259[(2)]);
var state_101259__$1 = state_101259;
var statearr_101274_101306 = state_101259__$1;
(statearr_101274_101306[(2)] = inst_101247);

(statearr_101274_101306[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (6))){
var state_101259__$1 = state_101259;
var statearr_101275_101307 = state_101259__$1;
(statearr_101275_101307[(2)] = null);

(statearr_101275_101307[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (17))){
var state_101259__$1 = state_101259;
var statearr_101276_101308 = state_101259__$1;
(statearr_101276_101308[(2)] = null);

(statearr_101276_101308[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (3))){
var inst_101175 = (state_101259[(2)]);
var inst_101176 = cljs.core.async.put_BANG_.call(null,resp_ch,inst_101175);
var state_101259__$1 = state_101259;
var statearr_101277_101309 = state_101259__$1;
(statearr_101277_101309[(2)] = inst_101176);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101259__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (12))){
var inst_101225 = (state_101259[(2)]);
var state_101259__$1 = state_101259;
if(cljs.core.truth_(inst_101225)){
var statearr_101278_101310 = state_101259__$1;
(statearr_101278_101310[(1)] = (13));

} else {
var statearr_101279_101311 = state_101259__$1;
(statearr_101279_101311[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (2))){
var inst_101257 = (state_101259[(2)]);
var state_101259__$1 = state_101259;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_101259__$1,inst_101257);
} else {
if((state_val_101260 === (19))){
var inst_101218 = (state_101259[(16)]);
var inst_101235 = (state_101259[(2)]);
var inst_101236 = fluree.db.util.async.throw_err.call(null,inst_101235);
var inst_101237 = (inst_101218 == null);
var state_101259__$1 = (function (){var statearr_101280 = state_101259;
(statearr_101280[(14)] = inst_101236);

return statearr_101280;
})();
if(cljs.core.truth_(inst_101237)){
var statearr_101281_101312 = state_101259__$1;
(statearr_101281_101312[(1)] = (20));

} else {
var statearr_101282_101313 = state_101259__$1;
(statearr_101282_101313[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (11))){
var inst_101218 = (state_101259[(16)]);
var state_101259__$1 = state_101259;
var statearr_101283_101314 = state_101259__$1;
(statearr_101283_101314[(2)] = inst_101218);

(statearr_101283_101314[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (9))){
var inst_101254 = (state_101259[(2)]);
var inst_101255 = cljs.core.async.put_BANG_.call(null,resp_ch,inst_101254);
var state_101259__$1 = state_101259;
var statearr_101284_101315 = state_101259__$1;
(statearr_101284_101315[(2)] = inst_101255);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101259__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (5))){
var inst_101184 = new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(db);
var inst_101185 = new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(db);
var inst_101186 = ["Invalid 'with' called for db ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_101184)," because current db 'block', ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_101185)," must be one less than supplied block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),"."].join('');
var inst_101187 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_101188 = [(500),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)];
var inst_101189 = cljs.core.PersistentHashMap.fromArrays(inst_101187,inst_101188);
var inst_101190 = cljs.core.ex_info.call(null,inst_101186,inst_101189);
var inst_101191 = (function(){throw inst_101190})();
var state_101259__$1 = state_101259;
var statearr_101285_101316 = state_101259__$1;
(statearr_101285_101316[(2)] = inst_101191);

(statearr_101285_101316[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (14))){
var state_101259__$1 = state_101259;
var statearr_101286_101317 = state_101259__$1;
(statearr_101286_101317[(1)] = (16));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (16))){
var inst_101212 = (state_101259[(8)]);
var inst_101210 = (state_101259[(9)]);
var inst_101211 = (state_101259[(12)]);
var inst_101231 = (inst_101210 + (1));
var inst_101232 = cljs.core.assoc.call(null,inst_101212,new cljs.core.Keyword(null,"t","t",-1397832519),inst_101231);
var inst_101233 = fluree.db.graphdb.with_t.call(null,inst_101232,inst_101211);
var state_101259__$1 = state_101259;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101259__$1,(19),inst_101233);
} else {
if((state_val_101260 === (10))){
var inst_101218 = (state_101259[(16)]);
var inst_101210 = (state_101259[(9)]);
var inst_101221 = inst_101218.t;
var inst_101222 = cljs.core._EQ_.call(null,inst_101210,inst_101221);
var state_101259__$1 = state_101259;
var statearr_101288_101318 = state_101259__$1;
(statearr_101288_101318[(2)] = inst_101222);

(statearr_101288_101318[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (18))){
var inst_101250 = (state_101259[(2)]);
var state_101259__$1 = state_101259;
var statearr_101289_101319 = state_101259__$1;
(statearr_101289_101319[(2)] = inst_101250);

(statearr_101289_101319[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101260 === (8))){
var inst_101209 = (state_101259[(7)]);
var inst_101218 = (state_101259[(16)]);
var inst_101217 = cljs.core.seq.call(null,inst_101209);
var inst_101218__$1 = cljs.core.first.call(null,inst_101217);
var inst_101219 = cljs.core.next.call(null,inst_101217);
var state_101259__$1 = (function (){var statearr_101290 = state_101259;
(statearr_101290[(15)] = inst_101219);

(statearr_101290[(16)] = inst_101218__$1);

return statearr_101290;
})();
if(cljs.core.truth_(inst_101218__$1)){
var statearr_101291_101320 = state_101259__$1;
(statearr_101291_101320[(1)] = (10));

} else {
var statearr_101292_101321 = state_101259__$1;
(statearr_101292_101321[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto___101297,resp_ch))
;
return ((function (switch__86624__auto__,c__86675__auto___101297,resp_ch){
return (function() {
var fluree$db$graphdb$with_$_state_machine__86625__auto__ = null;
var fluree$db$graphdb$with_$_state_machine__86625__auto____0 = (function (){
var statearr_101293 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_101293[(0)] = fluree$db$graphdb$with_$_state_machine__86625__auto__);

(statearr_101293[(1)] = (1));

return statearr_101293;
});
var fluree$db$graphdb$with_$_state_machine__86625__auto____1 = (function (state_101259){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_101259);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e101294){if((e101294 instanceof Object)){
var ex__86628__auto__ = e101294;
var statearr_101295_101322 = state_101259;
(statearr_101295_101322[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101259);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e101294;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__101323 = state_101259;
state_101259 = G__101323;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$graphdb$with_$_state_machine__86625__auto__ = function(state_101259){
switch(arguments.length){
case 0:
return fluree$db$graphdb$with_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$graphdb$with_$_state_machine__86625__auto____1.call(this,state_101259);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$with_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$with_$_state_machine__86625__auto____0;
fluree$db$graphdb$with_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$with_$_state_machine__86625__auto____1;
return fluree$db$graphdb$with_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___101297,resp_ch))
})();
var state__86677__auto__ = (function (){var statearr_101296 = f__86676__auto__.call(null);
(statearr_101296[(6)] = c__86675__auto___101297);

return statearr_101296;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___101297,resp_ch))
);


return resp_ch;
});
/**
 * Returns true if db is a forward time travel db.
 */
fluree.db.graphdb.forward_time_travel_db_QMARK_ = (function fluree$db$graphdb$forward_time_travel_db_QMARK_(db){
return (!((new cljs.core.Keyword(null,"tt-id","tt-id",725587484).cljs$core$IFn$_invoke$arity$1(db) == null)));
});
/**
 * Returns a core async chan with a new db based on the provided db, including the provided flakes.
 *   Flakes can contain one or more 't's, but should be sequential and start after the current
 *   't' of the provided db. (i.e. if db-t is -14, flakes 't' should be -15, -16, etc.).
 *   Remember 't' is negative and thus should be in descending order.
 * 
 *   A tt-id (time-travel-id), if provided, can be any unique identifier of any type and is required.
 *   It must be unique (to the computer/process) to avoid any query caching issues.
 * 
 *   A forward-time-travel dbf can be further forward-time-traveled. If a tt-id is provided, ensure
 *   it is unique for each successive call.
 * 
 *   A forward-time travel DB is held in memory, and is not shared across servers. Ensure you
 *   have adequate memory to hold the flakes you generate and add. If access is provided via
 *   an external API, do any desired size restrictions or controls within your API endpoint.
 * 
 *   Remember schema operations done via forward-time-travel should be done in a 't' prior to
 *   the flakes that end up requiring the schema change.
 */
fluree.db.graphdb.forward_time_travel = (function fluree$db$graphdb$forward_time_travel(db,tt_id,flakes){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_101376){
var state_val_101377 = (state_101376[(1)]);
if((state_val_101377 === (7))){
var inst_101333 = (state_101376[(2)]);
var inst_101334 = (function (){var tt_id_SINGLEQUOTE_ = inst_101333;
return ((function (tt_id_SINGLEQUOTE_,inst_101333,state_val_101377,c__86675__auto__){
return (function (db_STAR_,idx){
return cljs.core.assoc.call(null,db_STAR_,idx,cljs.core.assoc.call(null,cljs.core.get.call(null,db_STAR_,idx),new cljs.core.Keyword(null,"tt-id","tt-id",725587484),tt_id_SINGLEQUOTE_));
});
;})(tt_id_SINGLEQUOTE_,inst_101333,state_val_101377,c__86675__auto__))
})();
var inst_101335 = cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"tt-id","tt-id",725587484),inst_101333);
var inst_101336 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_101337 = [new cljs.core.Keyword(null,"spot","spot",-1706962147),new cljs.core.Keyword(null,"psot","psot",2111653059),new cljs.core.Keyword(null,"post","post",269697687),new cljs.core.Keyword(null,"opst","opst",1213963058)];
var inst_101338 = (new cljs.core.PersistentVector(null,4,(5),inst_101336,inst_101337,null));
var inst_101339 = cljs.core.reduce.call(null,inst_101334,inst_101335,inst_101338);
var inst_101340 = cljs.core.sort_by.call(null,new cljs.core.Keyword(null,"t","t",-1397832519),flakes);
var inst_101341 = cljs.core.reverse.call(null,inst_101340);
var inst_101342 = cljs.core.partition_by.call(null,new cljs.core.Keyword(null,"t","t",-1397832519),inst_101341);
var inst_101350 = cljs.core.seq.call(null,inst_101342);
var inst_101351 = cljs.core.first.call(null,inst_101350);
var inst_101352 = cljs.core.next.call(null,inst_101350);
var inst_101353 = inst_101339;
var inst_101354 = inst_101342;
var state_101376__$1 = (function (){var statearr_101378 = state_101376;
(statearr_101378[(7)] = inst_101353);

(statearr_101378[(8)] = inst_101351);

(statearr_101378[(9)] = inst_101352);

(statearr_101378[(10)] = inst_101354);

return statearr_101378;
})();
var statearr_101379_101398 = state_101376__$1;
(statearr_101379_101398[(2)] = null);

(statearr_101379_101398[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101377 === (1))){
var state_101376__$1 = state_101376;
var statearr_101380_101399 = state_101376__$1;
(statearr_101380_101399[(2)] = null);

(statearr_101380_101399[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101377 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_101376,(3),Error,null,(2));
var inst_101328 = (tt_id == null);
var state_101376__$1 = state_101376;
if(cljs.core.truth_(inst_101328)){
var statearr_101381_101400 = state_101376__$1;
(statearr_101381_101400[(1)] = (5));

} else {
var statearr_101382_101401 = state_101376__$1;
(statearr_101382_101401[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101377 === (13))){
var inst_101361 = (state_101376[(11)]);
var inst_101365 = (state_101376[(2)]);
var inst_101366 = fluree.db.util.async.throw_err.call(null,inst_101365);
var inst_101353 = inst_101366;
var inst_101354 = inst_101361;
var state_101376__$1 = (function (){var statearr_101383 = state_101376;
(statearr_101383[(7)] = inst_101353);

(statearr_101383[(10)] = inst_101354);

return statearr_101383;
})();
var statearr_101384_101402 = state_101376__$1;
(statearr_101384_101402[(2)] = null);

(statearr_101384_101402[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101377 === (6))){
var state_101376__$1 = state_101376;
var statearr_101385_101403 = state_101376__$1;
(statearr_101385_101403[(2)] = tt_id);

(statearr_101385_101403[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101377 === (3))){
var inst_101324 = (state_101376[(2)]);
var state_101376__$1 = state_101376;
var statearr_101386_101404 = state_101376__$1;
(statearr_101386_101404[(2)] = inst_101324);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101376__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101377 === (12))){
var inst_101370 = (state_101376[(2)]);
var state_101376__$1 = state_101376;
var statearr_101387_101405 = state_101376__$1;
(statearr_101387_101405[(2)] = inst_101370);

(statearr_101387_101405[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101377 === (2))){
var inst_101374 = (state_101376[(2)]);
var state_101376__$1 = state_101376;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_101376__$1,inst_101374);
} else {
if((state_val_101377 === (11))){
var inst_101353 = (state_101376[(7)]);
var state_101376__$1 = state_101376;
var statearr_101388_101406 = state_101376__$1;
(statearr_101388_101406[(2)] = inst_101353);

(statearr_101388_101406[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101377 === (9))){
var inst_101372 = (state_101376[(2)]);
var state_101376__$1 = state_101376;
var statearr_101389_101407 = state_101376__$1;
(statearr_101389_101407[(2)] = inst_101372);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101376__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101377 === (5))){
var inst_101330 = fluree.db.util.core.random_uuid.call(null);
var state_101376__$1 = state_101376;
var statearr_101390_101408 = state_101376__$1;
(statearr_101390_101408[(2)] = inst_101330);

(statearr_101390_101408[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101377 === (10))){
var inst_101353 = (state_101376[(7)]);
var inst_101360 = (state_101376[(12)]);
var inst_101363 = fluree.db.graphdb.with_t.call(null,inst_101353,inst_101360);
var state_101376__$1 = state_101376;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101376__$1,(13),inst_101363);
} else {
if((state_val_101377 === (8))){
var inst_101360 = (state_101376[(12)]);
var inst_101354 = (state_101376[(10)]);
var inst_101359 = cljs.core.seq.call(null,inst_101354);
var inst_101360__$1 = cljs.core.first.call(null,inst_101359);
var inst_101361 = cljs.core.next.call(null,inst_101359);
var state_101376__$1 = (function (){var statearr_101391 = state_101376;
(statearr_101391[(11)] = inst_101361);

(statearr_101391[(12)] = inst_101360__$1);

return statearr_101391;
})();
if(cljs.core.truth_(inst_101360__$1)){
var statearr_101392_101409 = state_101376__$1;
(statearr_101392_101409[(1)] = (10));

} else {
var statearr_101393_101410 = state_101376__$1;
(statearr_101393_101410[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto__ = null;
var fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto____0 = (function (){
var statearr_101394 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_101394[(0)] = fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto__);

(statearr_101394[(1)] = (1));

return statearr_101394;
});
var fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto____1 = (function (state_101376){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_101376);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e101395){if((e101395 instanceof Object)){
var ex__86628__auto__ = e101395;
var statearr_101396_101411 = state_101376;
(statearr_101396_101411[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101376);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e101395;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__101412 = state_101376;
state_101376 = G__101412;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto__ = function(state_101376){
switch(arguments.length){
case 0:
return fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto____1.call(this,state_101376);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto____0;
fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto____1;
return fluree$db$graphdb$forward_time_travel_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_101397 = f__86676__auto__.call(null);
(statearr_101397[(6)] = c__86675__auto__);

return statearr_101397;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Returns subject ID of ident as async promise channel.
 *   Closes channel (nil) if doesn't exist, or if strict? is true, will return exception.
 */
fluree.db.graphdb.subid = (function fluree$db$graphdb$subid(db,ident,strict_QMARK_){
var return_chan = cljs.core.async.promise_chan.call(null);
var c__86675__auto___101581 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___101581,return_chan){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___101581,return_chan){
return (function (state_101524){
var state_val_101525 = (state_101524[(1)]);
if((state_val_101525 === (7))){
var inst_101495 = (state_101524[(7)]);
var inst_101495__$1 = (state_101524[(2)]);
var state_101524__$1 = (function (){var statearr_101526 = state_101524;
(statearr_101526[(7)] = inst_101495__$1);

return statearr_101526;
})();
if(cljs.core.truth_(inst_101495__$1)){
var statearr_101527_101582 = state_101524__$1;
(statearr_101527_101582[(1)] = (28));

} else {
var statearr_101528_101583 = state_101524__$1;
(statearr_101528_101583[(1)] = (29));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (20))){
var inst_101465 = (state_101524[(8)]);
var inst_101469 = cljs.core.first.call(null,inst_101465);
var state_101524__$1 = state_101524;
var statearr_101529_101584 = state_101524__$1;
(statearr_101529_101584[(2)] = inst_101469);

(statearr_101529_101584[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (27))){
var inst_101489 = (state_101524[(2)]);
var state_101524__$1 = state_101524;
var statearr_101530_101585 = state_101524__$1;
(statearr_101530_101585[(2)] = inst_101489);

(statearr_101530_101585[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (1))){
var state_101524__$1 = state_101524;
var statearr_101531_101586 = state_101524__$1;
(statearr_101531_101586[(2)] = null);

(statearr_101531_101586[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (24))){
var inst_101477 = (state_101524[(2)]);
var state_101524__$1 = state_101524;
var statearr_101532_101587 = state_101524__$1;
(statearr_101532_101587[(2)] = inst_101477);

(statearr_101532_101587[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (39))){
var inst_101516 = (state_101524[(2)]);
var state_101524__$1 = state_101524;
var statearr_101533_101588 = state_101524__$1;
(statearr_101533_101588[(2)] = inst_101516);

(statearr_101533_101588[(1)] = (36));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_101524,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_101423 = typeof ident === 'number';
var state_101524__$1 = state_101524;
if(cljs.core.truth_(inst_101423)){
var statearr_101534_101589 = state_101524__$1;
(statearr_101534_101589[(1)] = (5));

} else {
var statearr_101535_101590 = state_101524__$1;
(statearr_101535_101590[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (15))){
var inst_101456 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_101457 = cljs.core.first.call(null,ident);
var inst_101458 = fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),inst_101457);
var inst_101459 = cljs.core.second.call(null,ident);
var inst_101460 = [inst_101458,inst_101459];
var inst_101461 = (new cljs.core.PersistentVector(null,2,(5),inst_101456,inst_101460,null));
var inst_101462 = fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"post","post",269697687),cljs.core._EQ_,inst_101461);
var state_101524__$1 = state_101524;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101524__$1,(18),inst_101462);
} else {
if((state_val_101525 === (21))){
var inst_101471 = (state_101524[(9)]);
var inst_101471__$1 = (state_101524[(2)]);
var inst_101472 = (inst_101471__$1 == null);
var state_101524__$1 = (function (){var statearr_101536 = state_101524;
(statearr_101536[(9)] = inst_101471__$1);

return statearr_101536;
})();
if(cljs.core.truth_(inst_101472)){
var statearr_101537_101591 = state_101524__$1;
(statearr_101537_101591[(1)] = (22));

} else {
var statearr_101538_101592 = state_101524__$1;
(statearr_101538_101592[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (31))){
var state_101524__$1 = state_101524;
var statearr_101539_101593 = state_101524__$1;
(statearr_101539_101593[(2)] = strict_QMARK_);

(statearr_101539_101593[(1)] = (33));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (32))){
var inst_101499 = (state_101524[(10)]);
var state_101524__$1 = state_101524;
var statearr_101540_101594 = state_101524__$1;
(statearr_101540_101594[(2)] = inst_101499);

(statearr_101540_101594[(1)] = (33));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (33))){
var inst_101503 = (state_101524[(2)]);
var state_101524__$1 = state_101524;
if(cljs.core.truth_(inst_101503)){
var statearr_101541_101595 = state_101524__$1;
(statearr_101541_101595[(1)] = (34));

} else {
var statearr_101542_101596 = state_101524__$1;
(statearr_101542_101596[(1)] = (35));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (13))){
var inst_101453 = fluree.db.util.core.pred_ident_QMARK_.call(null,ident);
var state_101524__$1 = state_101524;
if(inst_101453){
var statearr_101543_101597 = state_101524__$1;
(statearr_101543_101597[(1)] = (15));

} else {
var statearr_101544_101598 = state_101524__$1;
(statearr_101544_101598[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (22))){
var state_101524__$1 = state_101524;
var statearr_101545_101599 = state_101524__$1;
(statearr_101545_101599[(2)] = null);

(statearr_101545_101599[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (36))){
var inst_101518 = (state_101524[(2)]);
var state_101524__$1 = state_101524;
var statearr_101546_101600 = state_101524__$1;
(statearr_101546_101600[(2)] = inst_101518);

(statearr_101546_101600[(1)] = (30));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (29))){
var inst_101499 = (state_101524[(10)]);
var inst_101495 = (state_101524[(7)]);
var inst_101499__$1 = (inst_101495 == null);
var state_101524__$1 = (function (){var statearr_101547 = state_101524;
(statearr_101547[(10)] = inst_101499__$1);

return statearr_101547;
})();
if(cljs.core.truth_(inst_101499__$1)){
var statearr_101548_101601 = state_101524__$1;
(statearr_101548_101601[(1)] = (31));

} else {
var statearr_101549_101602 = state_101524__$1;
(statearr_101549_101602[(1)] = (32));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (6))){
var inst_101438 = fluree.db.util.core.pred_ident_QMARK_.call(null,ident);
var inst_101439 = cljs.core.first.call(null,ident);
var inst_101440 = fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),inst_101439);
var inst_101441 = (inst_101440 == null);
var inst_101442 = ((inst_101438) && (inst_101441));
var state_101524__$1 = state_101524;
if(cljs.core.truth_(inst_101442)){
var statearr_101550_101603 = state_101524__$1;
(statearr_101550_101603[(1)] = (12));

} else {
var statearr_101551_101604 = state_101524__$1;
(statearr_101551_101604[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (28))){
var inst_101495 = (state_101524[(7)]);
var inst_101497 = cljs.core.async.put_BANG_.call(null,return_chan,inst_101495);
var state_101524__$1 = state_101524;
var statearr_101552_101605 = state_101524__$1;
(statearr_101552_101605[(2)] = inst_101497);

(statearr_101552_101605[(1)] = (30));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (25))){
var inst_101480 = cljs.core.pr_str.call(null,ident);
var inst_101481 = ["Entid lookup must be a number or valid two-tuple identity: ",inst_101480].join('');
var inst_101482 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_101483 = [(400),new cljs.core.Keyword("db","invalid-ident","db/invalid-ident",939019721)];
var inst_101484 = cljs.core.PersistentHashMap.fromArrays(inst_101482,inst_101483);
var inst_101485 = cljs.core.ex_info.call(null,inst_101481,inst_101484);
var inst_101486 = (function(){throw inst_101485})();
var state_101524__$1 = state_101524;
var statearr_101553_101606 = state_101524__$1;
(statearr_101553_101606[(2)] = inst_101486);

(statearr_101553_101606[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (34))){
var inst_101505 = ["Subject identity does not exist: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ident)].join('');
var inst_101506 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_101507 = [(400),new cljs.core.Keyword("db","invalid-subject","db/invalid-subject",-8172837)];
var inst_101508 = cljs.core.PersistentHashMap.fromArrays(inst_101506,inst_101507);
var inst_101509 = cljs.core.ex_info.call(null,inst_101505,inst_101508);
var inst_101510 = cljs.core.async.put_BANG_.call(null,return_chan,inst_101509);
var state_101524__$1 = state_101524;
var statearr_101554_101607 = state_101524__$1;
(statearr_101554_101607[(2)] = inst_101510);

(statearr_101554_101607[(1)] = (36));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (17))){
var inst_101491 = (state_101524[(2)]);
var state_101524__$1 = state_101524;
var statearr_101555_101608 = state_101524__$1;
(statearr_101555_101608[(2)] = inst_101491);

(statearr_101555_101608[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (3))){
var inst_101413 = (state_101524[(2)]);
var inst_101414 = ["Error looking up subject id: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ident)].join('');
var inst_101415 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_101416 = [(400),new cljs.core.Keyword("db","invalid-subject","db/invalid-subject",-8172837)];
var inst_101417 = cljs.core.PersistentHashMap.fromArrays(inst_101415,inst_101416);
var inst_101418 = cljs.core.ex_info.call(null,inst_101414,inst_101417,inst_101413);
var inst_101419 = cljs.core.async.put_BANG_.call(null,return_chan,inst_101418);
var state_101524__$1 = state_101524;
var statearr_101556_101609 = state_101524__$1;
(statearr_101556_101609[(2)] = inst_101419);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101524__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (12))){
var inst_101444 = cljs.core.first.call(null,ident);
var inst_101445 = cljs.core.pr_str.call(null,inst_101444);
var inst_101446 = ["Subject ID lookup failed. The predicate ",inst_101445," does not exist."].join('');
var inst_101447 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_101448 = [(400),new cljs.core.Keyword("db","invalid-ident","db/invalid-ident",939019721)];
var inst_101449 = cljs.core.PersistentHashMap.fromArrays(inst_101447,inst_101448);
var inst_101450 = cljs.core.ex_info.call(null,inst_101446,inst_101449);
var inst_101451 = (function(){throw inst_101450})();
var state_101524__$1 = state_101524;
var statearr_101557_101610 = state_101524__$1;
(statearr_101557_101610[(2)] = inst_101451);

(statearr_101557_101610[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (2))){
var inst_101522 = (state_101524[(2)]);
var state_101524__$1 = state_101524;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_101524__$1,inst_101522);
} else {
if((state_val_101525 === (23))){
var inst_101471 = (state_101524[(9)]);
var inst_101475 = inst_101471.s;
var state_101524__$1 = state_101524;
var statearr_101558_101611 = state_101524__$1;
(statearr_101558_101611[(2)] = inst_101475);

(statearr_101558_101611[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (35))){
var state_101524__$1 = state_101524;
var statearr_101559_101612 = state_101524__$1;
(statearr_101559_101612[(1)] = (37));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (19))){
var state_101524__$1 = state_101524;
var statearr_101561_101613 = state_101524__$1;
(statearr_101561_101613[(2)] = null);

(statearr_101561_101613[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (11))){
var inst_101436 = (state_101524[(2)]);
var state_101524__$1 = state_101524;
var statearr_101562_101614 = state_101524__$1;
(statearr_101562_101614[(2)] = inst_101436);

(statearr_101562_101614[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (9))){
var state_101524__$1 = state_101524;
var statearr_101563_101615 = state_101524__$1;
(statearr_101563_101615[(2)] = ident);

(statearr_101563_101615[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (5))){
var inst_101425 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_101426 = [ident];
var inst_101427 = (new cljs.core.PersistentVector(null,1,(5),inst_101425,inst_101426,null));
var inst_101428 = fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"spot","spot",-1706962147),cljs.core._EQ_,inst_101427);
var state_101524__$1 = state_101524;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101524__$1,(8),inst_101428);
} else {
if((state_val_101525 === (14))){
var inst_101493 = (state_101524[(2)]);
var state_101524__$1 = state_101524;
var statearr_101564_101616 = state_101524__$1;
(statearr_101564_101616[(2)] = inst_101493);

(statearr_101564_101616[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (26))){
var state_101524__$1 = state_101524;
var statearr_101565_101617 = state_101524__$1;
(statearr_101565_101617[(2)] = null);

(statearr_101565_101617[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (16))){
var state_101524__$1 = state_101524;
var statearr_101566_101618 = state_101524__$1;
(statearr_101566_101618[(1)] = (25));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (38))){
var state_101524__$1 = state_101524;
var statearr_101568_101619 = state_101524__$1;
(statearr_101568_101619[(2)] = null);

(statearr_101568_101619[(1)] = (39));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (30))){
var inst_101520 = (state_101524[(2)]);
var state_101524__$1 = state_101524;
var statearr_101569_101620 = state_101524__$1;
(statearr_101569_101620[(2)] = inst_101520);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101524__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (10))){
var state_101524__$1 = state_101524;
var statearr_101570_101621 = state_101524__$1;
(statearr_101570_101621[(2)] = null);

(statearr_101570_101621[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (18))){
var inst_101465 = (state_101524[(8)]);
var inst_101464 = (state_101524[(2)]);
var inst_101465__$1 = fluree.db.util.async.throw_err.call(null,inst_101464);
var inst_101466 = (inst_101465__$1 == null);
var state_101524__$1 = (function (){var statearr_101571 = state_101524;
(statearr_101571[(8)] = inst_101465__$1);

return statearr_101571;
})();
if(cljs.core.truth_(inst_101466)){
var statearr_101572_101622 = state_101524__$1;
(statearr_101572_101622[(1)] = (19));

} else {
var statearr_101573_101623 = state_101524__$1;
(statearr_101573_101623[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (37))){
var inst_101513 = cljs.core.async.close_BANG_.call(null,return_chan);
var state_101524__$1 = state_101524;
var statearr_101574_101624 = state_101524__$1;
(statearr_101574_101624[(2)] = inst_101513);

(statearr_101574_101624[(1)] = (39));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101525 === (8))){
var inst_101430 = (state_101524[(2)]);
var inst_101431 = fluree.db.util.async.throw_err.call(null,inst_101430);
var inst_101432 = cljs.core.not_empty.call(null,inst_101431);
var state_101524__$1 = state_101524;
if(cljs.core.truth_(inst_101432)){
var statearr_101575_101625 = state_101524__$1;
(statearr_101575_101625[(1)] = (9));

} else {
var statearr_101576_101626 = state_101524__$1;
(statearr_101576_101626[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto___101581,return_chan))
;
return ((function (switch__86624__auto__,c__86675__auto___101581,return_chan){
return (function() {
var fluree$db$graphdb$subid_$_state_machine__86625__auto__ = null;
var fluree$db$graphdb$subid_$_state_machine__86625__auto____0 = (function (){
var statearr_101577 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_101577[(0)] = fluree$db$graphdb$subid_$_state_machine__86625__auto__);

(statearr_101577[(1)] = (1));

return statearr_101577;
});
var fluree$db$graphdb$subid_$_state_machine__86625__auto____1 = (function (state_101524){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_101524);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e101578){if((e101578 instanceof Object)){
var ex__86628__auto__ = e101578;
var statearr_101579_101627 = state_101524;
(statearr_101579_101627[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101524);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e101578;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__101628 = state_101524;
state_101524 = G__101628;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$graphdb$subid_$_state_machine__86625__auto__ = function(state_101524){
switch(arguments.length){
case 0:
return fluree$db$graphdb$subid_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$graphdb$subid_$_state_machine__86625__auto____1.call(this,state_101524);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$subid_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$subid_$_state_machine__86625__auto____0;
fluree$db$graphdb$subid_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$subid_$_state_machine__86625__auto____1;
return fluree$db$graphdb$subid_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___101581,return_chan))
})();
var state__86677__auto__ = (function (){var statearr_101580 = f__86676__auto__.call(null);
(statearr_101580[(6)] = c__86675__auto___101581);

return statearr_101580;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___101581,return_chan))
);


return return_chan;
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {fluree.db.dbproto.IFlureeDb}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.graphdb.GraphDb = (function (conn,network,dbid,block,t,tt_id,stats,spot,psot,post,opst,schema,settings,index_configs,schema_cache,novelty,permissions,fork,fork_block,current_db_fn,__meta,__extmap,__hash){
this.conn = conn;
this.network = network;
this.dbid = dbid;
this.block = block;
this.t = t;
this.tt_id = tt_id;
this.stats = stats;
this.spot = spot;
this.psot = psot;
this.post = post;
this.opst = opst;
this.schema = schema;
this.settings = settings;
this.index_configs = index_configs;
this.schema_cache = schema_cache;
this.novelty = novelty;
this.permissions = permissions;
this.fork = fork;
this.fork_block = fork_block;
this.current_db_fn = current_db_fn;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.graphdb.GraphDb.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k101630,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__101634 = k101630;
var G__101634__$1 = (((G__101634 instanceof cljs.core.Keyword))?G__101634.fqn:null);
switch (G__101634__$1) {
case "conn":
return self__.conn;

break;
case "network":
return self__.network;

break;
case "dbid":
return self__.dbid;

break;
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "tt-id":
return self__.tt_id;

break;
case "stats":
return self__.stats;

break;
case "spot":
return self__.spot;

break;
case "psot":
return self__.psot;

break;
case "post":
return self__.post;

break;
case "opst":
return self__.opst;

break;
case "schema":
return self__.schema;

break;
case "settings":
return self__.settings;

break;
case "index-configs":
return self__.index_configs;

break;
case "schema-cache":
return self__.schema_cache;

break;
case "novelty":
return self__.novelty;

break;
case "permissions":
return self__.permissions;

break;
case "fork":
return self__.fork;

break;
case "fork-block":
return self__.fork_block;

break;
case "current-db-fn":
return self__.current_db_fn;

break;
default:
return cljs.core.get.call(null,self__.__extmap,k101630,else__4388__auto__);

}
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.call(null,((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__101635){
var vec__101636 = p__101635;
var k__4408__auto__ = cljs.core.nth.call(null,vec__101636,(0),null);
var v__4409__auto__ = cljs.core.nth.call(null,vec__101636,(1),null);
return f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__);
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.graphdb.GraphDb{",", ","}",opts__4401__auto__,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 20, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"conn","conn",278309663),self__.conn],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"network","network",2050004697),self__.network],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"dbid","dbid",-196647356),self__.dbid],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"block","block",664686210),self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"t","t",-1397832519),self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"tt-id","tt-id",725587484),self__.tt_id],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"stats","stats",-85643011),self__.stats],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"spot","spot",-1706962147),self__.spot],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"psot","psot",2111653059),self__.psot],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"post","post",269697687),self__.post],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"opst","opst",1213963058),self__.opst],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"schema","schema",-1582001791),self__.schema],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"settings","settings",1556144875),self__.settings],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"index-configs","index-configs",1053959280),self__.index_configs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),self__.schema_cache],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"novelty","novelty",-1590246024),self__.novelty],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"permissions","permissions",67803075),self__.permissions],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"fork","fork",1062974235),self__.fork],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"fork-block","fork-block",178387923),self__.fork_block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"current-db-fn","current-db-fn",239646336),self__.current_db_fn],null))], null),self__.__extmap));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__101629){
var self__ = this;
var G__101629__$1 = this;
return (new cljs.core.RecordIter((0),G__101629__$1,20,new cljs.core.PersistentVector(null, 20, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"conn","conn",278309663),new cljs.core.Keyword(null,"network","network",2050004697),new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"tt-id","tt-id",725587484),new cljs.core.Keyword(null,"stats","stats",-85643011),new cljs.core.Keyword(null,"spot","spot",-1706962147),new cljs.core.Keyword(null,"psot","psot",2111653059),new cljs.core.Keyword(null,"post","post",269697687),new cljs.core.Keyword(null,"opst","opst",1213963058),new cljs.core.Keyword(null,"schema","schema",-1582001791),new cljs.core.Keyword(null,"settings","settings",1556144875),new cljs.core.Keyword(null,"index-configs","index-configs",1053959280),new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),new cljs.core.Keyword(null,"novelty","novelty",-1590246024),new cljs.core.Keyword(null,"permissions","permissions",67803075),new cljs.core.Keyword(null,"fork","fork",1062974235),new cljs.core.Keyword(null,"fork-block","fork-block",178387923),new cljs.core.Keyword(null,"current-db-fn","current-db-fn",239646336)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (20 + cljs.core.count.call(null,self__.__extmap));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (485580545 ^ cljs.core.hash_unordered_coll.call(null,coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
.call(null,this__4381__auto____$1);
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this101631,other101632){
var self__ = this;
var this101631__$1 = this;
return (((!((other101632 == null)))) && ((this101631__$1.constructor === other101632.constructor)) && (cljs.core._EQ_.call(null,this101631__$1.conn,other101632.conn)) && (cljs.core._EQ_.call(null,this101631__$1.network,other101632.network)) && (cljs.core._EQ_.call(null,this101631__$1.dbid,other101632.dbid)) && (cljs.core._EQ_.call(null,this101631__$1.block,other101632.block)) && (cljs.core._EQ_.call(null,this101631__$1.t,other101632.t)) && (cljs.core._EQ_.call(null,this101631__$1.tt_id,other101632.tt_id)) && (cljs.core._EQ_.call(null,this101631__$1.stats,other101632.stats)) && (cljs.core._EQ_.call(null,this101631__$1.spot,other101632.spot)) && (cljs.core._EQ_.call(null,this101631__$1.psot,other101632.psot)) && (cljs.core._EQ_.call(null,this101631__$1.post,other101632.post)) && (cljs.core._EQ_.call(null,this101631__$1.opst,other101632.opst)) && (cljs.core._EQ_.call(null,this101631__$1.schema,other101632.schema)) && (cljs.core._EQ_.call(null,this101631__$1.settings,other101632.settings)) && (cljs.core._EQ_.call(null,this101631__$1.index_configs,other101632.index_configs)) && (cljs.core._EQ_.call(null,this101631__$1.schema_cache,other101632.schema_cache)) && (cljs.core._EQ_.call(null,this101631__$1.novelty,other101632.novelty)) && (cljs.core._EQ_.call(null,this101631__$1.permissions,other101632.permissions)) && (cljs.core._EQ_.call(null,this101631__$1.fork,other101632.fork)) && (cljs.core._EQ_.call(null,this101631__$1.fork_block,other101632.fork_block)) && (cljs.core._EQ_.call(null,this101631__$1.current_db_fn,other101632.current_db_fn)) && (cljs.core._EQ_.call(null,this101631__$1.__extmap,other101632.__extmap)));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 20, [new cljs.core.Keyword(null,"current-db-fn","current-db-fn",239646336),null,new cljs.core.Keyword(null,"schema","schema",-1582001791),null,new cljs.core.Keyword(null,"block","block",664686210),null,new cljs.core.Keyword(null,"psot","psot",2111653059),null,new cljs.core.Keyword(null,"permissions","permissions",67803075),null,new cljs.core.Keyword(null,"dbid","dbid",-196647356),null,new cljs.core.Keyword(null,"settings","settings",1556144875),null,new cljs.core.Keyword(null,"index-configs","index-configs",1053959280),null,new cljs.core.Keyword(null,"opst","opst",1213963058),null,new cljs.core.Keyword(null,"fork-block","fork-block",178387923),null,new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),null,new cljs.core.Keyword(null,"post","post",269697687),null,new cljs.core.Keyword(null,"novelty","novelty",-1590246024),null,new cljs.core.Keyword(null,"t","t",-1397832519),null,new cljs.core.Keyword(null,"network","network",2050004697),null,new cljs.core.Keyword(null,"fork","fork",1062974235),null,new cljs.core.Keyword(null,"tt-id","tt-id",725587484),null,new cljs.core.Keyword(null,"stats","stats",-85643011),null,new cljs.core.Keyword(null,"spot","spot",-1706962147),null,new cljs.core.Keyword(null,"conn","conn",278309663),null], null), null),k__4395__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__101629){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__101639 = cljs.core.keyword_identical_QMARK_;
var expr__101640 = k__4393__auto__;
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"conn","conn",278309663),expr__101640))){
return (new fluree.db.graphdb.GraphDb(G__101629,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"network","network",2050004697),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,G__101629,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"dbid","dbid",-196647356),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,G__101629,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"block","block",664686210),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,G__101629,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"t","t",-1397832519),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,G__101629,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"tt-id","tt-id",725587484),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,G__101629,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"stats","stats",-85643011),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,G__101629,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"spot","spot",-1706962147),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,G__101629,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"psot","psot",2111653059),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,G__101629,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"post","post",269697687),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,G__101629,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"opst","opst",1213963058),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,G__101629,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"schema","schema",-1582001791),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,G__101629,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"settings","settings",1556144875),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,G__101629,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"index-configs","index-configs",1053959280),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,G__101629,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,G__101629,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"novelty","novelty",-1590246024),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,G__101629,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"permissions","permissions",67803075),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,G__101629,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"fork","fork",1062974235),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,G__101629,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"fork-block","fork-block",178387923),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,G__101629,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__101639.call(null,new cljs.core.Keyword(null,"current-db-fn","current-db-fn",239646336),expr__101640))){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,G__101629,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4393__auto__,G__101629),null));
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 20, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"conn","conn",278309663),self__.conn,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"network","network",2050004697),self__.network,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"dbid","dbid",-196647356),self__.dbid,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"block","block",664686210),self__.block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"t","t",-1397832519),self__.t,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"tt-id","tt-id",725587484),self__.tt_id,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"stats","stats",-85643011),self__.stats,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"spot","spot",-1706962147),self__.spot,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"psot","psot",2111653059),self__.psot,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"post","post",269697687),self__.post,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"opst","opst",1213963058),self__.opst,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"schema","schema",-1582001791),self__.schema,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"settings","settings",1556144875),self__.settings,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"index-configs","index-configs",1053959280),self__.index_configs,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),self__.schema_cache,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"novelty","novelty",-1590246024),self__.novelty,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"permissions","permissions",67803075),self__.permissions,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"fork","fork",1062974235),self__.fork,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"fork-block","fork-block",178387923),self__.fork_block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"current-db-fn","current-db-fn",239646336),self__.current_db_fn,null))], null),self__.__extmap));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__101629){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,G__101629,self__.__extmap,self__.__hash));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4391__auto__,(0)),cljs.core._nth.call(null,entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_latest_db$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,this$__$1){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,this$__$1){
return (function (state_101654){
var state_val_101655 = (state_101654[(1)]);
if((state_val_101655 === (1))){
var state_101654__$1 = state_101654;
var statearr_101656_101872 = state_101654__$1;
(statearr_101656_101872[(2)] = null);

(statearr_101656_101872[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101655 === (2))){
var inst_101652 = (state_101654[(2)]);
var state_101654__$1 = state_101654;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_101654__$1,inst_101652);
} else {
if((state_val_101655 === (3))){
var inst_101642 = (state_101654[(2)]);
var state_101654__$1 = state_101654;
var statearr_101657_101873 = state_101654__$1;
(statearr_101657_101873[(2)] = inst_101642);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101654__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101655 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_101654,(3),Error,null,(2));
var inst_101646 = self__.current_db_fn.call(null);
var state_101654__$1 = state_101654;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101654__$1,(5),inst_101646);
} else {
if((state_val_101655 === (5))){
var inst_101648 = (state_101654[(2)]);
var inst_101649 = fluree.db.util.async.throw_err.call(null,inst_101648);
var inst_101650 = cljs.core.assoc.call(null,inst_101649,new cljs.core.Keyword(null,"permissions","permissions",67803075),self__.permissions);
var state_101654__$1 = state_101654;
var statearr_101658_101874 = state_101654__$1;
(statearr_101658_101874[(2)] = inst_101650);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101654__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto__,this$__$1))
;
return ((function (switch__86624__auto__,c__86675__auto__,this$__$1){
return (function() {
var fluree$db$graphdb$state_machine__86625__auto__ = null;
var fluree$db$graphdb$state_machine__86625__auto____0 = (function (){
var statearr_101659 = [null,null,null,null,null,null,null];
(statearr_101659[(0)] = fluree$db$graphdb$state_machine__86625__auto__);

(statearr_101659[(1)] = (1));

return statearr_101659;
});
var fluree$db$graphdb$state_machine__86625__auto____1 = (function (state_101654){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_101654);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e101660){if((e101660 instanceof Object)){
var ex__86628__auto__ = e101660;
var statearr_101661_101875 = state_101654;
(statearr_101661_101875[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101654);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e101660;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__101876 = state_101654;
state_101654 = G__101876;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$graphdb$state_machine__86625__auto__ = function(state_101654){
switch(arguments.length){
case 0:
return fluree$db$graphdb$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$graphdb$state_machine__86625__auto____1.call(this,state_101654);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$state_machine__86625__auto____0;
fluree$db$graphdb$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$state_machine__86625__auto____1;
return fluree$db$graphdb$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,this$__$1))
})();
var state__86677__auto__ = (function (){var statearr_101662 = f__86676__auto__.call(null);
(statearr_101662[(6)] = c__86675__auto__);

return statearr_101662;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,this$__$1))
);

return c__86675__auto__;
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_add_predicate_to_idx$arity$2 = (function (this$,pred_id){
var self__ = this;
var this$__$1 = this;
return fluree.db.graphdb.add_predicate_to_idx.call(null,this$__$1,pred_id);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_c_prop$arity$3 = (function (this$,property,collection){
var self__ = this;
var this$__$1 = this;
if(cljs.core.truth_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"name","name",1843675177),null,new cljs.core.Keyword(null,"id","id",-1388402092),null,new cljs.core.Keyword(null,"sid","sid",1815016414),null], null), null).call(null,property))){
} else {
throw (new Error(["Assert failed: ",["Invalid collection property: ",cljs.core.pr_str.call(null,property)].join(''),"\n","(#{:name :id :sid} property)"].join('')));
}

if(cljs.core.neg_int_QMARK_.call(null,collection)){
return cljs.core.get_in.call(null,self__.schema,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"coll","coll",1647737163),"_tx",property], null));
} else {
return cljs.core.get_in.call(null,self__.schema,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"coll","coll",1647737163),collection,property], null));
}
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_p_prop$arity$3 = (function (this$,property,predicate){
var self__ = this;
var this$__$1 = this;
if(cljs.core.truth_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 17, [new cljs.core.Keyword(null,"unique","unique",329397282),null,new cljs.core.Keyword(null,"restrictCollection","restrictCollection",-564261275),null,new cljs.core.Keyword(null,"index","index",-1531685915),null,new cljs.core.Keyword(null,"name","name",1843675177),null,new cljs.core.Keyword(null,"noHistory","noHistory",-1975155222),null,new cljs.core.Keyword(null,"type","type",1174270348),null,new cljs.core.Keyword(null,"txSpec","txSpec",-570527155),null,new cljs.core.Keyword(null,"component","component",1555936782),null,new cljs.core.Keyword(null,"txSpecDoc","txSpecDoc",-103492081),null,new cljs.core.Keyword(null,"spec","spec",347520401),null,new cljs.core.Keyword(null,"multi","multi",-190293005),null,new cljs.core.Keyword(null,"id","id",-1388402092),null,new cljs.core.Keyword(null,"specDoc","specDoc",-1212731692),null,new cljs.core.Keyword(null,"idx?","idx?",-564590377),null,new cljs.core.Keyword(null,"ref?","ref?",1932693720),null,new cljs.core.Keyword(null,"upsert","upsert",1416724984),null,new cljs.core.Keyword(null,"restrictTag","restrictTag",-1004793733),null], null), null).call(null,property))){
} else {
throw (new Error(["Assert failed: ",["Invalid predicate property: ",cljs.core.pr_str.call(null,property)].join(''),"\n","(#{:unique :restrictCollection :index :name :noHistory :type :txSpec :component :txSpecDoc :spec :multi :id :specDoc :idx? :ref? :upsert :restrictTag} property)"].join('')));
}

var G__101663 = cljs.core.get_in.call(null,self__.schema,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"pred","pred",1927423397),predicate,property], null));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"restrictCollection","restrictCollection",-564261275),property)){
return this$__$1.fluree$db$dbproto$IFlureeDb$_c_prop$arity$3(null,new cljs.core.Keyword(null,"id","id",-1388402092),G__101663);
} else {
return G__101663;
}
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_with$arity$3 = (function (this$,block__$1,flakes){
var self__ = this;
var this$__$1 = this;
return fluree.db.graphdb.with$.call(null,this$__$1,block__$1,flakes);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_subid$arity$2 = (function (this$,ident){
var self__ = this;
var this$__$1 = this;
return fluree.db.graphdb.subid.call(null,this$__$1,ident,false);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_subid$arity$3 = (function (this$,ident,strict_QMARK_){
var self__ = this;
var this$__$1 = this;
return fluree.db.graphdb.subid.call(null,this$__$1,ident,strict_QMARK_);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_search$arity$2 = (function (this$,fparts){
var self__ = this;
var this$__$1 = this;
return fluree.db.query.range.search.call(null,this$__$1,fparts);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_rootdb$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return cljs.core.assoc.call(null,this$__$1,new cljs.core.Keyword(null,"permissions","permissions",67803075),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"root?","root?",-2045639518),true,new cljs.core.Keyword(null,"collection","collection",-683361892),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"all?","all?",1103779750),true], null),new cljs.core.Keyword(null,"predicate","predicate",-1742501860),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"all?","all?",1103779750),true], null)], null));
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_forward_time_travel$arity$2 = (function (db,flakes){
var self__ = this;
var db__$1 = this;
return fluree.db.graphdb.forward_time_travel.call(null,db__$1,null,flakes);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_forward_time_travel$arity$3 = (function (db,tt_id__$1,flakes){
var self__ = this;
var db__$1 = this;
return fluree.db.graphdb.forward_time_travel.call(null,db__$1,tt_id__$1,flakes);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_query$arity$2 = (function (this$,query_map){
var self__ = this;
var this$__$1 = this;
return fluree.db.query.fql.query.call(null,this$__$1,query_map);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_query$arity$3 = (function (this$,query_map,opts){
var self__ = this;
var this$__$1 = this;
return fluree.db.query.fql.query.call(null,this$__$1,query_map,opts);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_with_t$arity$2 = (function (this$,flakes){
var self__ = this;
var this$__$1 = this;
return fluree.db.graphdb.with_t.call(null,this$__$1,flakes);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_tag$arity$2 = (function (this$,tag_id){
var self__ = this;
var this$__$1 = this;
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,this$__$1){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,this$__$1){
return (function (state_101692){
var state_val_101693 = (state_101692[(1)]);
if((state_val_101693 === (7))){
var inst_101676 = (state_101692[(7)]);
var inst_101680 = cljs.core.first.call(null,inst_101676);
var state_101692__$1 = state_101692;
var statearr_101694_101877 = state_101692__$1;
(statearr_101694_101877[(2)] = inst_101680);

(statearr_101694_101877[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101693 === (1))){
var state_101692__$1 = state_101692;
var statearr_101695_101878 = state_101692__$1;
(statearr_101695_101878[(2)] = null);

(statearr_101695_101878[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101693 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_101692,(3),Error,null,(2));
var inst_101669 = fluree.db.dbproto._rootdb.call(null,this$__$1);
var inst_101670 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_101671 = [tag_id,(30)];
var inst_101672 = (new cljs.core.PersistentVector(null,2,(5),inst_101670,inst_101671,null));
var inst_101673 = fluree.db.query.range.index_range.call(null,inst_101669,new cljs.core.Keyword(null,"spot","spot",-1706962147),cljs.core._EQ_,inst_101672);
var state_101692__$1 = state_101692;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101692__$1,(5),inst_101673);
} else {
if((state_val_101693 === (6))){
var state_101692__$1 = state_101692;
var statearr_101696_101879 = state_101692__$1;
(statearr_101696_101879[(2)] = null);

(statearr_101696_101879[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101693 === (3))){
var inst_101664 = (state_101692[(2)]);
var state_101692__$1 = state_101692;
var statearr_101697_101880 = state_101692__$1;
(statearr_101697_101880[(2)] = inst_101664);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101692__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101693 === (2))){
var inst_101690 = (state_101692[(2)]);
var state_101692__$1 = state_101692;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_101692__$1,inst_101690);
} else {
if((state_val_101693 === (11))){
var inst_101688 = (state_101692[(2)]);
var state_101692__$1 = state_101692;
var statearr_101698_101881 = state_101692__$1;
(statearr_101698_101881[(2)] = inst_101688);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101692__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101693 === (9))){
var state_101692__$1 = state_101692;
var statearr_101699_101882 = state_101692__$1;
(statearr_101699_101882[(2)] = null);

(statearr_101699_101882[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101693 === (5))){
var inst_101676 = (state_101692[(7)]);
var inst_101675 = (state_101692[(2)]);
var inst_101676__$1 = fluree.db.util.async.throw_err.call(null,inst_101675);
var inst_101677 = (inst_101676__$1 == null);
var state_101692__$1 = (function (){var statearr_101700 = state_101692;
(statearr_101700[(7)] = inst_101676__$1);

return statearr_101700;
})();
if(cljs.core.truth_(inst_101677)){
var statearr_101701_101883 = state_101692__$1;
(statearr_101701_101883[(1)] = (6));

} else {
var statearr_101702_101884 = state_101692__$1;
(statearr_101702_101884[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101693 === (10))){
var inst_101682 = (state_101692[(8)]);
var inst_101686 = inst_101682.o;
var state_101692__$1 = state_101692;
var statearr_101703_101885 = state_101692__$1;
(statearr_101703_101885[(2)] = inst_101686);

(statearr_101703_101885[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101693 === (8))){
var inst_101682 = (state_101692[(8)]);
var inst_101682__$1 = (state_101692[(2)]);
var inst_101683 = (inst_101682__$1 == null);
var state_101692__$1 = (function (){var statearr_101704 = state_101692;
(statearr_101704[(8)] = inst_101682__$1);

return statearr_101704;
})();
if(cljs.core.truth_(inst_101683)){
var statearr_101705_101886 = state_101692__$1;
(statearr_101705_101886[(1)] = (9));

} else {
var statearr_101706_101887 = state_101692__$1;
(statearr_101706_101887[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,this$__$1))
;
return ((function (switch__86624__auto__,c__86675__auto__,this$__$1){
return (function() {
var fluree$db$graphdb$state_machine__86625__auto__ = null;
var fluree$db$graphdb$state_machine__86625__auto____0 = (function (){
var statearr_101707 = [null,null,null,null,null,null,null,null,null];
(statearr_101707[(0)] = fluree$db$graphdb$state_machine__86625__auto__);

(statearr_101707[(1)] = (1));

return statearr_101707;
});
var fluree$db$graphdb$state_machine__86625__auto____1 = (function (state_101692){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_101692);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e101708){if((e101708 instanceof Object)){
var ex__86628__auto__ = e101708;
var statearr_101709_101888 = state_101692;
(statearr_101709_101888[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101692);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e101708;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__101889 = state_101692;
state_101692 = G__101889;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$graphdb$state_machine__86625__auto__ = function(state_101692){
switch(arguments.length){
case 0:
return fluree$db$graphdb$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$graphdb$state_machine__86625__auto____1.call(this,state_101692);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$state_machine__86625__auto____0;
fluree$db$graphdb$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$state_machine__86625__auto____1;
return fluree$db$graphdb$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,this$__$1))
})();
var state__86677__auto__ = (function (){var statearr_101710 = f__86676__auto__.call(null);
(statearr_101710[(6)] = c__86675__auto__);

return statearr_101710;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,this$__$1))
);

return c__86675__auto__;
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_tag$arity$3 = (function (this$,tag_id,pred){
var self__ = this;
var this$__$1 = this;
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,this$__$1){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,this$__$1){
return (function (state_101743){
var state_val_101744 = (state_101743[(1)]);
if((state_val_101744 === (7))){
var inst_101720 = (state_101743[(2)]);
var inst_101721 = fluree.db.dbproto._tag.call(null,this$__$1,tag_id);
var state_101743__$1 = (function (){var statearr_101745 = state_101743;
(statearr_101745[(7)] = inst_101720);

return statearr_101745;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101743__$1,(8),inst_101721);
} else {
if((state_val_101744 === (1))){
var state_101743__$1 = state_101743;
var statearr_101746_101890 = state_101743__$1;
(statearr_101746_101890[(2)] = null);

(statearr_101746_101890[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_101743,(3),Error,null,(2));
var inst_101715 = typeof pred === 'string';
var state_101743__$1 = state_101743;
if(cljs.core.truth_(inst_101715)){
var statearr_101747_101891 = state_101743__$1;
(statearr_101747_101891[(1)] = (5));

} else {
var statearr_101748_101892 = state_101743__$1;
(statearr_101748_101892[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (15))){
var inst_101724 = (state_101743[(8)]);
var inst_101732 = clojure.string.split.call(null,inst_101724,/:/);
var inst_101733 = cljs.core.second.call(null,inst_101732);
var state_101743__$1 = state_101743;
var statearr_101749_101893 = state_101743__$1;
(statearr_101749_101893[(2)] = inst_101733);

(statearr_101749_101893[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (13))){
var state_101743__$1 = state_101743;
var statearr_101750_101894 = state_101743__$1;
(statearr_101750_101894[(2)] = null);

(statearr_101750_101894[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (6))){
var inst_101718 = fluree.db.dbproto._p_prop.call(null,this$__$1,new cljs.core.Keyword(null,"name","name",1843675177),pred);
var state_101743__$1 = state_101743;
var statearr_101751_101895 = state_101743__$1;
(statearr_101751_101895[(2)] = inst_101718);

(statearr_101751_101895[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (17))){
var inst_101736 = (state_101743[(2)]);
var state_101743__$1 = state_101743;
var statearr_101752_101896 = state_101743__$1;
(statearr_101752_101896[(2)] = inst_101736);

(statearr_101752_101896[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (3))){
var inst_101711 = (state_101743[(2)]);
var state_101743__$1 = state_101743;
var statearr_101753_101897 = state_101743__$1;
(statearr_101753_101897[(2)] = inst_101711);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101743__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (12))){
var inst_101724 = (state_101743[(8)]);
var inst_101730 = clojure.string.includes_QMARK_.call(null,inst_101724,":");
var state_101743__$1 = state_101743;
if(inst_101730){
var statearr_101754_101898 = state_101743__$1;
(statearr_101754_101898[(1)] = (15));

} else {
var statearr_101755_101899 = state_101743__$1;
(statearr_101755_101899[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (2))){
var inst_101741 = (state_101743[(2)]);
var state_101743__$1 = state_101743;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_101743__$1,inst_101741);
} else {
if((state_val_101744 === (11))){
var inst_101728 = (state_101743[(2)]);
var state_101743__$1 = state_101743;
if(cljs.core.truth_(inst_101728)){
var statearr_101756_101900 = state_101743__$1;
(statearr_101756_101900[(1)] = (12));

} else {
var statearr_101757_101901 = state_101743__$1;
(statearr_101757_101901[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (9))){
var inst_101724 = (state_101743[(8)]);
var state_101743__$1 = state_101743;
var statearr_101758_101902 = state_101743__$1;
(statearr_101758_101902[(2)] = inst_101724);

(statearr_101758_101902[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (5))){
var state_101743__$1 = state_101743;
var statearr_101759_101903 = state_101743__$1;
(statearr_101759_101903[(2)] = pred);

(statearr_101759_101903[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (14))){
var inst_101739 = (state_101743[(2)]);
var state_101743__$1 = state_101743;
var statearr_101760_101904 = state_101743__$1;
(statearr_101760_101904[(2)] = inst_101739);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101743__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (16))){
var inst_101724 = (state_101743[(8)]);
var state_101743__$1 = state_101743;
var statearr_101761_101905 = state_101743__$1;
(statearr_101761_101905[(2)] = inst_101724);

(statearr_101761_101905[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (10))){
var inst_101720 = (state_101743[(7)]);
var state_101743__$1 = state_101743;
var statearr_101762_101906 = state_101743__$1;
(statearr_101762_101906[(2)] = inst_101720);

(statearr_101762_101906[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101744 === (8))){
var inst_101720 = (state_101743[(7)]);
var inst_101723 = (state_101743[(2)]);
var inst_101724 = fluree.db.util.async.throw_err.call(null,inst_101723);
var state_101743__$1 = (function (){var statearr_101763 = state_101743;
(statearr_101763[(8)] = inst_101724);

return statearr_101763;
})();
if(cljs.core.truth_(inst_101720)){
var statearr_101764_101907 = state_101743__$1;
(statearr_101764_101907[(1)] = (9));

} else {
var statearr_101765_101908 = state_101743__$1;
(statearr_101765_101908[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,this$__$1))
;
return ((function (switch__86624__auto__,c__86675__auto__,this$__$1){
return (function() {
var fluree$db$graphdb$state_machine__86625__auto__ = null;
var fluree$db$graphdb$state_machine__86625__auto____0 = (function (){
var statearr_101766 = [null,null,null,null,null,null,null,null,null];
(statearr_101766[(0)] = fluree$db$graphdb$state_machine__86625__auto__);

(statearr_101766[(1)] = (1));

return statearr_101766;
});
var fluree$db$graphdb$state_machine__86625__auto____1 = (function (state_101743){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_101743);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e101767){if((e101767 instanceof Object)){
var ex__86628__auto__ = e101767;
var statearr_101768_101909 = state_101743;
(statearr_101768_101909[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101743);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e101767;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__101910 = state_101743;
state_101743 = G__101910;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$graphdb$state_machine__86625__auto__ = function(state_101743){
switch(arguments.length){
case 0:
return fluree$db$graphdb$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$graphdb$state_machine__86625__auto____1.call(this,state_101743);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$state_machine__86625__auto____0;
fluree$db$graphdb$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$state_machine__86625__auto____1;
return fluree$db$graphdb$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,this$__$1))
})();
var state__86677__auto__ = (function (){var statearr_101769 = f__86676__auto__.call(null);
(statearr_101769[(6)] = c__86675__auto__);

return statearr_101769;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,this$__$1))
);

return c__86675__auto__;
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_tag_id$arity$2 = (function (this$,tag_name){
var self__ = this;
var this$__$1 = this;
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,this$__$1){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,this$__$1){
return (function (state_101798){
var state_val_101799 = (state_101798[(1)]);
if((state_val_101799 === (7))){
var inst_101782 = (state_101798[(7)]);
var inst_101786 = cljs.core.first.call(null,inst_101782);
var state_101798__$1 = state_101798;
var statearr_101800_101911 = state_101798__$1;
(statearr_101800_101911[(2)] = inst_101786);

(statearr_101800_101911[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101799 === (1))){
var state_101798__$1 = state_101798;
var statearr_101801_101912 = state_101798__$1;
(statearr_101801_101912[(2)] = null);

(statearr_101801_101912[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101799 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_101798,(3),Error,null,(2));
var inst_101775 = fluree.db.dbproto._rootdb.call(null,this$__$1);
var inst_101776 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_101777 = [(30),tag_name];
var inst_101778 = (new cljs.core.PersistentVector(null,2,(5),inst_101776,inst_101777,null));
var inst_101779 = fluree.db.query.range.index_range.call(null,inst_101775,new cljs.core.Keyword(null,"post","post",269697687),cljs.core._EQ_,inst_101778);
var state_101798__$1 = state_101798;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101798__$1,(5),inst_101779);
} else {
if((state_val_101799 === (6))){
var state_101798__$1 = state_101798;
var statearr_101802_101913 = state_101798__$1;
(statearr_101802_101913[(2)] = null);

(statearr_101802_101913[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101799 === (3))){
var inst_101770 = (state_101798[(2)]);
var state_101798__$1 = state_101798;
var statearr_101803_101914 = state_101798__$1;
(statearr_101803_101914[(2)] = inst_101770);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101798__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101799 === (2))){
var inst_101796 = (state_101798[(2)]);
var state_101798__$1 = state_101798;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_101798__$1,inst_101796);
} else {
if((state_val_101799 === (11))){
var inst_101794 = (state_101798[(2)]);
var state_101798__$1 = state_101798;
var statearr_101804_101915 = state_101798__$1;
(statearr_101804_101915[(2)] = inst_101794);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101798__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101799 === (9))){
var state_101798__$1 = state_101798;
var statearr_101805_101916 = state_101798__$1;
(statearr_101805_101916[(2)] = null);

(statearr_101805_101916[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101799 === (5))){
var inst_101782 = (state_101798[(7)]);
var inst_101781 = (state_101798[(2)]);
var inst_101782__$1 = fluree.db.util.async.throw_err.call(null,inst_101781);
var inst_101783 = (inst_101782__$1 == null);
var state_101798__$1 = (function (){var statearr_101806 = state_101798;
(statearr_101806[(7)] = inst_101782__$1);

return statearr_101806;
})();
if(cljs.core.truth_(inst_101783)){
var statearr_101807_101917 = state_101798__$1;
(statearr_101807_101917[(1)] = (6));

} else {
var statearr_101808_101918 = state_101798__$1;
(statearr_101808_101918[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101799 === (10))){
var inst_101788 = (state_101798[(8)]);
var inst_101792 = inst_101788.s;
var state_101798__$1 = state_101798;
var statearr_101809_101919 = state_101798__$1;
(statearr_101809_101919[(2)] = inst_101792);

(statearr_101809_101919[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101799 === (8))){
var inst_101788 = (state_101798[(8)]);
var inst_101788__$1 = (state_101798[(2)]);
var inst_101789 = (inst_101788__$1 == null);
var state_101798__$1 = (function (){var statearr_101810 = state_101798;
(statearr_101810[(8)] = inst_101788__$1);

return statearr_101810;
})();
if(cljs.core.truth_(inst_101789)){
var statearr_101811_101920 = state_101798__$1;
(statearr_101811_101920[(1)] = (9));

} else {
var statearr_101812_101921 = state_101798__$1;
(statearr_101812_101921[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,this$__$1))
;
return ((function (switch__86624__auto__,c__86675__auto__,this$__$1){
return (function() {
var fluree$db$graphdb$state_machine__86625__auto__ = null;
var fluree$db$graphdb$state_machine__86625__auto____0 = (function (){
var statearr_101813 = [null,null,null,null,null,null,null,null,null];
(statearr_101813[(0)] = fluree$db$graphdb$state_machine__86625__auto__);

(statearr_101813[(1)] = (1));

return statearr_101813;
});
var fluree$db$graphdb$state_machine__86625__auto____1 = (function (state_101798){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_101798);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e101814){if((e101814 instanceof Object)){
var ex__86628__auto__ = e101814;
var statearr_101815_101922 = state_101798;
(statearr_101815_101922[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101798);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e101814;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__101923 = state_101798;
state_101798 = G__101923;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$graphdb$state_machine__86625__auto__ = function(state_101798){
switch(arguments.length){
case 0:
return fluree$db$graphdb$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$graphdb$state_machine__86625__auto____1.call(this,state_101798);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$state_machine__86625__auto____0;
fluree$db$graphdb$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$state_machine__86625__auto____1;
return fluree$db$graphdb$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,this$__$1))
})();
var state__86677__auto__ = (function (){var statearr_101816 = f__86676__auto__.call(null);
(statearr_101816[(6)] = c__86675__auto__);

return statearr_101816;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,this$__$1))
);

return c__86675__auto__;
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_tag_id$arity$3 = (function (this$,tag_name,pred){
var self__ = this;
var this$__$1 = this;
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,this$__$1){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,this$__$1){
return (function (state_101848){
var state_val_101849 = (state_101848[(1)]);
if((state_val_101849 === (7))){
var inst_101844 = (state_101848[(2)]);
var state_101848__$1 = state_101848;
var statearr_101850_101924 = state_101848__$1;
(statearr_101850_101924[(2)] = inst_101844);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101848__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (1))){
var state_101848__$1 = state_101848;
var statearr_101851_101925 = state_101848__$1;
(statearr_101851_101925[(2)] = null);

(statearr_101851_101925[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_101848,(3),Error,null,(2));
var inst_101821 = clojure.string.includes_QMARK_.call(null,tag_name,"/");
var state_101848__$1 = state_101848;
if(inst_101821){
var statearr_101852_101926 = state_101848__$1;
(statearr_101852_101926[(1)] = (5));

} else {
var statearr_101853_101927 = state_101848__$1;
(statearr_101853_101927[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (15))){
var inst_101838 = (state_101848[(2)]);
var inst_101839 = fluree.db.util.async.throw_err.call(null,inst_101838);
var state_101848__$1 = state_101848;
var statearr_101854_101928 = state_101848__$1;
(statearr_101854_101928[(2)] = inst_101839);

(statearr_101854_101928[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (13))){
var state_101848__$1 = state_101848;
var statearr_101855_101929 = state_101848__$1;
(statearr_101855_101929[(2)] = null);

(statearr_101855_101929[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (6))){
var inst_101828 = typeof pred === 'string';
var state_101848__$1 = state_101848;
if(cljs.core.truth_(inst_101828)){
var statearr_101856_101930 = state_101848__$1;
(statearr_101856_101930[(1)] = (9));

} else {
var statearr_101857_101931 = state_101848__$1;
(statearr_101857_101931[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (3))){
var inst_101817 = (state_101848[(2)]);
var state_101848__$1 = state_101848;
var statearr_101858_101932 = state_101848__$1;
(statearr_101858_101932[(2)] = inst_101817);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101848__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (12))){
var inst_101833 = (state_101848[(7)]);
var inst_101835 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_101833),":",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tag_name)].join('');
var inst_101836 = fluree.db.dbproto._tag_id.call(null,this$__$1,inst_101835);
var state_101848__$1 = state_101848;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101848__$1,(15),inst_101836);
} else {
if((state_val_101849 === (2))){
var inst_101846 = (state_101848[(2)]);
var state_101848__$1 = state_101848;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_101848__$1,inst_101846);
} else {
if((state_val_101849 === (11))){
var inst_101833 = (state_101848[(7)]);
var inst_101833__$1 = (state_101848[(2)]);
var state_101848__$1 = (function (){var statearr_101859 = state_101848;
(statearr_101859[(7)] = inst_101833__$1);

return statearr_101859;
})();
if(cljs.core.truth_(inst_101833__$1)){
var statearr_101860_101933 = state_101848__$1;
(statearr_101860_101933[(1)] = (12));

} else {
var statearr_101861_101934 = state_101848__$1;
(statearr_101861_101934[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (9))){
var state_101848__$1 = state_101848;
var statearr_101862_101935 = state_101848__$1;
(statearr_101862_101935[(2)] = pred);

(statearr_101862_101935[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (5))){
var inst_101823 = fluree.db.dbproto._tag_id.call(null,this$__$1,tag_name);
var state_101848__$1 = state_101848;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_101848__$1,(8),inst_101823);
} else {
if((state_val_101849 === (14))){
var inst_101842 = (state_101848[(2)]);
var state_101848__$1 = state_101848;
var statearr_101863_101936 = state_101848__$1;
(statearr_101863_101936[(2)] = inst_101842);

(statearr_101863_101936[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (10))){
var inst_101831 = fluree.db.dbproto._p_prop.call(null,this$__$1,new cljs.core.Keyword(null,"name","name",1843675177),pred);
var state_101848__$1 = state_101848;
var statearr_101864_101937 = state_101848__$1;
(statearr_101864_101937[(2)] = inst_101831);

(statearr_101864_101937[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_101849 === (8))){
var inst_101825 = (state_101848[(2)]);
var inst_101826 = fluree.db.util.async.throw_err.call(null,inst_101825);
var state_101848__$1 = state_101848;
var statearr_101865_101938 = state_101848__$1;
(statearr_101865_101938[(2)] = inst_101826);

(statearr_101865_101938[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,this$__$1))
;
return ((function (switch__86624__auto__,c__86675__auto__,this$__$1){
return (function() {
var fluree$db$graphdb$state_machine__86625__auto__ = null;
var fluree$db$graphdb$state_machine__86625__auto____0 = (function (){
var statearr_101866 = [null,null,null,null,null,null,null,null];
(statearr_101866[(0)] = fluree$db$graphdb$state_machine__86625__auto__);

(statearr_101866[(1)] = (1));

return statearr_101866;
});
var fluree$db$graphdb$state_machine__86625__auto____1 = (function (state_101848){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_101848);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e101867){if((e101867 instanceof Object)){
var ex__86628__auto__ = e101867;
var statearr_101868_101939 = state_101848;
(statearr_101868_101939[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_101848);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e101867;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__101940 = state_101848;
state_101848 = G__101940;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$graphdb$state_machine__86625__auto__ = function(state_101848){
switch(arguments.length){
case 0:
return fluree$db$graphdb$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$graphdb$state_machine__86625__auto____1.call(this,state_101848);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$state_machine__86625__auto____0;
fluree$db$graphdb$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$state_machine__86625__auto____1;
return fluree$db$graphdb$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,this$__$1))
})();
var state__86677__auto__ = (function (){var statearr_101869 = f__86676__auto__.call(null);
(statearr_101869[(6)] = c__86675__auto__);

return statearr_101869;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,this$__$1))
);

return c__86675__auto__;
});

fluree.db.graphdb.GraphDb.getBasis = (function (){
return new cljs.core.PersistentVector(null, 20, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"conn","conn",1918841190,null),new cljs.core.Symbol(null,"network","network",-604431072,null),new cljs.core.Symbol(null,"dbid","dbid",1443884171,null),new cljs.core.Symbol(null,"block","block",-1989749559,null),new cljs.core.Symbol(null,"t","t",242699008,null),new cljs.core.Symbol(null,"tt-id","tt-id",-1928848285,null),new cljs.core.Symbol(null,"stats","stats",1554888516,null),new cljs.core.Symbol(null,"spot","spot",-66430620,null),new cljs.core.Symbol(null,"psot","psot",-542782710,null),new cljs.core.Symbol(null,"post","post",1910229214,null),new cljs.core.Symbol(null,"opst","opst",-1440472711,null),new cljs.core.Symbol(null,"schema","schema",58529736,null),new cljs.core.Symbol(null,"settings","settings",-1098290894,null),new cljs.core.Symbol(null,"index-configs","index-configs",-1600476489,null),new cljs.core.Symbol(null,"schema-cache","schema-cache",1403970302,null),new cljs.core.Symbol(null,"novelty","novelty",50285503,null),new cljs.core.Symbol(null,"permissions","permissions",1708334602,null),new cljs.core.Symbol(null,"fork","fork",-1591461534,null),new cljs.core.Symbol(null,"fork-block","fork-block",1818919450,null),new cljs.core.Symbol(null,"current-db-fn","current-db-fn",1880177863,null)], null);
});

fluree.db.graphdb.GraphDb.cljs$lang$type = true;

fluree.db.graphdb.GraphDb.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.graphdb/GraphDb",null,(1),null));
});

fluree.db.graphdb.GraphDb.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write.call(null,writer__4429__auto__,"fluree.db.graphdb/GraphDb");
});

/**
 * Positional factory function for fluree.db.graphdb/GraphDb.
 */
fluree.db.graphdb.__GT_GraphDb = (function fluree$db$graphdb$__GT_GraphDb(conn,network,dbid,block,t,tt_id,stats,spot,psot,post,opst,schema,settings,index_configs,schema_cache,novelty,permissions,fork,fork_block,current_db_fn){
return (new fluree.db.graphdb.GraphDb(conn,network,dbid,block,t,tt_id,stats,spot,psot,post,opst,schema,settings,index_configs,schema_cache,novelty,permissions,fork,fork_block,current_db_fn,null,null,null));
});

/**
 * Factory function for fluree.db.graphdb/GraphDb, taking a map of keywords to field values.
 */
fluree.db.graphdb.map__GT_GraphDb = (function fluree$db$graphdb$map__GT_GraphDb(G__101633){
var extmap__4424__auto__ = (function (){var G__101870 = cljs.core.dissoc.call(null,G__101633,new cljs.core.Keyword(null,"conn","conn",278309663),new cljs.core.Keyword(null,"network","network",2050004697),new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"tt-id","tt-id",725587484),new cljs.core.Keyword(null,"stats","stats",-85643011),new cljs.core.Keyword(null,"spot","spot",-1706962147),new cljs.core.Keyword(null,"psot","psot",2111653059),new cljs.core.Keyword(null,"post","post",269697687),new cljs.core.Keyword(null,"opst","opst",1213963058),new cljs.core.Keyword(null,"schema","schema",-1582001791),new cljs.core.Keyword(null,"settings","settings",1556144875),new cljs.core.Keyword(null,"index-configs","index-configs",1053959280),new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225),new cljs.core.Keyword(null,"novelty","novelty",-1590246024),new cljs.core.Keyword(null,"permissions","permissions",67803075),new cljs.core.Keyword(null,"fork","fork",1062974235),new cljs.core.Keyword(null,"fork-block","fork-block",178387923),new cljs.core.Keyword(null,"current-db-fn","current-db-fn",239646336));
if(cljs.core.record_QMARK_.call(null,G__101633)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__101870);
} else {
return G__101870;
}
})();
return (new fluree.db.graphdb.GraphDb(new cljs.core.Keyword(null,"conn","conn",278309663).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"tt-id","tt-id",725587484).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"stats","stats",-85643011).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"spot","spot",-1706962147).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"psot","psot",2111653059).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"post","post",269697687).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"opst","opst",1213963058).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"schema","schema",-1582001791).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"settings","settings",1556144875).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"index-configs","index-configs",1053959280).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"schema-cache","schema-cache",-236561225).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"novelty","novelty",-1590246024).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"permissions","permissions",67803075).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"fork","fork",1062974235).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"fork-block","fork-block",178387923).cljs$core$IFn$_invoke$arity$1(G__101633),new cljs.core.Keyword(null,"current-db-fn","current-db-fn",239646336).cljs$core$IFn$_invoke$arity$1(G__101633),null,cljs.core.not_empty.call(null,extmap__4424__auto__),null));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IPrintWithWriter$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.graphdb.GraphDb.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (db,w,opts){
var db__$1 = this;
cljs.core._write.call(null,w,"#FlureeGraphDB ");

return cljs.core._write.call(null,w,cljs.core.pr.call(null,new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"network","network",2050004697),new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(db__$1),new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(db__$1),new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(db__$1),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(db__$1),new cljs.core.Keyword(null,"stats","stats",-85643011),new cljs.core.Keyword(null,"stats","stats",-85643011).cljs$core$IFn$_invoke$arity$1(db__$1),new cljs.core.Keyword(null,"permissions","permissions",67803075),new cljs.core.Keyword(null,"permissions","permissions",67803075).cljs$core$IFn$_invoke$arity$1(db__$1)], null)));
});
fluree.db.graphdb.new_novelty_map = (function fluree$db$graphdb$new_novelty_map(index_configs){
return cljs.core.reduce.call(null,(function (m,idx){
var ss = clojure.data.avl.sorted_set_by.call(null,cljs.core.get_in.call(null,index_configs,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [idx,new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658)], null)));
return cljs.core.assoc.call(null,m,idx,ss);
}),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"size","size",1098693007),(0)], null),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"spot","spot",-1706962147),new cljs.core.Keyword(null,"psot","psot",2111653059),new cljs.core.Keyword(null,"post","post",269697687),new cljs.core.Keyword(null,"opst","opst",1213963058)], null));
});
fluree.db.graphdb.new_empty_index = (function fluree$db$graphdb$new_empty_index(conn,index_configs,network,dbid,idx){
var index_config = cljs.core.get.call(null,index_configs,idx);
var _ = (cljs.core.truth_(index_config)?null:(function(){throw (new Error(["Assert failed: ",["No index config found for index: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(idx)].join(''),"\n","index-config"].join('')))})());
var comparator = new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658).cljs$core$IFn$_invoke$arity$1(index_config);
var ___$1 = (cljs.core.truth_(comparator)?null:(function(){throw (new Error(["Assert failed: ",["No index comparator found for index: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(idx)].join(''),"\n","comparator"].join('')))})());
var first_flake = fluree.db.flake.__GT_Flake.call(null,fluree.db.util.core.max_long,(0),fluree.db.util.core.max_long,(0),true,null);
var child_node = fluree.db.storage.core.map__GT_UnresolvedNode.call(null,cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"leaf","leaf",1306118732),new cljs.core.Keyword(null,"size","size",1098693007),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"network","network",2050004697),new cljs.core.Keyword(null,"first","first",-644103046),new cljs.core.Keyword(null,"tt-id","tt-id",725587484),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"conn","conn",278309663)],[(0),dbid,index_config,true,(0),true,new cljs.core.Keyword(null,"empty","empty",767870958),(0),network,first_flake,null,null,conn]));
var children = clojure.data.avl.sorted_map_by.call(null,comparator,first_flake,child_node);
var idx_node = fluree.db.index.__GT_IndexNode.call(null,(0),(0),null,children,index_config,true);
return idx_node;
});
fluree.db.graphdb.default_index_configs = new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"spot","spot",-1706962147),fluree.db.index.map__GT_IndexConfig.call(null,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"index-type","index-type",500383962),new cljs.core.Keyword(null,"spot","spot",-1706962147),new cljs.core.Keyword(null,"comparator","comparator",2144896662),fluree.db.flake.cmp_flakes_spot,new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),fluree.db.flake.cmp_flakes_spot_novelty], null)),new cljs.core.Keyword(null,"psot","psot",2111653059),fluree.db.index.map__GT_IndexConfig.call(null,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"index-type","index-type",500383962),new cljs.core.Keyword(null,"psot","psot",2111653059),new cljs.core.Keyword(null,"comparator","comparator",2144896662),fluree.db.flake.cmp_flakes_psot,new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),fluree.db.flake.cmp_flakes_psot_novelty], null)),new cljs.core.Keyword(null,"post","post",269697687),fluree.db.index.map__GT_IndexConfig.call(null,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"index-type","index-type",500383962),new cljs.core.Keyword(null,"post","post",269697687),new cljs.core.Keyword(null,"comparator","comparator",2144896662),fluree.db.flake.cmp_flakes_post,new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),fluree.db.flake.cmp_flakes_post_novelty], null)),new cljs.core.Keyword(null,"opst","opst",1213963058),fluree.db.index.map__GT_IndexConfig.call(null,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"index-type","index-type",500383962),new cljs.core.Keyword(null,"opst","opst",1213963058),new cljs.core.Keyword(null,"comparator","comparator",2144896662),fluree.db.flake.cmp_flakes_opst,new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),fluree.db.flake.cmp_flakes_opst_novelty], null))], null);
fluree.db.graphdb.blank_db = (function fluree$db$graphdb$blank_db(conn,network,dbid,schema_cache,current_db_fn){
if(cljs.core.truth_(conn)){
} else {
throw (new Error(["Assert failed: ","No conn provided when creating new db.","\n","conn"].join('')));
}

if(cljs.core.truth_(network)){
} else {
throw (new Error(["Assert failed: ","No network provided when creating new db.","\n","network"].join('')));
}

if(cljs.core.truth_(dbid)){
} else {
throw (new Error(["Assert failed: ","No dbid provided when creating new db.","\n","dbid"].join('')));
}

var novelty = fluree.db.graphdb.new_novelty_map.call(null,fluree.db.graphdb.default_index_configs);
var permissions = new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"collection","collection",-683361892),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"all?","all?",1103779750),false], null),new cljs.core.Keyword(null,"predicate","predicate",-1742501860),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"all?","all?",1103779750),true], null),new cljs.core.Keyword(null,"root?","root?",-2045639518),true], null);
var spot = fluree.db.graphdb.new_empty_index.call(null,conn,fluree.db.graphdb.default_index_configs,network,dbid,new cljs.core.Keyword(null,"spot","spot",-1706962147));
var psot = fluree.db.graphdb.new_empty_index.call(null,conn,fluree.db.graphdb.default_index_configs,network,dbid,new cljs.core.Keyword(null,"psot","psot",2111653059));
var post = fluree.db.graphdb.new_empty_index.call(null,conn,fluree.db.graphdb.default_index_configs,network,dbid,new cljs.core.Keyword(null,"post","post",269697687));
var opst = fluree.db.graphdb.new_empty_index.call(null,conn,fluree.db.graphdb.default_index_configs,network,dbid,new cljs.core.Keyword(null,"opst","opst",1213963058));
var stats = new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"flakes","flakes",1977895739),(0),new cljs.core.Keyword(null,"size","size",1098693007),(0),new cljs.core.Keyword(null,"indexed","indexed",390758624),(0)], null);
var fork = null;
var fork_block = null;
var schema = null;
var settings = null;
return fluree.db.graphdb.__GT_GraphDb.call(null,conn,network,dbid,(0),(-1),null,stats,spot,psot,post,opst,schema,settings,fluree.db.graphdb.default_index_configs,schema_cache,novelty,permissions,fork,fork_block,current_db_fn);
});
fluree.db.graphdb.graphdb_QMARK_ = (function fluree$db$graphdb$graphdb_QMARK_(db){
return (db instanceof fluree.db.graphdb.GraphDb);
});
