// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.storage.core');
goog.require('cljs.core');
goog.require('fluree.db.serde.protocol');
goog.require('fluree.db.flake');
goog.require('clojure.data.avl');
goog.require('fluree.db.util.log');
goog.require('fluree.db.index');
goog.require('fluree.db.dbproto');
goog.require('cljs.core.async');
goog.require('fluree.db.util.core');
goog.require('fluree.db.query.schema');
/**
 * Returns truthy if the provided key exists in storage.
 */
fluree.db.storage.core.storage_exists_QMARK_ = (function fluree$db$storage$core$storage_exists_QMARK_(conn,key){
var storage_exists_fn = new cljs.core.Keyword(null,"storage-exists","storage-exists",1403264075).cljs$core$IFn$_invoke$arity$1(conn);
return storage_exists_fn.call(null,key);
});
/**
 * Reads raw bytes from storage based on provided key.
 *   Returns core async channel with eventual response
 */
fluree.db.storage.core.storage_read = (function fluree$db$storage$core$storage_read(conn,key){
var storage_read_fn = new cljs.core.Keyword(null,"storage-read","storage-read",-885692537).cljs$core$IFn$_invoke$arity$1(conn);
return storage_read_fn.call(null,key);
});
/**
 * Writes raw bytes to storage based with provided key.
 */
fluree.db.storage.core.storage_write = (function fluree$db$storage$core$storage_write(conn,key,val){
var storage_write_fn = new cljs.core.Keyword(null,"storage-write","storage-write",595144816).cljs$core$IFn$_invoke$arity$1(conn);
return storage_write_fn.call(null,key,val);
});
/**
 * Returns serializer from connection.
 */
fluree.db.storage.core.serde = (function fluree$db$storage$core$serde(conn){
return new cljs.core.Keyword(null,"serializer","serializer",-875689688).cljs$core$IFn$_invoke$arity$1(conn);
});
fluree.db.storage.core.ledger_root_key = (function fluree$db$storage$core$ledger_root_key(network,ledger_id,block){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"_root_",fluree.db.util.core.zero_pad.call(null,block,(15))].join('');
});
fluree.db.storage.core.ledger_garbage_key = (function fluree$db$storage$core$ledger_garbage_key(network,ledger_key,block){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_key),"_garbage_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block)].join('');
});
fluree.db.storage.core.ledger_node_key = (function fluree$db$storage$core$ledger_node_key(network,ledger_id,idx_type,base_id,node_type){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"_",cljs.core.name.call(null,idx_type),"_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(base_id),"-",cljs.core.str.cljs$core$IFn$_invoke$arity$1(node_type)].join('');
});
fluree.db.storage.core.ledger_block_key = (function fluree$db$storage$core$ledger_block_key(network,ledger_id,block){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"_block_",fluree.db.util.core.zero_pad.call(null,block,(15))].join('');
});
fluree.db.storage.core.ledger_block_file_path = (function fluree$db$storage$core$ledger_block_file_path(network,ledger_id,block){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"/block/",fluree.db.util.core.zero_pad.call(null,block,(15))].join('');
});
/**
 * Returns a core async channel with the requested block.
 */
fluree.db.storage.core.read_block = (function fluree$db$storage$core$read_block(conn,network,ledger_id,block){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_91853){
var state_val_91854 = (state_91853[(1)]);
if((state_val_91854 === (1))){
var state_91853__$1 = state_91853;
var statearr_91855_91867 = state_91853__$1;
(statearr_91855_91867[(2)] = null);

(statearr_91855_91867[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91854 === (2))){
var inst_91851 = (state_91853[(2)]);
var state_91853__$1 = state_91853;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_91853__$1,inst_91851);
} else {
if((state_val_91854 === (3))){
var inst_91835 = (state_91853[(2)]);
var state_91853__$1 = state_91853;
var statearr_91856_91868 = state_91853__$1;
(statearr_91856_91868[(2)] = inst_91835);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91853__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91854 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_91853,(3),Error,null,(2));
var inst_91839 = fluree.db.storage.core.ledger_block_key.call(null,network,ledger_id,block);
var inst_91840 = fluree.db.storage.core.storage_read.call(null,conn,inst_91839);
var state_91853__$1 = state_91853;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_91853__$1,(5),inst_91840);
} else {
if((state_val_91854 === (5))){
var inst_91843 = (state_91853[(7)]);
var inst_91842 = (state_91853[(2)]);
var inst_91843__$1 = fluree.db.util.async.throw_err.call(null,inst_91842);
var state_91853__$1 = (function (){var statearr_91857 = state_91853;
(statearr_91857[(7)] = inst_91843__$1);

return statearr_91857;
})();
if(cljs.core.truth_(inst_91843__$1)){
var statearr_91858_91869 = state_91853__$1;
(statearr_91858_91869[(1)] = (6));

} else {
var statearr_91859_91870 = state_91853__$1;
(statearr_91859_91870[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91854 === (6))){
var inst_91843 = (state_91853[(7)]);
var inst_91845 = fluree.db.storage.core.serde.call(null,conn);
var inst_91846 = fluree.db.serde.protocol._deserialize_block.call(null,inst_91845,inst_91843);
var state_91853__$1 = state_91853;
var statearr_91860_91871 = state_91853__$1;
(statearr_91860_91871[(2)] = inst_91846);

(statearr_91860_91871[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91854 === (7))){
var state_91853__$1 = state_91853;
var statearr_91861_91872 = state_91853__$1;
(statearr_91861_91872[(2)] = null);

(statearr_91861_91872[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91854 === (8))){
var inst_91849 = (state_91853[(2)]);
var state_91853__$1 = state_91853;
var statearr_91862_91873 = state_91853__$1;
(statearr_91862_91873[(2)] = inst_91849);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91853__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$read_block_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$read_block_$_state_machine__86625__auto____0 = (function (){
var statearr_91863 = [null,null,null,null,null,null,null,null];
(statearr_91863[(0)] = fluree$db$storage$core$read_block_$_state_machine__86625__auto__);

(statearr_91863[(1)] = (1));

return statearr_91863;
});
var fluree$db$storage$core$read_block_$_state_machine__86625__auto____1 = (function (state_91853){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_91853);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e91864){if((e91864 instanceof Object)){
var ex__86628__auto__ = e91864;
var statearr_91865_91874 = state_91853;
(statearr_91865_91874[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91853);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e91864;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__91875 = state_91853;
state_91853 = G__91875;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$read_block_$_state_machine__86625__auto__ = function(state_91853){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_block_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_block_$_state_machine__86625__auto____1.call(this,state_91853);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_block_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_block_$_state_machine__86625__auto____0;
fluree$db$storage$core$read_block_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_block_$_state_machine__86625__auto____1;
return fluree$db$storage$core$read_block_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_91866 = f__86676__auto__.call(null);
(statearr_91866[(6)] = c__86675__auto__);

return statearr_91866;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Returns a core async channel with the requested block.
 */
fluree.db.storage.core.read_block_version = (function fluree$db$storage$core$read_block_version(conn,network,ledger_id,block,version){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_91895){
var state_val_91896 = (state_91895[(1)]);
if((state_val_91896 === (1))){
var state_91895__$1 = state_91895;
var statearr_91897_91909 = state_91895__$1;
(statearr_91897_91909[(2)] = null);

(statearr_91897_91909[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91896 === (2))){
var inst_91893 = (state_91895[(2)]);
var state_91895__$1 = state_91895;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_91895__$1,inst_91893);
} else {
if((state_val_91896 === (3))){
var inst_91876 = (state_91895[(2)]);
var state_91895__$1 = state_91895;
var statearr_91898_91910 = state_91895__$1;
(statearr_91898_91910[(2)] = inst_91876);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91895__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91896 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_91895,(3),Error,null,(2));
var inst_91880 = fluree.db.storage.core.ledger_block_key.call(null,network,ledger_id,block);
var inst_91881 = [inst_91880,"--v",cljs.core.str.cljs$core$IFn$_invoke$arity$1(version)].join('');
var inst_91882 = fluree.db.storage.core.storage_read.call(null,conn,inst_91881);
var state_91895__$1 = state_91895;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_91895__$1,(5),inst_91882);
} else {
if((state_val_91896 === (5))){
var inst_91885 = (state_91895[(7)]);
var inst_91884 = (state_91895[(2)]);
var inst_91885__$1 = fluree.db.util.async.throw_err.call(null,inst_91884);
var state_91895__$1 = (function (){var statearr_91899 = state_91895;
(statearr_91899[(7)] = inst_91885__$1);

return statearr_91899;
})();
if(cljs.core.truth_(inst_91885__$1)){
var statearr_91900_91911 = state_91895__$1;
(statearr_91900_91911[(1)] = (6));

} else {
var statearr_91901_91912 = state_91895__$1;
(statearr_91901_91912[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91896 === (6))){
var inst_91885 = (state_91895[(7)]);
var inst_91887 = fluree.db.storage.core.serde.call(null,conn);
var inst_91888 = fluree.db.serde.protocol._deserialize_block.call(null,inst_91887,inst_91885);
var state_91895__$1 = state_91895;
var statearr_91902_91913 = state_91895__$1;
(statearr_91902_91913[(2)] = inst_91888);

(statearr_91902_91913[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91896 === (7))){
var state_91895__$1 = state_91895;
var statearr_91903_91914 = state_91895__$1;
(statearr_91903_91914[(2)] = null);

(statearr_91903_91914[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91896 === (8))){
var inst_91891 = (state_91895[(2)]);
var state_91895__$1 = state_91895;
var statearr_91904_91915 = state_91895__$1;
(statearr_91904_91915[(2)] = inst_91891);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91895__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$read_block_version_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$read_block_version_$_state_machine__86625__auto____0 = (function (){
var statearr_91905 = [null,null,null,null,null,null,null,null];
(statearr_91905[(0)] = fluree$db$storage$core$read_block_version_$_state_machine__86625__auto__);

(statearr_91905[(1)] = (1));

return statearr_91905;
});
var fluree$db$storage$core$read_block_version_$_state_machine__86625__auto____1 = (function (state_91895){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_91895);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e91906){if((e91906 instanceof Object)){
var ex__86628__auto__ = e91906;
var statearr_91907_91916 = state_91895;
(statearr_91907_91916[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91895);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e91906;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__91917 = state_91895;
state_91895 = G__91917;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$read_block_version_$_state_machine__86625__auto__ = function(state_91895){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_block_version_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_block_version_$_state_machine__86625__auto____1.call(this,state_91895);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_block_version_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_block_version_$_state_machine__86625__auto____0;
fluree$db$storage$core$read_block_version_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_block_version_$_state_machine__86625__auto____1;
return fluree$db$storage$core$read_block_version_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_91908 = f__86676__auto__.call(null);
(statearr_91908[(6)] = c__86675__auto__);

return statearr_91908;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Block data should look like:
 * 
 *   {:block  block (long)
 * :flakes flakes
 * :hash hash
 * :sigs sigs
 * :txns   {tid (tx-id, string)  {:cmd    command (JSON string)
 *                                :sig    signature (string}]}
 *   
 */
fluree.db.storage.core.write_block_version = (function fluree$db$storage$core$write_block_version(conn,network,dbid,block_data,version){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_91938){
var state_val_91939 = (state_91938[(1)]);
if((state_val_91939 === (1))){
var state_91938__$1 = state_91938;
var statearr_91940_91947 = state_91938__$1;
(statearr_91940_91947[(2)] = null);

(statearr_91940_91947[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91939 === (2))){
var inst_91936 = (state_91938[(2)]);
var state_91938__$1 = state_91938;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_91938__$1,inst_91936);
} else {
if((state_val_91939 === (3))){
var inst_91918 = (state_91938[(2)]);
var state_91938__$1 = state_91938;
var statearr_91941_91948 = state_91938__$1;
(statearr_91941_91948[(2)] = inst_91918);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91938__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91939 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_91938,(3),Error,null,(2));
var inst_91922 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_91923 = [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"flakes","flakes",1977895739)];
var inst_91924 = (new cljs.core.PersistentVector(null,3,(5),inst_91922,inst_91923,null));
var inst_91925 = cljs.core.select_keys.call(null,block_data,inst_91924);
var inst_91926 = new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(inst_91925);
var inst_91927 = fluree.db.storage.core.ledger_block_key.call(null,network,dbid,inst_91926);
var inst_91928 = [inst_91927,"--v",cljs.core.str.cljs$core$IFn$_invoke$arity$1(version)].join('');
var inst_91929 = fluree.db.storage.core.serde.call(null,conn);
var inst_91930 = fluree.db.serde.protocol._serialize_block.call(null,inst_91929,inst_91925);
var inst_91931 = fluree.db.storage.core.storage_write.call(null,conn,inst_91928,inst_91930);
var state_91938__$1 = state_91938;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_91938__$1,(5),inst_91931);
} else {
if((state_val_91939 === (5))){
var inst_91933 = (state_91938[(2)]);
var inst_91934 = fluree.db.util.async.throw_err.call(null,inst_91933);
var state_91938__$1 = state_91938;
var statearr_91942_91949 = state_91938__$1;
(statearr_91942_91949[(2)] = inst_91934);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91938__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$write_block_version_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$write_block_version_$_state_machine__86625__auto____0 = (function (){
var statearr_91943 = [null,null,null,null,null,null,null];
(statearr_91943[(0)] = fluree$db$storage$core$write_block_version_$_state_machine__86625__auto__);

(statearr_91943[(1)] = (1));

return statearr_91943;
});
var fluree$db$storage$core$write_block_version_$_state_machine__86625__auto____1 = (function (state_91938){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_91938);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e91944){if((e91944 instanceof Object)){
var ex__86628__auto__ = e91944;
var statearr_91945_91950 = state_91938;
(statearr_91945_91950[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91938);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e91944;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__91951 = state_91938;
state_91938 = G__91951;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$write_block_version_$_state_machine__86625__auto__ = function(state_91938){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_block_version_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_block_version_$_state_machine__86625__auto____1.call(this,state_91938);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_block_version_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_block_version_$_state_machine__86625__auto____0;
fluree$db$storage$core$write_block_version_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_block_version_$_state_machine__86625__auto____1;
return fluree$db$storage$core$write_block_version_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_91946 = f__86676__auto__.call(null);
(statearr_91946[(6)] = c__86675__auto__);

return statearr_91946;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Block data should look like:
 * 
 *   {:block  block (long)
 * :flakes flakes
 * :hash hash
 * :sigs sigs
 * :txns   {tid (tx-id, string)  {:cmd    command (JSON string)
 *                                :sig    signature (string}]}
 *   
 */
fluree.db.storage.core.write_block = (function fluree$db$storage$core$write_block(conn,network,dbid,block_data){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_91971){
var state_val_91972 = (state_91971[(1)]);
if((state_val_91972 === (1))){
var state_91971__$1 = state_91971;
var statearr_91973_91980 = state_91971__$1;
(statearr_91973_91980[(2)] = null);

(statearr_91973_91980[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91972 === (2))){
var inst_91969 = (state_91971[(2)]);
var state_91971__$1 = state_91971;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_91971__$1,inst_91969);
} else {
if((state_val_91972 === (3))){
var inst_91952 = (state_91971[(2)]);
var state_91971__$1 = state_91971;
var statearr_91974_91981 = state_91971__$1;
(statearr_91974_91981[(2)] = inst_91952);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91971__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_91972 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_91971,(3),Error,null,(2));
var inst_91956 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_91957 = [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"flakes","flakes",1977895739)];
var inst_91958 = (new cljs.core.PersistentVector(null,3,(5),inst_91956,inst_91957,null));
var inst_91959 = cljs.core.select_keys.call(null,block_data,inst_91958);
var inst_91960 = new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(inst_91959);
var inst_91961 = fluree.db.storage.core.ledger_block_key.call(null,network,dbid,inst_91960);
var inst_91962 = fluree.db.storage.core.serde.call(null,conn);
var inst_91963 = fluree.db.serde.protocol._serialize_block.call(null,inst_91962,inst_91959);
var inst_91964 = fluree.db.storage.core.storage_write.call(null,conn,inst_91961,inst_91963);
var state_91971__$1 = state_91971;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_91971__$1,(5),inst_91964);
} else {
if((state_val_91972 === (5))){
var inst_91966 = (state_91971[(2)]);
var inst_91967 = fluree.db.util.async.throw_err.call(null,inst_91966);
var state_91971__$1 = state_91971;
var statearr_91975_91982 = state_91971__$1;
(statearr_91975_91982[(2)] = inst_91967);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91971__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$write_block_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$write_block_$_state_machine__86625__auto____0 = (function (){
var statearr_91976 = [null,null,null,null,null,null,null];
(statearr_91976[(0)] = fluree$db$storage$core$write_block_$_state_machine__86625__auto__);

(statearr_91976[(1)] = (1));

return statearr_91976;
});
var fluree$db$storage$core$write_block_$_state_machine__86625__auto____1 = (function (state_91971){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_91971);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e91977){if((e91977 instanceof Object)){
var ex__86628__auto__ = e91977;
var statearr_91978_91983 = state_91971;
(statearr_91978_91983[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_91971);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e91977;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__91984 = state_91971;
state_91971 = G__91984;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$write_block_$_state_machine__86625__auto__ = function(state_91971){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_block_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_block_$_state_machine__86625__auto____1.call(this,state_91971);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_block_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_block_$_state_machine__86625__auto____0;
fluree$db$storage$core$write_block_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_block_$_state_machine__86625__auto____1;
return fluree$db$storage$core$write_block_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_91979 = f__86676__auto__.call(null);
(statearr_91979[(6)] = c__86675__auto__);

return statearr_91979;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Given a child, unresolved node, extracts just the data that will go into storage.
 */
fluree.db.storage.core.child_data = (function fluree$db$storage$core$child_data(child){
return cljs.core.select_keys.call(null,child,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"leaf","leaf",1306118732),new cljs.core.Keyword(null,"first","first",-644103046),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"size","size",1098693007)], null));
});
fluree.db.storage.core.write_history = (function fluree$db$storage$core$write_history(conn,history,his_key,next_his_key){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_92001){
var state_val_92002 = (state_92001[(1)]);
if((state_val_92002 === (1))){
var state_92001__$1 = state_92001;
var statearr_92003_92010 = state_92001__$1;
(statearr_92003_92010[(2)] = null);

(statearr_92003_92010[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92002 === (2))){
var inst_91999 = (state_92001[(2)]);
var state_92001__$1 = state_92001;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92001__$1,inst_91999);
} else {
if((state_val_92002 === (3))){
var inst_91985 = (state_92001[(2)]);
var state_92001__$1 = state_92001;
var statearr_92004_92011 = state_92001__$1;
(statearr_92004_92011[(2)] = inst_91985);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92001__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92002 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92001,(3),Error,null,(2));
var inst_91989 = [new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"his","his",-1294347076)];
var inst_91990 = [history,next_his_key];
var inst_91991 = cljs.core.PersistentHashMap.fromArrays(inst_91989,inst_91990);
var inst_91992 = fluree.db.storage.core.serde.call(null,conn);
var inst_91993 = fluree.db.serde.protocol._serialize_leaf.call(null,inst_91992,inst_91991);
var inst_91994 = fluree.db.storage.core.storage_write.call(null,conn,his_key,inst_91993);
var state_92001__$1 = state_92001;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92001__$1,(5),inst_91994);
} else {
if((state_val_92002 === (5))){
var inst_91996 = (state_92001[(2)]);
var inst_91997 = fluree.db.util.async.throw_err.call(null,inst_91996);
var state_92001__$1 = state_92001;
var statearr_92005_92012 = state_92001__$1;
(statearr_92005_92012[(2)] = inst_91997);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92001__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$write_history_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$write_history_$_state_machine__86625__auto____0 = (function (){
var statearr_92006 = [null,null,null,null,null,null,null];
(statearr_92006[(0)] = fluree$db$storage$core$write_history_$_state_machine__86625__auto__);

(statearr_92006[(1)] = (1));

return statearr_92006;
});
var fluree$db$storage$core$write_history_$_state_machine__86625__auto____1 = (function (state_92001){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92001);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92007){if((e92007 instanceof Object)){
var ex__86628__auto__ = e92007;
var statearr_92008_92013 = state_92001;
(statearr_92008_92013[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92001);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92007;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92014 = state_92001;
state_92001 = G__92014;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$write_history_$_state_machine__86625__auto__ = function(state_92001){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_history_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_history_$_state_machine__86625__auto____1.call(this,state_92001);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_history_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_history_$_state_machine__86625__auto____0;
fluree$db$storage$core$write_history_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_history_$_state_machine__86625__auto____1;
return fluree$db$storage$core$write_history_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_92009 = f__86676__auto__.call(null);
(statearr_92009[(6)] = c__86675__auto__);

return statearr_92009;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Writes a leaf plus its history.
 * 
 *   Writes history first, and only on successful history write then writes leaf.
 * 
 *   Returns leaf's key
 */
fluree.db.storage.core.write_leaf = (function fluree$db$storage$core$write_leaf(conn,network,dbid,idx_type,id,flakes,history){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_92037){
var state_val_92038 = (state_92037[(1)]);
if((state_val_92038 === (1))){
var state_92037__$1 = state_92037;
var statearr_92039_92049 = state_92037__$1;
(statearr_92039_92049[(2)] = null);

(statearr_92039_92049[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92038 === (2))){
var inst_92035 = (state_92037[(2)]);
var state_92037__$1 = state_92037;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92037__$1,inst_92035);
} else {
if((state_val_92038 === (3))){
var inst_92015 = (state_92037[(2)]);
var state_92037__$1 = state_92037;
var statearr_92040_92050 = state_92037__$1;
(statearr_92040_92050[(2)] = inst_92015);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92037__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92038 === (4))){
var inst_92019 = (state_92037[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92037,(3),Error,null,(2));
var inst_92019__$1 = fluree.db.storage.core.ledger_node_key.call(null,network,dbid,idx_type,id,"l");
var inst_92020 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_92019__$1),"-his"].join('');
var inst_92021 = [new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"his","his",-1294347076)];
var inst_92022 = [flakes,inst_92020];
var inst_92023 = cljs.core.PersistentHashMap.fromArrays(inst_92021,inst_92022);
var inst_92024 = fluree.db.storage.core.serde.call(null,conn);
var inst_92025 = fluree.db.serde.protocol._serialize_leaf.call(null,inst_92024,inst_92023);
var inst_92026 = fluree.db.storage.core.write_history.call(null,conn,history,inst_92020,null);
var inst_92027 = fluree.db.storage.core.storage_write.call(null,conn,inst_92019__$1,inst_92025);
var state_92037__$1 = (function (){var statearr_92041 = state_92037;
(statearr_92041[(8)] = inst_92027);

(statearr_92041[(7)] = inst_92019__$1);

return statearr_92041;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92037__$1,(5),inst_92026);
} else {
if((state_val_92038 === (5))){
var inst_92027 = (state_92037[(8)]);
var inst_92029 = (state_92037[(2)]);
var inst_92030 = fluree.db.util.async.throw_err.call(null,inst_92029);
var state_92037__$1 = (function (){var statearr_92042 = state_92037;
(statearr_92042[(9)] = inst_92030);

return statearr_92042;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92037__$1,(6),inst_92027);
} else {
if((state_val_92038 === (6))){
var inst_92019 = (state_92037[(7)]);
var inst_92032 = (state_92037[(2)]);
var inst_92033 = fluree.db.util.async.throw_err.call(null,inst_92032);
var state_92037__$1 = (function (){var statearr_92043 = state_92037;
(statearr_92043[(10)] = inst_92033);

return statearr_92043;
})();
var statearr_92044_92051 = state_92037__$1;
(statearr_92044_92051[(2)] = inst_92019);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92037__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$write_leaf_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$write_leaf_$_state_machine__86625__auto____0 = (function (){
var statearr_92045 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_92045[(0)] = fluree$db$storage$core$write_leaf_$_state_machine__86625__auto__);

(statearr_92045[(1)] = (1));

return statearr_92045;
});
var fluree$db$storage$core$write_leaf_$_state_machine__86625__auto____1 = (function (state_92037){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92037);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92046){if((e92046 instanceof Object)){
var ex__86628__auto__ = e92046;
var statearr_92047_92052 = state_92037;
(statearr_92047_92052[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92037);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92046;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92053 = state_92037;
state_92037 = G__92053;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$write_leaf_$_state_machine__86625__auto__ = function(state_92037){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_leaf_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_leaf_$_state_machine__86625__auto____1.call(this,state_92037);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_leaf_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_leaf_$_state_machine__86625__auto____0;
fluree$db$storage$core$write_leaf_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_leaf_$_state_machine__86625__auto____1;
return fluree$db$storage$core$write_leaf_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_92048 = f__86676__auto__.call(null);
(statearr_92048[(6)] = c__86675__auto__);

return statearr_92048;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Serializes final data for branch and writes it to provided key
 */
fluree.db.storage.core.write_branch_data = (function fluree$db$storage$core$write_branch_data(conn,key,data){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_92067){
var state_val_92068 = (state_92067[(1)]);
if((state_val_92068 === (1))){
var state_92067__$1 = state_92067;
var statearr_92069_92077 = state_92067__$1;
(statearr_92069_92077[(2)] = null);

(statearr_92069_92077[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92068 === (2))){
var inst_92065 = (state_92067[(2)]);
var state_92067__$1 = state_92067;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92067__$1,inst_92065);
} else {
if((state_val_92068 === (3))){
var inst_92054 = (state_92067[(2)]);
var state_92067__$1 = state_92067;
var statearr_92070_92078 = state_92067__$1;
(statearr_92070_92078[(2)] = inst_92054);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92067__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92068 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92067,(3),Error,null,(2));
var inst_92058 = fluree.db.storage.core.serde.call(null,conn);
var inst_92059 = fluree.db.serde.protocol._serialize_branch.call(null,inst_92058,data);
var inst_92060 = fluree.db.storage.core.storage_write.call(null,conn,key,inst_92059);
var state_92067__$1 = state_92067;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92067__$1,(5),inst_92060);
} else {
if((state_val_92068 === (5))){
var inst_92062 = (state_92067[(2)]);
var inst_92063 = fluree.db.util.async.throw_err.call(null,inst_92062);
var state_92067__$1 = (function (){var statearr_92071 = state_92067;
(statearr_92071[(7)] = inst_92063);

return statearr_92071;
})();
var statearr_92072_92079 = state_92067__$1;
(statearr_92072_92079[(2)] = key);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92067__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto____0 = (function (){
var statearr_92073 = [null,null,null,null,null,null,null,null];
(statearr_92073[(0)] = fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto__);

(statearr_92073[(1)] = (1));

return statearr_92073;
});
var fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto____1 = (function (state_92067){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92067);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92074){if((e92074 instanceof Object)){
var ex__86628__auto__ = e92074;
var statearr_92075_92080 = state_92067;
(statearr_92075_92080[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92067);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92074;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92081 = state_92067;
state_92067 = G__92081;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto__ = function(state_92067){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto____1.call(this,state_92067);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto____0;
fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto____1;
return fluree$db$storage$core$write_branch_data_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_92076 = f__86676__auto__.call(null);
(statearr_92076[(6)] = c__86675__auto__);

return statearr_92076;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Returns core async channel with index key
 */
fluree.db.storage.core.write_branch = (function fluree$db$storage$core$write_branch(conn,network,dbid,idx_type,id,children){
var branch_key = fluree.db.storage.core.ledger_node_key.call(null,network,dbid,idx_type,id,"b");
var child_vals = cljs.core.mapv.call(null,((function (branch_key){
return (function (p1__92082_SHARP_){
return fluree.db.storage.core.child_data.call(null,cljs.core.val.call(null,p1__92082_SHARP_));
});})(branch_key))
,children);
var rhs = new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(cljs.core.last.call(null,child_vals));
var data = new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"children","children",-940561982),child_vals,new cljs.core.Keyword(null,"rhs","rhs",-229356739),rhs], null);
return fluree.db.storage.core.write_branch_data.call(null,conn,branch_key,data);
});
/**
 * Writes garbage record out for latest index.
 */
fluree.db.storage.core.write_garbage = (function fluree$db$storage$core$write_garbage(db,p__92083){
var map__92084 = p__92083;
var map__92084__$1 = (((((!((map__92084 == null))))?(((((map__92084.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__92084.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__92084):map__92084);
var progress = map__92084__$1;
var garbage = cljs.core.get.call(null,map__92084__$1,new cljs.core.Keyword(null,"garbage","garbage",-2063107600));
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,map__92084,map__92084__$1,progress,garbage){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,map__92084,map__92084__$1,progress,garbage){
return (function (state_92129){
var state_val_92130 = (state_92129[(1)]);
if((state_val_92130 === (7))){
var inst_92106 = (state_92129[(2)]);
var state_92129__$1 = state_92129;
if(cljs.core.truth_(inst_92106)){
var statearr_92131_92152 = state_92129__$1;
(statearr_92131_92152[(1)] = (11));

} else {
var statearr_92132_92153 = state_92129__$1;
(statearr_92132_92153[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (1))){
var state_92129__$1 = state_92129;
var statearr_92133_92154 = state_92129__$1;
(statearr_92133_92154[(2)] = null);

(statearr_92133_92154[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92129,(3),Error,null,(2));
var inst_92092 = (db == null);
var inst_92093 = cljs.core.not.call(null,inst_92092);
var state_92129__$1 = state_92129;
if(inst_92093){
var statearr_92134_92155 = state_92129__$1;
(statearr_92134_92155[(1)] = (5));

} else {
var statearr_92135_92156 = state_92129__$1;
(statearr_92135_92156[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (13))){
var inst_92116 = (state_92129[(7)]);
var inst_92111 = (state_92129[(2)]);
var inst_92112 = cljs.core.get.call(null,inst_92111,new cljs.core.Keyword(null,"conn","conn",278309663));
var inst_92113 = cljs.core.get.call(null,inst_92111,new cljs.core.Keyword(null,"network","network",2050004697));
var inst_92114 = cljs.core.get.call(null,inst_92111,new cljs.core.Keyword(null,"dbid","dbid",-196647356));
var inst_92115 = cljs.core.get.call(null,inst_92111,new cljs.core.Keyword(null,"block","block",664686210));
var inst_92116__$1 = fluree.db.storage.core.ledger_garbage_key.call(null,inst_92113,inst_92114,inst_92115);
var inst_92117 = [new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"garbage","garbage",-2063107600)];
var inst_92118 = [inst_92114,inst_92115,garbage];
var inst_92119 = cljs.core.PersistentHashMap.fromArrays(inst_92117,inst_92118);
var inst_92120 = fluree.db.storage.core.serde.call(null,inst_92112);
var inst_92121 = fluree.db.serde.protocol._serialize_garbage.call(null,inst_92120,inst_92119);
var inst_92122 = fluree.db.storage.core.storage_write.call(null,inst_92112,inst_92116__$1,inst_92121);
var state_92129__$1 = (function (){var statearr_92136 = state_92129;
(statearr_92136[(7)] = inst_92116__$1);

return statearr_92136;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92129__$1,(14),inst_92122);
} else {
if((state_val_92130 === (6))){
var state_92129__$1 = state_92129;
var statearr_92137_92157 = state_92129__$1;
(statearr_92137_92157[(2)] = false);

(statearr_92137_92157[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (3))){
var inst_92086 = (state_92129[(2)]);
var state_92129__$1 = state_92129;
var statearr_92138_92158 = state_92129__$1;
(statearr_92138_92158[(2)] = inst_92086);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92129__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (12))){
var state_92129__$1 = state_92129;
var statearr_92139_92159 = state_92129__$1;
(statearr_92139_92159[(2)] = db);

(statearr_92139_92159[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (2))){
var inst_92127 = (state_92129[(2)]);
var state_92129__$1 = state_92129;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92129__$1,inst_92127);
} else {
if((state_val_92130 === (11))){
var inst_92108 = cljs.core.apply.call(null,cljs.core.hash_map,db);
var state_92129__$1 = state_92129;
var statearr_92140_92160 = state_92129__$1;
(statearr_92140_92160[(2)] = inst_92108);

(statearr_92140_92160[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (9))){
var state_92129__$1 = state_92129;
var statearr_92141_92161 = state_92129__$1;
(statearr_92141_92161[(2)] = false);

(statearr_92141_92161[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (5))){
var inst_92095 = db.cljs$lang$protocol_mask$partition0$;
var inst_92096 = (inst_92095 & (64));
var inst_92097 = db.cljs$core$ISeq$;
var inst_92098 = (cljs.core.PROTOCOL_SENTINEL === inst_92097);
var inst_92099 = ((inst_92096) || (inst_92098));
var state_92129__$1 = state_92129;
if(cljs.core.truth_(inst_92099)){
var statearr_92142_92162 = state_92129__$1;
(statearr_92142_92162[(1)] = (8));

} else {
var statearr_92143_92163 = state_92129__$1;
(statearr_92143_92163[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (14))){
var inst_92116 = (state_92129[(7)]);
var inst_92124 = (state_92129[(2)]);
var inst_92125 = fluree.db.util.async.throw_err.call(null,inst_92124);
var state_92129__$1 = (function (){var statearr_92144 = state_92129;
(statearr_92144[(8)] = inst_92125);

return statearr_92144;
})();
var statearr_92145_92164 = state_92129__$1;
(statearr_92145_92164[(2)] = inst_92116);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92129__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (10))){
var inst_92103 = (state_92129[(2)]);
var state_92129__$1 = state_92129;
var statearr_92146_92165 = state_92129__$1;
(statearr_92146_92165[(2)] = inst_92103);

(statearr_92146_92165[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92130 === (8))){
var state_92129__$1 = state_92129;
var statearr_92147_92166 = state_92129__$1;
(statearr_92147_92166[(2)] = true);

(statearr_92147_92166[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,map__92084,map__92084__$1,progress,garbage))
;
return ((function (switch__86624__auto__,c__86675__auto__,map__92084,map__92084__$1,progress,garbage){
return (function() {
var fluree$db$storage$core$write_garbage_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$write_garbage_$_state_machine__86625__auto____0 = (function (){
var statearr_92148 = [null,null,null,null,null,null,null,null,null];
(statearr_92148[(0)] = fluree$db$storage$core$write_garbage_$_state_machine__86625__auto__);

(statearr_92148[(1)] = (1));

return statearr_92148;
});
var fluree$db$storage$core$write_garbage_$_state_machine__86625__auto____1 = (function (state_92129){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92129);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92149){if((e92149 instanceof Object)){
var ex__86628__auto__ = e92149;
var statearr_92150_92167 = state_92129;
(statearr_92150_92167[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92129);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92149;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92168 = state_92129;
state_92129 = G__92168;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$write_garbage_$_state_machine__86625__auto__ = function(state_92129){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_garbage_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_garbage_$_state_machine__86625__auto____1.call(this,state_92129);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_garbage_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_garbage_$_state_machine__86625__auto____0;
fluree$db$storage$core$write_garbage_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_garbage_$_state_machine__86625__auto____1;
return fluree$db$storage$core$write_garbage_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,map__92084,map__92084__$1,progress,garbage))
})();
var state__86677__auto__ = (function (){var statearr_92151 = f__86676__auto__.call(null);
(statearr_92151[(6)] = c__86675__auto__);

return statearr_92151;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,map__92084,map__92084__$1,progress,garbage))
);

return c__86675__auto__;
});
fluree.db.storage.core.write_db_root = (function fluree$db$storage$core$write_db_root(var_args){
var G__92170 = arguments.length;
switch (G__92170) {
case 1:
return fluree.db.storage.core.write_db_root.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.storage.core.write_db_root.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.storage.core.write_db_root.cljs$core$IFn$_invoke$arity$1 = (function (db){
return fluree.db.storage.core.write_db_root.call(null,db,null);
});

fluree.db.storage.core.write_db_root.cljs$core$IFn$_invoke$arity$2 = (function (db,custom_ecount){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_92241){
var state_val_92242 = (state_92241[(1)]);
if((state_val_92242 === (7))){
var inst_92191 = (state_92241[(2)]);
var state_92241__$1 = state_92241;
if(cljs.core.truth_(inst_92191)){
var statearr_92243_92274 = state_92241__$1;
(statearr_92243_92274[(1)] = (11));

} else {
var statearr_92244_92275 = state_92241__$1;
(statearr_92244_92275[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (20))){
var inst_92210 = (state_92241[(7)]);
var inst_92236 = (state_92241[(2)]);
var inst_92237 = fluree.db.util.async.throw_err.call(null,inst_92236);
var state_92241__$1 = (function (){var statearr_92245 = state_92241;
(statearr_92245[(8)] = inst_92237);

return statearr_92245;
})();
var statearr_92246_92276 = state_92241__$1;
(statearr_92246_92276[(2)] = inst_92210);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92241__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (1))){
var state_92241__$1 = state_92241;
var statearr_92247_92277 = state_92241__$1;
(statearr_92247_92277[(2)] = null);

(statearr_92247_92277[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92241,(3),Error,null,(2));
var inst_92177 = (db == null);
var inst_92178 = cljs.core.not.call(null,inst_92177);
var state_92241__$1 = state_92241;
if(inst_92178){
var statearr_92248_92278 = state_92241__$1;
(statearr_92248_92278[(1)] = (5));

} else {
var statearr_92249_92279 = state_92241__$1;
(statearr_92249_92279[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (15))){
var state_92241__$1 = state_92241;
var statearr_92250_92280 = state_92241__$1;
(statearr_92250_92280[(2)] = (0));

(statearr_92250_92280[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (13))){
var inst_92213 = (state_92241[(9)]);
var inst_92203 = (state_92241[(10)]);
var inst_92205 = (state_92241[(11)]);
var inst_92201 = (state_92241[(12)]);
var inst_92196 = (state_92241[(2)]);
var inst_92197 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"network","network",2050004697));
var inst_92198 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"t","t",-1397832519));
var inst_92199 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"fork","fork",1062974235));
var inst_92200 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"spot","spot",-1706962147));
var inst_92201__$1 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"stats","stats",-85643011));
var inst_92202 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"conn","conn",278309663));
var inst_92203__$1 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"block","block",664686210));
var inst_92204 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"psot","psot",2111653059));
var inst_92205__$1 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"dbid","dbid",-196647356));
var inst_92206 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"ecount","ecount",-879380887));
var inst_92207 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"opst","opst",1213963058));
var inst_92208 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"fork-block","fork-block",178387923));
var inst_92209 = cljs.core.get.call(null,inst_92196,new cljs.core.Keyword(null,"post","post",269697687));
var inst_92210 = fluree.db.storage.core.ledger_root_key.call(null,inst_92197,inst_92205__$1,inst_92203__$1);
var inst_92211 = [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"psot","psot",2111653059),new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"prevIndex","prevIndex",-331425114),new cljs.core.Keyword(null,"ecount","ecount",-879380887),new cljs.core.Keyword(null,"opst","opst",1213963058),new cljs.core.Keyword(null,"post","post",269697687),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"timestamp","timestamp",579478971),new cljs.core.Keyword(null,"fork","fork",1062974235),new cljs.core.Keyword(null,"forkBlock","forkBlock",-19917508),new cljs.core.Keyword(null,"stats","stats",-85643011),new cljs.core.Keyword(null,"spot","spot",-1706962147)];
var inst_92212 = fluree.db.storage.core.child_data.call(null,inst_92204);
var inst_92213__$1 = new cljs.core.Keyword(null,"indexed","indexed",390758624).cljs$core$IFn$_invoke$arity$1(inst_92201__$1);
var state_92241__$1 = (function (){var statearr_92251 = state_92241;
(statearr_92251[(13)] = inst_92208);

(statearr_92251[(14)] = inst_92199);

(statearr_92251[(15)] = inst_92212);

(statearr_92251[(16)] = inst_92209);

(statearr_92251[(9)] = inst_92213__$1);

(statearr_92251[(17)] = inst_92202);

(statearr_92251[(10)] = inst_92203__$1);

(statearr_92251[(18)] = inst_92206);

(statearr_92251[(7)] = inst_92210);

(statearr_92251[(19)] = inst_92211);

(statearr_92251[(20)] = inst_92198);

(statearr_92251[(21)] = inst_92200);

(statearr_92251[(11)] = inst_92205__$1);

(statearr_92251[(12)] = inst_92201__$1);

(statearr_92251[(22)] = inst_92207);

return statearr_92251;
})();
if(cljs.core.truth_(inst_92213__$1)){
var statearr_92252_92281 = state_92241__$1;
(statearr_92252_92281[(1)] = (14));

} else {
var statearr_92253_92282 = state_92241__$1;
(statearr_92253_92282[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (6))){
var state_92241__$1 = state_92241;
var statearr_92254_92283 = state_92241__$1;
(statearr_92254_92283[(2)] = false);

(statearr_92254_92283[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (17))){
var state_92241__$1 = state_92241;
var statearr_92255_92284 = state_92241__$1;
(statearr_92255_92284[(2)] = custom_ecount);

(statearr_92255_92284[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (3))){
var inst_92171 = (state_92241[(2)]);
var state_92241__$1 = state_92241;
var statearr_92256_92285 = state_92241__$1;
(statearr_92256_92285[(2)] = inst_92171);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92241__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (12))){
var state_92241__$1 = state_92241;
var statearr_92257_92286 = state_92241__$1;
(statearr_92257_92286[(2)] = db);

(statearr_92257_92286[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (2))){
var inst_92239 = (state_92241[(2)]);
var state_92241__$1 = state_92241;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92241__$1,inst_92239);
} else {
if((state_val_92242 === (19))){
var inst_92208 = (state_92241[(13)]);
var inst_92199 = (state_92241[(14)]);
var inst_92212 = (state_92241[(15)]);
var inst_92209 = (state_92241[(16)]);
var inst_92217 = (state_92241[(23)]);
var inst_92202 = (state_92241[(17)]);
var inst_92203 = (state_92241[(10)]);
var inst_92210 = (state_92241[(7)]);
var inst_92211 = (state_92241[(19)]);
var inst_92198 = (state_92241[(20)]);
var inst_92200 = (state_92241[(21)]);
var inst_92205 = (state_92241[(11)]);
var inst_92201 = (state_92241[(12)]);
var inst_92207 = (state_92241[(22)]);
var inst_92221 = (state_92241[(2)]);
var inst_92222 = fluree.db.storage.core.child_data.call(null,inst_92207);
var inst_92223 = fluree.db.storage.core.child_data.call(null,inst_92209);
var inst_92224 = fluree.db.util.core.current_time_millis.call(null);
var inst_92225 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_92226 = [new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"size","size",1098693007)];
var inst_92227 = (new cljs.core.PersistentVector(null,2,(5),inst_92225,inst_92226,null));
var inst_92228 = cljs.core.select_keys.call(null,inst_92201,inst_92227);
var inst_92229 = fluree.db.storage.core.child_data.call(null,inst_92200);
var inst_92230 = [inst_92203,inst_92212,inst_92205,inst_92217,inst_92221,inst_92222,inst_92223,inst_92198,inst_92224,inst_92199,inst_92208,inst_92228,inst_92229];
var inst_92231 = cljs.core.PersistentHashMap.fromArrays(inst_92211,inst_92230);
var inst_92232 = fluree.db.storage.core.serde.call(null,inst_92202);
var inst_92233 = fluree.db.serde.protocol._serialize_db_root.call(null,inst_92232,inst_92231);
var inst_92234 = fluree.db.storage.core.storage_write.call(null,inst_92202,inst_92210,inst_92233);
var state_92241__$1 = state_92241;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92241__$1,(20),inst_92234);
} else {
if((state_val_92242 === (11))){
var inst_92193 = cljs.core.apply.call(null,cljs.core.hash_map,db);
var state_92241__$1 = state_92241;
var statearr_92258_92287 = state_92241__$1;
(statearr_92258_92287[(2)] = inst_92193);

(statearr_92258_92287[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (9))){
var state_92241__$1 = state_92241;
var statearr_92259_92288 = state_92241__$1;
(statearr_92259_92288[(2)] = false);

(statearr_92259_92288[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (5))){
var inst_92180 = db.cljs$lang$protocol_mask$partition0$;
var inst_92181 = (inst_92180 & (64));
var inst_92182 = db.cljs$core$ISeq$;
var inst_92183 = (cljs.core.PROTOCOL_SENTINEL === inst_92182);
var inst_92184 = ((inst_92181) || (inst_92183));
var state_92241__$1 = state_92241;
if(cljs.core.truth_(inst_92184)){
var statearr_92260_92289 = state_92241__$1;
(statearr_92260_92289[(1)] = (8));

} else {
var statearr_92261_92290 = state_92241__$1;
(statearr_92261_92290[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (14))){
var inst_92213 = (state_92241[(9)]);
var state_92241__$1 = state_92241;
var statearr_92262_92291 = state_92241__$1;
(statearr_92262_92291[(2)] = inst_92213);

(statearr_92262_92291[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (16))){
var inst_92217 = (state_92241[(2)]);
var state_92241__$1 = (function (){var statearr_92263 = state_92241;
(statearr_92263[(23)] = inst_92217);

return statearr_92263;
})();
if(cljs.core.truth_(custom_ecount)){
var statearr_92264_92292 = state_92241__$1;
(statearr_92264_92292[(1)] = (17));

} else {
var statearr_92265_92293 = state_92241__$1;
(statearr_92265_92293[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (10))){
var inst_92188 = (state_92241[(2)]);
var state_92241__$1 = state_92241;
var statearr_92266_92294 = state_92241__$1;
(statearr_92266_92294[(2)] = inst_92188);

(statearr_92266_92294[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (18))){
var inst_92206 = (state_92241[(18)]);
var state_92241__$1 = state_92241;
var statearr_92267_92295 = state_92241__$1;
(statearr_92267_92295[(2)] = inst_92206);

(statearr_92267_92295[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92242 === (8))){
var state_92241__$1 = state_92241;
var statearr_92268_92296 = state_92241__$1;
(statearr_92268_92296[(2)] = true);

(statearr_92268_92296[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$state_machine__86625__auto__ = null;
var fluree$db$storage$core$state_machine__86625__auto____0 = (function (){
var statearr_92269 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_92269[(0)] = fluree$db$storage$core$state_machine__86625__auto__);

(statearr_92269[(1)] = (1));

return statearr_92269;
});
var fluree$db$storage$core$state_machine__86625__auto____1 = (function (state_92241){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92241);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92270){if((e92270 instanceof Object)){
var ex__86628__auto__ = e92270;
var statearr_92271_92297 = state_92241;
(statearr_92271_92297[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92241);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92270;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92298 = state_92241;
state_92241 = G__92298;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$state_machine__86625__auto__ = function(state_92241){
switch(arguments.length){
case 0:
return fluree$db$storage$core$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$state_machine__86625__auto____1.call(this,state_92241);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$state_machine__86625__auto____0;
fluree$db$storage$core$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$state_machine__86625__auto____1;
return fluree$db$storage$core$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_92272 = f__86676__auto__.call(null);
(statearr_92272[(6)] = c__86675__auto__);

return statearr_92272;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.storage.core.write_db_root.cljs$lang$maxFixedArity = 2;

fluree.db.storage.core.reify_history = (function fluree$db$storage$core$reify_history(conn,key,error_fn){
var return_ch = cljs.core.async.promise_chan.call(null);
var c__86675__auto___92340 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___92340,return_ch){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___92340,return_ch){
return (function (state_92325){
var state_val_92326 = (state_92325[(1)]);
if((state_val_92326 === (1))){
var state_92325__$1 = state_92325;
var statearr_92327_92341 = state_92325__$1;
(statearr_92327_92341[(2)] = null);

(statearr_92327_92341[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92326 === (2))){
var inst_92323 = (state_92325[(2)]);
var state_92325__$1 = state_92325;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92325__$1,inst_92323);
} else {
if((state_val_92326 === (3))){
var inst_92299 = (state_92325[(2)]);
var inst_92300 = error_fn.call(null);
var inst_92301 = cljs.core.async.put_BANG_.call(null,return_ch,inst_92299);
var inst_92302 = cljs.core.async.close_BANG_.call(null,return_ch);
var state_92325__$1 = (function (){var statearr_92328 = state_92325;
(statearr_92328[(7)] = inst_92300);

(statearr_92328[(8)] = inst_92301);

return statearr_92328;
})();
var statearr_92329_92342 = state_92325__$1;
(statearr_92329_92342[(2)] = inst_92302);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92325__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92326 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92325,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_92306 = fluree.db.storage.core.storage_read.call(null,conn,key);
var state_92325__$1 = state_92325;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92325__$1,(5),inst_92306);
} else {
if((state_val_92326 === (5))){
var inst_92308 = (state_92325[(9)]);
var inst_92308__$1 = (state_92325[(2)]);
var inst_92309 = (inst_92308__$1 == null);
var inst_92310 = (inst_92308__$1 instanceof Error);
var inst_92311 = ((inst_92309) || (inst_92310));
var state_92325__$1 = (function (){var statearr_92330 = state_92325;
(statearr_92330[(9)] = inst_92308__$1);

return statearr_92330;
})();
if(cljs.core.truth_(inst_92311)){
var statearr_92331_92343 = state_92325__$1;
(statearr_92331_92343[(1)] = (6));

} else {
var statearr_92332_92344 = state_92325__$1;
(statearr_92332_92344[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92326 === (6))){
var inst_92313 = cljs.core.async.close_BANG_.call(null,return_ch);
var state_92325__$1 = state_92325;
var statearr_92333_92345 = state_92325__$1;
(statearr_92333_92345[(2)] = inst_92313);

(statearr_92333_92345[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92326 === (7))){
var inst_92308 = (state_92325[(9)]);
var inst_92315 = fluree.db.storage.core.serde.call(null,conn);
var inst_92316 = fluree.db.serde.protocol._deserialize_leaf.call(null,inst_92315,inst_92308);
var inst_92317 = new cljs.core.Keyword(null,"flakes","flakes",1977895739).cljs$core$IFn$_invoke$arity$1(inst_92316);
var inst_92318 = cljs.core.sort.call(null,fluree.db.flake.cmp_flakes_history,inst_92317);
var inst_92319 = cljs.core.async.put_BANG_.call(null,return_ch,inst_92318);
var state_92325__$1 = state_92325;
var statearr_92334_92346 = state_92325__$1;
(statearr_92334_92346[(2)] = inst_92319);

(statearr_92334_92346[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92326 === (8))){
var inst_92321 = (state_92325[(2)]);
var state_92325__$1 = state_92325;
var statearr_92335_92347 = state_92325__$1;
(statearr_92335_92347[(2)] = inst_92321);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92325__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto___92340,return_ch))
;
return ((function (switch__86624__auto__,c__86675__auto___92340,return_ch){
return (function() {
var fluree$db$storage$core$reify_history_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$reify_history_$_state_machine__86625__auto____0 = (function (){
var statearr_92336 = [null,null,null,null,null,null,null,null,null,null];
(statearr_92336[(0)] = fluree$db$storage$core$reify_history_$_state_machine__86625__auto__);

(statearr_92336[(1)] = (1));

return statearr_92336;
});
var fluree$db$storage$core$reify_history_$_state_machine__86625__auto____1 = (function (state_92325){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92325);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92337){if((e92337 instanceof Object)){
var ex__86628__auto__ = e92337;
var statearr_92338_92348 = state_92325;
(statearr_92338_92348[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92325);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92337;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92349 = state_92325;
state_92325 = G__92349;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$reify_history_$_state_machine__86625__auto__ = function(state_92325){
switch(arguments.length){
case 0:
return fluree$db$storage$core$reify_history_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$reify_history_$_state_machine__86625__auto____1.call(this,state_92325);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$reify_history_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$reify_history_$_state_machine__86625__auto____0;
fluree$db$storage$core$reify_history_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$reify_history_$_state_machine__86625__auto____1;
return fluree$db$storage$core$reify_history_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___92340,return_ch))
})();
var state__86677__auto__ = (function (){var statearr_92339 = f__86676__auto__.call(null);
(statearr_92339[(6)] = c__86675__auto___92340);

return statearr_92339;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___92340,return_ch))
);


return return_ch;
});
/**
 * Given a novelty set, a first-flake and rhs flake boundary,
 *   returns novelty subrange as a collection.
 * 
 *   If through-t is specified, will return novelty only through the
 *   specified t.
 */
fluree.db.storage.core.source_novelty_t = (function fluree$db$storage$core$source_novelty_t(var_args){
var G__92351 = arguments.length;
switch (G__92351) {
case 4:
return fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$4 = (function (novelty,first_flake,rhs,leftmost_QMARK_){
return fluree.db.storage.core.source_novelty_t.call(null,novelty,first_flake,rhs,leftmost_QMARK_,null);
});

fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$5 = (function (novelty,first_flake,rhs,leftmost_QMARK_,through_t){
var novelty_subrange = (cljs.core.truth_((function (){var and__4120__auto__ = rhs;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.not.call(null,leftmost_QMARK_);
} else {
return and__4120__auto__;
}
})())?clojure.data.avl.subrange.call(null,novelty,cljs.core._GT_,first_flake,cljs.core._LT__EQ_,rhs):(cljs.core.truth_((function (){var and__4120__auto__ = rhs;
if(cljs.core.truth_(and__4120__auto__)){
return leftmost_QMARK_;
} else {
return and__4120__auto__;
}
})())?clojure.data.avl.subrange.call(null,novelty,cljs.core._LT__EQ_,rhs):(((((rhs == null)) && (cljs.core.not.call(null,leftmost_QMARK_))))?clojure.data.avl.subrange.call(null,novelty,cljs.core._GT_,first_flake):(cljs.core.truth_((function (){var and__4120__auto__ = (rhs == null);
if(and__4120__auto__){
return leftmost_QMARK_;
} else {
return and__4120__auto__;
}
})())?novelty:null))));
if(cljs.core.truth_(through_t)){
return cljs.core.reduce.call(null,((function (novelty_subrange){
return (function (novelty_set,f){
if((f.t < through_t)){
return cljs.core.disj.call(null,novelty_set,f);
} else {
return novelty_set;
}
});})(novelty_subrange))
,novelty_subrange,novelty_subrange);
} else {
return novelty_subrange;
}
});

fluree.db.storage.core.source_novelty_t.cljs$lang$maxFixedArity = 5;

fluree.db.storage.core.resolve_t = (function fluree$db$storage$core$resolve_t(node,t,idx_novelty,rhs,leftmost_QMARK_,remove_preds,error_fn){
var result_ch = cljs.core.async.promise_chan.call(null);
var c__86675__auto___92451 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___92451,result_ch){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___92451,result_ch){
return (function (state_92411){
var state_val_92412 = (state_92411[(1)]);
if((state_val_92412 === (7))){
var inst_92366 = (state_92411[(7)]);
var inst_92370 = (inst_92366 < t);
var state_92411__$1 = state_92411;
if(cljs.core.truth_(inst_92370)){
var statearr_92413_92452 = state_92411__$1;
(statearr_92413_92452[(1)] = (9));

} else {
var statearr_92414_92453 = state_92411__$1;
(statearr_92414_92453[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (20))){
var inst_92394 = (state_92411[(8)]);
var inst_92366 = (state_92411[(7)]);
var inst_92364 = (state_92411[(9)]);
var inst_92365 = (state_92411[(10)]);
var inst_92381 = (state_92411[(11)]);
var inst_92401 = (state_92411[(2)]);
var inst_92402 = (function (){var base_node = inst_92364;
var first_flake = inst_92365;
var node_t = inst_92366;
var source = inst_92381;
var coll = inst_92394;
var conj_QMARK_ = inst_92401;
return ((function (base_node,first_flake,node_t,source,coll,conj_QMARK_,inst_92394,inst_92366,inst_92364,inst_92365,inst_92381,inst_92401,state_val_92412,c__86675__auto___92451,result_ch){
return (function (acc,f){
if(cljs.core.truth_((function (){var or__4131__auto__ = remove_preds;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.PersistentHashSet.EMPTY;
}
})().call(null,f.p))){
return cljs.core.disj.call(null,acc,f);
} else {
if(cljs.core.truth_(conj_QMARK_.call(null,f))){
return cljs.core.conj.call(null,acc,f);
} else {
return cljs.core.disj.call(null,acc,f);

}
}
});
;})(base_node,first_flake,node_t,source,coll,conj_QMARK_,inst_92394,inst_92366,inst_92364,inst_92365,inst_92381,inst_92401,state_val_92412,c__86675__auto___92451,result_ch))
})();
var inst_92403 = new cljs.core.Keyword(null,"flakes","flakes",1977895739).cljs$core$IFn$_invoke$arity$1(inst_92364);
var inst_92404 = cljs.core.reduce.call(null,inst_92402,inst_92403,inst_92394);
var inst_92405 = cljs.core.doall.call(null,inst_92404);
var inst_92406 = cljs.core.assoc.call(null,inst_92364,new cljs.core.Keyword(null,"flakes","flakes",1977895739),inst_92405);
var inst_92407 = cljs.core.async.put_BANG_.call(null,result_ch,inst_92406);
var state_92411__$1 = state_92411;
var statearr_92415_92454 = state_92411__$1;
(statearr_92415_92454[(2)] = inst_92407);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92411__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (1))){
var state_92411__$1 = state_92411;
var statearr_92416_92455 = state_92411__$1;
(statearr_92416_92455[(2)] = null);

(statearr_92416_92455[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92411,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_92361 = fluree.db.dbproto._resolve.call(null,node);
var state_92411__$1 = state_92411;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92411__$1,(5),inst_92361);
} else {
if((state_val_92412 === (15))){
var inst_92381 = (state_92411[(11)]);
var inst_92394 = (state_92411[(2)]);
var state_92411__$1 = (function (){var statearr_92417 = state_92411;
(statearr_92417[(8)] = inst_92394);

return statearr_92417;
})();
var G__92418_92456 = inst_92381;
var G__92418_92457__$1 = (((G__92418_92456 instanceof cljs.core.Keyword))?G__92418_92456.fqn:null);
switch (G__92418_92457__$1) {
case "novelty":
var statearr_92419_92459 = state_92411__$1;
(statearr_92419_92459[(1)] = (21));


break;
case "history":
var statearr_92420_92460 = state_92411__$1;
(statearr_92420_92460[(1)] = (22));


break;
case "none":
var statearr_92421_92461 = state_92411__$1;
(statearr_92421_92461[(1)] = (23));


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__92418_92457__$1)].join('')));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (21))){
var inst_92394 = (state_92411[(8)]);
var inst_92366 = (state_92411[(7)]);
var inst_92364 = (state_92411[(9)]);
var inst_92365 = (state_92411[(10)]);
var inst_92381 = (state_92411[(11)]);
var inst_92395 = (function (){var base_node = inst_92364;
var first_flake = inst_92365;
var node_t = inst_92366;
var source = inst_92381;
var coll = inst_92394;
return ((function (base_node,first_flake,node_t,source,coll,inst_92394,inst_92366,inst_92364,inst_92365,inst_92381,state_val_92412,c__86675__auto___92451,result_ch){
return (function (f){
return f.op === true;
});
;})(base_node,first_flake,node_t,source,coll,inst_92394,inst_92366,inst_92364,inst_92365,inst_92381,state_val_92412,c__86675__auto___92451,result_ch))
})();
var state_92411__$1 = state_92411;
var statearr_92422_92462 = state_92411__$1;
(statearr_92422_92462[(2)] = inst_92395);

(statearr_92422_92462[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (13))){
var state_92411__$1 = state_92411;
var statearr_92423_92463 = state_92411__$1;
(statearr_92423_92463[(2)] = null);

(statearr_92423_92463[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (22))){
var inst_92394 = (state_92411[(8)]);
var inst_92366 = (state_92411[(7)]);
var inst_92364 = (state_92411[(9)]);
var inst_92365 = (state_92411[(10)]);
var inst_92381 = (state_92411[(11)]);
var inst_92397 = (function (){var base_node = inst_92364;
var first_flake = inst_92365;
var node_t = inst_92366;
var source = inst_92381;
var coll = inst_92394;
return ((function (base_node,first_flake,node_t,source,coll,inst_92394,inst_92366,inst_92364,inst_92365,inst_92381,state_val_92412,c__86675__auto___92451,result_ch){
return (function (f){
return f.op === false;
});
;})(base_node,first_flake,node_t,source,coll,inst_92394,inst_92366,inst_92364,inst_92365,inst_92381,state_val_92412,c__86675__auto___92451,result_ch))
})();
var state_92411__$1 = state_92411;
var statearr_92424_92464 = state_92411__$1;
(statearr_92424_92464[(2)] = inst_92397);

(statearr_92424_92464[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (6))){
var state_92411__$1 = state_92411;
var statearr_92425_92465 = state_92411__$1;
(statearr_92425_92465[(2)] = new cljs.core.Keyword(null,"novelty","novelty",-1590246024));

(statearr_92425_92465[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (17))){
var inst_92366 = (state_92411[(7)]);
var inst_92364 = (state_92411[(9)]);
var inst_92365 = (state_92411[(10)]);
var inst_92381 = (state_92411[(11)]);
var inst_92384 = (function (){var base_node = inst_92364;
var first_flake = inst_92365;
var node_t = inst_92366;
var source = inst_92381;
return ((function (base_node,first_flake,node_t,source,inst_92366,inst_92364,inst_92365,inst_92381,state_val_92412,c__86675__auto___92451,result_ch){
return (function (p1__92353_SHARP_){
return (p1__92353_SHARP_.t <= t);
});
;})(base_node,first_flake,node_t,source,inst_92366,inst_92364,inst_92365,inst_92381,state_val_92412,c__86675__auto___92451,result_ch))
})();
var inst_92385 = fluree.db.dbproto._resolve_history.call(null,node);
var state_92411__$1 = (function (){var statearr_92426 = state_92411;
(statearr_92426[(12)] = inst_92384);

return statearr_92426;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92411__$1,(18),inst_92385);
} else {
if((state_val_92412 === (3))){
var inst_92354 = (state_92411[(2)]);
var inst_92355 = error_fn.call(null);
var inst_92356 = cljs.core.async.put_BANG_.call(null,result_ch,inst_92354);
var inst_92357 = cljs.core.async.close_BANG_.call(null,result_ch);
var state_92411__$1 = (function (){var statearr_92427 = state_92411;
(statearr_92427[(13)] = inst_92356);

(statearr_92427[(14)] = inst_92355);

return statearr_92427;
})();
var statearr_92428_92466 = state_92411__$1;
(statearr_92428_92466[(2)] = inst_92357);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92411__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (12))){
var state_92411__$1 = state_92411;
var statearr_92429_92467 = state_92411__$1;
(statearr_92429_92467[(2)] = new cljs.core.Keyword(null,"none","none",1333468478));

(statearr_92429_92467[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (2))){
var inst_92409 = (state_92411[(2)]);
var state_92411__$1 = state_92411;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92411__$1,inst_92409);
} else {
if((state_val_92412 === (23))){
var state_92411__$1 = state_92411;
var statearr_92430_92468 = state_92411__$1;
(statearr_92430_92468[(2)] = null);

(statearr_92430_92468[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (19))){
var inst_92391 = cljs.core.PersistentVector.EMPTY;
var state_92411__$1 = state_92411;
var statearr_92431_92469 = state_92411__$1;
(statearr_92431_92469[(2)] = inst_92391);

(statearr_92431_92469[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (11))){
var inst_92379 = (state_92411[(2)]);
var state_92411__$1 = state_92411;
var statearr_92432_92470 = state_92411__$1;
(statearr_92432_92470[(2)] = inst_92379);

(statearr_92432_92470[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (9))){
var state_92411__$1 = state_92411;
var statearr_92433_92471 = state_92411__$1;
(statearr_92433_92471[(2)] = new cljs.core.Keyword(null,"history","history",-247395220));

(statearr_92433_92471[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (5))){
var inst_92366 = (state_92411[(7)]);
var inst_92364 = (state_92411[(9)]);
var inst_92363 = (state_92411[(2)]);
var inst_92364__$1 = fluree.db.util.async.throw_err.call(null,inst_92363);
var inst_92365 = fluree.db.dbproto._first_flake.call(null,inst_92364__$1);
var inst_92366__$1 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(inst_92364__$1);
var inst_92367 = (inst_92366__$1 > t);
var state_92411__$1 = (function (){var statearr_92434 = state_92411;
(statearr_92434[(7)] = inst_92366__$1);

(statearr_92434[(9)] = inst_92364__$1);

(statearr_92434[(10)] = inst_92365);

return statearr_92434;
})();
if(cljs.core.truth_(inst_92367)){
var statearr_92435_92472 = state_92411__$1;
(statearr_92435_92472[(1)] = (6));

} else {
var statearr_92436_92473 = state_92411__$1;
(statearr_92436_92473[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (14))){
var inst_92377 = (state_92411[(2)]);
var state_92411__$1 = state_92411;
var statearr_92437_92474 = state_92411__$1;
(statearr_92437_92474[(2)] = inst_92377);

(statearr_92437_92474[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (16))){
var inst_92365 = (state_92411[(10)]);
var inst_92382 = fluree.db.storage.core.source_novelty_t.call(null,idx_novelty,inst_92365,rhs,leftmost_QMARK_,t);
var state_92411__$1 = state_92411;
var statearr_92438_92475 = state_92411__$1;
(statearr_92438_92475[(2)] = inst_92382);

(statearr_92438_92475[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (10))){
var inst_92366 = (state_92411[(7)]);
var inst_92373 = cljs.core._EQ_.call(null,inst_92366,t);
var state_92411__$1 = state_92411;
if(inst_92373){
var statearr_92439_92476 = state_92411__$1;
(statearr_92439_92476[(1)] = (12));

} else {
var statearr_92440_92477 = state_92411__$1;
(statearr_92440_92477[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (18))){
var inst_92384 = (state_92411[(12)]);
var inst_92387 = (state_92411[(2)]);
var inst_92388 = fluree.db.util.async.throw_err.call(null,inst_92387);
var inst_92389 = cljs.core.take_while.call(null,inst_92384,inst_92388);
var state_92411__$1 = state_92411;
var statearr_92441_92478 = state_92411__$1;
(statearr_92441_92478[(2)] = inst_92389);

(statearr_92441_92478[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92412 === (8))){
var inst_92381 = (state_92411[(11)]);
var inst_92381__$1 = (state_92411[(2)]);
var state_92411__$1 = (function (){var statearr_92442 = state_92411;
(statearr_92442[(11)] = inst_92381__$1);

return statearr_92442;
})();
var G__92443_92479 = inst_92381__$1;
var G__92443_92480__$1 = (((G__92443_92479 instanceof cljs.core.Keyword))?G__92443_92479.fqn:null);
switch (G__92443_92480__$1) {
case "novelty":
var statearr_92444_92482 = state_92411__$1;
(statearr_92444_92482[(1)] = (16));


break;
case "history":
var statearr_92445_92483 = state_92411__$1;
(statearr_92445_92483[(1)] = (17));


break;
case "none":
var statearr_92446_92484 = state_92411__$1;
(statearr_92446_92484[(1)] = (19));


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__92443_92480__$1)].join('')));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto___92451,result_ch))
;
return ((function (switch__86624__auto__,c__86675__auto___92451,result_ch){
return (function() {
var fluree$db$storage$core$resolve_t_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$resolve_t_$_state_machine__86625__auto____0 = (function (){
var statearr_92447 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_92447[(0)] = fluree$db$storage$core$resolve_t_$_state_machine__86625__auto__);

(statearr_92447[(1)] = (1));

return statearr_92447;
});
var fluree$db$storage$core$resolve_t_$_state_machine__86625__auto____1 = (function (state_92411){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92411);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92448){if((e92448 instanceof Object)){
var ex__86628__auto__ = e92448;
var statearr_92449_92485 = state_92411;
(statearr_92449_92485[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92411);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92448;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92486 = state_92411;
state_92411 = G__92486;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$resolve_t_$_state_machine__86625__auto__ = function(state_92411){
switch(arguments.length){
case 0:
return fluree$db$storage$core$resolve_t_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$resolve_t_$_state_machine__86625__auto____1.call(this,state_92411);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$resolve_t_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$resolve_t_$_state_machine__86625__auto____0;
fluree$db$storage$core$resolve_t_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$resolve_t_$_state_machine__86625__auto____1;
return fluree$db$storage$core$resolve_t_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___92451,result_ch))
})();
var state__86677__auto__ = (function (){var statearr_92450 = f__86676__auto__.call(null);
(statearr_92450[(6)] = c__86675__auto___92451);

return statearr_92450;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___92451,result_ch))
);


return result_ch;
});
/**
 * Gets a history slice of a node with the oldest 't' from-t, to the
 *   most recent 't', to-t.
 * 
 *   Returns sorted set in novelty's sort order (spot, psot, post, or opst)
 */
fluree.db.storage.core.resolve_history_range = (function fluree$db$storage$core$resolve_history_range(node,from_t,to_t,idx_novelty,leftmost_QMARK_){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_92540){
var state_val_92541 = (state_92540[(1)]);
if((state_val_92541 === (7))){
var inst_92520 = (state_92540[(2)]);
var inst_92521 = fluree.db.dbproto._first_flake.call(null,node);
var inst_92522 = fluree.db.dbproto._rhs.call(null,node);
var inst_92523 = new cljs.core.Keyword(null,"leaf","leaf",1306118732).cljs$core$IFn$_invoke$arity$1(node);
var state_92540__$1 = (function (){var statearr_92542 = state_92540;
(statearr_92542[(7)] = inst_92520);

(statearr_92542[(8)] = inst_92521);

(statearr_92542[(9)] = inst_92522);

return statearr_92542;
})();
if(cljs.core.truth_(inst_92523)){
var statearr_92543_92571 = state_92540__$1;
(statearr_92543_92571[(1)] = (15));

} else {
var statearr_92544_92572 = state_92540__$1;
(statearr_92544_92572[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (1))){
var state_92540__$1 = state_92540;
var statearr_92545_92573 = state_92540__$1;
(statearr_92545_92573[(2)] = null);

(statearr_92545_92573[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (4))){
var inst_92495 = (state_92540[(10)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92540,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_92495__$1 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(node);
var inst_92496 = (from_t == null);
var inst_92497 = (inst_92495__$1 <= from_t);
var inst_92498 = ((inst_92496) || (inst_92497));
var state_92540__$1 = (function (){var statearr_92546 = state_92540;
(statearr_92546[(10)] = inst_92495__$1);

return statearr_92546;
})();
if(cljs.core.truth_(inst_92498)){
var statearr_92547_92574 = state_92540__$1;
(statearr_92547_92574[(1)] = (5));

} else {
var statearr_92548_92575 = state_92540__$1;
(statearr_92548_92575[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (15))){
var state_92540__$1 = state_92540;
var statearr_92549_92576 = state_92540__$1;
(statearr_92549_92576[(2)] = null);

(statearr_92549_92576[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (13))){
var inst_92511 = (state_92540[(11)]);
var state_92540__$1 = state_92540;
var statearr_92550_92577 = state_92540__$1;
(statearr_92550_92577[(2)] = inst_92511);

(statearr_92550_92577[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (6))){
var state_92540__$1 = state_92540;
var statearr_92551_92578 = state_92540__$1;
(statearr_92551_92578[(2)] = null);

(statearr_92551_92578[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (17))){
var inst_92520 = (state_92540[(7)]);
var inst_92521 = (state_92540[(8)]);
var inst_92522 = (state_92540[(9)]);
var inst_92534 = (state_92540[(2)]);
var inst_92535 = fluree.db.storage.core.source_novelty_t.call(null,idx_novelty,inst_92521,inst_92522,leftmost_QMARK_,to_t);
var inst_92536 = cljs.core.into.call(null,inst_92535,inst_92520);
var state_92540__$1 = (function (){var statearr_92552 = state_92540;
(statearr_92552[(12)] = inst_92534);

return statearr_92552;
})();
var statearr_92553_92579 = state_92540__$1;
(statearr_92553_92579[(2)] = inst_92536);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92540__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (3))){
var inst_92489 = (state_92540[(2)]);
var inst_92490 = fluree.db.util.log.error.call(null,inst_92489);
var inst_92491 = (function(){throw inst_92489})();
var state_92540__$1 = (function (){var statearr_92554 = state_92540;
(statearr_92554[(13)] = inst_92490);

return statearr_92554;
})();
var statearr_92555_92580 = state_92540__$1;
(statearr_92555_92580[(2)] = inst_92491);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92540__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (12))){
var inst_92511 = (state_92540[(11)]);
var inst_92495 = (state_92540[(10)]);
var inst_92513 = (function (){var node_t = inst_92495;
var G__92500 = inst_92511;
return ((function (node_t,G__92500,inst_92511,inst_92495,state_val_92541,c__86675__auto__){
return (function (p1__92488_SHARP_){
return (p1__92488_SHARP_.t <= from_t);
});
;})(node_t,G__92500,inst_92511,inst_92495,state_val_92541,c__86675__auto__))
})();
var inst_92514 = cljs.core.take_while.call(null,inst_92513,inst_92511);
var state_92540__$1 = state_92540;
var statearr_92556_92581 = state_92540__$1;
(statearr_92556_92581[(2)] = inst_92514);

(statearr_92556_92581[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (2))){
var inst_92538 = (state_92540[(2)]);
var state_92540__$1 = state_92540;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92540__$1,inst_92538);
} else {
if((state_val_92541 === (11))){
var inst_92511 = (state_92540[(2)]);
var state_92540__$1 = (function (){var statearr_92557 = state_92540;
(statearr_92557[(11)] = inst_92511);

return statearr_92557;
})();
if(cljs.core.truth_(from_t)){
var statearr_92558_92582 = state_92540__$1;
(statearr_92558_92582[(1)] = (12));

} else {
var statearr_92559_92583 = state_92540__$1;
(statearr_92559_92583[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (9))){
var inst_92504 = (state_92540[(14)]);
var inst_92495 = (state_92540[(10)]);
var inst_92507 = (function (){var node_t = inst_92495;
var G__92500 = inst_92504;
return ((function (node_t,G__92500,inst_92504,inst_92495,state_val_92541,c__86675__auto__){
return (function (p1__92487_SHARP_){
return (p1__92487_SHARP_.t < to_t);
});
;})(node_t,G__92500,inst_92504,inst_92495,state_val_92541,c__86675__auto__))
})();
var inst_92508 = cljs.core.drop_while.call(null,inst_92507,inst_92504);
var state_92540__$1 = state_92540;
var statearr_92560_92584 = state_92540__$1;
(statearr_92560_92584[(2)] = inst_92508);

(statearr_92560_92584[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (5))){
var inst_92501 = fluree.db.dbproto._resolve_history.call(null,node);
var state_92540__$1 = state_92540;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92540__$1,(8),inst_92501);
} else {
if((state_val_92541 === (14))){
var inst_92517 = (state_92540[(2)]);
var state_92540__$1 = state_92540;
var statearr_92561_92585 = state_92540__$1;
(statearr_92561_92585[(2)] = inst_92517);

(statearr_92561_92585[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (16))){
var inst_92526 = new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(node);
var inst_92527 = ["resolve-history-range called on index node: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_92526)].join('');
var inst_92528 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_92529 = [(500),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)];
var inst_92530 = cljs.core.PersistentHashMap.fromArrays(inst_92528,inst_92529);
var inst_92531 = cljs.core.ex_info.call(null,inst_92527,inst_92530);
var inst_92532 = (function(){throw inst_92531})();
var state_92540__$1 = state_92540;
var statearr_92562_92586 = state_92540__$1;
(statearr_92562_92586[(2)] = inst_92532);

(statearr_92562_92586[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (10))){
var inst_92504 = (state_92540[(14)]);
var state_92540__$1 = state_92540;
var statearr_92563_92587 = state_92540__$1;
(statearr_92563_92587[(2)] = inst_92504);

(statearr_92563_92587[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92541 === (8))){
var inst_92495 = (state_92540[(10)]);
var inst_92503 = (state_92540[(2)]);
var inst_92504 = fluree.db.util.async.throw_err.call(null,inst_92503);
var inst_92505 = (to_t > inst_92495);
var state_92540__$1 = (function (){var statearr_92564 = state_92540;
(statearr_92564[(14)] = inst_92504);

return statearr_92564;
})();
if(cljs.core.truth_(inst_92505)){
var statearr_92565_92588 = state_92540__$1;
(statearr_92565_92588[(1)] = (9));

} else {
var statearr_92566_92589 = state_92540__$1;
(statearr_92566_92589[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto____0 = (function (){
var statearr_92567 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_92567[(0)] = fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto__);

(statearr_92567[(1)] = (1));

return statearr_92567;
});
var fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto____1 = (function (state_92540){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92540);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92568){if((e92568 instanceof Object)){
var ex__86628__auto__ = e92568;
var statearr_92569_92590 = state_92540;
(statearr_92569_92590[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92540);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92568;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92591 = state_92540;
state_92540 = G__92591;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto__ = function(state_92540){
switch(arguments.length){
case 0:
return fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto____1.call(this,state_92540);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto____0;
fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto____1;
return fluree$db$storage$core$resolve_history_range_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_92570 = f__86676__auto__.call(null);
(statearr_92570[(6)] = c__86675__auto__);

return statearr_92570;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.storage.core.resolve_to_t = (function fluree$db$storage$core$resolve_to_t(node,id,tempid,rhs,leftmost_QMARK_,t,tt_id,idx_novelty,conn,fast_foward_db_QMARK_,remove_preds){
if(cljs.core.truth_((function (){var or__4131__auto__ = fast_foward_db_QMARK_;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"empty","empty",767870958),id);
}
})())){
return fluree.db.storage.core.resolve_t.call(null,node,t,idx_novelty,rhs,leftmost_QMARK_,remove_preds,null);
} else {
var object_cache = new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287).cljs$core$IFn$_invoke$arity$1(conn);
if((!(cljs.core.empty_QMARK_.call(null,remove_preds)))){
object_cache.call(null,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [id,t,tt_id,tempid], null),null);

return object_cache.call(null,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [id,t,tt_id,tempid], null),((function (object_cache){
return (function (_){
return fluree.db.storage.core.resolve_t.call(null,node,t,idx_novelty,rhs,leftmost_QMARK_,remove_preds,((function (object_cache){
return (function (){
return object_cache.call(null,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [id,t,tt_id,tempid], null),null);
});})(object_cache))
);
});})(object_cache))
);
} else {
return object_cache.call(null,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [id,t,tt_id,tempid], null),((function (object_cache){
return (function (_){
return fluree.db.storage.core.resolve_t.call(null,node,t,idx_novelty,rhs,leftmost_QMARK_,remove_preds,((function (object_cache){
return (function (){
return object_cache.call(null,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [id,t,tt_id,tempid], null),null);
});})(object_cache))
);
});})(object_cache))
);
}
}
});
/**
 * Reads and deserializes branch node.
 */
fluree.db.storage.core.read_branch = (function fluree$db$storage$core$read_branch(conn,key){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_92609){
var state_val_92610 = (state_92609[(1)]);
if((state_val_92610 === (1))){
var state_92609__$1 = state_92609;
var statearr_92611_92624 = state_92609__$1;
(statearr_92611_92624[(2)] = null);

(statearr_92611_92624[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92610 === (2))){
var inst_92607 = (state_92609[(2)]);
var state_92609__$1 = state_92609;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92609__$1,inst_92607);
} else {
if((state_val_92610 === (3))){
var inst_92592 = (state_92609[(2)]);
var state_92609__$1 = state_92609;
var statearr_92612_92625 = state_92609__$1;
(statearr_92612_92625[(2)] = inst_92592);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92609__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92610 === (4))){
var inst_92596 = (state_92609[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92609,(3),Error,null,(2));
var inst_92596__$1 = fluree.db.storage.core.storage_read.call(null,conn,key);
var state_92609__$1 = (function (){var statearr_92613 = state_92609;
(statearr_92613[(7)] = inst_92596__$1);

return statearr_92613;
})();
if(cljs.core.truth_(inst_92596__$1)){
var statearr_92614_92626 = state_92609__$1;
(statearr_92614_92626[(1)] = (5));

} else {
var statearr_92615_92627 = state_92609__$1;
(statearr_92615_92627[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92610 === (5))){
var inst_92596 = (state_92609[(7)]);
var inst_92598 = fluree.db.storage.core.serde.call(null,conn);
var state_92609__$1 = (function (){var statearr_92616 = state_92609;
(statearr_92616[(8)] = inst_92598);

return statearr_92616;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92609__$1,(8),inst_92596);
} else {
if((state_val_92610 === (6))){
var state_92609__$1 = state_92609;
var statearr_92617_92628 = state_92609__$1;
(statearr_92617_92628[(2)] = null);

(statearr_92617_92628[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92610 === (7))){
var inst_92605 = (state_92609[(2)]);
var state_92609__$1 = state_92609;
var statearr_92618_92629 = state_92609__$1;
(statearr_92618_92629[(2)] = inst_92605);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92609__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92610 === (8))){
var inst_92598 = (state_92609[(8)]);
var inst_92600 = (state_92609[(2)]);
var inst_92601 = fluree.db.util.async.throw_err.call(null,inst_92600);
var inst_92602 = fluree.db.serde.protocol._deserialize_branch.call(null,inst_92598,inst_92601);
var state_92609__$1 = state_92609;
var statearr_92619_92630 = state_92609__$1;
(statearr_92619_92630[(2)] = inst_92602);

(statearr_92619_92630[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$read_branch_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$read_branch_$_state_machine__86625__auto____0 = (function (){
var statearr_92620 = [null,null,null,null,null,null,null,null,null];
(statearr_92620[(0)] = fluree$db$storage$core$read_branch_$_state_machine__86625__auto__);

(statearr_92620[(1)] = (1));

return statearr_92620;
});
var fluree$db$storage$core$read_branch_$_state_machine__86625__auto____1 = (function (state_92609){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92609);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92621){if((e92621 instanceof Object)){
var ex__86628__auto__ = e92621;
var statearr_92622_92631 = state_92609;
(statearr_92622_92631[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92609);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92621;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92632 = state_92609;
state_92609 = G__92632;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$read_branch_$_state_machine__86625__auto__ = function(state_92609){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_branch_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_branch_$_state_machine__86625__auto____1.call(this,state_92609);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_branch_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_branch_$_state_machine__86625__auto____0;
fluree$db$storage$core$read_branch_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_branch_$_state_machine__86625__auto____1;
return fluree$db$storage$core$read_branch_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_92623 = f__86676__auto__.call(null);
(statearr_92623[(6)] = c__86675__auto__);

return statearr_92623;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Should throw if no result... should never be the case.
 */
fluree.db.storage.core.reify_branch = (function fluree$db$storage$core$reify_branch(conn,config,network,dbid,key,block,t,tt_id,leftmost_QMARK_,tempid,error_fn){
var return_ch = cljs.core.async.promise_chan.call(null);
var c__86675__auto___92767 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___92767,return_ch){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___92767,return_ch){
return (function (state_92719){
var state_val_92720 = (state_92719[(1)]);
if((state_val_92720 === (7))){
var state_92719__$1 = state_92719;
var statearr_92721_92768 = state_92719__$1;
(statearr_92721_92768[(2)] = null);

(statearr_92721_92768[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (20))){
var inst_92683 = (state_92719[(7)]);
var inst_92683__$1 = (state_92719[(2)]);
var inst_92684 = cljs.core.get.call(null,inst_92683__$1,new cljs.core.Keyword(null,"children","children",-940561982));
var inst_92685 = cljs.core.get.call(null,inst_92683__$1,new cljs.core.Keyword(null,"rhs","rhs",-229356739));
var inst_92687 = (config == null);
var inst_92688 = cljs.core.not.call(null,inst_92687);
var state_92719__$1 = (function (){var statearr_92722 = state_92719;
(statearr_92722[(7)] = inst_92683__$1);

(statearr_92722[(8)] = inst_92685);

(statearr_92722[(9)] = inst_92684);

return statearr_92722;
})();
if(inst_92688){
var statearr_92723_92769 = state_92719__$1;
(statearr_92723_92769[(1)] = (21));

} else {
var statearr_92724_92770 = state_92719__$1;
(statearr_92724_92770[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (27))){
var inst_92703 = cljs.core.apply.call(null,cljs.core.hash_map,config);
var state_92719__$1 = state_92719;
var statearr_92725_92771 = state_92719__$1;
(statearr_92725_92771[(2)] = inst_92703);

(statearr_92725_92771[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (1))){
var state_92719__$1 = state_92719;
var statearr_92726_92772 = state_92719__$1;
(statearr_92726_92772[(2)] = null);

(statearr_92726_92772[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (24))){
var state_92719__$1 = state_92719;
var statearr_92727_92773 = state_92719__$1;
(statearr_92727_92773[(2)] = true);

(statearr_92727_92773[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92719,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_92642 = fluree.db.storage.core.read_branch.call(null,conn,key);
var state_92719__$1 = state_92719;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92719__$1,(5),inst_92642);
} else {
if((state_val_92720 === (15))){
var state_92719__$1 = state_92719;
var statearr_92728_92774 = state_92719__$1;
(statearr_92728_92774[(2)] = true);

(statearr_92728_92774[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (21))){
var inst_92690 = config.cljs$lang$protocol_mask$partition0$;
var inst_92691 = (inst_92690 & (64));
var inst_92692 = config.cljs$core$ISeq$;
var inst_92693 = (cljs.core.PROTOCOL_SENTINEL === inst_92692);
var inst_92694 = ((inst_92691) || (inst_92693));
var state_92719__$1 = state_92719;
if(cljs.core.truth_(inst_92694)){
var statearr_92729_92775 = state_92719__$1;
(statearr_92729_92775[(1)] = (24));

} else {
var statearr_92730_92776 = state_92719__$1;
(statearr_92730_92776[(1)] = (25));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (13))){
var state_92719__$1 = state_92719;
var statearr_92731_92777 = state_92719__$1;
(statearr_92731_92777[(2)] = false);

(statearr_92731_92777[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (22))){
var state_92719__$1 = state_92719;
var statearr_92732_92778 = state_92719__$1;
(statearr_92732_92778[(2)] = false);

(statearr_92732_92778[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (29))){
var inst_92683 = (state_92719[(7)]);
var inst_92645 = (state_92719[(10)]);
var inst_92685 = (state_92719[(8)]);
var inst_92662 = (state_92719[(11)]);
var inst_92684 = (state_92719[(9)]);
var inst_92706 = (state_92719[(2)]);
var inst_92707 = cljs.core.get.call(null,inst_92706,new cljs.core.Keyword(null,"comparator","comparator",2144896662));
var inst_92709 = (function (){var data = inst_92645;
var _ = inst_92662;
var map__92640 = inst_92683;
var children = inst_92684;
var rhs = inst_92685;
var map__92641 = inst_92706;
var comparator = inst_92707;
return ((function (data,_,map__92640,children,rhs,map__92641,comparator,inst_92683,inst_92645,inst_92685,inst_92662,inst_92684,inst_92706,inst_92707,state_val_92720,c__86675__auto___92767,return_ch){
return (function (idx,p__92708){
var map__92733 = p__92708;
var map__92733__$1 = (((((!((map__92733 == null))))?(((((map__92733.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__92733.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__92733):map__92733);
var child = map__92733__$1;
var id = cljs.core.get.call(null,map__92733__$1,new cljs.core.Keyword(null,"id","id",-1388402092));
var leaf = cljs.core.get.call(null,map__92733__$1,new cljs.core.Keyword(null,"leaf","leaf",1306118732));
var first = cljs.core.get.call(null,map__92733__$1,new cljs.core.Keyword(null,"first","first",-644103046));
var rhs__$1 = cljs.core.get.call(null,map__92733__$1,new cljs.core.Keyword(null,"rhs","rhs",-229356739));
var size = cljs.core.get.call(null,map__92733__$1,new cljs.core.Keyword(null,"size","size",1098693007));
var at_leftmost_QMARK_ = (function (){var and__4120__auto__ = leftmost_QMARK_;
if(cljs.core.truth_(and__4120__auto__)){
return (idx === (0));
} else {
return and__4120__auto__;
}
})();
return fluree.db.storage.core.__GT_UnresolvedNode.call(null,conn,config,network,dbid,id,leaf,first,rhs__$1,size,block,t,tt_id,at_leftmost_QMARK_,tempid);
});
;})(data,_,map__92640,children,rhs,map__92641,comparator,inst_92683,inst_92645,inst_92685,inst_92662,inst_92684,inst_92706,inst_92707,state_val_92720,c__86675__auto___92767,return_ch))
})();
var inst_92710 = cljs.core.map_indexed.call(null,inst_92709,inst_92684);
var inst_92711 = cljs.core.map.call(null,new cljs.core.Keyword(null,"first","first",-644103046),inst_92710);
var inst_92712 = cljs.core.interleave.call(null,inst_92711,inst_92710);
var inst_92713 = cljs.core.apply.call(null,clojure.data.avl.sorted_map_by,inst_92707,inst_92712);
var inst_92714 = fluree.db.index.__GT_IndexNode.call(null,block,t,inst_92685,inst_92713,config,leftmost_QMARK_);
var inst_92715 = cljs.core.async.put_BANG_.call(null,return_ch,inst_92714);
var state_92719__$1 = state_92719;
var statearr_92735_92779 = state_92719__$1;
(statearr_92735_92779[(2)] = inst_92715);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92719__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (6))){
var inst_92648 = ["Unable to retrieve key from storage: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(key)].join('');
var inst_92649 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_92650 = [(500),new cljs.core.Keyword("db","storage-error","db/storage-error",-1318220587)];
var inst_92651 = cljs.core.PersistentHashMap.fromArrays(inst_92649,inst_92650);
var inst_92652 = cljs.core.ex_info.call(null,inst_92648,inst_92651);
var inst_92653 = (function(){throw inst_92652})();
var state_92719__$1 = state_92719;
var statearr_92736_92780 = state_92719__$1;
(statearr_92736_92780[(2)] = inst_92653);

(statearr_92736_92780[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (28))){
var state_92719__$1 = state_92719;
var statearr_92737_92781 = state_92719__$1;
(statearr_92737_92781[(2)] = config);

(statearr_92737_92781[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (25))){
var state_92719__$1 = state_92719;
var statearr_92738_92782 = state_92719__$1;
(statearr_92738_92782[(2)] = false);

(statearr_92738_92782[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (17))){
var inst_92675 = (state_92719[(2)]);
var state_92719__$1 = state_92719;
var statearr_92739_92783 = state_92719__$1;
(statearr_92739_92783[(2)] = inst_92675);

(statearr_92739_92783[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (3))){
var inst_92633 = (state_92719[(2)]);
var inst_92634 = error_fn.call(null);
var inst_92635 = cljs.core.async.put_BANG_.call(null,return_ch,inst_92633);
var inst_92636 = cljs.core.async.close_BANG_.call(null,return_ch);
var state_92719__$1 = (function (){var statearr_92740 = state_92719;
(statearr_92740[(12)] = inst_92635);

(statearr_92740[(13)] = inst_92634);

return statearr_92740;
})();
var statearr_92741_92784 = state_92719__$1;
(statearr_92741_92784[(2)] = inst_92636);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92719__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (12))){
var inst_92645 = (state_92719[(10)]);
var inst_92667 = inst_92645.cljs$lang$protocol_mask$partition0$;
var inst_92668 = (inst_92667 & (64));
var inst_92669 = inst_92645.cljs$core$ISeq$;
var inst_92670 = (cljs.core.PROTOCOL_SENTINEL === inst_92669);
var inst_92671 = ((inst_92668) || (inst_92670));
var state_92719__$1 = state_92719;
if(cljs.core.truth_(inst_92671)){
var statearr_92742_92785 = state_92719__$1;
(statearr_92742_92785[(1)] = (15));

} else {
var statearr_92743_92786 = state_92719__$1;
(statearr_92743_92786[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (2))){
var inst_92717 = (state_92719[(2)]);
var state_92719__$1 = state_92719;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92719__$1,inst_92717);
} else {
if((state_val_92720 === (23))){
var inst_92701 = (state_92719[(2)]);
var state_92719__$1 = state_92719;
if(cljs.core.truth_(inst_92701)){
var statearr_92744_92787 = state_92719__$1;
(statearr_92744_92787[(1)] = (27));

} else {
var statearr_92745_92788 = state_92719__$1;
(statearr_92745_92788[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (19))){
var inst_92645 = (state_92719[(10)]);
var state_92719__$1 = state_92719;
var statearr_92746_92789 = state_92719__$1;
(statearr_92746_92789[(2)] = inst_92645);

(statearr_92746_92789[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (11))){
var inst_92645 = (state_92719[(10)]);
var inst_92662 = (state_92719[(2)]);
var inst_92664 = (inst_92645 == null);
var inst_92665 = cljs.core.not.call(null,inst_92664);
var state_92719__$1 = (function (){var statearr_92747 = state_92719;
(statearr_92747[(11)] = inst_92662);

return statearr_92747;
})();
if(inst_92665){
var statearr_92748_92790 = state_92719__$1;
(statearr_92748_92790[(1)] = (12));

} else {
var statearr_92749_92791 = state_92719__$1;
(statearr_92749_92791[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (9))){
var inst_92645 = (state_92719[(10)]);
var inst_92659 = (function(){throw inst_92645})();
var state_92719__$1 = state_92719;
var statearr_92750_92792 = state_92719__$1;
(statearr_92750_92792[(2)] = inst_92659);

(statearr_92750_92792[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (5))){
var inst_92645 = (state_92719[(10)]);
var inst_92644 = (state_92719[(2)]);
var inst_92645__$1 = fluree.db.util.async.throw_err.call(null,inst_92644);
var inst_92646 = (inst_92645__$1 == null);
var state_92719__$1 = (function (){var statearr_92751 = state_92719;
(statearr_92751[(10)] = inst_92645__$1);

return statearr_92751;
})();
if(cljs.core.truth_(inst_92646)){
var statearr_92752_92793 = state_92719__$1;
(statearr_92752_92793[(1)] = (6));

} else {
var statearr_92753_92794 = state_92719__$1;
(statearr_92753_92794[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (14))){
var inst_92678 = (state_92719[(2)]);
var state_92719__$1 = state_92719;
if(cljs.core.truth_(inst_92678)){
var statearr_92754_92795 = state_92719__$1;
(statearr_92754_92795[(1)] = (18));

} else {
var statearr_92755_92796 = state_92719__$1;
(statearr_92755_92796[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (26))){
var inst_92698 = (state_92719[(2)]);
var state_92719__$1 = state_92719;
var statearr_92756_92797 = state_92719__$1;
(statearr_92756_92797[(2)] = inst_92698);

(statearr_92756_92797[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (16))){
var state_92719__$1 = state_92719;
var statearr_92757_92798 = state_92719__$1;
(statearr_92757_92798[(2)] = false);

(statearr_92757_92798[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (10))){
var state_92719__$1 = state_92719;
var statearr_92758_92799 = state_92719__$1;
(statearr_92758_92799[(2)] = null);

(statearr_92758_92799[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (18))){
var inst_92645 = (state_92719[(10)]);
var inst_92680 = cljs.core.apply.call(null,cljs.core.hash_map,inst_92645);
var state_92719__$1 = state_92719;
var statearr_92759_92800 = state_92719__$1;
(statearr_92759_92800[(2)] = inst_92680);

(statearr_92759_92800[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92720 === (8))){
var inst_92645 = (state_92719[(10)]);
var inst_92656 = (state_92719[(2)]);
var inst_92657 = fluree.db.util.core.exception_QMARK_.call(null,inst_92645);
var state_92719__$1 = (function (){var statearr_92760 = state_92719;
(statearr_92760[(14)] = inst_92656);

return statearr_92760;
})();
if(inst_92657){
var statearr_92761_92801 = state_92719__$1;
(statearr_92761_92801[(1)] = (9));

} else {
var statearr_92762_92802 = state_92719__$1;
(statearr_92762_92802[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto___92767,return_ch))
;
return ((function (switch__86624__auto__,c__86675__auto___92767,return_ch){
return (function() {
var fluree$db$storage$core$reify_branch_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$reify_branch_$_state_machine__86625__auto____0 = (function (){
var statearr_92763 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_92763[(0)] = fluree$db$storage$core$reify_branch_$_state_machine__86625__auto__);

(statearr_92763[(1)] = (1));

return statearr_92763;
});
var fluree$db$storage$core$reify_branch_$_state_machine__86625__auto____1 = (function (state_92719){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92719);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92764){if((e92764 instanceof Object)){
var ex__86628__auto__ = e92764;
var statearr_92765_92803 = state_92719;
(statearr_92765_92803[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92719);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92764;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92804 = state_92719;
state_92719 = G__92804;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$reify_branch_$_state_machine__86625__auto__ = function(state_92719){
switch(arguments.length){
case 0:
return fluree$db$storage$core$reify_branch_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$reify_branch_$_state_machine__86625__auto____1.call(this,state_92719);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$reify_branch_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$reify_branch_$_state_machine__86625__auto____0;
fluree$db$storage$core$reify_branch_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$reify_branch_$_state_machine__86625__auto____1;
return fluree$db$storage$core$reify_branch_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___92767,return_ch))
})();
var state__86677__auto__ = (function (){var statearr_92766 = f__86676__auto__.call(null);
(statearr_92766[(6)] = c__86675__auto___92767);

return statearr_92766;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___92767,return_ch))
);


return return_ch;
});
/**
 * Reads and deserializes a leaf node
 */
fluree.db.storage.core.read_leaf = (function fluree$db$storage$core$read_leaf(conn,key){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_92822){
var state_val_92823 = (state_92822[(1)]);
if((state_val_92823 === (1))){
var state_92822__$1 = state_92822;
var statearr_92824_92837 = state_92822__$1;
(statearr_92824_92837[(2)] = null);

(statearr_92824_92837[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92823 === (2))){
var inst_92820 = (state_92822[(2)]);
var state_92822__$1 = state_92822;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92822__$1,inst_92820);
} else {
if((state_val_92823 === (3))){
var inst_92805 = (state_92822[(2)]);
var state_92822__$1 = state_92822;
var statearr_92825_92838 = state_92822__$1;
(statearr_92825_92838[(2)] = inst_92805);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92822__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92823 === (4))){
var inst_92809 = (state_92822[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92822,(3),Error,null,(2));
var inst_92809__$1 = fluree.db.storage.core.storage_read.call(null,conn,key);
var state_92822__$1 = (function (){var statearr_92826 = state_92822;
(statearr_92826[(7)] = inst_92809__$1);

return statearr_92826;
})();
if(cljs.core.truth_(inst_92809__$1)){
var statearr_92827_92839 = state_92822__$1;
(statearr_92827_92839[(1)] = (5));

} else {
var statearr_92828_92840 = state_92822__$1;
(statearr_92828_92840[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92823 === (5))){
var inst_92809 = (state_92822[(7)]);
var inst_92811 = fluree.db.storage.core.serde.call(null,conn);
var state_92822__$1 = (function (){var statearr_92829 = state_92822;
(statearr_92829[(8)] = inst_92811);

return statearr_92829;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92822__$1,(8),inst_92809);
} else {
if((state_val_92823 === (6))){
var state_92822__$1 = state_92822;
var statearr_92830_92841 = state_92822__$1;
(statearr_92830_92841[(2)] = null);

(statearr_92830_92841[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92823 === (7))){
var inst_92818 = (state_92822[(2)]);
var state_92822__$1 = state_92822;
var statearr_92831_92842 = state_92822__$1;
(statearr_92831_92842[(2)] = inst_92818);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92822__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92823 === (8))){
var inst_92811 = (state_92822[(8)]);
var inst_92813 = (state_92822[(2)]);
var inst_92814 = fluree.db.util.async.throw_err.call(null,inst_92813);
var inst_92815 = fluree.db.serde.protocol._deserialize_leaf.call(null,inst_92811,inst_92814);
var state_92822__$1 = state_92822;
var statearr_92832_92843 = state_92822__$1;
(statearr_92832_92843[(2)] = inst_92815);

(statearr_92832_92843[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$read_leaf_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$read_leaf_$_state_machine__86625__auto____0 = (function (){
var statearr_92833 = [null,null,null,null,null,null,null,null,null];
(statearr_92833[(0)] = fluree$db$storage$core$read_leaf_$_state_machine__86625__auto__);

(statearr_92833[(1)] = (1));

return statearr_92833;
});
var fluree$db$storage$core$read_leaf_$_state_machine__86625__auto____1 = (function (state_92822){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92822);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92834){if((e92834 instanceof Object)){
var ex__86628__auto__ = e92834;
var statearr_92835_92844 = state_92822;
(statearr_92835_92844[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92822);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92834;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__92845 = state_92822;
state_92822 = G__92845;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$read_leaf_$_state_machine__86625__auto__ = function(state_92822){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_leaf_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_leaf_$_state_machine__86625__auto____1.call(this,state_92822);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_leaf_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_leaf_$_state_machine__86625__auto____0;
fluree$db$storage$core$read_leaf_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_leaf_$_state_machine__86625__auto____1;
return fluree$db$storage$core$read_leaf_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_92836 = f__86676__auto__.call(null);
(statearr_92836[(6)] = c__86675__auto__);

return statearr_92836;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Should throw if no result... should never be the case.
 */
fluree.db.storage.core.reify_leaf = (function fluree$db$storage$core$reify_leaf(conn,config,key,block,t,rhs,error_fn){
if(cljs.core.truth_(new cljs.core.Keyword(null,"comparator","comparator",2144896662).cljs$core$IFn$_invoke$arity$1(config))){
} else {
throw (new Error(["Assert failed: ",["Cannot reify leaf, config does not have a comparator. Config: ",cljs.core.pr_str.call(null,config)].join(''),"\n","(:comparator config)"].join('')));
}

var return_ch = cljs.core.async.promise_chan.call(null);
var c__86675__auto___92972 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___92972,return_ch){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___92972,return_ch){
return (function (state_92926){
var state_val_92927 = (state_92926[(1)]);
if((state_val_92927 === (7))){
var state_92926__$1 = state_92926;
var statearr_92928_92973 = state_92926__$1;
(statearr_92928_92973[(2)] = null);

(statearr_92928_92973[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (20))){
var inst_92895 = (state_92926[(2)]);
var inst_92896 = cljs.core.get.call(null,inst_92895,new cljs.core.Keyword(null,"flakes","flakes",1977895739));
var inst_92897 = cljs.core.get.call(null,inst_92895,new cljs.core.Keyword(null,"his","his",-1294347076));
var inst_92899 = (config == null);
var inst_92900 = cljs.core.not.call(null,inst_92899);
var state_92926__$1 = (function (){var statearr_92929 = state_92926;
(statearr_92929[(7)] = inst_92897);

(statearr_92929[(8)] = inst_92896);

return statearr_92929;
})();
if(inst_92900){
var statearr_92930_92974 = state_92926__$1;
(statearr_92930_92974[(1)] = (21));

} else {
var statearr_92931_92975 = state_92926__$1;
(statearr_92931_92975[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (27))){
var inst_92915 = cljs.core.apply.call(null,cljs.core.hash_map,config);
var state_92926__$1 = state_92926;
var statearr_92932_92976 = state_92926__$1;
(statearr_92932_92976[(2)] = inst_92915);

(statearr_92932_92976[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (1))){
var state_92926__$1 = state_92926;
var statearr_92933_92977 = state_92926__$1;
(statearr_92933_92977[(2)] = null);

(statearr_92933_92977[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (24))){
var state_92926__$1 = state_92926;
var statearr_92934_92978 = state_92926__$1;
(statearr_92934_92978[(2)] = true);

(statearr_92934_92978[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_92926,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_92855 = fluree.db.storage.core.read_leaf.call(null,conn,key);
var state_92926__$1 = state_92926;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_92926__$1,(5),inst_92855);
} else {
if((state_val_92927 === (15))){
var state_92926__$1 = state_92926;
var statearr_92935_92979 = state_92926__$1;
(statearr_92935_92979[(2)] = true);

(statearr_92935_92979[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (21))){
var inst_92902 = config.cljs$lang$protocol_mask$partition0$;
var inst_92903 = (inst_92902 & (64));
var inst_92904 = config.cljs$core$ISeq$;
var inst_92905 = (cljs.core.PROTOCOL_SENTINEL === inst_92904);
var inst_92906 = ((inst_92903) || (inst_92905));
var state_92926__$1 = state_92926;
if(cljs.core.truth_(inst_92906)){
var statearr_92936_92980 = state_92926__$1;
(statearr_92936_92980[(1)] = (24));

} else {
var statearr_92937_92981 = state_92926__$1;
(statearr_92937_92981[(1)] = (25));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (13))){
var state_92926__$1 = state_92926;
var statearr_92938_92982 = state_92926__$1;
(statearr_92938_92982[(2)] = false);

(statearr_92938_92982[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (22))){
var state_92926__$1 = state_92926;
var statearr_92939_92983 = state_92926__$1;
(statearr_92939_92983[(2)] = false);

(statearr_92939_92983[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (29))){
var inst_92896 = (state_92926[(8)]);
var inst_92918 = (state_92926[(2)]);
var inst_92919 = cljs.core.get.call(null,inst_92918,new cljs.core.Keyword(null,"comparator","comparator",2144896662));
var inst_92920 = cljs.core.apply.call(null,fluree.db.flake.sorted_set_by,inst_92919,inst_92896);
var inst_92921 = fluree.db.index.data_node.call(null,block,t,inst_92920,rhs,config);
var inst_92922 = cljs.core.async.put_BANG_.call(null,return_ch,inst_92921);
var state_92926__$1 = state_92926;
var statearr_92940_92984 = state_92926__$1;
(statearr_92940_92984[(2)] = inst_92922);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92926__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (6))){
var inst_92860 = ["Unable to retrieve key from storage: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(key)].join('');
var inst_92861 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_92862 = [(500),new cljs.core.Keyword("db","storage-error","db/storage-error",-1318220587)];
var inst_92863 = cljs.core.PersistentHashMap.fromArrays(inst_92861,inst_92862);
var inst_92864 = cljs.core.ex_info.call(null,inst_92860,inst_92863);
var inst_92865 = (function(){throw inst_92864})();
var state_92926__$1 = state_92926;
var statearr_92941_92985 = state_92926__$1;
(statearr_92941_92985[(2)] = inst_92865);

(statearr_92941_92985[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (28))){
var state_92926__$1 = state_92926;
var statearr_92942_92986 = state_92926__$1;
(statearr_92942_92986[(2)] = config);

(statearr_92942_92986[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (25))){
var state_92926__$1 = state_92926;
var statearr_92943_92987 = state_92926__$1;
(statearr_92943_92987[(2)] = false);

(statearr_92943_92987[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (17))){
var inst_92887 = (state_92926[(2)]);
var state_92926__$1 = state_92926;
var statearr_92944_92988 = state_92926__$1;
(statearr_92944_92988[(2)] = inst_92887);

(statearr_92944_92988[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (3))){
var inst_92846 = (state_92926[(2)]);
var inst_92847 = error_fn.call(null);
var inst_92848 = cljs.core.async.put_BANG_.call(null,return_ch,inst_92846);
var inst_92849 = cljs.core.async.close_BANG_.call(null,return_ch);
var state_92926__$1 = (function (){var statearr_92945 = state_92926;
(statearr_92945[(9)] = inst_92848);

(statearr_92945[(10)] = inst_92847);

return statearr_92945;
})();
var statearr_92946_92989 = state_92926__$1;
(statearr_92946_92989[(2)] = inst_92849);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92926__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (12))){
var inst_92857 = (state_92926[(11)]);
var inst_92879 = inst_92857.cljs$lang$protocol_mask$partition0$;
var inst_92880 = (inst_92879 & (64));
var inst_92881 = inst_92857.cljs$core$ISeq$;
var inst_92882 = (cljs.core.PROTOCOL_SENTINEL === inst_92881);
var inst_92883 = ((inst_92880) || (inst_92882));
var state_92926__$1 = state_92926;
if(cljs.core.truth_(inst_92883)){
var statearr_92947_92990 = state_92926__$1;
(statearr_92947_92990[(1)] = (15));

} else {
var statearr_92948_92991 = state_92926__$1;
(statearr_92948_92991[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (2))){
var inst_92924 = (state_92926[(2)]);
var state_92926__$1 = state_92926;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_92926__$1,inst_92924);
} else {
if((state_val_92927 === (23))){
var inst_92913 = (state_92926[(2)]);
var state_92926__$1 = state_92926;
if(cljs.core.truth_(inst_92913)){
var statearr_92949_92992 = state_92926__$1;
(statearr_92949_92992[(1)] = (27));

} else {
var statearr_92950_92993 = state_92926__$1;
(statearr_92950_92993[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (19))){
var inst_92857 = (state_92926[(11)]);
var state_92926__$1 = state_92926;
var statearr_92951_92994 = state_92926__$1;
(statearr_92951_92994[(2)] = inst_92857);

(statearr_92951_92994[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (11))){
var inst_92857 = (state_92926[(11)]);
var inst_92874 = (state_92926[(2)]);
var inst_92876 = (inst_92857 == null);
var inst_92877 = cljs.core.not.call(null,inst_92876);
var state_92926__$1 = (function (){var statearr_92952 = state_92926;
(statearr_92952[(12)] = inst_92874);

return statearr_92952;
})();
if(inst_92877){
var statearr_92953_92995 = state_92926__$1;
(statearr_92953_92995[(1)] = (12));

} else {
var statearr_92954_92996 = state_92926__$1;
(statearr_92954_92996[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (9))){
var inst_92857 = (state_92926[(11)]);
var inst_92871 = (function(){throw inst_92857})();
var state_92926__$1 = state_92926;
var statearr_92955_92997 = state_92926__$1;
(statearr_92955_92997[(2)] = inst_92871);

(statearr_92955_92997[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (5))){
var inst_92857 = (state_92926[(11)]);
var inst_92857__$1 = (state_92926[(2)]);
var inst_92858 = (inst_92857__$1 == null);
var state_92926__$1 = (function (){var statearr_92956 = state_92926;
(statearr_92956[(11)] = inst_92857__$1);

return statearr_92956;
})();
if(cljs.core.truth_(inst_92858)){
var statearr_92957_92998 = state_92926__$1;
(statearr_92957_92998[(1)] = (6));

} else {
var statearr_92958_92999 = state_92926__$1;
(statearr_92958_92999[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (14))){
var inst_92890 = (state_92926[(2)]);
var state_92926__$1 = state_92926;
if(cljs.core.truth_(inst_92890)){
var statearr_92959_93000 = state_92926__$1;
(statearr_92959_93000[(1)] = (18));

} else {
var statearr_92960_93001 = state_92926__$1;
(statearr_92960_93001[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (26))){
var inst_92910 = (state_92926[(2)]);
var state_92926__$1 = state_92926;
var statearr_92961_93002 = state_92926__$1;
(statearr_92961_93002[(2)] = inst_92910);

(statearr_92961_93002[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (16))){
var state_92926__$1 = state_92926;
var statearr_92962_93003 = state_92926__$1;
(statearr_92962_93003[(2)] = false);

(statearr_92962_93003[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (10))){
var state_92926__$1 = state_92926;
var statearr_92963_93004 = state_92926__$1;
(statearr_92963_93004[(2)] = null);

(statearr_92963_93004[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (18))){
var inst_92857 = (state_92926[(11)]);
var inst_92892 = cljs.core.apply.call(null,cljs.core.hash_map,inst_92857);
var state_92926__$1 = state_92926;
var statearr_92964_93005 = state_92926__$1;
(statearr_92964_93005[(2)] = inst_92892);

(statearr_92964_93005[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_92927 === (8))){
var inst_92857 = (state_92926[(11)]);
var inst_92868 = (state_92926[(2)]);
var inst_92869 = fluree.db.util.core.exception_QMARK_.call(null,inst_92857);
var state_92926__$1 = (function (){var statearr_92965 = state_92926;
(statearr_92965[(13)] = inst_92868);

return statearr_92965;
})();
if(inst_92869){
var statearr_92966_93006 = state_92926__$1;
(statearr_92966_93006[(1)] = (9));

} else {
var statearr_92967_93007 = state_92926__$1;
(statearr_92967_93007[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto___92972,return_ch))
;
return ((function (switch__86624__auto__,c__86675__auto___92972,return_ch){
return (function() {
var fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto____0 = (function (){
var statearr_92968 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_92968[(0)] = fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto__);

(statearr_92968[(1)] = (1));

return statearr_92968;
});
var fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto____1 = (function (state_92926){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_92926);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e92969){if((e92969 instanceof Object)){
var ex__86628__auto__ = e92969;
var statearr_92970_93008 = state_92926;
(statearr_92970_93008[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_92926);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e92969;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__93009 = state_92926;
state_92926 = G__93009;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto__ = function(state_92926){
switch(arguments.length){
case 0:
return fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto____1.call(this,state_92926);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto____0;
fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto____1;
return fluree$db$storage$core$reify_leaf_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___92972,return_ch))
})();
var state__86677__auto__ = (function (){var statearr_92971 = f__86676__auto__.call(null);
(statearr_92971[(6)] = c__86675__auto___92972);

return statearr_92971;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___92972,return_ch))
);


return return_ch;
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.storage.core.UnresolvedNode = (function (conn,config,network,dbid,id,leaf,first,rhs,size,block,t,tt_id,leftmost_QMARK_,tempid,__meta,__extmap,__hash){
this.conn = conn;
this.config = config;
this.network = network;
this.dbid = dbid;
this.id = id;
this.leaf = leaf;
this.first = first;
this.rhs = rhs;
this.size = size;
this.block = block;
this.t = t;
this.tt_id = tt_id;
this.leftmost_QMARK_ = leftmost_QMARK_;
this.tempid = tempid;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k93011,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__93015 = k93011;
var G__93015__$1 = (((G__93015 instanceof cljs.core.Keyword))?G__93015.fqn:null);
switch (G__93015__$1) {
case "conn":
return self__.conn;

break;
case "config":
return self__.config;

break;
case "network":
return self__.network;

break;
case "dbid":
return self__.dbid;

break;
case "id":
return self__.id;

break;
case "leaf":
return self__.leaf;

break;
case "first":
return self__.first;

break;
case "rhs":
return self__.rhs;

break;
case "size":
return self__.size;

break;
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "tt-id":
return self__.tt_id;

break;
case "leftmost?":
return self__.leftmost_QMARK_;

break;
case "tempid":
return self__.tempid;

break;
default:
return cljs.core.get.call(null,self__.__extmap,k93011,else__4388__auto__);

}
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.call(null,((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__93016){
var vec__93017 = p__93016;
var k__4408__auto__ = cljs.core.nth.call(null,vec__93017,(0),null);
var v__4409__auto__ = cljs.core.nth.call(null,vec__93017,(1),null);
return f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__);
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.storage.core.UnresolvedNode{",", ","}",opts__4401__auto__,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 14, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"conn","conn",278309663),self__.conn],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"config","config",994861415),self__.config],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"network","network",2050004697),self__.network],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"dbid","dbid",-196647356),self__.dbid],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"id","id",-1388402092),self__.id],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"leaf","leaf",1306118732),self__.leaf],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"first","first",-644103046),self__.first],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"size","size",1098693007),self__.size],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"block","block",664686210),self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"t","t",-1397832519),self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"tt-id","tt-id",725587484),self__.tt_id],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),self__.leftmost_QMARK_],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"tempid","tempid",1427663222),self__.tempid],null))], null),self__.__extmap));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__93010){
var self__ = this;
var G__93010__$1 = this;
return (new cljs.core.RecordIter((0),G__93010__$1,14,new cljs.core.PersistentVector(null, 14, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"conn","conn",278309663),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"network","network",2050004697),new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"leaf","leaf",1306118732),new cljs.core.Keyword(null,"first","first",-644103046),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"size","size",1098693007),new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"tt-id","tt-id",725587484),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),new cljs.core.Keyword(null,"tempid","tempid",1427663222)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.first;
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"empty","empty",767870958),self__.id)){
var pc = cljs.core.async.promise_chan.call(null);
cljs.core.async.put_BANG_.call(null,pc,fluree.db.index.data_node.call(null,(0),(0),fluree.db.flake.sorted_set_by.call(null,new cljs.core.Keyword(null,"comparator","comparator",2144896662).cljs$core$IFn$_invoke$arity$1(self__.config)),null,self__.config));

return pc;
} else {
var object_cache = new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287).cljs$core$IFn$_invoke$arity$1(self__.conn);
return object_cache.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.id,self__.tempid], null),((function (object_cache,___$1){
return (function (___$2){
if(cljs.core.truth_(self__.leaf)){
return fluree.db.storage.core.reify_leaf.call(null,self__.conn,self__.config,self__.id,self__.block,self__.t,self__.rhs,((function (object_cache,___$1){
return (function (){
return object_cache.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.id,self__.tempid], null),null);
});})(object_cache,___$1))
);
} else {
return fluree.db.storage.core.reify_branch.call(null,self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,((function (object_cache,___$1){
return (function (){
return object_cache.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.id,self__.tempid], null),null);
});})(object_cache,___$1))
);
}
});})(object_cache,___$1))
);
}
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_history$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
var history_id = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.id),"-his"].join('');
var object_cache = new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287).cljs$core$IFn$_invoke$arity$1(self__.conn);
var error_fn = ((function (history_id,object_cache,___$1){
return (function (){
return object_cache.call(null,history_id,null);
});})(history_id,object_cache,___$1))
;
return object_cache.call(null,history_id,((function (history_id,object_cache,error_fn,___$1){
return (function (___$2){
return fluree.db.storage.core.reify_history.call(null,self__.conn,history_id,error_fn);
});})(history_id,object_cache,error_fn,___$1))
);
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_to_t$arity$3 = (function (this$,to_t,idx_novelty){
var self__ = this;
var this$__$1 = this;
return fluree.db.storage.core.resolve_to_t.call(null,this$__$1,self__.id,self__.tempid,self__.rhs,self__.leftmost_QMARK_,to_t,self__.tt_id,idx_novelty,self__.conn,false,cljs.core.PersistentHashSet.EMPTY);
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_to_t$arity$4 = (function (this$,to_t,idx_novelty,fast_foward_db_QMARK_){
var self__ = this;
var this$__$1 = this;
return fluree.db.storage.core.resolve_to_t.call(null,this$__$1,self__.id,self__.tempid,self__.rhs,self__.leftmost_QMARK_,to_t,self__.tt_id,idx_novelty,self__.conn,fast_foward_db_QMARK_,cljs.core.PersistentHashSet.EMPTY);
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_to_t$arity$5 = (function (this$,to_t,idx_novelty,fast_foward_db_QMARK_,remove_preds){
var self__ = this;
var this$__$1 = this;
return fluree.db.storage.core.resolve_to_t.call(null,this$__$1,self__.id,self__.tempid,self__.rhs,self__.leftmost_QMARK_,to_t,self__.tt_id,idx_novelty,self__.conn,fast_foward_db_QMARK_,remove_preds);
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_history_range$arity$3 = (function (node,from_t,to_t){
var self__ = this;
var node__$1 = this;
return fluree.db.storage.core.resolve_history_range.call(null,node__$1,from_t,to_t,null,self__.leftmost_QMARK_);
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_history_range$arity$4 = (function (node,from_t,to_t,idx_novelty){
var self__ = this;
var node__$1 = this;
return fluree.db.storage.core.resolve_history_range.call(null,node__$1,from_t,to_t,idx_novelty,self__.leftmost_QMARK_);
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (14 + cljs.core.count.call(null,self__.__extmap));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (502391120 ^ cljs.core.hash_unordered_coll.call(null,coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
.call(null,this__4381__auto____$1);
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this93012,other93013){
var self__ = this;
var this93012__$1 = this;
return (((!((other93013 == null)))) && ((this93012__$1.constructor === other93013.constructor)) && (cljs.core._EQ_.call(null,this93012__$1.conn,other93013.conn)) && (cljs.core._EQ_.call(null,this93012__$1.config,other93013.config)) && (cljs.core._EQ_.call(null,this93012__$1.network,other93013.network)) && (cljs.core._EQ_.call(null,this93012__$1.dbid,other93013.dbid)) && (cljs.core._EQ_.call(null,this93012__$1.id,other93013.id)) && (cljs.core._EQ_.call(null,this93012__$1.leaf,other93013.leaf)) && (cljs.core._EQ_.call(null,this93012__$1.first,other93013.first)) && (cljs.core._EQ_.call(null,this93012__$1.rhs,other93013.rhs)) && (cljs.core._EQ_.call(null,this93012__$1.size,other93013.size)) && (cljs.core._EQ_.call(null,this93012__$1.block,other93013.block)) && (cljs.core._EQ_.call(null,this93012__$1.t,other93013.t)) && (cljs.core._EQ_.call(null,this93012__$1.tt_id,other93013.tt_id)) && (cljs.core._EQ_.call(null,this93012__$1.leftmost_QMARK_,other93013.leftmost_QMARK_)) && (cljs.core._EQ_.call(null,this93012__$1.tempid,other93013.tempid)) && (cljs.core._EQ_.call(null,this93012__$1.__extmap,other93013.__extmap)));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 14, [new cljs.core.Keyword(null,"block","block",664686210),null,new cljs.core.Keyword(null,"dbid","dbid",-196647356),null,new cljs.core.Keyword(null,"config","config",994861415),null,new cljs.core.Keyword(null,"leaf","leaf",1306118732),null,new cljs.core.Keyword(null,"size","size",1098693007),null,new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),null,new cljs.core.Keyword(null,"id","id",-1388402092),null,new cljs.core.Keyword(null,"tempid","tempid",1427663222),null,new cljs.core.Keyword(null,"t","t",-1397832519),null,new cljs.core.Keyword(null,"network","network",2050004697),null,new cljs.core.Keyword(null,"first","first",-644103046),null,new cljs.core.Keyword(null,"tt-id","tt-id",725587484),null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),null,new cljs.core.Keyword(null,"conn","conn",278309663),null], null), null),k__4395__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__93010){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__93020 = cljs.core.keyword_identical_QMARK_;
var expr__93021 = k__4393__auto__;
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"conn","conn",278309663),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(G__93010,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"config","config",994861415),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,G__93010,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"network","network",2050004697),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,G__93010,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"dbid","dbid",-196647356),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,G__93010,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"id","id",-1388402092),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,G__93010,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"leaf","leaf",1306118732),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,G__93010,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"first","first",-644103046),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,G__93010,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,G__93010,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"size","size",1098693007),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,G__93010,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"block","block",664686210),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,G__93010,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"t","t",-1397832519),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,G__93010,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"tt-id","tt-id",725587484),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,G__93010,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,G__93010,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__93020.call(null,new cljs.core.Keyword(null,"tempid","tempid",1427663222),expr__93021))){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,G__93010,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4393__auto__,G__93010),null));
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 14, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"conn","conn",278309663),self__.conn,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"config","config",994861415),self__.config,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"network","network",2050004697),self__.network,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"dbid","dbid",-196647356),self__.dbid,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"id","id",-1388402092),self__.id,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"leaf","leaf",1306118732),self__.leaf,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"first","first",-644103046),self__.first,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"size","size",1098693007),self__.size,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"block","block",664686210),self__.block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"t","t",-1397832519),self__.t,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"tt-id","tt-id",725587484),self__.tt_id,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),self__.leftmost_QMARK_,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"tempid","tempid",1427663222),self__.tempid,null))], null),self__.__extmap));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__93010){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,G__93010,self__.__extmap,self__.__hash));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4391__auto__,(0)),cljs.core._nth.call(null,entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.storage.core.UnresolvedNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 14, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"conn","conn",1918841190,null),new cljs.core.Symbol(null,"config","config",-1659574354,null),new cljs.core.Symbol(null,"network","network",-604431072,null),new cljs.core.Symbol(null,"dbid","dbid",1443884171,null),new cljs.core.Symbol(null,"id","id",252129435,null),new cljs.core.Symbol(null,"leaf","leaf",-1348317037,null),new cljs.core.Symbol(null,"first","first",996428481,null),new cljs.core.Symbol(null,"rhs","rhs",1411174788,null),new cljs.core.Symbol(null,"size","size",-1555742762,null),new cljs.core.Symbol(null,"block","block",-1989749559,null),new cljs.core.Symbol(null,"t","t",242699008,null),new cljs.core.Symbol(null,"tt-id","tt-id",-1928848285,null),new cljs.core.Symbol(null,"leftmost?","leftmost?",-31657032,null),new cljs.core.Symbol(null,"tempid","tempid",-1226772547,null)], null);
});

fluree.db.storage.core.UnresolvedNode.cljs$lang$type = true;

fluree.db.storage.core.UnresolvedNode.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.storage.core/UnresolvedNode",null,(1),null));
});

fluree.db.storage.core.UnresolvedNode.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write.call(null,writer__4429__auto__,"fluree.db.storage.core/UnresolvedNode");
});

/**
 * Positional factory function for fluree.db.storage.core/UnresolvedNode.
 */
fluree.db.storage.core.__GT_UnresolvedNode = (function fluree$db$storage$core$__GT_UnresolvedNode(conn,config,network,dbid,id,leaf,first,rhs,size,block,t,tt_id,leftmost_QMARK_,tempid){
return (new fluree.db.storage.core.UnresolvedNode(conn,config,network,dbid,id,leaf,first,rhs,size,block,t,tt_id,leftmost_QMARK_,tempid,null,null,null));
});

/**
 * Factory function for fluree.db.storage.core/UnresolvedNode, taking a map of keywords to field values.
 */
fluree.db.storage.core.map__GT_UnresolvedNode = (function fluree$db$storage$core$map__GT_UnresolvedNode(G__93014){
var extmap__4424__auto__ = (function (){var G__93023 = cljs.core.dissoc.call(null,G__93014,new cljs.core.Keyword(null,"conn","conn",278309663),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"network","network",2050004697),new cljs.core.Keyword(null,"dbid","dbid",-196647356),new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"leaf","leaf",1306118732),new cljs.core.Keyword(null,"first","first",-644103046),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"size","size",1098693007),new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"tt-id","tt-id",725587484),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),new cljs.core.Keyword(null,"tempid","tempid",1427663222));
if(cljs.core.record_QMARK_.call(null,G__93014)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__93023);
} else {
return G__93023;
}
})();
return (new fluree.db.storage.core.UnresolvedNode(new cljs.core.Keyword(null,"conn","conn",278309663).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"config","config",994861415).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"network","network",2050004697).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"dbid","dbid",-196647356).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"leaf","leaf",1306118732).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"first","first",-644103046).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"size","size",1098693007).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"tt-id","tt-id",725587484).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559).cljs$core$IFn$_invoke$arity$1(G__93014),new cljs.core.Keyword(null,"tempid","tempid",1427663222).cljs$core$IFn$_invoke$arity$1(G__93014),null,cljs.core.not_empty.call(null,extmap__4424__auto__),null));
});

/**
 * Turns each index root node into an unresolved node.
 */
fluree.db.storage.core.reify_index_root = (function fluree$db$storage$core$reify_index_root(conn,index_configs,network,dbid,index,index_data,block,t){
var cfg = (function (){var or__4131__auto__ = cljs.core.get.call(null,index_configs,index);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
throw cljs.core.ex_info.call(null,["Internal error reifying db root index: ",cljs.core.pr_str.call(null,index)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(500),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)], null));
}
})();
return fluree.db.storage.core.map__GT_UnresolvedNode.call(null,cljs.core.assoc.call(null,index_data,new cljs.core.Keyword(null,"conn","conn",278309663),conn,new cljs.core.Keyword(null,"config","config",994861415),cfg,new cljs.core.Keyword(null,"network","network",2050004697),network,new cljs.core.Keyword(null,"dbid","dbid",-196647356),dbid,new cljs.core.Keyword(null,"block","block",664686210),block,new cljs.core.Keyword(null,"t","t",-1397832519),t,new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),true));
});
/**
 * Constructs db from blank-db, and ensure index roots have proper config as unresolved nodes.
 */
fluree.db.storage.core.reify_db_root = (function fluree$db$storage$core$reify_db_root(conn,blank_db,root_data){
var map__93025 = blank_db;
var map__93025__$1 = (((((!((map__93025 == null))))?(((((map__93025.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__93025.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__93025):map__93025);
var network = cljs.core.get.call(null,map__93025__$1,new cljs.core.Keyword(null,"network","network",2050004697));
var dbid = cljs.core.get.call(null,map__93025__$1,new cljs.core.Keyword(null,"dbid","dbid",-196647356));
var index_configs = cljs.core.get.call(null,map__93025__$1,new cljs.core.Keyword(null,"index-configs","index-configs",1053959280));
var map__93026 = root_data;
var map__93026__$1 = (((((!((map__93026 == null))))?(((((map__93026.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__93026.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__93026):map__93026);
var block = cljs.core.get.call(null,map__93026__$1,new cljs.core.Keyword(null,"block","block",664686210));
var t = cljs.core.get.call(null,map__93026__$1,new cljs.core.Keyword(null,"t","t",-1397832519));
var ecount = cljs.core.get.call(null,map__93026__$1,new cljs.core.Keyword(null,"ecount","ecount",-879380887));
var stats = cljs.core.get.call(null,map__93026__$1,new cljs.core.Keyword(null,"stats","stats",-85643011));
var db_STAR_ = cljs.core.assoc.call(null,blank_db,new cljs.core.Keyword(null,"block","block",664686210),block,new cljs.core.Keyword(null,"t","t",-1397832519),t,new cljs.core.Keyword(null,"ecount","ecount",-879380887),ecount,new cljs.core.Keyword(null,"stats","stats",-85643011),cljs.core.assoc.call(null,stats,new cljs.core.Keyword(null,"indexed","indexed",390758624),block));
return cljs.core.reduce.call(null,((function (map__93025,map__93025__$1,network,dbid,index_configs,map__93026,map__93026__$1,block,t,ecount,stats,db_STAR_){
return (function (db,idx){
return cljs.core.assoc.call(null,db,idx,fluree.db.storage.core.reify_index_root.call(null,conn,index_configs,network,dbid,idx,cljs.core.get.call(null,root_data,idx),block,t));
});})(map__93025,map__93025__$1,network,dbid,index_configs,map__93026,map__93026__$1,block,t,ecount,stats,db_STAR_))
,db_STAR_,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"spot","spot",-1706962147),new cljs.core.Keyword(null,"psot","psot",2111653059),new cljs.core.Keyword(null,"post","post",269697687),new cljs.core.Keyword(null,"opst","opst",1213963058)], null));
});
/**
 * Returns a all data for a db index root of a given block.
 */
fluree.db.storage.core.read_garbage = (function fluree$db$storage$core$read_garbage(conn,network,dbid,block){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_93047){
var state_val_93048 = (state_93047[(1)]);
if((state_val_93048 === (1))){
var state_93047__$1 = state_93047;
var statearr_93049_93062 = state_93047__$1;
(statearr_93049_93062[(2)] = null);

(statearr_93049_93062[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93048 === (2))){
var inst_93045 = (state_93047[(2)]);
var state_93047__$1 = state_93047;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_93047__$1,inst_93045);
} else {
if((state_val_93048 === (3))){
var inst_93029 = (state_93047[(2)]);
var state_93047__$1 = state_93047;
var statearr_93050_93063 = state_93047__$1;
(statearr_93050_93063[(2)] = inst_93029);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93047__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93048 === (4))){
var inst_93034 = (state_93047[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_93047,(3),Error,null,(2));
var inst_93033 = fluree.db.storage.core.ledger_garbage_key.call(null,network,dbid,block);
var inst_93034__$1 = fluree.db.storage.core.storage_read.call(null,conn,inst_93033);
var state_93047__$1 = (function (){var statearr_93051 = state_93047;
(statearr_93051[(7)] = inst_93034__$1);

return statearr_93051;
})();
if(cljs.core.truth_(inst_93034__$1)){
var statearr_93052_93064 = state_93047__$1;
(statearr_93052_93064[(1)] = (5));

} else {
var statearr_93053_93065 = state_93047__$1;
(statearr_93053_93065[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93048 === (5))){
var inst_93034 = (state_93047[(7)]);
var inst_93036 = fluree.db.storage.core.serde.call(null,conn);
var state_93047__$1 = (function (){var statearr_93054 = state_93047;
(statearr_93054[(8)] = inst_93036);

return statearr_93054;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_93047__$1,(8),inst_93034);
} else {
if((state_val_93048 === (6))){
var state_93047__$1 = state_93047;
var statearr_93055_93066 = state_93047__$1;
(statearr_93055_93066[(2)] = null);

(statearr_93055_93066[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93048 === (7))){
var inst_93043 = (state_93047[(2)]);
var state_93047__$1 = state_93047;
var statearr_93056_93067 = state_93047__$1;
(statearr_93056_93067[(2)] = inst_93043);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93047__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93048 === (8))){
var inst_93036 = (state_93047[(8)]);
var inst_93038 = (state_93047[(2)]);
var inst_93039 = fluree.db.util.async.throw_err.call(null,inst_93038);
var inst_93040 = fluree.db.serde.protocol._deserialize_garbage.call(null,inst_93036,inst_93039);
var state_93047__$1 = state_93047;
var statearr_93057_93068 = state_93047__$1;
(statearr_93057_93068[(2)] = inst_93040);

(statearr_93057_93068[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$read_garbage_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$read_garbage_$_state_machine__86625__auto____0 = (function (){
var statearr_93058 = [null,null,null,null,null,null,null,null,null];
(statearr_93058[(0)] = fluree$db$storage$core$read_garbage_$_state_machine__86625__auto__);

(statearr_93058[(1)] = (1));

return statearr_93058;
});
var fluree$db$storage$core$read_garbage_$_state_machine__86625__auto____1 = (function (state_93047){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_93047);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e93059){if((e93059 instanceof Object)){
var ex__86628__auto__ = e93059;
var statearr_93060_93069 = state_93047;
(statearr_93060_93069[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93047);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e93059;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__93070 = state_93047;
state_93047 = G__93070;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$read_garbage_$_state_machine__86625__auto__ = function(state_93047){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_garbage_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_garbage_$_state_machine__86625__auto____1.call(this,state_93047);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_garbage_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_garbage_$_state_machine__86625__auto____0;
fluree$db$storage$core$read_garbage_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_garbage_$_state_machine__86625__auto____1;
return fluree$db$storage$core$read_garbage_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_93061 = f__86676__auto__.call(null);
(statearr_93061[(6)] = c__86675__auto__);

return statearr_93061;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Returns a all data for a db index root of a given block.
 */
fluree.db.storage.core.read_db_root = (function fluree$db$storage$core$read_db_root(conn,network,dbid,block){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_93089){
var state_val_93090 = (state_93089[(1)]);
if((state_val_93090 === (1))){
var state_93089__$1 = state_93089;
var statearr_93091_93104 = state_93089__$1;
(statearr_93091_93104[(2)] = null);

(statearr_93091_93104[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93090 === (2))){
var inst_93087 = (state_93089[(2)]);
var state_93089__$1 = state_93089;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_93089__$1,inst_93087);
} else {
if((state_val_93090 === (3))){
var inst_93071 = (state_93089[(2)]);
var state_93089__$1 = state_93089;
var statearr_93092_93105 = state_93089__$1;
(statearr_93092_93105[(2)] = inst_93071);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93089__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93090 === (4))){
var inst_93076 = (state_93089[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_93089,(3),Error,null,(2));
var inst_93075 = fluree.db.storage.core.ledger_root_key.call(null,network,dbid,block);
var inst_93076__$1 = fluree.db.storage.core.storage_read.call(null,conn,inst_93075);
var state_93089__$1 = (function (){var statearr_93093 = state_93089;
(statearr_93093[(7)] = inst_93076__$1);

return statearr_93093;
})();
if(cljs.core.truth_(inst_93076__$1)){
var statearr_93094_93106 = state_93089__$1;
(statearr_93094_93106[(1)] = (5));

} else {
var statearr_93095_93107 = state_93089__$1;
(statearr_93095_93107[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93090 === (5))){
var inst_93076 = (state_93089[(7)]);
var inst_93078 = fluree.db.storage.core.serde.call(null,conn);
var state_93089__$1 = (function (){var statearr_93096 = state_93089;
(statearr_93096[(8)] = inst_93078);

return statearr_93096;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_93089__$1,(8),inst_93076);
} else {
if((state_val_93090 === (6))){
var state_93089__$1 = state_93089;
var statearr_93097_93108 = state_93089__$1;
(statearr_93097_93108[(2)] = null);

(statearr_93097_93108[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93090 === (7))){
var inst_93085 = (state_93089[(2)]);
var state_93089__$1 = state_93089;
var statearr_93098_93109 = state_93089__$1;
(statearr_93098_93109[(2)] = inst_93085);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93089__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93090 === (8))){
var inst_93078 = (state_93089[(8)]);
var inst_93080 = (state_93089[(2)]);
var inst_93081 = fluree.db.util.async.throw_err.call(null,inst_93080);
var inst_93082 = fluree.db.serde.protocol._deserialize_db_root.call(null,inst_93078,inst_93081);
var state_93089__$1 = state_93089;
var statearr_93099_93110 = state_93089__$1;
(statearr_93099_93110[(2)] = inst_93082);

(statearr_93099_93110[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$read_db_root_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$read_db_root_$_state_machine__86625__auto____0 = (function (){
var statearr_93100 = [null,null,null,null,null,null,null,null,null];
(statearr_93100[(0)] = fluree$db$storage$core$read_db_root_$_state_machine__86625__auto__);

(statearr_93100[(1)] = (1));

return statearr_93100;
});
var fluree$db$storage$core$read_db_root_$_state_machine__86625__auto____1 = (function (state_93089){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_93089);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e93101){if((e93101 instanceof Object)){
var ex__86628__auto__ = e93101;
var statearr_93102_93111 = state_93089;
(statearr_93102_93111[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93089);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e93101;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__93112 = state_93089;
state_93089 = G__93112;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$read_db_root_$_state_machine__86625__auto__ = function(state_93089){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_db_root_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_db_root_$_state_machine__86625__auto____1.call(this,state_93089);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_db_root_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_db_root_$_state_machine__86625__auto____0;
fluree$db$storage$core$read_db_root_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_db_root_$_state_machine__86625__auto____1;
return fluree$db$storage$core$read_db_root_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_93103 = f__86676__auto__.call(null);
(statearr_93103[(6)] = c__86675__auto__);

return statearr_93103;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Reifies db at specified index point. If unable to read db-root at index, throws.
 */
fluree.db.storage.core.reify_db = (function fluree$db$storage$core$reify_db(conn,network,dbid,blank_db,index){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_93145){
var state_val_93146 = (state_93145[(1)]);
if((state_val_93146 === (7))){
var inst_93117 = (state_93145[(7)]);
var inst_93127 = (state_93145[(2)]);
var state_93145__$1 = (function (){var statearr_93147 = state_93145;
(statearr_93147[(8)] = inst_93127);

return statearr_93147;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_93145__$1,(8),inst_93117);
} else {
if((state_val_93146 === (1))){
var state_93145__$1 = state_93145;
var statearr_93148_93162 = state_93145__$1;
(statearr_93148_93162[(2)] = null);

(statearr_93148_93162[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93146 === (4))){
var inst_93117 = (state_93145[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_93145,(3),Error,null,(2));
var inst_93117__$1 = fluree.db.storage.core.read_db_root.call(null,conn,network,dbid,index);
var state_93145__$1 = (function (){var statearr_93149 = state_93145;
(statearr_93149[(7)] = inst_93117__$1);

return statearr_93149;
})();
if(cljs.core.truth_(inst_93117__$1)){
var statearr_93150_93163 = state_93145__$1;
(statearr_93150_93163[(1)] = (5));

} else {
var statearr_93151_93164 = state_93145__$1;
(statearr_93151_93164[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93146 === (6))){
var inst_93120 = ["Database ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(dbid)," could not be loaded at index point: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(index),"."].join('');
var inst_93121 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_93122 = [(400),new cljs.core.Keyword("db","unavailable","db/unavailable",1529908237)];
var inst_93123 = cljs.core.PersistentHashMap.fromArrays(inst_93121,inst_93122);
var inst_93124 = cljs.core.ex_info.call(null,inst_93120,inst_93123);
var inst_93125 = (function(){throw inst_93124})();
var state_93145__$1 = state_93145;
var statearr_93152_93165 = state_93145__$1;
(statearr_93152_93165[(2)] = inst_93125);

(statearr_93152_93165[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93146 === (3))){
var inst_93113 = (state_93145[(2)]);
var state_93145__$1 = state_93145;
var statearr_93153_93166 = state_93145__$1;
(statearr_93153_93166[(2)] = inst_93113);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93145__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93146 === (2))){
var inst_93143 = (state_93145[(2)]);
var state_93145__$1 = state_93145;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_93145__$1,inst_93143);
} else {
if((state_val_93146 === (9))){
var inst_93131 = (state_93145[(9)]);
var inst_93136 = (state_93145[(10)]);
var inst_93134 = (state_93145[(2)]);
var inst_93135 = fluree.db.util.async.throw_err.call(null,inst_93134);
var inst_93136__$1 = cljs.core.assoc.call(null,inst_93131,new cljs.core.Keyword(null,"schema","schema",-1582001791),inst_93135);
var inst_93137 = fluree.db.query.schema.setting_map.call(null,inst_93136__$1);
var state_93145__$1 = (function (){var statearr_93154 = state_93145;
(statearr_93154[(10)] = inst_93136__$1);

return statearr_93154;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_93145__$1,(10),inst_93137);
} else {
if((state_val_93146 === (5))){
var state_93145__$1 = state_93145;
var statearr_93155_93167 = state_93145__$1;
(statearr_93155_93167[(2)] = null);

(statearr_93155_93167[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93146 === (10))){
var inst_93136 = (state_93145[(10)]);
var inst_93139 = (state_93145[(2)]);
var inst_93140 = fluree.db.util.async.throw_err.call(null,inst_93139);
var inst_93141 = cljs.core.assoc.call(null,inst_93136,new cljs.core.Keyword(null,"settings","settings",1556144875),inst_93140);
var state_93145__$1 = state_93145;
var statearr_93156_93168 = state_93145__$1;
(statearr_93156_93168[(2)] = inst_93141);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93145__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93146 === (8))){
var inst_93131 = (state_93145[(9)]);
var inst_93129 = (state_93145[(2)]);
var inst_93130 = fluree.db.util.async.throw_err.call(null,inst_93129);
var inst_93131__$1 = fluree.db.storage.core.reify_db_root.call(null,conn,blank_db,inst_93130);
var inst_93132 = fluree.db.query.schema.schema_map.call(null,inst_93131__$1);
var state_93145__$1 = (function (){var statearr_93157 = state_93145;
(statearr_93157[(9)] = inst_93131__$1);

return statearr_93157;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_93145__$1,(9),inst_93132);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$reify_db_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$reify_db_$_state_machine__86625__auto____0 = (function (){
var statearr_93158 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_93158[(0)] = fluree$db$storage$core$reify_db_$_state_machine__86625__auto__);

(statearr_93158[(1)] = (1));

return statearr_93158;
});
var fluree$db$storage$core$reify_db_$_state_machine__86625__auto____1 = (function (state_93145){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_93145);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e93159){if((e93159 instanceof Object)){
var ex__86628__auto__ = e93159;
var statearr_93160_93169 = state_93145;
(statearr_93160_93169[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93145);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e93159;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__93170 = state_93145;
state_93145 = G__93170;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$reify_db_$_state_machine__86625__auto__ = function(state_93145){
switch(arguments.length){
case 0:
return fluree$db$storage$core$reify_db_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$reify_db_$_state_machine__86625__auto____1.call(this,state_93145);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$reify_db_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$reify_db_$_state_machine__86625__auto____0;
fluree$db$storage$core$reify_db_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$reify_db_$_state_machine__86625__auto____1;
return fluree$db$storage$core$reify_db_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_93161 = f__86676__auto__.call(null);
(statearr_93161[(6)] = c__86675__auto__);

return statearr_93161;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Returns a channel that will contains blocks in specified range.
 */
fluree.db.storage.core.block_range = (function fluree$db$storage$core$block_range(var_args){
var G__93172 = arguments.length;
switch (G__93172) {
case 4:
return fluree.db.storage.core.block_range.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return fluree.db.storage.core.block_range.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.storage.core.block_range.cljs$core$IFn$_invoke$arity$4 = (function (conn,network,dbid,start){
return fluree.db.storage.core.block_range.call(null,conn,network,dbid,start,null);
});

fluree.db.storage.core.block_range.cljs$core$IFn$_invoke$arity$5 = (function (conn,network,dbid,start,end){
fluree.db.util.log.trace.call(null,"Block-range request: ",network,dbid,start,end);

var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_93218){
var state_val_93219 = (state_93218[(1)]);
if((state_val_93219 === (7))){
var inst_93184 = (state_93218[(2)]);
var inst_93185 = new cljs.core.Keyword(null,"parallelism","parallelism",-930922333).cljs$core$IFn$_invoke$arity$1(conn);
var inst_93186 = cljs.core.PersistentVector.EMPTY;
var inst_93187 = start;
var inst_93188 = inst_93186;
var state_93218__$1 = (function (){var statearr_93220 = state_93218;
(statearr_93220[(7)] = inst_93185);

(statearr_93220[(8)] = inst_93187);

(statearr_93220[(9)] = inst_93184);

(statearr_93220[(10)] = inst_93188);

return statearr_93220;
})();
var statearr_93221_93249 = state_93218__$1;
(statearr_93221_93249[(2)] = null);

(statearr_93221_93249[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (1))){
var state_93218__$1 = state_93218;
var statearr_93222_93250 = state_93218__$1;
(statearr_93222_93250[(2)] = null);

(statearr_93222_93250[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_93218,(3),Error,null,(2));
var inst_93177 = (end >= start);
var state_93218__$1 = state_93218;
if(cljs.core.truth_(inst_93177)){
var statearr_93223_93251 = state_93218__$1;
(statearr_93223_93251[(1)] = (5));

} else {
var statearr_93224_93252 = state_93218__$1;
(statearr_93224_93252[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (15))){
var state_93218__$1 = state_93218;
var statearr_93225_93253 = state_93218__$1;
(statearr_93225_93253[(1)] = (17));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (13))){
var inst_93212 = (state_93218[(2)]);
var state_93218__$1 = state_93218;
var statearr_93227_93254 = state_93218__$1;
(statearr_93227_93254[(2)] = inst_93212);

(statearr_93227_93254[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (6))){
var inst_93180 = ["Assert failed: ","Block range should be in ascending order, from earliest (smallest) block to most recent (largest) block.","\n","(>= end start)"].join('');
var inst_93181 = (new Error(inst_93180));
var inst_93182 = (function(){throw inst_93181})();
var state_93218__$1 = state_93218;
var statearr_93228_93255 = state_93218__$1;
(statearr_93228_93255[(2)] = inst_93182);

(statearr_93228_93255[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (17))){
var inst_93192 = (state_93218[(11)]);
var inst_93187 = (state_93218[(8)]);
var inst_93188 = (state_93218[(10)]);
var inst_93203 = (inst_93187 + (1));
var inst_93204 = cljs.core.conj.call(null,inst_93188,inst_93192);
var inst_93187__$1 = inst_93203;
var inst_93188__$1 = inst_93204;
var state_93218__$1 = (function (){var statearr_93229 = state_93218;
(statearr_93229[(8)] = inst_93187__$1);

(statearr_93229[(10)] = inst_93188__$1);

return statearr_93229;
})();
var statearr_93230_93256 = state_93218__$1;
(statearr_93230_93256[(2)] = null);

(statearr_93230_93256[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (3))){
var inst_93173 = (state_93218[(2)]);
var state_93218__$1 = state_93218;
var statearr_93231_93257 = state_93218__$1;
(statearr_93231_93257[(2)] = inst_93173);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93218__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (12))){
var inst_93187 = (state_93218[(8)]);
var inst_93198 = cljs.core._EQ_.call(null,inst_93187,end);
var state_93218__$1 = state_93218;
if(inst_93198){
var statearr_93232_93258 = state_93218__$1;
(statearr_93232_93258[(1)] = (14));

} else {
var statearr_93233_93259 = state_93218__$1;
(statearr_93233_93259[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (2))){
var inst_93216 = (state_93218[(2)]);
var state_93218__$1 = state_93218;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_93218__$1,inst_93216);
} else {
if((state_val_93219 === (19))){
var inst_93208 = (state_93218[(2)]);
var state_93218__$1 = state_93218;
var statearr_93234_93260 = state_93218__$1;
(statearr_93234_93260[(2)] = inst_93208);

(statearr_93234_93260[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (11))){
var inst_93188 = (state_93218[(10)]);
var state_93218__$1 = state_93218;
var statearr_93235_93261 = state_93218__$1;
(statearr_93235_93261[(2)] = inst_93188);

(statearr_93235_93261[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (9))){
var inst_93214 = (state_93218[(2)]);
var state_93218__$1 = state_93218;
var statearr_93236_93262 = state_93218__$1;
(statearr_93236_93262[(2)] = inst_93214);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93218__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (5))){
var state_93218__$1 = state_93218;
var statearr_93237_93263 = state_93218__$1;
(statearr_93237_93263[(2)] = null);

(statearr_93237_93263[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (14))){
var inst_93192 = (state_93218[(11)]);
var inst_93188 = (state_93218[(10)]);
var inst_93200 = cljs.core.conj.call(null,inst_93188,inst_93192);
var state_93218__$1 = state_93218;
var statearr_93238_93264 = state_93218__$1;
(statearr_93238_93264[(2)] = inst_93200);

(statearr_93238_93264[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (16))){
var inst_93210 = (state_93218[(2)]);
var state_93218__$1 = state_93218;
var statearr_93239_93265 = state_93218__$1;
(statearr_93239_93265[(2)] = inst_93210);

(statearr_93239_93265[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (10))){
var inst_93192 = (state_93218[(11)]);
var inst_93192__$1 = (state_93218[(2)]);
var inst_93193 = (inst_93192__$1 == null);
var inst_93194 = (inst_93192__$1 instanceof Error);
var inst_93195 = ((inst_93193) || (inst_93194));
var state_93218__$1 = (function (){var statearr_93240 = state_93218;
(statearr_93240[(11)] = inst_93192__$1);

return statearr_93240;
})();
if(cljs.core.truth_(inst_93195)){
var statearr_93241_93266 = state_93218__$1;
(statearr_93241_93266[(1)] = (11));

} else {
var statearr_93242_93267 = state_93218__$1;
(statearr_93242_93267[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (18))){
var state_93218__$1 = state_93218;
var statearr_93243_93268 = state_93218__$1;
(statearr_93243_93268[(2)] = null);

(statearr_93243_93268[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93219 === (8))){
var inst_93187 = (state_93218[(8)]);
var inst_93190 = fluree.db.storage.core.read_block.call(null,conn,network,dbid,inst_93187);
var state_93218__$1 = state_93218;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_93218__$1,(10),inst_93190);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$state_machine__86625__auto__ = null;
var fluree$db$storage$core$state_machine__86625__auto____0 = (function (){
var statearr_93244 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_93244[(0)] = fluree$db$storage$core$state_machine__86625__auto__);

(statearr_93244[(1)] = (1));

return statearr_93244;
});
var fluree$db$storage$core$state_machine__86625__auto____1 = (function (state_93218){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_93218);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e93245){if((e93245 instanceof Object)){
var ex__86628__auto__ = e93245;
var statearr_93246_93269 = state_93218;
(statearr_93246_93269[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93218);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e93245;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__93270 = state_93218;
state_93218 = G__93270;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$state_machine__86625__auto__ = function(state_93218){
switch(arguments.length){
case 0:
return fluree$db$storage$core$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$state_machine__86625__auto____1.call(this,state_93218);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$state_machine__86625__auto____0;
fluree$db$storage$core$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$state_machine__86625__auto____1;
return fluree$db$storage$core$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_93247 = f__86676__auto__.call(null);
(statearr_93247[(6)] = c__86675__auto__);

return statearr_93247;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.storage.core.block_range.cljs$lang$maxFixedArity = 5;

/**
 * Reads a single block from storage
 */
fluree.db.storage.core.block = (function fluree$db$storage$core$block(conn,network,dbid,block){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_93283){
var state_val_93284 = (state_93283[(1)]);
if((state_val_93284 === (1))){
var state_93283__$1 = state_93283;
var statearr_93285_93292 = state_93283__$1;
(statearr_93285_93292[(2)] = null);

(statearr_93285_93292[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93284 === (2))){
var inst_93281 = (state_93283[(2)]);
var state_93283__$1 = state_93283;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_93283__$1,inst_93281);
} else {
if((state_val_93284 === (3))){
var inst_93271 = (state_93283[(2)]);
var state_93283__$1 = state_93283;
var statearr_93286_93293 = state_93283__$1;
(statearr_93286_93293[(2)] = inst_93271);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93283__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_93284 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_93283,(3),Error,null,(2));
var inst_93275 = fluree.db.storage.core.block_range.call(null,conn,network,dbid,block,block);
var state_93283__$1 = state_93283;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_93283__$1,(5),inst_93275);
} else {
if((state_val_93284 === (5))){
var inst_93277 = (state_93283[(2)]);
var inst_93278 = fluree.db.util.async.throw_err.call(null,inst_93277);
var inst_93279 = cljs.core.first.call(null,inst_93278);
var state_93283__$1 = state_93283;
var statearr_93287_93294 = state_93283__$1;
(statearr_93287_93294[(2)] = inst_93279);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93283__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$storage$core$block_$_state_machine__86625__auto__ = null;
var fluree$db$storage$core$block_$_state_machine__86625__auto____0 = (function (){
var statearr_93288 = [null,null,null,null,null,null,null];
(statearr_93288[(0)] = fluree$db$storage$core$block_$_state_machine__86625__auto__);

(statearr_93288[(1)] = (1));

return statearr_93288;
});
var fluree$db$storage$core$block_$_state_machine__86625__auto____1 = (function (state_93283){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_93283);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e93289){if((e93289 instanceof Object)){
var ex__86628__auto__ = e93289;
var statearr_93290_93295 = state_93283;
(statearr_93290_93295[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_93283);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e93289;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__93296 = state_93283;
state_93283 = G__93296;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$storage$core$block_$_state_machine__86625__auto__ = function(state_93283){
switch(arguments.length){
case 0:
return fluree$db$storage$core$block_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$storage$core$block_$_state_machine__86625__auto____1.call(this,state_93283);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$block_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$block_$_state_machine__86625__auto____0;
fluree$db$storage$core$block_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$block_$_state_machine__86625__auto____1;
return fluree$db$storage$core$block_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_93291 = f__86676__auto__.call(null);
(statearr_93291[(6)] = c__86675__auto__);

return statearr_93291;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
