// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.graphdb');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.storage.core');
goog.require('fluree.db.util.core');
goog.require('fluree.db.query.schema');
goog.require('fluree.db.util.schema');
goog.require('clojure.data.avl');
goog.require('fluree.db.query.fql');
goog.require('fluree.db.index');
goog.require('fluree.db.query.range');
goog.require('fluree.db.constants');
goog.require('fluree.db.flake');
goog.require('fluree.db.util.async');
goog.require('cljs.core.async');
goog.require('fluree.db.util.log');
goog.require('clojure.string');
/**
 * Returns when ledger name is valid.
 *   Otherwise throws.
 */
fluree.db.graphdb.validate_ledger_name = (function fluree$db$graphdb$validate_ledger_name(ledger_id,type){
if(cljs.core.truth_(cljs.core.re_matches(/^[a-z0-9-]{1,100}/,ledger_id))){
return null;
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(type)," id: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),". Must match a-z0-9- and be no more than 100 characters long."].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_db], null));
}
});
/**
 * Returns two-tuple of [network name-or-dbid] if db-ident is valid.
 * 
 *   Will ignore a direct db name reference (prefixed with '_')
 *   Otherwise throws.
 */
fluree.db.graphdb.validate_ledger_ident = (function fluree$db$graphdb$validate_ledger_ident(ledger){
var vec__114930 = cljs.core.re_find(/^([^\/]+)\/(?:_)?([^\/]+)$/,fluree.db.util.core.keyword__GT_str(ledger));
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__114930,(0),null);
var network = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__114930,(1),null);
var maybe_alias = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__114930,(2),null);
if(cljs.core.truth_((function (){var and__4120__auto__ = network;
if(cljs.core.truth_(and__4120__auto__)){
return maybe_alias;
} else {
return and__4120__auto__;
}
})())){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,maybe_alias], null);
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid ledger identity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_ledger_DASH_name], null));
}
});
fluree.db.graphdb.exclude_predicates = cljs.core.PersistentHashSet.createAsIfByAssoc([(107),(108),(106)]);
fluree.db.graphdb.add_predicate_to_idx = (function fluree$db$graphdb$add_predicate_to_idx(db,pred_id){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_115024){
var state_val_115025 = (state_115024[(1)]);
if((state_val_115025 === (7))){
var state_115024__$1 = state_115024;
var statearr_115026_115065 = state_115024__$1;
(statearr_115026_115065[(2)] = false);

(statearr_115026_115065[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (20))){
var inst_114988 = (state_115024[(2)]);
var state_115024__$1 = state_115024;
var statearr_115027_115066 = state_115024__$1;
(statearr_115027_115066[(2)] = inst_114988);

(statearr_115027_115066[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (1))){
var state_115024__$1 = state_115024;
var statearr_115028_115067 = state_115024__$1;
(statearr_115028_115067[(2)] = null);

(statearr_115028_115067[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (24))){
var inst_115001 = ["You cannot add ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(pred_id)," to the index at this point. There are too many affected flakes."].join('');
var inst_115002 = [cljs.core.cst$kw$error,cljs.core.cst$kw$status];
var inst_115003 = [cljs.core.cst$kw$db_SLASH_max_DASH_novelty_DASH_size,(400)];
var inst_115004 = cljs.core.PersistentHashMap.fromArrays(inst_115002,inst_115003);
var inst_115005 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_115001,inst_115004);
var inst_115006 = (function(){throw inst_115005})();
var state_115024__$1 = state_115024;
var statearr_115029_115068 = state_115024__$1;
(statearr_115029_115068[(2)] = inst_115006);

(statearr_115029_115068[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_115024,(3),Error,null,(2));
var inst_114939 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_114940 = [pred_id];
var inst_114941 = (new cljs.core.PersistentVector(null,1,(5),inst_114939,inst_114940,null));
var inst_114942 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(db,cljs.core.cst$kw$psot,cljs.core._EQ_,inst_114941);
var state_115024__$1 = state_115024;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_115024__$1,(5),inst_114942);
} else {
if((state_val_115025 === (15))){
var inst_114975 = (state_115024[(7)]);
var inst_114980 = inst_114975.cljs$lang$protocol_mask$partition0$;
var inst_114981 = (inst_114980 & (64));
var inst_114982 = inst_114975.cljs$core$ISeq$;
var inst_114983 = (cljs.core.PROTOCOL_SENTINEL === inst_114982);
var inst_114984 = ((inst_114981) || (inst_114983));
var state_115024__$1 = state_115024;
if(cljs.core.truth_(inst_114984)){
var statearr_115030_115069 = state_115024__$1;
(statearr_115030_115069[(1)] = (18));

} else {
var statearr_115031_115070 = state_115024__$1;
(statearr_115031_115070[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (21))){
var inst_114975 = (state_115024[(7)]);
var inst_114993 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_114975);
var state_115024__$1 = state_115024;
var statearr_115032_115071 = state_115024__$1;
(statearr_115032_115071[(2)] = inst_114993);

(statearr_115032_115071[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (13))){
var inst_114946 = (state_115024[(8)]);
var state_115024__$1 = state_115024;
var statearr_115033_115072 = state_115024__$1;
(statearr_115033_115072[(2)] = inst_114946);

(statearr_115033_115072[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (22))){
var inst_114975 = (state_115024[(7)]);
var state_115024__$1 = state_115024;
var statearr_115034_115073 = state_115024__$1;
(statearr_115034_115073[(2)] = inst_114975);

(statearr_115034_115073[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (6))){
var inst_114946 = (state_115024[(8)]);
var inst_114951 = inst_114946.cljs$lang$protocol_mask$partition0$;
var inst_114952 = (inst_114951 & (64));
var inst_114953 = inst_114946.cljs$core$ISeq$;
var inst_114954 = (cljs.core.PROTOCOL_SENTINEL === inst_114953);
var inst_114955 = ((inst_114952) || (inst_114954));
var state_115024__$1 = state_115024;
if(cljs.core.truth_(inst_114955)){
var statearr_115035_115074 = state_115024__$1;
(statearr_115035_115074[(1)] = (9));

} else {
var statearr_115036_115075 = state_115024__$1;
(statearr_115036_115075[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (25))){
var state_115024__$1 = state_115024;
var statearr_115037_115076 = state_115024__$1;
(statearr_115037_115076[(2)] = null);

(statearr_115037_115076[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (17))){
var inst_114991 = (state_115024[(2)]);
var state_115024__$1 = state_115024;
if(cljs.core.truth_(inst_114991)){
var statearr_115038_115077 = state_115024__$1;
(statearr_115038_115077[(1)] = (21));

} else {
var statearr_115039_115078 = state_115024__$1;
(statearr_115039_115078[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (3))){
var inst_114933 = (state_115024[(2)]);
var state_115024__$1 = state_115024;
var statearr_115040_115079 = state_115024__$1;
(statearr_115040_115079[(2)] = inst_114933);


cljs.core.async.impl.ioc_helpers.process_exception(state_115024__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (12))){
var inst_114946 = (state_115024[(8)]);
var inst_114964 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_114946);
var state_115024__$1 = state_115024;
var statearr_115041_115080 = state_115024__$1;
(statearr_115041_115080[(2)] = inst_114964);

(statearr_115041_115080[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (2))){
var inst_115022 = (state_115024[(2)]);
var state_115024__$1 = state_115024;
return cljs.core.async.impl.ioc_helpers.return_chan(state_115024__$1,inst_115022);
} else {
if((state_val_115025 === (23))){
var inst_114971 = (state_115024[(9)]);
var inst_114996 = (state_115024[(2)]);
var inst_114997 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_114996,cljs.core.cst$kw$novelty_DASH_min);
var inst_114998 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_114996,cljs.core.cst$kw$novelty_DASH_max);
var inst_114999 = (inst_114971 > inst_114998);
var state_115024__$1 = (function (){var statearr_115042 = state_115024;
(statearr_115042[(10)] = inst_114997);

return statearr_115042;
})();
if(cljs.core.truth_(inst_114999)){
var statearr_115043_115081 = state_115024__$1;
(statearr_115043_115081[(1)] = (24));

} else {
var statearr_115044_115082 = state_115024__$1;
(statearr_115044_115082[(1)] = (25));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (19))){
var state_115024__$1 = state_115024;
var statearr_115045_115083 = state_115024__$1;
(statearr_115045_115083[(2)] = false);

(statearr_115045_115083[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (11))){
var inst_114959 = (state_115024[(2)]);
var state_115024__$1 = state_115024;
var statearr_115046_115084 = state_115024__$1;
(statearr_115046_115084[(2)] = inst_114959);

(statearr_115046_115084[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (9))){
var state_115024__$1 = state_115024;
var statearr_115047_115085 = state_115024__$1;
(statearr_115047_115085[(2)] = true);

(statearr_115047_115085[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (5))){
var inst_114946 = (state_115024[(8)]);
var inst_114944 = (state_115024[(2)]);
var inst_114945 = fluree.db.util.async.throw_err(inst_114944);
var inst_114946__$1 = cljs.core.cst$kw$novelty.cljs$core$IFn$_invoke$arity$1(db);
var inst_114948 = (inst_114946__$1 == null);
var inst_114949 = cljs.core.not(inst_114948);
var state_115024__$1 = (function (){var statearr_115048 = state_115024;
(statearr_115048[(11)] = inst_114945);

(statearr_115048[(8)] = inst_114946__$1);

return statearr_115048;
})();
if(inst_114949){
var statearr_115049_115086 = state_115024__$1;
(statearr_115049_115086[(1)] = (6));

} else {
var statearr_115050_115087 = state_115024__$1;
(statearr_115050_115087[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (14))){
var inst_114945 = (state_115024[(11)]);
var inst_114975 = (state_115024[(7)]);
var inst_114967 = (state_115024[(2)]);
var inst_114968 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_114967,cljs.core.cst$kw$post);
var inst_114969 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_114967,cljs.core.cst$kw$size);
var inst_114970 = fluree.db.flake.size_bytes(inst_114945);
var inst_114971 = (inst_114969 + inst_114970);
var inst_114972 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_114973 = [cljs.core.cst$kw$conn,cljs.core.cst$kw$meta];
var inst_114974 = (new cljs.core.PersistentVector(null,2,(5),inst_114972,inst_114973,null));
var inst_114975__$1 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(db,inst_114974);
var inst_114977 = (inst_114975__$1 == null);
var inst_114978 = cljs.core.not(inst_114977);
var state_115024__$1 = (function (){var statearr_115051 = state_115024;
(statearr_115051[(12)] = inst_114968);

(statearr_115051[(9)] = inst_114971);

(statearr_115051[(7)] = inst_114975__$1);

return statearr_115051;
})();
if(inst_114978){
var statearr_115052_115088 = state_115024__$1;
(statearr_115052_115088[(1)] = (15));

} else {
var statearr_115053_115089 = state_115024__$1;
(statearr_115053_115089[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (26))){
var inst_114968 = (state_115024[(12)]);
var inst_114971 = (state_115024[(9)]);
var inst_114945 = (state_115024[(11)]);
var inst_115009 = (state_115024[(2)]);
var inst_115010 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_114968,inst_114945);
var inst_115011 = cljs.core.cst$kw$schema_DASH_cache.cljs$core$IFn$_invoke$arity$1(db);
var inst_115012 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$2(inst_115011,cljs.core.empty);
var inst_115013 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115014 = [cljs.core.cst$kw$novelty,cljs.core.cst$kw$post];
var inst_115015 = (new cljs.core.PersistentVector(null,2,(5),inst_115013,inst_115014,null));
var inst_115016 = cljs.core.assoc_in(db,inst_115015,inst_115010);
var inst_115017 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115018 = [cljs.core.cst$kw$novelty,cljs.core.cst$kw$size];
var inst_115019 = (new cljs.core.PersistentVector(null,2,(5),inst_115017,inst_115018,null));
var inst_115020 = cljs.core.assoc_in(inst_115016,inst_115019,inst_114971);
var state_115024__$1 = (function (){var statearr_115054 = state_115024;
(statearr_115054[(13)] = inst_115009);

(statearr_115054[(14)] = inst_115012);

return statearr_115054;
})();
var statearr_115055_115090 = state_115024__$1;
(statearr_115055_115090[(2)] = inst_115020);


cljs.core.async.impl.ioc_helpers.process_exception(state_115024__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (16))){
var state_115024__$1 = state_115024;
var statearr_115056_115091 = state_115024__$1;
(statearr_115056_115091[(2)] = false);

(statearr_115056_115091[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (10))){
var state_115024__$1 = state_115024;
var statearr_115057_115092 = state_115024__$1;
(statearr_115057_115092[(2)] = false);

(statearr_115057_115092[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (18))){
var state_115024__$1 = state_115024;
var statearr_115058_115093 = state_115024__$1;
(statearr_115058_115093[(2)] = true);

(statearr_115058_115093[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115025 === (8))){
var inst_114962 = (state_115024[(2)]);
var state_115024__$1 = state_115024;
if(cljs.core.truth_(inst_114962)){
var statearr_115059_115094 = state_115024__$1;
(statearr_115059_115094[(1)] = (12));

} else {
var statearr_115060_115095 = state_115024__$1;
(statearr_115060_115095[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto__ = null;
var fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto____0 = (function (){
var statearr_115061 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_115061[(0)] = fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto__);

(statearr_115061[(1)] = (1));

return statearr_115061;
});
var fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto____1 = (function (state_115024){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_115024);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e115062){if((e115062 instanceof Object)){
var ex__99706__auto__ = e115062;
var statearr_115063_115096 = state_115024;
(statearr_115063_115096[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_115024);

return cljs.core.cst$kw$recur;
} else {
throw e115062;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__115097 = state_115024;
state_115024 = G__115097;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto__ = function(state_115024){
switch(arguments.length){
case 0:
return fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto____1.call(this,state_115024);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto____0;
fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto____1;
return fluree$db$graphdb$add_predicate_to_idx_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_115064 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_115064[(6)] = c__99809__auto__);

return statearr_115064;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Processes a single transaction, adding it to the DB.
 *   Assumes flakes are already properly sorted.
 */
fluree.db.graphdb.with_t = (function fluree$db$graphdb$with_t(db,flakes){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_115292){
var state_val_115293 = (state_115292[(1)]);
if((state_val_115293 === (7))){
var inst_115137 = (state_115292[(7)]);
var inst_115131 = (state_115292[(8)]);
var inst_115106 = (state_115292[(9)]);
var inst_115127 = (state_115292[(10)]);
var inst_115123 = (state_115292[(11)]);
var inst_115121 = (state_115292[(12)]);
var inst_115121__$1 = (state_115292[(2)]);
var inst_115122 = (function (){var t = inst_115106;
var _ = inst_115121__$1;
return ((function (t,_,inst_115137,inst_115131,inst_115106,inst_115127,inst_115123,inst_115121,inst_115121__$1,state_val_115293,c__99809__auto__){
return (function (p1__115098_SHARP_){
return cljs.core.not((function (){var G__115294 = p1__115098_SHARP_.p;
return (fluree.db.graphdb.exclude_predicates.cljs$core$IFn$_invoke$arity$1 ? fluree.db.graphdb.exclude_predicates.cljs$core$IFn$_invoke$arity$1(G__115294) : fluree.db.graphdb.exclude_predicates.call(null,G__115294));
})());
});
;})(t,_,inst_115137,inst_115131,inst_115106,inst_115127,inst_115123,inst_115121,inst_115121__$1,state_val_115293,c__99809__auto__))
})();
var inst_115123__$1 = cljs.core.filter.cljs$core$IFn$_invoke$arity$2(inst_115122,flakes);
var inst_115124 = cljs.core.PersistentHashSet.EMPTY;
var inst_115125 = (function (){var t = inst_115106;
var _ = inst_115121__$1;
var add_flakes = inst_115123__$1;
return ((function (t,_,add_flakes,inst_115137,inst_115131,inst_115106,inst_115127,inst_115123,inst_115121,inst_115121__$1,inst_115122,inst_115123__$1,inst_115124,state_val_115293,c__99809__auto__){
return (function (p1__115099_SHARP_){
return p1__115099_SHARP_.p;
});
;})(t,_,add_flakes,inst_115137,inst_115131,inst_115106,inst_115127,inst_115123,inst_115121,inst_115121__$1,inst_115122,inst_115123__$1,inst_115124,state_val_115293,c__99809__auto__))
})();
var inst_115126 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_115125,inst_115123__$1);
var inst_115127__$1 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_115124,inst_115126);
var inst_115128 = cljs.core.PersistentHashMap.EMPTY;
var inst_115129 = (function (){var t = inst_115106;
var _ = inst_115121__$1;
var add_flakes = inst_115123__$1;
var add_preds = inst_115127__$1;
return ((function (t,_,add_flakes,add_preds,inst_115137,inst_115131,inst_115106,inst_115127,inst_115123,inst_115121,inst_115121__$1,inst_115122,inst_115123__$1,inst_115124,inst_115125,inst_115126,inst_115127__$1,inst_115128,state_val_115293,c__99809__auto__){
return (function (p){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p,fluree.db.dbproto._p_prop(db,cljs.core.cst$kw$idx_QMARK_,p)], null);
});
;})(t,_,add_flakes,add_preds,inst_115137,inst_115131,inst_115106,inst_115127,inst_115123,inst_115121,inst_115121__$1,inst_115122,inst_115123__$1,inst_115124,inst_115125,inst_115126,inst_115127__$1,inst_115128,state_val_115293,c__99809__auto__))
})();
var inst_115130 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_115129,inst_115127__$1);
var inst_115131__$1 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_115128,inst_115130);
var inst_115132 = cljs.core.PersistentHashMap.EMPTY;
var inst_115133 = (function (){var t = inst_115106;
var _ = inst_115121__$1;
var add_flakes = inst_115123__$1;
var add_preds = inst_115127__$1;
var idx_QMARK__map = inst_115131__$1;
return ((function (t,_,add_flakes,add_preds,idx_QMARK__map,inst_115137,inst_115131,inst_115106,inst_115127,inst_115123,inst_115121,inst_115121__$1,inst_115122,inst_115123__$1,inst_115124,inst_115125,inst_115126,inst_115127__$1,inst_115128,inst_115129,inst_115130,inst_115131__$1,inst_115132,state_val_115293,c__99809__auto__){
return (function (p){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p,fluree.db.dbproto._p_prop(db,cljs.core.cst$kw$ref_QMARK_,p)], null);
});
;})(t,_,add_flakes,add_preds,idx_QMARK__map,inst_115137,inst_115131,inst_115106,inst_115127,inst_115123,inst_115121,inst_115121__$1,inst_115122,inst_115123__$1,inst_115124,inst_115125,inst_115126,inst_115127__$1,inst_115128,inst_115129,inst_115130,inst_115131__$1,inst_115132,state_val_115293,c__99809__auto__))
})();
var inst_115134 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_115133,inst_115127__$1);
var inst_115135 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_115132,inst_115134);
var inst_115136 = fluree.db.flake.size_bytes(inst_115123__$1);
var inst_115137__$1 = fluree.db.util.schema.schema_change_QMARK_(inst_115123__$1);
var inst_115138 = fluree.db.util.schema.setting_change_QMARK_(inst_115123__$1);
var inst_115139 = cljs.core.cst$kw$ecount.cljs$core$IFn$_invoke$arity$1(db);
var inst_115140 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_115139,(0));
var state_115292__$1 = (function (){var statearr_115295 = state_115292;
(statearr_115295[(7)] = inst_115137__$1);

(statearr_115295[(13)] = inst_115135);

(statearr_115295[(8)] = inst_115131__$1);

(statearr_115295[(14)] = inst_115140);

(statearr_115295[(15)] = inst_115136);

(statearr_115295[(10)] = inst_115127__$1);

(statearr_115295[(16)] = inst_115138);

(statearr_115295[(11)] = inst_115123__$1);

(statearr_115295[(12)] = inst_115121__$1);

return statearr_115295;
})();
if(cljs.core.truth_(inst_115137__$1)){
var statearr_115296_115354 = state_115292__$1;
(statearr_115296_115354[(1)] = (8));

} else {
var statearr_115297_115355 = state_115292__$1;
(statearr_115297_115355[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (20))){
var inst_115137 = (state_115292[(7)]);
var inst_115135 = (state_115292[(13)]);
var inst_115219 = (state_115292[(17)]);
var inst_115214 = (state_115292[(18)]);
var inst_115131 = (state_115292[(8)]);
var inst_115218 = (state_115292[(19)]);
var inst_115196 = (state_115292[(20)]);
var inst_115217 = (state_115292[(21)]);
var inst_115225 = (state_115292[(22)]);
var inst_115216 = (state_115292[(23)]);
var inst_115146 = (state_115292[(24)]);
var inst_115186 = (state_115292[(25)]);
var inst_115106 = (state_115292[(9)]);
var inst_115140 = (state_115292[(14)]);
var inst_115136 = (state_115292[(15)]);
var inst_115127 = (state_115292[(10)]);
var inst_115138 = (state_115292[(16)]);
var inst_115215 = (state_115292[(26)]);
var inst_115195 = (state_115292[(27)]);
var inst_115123 = (state_115292[(11)]);
var inst_115121 = (state_115292[(12)]);
var inst_115226 = (state_115292[(28)]);
var inst_115264 = inst_115225.s;
var inst_115265 = fluree.db.flake.sid__GT_cid(inst_115264);
var inst_115266 = (function (){var flakes_bytes = inst_115136;
var t = inst_115106;
var first__115223 = inst_115225;
var vec__115191 = inst_115123;
var spot = inst_115215;
var add_flakes = inst_115123;
var root_setting_change_QMARK_ = inst_115138;
var ref_QMARK__map = inst_115135;
var r = inst_115226;
var psot = inst_115216;
var add_pred_to_idx_QMARK_ = inst_115146;
var _ = inst_115121;
var cid = inst_115265;
var ecount = inst_115219;
var pred_ecount = inst_115140;
var db_STAR_ = inst_115186;
var schema_change_QMARK_ = inst_115137;
var add_preds = inst_115127;
var seq__115222 = inst_115226;
var opst = inst_115218;
var first__115193 = inst_115195;
var seq__115192 = inst_115196;
var vec__115221 = inst_115214;
var idx_QMARK__map = inst_115131;
var post = inst_115217;
var G__115190 = inst_115214;
var f = inst_115225;
return ((function (flakes_bytes,t,first__115223,vec__115191,spot,add_flakes,root_setting_change_QMARK_,ref_QMARK__map,r,psot,add_pred_to_idx_QMARK_,_,cid,ecount,pred_ecount,db_STAR_,schema_change_QMARK_,add_preds,seq__115222,opst,first__115193,seq__115192,vec__115221,idx_QMARK__map,post,G__115190,f,inst_115137,inst_115135,inst_115219,inst_115214,inst_115131,inst_115218,inst_115196,inst_115217,inst_115225,inst_115216,inst_115146,inst_115186,inst_115106,inst_115140,inst_115136,inst_115127,inst_115138,inst_115215,inst_115195,inst_115123,inst_115121,inst_115226,inst_115264,inst_115265,state_val_115293,c__99809__auto__){
return (function (p1__115100_SHARP_){
if(cljs.core.truth_(p1__115100_SHARP_)){
var x__4219__auto__ = p1__115100_SHARP_;
var y__4220__auto__ = f.s;
return ((x__4219__auto__ > y__4220__auto__) ? x__4219__auto__ : y__4220__auto__);
} else {
return f.s;
}
});
;})(flakes_bytes,t,first__115223,vec__115191,spot,add_flakes,root_setting_change_QMARK_,ref_QMARK__map,r,psot,add_pred_to_idx_QMARK_,_,cid,ecount,pred_ecount,db_STAR_,schema_change_QMARK_,add_preds,seq__115222,opst,first__115193,seq__115192,vec__115221,idx_QMARK__map,post,G__115190,f,inst_115137,inst_115135,inst_115219,inst_115214,inst_115131,inst_115218,inst_115196,inst_115217,inst_115225,inst_115216,inst_115146,inst_115186,inst_115106,inst_115140,inst_115136,inst_115127,inst_115138,inst_115215,inst_115195,inst_115123,inst_115121,inst_115226,inst_115264,inst_115265,state_val_115293,c__99809__auto__))
})();
var inst_115267 = cljs.core.update.cljs$core$IFn$_invoke$arity$3(inst_115219,inst_115265,inst_115266);
var inst_115268 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(inst_115215,inst_115225);
var inst_115269 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(inst_115216,inst_115225);
var inst_115270 = inst_115225.p;
var inst_115271 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_115131,inst_115270);
var state_115292__$1 = (function (){var statearr_115298 = state_115292;
(statearr_115298[(29)] = inst_115269);

(statearr_115298[(30)] = inst_115268);

(statearr_115298[(31)] = inst_115267);

return statearr_115298;
})();
if(cljs.core.truth_(inst_115271)){
var statearr_115299_115356 = state_115292__$1;
(statearr_115299_115356[(1)] = (33));

} else {
var statearr_115300_115357 = state_115292__$1;
(statearr_115300_115357[(1)] = (34));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (27))){
var inst_115138 = (state_115292[(16)]);
var inst_115252 = (state_115292[(2)]);
var state_115292__$1 = (function (){var statearr_115301 = state_115292;
(statearr_115301[(32)] = inst_115252);

return statearr_115301;
})();
if(cljs.core.truth_(inst_115138)){
var statearr_115302_115358 = state_115292__$1;
(statearr_115302_115358[(1)] = (29));

} else {
var statearr_115303_115359 = state_115292__$1;
(statearr_115303_115359[(1)] = (30));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (1))){
var state_115292__$1 = state_115292;
var statearr_115304_115360 = state_115292__$1;
(statearr_115304_115360[(2)] = null);

(statearr_115304_115360[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (24))){
var inst_115243 = (state_115292[(2)]);
var state_115292__$1 = state_115292;
if(cljs.core.truth_(inst_115243)){
var statearr_115305_115361 = state_115292__$1;
(statearr_115305_115361[(1)] = (25));

} else {
var statearr_115306_115362 = state_115292__$1;
(statearr_115306_115362[(1)] = (26));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (4))){
var inst_115106 = (state_115292[(9)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_115292,(3),Error,null,(2));
var inst_115105 = cljs.core.first(flakes);
var inst_115106__$1 = inst_115105.t;
var inst_115107 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(db);
var inst_115108 = (inst_115107 - (1));
var inst_115109 = cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(inst_115106__$1,inst_115108);
var state_115292__$1 = (function (){var statearr_115307 = state_115292;
(statearr_115307[(9)] = inst_115106__$1);

return statearr_115307;
})();
if(inst_115109){
var statearr_115308_115363 = state_115292__$1;
(statearr_115308_115363[(1)] = (5));

} else {
var statearr_115309_115364 = state_115292__$1;
(statearr_115309_115364[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (15))){
var inst_115174 = (state_115292[(2)]);
var state_115292__$1 = state_115292;
var statearr_115310_115365 = state_115292__$1;
(statearr_115310_115365[(2)] = inst_115174);

(statearr_115310_115365[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (21))){
var inst_115286 = (state_115292[(2)]);
var state_115292__$1 = state_115292;
var statearr_115311_115366 = state_115292__$1;
(statearr_115311_115366[(2)] = inst_115286);

(statearr_115311_115366[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (31))){
var inst_115262 = (state_115292[(2)]);
var state_115292__$1 = state_115292;
var statearr_115312_115367 = state_115292__$1;
(statearr_115312_115367[(2)] = inst_115262);

(statearr_115312_115367[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (32))){
var inst_115252 = (state_115292[(32)]);
var inst_115257 = (state_115292[(2)]);
var inst_115258 = fluree.db.util.async.throw_err(inst_115257);
var inst_115259 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_115252,cljs.core.cst$kw$settings,inst_115258);
var state_115292__$1 = state_115292;
var statearr_115313_115368 = state_115292__$1;
(statearr_115313_115368[(2)] = inst_115259);

(statearr_115313_115368[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (33))){
var inst_115217 = (state_115292[(21)]);
var inst_115225 = (state_115292[(22)]);
var inst_115273 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(inst_115217,inst_115225);
var state_115292__$1 = state_115292;
var statearr_115314_115369 = state_115292__$1;
(statearr_115314_115369[(2)] = inst_115273);

(statearr_115314_115369[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (13))){
var inst_115158 = (state_115292[(33)]);
var inst_115164 = (state_115292[(34)]);
var inst_115167 = fluree.db.graphdb.add_predicate_to_idx(inst_115158,inst_115164);
var state_115292__$1 = state_115292;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_115292__$1,(16),inst_115167);
} else {
if((state_val_115293 === (22))){
var inst_115137 = (state_115292[(7)]);
var state_115292__$1 = state_115292;
var statearr_115315_115370 = state_115292__$1;
(statearr_115315_115370[(2)] = inst_115137);

(statearr_115315_115370[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (36))){
var inst_115218 = (state_115292[(19)]);
var inst_115225 = (state_115292[(22)]);
var inst_115280 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(inst_115218,inst_115225);
var state_115292__$1 = state_115292;
var statearr_115316_115371 = state_115292__$1;
(statearr_115316_115371[(2)] = inst_115280);

(statearr_115316_115371[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (29))){
var inst_115252 = (state_115292[(32)]);
var inst_115255 = fluree.db.query.schema.setting_map(inst_115252);
var state_115292__$1 = state_115292;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_115292__$1,(32),inst_115255);
} else {
if((state_val_115293 === (6))){
var state_115292__$1 = state_115292;
var statearr_115317_115372 = state_115292__$1;
(statearr_115317_115372[(2)] = null);

(statearr_115317_115372[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (28))){
var inst_115237 = (state_115292[(35)]);
var inst_115247 = (state_115292[(2)]);
var inst_115248 = fluree.db.util.async.throw_err(inst_115247);
var inst_115249 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_115237,cljs.core.cst$kw$schema,inst_115248);
var state_115292__$1 = state_115292;
var statearr_115318_115373 = state_115292__$1;
(statearr_115318_115373[(2)] = inst_115249);

(statearr_115318_115373[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (25))){
var inst_115237 = (state_115292[(35)]);
var inst_115245 = fluree.db.query.schema.schema_map(inst_115237);
var state_115292__$1 = state_115292;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_115292__$1,(28),inst_115245);
} else {
if((state_val_115293 === (34))){
var inst_115217 = (state_115292[(21)]);
var state_115292__$1 = state_115292;
var statearr_115319_115374 = state_115292__$1;
(statearr_115319_115374[(2)] = inst_115217);

(statearr_115319_115374[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (17))){
var inst_115214 = (state_115292[(18)]);
var inst_115225 = (state_115292[(22)]);
var inst_115224 = cljs.core.seq(inst_115214);
var inst_115225__$1 = cljs.core.first(inst_115224);
var inst_115226 = cljs.core.next(inst_115224);
var inst_115227 = cljs.core.not(inst_115225__$1);
var state_115292__$1 = (function (){var statearr_115320 = state_115292;
(statearr_115320[(22)] = inst_115225__$1);

(statearr_115320[(28)] = inst_115226);

return statearr_115320;
})();
if(inst_115227){
var statearr_115321_115375 = state_115292__$1;
(statearr_115321_115375[(1)] = (19));

} else {
var statearr_115322_115376 = state_115292__$1;
(statearr_115322_115376[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (3))){
var inst_115101 = (state_115292[(2)]);
var state_115292__$1 = state_115292;
var statearr_115323_115377 = state_115292__$1;
(statearr_115323_115377[(2)] = inst_115101);


cljs.core.async.impl.ioc_helpers.process_exception(state_115292__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (12))){
var inst_115186 = (state_115292[(25)]);
var inst_115106 = (state_115292[(9)]);
var inst_115136 = (state_115292[(15)]);
var inst_115123 = (state_115292[(11)]);
var inst_115176 = (state_115292[(2)]);
var inst_115177 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_115176,cljs.core.cst$kw$t,inst_115106);
var inst_115178 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115179 = [cljs.core.cst$kw$stats,cljs.core.cst$kw$size];
var inst_115180 = (new cljs.core.PersistentVector(null,2,(5),inst_115178,inst_115179,null));
var inst_115181 = cljs.core.update_in.cljs$core$IFn$_invoke$arity$4(inst_115177,inst_115180,cljs.core._PLUS_,inst_115136);
var inst_115182 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115183 = [cljs.core.cst$kw$stats,cljs.core.cst$kw$flakes];
var inst_115184 = (new cljs.core.PersistentVector(null,2,(5),inst_115182,inst_115183,null));
var inst_115185 = cljs.core.count(inst_115123);
var inst_115186__$1 = cljs.core.update_in.cljs$core$IFn$_invoke$arity$4(inst_115181,inst_115184,cljs.core._PLUS_,inst_115185);
var inst_115194 = cljs.core.seq(inst_115123);
var inst_115195 = cljs.core.first(inst_115194);
var inst_115196 = cljs.core.next(inst_115194);
var inst_115197 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115198 = [cljs.core.cst$kw$novelty,cljs.core.cst$kw$spot];
var inst_115199 = (new cljs.core.PersistentVector(null,2,(5),inst_115197,inst_115198,null));
var inst_115200 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(inst_115186__$1,inst_115199);
var inst_115201 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115202 = [cljs.core.cst$kw$novelty,cljs.core.cst$kw$psot];
var inst_115203 = (new cljs.core.PersistentVector(null,2,(5),inst_115201,inst_115202,null));
var inst_115204 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(inst_115186__$1,inst_115203);
var inst_115205 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115206 = [cljs.core.cst$kw$novelty,cljs.core.cst$kw$post];
var inst_115207 = (new cljs.core.PersistentVector(null,2,(5),inst_115205,inst_115206,null));
var inst_115208 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(inst_115186__$1,inst_115207);
var inst_115209 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115210 = [cljs.core.cst$kw$novelty,cljs.core.cst$kw$opst];
var inst_115211 = (new cljs.core.PersistentVector(null,2,(5),inst_115209,inst_115210,null));
var inst_115212 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(inst_115186__$1,inst_115211);
var inst_115213 = cljs.core.cst$kw$ecount.cljs$core$IFn$_invoke$arity$1(db);
var inst_115214 = inst_115123;
var inst_115215 = inst_115200;
var inst_115216 = inst_115204;
var inst_115217 = inst_115208;
var inst_115218 = inst_115212;
var inst_115219 = inst_115213;
var state_115292__$1 = (function (){var statearr_115324 = state_115292;
(statearr_115324[(17)] = inst_115219);

(statearr_115324[(18)] = inst_115214);

(statearr_115324[(19)] = inst_115218);

(statearr_115324[(20)] = inst_115196);

(statearr_115324[(21)] = inst_115217);

(statearr_115324[(23)] = inst_115216);

(statearr_115324[(25)] = inst_115186__$1);

(statearr_115324[(26)] = inst_115215);

(statearr_115324[(27)] = inst_115195);

return statearr_115324;
})();
var statearr_115325_115378 = state_115292__$1;
(statearr_115325_115378[(2)] = null);

(statearr_115325_115378[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (2))){
var inst_115290 = (state_115292[(2)]);
var state_115292__$1 = state_115292;
return cljs.core.async.impl.ioc_helpers.return_chan(state_115292__$1,inst_115290);
} else {
if((state_val_115293 === (23))){
var inst_115237 = (state_115292[(35)]);
var inst_115240 = cljs.core.cst$kw$schema.cljs$core$IFn$_invoke$arity$1(inst_115237);
var inst_115241 = (inst_115240 == null);
var state_115292__$1 = state_115292;
var statearr_115326_115379 = state_115292__$1;
(statearr_115326_115379[(2)] = inst_115241);

(statearr_115326_115379[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (35))){
var inst_115135 = (state_115292[(13)]);
var inst_115225 = (state_115292[(22)]);
var inst_115276 = (state_115292[(2)]);
var inst_115277 = inst_115225.p;
var inst_115278 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_115135,inst_115277);
var state_115292__$1 = (function (){var statearr_115327 = state_115292;
(statearr_115327[(36)] = inst_115276);

return statearr_115327;
})();
if(cljs.core.truth_(inst_115278)){
var statearr_115328_115380 = state_115292__$1;
(statearr_115328_115380[(1)] = (36));

} else {
var statearr_115329_115381 = state_115292__$1;
(statearr_115329_115381[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (19))){
var inst_115137 = (state_115292[(7)]);
var inst_115219 = (state_115292[(17)]);
var inst_115218 = (state_115292[(19)]);
var inst_115217 = (state_115292[(21)]);
var inst_115216 = (state_115292[(23)]);
var inst_115186 = (state_115292[(25)]);
var inst_115136 = (state_115292[(15)]);
var inst_115215 = (state_115292[(26)]);
var inst_115229 = [cljs.core.cst$kw$spot,cljs.core.cst$kw$psot,cljs.core.cst$kw$post,cljs.core.cst$kw$opst,cljs.core.cst$kw$size];
var inst_115230 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115231 = [cljs.core.cst$kw$novelty,cljs.core.cst$kw$size];
var inst_115232 = (new cljs.core.PersistentVector(null,2,(5),inst_115230,inst_115231,null));
var inst_115233 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(inst_115186,inst_115232);
var inst_115234 = (inst_115136 + inst_115233);
var inst_115235 = [inst_115215,inst_115216,inst_115217,inst_115218,inst_115234];
var inst_115236 = cljs.core.PersistentHashMap.fromArrays(inst_115229,inst_115235);
var inst_115237 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(inst_115186,cljs.core.cst$kw$ecount,inst_115219,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$novelty,inst_115236], 0));
var state_115292__$1 = (function (){var statearr_115330 = state_115292;
(statearr_115330[(35)] = inst_115237);

return statearr_115330;
})();
if(cljs.core.truth_(inst_115137)){
var statearr_115331_115382 = state_115292__$1;
(statearr_115331_115382[(1)] = (22));

} else {
var statearr_115332_115383 = state_115292__$1;
(statearr_115332_115383[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (11))){
var inst_115164 = (state_115292[(34)]);
var inst_115157 = (state_115292[(37)]);
var inst_115163 = cljs.core.seq(inst_115157);
var inst_115164__$1 = cljs.core.first(inst_115163);
var inst_115165 = cljs.core.next(inst_115163);
var state_115292__$1 = (function (){var statearr_115333 = state_115292;
(statearr_115333[(38)] = inst_115165);

(statearr_115333[(34)] = inst_115164__$1);

return statearr_115333;
})();
if(cljs.core.truth_(inst_115164__$1)){
var statearr_115334_115384 = state_115292__$1;
(statearr_115334_115384[(1)] = (13));

} else {
var statearr_115335_115385 = state_115292__$1;
(statearr_115335_115385[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (9))){
var inst_115144 = cljs.core.PersistentVector.EMPTY;
var state_115292__$1 = state_115292;
var statearr_115336_115386 = state_115292__$1;
(statearr_115336_115386[(2)] = inst_115144);

(statearr_115336_115386[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (5))){
var inst_115106 = (state_115292[(9)]);
var inst_115111 = cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(db);
var inst_115112 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(db);
var inst_115113 = ["Invalid with called for db ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_115111)," because current 't', ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_115112)," is not beyond supplied transaction t: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_115106),"."].join('');
var inst_115114 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_115115 = [(500),cljs.core.cst$kw$db_SLASH_unexpected_DASH_error];
var inst_115116 = cljs.core.PersistentHashMap.fromArrays(inst_115114,inst_115115);
var inst_115117 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_115113,inst_115116);
var inst_115118 = (function(){throw inst_115117})();
var state_115292__$1 = state_115292;
var statearr_115337_115387 = state_115292__$1;
(statearr_115337_115387[(2)] = inst_115118);

(statearr_115337_115387[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (14))){
var inst_115158 = (state_115292[(33)]);
var state_115292__$1 = state_115292;
var statearr_115338_115388 = state_115292__$1;
(statearr_115338_115388[(2)] = inst_115158);

(statearr_115338_115388[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (26))){
var inst_115237 = (state_115292[(35)]);
var state_115292__$1 = state_115292;
var statearr_115339_115389 = state_115292__$1;
(statearr_115339_115389[(2)] = inst_115237);

(statearr_115339_115389[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (16))){
var inst_115165 = (state_115292[(38)]);
var inst_115169 = (state_115292[(2)]);
var inst_115170 = fluree.db.util.async.throw_err(inst_115169);
var inst_115157 = inst_115165;
var inst_115158 = inst_115170;
var state_115292__$1 = (function (){var statearr_115340 = state_115292;
(statearr_115340[(33)] = inst_115158);

(statearr_115340[(37)] = inst_115157);

return statearr_115340;
})();
var statearr_115341_115390 = state_115292__$1;
(statearr_115341_115390[(2)] = null);

(statearr_115341_115390[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (38))){
var inst_115276 = (state_115292[(36)]);
var inst_115269 = (state_115292[(29)]);
var inst_115268 = (state_115292[(30)]);
var inst_115267 = (state_115292[(31)]);
var inst_115226 = (state_115292[(28)]);
var inst_115283 = (state_115292[(2)]);
var inst_115214 = inst_115226;
var inst_115215 = inst_115268;
var inst_115216 = inst_115269;
var inst_115217 = inst_115276;
var inst_115218 = inst_115283;
var inst_115219 = inst_115267;
var state_115292__$1 = (function (){var statearr_115342 = state_115292;
(statearr_115342[(17)] = inst_115219);

(statearr_115342[(18)] = inst_115214);

(statearr_115342[(19)] = inst_115218);

(statearr_115342[(21)] = inst_115217);

(statearr_115342[(23)] = inst_115216);

(statearr_115342[(26)] = inst_115215);

return statearr_115342;
})();
var statearr_115343_115391 = state_115292__$1;
(statearr_115343_115391[(2)] = null);

(statearr_115343_115391[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (30))){
var inst_115252 = (state_115292[(32)]);
var state_115292__$1 = state_115292;
var statearr_115344_115392 = state_115292__$1;
(statearr_115344_115392[(2)] = inst_115252);

(statearr_115344_115392[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (10))){
var inst_115146 = (state_115292[(24)]);
var inst_115146__$1 = (state_115292[(2)]);
var inst_115154 = cljs.core.seq(inst_115146__$1);
var inst_115155 = cljs.core.first(inst_115154);
var inst_115156 = cljs.core.next(inst_115154);
var inst_115157 = inst_115146__$1;
var inst_115158 = db;
var state_115292__$1 = (function (){var statearr_115345 = state_115292;
(statearr_115345[(39)] = inst_115155);

(statearr_115345[(33)] = inst_115158);

(statearr_115345[(24)] = inst_115146__$1);

(statearr_115345[(40)] = inst_115156);

(statearr_115345[(37)] = inst_115157);

return statearr_115345;
})();
var statearr_115346_115393 = state_115292__$1;
(statearr_115346_115393[(2)] = null);

(statearr_115346_115393[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (18))){
var inst_115288 = (state_115292[(2)]);
var state_115292__$1 = state_115292;
var statearr_115347_115394 = state_115292__$1;
(statearr_115347_115394[(2)] = inst_115288);


cljs.core.async.impl.ioc_helpers.process_exception(state_115292__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (37))){
var inst_115218 = (state_115292[(19)]);
var state_115292__$1 = state_115292;
var statearr_115348_115395 = state_115292__$1;
(statearr_115348_115395[(2)] = inst_115218);

(statearr_115348_115395[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115293 === (8))){
var inst_115140 = (state_115292[(14)]);
var inst_115123 = (state_115292[(11)]);
var inst_115142 = fluree.db.util.schema.add_to_post_preds_QMARK_(inst_115123,inst_115140);
var state_115292__$1 = state_115292;
var statearr_115349_115396 = state_115292__$1;
(statearr_115349_115396[(2)] = inst_115142);

(statearr_115349_115396[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$graphdb$with_t_$_state_machine__99703__auto__ = null;
var fluree$db$graphdb$with_t_$_state_machine__99703__auto____0 = (function (){
var statearr_115350 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_115350[(0)] = fluree$db$graphdb$with_t_$_state_machine__99703__auto__);

(statearr_115350[(1)] = (1));

return statearr_115350;
});
var fluree$db$graphdb$with_t_$_state_machine__99703__auto____1 = (function (state_115292){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_115292);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e115351){if((e115351 instanceof Object)){
var ex__99706__auto__ = e115351;
var statearr_115352_115397 = state_115292;
(statearr_115352_115397[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_115292);

return cljs.core.cst$kw$recur;
} else {
throw e115351;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__115398 = state_115292;
state_115292 = G__115398;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$graphdb$with_t_$_state_machine__99703__auto__ = function(state_115292){
switch(arguments.length){
case 0:
return fluree$db$graphdb$with_t_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$graphdb$with_t_$_state_machine__99703__auto____1.call(this,state_115292);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$with_t_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$with_t_$_state_machine__99703__auto____0;
fluree$db$graphdb$with_t_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$with_t_$_state_machine__99703__auto____1;
return fluree$db$graphdb$with_t_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_115353 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_115353[(6)] = c__99809__auto__);

return statearr_115353;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns db 'with' flakes added as a core async promise channel.
 *   Note this always does a re-sort.
 */
fluree.db.graphdb.with$ = (function fluree$db$graphdb$with(db,block,flakes){
var resp_ch = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__99809__auto___115521 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___115521,resp_ch){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___115521,resp_ch){
return (function (state_115483){
var state_val_115484 = (state_115483[(1)]);
if((state_val_115484 === (7))){
var inst_115418 = (state_115483[(2)]);
var inst_115419 = cljs.core.sort.cljs$core$IFn$_invoke$arity$2(fluree.db.flake.cmp_flakes_block,flakes);
var inst_115427 = cljs.core.seq(inst_115419);
var inst_115428 = cljs.core.first(inst_115427);
var inst_115429 = cljs.core.next(inst_115427);
var inst_115430 = cljs.core.first(inst_115419);
var inst_115431 = inst_115430.t;
var inst_115432 = cljs.core.PersistentVector.EMPTY;
var inst_115433 = inst_115419;
var inst_115434 = inst_115431;
var inst_115435 = inst_115432;
var inst_115436 = db;
var state_115483__$1 = (function (){var statearr_115485 = state_115483;
(statearr_115485[(7)] = inst_115434);

(statearr_115485[(8)] = inst_115436);

(statearr_115485[(9)] = inst_115418);

(statearr_115485[(10)] = inst_115429);

(statearr_115485[(11)] = inst_115428);

(statearr_115485[(12)] = inst_115433);

(statearr_115485[(13)] = inst_115435);

return statearr_115485;
})();
var statearr_115486_115522 = state_115483__$1;
(statearr_115486_115522[(2)] = null);

(statearr_115486_115522[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (20))){
var inst_115460 = (state_115483[(14)]);
var inst_115463 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_115460,cljs.core.cst$kw$block,block);
var state_115483__$1 = state_115483;
var statearr_115487_115523 = state_115483__$1;
(statearr_115487_115523[(2)] = inst_115463);

(statearr_115487_115523[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (1))){
var state_115483__$1 = state_115483;
var statearr_115488_115524 = state_115483__$1;
(statearr_115488_115524[(2)] = null);

(statearr_115488_115524[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_115483,(3),cljs.core.cst$kw$default,null,(2));
var inst_115404 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(db);
var inst_115405 = (inst_115404 + (1));
var inst_115406 = cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(block,inst_115405);
var state_115483__$1 = state_115483;
if(inst_115406){
var statearr_115489_115525 = state_115483__$1;
(statearr_115489_115525[(1)] = (5));

} else {
var statearr_115490_115526 = state_115483__$1;
(statearr_115490_115526[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (15))){
var inst_115476 = (state_115483[(2)]);
var state_115483__$1 = state_115483;
var statearr_115493_115527 = state_115483__$1;
(statearr_115493_115527[(2)] = inst_115476);

(statearr_115493_115527[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (21))){
var inst_115442 = (state_115483[(15)]);
var inst_115460 = (state_115483[(14)]);
var inst_115443 = (state_115483[(16)]);
var inst_115465 = inst_115442.t;
var inst_115466 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115467 = [inst_115442];
var inst_115468 = (new cljs.core.PersistentVector(null,1,(5),inst_115466,inst_115467,null));
var inst_115433 = inst_115443;
var inst_115434 = inst_115465;
var inst_115435 = inst_115468;
var inst_115436 = inst_115460;
var state_115483__$1 = (function (){var statearr_115494 = state_115483;
(statearr_115494[(7)] = inst_115434);

(statearr_115494[(8)] = inst_115436);

(statearr_115494[(12)] = inst_115433);

(statearr_115494[(13)] = inst_115435);

return statearr_115494;
})();
var statearr_115495_115528 = state_115483__$1;
(statearr_115495_115528[(2)] = null);

(statearr_115495_115528[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (13))){
var inst_115434 = (state_115483[(7)]);
var inst_115436 = (state_115483[(8)]);
var inst_115442 = (state_115483[(15)]);
var inst_115443 = (state_115483[(16)]);
var inst_115435 = (state_115483[(13)]);
var inst_115451 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(inst_115435,inst_115442);
var tmp115491 = inst_115434;
var tmp115492 = inst_115436;
var inst_115433 = inst_115443;
var inst_115434__$1 = tmp115491;
var inst_115435__$1 = inst_115451;
var inst_115436__$1 = tmp115492;
var state_115483__$1 = (function (){var statearr_115496 = state_115483;
(statearr_115496[(7)] = inst_115434__$1);

(statearr_115496[(8)] = inst_115436__$1);

(statearr_115496[(12)] = inst_115433);

(statearr_115496[(13)] = inst_115435__$1);

return statearr_115496;
})();
var statearr_115497_115529 = state_115483__$1;
(statearr_115497_115529[(2)] = null);

(statearr_115497_115529[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (22))){
var inst_115471 = (state_115483[(2)]);
var state_115483__$1 = state_115483;
var statearr_115498_115530 = state_115483__$1;
(statearr_115498_115530[(2)] = inst_115471);

(statearr_115498_115530[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (6))){
var state_115483__$1 = state_115483;
var statearr_115499_115531 = state_115483__$1;
(statearr_115499_115531[(2)] = null);

(statearr_115499_115531[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (17))){
var state_115483__$1 = state_115483;
var statearr_115500_115532 = state_115483__$1;
(statearr_115500_115532[(2)] = null);

(statearr_115500_115532[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (3))){
var inst_115399 = (state_115483[(2)]);
var inst_115400 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(resp_ch,inst_115399);
var state_115483__$1 = state_115483;
var statearr_115501_115533 = state_115483__$1;
(statearr_115501_115533[(2)] = inst_115400);


cljs.core.async.impl.ioc_helpers.process_exception(state_115483__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (12))){
var inst_115449 = (state_115483[(2)]);
var state_115483__$1 = state_115483;
if(cljs.core.truth_(inst_115449)){
var statearr_115502_115534 = state_115483__$1;
(statearr_115502_115534[(1)] = (13));

} else {
var statearr_115503_115535 = state_115483__$1;
(statearr_115503_115535[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (2))){
var inst_115481 = (state_115483[(2)]);
var state_115483__$1 = state_115483;
return cljs.core.async.impl.ioc_helpers.return_chan(state_115483__$1,inst_115481);
} else {
if((state_val_115484 === (19))){
var inst_115442 = (state_115483[(15)]);
var inst_115459 = (state_115483[(2)]);
var inst_115460 = fluree.db.util.async.throw_err(inst_115459);
var inst_115461 = (inst_115442 == null);
var state_115483__$1 = (function (){var statearr_115504 = state_115483;
(statearr_115504[(14)] = inst_115460);

return statearr_115504;
})();
if(cljs.core.truth_(inst_115461)){
var statearr_115505_115536 = state_115483__$1;
(statearr_115505_115536[(1)] = (20));

} else {
var statearr_115506_115537 = state_115483__$1;
(statearr_115506_115537[(1)] = (21));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (11))){
var inst_115442 = (state_115483[(15)]);
var state_115483__$1 = state_115483;
var statearr_115507_115538 = state_115483__$1;
(statearr_115507_115538[(2)] = inst_115442);

(statearr_115507_115538[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (9))){
var inst_115478 = (state_115483[(2)]);
var inst_115479 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(resp_ch,inst_115478);
var state_115483__$1 = state_115483;
var statearr_115508_115539 = state_115483__$1;
(statearr_115508_115539[(2)] = inst_115479);


cljs.core.async.impl.ioc_helpers.process_exception(state_115483__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (5))){
var inst_115408 = cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(db);
var inst_115409 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(db);
var inst_115410 = ["Invalid 'with' called for db ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_115408)," because current db 'block', ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_115409)," must be one less than supplied block ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block),"."].join('');
var inst_115411 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_115412 = [(500),cljs.core.cst$kw$db_SLASH_unexpected_DASH_error];
var inst_115413 = cljs.core.PersistentHashMap.fromArrays(inst_115411,inst_115412);
var inst_115414 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_115410,inst_115413);
var inst_115415 = (function(){throw inst_115414})();
var state_115483__$1 = state_115483;
var statearr_115509_115540 = state_115483__$1;
(statearr_115509_115540[(2)] = inst_115415);

(statearr_115509_115540[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (14))){
var state_115483__$1 = state_115483;
var statearr_115510_115541 = state_115483__$1;
(statearr_115510_115541[(1)] = (16));



return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (16))){
var inst_115434 = (state_115483[(7)]);
var inst_115436 = (state_115483[(8)]);
var inst_115435 = (state_115483[(13)]);
var inst_115455 = (inst_115434 + (1));
var inst_115456 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_115436,cljs.core.cst$kw$t,inst_115455);
var inst_115457 = fluree.db.graphdb.with_t(inst_115456,inst_115435);
var state_115483__$1 = state_115483;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_115483__$1,(19),inst_115457);
} else {
if((state_val_115484 === (10))){
var inst_115434 = (state_115483[(7)]);
var inst_115442 = (state_115483[(15)]);
var inst_115445 = inst_115442.t;
var inst_115446 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_115434,inst_115445);
var state_115483__$1 = state_115483;
var statearr_115512_115542 = state_115483__$1;
(statearr_115512_115542[(2)] = inst_115446);

(statearr_115512_115542[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (18))){
var inst_115474 = (state_115483[(2)]);
var state_115483__$1 = state_115483;
var statearr_115513_115543 = state_115483__$1;
(statearr_115513_115543[(2)] = inst_115474);

(statearr_115513_115543[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115484 === (8))){
var inst_115442 = (state_115483[(15)]);
var inst_115433 = (state_115483[(12)]);
var inst_115441 = cljs.core.seq(inst_115433);
var inst_115442__$1 = cljs.core.first(inst_115441);
var inst_115443 = cljs.core.next(inst_115441);
var state_115483__$1 = (function (){var statearr_115514 = state_115483;
(statearr_115514[(15)] = inst_115442__$1);

(statearr_115514[(16)] = inst_115443);

return statearr_115514;
})();
if(cljs.core.truth_(inst_115442__$1)){
var statearr_115515_115544 = state_115483__$1;
(statearr_115515_115544[(1)] = (10));

} else {
var statearr_115516_115545 = state_115483__$1;
(statearr_115516_115545[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___115521,resp_ch))
;
return ((function (switch__99702__auto__,c__99809__auto___115521,resp_ch){
return (function() {
var fluree$db$graphdb$with_$_state_machine__99703__auto__ = null;
var fluree$db$graphdb$with_$_state_machine__99703__auto____0 = (function (){
var statearr_115517 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_115517[(0)] = fluree$db$graphdb$with_$_state_machine__99703__auto__);

(statearr_115517[(1)] = (1));

return statearr_115517;
});
var fluree$db$graphdb$with_$_state_machine__99703__auto____1 = (function (state_115483){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_115483);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e115518){if((e115518 instanceof Object)){
var ex__99706__auto__ = e115518;
var statearr_115519_115546 = state_115483;
(statearr_115519_115546[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_115483);

return cljs.core.cst$kw$recur;
} else {
throw e115518;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__115547 = state_115483;
state_115483 = G__115547;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$graphdb$with_$_state_machine__99703__auto__ = function(state_115483){
switch(arguments.length){
case 0:
return fluree$db$graphdb$with_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$graphdb$with_$_state_machine__99703__auto____1.call(this,state_115483);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$with_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$with_$_state_machine__99703__auto____0;
fluree$db$graphdb$with_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$with_$_state_machine__99703__auto____1;
return fluree$db$graphdb$with_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___115521,resp_ch))
})();
var state__99811__auto__ = (function (){var statearr_115520 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_115520[(6)] = c__99809__auto___115521);

return statearr_115520;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___115521,resp_ch))
);


return resp_ch;
});
/**
 * Returns true if db is a forward time travel db.
 */
fluree.db.graphdb.forward_time_travel_db_QMARK_ = (function fluree$db$graphdb$forward_time_travel_db_QMARK_(db){
return (!((cljs.core.cst$kw$tt_DASH_id.cljs$core$IFn$_invoke$arity$1(db) == null)));
});
/**
 * Returns a core async chan with a new db based on the provided db, including the provided flakes.
 *   Flakes can contain one or more 't's, but should be sequential and start after the current
 *   't' of the provided db. (i.e. if db-t is -14, flakes 't' should be -15, -16, etc.).
 *   Remember 't' is negative and thus should be in descending order.
 * 
 *   A tt-id (time-travel-id), if provided, can be any unique identifier of any type and is required.
 *   It must be unique (to the computer/process) to avoid any query caching issues.
 * 
 *   A forward-time-travel dbf can be further forward-time-traveled. If a tt-id is provided, ensure
 *   it is unique for each successive call.
 * 
 *   A forward-time travel DB is held in memory, and is not shared across servers. Ensure you
 *   have adequate memory to hold the flakes you generate and add. If access is provided via
 *   an external API, do any desired size restrictions or controls within your API endpoint.
 * 
 *   Remember schema operations done via forward-time-travel should be done in a 't' prior to
 *   the flakes that end up requiring the schema change.
 */
fluree.db.graphdb.forward_time_travel = (function fluree$db$graphdb$forward_time_travel(db,tt_id,flakes){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_115600){
var state_val_115601 = (state_115600[(1)]);
if((state_val_115601 === (7))){
var inst_115557 = (state_115600[(2)]);
var inst_115558 = (function (){var tt_id_SINGLEQUOTE_ = inst_115557;
return ((function (tt_id_SINGLEQUOTE_,inst_115557,state_val_115601,c__99809__auto__){
return (function (db_STAR_,idx){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(db_STAR_,idx,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(cljs.core.get.cljs$core$IFn$_invoke$arity$2(db_STAR_,idx),cljs.core.cst$kw$tt_DASH_id,tt_id_SINGLEQUOTE_));
});
;})(tt_id_SINGLEQUOTE_,inst_115557,state_val_115601,c__99809__auto__))
})();
var inst_115559 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(db,cljs.core.cst$kw$tt_DASH_id,inst_115557);
var inst_115560 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115561 = [cljs.core.cst$kw$spot,cljs.core.cst$kw$psot,cljs.core.cst$kw$post,cljs.core.cst$kw$opst];
var inst_115562 = (new cljs.core.PersistentVector(null,4,(5),inst_115560,inst_115561,null));
var inst_115563 = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(inst_115558,inst_115559,inst_115562);
var inst_115564 = cljs.core.sort_by.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$t,flakes);
var inst_115565 = cljs.core.reverse(inst_115564);
var inst_115566 = cljs.core.partition_by.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$t,inst_115565);
var inst_115574 = cljs.core.seq(inst_115566);
var inst_115575 = cljs.core.first(inst_115574);
var inst_115576 = cljs.core.next(inst_115574);
var inst_115577 = inst_115563;
var inst_115578 = inst_115566;
var state_115600__$1 = (function (){var statearr_115602 = state_115600;
(statearr_115602[(7)] = inst_115577);

(statearr_115602[(8)] = inst_115576);

(statearr_115602[(9)] = inst_115575);

(statearr_115602[(10)] = inst_115578);

return statearr_115602;
})();
var statearr_115603_115622 = state_115600__$1;
(statearr_115603_115622[(2)] = null);

(statearr_115603_115622[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115601 === (1))){
var state_115600__$1 = state_115600;
var statearr_115604_115623 = state_115600__$1;
(statearr_115604_115623[(2)] = null);

(statearr_115604_115623[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115601 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_115600,(3),Error,null,(2));
var inst_115552 = (tt_id == null);
var state_115600__$1 = state_115600;
if(cljs.core.truth_(inst_115552)){
var statearr_115605_115624 = state_115600__$1;
(statearr_115605_115624[(1)] = (5));

} else {
var statearr_115606_115625 = state_115600__$1;
(statearr_115606_115625[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115601 === (13))){
var inst_115585 = (state_115600[(11)]);
var inst_115589 = (state_115600[(2)]);
var inst_115590 = fluree.db.util.async.throw_err(inst_115589);
var inst_115577 = inst_115590;
var inst_115578 = inst_115585;
var state_115600__$1 = (function (){var statearr_115607 = state_115600;
(statearr_115607[(7)] = inst_115577);

(statearr_115607[(10)] = inst_115578);

return statearr_115607;
})();
var statearr_115608_115626 = state_115600__$1;
(statearr_115608_115626[(2)] = null);

(statearr_115608_115626[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115601 === (6))){
var state_115600__$1 = state_115600;
var statearr_115609_115627 = state_115600__$1;
(statearr_115609_115627[(2)] = tt_id);

(statearr_115609_115627[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115601 === (3))){
var inst_115548 = (state_115600[(2)]);
var state_115600__$1 = state_115600;
var statearr_115610_115628 = state_115600__$1;
(statearr_115610_115628[(2)] = inst_115548);


cljs.core.async.impl.ioc_helpers.process_exception(state_115600__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115601 === (12))){
var inst_115594 = (state_115600[(2)]);
var state_115600__$1 = state_115600;
var statearr_115611_115629 = state_115600__$1;
(statearr_115611_115629[(2)] = inst_115594);

(statearr_115611_115629[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115601 === (2))){
var inst_115598 = (state_115600[(2)]);
var state_115600__$1 = state_115600;
return cljs.core.async.impl.ioc_helpers.return_chan(state_115600__$1,inst_115598);
} else {
if((state_val_115601 === (11))){
var inst_115577 = (state_115600[(7)]);
var state_115600__$1 = state_115600;
var statearr_115612_115630 = state_115600__$1;
(statearr_115612_115630[(2)] = inst_115577);

(statearr_115612_115630[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115601 === (9))){
var inst_115596 = (state_115600[(2)]);
var state_115600__$1 = state_115600;
var statearr_115613_115631 = state_115600__$1;
(statearr_115613_115631[(2)] = inst_115596);


cljs.core.async.impl.ioc_helpers.process_exception(state_115600__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115601 === (5))){
var inst_115554 = fluree.db.util.core.random_uuid();
var state_115600__$1 = state_115600;
var statearr_115614_115632 = state_115600__$1;
(statearr_115614_115632[(2)] = inst_115554);

(statearr_115614_115632[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115601 === (10))){
var inst_115577 = (state_115600[(7)]);
var inst_115584 = (state_115600[(12)]);
var inst_115587 = fluree.db.graphdb.with_t(inst_115577,inst_115584);
var state_115600__$1 = state_115600;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_115600__$1,(13),inst_115587);
} else {
if((state_val_115601 === (8))){
var inst_115578 = (state_115600[(10)]);
var inst_115584 = (state_115600[(12)]);
var inst_115583 = cljs.core.seq(inst_115578);
var inst_115584__$1 = cljs.core.first(inst_115583);
var inst_115585 = cljs.core.next(inst_115583);
var state_115600__$1 = (function (){var statearr_115615 = state_115600;
(statearr_115615[(11)] = inst_115585);

(statearr_115615[(12)] = inst_115584__$1);

return statearr_115615;
})();
if(cljs.core.truth_(inst_115584__$1)){
var statearr_115616_115633 = state_115600__$1;
(statearr_115616_115633[(1)] = (10));

} else {
var statearr_115617_115634 = state_115600__$1;
(statearr_115617_115634[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto__ = null;
var fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto____0 = (function (){
var statearr_115618 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_115618[(0)] = fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto__);

(statearr_115618[(1)] = (1));

return statearr_115618;
});
var fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto____1 = (function (state_115600){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_115600);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e115619){if((e115619 instanceof Object)){
var ex__99706__auto__ = e115619;
var statearr_115620_115635 = state_115600;
(statearr_115620_115635[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_115600);

return cljs.core.cst$kw$recur;
} else {
throw e115619;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__115636 = state_115600;
state_115600 = G__115636;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto__ = function(state_115600){
switch(arguments.length){
case 0:
return fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto____1.call(this,state_115600);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto____0;
fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto____1;
return fluree$db$graphdb$forward_time_travel_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_115621 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_115621[(6)] = c__99809__auto__);

return statearr_115621;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns subject ID of ident as async promise channel.
 *   Closes channel (nil) if doesn't exist, or if strict? is true, will return exception.
 */
fluree.db.graphdb.subid = (function fluree$db$graphdb$subid(db,ident,strict_QMARK_){
var return_chan = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__99809__auto___115805 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___115805,return_chan){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___115805,return_chan){
return (function (state_115748){
var state_val_115749 = (state_115748[(1)]);
if((state_val_115749 === (7))){
var inst_115719 = (state_115748[(7)]);
var inst_115719__$1 = (state_115748[(2)]);
var state_115748__$1 = (function (){var statearr_115750 = state_115748;
(statearr_115750[(7)] = inst_115719__$1);

return statearr_115750;
})();
if(cljs.core.truth_(inst_115719__$1)){
var statearr_115751_115806 = state_115748__$1;
(statearr_115751_115806[(1)] = (28));

} else {
var statearr_115752_115807 = state_115748__$1;
(statearr_115752_115807[(1)] = (29));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (20))){
var inst_115689 = (state_115748[(8)]);
var inst_115693 = cljs.core.first(inst_115689);
var state_115748__$1 = state_115748;
var statearr_115753_115808 = state_115748__$1;
(statearr_115753_115808[(2)] = inst_115693);

(statearr_115753_115808[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (27))){
var inst_115713 = (state_115748[(2)]);
var state_115748__$1 = state_115748;
var statearr_115754_115809 = state_115748__$1;
(statearr_115754_115809[(2)] = inst_115713);

(statearr_115754_115809[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (1))){
var state_115748__$1 = state_115748;
var statearr_115755_115810 = state_115748__$1;
(statearr_115755_115810[(2)] = null);

(statearr_115755_115810[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (24))){
var inst_115701 = (state_115748[(2)]);
var state_115748__$1 = state_115748;
var statearr_115756_115811 = state_115748__$1;
(statearr_115756_115811[(2)] = inst_115701);

(statearr_115756_115811[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (39))){
var inst_115740 = (state_115748[(2)]);
var state_115748__$1 = state_115748;
var statearr_115757_115812 = state_115748__$1;
(statearr_115757_115812[(2)] = inst_115740);

(statearr_115757_115812[(1)] = (36));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_115748,(3),cljs.core.cst$kw$default,null,(2));
var inst_115647 = typeof ident === 'number';
var state_115748__$1 = state_115748;
if(cljs.core.truth_(inst_115647)){
var statearr_115758_115813 = state_115748__$1;
(statearr_115758_115813[(1)] = (5));

} else {
var statearr_115759_115814 = state_115748__$1;
(statearr_115759_115814[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (15))){
var inst_115680 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115681 = cljs.core.first(ident);
var inst_115682 = fluree.db.dbproto._p_prop(db,cljs.core.cst$kw$id,inst_115681);
var inst_115683 = cljs.core.second(ident);
var inst_115684 = [inst_115682,inst_115683];
var inst_115685 = (new cljs.core.PersistentVector(null,2,(5),inst_115680,inst_115684,null));
var inst_115686 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(db,cljs.core.cst$kw$post,cljs.core._EQ_,inst_115685);
var state_115748__$1 = state_115748;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_115748__$1,(18),inst_115686);
} else {
if((state_val_115749 === (21))){
var inst_115695 = (state_115748[(9)]);
var inst_115695__$1 = (state_115748[(2)]);
var inst_115696 = (inst_115695__$1 == null);
var state_115748__$1 = (function (){var statearr_115760 = state_115748;
(statearr_115760[(9)] = inst_115695__$1);

return statearr_115760;
})();
if(cljs.core.truth_(inst_115696)){
var statearr_115761_115815 = state_115748__$1;
(statearr_115761_115815[(1)] = (22));

} else {
var statearr_115762_115816 = state_115748__$1;
(statearr_115762_115816[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (31))){
var state_115748__$1 = state_115748;
var statearr_115763_115817 = state_115748__$1;
(statearr_115763_115817[(2)] = strict_QMARK_);

(statearr_115763_115817[(1)] = (33));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (32))){
var inst_115723 = (state_115748[(10)]);
var state_115748__$1 = state_115748;
var statearr_115764_115818 = state_115748__$1;
(statearr_115764_115818[(2)] = inst_115723);

(statearr_115764_115818[(1)] = (33));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (33))){
var inst_115727 = (state_115748[(2)]);
var state_115748__$1 = state_115748;
if(cljs.core.truth_(inst_115727)){
var statearr_115765_115819 = state_115748__$1;
(statearr_115765_115819[(1)] = (34));

} else {
var statearr_115766_115820 = state_115748__$1;
(statearr_115766_115820[(1)] = (35));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (13))){
var inst_115677 = fluree.db.util.core.pred_ident_QMARK_(ident);
var state_115748__$1 = state_115748;
if(inst_115677){
var statearr_115767_115821 = state_115748__$1;
(statearr_115767_115821[(1)] = (15));

} else {
var statearr_115768_115822 = state_115748__$1;
(statearr_115768_115822[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (22))){
var state_115748__$1 = state_115748;
var statearr_115769_115823 = state_115748__$1;
(statearr_115769_115823[(2)] = null);

(statearr_115769_115823[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (36))){
var inst_115742 = (state_115748[(2)]);
var state_115748__$1 = state_115748;
var statearr_115770_115824 = state_115748__$1;
(statearr_115770_115824[(2)] = inst_115742);

(statearr_115770_115824[(1)] = (30));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (29))){
var inst_115719 = (state_115748[(7)]);
var inst_115723 = (state_115748[(10)]);
var inst_115723__$1 = (inst_115719 == null);
var state_115748__$1 = (function (){var statearr_115771 = state_115748;
(statearr_115771[(10)] = inst_115723__$1);

return statearr_115771;
})();
if(cljs.core.truth_(inst_115723__$1)){
var statearr_115772_115825 = state_115748__$1;
(statearr_115772_115825[(1)] = (31));

} else {
var statearr_115773_115826 = state_115748__$1;
(statearr_115773_115826[(1)] = (32));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (6))){
var inst_115662 = fluree.db.util.core.pred_ident_QMARK_(ident);
var inst_115663 = cljs.core.first(ident);
var inst_115664 = fluree.db.dbproto._p_prop(db,cljs.core.cst$kw$id,inst_115663);
var inst_115665 = (inst_115664 == null);
var inst_115666 = ((inst_115662) && (inst_115665));
var state_115748__$1 = state_115748;
if(cljs.core.truth_(inst_115666)){
var statearr_115774_115827 = state_115748__$1;
(statearr_115774_115827[(1)] = (12));

} else {
var statearr_115775_115828 = state_115748__$1;
(statearr_115775_115828[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (28))){
var inst_115719 = (state_115748[(7)]);
var inst_115721 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(return_chan,inst_115719);
var state_115748__$1 = state_115748;
var statearr_115776_115829 = state_115748__$1;
(statearr_115776_115829[(2)] = inst_115721);

(statearr_115776_115829[(1)] = (30));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (25))){
var inst_115704 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([ident], 0));
var inst_115705 = ["Entid lookup must be a number or valid two-tuple identity: ",inst_115704].join('');
var inst_115706 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_115707 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_ident];
var inst_115708 = cljs.core.PersistentHashMap.fromArrays(inst_115706,inst_115707);
var inst_115709 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_115705,inst_115708);
var inst_115710 = (function(){throw inst_115709})();
var state_115748__$1 = state_115748;
var statearr_115777_115830 = state_115748__$1;
(statearr_115777_115830[(2)] = inst_115710);

(statearr_115777_115830[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (34))){
var inst_115729 = ["Subject identity does not exist: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ident)].join('');
var inst_115730 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_115731 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_subject];
var inst_115732 = cljs.core.PersistentHashMap.fromArrays(inst_115730,inst_115731);
var inst_115733 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_115729,inst_115732);
var inst_115734 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(return_chan,inst_115733);
var state_115748__$1 = state_115748;
var statearr_115778_115831 = state_115748__$1;
(statearr_115778_115831[(2)] = inst_115734);

(statearr_115778_115831[(1)] = (36));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (17))){
var inst_115715 = (state_115748[(2)]);
var state_115748__$1 = state_115748;
var statearr_115779_115832 = state_115748__$1;
(statearr_115779_115832[(2)] = inst_115715);

(statearr_115779_115832[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (3))){
var inst_115637 = (state_115748[(2)]);
var inst_115638 = ["Error looking up subject id: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ident)].join('');
var inst_115639 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_115640 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_subject];
var inst_115641 = cljs.core.PersistentHashMap.fromArrays(inst_115639,inst_115640);
var inst_115642 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$3(inst_115638,inst_115641,inst_115637);
var inst_115643 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(return_chan,inst_115642);
var state_115748__$1 = state_115748;
var statearr_115780_115833 = state_115748__$1;
(statearr_115780_115833[(2)] = inst_115643);


cljs.core.async.impl.ioc_helpers.process_exception(state_115748__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (12))){
var inst_115668 = cljs.core.first(ident);
var inst_115669 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_115668], 0));
var inst_115670 = ["Subject ID lookup failed. The predicate ",inst_115669," does not exist."].join('');
var inst_115671 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_115672 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_ident];
var inst_115673 = cljs.core.PersistentHashMap.fromArrays(inst_115671,inst_115672);
var inst_115674 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_115670,inst_115673);
var inst_115675 = (function(){throw inst_115674})();
var state_115748__$1 = state_115748;
var statearr_115781_115834 = state_115748__$1;
(statearr_115781_115834[(2)] = inst_115675);

(statearr_115781_115834[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (2))){
var inst_115746 = (state_115748[(2)]);
var state_115748__$1 = state_115748;
return cljs.core.async.impl.ioc_helpers.return_chan(state_115748__$1,inst_115746);
} else {
if((state_val_115749 === (23))){
var inst_115695 = (state_115748[(9)]);
var inst_115699 = inst_115695.s;
var state_115748__$1 = state_115748;
var statearr_115782_115835 = state_115748__$1;
(statearr_115782_115835[(2)] = inst_115699);

(statearr_115782_115835[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (35))){
var state_115748__$1 = state_115748;
var statearr_115783_115836 = state_115748__$1;
(statearr_115783_115836[(1)] = (37));



return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (19))){
var state_115748__$1 = state_115748;
var statearr_115785_115837 = state_115748__$1;
(statearr_115785_115837[(2)] = null);

(statearr_115785_115837[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (11))){
var inst_115660 = (state_115748[(2)]);
var state_115748__$1 = state_115748;
var statearr_115786_115838 = state_115748__$1;
(statearr_115786_115838[(2)] = inst_115660);

(statearr_115786_115838[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (9))){
var state_115748__$1 = state_115748;
var statearr_115787_115839 = state_115748__$1;
(statearr_115787_115839[(2)] = ident);

(statearr_115787_115839[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (5))){
var inst_115649 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115650 = [ident];
var inst_115651 = (new cljs.core.PersistentVector(null,1,(5),inst_115649,inst_115650,null));
var inst_115652 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(db,cljs.core.cst$kw$spot,cljs.core._EQ_,inst_115651);
var state_115748__$1 = state_115748;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_115748__$1,(8),inst_115652);
} else {
if((state_val_115749 === (14))){
var inst_115717 = (state_115748[(2)]);
var state_115748__$1 = state_115748;
var statearr_115788_115840 = state_115748__$1;
(statearr_115788_115840[(2)] = inst_115717);

(statearr_115788_115840[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (26))){
var state_115748__$1 = state_115748;
var statearr_115789_115841 = state_115748__$1;
(statearr_115789_115841[(2)] = null);

(statearr_115789_115841[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (16))){
var state_115748__$1 = state_115748;
var statearr_115790_115842 = state_115748__$1;
(statearr_115790_115842[(1)] = (25));



return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (38))){
var state_115748__$1 = state_115748;
var statearr_115792_115843 = state_115748__$1;
(statearr_115792_115843[(2)] = null);

(statearr_115792_115843[(1)] = (39));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (30))){
var inst_115744 = (state_115748[(2)]);
var state_115748__$1 = state_115748;
var statearr_115793_115844 = state_115748__$1;
(statearr_115793_115844[(2)] = inst_115744);


cljs.core.async.impl.ioc_helpers.process_exception(state_115748__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (10))){
var state_115748__$1 = state_115748;
var statearr_115794_115845 = state_115748__$1;
(statearr_115794_115845[(2)] = null);

(statearr_115794_115845[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (18))){
var inst_115689 = (state_115748[(8)]);
var inst_115688 = (state_115748[(2)]);
var inst_115689__$1 = fluree.db.util.async.throw_err(inst_115688);
var inst_115690 = (inst_115689__$1 == null);
var state_115748__$1 = (function (){var statearr_115795 = state_115748;
(statearr_115795[(8)] = inst_115689__$1);

return statearr_115795;
})();
if(cljs.core.truth_(inst_115690)){
var statearr_115796_115846 = state_115748__$1;
(statearr_115796_115846[(1)] = (19));

} else {
var statearr_115797_115847 = state_115748__$1;
(statearr_115797_115847[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (37))){
var inst_115737 = cljs.core.async.close_BANG_(return_chan);
var state_115748__$1 = state_115748;
var statearr_115798_115848 = state_115748__$1;
(statearr_115798_115848[(2)] = inst_115737);

(statearr_115798_115848[(1)] = (39));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115749 === (8))){
var inst_115654 = (state_115748[(2)]);
var inst_115655 = fluree.db.util.async.throw_err(inst_115654);
var inst_115656 = cljs.core.not_empty(inst_115655);
var state_115748__$1 = state_115748;
if(cljs.core.truth_(inst_115656)){
var statearr_115799_115849 = state_115748__$1;
(statearr_115799_115849[(1)] = (9));

} else {
var statearr_115800_115850 = state_115748__$1;
(statearr_115800_115850[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___115805,return_chan))
;
return ((function (switch__99702__auto__,c__99809__auto___115805,return_chan){
return (function() {
var fluree$db$graphdb$subid_$_state_machine__99703__auto__ = null;
var fluree$db$graphdb$subid_$_state_machine__99703__auto____0 = (function (){
var statearr_115801 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_115801[(0)] = fluree$db$graphdb$subid_$_state_machine__99703__auto__);

(statearr_115801[(1)] = (1));

return statearr_115801;
});
var fluree$db$graphdb$subid_$_state_machine__99703__auto____1 = (function (state_115748){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_115748);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e115802){if((e115802 instanceof Object)){
var ex__99706__auto__ = e115802;
var statearr_115803_115851 = state_115748;
(statearr_115803_115851[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_115748);

return cljs.core.cst$kw$recur;
} else {
throw e115802;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__115852 = state_115748;
state_115748 = G__115852;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$graphdb$subid_$_state_machine__99703__auto__ = function(state_115748){
switch(arguments.length){
case 0:
return fluree$db$graphdb$subid_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$graphdb$subid_$_state_machine__99703__auto____1.call(this,state_115748);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$subid_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$subid_$_state_machine__99703__auto____0;
fluree$db$graphdb$subid_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$subid_$_state_machine__99703__auto____1;
return fluree$db$graphdb$subid_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___115805,return_chan))
})();
var state__99811__auto__ = (function (){var statearr_115804 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_115804[(6)] = c__99809__auto___115805);

return statearr_115804;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___115805,return_chan))
);


return return_chan;
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {fluree.db.dbproto.IFlureeDb}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.graphdb.GraphDb = (function (conn,network,dbid,block,t,tt_id,stats,spot,psot,post,opst,schema,settings,index_configs,schema_cache,novelty,permissions,fork,fork_block,current_db_fn,__meta,__extmap,__hash){
this.conn = conn;
this.network = network;
this.dbid = dbid;
this.block = block;
this.t = t;
this.tt_id = tt_id;
this.stats = stats;
this.spot = spot;
this.psot = psot;
this.post = post;
this.opst = opst;
this.schema = schema;
this.settings = settings;
this.index_configs = index_configs;
this.schema_cache = schema_cache;
this.novelty = novelty;
this.permissions = permissions;
this.fork = fork;
this.fork_block = fork_block;
this.current_db_fn = current_db_fn;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.graphdb.GraphDb.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k115854,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__115858 = k115854;
var G__115858__$1 = (((G__115858 instanceof cljs.core.Keyword))?G__115858.fqn:null);
switch (G__115858__$1) {
case "conn":
return self__.conn;

break;
case "network":
return self__.network;

break;
case "dbid":
return self__.dbid;

break;
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "tt-id":
return self__.tt_id;

break;
case "stats":
return self__.stats;

break;
case "spot":
return self__.spot;

break;
case "psot":
return self__.psot;

break;
case "post":
return self__.post;

break;
case "opst":
return self__.opst;

break;
case "schema":
return self__.schema;

break;
case "settings":
return self__.settings;

break;
case "index-configs":
return self__.index_configs;

break;
case "schema-cache":
return self__.schema_cache;

break;
case "novelty":
return self__.novelty;

break;
case "permissions":
return self__.permissions;

break;
case "fork":
return self__.fork;

break;
case "fork-block":
return self__.fork_block;

break;
case "current-db-fn":
return self__.current_db_fn;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k115854,else__4388__auto__);

}
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__115859){
var vec__115860 = p__115859;
var k__4408__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__115860,(0),null);
var v__4409__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__115860,(1),null);
return (f__4405__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4405__auto__.cljs$core$IFn$_invoke$arity$3(ret__4407__auto__,k__4408__auto__,v__4409__auto__) : f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__));
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer(writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer(writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.graphdb.GraphDb{",", ","}",opts__4401__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 20, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$conn,self__.conn],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$network,self__.network],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$dbid,self__.dbid],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$block,self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$t,self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$tt_DASH_id,self__.tt_id],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$stats,self__.stats],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$spot,self__.spot],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$psot,self__.psot],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$post,self__.post],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$opst,self__.opst],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$schema,self__.schema],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$settings,self__.settings],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$index_DASH_configs,self__.index_configs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$schema_DASH_cache,self__.schema_cache],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$novelty,self__.novelty],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$permissions,self__.permissions],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$fork,self__.fork],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$fork_DASH_block,self__.fork_block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$current_DASH_db_DASH_fn,self__.current_db_fn],null))], null),self__.__extmap));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__115853){
var self__ = this;
var G__115853__$1 = this;
return (new cljs.core.RecordIter((0),G__115853__$1,20,new cljs.core.PersistentVector(null, 20, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$conn,cljs.core.cst$kw$network,cljs.core.cst$kw$dbid,cljs.core.cst$kw$block,cljs.core.cst$kw$t,cljs.core.cst$kw$tt_DASH_id,cljs.core.cst$kw$stats,cljs.core.cst$kw$spot,cljs.core.cst$kw$psot,cljs.core.cst$kw$post,cljs.core.cst$kw$opst,cljs.core.cst$kw$schema,cljs.core.cst$kw$settings,cljs.core.cst$kw$index_DASH_configs,cljs.core.cst$kw$schema_DASH_cache,cljs.core.cst$kw$novelty,cljs.core.cst$kw$permissions,cljs.core.cst$kw$fork,cljs.core.cst$kw$fork_DASH_block,cljs.core.cst$kw$current_DASH_db_DASH_fn], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (20 + cljs.core.count(self__.__extmap));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = (function (){var fexpr__115863 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (485580545 ^ cljs.core.hash_unordered_coll(coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
;
return fexpr__115863(this__4381__auto____$1);
})();
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this115855,other115856){
var self__ = this;
var this115855__$1 = this;
return (((!((other115856 == null)))) && ((this115855__$1.constructor === other115856.constructor)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.conn,other115856.conn)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.network,other115856.network)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.dbid,other115856.dbid)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.block,other115856.block)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.t,other115856.t)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.tt_id,other115856.tt_id)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.stats,other115856.stats)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.spot,other115856.spot)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.psot,other115856.psot)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.post,other115856.post)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.opst,other115856.opst)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.schema,other115856.schema)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.settings,other115856.settings)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.index_configs,other115856.index_configs)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.schema_cache,other115856.schema_cache)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.novelty,other115856.novelty)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.permissions,other115856.permissions)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.fork,other115856.fork)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.fork_block,other115856.fork_block)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.current_db_fn,other115856.current_db_fn)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this115855__$1.__extmap,other115856.__extmap)));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 20, [cljs.core.cst$kw$current_DASH_db_DASH_fn,null,cljs.core.cst$kw$schema,null,cljs.core.cst$kw$block,null,cljs.core.cst$kw$psot,null,cljs.core.cst$kw$permissions,null,cljs.core.cst$kw$dbid,null,cljs.core.cst$kw$settings,null,cljs.core.cst$kw$index_DASH_configs,null,cljs.core.cst$kw$opst,null,cljs.core.cst$kw$fork_DASH_block,null,cljs.core.cst$kw$schema_DASH_cache,null,cljs.core.cst$kw$post,null,cljs.core.cst$kw$novelty,null,cljs.core.cst$kw$t,null,cljs.core.cst$kw$network,null,cljs.core.cst$kw$fork,null,cljs.core.cst$kw$tt_DASH_id,null,cljs.core.cst$kw$stats,null,cljs.core.cst$kw$spot,null,cljs.core.cst$kw$conn,null], null), null),k__4395__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__115853){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__115864 = cljs.core.keyword_identical_QMARK_;
var expr__115865 = k__4393__auto__;
if(cljs.core.truth_((function (){var G__115867 = cljs.core.cst$kw$conn;
var G__115868 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115867,G__115868) : pred__115864.call(null,G__115867,G__115868));
})())){
return (new fluree.db.graphdb.GraphDb(G__115853,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115869 = cljs.core.cst$kw$network;
var G__115870 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115869,G__115870) : pred__115864.call(null,G__115869,G__115870));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,G__115853,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115871 = cljs.core.cst$kw$dbid;
var G__115872 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115871,G__115872) : pred__115864.call(null,G__115871,G__115872));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,G__115853,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115873 = cljs.core.cst$kw$block;
var G__115874 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115873,G__115874) : pred__115864.call(null,G__115873,G__115874));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,G__115853,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115875 = cljs.core.cst$kw$t;
var G__115876 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115875,G__115876) : pred__115864.call(null,G__115875,G__115876));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,G__115853,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115877 = cljs.core.cst$kw$tt_DASH_id;
var G__115878 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115877,G__115878) : pred__115864.call(null,G__115877,G__115878));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,G__115853,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115879 = cljs.core.cst$kw$stats;
var G__115880 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115879,G__115880) : pred__115864.call(null,G__115879,G__115880));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,G__115853,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115881 = cljs.core.cst$kw$spot;
var G__115882 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115881,G__115882) : pred__115864.call(null,G__115881,G__115882));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,G__115853,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115883 = cljs.core.cst$kw$psot;
var G__115884 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115883,G__115884) : pred__115864.call(null,G__115883,G__115884));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,G__115853,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115885 = cljs.core.cst$kw$post;
var G__115886 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115885,G__115886) : pred__115864.call(null,G__115885,G__115886));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,G__115853,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115887 = cljs.core.cst$kw$opst;
var G__115888 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115887,G__115888) : pred__115864.call(null,G__115887,G__115888));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,G__115853,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115889 = cljs.core.cst$kw$schema;
var G__115890 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115889,G__115890) : pred__115864.call(null,G__115889,G__115890));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,G__115853,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115891 = cljs.core.cst$kw$settings;
var G__115892 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115891,G__115892) : pred__115864.call(null,G__115891,G__115892));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,G__115853,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115893 = cljs.core.cst$kw$index_DASH_configs;
var G__115894 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115893,G__115894) : pred__115864.call(null,G__115893,G__115894));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,G__115853,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115895 = cljs.core.cst$kw$schema_DASH_cache;
var G__115896 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115895,G__115896) : pred__115864.call(null,G__115895,G__115896));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,G__115853,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115897 = cljs.core.cst$kw$novelty;
var G__115898 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115897,G__115898) : pred__115864.call(null,G__115897,G__115898));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,G__115853,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115899 = cljs.core.cst$kw$permissions;
var G__115900 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115899,G__115900) : pred__115864.call(null,G__115899,G__115900));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,G__115853,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115901 = cljs.core.cst$kw$fork;
var G__115902 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115901,G__115902) : pred__115864.call(null,G__115901,G__115902));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,G__115853,self__.fork_block,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115903 = cljs.core.cst$kw$fork_DASH_block;
var G__115904 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115903,G__115904) : pred__115864.call(null,G__115903,G__115904));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,G__115853,self__.current_db_fn,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__115905 = cljs.core.cst$kw$current_DASH_db_DASH_fn;
var G__115906 = expr__115865;
return (pred__115864.cljs$core$IFn$_invoke$arity$2 ? pred__115864.cljs$core$IFn$_invoke$arity$2(G__115905,G__115906) : pred__115864.call(null,G__115905,G__115906));
})())){
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,G__115853,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4393__auto__,G__115853),null));
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 20, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(cljs.core.cst$kw$conn,self__.conn,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$network,self__.network,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$dbid,self__.dbid,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$block,self__.block,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$t,self__.t,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$tt_DASH_id,self__.tt_id,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$stats,self__.stats,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$spot,self__.spot,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$psot,self__.psot,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$post,self__.post,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$opst,self__.opst,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$schema,self__.schema,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$settings,self__.settings,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$index_DASH_configs,self__.index_configs,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$schema_DASH_cache,self__.schema_cache,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$novelty,self__.novelty,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$permissions,self__.permissions,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$fork,self__.fork,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$fork_DASH_block,self__.fork_block,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$current_DASH_db_DASH_fn,self__.current_db_fn,null))], null),self__.__extmap));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__115853){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.graphdb.GraphDb(self__.conn,self__.network,self__.dbid,self__.block,self__.t,self__.tt_id,self__.stats,self__.spot,self__.psot,self__.post,self__.opst,self__.schema,self__.settings,self__.index_configs,self__.schema_cache,self__.novelty,self__.permissions,self__.fork,self__.fork_block,self__.current_db_fn,G__115853,self__.__extmap,self__.__hash));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_latest_db$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,this$__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,this$__$1){
return (function (state_115919){
var state_val_115920 = (state_115919[(1)]);
if((state_val_115920 === (1))){
var state_115919__$1 = state_115919;
var statearr_115921_116139 = state_115919__$1;
(statearr_115921_116139[(2)] = null);

(statearr_115921_116139[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115920 === (2))){
var inst_115917 = (state_115919[(2)]);
var state_115919__$1 = state_115919;
return cljs.core.async.impl.ioc_helpers.return_chan(state_115919__$1,inst_115917);
} else {
if((state_val_115920 === (3))){
var inst_115907 = (state_115919[(2)]);
var state_115919__$1 = state_115919;
var statearr_115922_116140 = state_115919__$1;
(statearr_115922_116140[(2)] = inst_115907);


cljs.core.async.impl.ioc_helpers.process_exception(state_115919__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115920 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_115919,(3),Error,null,(2));
var inst_115911 = (self__.current_db_fn.cljs$core$IFn$_invoke$arity$0 ? self__.current_db_fn.cljs$core$IFn$_invoke$arity$0() : self__.current_db_fn.call(null));
var state_115919__$1 = state_115919;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_115919__$1,(5),inst_115911);
} else {
if((state_val_115920 === (5))){
var inst_115913 = (state_115919[(2)]);
var inst_115914 = fluree.db.util.async.throw_err(inst_115913);
var inst_115915 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_115914,cljs.core.cst$kw$permissions,self__.permissions);
var state_115919__$1 = state_115919;
var statearr_115923_116141 = state_115919__$1;
(statearr_115923_116141[(2)] = inst_115915);


cljs.core.async.impl.ioc_helpers.process_exception(state_115919__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__,this$__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,this$__$1){
return (function() {
var fluree$db$graphdb$state_machine__99703__auto__ = null;
var fluree$db$graphdb$state_machine__99703__auto____0 = (function (){
var statearr_115924 = [null,null,null,null,null,null,null];
(statearr_115924[(0)] = fluree$db$graphdb$state_machine__99703__auto__);

(statearr_115924[(1)] = (1));

return statearr_115924;
});
var fluree$db$graphdb$state_machine__99703__auto____1 = (function (state_115919){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_115919);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e115925){if((e115925 instanceof Object)){
var ex__99706__auto__ = e115925;
var statearr_115926_116142 = state_115919;
(statearr_115926_116142[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_115919);

return cljs.core.cst$kw$recur;
} else {
throw e115925;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__116143 = state_115919;
state_115919 = G__116143;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$graphdb$state_machine__99703__auto__ = function(state_115919){
switch(arguments.length){
case 0:
return fluree$db$graphdb$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$graphdb$state_machine__99703__auto____1.call(this,state_115919);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$state_machine__99703__auto____0;
fluree$db$graphdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$state_machine__99703__auto____1;
return fluree$db$graphdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,this$__$1))
})();
var state__99811__auto__ = (function (){var statearr_115927 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_115927[(6)] = c__99809__auto__);

return statearr_115927;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,this$__$1))
);

return c__99809__auto__;
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_add_predicate_to_idx$arity$2 = (function (this$,pred_id){
var self__ = this;
var this$__$1 = this;
return fluree.db.graphdb.add_predicate_to_idx(this$__$1,pred_id);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_c_prop$arity$3 = (function (this$,property,collection){
var self__ = this;
var this$__$1 = this;
if(cljs.core.truth_((function (){var fexpr__115928 = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$name,null,cljs.core.cst$kw$id,null,cljs.core.cst$kw$sid,null], null), null);
return (fexpr__115928.cljs$core$IFn$_invoke$arity$1 ? fexpr__115928.cljs$core$IFn$_invoke$arity$1(property) : fexpr__115928.call(null,property));
})())){
} else {
throw (new Error(["Assert failed: ",["Invalid collection property: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([property], 0))].join(''),"\n","(#{:name :id :sid} property)"].join('')));
}

if(cljs.core.neg_int_QMARK_(collection)){
return cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(self__.schema,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$coll,"_tx",property], null));
} else {
return cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(self__.schema,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$coll,collection,property], null));
}
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_p_prop$arity$3 = (function (this$,property,predicate){
var self__ = this;
var this$__$1 = this;
if(cljs.core.truth_((function (){var fexpr__115929 = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 17, [cljs.core.cst$kw$unique,null,cljs.core.cst$kw$restrictCollection,null,cljs.core.cst$kw$index,null,cljs.core.cst$kw$name,null,cljs.core.cst$kw$noHistory,null,cljs.core.cst$kw$type,null,cljs.core.cst$kw$txSpec,null,cljs.core.cst$kw$component,null,cljs.core.cst$kw$txSpecDoc,null,cljs.core.cst$kw$spec,null,cljs.core.cst$kw$multi,null,cljs.core.cst$kw$id,null,cljs.core.cst$kw$specDoc,null,cljs.core.cst$kw$idx_QMARK_,null,cljs.core.cst$kw$ref_QMARK_,null,cljs.core.cst$kw$upsert,null,cljs.core.cst$kw$restrictTag,null], null), null);
return (fexpr__115929.cljs$core$IFn$_invoke$arity$1 ? fexpr__115929.cljs$core$IFn$_invoke$arity$1(property) : fexpr__115929.call(null,property));
})())){
} else {
throw (new Error(["Assert failed: ",["Invalid predicate property: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([property], 0))].join(''),"\n","(#{:unique :restrictCollection :index :name :noHistory :type :txSpec :component :txSpecDoc :spec :multi :id :specDoc :idx? :ref? :upsert :restrictTag} property)"].join('')));
}

var G__115930 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(self__.schema,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$pred,predicate,property], null));
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$restrictCollection,property)){
return this$__$1.fluree$db$dbproto$IFlureeDb$_c_prop$arity$3(null,cljs.core.cst$kw$id,G__115930);
} else {
return G__115930;
}
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_with$arity$3 = (function (this$,block__$1,flakes){
var self__ = this;
var this$__$1 = this;
return fluree.db.graphdb.with$(this$__$1,block__$1,flakes);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_subid$arity$2 = (function (this$,ident){
var self__ = this;
var this$__$1 = this;
return fluree.db.graphdb.subid(this$__$1,ident,false);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_subid$arity$3 = (function (this$,ident,strict_QMARK_){
var self__ = this;
var this$__$1 = this;
return fluree.db.graphdb.subid(this$__$1,ident,strict_QMARK_);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_search$arity$2 = (function (this$,fparts){
var self__ = this;
var this$__$1 = this;
return fluree.db.query.range.search.cljs$core$IFn$_invoke$arity$2(this$__$1,fparts);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_rootdb$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(this$__$1,cljs.core.cst$kw$permissions,new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$root_QMARK_,true,cljs.core.cst$kw$collection,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$all_QMARK_,true], null),cljs.core.cst$kw$predicate,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$all_QMARK_,true], null)], null));
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_forward_time_travel$arity$2 = (function (db,flakes){
var self__ = this;
var db__$1 = this;
return fluree.db.graphdb.forward_time_travel(db__$1,null,flakes);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_forward_time_travel$arity$3 = (function (db,tt_id__$1,flakes){
var self__ = this;
var db__$1 = this;
return fluree.db.graphdb.forward_time_travel(db__$1,tt_id__$1,flakes);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_query$arity$2 = (function (this$,query_map){
var self__ = this;
var this$__$1 = this;
return fluree.db.query.fql.query.cljs$core$IFn$_invoke$arity$2(this$__$1,query_map);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_query$arity$3 = (function (this$,query_map,opts){
var self__ = this;
var this$__$1 = this;
return fluree.db.query.fql.query.cljs$core$IFn$_invoke$arity$3(this$__$1,query_map,opts);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_with_t$arity$2 = (function (this$,flakes){
var self__ = this;
var this$__$1 = this;
return fluree.db.graphdb.with_t(this$__$1,flakes);
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_tag$arity$2 = (function (this$,tag_id){
var self__ = this;
var this$__$1 = this;
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,this$__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,this$__$1){
return (function (state_115959){
var state_val_115960 = (state_115959[(1)]);
if((state_val_115960 === (7))){
var inst_115943 = (state_115959[(7)]);
var inst_115947 = cljs.core.first(inst_115943);
var state_115959__$1 = state_115959;
var statearr_115961_116144 = state_115959__$1;
(statearr_115961_116144[(2)] = inst_115947);

(statearr_115961_116144[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115960 === (1))){
var state_115959__$1 = state_115959;
var statearr_115962_116145 = state_115959__$1;
(statearr_115962_116145[(2)] = null);

(statearr_115962_116145[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115960 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_115959,(3),Error,null,(2));
var inst_115936 = this$__$1.fluree$db$dbproto$IFlureeDb$_rootdb$arity$1(null);
var inst_115937 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_115938 = [tag_id,(30)];
var inst_115939 = (new cljs.core.PersistentVector(null,2,(5),inst_115937,inst_115938,null));
var inst_115940 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(inst_115936,cljs.core.cst$kw$spot,cljs.core._EQ_,inst_115939);
var state_115959__$1 = state_115959;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_115959__$1,(5),inst_115940);
} else {
if((state_val_115960 === (6))){
var state_115959__$1 = state_115959;
var statearr_115963_116146 = state_115959__$1;
(statearr_115963_116146[(2)] = null);

(statearr_115963_116146[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115960 === (3))){
var inst_115931 = (state_115959[(2)]);
var state_115959__$1 = state_115959;
var statearr_115964_116147 = state_115959__$1;
(statearr_115964_116147[(2)] = inst_115931);


cljs.core.async.impl.ioc_helpers.process_exception(state_115959__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115960 === (2))){
var inst_115957 = (state_115959[(2)]);
var state_115959__$1 = state_115959;
return cljs.core.async.impl.ioc_helpers.return_chan(state_115959__$1,inst_115957);
} else {
if((state_val_115960 === (11))){
var inst_115955 = (state_115959[(2)]);
var state_115959__$1 = state_115959;
var statearr_115965_116148 = state_115959__$1;
(statearr_115965_116148[(2)] = inst_115955);


cljs.core.async.impl.ioc_helpers.process_exception(state_115959__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_115960 === (9))){
var state_115959__$1 = state_115959;
var statearr_115966_116149 = state_115959__$1;
(statearr_115966_116149[(2)] = null);

(statearr_115966_116149[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115960 === (5))){
var inst_115943 = (state_115959[(7)]);
var inst_115942 = (state_115959[(2)]);
var inst_115943__$1 = fluree.db.util.async.throw_err(inst_115942);
var inst_115944 = (inst_115943__$1 == null);
var state_115959__$1 = (function (){var statearr_115967 = state_115959;
(statearr_115967[(7)] = inst_115943__$1);

return statearr_115967;
})();
if(cljs.core.truth_(inst_115944)){
var statearr_115968_116150 = state_115959__$1;
(statearr_115968_116150[(1)] = (6));

} else {
var statearr_115969_116151 = state_115959__$1;
(statearr_115969_116151[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_115960 === (10))){
var inst_115949 = (state_115959[(8)]);
var inst_115953 = inst_115949.o;
var state_115959__$1 = state_115959;
var statearr_115970_116152 = state_115959__$1;
(statearr_115970_116152[(2)] = inst_115953);

(statearr_115970_116152[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_115960 === (8))){
var inst_115949 = (state_115959[(8)]);
var inst_115949__$1 = (state_115959[(2)]);
var inst_115950 = (inst_115949__$1 == null);
var state_115959__$1 = (function (){var statearr_115971 = state_115959;
(statearr_115971[(8)] = inst_115949__$1);

return statearr_115971;
})();
if(cljs.core.truth_(inst_115950)){
var statearr_115972_116153 = state_115959__$1;
(statearr_115972_116153[(1)] = (9));

} else {
var statearr_115973_116154 = state_115959__$1;
(statearr_115973_116154[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,this$__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,this$__$1){
return (function() {
var fluree$db$graphdb$state_machine__99703__auto__ = null;
var fluree$db$graphdb$state_machine__99703__auto____0 = (function (){
var statearr_115974 = [null,null,null,null,null,null,null,null,null];
(statearr_115974[(0)] = fluree$db$graphdb$state_machine__99703__auto__);

(statearr_115974[(1)] = (1));

return statearr_115974;
});
var fluree$db$graphdb$state_machine__99703__auto____1 = (function (state_115959){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_115959);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e115975){if((e115975 instanceof Object)){
var ex__99706__auto__ = e115975;
var statearr_115976_116155 = state_115959;
(statearr_115976_116155[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_115959);

return cljs.core.cst$kw$recur;
} else {
throw e115975;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__116156 = state_115959;
state_115959 = G__116156;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$graphdb$state_machine__99703__auto__ = function(state_115959){
switch(arguments.length){
case 0:
return fluree$db$graphdb$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$graphdb$state_machine__99703__auto____1.call(this,state_115959);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$state_machine__99703__auto____0;
fluree$db$graphdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$state_machine__99703__auto____1;
return fluree$db$graphdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,this$__$1))
})();
var state__99811__auto__ = (function (){var statearr_115977 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_115977[(6)] = c__99809__auto__);

return statearr_115977;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,this$__$1))
);

return c__99809__auto__;
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_tag$arity$3 = (function (this$,tag_id,pred){
var self__ = this;
var this$__$1 = this;
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,this$__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,this$__$1){
return (function (state_116010){
var state_val_116011 = (state_116010[(1)]);
if((state_val_116011 === (7))){
var inst_115987 = (state_116010[(2)]);
var inst_115988 = this$__$1.fluree$db$dbproto$IFlureeDb$_tag$arity$2(null,tag_id);
var state_116010__$1 = (function (){var statearr_116012 = state_116010;
(statearr_116012[(7)] = inst_115987);

return statearr_116012;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116010__$1,(8),inst_115988);
} else {
if((state_val_116011 === (1))){
var state_116010__$1 = state_116010;
var statearr_116013_116157 = state_116010__$1;
(statearr_116013_116157[(2)] = null);

(statearr_116013_116157[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_116010,(3),Error,null,(2));
var inst_115982 = typeof pred === 'string';
var state_116010__$1 = state_116010;
if(cljs.core.truth_(inst_115982)){
var statearr_116014_116158 = state_116010__$1;
(statearr_116014_116158[(1)] = (5));

} else {
var statearr_116015_116159 = state_116010__$1;
(statearr_116015_116159[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (15))){
var inst_115991 = (state_116010[(8)]);
var inst_115999 = clojure.string.split.cljs$core$IFn$_invoke$arity$2(inst_115991,/:/);
var inst_116000 = cljs.core.second(inst_115999);
var state_116010__$1 = state_116010;
var statearr_116016_116160 = state_116010__$1;
(statearr_116016_116160[(2)] = inst_116000);

(statearr_116016_116160[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (13))){
var state_116010__$1 = state_116010;
var statearr_116017_116161 = state_116010__$1;
(statearr_116017_116161[(2)] = null);

(statearr_116017_116161[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (6))){
var inst_115985 = this$__$1.fluree$db$dbproto$IFlureeDb$_p_prop$arity$3(null,cljs.core.cst$kw$name,pred);
var state_116010__$1 = state_116010;
var statearr_116018_116162 = state_116010__$1;
(statearr_116018_116162[(2)] = inst_115985);

(statearr_116018_116162[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (17))){
var inst_116003 = (state_116010[(2)]);
var state_116010__$1 = state_116010;
var statearr_116019_116163 = state_116010__$1;
(statearr_116019_116163[(2)] = inst_116003);

(statearr_116019_116163[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (3))){
var inst_115978 = (state_116010[(2)]);
var state_116010__$1 = state_116010;
var statearr_116020_116164 = state_116010__$1;
(statearr_116020_116164[(2)] = inst_115978);


cljs.core.async.impl.ioc_helpers.process_exception(state_116010__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (12))){
var inst_115991 = (state_116010[(8)]);
var inst_115997 = clojure.string.includes_QMARK_(inst_115991,":");
var state_116010__$1 = state_116010;
if(inst_115997){
var statearr_116021_116165 = state_116010__$1;
(statearr_116021_116165[(1)] = (15));

} else {
var statearr_116022_116166 = state_116010__$1;
(statearr_116022_116166[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (2))){
var inst_116008 = (state_116010[(2)]);
var state_116010__$1 = state_116010;
return cljs.core.async.impl.ioc_helpers.return_chan(state_116010__$1,inst_116008);
} else {
if((state_val_116011 === (11))){
var inst_115995 = (state_116010[(2)]);
var state_116010__$1 = state_116010;
if(cljs.core.truth_(inst_115995)){
var statearr_116023_116167 = state_116010__$1;
(statearr_116023_116167[(1)] = (12));

} else {
var statearr_116024_116168 = state_116010__$1;
(statearr_116024_116168[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (9))){
var inst_115991 = (state_116010[(8)]);
var state_116010__$1 = state_116010;
var statearr_116025_116169 = state_116010__$1;
(statearr_116025_116169[(2)] = inst_115991);

(statearr_116025_116169[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (5))){
var state_116010__$1 = state_116010;
var statearr_116026_116170 = state_116010__$1;
(statearr_116026_116170[(2)] = pred);

(statearr_116026_116170[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (14))){
var inst_116006 = (state_116010[(2)]);
var state_116010__$1 = state_116010;
var statearr_116027_116171 = state_116010__$1;
(statearr_116027_116171[(2)] = inst_116006);


cljs.core.async.impl.ioc_helpers.process_exception(state_116010__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (16))){
var inst_115991 = (state_116010[(8)]);
var state_116010__$1 = state_116010;
var statearr_116028_116172 = state_116010__$1;
(statearr_116028_116172[(2)] = inst_115991);

(statearr_116028_116172[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (10))){
var inst_115987 = (state_116010[(7)]);
var state_116010__$1 = state_116010;
var statearr_116029_116173 = state_116010__$1;
(statearr_116029_116173[(2)] = inst_115987);

(statearr_116029_116173[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116011 === (8))){
var inst_115987 = (state_116010[(7)]);
var inst_115990 = (state_116010[(2)]);
var inst_115991 = fluree.db.util.async.throw_err(inst_115990);
var state_116010__$1 = (function (){var statearr_116030 = state_116010;
(statearr_116030[(8)] = inst_115991);

return statearr_116030;
})();
if(cljs.core.truth_(inst_115987)){
var statearr_116031_116174 = state_116010__$1;
(statearr_116031_116174[(1)] = (9));

} else {
var statearr_116032_116175 = state_116010__$1;
(statearr_116032_116175[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,this$__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,this$__$1){
return (function() {
var fluree$db$graphdb$state_machine__99703__auto__ = null;
var fluree$db$graphdb$state_machine__99703__auto____0 = (function (){
var statearr_116033 = [null,null,null,null,null,null,null,null,null];
(statearr_116033[(0)] = fluree$db$graphdb$state_machine__99703__auto__);

(statearr_116033[(1)] = (1));

return statearr_116033;
});
var fluree$db$graphdb$state_machine__99703__auto____1 = (function (state_116010){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_116010);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e116034){if((e116034 instanceof Object)){
var ex__99706__auto__ = e116034;
var statearr_116035_116176 = state_116010;
(statearr_116035_116176[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_116010);

return cljs.core.cst$kw$recur;
} else {
throw e116034;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__116177 = state_116010;
state_116010 = G__116177;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$graphdb$state_machine__99703__auto__ = function(state_116010){
switch(arguments.length){
case 0:
return fluree$db$graphdb$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$graphdb$state_machine__99703__auto____1.call(this,state_116010);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$state_machine__99703__auto____0;
fluree$db$graphdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$state_machine__99703__auto____1;
return fluree$db$graphdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,this$__$1))
})();
var state__99811__auto__ = (function (){var statearr_116036 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_116036[(6)] = c__99809__auto__);

return statearr_116036;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,this$__$1))
);

return c__99809__auto__;
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_tag_id$arity$2 = (function (this$,tag_name){
var self__ = this;
var this$__$1 = this;
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,this$__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,this$__$1){
return (function (state_116065){
var state_val_116066 = (state_116065[(1)]);
if((state_val_116066 === (7))){
var inst_116049 = (state_116065[(7)]);
var inst_116053 = cljs.core.first(inst_116049);
var state_116065__$1 = state_116065;
var statearr_116067_116178 = state_116065__$1;
(statearr_116067_116178[(2)] = inst_116053);

(statearr_116067_116178[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116066 === (1))){
var state_116065__$1 = state_116065;
var statearr_116068_116179 = state_116065__$1;
(statearr_116068_116179[(2)] = null);

(statearr_116068_116179[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116066 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_116065,(3),Error,null,(2));
var inst_116042 = this$__$1.fluree$db$dbproto$IFlureeDb$_rootdb$arity$1(null);
var inst_116043 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_116044 = [(30),tag_name];
var inst_116045 = (new cljs.core.PersistentVector(null,2,(5),inst_116043,inst_116044,null));
var inst_116046 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(inst_116042,cljs.core.cst$kw$post,cljs.core._EQ_,inst_116045);
var state_116065__$1 = state_116065;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116065__$1,(5),inst_116046);
} else {
if((state_val_116066 === (6))){
var state_116065__$1 = state_116065;
var statearr_116069_116180 = state_116065__$1;
(statearr_116069_116180[(2)] = null);

(statearr_116069_116180[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116066 === (3))){
var inst_116037 = (state_116065[(2)]);
var state_116065__$1 = state_116065;
var statearr_116070_116181 = state_116065__$1;
(statearr_116070_116181[(2)] = inst_116037);


cljs.core.async.impl.ioc_helpers.process_exception(state_116065__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116066 === (2))){
var inst_116063 = (state_116065[(2)]);
var state_116065__$1 = state_116065;
return cljs.core.async.impl.ioc_helpers.return_chan(state_116065__$1,inst_116063);
} else {
if((state_val_116066 === (11))){
var inst_116061 = (state_116065[(2)]);
var state_116065__$1 = state_116065;
var statearr_116071_116182 = state_116065__$1;
(statearr_116071_116182[(2)] = inst_116061);


cljs.core.async.impl.ioc_helpers.process_exception(state_116065__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116066 === (9))){
var state_116065__$1 = state_116065;
var statearr_116072_116183 = state_116065__$1;
(statearr_116072_116183[(2)] = null);

(statearr_116072_116183[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116066 === (5))){
var inst_116049 = (state_116065[(7)]);
var inst_116048 = (state_116065[(2)]);
var inst_116049__$1 = fluree.db.util.async.throw_err(inst_116048);
var inst_116050 = (inst_116049__$1 == null);
var state_116065__$1 = (function (){var statearr_116073 = state_116065;
(statearr_116073[(7)] = inst_116049__$1);

return statearr_116073;
})();
if(cljs.core.truth_(inst_116050)){
var statearr_116074_116184 = state_116065__$1;
(statearr_116074_116184[(1)] = (6));

} else {
var statearr_116075_116185 = state_116065__$1;
(statearr_116075_116185[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116066 === (10))){
var inst_116055 = (state_116065[(8)]);
var inst_116059 = inst_116055.s;
var state_116065__$1 = state_116065;
var statearr_116076_116186 = state_116065__$1;
(statearr_116076_116186[(2)] = inst_116059);

(statearr_116076_116186[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116066 === (8))){
var inst_116055 = (state_116065[(8)]);
var inst_116055__$1 = (state_116065[(2)]);
var inst_116056 = (inst_116055__$1 == null);
var state_116065__$1 = (function (){var statearr_116077 = state_116065;
(statearr_116077[(8)] = inst_116055__$1);

return statearr_116077;
})();
if(cljs.core.truth_(inst_116056)){
var statearr_116078_116187 = state_116065__$1;
(statearr_116078_116187[(1)] = (9));

} else {
var statearr_116079_116188 = state_116065__$1;
(statearr_116079_116188[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,this$__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,this$__$1){
return (function() {
var fluree$db$graphdb$state_machine__99703__auto__ = null;
var fluree$db$graphdb$state_machine__99703__auto____0 = (function (){
var statearr_116080 = [null,null,null,null,null,null,null,null,null];
(statearr_116080[(0)] = fluree$db$graphdb$state_machine__99703__auto__);

(statearr_116080[(1)] = (1));

return statearr_116080;
});
var fluree$db$graphdb$state_machine__99703__auto____1 = (function (state_116065){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_116065);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e116081){if((e116081 instanceof Object)){
var ex__99706__auto__ = e116081;
var statearr_116082_116189 = state_116065;
(statearr_116082_116189[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_116065);

return cljs.core.cst$kw$recur;
} else {
throw e116081;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__116190 = state_116065;
state_116065 = G__116190;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$graphdb$state_machine__99703__auto__ = function(state_116065){
switch(arguments.length){
case 0:
return fluree$db$graphdb$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$graphdb$state_machine__99703__auto____1.call(this,state_116065);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$state_machine__99703__auto____0;
fluree$db$graphdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$state_machine__99703__auto____1;
return fluree$db$graphdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,this$__$1))
})();
var state__99811__auto__ = (function (){var statearr_116083 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_116083[(6)] = c__99809__auto__);

return statearr_116083;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,this$__$1))
);

return c__99809__auto__;
});

fluree.db.graphdb.GraphDb.prototype.fluree$db$dbproto$IFlureeDb$_tag_id$arity$3 = (function (this$,tag_name,pred){
var self__ = this;
var this$__$1 = this;
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,this$__$1){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,this$__$1){
return (function (state_116115){
var state_val_116116 = (state_116115[(1)]);
if((state_val_116116 === (7))){
var inst_116111 = (state_116115[(2)]);
var state_116115__$1 = state_116115;
var statearr_116117_116191 = state_116115__$1;
(statearr_116117_116191[(2)] = inst_116111);


cljs.core.async.impl.ioc_helpers.process_exception(state_116115__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (1))){
var state_116115__$1 = state_116115;
var statearr_116118_116192 = state_116115__$1;
(statearr_116118_116192[(2)] = null);

(statearr_116118_116192[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_116115,(3),Error,null,(2));
var inst_116088 = clojure.string.includes_QMARK_(tag_name,"/");
var state_116115__$1 = state_116115;
if(inst_116088){
var statearr_116119_116193 = state_116115__$1;
(statearr_116119_116193[(1)] = (5));

} else {
var statearr_116120_116194 = state_116115__$1;
(statearr_116120_116194[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (15))){
var inst_116105 = (state_116115[(2)]);
var inst_116106 = fluree.db.util.async.throw_err(inst_116105);
var state_116115__$1 = state_116115;
var statearr_116121_116195 = state_116115__$1;
(statearr_116121_116195[(2)] = inst_116106);

(statearr_116121_116195[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (13))){
var state_116115__$1 = state_116115;
var statearr_116122_116196 = state_116115__$1;
(statearr_116122_116196[(2)] = null);

(statearr_116122_116196[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (6))){
var inst_116095 = typeof pred === 'string';
var state_116115__$1 = state_116115;
if(cljs.core.truth_(inst_116095)){
var statearr_116123_116197 = state_116115__$1;
(statearr_116123_116197[(1)] = (9));

} else {
var statearr_116124_116198 = state_116115__$1;
(statearr_116124_116198[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (3))){
var inst_116084 = (state_116115[(2)]);
var state_116115__$1 = state_116115;
var statearr_116125_116199 = state_116115__$1;
(statearr_116125_116199[(2)] = inst_116084);


cljs.core.async.impl.ioc_helpers.process_exception(state_116115__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (12))){
var inst_116100 = (state_116115[(7)]);
var inst_116102 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_116100),":",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tag_name)].join('');
var inst_116103 = this$__$1.fluree$db$dbproto$IFlureeDb$_tag_id$arity$2(null,inst_116102);
var state_116115__$1 = state_116115;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116115__$1,(15),inst_116103);
} else {
if((state_val_116116 === (2))){
var inst_116113 = (state_116115[(2)]);
var state_116115__$1 = state_116115;
return cljs.core.async.impl.ioc_helpers.return_chan(state_116115__$1,inst_116113);
} else {
if((state_val_116116 === (11))){
var inst_116100 = (state_116115[(7)]);
var inst_116100__$1 = (state_116115[(2)]);
var state_116115__$1 = (function (){var statearr_116126 = state_116115;
(statearr_116126[(7)] = inst_116100__$1);

return statearr_116126;
})();
if(cljs.core.truth_(inst_116100__$1)){
var statearr_116127_116200 = state_116115__$1;
(statearr_116127_116200[(1)] = (12));

} else {
var statearr_116128_116201 = state_116115__$1;
(statearr_116128_116201[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (9))){
var state_116115__$1 = state_116115;
var statearr_116129_116202 = state_116115__$1;
(statearr_116129_116202[(2)] = pred);

(statearr_116129_116202[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (5))){
var inst_116090 = this$__$1.fluree$db$dbproto$IFlureeDb$_tag_id$arity$2(null,tag_name);
var state_116115__$1 = state_116115;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_116115__$1,(8),inst_116090);
} else {
if((state_val_116116 === (14))){
var inst_116109 = (state_116115[(2)]);
var state_116115__$1 = state_116115;
var statearr_116130_116203 = state_116115__$1;
(statearr_116130_116203[(2)] = inst_116109);

(statearr_116130_116203[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (10))){
var inst_116098 = this$__$1.fluree$db$dbproto$IFlureeDb$_p_prop$arity$3(null,cljs.core.cst$kw$name,pred);
var state_116115__$1 = state_116115;
var statearr_116131_116204 = state_116115__$1;
(statearr_116131_116204[(2)] = inst_116098);

(statearr_116131_116204[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_116116 === (8))){
var inst_116092 = (state_116115[(2)]);
var inst_116093 = fluree.db.util.async.throw_err(inst_116092);
var state_116115__$1 = state_116115;
var statearr_116132_116205 = state_116115__$1;
(statearr_116132_116205[(2)] = inst_116093);

(statearr_116132_116205[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,this$__$1))
;
return ((function (switch__99702__auto__,c__99809__auto__,this$__$1){
return (function() {
var fluree$db$graphdb$state_machine__99703__auto__ = null;
var fluree$db$graphdb$state_machine__99703__auto____0 = (function (){
var statearr_116133 = [null,null,null,null,null,null,null,null];
(statearr_116133[(0)] = fluree$db$graphdb$state_machine__99703__auto__);

(statearr_116133[(1)] = (1));

return statearr_116133;
});
var fluree$db$graphdb$state_machine__99703__auto____1 = (function (state_116115){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_116115);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e116134){if((e116134 instanceof Object)){
var ex__99706__auto__ = e116134;
var statearr_116135_116206 = state_116115;
(statearr_116135_116206[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_116115);

return cljs.core.cst$kw$recur;
} else {
throw e116134;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__116207 = state_116115;
state_116115 = G__116207;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$graphdb$state_machine__99703__auto__ = function(state_116115){
switch(arguments.length){
case 0:
return fluree$db$graphdb$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$graphdb$state_machine__99703__auto____1.call(this,state_116115);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$graphdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$graphdb$state_machine__99703__auto____0;
fluree$db$graphdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$graphdb$state_machine__99703__auto____1;
return fluree$db$graphdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,this$__$1))
})();
var state__99811__auto__ = (function (){var statearr_116136 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_116136[(6)] = c__99809__auto__);

return statearr_116136;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,this$__$1))
);

return c__99809__auto__;
});

fluree.db.graphdb.GraphDb.getBasis = (function (){
return new cljs.core.PersistentVector(null, 20, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$conn,cljs.core.cst$sym$network,cljs.core.cst$sym$dbid,cljs.core.cst$sym$block,cljs.core.cst$sym$t,cljs.core.cst$sym$tt_DASH_id,cljs.core.cst$sym$stats,cljs.core.cst$sym$spot,cljs.core.cst$sym$psot,cljs.core.cst$sym$post,cljs.core.cst$sym$opst,cljs.core.cst$sym$schema,cljs.core.cst$sym$settings,cljs.core.cst$sym$index_DASH_configs,cljs.core.cst$sym$schema_DASH_cache,cljs.core.cst$sym$novelty,cljs.core.cst$sym$permissions,cljs.core.cst$sym$fork,cljs.core.cst$sym$fork_DASH_block,cljs.core.cst$sym$current_DASH_db_DASH_fn], null);
});

fluree.db.graphdb.GraphDb.cljs$lang$type = true;

fluree.db.graphdb.GraphDb.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.graphdb/GraphDb",null,(1),null));
});

fluree.db.graphdb.GraphDb.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write(writer__4429__auto__,"fluree.db.graphdb/GraphDb");
});

/**
 * Positional factory function for fluree.db.graphdb/GraphDb.
 */
fluree.db.graphdb.__GT_GraphDb = (function fluree$db$graphdb$__GT_GraphDb(conn,network,dbid,block,t,tt_id,stats,spot,psot,post,opst,schema,settings,index_configs,schema_cache,novelty,permissions,fork,fork_block,current_db_fn){
return (new fluree.db.graphdb.GraphDb(conn,network,dbid,block,t,tt_id,stats,spot,psot,post,opst,schema,settings,index_configs,schema_cache,novelty,permissions,fork,fork_block,current_db_fn,null,null,null));
});

/**
 * Factory function for fluree.db.graphdb/GraphDb, taking a map of keywords to field values.
 */
fluree.db.graphdb.map__GT_GraphDb = (function fluree$db$graphdb$map__GT_GraphDb(G__115857){
var extmap__4424__auto__ = (function (){var G__116137 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__115857,cljs.core.cst$kw$conn,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$network,cljs.core.cst$kw$dbid,cljs.core.cst$kw$block,cljs.core.cst$kw$t,cljs.core.cst$kw$tt_DASH_id,cljs.core.cst$kw$stats,cljs.core.cst$kw$spot,cljs.core.cst$kw$psot,cljs.core.cst$kw$post,cljs.core.cst$kw$opst,cljs.core.cst$kw$schema,cljs.core.cst$kw$settings,cljs.core.cst$kw$index_DASH_configs,cljs.core.cst$kw$schema_DASH_cache,cljs.core.cst$kw$novelty,cljs.core.cst$kw$permissions,cljs.core.cst$kw$fork,cljs.core.cst$kw$fork_DASH_block,cljs.core.cst$kw$current_DASH_db_DASH_fn], 0));
if(cljs.core.record_QMARK_(G__115857)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__116137);
} else {
return G__116137;
}
})();
return (new fluree.db.graphdb.GraphDb(cljs.core.cst$kw$conn.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$tt_DASH_id.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$stats.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$spot.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$psot.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$post.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$opst.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$schema.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$settings.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$index_DASH_configs.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$schema_DASH_cache.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$novelty.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$permissions.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$fork.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$fork_DASH_block.cljs$core$IFn$_invoke$arity$1(G__115857),cljs.core.cst$kw$current_DASH_db_DASH_fn.cljs$core$IFn$_invoke$arity$1(G__115857),null,cljs.core.not_empty(extmap__4424__auto__),null));
});

fluree.db.graphdb.GraphDb.prototype.cljs$core$IPrintWithWriter$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.graphdb.GraphDb.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (db,w,opts){
var db__$1 = this;
cljs.core._write(w,"#FlureeGraphDB ");

return cljs.core._write(w,cljs.core.pr.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.PersistentArrayMap(null, 6, [cljs.core.cst$kw$network,cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(db__$1),cljs.core.cst$kw$dbid,cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(db__$1),cljs.core.cst$kw$block,cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(db__$1),cljs.core.cst$kw$t,cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(db__$1),cljs.core.cst$kw$stats,cljs.core.cst$kw$stats.cljs$core$IFn$_invoke$arity$1(db__$1),cljs.core.cst$kw$permissions,cljs.core.cst$kw$permissions.cljs$core$IFn$_invoke$arity$1(db__$1)], null)], 0)));
});
fluree.db.graphdb.new_novelty_map = (function fluree$db$graphdb$new_novelty_map(index_configs){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (m,idx){
var ss = clojure.data.avl.sorted_set_by(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(index_configs,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [idx,cljs.core.cst$kw$historyComparator], null)));
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(m,idx,ss);
}),new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$size,(0)], null),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$spot,cljs.core.cst$kw$psot,cljs.core.cst$kw$post,cljs.core.cst$kw$opst], null));
});
fluree.db.graphdb.new_empty_index = (function fluree$db$graphdb$new_empty_index(conn,index_configs,network,dbid,idx){
var index_config = cljs.core.get.cljs$core$IFn$_invoke$arity$2(index_configs,idx);
var _ = (cljs.core.truth_(index_config)?null:(function(){throw (new Error(["Assert failed: ",["No index config found for index: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(idx)].join(''),"\n","index-config"].join('')))})());
var comparator = cljs.core.cst$kw$historyComparator.cljs$core$IFn$_invoke$arity$1(index_config);
var ___$1 = (cljs.core.truth_(comparator)?null:(function(){throw (new Error(["Assert failed: ",["No index comparator found for index: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(idx)].join(''),"\n","comparator"].join('')))})());
var first_flake = fluree.db.flake.__GT_Flake(fluree.db.util.core.max_long,(0),fluree.db.util.core.max_long,(0),true,null);
var child_node = fluree.db.storage.core.map__GT_UnresolvedNode(cljs.core.PersistentHashMap.fromArrays([cljs.core.cst$kw$block,cljs.core.cst$kw$dbid,cljs.core.cst$kw$config,cljs.core.cst$kw$leaf,cljs.core.cst$kw$size,cljs.core.cst$kw$leftmost_QMARK_,cljs.core.cst$kw$id,cljs.core.cst$kw$t,cljs.core.cst$kw$network,cljs.core.cst$kw$first,cljs.core.cst$kw$tt_DASH_id,cljs.core.cst$kw$rhs,cljs.core.cst$kw$conn],[(0),dbid,index_config,true,(0),true,cljs.core.cst$kw$empty,(0),network,first_flake,null,null,conn]));
var children = clojure.data.avl.sorted_map_by.cljs$core$IFn$_invoke$arity$variadic(comparator,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([first_flake,child_node], 0));
var idx_node = fluree.db.index.__GT_IndexNode((0),(0),null,children,index_config,true);
return idx_node;
});
fluree.db.graphdb.default_index_configs = new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$spot,fluree.db.index.map__GT_IndexConfig(new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$index_DASH_type,cljs.core.cst$kw$spot,cljs.core.cst$kw$comparator,fluree.db.flake.cmp_flakes_spot,cljs.core.cst$kw$historyComparator,fluree.db.flake.cmp_flakes_spot_novelty], null)),cljs.core.cst$kw$psot,fluree.db.index.map__GT_IndexConfig(new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$index_DASH_type,cljs.core.cst$kw$psot,cljs.core.cst$kw$comparator,fluree.db.flake.cmp_flakes_psot,cljs.core.cst$kw$historyComparator,fluree.db.flake.cmp_flakes_psot_novelty], null)),cljs.core.cst$kw$post,fluree.db.index.map__GT_IndexConfig(new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$index_DASH_type,cljs.core.cst$kw$post,cljs.core.cst$kw$comparator,fluree.db.flake.cmp_flakes_post,cljs.core.cst$kw$historyComparator,fluree.db.flake.cmp_flakes_post_novelty], null)),cljs.core.cst$kw$opst,fluree.db.index.map__GT_IndexConfig(new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$index_DASH_type,cljs.core.cst$kw$opst,cljs.core.cst$kw$comparator,fluree.db.flake.cmp_flakes_opst,cljs.core.cst$kw$historyComparator,fluree.db.flake.cmp_flakes_opst_novelty], null))], null);
fluree.db.graphdb.blank_db = (function fluree$db$graphdb$blank_db(conn,network,dbid,schema_cache,current_db_fn){
if(cljs.core.truth_(conn)){
} else {
throw (new Error(["Assert failed: ","No conn provided when creating new db.","\n","conn"].join('')));
}

if(cljs.core.truth_(network)){
} else {
throw (new Error(["Assert failed: ","No network provided when creating new db.","\n","network"].join('')));
}

if(cljs.core.truth_(dbid)){
} else {
throw (new Error(["Assert failed: ","No dbid provided when creating new db.","\n","dbid"].join('')));
}

var novelty = fluree.db.graphdb.new_novelty_map(fluree.db.graphdb.default_index_configs);
var permissions = new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$collection,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$all_QMARK_,false], null),cljs.core.cst$kw$predicate,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$all_QMARK_,true], null),cljs.core.cst$kw$root_QMARK_,true], null);
var spot = fluree.db.graphdb.new_empty_index(conn,fluree.db.graphdb.default_index_configs,network,dbid,cljs.core.cst$kw$spot);
var psot = fluree.db.graphdb.new_empty_index(conn,fluree.db.graphdb.default_index_configs,network,dbid,cljs.core.cst$kw$psot);
var post = fluree.db.graphdb.new_empty_index(conn,fluree.db.graphdb.default_index_configs,network,dbid,cljs.core.cst$kw$post);
var opst = fluree.db.graphdb.new_empty_index(conn,fluree.db.graphdb.default_index_configs,network,dbid,cljs.core.cst$kw$opst);
var stats = new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$flakes,(0),cljs.core.cst$kw$size,(0),cljs.core.cst$kw$indexed,(0)], null);
var fork = null;
var fork_block = null;
var schema = null;
var settings = null;
return fluree.db.graphdb.__GT_GraphDb(conn,network,dbid,(0),(-1),null,stats,spot,psot,post,opst,schema,settings,fluree.db.graphdb.default_index_configs,schema_cache,novelty,permissions,fork,fork_block,current_db_fn);
});
fluree.db.graphdb.graphdb_QMARK_ = (function fluree$db$graphdb$graphdb_QMARK_(db){
return (db instanceof fluree.db.graphdb.GraphDb);
});
