// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.storage.core');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('fluree.db.serde.protocol');
goog.require('fluree.db.flake');
goog.require('clojure.data.avl');
goog.require('fluree.db.util.log');
goog.require('fluree.db.index');
goog.require('fluree.db.dbproto');
goog.require('cljs.core.async');
goog.require('fluree.db.util.core');
goog.require('fluree.db.query.schema');
/**
 * Returns truthy if the provided key exists in storage.
 */
fluree.db.storage.core.storage_exists_QMARK_ = (function fluree$db$storage$core$storage_exists_QMARK_(conn,key){
var storage_exists_fn = cljs.core.cst$kw$storage_DASH_exists.cljs$core$IFn$_invoke$arity$1(conn);
return (storage_exists_fn.cljs$core$IFn$_invoke$arity$1 ? storage_exists_fn.cljs$core$IFn$_invoke$arity$1(key) : storage_exists_fn.call(null,key));
});
/**
 * Reads raw bytes from storage based on provided key.
 *   Returns core async channel with eventual response
 */
fluree.db.storage.core.storage_read = (function fluree$db$storage$core$storage_read(conn,key){
var storage_read_fn = cljs.core.cst$kw$storage_DASH_read.cljs$core$IFn$_invoke$arity$1(conn);
return (storage_read_fn.cljs$core$IFn$_invoke$arity$1 ? storage_read_fn.cljs$core$IFn$_invoke$arity$1(key) : storage_read_fn.call(null,key));
});
/**
 * Writes raw bytes to storage based with provided key.
 */
fluree.db.storage.core.storage_write = (function fluree$db$storage$core$storage_write(conn,key,val){
var storage_write_fn = cljs.core.cst$kw$storage_DASH_write.cljs$core$IFn$_invoke$arity$1(conn);
return (storage_write_fn.cljs$core$IFn$_invoke$arity$2 ? storage_write_fn.cljs$core$IFn$_invoke$arity$2(key,val) : storage_write_fn.call(null,key,val));
});
/**
 * Returns serializer from connection.
 */
fluree.db.storage.core.serde = (function fluree$db$storage$core$serde(conn){
return cljs.core.cst$kw$serializer.cljs$core$IFn$_invoke$arity$1(conn);
});
fluree.db.storage.core.ledger_root_key = (function fluree$db$storage$core$ledger_root_key(network,ledger_id,block){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"_root_",fluree.db.util.core.zero_pad(block,(15))].join('');
});
fluree.db.storage.core.ledger_garbage_key = (function fluree$db$storage$core$ledger_garbage_key(network,ledger_key,block){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_key),"_garbage_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block)].join('');
});
fluree.db.storage.core.ledger_node_key = (function fluree$db$storage$core$ledger_node_key(network,ledger_id,idx_type,base_id,node_type){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"_",cljs.core.name(idx_type),"_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(base_id),"-",cljs.core.str.cljs$core$IFn$_invoke$arity$1(node_type)].join('');
});
fluree.db.storage.core.ledger_block_key = (function fluree$db$storage$core$ledger_block_key(network,ledger_id,block){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"_",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"_block_",fluree.db.util.core.zero_pad(block,(15))].join('');
});
fluree.db.storage.core.ledger_block_file_path = (function fluree$db$storage$core$ledger_block_file_path(network,ledger_id,block){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ledger_id),"/block/",fluree.db.util.core.zero_pad(block,(15))].join('');
});
/**
 * Returns a core async channel with the requested block.
 */
fluree.db.storage.core.read_block = (function fluree$db$storage$core$read_block(conn,network,ledger_id,block){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_105380){
var state_val_105381 = (state_105380[(1)]);
if((state_val_105381 === (1))){
var state_105380__$1 = state_105380;
var statearr_105382_105394 = state_105380__$1;
(statearr_105382_105394[(2)] = null);

(statearr_105382_105394[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105381 === (2))){
var inst_105378 = (state_105380[(2)]);
var state_105380__$1 = state_105380;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105380__$1,inst_105378);
} else {
if((state_val_105381 === (3))){
var inst_105362 = (state_105380[(2)]);
var state_105380__$1 = state_105380;
var statearr_105383_105395 = state_105380__$1;
(statearr_105383_105395[(2)] = inst_105362);


cljs.core.async.impl.ioc_helpers.process_exception(state_105380__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105381 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105380,(3),Error,null,(2));
var inst_105366 = fluree.db.storage.core.ledger_block_key(network,ledger_id,block);
var inst_105367 = fluree.db.storage.core.storage_read(conn,inst_105366);
var state_105380__$1 = state_105380;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105380__$1,(5),inst_105367);
} else {
if((state_val_105381 === (5))){
var inst_105370 = (state_105380[(7)]);
var inst_105369 = (state_105380[(2)]);
var inst_105370__$1 = fluree.db.util.async.throw_err(inst_105369);
var state_105380__$1 = (function (){var statearr_105384 = state_105380;
(statearr_105384[(7)] = inst_105370__$1);

return statearr_105384;
})();
if(cljs.core.truth_(inst_105370__$1)){
var statearr_105385_105396 = state_105380__$1;
(statearr_105385_105396[(1)] = (6));

} else {
var statearr_105386_105397 = state_105380__$1;
(statearr_105386_105397[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105381 === (6))){
var inst_105370 = (state_105380[(7)]);
var inst_105372 = fluree.db.storage.core.serde(conn);
var inst_105373 = fluree.db.serde.protocol._deserialize_block(inst_105372,inst_105370);
var state_105380__$1 = state_105380;
var statearr_105387_105398 = state_105380__$1;
(statearr_105387_105398[(2)] = inst_105373);

(statearr_105387_105398[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105381 === (7))){
var state_105380__$1 = state_105380;
var statearr_105388_105399 = state_105380__$1;
(statearr_105388_105399[(2)] = null);

(statearr_105388_105399[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105381 === (8))){
var inst_105376 = (state_105380[(2)]);
var state_105380__$1 = state_105380;
var statearr_105389_105400 = state_105380__$1;
(statearr_105389_105400[(2)] = inst_105376);


cljs.core.async.impl.ioc_helpers.process_exception(state_105380__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$read_block_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$read_block_$_state_machine__99703__auto____0 = (function (){
var statearr_105390 = [null,null,null,null,null,null,null,null];
(statearr_105390[(0)] = fluree$db$storage$core$read_block_$_state_machine__99703__auto__);

(statearr_105390[(1)] = (1));

return statearr_105390;
});
var fluree$db$storage$core$read_block_$_state_machine__99703__auto____1 = (function (state_105380){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105380);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105391){if((e105391 instanceof Object)){
var ex__99706__auto__ = e105391;
var statearr_105392_105401 = state_105380;
(statearr_105392_105401[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105380);

return cljs.core.cst$kw$recur;
} else {
throw e105391;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105402 = state_105380;
state_105380 = G__105402;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$read_block_$_state_machine__99703__auto__ = function(state_105380){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_block_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_block_$_state_machine__99703__auto____1.call(this,state_105380);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_block_$_state_machine__99703__auto____0;
fluree$db$storage$core$read_block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_block_$_state_machine__99703__auto____1;
return fluree$db$storage$core$read_block_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105393 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105393[(6)] = c__99809__auto__);

return statearr_105393;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns a core async channel with the requested block.
 */
fluree.db.storage.core.read_block_version = (function fluree$db$storage$core$read_block_version(conn,network,ledger_id,block,version){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_105422){
var state_val_105423 = (state_105422[(1)]);
if((state_val_105423 === (1))){
var state_105422__$1 = state_105422;
var statearr_105424_105436 = state_105422__$1;
(statearr_105424_105436[(2)] = null);

(statearr_105424_105436[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105423 === (2))){
var inst_105420 = (state_105422[(2)]);
var state_105422__$1 = state_105422;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105422__$1,inst_105420);
} else {
if((state_val_105423 === (3))){
var inst_105403 = (state_105422[(2)]);
var state_105422__$1 = state_105422;
var statearr_105425_105437 = state_105422__$1;
(statearr_105425_105437[(2)] = inst_105403);


cljs.core.async.impl.ioc_helpers.process_exception(state_105422__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105423 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105422,(3),Error,null,(2));
var inst_105407 = fluree.db.storage.core.ledger_block_key(network,ledger_id,block);
var inst_105408 = [inst_105407,"--v",cljs.core.str.cljs$core$IFn$_invoke$arity$1(version)].join('');
var inst_105409 = fluree.db.storage.core.storage_read(conn,inst_105408);
var state_105422__$1 = state_105422;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105422__$1,(5),inst_105409);
} else {
if((state_val_105423 === (5))){
var inst_105412 = (state_105422[(7)]);
var inst_105411 = (state_105422[(2)]);
var inst_105412__$1 = fluree.db.util.async.throw_err(inst_105411);
var state_105422__$1 = (function (){var statearr_105426 = state_105422;
(statearr_105426[(7)] = inst_105412__$1);

return statearr_105426;
})();
if(cljs.core.truth_(inst_105412__$1)){
var statearr_105427_105438 = state_105422__$1;
(statearr_105427_105438[(1)] = (6));

} else {
var statearr_105428_105439 = state_105422__$1;
(statearr_105428_105439[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105423 === (6))){
var inst_105412 = (state_105422[(7)]);
var inst_105414 = fluree.db.storage.core.serde(conn);
var inst_105415 = fluree.db.serde.protocol._deserialize_block(inst_105414,inst_105412);
var state_105422__$1 = state_105422;
var statearr_105429_105440 = state_105422__$1;
(statearr_105429_105440[(2)] = inst_105415);

(statearr_105429_105440[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105423 === (7))){
var state_105422__$1 = state_105422;
var statearr_105430_105441 = state_105422__$1;
(statearr_105430_105441[(2)] = null);

(statearr_105430_105441[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105423 === (8))){
var inst_105418 = (state_105422[(2)]);
var state_105422__$1 = state_105422;
var statearr_105431_105442 = state_105422__$1;
(statearr_105431_105442[(2)] = inst_105418);


cljs.core.async.impl.ioc_helpers.process_exception(state_105422__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$read_block_version_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$read_block_version_$_state_machine__99703__auto____0 = (function (){
var statearr_105432 = [null,null,null,null,null,null,null,null];
(statearr_105432[(0)] = fluree$db$storage$core$read_block_version_$_state_machine__99703__auto__);

(statearr_105432[(1)] = (1));

return statearr_105432;
});
var fluree$db$storage$core$read_block_version_$_state_machine__99703__auto____1 = (function (state_105422){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105422);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105433){if((e105433 instanceof Object)){
var ex__99706__auto__ = e105433;
var statearr_105434_105443 = state_105422;
(statearr_105434_105443[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105422);

return cljs.core.cst$kw$recur;
} else {
throw e105433;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105444 = state_105422;
state_105422 = G__105444;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$read_block_version_$_state_machine__99703__auto__ = function(state_105422){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_block_version_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_block_version_$_state_machine__99703__auto____1.call(this,state_105422);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_block_version_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_block_version_$_state_machine__99703__auto____0;
fluree$db$storage$core$read_block_version_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_block_version_$_state_machine__99703__auto____1;
return fluree$db$storage$core$read_block_version_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105435 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105435[(6)] = c__99809__auto__);

return statearr_105435;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Block data should look like:
 * 
 *   {:block  block (long)
 * :flakes flakes
 * :hash hash
 * :sigs sigs
 * :txns   {tid (tx-id, string)  {:cmd    command (JSON string)
 *                                :sig    signature (string}]}
 *   
 */
fluree.db.storage.core.write_block_version = (function fluree$db$storage$core$write_block_version(conn,network,dbid,block_data,version){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_105465){
var state_val_105466 = (state_105465[(1)]);
if((state_val_105466 === (1))){
var state_105465__$1 = state_105465;
var statearr_105467_105474 = state_105465__$1;
(statearr_105467_105474[(2)] = null);

(statearr_105467_105474[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105466 === (2))){
var inst_105463 = (state_105465[(2)]);
var state_105465__$1 = state_105465;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105465__$1,inst_105463);
} else {
if((state_val_105466 === (3))){
var inst_105445 = (state_105465[(2)]);
var state_105465__$1 = state_105465;
var statearr_105468_105475 = state_105465__$1;
(statearr_105468_105475[(2)] = inst_105445);


cljs.core.async.impl.ioc_helpers.process_exception(state_105465__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105466 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105465,(3),Error,null,(2));
var inst_105449 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105450 = [cljs.core.cst$kw$block,cljs.core.cst$kw$t,cljs.core.cst$kw$flakes];
var inst_105451 = (new cljs.core.PersistentVector(null,3,(5),inst_105449,inst_105450,null));
var inst_105452 = cljs.core.select_keys(block_data,inst_105451);
var inst_105453 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(inst_105452);
var inst_105454 = fluree.db.storage.core.ledger_block_key(network,dbid,inst_105453);
var inst_105455 = [inst_105454,"--v",cljs.core.str.cljs$core$IFn$_invoke$arity$1(version)].join('');
var inst_105456 = fluree.db.storage.core.serde(conn);
var inst_105457 = fluree.db.serde.protocol._serialize_block(inst_105456,inst_105452);
var inst_105458 = fluree.db.storage.core.storage_write(conn,inst_105455,inst_105457);
var state_105465__$1 = state_105465;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105465__$1,(5),inst_105458);
} else {
if((state_val_105466 === (5))){
var inst_105460 = (state_105465[(2)]);
var inst_105461 = fluree.db.util.async.throw_err(inst_105460);
var state_105465__$1 = state_105465;
var statearr_105469_105476 = state_105465__$1;
(statearr_105469_105476[(2)] = inst_105461);


cljs.core.async.impl.ioc_helpers.process_exception(state_105465__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$write_block_version_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$write_block_version_$_state_machine__99703__auto____0 = (function (){
var statearr_105470 = [null,null,null,null,null,null,null];
(statearr_105470[(0)] = fluree$db$storage$core$write_block_version_$_state_machine__99703__auto__);

(statearr_105470[(1)] = (1));

return statearr_105470;
});
var fluree$db$storage$core$write_block_version_$_state_machine__99703__auto____1 = (function (state_105465){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105465);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105471){if((e105471 instanceof Object)){
var ex__99706__auto__ = e105471;
var statearr_105472_105477 = state_105465;
(statearr_105472_105477[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105465);

return cljs.core.cst$kw$recur;
} else {
throw e105471;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105478 = state_105465;
state_105465 = G__105478;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$write_block_version_$_state_machine__99703__auto__ = function(state_105465){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_block_version_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_block_version_$_state_machine__99703__auto____1.call(this,state_105465);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_block_version_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_block_version_$_state_machine__99703__auto____0;
fluree$db$storage$core$write_block_version_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_block_version_$_state_machine__99703__auto____1;
return fluree$db$storage$core$write_block_version_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105473 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105473[(6)] = c__99809__auto__);

return statearr_105473;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Block data should look like:
 * 
 *   {:block  block (long)
 * :flakes flakes
 * :hash hash
 * :sigs sigs
 * :txns   {tid (tx-id, string)  {:cmd    command (JSON string)
 *                                :sig    signature (string}]}
 *   
 */
fluree.db.storage.core.write_block = (function fluree$db$storage$core$write_block(conn,network,dbid,block_data){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_105498){
var state_val_105499 = (state_105498[(1)]);
if((state_val_105499 === (1))){
var state_105498__$1 = state_105498;
var statearr_105500_105507 = state_105498__$1;
(statearr_105500_105507[(2)] = null);

(statearr_105500_105507[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105499 === (2))){
var inst_105496 = (state_105498[(2)]);
var state_105498__$1 = state_105498;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105498__$1,inst_105496);
} else {
if((state_val_105499 === (3))){
var inst_105479 = (state_105498[(2)]);
var state_105498__$1 = state_105498;
var statearr_105501_105508 = state_105498__$1;
(statearr_105501_105508[(2)] = inst_105479);


cljs.core.async.impl.ioc_helpers.process_exception(state_105498__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105499 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105498,(3),Error,null,(2));
var inst_105483 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105484 = [cljs.core.cst$kw$block,cljs.core.cst$kw$t,cljs.core.cst$kw$flakes];
var inst_105485 = (new cljs.core.PersistentVector(null,3,(5),inst_105483,inst_105484,null));
var inst_105486 = cljs.core.select_keys(block_data,inst_105485);
var inst_105487 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(inst_105486);
var inst_105488 = fluree.db.storage.core.ledger_block_key(network,dbid,inst_105487);
var inst_105489 = fluree.db.storage.core.serde(conn);
var inst_105490 = fluree.db.serde.protocol._serialize_block(inst_105489,inst_105486);
var inst_105491 = fluree.db.storage.core.storage_write(conn,inst_105488,inst_105490);
var state_105498__$1 = state_105498;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105498__$1,(5),inst_105491);
} else {
if((state_val_105499 === (5))){
var inst_105493 = (state_105498[(2)]);
var inst_105494 = fluree.db.util.async.throw_err(inst_105493);
var state_105498__$1 = state_105498;
var statearr_105502_105509 = state_105498__$1;
(statearr_105502_105509[(2)] = inst_105494);


cljs.core.async.impl.ioc_helpers.process_exception(state_105498__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$write_block_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$write_block_$_state_machine__99703__auto____0 = (function (){
var statearr_105503 = [null,null,null,null,null,null,null];
(statearr_105503[(0)] = fluree$db$storage$core$write_block_$_state_machine__99703__auto__);

(statearr_105503[(1)] = (1));

return statearr_105503;
});
var fluree$db$storage$core$write_block_$_state_machine__99703__auto____1 = (function (state_105498){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105498);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105504){if((e105504 instanceof Object)){
var ex__99706__auto__ = e105504;
var statearr_105505_105510 = state_105498;
(statearr_105505_105510[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105498);

return cljs.core.cst$kw$recur;
} else {
throw e105504;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105511 = state_105498;
state_105498 = G__105511;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$write_block_$_state_machine__99703__auto__ = function(state_105498){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_block_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_block_$_state_machine__99703__auto____1.call(this,state_105498);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_block_$_state_machine__99703__auto____0;
fluree$db$storage$core$write_block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_block_$_state_machine__99703__auto____1;
return fluree$db$storage$core$write_block_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105506 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105506[(6)] = c__99809__auto__);

return statearr_105506;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Given a child, unresolved node, extracts just the data that will go into storage.
 */
fluree.db.storage.core.child_data = (function fluree$db$storage$core$child_data(child){
return cljs.core.select_keys(child,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$id,cljs.core.cst$kw$leaf,cljs.core.cst$kw$first,cljs.core.cst$kw$rhs,cljs.core.cst$kw$size], null));
});
fluree.db.storage.core.write_history = (function fluree$db$storage$core$write_history(conn,history,his_key,next_his_key){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_105528){
var state_val_105529 = (state_105528[(1)]);
if((state_val_105529 === (1))){
var state_105528__$1 = state_105528;
var statearr_105530_105537 = state_105528__$1;
(statearr_105530_105537[(2)] = null);

(statearr_105530_105537[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105529 === (2))){
var inst_105526 = (state_105528[(2)]);
var state_105528__$1 = state_105528;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105528__$1,inst_105526);
} else {
if((state_val_105529 === (3))){
var inst_105512 = (state_105528[(2)]);
var state_105528__$1 = state_105528;
var statearr_105531_105538 = state_105528__$1;
(statearr_105531_105538[(2)] = inst_105512);


cljs.core.async.impl.ioc_helpers.process_exception(state_105528__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105529 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105528,(3),Error,null,(2));
var inst_105516 = [cljs.core.cst$kw$flakes,cljs.core.cst$kw$his];
var inst_105517 = [history,next_his_key];
var inst_105518 = cljs.core.PersistentHashMap.fromArrays(inst_105516,inst_105517);
var inst_105519 = fluree.db.storage.core.serde(conn);
var inst_105520 = fluree.db.serde.protocol._serialize_leaf(inst_105519,inst_105518);
var inst_105521 = fluree.db.storage.core.storage_write(conn,his_key,inst_105520);
var state_105528__$1 = state_105528;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105528__$1,(5),inst_105521);
} else {
if((state_val_105529 === (5))){
var inst_105523 = (state_105528[(2)]);
var inst_105524 = fluree.db.util.async.throw_err(inst_105523);
var state_105528__$1 = state_105528;
var statearr_105532_105539 = state_105528__$1;
(statearr_105532_105539[(2)] = inst_105524);


cljs.core.async.impl.ioc_helpers.process_exception(state_105528__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$write_history_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$write_history_$_state_machine__99703__auto____0 = (function (){
var statearr_105533 = [null,null,null,null,null,null,null];
(statearr_105533[(0)] = fluree$db$storage$core$write_history_$_state_machine__99703__auto__);

(statearr_105533[(1)] = (1));

return statearr_105533;
});
var fluree$db$storage$core$write_history_$_state_machine__99703__auto____1 = (function (state_105528){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105528);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105534){if((e105534 instanceof Object)){
var ex__99706__auto__ = e105534;
var statearr_105535_105540 = state_105528;
(statearr_105535_105540[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105528);

return cljs.core.cst$kw$recur;
} else {
throw e105534;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105541 = state_105528;
state_105528 = G__105541;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$write_history_$_state_machine__99703__auto__ = function(state_105528){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_history_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_history_$_state_machine__99703__auto____1.call(this,state_105528);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_history_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_history_$_state_machine__99703__auto____0;
fluree$db$storage$core$write_history_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_history_$_state_machine__99703__auto____1;
return fluree$db$storage$core$write_history_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105536 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105536[(6)] = c__99809__auto__);

return statearr_105536;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Writes a leaf plus its history.
 * 
 *   Writes history first, and only on successful history write then writes leaf.
 * 
 *   Returns leaf's key
 */
fluree.db.storage.core.write_leaf = (function fluree$db$storage$core$write_leaf(conn,network,dbid,idx_type,id,flakes,history){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_105564){
var state_val_105565 = (state_105564[(1)]);
if((state_val_105565 === (1))){
var state_105564__$1 = state_105564;
var statearr_105566_105576 = state_105564__$1;
(statearr_105566_105576[(2)] = null);

(statearr_105566_105576[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105565 === (2))){
var inst_105562 = (state_105564[(2)]);
var state_105564__$1 = state_105564;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105564__$1,inst_105562);
} else {
if((state_val_105565 === (3))){
var inst_105542 = (state_105564[(2)]);
var state_105564__$1 = state_105564;
var statearr_105567_105577 = state_105564__$1;
(statearr_105567_105577[(2)] = inst_105542);


cljs.core.async.impl.ioc_helpers.process_exception(state_105564__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105565 === (4))){
var inst_105546 = (state_105564[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105564,(3),Error,null,(2));
var inst_105546__$1 = fluree.db.storage.core.ledger_node_key(network,dbid,idx_type,id,"l");
var inst_105547 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_105546__$1),"-his"].join('');
var inst_105548 = [cljs.core.cst$kw$flakes,cljs.core.cst$kw$his];
var inst_105549 = [flakes,inst_105547];
var inst_105550 = cljs.core.PersistentHashMap.fromArrays(inst_105548,inst_105549);
var inst_105551 = fluree.db.storage.core.serde(conn);
var inst_105552 = fluree.db.serde.protocol._serialize_leaf(inst_105551,inst_105550);
var inst_105553 = fluree.db.storage.core.write_history(conn,history,inst_105547,null);
var inst_105554 = fluree.db.storage.core.storage_write(conn,inst_105546__$1,inst_105552);
var state_105564__$1 = (function (){var statearr_105568 = state_105564;
(statearr_105568[(7)] = inst_105546__$1);

(statearr_105568[(8)] = inst_105554);

return statearr_105568;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105564__$1,(5),inst_105553);
} else {
if((state_val_105565 === (5))){
var inst_105554 = (state_105564[(8)]);
var inst_105556 = (state_105564[(2)]);
var inst_105557 = fluree.db.util.async.throw_err(inst_105556);
var state_105564__$1 = (function (){var statearr_105569 = state_105564;
(statearr_105569[(9)] = inst_105557);

return statearr_105569;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105564__$1,(6),inst_105554);
} else {
if((state_val_105565 === (6))){
var inst_105546 = (state_105564[(7)]);
var inst_105559 = (state_105564[(2)]);
var inst_105560 = fluree.db.util.async.throw_err(inst_105559);
var state_105564__$1 = (function (){var statearr_105570 = state_105564;
(statearr_105570[(10)] = inst_105560);

return statearr_105570;
})();
var statearr_105571_105578 = state_105564__$1;
(statearr_105571_105578[(2)] = inst_105546);


cljs.core.async.impl.ioc_helpers.process_exception(state_105564__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$write_leaf_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$write_leaf_$_state_machine__99703__auto____0 = (function (){
var statearr_105572 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_105572[(0)] = fluree$db$storage$core$write_leaf_$_state_machine__99703__auto__);

(statearr_105572[(1)] = (1));

return statearr_105572;
});
var fluree$db$storage$core$write_leaf_$_state_machine__99703__auto____1 = (function (state_105564){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105564);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105573){if((e105573 instanceof Object)){
var ex__99706__auto__ = e105573;
var statearr_105574_105579 = state_105564;
(statearr_105574_105579[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105564);

return cljs.core.cst$kw$recur;
} else {
throw e105573;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105580 = state_105564;
state_105564 = G__105580;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$write_leaf_$_state_machine__99703__auto__ = function(state_105564){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_leaf_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_leaf_$_state_machine__99703__auto____1.call(this,state_105564);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_leaf_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_leaf_$_state_machine__99703__auto____0;
fluree$db$storage$core$write_leaf_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_leaf_$_state_machine__99703__auto____1;
return fluree$db$storage$core$write_leaf_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105575 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105575[(6)] = c__99809__auto__);

return statearr_105575;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Serializes final data for branch and writes it to provided key
 */
fluree.db.storage.core.write_branch_data = (function fluree$db$storage$core$write_branch_data(conn,key,data){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_105594){
var state_val_105595 = (state_105594[(1)]);
if((state_val_105595 === (1))){
var state_105594__$1 = state_105594;
var statearr_105596_105604 = state_105594__$1;
(statearr_105596_105604[(2)] = null);

(statearr_105596_105604[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105595 === (2))){
var inst_105592 = (state_105594[(2)]);
var state_105594__$1 = state_105594;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105594__$1,inst_105592);
} else {
if((state_val_105595 === (3))){
var inst_105581 = (state_105594[(2)]);
var state_105594__$1 = state_105594;
var statearr_105597_105605 = state_105594__$1;
(statearr_105597_105605[(2)] = inst_105581);


cljs.core.async.impl.ioc_helpers.process_exception(state_105594__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105595 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105594,(3),Error,null,(2));
var inst_105585 = fluree.db.storage.core.serde(conn);
var inst_105586 = fluree.db.serde.protocol._serialize_branch(inst_105585,data);
var inst_105587 = fluree.db.storage.core.storage_write(conn,key,inst_105586);
var state_105594__$1 = state_105594;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105594__$1,(5),inst_105587);
} else {
if((state_val_105595 === (5))){
var inst_105589 = (state_105594[(2)]);
var inst_105590 = fluree.db.util.async.throw_err(inst_105589);
var state_105594__$1 = (function (){var statearr_105598 = state_105594;
(statearr_105598[(7)] = inst_105590);

return statearr_105598;
})();
var statearr_105599_105606 = state_105594__$1;
(statearr_105599_105606[(2)] = key);


cljs.core.async.impl.ioc_helpers.process_exception(state_105594__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto____0 = (function (){
var statearr_105600 = [null,null,null,null,null,null,null,null];
(statearr_105600[(0)] = fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto__);

(statearr_105600[(1)] = (1));

return statearr_105600;
});
var fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto____1 = (function (state_105594){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105594);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105601){if((e105601 instanceof Object)){
var ex__99706__auto__ = e105601;
var statearr_105602_105607 = state_105594;
(statearr_105602_105607[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105594);

return cljs.core.cst$kw$recur;
} else {
throw e105601;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105608 = state_105594;
state_105594 = G__105608;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto__ = function(state_105594){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto____1.call(this,state_105594);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto____0;
fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto____1;
return fluree$db$storage$core$write_branch_data_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105603 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105603[(6)] = c__99809__auto__);

return statearr_105603;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns core async channel with index key
 */
fluree.db.storage.core.write_branch = (function fluree$db$storage$core$write_branch(conn,network,dbid,idx_type,id,children){
var branch_key = fluree.db.storage.core.ledger_node_key(network,dbid,idx_type,id,"b");
var child_vals = cljs.core.mapv.cljs$core$IFn$_invoke$arity$2(((function (branch_key){
return (function (p1__105609_SHARP_){
return fluree.db.storage.core.child_data(cljs.core.val(p1__105609_SHARP_));
});})(branch_key))
,children);
var rhs = cljs.core.cst$kw$rhs.cljs$core$IFn$_invoke$arity$1(cljs.core.last(child_vals));
var data = new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$children,child_vals,cljs.core.cst$kw$rhs,rhs], null);
return fluree.db.storage.core.write_branch_data(conn,branch_key,data);
});
/**
 * Writes garbage record out for latest index.
 */
fluree.db.storage.core.write_garbage = (function fluree$db$storage$core$write_garbage(db,p__105610){
var map__105611 = p__105610;
var map__105611__$1 = (((((!((map__105611 == null))))?(((((map__105611.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__105611.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__105611):map__105611);
var progress = map__105611__$1;
var garbage = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__105611__$1,cljs.core.cst$kw$garbage);
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,map__105611,map__105611__$1,progress,garbage){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,map__105611,map__105611__$1,progress,garbage){
return (function (state_105656){
var state_val_105657 = (state_105656[(1)]);
if((state_val_105657 === (7))){
var inst_105633 = (state_105656[(2)]);
var state_105656__$1 = state_105656;
if(cljs.core.truth_(inst_105633)){
var statearr_105658_105679 = state_105656__$1;
(statearr_105658_105679[(1)] = (11));

} else {
var statearr_105659_105680 = state_105656__$1;
(statearr_105659_105680[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (1))){
var state_105656__$1 = state_105656;
var statearr_105660_105681 = state_105656__$1;
(statearr_105660_105681[(2)] = null);

(statearr_105660_105681[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105656,(3),Error,null,(2));
var inst_105619 = (db == null);
var inst_105620 = cljs.core.not(inst_105619);
var state_105656__$1 = state_105656;
if(inst_105620){
var statearr_105661_105682 = state_105656__$1;
(statearr_105661_105682[(1)] = (5));

} else {
var statearr_105662_105683 = state_105656__$1;
(statearr_105662_105683[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (13))){
var inst_105643 = (state_105656[(7)]);
var inst_105638 = (state_105656[(2)]);
var inst_105639 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105638,cljs.core.cst$kw$conn);
var inst_105640 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105638,cljs.core.cst$kw$network);
var inst_105641 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105638,cljs.core.cst$kw$dbid);
var inst_105642 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105638,cljs.core.cst$kw$block);
var inst_105643__$1 = fluree.db.storage.core.ledger_garbage_key(inst_105640,inst_105641,inst_105642);
var inst_105644 = [cljs.core.cst$kw$dbid,cljs.core.cst$kw$block,cljs.core.cst$kw$garbage];
var inst_105645 = [inst_105641,inst_105642,garbage];
var inst_105646 = cljs.core.PersistentHashMap.fromArrays(inst_105644,inst_105645);
var inst_105647 = fluree.db.storage.core.serde(inst_105639);
var inst_105648 = fluree.db.serde.protocol._serialize_garbage(inst_105647,inst_105646);
var inst_105649 = fluree.db.storage.core.storage_write(inst_105639,inst_105643__$1,inst_105648);
var state_105656__$1 = (function (){var statearr_105663 = state_105656;
(statearr_105663[(7)] = inst_105643__$1);

return statearr_105663;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105656__$1,(14),inst_105649);
} else {
if((state_val_105657 === (6))){
var state_105656__$1 = state_105656;
var statearr_105664_105684 = state_105656__$1;
(statearr_105664_105684[(2)] = false);

(statearr_105664_105684[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (3))){
var inst_105613 = (state_105656[(2)]);
var state_105656__$1 = state_105656;
var statearr_105665_105685 = state_105656__$1;
(statearr_105665_105685[(2)] = inst_105613);


cljs.core.async.impl.ioc_helpers.process_exception(state_105656__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (12))){
var state_105656__$1 = state_105656;
var statearr_105666_105686 = state_105656__$1;
(statearr_105666_105686[(2)] = db);

(statearr_105666_105686[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (2))){
var inst_105654 = (state_105656[(2)]);
var state_105656__$1 = state_105656;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105656__$1,inst_105654);
} else {
if((state_val_105657 === (11))){
var inst_105635 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,db);
var state_105656__$1 = state_105656;
var statearr_105667_105687 = state_105656__$1;
(statearr_105667_105687[(2)] = inst_105635);

(statearr_105667_105687[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (9))){
var state_105656__$1 = state_105656;
var statearr_105668_105688 = state_105656__$1;
(statearr_105668_105688[(2)] = false);

(statearr_105668_105688[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (5))){
var inst_105622 = db.cljs$lang$protocol_mask$partition0$;
var inst_105623 = (inst_105622 & (64));
var inst_105624 = db.cljs$core$ISeq$;
var inst_105625 = (cljs.core.PROTOCOL_SENTINEL === inst_105624);
var inst_105626 = ((inst_105623) || (inst_105625));
var state_105656__$1 = state_105656;
if(cljs.core.truth_(inst_105626)){
var statearr_105669_105689 = state_105656__$1;
(statearr_105669_105689[(1)] = (8));

} else {
var statearr_105670_105690 = state_105656__$1;
(statearr_105670_105690[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (14))){
var inst_105643 = (state_105656[(7)]);
var inst_105651 = (state_105656[(2)]);
var inst_105652 = fluree.db.util.async.throw_err(inst_105651);
var state_105656__$1 = (function (){var statearr_105671 = state_105656;
(statearr_105671[(8)] = inst_105652);

return statearr_105671;
})();
var statearr_105672_105691 = state_105656__$1;
(statearr_105672_105691[(2)] = inst_105643);


cljs.core.async.impl.ioc_helpers.process_exception(state_105656__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (10))){
var inst_105630 = (state_105656[(2)]);
var state_105656__$1 = state_105656;
var statearr_105673_105692 = state_105656__$1;
(statearr_105673_105692[(2)] = inst_105630);

(statearr_105673_105692[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105657 === (8))){
var state_105656__$1 = state_105656;
var statearr_105674_105693 = state_105656__$1;
(statearr_105674_105693[(2)] = true);

(statearr_105674_105693[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,map__105611,map__105611__$1,progress,garbage))
;
return ((function (switch__99702__auto__,c__99809__auto__,map__105611,map__105611__$1,progress,garbage){
return (function() {
var fluree$db$storage$core$write_garbage_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$write_garbage_$_state_machine__99703__auto____0 = (function (){
var statearr_105675 = [null,null,null,null,null,null,null,null,null];
(statearr_105675[(0)] = fluree$db$storage$core$write_garbage_$_state_machine__99703__auto__);

(statearr_105675[(1)] = (1));

return statearr_105675;
});
var fluree$db$storage$core$write_garbage_$_state_machine__99703__auto____1 = (function (state_105656){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105656);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105676){if((e105676 instanceof Object)){
var ex__99706__auto__ = e105676;
var statearr_105677_105694 = state_105656;
(statearr_105677_105694[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105656);

return cljs.core.cst$kw$recur;
} else {
throw e105676;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105695 = state_105656;
state_105656 = G__105695;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$write_garbage_$_state_machine__99703__auto__ = function(state_105656){
switch(arguments.length){
case 0:
return fluree$db$storage$core$write_garbage_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$write_garbage_$_state_machine__99703__auto____1.call(this,state_105656);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$write_garbage_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$write_garbage_$_state_machine__99703__auto____0;
fluree$db$storage$core$write_garbage_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$write_garbage_$_state_machine__99703__auto____1;
return fluree$db$storage$core$write_garbage_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,map__105611,map__105611__$1,progress,garbage))
})();
var state__99811__auto__ = (function (){var statearr_105678 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105678[(6)] = c__99809__auto__);

return statearr_105678;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,map__105611,map__105611__$1,progress,garbage))
);

return c__99809__auto__;
});
fluree.db.storage.core.write_db_root = (function fluree$db$storage$core$write_db_root(var_args){
var G__105697 = arguments.length;
switch (G__105697) {
case 1:
return fluree.db.storage.core.write_db_root.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return fluree.db.storage.core.write_db_root.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.storage.core.write_db_root.cljs$core$IFn$_invoke$arity$1 = (function (db){
return fluree.db.storage.core.write_db_root.cljs$core$IFn$_invoke$arity$2(db,null);
});

fluree.db.storage.core.write_db_root.cljs$core$IFn$_invoke$arity$2 = (function (db,custom_ecount){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_105768){
var state_val_105769 = (state_105768[(1)]);
if((state_val_105769 === (7))){
var inst_105718 = (state_105768[(2)]);
var state_105768__$1 = state_105768;
if(cljs.core.truth_(inst_105718)){
var statearr_105770_105801 = state_105768__$1;
(statearr_105770_105801[(1)] = (11));

} else {
var statearr_105771_105802 = state_105768__$1;
(statearr_105771_105802[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (20))){
var inst_105737 = (state_105768[(7)]);
var inst_105763 = (state_105768[(2)]);
var inst_105764 = fluree.db.util.async.throw_err(inst_105763);
var state_105768__$1 = (function (){var statearr_105772 = state_105768;
(statearr_105772[(8)] = inst_105764);

return statearr_105772;
})();
var statearr_105773_105803 = state_105768__$1;
(statearr_105773_105803[(2)] = inst_105737);


cljs.core.async.impl.ioc_helpers.process_exception(state_105768__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (1))){
var state_105768__$1 = state_105768;
var statearr_105774_105804 = state_105768__$1;
(statearr_105774_105804[(2)] = null);

(statearr_105774_105804[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105768,(3),Error,null,(2));
var inst_105704 = (db == null);
var inst_105705 = cljs.core.not(inst_105704);
var state_105768__$1 = state_105768;
if(inst_105705){
var statearr_105775_105805 = state_105768__$1;
(statearr_105775_105805[(1)] = (5));

} else {
var statearr_105776_105806 = state_105768__$1;
(statearr_105776_105806[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (15))){
var state_105768__$1 = state_105768;
var statearr_105777_105807 = state_105768__$1;
(statearr_105777_105807[(2)] = (0));

(statearr_105777_105807[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (13))){
var inst_105728 = (state_105768[(9)]);
var inst_105740 = (state_105768[(10)]);
var inst_105732 = (state_105768[(11)]);
var inst_105730 = (state_105768[(12)]);
var inst_105723 = (state_105768[(2)]);
var inst_105724 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$network);
var inst_105725 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$t);
var inst_105726 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$fork);
var inst_105727 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$spot);
var inst_105728__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$stats);
var inst_105729 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$conn);
var inst_105730__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$block);
var inst_105731 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$psot);
var inst_105732__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$dbid);
var inst_105733 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$ecount);
var inst_105734 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$opst);
var inst_105735 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$fork_DASH_block);
var inst_105736 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_105723,cljs.core.cst$kw$post);
var inst_105737 = fluree.db.storage.core.ledger_root_key(inst_105724,inst_105732__$1,inst_105730__$1);
var inst_105738 = [cljs.core.cst$kw$block,cljs.core.cst$kw$psot,cljs.core.cst$kw$dbid,cljs.core.cst$kw$prevIndex,cljs.core.cst$kw$ecount,cljs.core.cst$kw$opst,cljs.core.cst$kw$post,cljs.core.cst$kw$t,cljs.core.cst$kw$timestamp,cljs.core.cst$kw$fork,cljs.core.cst$kw$forkBlock,cljs.core.cst$kw$stats,cljs.core.cst$kw$spot];
var inst_105739 = fluree.db.storage.core.child_data(inst_105731);
var inst_105740__$1 = cljs.core.cst$kw$indexed.cljs$core$IFn$_invoke$arity$1(inst_105728__$1);
var state_105768__$1 = (function (){var statearr_105778 = state_105768;
(statearr_105778[(13)] = inst_105736);

(statearr_105778[(7)] = inst_105737);

(statearr_105778[(14)] = inst_105738);

(statearr_105778[(15)] = inst_105725);

(statearr_105778[(9)] = inst_105728__$1);

(statearr_105778[(16)] = inst_105734);

(statearr_105778[(17)] = inst_105739);

(statearr_105778[(18)] = inst_105735);

(statearr_105778[(10)] = inst_105740__$1);

(statearr_105778[(11)] = inst_105732__$1);

(statearr_105778[(19)] = inst_105726);

(statearr_105778[(12)] = inst_105730__$1);

(statearr_105778[(20)] = inst_105733);

(statearr_105778[(21)] = inst_105729);

(statearr_105778[(22)] = inst_105727);

return statearr_105778;
})();
if(cljs.core.truth_(inst_105740__$1)){
var statearr_105779_105808 = state_105768__$1;
(statearr_105779_105808[(1)] = (14));

} else {
var statearr_105780_105809 = state_105768__$1;
(statearr_105780_105809[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (6))){
var state_105768__$1 = state_105768;
var statearr_105781_105810 = state_105768__$1;
(statearr_105781_105810[(2)] = false);

(statearr_105781_105810[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (17))){
var state_105768__$1 = state_105768;
var statearr_105782_105811 = state_105768__$1;
(statearr_105782_105811[(2)] = custom_ecount);

(statearr_105782_105811[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (3))){
var inst_105698 = (state_105768[(2)]);
var state_105768__$1 = state_105768;
var statearr_105783_105812 = state_105768__$1;
(statearr_105783_105812[(2)] = inst_105698);


cljs.core.async.impl.ioc_helpers.process_exception(state_105768__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (12))){
var state_105768__$1 = state_105768;
var statearr_105784_105813 = state_105768__$1;
(statearr_105784_105813[(2)] = db);

(statearr_105784_105813[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (2))){
var inst_105766 = (state_105768[(2)]);
var state_105768__$1 = state_105768;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105768__$1,inst_105766);
} else {
if((state_val_105769 === (19))){
var inst_105736 = (state_105768[(13)]);
var inst_105737 = (state_105768[(7)]);
var inst_105738 = (state_105768[(14)]);
var inst_105725 = (state_105768[(15)]);
var inst_105728 = (state_105768[(9)]);
var inst_105734 = (state_105768[(16)]);
var inst_105739 = (state_105768[(17)]);
var inst_105744 = (state_105768[(23)]);
var inst_105735 = (state_105768[(18)]);
var inst_105732 = (state_105768[(11)]);
var inst_105726 = (state_105768[(19)]);
var inst_105730 = (state_105768[(12)]);
var inst_105729 = (state_105768[(21)]);
var inst_105727 = (state_105768[(22)]);
var inst_105748 = (state_105768[(2)]);
var inst_105749 = fluree.db.storage.core.child_data(inst_105734);
var inst_105750 = fluree.db.storage.core.child_data(inst_105736);
var inst_105751 = fluree.db.util.core.current_time_millis();
var inst_105752 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_105753 = [cljs.core.cst$kw$flakes,cljs.core.cst$kw$size];
var inst_105754 = (new cljs.core.PersistentVector(null,2,(5),inst_105752,inst_105753,null));
var inst_105755 = cljs.core.select_keys(inst_105728,inst_105754);
var inst_105756 = fluree.db.storage.core.child_data(inst_105727);
var inst_105757 = [inst_105730,inst_105739,inst_105732,inst_105744,inst_105748,inst_105749,inst_105750,inst_105725,inst_105751,inst_105726,inst_105735,inst_105755,inst_105756];
var inst_105758 = cljs.core.PersistentHashMap.fromArrays(inst_105738,inst_105757);
var inst_105759 = fluree.db.storage.core.serde(inst_105729);
var inst_105760 = fluree.db.serde.protocol._serialize_db_root(inst_105759,inst_105758);
var inst_105761 = fluree.db.storage.core.storage_write(inst_105729,inst_105737,inst_105760);
var state_105768__$1 = state_105768;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105768__$1,(20),inst_105761);
} else {
if((state_val_105769 === (11))){
var inst_105720 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,db);
var state_105768__$1 = state_105768;
var statearr_105785_105814 = state_105768__$1;
(statearr_105785_105814[(2)] = inst_105720);

(statearr_105785_105814[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (9))){
var state_105768__$1 = state_105768;
var statearr_105786_105815 = state_105768__$1;
(statearr_105786_105815[(2)] = false);

(statearr_105786_105815[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (5))){
var inst_105707 = db.cljs$lang$protocol_mask$partition0$;
var inst_105708 = (inst_105707 & (64));
var inst_105709 = db.cljs$core$ISeq$;
var inst_105710 = (cljs.core.PROTOCOL_SENTINEL === inst_105709);
var inst_105711 = ((inst_105708) || (inst_105710));
var state_105768__$1 = state_105768;
if(cljs.core.truth_(inst_105711)){
var statearr_105787_105816 = state_105768__$1;
(statearr_105787_105816[(1)] = (8));

} else {
var statearr_105788_105817 = state_105768__$1;
(statearr_105788_105817[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (14))){
var inst_105740 = (state_105768[(10)]);
var state_105768__$1 = state_105768;
var statearr_105789_105818 = state_105768__$1;
(statearr_105789_105818[(2)] = inst_105740);

(statearr_105789_105818[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (16))){
var inst_105744 = (state_105768[(2)]);
var state_105768__$1 = (function (){var statearr_105790 = state_105768;
(statearr_105790[(23)] = inst_105744);

return statearr_105790;
})();
if(cljs.core.truth_(custom_ecount)){
var statearr_105791_105819 = state_105768__$1;
(statearr_105791_105819[(1)] = (17));

} else {
var statearr_105792_105820 = state_105768__$1;
(statearr_105792_105820[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (10))){
var inst_105715 = (state_105768[(2)]);
var state_105768__$1 = state_105768;
var statearr_105793_105821 = state_105768__$1;
(statearr_105793_105821[(2)] = inst_105715);

(statearr_105793_105821[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (18))){
var inst_105733 = (state_105768[(20)]);
var state_105768__$1 = state_105768;
var statearr_105794_105822 = state_105768__$1;
(statearr_105794_105822[(2)] = inst_105733);

(statearr_105794_105822[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105769 === (8))){
var state_105768__$1 = state_105768;
var statearr_105795_105823 = state_105768__$1;
(statearr_105795_105823[(2)] = true);

(statearr_105795_105823[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$state_machine__99703__auto__ = null;
var fluree$db$storage$core$state_machine__99703__auto____0 = (function (){
var statearr_105796 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_105796[(0)] = fluree$db$storage$core$state_machine__99703__auto__);

(statearr_105796[(1)] = (1));

return statearr_105796;
});
var fluree$db$storage$core$state_machine__99703__auto____1 = (function (state_105768){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105768);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105797){if((e105797 instanceof Object)){
var ex__99706__auto__ = e105797;
var statearr_105798_105824 = state_105768;
(statearr_105798_105824[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105768);

return cljs.core.cst$kw$recur;
} else {
throw e105797;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105825 = state_105768;
state_105768 = G__105825;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$state_machine__99703__auto__ = function(state_105768){
switch(arguments.length){
case 0:
return fluree$db$storage$core$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$state_machine__99703__auto____1.call(this,state_105768);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$state_machine__99703__auto____0;
fluree$db$storage$core$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$state_machine__99703__auto____1;
return fluree$db$storage$core$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_105799 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105799[(6)] = c__99809__auto__);

return statearr_105799;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

fluree.db.storage.core.write_db_root.cljs$lang$maxFixedArity = 2;

fluree.db.storage.core.reify_history = (function fluree$db$storage$core$reify_history(conn,key,error_fn){
var return_ch = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__99809__auto___105867 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___105867,return_ch){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___105867,return_ch){
return (function (state_105852){
var state_val_105853 = (state_105852[(1)]);
if((state_val_105853 === (1))){
var state_105852__$1 = state_105852;
var statearr_105854_105868 = state_105852__$1;
(statearr_105854_105868[(2)] = null);

(statearr_105854_105868[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105853 === (2))){
var inst_105850 = (state_105852[(2)]);
var state_105852__$1 = state_105852;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105852__$1,inst_105850);
} else {
if((state_val_105853 === (3))){
var inst_105826 = (state_105852[(2)]);
var inst_105827 = (error_fn.cljs$core$IFn$_invoke$arity$0 ? error_fn.cljs$core$IFn$_invoke$arity$0() : error_fn.call(null));
var inst_105828 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(return_ch,inst_105826);
var inst_105829 = cljs.core.async.close_BANG_(return_ch);
var state_105852__$1 = (function (){var statearr_105855 = state_105852;
(statearr_105855[(7)] = inst_105828);

(statearr_105855[(8)] = inst_105827);

return statearr_105855;
})();
var statearr_105856_105869 = state_105852__$1;
(statearr_105856_105869[(2)] = inst_105829);


cljs.core.async.impl.ioc_helpers.process_exception(state_105852__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105853 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105852,(3),cljs.core.cst$kw$default,null,(2));
var inst_105833 = fluree.db.storage.core.storage_read(conn,key);
var state_105852__$1 = state_105852;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105852__$1,(5),inst_105833);
} else {
if((state_val_105853 === (5))){
var inst_105835 = (state_105852[(9)]);
var inst_105835__$1 = (state_105852[(2)]);
var inst_105836 = (inst_105835__$1 == null);
var inst_105837 = (inst_105835__$1 instanceof Error);
var inst_105838 = ((inst_105836) || (inst_105837));
var state_105852__$1 = (function (){var statearr_105857 = state_105852;
(statearr_105857[(9)] = inst_105835__$1);

return statearr_105857;
})();
if(cljs.core.truth_(inst_105838)){
var statearr_105858_105870 = state_105852__$1;
(statearr_105858_105870[(1)] = (6));

} else {
var statearr_105859_105871 = state_105852__$1;
(statearr_105859_105871[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105853 === (6))){
var inst_105840 = cljs.core.async.close_BANG_(return_ch);
var state_105852__$1 = state_105852;
var statearr_105860_105872 = state_105852__$1;
(statearr_105860_105872[(2)] = inst_105840);

(statearr_105860_105872[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105853 === (7))){
var inst_105835 = (state_105852[(9)]);
var inst_105842 = fluree.db.storage.core.serde(conn);
var inst_105843 = fluree.db.serde.protocol._deserialize_leaf(inst_105842,inst_105835);
var inst_105844 = cljs.core.cst$kw$flakes.cljs$core$IFn$_invoke$arity$1(inst_105843);
var inst_105845 = cljs.core.sort.cljs$core$IFn$_invoke$arity$2(fluree.db.flake.cmp_flakes_history,inst_105844);
var inst_105846 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(return_ch,inst_105845);
var state_105852__$1 = state_105852;
var statearr_105861_105873 = state_105852__$1;
(statearr_105861_105873[(2)] = inst_105846);

(statearr_105861_105873[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105853 === (8))){
var inst_105848 = (state_105852[(2)]);
var state_105852__$1 = state_105852;
var statearr_105862_105874 = state_105852__$1;
(statearr_105862_105874[(2)] = inst_105848);


cljs.core.async.impl.ioc_helpers.process_exception(state_105852__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto___105867,return_ch))
;
return ((function (switch__99702__auto__,c__99809__auto___105867,return_ch){
return (function() {
var fluree$db$storage$core$reify_history_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$reify_history_$_state_machine__99703__auto____0 = (function (){
var statearr_105863 = [null,null,null,null,null,null,null,null,null,null];
(statearr_105863[(0)] = fluree$db$storage$core$reify_history_$_state_machine__99703__auto__);

(statearr_105863[(1)] = (1));

return statearr_105863;
});
var fluree$db$storage$core$reify_history_$_state_machine__99703__auto____1 = (function (state_105852){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105852);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105864){if((e105864 instanceof Object)){
var ex__99706__auto__ = e105864;
var statearr_105865_105875 = state_105852;
(statearr_105865_105875[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105852);

return cljs.core.cst$kw$recur;
} else {
throw e105864;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__105876 = state_105852;
state_105852 = G__105876;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$reify_history_$_state_machine__99703__auto__ = function(state_105852){
switch(arguments.length){
case 0:
return fluree$db$storage$core$reify_history_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$reify_history_$_state_machine__99703__auto____1.call(this,state_105852);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$reify_history_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$reify_history_$_state_machine__99703__auto____0;
fluree$db$storage$core$reify_history_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$reify_history_$_state_machine__99703__auto____1;
return fluree$db$storage$core$reify_history_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___105867,return_ch))
})();
var state__99811__auto__ = (function (){var statearr_105866 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105866[(6)] = c__99809__auto___105867);

return statearr_105866;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___105867,return_ch))
);


return return_ch;
});
/**
 * Given a novelty set, a first-flake and rhs flake boundary,
 *   returns novelty subrange as a collection.
 * 
 *   If through-t is specified, will return novelty only through the
 *   specified t.
 */
fluree.db.storage.core.source_novelty_t = (function fluree$db$storage$core$source_novelty_t(var_args){
var G__105878 = arguments.length;
switch (G__105878) {
case 4:
return fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$4 = (function (novelty,first_flake,rhs,leftmost_QMARK_){
return fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$5(novelty,first_flake,rhs,leftmost_QMARK_,null);
});

fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$5 = (function (novelty,first_flake,rhs,leftmost_QMARK_,through_t){
var novelty_subrange = (cljs.core.truth_((function (){var and__4120__auto__ = rhs;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.not(leftmost_QMARK_);
} else {
return and__4120__auto__;
}
})())?clojure.data.avl.subrange.cljs$core$IFn$_invoke$arity$5(novelty,cljs.core._GT_,first_flake,cljs.core._LT__EQ_,rhs):(cljs.core.truth_((function (){var and__4120__auto__ = rhs;
if(cljs.core.truth_(and__4120__auto__)){
return leftmost_QMARK_;
} else {
return and__4120__auto__;
}
})())?clojure.data.avl.subrange.cljs$core$IFn$_invoke$arity$3(novelty,cljs.core._LT__EQ_,rhs):(((((rhs == null)) && (cljs.core.not(leftmost_QMARK_))))?clojure.data.avl.subrange.cljs$core$IFn$_invoke$arity$3(novelty,cljs.core._GT_,first_flake):(cljs.core.truth_((function (){var and__4120__auto__ = (rhs == null);
if(and__4120__auto__){
return leftmost_QMARK_;
} else {
return and__4120__auto__;
}
})())?novelty:null))));
if(cljs.core.truth_(through_t)){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (novelty_subrange){
return (function (novelty_set,f){
if((f.t < through_t)){
return cljs.core.disj.cljs$core$IFn$_invoke$arity$2(novelty_set,f);
} else {
return novelty_set;
}
});})(novelty_subrange))
,novelty_subrange,novelty_subrange);
} else {
return novelty_subrange;
}
});

fluree.db.storage.core.source_novelty_t.cljs$lang$maxFixedArity = 5;

fluree.db.storage.core.resolve_t = (function fluree$db$storage$core$resolve_t(node,t,idx_novelty,rhs,leftmost_QMARK_,remove_preds,error_fn){
var result_ch = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__99809__auto___105980 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___105980,result_ch){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___105980,result_ch){
return (function (state_105938){
var state_val_105939 = (state_105938[(1)]);
if((state_val_105939 === (7))){
var inst_105893 = (state_105938[(7)]);
var inst_105897 = (inst_105893 < t);
var state_105938__$1 = state_105938;
if(cljs.core.truth_(inst_105897)){
var statearr_105940_105981 = state_105938__$1;
(statearr_105940_105981[(1)] = (9));

} else {
var statearr_105941_105982 = state_105938__$1;
(statearr_105941_105982[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (20))){
var inst_105908 = (state_105938[(8)]);
var inst_105921 = (state_105938[(9)]);
var inst_105893 = (state_105938[(7)]);
var inst_105891 = (state_105938[(10)]);
var inst_105892 = (state_105938[(11)]);
var inst_105928 = (state_105938[(2)]);
var inst_105929 = (function (){var base_node = inst_105891;
var first_flake = inst_105892;
var node_t = inst_105893;
var source = inst_105908;
var coll = inst_105921;
var conj_QMARK_ = inst_105928;
return ((function (base_node,first_flake,node_t,source,coll,conj_QMARK_,inst_105908,inst_105921,inst_105893,inst_105891,inst_105892,inst_105928,state_val_105939,c__99809__auto___105980,result_ch){
return (function (acc,f){
if(cljs.core.truth_((function (){var G__105943 = f.p;
var fexpr__105942 = (function (){var or__4131__auto__ = remove_preds;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.PersistentHashSet.EMPTY;
}
})();
return (fexpr__105942.cljs$core$IFn$_invoke$arity$1 ? fexpr__105942.cljs$core$IFn$_invoke$arity$1(G__105943) : fexpr__105942.call(null,G__105943));
})())){
return cljs.core.disj.cljs$core$IFn$_invoke$arity$2(acc,f);
} else {
if(cljs.core.truth_((conj_QMARK_.cljs$core$IFn$_invoke$arity$1 ? conj_QMARK_.cljs$core$IFn$_invoke$arity$1(f) : conj_QMARK_.call(null,f)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,f);
} else {
return cljs.core.disj.cljs$core$IFn$_invoke$arity$2(acc,f);

}
}
});
;})(base_node,first_flake,node_t,source,coll,conj_QMARK_,inst_105908,inst_105921,inst_105893,inst_105891,inst_105892,inst_105928,state_val_105939,c__99809__auto___105980,result_ch))
})();
var inst_105930 = cljs.core.cst$kw$flakes.cljs$core$IFn$_invoke$arity$1(inst_105891);
var inst_105931 = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(inst_105929,inst_105930,inst_105921);
var inst_105932 = cljs.core.doall.cljs$core$IFn$_invoke$arity$1(inst_105931);
var inst_105933 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_105891,cljs.core.cst$kw$flakes,inst_105932);
var inst_105934 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(result_ch,inst_105933);
var state_105938__$1 = state_105938;
var statearr_105944_105983 = state_105938__$1;
(statearr_105944_105983[(2)] = inst_105934);


cljs.core.async.impl.ioc_helpers.process_exception(state_105938__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (1))){
var state_105938__$1 = state_105938;
var statearr_105945_105984 = state_105938__$1;
(statearr_105945_105984[(2)] = null);

(statearr_105945_105984[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_105938,(3),cljs.core.cst$kw$default,null,(2));
var inst_105888 = fluree.db.dbproto._resolve(node);
var state_105938__$1 = state_105938;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105938__$1,(5),inst_105888);
} else {
if((state_val_105939 === (15))){
var inst_105908 = (state_105938[(8)]);
var inst_105921 = (state_105938[(2)]);
var state_105938__$1 = (function (){var statearr_105946 = state_105938;
(statearr_105946[(9)] = inst_105921);

return statearr_105946;
})();
var G__105947_105985 = inst_105908;
var G__105947_105986__$1 = (((G__105947_105985 instanceof cljs.core.Keyword))?G__105947_105985.fqn:null);
switch (G__105947_105986__$1) {
case "novelty":
var statearr_105948_105988 = state_105938__$1;
(statearr_105948_105988[(1)] = (21));


break;
case "history":
var statearr_105949_105989 = state_105938__$1;
(statearr_105949_105989[(1)] = (22));


break;
case "none":
var statearr_105950_105990 = state_105938__$1;
(statearr_105950_105990[(1)] = (23));


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__105947_105986__$1)].join('')));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (21))){
var inst_105908 = (state_105938[(8)]);
var inst_105921 = (state_105938[(9)]);
var inst_105893 = (state_105938[(7)]);
var inst_105891 = (state_105938[(10)]);
var inst_105892 = (state_105938[(11)]);
var inst_105922 = (function (){var base_node = inst_105891;
var first_flake = inst_105892;
var node_t = inst_105893;
var source = inst_105908;
var coll = inst_105921;
return ((function (base_node,first_flake,node_t,source,coll,inst_105908,inst_105921,inst_105893,inst_105891,inst_105892,state_val_105939,c__99809__auto___105980,result_ch){
return (function (f){
return f.op === true;
});
;})(base_node,first_flake,node_t,source,coll,inst_105908,inst_105921,inst_105893,inst_105891,inst_105892,state_val_105939,c__99809__auto___105980,result_ch))
})();
var state_105938__$1 = state_105938;
var statearr_105951_105991 = state_105938__$1;
(statearr_105951_105991[(2)] = inst_105922);

(statearr_105951_105991[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (13))){
var state_105938__$1 = state_105938;
var statearr_105952_105992 = state_105938__$1;
(statearr_105952_105992[(2)] = null);

(statearr_105952_105992[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (22))){
var inst_105908 = (state_105938[(8)]);
var inst_105921 = (state_105938[(9)]);
var inst_105893 = (state_105938[(7)]);
var inst_105891 = (state_105938[(10)]);
var inst_105892 = (state_105938[(11)]);
var inst_105924 = (function (){var base_node = inst_105891;
var first_flake = inst_105892;
var node_t = inst_105893;
var source = inst_105908;
var coll = inst_105921;
return ((function (base_node,first_flake,node_t,source,coll,inst_105908,inst_105921,inst_105893,inst_105891,inst_105892,state_val_105939,c__99809__auto___105980,result_ch){
return (function (f){
return f.op === false;
});
;})(base_node,first_flake,node_t,source,coll,inst_105908,inst_105921,inst_105893,inst_105891,inst_105892,state_val_105939,c__99809__auto___105980,result_ch))
})();
var state_105938__$1 = state_105938;
var statearr_105953_105993 = state_105938__$1;
(statearr_105953_105993[(2)] = inst_105924);

(statearr_105953_105993[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (6))){
var state_105938__$1 = state_105938;
var statearr_105954_105994 = state_105938__$1;
(statearr_105954_105994[(2)] = cljs.core.cst$kw$novelty);

(statearr_105954_105994[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (17))){
var inst_105908 = (state_105938[(8)]);
var inst_105893 = (state_105938[(7)]);
var inst_105891 = (state_105938[(10)]);
var inst_105892 = (state_105938[(11)]);
var inst_105911 = (function (){var base_node = inst_105891;
var first_flake = inst_105892;
var node_t = inst_105893;
var source = inst_105908;
return ((function (base_node,first_flake,node_t,source,inst_105908,inst_105893,inst_105891,inst_105892,state_val_105939,c__99809__auto___105980,result_ch){
return (function (p1__105880_SHARP_){
return (p1__105880_SHARP_.t <= t);
});
;})(base_node,first_flake,node_t,source,inst_105908,inst_105893,inst_105891,inst_105892,state_val_105939,c__99809__auto___105980,result_ch))
})();
var inst_105912 = fluree.db.dbproto._resolve_history(node);
var state_105938__$1 = (function (){var statearr_105955 = state_105938;
(statearr_105955[(12)] = inst_105911);

return statearr_105955;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_105938__$1,(18),inst_105912);
} else {
if((state_val_105939 === (3))){
var inst_105881 = (state_105938[(2)]);
var inst_105882 = (error_fn.cljs$core$IFn$_invoke$arity$0 ? error_fn.cljs$core$IFn$_invoke$arity$0() : error_fn.call(null));
var inst_105883 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(result_ch,inst_105881);
var inst_105884 = cljs.core.async.close_BANG_(result_ch);
var state_105938__$1 = (function (){var statearr_105956 = state_105938;
(statearr_105956[(13)] = inst_105883);

(statearr_105956[(14)] = inst_105882);

return statearr_105956;
})();
var statearr_105957_105995 = state_105938__$1;
(statearr_105957_105995[(2)] = inst_105884);


cljs.core.async.impl.ioc_helpers.process_exception(state_105938__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (12))){
var state_105938__$1 = state_105938;
var statearr_105958_105996 = state_105938__$1;
(statearr_105958_105996[(2)] = cljs.core.cst$kw$none);

(statearr_105958_105996[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (2))){
var inst_105936 = (state_105938[(2)]);
var state_105938__$1 = state_105938;
return cljs.core.async.impl.ioc_helpers.return_chan(state_105938__$1,inst_105936);
} else {
if((state_val_105939 === (23))){
var state_105938__$1 = state_105938;
var statearr_105959_105997 = state_105938__$1;
(statearr_105959_105997[(2)] = null);

(statearr_105959_105997[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (19))){
var inst_105918 = cljs.core.PersistentVector.EMPTY;
var state_105938__$1 = state_105938;
var statearr_105960_105998 = state_105938__$1;
(statearr_105960_105998[(2)] = inst_105918);

(statearr_105960_105998[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (11))){
var inst_105906 = (state_105938[(2)]);
var state_105938__$1 = state_105938;
var statearr_105961_105999 = state_105938__$1;
(statearr_105961_105999[(2)] = inst_105906);

(statearr_105961_105999[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (9))){
var state_105938__$1 = state_105938;
var statearr_105962_106000 = state_105938__$1;
(statearr_105962_106000[(2)] = cljs.core.cst$kw$history);

(statearr_105962_106000[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (5))){
var inst_105893 = (state_105938[(7)]);
var inst_105891 = (state_105938[(10)]);
var inst_105890 = (state_105938[(2)]);
var inst_105891__$1 = fluree.db.util.async.throw_err(inst_105890);
var inst_105892 = fluree.db.dbproto._first_flake(inst_105891__$1);
var inst_105893__$1 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(inst_105891__$1);
var inst_105894 = (inst_105893__$1 > t);
var state_105938__$1 = (function (){var statearr_105963 = state_105938;
(statearr_105963[(7)] = inst_105893__$1);

(statearr_105963[(10)] = inst_105891__$1);

(statearr_105963[(11)] = inst_105892);

return statearr_105963;
})();
if(cljs.core.truth_(inst_105894)){
var statearr_105964_106001 = state_105938__$1;
(statearr_105964_106001[(1)] = (6));

} else {
var statearr_105965_106002 = state_105938__$1;
(statearr_105965_106002[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (14))){
var inst_105904 = (state_105938[(2)]);
var state_105938__$1 = state_105938;
var statearr_105966_106003 = state_105938__$1;
(statearr_105966_106003[(2)] = inst_105904);

(statearr_105966_106003[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (16))){
var inst_105892 = (state_105938[(11)]);
var inst_105909 = fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$5(idx_novelty,inst_105892,rhs,leftmost_QMARK_,t);
var state_105938__$1 = state_105938;
var statearr_105967_106004 = state_105938__$1;
(statearr_105967_106004[(2)] = inst_105909);

(statearr_105967_106004[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (10))){
var inst_105893 = (state_105938[(7)]);
var inst_105900 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_105893,t);
var state_105938__$1 = state_105938;
if(inst_105900){
var statearr_105968_106005 = state_105938__$1;
(statearr_105968_106005[(1)] = (12));

} else {
var statearr_105969_106006 = state_105938__$1;
(statearr_105969_106006[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (18))){
var inst_105911 = (state_105938[(12)]);
var inst_105914 = (state_105938[(2)]);
var inst_105915 = fluree.db.util.async.throw_err(inst_105914);
var inst_105916 = cljs.core.take_while.cljs$core$IFn$_invoke$arity$2(inst_105911,inst_105915);
var state_105938__$1 = state_105938;
var statearr_105970_106007 = state_105938__$1;
(statearr_105970_106007[(2)] = inst_105916);

(statearr_105970_106007[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_105939 === (8))){
var inst_105908 = (state_105938[(8)]);
var inst_105908__$1 = (state_105938[(2)]);
var state_105938__$1 = (function (){var statearr_105971 = state_105938;
(statearr_105971[(8)] = inst_105908__$1);

return statearr_105971;
})();
var G__105972_106008 = inst_105908__$1;
var G__105972_106009__$1 = (((G__105972_106008 instanceof cljs.core.Keyword))?G__105972_106008.fqn:null);
switch (G__105972_106009__$1) {
case "novelty":
var statearr_105973_106011 = state_105938__$1;
(statearr_105973_106011[(1)] = (16));


break;
case "history":
var statearr_105974_106012 = state_105938__$1;
(statearr_105974_106012[(1)] = (17));


break;
case "none":
var statearr_105975_106013 = state_105938__$1;
(statearr_105975_106013[(1)] = (19));


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__105972_106009__$1)].join('')));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___105980,result_ch))
;
return ((function (switch__99702__auto__,c__99809__auto___105980,result_ch){
return (function() {
var fluree$db$storage$core$resolve_t_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$resolve_t_$_state_machine__99703__auto____0 = (function (){
var statearr_105976 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_105976[(0)] = fluree$db$storage$core$resolve_t_$_state_machine__99703__auto__);

(statearr_105976[(1)] = (1));

return statearr_105976;
});
var fluree$db$storage$core$resolve_t_$_state_machine__99703__auto____1 = (function (state_105938){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_105938);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e105977){if((e105977 instanceof Object)){
var ex__99706__auto__ = e105977;
var statearr_105978_106014 = state_105938;
(statearr_105978_106014[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_105938);

return cljs.core.cst$kw$recur;
} else {
throw e105977;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106015 = state_105938;
state_105938 = G__106015;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$resolve_t_$_state_machine__99703__auto__ = function(state_105938){
switch(arguments.length){
case 0:
return fluree$db$storage$core$resolve_t_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$resolve_t_$_state_machine__99703__auto____1.call(this,state_105938);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$resolve_t_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$resolve_t_$_state_machine__99703__auto____0;
fluree$db$storage$core$resolve_t_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$resolve_t_$_state_machine__99703__auto____1;
return fluree$db$storage$core$resolve_t_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___105980,result_ch))
})();
var state__99811__auto__ = (function (){var statearr_105979 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_105979[(6)] = c__99809__auto___105980);

return statearr_105979;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___105980,result_ch))
);


return result_ch;
});
/**
 * Gets a history slice of a node with the oldest 't' from-t, to the
 *   most recent 't', to-t.
 * 
 *   Returns sorted set in novelty's sort order (spot, psot, post, or opst)
 */
fluree.db.storage.core.resolve_history_range = (function fluree$db$storage$core$resolve_history_range(node,from_t,to_t,idx_novelty,leftmost_QMARK_){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_106069){
var state_val_106070 = (state_106069[(1)]);
if((state_val_106070 === (7))){
var inst_106049 = (state_106069[(2)]);
var inst_106050 = fluree.db.dbproto._first_flake(node);
var inst_106051 = fluree.db.dbproto._rhs(node);
var inst_106052 = cljs.core.cst$kw$leaf.cljs$core$IFn$_invoke$arity$1(node);
var state_106069__$1 = (function (){var statearr_106071 = state_106069;
(statearr_106071[(7)] = inst_106049);

(statearr_106071[(8)] = inst_106050);

(statearr_106071[(9)] = inst_106051);

return statearr_106071;
})();
if(cljs.core.truth_(inst_106052)){
var statearr_106072_106100 = state_106069__$1;
(statearr_106072_106100[(1)] = (15));

} else {
var statearr_106073_106101 = state_106069__$1;
(statearr_106073_106101[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (1))){
var state_106069__$1 = state_106069;
var statearr_106074_106102 = state_106069__$1;
(statearr_106074_106102[(2)] = null);

(statearr_106074_106102[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (4))){
var inst_106024 = (state_106069[(10)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106069,(3),cljs.core.cst$kw$default,null,(2));
var inst_106024__$1 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(node);
var inst_106025 = (from_t == null);
var inst_106026 = (inst_106024__$1 <= from_t);
var inst_106027 = ((inst_106025) || (inst_106026));
var state_106069__$1 = (function (){var statearr_106075 = state_106069;
(statearr_106075[(10)] = inst_106024__$1);

return statearr_106075;
})();
if(cljs.core.truth_(inst_106027)){
var statearr_106076_106103 = state_106069__$1;
(statearr_106076_106103[(1)] = (5));

} else {
var statearr_106077_106104 = state_106069__$1;
(statearr_106077_106104[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (15))){
var state_106069__$1 = state_106069;
var statearr_106078_106105 = state_106069__$1;
(statearr_106078_106105[(2)] = null);

(statearr_106078_106105[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (13))){
var inst_106040 = (state_106069[(11)]);
var state_106069__$1 = state_106069;
var statearr_106079_106106 = state_106069__$1;
(statearr_106079_106106[(2)] = inst_106040);

(statearr_106079_106106[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (6))){
var state_106069__$1 = state_106069;
var statearr_106080_106107 = state_106069__$1;
(statearr_106080_106107[(2)] = null);

(statearr_106080_106107[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (17))){
var inst_106049 = (state_106069[(7)]);
var inst_106050 = (state_106069[(8)]);
var inst_106051 = (state_106069[(9)]);
var inst_106063 = (state_106069[(2)]);
var inst_106064 = fluree.db.storage.core.source_novelty_t.cljs$core$IFn$_invoke$arity$5(idx_novelty,inst_106050,inst_106051,leftmost_QMARK_,to_t);
var inst_106065 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_106064,inst_106049);
var state_106069__$1 = (function (){var statearr_106081 = state_106069;
(statearr_106081[(12)] = inst_106063);

return statearr_106081;
})();
var statearr_106082_106108 = state_106069__$1;
(statearr_106082_106108[(2)] = inst_106065);


cljs.core.async.impl.ioc_helpers.process_exception(state_106069__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (3))){
var inst_106018 = (state_106069[(2)]);
var inst_106019 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_106018], 0));
var inst_106020 = (function(){throw inst_106018})();
var state_106069__$1 = (function (){var statearr_106083 = state_106069;
(statearr_106083[(13)] = inst_106019);

return statearr_106083;
})();
var statearr_106084_106109 = state_106069__$1;
(statearr_106084_106109[(2)] = inst_106020);


cljs.core.async.impl.ioc_helpers.process_exception(state_106069__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (12))){
var inst_106024 = (state_106069[(10)]);
var inst_106040 = (state_106069[(11)]);
var inst_106042 = (function (){var node_t = inst_106024;
var G__106029 = inst_106040;
return ((function (node_t,G__106029,inst_106024,inst_106040,state_val_106070,c__99809__auto__){
return (function (p1__106017_SHARP_){
return (p1__106017_SHARP_.t <= from_t);
});
;})(node_t,G__106029,inst_106024,inst_106040,state_val_106070,c__99809__auto__))
})();
var inst_106043 = cljs.core.take_while.cljs$core$IFn$_invoke$arity$2(inst_106042,inst_106040);
var state_106069__$1 = state_106069;
var statearr_106085_106110 = state_106069__$1;
(statearr_106085_106110[(2)] = inst_106043);

(statearr_106085_106110[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (2))){
var inst_106067 = (state_106069[(2)]);
var state_106069__$1 = state_106069;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106069__$1,inst_106067);
} else {
if((state_val_106070 === (11))){
var inst_106040 = (state_106069[(2)]);
var state_106069__$1 = (function (){var statearr_106086 = state_106069;
(statearr_106086[(11)] = inst_106040);

return statearr_106086;
})();
if(cljs.core.truth_(from_t)){
var statearr_106087_106111 = state_106069__$1;
(statearr_106087_106111[(1)] = (12));

} else {
var statearr_106088_106112 = state_106069__$1;
(statearr_106088_106112[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (9))){
var inst_106024 = (state_106069[(10)]);
var inst_106033 = (state_106069[(14)]);
var inst_106036 = (function (){var node_t = inst_106024;
var G__106029 = inst_106033;
return ((function (node_t,G__106029,inst_106024,inst_106033,state_val_106070,c__99809__auto__){
return (function (p1__106016_SHARP_){
return (p1__106016_SHARP_.t < to_t);
});
;})(node_t,G__106029,inst_106024,inst_106033,state_val_106070,c__99809__auto__))
})();
var inst_106037 = cljs.core.drop_while.cljs$core$IFn$_invoke$arity$2(inst_106036,inst_106033);
var state_106069__$1 = state_106069;
var statearr_106089_106113 = state_106069__$1;
(statearr_106089_106113[(2)] = inst_106037);

(statearr_106089_106113[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (5))){
var inst_106030 = fluree.db.dbproto._resolve_history(node);
var state_106069__$1 = state_106069;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106069__$1,(8),inst_106030);
} else {
if((state_val_106070 === (14))){
var inst_106046 = (state_106069[(2)]);
var state_106069__$1 = state_106069;
var statearr_106090_106114 = state_106069__$1;
(statearr_106090_106114[(2)] = inst_106046);

(statearr_106090_106114[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (16))){
var inst_106055 = cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(node);
var inst_106056 = ["resolve-history-range called on index node: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_106055)].join('');
var inst_106057 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_106058 = [(500),cljs.core.cst$kw$db_SLASH_unexpected_DASH_error];
var inst_106059 = cljs.core.PersistentHashMap.fromArrays(inst_106057,inst_106058);
var inst_106060 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_106056,inst_106059);
var inst_106061 = (function(){throw inst_106060})();
var state_106069__$1 = state_106069;
var statearr_106091_106115 = state_106069__$1;
(statearr_106091_106115[(2)] = inst_106061);

(statearr_106091_106115[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (10))){
var inst_106033 = (state_106069[(14)]);
var state_106069__$1 = state_106069;
var statearr_106092_106116 = state_106069__$1;
(statearr_106092_106116[(2)] = inst_106033);

(statearr_106092_106116[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106070 === (8))){
var inst_106024 = (state_106069[(10)]);
var inst_106032 = (state_106069[(2)]);
var inst_106033 = fluree.db.util.async.throw_err(inst_106032);
var inst_106034 = (to_t > inst_106024);
var state_106069__$1 = (function (){var statearr_106093 = state_106069;
(statearr_106093[(14)] = inst_106033);

return statearr_106093;
})();
if(cljs.core.truth_(inst_106034)){
var statearr_106094_106117 = state_106069__$1;
(statearr_106094_106117[(1)] = (9));

} else {
var statearr_106095_106118 = state_106069__$1;
(statearr_106095_106118[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto____0 = (function (){
var statearr_106096 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_106096[(0)] = fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto__);

(statearr_106096[(1)] = (1));

return statearr_106096;
});
var fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto____1 = (function (state_106069){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106069);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106097){if((e106097 instanceof Object)){
var ex__99706__auto__ = e106097;
var statearr_106098_106119 = state_106069;
(statearr_106098_106119[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106069);

return cljs.core.cst$kw$recur;
} else {
throw e106097;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106120 = state_106069;
state_106069 = G__106120;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto__ = function(state_106069){
switch(arguments.length){
case 0:
return fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto____1.call(this,state_106069);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto____0;
fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto____1;
return fluree$db$storage$core$resolve_history_range_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_106099 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106099[(6)] = c__99809__auto__);

return statearr_106099;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.storage.core.resolve_to_t = (function fluree$db$storage$core$resolve_to_t(node,id,tempid,rhs,leftmost_QMARK_,t,tt_id,idx_novelty,conn,fast_foward_db_QMARK_,remove_preds){
if(cljs.core.truth_((function (){var or__4131__auto__ = fast_foward_db_QMARK_;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$empty,id);
}
})())){
return fluree.db.storage.core.resolve_t(node,t,idx_novelty,rhs,leftmost_QMARK_,remove_preds,null);
} else {
var object_cache = cljs.core.cst$kw$object_DASH_cache.cljs$core$IFn$_invoke$arity$1(conn);
if((!(cljs.core.empty_QMARK_(remove_preds)))){
var G__106121_106131 = new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [id,t,tt_id,tempid], null);
var G__106122_106132 = null;
(object_cache.cljs$core$IFn$_invoke$arity$2 ? object_cache.cljs$core$IFn$_invoke$arity$2(G__106121_106131,G__106122_106132) : object_cache.call(null,G__106121_106131,G__106122_106132));

var G__106123 = new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [id,t,tt_id,tempid], null);
var G__106124 = ((function (G__106123,object_cache){
return (function (_){
return fluree.db.storage.core.resolve_t(node,t,idx_novelty,rhs,leftmost_QMARK_,remove_preds,((function (G__106123,object_cache){
return (function (){
var G__106125 = new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [id,t,tt_id,tempid], null);
var G__106126 = null;
return (object_cache.cljs$core$IFn$_invoke$arity$2 ? object_cache.cljs$core$IFn$_invoke$arity$2(G__106125,G__106126) : object_cache.call(null,G__106125,G__106126));
});})(G__106123,object_cache))
);
});})(G__106123,object_cache))
;
return (object_cache.cljs$core$IFn$_invoke$arity$2 ? object_cache.cljs$core$IFn$_invoke$arity$2(G__106123,G__106124) : object_cache.call(null,G__106123,G__106124));
} else {
var G__106127 = new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [id,t,tt_id,tempid], null);
var G__106128 = ((function (G__106127,object_cache){
return (function (_){
return fluree.db.storage.core.resolve_t(node,t,idx_novelty,rhs,leftmost_QMARK_,remove_preds,((function (G__106127,object_cache){
return (function (){
var G__106129 = new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [id,t,tt_id,tempid], null);
var G__106130 = null;
return (object_cache.cljs$core$IFn$_invoke$arity$2 ? object_cache.cljs$core$IFn$_invoke$arity$2(G__106129,G__106130) : object_cache.call(null,G__106129,G__106130));
});})(G__106127,object_cache))
);
});})(G__106127,object_cache))
;
return (object_cache.cljs$core$IFn$_invoke$arity$2 ? object_cache.cljs$core$IFn$_invoke$arity$2(G__106127,G__106128) : object_cache.call(null,G__106127,G__106128));
}
}
});
/**
 * Reads and deserializes branch node.
 */
fluree.db.storage.core.read_branch = (function fluree$db$storage$core$read_branch(conn,key){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_106150){
var state_val_106151 = (state_106150[(1)]);
if((state_val_106151 === (1))){
var state_106150__$1 = state_106150;
var statearr_106152_106165 = state_106150__$1;
(statearr_106152_106165[(2)] = null);

(statearr_106152_106165[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106151 === (2))){
var inst_106148 = (state_106150[(2)]);
var state_106150__$1 = state_106150;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106150__$1,inst_106148);
} else {
if((state_val_106151 === (3))){
var inst_106133 = (state_106150[(2)]);
var state_106150__$1 = state_106150;
var statearr_106153_106166 = state_106150__$1;
(statearr_106153_106166[(2)] = inst_106133);


cljs.core.async.impl.ioc_helpers.process_exception(state_106150__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106151 === (4))){
var inst_106137 = (state_106150[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106150,(3),Error,null,(2));
var inst_106137__$1 = fluree.db.storage.core.storage_read(conn,key);
var state_106150__$1 = (function (){var statearr_106154 = state_106150;
(statearr_106154[(7)] = inst_106137__$1);

return statearr_106154;
})();
if(cljs.core.truth_(inst_106137__$1)){
var statearr_106155_106167 = state_106150__$1;
(statearr_106155_106167[(1)] = (5));

} else {
var statearr_106156_106168 = state_106150__$1;
(statearr_106156_106168[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106151 === (5))){
var inst_106137 = (state_106150[(7)]);
var inst_106139 = fluree.db.storage.core.serde(conn);
var state_106150__$1 = (function (){var statearr_106157 = state_106150;
(statearr_106157[(8)] = inst_106139);

return statearr_106157;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106150__$1,(8),inst_106137);
} else {
if((state_val_106151 === (6))){
var state_106150__$1 = state_106150;
var statearr_106158_106169 = state_106150__$1;
(statearr_106158_106169[(2)] = null);

(statearr_106158_106169[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106151 === (7))){
var inst_106146 = (state_106150[(2)]);
var state_106150__$1 = state_106150;
var statearr_106159_106170 = state_106150__$1;
(statearr_106159_106170[(2)] = inst_106146);


cljs.core.async.impl.ioc_helpers.process_exception(state_106150__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106151 === (8))){
var inst_106139 = (state_106150[(8)]);
var inst_106141 = (state_106150[(2)]);
var inst_106142 = fluree.db.util.async.throw_err(inst_106141);
var inst_106143 = fluree.db.serde.protocol._deserialize_branch(inst_106139,inst_106142);
var state_106150__$1 = state_106150;
var statearr_106160_106171 = state_106150__$1;
(statearr_106160_106171[(2)] = inst_106143);

(statearr_106160_106171[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$read_branch_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$read_branch_$_state_machine__99703__auto____0 = (function (){
var statearr_106161 = [null,null,null,null,null,null,null,null,null];
(statearr_106161[(0)] = fluree$db$storage$core$read_branch_$_state_machine__99703__auto__);

(statearr_106161[(1)] = (1));

return statearr_106161;
});
var fluree$db$storage$core$read_branch_$_state_machine__99703__auto____1 = (function (state_106150){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106150);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106162){if((e106162 instanceof Object)){
var ex__99706__auto__ = e106162;
var statearr_106163_106172 = state_106150;
(statearr_106163_106172[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106150);

return cljs.core.cst$kw$recur;
} else {
throw e106162;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106173 = state_106150;
state_106150 = G__106173;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$read_branch_$_state_machine__99703__auto__ = function(state_106150){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_branch_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_branch_$_state_machine__99703__auto____1.call(this,state_106150);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_branch_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_branch_$_state_machine__99703__auto____0;
fluree$db$storage$core$read_branch_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_branch_$_state_machine__99703__auto____1;
return fluree$db$storage$core$read_branch_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_106164 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106164[(6)] = c__99809__auto__);

return statearr_106164;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Should throw if no result... should never be the case.
 */
fluree.db.storage.core.reify_branch = (function fluree$db$storage$core$reify_branch(conn,config,network,dbid,key,block,t,tt_id,leftmost_QMARK_,tempid,error_fn){
var return_ch = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__99809__auto___106308 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___106308,return_ch){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___106308,return_ch){
return (function (state_106260){
var state_val_106261 = (state_106260[(1)]);
if((state_val_106261 === (7))){
var state_106260__$1 = state_106260;
var statearr_106262_106309 = state_106260__$1;
(statearr_106262_106309[(2)] = null);

(statearr_106262_106309[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (20))){
var inst_106224 = (state_106260[(7)]);
var inst_106224__$1 = (state_106260[(2)]);
var inst_106225 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_106224__$1,cljs.core.cst$kw$children);
var inst_106226 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_106224__$1,cljs.core.cst$kw$rhs);
var inst_106228 = (config == null);
var inst_106229 = cljs.core.not(inst_106228);
var state_106260__$1 = (function (){var statearr_106263 = state_106260;
(statearr_106263[(8)] = inst_106225);

(statearr_106263[(7)] = inst_106224__$1);

(statearr_106263[(9)] = inst_106226);

return statearr_106263;
})();
if(inst_106229){
var statearr_106264_106310 = state_106260__$1;
(statearr_106264_106310[(1)] = (21));

} else {
var statearr_106265_106311 = state_106260__$1;
(statearr_106265_106311[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (27))){
var inst_106244 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,config);
var state_106260__$1 = state_106260;
var statearr_106266_106312 = state_106260__$1;
(statearr_106266_106312[(2)] = inst_106244);

(statearr_106266_106312[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (1))){
var state_106260__$1 = state_106260;
var statearr_106267_106313 = state_106260__$1;
(statearr_106267_106313[(2)] = null);

(statearr_106267_106313[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (24))){
var state_106260__$1 = state_106260;
var statearr_106268_106314 = state_106260__$1;
(statearr_106268_106314[(2)] = true);

(statearr_106268_106314[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106260,(3),cljs.core.cst$kw$default,null,(2));
var inst_106183 = fluree.db.storage.core.read_branch(conn,key);
var state_106260__$1 = state_106260;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106260__$1,(5),inst_106183);
} else {
if((state_val_106261 === (15))){
var state_106260__$1 = state_106260;
var statearr_106269_106315 = state_106260__$1;
(statearr_106269_106315[(2)] = true);

(statearr_106269_106315[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (21))){
var inst_106231 = config.cljs$lang$protocol_mask$partition0$;
var inst_106232 = (inst_106231 & (64));
var inst_106233 = config.cljs$core$ISeq$;
var inst_106234 = (cljs.core.PROTOCOL_SENTINEL === inst_106233);
var inst_106235 = ((inst_106232) || (inst_106234));
var state_106260__$1 = state_106260;
if(cljs.core.truth_(inst_106235)){
var statearr_106270_106316 = state_106260__$1;
(statearr_106270_106316[(1)] = (24));

} else {
var statearr_106271_106317 = state_106260__$1;
(statearr_106271_106317[(1)] = (25));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (13))){
var state_106260__$1 = state_106260;
var statearr_106272_106318 = state_106260__$1;
(statearr_106272_106318[(2)] = false);

(statearr_106272_106318[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (22))){
var state_106260__$1 = state_106260;
var statearr_106273_106319 = state_106260__$1;
(statearr_106273_106319[(2)] = false);

(statearr_106273_106319[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (29))){
var inst_106225 = (state_106260[(8)]);
var inst_106224 = (state_106260[(7)]);
var inst_106203 = (state_106260[(10)]);
var inst_106186 = (state_106260[(11)]);
var inst_106226 = (state_106260[(9)]);
var inst_106247 = (state_106260[(2)]);
var inst_106248 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_106247,cljs.core.cst$kw$comparator);
var inst_106250 = (function (){var data = inst_106186;
var _ = inst_106203;
var map__106181 = inst_106224;
var children = inst_106225;
var rhs = inst_106226;
var map__106182 = inst_106247;
var comparator = inst_106248;
return ((function (data,_,map__106181,children,rhs,map__106182,comparator,inst_106225,inst_106224,inst_106203,inst_106186,inst_106226,inst_106247,inst_106248,state_val_106261,c__99809__auto___106308,return_ch){
return (function (idx,p__106249){
var map__106274 = p__106249;
var map__106274__$1 = (((((!((map__106274 == null))))?(((((map__106274.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__106274.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__106274):map__106274);
var child = map__106274__$1;
var id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106274__$1,cljs.core.cst$kw$id);
var leaf = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106274__$1,cljs.core.cst$kw$leaf);
var first = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106274__$1,cljs.core.cst$kw$first);
var rhs__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106274__$1,cljs.core.cst$kw$rhs);
var size = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106274__$1,cljs.core.cst$kw$size);
var at_leftmost_QMARK_ = (function (){var and__4120__auto__ = leftmost_QMARK_;
if(cljs.core.truth_(and__4120__auto__)){
return (idx === (0));
} else {
return and__4120__auto__;
}
})();
return (fluree.db.storage.core.__GT_UnresolvedNode.cljs$core$IFn$_invoke$arity$14 ? fluree.db.storage.core.__GT_UnresolvedNode.cljs$core$IFn$_invoke$arity$14(conn,config,network,dbid,id,leaf,first,rhs__$1,size,block,t,tt_id,at_leftmost_QMARK_,tempid) : fluree.db.storage.core.__GT_UnresolvedNode.call(null,conn,config,network,dbid,id,leaf,first,rhs__$1,size,block,t,tt_id,at_leftmost_QMARK_,tempid));
});
;})(data,_,map__106181,children,rhs,map__106182,comparator,inst_106225,inst_106224,inst_106203,inst_106186,inst_106226,inst_106247,inst_106248,state_val_106261,c__99809__auto___106308,return_ch))
})();
var inst_106251 = cljs.core.map_indexed.cljs$core$IFn$_invoke$arity$2(inst_106250,inst_106225);
var inst_106252 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$first,inst_106251);
var inst_106253 = cljs.core.interleave.cljs$core$IFn$_invoke$arity$2(inst_106252,inst_106251);
var inst_106254 = cljs.core.apply.cljs$core$IFn$_invoke$arity$3(clojure.data.avl.sorted_map_by,inst_106248,inst_106253);
var inst_106255 = fluree.db.index.__GT_IndexNode(block,t,inst_106226,inst_106254,config,leftmost_QMARK_);
var inst_106256 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(return_ch,inst_106255);
var state_106260__$1 = state_106260;
var statearr_106276_106320 = state_106260__$1;
(statearr_106276_106320[(2)] = inst_106256);


cljs.core.async.impl.ioc_helpers.process_exception(state_106260__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (6))){
var inst_106189 = ["Unable to retrieve key from storage: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(key)].join('');
var inst_106190 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_106191 = [(500),cljs.core.cst$kw$db_SLASH_storage_DASH_error];
var inst_106192 = cljs.core.PersistentHashMap.fromArrays(inst_106190,inst_106191);
var inst_106193 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_106189,inst_106192);
var inst_106194 = (function(){throw inst_106193})();
var state_106260__$1 = state_106260;
var statearr_106277_106321 = state_106260__$1;
(statearr_106277_106321[(2)] = inst_106194);

(statearr_106277_106321[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (28))){
var state_106260__$1 = state_106260;
var statearr_106278_106322 = state_106260__$1;
(statearr_106278_106322[(2)] = config);

(statearr_106278_106322[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (25))){
var state_106260__$1 = state_106260;
var statearr_106279_106323 = state_106260__$1;
(statearr_106279_106323[(2)] = false);

(statearr_106279_106323[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (17))){
var inst_106216 = (state_106260[(2)]);
var state_106260__$1 = state_106260;
var statearr_106280_106324 = state_106260__$1;
(statearr_106280_106324[(2)] = inst_106216);

(statearr_106280_106324[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (3))){
var inst_106174 = (state_106260[(2)]);
var inst_106175 = (error_fn.cljs$core$IFn$_invoke$arity$0 ? error_fn.cljs$core$IFn$_invoke$arity$0() : error_fn.call(null));
var inst_106176 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(return_ch,inst_106174);
var inst_106177 = cljs.core.async.close_BANG_(return_ch);
var state_106260__$1 = (function (){var statearr_106281 = state_106260;
(statearr_106281[(12)] = inst_106175);

(statearr_106281[(13)] = inst_106176);

return statearr_106281;
})();
var statearr_106282_106325 = state_106260__$1;
(statearr_106282_106325[(2)] = inst_106177);


cljs.core.async.impl.ioc_helpers.process_exception(state_106260__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (12))){
var inst_106186 = (state_106260[(11)]);
var inst_106208 = inst_106186.cljs$lang$protocol_mask$partition0$;
var inst_106209 = (inst_106208 & (64));
var inst_106210 = inst_106186.cljs$core$ISeq$;
var inst_106211 = (cljs.core.PROTOCOL_SENTINEL === inst_106210);
var inst_106212 = ((inst_106209) || (inst_106211));
var state_106260__$1 = state_106260;
if(cljs.core.truth_(inst_106212)){
var statearr_106283_106326 = state_106260__$1;
(statearr_106283_106326[(1)] = (15));

} else {
var statearr_106284_106327 = state_106260__$1;
(statearr_106284_106327[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (2))){
var inst_106258 = (state_106260[(2)]);
var state_106260__$1 = state_106260;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106260__$1,inst_106258);
} else {
if((state_val_106261 === (23))){
var inst_106242 = (state_106260[(2)]);
var state_106260__$1 = state_106260;
if(cljs.core.truth_(inst_106242)){
var statearr_106285_106328 = state_106260__$1;
(statearr_106285_106328[(1)] = (27));

} else {
var statearr_106286_106329 = state_106260__$1;
(statearr_106286_106329[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (19))){
var inst_106186 = (state_106260[(11)]);
var state_106260__$1 = state_106260;
var statearr_106287_106330 = state_106260__$1;
(statearr_106287_106330[(2)] = inst_106186);

(statearr_106287_106330[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (11))){
var inst_106186 = (state_106260[(11)]);
var inst_106203 = (state_106260[(2)]);
var inst_106205 = (inst_106186 == null);
var inst_106206 = cljs.core.not(inst_106205);
var state_106260__$1 = (function (){var statearr_106288 = state_106260;
(statearr_106288[(10)] = inst_106203);

return statearr_106288;
})();
if(inst_106206){
var statearr_106289_106331 = state_106260__$1;
(statearr_106289_106331[(1)] = (12));

} else {
var statearr_106290_106332 = state_106260__$1;
(statearr_106290_106332[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (9))){
var inst_106186 = (state_106260[(11)]);
var inst_106200 = (function(){throw inst_106186})();
var state_106260__$1 = state_106260;
var statearr_106291_106333 = state_106260__$1;
(statearr_106291_106333[(2)] = inst_106200);

(statearr_106291_106333[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (5))){
var inst_106186 = (state_106260[(11)]);
var inst_106185 = (state_106260[(2)]);
var inst_106186__$1 = fluree.db.util.async.throw_err(inst_106185);
var inst_106187 = (inst_106186__$1 == null);
var state_106260__$1 = (function (){var statearr_106292 = state_106260;
(statearr_106292[(11)] = inst_106186__$1);

return statearr_106292;
})();
if(cljs.core.truth_(inst_106187)){
var statearr_106293_106334 = state_106260__$1;
(statearr_106293_106334[(1)] = (6));

} else {
var statearr_106294_106335 = state_106260__$1;
(statearr_106294_106335[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (14))){
var inst_106219 = (state_106260[(2)]);
var state_106260__$1 = state_106260;
if(cljs.core.truth_(inst_106219)){
var statearr_106295_106336 = state_106260__$1;
(statearr_106295_106336[(1)] = (18));

} else {
var statearr_106296_106337 = state_106260__$1;
(statearr_106296_106337[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (26))){
var inst_106239 = (state_106260[(2)]);
var state_106260__$1 = state_106260;
var statearr_106297_106338 = state_106260__$1;
(statearr_106297_106338[(2)] = inst_106239);

(statearr_106297_106338[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (16))){
var state_106260__$1 = state_106260;
var statearr_106298_106339 = state_106260__$1;
(statearr_106298_106339[(2)] = false);

(statearr_106298_106339[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (10))){
var state_106260__$1 = state_106260;
var statearr_106299_106340 = state_106260__$1;
(statearr_106299_106340[(2)] = null);

(statearr_106299_106340[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (18))){
var inst_106186 = (state_106260[(11)]);
var inst_106221 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_106186);
var state_106260__$1 = state_106260;
var statearr_106300_106341 = state_106260__$1;
(statearr_106300_106341[(2)] = inst_106221);

(statearr_106300_106341[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106261 === (8))){
var inst_106186 = (state_106260[(11)]);
var inst_106197 = (state_106260[(2)]);
var inst_106198 = fluree.db.util.core.exception_QMARK_(inst_106186);
var state_106260__$1 = (function (){var statearr_106301 = state_106260;
(statearr_106301[(14)] = inst_106197);

return statearr_106301;
})();
if(inst_106198){
var statearr_106302_106342 = state_106260__$1;
(statearr_106302_106342[(1)] = (9));

} else {
var statearr_106303_106343 = state_106260__$1;
(statearr_106303_106343[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___106308,return_ch))
;
return ((function (switch__99702__auto__,c__99809__auto___106308,return_ch){
return (function() {
var fluree$db$storage$core$reify_branch_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$reify_branch_$_state_machine__99703__auto____0 = (function (){
var statearr_106304 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_106304[(0)] = fluree$db$storage$core$reify_branch_$_state_machine__99703__auto__);

(statearr_106304[(1)] = (1));

return statearr_106304;
});
var fluree$db$storage$core$reify_branch_$_state_machine__99703__auto____1 = (function (state_106260){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106260);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106305){if((e106305 instanceof Object)){
var ex__99706__auto__ = e106305;
var statearr_106306_106344 = state_106260;
(statearr_106306_106344[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106260);

return cljs.core.cst$kw$recur;
} else {
throw e106305;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106345 = state_106260;
state_106260 = G__106345;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$reify_branch_$_state_machine__99703__auto__ = function(state_106260){
switch(arguments.length){
case 0:
return fluree$db$storage$core$reify_branch_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$reify_branch_$_state_machine__99703__auto____1.call(this,state_106260);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$reify_branch_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$reify_branch_$_state_machine__99703__auto____0;
fluree$db$storage$core$reify_branch_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$reify_branch_$_state_machine__99703__auto____1;
return fluree$db$storage$core$reify_branch_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___106308,return_ch))
})();
var state__99811__auto__ = (function (){var statearr_106307 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106307[(6)] = c__99809__auto___106308);

return statearr_106307;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___106308,return_ch))
);


return return_ch;
});
/**
 * Reads and deserializes a leaf node
 */
fluree.db.storage.core.read_leaf = (function fluree$db$storage$core$read_leaf(conn,key){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_106363){
var state_val_106364 = (state_106363[(1)]);
if((state_val_106364 === (1))){
var state_106363__$1 = state_106363;
var statearr_106365_106378 = state_106363__$1;
(statearr_106365_106378[(2)] = null);

(statearr_106365_106378[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106364 === (2))){
var inst_106361 = (state_106363[(2)]);
var state_106363__$1 = state_106363;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106363__$1,inst_106361);
} else {
if((state_val_106364 === (3))){
var inst_106346 = (state_106363[(2)]);
var state_106363__$1 = state_106363;
var statearr_106366_106379 = state_106363__$1;
(statearr_106366_106379[(2)] = inst_106346);


cljs.core.async.impl.ioc_helpers.process_exception(state_106363__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106364 === (4))){
var inst_106350 = (state_106363[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106363,(3),Error,null,(2));
var inst_106350__$1 = fluree.db.storage.core.storage_read(conn,key);
var state_106363__$1 = (function (){var statearr_106367 = state_106363;
(statearr_106367[(7)] = inst_106350__$1);

return statearr_106367;
})();
if(cljs.core.truth_(inst_106350__$1)){
var statearr_106368_106380 = state_106363__$1;
(statearr_106368_106380[(1)] = (5));

} else {
var statearr_106369_106381 = state_106363__$1;
(statearr_106369_106381[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106364 === (5))){
var inst_106350 = (state_106363[(7)]);
var inst_106352 = fluree.db.storage.core.serde(conn);
var state_106363__$1 = (function (){var statearr_106370 = state_106363;
(statearr_106370[(8)] = inst_106352);

return statearr_106370;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106363__$1,(8),inst_106350);
} else {
if((state_val_106364 === (6))){
var state_106363__$1 = state_106363;
var statearr_106371_106382 = state_106363__$1;
(statearr_106371_106382[(2)] = null);

(statearr_106371_106382[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106364 === (7))){
var inst_106359 = (state_106363[(2)]);
var state_106363__$1 = state_106363;
var statearr_106372_106383 = state_106363__$1;
(statearr_106372_106383[(2)] = inst_106359);


cljs.core.async.impl.ioc_helpers.process_exception(state_106363__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106364 === (8))){
var inst_106352 = (state_106363[(8)]);
var inst_106354 = (state_106363[(2)]);
var inst_106355 = fluree.db.util.async.throw_err(inst_106354);
var inst_106356 = fluree.db.serde.protocol._deserialize_leaf(inst_106352,inst_106355);
var state_106363__$1 = state_106363;
var statearr_106373_106384 = state_106363__$1;
(statearr_106373_106384[(2)] = inst_106356);

(statearr_106373_106384[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$read_leaf_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$read_leaf_$_state_machine__99703__auto____0 = (function (){
var statearr_106374 = [null,null,null,null,null,null,null,null,null];
(statearr_106374[(0)] = fluree$db$storage$core$read_leaf_$_state_machine__99703__auto__);

(statearr_106374[(1)] = (1));

return statearr_106374;
});
var fluree$db$storage$core$read_leaf_$_state_machine__99703__auto____1 = (function (state_106363){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106363);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106375){if((e106375 instanceof Object)){
var ex__99706__auto__ = e106375;
var statearr_106376_106385 = state_106363;
(statearr_106376_106385[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106363);

return cljs.core.cst$kw$recur;
} else {
throw e106375;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106386 = state_106363;
state_106363 = G__106386;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$read_leaf_$_state_machine__99703__auto__ = function(state_106363){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_leaf_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_leaf_$_state_machine__99703__auto____1.call(this,state_106363);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_leaf_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_leaf_$_state_machine__99703__auto____0;
fluree$db$storage$core$read_leaf_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_leaf_$_state_machine__99703__auto____1;
return fluree$db$storage$core$read_leaf_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_106377 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106377[(6)] = c__99809__auto__);

return statearr_106377;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Should throw if no result... should never be the case.
 */
fluree.db.storage.core.reify_leaf = (function fluree$db$storage$core$reify_leaf(conn,config,key,block,t,rhs,error_fn){
if(cljs.core.truth_(cljs.core.cst$kw$comparator.cljs$core$IFn$_invoke$arity$1(config))){
} else {
throw (new Error(["Assert failed: ",["Cannot reify leaf, config does not have a comparator. Config: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([config], 0))].join(''),"\n","(:comparator config)"].join('')));
}

var return_ch = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__99809__auto___106513 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___106513,return_ch){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___106513,return_ch){
return (function (state_106467){
var state_val_106468 = (state_106467[(1)]);
if((state_val_106468 === (7))){
var state_106467__$1 = state_106467;
var statearr_106469_106514 = state_106467__$1;
(statearr_106469_106514[(2)] = null);

(statearr_106469_106514[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (20))){
var inst_106436 = (state_106467[(2)]);
var inst_106437 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_106436,cljs.core.cst$kw$flakes);
var inst_106438 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_106436,cljs.core.cst$kw$his);
var inst_106440 = (config == null);
var inst_106441 = cljs.core.not(inst_106440);
var state_106467__$1 = (function (){var statearr_106470 = state_106467;
(statearr_106470[(7)] = inst_106438);

(statearr_106470[(8)] = inst_106437);

return statearr_106470;
})();
if(inst_106441){
var statearr_106471_106515 = state_106467__$1;
(statearr_106471_106515[(1)] = (21));

} else {
var statearr_106472_106516 = state_106467__$1;
(statearr_106472_106516[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (27))){
var inst_106456 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,config);
var state_106467__$1 = state_106467;
var statearr_106473_106517 = state_106467__$1;
(statearr_106473_106517[(2)] = inst_106456);

(statearr_106473_106517[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (1))){
var state_106467__$1 = state_106467;
var statearr_106474_106518 = state_106467__$1;
(statearr_106474_106518[(2)] = null);

(statearr_106474_106518[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (24))){
var state_106467__$1 = state_106467;
var statearr_106475_106519 = state_106467__$1;
(statearr_106475_106519[(2)] = true);

(statearr_106475_106519[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106467,(3),cljs.core.cst$kw$default,null,(2));
var inst_106396 = fluree.db.storage.core.read_leaf(conn,key);
var state_106467__$1 = state_106467;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106467__$1,(5),inst_106396);
} else {
if((state_val_106468 === (15))){
var state_106467__$1 = state_106467;
var statearr_106476_106520 = state_106467__$1;
(statearr_106476_106520[(2)] = true);

(statearr_106476_106520[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (21))){
var inst_106443 = config.cljs$lang$protocol_mask$partition0$;
var inst_106444 = (inst_106443 & (64));
var inst_106445 = config.cljs$core$ISeq$;
var inst_106446 = (cljs.core.PROTOCOL_SENTINEL === inst_106445);
var inst_106447 = ((inst_106444) || (inst_106446));
var state_106467__$1 = state_106467;
if(cljs.core.truth_(inst_106447)){
var statearr_106477_106521 = state_106467__$1;
(statearr_106477_106521[(1)] = (24));

} else {
var statearr_106478_106522 = state_106467__$1;
(statearr_106478_106522[(1)] = (25));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (13))){
var state_106467__$1 = state_106467;
var statearr_106479_106523 = state_106467__$1;
(statearr_106479_106523[(2)] = false);

(statearr_106479_106523[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (22))){
var state_106467__$1 = state_106467;
var statearr_106480_106524 = state_106467__$1;
(statearr_106480_106524[(2)] = false);

(statearr_106480_106524[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (29))){
var inst_106437 = (state_106467[(8)]);
var inst_106459 = (state_106467[(2)]);
var inst_106460 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_106459,cljs.core.cst$kw$comparator);
var inst_106461 = cljs.core.apply.cljs$core$IFn$_invoke$arity$3(fluree.db.flake.sorted_set_by,inst_106460,inst_106437);
var inst_106462 = fluree.db.index.data_node(block,t,inst_106461,rhs,config);
var inst_106463 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(return_ch,inst_106462);
var state_106467__$1 = state_106467;
var statearr_106481_106525 = state_106467__$1;
(statearr_106481_106525[(2)] = inst_106463);


cljs.core.async.impl.ioc_helpers.process_exception(state_106467__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (6))){
var inst_106401 = ["Unable to retrieve key from storage: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(key)].join('');
var inst_106402 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_106403 = [(500),cljs.core.cst$kw$db_SLASH_storage_DASH_error];
var inst_106404 = cljs.core.PersistentHashMap.fromArrays(inst_106402,inst_106403);
var inst_106405 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_106401,inst_106404);
var inst_106406 = (function(){throw inst_106405})();
var state_106467__$1 = state_106467;
var statearr_106482_106526 = state_106467__$1;
(statearr_106482_106526[(2)] = inst_106406);

(statearr_106482_106526[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (28))){
var state_106467__$1 = state_106467;
var statearr_106483_106527 = state_106467__$1;
(statearr_106483_106527[(2)] = config);

(statearr_106483_106527[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (25))){
var state_106467__$1 = state_106467;
var statearr_106484_106528 = state_106467__$1;
(statearr_106484_106528[(2)] = false);

(statearr_106484_106528[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (17))){
var inst_106428 = (state_106467[(2)]);
var state_106467__$1 = state_106467;
var statearr_106485_106529 = state_106467__$1;
(statearr_106485_106529[(2)] = inst_106428);

(statearr_106485_106529[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (3))){
var inst_106387 = (state_106467[(2)]);
var inst_106388 = (error_fn.cljs$core$IFn$_invoke$arity$0 ? error_fn.cljs$core$IFn$_invoke$arity$0() : error_fn.call(null));
var inst_106389 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(return_ch,inst_106387);
var inst_106390 = cljs.core.async.close_BANG_(return_ch);
var state_106467__$1 = (function (){var statearr_106486 = state_106467;
(statearr_106486[(9)] = inst_106388);

(statearr_106486[(10)] = inst_106389);

return statearr_106486;
})();
var statearr_106487_106530 = state_106467__$1;
(statearr_106487_106530[(2)] = inst_106390);


cljs.core.async.impl.ioc_helpers.process_exception(state_106467__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (12))){
var inst_106398 = (state_106467[(11)]);
var inst_106420 = inst_106398.cljs$lang$protocol_mask$partition0$;
var inst_106421 = (inst_106420 & (64));
var inst_106422 = inst_106398.cljs$core$ISeq$;
var inst_106423 = (cljs.core.PROTOCOL_SENTINEL === inst_106422);
var inst_106424 = ((inst_106421) || (inst_106423));
var state_106467__$1 = state_106467;
if(cljs.core.truth_(inst_106424)){
var statearr_106488_106531 = state_106467__$1;
(statearr_106488_106531[(1)] = (15));

} else {
var statearr_106489_106532 = state_106467__$1;
(statearr_106489_106532[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (2))){
var inst_106465 = (state_106467[(2)]);
var state_106467__$1 = state_106467;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106467__$1,inst_106465);
} else {
if((state_val_106468 === (23))){
var inst_106454 = (state_106467[(2)]);
var state_106467__$1 = state_106467;
if(cljs.core.truth_(inst_106454)){
var statearr_106490_106533 = state_106467__$1;
(statearr_106490_106533[(1)] = (27));

} else {
var statearr_106491_106534 = state_106467__$1;
(statearr_106491_106534[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (19))){
var inst_106398 = (state_106467[(11)]);
var state_106467__$1 = state_106467;
var statearr_106492_106535 = state_106467__$1;
(statearr_106492_106535[(2)] = inst_106398);

(statearr_106492_106535[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (11))){
var inst_106398 = (state_106467[(11)]);
var inst_106415 = (state_106467[(2)]);
var inst_106417 = (inst_106398 == null);
var inst_106418 = cljs.core.not(inst_106417);
var state_106467__$1 = (function (){var statearr_106493 = state_106467;
(statearr_106493[(12)] = inst_106415);

return statearr_106493;
})();
if(inst_106418){
var statearr_106494_106536 = state_106467__$1;
(statearr_106494_106536[(1)] = (12));

} else {
var statearr_106495_106537 = state_106467__$1;
(statearr_106495_106537[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (9))){
var inst_106398 = (state_106467[(11)]);
var inst_106412 = (function(){throw inst_106398})();
var state_106467__$1 = state_106467;
var statearr_106496_106538 = state_106467__$1;
(statearr_106496_106538[(2)] = inst_106412);

(statearr_106496_106538[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (5))){
var inst_106398 = (state_106467[(11)]);
var inst_106398__$1 = (state_106467[(2)]);
var inst_106399 = (inst_106398__$1 == null);
var state_106467__$1 = (function (){var statearr_106497 = state_106467;
(statearr_106497[(11)] = inst_106398__$1);

return statearr_106497;
})();
if(cljs.core.truth_(inst_106399)){
var statearr_106498_106539 = state_106467__$1;
(statearr_106498_106539[(1)] = (6));

} else {
var statearr_106499_106540 = state_106467__$1;
(statearr_106499_106540[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (14))){
var inst_106431 = (state_106467[(2)]);
var state_106467__$1 = state_106467;
if(cljs.core.truth_(inst_106431)){
var statearr_106500_106541 = state_106467__$1;
(statearr_106500_106541[(1)] = (18));

} else {
var statearr_106501_106542 = state_106467__$1;
(statearr_106501_106542[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (26))){
var inst_106451 = (state_106467[(2)]);
var state_106467__$1 = state_106467;
var statearr_106502_106543 = state_106467__$1;
(statearr_106502_106543[(2)] = inst_106451);

(statearr_106502_106543[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (16))){
var state_106467__$1 = state_106467;
var statearr_106503_106544 = state_106467__$1;
(statearr_106503_106544[(2)] = false);

(statearr_106503_106544[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (10))){
var state_106467__$1 = state_106467;
var statearr_106504_106545 = state_106467__$1;
(statearr_106504_106545[(2)] = null);

(statearr_106504_106545[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (18))){
var inst_106398 = (state_106467[(11)]);
var inst_106433 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_106398);
var state_106467__$1 = state_106467;
var statearr_106505_106546 = state_106467__$1;
(statearr_106505_106546[(2)] = inst_106433);

(statearr_106505_106546[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106468 === (8))){
var inst_106398 = (state_106467[(11)]);
var inst_106409 = (state_106467[(2)]);
var inst_106410 = fluree.db.util.core.exception_QMARK_(inst_106398);
var state_106467__$1 = (function (){var statearr_106506 = state_106467;
(statearr_106506[(13)] = inst_106409);

return statearr_106506;
})();
if(inst_106410){
var statearr_106507_106547 = state_106467__$1;
(statearr_106507_106547[(1)] = (9));

} else {
var statearr_106508_106548 = state_106467__$1;
(statearr_106508_106548[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___106513,return_ch))
;
return ((function (switch__99702__auto__,c__99809__auto___106513,return_ch){
return (function() {
var fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto____0 = (function (){
var statearr_106509 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_106509[(0)] = fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto__);

(statearr_106509[(1)] = (1));

return statearr_106509;
});
var fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto____1 = (function (state_106467){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106467);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106510){if((e106510 instanceof Object)){
var ex__99706__auto__ = e106510;
var statearr_106511_106549 = state_106467;
(statearr_106511_106549[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106467);

return cljs.core.cst$kw$recur;
} else {
throw e106510;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106550 = state_106467;
state_106467 = G__106550;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto__ = function(state_106467){
switch(arguments.length){
case 0:
return fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto____1.call(this,state_106467);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto____0;
fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto____1;
return fluree$db$storage$core$reify_leaf_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___106513,return_ch))
})();
var state__99811__auto__ = (function (){var statearr_106512 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106512[(6)] = c__99809__auto___106513);

return statearr_106512;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___106513,return_ch))
);


return return_ch;
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.storage.core.UnresolvedNode = (function (conn,config,network,dbid,id,leaf,first,rhs,size,block,t,tt_id,leftmost_QMARK_,tempid,__meta,__extmap,__hash){
this.conn = conn;
this.config = config;
this.network = network;
this.dbid = dbid;
this.id = id;
this.leaf = leaf;
this.first = first;
this.rhs = rhs;
this.size = size;
this.block = block;
this.t = t;
this.tt_id = tt_id;
this.leftmost_QMARK_ = leftmost_QMARK_;
this.tempid = tempid;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k106552,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__106556 = k106552;
var G__106556__$1 = (((G__106556 instanceof cljs.core.Keyword))?G__106556.fqn:null);
switch (G__106556__$1) {
case "conn":
return self__.conn;

break;
case "config":
return self__.config;

break;
case "network":
return self__.network;

break;
case "dbid":
return self__.dbid;

break;
case "id":
return self__.id;

break;
case "leaf":
return self__.leaf;

break;
case "first":
return self__.first;

break;
case "rhs":
return self__.rhs;

break;
case "size":
return self__.size;

break;
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "tt-id":
return self__.tt_id;

break;
case "leftmost?":
return self__.leftmost_QMARK_;

break;
case "tempid":
return self__.tempid;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k106552,else__4388__auto__);

}
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__106557){
var vec__106558 = p__106557;
var k__4408__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__106558,(0),null);
var v__4409__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__106558,(1),null);
return (f__4405__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4405__auto__.cljs$core$IFn$_invoke$arity$3(ret__4407__auto__,k__4408__auto__,v__4409__auto__) : f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__));
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer(writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer(writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.storage.core.UnresolvedNode{",", ","}",opts__4401__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 14, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$conn,self__.conn],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$config,self__.config],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$network,self__.network],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$dbid,self__.dbid],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$id,self__.id],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$leaf,self__.leaf],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$first,self__.first],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$rhs,self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$size,self__.size],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$block,self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$t,self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$tt_DASH_id,self__.tt_id],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$leftmost_QMARK_,self__.leftmost_QMARK_],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$tempid,self__.tempid],null))], null),self__.__extmap));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__106551){
var self__ = this;
var G__106551__$1 = this;
return (new cljs.core.RecordIter((0),G__106551__$1,14,new cljs.core.PersistentVector(null, 14, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$conn,cljs.core.cst$kw$config,cljs.core.cst$kw$network,cljs.core.cst$kw$dbid,cljs.core.cst$kw$id,cljs.core.cst$kw$leaf,cljs.core.cst$kw$first,cljs.core.cst$kw$rhs,cljs.core.cst$kw$size,cljs.core.cst$kw$block,cljs.core.cst$kw$t,cljs.core.cst$kw$tt_DASH_id,cljs.core.cst$kw$leftmost_QMARK_,cljs.core.cst$kw$tempid], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL;

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.first;
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$empty,self__.id)){
var pc = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pc,fluree.db.index.data_node((0),(0),fluree.db.flake.sorted_set_by(cljs.core.cst$kw$comparator.cljs$core$IFn$_invoke$arity$1(self__.config)),null,self__.config));

return pc;
} else {
var object_cache = cljs.core.cst$kw$object_DASH_cache.cljs$core$IFn$_invoke$arity$1(self__.conn);
var G__106561 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.id,self__.tempid], null);
var G__106562 = ((function (G__106561,object_cache,___$1){
return (function (___$2){
if(cljs.core.truth_(self__.leaf)){
return fluree.db.storage.core.reify_leaf(self__.conn,self__.config,self__.id,self__.block,self__.t,self__.rhs,((function (G__106561,object_cache,___$1){
return (function (){
var G__106563 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.id,self__.tempid], null);
var G__106564 = null;
return (object_cache.cljs$core$IFn$_invoke$arity$2 ? object_cache.cljs$core$IFn$_invoke$arity$2(G__106563,G__106564) : object_cache.call(null,G__106563,G__106564));
});})(G__106561,object_cache,___$1))
);
} else {
return fluree.db.storage.core.reify_branch(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,((function (G__106561,object_cache,___$1){
return (function (){
var G__106565 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [self__.id,self__.tempid], null);
var G__106566 = null;
return (object_cache.cljs$core$IFn$_invoke$arity$2 ? object_cache.cljs$core$IFn$_invoke$arity$2(G__106565,G__106566) : object_cache.call(null,G__106565,G__106566));
});})(G__106561,object_cache,___$1))
);
}
});})(G__106561,object_cache,___$1))
;
return (object_cache.cljs$core$IFn$_invoke$arity$2 ? object_cache.cljs$core$IFn$_invoke$arity$2(G__106561,G__106562) : object_cache.call(null,G__106561,G__106562));
}
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_history$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
var history_id = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.id),"-his"].join('');
var object_cache = cljs.core.cst$kw$object_DASH_cache.cljs$core$IFn$_invoke$arity$1(self__.conn);
var error_fn = ((function (history_id,object_cache,___$1){
return (function (){
return (object_cache.cljs$core$IFn$_invoke$arity$2 ? object_cache.cljs$core$IFn$_invoke$arity$2(history_id,null) : object_cache.call(null,history_id,null));
});})(history_id,object_cache,___$1))
;
var G__106567 = history_id;
var G__106568 = ((function (G__106567,history_id,object_cache,error_fn,___$1){
return (function (___$2){
return fluree.db.storage.core.reify_history(self__.conn,history_id,error_fn);
});})(G__106567,history_id,object_cache,error_fn,___$1))
;
return (object_cache.cljs$core$IFn$_invoke$arity$2 ? object_cache.cljs$core$IFn$_invoke$arity$2(G__106567,G__106568) : object_cache.call(null,G__106567,G__106568));
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_to_t$arity$3 = (function (this$,to_t,idx_novelty){
var self__ = this;
var this$__$1 = this;
return fluree.db.storage.core.resolve_to_t(this$__$1,self__.id,self__.tempid,self__.rhs,self__.leftmost_QMARK_,to_t,self__.tt_id,idx_novelty,self__.conn,false,cljs.core.PersistentHashSet.EMPTY);
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_to_t$arity$4 = (function (this$,to_t,idx_novelty,fast_foward_db_QMARK_){
var self__ = this;
var this$__$1 = this;
return fluree.db.storage.core.resolve_to_t(this$__$1,self__.id,self__.tempid,self__.rhs,self__.leftmost_QMARK_,to_t,self__.tt_id,idx_novelty,self__.conn,fast_foward_db_QMARK_,cljs.core.PersistentHashSet.EMPTY);
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_to_t$arity$5 = (function (this$,to_t,idx_novelty,fast_foward_db_QMARK_,remove_preds){
var self__ = this;
var this$__$1 = this;
return fluree.db.storage.core.resolve_to_t(this$__$1,self__.id,self__.tempid,self__.rhs,self__.leftmost_QMARK_,to_t,self__.tt_id,idx_novelty,self__.conn,fast_foward_db_QMARK_,remove_preds);
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_history_range$arity$3 = (function (node,from_t,to_t){
var self__ = this;
var node__$1 = this;
return fluree.db.storage.core.resolve_history_range(node__$1,from_t,to_t,null,self__.leftmost_QMARK_);
});

fluree.db.storage.core.UnresolvedNode.prototype.fluree$db$dbproto$IResolve$_resolve_history_range$arity$4 = (function (node,from_t,to_t,idx_novelty){
var self__ = this;
var node__$1 = this;
return fluree.db.storage.core.resolve_history_range(node__$1,from_t,to_t,idx_novelty,self__.leftmost_QMARK_);
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (14 + cljs.core.count(self__.__extmap));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = (function (){var fexpr__106569 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (502391120 ^ cljs.core.hash_unordered_coll(coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
;
return fexpr__106569(this__4381__auto____$1);
})();
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this106553,other106554){
var self__ = this;
var this106553__$1 = this;
return (((!((other106554 == null)))) && ((this106553__$1.constructor === other106554.constructor)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.conn,other106554.conn)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.config,other106554.config)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.network,other106554.network)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.dbid,other106554.dbid)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.id,other106554.id)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.leaf,other106554.leaf)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.first,other106554.first)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.rhs,other106554.rhs)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.size,other106554.size)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.block,other106554.block)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.t,other106554.t)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.tt_id,other106554.tt_id)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.leftmost_QMARK_,other106554.leftmost_QMARK_)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.tempid,other106554.tempid)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this106553__$1.__extmap,other106554.__extmap)));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 14, [cljs.core.cst$kw$block,null,cljs.core.cst$kw$dbid,null,cljs.core.cst$kw$config,null,cljs.core.cst$kw$leaf,null,cljs.core.cst$kw$size,null,cljs.core.cst$kw$leftmost_QMARK_,null,cljs.core.cst$kw$id,null,cljs.core.cst$kw$tempid,null,cljs.core.cst$kw$t,null,cljs.core.cst$kw$network,null,cljs.core.cst$kw$first,null,cljs.core.cst$kw$tt_DASH_id,null,cljs.core.cst$kw$rhs,null,cljs.core.cst$kw$conn,null], null), null),k__4395__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__106551){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__106570 = cljs.core.keyword_identical_QMARK_;
var expr__106571 = k__4393__auto__;
if(cljs.core.truth_((function (){var G__106573 = cljs.core.cst$kw$conn;
var G__106574 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106573,G__106574) : pred__106570.call(null,G__106573,G__106574));
})())){
return (new fluree.db.storage.core.UnresolvedNode(G__106551,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106575 = cljs.core.cst$kw$config;
var G__106576 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106575,G__106576) : pred__106570.call(null,G__106575,G__106576));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,G__106551,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106577 = cljs.core.cst$kw$network;
var G__106578 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106577,G__106578) : pred__106570.call(null,G__106577,G__106578));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,G__106551,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106579 = cljs.core.cst$kw$dbid;
var G__106580 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106579,G__106580) : pred__106570.call(null,G__106579,G__106580));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,G__106551,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106581 = cljs.core.cst$kw$id;
var G__106582 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106581,G__106582) : pred__106570.call(null,G__106581,G__106582));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,G__106551,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106583 = cljs.core.cst$kw$leaf;
var G__106584 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106583,G__106584) : pred__106570.call(null,G__106583,G__106584));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,G__106551,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106585 = cljs.core.cst$kw$first;
var G__106586 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106585,G__106586) : pred__106570.call(null,G__106585,G__106586));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,G__106551,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106587 = cljs.core.cst$kw$rhs;
var G__106588 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106587,G__106588) : pred__106570.call(null,G__106587,G__106588));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,G__106551,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106589 = cljs.core.cst$kw$size;
var G__106590 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106589,G__106590) : pred__106570.call(null,G__106589,G__106590));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,G__106551,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106591 = cljs.core.cst$kw$block;
var G__106592 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106591,G__106592) : pred__106570.call(null,G__106591,G__106592));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,G__106551,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106593 = cljs.core.cst$kw$t;
var G__106594 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106593,G__106594) : pred__106570.call(null,G__106593,G__106594));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,G__106551,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106595 = cljs.core.cst$kw$tt_DASH_id;
var G__106596 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106595,G__106596) : pred__106570.call(null,G__106595,G__106596));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,G__106551,self__.leftmost_QMARK_,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106597 = cljs.core.cst$kw$leftmost_QMARK_;
var G__106598 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106597,G__106598) : pred__106570.call(null,G__106597,G__106598));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,G__106551,self__.tempid,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__106599 = cljs.core.cst$kw$tempid;
var G__106600 = expr__106571;
return (pred__106570.cljs$core$IFn$_invoke$arity$2 ? pred__106570.cljs$core$IFn$_invoke$arity$2(G__106599,G__106600) : pred__106570.call(null,G__106599,G__106600));
})())){
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,G__106551,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4393__auto__,G__106551),null));
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 14, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(cljs.core.cst$kw$conn,self__.conn,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$config,self__.config,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$network,self__.network,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$dbid,self__.dbid,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$id,self__.id,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$leaf,self__.leaf,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$first,self__.first,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$rhs,self__.rhs,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$size,self__.size,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$block,self__.block,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$t,self__.t,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$tt_DASH_id,self__.tt_id,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$leftmost_QMARK_,self__.leftmost_QMARK_,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$tempid,self__.tempid,null))], null),self__.__extmap));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__106551){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.storage.core.UnresolvedNode(self__.conn,self__.config,self__.network,self__.dbid,self__.id,self__.leaf,self__.first,self__.rhs,self__.size,self__.block,self__.t,self__.tt_id,self__.leftmost_QMARK_,self__.tempid,G__106551,self__.__extmap,self__.__hash));
});

fluree.db.storage.core.UnresolvedNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.storage.core.UnresolvedNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 14, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$conn,cljs.core.cst$sym$config,cljs.core.cst$sym$network,cljs.core.cst$sym$dbid,cljs.core.cst$sym$id,cljs.core.cst$sym$leaf,cljs.core.cst$sym$first,cljs.core.cst$sym$rhs,cljs.core.cst$sym$size,cljs.core.cst$sym$block,cljs.core.cst$sym$t,cljs.core.cst$sym$tt_DASH_id,cljs.core.cst$sym$leftmost_QMARK_,cljs.core.cst$sym$tempid], null);
});

fluree.db.storage.core.UnresolvedNode.cljs$lang$type = true;

fluree.db.storage.core.UnresolvedNode.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.storage.core/UnresolvedNode",null,(1),null));
});

fluree.db.storage.core.UnresolvedNode.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write(writer__4429__auto__,"fluree.db.storage.core/UnresolvedNode");
});

/**
 * Positional factory function for fluree.db.storage.core/UnresolvedNode.
 */
fluree.db.storage.core.__GT_UnresolvedNode = (function fluree$db$storage$core$__GT_UnresolvedNode(conn,config,network,dbid,id,leaf,first,rhs,size,block,t,tt_id,leftmost_QMARK_,tempid){
return (new fluree.db.storage.core.UnresolvedNode(conn,config,network,dbid,id,leaf,first,rhs,size,block,t,tt_id,leftmost_QMARK_,tempid,null,null,null));
});

/**
 * Factory function for fluree.db.storage.core/UnresolvedNode, taking a map of keywords to field values.
 */
fluree.db.storage.core.map__GT_UnresolvedNode = (function fluree$db$storage$core$map__GT_UnresolvedNode(G__106555){
var extmap__4424__auto__ = (function (){var G__106601 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__106555,cljs.core.cst$kw$conn,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$config,cljs.core.cst$kw$network,cljs.core.cst$kw$dbid,cljs.core.cst$kw$id,cljs.core.cst$kw$leaf,cljs.core.cst$kw$first,cljs.core.cst$kw$rhs,cljs.core.cst$kw$size,cljs.core.cst$kw$block,cljs.core.cst$kw$t,cljs.core.cst$kw$tt_DASH_id,cljs.core.cst$kw$leftmost_QMARK_,cljs.core.cst$kw$tempid], 0));
if(cljs.core.record_QMARK_(G__106555)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__106601);
} else {
return G__106601;
}
})();
return (new fluree.db.storage.core.UnresolvedNode(cljs.core.cst$kw$conn.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$config.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$dbid.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$leaf.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$first.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$rhs.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$size.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$tt_DASH_id.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$leftmost_QMARK_.cljs$core$IFn$_invoke$arity$1(G__106555),cljs.core.cst$kw$tempid.cljs$core$IFn$_invoke$arity$1(G__106555),null,cljs.core.not_empty(extmap__4424__auto__),null));
});

/**
 * Turns each index root node into an unresolved node.
 */
fluree.db.storage.core.reify_index_root = (function fluree$db$storage$core$reify_index_root(conn,index_configs,network,dbid,index,index_data,block,t){
var cfg = (function (){var or__4131__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(index_configs,index);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Internal error reifying db root index: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([index], 0))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error], null));
}
})();
return fluree.db.storage.core.map__GT_UnresolvedNode(cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(index_data,cljs.core.cst$kw$conn,conn,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$config,cfg,cljs.core.cst$kw$network,network,cljs.core.cst$kw$dbid,dbid,cljs.core.cst$kw$block,block,cljs.core.cst$kw$t,t,cljs.core.cst$kw$leftmost_QMARK_,true], 0)));
});
/**
 * Constructs db from blank-db, and ensure index roots have proper config as unresolved nodes.
 */
fluree.db.storage.core.reify_db_root = (function fluree$db$storage$core$reify_db_root(conn,blank_db,root_data){
var map__106603 = blank_db;
var map__106603__$1 = (((((!((map__106603 == null))))?(((((map__106603.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__106603.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__106603):map__106603);
var network = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106603__$1,cljs.core.cst$kw$network);
var dbid = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106603__$1,cljs.core.cst$kw$dbid);
var index_configs = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106603__$1,cljs.core.cst$kw$index_DASH_configs);
var map__106604 = root_data;
var map__106604__$1 = (((((!((map__106604 == null))))?(((((map__106604.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__106604.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__106604):map__106604);
var block = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106604__$1,cljs.core.cst$kw$block);
var t = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106604__$1,cljs.core.cst$kw$t);
var ecount = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106604__$1,cljs.core.cst$kw$ecount);
var stats = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__106604__$1,cljs.core.cst$kw$stats);
var db_STAR_ = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(blank_db,cljs.core.cst$kw$block,block,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$t,t,cljs.core.cst$kw$ecount,ecount,cljs.core.cst$kw$stats,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(stats,cljs.core.cst$kw$indexed,block)], 0));
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (map__106603,map__106603__$1,network,dbid,index_configs,map__106604,map__106604__$1,block,t,ecount,stats,db_STAR_){
return (function (db,idx){
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(db,idx,fluree.db.storage.core.reify_index_root(conn,index_configs,network,dbid,idx,cljs.core.get.cljs$core$IFn$_invoke$arity$2(root_data,idx),block,t));
});})(map__106603,map__106603__$1,network,dbid,index_configs,map__106604,map__106604__$1,block,t,ecount,stats,db_STAR_))
,db_STAR_,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$spot,cljs.core.cst$kw$psot,cljs.core.cst$kw$post,cljs.core.cst$kw$opst], null));
});
/**
 * Returns a all data for a db index root of a given block.
 */
fluree.db.storage.core.read_garbage = (function fluree$db$storage$core$read_garbage(conn,network,dbid,block){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_106625){
var state_val_106626 = (state_106625[(1)]);
if((state_val_106626 === (1))){
var state_106625__$1 = state_106625;
var statearr_106627_106640 = state_106625__$1;
(statearr_106627_106640[(2)] = null);

(statearr_106627_106640[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106626 === (2))){
var inst_106623 = (state_106625[(2)]);
var state_106625__$1 = state_106625;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106625__$1,inst_106623);
} else {
if((state_val_106626 === (3))){
var inst_106607 = (state_106625[(2)]);
var state_106625__$1 = state_106625;
var statearr_106628_106641 = state_106625__$1;
(statearr_106628_106641[(2)] = inst_106607);


cljs.core.async.impl.ioc_helpers.process_exception(state_106625__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106626 === (4))){
var inst_106612 = (state_106625[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106625,(3),Error,null,(2));
var inst_106611 = fluree.db.storage.core.ledger_garbage_key(network,dbid,block);
var inst_106612__$1 = fluree.db.storage.core.storage_read(conn,inst_106611);
var state_106625__$1 = (function (){var statearr_106629 = state_106625;
(statearr_106629[(7)] = inst_106612__$1);

return statearr_106629;
})();
if(cljs.core.truth_(inst_106612__$1)){
var statearr_106630_106642 = state_106625__$1;
(statearr_106630_106642[(1)] = (5));

} else {
var statearr_106631_106643 = state_106625__$1;
(statearr_106631_106643[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106626 === (5))){
var inst_106612 = (state_106625[(7)]);
var inst_106614 = fluree.db.storage.core.serde(conn);
var state_106625__$1 = (function (){var statearr_106632 = state_106625;
(statearr_106632[(8)] = inst_106614);

return statearr_106632;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106625__$1,(8),inst_106612);
} else {
if((state_val_106626 === (6))){
var state_106625__$1 = state_106625;
var statearr_106633_106644 = state_106625__$1;
(statearr_106633_106644[(2)] = null);

(statearr_106633_106644[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106626 === (7))){
var inst_106621 = (state_106625[(2)]);
var state_106625__$1 = state_106625;
var statearr_106634_106645 = state_106625__$1;
(statearr_106634_106645[(2)] = inst_106621);


cljs.core.async.impl.ioc_helpers.process_exception(state_106625__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106626 === (8))){
var inst_106614 = (state_106625[(8)]);
var inst_106616 = (state_106625[(2)]);
var inst_106617 = fluree.db.util.async.throw_err(inst_106616);
var inst_106618 = fluree.db.serde.protocol._deserialize_garbage(inst_106614,inst_106617);
var state_106625__$1 = state_106625;
var statearr_106635_106646 = state_106625__$1;
(statearr_106635_106646[(2)] = inst_106618);

(statearr_106635_106646[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$read_garbage_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$read_garbage_$_state_machine__99703__auto____0 = (function (){
var statearr_106636 = [null,null,null,null,null,null,null,null,null];
(statearr_106636[(0)] = fluree$db$storage$core$read_garbage_$_state_machine__99703__auto__);

(statearr_106636[(1)] = (1));

return statearr_106636;
});
var fluree$db$storage$core$read_garbage_$_state_machine__99703__auto____1 = (function (state_106625){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106625);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106637){if((e106637 instanceof Object)){
var ex__99706__auto__ = e106637;
var statearr_106638_106647 = state_106625;
(statearr_106638_106647[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106625);

return cljs.core.cst$kw$recur;
} else {
throw e106637;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106648 = state_106625;
state_106625 = G__106648;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$read_garbage_$_state_machine__99703__auto__ = function(state_106625){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_garbage_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_garbage_$_state_machine__99703__auto____1.call(this,state_106625);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_garbage_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_garbage_$_state_machine__99703__auto____0;
fluree$db$storage$core$read_garbage_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_garbage_$_state_machine__99703__auto____1;
return fluree$db$storage$core$read_garbage_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_106639 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106639[(6)] = c__99809__auto__);

return statearr_106639;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns a all data for a db index root of a given block.
 */
fluree.db.storage.core.read_db_root = (function fluree$db$storage$core$read_db_root(conn,network,dbid,block){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_106667){
var state_val_106668 = (state_106667[(1)]);
if((state_val_106668 === (1))){
var state_106667__$1 = state_106667;
var statearr_106669_106682 = state_106667__$1;
(statearr_106669_106682[(2)] = null);

(statearr_106669_106682[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106668 === (2))){
var inst_106665 = (state_106667[(2)]);
var state_106667__$1 = state_106667;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106667__$1,inst_106665);
} else {
if((state_val_106668 === (3))){
var inst_106649 = (state_106667[(2)]);
var state_106667__$1 = state_106667;
var statearr_106670_106683 = state_106667__$1;
(statearr_106670_106683[(2)] = inst_106649);


cljs.core.async.impl.ioc_helpers.process_exception(state_106667__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106668 === (4))){
var inst_106654 = (state_106667[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106667,(3),Error,null,(2));
var inst_106653 = fluree.db.storage.core.ledger_root_key(network,dbid,block);
var inst_106654__$1 = fluree.db.storage.core.storage_read(conn,inst_106653);
var state_106667__$1 = (function (){var statearr_106671 = state_106667;
(statearr_106671[(7)] = inst_106654__$1);

return statearr_106671;
})();
if(cljs.core.truth_(inst_106654__$1)){
var statearr_106672_106684 = state_106667__$1;
(statearr_106672_106684[(1)] = (5));

} else {
var statearr_106673_106685 = state_106667__$1;
(statearr_106673_106685[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106668 === (5))){
var inst_106654 = (state_106667[(7)]);
var inst_106656 = fluree.db.storage.core.serde(conn);
var state_106667__$1 = (function (){var statearr_106674 = state_106667;
(statearr_106674[(8)] = inst_106656);

return statearr_106674;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106667__$1,(8),inst_106654);
} else {
if((state_val_106668 === (6))){
var state_106667__$1 = state_106667;
var statearr_106675_106686 = state_106667__$1;
(statearr_106675_106686[(2)] = null);

(statearr_106675_106686[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106668 === (7))){
var inst_106663 = (state_106667[(2)]);
var state_106667__$1 = state_106667;
var statearr_106676_106687 = state_106667__$1;
(statearr_106676_106687[(2)] = inst_106663);


cljs.core.async.impl.ioc_helpers.process_exception(state_106667__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106668 === (8))){
var inst_106656 = (state_106667[(8)]);
var inst_106658 = (state_106667[(2)]);
var inst_106659 = fluree.db.util.async.throw_err(inst_106658);
var inst_106660 = fluree.db.serde.protocol._deserialize_db_root(inst_106656,inst_106659);
var state_106667__$1 = state_106667;
var statearr_106677_106688 = state_106667__$1;
(statearr_106677_106688[(2)] = inst_106660);

(statearr_106677_106688[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$read_db_root_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$read_db_root_$_state_machine__99703__auto____0 = (function (){
var statearr_106678 = [null,null,null,null,null,null,null,null,null];
(statearr_106678[(0)] = fluree$db$storage$core$read_db_root_$_state_machine__99703__auto__);

(statearr_106678[(1)] = (1));

return statearr_106678;
});
var fluree$db$storage$core$read_db_root_$_state_machine__99703__auto____1 = (function (state_106667){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106667);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106679){if((e106679 instanceof Object)){
var ex__99706__auto__ = e106679;
var statearr_106680_106689 = state_106667;
(statearr_106680_106689[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106667);

return cljs.core.cst$kw$recur;
} else {
throw e106679;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106690 = state_106667;
state_106667 = G__106690;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$read_db_root_$_state_machine__99703__auto__ = function(state_106667){
switch(arguments.length){
case 0:
return fluree$db$storage$core$read_db_root_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$read_db_root_$_state_machine__99703__auto____1.call(this,state_106667);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$read_db_root_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$read_db_root_$_state_machine__99703__auto____0;
fluree$db$storage$core$read_db_root_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$read_db_root_$_state_machine__99703__auto____1;
return fluree$db$storage$core$read_db_root_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_106681 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106681[(6)] = c__99809__auto__);

return statearr_106681;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Reifies db at specified index point. If unable to read db-root at index, throws.
 */
fluree.db.storage.core.reify_db = (function fluree$db$storage$core$reify_db(conn,network,dbid,blank_db,index){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_106723){
var state_val_106724 = (state_106723[(1)]);
if((state_val_106724 === (7))){
var inst_106695 = (state_106723[(7)]);
var inst_106705 = (state_106723[(2)]);
var state_106723__$1 = (function (){var statearr_106725 = state_106723;
(statearr_106725[(8)] = inst_106705);

return statearr_106725;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106723__$1,(8),inst_106695);
} else {
if((state_val_106724 === (1))){
var state_106723__$1 = state_106723;
var statearr_106726_106740 = state_106723__$1;
(statearr_106726_106740[(2)] = null);

(statearr_106726_106740[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106724 === (4))){
var inst_106695 = (state_106723[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106723,(3),Error,null,(2));
var inst_106695__$1 = fluree.db.storage.core.read_db_root(conn,network,dbid,index);
var state_106723__$1 = (function (){var statearr_106727 = state_106723;
(statearr_106727[(7)] = inst_106695__$1);

return statearr_106727;
})();
if(cljs.core.truth_(inst_106695__$1)){
var statearr_106728_106741 = state_106723__$1;
(statearr_106728_106741[(1)] = (5));

} else {
var statearr_106729_106742 = state_106723__$1;
(statearr_106729_106742[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106724 === (6))){
var inst_106698 = ["Database ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(network),"/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(dbid)," could not be loaded at index point: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(index),"."].join('');
var inst_106699 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_106700 = [(400),cljs.core.cst$kw$db_SLASH_unavailable];
var inst_106701 = cljs.core.PersistentHashMap.fromArrays(inst_106699,inst_106700);
var inst_106702 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_106698,inst_106701);
var inst_106703 = (function(){throw inst_106702})();
var state_106723__$1 = state_106723;
var statearr_106730_106743 = state_106723__$1;
(statearr_106730_106743[(2)] = inst_106703);

(statearr_106730_106743[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106724 === (3))){
var inst_106691 = (state_106723[(2)]);
var state_106723__$1 = state_106723;
var statearr_106731_106744 = state_106723__$1;
(statearr_106731_106744[(2)] = inst_106691);


cljs.core.async.impl.ioc_helpers.process_exception(state_106723__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106724 === (2))){
var inst_106721 = (state_106723[(2)]);
var state_106723__$1 = state_106723;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106723__$1,inst_106721);
} else {
if((state_val_106724 === (9))){
var inst_106709 = (state_106723[(9)]);
var inst_106714 = (state_106723[(10)]);
var inst_106712 = (state_106723[(2)]);
var inst_106713 = fluree.db.util.async.throw_err(inst_106712);
var inst_106714__$1 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_106709,cljs.core.cst$kw$schema,inst_106713);
var inst_106715 = fluree.db.query.schema.setting_map(inst_106714__$1);
var state_106723__$1 = (function (){var statearr_106732 = state_106723;
(statearr_106732[(10)] = inst_106714__$1);

return statearr_106732;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106723__$1,(10),inst_106715);
} else {
if((state_val_106724 === (5))){
var state_106723__$1 = state_106723;
var statearr_106733_106745 = state_106723__$1;
(statearr_106733_106745[(2)] = null);

(statearr_106733_106745[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106724 === (10))){
var inst_106714 = (state_106723[(10)]);
var inst_106717 = (state_106723[(2)]);
var inst_106718 = fluree.db.util.async.throw_err(inst_106717);
var inst_106719 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_106714,cljs.core.cst$kw$settings,inst_106718);
var state_106723__$1 = state_106723;
var statearr_106734_106746 = state_106723__$1;
(statearr_106734_106746[(2)] = inst_106719);


cljs.core.async.impl.ioc_helpers.process_exception(state_106723__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106724 === (8))){
var inst_106709 = (state_106723[(9)]);
var inst_106707 = (state_106723[(2)]);
var inst_106708 = fluree.db.util.async.throw_err(inst_106707);
var inst_106709__$1 = fluree.db.storage.core.reify_db_root(conn,blank_db,inst_106708);
var inst_106710 = fluree.db.query.schema.schema_map(inst_106709__$1);
var state_106723__$1 = (function (){var statearr_106735 = state_106723;
(statearr_106735[(9)] = inst_106709__$1);

return statearr_106735;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106723__$1,(9),inst_106710);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$reify_db_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$reify_db_$_state_machine__99703__auto____0 = (function (){
var statearr_106736 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_106736[(0)] = fluree$db$storage$core$reify_db_$_state_machine__99703__auto__);

(statearr_106736[(1)] = (1));

return statearr_106736;
});
var fluree$db$storage$core$reify_db_$_state_machine__99703__auto____1 = (function (state_106723){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106723);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106737){if((e106737 instanceof Object)){
var ex__99706__auto__ = e106737;
var statearr_106738_106747 = state_106723;
(statearr_106738_106747[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106723);

return cljs.core.cst$kw$recur;
} else {
throw e106737;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106748 = state_106723;
state_106723 = G__106748;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$reify_db_$_state_machine__99703__auto__ = function(state_106723){
switch(arguments.length){
case 0:
return fluree$db$storage$core$reify_db_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$reify_db_$_state_machine__99703__auto____1.call(this,state_106723);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$reify_db_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$reify_db_$_state_machine__99703__auto____0;
fluree$db$storage$core$reify_db_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$reify_db_$_state_machine__99703__auto____1;
return fluree$db$storage$core$reify_db_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_106739 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106739[(6)] = c__99809__auto__);

return statearr_106739;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns a channel that will contains blocks in specified range.
 */
fluree.db.storage.core.block_range = (function fluree$db$storage$core$block_range(var_args){
var G__106750 = arguments.length;
switch (G__106750) {
case 4:
return fluree.db.storage.core.block_range.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return fluree.db.storage.core.block_range.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.storage.core.block_range.cljs$core$IFn$_invoke$arity$4 = (function (conn,network,dbid,start){
return fluree.db.storage.core.block_range.cljs$core$IFn$_invoke$arity$5(conn,network,dbid,start,null);
});

fluree.db.storage.core.block_range.cljs$core$IFn$_invoke$arity$5 = (function (conn,network,dbid,start,end){
fluree.db.util.log.trace.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Block-range request: ",network,dbid,start,end], 0));

var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_106796){
var state_val_106797 = (state_106796[(1)]);
if((state_val_106797 === (7))){
var inst_106762 = (state_106796[(2)]);
var inst_106763 = cljs.core.cst$kw$parallelism.cljs$core$IFn$_invoke$arity$1(conn);
var inst_106764 = cljs.core.PersistentVector.EMPTY;
var inst_106765 = start;
var inst_106766 = inst_106764;
var state_106796__$1 = (function (){var statearr_106798 = state_106796;
(statearr_106798[(7)] = inst_106763);

(statearr_106798[(8)] = inst_106766);

(statearr_106798[(9)] = inst_106762);

(statearr_106798[(10)] = inst_106765);

return statearr_106798;
})();
var statearr_106799_106827 = state_106796__$1;
(statearr_106799_106827[(2)] = null);

(statearr_106799_106827[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (1))){
var state_106796__$1 = state_106796;
var statearr_106800_106828 = state_106796__$1;
(statearr_106800_106828[(2)] = null);

(statearr_106800_106828[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106796,(3),Error,null,(2));
var inst_106755 = (end >= start);
var state_106796__$1 = state_106796;
if(cljs.core.truth_(inst_106755)){
var statearr_106801_106829 = state_106796__$1;
(statearr_106801_106829[(1)] = (5));

} else {
var statearr_106802_106830 = state_106796__$1;
(statearr_106802_106830[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (15))){
var state_106796__$1 = state_106796;
var statearr_106803_106831 = state_106796__$1;
(statearr_106803_106831[(1)] = (17));



return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (13))){
var inst_106790 = (state_106796[(2)]);
var state_106796__$1 = state_106796;
var statearr_106805_106832 = state_106796__$1;
(statearr_106805_106832[(2)] = inst_106790);

(statearr_106805_106832[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (6))){
var inst_106758 = ["Assert failed: ","Block range should be in ascending order, from earliest (smallest) block to most recent (largest) block.","\n","(>= end start)"].join('');
var inst_106759 = (new Error(inst_106758));
var inst_106760 = (function(){throw inst_106759})();
var state_106796__$1 = state_106796;
var statearr_106806_106833 = state_106796__$1;
(statearr_106806_106833[(2)] = inst_106760);

(statearr_106806_106833[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (17))){
var inst_106770 = (state_106796[(11)]);
var inst_106766 = (state_106796[(8)]);
var inst_106765 = (state_106796[(10)]);
var inst_106781 = (inst_106765 + (1));
var inst_106782 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(inst_106766,inst_106770);
var inst_106765__$1 = inst_106781;
var inst_106766__$1 = inst_106782;
var state_106796__$1 = (function (){var statearr_106807 = state_106796;
(statearr_106807[(8)] = inst_106766__$1);

(statearr_106807[(10)] = inst_106765__$1);

return statearr_106807;
})();
var statearr_106808_106834 = state_106796__$1;
(statearr_106808_106834[(2)] = null);

(statearr_106808_106834[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (3))){
var inst_106751 = (state_106796[(2)]);
var state_106796__$1 = state_106796;
var statearr_106809_106835 = state_106796__$1;
(statearr_106809_106835[(2)] = inst_106751);


cljs.core.async.impl.ioc_helpers.process_exception(state_106796__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (12))){
var inst_106765 = (state_106796[(10)]);
var inst_106776 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_106765,end);
var state_106796__$1 = state_106796;
if(inst_106776){
var statearr_106810_106836 = state_106796__$1;
(statearr_106810_106836[(1)] = (14));

} else {
var statearr_106811_106837 = state_106796__$1;
(statearr_106811_106837[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (2))){
var inst_106794 = (state_106796[(2)]);
var state_106796__$1 = state_106796;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106796__$1,inst_106794);
} else {
if((state_val_106797 === (19))){
var inst_106786 = (state_106796[(2)]);
var state_106796__$1 = state_106796;
var statearr_106812_106838 = state_106796__$1;
(statearr_106812_106838[(2)] = inst_106786);

(statearr_106812_106838[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (11))){
var inst_106766 = (state_106796[(8)]);
var state_106796__$1 = state_106796;
var statearr_106813_106839 = state_106796__$1;
(statearr_106813_106839[(2)] = inst_106766);

(statearr_106813_106839[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (9))){
var inst_106792 = (state_106796[(2)]);
var state_106796__$1 = state_106796;
var statearr_106814_106840 = state_106796__$1;
(statearr_106814_106840[(2)] = inst_106792);


cljs.core.async.impl.ioc_helpers.process_exception(state_106796__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (5))){
var state_106796__$1 = state_106796;
var statearr_106815_106841 = state_106796__$1;
(statearr_106815_106841[(2)] = null);

(statearr_106815_106841[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (14))){
var inst_106770 = (state_106796[(11)]);
var inst_106766 = (state_106796[(8)]);
var inst_106778 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(inst_106766,inst_106770);
var state_106796__$1 = state_106796;
var statearr_106816_106842 = state_106796__$1;
(statearr_106816_106842[(2)] = inst_106778);

(statearr_106816_106842[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (16))){
var inst_106788 = (state_106796[(2)]);
var state_106796__$1 = state_106796;
var statearr_106817_106843 = state_106796__$1;
(statearr_106817_106843[(2)] = inst_106788);

(statearr_106817_106843[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (10))){
var inst_106770 = (state_106796[(11)]);
var inst_106770__$1 = (state_106796[(2)]);
var inst_106771 = (inst_106770__$1 == null);
var inst_106772 = (inst_106770__$1 instanceof Error);
var inst_106773 = ((inst_106771) || (inst_106772));
var state_106796__$1 = (function (){var statearr_106818 = state_106796;
(statearr_106818[(11)] = inst_106770__$1);

return statearr_106818;
})();
if(cljs.core.truth_(inst_106773)){
var statearr_106819_106844 = state_106796__$1;
(statearr_106819_106844[(1)] = (11));

} else {
var statearr_106820_106845 = state_106796__$1;
(statearr_106820_106845[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (18))){
var state_106796__$1 = state_106796;
var statearr_106821_106846 = state_106796__$1;
(statearr_106821_106846[(2)] = null);

(statearr_106821_106846[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106797 === (8))){
var inst_106765 = (state_106796[(10)]);
var inst_106768 = fluree.db.storage.core.read_block(conn,network,dbid,inst_106765);
var state_106796__$1 = state_106796;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106796__$1,(10),inst_106768);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$state_machine__99703__auto__ = null;
var fluree$db$storage$core$state_machine__99703__auto____0 = (function (){
var statearr_106822 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_106822[(0)] = fluree$db$storage$core$state_machine__99703__auto__);

(statearr_106822[(1)] = (1));

return statearr_106822;
});
var fluree$db$storage$core$state_machine__99703__auto____1 = (function (state_106796){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106796);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106823){if((e106823 instanceof Object)){
var ex__99706__auto__ = e106823;
var statearr_106824_106847 = state_106796;
(statearr_106824_106847[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106796);

return cljs.core.cst$kw$recur;
} else {
throw e106823;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106848 = state_106796;
state_106796 = G__106848;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$state_machine__99703__auto__ = function(state_106796){
switch(arguments.length){
case 0:
return fluree$db$storage$core$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$state_machine__99703__auto____1.call(this,state_106796);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$state_machine__99703__auto____0;
fluree$db$storage$core$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$state_machine__99703__auto____1;
return fluree$db$storage$core$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_106825 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106825[(6)] = c__99809__auto__);

return statearr_106825;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

fluree.db.storage.core.block_range.cljs$lang$maxFixedArity = 5;

/**
 * Reads a single block from storage
 */
fluree.db.storage.core.block = (function fluree$db$storage$core$block(conn,network,dbid,block){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_106861){
var state_val_106862 = (state_106861[(1)]);
if((state_val_106862 === (1))){
var state_106861__$1 = state_106861;
var statearr_106863_106870 = state_106861__$1;
(statearr_106863_106870[(2)] = null);

(statearr_106863_106870[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_106862 === (2))){
var inst_106859 = (state_106861[(2)]);
var state_106861__$1 = state_106861;
return cljs.core.async.impl.ioc_helpers.return_chan(state_106861__$1,inst_106859);
} else {
if((state_val_106862 === (3))){
var inst_106849 = (state_106861[(2)]);
var state_106861__$1 = state_106861;
var statearr_106864_106871 = state_106861__$1;
(statearr_106864_106871[(2)] = inst_106849);


cljs.core.async.impl.ioc_helpers.process_exception(state_106861__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_106862 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_106861,(3),Error,null,(2));
var inst_106853 = fluree.db.storage.core.block_range.cljs$core$IFn$_invoke$arity$5(conn,network,dbid,block,block);
var state_106861__$1 = state_106861;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_106861__$1,(5),inst_106853);
} else {
if((state_val_106862 === (5))){
var inst_106855 = (state_106861[(2)]);
var inst_106856 = fluree.db.util.async.throw_err(inst_106855);
var inst_106857 = cljs.core.first(inst_106856);
var state_106861__$1 = state_106861;
var statearr_106865_106872 = state_106861__$1;
(statearr_106865_106872[(2)] = inst_106857);


cljs.core.async.impl.ioc_helpers.process_exception(state_106861__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$storage$core$block_$_state_machine__99703__auto__ = null;
var fluree$db$storage$core$block_$_state_machine__99703__auto____0 = (function (){
var statearr_106866 = [null,null,null,null,null,null,null];
(statearr_106866[(0)] = fluree$db$storage$core$block_$_state_machine__99703__auto__);

(statearr_106866[(1)] = (1));

return statearr_106866;
});
var fluree$db$storage$core$block_$_state_machine__99703__auto____1 = (function (state_106861){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_106861);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e106867){if((e106867 instanceof Object)){
var ex__99706__auto__ = e106867;
var statearr_106868_106873 = state_106861;
(statearr_106868_106873[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_106861);

return cljs.core.cst$kw$recur;
} else {
throw e106867;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__106874 = state_106861;
state_106861 = G__106874;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$storage$core$block_$_state_machine__99703__auto__ = function(state_106861){
switch(arguments.length){
case 0:
return fluree$db$storage$core$block_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$storage$core$block_$_state_machine__99703__auto____1.call(this,state_106861);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$storage$core$block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$storage$core$block_$_state_machine__99703__auto____0;
fluree$db$storage$core$block_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$storage$core$block_$_state_machine__99703__auto____1;
return fluree$db$storage$core$block_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_106869 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_106869[(6)] = c__99809__auto__);

return statearr_106869;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
