// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.connection');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('clojure.string');
goog.require('cljs.core.async');
goog.require('fluree.db.util.json');
goog.require('fluree.db.util.log');
goog.require('cljs.cache');
goog.require('fluree.db.session');
goog.require('fluree.db.util.xhttp');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.async');
goog.require('fluree.db.serde.json');
goog.require('fluree.db.query.http_signatures');
fluree.db.connection.server_connections_atom = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
/**
 * Tries all servers in parralel, the first healthy response will be used for the connection
 *   (additional server healthy writes will be no-ops after first).
 */
fluree.db.connection.acquire_healthy_server = (function fluree$db$connection$acquire_healthy_server(conn_id,servers,promise_chan){
var seq__117390_117553 = cljs.core.seq(servers);
var chunk__117391_117554 = null;
var count__117392_117555 = (0);
var i__117393_117556 = (0);
while(true){
if((i__117393_117556 < count__117392_117555)){
var server_117557 = chunk__117391_117554.cljs$core$IIndexed$_nth$arity$2(null,i__117393_117556);
var healthcheck_uri_117558 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(server_117557),"/fdb/health"].join('');
var resp_chan_117559 = fluree.db.util.xhttp.post_json(healthcheck_uri_117558,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$request_DASH_timeout,(5000)], null));
var c__99809__auto___117560 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,c__99809__auto___117560,healthcheck_uri_117558,resp_chan_117559,server_117557){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,c__99809__auto___117560,healthcheck_uri_117558,resp_chan_117559,server_117557){
return (function (state_117452){
var state_val_117453 = (state_117452[(1)]);
if((state_val_117453 === (1))){
var state_117452__$1 = state_117452;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_117452__$1,(2),resp_chan_117559);
} else {
if((state_val_117453 === (2))){
var inst_117441 = (state_117452[(7)]);
var inst_117441__$1 = (state_117452[(2)]);
var inst_117442 = fluree.db.util.core.exception_QMARK_(inst_117441__$1);
var state_117452__$1 = (function (){var statearr_117454 = state_117452;
(statearr_117454[(7)] = inst_117441__$1);

return statearr_117454;
})();
if(inst_117442){
var statearr_117455_117561 = state_117452__$1;
(statearr_117455_117561[(1)] = (3));

} else {
var statearr_117456_117562 = state_117452__$1;
(statearr_117456_117562[(1)] = (4));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117453 === (3))){
var inst_117441 = (state_117452[(7)]);
var inst_117444 = cljs.core.ex_message(inst_117441);
var inst_117445 = cljs.core.ex_data(inst_117441);
var inst_117446 = fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Server contact error: ",inst_117444,inst_117445], 0));
var state_117452__$1 = state_117452;
var statearr_117457_117563 = state_117452__$1;
(statearr_117457_117563[(2)] = inst_117446);

(statearr_117457_117563[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117453 === (4))){
var inst_117448 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(promise_chan,server_117557);
var state_117452__$1 = state_117452;
var statearr_117458_117564 = state_117452__$1;
(statearr_117458_117564[(2)] = inst_117448);

(statearr_117458_117564[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117453 === (5))){
var inst_117450 = (state_117452[(2)]);
var state_117452__$1 = state_117452;
return cljs.core.async.impl.ioc_helpers.return_chan(state_117452__$1,inst_117450);
} else {
return null;
}
}
}
}
}
});})(seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,c__99809__auto___117560,healthcheck_uri_117558,resp_chan_117559,server_117557))
;
return ((function (seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,switch__99702__auto__,c__99809__auto___117560,healthcheck_uri_117558,resp_chan_117559,server_117557){
return (function() {
var fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__ = null;
var fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____0 = (function (){
var statearr_117459 = [null,null,null,null,null,null,null,null];
(statearr_117459[(0)] = fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__);

(statearr_117459[(1)] = (1));

return statearr_117459;
});
var fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____1 = (function (state_117452){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_117452);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e117460){if((e117460 instanceof Object)){
var ex__99706__auto__ = e117460;
var statearr_117461_117565 = state_117452;
(statearr_117461_117565[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_117452);

return cljs.core.cst$kw$recur;
} else {
throw e117460;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__117566 = state_117452;
state_117452 = G__117566;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__ = function(state_117452){
switch(arguments.length){
case 0:
return fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____1.call(this,state_117452);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____0;
fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____1;
return fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__;
})()
;})(seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,switch__99702__auto__,c__99809__auto___117560,healthcheck_uri_117558,resp_chan_117559,server_117557))
})();
var state__99811__auto__ = (function (){var statearr_117462 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_117462[(6)] = c__99809__auto___117560);

return statearr_117462;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,c__99809__auto___117560,healthcheck_uri_117558,resp_chan_117559,server_117557))
);



var G__117567 = seq__117390_117553;
var G__117568 = chunk__117391_117554;
var G__117569 = count__117392_117555;
var G__117570 = (i__117393_117556 + (1));
seq__117390_117553 = G__117567;
chunk__117391_117554 = G__117568;
count__117392_117555 = G__117569;
i__117393_117556 = G__117570;
continue;
} else {
var temp__5735__auto___117571 = cljs.core.seq(seq__117390_117553);
if(temp__5735__auto___117571){
var seq__117390_117572__$1 = temp__5735__auto___117571;
if(cljs.core.chunked_seq_QMARK_(seq__117390_117572__$1)){
var c__4550__auto___117573 = cljs.core.chunk_first(seq__117390_117572__$1);
var G__117574 = cljs.core.chunk_rest(seq__117390_117572__$1);
var G__117575 = c__4550__auto___117573;
var G__117576 = cljs.core.count(c__4550__auto___117573);
var G__117577 = (0);
seq__117390_117553 = G__117574;
chunk__117391_117554 = G__117575;
count__117392_117555 = G__117576;
i__117393_117556 = G__117577;
continue;
} else {
var server_117578 = cljs.core.first(seq__117390_117572__$1);
var healthcheck_uri_117579 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(server_117578),"/fdb/health"].join('');
var resp_chan_117580 = fluree.db.util.xhttp.post_json(healthcheck_uri_117579,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$request_DASH_timeout,(5000)], null));
var c__99809__auto___117581 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,c__99809__auto___117581,healthcheck_uri_117579,resp_chan_117580,server_117578,seq__117390_117572__$1,temp__5735__auto___117571){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,c__99809__auto___117581,healthcheck_uri_117579,resp_chan_117580,server_117578,seq__117390_117572__$1,temp__5735__auto___117571){
return (function (state_117475){
var state_val_117476 = (state_117475[(1)]);
if((state_val_117476 === (1))){
var state_117475__$1 = state_117475;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_117475__$1,(2),resp_chan_117580);
} else {
if((state_val_117476 === (2))){
var inst_117464 = (state_117475[(7)]);
var inst_117464__$1 = (state_117475[(2)]);
var inst_117465 = fluree.db.util.core.exception_QMARK_(inst_117464__$1);
var state_117475__$1 = (function (){var statearr_117477 = state_117475;
(statearr_117477[(7)] = inst_117464__$1);

return statearr_117477;
})();
if(inst_117465){
var statearr_117478_117582 = state_117475__$1;
(statearr_117478_117582[(1)] = (3));

} else {
var statearr_117479_117583 = state_117475__$1;
(statearr_117479_117583[(1)] = (4));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117476 === (3))){
var inst_117464 = (state_117475[(7)]);
var inst_117467 = cljs.core.ex_message(inst_117464);
var inst_117468 = cljs.core.ex_data(inst_117464);
var inst_117469 = fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Server contact error: ",inst_117467,inst_117468], 0));
var state_117475__$1 = state_117475;
var statearr_117480_117584 = state_117475__$1;
(statearr_117480_117584[(2)] = inst_117469);

(statearr_117480_117584[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117476 === (4))){
var inst_117471 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(promise_chan,server_117578);
var state_117475__$1 = state_117475;
var statearr_117481_117585 = state_117475__$1;
(statearr_117481_117585[(2)] = inst_117471);

(statearr_117481_117585[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117476 === (5))){
var inst_117473 = (state_117475[(2)]);
var state_117475__$1 = state_117475;
return cljs.core.async.impl.ioc_helpers.return_chan(state_117475__$1,inst_117473);
} else {
return null;
}
}
}
}
}
});})(seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,c__99809__auto___117581,healthcheck_uri_117579,resp_chan_117580,server_117578,seq__117390_117572__$1,temp__5735__auto___117571))
;
return ((function (seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,switch__99702__auto__,c__99809__auto___117581,healthcheck_uri_117579,resp_chan_117580,server_117578,seq__117390_117572__$1,temp__5735__auto___117571){
return (function() {
var fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__ = null;
var fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____0 = (function (){
var statearr_117482 = [null,null,null,null,null,null,null,null];
(statearr_117482[(0)] = fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__);

(statearr_117482[(1)] = (1));

return statearr_117482;
});
var fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____1 = (function (state_117475){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_117475);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e117483){if((e117483 instanceof Object)){
var ex__99706__auto__ = e117483;
var statearr_117484_117586 = state_117475;
(statearr_117484_117586[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_117475);

return cljs.core.cst$kw$recur;
} else {
throw e117483;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__117587 = state_117475;
state_117475 = G__117587;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__ = function(state_117475){
switch(arguments.length){
case 0:
return fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____1.call(this,state_117475);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____0;
fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____1;
return fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__;
})()
;})(seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,switch__99702__auto__,c__99809__auto___117581,healthcheck_uri_117579,resp_chan_117580,server_117578,seq__117390_117572__$1,temp__5735__auto___117571))
})();
var state__99811__auto__ = (function (){var statearr_117485 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_117485[(6)] = c__99809__auto___117581);

return statearr_117485;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(seq__117390_117553,chunk__117391_117554,count__117392_117555,i__117393_117556,c__99809__auto___117581,healthcheck_uri_117579,resp_chan_117580,server_117578,seq__117390_117572__$1,temp__5735__auto___117571))
);



var G__117588 = cljs.core.next(seq__117390_117572__$1);
var G__117589 = null;
var G__117590 = (0);
var G__117591 = (0);
seq__117390_117553 = G__117588;
chunk__117391_117554 = G__117589;
count__117392_117555 = G__117590;
i__117393_117556 = G__117591;
continue;
}
} else {
}
}
break;
}

var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_117528){
var state_val_117529 = (state_117528[(1)]);
if((state_val_117529 === (7))){
var inst_117500 = (state_117528[(7)]);
var inst_117507 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_117500,cljs.core.cst$kw$default);
var state_117528__$1 = state_117528;
if(inst_117507){
var statearr_117530_117592 = state_117528__$1;
(statearr_117530_117592[(1)] = (9));

} else {
var statearr_117531_117593 = state_117528__$1;
(statearr_117531_117593[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (1))){
var inst_117493 = (state_117528[(8)]);
var inst_117493__$1 = cljs.core.async.timeout((60000));
var inst_117494 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_117495 = [promise_chan,inst_117493__$1];
var inst_117496 = (new cljs.core.PersistentVector(null,2,(5),inst_117494,inst_117495,null));
var state_117528__$1 = (function (){var statearr_117532 = state_117528;
(statearr_117532[(8)] = inst_117493__$1);

return statearr_117532;
})();
return cljs.core.async.ioc_alts_BANG_(state_117528__$1,(2),inst_117496);
} else {
if((state_val_117529 === (4))){
var inst_117500 = (state_117528[(7)]);
var inst_117493 = (state_117528[(8)]);
var inst_117504 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_117500,inst_117493);
var state_117528__$1 = state_117528;
if(inst_117504){
var statearr_117533_117594 = state_117528__$1;
(statearr_117533_117594[(1)] = (6));

} else {
var statearr_117534_117595 = state_117528__$1;
(statearr_117534_117595[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (13))){
var state_117528__$1 = state_117528;
var statearr_117535_117596 = state_117528__$1;
(statearr_117535_117596[(2)] = null);

(statearr_117535_117596[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (6))){
var state_117528__$1 = state_117528;
var statearr_117536_117597 = state_117528__$1;
(statearr_117536_117597[(2)] = cljs.core.cst$kw$fluree$db$connection_SLASH_timeout);

(statearr_117536_117597[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (3))){
var state_117528__$1 = state_117528;
var statearr_117537_117598 = state_117528__$1;
(statearr_117537_117598[(2)] = cljs.core.cst$kw$fluree$db$connection_SLASH_server_DASH_found);

(statearr_117537_117598[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (12))){
var inst_117518 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$variadic(fluree.db.connection.server_connections_atom,cljs.core.update,conn_id,cljs.core.dissoc,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$server], 0));
var inst_117519 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_117520 = [(500),cljs.core.cst$kw$db_SLASH_connection_DASH_error];
var inst_117521 = cljs.core.PersistentHashMap.fromArrays(inst_117519,inst_117520);
var inst_117522 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Unable to find healthy server before timeout.",inst_117521);
var inst_117523 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(promise_chan,inst_117522);
var state_117528__$1 = (function (){var statearr_117538 = state_117528;
(statearr_117538[(9)] = inst_117518);

return statearr_117538;
})();
var statearr_117539_117599 = state_117528__$1;
(statearr_117539_117599[(2)] = inst_117523);

(statearr_117539_117599[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (2))){
var inst_117500 = (state_117528[(7)]);
var inst_117498 = (state_117528[(2)]);
var inst_117499 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117498,(0),null);
var inst_117500__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117498,(1),null);
var inst_117501 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_117500__$1,promise_chan);
var state_117528__$1 = (function (){var statearr_117540 = state_117528;
(statearr_117540[(10)] = inst_117499);

(statearr_117540[(7)] = inst_117500__$1);

return statearr_117540;
})();
if(inst_117501){
var statearr_117541_117600 = state_117528__$1;
(statearr_117541_117600[(1)] = (3));

} else {
var statearr_117542_117601 = state_117528__$1;
(statearr_117542_117601[(1)] = (4));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (11))){
var inst_117511 = (state_117528[(2)]);
var state_117528__$1 = state_117528;
var statearr_117543_117602 = state_117528__$1;
(statearr_117543_117602[(2)] = inst_117511);

(statearr_117543_117602[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (9))){
var inst_117499 = (state_117528[(10)]);
var state_117528__$1 = state_117528;
var statearr_117544_117603 = state_117528__$1;
(statearr_117544_117603[(2)] = inst_117499);

(statearr_117544_117603[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (5))){
var inst_117515 = (state_117528[(2)]);
var inst_117516 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$fluree$db$connection_SLASH_timeout,inst_117515);
var state_117528__$1 = state_117528;
if(inst_117516){
var statearr_117545_117604 = state_117528__$1;
(statearr_117545_117604[(1)] = (12));

} else {
var statearr_117546_117605 = state_117528__$1;
(statearr_117546_117605[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (14))){
var inst_117526 = (state_117528[(2)]);
var state_117528__$1 = state_117528;
return cljs.core.async.impl.ioc_helpers.return_chan(state_117528__$1,inst_117526);
} else {
if((state_val_117529 === (10))){
var state_117528__$1 = state_117528;
var statearr_117547_117606 = state_117528__$1;
(statearr_117547_117606[(2)] = null);

(statearr_117547_117606[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117529 === (8))){
var inst_117513 = (state_117528[(2)]);
var state_117528__$1 = state_117528;
var statearr_117548_117607 = state_117528__$1;
(statearr_117548_117607[(2)] = inst_117513);

(statearr_117548_117607[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__ = null;
var fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____0 = (function (){
var statearr_117549 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_117549[(0)] = fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__);

(statearr_117549[(1)] = (1));

return statearr_117549;
});
var fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____1 = (function (state_117528){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_117528);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e117550){if((e117550 instanceof Object)){
var ex__99706__auto__ = e117550;
var statearr_117551_117608 = state_117528;
(statearr_117551_117608[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_117528);

return cljs.core.cst$kw$recur;
} else {
throw e117550;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__117609 = state_117528;
state_117528 = G__117609;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__ = function(state_117528){
switch(arguments.length){
case 0:
return fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____1.call(this,state_117528);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____0;
fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto____1;
return fluree$db$connection$acquire_healthy_server_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_117552 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_117552[(6)] = c__99809__auto__);

return statearr_117552;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns a core async channel that will contain first healthy as it appears.
 * 
 *   Use with a timeout to consume, as no healthy servers may be avail.
 */
fluree.db.connection.get_healthy_server = (function fluree$db$connection$get_healthy_server(conn_id,servers){
var lock_id = fluree.db.util.core.random_uuid();
var new_state = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(fluree.db.connection.server_connections_atom,cljs.core.update_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$server], null),((function (lock_id){
return (function (x){
if(cljs.core.truth_(x)){
return x;
} else {
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$lock_DASH_id,lock_id,cljs.core.cst$kw$chan,cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0()], null);
}
});})(lock_id))
);
var have_lock_QMARK_ = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(lock_id,cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(new_state,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$server,cljs.core.cst$kw$lock_DASH_id], null)));
var promise_chan = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(new_state,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$server,cljs.core.cst$kw$chan], null));
if(have_lock_QMARK_){
fluree.db.connection.acquire_healthy_server(conn_id,servers,promise_chan);
} else {
}

return promise_chan;
});
fluree.db.connection.establish_socket = (function fluree$db$connection$establish_socket(conn_id,sub_chan,pub_chan,servers){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_117650){
var state_val_117651 = (state_117650[(1)]);
if((state_val_117651 === (7))){
var inst_117628 = (state_117650[(7)]);
var inst_117646 = (state_117650[(2)]);
var state_117650__$1 = (function (){var statearr_117652 = state_117650;
(statearr_117652[(8)] = inst_117646);

return statearr_117652;
})();
var statearr_117653_117671 = state_117650__$1;
(statearr_117653_117671[(2)] = inst_117628);


cljs.core.async.impl.ioc_helpers.process_exception(state_117650__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_117651 === (1))){
var state_117650__$1 = state_117650;
var statearr_117654_117672 = state_117650__$1;
(statearr_117654_117672[(2)] = null);

(statearr_117654_117672[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117651 === (4))){
var inst_117624 = (state_117650[(9)]);
var inst_117614 = (state_117650[(10)]);
var inst_117619 = (state_117650[(11)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_117650,(3),Error,null,(2));
var inst_117614__$1 = fluree.db.util.core.random_uuid();
var inst_117615 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_117616 = [conn_id,cljs.core.cst$kw$ws];
var inst_117617 = (new cljs.core.PersistentVector(null,2,(5),inst_117615,inst_117616,null));
var inst_117618 = (function (){var lock_id = inst_117614__$1;
return ((function (lock_id,inst_117624,inst_117614,inst_117619,_,inst_117614__$1,inst_117615,inst_117616,inst_117617,state_val_117651,c__99809__auto__){
return (function (x){
if(cljs.core.truth_(x)){
return x;
} else {
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$lock_DASH_id,lock_id,cljs.core.cst$kw$socket,cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0()], null);
}
});
;})(lock_id,inst_117624,inst_117614,inst_117619,_,inst_117614__$1,inst_117615,inst_117616,inst_117617,state_val_117651,c__99809__auto__))
})();
var inst_117619__$1 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(fluree.db.connection.server_connections_atom,cljs.core.update_in,inst_117617,inst_117618);
var inst_117620 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_117621 = [conn_id,cljs.core.cst$kw$ws,cljs.core.cst$kw$lock_DASH_id];
var inst_117622 = (new cljs.core.PersistentVector(null,3,(5),inst_117620,inst_117621,null));
var inst_117623 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(inst_117619__$1,inst_117622);
var inst_117624__$1 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_117614__$1,inst_117623);
var inst_117625 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_117626 = [conn_id,cljs.core.cst$kw$ws,cljs.core.cst$kw$socket];
var inst_117627 = (new cljs.core.PersistentVector(null,3,(5),inst_117625,inst_117626,null));
var inst_117628 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(inst_117619__$1,inst_117627);
var state_117650__$1 = (function (){var statearr_117655 = state_117650;
(statearr_117655[(7)] = inst_117628);

(statearr_117655[(9)] = inst_117624__$1);

(statearr_117655[(10)] = inst_117614__$1);

(statearr_117655[(11)] = inst_117619__$1);

return statearr_117655;
})();
if(inst_117624__$1){
var statearr_117656_117673 = state_117650__$1;
(statearr_117656_117673[(1)] = (5));

} else {
var statearr_117657_117674 = state_117650__$1;
(statearr_117657_117674[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117651 === (6))){
var state_117650__$1 = state_117650;
var statearr_117658_117675 = state_117650__$1;
(statearr_117658_117675[(2)] = null);

(statearr_117658_117675[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117651 === (3))){
var inst_117610 = (state_117650[(2)]);
var state_117650__$1 = state_117650;
var statearr_117659_117676 = state_117650__$1;
(statearr_117659_117676[(2)] = inst_117610);


cljs.core.async.impl.ioc_helpers.process_exception(state_117650__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_117651 === (2))){
var inst_117648 = (state_117650[(2)]);
var state_117650__$1 = state_117650;
return cljs.core.async.impl.ioc_helpers.return_chan(state_117650__$1,inst_117648);
} else {
if((state_val_117651 === (11))){
var inst_117643 = (state_117650[(2)]);
var state_117650__$1 = state_117650;
var statearr_117660_117677 = state_117650__$1;
(statearr_117660_117677[(2)] = inst_117643);

(statearr_117660_117677[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117651 === (9))){
var inst_117628 = (state_117650[(7)]);
var inst_117632 = (state_117650[(12)]);
var inst_117638 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$variadic(fluree.db.connection.server_connections_atom,cljs.core.update,conn_id,cljs.core.dissoc,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$ws], 0));
var inst_117639 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(inst_117628,inst_117632);
var state_117650__$1 = (function (){var statearr_117661 = state_117650;
(statearr_117661[(13)] = inst_117638);

return statearr_117661;
})();
var statearr_117662_117678 = state_117650__$1;
(statearr_117662_117678[(2)] = inst_117639);

(statearr_117662_117678[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117651 === (5))){
var inst_117630 = fluree.db.connection.get_healthy_server(conn_id,servers);
var state_117650__$1 = state_117650;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_117650__$1,(8),inst_117630);
} else {
if((state_val_117651 === (10))){
var inst_117628 = (state_117650[(7)]);
var inst_117635 = (state_117650[(14)]);
var inst_117634 = (state_117650[(15)]);
var inst_117641 = fluree.db.util.xhttp.try_socket(inst_117634,sub_chan,pub_chan,inst_117628,(60000),inst_117635);
var state_117650__$1 = state_117650;
var statearr_117663_117679 = state_117650__$1;
(statearr_117663_117679[(2)] = inst_117641);

(statearr_117663_117679[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117651 === (8))){
var inst_117628 = (state_117650[(7)]);
var inst_117632 = (state_117650[(12)]);
var inst_117624 = (state_117650[(9)]);
var inst_117634 = (state_117650[(15)]);
var inst_117614 = (state_117650[(10)]);
var inst_117619 = (state_117650[(11)]);
var inst_117632__$1 = (state_117650[(2)]);
var inst_117633 = clojure.string.replace(inst_117632__$1,"http","ws");
var inst_117634__$1 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_117633),"/fdb/ws"].join('');
var inst_117635 = (function (){var lock_id = inst_117614;
var state = inst_117619;
var have_lock_QMARK_ = inst_117624;
var resp_chan = inst_117628;
var healthy_server = inst_117632__$1;
var ws_url = inst_117634__$1;
var timeout = (60000);
return ((function (lock_id,state,have_lock_QMARK_,resp_chan,healthy_server,ws_url,timeout,inst_117628,inst_117632,inst_117624,inst_117634,inst_117614,inst_117619,inst_117632__$1,inst_117633,inst_117634__$1,state_val_117651,c__99809__auto__){
return (function (){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(fluree.db.connection.server_connections_atom,cljs.core.dissoc,conn_id);

return fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$1(conn_id);
});
;})(lock_id,state,have_lock_QMARK_,resp_chan,healthy_server,ws_url,timeout,inst_117628,inst_117632,inst_117624,inst_117634,inst_117614,inst_117619,inst_117632__$1,inst_117633,inst_117634__$1,state_val_117651,c__99809__auto__))
})();
var inst_117636 = fluree.db.util.core.exception_QMARK_(inst_117632__$1);
var state_117650__$1 = (function (){var statearr_117664 = state_117650;
(statearr_117664[(12)] = inst_117632__$1);

(statearr_117664[(14)] = inst_117635);

(statearr_117664[(15)] = inst_117634__$1);

return statearr_117664;
})();
if(inst_117636){
var statearr_117665_117680 = state_117650__$1;
(statearr_117665_117680[(1)] = (9));

} else {
var statearr_117666_117681 = state_117650__$1;
(statearr_117666_117681[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$connection$establish_socket_$_state_machine__99703__auto__ = null;
var fluree$db$connection$establish_socket_$_state_machine__99703__auto____0 = (function (){
var statearr_117667 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_117667[(0)] = fluree$db$connection$establish_socket_$_state_machine__99703__auto__);

(statearr_117667[(1)] = (1));

return statearr_117667;
});
var fluree$db$connection$establish_socket_$_state_machine__99703__auto____1 = (function (state_117650){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_117650);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e117668){if((e117668 instanceof Object)){
var ex__99706__auto__ = e117668;
var statearr_117669_117682 = state_117650;
(statearr_117669_117682[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_117650);

return cljs.core.cst$kw$recur;
} else {
throw e117668;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__117683 = state_117650;
state_117650 = G__117683;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$connection$establish_socket_$_state_machine__99703__auto__ = function(state_117650){
switch(arguments.length){
case 0:
return fluree$db$connection$establish_socket_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$connection$establish_socket_$_state_machine__99703__auto____1.call(this,state_117650);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$establish_socket_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$establish_socket_$_state_machine__99703__auto____0;
fluree$db$connection$establish_socket_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$establish_socket_$_state_machine__99703__auto____1;
return fluree$db$connection$establish_socket_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_117670 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_117670[(6)] = c__99809__auto__);

return statearr_117670;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.connection.Connection = (function (id,servers,state,req_chan,sub_chan,pub_chan,storage_read,storage_write,object_cache,parallelism,serializer,default_network,transactor_QMARK_,publish,transact_handler,tx_private_key,tx_key_id,meta,add_listener,remove_listener,close,__meta,__extmap,__hash){
this.id = id;
this.servers = servers;
this.state = state;
this.req_chan = req_chan;
this.sub_chan = sub_chan;
this.pub_chan = pub_chan;
this.storage_read = storage_read;
this.storage_write = storage_write;
this.object_cache = object_cache;
this.parallelism = parallelism;
this.serializer = serializer;
this.default_network = default_network;
this.transactor_QMARK_ = transactor_QMARK_;
this.publish = publish;
this.transact_handler = transact_handler;
this.tx_private_key = tx_private_key;
this.tx_key_id = tx_key_id;
this.meta = meta;
this.add_listener = add_listener;
this.remove_listener = remove_listener;
this.close = close;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.connection.Connection.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.connection.Connection.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k117685,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__117689 = k117685;
var G__117689__$1 = (((G__117689 instanceof cljs.core.Keyword))?G__117689.fqn:null);
switch (G__117689__$1) {
case "id":
return self__.id;

break;
case "servers":
return self__.servers;

break;
case "state":
return self__.state;

break;
case "req-chan":
return self__.req_chan;

break;
case "sub-chan":
return self__.sub_chan;

break;
case "pub-chan":
return self__.pub_chan;

break;
case "storage-read":
return self__.storage_read;

break;
case "storage-write":
return self__.storage_write;

break;
case "object-cache":
return self__.object_cache;

break;
case "parallelism":
return self__.parallelism;

break;
case "serializer":
return self__.serializer;

break;
case "default-network":
return self__.default_network;

break;
case "transactor?":
return self__.transactor_QMARK_;

break;
case "publish":
return self__.publish;

break;
case "transact-handler":
return self__.transact_handler;

break;
case "tx-private-key":
return self__.tx_private_key;

break;
case "tx-key-id":
return self__.tx_key_id;

break;
case "meta":
return self__.meta;

break;
case "add-listener":
return self__.add_listener;

break;
case "remove-listener":
return self__.remove_listener;

break;
case "close":
return self__.close;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k117685,else__4388__auto__);

}
});

fluree.db.connection.Connection.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__117690){
var vec__117691 = p__117690;
var k__4408__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117691,(0),null);
var v__4409__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117691,(1),null);
return (f__4405__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4405__auto__.cljs$core$IFn$_invoke$arity$3(ret__4407__auto__,k__4408__auto__,v__4409__auto__) : f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__));
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.connection.Connection.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer(writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer(writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.connection.Connection{",", ","}",opts__4401__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 21, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$id,self__.id],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$servers,self__.servers],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$state,self__.state],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$req_DASH_chan,self__.req_chan],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$sub_DASH_chan,self__.sub_chan],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$pub_DASH_chan,self__.pub_chan],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$storage_DASH_read,self__.storage_read],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$storage_DASH_write,self__.storage_write],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$object_DASH_cache,self__.object_cache],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$parallelism,self__.parallelism],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$serializer,self__.serializer],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$default_DASH_network,self__.default_network],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$transactor_QMARK_,self__.transactor_QMARK_],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$publish,self__.publish],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$transact_DASH_handler,self__.transact_handler],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$tx_DASH_private_DASH_key,self__.tx_private_key],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$tx_DASH_key_DASH_id,self__.tx_key_id],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$meta,self__.meta],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$add_DASH_listener,self__.add_listener],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$remove_DASH_listener,self__.remove_listener],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.cst$kw$close,self__.close],null))], null),self__.__extmap));
});

fluree.db.connection.Connection.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__117684){
var self__ = this;
var G__117684__$1 = this;
return (new cljs.core.RecordIter((0),G__117684__$1,21,new cljs.core.PersistentVector(null, 21, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$id,cljs.core.cst$kw$servers,cljs.core.cst$kw$state,cljs.core.cst$kw$req_DASH_chan,cljs.core.cst$kw$sub_DASH_chan,cljs.core.cst$kw$pub_DASH_chan,cljs.core.cst$kw$storage_DASH_read,cljs.core.cst$kw$storage_DASH_write,cljs.core.cst$kw$object_DASH_cache,cljs.core.cst$kw$parallelism,cljs.core.cst$kw$serializer,cljs.core.cst$kw$default_DASH_network,cljs.core.cst$kw$transactor_QMARK_,cljs.core.cst$kw$publish,cljs.core.cst$kw$transact_DASH_handler,cljs.core.cst$kw$tx_DASH_private_DASH_key,cljs.core.cst$kw$tx_DASH_key_DASH_id,cljs.core.cst$kw$meta,cljs.core.cst$kw$add_DASH_listener,cljs.core.cst$kw$remove_DASH_listener,cljs.core.cst$kw$close], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
});

fluree.db.connection.Connection.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.connection.Connection.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.connection.Connection.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (21 + cljs.core.count(self__.__extmap));
});

fluree.db.connection.Connection.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = (function (){var fexpr__117694 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (1865480964 ^ cljs.core.hash_unordered_coll(coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
;
return fexpr__117694(this__4381__auto____$1);
})();
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.connection.Connection.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this117686,other117687){
var self__ = this;
var this117686__$1 = this;
return (((!((other117687 == null)))) && ((this117686__$1.constructor === other117687.constructor)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.id,other117687.id)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.servers,other117687.servers)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.state,other117687.state)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.req_chan,other117687.req_chan)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.sub_chan,other117687.sub_chan)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.pub_chan,other117687.pub_chan)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.storage_read,other117687.storage_read)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.storage_write,other117687.storage_write)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.object_cache,other117687.object_cache)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.parallelism,other117687.parallelism)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.serializer,other117687.serializer)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.default_network,other117687.default_network)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.transactor_QMARK_,other117687.transactor_QMARK_)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.publish,other117687.publish)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.transact_handler,other117687.transact_handler)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.tx_private_key,other117687.tx_private_key)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.tx_key_id,other117687.tx_key_id)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.meta,other117687.meta)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.add_listener,other117687.add_listener)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.remove_listener,other117687.remove_listener)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.close,other117687.close)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this117686__$1.__extmap,other117687.__extmap)));
});

fluree.db.connection.Connection.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 21, [cljs.core.cst$kw$object_DASH_cache,null,cljs.core.cst$kw$default_DASH_network,null,cljs.core.cst$kw$parallelism,null,cljs.core.cst$kw$transact_DASH_handler,null,cljs.core.cst$kw$add_DASH_listener,null,cljs.core.cst$kw$meta,null,cljs.core.cst$kw$tx_DASH_private_DASH_key,null,cljs.core.cst$kw$remove_DASH_listener,null,cljs.core.cst$kw$transactor_QMARK_,null,cljs.core.cst$kw$storage_DASH_read,null,cljs.core.cst$kw$serializer,null,cljs.core.cst$kw$state,null,cljs.core.cst$kw$close,null,cljs.core.cst$kw$tx_DASH_key_DASH_id,null,cljs.core.cst$kw$storage_DASH_write,null,cljs.core.cst$kw$req_DASH_chan,null,cljs.core.cst$kw$id,null,cljs.core.cst$kw$servers,null,cljs.core.cst$kw$pub_DASH_chan,null,cljs.core.cst$kw$sub_DASH_chan,null,cljs.core.cst$kw$publish,null], null), null),k__4395__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.connection.Connection.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__117684){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__117695 = cljs.core.keyword_identical_QMARK_;
var expr__117696 = k__4393__auto__;
if(cljs.core.truth_((function (){var G__117698 = cljs.core.cst$kw$id;
var G__117699 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117698,G__117699) : pred__117695.call(null,G__117698,G__117699));
})())){
return (new fluree.db.connection.Connection(G__117684,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117700 = cljs.core.cst$kw$servers;
var G__117701 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117700,G__117701) : pred__117695.call(null,G__117700,G__117701));
})())){
return (new fluree.db.connection.Connection(self__.id,G__117684,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117702 = cljs.core.cst$kw$state;
var G__117703 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117702,G__117703) : pred__117695.call(null,G__117702,G__117703));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,G__117684,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117704 = cljs.core.cst$kw$req_DASH_chan;
var G__117705 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117704,G__117705) : pred__117695.call(null,G__117704,G__117705));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,G__117684,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117706 = cljs.core.cst$kw$sub_DASH_chan;
var G__117707 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117706,G__117707) : pred__117695.call(null,G__117706,G__117707));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,G__117684,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117708 = cljs.core.cst$kw$pub_DASH_chan;
var G__117709 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117708,G__117709) : pred__117695.call(null,G__117708,G__117709));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,G__117684,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117710 = cljs.core.cst$kw$storage_DASH_read;
var G__117711 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117710,G__117711) : pred__117695.call(null,G__117710,G__117711));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,G__117684,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117712 = cljs.core.cst$kw$storage_DASH_write;
var G__117713 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117712,G__117713) : pred__117695.call(null,G__117712,G__117713));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,G__117684,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117714 = cljs.core.cst$kw$object_DASH_cache;
var G__117715 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117714,G__117715) : pred__117695.call(null,G__117714,G__117715));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,G__117684,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117716 = cljs.core.cst$kw$parallelism;
var G__117717 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117716,G__117717) : pred__117695.call(null,G__117716,G__117717));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,G__117684,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117718 = cljs.core.cst$kw$serializer;
var G__117719 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117718,G__117719) : pred__117695.call(null,G__117718,G__117719));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,G__117684,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117720 = cljs.core.cst$kw$default_DASH_network;
var G__117721 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117720,G__117721) : pred__117695.call(null,G__117720,G__117721));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,G__117684,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117722 = cljs.core.cst$kw$transactor_QMARK_;
var G__117723 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117722,G__117723) : pred__117695.call(null,G__117722,G__117723));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,G__117684,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117724 = cljs.core.cst$kw$publish;
var G__117725 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117724,G__117725) : pred__117695.call(null,G__117724,G__117725));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,G__117684,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117726 = cljs.core.cst$kw$transact_DASH_handler;
var G__117727 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117726,G__117727) : pred__117695.call(null,G__117726,G__117727));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,G__117684,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117728 = cljs.core.cst$kw$tx_DASH_private_DASH_key;
var G__117729 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117728,G__117729) : pred__117695.call(null,G__117728,G__117729));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,G__117684,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117730 = cljs.core.cst$kw$tx_DASH_key_DASH_id;
var G__117731 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117730,G__117731) : pred__117695.call(null,G__117730,G__117731));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,G__117684,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117732 = cljs.core.cst$kw$meta;
var G__117733 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117732,G__117733) : pred__117695.call(null,G__117732,G__117733));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,G__117684,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117734 = cljs.core.cst$kw$add_DASH_listener;
var G__117735 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117734,G__117735) : pred__117695.call(null,G__117734,G__117735));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,G__117684,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117736 = cljs.core.cst$kw$remove_DASH_listener;
var G__117737 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117736,G__117737) : pred__117695.call(null,G__117736,G__117737));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,G__117684,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__117738 = cljs.core.cst$kw$close;
var G__117739 = expr__117696;
return (pred__117695.cljs$core$IFn$_invoke$arity$2 ? pred__117695.cljs$core$IFn$_invoke$arity$2(G__117738,G__117739) : pred__117695.call(null,G__117738,G__117739));
})())){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,G__117684,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4393__auto__,G__117684),null));
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});

fluree.db.connection.Connection.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 21, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(cljs.core.cst$kw$id,self__.id,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$servers,self__.servers,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$state,self__.state,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$req_DASH_chan,self__.req_chan,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$sub_DASH_chan,self__.sub_chan,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$pub_DASH_chan,self__.pub_chan,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$storage_DASH_read,self__.storage_read,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$storage_DASH_write,self__.storage_write,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$object_DASH_cache,self__.object_cache,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$parallelism,self__.parallelism,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$serializer,self__.serializer,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$default_DASH_network,self__.default_network,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$transactor_QMARK_,self__.transactor_QMARK_,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$publish,self__.publish,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$transact_DASH_handler,self__.transact_handler,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$tx_DASH_private_DASH_key,self__.tx_private_key,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$tx_DASH_key_DASH_id,self__.tx_key_id,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$meta,self__.meta,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$add_DASH_listener,self__.add_listener,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$remove_DASH_listener,self__.remove_listener,null)),(new cljs.core.MapEntry(cljs.core.cst$kw$close,self__.close,null))], null),self__.__extmap));
});

fluree.db.connection.Connection.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__117684){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,G__117684,self__.__extmap,self__.__hash));
});

fluree.db.connection.Connection.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.connection.Connection.getBasis = (function (){
return new cljs.core.PersistentVector(null, 21, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$sym$id,cljs.core.cst$sym$servers,cljs.core.cst$sym$state,cljs.core.cst$sym$req_DASH_chan,cljs.core.cst$sym$sub_DASH_chan,cljs.core.cst$sym$pub_DASH_chan,cljs.core.cst$sym$storage_DASH_read,cljs.core.cst$sym$storage_DASH_write,cljs.core.cst$sym$object_DASH_cache,cljs.core.cst$sym$parallelism,cljs.core.cst$sym$serializer,cljs.core.cst$sym$default_DASH_network,cljs.core.cst$sym$transactor_QMARK_,cljs.core.cst$sym$publish,cljs.core.cst$sym$transact_DASH_handler,cljs.core.cst$sym$tx_DASH_private_DASH_key,cljs.core.cst$sym$tx_DASH_key_DASH_id,cljs.core.cst$sym$meta,cljs.core.cst$sym$add_DASH_listener,cljs.core.cst$sym$remove_DASH_listener,cljs.core.cst$sym$close], null);
});

fluree.db.connection.Connection.cljs$lang$type = true;

fluree.db.connection.Connection.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.connection/Connection",null,(1),null));
});

fluree.db.connection.Connection.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write(writer__4429__auto__,"fluree.db.connection/Connection");
});

/**
 * Positional factory function for fluree.db.connection/Connection.
 */
fluree.db.connection.__GT_Connection = (function fluree$db$connection$__GT_Connection(id,servers,state,req_chan,sub_chan,pub_chan,storage_read,storage_write,object_cache,parallelism,serializer,default_network,transactor_QMARK_,publish,transact_handler,tx_private_key,tx_key_id,meta,add_listener,remove_listener,close){
return (new fluree.db.connection.Connection(id,servers,state,req_chan,sub_chan,pub_chan,storage_read,storage_write,object_cache,parallelism,serializer,default_network,transactor_QMARK_,publish,transact_handler,tx_private_key,tx_key_id,meta,add_listener,remove_listener,close,null,null,null));
});

/**
 * Factory function for fluree.db.connection/Connection, taking a map of keywords to field values.
 */
fluree.db.connection.map__GT_Connection = (function fluree$db$connection$map__GT_Connection(G__117688){
var extmap__4424__auto__ = (function (){var G__117740 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__117688,cljs.core.cst$kw$id,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$servers,cljs.core.cst$kw$state,cljs.core.cst$kw$req_DASH_chan,cljs.core.cst$kw$sub_DASH_chan,cljs.core.cst$kw$pub_DASH_chan,cljs.core.cst$kw$storage_DASH_read,cljs.core.cst$kw$storage_DASH_write,cljs.core.cst$kw$object_DASH_cache,cljs.core.cst$kw$parallelism,cljs.core.cst$kw$serializer,cljs.core.cst$kw$default_DASH_network,cljs.core.cst$kw$transactor_QMARK_,cljs.core.cst$kw$publish,cljs.core.cst$kw$transact_DASH_handler,cljs.core.cst$kw$tx_DASH_private_DASH_key,cljs.core.cst$kw$tx_DASH_key_DASH_id,cljs.core.cst$kw$meta,cljs.core.cst$kw$add_DASH_listener,cljs.core.cst$kw$remove_DASH_listener,cljs.core.cst$kw$close], 0));
if(cljs.core.record_QMARK_(G__117688)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__117740);
} else {
return G__117740;
}
})();
return (new fluree.db.connection.Connection(cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$servers.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$req_DASH_chan.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$sub_DASH_chan.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$pub_DASH_chan.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$storage_DASH_read.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$storage_DASH_write.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$object_DASH_cache.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$parallelism.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$serializer.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$default_DASH_network.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$transactor_QMARK_.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$publish.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$transact_DASH_handler.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$tx_DASH_private_DASH_key.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$tx_DASH_key_DASH_id.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$meta.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$add_DASH_listener.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$remove_DASH_listener.cljs$core$IFn$_invoke$arity$1(G__117688),cljs.core.cst$kw$close.cljs$core$IFn$_invoke$arity$1(G__117688),null,cljs.core.not_empty(extmap__4424__auto__),null));
});

/**
 * Split servers in a string into a vector.
 * 
 *   Randomizies order, ensures uniqueness.
 */
fluree.db.connection.normalize_servers = (function fluree$db$connection$normalize_servers(servers,transactor_QMARK_){
var servers_STAR_ = ((typeof servers === 'string')?clojure.string.split.cljs$core$IFn$_invoke$arity$2(servers,/,/):servers);
if(((cljs.core.empty_QMARK_(servers)) && (cljs.core.not(transactor_QMARK_)))){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("At least one server must be supplied for connection.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_connection], null));
} else {
}

if(cljs.core.truth_(cljs.core.not_empty(servers_STAR_))){
var G__117745 = servers_STAR_;
var vec__117746 = G__117745;
var seq__117747 = cljs.core.seq(vec__117746);
var first__117748 = cljs.core.first(seq__117747);
var seq__117747__$1 = cljs.core.next(seq__117747);
var server = first__117748;
var r = seq__117747__$1;
var https_QMARK_ = null;
var result = cljs.core.PersistentHashSet.EMPTY;
var G__117745__$1 = G__117745;
var https_QMARK___$1 = https_QMARK_;
var result__$1 = result;
while(true){
var vec__117752 = G__117745__$1;
var seq__117753 = cljs.core.seq(vec__117752);
var first__117754 = cljs.core.first(seq__117753);
var seq__117753__$1 = cljs.core.next(seq__117753);
var server__$1 = first__117754;
var r__$1 = seq__117753__$1;
var https_QMARK___$2 = https_QMARK___$1;
var result__$2 = result__$1;
if(typeof server__$1 === 'string'){
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid server provided for connection, must be a string: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([server__$1], 0))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_connection], null));
}

var server__$2 = clojure.string.replace(server__$1,/.+@/,"");
var server_STAR_ = (cljs.core.truth_(cljs.core.re_matches(/^https?:\/\/.+/,server__$2))?server__$2:((clojure.string.includes_QMARK_(server__$2,"//"))?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Only http:// and https:// protocols currently supported for connection servers. Provided:",cljs.core.str.cljs$core$IFn$_invoke$arity$1(server__$2)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_connection], null))})():["http://",cljs.core.str.cljs$core$IFn$_invoke$arity$1(server__$2)].join('')
));
var server_STAR___$1 = (cljs.core.truth_(cljs.core.re_matches(/.+:[0-9]+/,server_STAR_))?server_STAR_:[cljs.core.str.cljs$core$IFn$_invoke$arity$1(server_STAR_),":8080"].join(''));
var is_https_QMARK_ = clojure.string.starts_with_QMARK_(server__$2,"https://");
var result_STAR_ = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(result__$2,server_STAR___$1);
if(cljs.core.truth_(cljs.core.re_matches(/^https?:\/\/(((?!-))(xn--|_{1,1})?[a-z0-9-]{0,61}[a-z0-9]{1,1}\.)*(xn--)?([a-z0-9\-]{1,61}|[a-z0-9-]{1,30}\.[a-z]{2,})(?:\:\d+)$/,server_STAR___$1))){
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid connection server, provide url and port only. Optionally specify http:// or https://. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(server__$2)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_connection], null));
}

if(cljs.core.truth_((function (){var and__4120__auto__ = https_QMARK___$2;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(is_https_QMARK_,https_QMARK___$2);
} else {
return and__4120__auto__;
}
})())){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Connection servers must all be http or https, not a mix.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_connection], null));
} else {
}

if(cljs.core.empty_QMARK_(r__$1)){
return cljs.core.shuffle(result_STAR_);
} else {
var G__117755 = r__$1;
var G__117756 = is_https_QMARK_;
var G__117757 = result_STAR_;
G__117745__$1 = G__117755;
https_QMARK___$1 = G__117756;
result__$1 = G__117757;
continue;
}
break;
}
} else {
return null;
}
});
/**
 * Returns true if connection has been closed.
 */
fluree.db.connection.closed_QMARK_ = (function fluree$db$connection$closed_QMARK_(conn){
return cljs.core.cst$kw$close_QMARK_.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(conn)));
});
if((typeof fluree !== 'undefined') && (typeof fluree.db !== 'undefined') && (typeof fluree.db.connection !== 'undefined') && (typeof fluree.db.connection.process_event !== 'undefined')){
} else {
fluree.db.connection.process_event = (function (){var method_table__4613__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4614__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4615__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4616__auto__ = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4617__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$3(cljs.core.PersistentArrayMap.EMPTY,cljs.core.cst$kw$hierarchy,(function (){var fexpr__117758 = cljs.core.get_global_hierarchy;
return (fexpr__117758.cljs$core$IFn$_invoke$arity$0 ? fexpr__117758.cljs$core$IFn$_invoke$arity$0() : fexpr__117758.call(null));
})());
return (new cljs.core.MultiFn(cljs.core.symbol.cljs$core$IFn$_invoke$arity$2("fluree.db.connection","process-event"),((function (method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__){
return (function (_,event_type,___$1,___$2){
return event_type;
});})(method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__))
,cljs.core.cst$kw$default,hierarchy__4617__auto__,method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__));
})();
}
fluree.db.connection.process_event.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$set_DASH_ws_DASH_id,(function (conn,_,___$1,ws_id){
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc,cljs.core.cst$kw$socket_DASH_id,ws_id);
}));
fluree.db.connection.process_event.cljs$core$IMultiFn$_add_method$arity$3(null,cljs.core.cst$kw$default,(function (conn,event_type,subject,event_data){
var callbacks = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(conn)),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$listeners,subject], null));
var seq__117759 = cljs.core.seq(callbacks);
var chunk__117760 = null;
var count__117761 = (0);
var i__117762 = (0);
while(true){
if((i__117762 < count__117761)){
var vec__117771 = chunk__117760.cljs$core$IIndexed$_nth$arity$2(null,i__117762);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117771,(0),null);
var f = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117771,(1),null);
try{(f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(event_type,event_data) : f.call(null,event_type,event_data));
}catch (e117774){var e_117779 = e117774;
fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([e_117779,["Error calling registered callback: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([k], 0))," for db: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(subject),". Event: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(event_type)," Data: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([event_data], 0)),"."].join('')], 0));
}

var G__117780 = seq__117759;
var G__117781 = chunk__117760;
var G__117782 = count__117761;
var G__117783 = (i__117762 + (1));
seq__117759 = G__117780;
chunk__117760 = G__117781;
count__117761 = G__117782;
i__117762 = G__117783;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq(seq__117759);
if(temp__5735__auto__){
var seq__117759__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__117759__$1)){
var c__4550__auto__ = cljs.core.chunk_first(seq__117759__$1);
var G__117784 = cljs.core.chunk_rest(seq__117759__$1);
var G__117785 = c__4550__auto__;
var G__117786 = cljs.core.count(c__4550__auto__);
var G__117787 = (0);
seq__117759 = G__117784;
chunk__117760 = G__117785;
count__117761 = G__117786;
i__117762 = G__117787;
continue;
} else {
var vec__117775 = cljs.core.first(seq__117759__$1);
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117775,(0),null);
var f = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117775,(1),null);
try{(f.cljs$core$IFn$_invoke$arity$2 ? f.cljs$core$IFn$_invoke$arity$2(event_type,event_data) : f.call(null,event_type,event_data));
}catch (e117778){var e_117788 = e117778;
fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([e_117788,["Error calling registered callback: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([k], 0))," for db: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(subject),". Event: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(event_type)," Data: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([event_data], 0)),"."].join('')], 0));
}

var G__117789 = cljs.core.next(seq__117759__$1);
var G__117790 = null;
var G__117791 = (0);
var G__117792 = (0);
seq__117759 = G__117789;
chunk__117760 = G__117790;
count__117761 = G__117791;
i__117762 = G__117792;
continue;
}
} else {
return null;
}
}
break;
}
}));
/**
 * Processes incoming events from the ledger.
 * 
 *   Requests that carry a :req-id in the header will attempt to lookup a
 *   corresponding return channel and send the message along on it.
 * 
 *   Otherwise looks for database events and updates local state accordingly.
 */
fluree.db.connection.process_events = (function fluree$db$connection$process_events(conn,msg){
try{var _ = fluree.db.util.log.trace.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Process events: ",msg], 0));
var vec__117795 = msg;
var event_type = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117795,(0),null);
var subject = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117795,(1),null);
var event_data = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117795,(2),null);
var error_data = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__117795,(3),null);
var event_type__$1 = cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(event_type);
var map__117798 = conn;
var map__117798__$1 = (((((!((map__117798 == null))))?(((((map__117798.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__117798.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__117798):map__117798);
var state = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__117798__$1,cljs.core.cst$kw$state);
var G__117800 = event_type__$1;
var G__117800__$1 = (((G__117800 instanceof cljs.core.Keyword))?G__117800.fqn:null);
switch (G__117800__$1) {
case "response":
var temp__5735__auto__ = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(state),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$pending_DASH_req,subject], null));
if(cljs.core.truth_(temp__5735__auto__)){
var res_chan = temp__5735__auto__;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(state,cljs.core.update,cljs.core.cst$kw$pending_DASH_req,((function (res_chan,temp__5735__auto__,G__117800,G__117800__$1,_,vec__117795,event_type,subject,event_data,error_data,event_type__$1,map__117798,map__117798__$1,state){
return (function (p1__117793_SHARP_){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(p1__117793_SHARP_,subject);
});})(res_chan,temp__5735__auto__,G__117800,G__117800__$1,_,vec__117795,event_type,subject,event_data,error_data,event_type__$1,map__117798,map__117798__$1,state))
);

if(cljs.core.truth_(error_data)){
var map__117801 = error_data;
var map__117801__$1 = (((((!((map__117801 == null))))?(((((map__117801.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__117801.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__117801):map__117801);
var message = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__117801__$1,cljs.core.cst$kw$message);
var exception = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2((function (){var or__4131__auto__ = message;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([error_data], 0));
}
})(),cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(error_data,cljs.core.cst$kw$message));
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(res_chan,exception);
} else {
if(cljs.core.truth_(event_data)){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(res_chan,event_data);
} else {
return cljs.core.async.close_BANG_(res_chan);

}
}
} else {
return null;
}

break;
case "pong":
return null;

break;
default:
return (fluree.db.connection.process_event.cljs$core$IFn$_invoke$arity$4 ? fluree.db.connection.process_event.cljs$core$IFn$_invoke$arity$4(conn,event_type__$1,subject,event_data) : fluree.db.connection.process_event.call(null,conn,event_type__$1,subject,event_data));

}
}catch (e117794){var e = e117794;
return fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([e], 0));
}});
/**
 * Closes websocket on connection if exists.
 */
fluree.db.connection.close_websocket = (function fluree$db$connection$close_websocket(conn_id){
var existing_socket = (function (){var G__117804 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(fluree.db.connection.server_connections_atom,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$ws,cljs.core.cst$kw$socket], null));
if((G__117804 == null)){
return null;
} else {
return cljs.core.async.poll_BANG_(G__117804);
}
})();
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(fluree.db.connection.server_connections_atom,cljs.core.dissoc,conn_id);

if(cljs.core.truth_(existing_socket)){
return fluree.db.util.xhttp.close_websocket(existing_socket);
} else {
return false;
}
});
/**
 * Gets websocket from connection, or establishes one if not already done.
 * 
 *   Returns a core async promise channel. Check for exceptions.
 */
fluree.db.connection.get_socket = (function fluree$db$connection$get_socket(conn){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_117830){
var state_val_117831 = (state_117830[(1)]);
if((state_val_117831 === (1))){
var state_117830__$1 = state_117830;
var statearr_117832_117844 = state_117830__$1;
(statearr_117832_117844[(2)] = null);

(statearr_117832_117844[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117831 === (2))){
var inst_117828 = (state_117830[(2)]);
var state_117830__$1 = state_117830;
return cljs.core.async.impl.ioc_helpers.return_chan(state_117830__$1,inst_117828);
} else {
if((state_val_117831 === (3))){
var inst_117805 = (state_117830[(2)]);
var state_117830__$1 = state_117830;
var statearr_117833_117845 = state_117830__$1;
(statearr_117833_117845[(2)] = inst_117805);


cljs.core.async.impl.ioc_helpers.process_exception(state_117830__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_117831 === (4))){
var inst_117814 = (state_117830[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_117830,(3),Error,null,(2));
var inst_117809 = cljs.core.deref(fluree.db.connection.server_connections_atom);
var inst_117810 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_117811 = cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(conn);
var inst_117812 = [inst_117811,cljs.core.cst$kw$ws,cljs.core.cst$kw$socket];
var inst_117813 = (new cljs.core.PersistentVector(null,3,(5),inst_117810,inst_117812,null));
var inst_117814__$1 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(inst_117809,inst_117813);
var state_117830__$1 = (function (){var statearr_117834 = state_117830;
(statearr_117834[(7)] = inst_117814__$1);

return statearr_117834;
})();
if(cljs.core.truth_(inst_117814__$1)){
var statearr_117835_117846 = state_117830__$1;
(statearr_117835_117846[(1)] = (5));

} else {
var statearr_117836_117847 = state_117830__$1;
(statearr_117836_117847[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117831 === (5))){
var inst_117814 = (state_117830[(7)]);
var state_117830__$1 = state_117830;
var statearr_117837_117848 = state_117830__$1;
(statearr_117837_117848[(2)] = inst_117814);

(statearr_117837_117848[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117831 === (6))){
var inst_117817 = cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(conn);
var inst_117818 = cljs.core.cst$kw$sub_DASH_chan.cljs$core$IFn$_invoke$arity$1(conn);
var inst_117819 = cljs.core.cst$kw$pub_DASH_chan.cljs$core$IFn$_invoke$arity$1(conn);
var inst_117820 = cljs.core.cst$kw$servers.cljs$core$IFn$_invoke$arity$1(conn);
var inst_117821 = fluree.db.connection.establish_socket(inst_117817,inst_117818,inst_117819,inst_117820);
var state_117830__$1 = state_117830;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_117830__$1,(8),inst_117821);
} else {
if((state_val_117831 === (7))){
var inst_117826 = (state_117830[(2)]);
var state_117830__$1 = state_117830;
var statearr_117838_117849 = state_117830__$1;
(statearr_117838_117849[(2)] = inst_117826);


cljs.core.async.impl.ioc_helpers.process_exception(state_117830__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_117831 === (8))){
var inst_117823 = (state_117830[(2)]);
var inst_117824 = fluree.db.util.async.throw_err(inst_117823);
var state_117830__$1 = state_117830;
var statearr_117839_117850 = state_117830__$1;
(statearr_117839_117850[(2)] = inst_117824);

(statearr_117839_117850[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$connection$get_socket_$_state_machine__99703__auto__ = null;
var fluree$db$connection$get_socket_$_state_machine__99703__auto____0 = (function (){
var statearr_117840 = [null,null,null,null,null,null,null,null];
(statearr_117840[(0)] = fluree$db$connection$get_socket_$_state_machine__99703__auto__);

(statearr_117840[(1)] = (1));

return statearr_117840;
});
var fluree$db$connection$get_socket_$_state_machine__99703__auto____1 = (function (state_117830){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_117830);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e117841){if((e117841 instanceof Object)){
var ex__99706__auto__ = e117841;
var statearr_117842_117851 = state_117830;
(statearr_117842_117851[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_117830);

return cljs.core.cst$kw$recur;
} else {
throw e117841;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__117852 = state_117830;
state_117830 = G__117852;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$connection$get_socket_$_state_machine__99703__auto__ = function(state_117830){
switch(arguments.length){
case 0:
return fluree$db$connection$get_socket_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$connection$get_socket_$_state_machine__99703__auto____1.call(this,state_117830);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$get_socket_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$get_socket_$_state_machine__99703__auto____0;
fluree$db$connection$get_socket_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$get_socket_$_state_machine__99703__auto____1;
return fluree$db$connection$get_socket_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_117843 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_117843[(6)] = c__99809__auto__);

return statearr_117843;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * returns promise channel, check for errors
 */
fluree.db.connection.get_server = (function fluree$db$connection$get_server(conn_id,servers){
var or__4131__auto__ = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(fluree.db.connection.server_connections_atom),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,cljs.core.cst$kw$server,cljs.core.cst$kw$chan], null));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return fluree.db.connection.get_healthy_server(conn_id,servers);
}
});
/**
 * Publishes message to the websocket associated with the connection.
 */
fluree.db.connection.default_publish_fn = (function fluree$db$connection$default_publish_fn(conn,message){
var pub_chan = cljs.core.cst$kw$pub_DASH_chan.cljs$core$IFn$_invoke$arity$1(conn);
var resp_chan = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var msg = (function (){try{return fluree.db.util.json.stringify(message);
}catch (e117853){var e = e117853;
fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Unable to publish message on websocket. Error encoding JSON message: ",message], 0));

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(resp_chan,cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Error encoding JSON message: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(message)].join(''),cljs.core.PersistentArrayMap.EMPTY));

return null;
}})();
if(cljs.core.truth_(msg)){
cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pub_chan,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [msg,resp_chan], null));
} else {
}

return resp_chan;
});
/**
 * Shuffles outgoing messages to the web socket in order.
 */
fluree.db.connection.msg_producer = (function fluree$db$connection$msg_producer(conn){
var state = cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(conn);
var req_chan = cljs.core.cst$kw$req_DASH_chan.cljs$core$IFn$_invoke$arity$1(conn);
var publish_fn = (function (){var or__4131__auto__ = cljs.core.cst$kw$publish.cljs$core$IFn$_invoke$arity$1(conn);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return fluree.db.connection.default_publish_fn;
}
})();
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,state,req_chan,publish_fn){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,state,req_chan,publish_fn){
return (function (state_117997){
var state_val_117998 = (state_117997[(1)]);
if((state_val_117998 === (7))){
var inst_117993 = (state_117997[(2)]);
var state_117997__$1 = state_117997;
var statearr_117999_118075 = state_117997__$1;
(statearr_117999_118075[(2)] = inst_117993);

(statearr_117999_118075[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (20))){
var inst_117896 = (state_117997[(7)]);
var inst_117901 = inst_117896.cljs$lang$protocol_mask$partition0$;
var inst_117902 = (inst_117901 & (64));
var inst_117903 = inst_117896.cljs$core$ISeq$;
var inst_117904 = (cljs.core.PROTOCOL_SENTINEL === inst_117903);
var inst_117905 = ((inst_117902) || (inst_117904));
var state_117997__$1 = state_117997;
if(cljs.core.truth_(inst_117905)){
var statearr_118000_118076 = state_117997__$1;
(statearr_118000_118076[(1)] = (23));

} else {
var statearr_118001_118077 = state_117997__$1;
(statearr_118001_118077[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (27))){
var inst_117896 = (state_117997[(7)]);
var state_117997__$1 = state_117997;
var statearr_118002_118078 = state_117997__$1;
(statearr_118002_118078[(2)] = inst_117896);

(statearr_118002_118078[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (1))){
var inst_117855 = (0);
var state_117997__$1 = (function (){var statearr_118003 = state_117997;
(statearr_118003[(8)] = inst_117855);

return statearr_118003;
})();
var statearr_118004_118079 = state_117997__$1;
(statearr_118004_118079[(2)] = null);

(statearr_118004_118079[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (24))){
var state_117997__$1 = state_117997;
var statearr_118005_118080 = state_117997__$1;
(statearr_118005_118080[(2)] = false);

(statearr_118005_118080[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (39))){
var inst_117974 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Error processing message in producer. Socket closed."], 0));
var state_117997__$1 = state_117997;
var statearr_118006_118081 = state_117997__$1;
(statearr_118006_118081[(2)] = inst_117974);

(statearr_118006_118081[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (4))){
var inst_117858 = (state_117997[(9)]);
var inst_117858__$1 = (state_117997[(2)]);
var state_117997__$1 = (function (){var statearr_118007 = state_117997;
(statearr_118007[(9)] = inst_117858__$1);

return statearr_118007;
})();
if(cljs.core.truth_(inst_117858__$1)){
var statearr_118008_118082 = state_117997__$1;
(statearr_118008_118082[(1)] = (5));

} else {
var statearr_118009_118083 = state_117997__$1;
(statearr_118009_118083[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (15))){
var inst_117876 = (state_117997[(2)]);
var state_117997__$1 = state_117997;
if(cljs.core.truth_(inst_117876)){
var statearr_118010_118084 = state_117997__$1;
(statearr_118010_118084[(1)] = (16));

} else {
var statearr_118011_118085 = state_117997__$1;
(statearr_118011_118085[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (21))){
var state_117997__$1 = state_117997;
var statearr_118012_118086 = state_117997__$1;
(statearr_118012_118086[(2)] = false);

(statearr_118012_118086[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (31))){
var inst_117893 = (state_117997[(10)]);
var inst_117920 = (state_117997[(11)]);
var inst_117894 = (state_117997[(12)]);
var inst_117958 = (state_117997[(2)]);
var inst_117959 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_117960 = [inst_117893,inst_117920,inst_117894];
var inst_117961 = (new cljs.core.PersistentVector(null,3,(5),inst_117959,inst_117960,null));
var inst_117962 = (publish_fn.cljs$core$IFn$_invoke$arity$2 ? publish_fn.cljs$core$IFn$_invoke$arity$2(conn,inst_117961) : publish_fn.call(null,conn,inst_117961));
var state_117997__$1 = (function (){var statearr_118013 = state_117997;
(statearr_118013[(13)] = inst_117958);

return statearr_118013;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_117997__$1,(32),inst_117962);
} else {
if((state_val_117998 === (32))){
var inst_117964 = (state_117997[(14)]);
var inst_117964__$1 = (state_117997[(2)]);
var inst_117965 = inst_117964__$1 === true;
var state_117997__$1 = (function (){var statearr_118014 = state_117997;
(statearr_118014[(14)] = inst_117964__$1);

return statearr_118014;
})();
if(cljs.core.truth_(inst_117965)){
var statearr_118015_118087 = state_117997__$1;
(statearr_118015_118087[(1)] = (33));

} else {
var statearr_118016_118088 = state_117997__$1;
(statearr_118016_118088[(1)] = (34));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (40))){
var state_117997__$1 = state_117997;
var statearr_118017_118089 = state_117997__$1;
(statearr_118017_118089[(1)] = (42));



return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (33))){
var state_117997__$1 = state_117997;
var statearr_118019_118090 = state_117997__$1;
(statearr_118019_118090[(2)] = null);

(statearr_118019_118090[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (13))){
var inst_117871 = (state_117997[(15)]);
var inst_117873 = fluree.db.util.async.channel_QMARK_(inst_117871);
var state_117997__$1 = state_117997;
var statearr_118020_118091 = state_117997__$1;
(statearr_118020_118091[(2)] = inst_117873);

(statearr_118020_118091[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (22))){
var inst_117912 = (state_117997[(2)]);
var state_117997__$1 = state_117997;
if(cljs.core.truth_(inst_117912)){
var statearr_118021_118092 = state_117997__$1;
(statearr_118021_118092[(1)] = (26));

} else {
var statearr_118022_118093 = state_117997__$1;
(statearr_118022_118093[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (36))){
var inst_117964 = (state_117997[(14)]);
var inst_117970 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_117964,"Error processing message in producer."], 0));
var state_117997__$1 = state_117997;
var statearr_118023_118094 = state_117997__$1;
(statearr_118023_118094[(2)] = inst_117970);

(statearr_118023_118094[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (41))){
var inst_117982 = (state_117997[(2)]);
var state_117997__$1 = state_117997;
var statearr_118024_118095 = state_117997__$1;
(statearr_118024_118095[(2)] = inst_117982);

(statearr_118024_118095[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (43))){
var state_117997__$1 = state_117997;
var statearr_118025_118096 = state_117997__$1;
(statearr_118025_118096[(2)] = null);

(statearr_118025_118096[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (29))){
var inst_117893 = (state_117997[(10)]);
var inst_117896 = (state_117997[(7)]);
var inst_117892 = (state_117997[(16)]);
var inst_117920 = (state_117997[(11)]);
var inst_117921 = (state_117997[(17)]);
var inst_117917 = (state_117997[(18)]);
var inst_117858 = (state_117997[(9)]);
var inst_117895 = (state_117997[(19)]);
var inst_117855 = (state_117997[(8)]);
var inst_117894 = (state_117997[(12)]);
var inst_117923 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_117924 = [cljs.core.cst$kw$pending_DASH_req,inst_117920];
var inst_117925 = (new cljs.core.PersistentVector(null,2,(5),inst_117923,inst_117924,null));
var inst_117926 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(state,cljs.core.assoc_in,inst_117925,inst_117895);
var inst_117953 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_117954 = (function (){var resp_chan = inst_117895;
var timeout = inst_117921;
var i = inst_117855;
var data = inst_117894;
var _ = inst_117892;
var req_id = inst_117920;
var operation = inst_117893;
var map__117891 = inst_117917;
var msg = inst_117858;
var vec__117888 = inst_117858;
var opts = inst_117896;
var c__99809__auto____$1 = inst_117953;
return ((function (resp_chan,timeout,i,data,_,req_id,operation,map__117891,msg,vec__117888,opts,c__99809__auto____$1,inst_117893,inst_117896,inst_117892,inst_117920,inst_117921,inst_117917,inst_117858,inst_117895,inst_117855,inst_117894,inst_117923,inst_117924,inst_117925,inst_117926,inst_117953,state_val_117998,c__99809__auto__,state,req_chan,publish_fn){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (resp_chan,timeout,i,data,_,req_id,operation,map__117891,msg,vec__117888,opts,c__99809__auto____$1,inst_117893,inst_117896,inst_117892,inst_117920,inst_117921,inst_117917,inst_117858,inst_117895,inst_117855,inst_117894,inst_117923,inst_117924,inst_117925,inst_117926,inst_117953,state_val_117998,c__99809__auto__,state,req_chan,publish_fn){
return (function (state_117951){
var state_val_117952 = (state_117951[(1)]);
if((state_val_117952 === (1))){
var inst_117930 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_117931 = cljs.core.async.timeout(timeout);
var inst_117932 = [resp_chan,inst_117931];
var inst_117933 = (new cljs.core.PersistentVector(null,2,(5),inst_117930,inst_117932,null));
var state_117951__$1 = state_117951;
return cljs.core.async.ioc_alts_BANG_(state_117951__$1,(2),inst_117933);
} else {
if((state_val_117952 === (2))){
var inst_117936 = (state_117951[(7)]);
var inst_117935 = (state_117951[(2)]);
var inst_117936__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117935,(0),null);
var inst_117937 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117935,(1),null);
var inst_117938 = (function (){var vec__117927 = inst_117935;
var resp = inst_117936__$1;
var c = inst_117937;
return ((function (vec__117927,resp,c,inst_117936,inst_117935,inst_117936__$1,inst_117937,state_val_117952,resp_chan,timeout,i,data,_,req_id,operation,map__117891,msg,vec__117888,opts,c__99809__auto____$1,inst_117893,inst_117896,inst_117892,inst_117920,inst_117921,inst_117917,inst_117858,inst_117895,inst_117855,inst_117894,inst_117923,inst_117924,inst_117925,inst_117926,inst_117953,state_val_117998,c__99809__auto__,state,req_chan,publish_fn){
return (function (p1__117854_SHARP_){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(p1__117854_SHARP_,req_id);
});
;})(vec__117927,resp,c,inst_117936,inst_117935,inst_117936__$1,inst_117937,state_val_117952,resp_chan,timeout,i,data,_,req_id,operation,map__117891,msg,vec__117888,opts,c__99809__auto____$1,inst_117893,inst_117896,inst_117892,inst_117920,inst_117921,inst_117917,inst_117858,inst_117895,inst_117855,inst_117894,inst_117923,inst_117924,inst_117925,inst_117926,inst_117953,state_val_117998,c__99809__auto__,state,req_chan,publish_fn))
})();
var inst_117939 = cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(state,cljs.core.update,cljs.core.cst$kw$pending_DASH_req,inst_117938);
var inst_117940 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_117937,resp_chan);
var state_117951__$1 = (function (){var statearr_118026 = state_117951;
(statearr_118026[(8)] = inst_117939);

(statearr_118026[(7)] = inst_117936__$1);

return statearr_118026;
})();
if(inst_117940){
var statearr_118027_118097 = state_117951__$1;
(statearr_118027_118097[(1)] = (3));

} else {
var statearr_118028_118098 = state_117951__$1;
(statearr_118028_118098[(1)] = (4));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117952 === (3))){
var inst_117936 = (state_117951[(7)]);
var state_117951__$1 = state_117951;
var statearr_118029_118099 = state_117951__$1;
(statearr_118029_118099[(2)] = inst_117936);

(statearr_118029_118099[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117952 === (4))){
var inst_117943 = ["Request ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(req_id)," timed out."].join('');
var inst_117944 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_117945 = [(408),cljs.core.cst$kw$db_SLASH_timeout];
var inst_117946 = cljs.core.PersistentHashMap.fromArrays(inst_117944,inst_117945);
var inst_117947 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_117943,inst_117946);
var state_117951__$1 = state_117951;
var statearr_118030_118100 = state_117951__$1;
(statearr_118030_118100[(2)] = inst_117947);

(statearr_118030_118100[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117952 === (5))){
var inst_117949 = (state_117951[(2)]);
var state_117951__$1 = state_117951;
return cljs.core.async.impl.ioc_helpers.return_chan(state_117951__$1,inst_117949);
} else {
return null;
}
}
}
}
}
});})(resp_chan,timeout,i,data,_,req_id,operation,map__117891,msg,vec__117888,opts,c__99809__auto____$1,inst_117893,inst_117896,inst_117892,inst_117920,inst_117921,inst_117917,inst_117858,inst_117895,inst_117855,inst_117894,inst_117923,inst_117924,inst_117925,inst_117926,inst_117953,state_val_117998,c__99809__auto__,state,req_chan,publish_fn))
;
return ((function (switch__99702__auto__,resp_chan,timeout,i,data,_,req_id,operation,map__117891,msg,vec__117888,opts,c__99809__auto____$1,inst_117893,inst_117896,inst_117892,inst_117920,inst_117921,inst_117917,inst_117858,inst_117895,inst_117855,inst_117894,inst_117923,inst_117924,inst_117925,inst_117926,inst_117953,state_val_117998,c__99809__auto__,state,req_chan,publish_fn){
return (function() {
var fluree$db$connection$msg_producer_$_state_machine__99703__auto__ = null;
var fluree$db$connection$msg_producer_$_state_machine__99703__auto____0 = (function (){
var statearr_118031 = [null,null,null,null,null,null,null,null,null];
(statearr_118031[(0)] = fluree$db$connection$msg_producer_$_state_machine__99703__auto__);

(statearr_118031[(1)] = (1));

return statearr_118031;
});
var fluree$db$connection$msg_producer_$_state_machine__99703__auto____1 = (function (state_117951){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_117951);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e118032){if((e118032 instanceof Object)){
var ex__99706__auto__ = e118032;
var statearr_118033_118101 = state_117951;
(statearr_118033_118101[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_117951);

return cljs.core.cst$kw$recur;
} else {
throw e118032;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__118102 = state_117951;
state_117951 = G__118102;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$connection$msg_producer_$_state_machine__99703__auto__ = function(state_117951){
switch(arguments.length){
case 0:
return fluree$db$connection$msg_producer_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$connection$msg_producer_$_state_machine__99703__auto____1.call(this,state_117951);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$msg_producer_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$msg_producer_$_state_machine__99703__auto____0;
fluree$db$connection$msg_producer_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$msg_producer_$_state_machine__99703__auto____1;
return fluree$db$connection$msg_producer_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,resp_chan,timeout,i,data,_,req_id,operation,map__117891,msg,vec__117888,opts,c__99809__auto____$1,inst_117893,inst_117896,inst_117892,inst_117920,inst_117921,inst_117917,inst_117858,inst_117895,inst_117855,inst_117894,inst_117923,inst_117924,inst_117925,inst_117926,inst_117953,state_val_117998,c__99809__auto__,state,req_chan,publish_fn))
})();
var state__99811__auto__ = (function (){var statearr_118034 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_118034[(6)] = c__99809__auto____$1);

return statearr_118034;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});
;})(resp_chan,timeout,i,data,_,req_id,operation,map__117891,msg,vec__117888,opts,c__99809__auto____$1,inst_117893,inst_117896,inst_117892,inst_117920,inst_117921,inst_117917,inst_117858,inst_117895,inst_117855,inst_117894,inst_117923,inst_117924,inst_117925,inst_117926,inst_117953,state_val_117998,c__99809__auto__,state,req_chan,publish_fn))
})();
var inst_117955 = cljs.core.async.impl.dispatch.run(inst_117954);
var state_117997__$1 = (function (){var statearr_118035 = state_117997;
(statearr_118035[(20)] = inst_117955);

(statearr_118035[(21)] = inst_117926);

return statearr_118035;
})();
var statearr_118036_118103 = state_117997__$1;
(statearr_118036_118103[(2)] = inst_117953);

(statearr_118036_118103[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (44))){
var inst_117980 = (state_117997[(2)]);
var state_117997__$1 = state_117997;
var statearr_118037_118104 = state_117997__$1;
(statearr_118037_118104[(2)] = inst_117980);

(statearr_118037_118104[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (6))){
var state_117997__$1 = state_117997;
var statearr_118038_118105 = state_117997__$1;
(statearr_118038_118105[(2)] = null);

(statearr_118038_118105[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (28))){
var inst_117917 = (state_117997[(18)]);
var inst_117895 = (state_117997[(19)]);
var inst_117917__$1 = (state_117997[(2)]);
var inst_117918 = fluree.db.util.core.random_uuid();
var inst_117919 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_117918);
var inst_117920 = cljs.core.get.cljs$core$IFn$_invoke$arity$3(inst_117917__$1,cljs.core.cst$kw$req_DASH_id,inst_117919);
var inst_117921 = cljs.core.get.cljs$core$IFn$_invoke$arity$3(inst_117917__$1,cljs.core.cst$kw$timeout,(60000));
var state_117997__$1 = (function (){var statearr_118039 = state_117997;
(statearr_118039[(11)] = inst_117920);

(statearr_118039[(17)] = inst_117921);

(statearr_118039[(18)] = inst_117917__$1);

return statearr_118039;
})();
if(cljs.core.truth_(inst_117895)){
var statearr_118040_118106 = state_117997__$1;
(statearr_118040_118106[(1)] = (29));

} else {
var statearr_118041_118107 = state_117997__$1;
(statearr_118041_118107[(1)] = (30));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (25))){
var inst_117909 = (state_117997[(2)]);
var state_117997__$1 = state_117997;
var statearr_118042_118108 = state_117997__$1;
(statearr_118042_118108[(2)] = inst_117909);

(statearr_118042_118108[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (34))){
var inst_117964 = (state_117997[(14)]);
var inst_117968 = fluree.db.util.core.exception_QMARK_(inst_117964);
var state_117997__$1 = state_117997;
if(inst_117968){
var statearr_118043_118109 = state_117997__$1;
(statearr_118043_118109[(1)] = (36));

} else {
var statearr_118044_118110 = state_117997__$1;
(statearr_118044_118110[(1)] = (37));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (17))){
var inst_117860 = (state_117997[(22)]);
var inst_117858 = (state_117997[(9)]);
var inst_117880 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_117858], 0));
var inst_117881 = ["Error processing ledger request, no valid return channel: ",inst_117880].join('');
var inst_117882 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_117860,inst_117881], 0));
var state_117997__$1 = state_117997;
var statearr_118045_118111 = state_117997__$1;
(statearr_118045_118111[(2)] = inst_117882);

(statearr_118045_118111[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (3))){
var inst_117995 = (state_117997[(2)]);
var state_117997__$1 = state_117997;
return cljs.core.async.impl.ioc_helpers.return_chan(state_117997__$1,inst_117995);
} else {
if((state_val_117998 === (12))){
var inst_117871 = (state_117997[(15)]);
var inst_117868 = (state_117997[(2)]);
var inst_117869 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117868,(0),null);
var inst_117870 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117868,(1),null);
var inst_117871__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117868,(2),null);
var state_117997__$1 = (function (){var statearr_118046 = state_117997;
(statearr_118046[(15)] = inst_117871__$1);

(statearr_118046[(23)] = inst_117869);

(statearr_118046[(24)] = inst_117870);

return statearr_118046;
})();
if(cljs.core.truth_(inst_117871__$1)){
var statearr_118047_118112 = state_117997__$1;
(statearr_118047_118112[(1)] = (13));

} else {
var statearr_118048_118113 = state_117997__$1;
(statearr_118048_118113[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (2))){
var state_117997__$1 = state_117997;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_117997__$1,(4),req_chan);
} else {
if((state_val_117998 === (23))){
var state_117997__$1 = state_117997;
var statearr_118049_118114 = state_117997__$1;
(statearr_118049_118114[(2)] = true);

(statearr_118049_118114[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (35))){
var inst_117986 = (state_117997[(2)]);
var state_117997__$1 = state_117997;
var statearr_118050_118115 = state_117997__$1;
(statearr_118050_118115[(2)] = inst_117986);


cljs.core.async.impl.ioc_helpers.process_exception(state_117997__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (19))){
var inst_117896 = (state_117997[(7)]);
var inst_117858 = (state_117997[(9)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_117997,(9),cljs.core.cst$kw$default,null,(8));
var inst_117892 = fluree.db.util.log.trace.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Outgoing message to websocket: ",inst_117858], 0));
var inst_117893 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117858,(0),null);
var inst_117894 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117858,(1),null);
var inst_117895 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117858,(2),null);
var inst_117896__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_117858,(3),null);
var inst_117898 = (inst_117896__$1 == null);
var inst_117899 = cljs.core.not(inst_117898);
var state_117997__$1 = (function (){var statearr_118051 = state_117997;
(statearr_118051[(10)] = inst_117893);

(statearr_118051[(7)] = inst_117896__$1);

(statearr_118051[(16)] = inst_117892);

(statearr_118051[(19)] = inst_117895);

(statearr_118051[(12)] = inst_117894);

return statearr_118051;
})();
if(inst_117899){
var statearr_118052_118116 = state_117997__$1;
(statearr_118052_118116[(1)] = (20));

} else {
var statearr_118053_118117 = state_117997__$1;
(statearr_118053_118117[(1)] = (21));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (11))){
var state_117997__$1 = state_117997;
var statearr_118054_118118 = state_117997__$1;
(statearr_118054_118118[(2)] = null);

(statearr_118054_118118[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (9))){
var inst_117858 = (state_117997[(9)]);
var inst_117860 = (state_117997[(2)]);
var inst_117864 = cljs.core.sequential_QMARK_(inst_117858);
var state_117997__$1 = (function (){var statearr_118055 = state_117997;
(statearr_118055[(22)] = inst_117860);

return statearr_118055;
})();
if(inst_117864){
var statearr_118056_118119 = state_117997__$1;
(statearr_118056_118119[(1)] = (10));

} else {
var statearr_118057_118120 = state_117997__$1;
(statearr_118057_118120[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (5))){
var state_117997__$1 = state_117997;
var statearr_118058_118121 = state_117997__$1;
(statearr_118058_118121[(2)] = null);

(statearr_118058_118121[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (14))){
var inst_117871 = (state_117997[(15)]);
var state_117997__$1 = state_117997;
var statearr_118059_118122 = state_117997__$1;
(statearr_118059_118122[(2)] = inst_117871);

(statearr_118059_118122[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (26))){
var inst_117896 = (state_117997[(7)]);
var inst_117914 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_117896);
var state_117997__$1 = state_117997;
var statearr_118060_118123 = state_117997__$1;
(statearr_118060_118123[(2)] = inst_117914);

(statearr_118060_118123[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (16))){
var inst_117860 = (state_117997[(22)]);
var inst_117871 = (state_117997[(15)]);
var inst_117878 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(inst_117871,inst_117860);
var state_117997__$1 = state_117997;
var statearr_118061_118124 = state_117997__$1;
(statearr_118061_118124[(2)] = inst_117878);

(statearr_118061_118124[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (38))){
var inst_117984 = (state_117997[(2)]);
var state_117997__$1 = state_117997;
var statearr_118062_118125 = state_117997__$1;
(statearr_118062_118125[(2)] = inst_117984);

(statearr_118062_118125[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (30))){
var state_117997__$1 = state_117997;
var statearr_118063_118126 = state_117997__$1;
(statearr_118063_118126[(2)] = null);

(statearr_118063_118126[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (10))){
var inst_117858 = (state_117997[(9)]);
var state_117997__$1 = state_117997;
var statearr_118064_118127 = state_117997__$1;
(statearr_118064_118127[(2)] = inst_117858);

(statearr_118064_118127[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (18))){
var inst_117884 = (state_117997[(2)]);
var state_117997__$1 = state_117997;
var statearr_118065_118128 = state_117997__$1;
(statearr_118065_118128[(2)] = inst_117884);


cljs.core.async.impl.ioc_helpers.process_exception(state_117997__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (42))){
var inst_117964 = (state_117997[(14)]);
var inst_117977 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Error processing message in producer. Socket closed. Published result",inst_117964], 0));
var state_117997__$1 = state_117997;
var statearr_118066_118129 = state_117997__$1;
(statearr_118066_118129[(2)] = inst_117977);

(statearr_118066_118129[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (37))){
var inst_117964 = (state_117997[(14)]);
var inst_117972 = (inst_117964 == null);
var state_117997__$1 = state_117997;
if(cljs.core.truth_(inst_117972)){
var statearr_118067_118130 = state_117997__$1;
(statearr_118067_118130[(1)] = (39));

} else {
var statearr_118068_118131 = state_117997__$1;
(statearr_118068_118131[(1)] = (40));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_117998 === (8))){
var inst_117855 = (state_117997[(8)]);
var inst_117988 = (state_117997[(2)]);
var inst_117989 = (inst_117855 + (1));
var inst_117855__$1 = inst_117989;
var state_117997__$1 = (function (){var statearr_118069 = state_117997;
(statearr_118069[(25)] = inst_117988);

(statearr_118069[(8)] = inst_117855__$1);

return statearr_118069;
})();
var statearr_118070_118132 = state_117997__$1;
(statearr_118070_118132[(2)] = null);

(statearr_118070_118132[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,state,req_chan,publish_fn))
;
return ((function (switch__99702__auto__,c__99809__auto__,state,req_chan,publish_fn){
return (function() {
var fluree$db$connection$msg_producer_$_state_machine__99703__auto__ = null;
var fluree$db$connection$msg_producer_$_state_machine__99703__auto____0 = (function (){
var statearr_118071 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_118071[(0)] = fluree$db$connection$msg_producer_$_state_machine__99703__auto__);

(statearr_118071[(1)] = (1));

return statearr_118071;
});
var fluree$db$connection$msg_producer_$_state_machine__99703__auto____1 = (function (state_117997){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_117997);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e118072){if((e118072 instanceof Object)){
var ex__99706__auto__ = e118072;
var statearr_118073_118133 = state_117997;
(statearr_118073_118133[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_117997);

return cljs.core.cst$kw$recur;
} else {
throw e118072;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__118134 = state_117997;
state_117997 = G__118134;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$connection$msg_producer_$_state_machine__99703__auto__ = function(state_117997){
switch(arguments.length){
case 0:
return fluree$db$connection$msg_producer_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$connection$msg_producer_$_state_machine__99703__auto____1.call(this,state_117997);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$msg_producer_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$msg_producer_$_state_machine__99703__auto____0;
fluree$db$connection$msg_producer_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$msg_producer_$_state_machine__99703__auto____1;
return fluree$db$connection$msg_producer_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,state,req_chan,publish_fn))
})();
var state__99811__auto__ = (function (){var statearr_118074 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_118074[(6)] = c__99809__auto__);

return statearr_118074;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,state,req_chan,publish_fn))
);

return c__99809__auto__;
});
fluree.db.connection.ping_transactor = (function fluree$db$connection$ping_transactor(conn){
var req_chan = cljs.core.cst$kw$req_DASH_chan.cljs$core$IFn$_invoke$arity$1(conn);
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(req_chan,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$ping,true], null));
});
/**
 * Takes messages from peer/ledger and processes them.
 */
fluree.db.connection.msg_consumer = (function fluree$db$connection$msg_consumer(conn){
var ping_transactor_after = (2500);
var map__118135 = conn;
var map__118135__$1 = (((((!((map__118135 == null))))?(((((map__118135.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__118135.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__118135):map__118135);
var sub_chan = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118135__$1,cljs.core.cst$kw$sub_DASH_chan);
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,ping_transactor_after,map__118135,map__118135__$1,sub_chan){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,ping_transactor_after,map__118135,map__118135__$1,sub_chan){
return (function (state_118218){
var state_val_118219 = (state_118218[(1)]);
if((state_val_118219 === (7))){
var inst_118214 = (state_118218[(2)]);
var state_118218__$1 = state_118218;
var statearr_118220_118270 = state_118218__$1;
(statearr_118220_118270[(2)] = inst_118214);

(statearr_118220_118270[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (20))){
var inst_118155 = (state_118218[(7)]);
var inst_118169 = [cljs.core.cst$kw$keep_DASH_alive_DASH_fn];
var inst_118170 = [inst_118155];
var inst_118171 = cljs.core.PersistentHashMap.fromArrays(inst_118169,inst_118170);
var inst_118172 = fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Unsupported callback registered",inst_118171], 0));
var state_118218__$1 = state_118218;
var statearr_118221_118271 = state_118218__$1;
(statearr_118221_118271[(2)] = inst_118172);

(statearr_118221_118271[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (27))){
var state_118218__$1 = state_118218;
var statearr_118222_118272 = state_118218__$1;
(statearr_118222_118272[(1)] = (29));



return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (1))){
var inst_118137 = (0);
var state_118218__$1 = (function (){var statearr_118224 = state_118218;
(statearr_118224[(8)] = inst_118137);

return statearr_118224;
})();
var statearr_118225_118273 = state_118218__$1;
(statearr_118225_118273[(2)] = null);

(statearr_118225_118273[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (24))){
var inst_118148 = (state_118218[(9)]);
var inst_118197 = fluree.db.util.core.exception_QMARK_(inst_118148);
var state_118218__$1 = state_118218;
if(inst_118197){
var statearr_118226_118274 = state_118218__$1;
(statearr_118226_118274[(1)] = (26));

} else {
var statearr_118227_118275 = state_118218__$1;
(statearr_118227_118275[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (4))){
var inst_118142 = (state_118218[(10)]);
var inst_118147 = (state_118218[(2)]);
var inst_118148 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_118147,(0),null);
var inst_118149 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_118147,(1),null);
var inst_118150 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_118149,inst_118142);
var state_118218__$1 = (function (){var statearr_118228 = state_118218;
(statearr_118228[(9)] = inst_118148);

return statearr_118228;
})();
if(inst_118150){
var statearr_118229_118276 = state_118218__$1;
(statearr_118229_118276[(1)] = (5));

} else {
var statearr_118230_118277 = state_118218__$1;
(statearr_118230_118277[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (15))){
var inst_118155 = (state_118218[(7)]);
var inst_118164 = typeof inst_118155 === 'string';
var state_118218__$1 = state_118218;
if(cljs.core.truth_(inst_118164)){
var statearr_118231_118278 = state_118218__$1;
(statearr_118231_118278[(1)] = (17));

} else {
var statearr_118232_118279 = state_118218__$1;
(statearr_118232_118279[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (21))){
var state_118218__$1 = state_118218;
var statearr_118233_118280 = state_118218__$1;
(statearr_118233_118280[(2)] = null);

(statearr_118233_118280[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (31))){
var inst_118208 = (state_118218[(2)]);
var state_118218__$1 = state_118218;
var statearr_118234_118281 = state_118218__$1;
(statearr_118234_118281[(2)] = inst_118208);

(statearr_118234_118281[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (13))){
var inst_118181 = (state_118218[(2)]);
var inst_118182 = cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(conn);
var inst_118183 = fluree.db.connection.close_websocket(inst_118182);
var inst_118184 = cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(conn);
var inst_118185 = fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$1(inst_118184);
var state_118218__$1 = (function (){var statearr_118235 = state_118218;
(statearr_118235[(11)] = inst_118183);

(statearr_118235[(12)] = inst_118181);

return statearr_118235;
})();
var statearr_118236_118282 = state_118218__$1;
(statearr_118236_118282[(2)] = inst_118185);

(statearr_118236_118282[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (22))){
var inst_118175 = (state_118218[(2)]);
var state_118218__$1 = state_118218;
var statearr_118237_118283 = state_118218__$1;
(statearr_118237_118283[(2)] = inst_118175);

(statearr_118237_118283[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (29))){
var inst_118148 = (state_118218[(9)]);
var inst_118203 = fluree.db.util.json.parse(inst_118148);
var inst_118204 = fluree.db.connection.process_events(conn,inst_118203);
var inst_118137 = (0);
var state_118218__$1 = (function (){var statearr_118238 = state_118218;
(statearr_118238[(8)] = inst_118137);

(statearr_118238[(13)] = inst_118204);

return statearr_118238;
})();
var statearr_118239_118284 = state_118218__$1;
(statearr_118239_118284[(2)] = null);

(statearr_118239_118284[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (6))){
var inst_118148 = (state_118218[(9)]);
var inst_118193 = (inst_118148 == null);
var state_118218__$1 = state_118218;
if(cljs.core.truth_(inst_118193)){
var statearr_118240_118285 = state_118218__$1;
(statearr_118240_118285[(1)] = (23));

} else {
var statearr_118241_118286 = state_118218__$1;
(statearr_118241_118286[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (28))){
var inst_118210 = (state_118218[(2)]);
var state_118218__$1 = state_118218;
var statearr_118242_118287 = state_118218__$1;
(statearr_118242_118287[(2)] = inst_118210);

(statearr_118242_118287[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (25))){
var inst_118212 = (state_118218[(2)]);
var state_118218__$1 = state_118218;
var statearr_118243_118288 = state_118218__$1;
(statearr_118243_118288[(2)] = inst_118212);

(statearr_118243_118288[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (17))){
var inst_118155 = (state_118218[(7)]);
var inst_118166 = cljs.core.eval(inst_118155);
var state_118218__$1 = state_118218;
var statearr_118244_118289 = state_118218__$1;
(statearr_118244_118289[(2)] = inst_118166);

(statearr_118244_118289[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (3))){
var inst_118216 = (state_118218[(2)]);
var state_118218__$1 = state_118218;
return cljs.core.async.impl.ioc_helpers.return_chan(state_118218__$1,inst_118216);
} else {
if((state_val_118219 === (12))){
var inst_118155 = (state_118218[(7)]);
var inst_118160 = cljs.core.fn_QMARK_(inst_118155);
var state_118218__$1 = state_118218;
if(inst_118160){
var statearr_118245_118290 = state_118218__$1;
(statearr_118245_118290[(1)] = (14));

} else {
var statearr_118246_118291 = state_118218__$1;
(statearr_118246_118291[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (2))){
var inst_118142 = (state_118218[(10)]);
var inst_118142__$1 = cljs.core.async.timeout(ping_transactor_after);
var inst_118143 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_118144 = [sub_chan,inst_118142__$1];
var inst_118145 = (new cljs.core.PersistentVector(null,2,(5),inst_118143,inst_118144,null));
var state_118218__$1 = (function (){var statearr_118247 = state_118218;
(statearr_118247[(10)] = inst_118142__$1);

return statearr_118247;
})();
return cljs.core.async.ioc_alts_BANG_(state_118218__$1,(4),inst_118145);
} else {
if((state_val_118219 === (23))){
var inst_118195 = fluree.db.util.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Connection closed."], 0));
var state_118218__$1 = state_118218;
var statearr_118248_118292 = state_118218__$1;
(statearr_118248_118292[(2)] = inst_118195);

(statearr_118248_118292[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (19))){
var inst_118177 = (state_118218[(2)]);
var state_118218__$1 = state_118218;
var statearr_118249_118293 = state_118218__$1;
(statearr_118249_118293[(2)] = inst_118177);

(statearr_118249_118293[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (11))){
var inst_118158 = fluree.db.util.log.trace.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["No keep-alive callback is registered"], 0));
var state_118218__$1 = state_118218;
var statearr_118250_118294 = state_118218__$1;
(statearr_118250_118294[(2)] = inst_118158);

(statearr_118250_118294[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (9))){
var inst_118137 = (state_118218[(8)]);
var inst_118187 = fluree.db.connection.ping_transactor(conn);
var inst_118188 = (inst_118137 + (1));
var inst_118137__$1 = inst_118188;
var state_118218__$1 = (function (){var statearr_118251 = state_118218;
(statearr_118251[(8)] = inst_118137__$1);

(statearr_118251[(14)] = inst_118187);

return statearr_118251;
})();
var statearr_118252_118295 = state_118218__$1;
(statearr_118252_118295[(2)] = null);

(statearr_118252_118295[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (5))){
var inst_118137 = (state_118218[(8)]);
var inst_118152 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((2),inst_118137);
var state_118218__$1 = state_118218;
if(inst_118152){
var statearr_118253_118296 = state_118218__$1;
(statearr_118253_118296[(1)] = (8));

} else {
var statearr_118254_118297 = state_118218__$1;
(statearr_118254_118297[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (14))){
var inst_118155 = (state_118218[(7)]);
var inst_118162 = (inst_118155.cljs$core$IFn$_invoke$arity$0 ? inst_118155.cljs$core$IFn$_invoke$arity$0() : inst_118155.call(null));
var state_118218__$1 = state_118218;
var statearr_118255_118298 = state_118218__$1;
(statearr_118255_118298[(2)] = inst_118162);

(statearr_118255_118298[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (26))){
var inst_118148 = (state_118218[(9)]);
var inst_118199 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_118148], 0));
var inst_118137 = (0);
var state_118218__$1 = (function (){var statearr_118256 = state_118218;
(statearr_118256[(8)] = inst_118137);

(statearr_118256[(15)] = inst_118199);

return statearr_118256;
})();
var statearr_118257_118299 = state_118218__$1;
(statearr_118257_118299[(2)] = null);

(statearr_118257_118299[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (16))){
var inst_118179 = (state_118218[(2)]);
var state_118218__$1 = state_118218;
var statearr_118258_118300 = state_118218__$1;
(statearr_118258_118300[(2)] = inst_118179);

(statearr_118258_118300[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (30))){
var state_118218__$1 = state_118218;
var statearr_118259_118301 = state_118218__$1;
(statearr_118259_118301[(2)] = null);

(statearr_118259_118301[(1)] = (31));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (10))){
var inst_118191 = (state_118218[(2)]);
var state_118218__$1 = state_118218;
var statearr_118260_118302 = state_118218__$1;
(statearr_118260_118302[(2)] = inst_118191);

(statearr_118260_118302[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (18))){
var state_118218__$1 = state_118218;
var statearr_118261_118303 = state_118218__$1;
(statearr_118261_118303[(1)] = (20));



return cljs.core.cst$kw$recur;
} else {
if((state_val_118219 === (8))){
var inst_118155 = (state_118218[(7)]);
var inst_118154 = fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Connection has gone stale. Perhaps network conditions are poor. Disconnecting socket."], 0));
var inst_118155__$1 = cljs.core.cst$kw$keep_DASH_alive_DASH_fn.cljs$core$IFn$_invoke$arity$1(conn);
var inst_118156 = (inst_118155__$1 == null);
var state_118218__$1 = (function (){var statearr_118263 = state_118218;
(statearr_118263[(16)] = inst_118154);

(statearr_118263[(7)] = inst_118155__$1);

return statearr_118263;
})();
if(cljs.core.truth_(inst_118156)){
var statearr_118264_118304 = state_118218__$1;
(statearr_118264_118304[(1)] = (11));

} else {
var statearr_118265_118305 = state_118218__$1;
(statearr_118265_118305[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,ping_transactor_after,map__118135,map__118135__$1,sub_chan))
;
return ((function (switch__99702__auto__,c__99809__auto__,ping_transactor_after,map__118135,map__118135__$1,sub_chan){
return (function() {
var fluree$db$connection$msg_consumer_$_state_machine__99703__auto__ = null;
var fluree$db$connection$msg_consumer_$_state_machine__99703__auto____0 = (function (){
var statearr_118266 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_118266[(0)] = fluree$db$connection$msg_consumer_$_state_machine__99703__auto__);

(statearr_118266[(1)] = (1));

return statearr_118266;
});
var fluree$db$connection$msg_consumer_$_state_machine__99703__auto____1 = (function (state_118218){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_118218);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e118267){if((e118267 instanceof Object)){
var ex__99706__auto__ = e118267;
var statearr_118268_118306 = state_118218;
(statearr_118268_118306[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_118218);

return cljs.core.cst$kw$recur;
} else {
throw e118267;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__118307 = state_118218;
state_118218 = G__118307;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$connection$msg_consumer_$_state_machine__99703__auto__ = function(state_118218){
switch(arguments.length){
case 0:
return fluree$db$connection$msg_consumer_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$connection$msg_consumer_$_state_machine__99703__auto____1.call(this,state_118218);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$msg_consumer_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$msg_consumer_$_state_machine__99703__auto____0;
fluree$db$connection$msg_consumer_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$msg_consumer_$_state_machine__99703__auto____1;
return fluree$db$connection$msg_consumer_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,ping_transactor_after,map__118135,map__118135__$1,sub_chan))
})();
var state__99811__auto__ = (function (){var statearr_118269 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_118269[(6)] = c__99809__auto__);

return statearr_118269;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,ping_transactor_after,map__118135,map__118135__$1,sub_chan))
);

return c__99809__auto__;
});
/**
 * Default storage read function - uses ledger storage and issues http(s) requests.
 */
fluree.db.connection.default_storage_read = (function fluree$db$connection$default_storage_read(var_args){
var G__118309 = arguments.length;
switch (G__118309) {
case 2:
return fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$2 = (function (conn_id,servers){
return fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$3(conn_id,servers,null);
});

fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$3 = (function (conn_id,servers,opts){
var map__118310 = opts;
var map__118310__$1 = (((((!((map__118310 == null))))?(((((map__118310.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__118310.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__118310):map__118310);
var private$ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118310__$1,cljs.core.cst$kw$private);
return ((function (map__118310,map__118310__$1,private$){
return (function (k){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,map__118310,map__118310__$1,private$){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,map__118310,map__118310__$1,private$){
return (function (state_118349){
var state_val_118350 = (state_118349[(1)]);
if((state_val_118350 === (7))){
var inst_118324 = (state_118349[(7)]);
var state_118349__$1 = state_118349;
var statearr_118351_118370 = state_118349__$1;
(statearr_118351_118370[(2)] = inst_118324);

(statearr_118351_118370[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118350 === (1))){
var state_118349__$1 = state_118349;
var statearr_118352_118371 = state_118349__$1;
(statearr_118352_118371[(2)] = null);

(statearr_118352_118371[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118350 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_118349,(3),Error,null,(2));
var inst_118316 = clojure.string.replace(k,"_","/");
var inst_118317 = fluree.db.connection.get_server(conn_id,servers);
var state_118349__$1 = (function (){var statearr_118353 = state_118349;
(statearr_118353[(8)] = inst_118316);

return statearr_118353;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_118349__$1,(5),inst_118317);
} else {
if((state_val_118350 === (6))){
var inst_118324 = (state_118349[(7)]);
var inst_118326 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_118324,"X-fdb-pri",private$);
var state_118349__$1 = state_118349;
var statearr_118354_118372 = state_118349__$1;
(statearr_118354_118372[(2)] = inst_118326);

(statearr_118354_118372[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118350 === (3))){
var inst_118312 = (state_118349[(2)]);
var state_118349__$1 = state_118349;
var statearr_118355_118373 = state_118349__$1;
(statearr_118355_118373[(2)] = inst_118312);


cljs.core.async.impl.ioc_helpers.process_exception(state_118349__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_118350 === (12))){
var inst_118344 = (state_118349[(2)]);
var inst_118345 = fluree.db.util.async.throw_err(inst_118344);
var state_118349__$1 = state_118349;
var statearr_118356_118374 = state_118349__$1;
(statearr_118356_118374[(2)] = inst_118345);


cljs.core.async.impl.ioc_helpers.process_exception(state_118349__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_118350 === (2))){
var inst_118347 = (state_118349[(2)]);
var state_118349__$1 = state_118349;
return cljs.core.async.impl.ioc_helpers.return_chan(state_118349__$1,inst_118347);
} else {
if((state_val_118350 === (11))){
var inst_118320 = (state_118349[(9)]);
var inst_118338 = (state_118349[(2)]);
var inst_118339 = [cljs.core.cst$kw$request_DASH_timeout,cljs.core.cst$kw$headers,cljs.core.cst$kw$output_DASH_format];
var inst_118340 = [(5000),inst_118338,cljs.core.cst$kw$text];
var inst_118341 = cljs.core.PersistentHashMap.fromArrays(inst_118339,inst_118340);
var inst_118342 = fluree.db.util.xhttp.get(inst_118320,inst_118341);
var state_118349__$1 = state_118349;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_118349__$1,(12),inst_118342);
} else {
if((state_val_118350 === (9))){
var inst_118329 = (state_118349[(10)]);
var inst_118320 = (state_118349[(9)]);
var inst_118331 = [cljs.core.cst$kw$headers];
var inst_118332 = [inst_118329];
var inst_118333 = cljs.core.PersistentHashMap.fromArrays(inst_118331,inst_118332);
var inst_118334 = fluree.db.query.http_signatures.sign_request.cljs$core$IFn$_invoke$arity$4("get",inst_118320,inst_118333,private$);
var inst_118335 = cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(inst_118334);
var state_118349__$1 = state_118349;
var statearr_118357_118375 = state_118349__$1;
(statearr_118357_118375[(2)] = inst_118335);

(statearr_118357_118375[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118350 === (5))){
var inst_118316 = (state_118349[(8)]);
var inst_118319 = (state_118349[(2)]);
var inst_118320 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_118319),"/fdb/storage/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_118316)].join('');
var inst_118322 = ["Accept"];
var inst_118323 = ["application/json"];
var inst_118324 = cljs.core.PersistentHashMap.fromArrays(inst_118322,inst_118323);
var state_118349__$1 = (function (){var statearr_118358 = state_118349;
(statearr_118358[(7)] = inst_118324);

(statearr_118358[(9)] = inst_118320);

return statearr_118358;
})();
if(cljs.core.truth_(private$)){
var statearr_118359_118376 = state_118349__$1;
(statearr_118359_118376[(1)] = (6));

} else {
var statearr_118360_118377 = state_118349__$1;
(statearr_118360_118377[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118350 === (10))){
var inst_118329 = (state_118349[(10)]);
var state_118349__$1 = state_118349;
var statearr_118361_118378 = state_118349__$1;
(statearr_118361_118378[(2)] = inst_118329);

(statearr_118361_118378[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118350 === (8))){
var inst_118329 = (state_118349[(2)]);
var state_118349__$1 = (function (){var statearr_118362 = state_118349;
(statearr_118362[(10)] = inst_118329);

return statearr_118362;
})();
if(cljs.core.truth_(private$)){
var statearr_118363_118379 = state_118349__$1;
(statearr_118363_118379[(1)] = (9));

} else {
var statearr_118364_118380 = state_118349__$1;
(statearr_118364_118380[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,map__118310,map__118310__$1,private$))
;
return ((function (switch__99702__auto__,c__99809__auto__,map__118310,map__118310__$1,private$){
return (function() {
var fluree$db$connection$state_machine__99703__auto__ = null;
var fluree$db$connection$state_machine__99703__auto____0 = (function (){
var statearr_118365 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_118365[(0)] = fluree$db$connection$state_machine__99703__auto__);

(statearr_118365[(1)] = (1));

return statearr_118365;
});
var fluree$db$connection$state_machine__99703__auto____1 = (function (state_118349){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_118349);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e118366){if((e118366 instanceof Object)){
var ex__99706__auto__ = e118366;
var statearr_118367_118381 = state_118349;
(statearr_118367_118381[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_118349);

return cljs.core.cst$kw$recur;
} else {
throw e118366;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__118382 = state_118349;
state_118349 = G__118382;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$connection$state_machine__99703__auto__ = function(state_118349){
switch(arguments.length){
case 0:
return fluree$db$connection$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$connection$state_machine__99703__auto____1.call(this,state_118349);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$state_machine__99703__auto____0;
fluree$db$connection$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$state_machine__99703__auto____1;
return fluree$db$connection$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,map__118310,map__118310__$1,private$))
})();
var state__99811__auto__ = (function (){var statearr_118368 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_118368[(6)] = c__99809__auto__);

return statearr_118368;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,map__118310,map__118310__$1,private$))
);

return c__99809__auto__;
});
;})(map__118310,map__118310__$1,private$))
});

fluree.db.connection.default_storage_read.cljs$lang$maxFixedArity = 3;

/**
 * Default object cache to use for ledger.
 */
fluree.db.connection.default_object_cache_fn = (function fluree$db$connection$default_object_cache_fn(cache_atom){
return (function (k,value_fn){
if((value_fn == null)){
return cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cache_atom,cljs.cache.evict,k);
} else {
var temp__5733__auto__ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(cache_atom),k);
if(cljs.core.truth_(temp__5733__auto__)){
var v = temp__5733__auto__;
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$3(cache_atom,cljs.cache.hit,k);

return v;
} else {
var v = (value_fn.cljs$core$IFn$_invoke$arity$1 ? value_fn.cljs$core$IFn$_invoke$arity$1(k) : value_fn.call(null,k));
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(cache_atom,cljs.cache.miss,k,v);

return v;
}
}
});
});
/**
 * Generates a default object cache.
 */
fluree.db.connection.default_object_cache_factory = (function fluree$db$connection$default_object_cache_factory(cache_size){
return cljs.cache.lru_cache_factory.cljs$core$IFn$_invoke$arity$variadic(cljs.core.PersistentArrayMap.EMPTY,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$threshold,cache_size], 0));
});
/**
 * Gets a specific key from the environment, returns nil if doesn't exist.
 */
fluree.db.connection.from_environment = (function fluree$db$connection$from_environment(key){
return null;
});
/**
 * Returns list of listeners
 */
fluree.db.connection.listeners = (function fluree$db$connection$listeners(conn_state){
return cljs.core.cst$kw$listeners.cljs$core$IFn$_invoke$arity$1(cljs.core.deref(conn_state));
});
/**
 * Internal call to add-listener that uses the state atom directly.
 */
fluree.db.connection.add_listener_STAR_ = (function fluree$db$connection$add_listener_STAR_(conn_state,network,dbid,key,fn){
if(cljs.core.fn_QMARK_(fn)){
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("add-listener fn paramer not a function.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_listener], null));
}

if((key == null)){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("add-listener key must not be nil.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_listener], null));
} else {
}

cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(conn_state,cljs.core.update_in,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$listeners,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null),key], null),(function (p1__118383_SHARP_){
if(cljs.core.truth_(p1__118383_SHARP_)){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["add-listener key already in use: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([key], 0))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_listener], null));
} else {
return fn;
}
}));

return true;
});
/**
 * Internal call to remove-listener that uses the state atom directly.
 */
fluree.db.connection.remove_listener_STAR_ = (function fluree$db$connection$remove_listener_STAR_(conn_state,network,dbid,key){
if(cljs.core.truth_(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(cljs.core.deref(conn_state),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$listeners,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null),key], null)))){
cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$variadic(conn_state,cljs.core.update_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$listeners,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null)], null),cljs.core.dissoc,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([key], 0));

return true;
} else {
return false;
}
});
/**
 * Registers a new listener function, fn,  on connection.
 * 
 *   Each listener must have an associated key, which is used to remove the listener
 *   when needed but is otherwise opaque to the function. Each key must be unique for the
 *   given network + dbid.
 */
fluree.db.connection.add_listener = (function fluree$db$connection$add_listener(conn,network,dbid,key,fn){
return fluree.db.connection.add_listener_STAR_(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(conn),network,dbid,key,fn);
});
/**
 * Removes listener on given network + dbid for the provided key.
 * 
 *   The key is the same provided for add-listener when registering.
 * 
 *   Will return true if a function exists for that key and it was removed.
 */
fluree.db.connection.remove_listener = (function fluree$db$connection$remove_listener(conn,network,dbid,key){
return fluree.db.connection.remove_listener_STAR_(cljs.core.cst$kw$state.cljs$core$IFn$_invoke$arity$1(conn),network,dbid,key);
});
/**
 * Generates connection object.
 */
fluree.db.connection.generate_connection = (function fluree$db$connection$generate_connection(servers,opts){
var state_atom = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(new cljs.core.PersistentArrayMap(null, 7, [cljs.core.cst$kw$close_QMARK_,false,cljs.core.cst$kw$health,cljs.core.PersistentArrayMap.EMPTY,cljs.core.cst$kw$connected_DASH_to,null,cljs.core.cst$kw$socket,null,cljs.core.cst$kw$socket_DASH_id,null,cljs.core.cst$kw$pending_DASH_req,cljs.core.PersistentArrayMap.EMPTY,cljs.core.cst$kw$listeners,cljs.core.PersistentArrayMap.EMPTY], null));
var map__118384 = opts;
var map__118384__$1 = (((((!((map__118384 == null))))?(((((map__118384.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__118384.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__118384):map__118384);
var sub_chan = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__118384__$1,cljs.core.cst$kw$sub_DASH_chan,cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0());
var storage_rename = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$storage_DASH_rename);
var keep_alive_fn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$keep_DASH_alive_DASH_fn);
var publish = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$publish);
var close_fn = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$close_DASH_fn);
var default_network = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$default_DASH_network);
var object_cache = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$object_DASH_cache);
var transact_handler = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$transact_DASH_handler);
var parallelism = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__118384__$1,cljs.core.cst$kw$parallelism,(4));
var meta = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$meta);
var tx_private_key = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$tx_DASH_private_DASH_key);
var private$ = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$private);
var storage_read = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$storage_DASH_read);
var transactor_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__118384__$1,cljs.core.cst$kw$transactor_QMARK_,false);
var serializer = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__118384__$1,cljs.core.cst$kw$serializer,fluree.db.serde.json.json_serde());
var memory = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__118384__$1,cljs.core.cst$kw$memory,(1000000));
var storage_exists = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__118384__$1,cljs.core.cst$kw$storage_DASH_exists);
var storage_write = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__118384__$1,cljs.core.cst$kw$storage_DASH_write,((function (state_atom,map__118384,map__118384__$1,sub_chan,storage_rename,keep_alive_fn,publish,close_fn,default_network,object_cache,transact_handler,parallelism,meta,tx_private_key,private$,storage_read,transactor_QMARK_,serializer,memory,storage_exists){
return (function (k,v){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Storage write was not implemented on connection, but was called to store key: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(k)].join(''),cljs.core.PersistentArrayMap.EMPTY);
});})(state_atom,map__118384,map__118384__$1,sub_chan,storage_rename,keep_alive_fn,publish,close_fn,default_network,object_cache,transact_handler,parallelism,meta,tx_private_key,private$,storage_read,transactor_QMARK_,serializer,memory,storage_exists))
);
var memory_QMARK_ = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__118384__$1,cljs.core.cst$kw$memory_QMARK_,false);
var req_chan = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__118384__$1,cljs.core.cst$kw$req_DASH_chan,cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0());
var pub_chan = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__118384__$1,cljs.core.cst$kw$pub_DASH_chan,cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0());
var private_key_file = cljs.core.get.cljs$core$IFn$_invoke$arity$3(map__118384__$1,cljs.core.cst$kw$private_DASH_key_DASH_file,"default-private-key.txt");
var memory_object_size = cljs.core.quot(memory,(100000));
var _ = (((memory_object_size < (10)))?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Must allocate at least 1MB of memory for Fluree. You've allocated: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(memory)," bytes."].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_configuration], null))})():null);
var default_cache_atom = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(fluree.db.connection.default_object_cache_factory(memory_object_size));
var object_cache_fn = (function (){var or__4131__auto__ = object_cache;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return fluree.db.connection.default_object_cache_fn(default_cache_atom);
}
})();
var conn_id = cljs.core.str.cljs$core$IFn$_invoke$arity$1(fluree.db.util.core.random_uuid());
var close = ((function (state_atom,map__118384,map__118384__$1,sub_chan,storage_rename,keep_alive_fn,publish,close_fn,default_network,object_cache,transact_handler,parallelism,meta,tx_private_key,private$,storage_read,transactor_QMARK_,serializer,memory,storage_exists,storage_write,memory_QMARK_,req_chan,pub_chan,private_key_file,memory_object_size,_,default_cache_atom,object_cache_fn,conn_id){
return (function (){
cljs.core.async.close_BANG_(req_chan);

cljs.core.async.close_BANG_(sub_chan);

cljs.core.async.close_BANG_(pub_chan);

fluree.db.connection.close_websocket(conn_id);

cljs.core.swap_BANG_.cljs$core$IFn$_invoke$arity$4(state_atom,cljs.core.assoc,cljs.core.cst$kw$close_QMARK_,true);

fluree.db.session.close_all_sessions.cljs$core$IFn$_invoke$arity$1(conn_id);

cljs.core.reset_BANG_(default_cache_atom,fluree.db.connection.default_object_cache_factory(memory_object_size));

if(cljs.core.fn_QMARK_(close_fn)){
(close_fn.cljs$core$IFn$_invoke$arity$0 ? close_fn.cljs$core$IFn$_invoke$arity$0() : close_fn.call(null));
} else {
}

return fluree.db.util.log.info.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$conn_DASH_closed], 0));
});})(state_atom,map__118384,map__118384__$1,sub_chan,storage_rename,keep_alive_fn,publish,close_fn,default_network,object_cache,transact_handler,parallelism,meta,tx_private_key,private$,storage_read,transactor_QMARK_,serializer,memory,storage_exists,storage_write,memory_QMARK_,req_chan,pub_chan,private_key_file,memory_object_size,_,default_cache_atom,object_cache_fn,conn_id))
;
var servers_STAR_ = fluree.db.connection.normalize_servers(servers,transactor_QMARK_);
var storage_read_STAR_ = (function (){var or__4131__auto__ = storage_read;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$3(conn_id,servers_STAR_,opts);
}
})();
var storage_exists_STAR_ = (function (){var or__4131__auto__ = storage_exists;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var or__4131__auto____$1 = storage_read;
if(cljs.core.truth_(or__4131__auto____$1)){
return or__4131__auto____$1;
} else {
return fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$3(conn_id,servers_STAR_,opts);
}
}
})();
var ___$1 = ((cljs.core.fn_QMARK_(storage_read_STAR_))?null:(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Connection's storage-read must be a function. Provided: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([storage_read], 0))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error], null))})());
var ___$2 = ((cljs.core.fn_QMARK_(storage_exists_STAR_))?null:(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Connection's storage-exists must be a function. Provided: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([storage_exists], 0))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error], null))})());
var ___$3 = (cljs.core.truth_((function (){var and__4120__auto__ = storage_write;
if(cljs.core.truth_(and__4120__auto__)){
return (!(cljs.core.fn_QMARK_(storage_write)));
} else {
return and__4120__auto__;
}
})())?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Connection's storage-write, if provided, must be a function. Provided: ",cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([storage_write], 0))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error], null))})():null);
var settings = cljs.core.PersistentHashMap.fromArrays([cljs.core.cst$kw$object_DASH_cache,cljs.core.cst$kw$default_DASH_network,cljs.core.cst$kw$parallelism,cljs.core.cst$kw$transact_DASH_handler,cljs.core.cst$kw$add_DASH_listener,cljs.core.cst$kw$meta,cljs.core.cst$kw$tx_DASH_private_DASH_key,cljs.core.cst$kw$remove_DASH_listener,cljs.core.cst$kw$transactor_QMARK_,cljs.core.cst$kw$storage_DASH_read,cljs.core.cst$kw$serializer,cljs.core.cst$kw$memory,cljs.core.cst$kw$storage_DASH_exists,cljs.core.cst$kw$state,cljs.core.cst$kw$close,cljs.core.cst$kw$tx_DASH_key_DASH_id,cljs.core.cst$kw$storage_DASH_write,cljs.core.cst$kw$req_DASH_chan,cljs.core.cst$kw$id,cljs.core.cst$kw$servers,cljs.core.cst$kw$pub_DASH_chan,cljs.core.cst$kw$sub_DASH_chan,cljs.core.cst$kw$storage_DASH_rename,cljs.core.cst$kw$keep_DASH_alive_DASH_fn,cljs.core.cst$kw$publish],[object_cache_fn,default_network,parallelism,transact_handler,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(fluree.db.connection.add_listener_STAR_,state_atom),meta,tx_private_key,cljs.core.partial.cljs$core$IFn$_invoke$arity$2(fluree.db.connection.remove_listener_STAR_,state_atom),transactor_QMARK_,storage_read_STAR_,serializer,memory_QMARK_,storage_exists_STAR_,state_atom,close,(cljs.core.truth_(tx_private_key)?null:null),storage_write,req_chan,conn_id,servers_STAR_,pub_chan,sub_chan,storage_rename,((((cljs.core.fn_QMARK_(keep_alive_fn)) || (typeof keep_alive_fn === 'string')))?keep_alive_fn:null),publish]);
return fluree.db.connection.map__GT_Connection(settings);
});
/**
 * Closes connection, returns true if close successful, false if already closed.
 */
fluree.db.connection.close_BANG_ = (function fluree$db$connection$close_BANG_(conn){
if(cljs.core.truth_(fluree.db.connection.closed_QMARK_(conn))){
return false;
} else {
var fexpr__118386_118387 = cljs.core.cst$kw$close.cljs$core$IFn$_invoke$arity$1(conn);
(fexpr__118386_118387.cljs$core$IFn$_invoke$arity$0 ? fexpr__118386_118387.cljs$core$IFn$_invoke$arity$0() : fexpr__118386_118387.call(null));

return true;
}
});
/**
 * Creates a connection to a ledger group server.
 *   Provide servers in either a sequence or as a string that is comma-separated.
 */
fluree.db.connection.connect = (function fluree$db$connection$connect(var_args){
var args__4736__auto__ = [];
var len__4730__auto___118419 = arguments.length;
var i__4731__auto___118420 = (0);
while(true){
if((i__4731__auto___118420 < len__4730__auto___118419)){
args__4736__auto__.push((arguments[i__4731__auto___118420]));

var G__118421 = (i__4731__auto___118420 + (1));
i__4731__auto___118420 = G__118421;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return fluree.db.connection.connect.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

fluree.db.connection.connect.cljs$core$IFn$_invoke$arity$variadic = (function (servers,p__118390){
var vec__118391 = p__118390;
var opts = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__118391,(0),null);
var conn = fluree.db.connection.generate_connection(servers,opts);
var transactor_QMARK_ = cljs.core.cst$kw$transactor_QMARK_.cljs$core$IFn$_invoke$arity$1(opts);
var dev_QMARK_ = cljs.core.cst$kw$dev_QMARK_.cljs$core$IFn$_invoke$arity$1(cljs.core.cst$kw$meta.cljs$core$IFn$_invoke$arity$1(conn));
if(cljs.core.truth_(transactor_QMARK_)){
} else {
var c__99809__auto___118422 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___118422,conn,transactor_QMARK_,dev_QMARK_,vec__118391,opts){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___118422,conn,transactor_QMARK_,dev_QMARK_,vec__118391,opts){
return (function (state_118408){
var state_val_118409 = (state_118408[(1)]);
if((state_val_118409 === (1))){
var inst_118394 = fluree.db.connection.get_socket(conn);
var state_118408__$1 = state_118408;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_118408__$1,(2),inst_118394);
} else {
if((state_val_118409 === (2))){
var inst_118396 = (state_118408[(2)]);
var inst_118397 = (inst_118396 == null);
var inst_118398 = fluree.db.util.core.exception_QMARK_(inst_118396);
var inst_118399 = ((inst_118397) || (inst_118398));
var state_118408__$1 = state_118408;
if(cljs.core.truth_(inst_118399)){
var statearr_118410_118423 = state_118408__$1;
(statearr_118410_118423[(1)] = (3));

} else {
var statearr_118411_118424 = state_118408__$1;
(statearr_118411_118424[(1)] = (4));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_118409 === (3))){
var inst_118401 = fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["Cannot establish connection to a healthy server, disconnecting."], 0));
var inst_118402 = cljs.core.async.close_BANG_(conn);
var state_118408__$1 = (function (){var statearr_118412 = state_118408;
(statearr_118412[(7)] = inst_118401);

return statearr_118412;
})();
var statearr_118413_118425 = state_118408__$1;
(statearr_118413_118425[(2)] = inst_118402);

(statearr_118413_118425[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118409 === (4))){
var inst_118404 = fluree.db.connection.msg_consumer(conn);
var state_118408__$1 = state_118408;
var statearr_118414_118426 = state_118408__$1;
(statearr_118414_118426[(2)] = inst_118404);

(statearr_118414_118426[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_118409 === (5))){
var inst_118406 = (state_118408[(2)]);
var state_118408__$1 = state_118408;
return cljs.core.async.impl.ioc_helpers.return_chan(state_118408__$1,inst_118406);
} else {
return null;
}
}
}
}
}
});})(c__99809__auto___118422,conn,transactor_QMARK_,dev_QMARK_,vec__118391,opts))
;
return ((function (switch__99702__auto__,c__99809__auto___118422,conn,transactor_QMARK_,dev_QMARK_,vec__118391,opts){
return (function() {
var fluree$db$connection$state_machine__99703__auto__ = null;
var fluree$db$connection$state_machine__99703__auto____0 = (function (){
var statearr_118415 = [null,null,null,null,null,null,null,null];
(statearr_118415[(0)] = fluree$db$connection$state_machine__99703__auto__);

(statearr_118415[(1)] = (1));

return statearr_118415;
});
var fluree$db$connection$state_machine__99703__auto____1 = (function (state_118408){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_118408);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e118416){if((e118416 instanceof Object)){
var ex__99706__auto__ = e118416;
var statearr_118417_118427 = state_118408;
(statearr_118417_118427[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_118408);

return cljs.core.cst$kw$recur;
} else {
throw e118416;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__118428 = state_118408;
state_118408 = G__118428;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$connection$state_machine__99703__auto__ = function(state_118408){
switch(arguments.length){
case 0:
return fluree$db$connection$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$connection$state_machine__99703__auto____1.call(this,state_118408);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$state_machine__99703__auto____0;
fluree$db$connection$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$state_machine__99703__auto____1;
return fluree$db$connection$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___118422,conn,transactor_QMARK_,dev_QMARK_,vec__118391,opts))
})();
var state__99811__auto__ = (function (){var statearr_118418 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_118418[(6)] = c__99809__auto___118422);

return statearr_118418;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___118422,conn,transactor_QMARK_,dev_QMARK_,vec__118391,opts))
);

}

fluree.db.connection.msg_producer(conn);

return conn;
});

fluree.db.connection.connect.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
fluree.db.connection.connect.cljs$lang$applyTo = (function (seq118388){
var G__118389 = cljs.core.first(seq118388);
var seq118388__$1 = cljs.core.next(seq118388);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__118389,seq118388__$1);
});

