// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('fluree.db.query.analytical');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('clojure.set');
goog.require('fluree.db.query.range');
goog.require('cljs.core.async');
goog.require('fluree.db.time_travel');
goog.require('fluree.db.util.async');
goog.require('fluree.db.util.core');
goog.require('fluree.db.flake');
goog.require('fluree.db.query.analytical_wikidata');
goog.require('fluree.db.query.analytical_filter');
goog.require('clojure.string');
goog.require('fluree.db.util.log');
goog.require('cljs.reader');
goog.require('fluree.db.dbproto');
fluree.db.query.analytical.variable_QMARK_ = (function fluree$db$query$analytical$variable_QMARK_(form){
if(((((typeof form === 'string') || ((form instanceof cljs.core.Keyword)) || ((form instanceof cljs.core.Symbol)))) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.first(cljs.core.name(form)),"?")))){
return cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(form);
} else {
return null;
}
});
fluree.db.query.analytical.internal_filter_QMARK_ = (function fluree$db$query$analytical$internal_filter_QMARK_(form){
if(((((typeof form === 'string') || ((form instanceof cljs.core.Keyword)) || ((form instanceof cljs.core.Symbol)))) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.first(cljs.core.name(form)),"#")) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.second(cljs.core.name(form)),"(")))){
return cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(form);
} else {
return null;
}
});
fluree.db.query.analytical.escaped_string_QMARK_ = (function fluree$db$query$analytical$escaped_string_QMARK_(form){
return ((typeof form === 'string') && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.first(cljs.core.name(form)),"\"")) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.last(cljs.core.name(form)),"\"")));
});
fluree.db.query.analytical.safe_read_string = (function fluree$db$query$analytical$safe_read_string(string){
try{return cljs.reader.read_string.cljs$core$IFn$_invoke$arity$1(string);
}catch (e108658){var e = e108658;
return string;
}});
fluree.db.query.analytical.get_vars = (function fluree$db$query$analytical$get_vars(filter_code){
return cljs.core.some((function (p1__108659_SHARP_){
var or__4131__auto__ = fluree.db.query.analytical.variable_QMARK_(p1__108659_SHARP_);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
if(cljs.core.coll_QMARK_(p1__108659_SHARP_)){
return (fluree.db.query.analytical.get_vars.cljs$core$IFn$_invoke$arity$1 ? fluree.db.query.analytical.get_vars.cljs$core$IFn$_invoke$arity$1(p1__108659_SHARP_) : fluree.db.query.analytical.get_vars.call(null,p1__108659_SHARP_));
} else {
return null;
}
}
}),filter_code);
});
/**
 * Given any interm-vars, such as {?article 351843720901583}
 *   and an fdb clause, such as  ["?article", "articles/leadInstitutionOrg", "?org"],
 * 
 * 
 *   Returns a map with the following keys:
 * 
 *   - search - a vector that will be passed to query-range/search, i.e. [ nil "articles/leadInstitutionOrg" nil ]
 *   - rel - a map with any variables (that are not present in interm-vars) and their idx, i.e. {?org 2}
 *   - opts - search opts, currently recur, if the predicate is recurred, and object-fn, if there is an object function.
 *  
 */
fluree.db.query.analytical.clause__GT_rel = (function fluree$db$query$analytical$clause__GT_rel(db,interm_vars,clause){
return cljs.core.reduce_kv((function (acc,idx,key){
var key_as_var = fluree.db.query.analytical.variable_QMARK_(key);
var static_value = cljs.core.get.cljs$core$IFn$_invoke$arity$2(interm_vars,key_as_var);
if(((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(idx,(1))) && (cljs.core.not(key_as_var)) && (cljs.core.not(fluree.db.dbproto._p_prop(db,cljs.core.cst$kw$name,cljs.core.re_find(/[_a-zA-Z0-9\/]*/,key)))))){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid predicate provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(key)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null));
} else {
}

if(cljs.core.truth_(static_value)){
return cljs.core.update.cljs$core$IFn$_invoke$arity$3(acc,cljs.core.cst$kw$search,((function (key_as_var,static_value){
return (function (p1__108660_SHARP_){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(p1__108660_SHARP_,static_value);
});})(key_as_var,static_value))
);
} else {
if(cljs.core.truth_(key_as_var)){
return cljs.core.assoc_in(cljs.core.update.cljs$core$IFn$_invoke$arity$3(acc,cljs.core.cst$kw$search,((function (key_as_var,static_value){
return (function (p1__108661_SHARP_){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(p1__108661_SHARP_,null);
});})(key_as_var,static_value))
),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$rel,key_as_var], null),idx);
} else {
if(cljs.core.truth_((function (){var and__4120__auto__ = fluree.db.query.analytical.internal_filter_QMARK_(key);
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(idx,(2));
} else {
return and__4120__auto__;
}
})())){
var filter_code = cljs.reader.read_string.cljs$core$IFn$_invoke$arity$1(cljs.core.subs.cljs$core$IFn$_invoke$arity$2(key,(1)));
var var$ = (function (){var or__4131__auto__ = fluree.db.query.analytical.get_vars(filter_code);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Filter function must contain a valid variable. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(key)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null));
}
})();
var vec__108666 = fluree.db.query.analytical_filter.valid_filter_QMARK_.cljs$core$IFn$_invoke$arity$2(filter_code,cljs.core.PersistentHashSet.createAsIfByAssoc([var$]));
var fun = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__108666,(0),null);
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__108666,(1),null);
var filter_fn = fluree.db.query.analytical_filter.get_internal_filter_fn(var$,fun);
return cljs.core.assoc_in(cljs.core.assoc_in(cljs.core.update.cljs$core$IFn$_invoke$arity$3(acc,cljs.core.cst$kw$search,((function (filter_code,var$,vec__108666,fun,_,filter_fn,key_as_var,static_value){
return (function (p1__108662_SHARP_){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(p1__108662_SHARP_,null);
});})(filter_code,var$,vec__108666,fun,_,filter_fn,key_as_var,static_value))
),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$opts,cljs.core.cst$kw$object_DASH_fn], null),filter_fn),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$rel,var$], null),idx);
} else {
if(cljs.core.truth_((function (){var and__4120__auto__ = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(idx,(1));
if(and__4120__auto__){
return cljs.core.re_find(/\+/,key);
} else {
return and__4120__auto__;
}
})())){
var vec__108669 = clojure.string.split.cljs$core$IFn$_invoke$arity$2(key,/\+/);
var pred = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__108669,(0),null);
var recur_amt = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__108669,(1),null);
var recur_amt__$1 = (cljs.core.truth_(recur_amt)?(function (){var or__4131__auto__ = fluree.db.query.analytical.safe_read_string(recur_amt);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (100);
}
})():(100));
return cljs.core.assoc_in(cljs.core.update.cljs$core$IFn$_invoke$arity$3(acc,cljs.core.cst$kw$search,((function (vec__108669,pred,recur_amt,recur_amt__$1,key_as_var,static_value){
return (function (p1__108663_SHARP_){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(p1__108663_SHARP_,pred);
});})(vec__108669,pred,recur_amt,recur_amt__$1,key_as_var,static_value))
),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$opts,cljs.core.cst$kw$recur], null),recur_amt__$1);
} else {
if(fluree.db.query.analytical.escaped_string_QMARK_(key)){
return cljs.core.update.cljs$core$IFn$_invoke$arity$3(acc,cljs.core.cst$kw$search,((function (key_as_var,static_value){
return (function (p1__108664_SHARP_){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(p1__108664_SHARP_,fluree.db.query.analytical.safe_read_string(key));
});})(key_as_var,static_value))
);
} else {
return cljs.core.update.cljs$core$IFn$_invoke$arity$3(acc,cljs.core.cst$kw$search,((function (key_as_var,static_value){
return (function (p1__108665_SHARP_){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(p1__108665_SHARP_,key);
});})(key_as_var,static_value))
);

}
}
}
}
}
}),new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$search,cljs.core.PersistentVector.EMPTY,cljs.core.cst$kw$rel,cljs.core.PersistentArrayMap.EMPTY,cljs.core.cst$kw$opts,cljs.core.PersistentArrayMap.EMPTY], null),clause);
});
fluree.db.query.analytical.get_ns_arrays = (function fluree$db$query$analytical$get_ns_arrays(ns,arrays){
return cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (array){
return cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__108672_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(array,p1__108672_SHARP_);
}),ns);
}),arrays);
});
fluree.db.query.analytical.clause__GT_keys = (function fluree$db$query$analytical$clause__GT_keys(clause){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc,var$){
var temp__5733__auto__ = fluree.db.query.analytical.variable_QMARK_(var$);
if(cljs.core.truth_(temp__5733__auto__)){
var var$__$1 = temp__5733__auto__;
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,var$__$1);
} else {
return acc;
}
}),cljs.core.PersistentVector.EMPTY,clause);
});
fluree.db.query.analytical.intersecting_keys_tuples_clause = (function fluree$db$query$analytical$intersecting_keys_tuples_clause(tuples,clause){
var rel_keys = cljs.core.set(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(tuples));
var clause_keys = fluree.db.query.analytical.clause__GT_keys(clause);
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (rel_keys,clause_keys){
return (function (acc,key){
if(cljs.core.truth_((rel_keys.cljs$core$IFn$_invoke$arity$1 ? rel_keys.cljs$core$IFn$_invoke$arity$1(key) : rel_keys.call(null,key)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,key);
} else {
return acc;
}
});})(rel_keys,clause_keys))
,cljs.core.PersistentVector.EMPTY,clause_keys);
});
fluree.db.query.analytical.intersecting_keys_tuples = (function fluree$db$query$analytical$intersecting_keys_tuples(a_tuples,b_tuples){
var a_keys = cljs.core.set(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(a_tuples));
var b_keys = cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_tuples);
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (a_keys,b_keys){
return (function (acc,key){
if(cljs.core.truth_((a_keys.cljs$core$IFn$_invoke$arity$1 ? a_keys.cljs$core$IFn$_invoke$arity$1(key) : a_keys.call(null,key)))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,key);
} else {
return acc;
}
});})(a_keys,b_keys))
,cljs.core.PersistentVector.EMPTY,b_keys);
});
fluree.db.query.analytical.select_from_tuples = (function fluree$db$query$analytical$select_from_tuples(vars,tuples){
var ns = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc,var_smt){
var temp__5733__auto__ = (function (){var or__4131__auto__ = fluree.db.query.analytical.variable_QMARK_(var_smt);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.cst$kw$variable.cljs$core$IFn$_invoke$arity$1(var_smt);
}
})();
if(cljs.core.truth_(temp__5733__auto__)){
var var$ = temp__5733__auto__;
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,fluree.db.util.core.index_of(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(tuples),var$));
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2([cljs.core.str.cljs$core$IFn$_invoke$arity$1(var_smt)," cannot be retrieved from the results. Check that it is declared in your where clause."].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null));
}
}),cljs.core.PersistentVector.EMPTY,vars);
return fluree.db.query.analytical.get_ns_arrays(ns,cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(tuples));
});
fluree.db.query.analytical.add_fuel = (function fluree$db$query$analytical$add_fuel(add_amount,fuel,max_fuel){
if(cljs.core.truth_((function (){var and__4120__auto__ = max_fuel;
if(cljs.core.truth_(and__4120__auto__)){
return (add_amount > max_fuel);
} else {
return and__4120__auto__;
}
})())){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Maximum query fuel exceeded: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(max_fuel)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_exceeded_DASH_cost], null));
} else {
if(cljs.core.truth_((function (){var and__4120__auto__ = fuel;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.volatile_QMARK_(fuel);
} else {
return and__4120__auto__;
}
})())){
return cljs.core._vreset_BANG_(fuel,(cljs.core._deref(fuel) + add_amount));
} else {
return null;
}
}
});
fluree.db.query.analytical.replace_vars_wikidata = (function fluree$db$query$analytical$replace_vars_wikidata(all_wd,intersecting_vars,vars){
return cljs.core.mapv.cljs$core$IFn$_invoke$arity$2((function (clause){
return cljs.core.mapv.cljs$core$IFn$_invoke$arity$2((function (clause_item){
var temp__5733__auto__ = (function (){var G__108673 = cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(clause_item);
return (intersecting_vars.cljs$core$IFn$_invoke$arity$1 ? intersecting_vars.cljs$core$IFn$_invoke$arity$1(G__108673) : intersecting_vars.call(null,G__108673));
})();
if(cljs.core.truth_(temp__5733__auto__)){
var key_replace = temp__5733__auto__;
var replacement = cljs.core.get.cljs$core$IFn$_invoke$arity$2(vars,key_replace);
var replacement_SINGLEQUOTE_ = ((typeof cljs.reader.read_string.cljs$core$IFn$_invoke$arity$1(replacement) === 'number')?replacement:["\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(replacement),"\""].join(''));
return replacement_SINGLEQUOTE_;
} else {
return clause_item;
}
}),clause);
}),all_wd);
});
fluree.db.query.analytical.wikidata__GT_tuples = (function fluree$db$query$analytical$wikidata__GT_tuples(q_map,clause,r,p__108676,optional_QMARK_,fuel,max_fuel){
var map__108677 = p__108676;
var map__108677__$1 = (((((!((map__108677 == null))))?(((((map__108677.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__108677.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__108677):map__108677);
var res = map__108677__$1;
var vars = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__108677__$1,cljs.core.cst$kw$vars);
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,map__108677,map__108677__$1,res,vars){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,map__108677,map__108677__$1,res,vars){
return (function (state_108740){
var state_val_108741 = (state_108740[(1)]);
if((state_val_108741 === (7))){
var inst_108736 = (state_108740[(2)]);
var state_108740__$1 = state_108740;
var statearr_108742_108763 = state_108740__$1;
(statearr_108742_108763[(2)] = inst_108736);


cljs.core.async.impl.ioc_helpers.process_exception(state_108740__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (1))){
var state_108740__$1 = state_108740;
var statearr_108743_108764 = state_108740__$1;
(statearr_108743_108764[(2)] = null);

(statearr_108743_108764[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_108740,(3),Error,null,(2));
var inst_108683 = (r == null);
var state_108740__$1 = state_108740;
if(cljs.core.truth_(inst_108683)){
var statearr_108744_108765 = state_108740__$1;
(statearr_108744_108765[(1)] = (5));

} else {
var statearr_108745_108766 = state_108740__$1;
(statearr_108745_108766[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (13))){
var inst_108728 = (state_108740[(2)]);
var state_108740__$1 = state_108740;
var statearr_108746_108767 = state_108740__$1;
(statearr_108746_108767[(2)] = inst_108728);

(statearr_108746_108767[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (6))){
var inst_108730 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_108731 = fluree.db.query.analytical_wikidata.drop_all_wd_clauses(r);
var inst_108732 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(inst_108731,clause);
var inst_108733 = [null,inst_108732];
var inst_108734 = (new cljs.core.PersistentVector(null,2,(5),inst_108730,inst_108733,null));
var state_108740__$1 = state_108740;
var statearr_108747_108768 = state_108740__$1;
(statearr_108747_108768[(2)] = inst_108734);

(statearr_108747_108768[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (3))){
var inst_108679 = (state_108740[(2)]);
var state_108740__$1 = state_108740;
var statearr_108748_108769 = state_108740__$1;
(statearr_108748_108769[(2)] = inst_108679);


cljs.core.async.impl.ioc_helpers.process_exception(state_108740__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (12))){
var inst_108686 = (state_108740[(7)]);
var inst_108698 = cljs.core.cst$kw$optional.cljs$core$IFn$_invoke$arity$1(q_map);
var inst_108699 = fluree.db.query.analytical_wikidata.get_all_wd_clauses(inst_108698);
var inst_108700 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(fluree.db.query.analytical.clause__GT_keys,inst_108686);
var inst_108701 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.concat,inst_108700);
var inst_108702 = cljs.core.set(inst_108701);
var inst_108703 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(fluree.db.query.analytical.clause__GT_keys,inst_108699);
var inst_108704 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.concat,inst_108703);
var inst_108705 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_108702,inst_108704);
var inst_108706 = (function (){var all_wd = inst_108686;
var optional = inst_108699;
var all_wd_vars = inst_108702;
var all_vars = inst_108705;
return ((function (all_wd,optional,all_wd_vars,all_vars,inst_108686,inst_108698,inst_108699,inst_108700,inst_108701,inst_108702,inst_108703,inst_108704,inst_108705,state_val_108741,c__99809__auto__,map__108677,map__108677__$1,res,vars){
return (function (p1__108674_SHARP_){
return (all_vars.cljs$core$IFn$_invoke$arity$1 ? all_vars.cljs$core$IFn$_invoke$arity$1(p1__108674_SHARP_) : all_vars.call(null,p1__108674_SHARP_));
});
;})(all_wd,optional,all_wd_vars,all_vars,inst_108686,inst_108698,inst_108699,inst_108700,inst_108701,inst_108702,inst_108703,inst_108704,inst_108705,state_val_108741,c__99809__auto__,map__108677,map__108677__$1,res,vars))
})();
var inst_108707 = cljs.core.keys(vars);
var inst_108708 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_108706,inst_108707);
var inst_108709 = cljs.core.remove.cljs$core$IFn$_invoke$arity$2(cljs.core.nil_QMARK_,inst_108708);
var inst_108710 = cljs.core.set(inst_108709);
var inst_108711 = (function (){var all_wd = inst_108686;
var optional = inst_108699;
var all_wd_vars = inst_108702;
var all_vars = inst_108705;
var intersecting_vars = inst_108710;
return ((function (all_wd,optional,all_wd_vars,all_vars,intersecting_vars,inst_108686,inst_108698,inst_108699,inst_108700,inst_108701,inst_108702,inst_108703,inst_108704,inst_108705,inst_108706,inst_108707,inst_108708,inst_108709,inst_108710,state_val_108741,c__99809__auto__,map__108677,map__108677__$1,res,vars){
return (function (p1__108675_SHARP_){
return fluree.db.query.analytical.intersecting_keys_tuples_clause(res,p1__108675_SHARP_);
});
;})(all_wd,optional,all_wd_vars,all_vars,intersecting_vars,inst_108686,inst_108698,inst_108699,inst_108700,inst_108701,inst_108702,inst_108703,inst_108704,inst_108705,inst_108706,inst_108707,inst_108708,inst_108709,inst_108710,state_val_108741,c__99809__auto__,map__108677,map__108677__$1,res,vars))
})();
var inst_108712 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_108711,inst_108686);
var inst_108713 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.concat,inst_108712);
var inst_108714 = fluree.db.query.analytical.select_from_tuples(inst_108713,res);
var inst_108715 = fluree.db.query.analytical.replace_vars_wikidata(inst_108686,inst_108710,vars);
var inst_108716 = cljs.core.remove.cljs$core$IFn$_invoke$arity$2(inst_108710,inst_108705);
var inst_108717 = fluree.db.query.analytical_wikidata.get_wikidata_tuples(q_map,inst_108715,inst_108713,inst_108714,inst_108716,inst_108699);
var state_108740__$1 = state_108740;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108740__$1,(14),inst_108717);
} else {
if((state_val_108741 === (2))){
var inst_108738 = (state_108740[(2)]);
var state_108740__$1 = state_108740;
return cljs.core.async.impl.ioc_helpers.return_chan(state_108740__$1,inst_108738);
} else {
if((state_val_108741 === (11))){
var inst_108694 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_108695 = [null,r];
var inst_108696 = (new cljs.core.PersistentVector(null,2,(5),inst_108694,inst_108695,null));
var state_108740__$1 = state_108740;
var statearr_108749_108770 = state_108740__$1;
(statearr_108749_108770[(2)] = inst_108696);

(statearr_108749_108770[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (9))){
var state_108740__$1 = state_108740;
var statearr_108750_108771 = state_108740__$1;
(statearr_108750_108771[(2)] = optional_QMARK_);

(statearr_108750_108771[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (5))){
var inst_108685 = cljs.core.cst$kw$where.cljs$core$IFn$_invoke$arity$1(q_map);
var inst_108686 = fluree.db.query.analytical_wikidata.get_all_wd_clauses(inst_108685);
var state_108740__$1 = (function (){var statearr_108751 = state_108740;
(statearr_108751[(7)] = inst_108686);

return statearr_108751;
})();
if(cljs.core.truth_(optional_QMARK_)){
var statearr_108752_108772 = state_108740__$1;
(statearr_108752_108772[(1)] = (8));

} else {
var statearr_108753_108773 = state_108740__$1;
(statearr_108753_108773[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (14))){
var inst_108719 = (state_108740[(2)]);
var inst_108720 = fluree.db.util.async.throw_err(inst_108719);
var inst_108721 = cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(inst_108720);
var inst_108722 = cljs.core.count(inst_108721);
var inst_108723 = fluree.db.query.analytical.add_fuel(inst_108722,fuel,max_fuel);
var inst_108724 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_108725 = [inst_108720,r];
var inst_108726 = (new cljs.core.PersistentVector(null,2,(5),inst_108724,inst_108725,null));
var state_108740__$1 = (function (){var statearr_108754 = state_108740;
(statearr_108754[(8)] = inst_108723);

return statearr_108754;
})();
var statearr_108755_108774 = state_108740__$1;
(statearr_108755_108774[(2)] = inst_108726);

(statearr_108755_108774[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (10))){
var inst_108692 = (state_108740[(2)]);
var state_108740__$1 = state_108740;
if(cljs.core.truth_(inst_108692)){
var statearr_108756_108775 = state_108740__$1;
(statearr_108756_108775[(1)] = (11));

} else {
var statearr_108757_108776 = state_108740__$1;
(statearr_108757_108776[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108741 === (8))){
var inst_108686 = (state_108740[(7)]);
var inst_108688 = cljs.core.empty_QMARK_(inst_108686);
var inst_108689 = (!(inst_108688));
var state_108740__$1 = state_108740;
var statearr_108758_108777 = state_108740__$1;
(statearr_108758_108777[(2)] = inst_108689);

(statearr_108758_108777[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,map__108677,map__108677__$1,res,vars))
;
return ((function (switch__99702__auto__,c__99809__auto__,map__108677,map__108677__$1,res,vars){
return (function() {
var fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto__ = null;
var fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto____0 = (function (){
var statearr_108759 = [null,null,null,null,null,null,null,null,null];
(statearr_108759[(0)] = fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto__);

(statearr_108759[(1)] = (1));

return statearr_108759;
});
var fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto____1 = (function (state_108740){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_108740);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e108760){if((e108760 instanceof Object)){
var ex__99706__auto__ = e108760;
var statearr_108761_108778 = state_108740;
(statearr_108761_108778[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_108740);

return cljs.core.cst$kw$recur;
} else {
throw e108760;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__108779 = state_108740;
state_108740 = G__108779;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto__ = function(state_108740){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto____1.call(this,state_108740);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto____0;
fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto____1;
return fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,map__108677,map__108677__$1,res,vars))
})();
var state__99811__auto__ = (function (){var statearr_108762 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_108762[(6)] = c__99809__auto__);

return statearr_108762;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,map__108677,map__108677__$1,res,vars))
);

return c__99809__auto__;
});
fluree.db.query.analytical.db_ident_QMARK_ = (function fluree$db$query$analytical$db_ident_QMARK_(source){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.count(clojure.string.split.cljs$core$IFn$_invoke$arity$2(source,/\//)),(2));
});
fluree.db.query.analytical.parse_block_from_source = (function fluree$db$query$analytical$parse_block_from_source(block){
var block_SINGLEQUOTE_ = fluree.db.query.analytical.safe_read_string(block);
if(cljs.core.int_QMARK_(block_SINGLEQUOTE_)){
return block_SINGLEQUOTE_;
} else {
return block;
}
});
fluree.db.query.analytical.isolate_source_name = (function fluree$db$query$analytical$isolate_source_name(dbid){
return cljs.core.re_find(/[a-z]+/,dbid);
});
fluree.db.query.analytical.isolate_source_block = (function fluree$db$query$analytical$isolate_source_block(dbid){
return cljs.core.re_find(/[A-Z0-9]+/,dbid);
});
fluree.db.query.analytical.get_source_clause = (function fluree$db$query$analytical$get_source_clause(var_args){
var G__108781 = arguments.length;
switch (G__108781) {
case 2:
return fluree.db.query.analytical.get_source_clause.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return fluree.db.query.analytical.get_source_clause.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.analytical.get_source_clause.cljs$core$IFn$_invoke$arity$2 = (function (db,clause){
return fluree.db.query.analytical.get_source_clause.cljs$core$IFn$_invoke$arity$4(db,clause,cljs.core.PersistentArrayMap.EMPTY,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.analytical.get_source_clause.cljs$core$IFn$_invoke$arity$4 = (function (db,clause,prefixes,opts){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_108872){
var state_val_108873 = (state_108872[(1)]);
if((state_val_108873 === (7))){
var inst_108868 = (state_108872[(2)]);
var state_108872__$1 = state_108872;
var statearr_108874_108916 = state_108872__$1;
(statearr_108874_108916[(2)] = inst_108868);


cljs.core.async.impl.ioc_helpers.process_exception(state_108872__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (20))){
var inst_108862 = (state_108872[(2)]);
var state_108872__$1 = state_108872;
var statearr_108875_108917 = state_108872__$1;
(statearr_108875_108917[(2)] = inst_108862);

(statearr_108875_108917[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (27))){
var inst_108844 = (state_108872[(2)]);
var inst_108845 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_108846 = cljs.core.PersistentVector.EMPTY;
var inst_108847 = cljs.core.subvec.cljs$core$IFn$_invoke$arity$3(clause,(1),(4));
var inst_108848 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_108846,inst_108847);
var inst_108849 = [inst_108844,inst_108848];
var inst_108850 = (new cljs.core.PersistentVector(null,2,(5),inst_108845,inst_108849,null));
var state_108872__$1 = state_108872;
var statearr_108876_108918 = state_108872__$1;
(statearr_108876_108918[(2)] = inst_108850);

(statearr_108876_108918[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (1))){
var state_108872__$1 = state_108872;
var statearr_108877_108919 = state_108872__$1;
(statearr_108877_108919[(2)] = null);

(statearr_108877_108919[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (24))){
var inst_108829 = (state_108872[(7)]);
var inst_108835 = (state_108872[(2)]);
var inst_108836 = fluree.db.util.async.throw_err(inst_108835);
var state_108872__$1 = (function (){var statearr_108878 = state_108872;
(statearr_108878[(8)] = inst_108836);

return statearr_108878;
})();
if(cljs.core.truth_(inst_108829)){
var statearr_108879_108920 = state_108872__$1;
(statearr_108879_108920[(1)] = (25));

} else {
var statearr_108880_108921 = state_108872__$1;
(statearr_108880_108921[(1)] = (26));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (4))){
var inst_108786 = (state_108872[(9)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_108872,(3),Error,null,(2));
var inst_108786__$1 = cljs.core.first(clause);
var inst_108787 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("$fdb",inst_108786__$1);
var state_108872__$1 = (function (){var statearr_108881 = state_108872;
(statearr_108881[(9)] = inst_108786__$1);

return statearr_108881;
})();
if(inst_108787){
var statearr_108882_108922 = state_108872__$1;
(statearr_108882_108922[(1)] = (5));

} else {
var statearr_108883_108923 = state_108872__$1;
(statearr_108883_108923[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (15))){
var inst_108819 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_108820 = ["$wd",clause];
var inst_108821 = (new cljs.core.PersistentVector(null,2,(5),inst_108819,inst_108820,null));
var state_108872__$1 = state_108872;
var statearr_108884_108924 = state_108872__$1;
(statearr_108884_108924[(2)] = inst_108821);

(statearr_108884_108924[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (21))){
var inst_108827 = (state_108872[(10)]);
var inst_108825 = (state_108872[(11)]);
var inst_108829 = fluree.db.query.analytical.parse_block_from_source(inst_108825);
var inst_108830 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_108831 = [cljs.core.cst$kw$sources,inst_108827];
var inst_108832 = (new cljs.core.PersistentVector(null,2,(5),inst_108830,inst_108831,null));
var inst_108833 = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(opts,inst_108832);
var state_108872__$1 = (function (){var statearr_108885 = state_108872;
(statearr_108885[(7)] = inst_108829);

return statearr_108885;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108872__$1,(24),inst_108833);
} else {
if((state_val_108873 === (13))){
var state_108872__$1 = state_108872;
var statearr_108886_108925 = state_108872__$1;
(statearr_108886_108925[(2)] = null);

(statearr_108886_108925[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (22))){
var inst_108786 = (state_108872[(9)]);
var inst_108852 = ["The data source: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_108786)," is not supported in Fluree"].join('');
var inst_108853 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_108854 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_108855 = cljs.core.PersistentHashMap.fromArrays(inst_108853,inst_108854);
var inst_108856 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_108852,inst_108855);
var inst_108857 = (function(){throw inst_108856})();
var state_108872__$1 = state_108872;
var statearr_108887_108926 = state_108872__$1;
(statearr_108887_108926[(2)] = inst_108857);

(statearr_108887_108926[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (6))){
var inst_108786 = (state_108872[(9)]);
var inst_108796 = clojure.string.starts_with_QMARK_(inst_108786,"$fdb");
var state_108872__$1 = state_108872;
if(inst_108796){
var statearr_108888_108927 = state_108872__$1;
(statearr_108888_108927[(1)] = (8));

} else {
var statearr_108889_108928 = state_108872__$1;
(statearr_108889_108928[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (28))){
var inst_108840 = (state_108872[(2)]);
var inst_108841 = fluree.db.util.async.throw_err(inst_108840);
var state_108872__$1 = state_108872;
var statearr_108890_108929 = state_108872__$1;
(statearr_108890_108929[(2)] = inst_108841);

(statearr_108890_108929[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (25))){
var inst_108829 = (state_108872[(7)]);
var inst_108836 = (state_108872[(8)]);
var inst_108838 = fluree.db.time_travel.as_of_block(inst_108836,inst_108829);
var state_108872__$1 = state_108872;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108872__$1,(28),inst_108838);
} else {
if((state_val_108873 === (17))){
var inst_108864 = (state_108872[(2)]);
var state_108872__$1 = state_108872;
var statearr_108891_108930 = state_108872__$1;
(statearr_108891_108930[(2)] = inst_108864);

(statearr_108891_108930[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (3))){
var inst_108782 = (state_108872[(2)]);
var state_108872__$1 = state_108872;
var statearr_108892_108931 = state_108872__$1;
(statearr_108892_108931[(2)] = inst_108782);


cljs.core.async.impl.ioc_helpers.process_exception(state_108872__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (12))){
var inst_108803 = (state_108872[(12)]);
var inst_108806 = (function(){throw inst_108803})();
var state_108872__$1 = state_108872;
var statearr_108893_108932 = state_108872__$1;
(statearr_108893_108932[(2)] = inst_108806);

(statearr_108893_108932[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (2))){
var inst_108870 = (state_108872[(2)]);
var state_108872__$1 = state_108872;
return cljs.core.async.impl.ioc_helpers.return_chan(state_108872__$1,inst_108870);
} else {
if((state_val_108873 === (23))){
var inst_108859 = (state_108872[(2)]);
var state_108872__$1 = state_108872;
var statearr_108894_108933 = state_108872__$1;
(statearr_108894_108933[(2)] = inst_108859);

(statearr_108894_108933[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (19))){
var state_108872__$1 = state_108872;
var statearr_108895_108934 = state_108872__$1;
(statearr_108895_108934[(2)] = null);

(statearr_108895_108934[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (11))){
var inst_108803 = (state_108872[(12)]);
var inst_108802 = (state_108872[(2)]);
var inst_108803__$1 = fluree.db.util.async.throw_err(inst_108802);
var inst_108804 = fluree.db.util.core.exception_QMARK_(inst_108803__$1);
var state_108872__$1 = (function (){var statearr_108896 = state_108872;
(statearr_108896[(12)] = inst_108803__$1);

return statearr_108896;
})();
if(inst_108804){
var statearr_108897_108935 = state_108872__$1;
(statearr_108897_108935[(1)] = (12));

} else {
var statearr_108898_108936 = state_108872__$1;
(statearr_108898_108936[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (9))){
var inst_108786 = (state_108872[(9)]);
var inst_108817 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("$wd",inst_108786);
var state_108872__$1 = state_108872;
if(inst_108817){
var statearr_108899_108937 = state_108872__$1;
(statearr_108899_108937[(1)] = (15));

} else {
var statearr_108900_108938 = state_108872__$1;
(statearr_108900_108938[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (5))){
var inst_108789 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_108790 = cljs.core.PersistentVector.EMPTY;
var inst_108791 = cljs.core.subvec.cljs$core$IFn$_invoke$arity$3(clause,(1),(4));
var inst_108792 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_108790,inst_108791);
var inst_108793 = [db,inst_108792];
var inst_108794 = (new cljs.core.PersistentVector(null,2,(5),inst_108789,inst_108793,null));
var state_108872__$1 = state_108872;
var statearr_108901_108939 = state_108872__$1;
(statearr_108901_108939[(2)] = inst_108794);

(statearr_108901_108939[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (14))){
var inst_108803 = (state_108872[(12)]);
var inst_108809 = (state_108872[(2)]);
var inst_108810 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_108811 = cljs.core.PersistentVector.EMPTY;
var inst_108812 = cljs.core.subvec.cljs$core$IFn$_invoke$arity$3(clause,(1),(4));
var inst_108813 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_108811,inst_108812);
var inst_108814 = [inst_108803,inst_108813];
var inst_108815 = (new cljs.core.PersistentVector(null,2,(5),inst_108810,inst_108814,null));
var state_108872__$1 = (function (){var statearr_108902 = state_108872;
(statearr_108902[(13)] = inst_108809);

return statearr_108902;
})();
var statearr_108903_108940 = state_108872__$1;
(statearr_108903_108940[(2)] = inst_108815);

(statearr_108903_108940[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (26))){
var inst_108836 = (state_108872[(8)]);
var state_108872__$1 = state_108872;
var statearr_108904_108941 = state_108872__$1;
(statearr_108904_108941[(2)] = inst_108836);

(statearr_108904_108941[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (16))){
var state_108872__$1 = state_108872;
var statearr_108905_108942 = state_108872__$1;
(statearr_108905_108942[(1)] = (18));



return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (10))){
var inst_108866 = (state_108872[(2)]);
var state_108872__$1 = state_108872;
var statearr_108907_108943 = state_108872__$1;
(statearr_108907_108943[(2)] = inst_108866);

(statearr_108907_108943[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (18))){
var inst_108827 = (state_108872[(10)]);
var inst_108786 = (state_108872[(9)]);
var inst_108824 = fluree.db.query.analytical.isolate_source_name(inst_108786);
var inst_108825 = fluree.db.query.analytical.isolate_source_block(inst_108786);
var inst_108826 = cljs.core.keyword.cljs$core$IFn$_invoke$arity$1(inst_108824);
var inst_108827__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(prefixes,inst_108826);
var state_108872__$1 = (function (){var statearr_108908 = state_108872;
(statearr_108908[(10)] = inst_108827__$1);

(statearr_108908[(11)] = inst_108825);

return statearr_108908;
})();
if(cljs.core.truth_(inst_108827__$1)){
var statearr_108909_108944 = state_108872__$1;
(statearr_108909_108944[(1)] = (21));

} else {
var statearr_108910_108945 = state_108872__$1;
(statearr_108910_108945[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_108873 === (8))){
var inst_108786 = (state_108872[(9)]);
var inst_108798 = cljs.core.subs.cljs$core$IFn$_invoke$arity$2(inst_108786,(4));
var inst_108799 = fluree.db.query.analytical.parse_block_from_source(inst_108798);
var inst_108800 = fluree.db.time_travel.as_of_block(db,inst_108799);
var state_108872__$1 = state_108872;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_108872__$1,(11),inst_108800);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$analytical$state_machine__99703__auto__ = null;
var fluree$db$query$analytical$state_machine__99703__auto____0 = (function (){
var statearr_108911 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_108911[(0)] = fluree$db$query$analytical$state_machine__99703__auto__);

(statearr_108911[(1)] = (1));

return statearr_108911;
});
var fluree$db$query$analytical$state_machine__99703__auto____1 = (function (state_108872){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_108872);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e108912){if((e108912 instanceof Object)){
var ex__99706__auto__ = e108912;
var statearr_108913_108946 = state_108872;
(statearr_108913_108946[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_108872);

return cljs.core.cst$kw$recur;
} else {
throw e108912;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__108947 = state_108872;
state_108872 = G__108947;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical$state_machine__99703__auto__ = function(state_108872){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical$state_machine__99703__auto____1.call(this,state_108872);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$state_machine__99703__auto____0;
fluree$db$query$analytical$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$state_machine__99703__auto____1;
return fluree$db$query$analytical$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_108914 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_108914[(6)] = c__99809__auto__);

return statearr_108914;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

fluree.db.query.analytical.get_source_clause.cljs$lang$maxFixedArity = 4;

fluree.db.query.analytical.tuples__GT_map = (function fluree$db$query$analytical$tuples__GT_map(start_map,tuples){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc,p__108948){
var vec__108949 = p__108948;
var sub = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__108949,(0),null);
var obj = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__108949,(1),null);
return cljs.core.update.cljs$core$IFn$_invoke$arity$4(acc,sub,cljs.core.conj,obj);
}),start_map,tuples);
});
fluree.db.query.analytical.expand_map = (function fluree$db$query$analytical$expand_map(tuple_map){
return cljs.core.zipmap(cljs.core.keys(tuple_map),cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__108952_SHARP_){
return cljs.core.PersistentHashMap.fromArrays([cljs.core.cst$kw$done,cljs.core.cst$kw$followed,cljs.core.cst$kw$all],[false,cljs.core.PersistentHashSet.EMPTY,cljs.core.set(p1__108952_SHARP_)]);
}),cljs.core.vals(tuple_map)));
});
fluree.db.query.analytical.follow_all_original_subject_paths = (function fluree$db$query$analytical$follow_all_original_subject_paths(subjects,tuple_map){
var expanded_map = fluree.db.query.analytical.expand_map(tuple_map);
var G__108956 = subjects;
var vec__108957 = G__108956;
var seq__108958 = cljs.core.seq(vec__108957);
var first__108959 = cljs.core.first(seq__108958);
var seq__108958__$1 = cljs.core.next(seq__108958);
var subject = first__108959;
var r = seq__108958__$1;
var acc = expanded_map;
var G__108956__$1 = G__108956;
var acc__$1 = acc;
while(true){
var vec__108963 = G__108956__$1;
var seq__108964 = cljs.core.seq(vec__108963);
var first__108965 = cljs.core.first(seq__108964);
var seq__108964__$1 = cljs.core.next(seq__108964);
var subject__$1 = first__108965;
var r__$1 = seq__108964__$1;
var acc__$2 = acc__$1;
if(cljs.core.not(subject__$1)){
return acc__$2;
} else {
if(cljs.core.truth_(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(acc__$2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,cljs.core.cst$kw$done], null)))){
var G__108966 = r__$1;
var G__108967 = acc__$2;
G__108956__$1 = G__108966;
acc__$1 = G__108967;
continue;
} else {
var subject_all = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(acc__$2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,cljs.core.cst$kw$all], null));
var subject_followed = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(acc__$2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,cljs.core.cst$kw$followed], null));
var subjects_to_follow = clojure.set.difference.cljs$core$IFn$_invoke$arity$2(subject_all,subject_followed);
var acc_STAR_ = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (G__108956__$1,acc__$1,subject_all,subject_followed,subjects_to_follow,vec__108963,seq__108964,first__108965,seq__108964__$1,subject__$1,r__$1,acc__$2,G__108956,vec__108957,seq__108958,first__108959,seq__108958__$1,subject,r,acc,expanded_map){
return (function (acc__$3,subject_to_follow){
var all_followed = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(acc__$3,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,cljs.core.cst$kw$followed], null));
var self_QMARK_ = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(subject__$1,subject_to_follow);
var already_followed_QMARK_ = ((self_QMARK_)?false:(all_followed.cljs$core$IFn$_invoke$arity$1 ? all_followed.cljs$core$IFn$_invoke$arity$1(subject_to_follow) : all_followed.call(null,subject_to_follow)));
var acc_SINGLEQUOTE_ = cljs.core.update_in.cljs$core$IFn$_invoke$arity$4(acc__$3,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,cljs.core.cst$kw$followed], null),cljs.core.conj,subject_to_follow);
if(cljs.core.truth_((function (){var or__4131__auto__ = already_followed_QMARK_;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return self_QMARK_;
}
})())){
return acc_SINGLEQUOTE_;
} else {
var subject_to_follow_all = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(acc_SINGLEQUOTE_,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject_to_follow,cljs.core.cst$kw$all], null));
var acc_SINGLEQUOTE___$1 = cljs.core.update_in.cljs$core$IFn$_invoke$arity$3(acc_SINGLEQUOTE_,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,cljs.core.cst$kw$all], null),((function (G__108956__$1,acc__$1,subject_to_follow_all,all_followed,self_QMARK_,already_followed_QMARK_,acc_SINGLEQUOTE_,subject_all,subject_followed,subjects_to_follow,vec__108963,seq__108964,first__108965,seq__108964__$1,subject__$1,r__$1,acc__$2,G__108956,vec__108957,seq__108958,first__108959,seq__108958__$1,subject,r,acc,expanded_map){
return (function (existing){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(cljs.core.conj,existing,subject_to_follow_all);
});})(G__108956__$1,acc__$1,subject_to_follow_all,all_followed,self_QMARK_,already_followed_QMARK_,acc_SINGLEQUOTE_,subject_all,subject_followed,subjects_to_follow,vec__108963,seq__108964,first__108965,seq__108964__$1,subject__$1,r__$1,acc__$2,G__108956,vec__108957,seq__108958,first__108959,seq__108958__$1,subject,r,acc,expanded_map))
);
if(cljs.core.truth_(cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(acc_SINGLEQUOTE___$1,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject_to_follow,cljs.core.cst$kw$done], null)))){
return cljs.core.update_in.cljs$core$IFn$_invoke$arity$3(acc_SINGLEQUOTE___$1,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,cljs.core.cst$kw$followed], null),((function (G__108956__$1,acc__$1,subject_to_follow_all,acc_SINGLEQUOTE___$1,all_followed,self_QMARK_,already_followed_QMARK_,acc_SINGLEQUOTE_,subject_all,subject_followed,subjects_to_follow,vec__108963,seq__108964,first__108965,seq__108964__$1,subject__$1,r__$1,acc__$2,G__108956,vec__108957,seq__108958,first__108959,seq__108958__$1,subject,r,acc,expanded_map){
return (function (existing){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$3(cljs.core.conj,existing,subject_to_follow_all);
});})(G__108956__$1,acc__$1,subject_to_follow_all,acc_SINGLEQUOTE___$1,all_followed,self_QMARK_,already_followed_QMARK_,acc_SINGLEQUOTE_,subject_all,subject_followed,subjects_to_follow,vec__108963,seq__108964,first__108965,seq__108964__$1,subject__$1,r__$1,acc__$2,G__108956,vec__108957,seq__108958,first__108959,seq__108958__$1,subject,r,acc,expanded_map))
);
} else {
return acc_SINGLEQUOTE___$1;
}
}
});})(G__108956__$1,acc__$1,subject_all,subject_followed,subjects_to_follow,vec__108963,seq__108964,first__108965,seq__108964__$1,subject__$1,r__$1,acc__$2,G__108956,vec__108957,seq__108958,first__108959,seq__108958__$1,subject,r,acc,expanded_map))
,acc__$2,subjects_to_follow);
var subject_followed_count = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(acc__$2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,cljs.core.cst$kw$followed], null));
var subject_all_count = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(acc__$2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,cljs.core.cst$kw$all], null));
var subject_done_QMARK_ = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(subject_followed_count,subject_all_count);
if(subject_done_QMARK_){
var G__108968 = r__$1;
var G__108969 = cljs.core.assoc_in(acc_STAR_,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,cljs.core.cst$kw$done], null),true);
G__108956__$1 = G__108968;
acc__$1 = G__108969;
continue;
} else {
var G__108970 = subjects;
var G__108971 = acc_STAR_;
G__108956__$1 = G__108970;
acc__$1 = G__108971;
continue;
}

}
}
break;
}
});
fluree.db.query.analytical.recur_map__GT_tuples = (function fluree$db$query$analytical$recur_map__GT_tuples(subjects,recur_map){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc,subject){
var subject_vals = cljs.core.get_in.cljs$core$IFn$_invoke$arity$2(recur_map,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject,cljs.core.cst$kw$followed], null));
return cljs.core.concat.cljs$core$IFn$_invoke$arity$2(acc,cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (subject_vals){
return (function (p1__108972_SHARP_){
return (new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[subject,p1__108972_SHARP_],null));
});})(subject_vals))
,subject_vals));
}),cljs.core.PersistentVector.EMPTY,subjects);
});
fluree.db.query.analytical.tuples__GT_recur = (function fluree$db$query$analytical$tuples__GT_recur(db,predicate,recur_map,depth,var_first_QMARK_){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_109058){
var state_val_109059 = (state_109058[(1)]);
if((state_val_109059 === (7))){
var inst_108981 = (state_109058[(2)]);
var inst_108982 = recur_map;
var inst_108983 = (1);
var state_109058__$1 = (function (){var statearr_109060 = state_109058;
(statearr_109060[(7)] = inst_108982);

(statearr_109060[(8)] = inst_108983);

(statearr_109060[(9)] = inst_108981);

return statearr_109060;
})();
var statearr_109061_109098 = state_109058__$1;
(statearr_109061_109098[(2)] = null);

(statearr_109061_109098[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (20))){
var inst_109029 = (state_109058[(2)]);
var state_109058__$1 = state_109058;
var statearr_109062_109099 = state_109058__$1;
(statearr_109062_109099[(2)] = inst_109029);

(statearr_109062_109099[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (1))){
var state_109058__$1 = state_109058;
var statearr_109063_109100 = state_109058__$1;
(statearr_109063_109100[(2)] = null);

(statearr_109063_109100[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (24))){
var inst_109054 = (state_109058[(2)]);
var state_109058__$1 = state_109058;
var statearr_109064_109101 = state_109058__$1;
(statearr_109064_109101[(2)] = inst_109054);


cljs.core.async.impl.ioc_helpers.process_exception(state_109058__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_109058,(3),Error,null,(2));
var state_109058__$1 = state_109058;
if(cljs.core.truth_(depth)){
var statearr_109065_109102 = state_109058__$1;
(statearr_109065_109102[(1)] = (5));

} else {
var statearr_109066_109103 = state_109058__$1;
(statearr_109066_109103[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (15))){
var inst_109040 = (state_109058[(2)]);
var state_109058__$1 = state_109058;
var statearr_109067_109104 = state_109058__$1;
(statearr_109067_109104[(2)] = inst_109040);

(statearr_109067_109104[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (21))){
var inst_109008 = (state_109058[(10)]);
var inst_109016 = (state_109058[(11)]);
var inst_109023 = (state_109058[(2)]);
var inst_109024 = fluree.db.util.async.throw_err(inst_109023);
var inst_109025 = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(inst_109008,inst_109024);
var inst_109008__$1 = inst_109025;
var inst_109009 = inst_109016;
var state_109058__$1 = (function (){var statearr_109068 = state_109058;
(statearr_109068[(10)] = inst_109008__$1);

(statearr_109068[(12)] = inst_109009);

return statearr_109068;
})();
var statearr_109069_109105 = state_109058__$1;
(statearr_109069_109105[(2)] = null);

(statearr_109069_109105[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (13))){
var inst_108982 = (state_109058[(7)]);
var state_109058__$1 = state_109058;
var statearr_109070_109106 = state_109058__$1;
(statearr_109070_109106[(2)] = inst_108982);

(statearr_109070_109106[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (22))){
var inst_109047 = (state_109058[(13)]);
var state_109058__$1 = state_109058;
var statearr_109071_109107 = state_109058__$1;
(statearr_109071_109107[(2)] = inst_109047);

(statearr_109071_109107[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (6))){
var state_109058__$1 = state_109058;
var statearr_109072_109108 = state_109058__$1;
(statearr_109072_109108[(2)] = (100));

(statearr_109072_109108[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (17))){
var inst_108982 = (state_109058[(7)]);
var inst_108983 = (state_109058[(8)]);
var inst_109031 = (state_109058[(2)]);
var inst_109032 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109033 = [(0),(2)];
var inst_109034 = (new cljs.core.PersistentVector(null,2,(5),inst_109032,inst_109033,null));
var inst_109035 = fluree.db.query.analytical.get_ns_arrays(inst_109034,inst_109031);
var inst_109036 = fluree.db.query.analytical.tuples__GT_map(inst_108982,inst_109035);
var inst_109037 = (inst_108983 + (1));
var inst_108982__$1 = inst_109036;
var inst_108983__$1 = inst_109037;
var state_109058__$1 = (function (){var statearr_109073 = state_109058;
(statearr_109073[(7)] = inst_108982__$1);

(statearr_109073[(8)] = inst_108983__$1);

return statearr_109073;
})();
var statearr_109074_109109 = state_109058__$1;
(statearr_109074_109109[(2)] = null);

(statearr_109074_109109[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (3))){
var inst_108974 = (state_109058[(2)]);
var state_109058__$1 = state_109058;
var statearr_109075_109110 = state_109058__$1;
(statearr_109075_109110[(2)] = inst_108974);


cljs.core.async.impl.ioc_helpers.process_exception(state_109058__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (12))){
var inst_109042 = (state_109058[(2)]);
var state_109058__$1 = state_109058;
var statearr_109076_109111 = state_109058__$1;
(statearr_109076_109111[(2)] = inst_109042);

(statearr_109076_109111[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (2))){
var inst_109056 = (state_109058[(2)]);
var state_109058__$1 = state_109058;
return cljs.core.async.impl.ioc_helpers.return_chan(state_109058__$1,inst_109056);
} else {
if((state_val_109059 === (23))){
var inst_109046 = (state_109058[(14)]);
var inst_108981 = (state_109058[(9)]);
var inst_109047 = (state_109058[(13)]);
var inst_109045 = (state_109058[(15)]);
var inst_109050 = (function (){var max_depth = inst_108981;
var recur_map__$1 = inst_109046;
var subjects = inst_109045;
var tuples = inst_109047;
return ((function (max_depth,recur_map__$1,subjects,tuples,inst_109046,inst_108981,inst_109047,inst_109045,state_val_109059,c__99809__auto__){
return (function (p1__108973_SHARP_){
return (new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.second(p1__108973_SHARP_)],null));
});
;})(max_depth,recur_map__$1,subjects,tuples,inst_109046,inst_108981,inst_109047,inst_109045,state_val_109059,c__99809__auto__))
})();
var inst_109051 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_109050,inst_109047);
var inst_109052 = cljs.core.distinct.cljs$core$IFn$_invoke$arity$1(inst_109051);
var state_109058__$1 = state_109058;
var statearr_109077_109112 = state_109058__$1;
(statearr_109077_109112[(2)] = inst_109052);

(statearr_109077_109112[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (19))){
var inst_109008 = (state_109058[(10)]);
var state_109058__$1 = state_109058;
var statearr_109078_109113 = state_109058__$1;
(statearr_109078_109113[(2)] = inst_109008);

(statearr_109078_109113[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (11))){
var inst_108982 = (state_109058[(7)]);
var inst_108993 = (state_109058[(16)]);
var inst_108988 = cljs.core.vals(inst_108982);
var inst_108989 = cljs.core.flatten(inst_108988);
var inst_108990 = cljs.core.set(inst_108989);
var inst_108991 = cljs.core.keys(inst_108982);
var inst_108992 = cljs.core.set(inst_108991);
var inst_108993__$1 = clojure.set.difference.cljs$core$IFn$_invoke$arity$2(inst_108990,inst_108992);
var inst_108994 = cljs.core.empty_QMARK_(inst_108993__$1);
var state_109058__$1 = (function (){var statearr_109079 = state_109058;
(statearr_109079[(16)] = inst_108993__$1);

return statearr_109079;
})();
if(inst_108994){
var statearr_109080_109114 = state_109058__$1;
(statearr_109080_109114[(1)] = (13));

} else {
var statearr_109081_109115 = state_109058__$1;
(statearr_109081_109115[(1)] = (14));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (9))){
var inst_109046 = (state_109058[(14)]);
var inst_109045 = (state_109058[(15)]);
var inst_109044 = (state_109058[(2)]);
var inst_109045__$1 = cljs.core.keys(inst_109044);
var inst_109046__$1 = fluree.db.query.analytical.follow_all_original_subject_paths(inst_109045__$1,inst_109044);
var inst_109047 = fluree.db.query.analytical.recur_map__GT_tuples(inst_109045__$1,inst_109046__$1);
var state_109058__$1 = (function (){var statearr_109082 = state_109058;
(statearr_109082[(14)] = inst_109046__$1);

(statearr_109082[(13)] = inst_109047);

(statearr_109082[(15)] = inst_109045__$1);

return statearr_109082;
})();
if(cljs.core.truth_(var_first_QMARK_)){
var statearr_109083_109116 = state_109058__$1;
(statearr_109083_109116[(1)] = (22));

} else {
var statearr_109084_109117 = state_109058__$1;
(statearr_109084_109117[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (5))){
var state_109058__$1 = state_109058;
var statearr_109085_109118 = state_109058__$1;
(statearr_109085_109118[(2)] = depth);

(statearr_109085_109118[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (14))){
var inst_108993 = (state_109058[(16)]);
var inst_109004 = cljs.core.PersistentVector.EMPTY;
var inst_109005 = cljs.core.seq(inst_108993);
var inst_109006 = cljs.core.first(inst_109005);
var inst_109007 = cljs.core.next(inst_109005);
var inst_109008 = inst_109004;
var inst_109009 = inst_108993;
var state_109058__$1 = (function (){var statearr_109086 = state_109058;
(statearr_109086[(17)] = inst_109006);

(statearr_109086[(18)] = inst_109007);

(statearr_109086[(10)] = inst_109008);

(statearr_109086[(12)] = inst_109009);

return statearr_109086;
})();
var statearr_109087_109119 = state_109058__$1;
(statearr_109087_109119[(2)] = null);

(statearr_109087_109119[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (16))){
var inst_109015 = (state_109058[(19)]);
var inst_109009 = (state_109058[(12)]);
var inst_109014 = cljs.core.seq(inst_109009);
var inst_109015__$1 = cljs.core.first(inst_109014);
var inst_109016 = cljs.core.next(inst_109014);
var state_109058__$1 = (function (){var statearr_109088 = state_109058;
(statearr_109088[(19)] = inst_109015__$1);

(statearr_109088[(11)] = inst_109016);

return statearr_109088;
})();
if(cljs.core.truth_(inst_109015__$1)){
var statearr_109089_109120 = state_109058__$1;
(statearr_109089_109120[(1)] = (18));

} else {
var statearr_109090_109121 = state_109058__$1;
(statearr_109090_109121[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (10))){
var inst_108982 = (state_109058[(7)]);
var state_109058__$1 = state_109058;
var statearr_109091_109122 = state_109058__$1;
(statearr_109091_109122[(2)] = inst_108982);

(statearr_109091_109122[(1)] = (12));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109059 === (18))){
var inst_109015 = (state_109058[(19)]);
var inst_109018 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109019 = [inst_109015,predicate];
var inst_109020 = (new cljs.core.PersistentVector(null,2,(5),inst_109018,inst_109019,null));
var inst_109021 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(db,cljs.core.cst$kw$spot,cljs.core._EQ_,inst_109020);
var state_109058__$1 = state_109058;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109058__$1,(21),inst_109021);
} else {
if((state_val_109059 === (8))){
var inst_108983 = (state_109058[(8)]);
var inst_108981 = (state_109058[(9)]);
var inst_108985 = (inst_108983 >= inst_108981);
var state_109058__$1 = state_109058;
if(cljs.core.truth_(inst_108985)){
var statearr_109092_109123 = state_109058__$1;
(statearr_109092_109123[(1)] = (10));

} else {
var statearr_109093_109124 = state_109058__$1;
(statearr_109093_109124[(1)] = (11));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto__ = null;
var fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto____0 = (function (){
var statearr_109094 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_109094[(0)] = fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto__);

(statearr_109094[(1)] = (1));

return statearr_109094;
});
var fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto____1 = (function (state_109058){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_109058);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e109095){if((e109095 instanceof Object)){
var ex__99706__auto__ = e109095;
var statearr_109096_109125 = state_109058;
(statearr_109096_109125[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_109058);

return cljs.core.cst$kw$recur;
} else {
throw e109095;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__109126 = state_109058;
state_109058 = G__109126;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto__ = function(state_109058){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto____1.call(this,state_109058);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto____0;
fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto____1;
return fluree$db$query$analytical$tuples__GT_recur_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_109097 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_109097[(6)] = c__99809__auto__);

return statearr_109097;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.query.analytical.fdb_clause__GT_tuples = (function fluree$db$query$analytical$fdb_clause__GT_tuples(db,p__109127,clause,fuel,max_fuel){
var map__109128 = p__109127;
var map__109128__$1 = (((((!((map__109128 == null))))?(((((map__109128.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__109128.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__109128):map__109128);
var res = map__109128__$1;
var headers = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109128__$1,cljs.core.cst$kw$headers);
var tuples = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109128__$1,cljs.core.cst$kw$tuples);
var vars = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109128__$1,cljs.core.cst$kw$vars);
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,map__109128,map__109128__$1,res,headers,tuples,vars){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,map__109128,map__109128__$1,res,headers,tuples,vars){
return (function (state_109257){
var state_val_109258 = (state_109257[(1)]);
if((state_val_109258 === (7))){
var inst_109154 = (state_109257[(2)]);
var state_109257__$1 = state_109257;
if(cljs.core.truth_(inst_109154)){
var statearr_109259_109318 = state_109257__$1;
(statearr_109259_109318[(1)] = (11));

} else {
var statearr_109260_109319 = state_109257__$1;
(statearr_109260_109319[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (20))){
var inst_109161 = (state_109257[(7)]);
var inst_109249 = (state_109257[(2)]);
var inst_109250 = [cljs.core.cst$kw$headers,cljs.core.cst$kw$vars,cljs.core.cst$kw$tuples];
var inst_109251 = cljs.core.keys(inst_109161);
var inst_109252 = [inst_109251,vars,inst_109249];
var inst_109253 = cljs.core.PersistentHashMap.fromArrays(inst_109250,inst_109252);
var state_109257__$1 = state_109257;
var statearr_109261_109320 = state_109257__$1;
(statearr_109261_109320[(2)] = inst_109253);


cljs.core.async.impl.ioc_helpers.process_exception(state_109257__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (27))){
var inst_109190 = (state_109257[(8)]);
var inst_109220 = cljs.core.PersistentHashMap.EMPTY;
var inst_109221 = fluree.db.query.analytical.tuples__GT_map(inst_109220,inst_109190);
var state_109257__$1 = state_109257;
var statearr_109262_109321 = state_109257__$1;
(statearr_109262_109321[(2)] = inst_109221);

(statearr_109262_109321[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (1))){
var state_109257__$1 = state_109257;
var statearr_109263_109322 = state_109257__$1;
(statearr_109263_109322[(2)] = null);

(statearr_109263_109322[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (24))){
var state_109257__$1 = state_109257;
var statearr_109264_109323 = state_109257__$1;
(statearr_109264_109323[(2)] = null);

(statearr_109264_109323[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (4))){
var inst_109138 = (state_109257[(9)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_109257,(3),Error,null,(2));
var inst_109138__$1 = fluree.db.query.analytical.clause__GT_rel(db,vars,clause);
var inst_109140 = (inst_109138__$1 == null);
var inst_109141 = cljs.core.not(inst_109140);
var state_109257__$1 = (function (){var statearr_109265 = state_109257;
(statearr_109265[(9)] = inst_109138__$1);

return statearr_109265;
})();
if(inst_109141){
var statearr_109266_109324 = state_109257__$1;
(statearr_109266_109324[(1)] = (5));

} else {
var statearr_109267_109325 = state_109257__$1;
(statearr_109267_109325[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (15))){
var inst_109164 = (state_109257[(10)]);
var state_109257__$1 = state_109257;
var statearr_109268_109326 = state_109257__$1;
(statearr_109268_109326[(2)] = inst_109164);

(statearr_109268_109326[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (21))){
var inst_109174 = (state_109257[(11)]);
var inst_109198 = ["Cannot use predicate recursion when predicate is variable. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_109174)].join('');
var inst_109199 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_109200 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_109201 = cljs.core.PersistentHashMap.fromArrays(inst_109199,inst_109200);
var inst_109202 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_109198,inst_109201);
var inst_109203 = (function(){throw inst_109202})();
var state_109257__$1 = state_109257;
var statearr_109269_109327 = state_109257__$1;
(statearr_109269_109327[(2)] = inst_109203);

(statearr_109269_109327[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (31))){
var inst_109192 = (state_109257[(12)]);
var inst_109229 = cljs.core.coll_QMARK_(inst_109192);
var state_109257__$1 = state_109257;
if(inst_109229){
var statearr_109270_109328 = state_109257__$1;
(statearr_109270_109328[(1)] = (33));

} else {
var statearr_109271_109329 = state_109257__$1;
(statearr_109271_109329[(1)] = (34));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (32))){
var inst_109240 = (state_109257[(2)]);
var state_109257__$1 = state_109257;
var statearr_109272_109330 = state_109257__$1;
(statearr_109272_109330[(2)] = inst_109240);

(statearr_109272_109330[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (33))){
var inst_109186 = (state_109257[(13)]);
var inst_109190 = (state_109257[(8)]);
var inst_109231 = cljs.core.PersistentHashMap.EMPTY;
var inst_109232 = cljs.core.first(inst_109186);
var inst_109233 = cljs.core.first(inst_109232);
var inst_109234 = cljs.core.flatten(inst_109190);
var inst_109235 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_109231,inst_109233,inst_109234);
var state_109257__$1 = state_109257;
var statearr_109273_109331 = state_109257__$1;
(statearr_109273_109331[(2)] = inst_109235);

(statearr_109273_109331[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (13))){
var inst_109165 = (state_109257[(14)]);
var inst_109176 = (state_109257[(15)]);
var inst_109164 = (state_109257[(10)]);
var inst_109161 = (state_109257[(7)]);
var inst_109159 = (state_109257[(2)]);
var inst_109160 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_109159,cljs.core.cst$kw$search);
var inst_109161__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_109159,cljs.core.cst$kw$rel);
var inst_109162 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_109159,cljs.core.cst$kw$opts);
var inst_109163 = fluree.db.query.analytical.intersecting_keys_tuples_clause(res,clause);
var inst_109164__$1 = cljs.core.cst$kw$object_DASH_fn.cljs$core$IFn$_invoke$arity$1(inst_109162);
var inst_109165__$1 = cljs.core.cst$kw$recur.cljs$core$IFn$_invoke$arity$1(inst_109162);
var inst_109167 = (function (){var map__109134 = inst_109159;
var search = inst_109160;
var rel = inst_109161__$1;
var opts = inst_109162;
var common_keys = inst_109163;
var object_fn = inst_109164__$1;
var recur_depth = inst_109165__$1;
return ((function (map__109134,search,rel,opts,common_keys,object_fn,recur_depth,inst_109165,inst_109176,inst_109164,inst_109161,inst_109159,inst_109160,inst_109161__$1,inst_109162,inst_109163,inst_109164__$1,inst_109165__$1,state_val_109258,c__99809__auto__,map__109128,map__109128__$1,res,headers,tuples,vars){
return (function (p__109166,common_key){
var vec__109274 = p__109166;
var acc = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109274,(0),null);
var clause_SINGLEQUOTE_ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109274,(1),null);
var idx_of = fluree.db.util.core.index_of(clause,cljs.core.str.cljs$core$IFn$_invoke$arity$1(common_key));
var k = (function (){var pred__109277 = cljs.core._EQ_;
var expr__109278 = idx_of;
if(cljs.core.truth_((pred__109277.cljs$core$IFn$_invoke$arity$2 ? pred__109277.cljs$core$IFn$_invoke$arity$2((0),expr__109278) : pred__109277.call(null,(0),expr__109278)))){
return cljs.core.cst$kw$subject_DASH_fn;
} else {
if(cljs.core.truth_((pred__109277.cljs$core$IFn$_invoke$arity$2 ? pred__109277.cljs$core$IFn$_invoke$arity$2((1),expr__109278) : pred__109277.call(null,(1),expr__109278)))){
return cljs.core.cst$kw$predicate_DASH_fn;
} else {
if(cljs.core.truth_((pred__109277.cljs$core$IFn$_invoke$arity$2 ? pred__109277.cljs$core$IFn$_invoke$arity$2((2),expr__109278) : pred__109277.call(null,(2),expr__109278)))){
return cljs.core.cst$kw$object_DASH_fn;
} else {
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(expr__109278)].join('')));
}
}
}
})();
var res_idx = fluree.db.util.core.index_of(headers,common_key);
var v = cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentHashSet.EMPTY,cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.first,fluree.db.query.analytical.get_ns_arrays(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [res_idx], null),tuples)));
var single_v_QMARK_ = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((1),cljs.core.count(v));
var v__$1 = (cljs.core.truth_((function (){var and__4120__auto__ = (!(single_v_QMARK_));
if(and__4120__auto__){
var and__4120__auto____$1 = object_fn;
if(cljs.core.truth_(and__4120__auto____$1)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(k,object_fn);
} else {
return and__4120__auto____$1;
}
} else {
return and__4120__auto__;
}
})())?cljs.core.comp.cljs$core$IFn$_invoke$arity$2(v,object_fn):v);
if(single_v_QMARK_){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [acc,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(clause_SINGLEQUOTE_,idx_of,cljs.core.first(v__$1))], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(acc,k,v__$1),clause_SINGLEQUOTE_], null);
}
});
;})(map__109134,search,rel,opts,common_keys,object_fn,recur_depth,inst_109165,inst_109176,inst_109164,inst_109161,inst_109159,inst_109160,inst_109161__$1,inst_109162,inst_109163,inst_109164__$1,inst_109165__$1,state_val_109258,c__99809__auto__,map__109128,map__109128__$1,res,headers,tuples,vars))
})();
var inst_109168 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109169 = cljs.core.PersistentHashMap.EMPTY;
var inst_109170 = [inst_109169,inst_109160];
var inst_109171 = (new cljs.core.PersistentVector(null,2,(5),inst_109168,inst_109170,null));
var inst_109172 = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(inst_109167,inst_109171,inst_109163);
var inst_109173 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_109172,(0),null);
var inst_109174 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_109172,(1),null);
var inst_109175 = [cljs.core.cst$kw$object_DASH_fn];
var inst_109176__$1 = cljs.core.cst$kw$object_DASH_fn.cljs$core$IFn$_invoke$arity$1(inst_109173);
var state_109257__$1 = (function (){var statearr_109280 = state_109257;
(statearr_109280[(14)] = inst_109165__$1);

(statearr_109280[(15)] = inst_109176__$1);

(statearr_109280[(11)] = inst_109174);

(statearr_109280[(16)] = inst_109175);

(statearr_109280[(10)] = inst_109164__$1);

(statearr_109280[(7)] = inst_109161__$1);

return statearr_109280;
})();
if(cljs.core.truth_(inst_109176__$1)){
var statearr_109281_109332 = state_109257__$1;
(statearr_109281_109332[(1)] = (14));

} else {
var statearr_109282_109333 = state_109257__$1;
(statearr_109282_109333[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (22))){
var state_109257__$1 = state_109257;
var statearr_109283_109334 = state_109257__$1;
(statearr_109283_109334[(2)] = null);

(statearr_109283_109334[(1)] = (23));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (36))){
var inst_109245 = (state_109257[(2)]);
var inst_109246 = fluree.db.util.async.throw_err(inst_109245);
var state_109257__$1 = state_109257;
var statearr_109284_109335 = state_109257__$1;
(statearr_109284_109335[(2)] = inst_109246);

(statearr_109284_109335[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (29))){
var inst_109195 = (state_109257[(17)]);
var inst_109165 = (state_109257[(14)]);
var inst_109194 = (state_109257[(18)]);
var inst_109242 = (state_109257[(2)]);
var inst_109243 = fluree.db.query.analytical.tuples__GT_recur(db,inst_109195,inst_109242,inst_109165,inst_109194);
var state_109257__$1 = state_109257;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109257__$1,(36),inst_109243);
} else {
if((state_val_109258 === (6))){
var state_109257__$1 = state_109257;
var statearr_109285_109336 = state_109257__$1;
(statearr_109285_109336[(2)] = false);

(statearr_109285_109336[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (28))){
var inst_109192 = (state_109257[(12)]);
var inst_109223 = typeof inst_109192 === 'number';
var state_109257__$1 = state_109257;
if(cljs.core.truth_(inst_109223)){
var statearr_109286_109337 = state_109257__$1;
(statearr_109286_109337[(1)] = (30));

} else {
var statearr_109287_109338 = state_109257__$1;
(statearr_109287_109338[(1)] = (31));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (25))){
var inst_109174 = (state_109257[(11)]);
var inst_109211 = ["Cannot use predicate recursion when object is not a variable. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_109174)].join('');
var inst_109212 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_109213 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_109214 = cljs.core.PersistentHashMap.fromArrays(inst_109212,inst_109213);
var inst_109215 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_109211,inst_109214);
var inst_109216 = (function(){throw inst_109215})();
var state_109257__$1 = state_109257;
var statearr_109288_109339 = state_109257__$1;
(statearr_109288_109339[(2)] = inst_109216);

(statearr_109288_109339[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (34))){
var state_109257__$1 = state_109257;
var statearr_109289_109340 = state_109257__$1;
(statearr_109289_109340[(2)] = null);

(statearr_109289_109340[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (17))){
var inst_109165 = (state_109257[(14)]);
var inst_109186 = (state_109257[(13)]);
var inst_109161 = (state_109257[(7)]);
var inst_109185 = (state_109257[(2)]);
var inst_109186__$1 = fluree.db.util.async.throw_err(inst_109185);
var inst_109187 = cljs.core.count(inst_109186__$1);
var inst_109188 = fluree.db.query.analytical.add_fuel(inst_109187,fuel,max_fuel);
var inst_109189 = cljs.core.vals(inst_109161);
var inst_109190 = fluree.db.query.analytical.get_ns_arrays(inst_109189,inst_109186__$1);
var state_109257__$1 = (function (){var statearr_109290 = state_109257;
(statearr_109290[(13)] = inst_109186__$1);

(statearr_109290[(19)] = inst_109188);

(statearr_109290[(8)] = inst_109190);

return statearr_109290;
})();
if(cljs.core.truth_(inst_109165)){
var statearr_109291_109341 = state_109257__$1;
(statearr_109291_109341[(1)] = (18));

} else {
var statearr_109292_109342 = state_109257__$1;
(statearr_109292_109342[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (3))){
var inst_109130 = (state_109257[(2)]);
var state_109257__$1 = state_109257;
var statearr_109293_109343 = state_109257__$1;
(statearr_109293_109343[(2)] = inst_109130);


cljs.core.async.impl.ioc_helpers.process_exception(state_109257__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (12))){
var inst_109138 = (state_109257[(9)]);
var state_109257__$1 = state_109257;
var statearr_109294_109344 = state_109257__$1;
(statearr_109294_109344[(2)] = inst_109138);

(statearr_109294_109344[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (2))){
var inst_109255 = (state_109257[(2)]);
var state_109257__$1 = state_109257;
return cljs.core.async.impl.ioc_helpers.return_chan(state_109257__$1,inst_109255);
} else {
if((state_val_109258 === (23))){
var inst_109206 = (state_109257[(2)]);
var inst_109207 = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(clause,(2));
var inst_109208 = fluree.db.query.analytical.variable_QMARK_(inst_109207);
var state_109257__$1 = (function (){var statearr_109295 = state_109257;
(statearr_109295[(20)] = inst_109206);

return statearr_109295;
})();
if(cljs.core.truth_(inst_109208)){
var statearr_109296_109345 = state_109257__$1;
(statearr_109296_109345[(1)] = (24));

} else {
var statearr_109297_109346 = state_109257__$1;
(statearr_109297_109346[(1)] = (25));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (35))){
var inst_109238 = (state_109257[(2)]);
var state_109257__$1 = state_109257;
var statearr_109298_109347 = state_109257__$1;
(statearr_109298_109347[(2)] = inst_109238);

(statearr_109298_109347[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (19))){
var inst_109190 = (state_109257[(8)]);
var state_109257__$1 = state_109257;
var statearr_109299_109348 = state_109257__$1;
(statearr_109299_109348[(2)] = inst_109190);

(statearr_109299_109348[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (11))){
var inst_109138 = (state_109257[(9)]);
var inst_109156 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,inst_109138);
var state_109257__$1 = state_109257;
var statearr_109300_109349 = state_109257__$1;
(statearr_109300_109349[(2)] = inst_109156);

(statearr_109300_109349[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (9))){
var state_109257__$1 = state_109257;
var statearr_109301_109350 = state_109257__$1;
(statearr_109301_109350[(2)] = false);

(statearr_109301_109350[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (5))){
var inst_109138 = (state_109257[(9)]);
var inst_109143 = inst_109138.cljs$lang$protocol_mask$partition0$;
var inst_109144 = (inst_109143 & (64));
var inst_109145 = inst_109138.cljs$core$ISeq$;
var inst_109146 = (cljs.core.PROTOCOL_SENTINEL === inst_109145);
var inst_109147 = ((inst_109144) || (inst_109146));
var state_109257__$1 = state_109257;
if(cljs.core.truth_(inst_109147)){
var statearr_109302_109351 = state_109257__$1;
(statearr_109302_109351[(1)] = (8));

} else {
var statearr_109303_109352 = state_109257__$1;
(statearr_109303_109352[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (14))){
var inst_109176 = (state_109257[(15)]);
var state_109257__$1 = state_109257;
var statearr_109304_109353 = state_109257__$1;
(statearr_109304_109353[(2)] = inst_109176);

(statearr_109304_109353[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (26))){
var inst_109194 = (state_109257[(18)]);
var inst_109218 = (state_109257[(2)]);
var state_109257__$1 = (function (){var statearr_109305 = state_109257;
(statearr_109305[(21)] = inst_109218);

return statearr_109305;
})();
if(cljs.core.truth_(inst_109194)){
var statearr_109306_109354 = state_109257__$1;
(statearr_109306_109354[(1)] = (27));

} else {
var statearr_109307_109355 = state_109257__$1;
(statearr_109307_109355[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (16))){
var inst_109174 = (state_109257[(11)]);
var inst_109175 = (state_109257[(16)]);
var inst_109180 = (state_109257[(2)]);
var inst_109181 = [inst_109180];
var inst_109182 = cljs.core.PersistentHashMap.fromArrays(inst_109175,inst_109181);
var inst_109183 = fluree.db.query.range.search.cljs$core$IFn$_invoke$arity$3(db,inst_109174,inst_109182);
var state_109257__$1 = state_109257;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109257__$1,(17),inst_109183);
} else {
if((state_val_109258 === (30))){
var inst_109190 = (state_109257[(8)]);
var inst_109192 = (state_109257[(12)]);
var inst_109225 = cljs.core.PersistentHashMap.EMPTY;
var inst_109226 = cljs.core.flatten(inst_109190);
var inst_109227 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_109225,inst_109192,inst_109226);
var state_109257__$1 = state_109257;
var statearr_109308_109356 = state_109257__$1;
(statearr_109308_109356[(2)] = inst_109227);

(statearr_109308_109356[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (10))){
var inst_109151 = (state_109257[(2)]);
var state_109257__$1 = state_109257;
var statearr_109309_109357 = state_109257__$1;
(statearr_109309_109357[(2)] = inst_109151);

(statearr_109309_109357[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (18))){
var inst_109195 = (state_109257[(17)]);
var inst_109174 = (state_109257[(11)]);
var inst_109192 = cljs.core.first(inst_109174);
var inst_109193 = cljs.core.first(clause);
var inst_109194 = fluree.db.query.analytical.variable_QMARK_(inst_109193);
var inst_109195__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(inst_109174,(1));
var inst_109196 = fluree.db.query.analytical.variable_QMARK_(inst_109195__$1);
var state_109257__$1 = (function (){var statearr_109310 = state_109257;
(statearr_109310[(17)] = inst_109195__$1);

(statearr_109310[(18)] = inst_109194);

(statearr_109310[(12)] = inst_109192);

return statearr_109310;
})();
if(cljs.core.truth_(inst_109196)){
var statearr_109311_109358 = state_109257__$1;
(statearr_109311_109358[(1)] = (21));

} else {
var statearr_109312_109359 = state_109257__$1;
(statearr_109312_109359[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109258 === (8))){
var state_109257__$1 = state_109257;
var statearr_109313_109360 = state_109257__$1;
(statearr_109313_109360[(2)] = true);

(statearr_109313_109360[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,map__109128,map__109128__$1,res,headers,tuples,vars))
;
return ((function (switch__99702__auto__,c__99809__auto__,map__109128,map__109128__$1,res,headers,tuples,vars){
return (function() {
var fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto__ = null;
var fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto____0 = (function (){
var statearr_109314 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_109314[(0)] = fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto__);

(statearr_109314[(1)] = (1));

return statearr_109314;
});
var fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto____1 = (function (state_109257){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_109257);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e109315){if((e109315 instanceof Object)){
var ex__99706__auto__ = e109315;
var statearr_109316_109361 = state_109257;
(statearr_109316_109361[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_109257);

return cljs.core.cst$kw$recur;
} else {
throw e109315;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__109362 = state_109257;
state_109257 = G__109362;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto__ = function(state_109257){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto____1.call(this,state_109257);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto____0;
fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto____1;
return fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,map__109128,map__109128__$1,res,headers,tuples,vars))
})();
var state__99811__auto__ = (function (){var statearr_109317 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_109317[(6)] = c__99809__auto__);

return statearr_109317;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,map__109128,map__109128__$1,res,headers,tuples,vars))
);

return c__99809__auto__;
});
fluree.db.query.analytical.full_text__GT_tuples = (function fluree$db$query$analytical$full_text__GT_tuples(db,res,clause){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Full text search is not supported in JS",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null));
});
fluree.db.query.analytical.collection__GT_tuples = (function fluree$db$query$analytical$collection__GT_tuples(db,res,clause){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_109458){
var state_val_109459 = (state_109458[(1)]);
if((state_val_109459 === (7))){
var inst_109376 = (state_109458[(2)]);
var state_109458__$1 = state_109458;
if(cljs.core.truth_(inst_109376)){
var statearr_109460_109493 = state_109458__$1;
(statearr_109460_109493[(1)] = (8));

} else {
var statearr_109461_109494 = state_109458__$1;
(statearr_109461_109494[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (20))){
var inst_109423 = (state_109458[(7)]);
var state_109458__$1 = state_109458;
var statearr_109462_109495 = state_109458__$1;
(statearr_109462_109495[(2)] = inst_109423);

(statearr_109462_109495[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (1))){
var state_109458__$1 = state_109458;
var statearr_109463_109496 = state_109458__$1;
(statearr_109463_109496[(2)] = null);

(statearr_109463_109496[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (4))){
var inst_109370 = (state_109458[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_109458,(3),Error,null,(2));
var inst_109369 = cljs.core.first(clause);
var inst_109370__$1 = fluree.db.query.analytical.variable_QMARK_(inst_109369);
var inst_109371 = cljs.core.last(clause);
var inst_109372 = fluree.db.query.analytical.variable_QMARK_(inst_109371);
var state_109458__$1 = (function (){var statearr_109464 = state_109458;
(statearr_109464[(9)] = inst_109372);

(statearr_109464[(8)] = inst_109370__$1);

return statearr_109464;
})();
if(cljs.core.truth_(inst_109370__$1)){
var statearr_109465_109497 = state_109458__$1;
(statearr_109465_109497[(1)] = (5));

} else {
var statearr_109466_109498 = state_109458__$1;
(statearr_109466_109498[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (15))){
var inst_109372 = (state_109458[(9)]);
var inst_109370 = (state_109458[(8)]);
var inst_109403 = cljs.core.last(clause);
var inst_109404 = fluree.db.dbproto._c_prop(db,cljs.core.cst$kw$id,inst_109403);
var inst_109405 = cljs.core.cst$kw$ecount.cljs$core$IFn$_invoke$arity$1(db);
var inst_109406 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_109405,inst_109404);
var inst_109407 = fluree.db.flake.min_subject_id(inst_109404);
var inst_109408 = [cljs.core.cst$kw$headers,cljs.core.cst$kw$tuples,cljs.core.cst$kw$vars];
var inst_109409 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109410 = [inst_109370];
var inst_109411 = (new cljs.core.PersistentVector(null,1,(5),inst_109409,inst_109410,null));
var inst_109412 = (function (){var subject_var = inst_109370;
var object_var = inst_109372;
var cid = inst_109404;
var max_sid = inst_109406;
var min_sid = inst_109407;
return ((function (subject_var,object_var,cid,max_sid,min_sid,inst_109372,inst_109370,inst_109403,inst_109404,inst_109405,inst_109406,inst_109407,inst_109408,inst_109409,inst_109410,inst_109411,state_val_109459,c__99809__auto__){
return (function (p1__109364_SHARP_){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,p1__109364_SHARP_);
});
;})(subject_var,object_var,cid,max_sid,min_sid,inst_109372,inst_109370,inst_109403,inst_109404,inst_109405,inst_109406,inst_109407,inst_109408,inst_109409,inst_109410,inst_109411,state_val_109459,c__99809__auto__))
})();
var inst_109413 = (inst_109406 + (1));
var inst_109414 = cljs.core.range.cljs$core$IFn$_invoke$arity$2(inst_109407,inst_109413);
var inst_109415 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_109412,inst_109414);
var inst_109416 = cljs.core.PersistentHashMap.EMPTY;
var inst_109417 = [inst_109411,inst_109415,inst_109416];
var inst_109418 = cljs.core.PersistentHashMap.fromArrays(inst_109408,inst_109417);
var state_109458__$1 = state_109458;
var statearr_109467_109499 = state_109458__$1;
(statearr_109467_109499[(2)] = inst_109418);

(statearr_109467_109499[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (21))){
var inst_109423 = (state_109458[(7)]);
var inst_109427 = fluree.db.dbproto._subid.cljs$core$IFn$_invoke$arity$2(db,inst_109423);
var state_109458__$1 = state_109458;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109458__$1,(23),inst_109427);
} else {
if((state_val_109459 === (13))){
var inst_109452 = (state_109458[(2)]);
var state_109458__$1 = state_109458;
var statearr_109468_109500 = state_109458__$1;
(statearr_109468_109500[(2)] = inst_109452);

(statearr_109468_109500[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (22))){
var inst_109372 = (state_109458[(9)]);
var inst_109432 = (state_109458[(2)]);
var inst_109433 = fluree.db.flake.sid__GT_cid(inst_109432);
var inst_109434 = fluree.db.dbproto._c_prop(db,cljs.core.cst$kw$name,inst_109433);
var inst_109435 = [cljs.core.cst$kw$headers,cljs.core.cst$kw$tuples,cljs.core.cst$kw$vars];
var inst_109436 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109437 = [inst_109372];
var inst_109438 = (new cljs.core.PersistentVector(null,1,(5),inst_109436,inst_109437,null));
var inst_109439 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109440 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109441 = [inst_109434];
var inst_109442 = (new cljs.core.PersistentVector(null,1,(5),inst_109440,inst_109441,null));
var inst_109443 = [inst_109442];
var inst_109444 = (new cljs.core.PersistentVector(null,1,(5),inst_109439,inst_109443,null));
var inst_109445 = cljs.core.PersistentHashMap.EMPTY;
var inst_109446 = [inst_109438,inst_109444,inst_109445];
var inst_109447 = cljs.core.PersistentHashMap.fromArrays(inst_109435,inst_109446);
var state_109458__$1 = state_109458;
var statearr_109469_109501 = state_109458__$1;
(statearr_109469_109501[(2)] = inst_109447);

(statearr_109469_109501[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (6))){
var inst_109370 = (state_109458[(8)]);
var state_109458__$1 = state_109458;
var statearr_109470_109502 = state_109458__$1;
(statearr_109470_109502[(2)] = inst_109370);

(statearr_109470_109502[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (17))){
var inst_109423 = (state_109458[(7)]);
var inst_109423__$1 = cljs.core.first(clause);
var inst_109424 = typeof inst_109423__$1 === 'number';
var state_109458__$1 = (function (){var statearr_109471 = state_109458;
(statearr_109471[(7)] = inst_109423__$1);

return statearr_109471;
})();
if(cljs.core.truth_(inst_109424)){
var statearr_109472_109503 = state_109458__$1;
(statearr_109472_109503[(1)] = (20));

} else {
var statearr_109473_109504 = state_109458__$1;
(statearr_109473_109504[(1)] = (21));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (3))){
var inst_109365 = (state_109458[(2)]);
var state_109458__$1 = state_109458;
var statearr_109474_109505 = state_109458__$1;
(statearr_109474_109505[(2)] = inst_109365);


cljs.core.async.impl.ioc_helpers.process_exception(state_109458__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (12))){
var inst_109372 = (state_109458[(9)]);
var state_109458__$1 = state_109458;
if(cljs.core.truth_(inst_109372)){
var statearr_109475_109506 = state_109458__$1;
(statearr_109475_109506[(1)] = (17));

} else {
var statearr_109476_109507 = state_109458__$1;
(statearr_109476_109507[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (2))){
var inst_109456 = (state_109458[(2)]);
var state_109458__$1 = state_109458;
return cljs.core.async.impl.ioc_helpers.return_chan(state_109458__$1,inst_109456);
} else {
if((state_val_109459 === (23))){
var inst_109429 = (state_109458[(2)]);
var inst_109430 = fluree.db.util.async.throw_err(inst_109429);
var state_109458__$1 = state_109458;
var statearr_109477_109508 = state_109458__$1;
(statearr_109477_109508[(2)] = inst_109430);

(statearr_109477_109508[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (19))){
var inst_109450 = (state_109458[(2)]);
var state_109458__$1 = state_109458;
var statearr_109478_109509 = state_109458__$1;
(statearr_109478_109509[(2)] = inst_109450);

(statearr_109478_109509[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (11))){
var inst_109385 = ["_tx",null,"_block",null];
var inst_109386 = (new cljs.core.PersistentArrayMap(null,2,inst_109385,null));
var inst_109387 = (new cljs.core.PersistentHashSet(null,inst_109386,null));
var inst_109388 = cljs.core.last(clause);
var inst_109389 = (inst_109387.cljs$core$IFn$_invoke$arity$1 ? inst_109387.cljs$core$IFn$_invoke$arity$1(inst_109388) : inst_109387.call(null,inst_109388));
var state_109458__$1 = state_109458;
if(cljs.core.truth_(inst_109389)){
var statearr_109479_109510 = state_109458__$1;
(statearr_109479_109510[(1)] = (14));

} else {
var statearr_109480_109511 = state_109458__$1;
(statearr_109480_109511[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (9))){
var inst_109370 = (state_109458[(8)]);
var state_109458__$1 = state_109458;
if(cljs.core.truth_(inst_109370)){
var statearr_109481_109512 = state_109458__$1;
(statearr_109481_109512[(1)] = (11));

} else {
var statearr_109482_109513 = state_109458__$1;
(statearr_109482_109513[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (5))){
var inst_109372 = (state_109458[(9)]);
var state_109458__$1 = state_109458;
var statearr_109483_109514 = state_109458__$1;
(statearr_109483_109514[(2)] = inst_109372);

(statearr_109483_109514[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (14))){
var inst_109372 = (state_109458[(9)]);
var inst_109370 = (state_109458[(8)]);
var inst_109391 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(db);
var inst_109392 = [cljs.core.cst$kw$headers,cljs.core.cst$kw$tuples,cljs.core.cst$kw$vars];
var inst_109393 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109394 = [inst_109370];
var inst_109395 = (new cljs.core.PersistentVector(null,1,(5),inst_109393,inst_109394,null));
var inst_109396 = (function (){var subject_var = inst_109370;
var object_var = inst_109372;
var min_sid = inst_109391;
var max_sid = (0);
return ((function (subject_var,object_var,min_sid,max_sid,inst_109372,inst_109370,inst_109391,inst_109392,inst_109393,inst_109394,inst_109395,state_val_109459,c__99809__auto__){
return (function (p1__109363_SHARP_){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,p1__109363_SHARP_);
});
;})(subject_var,object_var,min_sid,max_sid,inst_109372,inst_109370,inst_109391,inst_109392,inst_109393,inst_109394,inst_109395,state_val_109459,c__99809__auto__))
})();
var inst_109397 = cljs.core.range.cljs$core$IFn$_invoke$arity$2(inst_109391,(0));
var inst_109398 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_109396,inst_109397);
var inst_109399 = cljs.core.PersistentHashMap.EMPTY;
var inst_109400 = [inst_109395,inst_109398,inst_109399];
var inst_109401 = cljs.core.PersistentHashMap.fromArrays(inst_109392,inst_109400);
var state_109458__$1 = state_109458;
var statearr_109484_109515 = state_109458__$1;
(statearr_109484_109515[(2)] = inst_109401);

(statearr_109484_109515[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (16))){
var inst_109420 = (state_109458[(2)]);
var state_109458__$1 = state_109458;
var statearr_109485_109516 = state_109458__$1;
(statearr_109485_109516[(2)] = inst_109420);

(statearr_109485_109516[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (10))){
var inst_109454 = (state_109458[(2)]);
var state_109458__$1 = state_109458;
var statearr_109486_109517 = state_109458__$1;
(statearr_109486_109517[(2)] = inst_109454);


cljs.core.async.impl.ioc_helpers.process_exception(state_109458__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (18))){
var state_109458__$1 = state_109458;
var statearr_109487_109518 = state_109458__$1;
(statearr_109487_109518[(2)] = null);

(statearr_109487_109518[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109459 === (8))){
var inst_109378 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_109379 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_109380 = cljs.core.PersistentHashMap.fromArrays(inst_109378,inst_109379);
var inst_109381 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("When using rdf:type, either a subject or a type (collection) must be specified.",inst_109380);
var inst_109382 = (function(){throw inst_109381})();
var state_109458__$1 = state_109458;
var statearr_109488_109519 = state_109458__$1;
(statearr_109488_109519[(2)] = inst_109382);

(statearr_109488_109519[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto__ = null;
var fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto____0 = (function (){
var statearr_109489 = [null,null,null,null,null,null,null,null,null,null];
(statearr_109489[(0)] = fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto__);

(statearr_109489[(1)] = (1));

return statearr_109489;
});
var fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto____1 = (function (state_109458){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_109458);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e109490){if((e109490 instanceof Object)){
var ex__99706__auto__ = e109490;
var statearr_109491_109520 = state_109458;
(statearr_109491_109520[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_109458);

return cljs.core.cst$kw$recur;
} else {
throw e109490;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__109521 = state_109458;
state_109458 = G__109521;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto__ = function(state_109458){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto____1.call(this,state_109458);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto____0;
fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto____1;
return fluree$db$query$analytical$collection__GT_tuples_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_109492 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_109492[(6)] = c__99809__auto__);

return statearr_109492;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.query.analytical.all_functions = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 41, ["isIRI",null,"YEAR",null,"UCASE",null,"isBLANK",null,"MONTH",null,"STRSTARTS",null,"sameTerm",null,"NOW",null,"MINUTES",null,"isURI",null,"IF",null,"COALESCE",null,"STRLEN",null,"CONCAT",null,"CONTAINS",null,"SHA512",null,"CEIL",null,"SECONDS",null,"SHA384",null,"RAND",null,"TZ",null,"isNUMERIC",null,"STRENDS",null,"STRAFTER",null,"ENCODE_FOR_URI",null,"HOURS",null,"LCASE",null,"STRDT",null,"FLOOR",null,"SHA1",null,"STRBEFORE",null,"STR",null,"TIMEZONE",null,"DAY",null,"SHA256",null,"isLITERAL",null,"STRUUID",null,"MD5",null,"ABS",null,"STRLANG",null,"UUID",null], null), null);
fluree.db.query.analytical.built_in_aggregates = (function (){var sum = (function fluree$db$query$analytical$sum(coll){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._PLUS_,(0),coll);
});
var avg = (function fluree$db$query$analytical$avg(coll){
return (sum(coll) / cljs.core.count(coll));
});
var median = (function fluree$db$query$analytical$median(coll){
var terms = cljs.core.sort.cljs$core$IFn$_invoke$arity$1(coll);
var size = cljs.core.count(coll);
var med = (size >> (1));
var G__109528 = cljs.core.nth.cljs$core$IFn$_invoke$arity$2(terms,med);
if(cljs.core.even_QMARK_(size)){
return ((G__109528 + cljs.core.nth.cljs$core$IFn$_invoke$arity$2(terms,(med - (1)))) / (2));
} else {
return G__109528;
}
});
var variance = (function fluree$db$query$analytical$variance(coll){
var mean = avg(coll);
var sum__$1 = sum((function (){var iter__4523__auto__ = ((function (mean){
return (function fluree$db$query$analytical$variance_$_iter__109529(s__109530){
return (new cljs.core.LazySeq(null,((function (mean){
return (function (){
var s__109530__$1 = s__109530;
while(true){
var temp__5735__auto__ = cljs.core.seq(s__109530__$1);
if(temp__5735__auto__){
var s__109530__$2 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_(s__109530__$2)){
var c__4521__auto__ = cljs.core.chunk_first(s__109530__$2);
var size__4522__auto__ = cljs.core.count(c__4521__auto__);
var b__109532 = cljs.core.chunk_buffer(size__4522__auto__);
if((function (){var i__109531 = (0);
while(true){
if((i__109531 < size__4522__auto__)){
var x = cljs.core._nth.cljs$core$IFn$_invoke$arity$2(c__4521__auto__,i__109531);
var delta = (x - mean);
cljs.core.chunk_append(b__109532,(delta * delta));

var G__109534 = (i__109531 + (1));
i__109531 = G__109534;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons(cljs.core.chunk(b__109532),fluree$db$query$analytical$variance_$_iter__109529(cljs.core.chunk_rest(s__109530__$2)));
} else {
return cljs.core.chunk_cons(cljs.core.chunk(b__109532),null);
}
} else {
var x = cljs.core.first(s__109530__$2);
var delta = (x - mean);
return cljs.core.cons((delta * delta),fluree$db$query$analytical$variance_$_iter__109529(cljs.core.rest(s__109530__$2)));
}
} else {
return null;
}
break;
}
});})(mean))
,null,null));
});})(mean))
;
return iter__4523__auto__(coll);
})());
return (sum__$1 / cljs.core.count(coll));
});
var stddev = (function fluree$db$query$analytical$stddev(coll){
var G__109533 = variance(coll);
return Math.sqrt(G__109533);
});
return cljs.core.PersistentHashMap.fromArrays([cljs.core.cst$sym$variance,cljs.core.cst$sym$count,cljs.core.cst$sym$median,cljs.core.cst$sym$groupconcat,cljs.core.cst$sym$sum,cljs.core.cst$sym$abs,cljs.core.cst$sym$min,cljs.core.cst$sym$ceil,cljs.core.cst$sym$max,cljs.core.cst$sym$count_DASH_distinct,cljs.core.cst$sym$avg,cljs.core.cst$sym$floor,cljs.core.cst$sym$str,cljs.core.cst$sym$stddev,cljs.core.cst$sym$rand,cljs.core.cst$sym$sample],[variance,cljs.core.count,median,cljs.core.concat,sum,(function (n){
var x__4219__auto__ = n;
var y__4220__auto__ = (- n);
return ((x__4219__auto__ > y__4220__auto__) ? x__4219__auto__ : y__4220__auto__);
}),(function() {
var G__109535 = null;
var G__109535__1 = (function (coll){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc,x){
if((cljs.core.compare(x,acc) < (0))){
return x;
} else {
return acc;
}
}),cljs.core.first(coll),cljs.core.next(coll));
});
var G__109535__2 = (function (n,coll){
return cljs.core.vec(cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc,x){
if((cljs.core.count(acc) < n)){
return cljs.core.sort.cljs$core$IFn$_invoke$arity$2(cljs.core.compare,cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,x));
} else {
if((cljs.core.compare(x,cljs.core.last(acc)) < (0))){
return cljs.core.sort.cljs$core$IFn$_invoke$arity$2(cljs.core.compare,cljs.core.conj.cljs$core$IFn$_invoke$arity$2(cljs.core.butlast(acc),x));
} else {
return acc;

}
}
}),cljs.core.PersistentVector.EMPTY,coll));
});
G__109535 = function(n,coll){
switch(arguments.length){
case 1:
return G__109535__1.call(this,n);
case 2:
return G__109535__2.call(this,n,coll);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
G__109535.cljs$core$IFn$_invoke$arity$1 = G__109535__1;
G__109535.cljs$core$IFn$_invoke$arity$2 = G__109535__2;
return G__109535;
})()
,(function (n){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(n,(n | (0)))){
return n;
} else {
if((n > (0))){
return ((n | (0)) + (1));
} else {
if((n < (0))){
return (n | (0));
} else {
return null;
}
}
}
}),(function() {
var G__109536 = null;
var G__109536__1 = (function (coll){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc,x){
if((cljs.core.compare(x,acc) > (0))){
return x;
} else {
return acc;
}
}),cljs.core.first(coll),cljs.core.next(coll));
});
var G__109536__2 = (function (n,coll){
return cljs.core.vec(cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc,x){
if((cljs.core.count(acc) < n)){
return cljs.core.sort.cljs$core$IFn$_invoke$arity$2(cljs.core.compare,cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,x));
} else {
if((cljs.core.compare(x,cljs.core.first(acc)) > (0))){
return cljs.core.sort.cljs$core$IFn$_invoke$arity$2(cljs.core.compare,cljs.core.conj.cljs$core$IFn$_invoke$arity$2(cljs.core.next(acc),x));
} else {
return acc;

}
}
}),cljs.core.PersistentVector.EMPTY,coll));
});
G__109536 = function(n,coll){
switch(arguments.length){
case 1:
return G__109536__1.call(this,n);
case 2:
return G__109536__2.call(this,n,coll);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
G__109536.cljs$core$IFn$_invoke$arity$1 = G__109536__1;
G__109536.cljs$core$IFn$_invoke$arity$2 = G__109536__2;
return G__109536;
})()
,(function (coll){
return cljs.core.count(cljs.core.distinct.cljs$core$IFn$_invoke$arity$1(coll));
}),avg,(function (n){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(n,(n | (0)))){
return n;
} else {
if((n > (0))){
return (n | (0));
} else {
if((n < (0))){
return ((n | (0)) - (1));
} else {
return null;
}
}
}
}),cljs.core.str,stddev,(function() {
var G__109537 = null;
var G__109537__1 = (function (coll){
return cljs.core.rand_nth(coll);
});
var G__109537__2 = (function (n,coll){
return cljs.core.vec(cljs.core.repeatedly.cljs$core$IFn$_invoke$arity$2(n,(function (){
return cljs.core.rand_nth(coll);
})));
});
G__109537 = function(n,coll){
switch(arguments.length){
case 1:
return G__109537__1.call(this,n);
case 2:
return G__109537__2.call(this,n,coll);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
G__109537.cljs$core$IFn$_invoke$arity$1 = G__109537__1;
G__109537.cljs$core$IFn$_invoke$arity$2 = G__109537__2;
return G__109537;
})()
,(function (n,coll){
return cljs.core.vec(cljs.core.take.cljs$core$IFn$_invoke$arity$2(n,cljs.core.shuffle(coll)));
})]);
})();
fluree.db.query.analytical.aggregate_QMARK_ = (function fluree$db$query$analytical$aggregate_QMARK_(x){
var and__4120__auto__ = typeof x === 'string';
if(and__4120__auto__){
return cljs.core.re_matches(/^\(.+\)$/,x);
} else {
return and__4120__auto__;
}
});
fluree.db.query.analytical.interm_aggregate_QMARK_ = (function fluree$db$query$analytical$interm_aggregate_QMARK_(x){
var and__4120__auto__ = typeof x === 'string';
if(and__4120__auto__){
return cljs.core.re_matches(/^#\(.+\)$/,x);
} else {
return and__4120__auto__;
}
});
fluree.db.query.analytical.parse_aggregate = (function fluree$db$query$analytical$parse_aggregate(x,valid_var){
var list_agg = cljs.reader.read_string.cljs$core$IFn$_invoke$arity$1(x);
var as_QMARK_ = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$sym$as,cljs.core.first(list_agg));
var as = ((as_QMARK_)?cljs.core.first(list_agg):cljs.core.symbol.cljs$core$IFn$_invoke$arity$1(cljs.core.str.cljs$core$IFn$_invoke$arity$1(list_agg)));
var func_list = ((as_QMARK_)?(function (){var func_list = cljs.core.second(list_agg);
if(cljs.core.coll_QMARK_(func_list)){
return func_list;
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid aggregate selection. As can only be used in conjunction with other functions. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null));
}
})():list_agg);
var list_count = cljs.core.count(func_list);
var vec__109538 = ((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((3),list_count))?new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.first(func_list),cljs.core.second(func_list),cljs.core.last(func_list)], null):((((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((2),list_count)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$sym$sample,cljs.core.first(func_list)))))?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["The sample aggregate function takes two arguments: n and a variable, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null))})():((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((2),list_count))?new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.first(func_list),null,cljs.core.last(func_list)], null):(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid aggregate selection, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null))})()
)));
var fun = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109538,(0),null);
var arg = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109538,(1),null);
var var$ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109538,(2),null);
var agg_fn = (function (){var temp__5733__auto__ = (fluree.db.query.analytical.built_in_aggregates.cljs$core$IFn$_invoke$arity$1 ? fluree.db.query.analytical.built_in_aggregates.cljs$core$IFn$_invoke$arity$1(fun) : fluree.db.query.analytical.built_in_aggregates.call(null,fun));
if(cljs.core.truth_(temp__5733__auto__)){
var agg_fn = temp__5733__auto__;
if(cljs.core.truth_(arg)){
return ((function (agg_fn,temp__5733__auto__,list_agg,as_QMARK_,as,func_list,list_count,vec__109538,fun,arg,var$){
return (function (coll){
return (agg_fn.cljs$core$IFn$_invoke$arity$2 ? agg_fn.cljs$core$IFn$_invoke$arity$2(arg,coll) : agg_fn.call(null,arg,coll));
});
;})(agg_fn,temp__5733__auto__,list_agg,as_QMARK_,as,func_list,list_count,vec__109538,fun,arg,var$))
} else {
return agg_fn;
}
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid aggregate selection function, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null));
}
})();
var vec__109541 = (function (){var distinct_QMARK_ = ((cljs.core.coll_QMARK_(var$)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.first(var$),cljs.core.cst$sym$distinct)));
var variable = ((distinct_QMARK_)?cljs.core.second(var$):var$);
var agg_fn__$1 = ((distinct_QMARK_)?((function (distinct_QMARK_,variable,list_agg,as_QMARK_,as,func_list,list_count,vec__109538,fun,arg,var$,agg_fn){
return (function (coll){
var G__109544 = cljs.core.distinct.cljs$core$IFn$_invoke$arity$1(coll);
return (agg_fn.cljs$core$IFn$_invoke$arity$1 ? agg_fn.cljs$core$IFn$_invoke$arity$1(G__109544) : agg_fn.call(null,G__109544));
});})(distinct_QMARK_,variable,list_agg,as_QMARK_,as,func_list,list_count,vec__109538,fun,arg,var$,agg_fn))
:agg_fn);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [agg_fn__$1,variable], null);
})();
var agg_fn__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109541,(0),null);
var variable = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109541,(1),null);
var _ = (cljs.core.truth_((valid_var.cljs$core$IFn$_invoke$arity$1 ? valid_var.cljs$core$IFn$_invoke$arity$1(variable) : valid_var.call(null,variable)))?null:(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid select variable in aggregate select, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null))})());
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$variable,variable,cljs.core.cst$kw$as,as,cljs.core.cst$kw$code,agg_fn__$1], null);
});
fluree.db.query.analytical.calculate_aggregate = (function fluree$db$query$analytical$calculate_aggregate(res,agg){
var map__109545 = agg;
var map__109545__$1 = (((((!((map__109545 == null))))?(((((map__109545.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__109545.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__109545):map__109545);
var variable = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109545__$1,cljs.core.cst$kw$variable);
var as = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109545__$1,cljs.core.cst$kw$as);
var code = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109545__$1,cljs.core.cst$kw$code);
var agg_params = cljs.core.flatten(fluree.db.query.analytical.select_from_tuples(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [variable], null),res));
var agg_result = (code.cljs$core$IFn$_invoke$arity$1 ? code.cljs$core$IFn$_invoke$arity$1(agg_params) : code.call(null,agg_params));
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [as,agg_result], null);
});
fluree.db.query.analytical.add_aggregate_cols = (function fluree$db$query$analytical$add_aggregate_cols(res,aggregate){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (res__$1,agg){
var vec__109548 = fluree.db.query.analytical.calculate_aggregate(res__$1,agg);
var as = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109548,(0),null);
var agg_result = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109548,(1),null);
var map__109551 = res__$1;
var map__109551__$1 = (((((!((map__109551 == null))))?(((((map__109551.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__109551.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__109551):map__109551);
var headers = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109551__$1,cljs.core.cst$kw$headers);
var tuples = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109551__$1,cljs.core.cst$kw$tuples);
var tuples_SINGLEQUOTE_ = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (vec__109548,as,agg_result,map__109551,map__109551__$1,headers,tuples){
return (function (p1__109547_SHARP_){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(cljs.core.vec(p1__109547_SHARP_),agg_result);
});})(vec__109548,as,agg_result,map__109551,map__109551__$1,headers,tuples))
,tuples);
var headers_SINGLEQUOTE_ = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(cljs.core.vec(headers),as);
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$headers,headers_SINGLEQUOTE_,cljs.core.cst$kw$tuples,tuples_SINGLEQUOTE_], null);
}),res,aggregate);
});
fluree.db.query.analytical.symbolize_keys = (function fluree$db$query$analytical$symbolize_keys(q_map){
var keys = cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.symbol,cljs.core.keys(q_map));
var vals = cljs.core.vals(q_map);
return cljs.core.zipmap(keys,vals);
});
/**
 * Given a single tuple from A, a-idxs, b-idxs, b-not-idxs, and b-tuples, return any tuples in b that match.
 */
fluree.db.query.analytical.find_match = (function fluree$db$query$analytical$find_match(a_tuple,a_idxs,b_tuples,b_idxs,b_not_idxs){
var a_tuple_part = cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__109553_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(a_tuple,p1__109553_SHARP_);
}),a_idxs);
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (a_tuple_part){
return (function (acc,b_tuple){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(a_tuple_part,cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (a_tuple_part){
return (function (p1__109554_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(b_tuple,p1__109554_SHARP_);
});})(a_tuple_part))
,b_idxs))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2((function (){var or__4131__auto__ = acc;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.PersistentVector.EMPTY;
}
})(),cljs.core.concat.cljs$core$IFn$_invoke$arity$2(a_tuple,cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (a_tuple_part){
return (function (p1__109555_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(b_tuple,p1__109555_SHARP_);
});})(a_tuple_part))
,b_not_idxs)));
} else {
return acc;
}
});})(a_tuple_part))
,null,b_tuples);
});
/**
 * Given a single tuple from A, a-idxs, b-idxs, b-not-idxs, and b-tuples, return any tuples in b that match.
 *   Along with their row-numbers
 */
fluree.db.query.analytical.find_match_PLUS_row_nums = (function fluree$db$query$analytical$find_match_PLUS_row_nums(a_tuple,a_idxs,b_tuples,b_idxs,b_not_idxs){
var a_tuple_part = cljs.core.map.cljs$core$IFn$_invoke$arity$2((function (p1__109556_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(a_tuple,p1__109556_SHARP_);
}),a_idxs);
return cljs.core.reduce_kv(((function (a_tuple_part){
return (function (p__109559,row,b_tuple){
var vec__109560 = p__109559;
var acc = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109560,(0),null);
var b_rows = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109560,(1),null);
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(a_tuple_part,cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (vec__109560,acc,b_rows,a_tuple_part){
return (function (p1__109557_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(b_tuple,p1__109557_SHARP_);
});})(vec__109560,acc,b_rows,a_tuple_part))
,b_idxs))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.conj.cljs$core$IFn$_invoke$arity$2((function (){var or__4131__auto__ = acc;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.PersistentVector.EMPTY;
}
})(),cljs.core.concat.cljs$core$IFn$_invoke$arity$2(a_tuple,cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (vec__109560,acc,b_rows,a_tuple_part){
return (function (p1__109558_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(b_tuple,p1__109558_SHARP_);
});})(vec__109560,acc,b_rows,a_tuple_part))
,b_not_idxs))),cljs.core.conj.cljs$core$IFn$_invoke$arity$2(b_rows,row)], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [acc,b_rows], null);
}
});})(a_tuple_part))
,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [null,cljs.core.PersistentHashSet.EMPTY], null),cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,b_tuples));
});
fluree.db.query.analytical.inner_join = (function fluree$db$query$analytical$inner_join(a_res,b_res){
var common_keys = fluree.db.query.analytical.intersecting_keys_tuples(a_res,b_res);
var a_idxs = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys){
return (function (p1__109563_SHARP_){
return fluree.db.util.core.index_of(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(a_res),p1__109563_SHARP_);
});})(common_keys))
,common_keys);
var b_idxs = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys,a_idxs){
return (function (p1__109564_SHARP_){
return fluree.db.util.core.index_of(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_res),p1__109564_SHARP_);
});})(common_keys,a_idxs))
,common_keys);
var b_not_idxs = (function (){var G__109569 = clojure.set.difference.cljs$core$IFn$_invoke$arity$2(cljs.core.set((function (){var G__109571 = cljs.core.count(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_res));
var fexpr__109570 = ((function (G__109571,common_keys,a_idxs,b_idxs){
return (function (p1__109565_SHARP_){
return cljs.core.range.cljs$core$IFn$_invoke$arity$2((0),p1__109565_SHARP_);
});})(G__109571,common_keys,a_idxs,b_idxs))
;
return fexpr__109570(G__109571);
})()),cljs.core.set(b_idxs));
var fexpr__109568 = ((function (G__109569,common_keys,a_idxs,b_idxs){
return (function (p1__109566_SHARP_){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.vector,p1__109566_SHARP_);
});})(G__109569,common_keys,a_idxs,b_idxs))
;
return fexpr__109568(G__109569);
})();
var c_tuples = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.concat,cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys,a_idxs,b_idxs,b_not_idxs){
return (function (a_tuple){
return fluree.db.query.analytical.find_match(a_tuple,a_idxs,cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(b_res),b_idxs,b_not_idxs);
});})(common_keys,a_idxs,b_idxs,b_not_idxs))
,cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(a_res)));
var c_headers = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(a_res),cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys,a_idxs,b_idxs,b_not_idxs,c_tuples){
return (function (p1__109567_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_res),p1__109567_SHARP_);
});})(common_keys,a_idxs,b_idxs,b_not_idxs,c_tuples))
,b_not_idxs));
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$headers,c_headers,cljs.core.cst$kw$vars,cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$vars.cljs$core$IFn$_invoke$arity$1(a_res),cljs.core.cst$kw$vars.cljs$core$IFn$_invoke$arity$1(b_res)], 0)),cljs.core.cst$kw$tuples,c_tuples], null);
});
/**
 * OPTIONAL clause is equivalent to a left outer join. If there are no matches in the b-tuples,
 *   we just return a 'match' where each element of the match from b-tuple is nil.
 */
fluree.db.query.analytical.left_outer_join = (function fluree$db$query$analytical$left_outer_join(a_tuples,b_tuples){
var common_keys = fluree.db.query.analytical.intersecting_keys_tuples(a_tuples,b_tuples);
var a_idxs = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys){
return (function (p1__109572_SHARP_){
return fluree.db.util.core.index_of(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(a_tuples),p1__109572_SHARP_);
});})(common_keys))
,common_keys);
var b_idxs = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys,a_idxs){
return (function (p1__109573_SHARP_){
return fluree.db.util.core.index_of(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_tuples),p1__109573_SHARP_);
});})(common_keys,a_idxs))
,common_keys);
var b_not_idxs = (function (){var G__109578 = clojure.set.difference.cljs$core$IFn$_invoke$arity$2(cljs.core.set((function (){var G__109580 = cljs.core.count(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_tuples));
var fexpr__109579 = ((function (G__109580,common_keys,a_idxs,b_idxs){
return (function (p1__109574_SHARP_){
return cljs.core.range.cljs$core$IFn$_invoke$arity$2((0),p1__109574_SHARP_);
});})(G__109580,common_keys,a_idxs,b_idxs))
;
return fexpr__109579(G__109580);
})()),cljs.core.set(b_idxs));
var fexpr__109577 = ((function (G__109578,common_keys,a_idxs,b_idxs){
return (function (p1__109575_SHARP_){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.vector,p1__109575_SHARP_);
});})(G__109578,common_keys,a_idxs,b_idxs))
;
return fexpr__109577(G__109578);
})();
var c_tuples = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.concat,cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys,a_idxs,b_idxs,b_not_idxs){
return (function (a_tuple){
var matches = fluree.db.query.analytical.find_match(a_tuple,a_idxs,cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(b_tuples),b_idxs,b_not_idxs);
var or__4131__auto__ = matches;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.concat.cljs$core$IFn$_invoke$arity$2(a_tuple,cljs.core.repeat.cljs$core$IFn$_invoke$arity$2(cljs.core.count(b_not_idxs),null))], null);
}
});})(common_keys,a_idxs,b_idxs,b_not_idxs))
,cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(a_tuples)));
var c_headers = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(a_tuples),cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys,a_idxs,b_idxs,b_not_idxs,c_tuples){
return (function (p1__109576_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_tuples),p1__109576_SHARP_);
});})(common_keys,a_idxs,b_idxs,b_not_idxs,c_tuples))
,b_not_idxs));
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$headers,c_headers,cljs.core.cst$kw$vars,cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$vars.cljs$core$IFn$_invoke$arity$1(a_tuples),cljs.core.cst$kw$vars.cljs$core$IFn$_invoke$arity$1(b_tuples)], 0)),cljs.core.cst$kw$tuples,c_tuples], null);
});
/**
 * UNION clause takes a left-hand side, which is inner-joined, and a right-hand side, which is inner-joined.
 *   Any tuples unbound by the other set are included.
 */
fluree.db.query.analytical.outer_union = (function fluree$db$query$analytical$outer_union(a_tuples,b_tuples){
var common_keys = fluree.db.query.analytical.intersecting_keys_tuples(a_tuples,b_tuples);
var a_idxs = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys){
return (function (p1__109581_SHARP_){
return fluree.db.util.core.index_of(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(a_tuples),p1__109581_SHARP_);
});})(common_keys))
,common_keys);
var b_idxs = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys,a_idxs){
return (function (p1__109582_SHARP_){
return fluree.db.util.core.index_of(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_tuples),p1__109582_SHARP_);
});})(common_keys,a_idxs))
,common_keys);
var b_not_idxs = (function (){var G__109591 = clojure.set.difference.cljs$core$IFn$_invoke$arity$2(cljs.core.set((function (){var G__109593 = cljs.core.count(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_tuples));
var fexpr__109592 = ((function (G__109593,common_keys,a_idxs,b_idxs){
return (function (p1__109583_SHARP_){
return cljs.core.range.cljs$core$IFn$_invoke$arity$2((0),p1__109583_SHARP_);
});})(G__109593,common_keys,a_idxs,b_idxs))
;
return fexpr__109592(G__109593);
})()),cljs.core.set(b_idxs));
var fexpr__109590 = ((function (G__109591,common_keys,a_idxs,b_idxs){
return (function (p1__109584_SHARP_){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.vector,p1__109584_SHARP_);
});})(G__109591,common_keys,a_idxs,b_idxs))
;
return fexpr__109590(G__109591);
})();
var vec__109587 = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (common_keys,a_idxs,b_idxs,b_not_idxs){
return (function (p__109594,a_tuple){
var vec__109595 = p__109594;
var c_tuples = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109595,(0),null);
var b_matched_rows = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109595,(1),null);
var vec__109598 = fluree.db.query.analytical.find_match_PLUS_row_nums(a_tuple,a_idxs,cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(b_tuples),b_idxs,b_not_idxs);
var matches = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109598,(0),null);
var matched_rows = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109598,(1),null);
var matches__$1 = (function (){var or__4131__auto__ = matches;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.concat.cljs$core$IFn$_invoke$arity$2(a_tuple,cljs.core.repeat.cljs$core$IFn$_invoke$arity$2(cljs.core.count(b_not_idxs),null))], null);
}
})();
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.concat.cljs$core$IFn$_invoke$arity$2(c_tuples,matches__$1),clojure.set.union.cljs$core$IFn$_invoke$arity$2(b_matched_rows,matched_rows)], null);
});})(common_keys,a_idxs,b_idxs,b_not_idxs))
,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.PersistentVector.EMPTY,cljs.core.PersistentHashSet.EMPTY], null),cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(a_tuples));
var c_tuples = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109587,(0),null);
var b_matched_rows = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109587,(1),null);
var b_unmatched_rows = cljs.core.remove.cljs$core$IFn$_invoke$arity$2(b_matched_rows,cljs.core.range.cljs$core$IFn$_invoke$arity$2((0),cljs.core.count(cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(b_tuples))));
var c_headers = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(a_tuples),cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys,a_idxs,b_idxs,b_not_idxs,vec__109587,c_tuples,b_matched_rows,b_unmatched_rows){
return (function (p1__109585_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_tuples),p1__109585_SHARP_);
});})(common_keys,a_idxs,b_idxs,b_not_idxs,vec__109587,c_tuples,b_matched_rows,b_unmatched_rows))
,b_not_idxs));
var b_idxs__GT_c_idxs = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys,a_idxs,b_idxs,b_not_idxs,vec__109587,c_tuples,b_matched_rows,b_unmatched_rows,c_headers){
return (function (p1__109586_SHARP_){
return fluree.db.util.core.index_of(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(b_tuples),p1__109586_SHARP_);
});})(common_keys,a_idxs,b_idxs,b_not_idxs,vec__109587,c_tuples,b_matched_rows,b_unmatched_rows,c_headers))
,c_headers);
var c_from_unmatched_b_tuples = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (common_keys,a_idxs,b_idxs,b_not_idxs,vec__109587,c_tuples,b_matched_rows,b_unmatched_rows,c_headers,b_idxs__GT_c_idxs){
return (function (b_row){
var b_tuple = cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,cljs.core.nth.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(b_tuples),b_row));
return cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (b_tuple,common_keys,a_idxs,b_idxs,b_not_idxs,vec__109587,c_tuples,b_matched_rows,b_unmatched_rows,c_headers,b_idxs__GT_c_idxs){
return (function (c_idx){
if((c_idx == null)){
return null;
} else {
return cljs.core.get.cljs$core$IFn$_invoke$arity$2(b_tuple,c_idx);
}
});})(b_tuple,common_keys,a_idxs,b_idxs,b_not_idxs,vec__109587,c_tuples,b_matched_rows,b_unmatched_rows,c_headers,b_idxs__GT_c_idxs))
,b_idxs__GT_c_idxs);
});})(common_keys,a_idxs,b_idxs,b_not_idxs,vec__109587,c_tuples,b_matched_rows,b_unmatched_rows,c_headers,b_idxs__GT_c_idxs))
,b_unmatched_rows);
var c_tuples__$1 = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(c_tuples,c_from_unmatched_b_tuples);
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$headers,c_headers,cljs.core.cst$kw$vars,cljs.core.merge.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$vars.cljs$core$IFn$_invoke$arity$1(a_tuples),cljs.core.cst$kw$vars.cljs$core$IFn$_invoke$arity$1(b_tuples)], 0)),cljs.core.cst$kw$tuples,c_tuples__$1], null);
});
fluree.db.query.analytical.tuples__GT_filter_required = (function fluree$db$query$analytical$tuples__GT_filter_required(headers,tuples,valid_vars,filter_code_req){
var filter_code_req_str = ["(and ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.cljs$core$IFn$_invoke$arity$2(" ",filter_code_req)),")"].join('');
var vec__109602 = (function (){var or__4131__auto__ = fluree.db.query.analytical_filter.valid_filter_QMARK_.cljs$core$IFn$_invoke$arity$2(filter_code_req_str,valid_vars);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid required filters, provided: ",filter_code_req_str].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null));
}
})();
var filter_code_req_STAR_ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109602,(0),null);
var _ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109602,(1),null);
var filter_code_req_str_STAR_ = cljs.core.str.cljs$core$IFn$_invoke$arity$1(filter_code_req_STAR_);
return cljs.core.filter.cljs$core$IFn$_invoke$arity$2(((function (filter_code_req_str,vec__109602,filter_code_req_STAR_,_,filter_code_req_str_STAR_){
return (function (p1__109601_SHARP_){
return fluree.db.query.analytical_filter.filter_row(headers,p1__109601_SHARP_,filter_code_req_str_STAR_);
});})(filter_code_req_str,vec__109602,filter_code_req_STAR_,_,filter_code_req_str_STAR_))
,tuples);
});
fluree.db.query.analytical.tuples__GT_filter_optional = (function fluree$db$query$analytical$tuples__GT_filter_optional(headers,tuples,valid_vars,filter_code_opts){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (tuples__$1,filt){
var var_atom = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(cljs.core.PersistentHashSet.EMPTY);
var vec__109607 = (function (){var or__4131__auto__ = fluree.db.query.analytical_filter.valid_filter_QMARK_.cljs$core$IFn$_invoke$arity$3(filt,valid_vars,var_atom);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid filter, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(filt)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null));
}
})();
var filt_STAR_ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109607,(0),null);
var filt_vars = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109607,(1),null);
var filt_str = cljs.core.str.cljs$core$IFn$_invoke$arity$1(filt_STAR_);
var filt_vars_idxs = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (var_atom,vec__109607,filt_STAR_,filt_vars,filt_str){
return (function (p1__109605_SHARP_){
return fluree.db.util.core.index_of(headers,p1__109605_SHARP_);
});})(var_atom,vec__109607,filt_STAR_,filt_vars,filt_str))
,cljs.core.deref(filt_vars));
var filtered_tuples = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(((function (var_atom,vec__109607,filt_STAR_,filt_vars,filt_str,filt_vars_idxs){
return (function (acc,clause){
if(cljs.core.every_QMARK_(((function (var_atom,vec__109607,filt_STAR_,filt_vars,filt_str,filt_vars_idxs){
return (function (p1__109606_SHARP_){
return cljs.core.nth.cljs$core$IFn$_invoke$arity$2(clause,p1__109606_SHARP_);
});})(var_atom,vec__109607,filt_STAR_,filt_vars,filt_str,filt_vars_idxs))
,filt_vars_idxs)){
if(cljs.core.truth_(fluree.db.query.analytical_filter.filter_row(headers,clause,filt_str))){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,clause);
} else {
return acc;
}
} else {
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(acc,clause);
}
});})(var_atom,vec__109607,filt_STAR_,filt_vars,filt_str,filt_vars_idxs))
,cljs.core.PersistentVector.EMPTY,tuples__$1);
return filtered_tuples;
}),tuples,filter_code_opts);
});
fluree.db.query.analytical.tuples__GT_filtered = (function fluree$db$query$analytical$tuples__GT_filtered(p__109610,filters,optional_QMARK_){
var map__109611 = p__109610;
var map__109611__$1 = (((((!((map__109611 == null))))?(((((map__109611.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__109611.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__109611):map__109611);
var tuple_map = map__109611__$1;
var headers = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109611__$1,cljs.core.cst$kw$headers);
var vars = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109611__$1,cljs.core.cst$kw$vars);
var tuples = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109611__$1,cljs.core.cst$kw$tuples);
var valid_vars = cljs.core.set(headers);
var header_vec = cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,headers);
var _ = ((typeof filters === 'string')?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Filter must be enclosed in square brackets. Provided: ",filters].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null))})():null);
if(cljs.core.truth_(optional_QMARK_)){
var res = new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$headers,headers,cljs.core.cst$kw$vars,vars,cljs.core.cst$kw$tuples,fluree.db.query.analytical.tuples__GT_filter_optional(header_vec,tuples,valid_vars,filters)], null);
return res;
} else {
var filter_code_req = fluree.db.query.analytical_filter.get_filters(filters,false);
var tuples__$1 = (cljs.core.truth_(cljs.core.not_empty(filter_code_req))?fluree.db.query.analytical.tuples__GT_filter_required(header_vec,tuples,valid_vars,filter_code_req):tuples);
var filter_code_opt = fluree.db.query.analytical_filter.get_filters(filters,true);
var tuples__$2 = (cljs.core.truth_(cljs.core.not_empty(filter_code_opt))?fluree.db.query.analytical.tuples__GT_filter_optional(header_vec,tuples__$1,valid_vars,filter_code_opt):tuples__$1);
return new cljs.core.PersistentArrayMap(null, 3, [cljs.core.cst$kw$headers,headers,cljs.core.cst$kw$vars,vars,cljs.core.cst$kw$tuples,tuples__$2], null);
}
});
fluree.db.query.analytical.bind_clause__GT_vars = (function fluree$db$query$analytical$bind_clause__GT_vars(res,clause){
var vec__109613 = clause;
var k = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109613,(0),null);
var v = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109613,(1),null);
var k__$1 = fluree.db.query.analytical.variable_QMARK_(k);
var _ = (cljs.core.truth_(k__$1)?null:(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Invalid intermediate aggregate value. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clause)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null))})());
var map__109616 = res;
var map__109616__$1 = (((((!((map__109616 == null))))?(((((map__109616.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__109616.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__109616):map__109616);
var headers = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109616__$1,cljs.core.cst$kw$headers);
var vars = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109616__$1,cljs.core.cst$kw$vars);
var var_value = (cljs.core.truth_(fluree.db.query.analytical.interm_aggregate_QMARK_(v))?cljs.core.second(fluree.db.query.analytical.calculate_aggregate(res,fluree.db.query.analytical.parse_aggregate(cljs.core.subs.cljs$core$IFn$_invoke$arity$2(v,(1)),cljs.core.set((function (){var temp__5733__auto__ = cljs.core.keys(vars);
if(cljs.core.truth_(temp__5733__auto__)){
var valid_var = temp__5733__auto__;
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(headers,valid_var);
} else {
return headers;
}
})())))):v);
return cljs.core.PersistentArrayMap.createAsIfByAssoc([k__$1,var_value]);
});
fluree.db.query.analytical.optional__GT_left_outer_joins = (function fluree$db$query$analytical$optional__GT_left_outer_joins(db,q_map,optional_clauses,where_tuples,fuel,max_fuel,opts){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_109671){
var state_val_109672 = (state_109671[(1)]);
if((state_val_109672 === (7))){
var inst_109645 = (state_109671[(7)]);
var inst_109643 = (state_109671[(2)]);
var inst_109644 = fluree.db.util.async.throw_err(inst_109643);
var inst_109645__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_109644,(0),null);
var inst_109646 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_109644,(1),null);
var inst_109647 = (inst_109645__$1 == null);
var state_109671__$1 = (function (){var statearr_109673 = state_109671;
(statearr_109673[(8)] = inst_109646);

(statearr_109673[(7)] = inst_109645__$1);

return statearr_109673;
})();
if(cljs.core.truth_(inst_109647)){
var statearr_109674_109702 = state_109671__$1;
(statearr_109674_109702[(1)] = (8));

} else {
var statearr_109675_109703 = state_109671__$1;
(statearr_109675_109703[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (1))){
var inst_109625 = cljs.core.seq(optional_clauses);
var inst_109626 = cljs.core.first(inst_109625);
var inst_109627 = cljs.core.next(inst_109625);
var inst_109628 = optional_clauses;
var inst_109629 = where_tuples;
var state_109671__$1 = (function (){var statearr_109676 = state_109671;
(statearr_109676[(9)] = inst_109626);

(statearr_109676[(10)] = inst_109629);

(statearr_109676[(11)] = inst_109627);

(statearr_109676[(12)] = inst_109628);

return statearr_109676;
})();
var statearr_109677_109704 = state_109671__$1;
(statearr_109677_109704[(2)] = null);

(statearr_109677_109704[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (4))){
var inst_109635 = (state_109671[(13)]);
var inst_109636 = (state_109671[(14)]);
var inst_109629 = (state_109671[(10)]);
var inst_109641 = (fluree.db.query.analytical.clause__GT_tuples.cljs$core$IFn$_invoke$arity$9 ? fluree.db.query.analytical.clause__GT_tuples.cljs$core$IFn$_invoke$arity$9(db,q_map,inst_109629,inst_109635,inst_109636,true,fuel,max_fuel,opts) : fluree.db.query.analytical.clause__GT_tuples.call(null,db,q_map,inst_109629,inst_109635,inst_109636,true,fuel,max_fuel,opts));
var state_109671__$1 = state_109671;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109671__$1,(7),inst_109641);
} else {
if((state_val_109672 === (15))){
var state_109671__$1 = state_109671;
var statearr_109678_109705 = state_109671__$1;
(statearr_109678_109705[(2)] = null);

(statearr_109678_109705[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (13))){
var inst_109662 = (state_109671[(2)]);
var state_109671__$1 = state_109671;
var statearr_109679_109706 = state_109671__$1;
(statearr_109679_109706[(2)] = inst_109662);

(statearr_109679_109706[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (6))){
var inst_109667 = (state_109671[(2)]);
var state_109671__$1 = state_109671;
var statearr_109680_109707 = state_109671__$1;
(statearr_109680_109707[(2)] = inst_109667);

(statearr_109680_109707[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (3))){
var inst_109669 = (state_109671[(2)]);
var state_109671__$1 = state_109671;
return cljs.core.async.impl.ioc_helpers.return_chan(state_109671__$1,inst_109669);
} else {
if((state_val_109672 === (12))){
var state_109671__$1 = state_109671;
var statearr_109681_109708 = state_109671__$1;
(statearr_109681_109708[(1)] = (14));



return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (2))){
var inst_109635 = (state_109671[(13)]);
var inst_109628 = (state_109671[(12)]);
var inst_109634 = cljs.core.seq(inst_109628);
var inst_109635__$1 = cljs.core.first(inst_109634);
var inst_109636 = cljs.core.next(inst_109634);
var state_109671__$1 = (function (){var statearr_109683 = state_109671;
(statearr_109683[(13)] = inst_109635__$1);

(statearr_109683[(14)] = inst_109636);

return statearr_109683;
})();
if(cljs.core.truth_(inst_109635__$1)){
var statearr_109684_109709 = state_109671__$1;
(statearr_109684_109709[(1)] = (4));

} else {
var statearr_109685_109710 = state_109671__$1;
(statearr_109685_109710[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (11))){
var inst_109646 = (state_109671[(8)]);
var inst_109645 = (state_109671[(7)]);
var inst_109628 = inst_109646;
var inst_109629 = inst_109645;
var state_109671__$1 = (function (){var statearr_109686 = state_109671;
(statearr_109686[(10)] = inst_109629);

(statearr_109686[(12)] = inst_109628);

return statearr_109686;
})();
var statearr_109687_109711 = state_109671__$1;
(statearr_109687_109711[(2)] = null);

(statearr_109687_109711[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (9))){
var inst_109635 = (state_109671[(13)]);
var inst_109651 = cljs.core.cst$kw$filter.cljs$core$IFn$_invoke$arity$1(inst_109635);
var state_109671__$1 = state_109671;
if(cljs.core.truth_(inst_109651)){
var statearr_109688_109712 = state_109671__$1;
(statearr_109688_109712[(1)] = (11));

} else {
var statearr_109689_109713 = state_109671__$1;
(statearr_109689_109713[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (5))){
var inst_109629 = (state_109671[(10)]);
var state_109671__$1 = state_109671;
var statearr_109690_109714 = state_109671__$1;
(statearr_109690_109714[(2)] = inst_109629);

(statearr_109690_109714[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (14))){
var inst_109646 = (state_109671[(8)]);
var inst_109645 = (state_109671[(7)]);
var inst_109629 = (state_109671[(10)]);
var inst_109656 = fluree.db.query.analytical.left_outer_join(inst_109629,inst_109645);
var inst_109628 = inst_109646;
var inst_109629__$1 = inst_109656;
var state_109671__$1 = (function (){var statearr_109691 = state_109671;
(statearr_109691[(10)] = inst_109629__$1);

(statearr_109691[(12)] = inst_109628);

return statearr_109691;
})();
var statearr_109692_109715 = state_109671__$1;
(statearr_109692_109715[(2)] = null);

(statearr_109692_109715[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (16))){
var inst_109660 = (state_109671[(2)]);
var state_109671__$1 = state_109671;
var statearr_109694_109716 = state_109671__$1;
(statearr_109694_109716[(2)] = inst_109660);

(statearr_109694_109716[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (10))){
var inst_109664 = (state_109671[(2)]);
var state_109671__$1 = state_109671;
var statearr_109695_109717 = state_109671__$1;
(statearr_109695_109717[(2)] = inst_109664);

(statearr_109695_109717[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109672 === (8))){
var inst_109646 = (state_109671[(8)]);
var inst_109629 = (state_109671[(10)]);
var tmp109693 = inst_109629;
var inst_109628 = inst_109646;
var inst_109629__$1 = tmp109693;
var state_109671__$1 = (function (){var statearr_109696 = state_109671;
(statearr_109696[(10)] = inst_109629__$1);

(statearr_109696[(12)] = inst_109628);

return statearr_109696;
})();
var statearr_109697_109718 = state_109671__$1;
(statearr_109697_109718[(2)] = null);

(statearr_109697_109718[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto__ = null;
var fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto____0 = (function (){
var statearr_109698 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_109698[(0)] = fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto__);

(statearr_109698[(1)] = (1));

return statearr_109698;
});
var fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto____1 = (function (state_109671){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_109671);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e109699){if((e109699 instanceof Object)){
var ex__99706__auto__ = e109699;
var statearr_109700_109719 = state_109671;
(statearr_109700_109719[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_109671);

return cljs.core.cst$kw$recur;
} else {
throw e109699;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__109720 = state_109671;
state_109671 = G__109720;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto__ = function(state_109671){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto____1.call(this,state_109671);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto____0;
fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto____1;
return fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_109701 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_109701[(6)] = c__99809__auto__);

return statearr_109701;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
fluree.db.query.analytical.res_absorb_vars = (function fluree$db$query$analytical$res_absorb_vars(res){
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (acc,p__109722){
var vec__109723 = p__109722;
var var_name = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109723,(0),null);
var var_val = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__109723,(1),null);
var tuples_SINGLEQUOTE_ = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (vec__109723,var_name,var_val){
return (function (p1__109721_SHARP_){
return cljs.core.conj.cljs$core$IFn$_invoke$arity$2(p1__109721_SHARP_,var_val);
});})(vec__109723,var_name,var_val))
,cljs.core.cst$kw$tuples.cljs$core$IFn$_invoke$arity$1(res));
var headers_SINGLEQUOTE_ = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$headers.cljs$core$IFn$_invoke$arity$1(res),var_name);
return new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$tuples,tuples_SINGLEQUOTE_,cljs.core.cst$kw$headers,headers_SINGLEQUOTE_], null);
}),res,cljs.core.cst$kw$vars.cljs$core$IFn$_invoke$arity$1(res));
});
/**
 * Tuples and optional? are only used for Wikidata, because need to both limit calls to Wikidata,
 *   and ensure that returned results are as limited as possible (but still relevant).
 */
fluree.db.query.analytical.clause__GT_tuples = (function fluree$db$query$analytical$clause__GT_tuples(db,p__109727,p__109728,clause,r,optional_QMARK_,fuel,max_fuel,opts){
var map__109729 = p__109727;
var map__109729__$1 = (((((!((map__109729 == null))))?(((((map__109729.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__109729.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__109729):map__109729);
var q_map = map__109729__$1;
var prefixes = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109729__$1,cljs.core.cst$kw$prefixes);
var map__109730 = p__109728;
var map__109730__$1 = (((((!((map__109730 == null))))?(((((map__109730.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__109730.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__109730):map__109730);
var res = map__109730__$1;
var vars = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__109730__$1,cljs.core.cst$kw$vars);
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,map__109729,map__109729__$1,q_map,prefixes,map__109730,map__109730__$1,res,vars){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,map__109729,map__109729__$1,q_map,prefixes,map__109730,map__109730__$1,res,vars){
return (function (state_109935){
var state_val_109936 = (state_109935[(1)]);
if((state_val_109936 === (7))){
var inst_109931 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109937_110017 = state_109935__$1;
(statearr_109937_110017[(2)] = inst_109931);


cljs.core.async.impl.ioc_helpers.process_exception(state_109935__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (20))){
var inst_109766 = (state_109935[(7)]);
var inst_109769 = (state_109935[(8)]);
var inst_109764 = (state_109935[(9)]);
var inst_109776 = (state_109935[(10)]);
var inst_109740 = (state_109935[(11)]);
var inst_109768 = (state_109935[(12)]);
var inst_109775 = (state_109935[(13)]);
var inst_109767 = (state_109935[(14)]);
var inst_109780 = (state_109935[(2)]);
var inst_109781 = fluree.db.util.async.throw_err(inst_109780);
var inst_109782 = (function (){var seq__109762 = inst_109767;
var expr__109742 = inst_109740;
var new_res = inst_109781;
var first__109763 = inst_109766;
var vec__109761 = inst_109764;
var rest = inst_109776;
var tuples = inst_109769;
var seq__109772 = inst_109776;
var first__109773 = inst_109775;
var pred__109741 = cljs.core._EQ_;
var vec__109771 = inst_109768;
var segment_type = inst_109740;
var G__109760 = inst_109768;
var clause_group = inst_109775;
return ((function (seq__109762,expr__109742,new_res,first__109763,vec__109761,rest,tuples,seq__109772,first__109773,pred__109741,vec__109771,segment_type,G__109760,clause_group,inst_109766,inst_109769,inst_109764,inst_109776,inst_109740,inst_109768,inst_109775,inst_109767,inst_109780,inst_109781,state_val_109936,c__99809__auto__,map__109729,map__109729__$1,q_map,prefixes,map__109730,map__109730__$1,res,vars){
return (function (res__$1,var$){
return cljs.core.update.cljs$core$IFn$_invoke$arity$4(new_res,cljs.core.cst$kw$var,cljs.core.dissoc,var$);
});
;})(seq__109762,expr__109742,new_res,first__109763,vec__109761,rest,tuples,seq__109772,first__109773,pred__109741,vec__109771,segment_type,G__109760,clause_group,inst_109766,inst_109769,inst_109764,inst_109776,inst_109740,inst_109768,inst_109775,inst_109767,inst_109780,inst_109781,state_val_109936,c__99809__auto__,map__109729,map__109729__$1,q_map,prefixes,map__109730,map__109730__$1,res,vars))
})();
var inst_109783 = cljs.core.keys(vars);
var inst_109784 = cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(inst_109782,inst_109781,inst_109783);
var inst_109785 = fluree.db.query.analytical.res_absorb_vars(inst_109784);
var state_109935__$1 = (function (){var statearr_109938 = state_109935;
(statearr_109938[(15)] = inst_109785);

return statearr_109938;
})();
if(cljs.core.truth_(inst_109769)){
var statearr_109939_110018 = state_109935__$1;
(statearr_109939_110018[(1)] = (21));

} else {
var statearr_109940_110019 = state_109935__$1;
(statearr_109940_110019[(1)] = (22));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (58))){
var inst_109905 = (state_109935[(16)]);
var inst_109908 = (state_109935[(2)]);
var inst_109909 = fluree.db.util.async.throw_err(inst_109908);
var inst_109910 = [inst_109909,r];
var inst_109911 = (new cljs.core.PersistentVector(null,2,(5),inst_109905,inst_109910,null));
var state_109935__$1 = state_109935;
var statearr_109941_110020 = state_109935__$1;
(statearr_109941_110020[(2)] = inst_109911);

(statearr_109941_110020[(1)] = (57));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (27))){
var inst_109816 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109817 = cljs.core.cst$kw$filter.cljs$core$IFn$_invoke$arity$1(clause);
var inst_109818 = fluree.db.query.analytical.tuples__GT_filtered(res,inst_109817,optional_QMARK_);
var inst_109819 = [inst_109818,r];
var inst_109820 = (new cljs.core.PersistentVector(null,2,(5),inst_109816,inst_109819,null));
var state_109935__$1 = state_109935;
var statearr_109942_110021 = state_109935__$1;
(statearr_109942_110021[(2)] = inst_109820);

(statearr_109942_110021[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (1))){
var state_109935__$1 = state_109935;
var statearr_109943_110022 = state_109935__$1;
(statearr_109943_110022[(2)] = null);

(statearr_109943_110022[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (24))){
var inst_109740 = (state_109935[(11)]);
var inst_109804 = cljs.core.cst$kw$bind.cljs$core$IFn$_invoke$arity$1(clause);
var inst_109805 = (function (){var segment_type = inst_109740;
var pred__109741 = cljs.core._EQ_;
var expr__109742 = inst_109740;
var bindings = inst_109804;
return ((function (segment_type,pred__109741,expr__109742,bindings,inst_109740,inst_109804,state_val_109936,c__99809__auto__,map__109729,map__109729__$1,q_map,prefixes,map__109730,map__109730__$1,res,vars){
return (function (p1__109726_SHARP_){
return fluree.db.query.analytical.bind_clause__GT_vars(res,p1__109726_SHARP_);
});
;})(segment_type,pred__109741,expr__109742,bindings,inst_109740,inst_109804,state_val_109936,c__99809__auto__,map__109729,map__109729__$1,q_map,prefixes,map__109730,map__109730__$1,res,vars))
})();
var inst_109806 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_109805,inst_109804);
var inst_109807 = cljs.core.PersistentHashMap.EMPTY;
var inst_109808 = cljs.core.into.cljs$core$IFn$_invoke$arity$2(inst_109807,inst_109806);
var inst_109809 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109810 = cljs.core.update.cljs$core$IFn$_invoke$arity$4(res,cljs.core.cst$kw$vars,cljs.core.merge,inst_109808);
var inst_109811 = [inst_109810,r];
var inst_109812 = (new cljs.core.PersistentVector(null,2,(5),inst_109809,inst_109811,null));
var state_109935__$1 = state_109935;
var statearr_109944_110023 = state_109935__$1;
(statearr_109944_110023[(2)] = inst_109812);

(statearr_109944_110023[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (55))){
var inst_109887 = (state_109935[(17)]);
var inst_109888 = (state_109935[(18)]);
var inst_109905 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109906 = fluree.db.query.analytical.fdb_clause__GT_tuples(inst_109887,res,inst_109888,fuel,max_fuel);
var state_109935__$1 = (function (){var statearr_109945 = state_109935;
(statearr_109945[(16)] = inst_109905);

return statearr_109945;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109935__$1,(58),inst_109906);
} else {
if((state_val_109936 === (39))){
var inst_109925 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109946_110024 = state_109935__$1;
(statearr_109946_110024[(2)] = inst_109925);

(statearr_109946_110024[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (46))){
var inst_109921 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109947_110025 = state_109935__$1;
(statearr_109947_110025[(2)] = inst_109921);

(statearr_109947_110025[(1)] = (43));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_109935,(3),Error,null,(2));
var inst_109737 = cljs.core.map_QMARK_(clause);
var state_109935__$1 = state_109935;
if(inst_109737){
var statearr_109948_110026 = state_109935__$1;
(statearr_109948_110026[(1)] = (5));

} else {
var statearr_109949_110027 = state_109935__$1;
(statearr_109949_110027[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (54))){
var inst_109916 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109950_110028 = state_109935__$1;
(statearr_109950_110028[(2)] = inst_109916);

(statearr_109950_110028[(1)] = (50));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (15))){
var inst_109768 = (state_109935[(12)]);
var inst_109775 = (state_109935[(13)]);
var inst_109774 = cljs.core.seq(inst_109768);
var inst_109775__$1 = cljs.core.first(inst_109774);
var inst_109776 = cljs.core.next(inst_109774);
var state_109935__$1 = (function (){var statearr_109951 = state_109935;
(statearr_109951[(10)] = inst_109776);

(statearr_109951[(13)] = inst_109775__$1);

return statearr_109951;
})();
if(cljs.core.truth_(inst_109775__$1)){
var statearr_109952_110029 = state_109935__$1;
(statearr_109952_110029[(1)] = (17));

} else {
var statearr_109953_110030 = state_109935__$1;
(statearr_109953_110030[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (48))){
var inst_109888 = (state_109935[(18)]);
var inst_109891 = fluree.db.query.analytical.wikidata__GT_tuples(q_map,inst_109888,r,res,optional_QMARK_,fuel,max_fuel);
var state_109935__$1 = state_109935;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109935__$1,(51),inst_109891);
} else {
if((state_val_109936 === (50))){
var inst_109918 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109954_110031 = state_109935__$1;
(statearr_109954_110031[(2)] = inst_109918);

(statearr_109954_110031[(1)] = (46));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (21))){
var inst_109785 = (state_109935[(15)]);
var inst_109769 = (state_109935[(8)]);
var inst_109776 = (state_109935[(10)]);
var inst_109787 = fluree.db.query.analytical.outer_union(inst_109769,inst_109785);
var inst_109768 = inst_109776;
var inst_109769__$1 = inst_109787;
var state_109935__$1 = (function (){var statearr_109955 = state_109935;
(statearr_109955[(8)] = inst_109769__$1);

(statearr_109955[(12)] = inst_109768);

return statearr_109955;
})();
var statearr_109956_110032 = state_109935__$1;
(statearr_109956_110032[(2)] = null);

(statearr_109956_110032[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (31))){
var inst_109845 = cljs.core.count(clause);
var inst_109846 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((3),inst_109845);
var inst_109847 = cljs.core.second(clause);
var inst_109848 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_109847,"rdf:type");
var inst_109849 = ((inst_109846) && (inst_109848));
var state_109935__$1 = state_109935;
if(cljs.core.truth_(inst_109849)){
var statearr_109957_110033 = state_109935__$1;
(statearr_109957_110033[(1)] = (33));

} else {
var statearr_109958_110034 = state_109935__$1;
(statearr_109958_110034[(1)] = (34));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (32))){
var inst_109929 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109959_110035 = state_109935__$1;
(statearr_109959_110035[(2)] = inst_109929);

(statearr_109959_110035[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (40))){
var inst_109862 = (state_109935[(19)]);
var inst_109865 = (state_109935[(2)]);
var inst_109866 = fluree.db.util.async.throw_err(inst_109865);
var inst_109867 = [inst_109866,r];
var inst_109868 = (new cljs.core.PersistentVector(null,2,(5),inst_109862,inst_109867,null));
var state_109935__$1 = state_109935;
var statearr_109960_110036 = state_109935__$1;
(statearr_109960_110036[(2)] = inst_109868);

(statearr_109960_110036[(1)] = (39));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (56))){
var state_109935__$1 = state_109935;
var statearr_109961_110037 = state_109935__$1;
(statearr_109961_110037[(2)] = null);

(statearr_109961_110037[(1)] = (57));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (33))){
var inst_109851 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109852 = fluree.db.query.analytical.collection__GT_tuples(db,res,clause);
var state_109935__$1 = (function (){var statearr_109962 = state_109935;
(statearr_109962[(20)] = inst_109851);

return statearr_109962;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109935__$1,(36),inst_109852);
} else {
if((state_val_109936 === (13))){
var inst_109740 = (state_109935[(11)]);
var inst_109802 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$bind,inst_109740);
var state_109935__$1 = state_109935;
if(inst_109802){
var statearr_109963_110038 = state_109935__$1;
(statearr_109963_110038[(1)] = (24));

} else {
var statearr_109964_110039 = state_109935__$1;
(statearr_109964_110039[(1)] = (25));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (22))){
var inst_109785 = (state_109935[(15)]);
var inst_109776 = (state_109935[(10)]);
var inst_109768 = inst_109776;
var inst_109769 = inst_109785;
var state_109935__$1 = (function (){var statearr_109965 = state_109935;
(statearr_109965[(8)] = inst_109769);

(statearr_109965[(12)] = inst_109768);

return statearr_109965;
})();
var statearr_109966_110040 = state_109935__$1;
(statearr_109966_110040[(2)] = null);

(statearr_109966_110040[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (36))){
var inst_109851 = (state_109935[(20)]);
var inst_109854 = (state_109935[(2)]);
var inst_109855 = fluree.db.util.async.throw_err(inst_109854);
var inst_109856 = [inst_109855,r];
var inst_109857 = (new cljs.core.PersistentVector(null,2,(5),inst_109851,inst_109856,null));
var state_109935__$1 = state_109935;
var statearr_109967_110041 = state_109935__$1;
(statearr_109967_110041[(2)] = inst_109857);

(statearr_109967_110041[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (41))){
var inst_109873 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109874 = fluree.db.query.analytical.bind_clause__GT_vars(res,clause);
var inst_109875 = cljs.core.update.cljs$core$IFn$_invoke$arity$4(res,cljs.core.cst$kw$vars,cljs.core.merge,inst_109874);
var inst_109876 = [inst_109875,r];
var inst_109877 = (new cljs.core.PersistentVector(null,2,(5),inst_109873,inst_109876,null));
var state_109935__$1 = state_109935;
var statearr_109968_110042 = state_109935__$1;
(statearr_109968_110042[(2)] = inst_109877);

(statearr_109968_110042[(1)] = (43));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (43))){
var inst_109923 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109969_110043 = state_109935__$1;
(statearr_109969_110043[(2)] = inst_109923);

(statearr_109969_110043[(1)] = (39));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (29))){
var inst_109826 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109970_110044 = state_109935__$1;
(statearr_109970_110044[(2)] = inst_109826);

(statearr_109970_110044[(1)] = (26));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (44))){
var inst_109883 = fluree.db.query.analytical.get_source_clause.cljs$core$IFn$_invoke$arity$4(db,clause,prefixes,opts);
var state_109935__$1 = state_109935;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109935__$1,(47),inst_109883);
} else {
if((state_val_109936 === (6))){
var inst_109834 = cljs.core.count(clause);
var inst_109835 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((3),inst_109834);
var inst_109836 = cljs.core.second(clause);
var inst_109837 = clojure.string.starts_with_QMARK_(inst_109836,"fullText:");
var inst_109838 = ((inst_109835) && (inst_109837));
var state_109935__$1 = state_109935;
if(cljs.core.truth_(inst_109838)){
var statearr_109971_110045 = state_109935__$1;
(statearr_109971_110045[(1)] = (30));

} else {
var statearr_109972_110046 = state_109935__$1;
(statearr_109972_110046[(1)] = (31));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (28))){
var inst_109740 = (state_109935[(11)]);
var inst_109822 = ["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_109740)].join('');
var inst_109823 = (new Error(inst_109822));
var inst_109824 = (function(){throw inst_109823})();
var state_109935__$1 = state_109935;
var statearr_109973_110047 = state_109935__$1;
(statearr_109973_110047[(2)] = inst_109824);

(statearr_109973_110047[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (51))){
var inst_109893 = (state_109935[(2)]);
var inst_109894 = fluree.db.util.async.throw_err(inst_109893);
var state_109935__$1 = state_109935;
var statearr_109974_110048 = state_109935__$1;
(statearr_109974_110048[(2)] = inst_109894);

(statearr_109974_110048[(1)] = (50));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (25))){
var inst_109740 = (state_109935[(11)]);
var inst_109814 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$filter,inst_109740);
var state_109935__$1 = state_109935;
if(inst_109814){
var statearr_109975_110049 = state_109935__$1;
(statearr_109975_110049[(1)] = (27));

} else {
var statearr_109976_110050 = state_109935__$1;
(statearr_109976_110050[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (34))){
var inst_109859 = cljs.core.count(clause);
var inst_109860 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((3),inst_109859);
var state_109935__$1 = state_109935;
if(inst_109860){
var statearr_109977_110051 = state_109935__$1;
(statearr_109977_110051[(1)] = (37));

} else {
var statearr_109978_110052 = state_109935__$1;
(statearr_109978_110052[(1)] = (38));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (17))){
var inst_109775 = (state_109935[(13)]);
var inst_109778 = (fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$7 ? fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$7(db,inst_109775,q_map,vars,fuel,max_fuel,opts) : fluree.db.query.analytical.resolve_where_clause.call(null,db,inst_109775,q_map,vars,fuel,max_fuel,opts));
var state_109935__$1 = state_109935;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109935__$1,(20),inst_109778);
} else {
if((state_val_109936 === (3))){
var inst_109733 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109979_110053 = state_109935__$1;
(statearr_109979_110053[(2)] = inst_109733);


cljs.core.async.impl.ioc_helpers.process_exception(state_109935__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (12))){
var inst_109764 = (state_109935[(9)]);
var inst_109764__$1 = cljs.core.cst$kw$union.cljs$core$IFn$_invoke$arity$1(clause);
var inst_109765 = cljs.core.seq(inst_109764__$1);
var inst_109766 = cljs.core.first(inst_109765);
var inst_109767 = cljs.core.next(inst_109765);
var inst_109768 = inst_109764__$1;
var inst_109769 = null;
var state_109935__$1 = (function (){var statearr_109980 = state_109935;
(statearr_109980[(7)] = inst_109766);

(statearr_109980[(8)] = inst_109769);

(statearr_109980[(9)] = inst_109764__$1);

(statearr_109980[(12)] = inst_109768);

(statearr_109980[(14)] = inst_109767);

return statearr_109980;
})();
var statearr_109981_110054 = state_109935__$1;
(statearr_109981_110054[(2)] = null);

(statearr_109981_110054[(1)] = (15));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (2))){
var inst_109933 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
return cljs.core.async.impl.ioc_helpers.return_chan(state_109935__$1,inst_109933);
} else {
if((state_val_109936 === (23))){
var inst_109792 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109982_110055 = state_109935__$1;
(statearr_109982_110055[(2)] = inst_109792);

(statearr_109982_110055[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (47))){
var inst_109887 = (state_109935[(17)]);
var inst_109885 = (state_109935[(2)]);
var inst_109886 = fluree.db.util.async.throw_err(inst_109885);
var inst_109887__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_109886,(0),null);
var inst_109888 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_109886,(1),null);
var inst_109889 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("$wd",inst_109887__$1);
var state_109935__$1 = (function (){var statearr_109983 = state_109935;
(statearr_109983[(17)] = inst_109887__$1);

(statearr_109983[(18)] = inst_109888);

return statearr_109983;
})();
if(inst_109889){
var statearr_109984_110056 = state_109935__$1;
(statearr_109984_110056[(1)] = (48));

} else {
var statearr_109985_110057 = state_109935__$1;
(statearr_109985_110057[(1)] = (49));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (35))){
var inst_109927 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109986_110058 = state_109935__$1;
(statearr_109986_110058[(2)] = inst_109927);

(statearr_109986_110058[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (19))){
var inst_109798 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109987_110059 = state_109935__$1;
(statearr_109987_110059[(2)] = inst_109798);

(statearr_109987_110059[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (57))){
var inst_109914 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109988_110060 = state_109935__$1;
(statearr_109988_110060[(2)] = inst_109914);

(statearr_109988_110060[(1)] = (54));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (11))){
var inst_109746 = (state_109935[(21)]);
var inst_109750 = (state_109935[(2)]);
var inst_109751 = fluree.db.util.async.throw_err(inst_109750);
var inst_109752 = [inst_109751,r];
var inst_109753 = (new cljs.core.PersistentVector(null,2,(5),inst_109746,inst_109752,null));
var state_109935__$1 = state_109935;
var statearr_109989_110061 = state_109935__$1;
(statearr_109989_110061[(2)] = inst_109753);

(statearr_109989_110061[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (9))){
var inst_109740 = (state_109935[(11)]);
var inst_109755 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$union,inst_109740);
var state_109935__$1 = state_109935;
if(inst_109755){
var statearr_109990_110062 = state_109935__$1;
(statearr_109990_110062[(1)] = (12));

} else {
var statearr_109991_110063 = state_109935__$1;
(statearr_109991_110063[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (5))){
var inst_109740 = (state_109935[(11)]);
var inst_109739 = cljs.core.keys(clause);
var inst_109740__$1 = cljs.core.first(inst_109739);
var inst_109744 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$optional,inst_109740__$1);
var state_109935__$1 = (function (){var statearr_109992 = state_109935;
(statearr_109992[(11)] = inst_109740__$1);

return statearr_109992;
})();
if(inst_109744){
var statearr_109993_110064 = state_109935__$1;
(statearr_109993_110064[(1)] = (8));

} else {
var statearr_109994_110065 = state_109935__$1;
(statearr_109994_110065[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (14))){
var inst_109830 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109995_110066 = state_109935__$1;
(statearr_109995_110066[(2)] = inst_109830);

(statearr_109995_110066[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (45))){
var state_109935__$1 = state_109935;
var statearr_109996_110067 = state_109935__$1;
(statearr_109996_110067[(2)] = null);

(statearr_109996_110067[(1)] = (46));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (53))){
var state_109935__$1 = state_109935;
var statearr_109997_110068 = state_109935__$1;
(statearr_109997_110068[(1)] = (55));



return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (26))){
var inst_109828 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_109999_110069 = state_109935__$1;
(statearr_109999_110069[(2)] = inst_109828);

(statearr_109999_110069[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (16))){
var inst_109800 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_110000_110070 = state_109935__$1;
(statearr_110000_110070[(2)] = inst_109800);

(statearr_110000_110070[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (38))){
var inst_109870 = cljs.core.count(clause);
var inst_109871 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((2),inst_109870);
var state_109935__$1 = state_109935;
if(inst_109871){
var statearr_110001_110071 = state_109935__$1;
(statearr_110001_110071[(1)] = (41));

} else {
var statearr_110002_110072 = state_109935__$1;
(statearr_110002_110072[(1)] = (42));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (30))){
var inst_109840 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109841 = fluree.db.query.analytical.full_text__GT_tuples(db,res,clause);
var inst_109842 = [inst_109841,r];
var inst_109843 = (new cljs.core.PersistentVector(null,2,(5),inst_109840,inst_109842,null));
var state_109935__$1 = state_109935;
var statearr_110003_110073 = state_109935__$1;
(statearr_110003_110073[(2)] = inst_109843);

(statearr_110003_110073[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (10))){
var inst_109832 = (state_109935[(2)]);
var state_109935__$1 = state_109935;
var statearr_110004_110074 = state_109935__$1;
(statearr_110004_110074[(2)] = inst_109832);

(statearr_110004_110074[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (18))){
var inst_109769 = (state_109935[(8)]);
var inst_109794 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109795 = [inst_109769,r];
var inst_109796 = (new cljs.core.PersistentVector(null,2,(5),inst_109794,inst_109795,null));
var state_109935__$1 = state_109935;
var statearr_110005_110075 = state_109935__$1;
(statearr_110005_110075[(2)] = inst_109796);

(statearr_110005_110075[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (52))){
var inst_109887 = (state_109935[(17)]);
var inst_109888 = (state_109935[(18)]);
var inst_109899 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109900 = fluree.db.query.analytical.full_text__GT_tuples(inst_109887,res,inst_109888);
var inst_109901 = [inst_109900,r];
var inst_109902 = (new cljs.core.PersistentVector(null,2,(5),inst_109899,inst_109901,null));
var state_109935__$1 = state_109935;
var statearr_110006_110076 = state_109935__$1;
(statearr_110006_110076[(2)] = inst_109902);

(statearr_110006_110076[(1)] = (54));


return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (42))){
var state_109935__$1 = state_109935;
var statearr_110007_110077 = state_109935__$1;
(statearr_110007_110077[(1)] = (44));



return cljs.core.cst$kw$recur;
} else {
if((state_val_109936 === (37))){
var inst_109862 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109863 = fluree.db.query.analytical.fdb_clause__GT_tuples(db,res,clause,fuel,max_fuel);
var state_109935__$1 = (function (){var statearr_110009 = state_109935;
(statearr_110009[(19)] = inst_109862);

return statearr_110009;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109935__$1,(40),inst_109863);
} else {
if((state_val_109936 === (8))){
var inst_109746 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_109747 = cljs.core.cst$kw$optional.cljs$core$IFn$_invoke$arity$1(clause);
var inst_109748 = fluree.db.query.analytical.optional__GT_left_outer_joins(db,q_map,inst_109747,res,fuel,max_fuel,opts);
var state_109935__$1 = (function (){var statearr_110010 = state_109935;
(statearr_110010[(21)] = inst_109746);

return statearr_110010;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_109935__$1,(11),inst_109748);
} else {
if((state_val_109936 === (49))){
var inst_109888 = (state_109935[(18)]);
var inst_109896 = cljs.core.second(inst_109888);
var inst_109897 = clojure.string.starts_with_QMARK_(inst_109896,"fullText:");
var state_109935__$1 = state_109935;
if(inst_109897){
var statearr_110011_110078 = state_109935__$1;
(statearr_110011_110078[(1)] = (52));

} else {
var statearr_110012_110079 = state_109935__$1;
(statearr_110012_110079[(1)] = (53));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,map__109729,map__109729__$1,q_map,prefixes,map__109730,map__109730__$1,res,vars))
;
return ((function (switch__99702__auto__,c__99809__auto__,map__109729,map__109729__$1,q_map,prefixes,map__109730,map__109730__$1,res,vars){
return (function() {
var fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto__ = null;
var fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto____0 = (function (){
var statearr_110013 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_110013[(0)] = fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto__);

(statearr_110013[(1)] = (1));

return statearr_110013;
});
var fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto____1 = (function (state_109935){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_109935);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e110014){if((e110014 instanceof Object)){
var ex__99706__auto__ = e110014;
var statearr_110015_110080 = state_109935;
(statearr_110015_110080[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_109935);

return cljs.core.cst$kw$recur;
} else {
throw e110014;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__110081 = state_109935;
state_109935 = G__110081;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto__ = function(state_109935){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto____1.call(this,state_109935);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto____0;
fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto____1;
return fluree$db$query$analytical$clause__GT_tuples_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,map__109729,map__109729__$1,q_map,prefixes,map__109730,map__109730__$1,res,vars))
})();
var state__99811__auto__ = (function (){var statearr_110016 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_110016[(6)] = c__99809__auto__);

return statearr_110016;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,map__109729,map__109729__$1,q_map,prefixes,map__109730,map__109730__$1,res,vars))
);

return c__99809__auto__;
});
fluree.db.query.analytical.resolve_where_clause = (function fluree$db$query$analytical$resolve_where_clause(var_args){
var G__110083 = arguments.length;
switch (G__110083) {
case 6:
return fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
case 7:
return fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$7((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]),(arguments[(6)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$6 = (function (db,where,q_map,vars,fuel,max_fuel){
return fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$7(db,where,q_map,vars,fuel,max_fuel,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$7 = (function (db,where,q_map,vars,fuel,max_fuel,opts){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_110159){
var state_val_110160 = (state_110159[(1)]);
if((state_val_110160 === (7))){
var inst_110110 = (state_110159[(7)]);
var inst_110109 = (state_110159[(8)]);
var inst_110103 = (state_110159[(9)]);
var inst_110115 = fluree.db.query.analytical.clause__GT_tuples(db,q_map,inst_110103,inst_110109,inst_110110,false,fuel,max_fuel,opts);
var state_110159__$1 = state_110159;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_110159__$1,(10),inst_110115);
} else {
if((state_val_110160 === (20))){
var inst_110120 = (state_110159[(10)]);
var inst_110103 = (state_110159[(9)]);
var tmp110161 = inst_110103;
var inst_110102 = inst_110120;
var inst_110103__$1 = tmp110161;
var state_110159__$1 = (function (){var statearr_110162 = state_110159;
(statearr_110162[(9)] = inst_110103__$1);

(statearr_110162[(11)] = inst_110102);

return statearr_110162;
})();
var statearr_110163_110203 = state_110159__$1;
(statearr_110163_110203[(2)] = null);

(statearr_110163_110203[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (1))){
var state_110159__$1 = state_110159;
var statearr_110164_110204 = state_110159__$1;
(statearr_110164_110204[(2)] = null);

(statearr_110164_110204[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (24))){
var state_110159__$1 = state_110159;
var statearr_110165_110205 = state_110159__$1;
(statearr_110165_110205[(2)] = null);

(statearr_110165_110205[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_110159,(3),Error,null,(2));
var inst_110095 = cljs.core.seq(where);
var inst_110096 = cljs.core.first(inst_110095);
var inst_110097 = cljs.core.next(inst_110095);
var inst_110098 = [cljs.core.cst$kw$vars];
var inst_110099 = fluree.db.query.analytical.symbolize_keys(vars);
var inst_110100 = [inst_110099];
var inst_110101 = cljs.core.PersistentHashMap.fromArrays(inst_110098,inst_110100);
var inst_110102 = where;
var inst_110103 = inst_110101;
var state_110159__$1 = (function (){var statearr_110166 = state_110159;
(statearr_110166[(12)] = inst_110097);

(statearr_110166[(9)] = inst_110103);

(statearr_110166[(13)] = inst_110096);

(statearr_110166[(11)] = inst_110102);

return statearr_110166;
})();
var statearr_110167_110206 = state_110159__$1;
(statearr_110167_110206[(2)] = null);

(statearr_110167_110206[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (15))){
var inst_110119 = (state_110159[(14)]);
var inst_110135 = (inst_110119 == null);
var state_110159__$1 = state_110159;
if(cljs.core.truth_(inst_110135)){
var statearr_110168_110207 = state_110159__$1;
(statearr_110168_110207[(1)] = (20));

} else {
var statearr_110169_110208 = state_110159__$1;
(statearr_110169_110208[(1)] = (21));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (21))){
var state_110159__$1 = state_110159;
var statearr_110170_110209 = state_110159__$1;
(statearr_110170_110209[(1)] = (23));



return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (13))){
var inst_110150 = (state_110159[(2)]);
var state_110159__$1 = state_110159;
var statearr_110172_110210 = state_110159__$1;
(statearr_110172_110210[(2)] = inst_110150);

(statearr_110172_110210[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (22))){
var inst_110146 = (state_110159[(2)]);
var state_110159__$1 = state_110159;
var statearr_110173_110211 = state_110159__$1;
(statearr_110173_110211[(2)] = inst_110146);

(statearr_110173_110211[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (6))){
var inst_110155 = (state_110159[(2)]);
var state_110159__$1 = state_110159;
var statearr_110174_110212 = state_110159__$1;
(statearr_110174_110212[(2)] = inst_110155);


cljs.core.async.impl.ioc_helpers.process_exception(state_110159__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (25))){
var inst_110144 = (state_110159[(2)]);
var state_110159__$1 = state_110159;
var statearr_110175_110213 = state_110159__$1;
(statearr_110175_110213[(2)] = inst_110144);

(statearr_110175_110213[(1)] = (22));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (17))){
var inst_110119 = (state_110159[(14)]);
var state_110159__$1 = state_110159;
var statearr_110176_110214 = state_110159__$1;
(statearr_110176_110214[(2)] = inst_110119);

(statearr_110176_110214[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (3))){
var inst_110084 = (state_110159[(2)]);
var state_110159__$1 = state_110159;
var statearr_110177_110215 = state_110159__$1;
(statearr_110177_110215[(2)] = inst_110084);


cljs.core.async.impl.ioc_helpers.process_exception(state_110159__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (12))){
var inst_110103 = (state_110159[(9)]);
var inst_110126 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(inst_110103,cljs.core.cst$kw$vars);
var inst_110127 = cljs.core.empty_QMARK_(inst_110126);
var state_110159__$1 = state_110159;
if(inst_110127){
var statearr_110178_110216 = state_110159__$1;
(statearr_110178_110216[(1)] = (14));

} else {
var statearr_110179_110217 = state_110159__$1;
(statearr_110179_110217[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (2))){
var inst_110157 = (state_110159[(2)]);
var state_110159__$1 = state_110159;
return cljs.core.async.impl.ioc_helpers.return_chan(state_110159__$1,inst_110157);
} else {
if((state_val_110160 === (23))){
var inst_110120 = (state_110159[(10)]);
var inst_110119 = (state_110159[(14)]);
var inst_110103 = (state_110159[(9)]);
var inst_110140 = fluree.db.query.analytical.inner_join(inst_110103,inst_110119);
var inst_110102 = inst_110120;
var inst_110103__$1 = inst_110140;
var state_110159__$1 = (function (){var statearr_110180 = state_110159;
(statearr_110180[(9)] = inst_110103__$1);

(statearr_110180[(11)] = inst_110102);

return statearr_110180;
})();
var statearr_110181_110218 = state_110159__$1;
(statearr_110181_110218[(2)] = null);

(statearr_110181_110218[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (19))){
var inst_110120 = (state_110159[(10)]);
var inst_110132 = (state_110159[(2)]);
var inst_110102 = inst_110120;
var inst_110103 = inst_110132;
var state_110159__$1 = (function (){var statearr_110182 = state_110159;
(statearr_110182[(9)] = inst_110103);

(statearr_110182[(11)] = inst_110102);

return statearr_110182;
})();
var statearr_110183_110219 = state_110159__$1;
(statearr_110183_110219[(2)] = null);

(statearr_110183_110219[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (11))){
var inst_110120 = (state_110159[(10)]);
var inst_110119 = (state_110159[(14)]);
var inst_110102 = inst_110120;
var inst_110103 = inst_110119;
var state_110159__$1 = (function (){var statearr_110184 = state_110159;
(statearr_110184[(9)] = inst_110103);

(statearr_110184[(11)] = inst_110102);

return statearr_110184;
})();
var statearr_110185_110220 = state_110159__$1;
(statearr_110185_110220[(2)] = null);

(statearr_110185_110220[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (9))){
var inst_110153 = (state_110159[(2)]);
var state_110159__$1 = state_110159;
var statearr_110186_110221 = state_110159__$1;
(statearr_110186_110221[(2)] = inst_110153);

(statearr_110186_110221[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (5))){
var inst_110109 = (state_110159[(8)]);
var inst_110102 = (state_110159[(11)]);
var inst_110108 = cljs.core.seq(inst_110102);
var inst_110109__$1 = cljs.core.first(inst_110108);
var inst_110110 = cljs.core.next(inst_110108);
var state_110159__$1 = (function (){var statearr_110187 = state_110159;
(statearr_110187[(7)] = inst_110110);

(statearr_110187[(8)] = inst_110109__$1);

return statearr_110187;
})();
if(cljs.core.truth_(inst_110109__$1)){
var statearr_110188_110222 = state_110159__$1;
(statearr_110188_110222[(1)] = (7));

} else {
var statearr_110189_110223 = state_110159__$1;
(statearr_110189_110223[(1)] = (8));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (14))){
var inst_110119 = (state_110159[(14)]);
var state_110159__$1 = state_110159;
if(cljs.core.truth_(inst_110119)){
var statearr_110190_110224 = state_110159__$1;
(statearr_110190_110224[(1)] = (17));

} else {
var statearr_110191_110225 = state_110159__$1;
(statearr_110191_110225[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (16))){
var inst_110148 = (state_110159[(2)]);
var state_110159__$1 = state_110159;
var statearr_110192_110226 = state_110159__$1;
(statearr_110192_110226[(2)] = inst_110148);

(statearr_110192_110226[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (10))){
var inst_110109 = (state_110159[(8)]);
var inst_110117 = (state_110159[(2)]);
var inst_110118 = fluree.db.util.async.throw_err(inst_110117);
var inst_110119 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_110118,(0),null);
var inst_110120 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_110118,(1),null);
var inst_110121 = cljs.core.count(inst_110109);
var inst_110122 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((2),inst_110121);
var state_110159__$1 = (function (){var statearr_110193 = state_110159;
(statearr_110193[(10)] = inst_110120);

(statearr_110193[(14)] = inst_110119);

return statearr_110193;
})();
if(inst_110122){
var statearr_110194_110227 = state_110159__$1;
(statearr_110194_110227[(1)] = (11));

} else {
var statearr_110195_110228 = state_110159__$1;
(statearr_110195_110228[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (18))){
var inst_110103 = (state_110159[(9)]);
var state_110159__$1 = state_110159;
var statearr_110196_110229 = state_110159__$1;
(statearr_110196_110229[(2)] = inst_110103);

(statearr_110196_110229[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110160 === (8))){
var inst_110103 = (state_110159[(9)]);
var state_110159__$1 = state_110159;
var statearr_110197_110230 = state_110159__$1;
(statearr_110197_110230[(2)] = inst_110103);

(statearr_110197_110230[(1)] = (9));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$analytical$state_machine__99703__auto__ = null;
var fluree$db$query$analytical$state_machine__99703__auto____0 = (function (){
var statearr_110198 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_110198[(0)] = fluree$db$query$analytical$state_machine__99703__auto__);

(statearr_110198[(1)] = (1));

return statearr_110198;
});
var fluree$db$query$analytical$state_machine__99703__auto____1 = (function (state_110159){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_110159);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e110199){if((e110199 instanceof Object)){
var ex__99706__auto__ = e110199;
var statearr_110200_110231 = state_110159;
(statearr_110200_110231[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_110159);

return cljs.core.cst$kw$recur;
} else {
throw e110199;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__110232 = state_110159;
state_110159 = G__110232;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical$state_machine__99703__auto__ = function(state_110159){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical$state_machine__99703__auto____1.call(this,state_110159);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$state_machine__99703__auto____0;
fluree$db$query$analytical$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$state_machine__99703__auto____1;
return fluree$db$query$analytical$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_110201 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_110201[(6)] = c__99809__auto__);

return statearr_110201;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

fluree.db.query.analytical.resolve_where_clause.cljs$lang$maxFixedArity = 7;

fluree.db.query.analytical.q = (function fluree$db$query$analytical$q(q_map,fuel,max_fuel,db,opts){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_110289){
var state_val_110290 = (state_110289[(1)]);
if((state_val_110290 === (7))){
var inst_110253 = (state_110289[(2)]);
var state_110289__$1 = state_110289;
if(cljs.core.truth_(inst_110253)){
var statearr_110291_110323 = state_110289__$1;
(statearr_110291_110323[(1)] = (11));

} else {
var statearr_110292_110324 = state_110289__$1;
(statearr_110292_110324[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (20))){
var inst_110277 = (state_110289[(7)]);
var state_110289__$1 = state_110289;
var statearr_110293_110325 = state_110289__$1;
(statearr_110293_110325[(2)] = inst_110277);

(statearr_110293_110325[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (1))){
var state_110289__$1 = state_110289;
var statearr_110294_110326 = state_110289__$1;
(statearr_110294_110326[(2)] = null);

(statearr_110294_110326[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_110289,(3),Error,null,(2));
var inst_110239 = (q_map == null);
var inst_110240 = cljs.core.not(inst_110239);
var state_110289__$1 = state_110289;
if(inst_110240){
var statearr_110295_110327 = state_110289__$1;
(statearr_110295_110327[(1)] = (5));

} else {
var statearr_110296_110328 = state_110289__$1;
(statearr_110296_110328[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (15))){
var inst_110266 = (state_110289[(8)]);
var inst_110261 = (state_110289[(9)]);
var inst_110268 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([q_map], 0));
var inst_110269 = ["The query key: optional should be included in the 'where' array. The top-level 'optional' is being deprecated. Provided: ",inst_110268].join('');
var inst_110270 = fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_110269], 0));
var inst_110271 = fluree.db.query.analytical.optional__GT_left_outer_joins(db,q_map,inst_110261,inst_110266,fuel,max_fuel,opts);
var state_110289__$1 = (function (){var statearr_110297 = state_110289;
(statearr_110297[(10)] = inst_110270);

return statearr_110297;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_110289__$1,(18),inst_110271);
} else {
if((state_val_110290 === (21))){
var inst_110285 = (state_110289[(2)]);
var state_110289__$1 = state_110289;
var statearr_110298_110329 = state_110289__$1;
(statearr_110298_110329[(2)] = inst_110285);


cljs.core.async.impl.ioc_helpers.process_exception(state_110289__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (13))){
var inst_110258 = (state_110289[(2)]);
var inst_110259 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_110258,cljs.core.cst$kw$vars);
var inst_110260 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_110258,cljs.core.cst$kw$where);
var inst_110261 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_110258,cljs.core.cst$kw$optional);
var inst_110262 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_110258,cljs.core.cst$kw$filter);
var inst_110263 = fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$7(db,inst_110260,q_map,inst_110259,fuel,max_fuel,opts);
var state_110289__$1 = (function (){var statearr_110299 = state_110289;
(statearr_110299[(11)] = inst_110262);

(statearr_110299[(9)] = inst_110261);

return statearr_110299;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_110289__$1,(14),inst_110263);
} else {
if((state_val_110290 === (6))){
var state_110289__$1 = state_110289;
var statearr_110300_110330 = state_110289__$1;
(statearr_110300_110330[(2)] = false);

(statearr_110300_110330[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (17))){
var inst_110262 = (state_110289[(11)]);
var inst_110277 = (state_110289[(2)]);
var state_110289__$1 = (function (){var statearr_110301 = state_110289;
(statearr_110301[(7)] = inst_110277);

return statearr_110301;
})();
if(cljs.core.truth_(inst_110262)){
var statearr_110302_110331 = state_110289__$1;
(statearr_110302_110331[(1)] = (19));

} else {
var statearr_110303_110332 = state_110289__$1;
(statearr_110303_110332[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (3))){
var inst_110233 = (state_110289[(2)]);
var state_110289__$1 = state_110289;
var statearr_110304_110333 = state_110289__$1;
(statearr_110304_110333[(2)] = inst_110233);


cljs.core.async.impl.ioc_helpers.process_exception(state_110289__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (12))){
var state_110289__$1 = state_110289;
var statearr_110305_110334 = state_110289__$1;
(statearr_110305_110334[(2)] = q_map);

(statearr_110305_110334[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (2))){
var inst_110287 = (state_110289[(2)]);
var state_110289__$1 = state_110289;
return cljs.core.async.impl.ioc_helpers.return_chan(state_110289__$1,inst_110287);
} else {
if((state_val_110290 === (19))){
var inst_110262 = (state_110289[(11)]);
var inst_110277 = (state_110289[(7)]);
var inst_110279 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([q_map], 0));
var inst_110280 = ["The query key: filter should be included in the 'where' array. The top-level 'filter' is being deprecated. Provided: ",inst_110279].join('');
var inst_110281 = fluree.db.util.log.warn.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_110280], 0));
var inst_110282 = fluree.db.query.analytical.tuples__GT_filtered(inst_110277,inst_110262,null);
var state_110289__$1 = (function (){var statearr_110306 = state_110289;
(statearr_110306[(12)] = inst_110281);

return statearr_110306;
})();
var statearr_110307_110335 = state_110289__$1;
(statearr_110307_110335[(2)] = inst_110282);

(statearr_110307_110335[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (11))){
var inst_110255 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,q_map);
var state_110289__$1 = state_110289;
var statearr_110308_110336 = state_110289__$1;
(statearr_110308_110336[(2)] = inst_110255);

(statearr_110308_110336[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (9))){
var state_110289__$1 = state_110289;
var statearr_110309_110337 = state_110289__$1;
(statearr_110309_110337[(2)] = false);

(statearr_110309_110337[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (5))){
var inst_110242 = q_map.cljs$lang$protocol_mask$partition0$;
var inst_110243 = (inst_110242 & (64));
var inst_110244 = q_map.cljs$core$ISeq$;
var inst_110245 = (cljs.core.PROTOCOL_SENTINEL === inst_110244);
var inst_110246 = ((inst_110243) || (inst_110245));
var state_110289__$1 = state_110289;
if(cljs.core.truth_(inst_110246)){
var statearr_110310_110338 = state_110289__$1;
(statearr_110310_110338[(1)] = (8));

} else {
var statearr_110311_110339 = state_110289__$1;
(statearr_110311_110339[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (14))){
var inst_110261 = (state_110289[(9)]);
var inst_110265 = (state_110289[(2)]);
var inst_110266 = fluree.db.util.async.throw_err(inst_110265);
var state_110289__$1 = (function (){var statearr_110312 = state_110289;
(statearr_110312[(8)] = inst_110266);

return statearr_110312;
})();
if(cljs.core.truth_(inst_110261)){
var statearr_110313_110340 = state_110289__$1;
(statearr_110313_110340[(1)] = (15));

} else {
var statearr_110314_110341 = state_110289__$1;
(statearr_110314_110341[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (16))){
var inst_110266 = (state_110289[(8)]);
var state_110289__$1 = state_110289;
var statearr_110315_110342 = state_110289__$1;
(statearr_110315_110342[(2)] = inst_110266);

(statearr_110315_110342[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (10))){
var inst_110250 = (state_110289[(2)]);
var state_110289__$1 = state_110289;
var statearr_110316_110343 = state_110289__$1;
(statearr_110316_110343[(2)] = inst_110250);

(statearr_110316_110343[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (18))){
var inst_110273 = (state_110289[(2)]);
var inst_110274 = fluree.db.util.async.throw_err(inst_110273);
var state_110289__$1 = state_110289;
var statearr_110317_110344 = state_110289__$1;
(statearr_110317_110344[(2)] = inst_110274);

(statearr_110317_110344[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_110290 === (8))){
var state_110289__$1 = state_110289;
var statearr_110318_110345 = state_110289__$1;
(statearr_110318_110345[(2)] = true);

(statearr_110318_110345[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var fluree$db$query$analytical$q_$_state_machine__99703__auto__ = null;
var fluree$db$query$analytical$q_$_state_machine__99703__auto____0 = (function (){
var statearr_110319 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_110319[(0)] = fluree$db$query$analytical$q_$_state_machine__99703__auto__);

(statearr_110319[(1)] = (1));

return statearr_110319;
});
var fluree$db$query$analytical$q_$_state_machine__99703__auto____1 = (function (state_110289){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_110289);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e110320){if((e110320 instanceof Object)){
var ex__99706__auto__ = e110320;
var statearr_110321_110346 = state_110289;
(statearr_110321_110346[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_110289);

return cljs.core.cst$kw$recur;
} else {
throw e110320;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__110347 = state_110289;
state_110289 = G__110347;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
fluree$db$query$analytical$q_$_state_machine__99703__auto__ = function(state_110289){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$q_$_state_machine__99703__auto____0.call(this);
case 1:
return fluree$db$query$analytical$q_$_state_machine__99703__auto____1.call(this,state_110289);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$q_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$q_$_state_machine__99703__auto____0;
fluree$db$query$analytical$q_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$q_$_state_machine__99703__auto____1;
return fluree$db$query$analytical$q_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_110322 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_110322[(6)] = c__99809__auto__);

return statearr_110322;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
