// Compiled by ClojureScript 1.10.520 {:static-fns true, :optimize-constants true}
goog.provide('shared.fdb');
goog.require('cljs.core');
goog.require('cljs.core.constants');
goog.require('clojure.string');
goog.require('cljs.core.async');
goog.require('fluree.crypto');
goog.require('fluree.db.flake');
goog.require('fluree.db.operations');
goog.require('fluree.db.query.block');
goog.require('fluree.db.query.range');
goog.require('fluree.db.query.fql');
goog.require('fluree.db.session');
goog.require('fluree.db.time_travel');
goog.require('fluree.db.util.async');
goog.require('fluree.db.util.json');
goog.require('fluree.db.util.log');
goog.require('fluree.db.util.core');
goog.require('goog.string.format');
goog.require('shared.connection_handler');
/**
 * Returns a queryable database from the connection.
 * No permissions applied - assumes root
 */
shared.fdb.db = (function shared$fdb$db(var_args){
var args__4736__auto__ = [];
var len__4730__auto___119071 = arguments.length;
var i__4731__auto___119072 = (0);
while(true){
if((i__4731__auto___119072 < len__4730__auto___119071)){
args__4736__auto__.push((arguments[i__4731__auto___119072]));

var G__119073 = (i__4731__auto___119072 + (1));
i__4731__auto___119072 = G__119073;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((2) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((2)),(0),null)):null);
return shared.fdb.db.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4737__auto__);
});

shared.fdb.db.cljs$core$IFn$_invoke$arity$variadic = (function (conn,ledger,p__118982){
var vec__118983 = p__118982;
var opts = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__118983,(0),null);
var pc = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__99809__auto___119074 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto___119074,pc,vec__118983,opts){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto___119074,pc,vec__118983,opts){
return (function (state_119043){
var state_val_119044 = (state_119043[(1)]);
if((state_val_119044 === (7))){
var inst_119012 = (state_119043[(2)]);
var state_119043__$1 = state_119043;
if(cljs.core.truth_(inst_119012)){
var statearr_119045_119075 = state_119043__$1;
(statearr_119045_119075[(1)] = (11));

} else {
var statearr_119046_119076 = state_119043__$1;
(statearr_119046_119076[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (1))){
var state_119043__$1 = state_119043;
var statearr_119047_119077 = state_119043__$1;
(statearr_119047_119077[(2)] = null);

(statearr_119047_119077[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_119043,(3),cljs.core.cst$kw$default,null,(2));
var inst_118998 = (opts == null);
var inst_118999 = cljs.core.not(inst_118998);
var state_119043__$1 = state_119043;
if(inst_118999){
var statearr_119048_119078 = state_119043__$1;
(statearr_119048_119078[(1)] = (5));

} else {
var statearr_119049_119079 = state_119043__$1;
(statearr_119049_119079[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (15))){
var inst_119030 = (state_119043[(7)]);
var inst_119021 = (state_119043[(8)]);
var inst_119032 = fluree.db.time_travel.as_of_block(inst_119030,inst_119021);
var state_119043__$1 = state_119043;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119043__$1,(18),inst_119032);
} else {
if((state_val_119044 === (13))){
var inst_119017 = (state_119043[(2)]);
var inst_119018 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119017,cljs.core.cst$kw$roles);
var inst_119019 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119017,cljs.core.cst$kw$user);
var inst_119020 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119017,cljs.core.cst$kw$auth);
var inst_119021 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119017,cljs.core.cst$kw$block);
var inst_119022 = shared.connection_handler.check_connection.cljs$core$IFn$_invoke$arity$2(conn,opts);
var inst_119023 = fluree.db.session.resolve_ledger(conn,ledger);
var inst_119024 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_119023,(0),null);
var inst_119025 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_119023,(1),null);
var inst_119026 = fluree.db.session.db(conn,ledger,opts);
var state_119043__$1 = (function (){var statearr_119050 = state_119043;
(statearr_119050[(9)] = inst_119024);

(statearr_119050[(8)] = inst_119021);

(statearr_119050[(10)] = inst_119022);

(statearr_119050[(11)] = inst_119019);

(statearr_119050[(12)] = inst_119018);

(statearr_119050[(13)] = inst_119020);

(statearr_119050[(14)] = inst_119025);

return statearr_119050;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119043__$1,(14),inst_119026);
} else {
if((state_val_119044 === (6))){
var state_119043__$1 = state_119043;
var statearr_119051_119080 = state_119043__$1;
(statearr_119051_119080[(2)] = false);

(statearr_119051_119080[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (17))){
var inst_119038 = (state_119043[(2)]);
var inst_119039 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pc,inst_119038);
var state_119043__$1 = state_119043;
var statearr_119052_119081 = state_119043__$1;
(statearr_119052_119081[(2)] = inst_119039);


cljs.core.async.impl.ioc_helpers.process_exception(state_119043__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (3))){
var inst_118986 = (state_119043[(2)]);
var inst_118987 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_118986], 0));
var inst_118988 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pc,inst_118986);
var inst_118989 = cljs.core.async.close_BANG_(pc);
var state_119043__$1 = (function (){var statearr_119053 = state_119043;
(statearr_119053[(15)] = inst_118987);

(statearr_119053[(16)] = inst_118988);

return statearr_119053;
})();
var statearr_119054_119082 = state_119043__$1;
(statearr_119054_119082[(2)] = inst_118989);


cljs.core.async.impl.ioc_helpers.process_exception(state_119043__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (12))){
var state_119043__$1 = state_119043;
var statearr_119055_119083 = state_119043__$1;
(statearr_119055_119083[(2)] = opts);

(statearr_119055_119083[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (2))){
var inst_119041 = (state_119043[(2)]);
var state_119043__$1 = state_119043;
return cljs.core.async.impl.ioc_helpers.return_chan(state_119043__$1,inst_119041);
} else {
if((state_val_119044 === (11))){
var inst_119014 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,opts);
var state_119043__$1 = state_119043;
var statearr_119056_119084 = state_119043__$1;
(statearr_119056_119084[(2)] = inst_119014);

(statearr_119056_119084[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (9))){
var state_119043__$1 = state_119043;
var statearr_119057_119085 = state_119043__$1;
(statearr_119057_119085[(2)] = false);

(statearr_119057_119085[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (5))){
var inst_119001 = opts.cljs$lang$protocol_mask$partition0$;
var inst_119002 = (inst_119001 & (64));
var inst_119003 = opts.cljs$core$ISeq$;
var inst_119004 = (cljs.core.PROTOCOL_SENTINEL === inst_119003);
var inst_119005 = ((inst_119002) || (inst_119004));
var state_119043__$1 = state_119043;
if(cljs.core.truth_(inst_119005)){
var statearr_119058_119086 = state_119043__$1;
(statearr_119058_119086[(1)] = (8));

} else {
var statearr_119059_119087 = state_119043__$1;
(statearr_119059_119087[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (14))){
var inst_119024 = (state_119043[(9)]);
var inst_119021 = (state_119043[(8)]);
var inst_119025 = (state_119043[(14)]);
var inst_119028 = (state_119043[(2)]);
var inst_119029 = fluree.db.util.async.throw_err(inst_119028);
var inst_119030 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(inst_119029,cljs.core.cst$kw$conn,conn,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$network,inst_119024,cljs.core.cst$kw$dbid,inst_119025], 0));
var state_119043__$1 = (function (){var statearr_119060 = state_119043;
(statearr_119060[(7)] = inst_119030);

return statearr_119060;
})();
if(cljs.core.truth_(inst_119021)){
var statearr_119061_119088 = state_119043__$1;
(statearr_119061_119088[(1)] = (15));

} else {
var statearr_119062_119089 = state_119043__$1;
(statearr_119062_119089[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (16))){
var inst_119030 = (state_119043[(7)]);
var state_119043__$1 = state_119043;
var statearr_119063_119090 = state_119043__$1;
(statearr_119063_119090[(2)] = inst_119030);

(statearr_119063_119090[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (10))){
var inst_119009 = (state_119043[(2)]);
var state_119043__$1 = state_119043;
var statearr_119064_119091 = state_119043__$1;
(statearr_119064_119091[(2)] = inst_119009);

(statearr_119064_119091[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (18))){
var inst_119034 = (state_119043[(2)]);
var inst_119035 = fluree.db.util.async.throw_err(inst_119034);
var state_119043__$1 = state_119043;
var statearr_119065_119092 = state_119043__$1;
(statearr_119065_119092[(2)] = inst_119035);

(statearr_119065_119092[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119044 === (8))){
var state_119043__$1 = state_119043;
var statearr_119066_119093 = state_119043__$1;
(statearr_119066_119093[(2)] = true);

(statearr_119066_119093[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto___119074,pc,vec__118983,opts))
;
return ((function (switch__99702__auto__,c__99809__auto___119074,pc,vec__118983,opts){
return (function() {
var shared$fdb$state_machine__99703__auto__ = null;
var shared$fdb$state_machine__99703__auto____0 = (function (){
var statearr_119067 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_119067[(0)] = shared$fdb$state_machine__99703__auto__);

(statearr_119067[(1)] = (1));

return statearr_119067;
});
var shared$fdb$state_machine__99703__auto____1 = (function (state_119043){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_119043);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e119068){if((e119068 instanceof Object)){
var ex__99706__auto__ = e119068;
var statearr_119069_119094 = state_119043;
(statearr_119069_119094[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_119043);

return cljs.core.cst$kw$recur;
} else {
throw e119068;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__119095 = state_119043;
state_119043 = G__119095;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$state_machine__99703__auto__ = function(state_119043){
switch(arguments.length){
case 0:
return shared$fdb$state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$state_machine__99703__auto____1.call(this,state_119043);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$state_machine__99703__auto____0;
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$state_machine__99703__auto____1;
return shared$fdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto___119074,pc,vec__118983,opts))
})();
var state__99811__auto__ = (function (){var statearr_119070 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_119070[(6)] = c__99809__auto___119074);

return statearr_119070;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto___119074,pc,vec__118983,opts))
);


return pc;
});

shared.fdb.db.cljs$lang$maxFixedArity = (2);

/** @this {Function} */
shared.fdb.db.cljs$lang$applyTo = (function (seq118979){
var G__118980 = cljs.core.first(seq118979);
var seq118979__$1 = cljs.core.next(seq118979);
var G__118981 = cljs.core.first(seq118979__$1);
var seq118979__$2 = cljs.core.next(seq118979__$1);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__118980,G__118981,seq118979__$2);
});

shared.fdb.db_ident_QMARK_ = (function shared$fdb$db_ident_QMARK_(source){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.count(clojure.string.split.cljs$core$IFn$_invoke$arity$2(source,/\//)),(2));
});
shared.fdb.isolate_ledger_id = (function shared$fdb$isolate_ledger_id(dbid){
return cljs.core.re_find(/[a-z0-9]+\/[a-z0-9]+/,dbid);
});
/**
 * Validates & returns the query sources.
 * 
 *   The db function, to evaluate prefixes/multiple sources, is passed
 *   as a parameter.  This allows for the node.js version to override the
 *   default [shared.fdb.db] with its own function.
 *   
 */
shared.fdb.get_sources = (function shared$fdb$get_sources(conn,network,open_api,auth,prefixes,db_fn){
return cljs.core.reduce_kv((function (acc,key,val){
if(cljs.core.truth_(cljs.core.re_matches(/[a-z]+/,fluree.db.util.core.keyword__GT_str(key)))){
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Source name must be only lowercase letters. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fluree.db.util.core.keyword__GT_str(key))].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null));
}

if(cljs.core.truth_((function (){var and__4120__auto__ = shared.fdb.db_ident_QMARK_(val);
if(and__4120__auto__){
var and__4120__auto____$1 = open_api;
if(cljs.core.truth_(and__4120__auto____$1)){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(network,cljs.core.first(clojure.string.split.cljs$core$IFn$_invoke$arity$2(val,/\//)));
} else {
return and__4120__auto____$1;
}
} else {
return and__4120__auto__;
}
})())){
var db_id = shared.fdb.isolate_ledger_id(val);
var opts = (cljs.core.truth_(auth)?new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$auth,auth], null):cljs.core.PersistentArrayMap.EMPTY);
var ledger = cljs.core.apply.cljs$core$IFn$_invoke$arity$4(db_fn,conn,db_id,opts);
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(acc,val,ledger);
} else {
if(cljs.core.truth_((function (){var and__4120__auto__ = shared.fdb.db_ident_QMARK_(val);
if(and__4120__auto__){
return open_api;
} else {
return and__4120__auto__;
}
})())){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("When attempting to query across multiple databases in different networks, you must be using a closed API.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_query], null));
} else {
if(cljs.core.truth_((function (){var and__4120__auto__ = shared.fdb.db_ident_QMARK_(val);
if(and__4120__auto__){
return auth;
} else {
return and__4120__auto__;
}
})())){
var db_id = shared.fdb.isolate_ledger_id(val);
var ledger = cljs.core.apply.cljs$core$IFn$_invoke$arity$4(db_fn,conn,db_id,new cljs.core.PersistentArrayMap(null, 1, [cljs.core.cst$kw$auth,auth], null));
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(acc,val,ledger);
} else {
return acc;

}
}
}
}),cljs.core.PersistentArrayMap.EMPTY,prefixes);
});
/**
 * Execute an unsigned query against a database source, or optionally
 *   additional sources if the query spans multiple data sets.
 *   Returns a channel, where the results are eventually put.
 * 
 *   The db function, to evaluate prefixes/multiple sources, is passed
 *   as a parameter.  This allows for the node.js version to override the
 *   default [shared.fdb.db] with its own function.
 *   
 */
shared.fdb.query_async = (function shared$fdb$query_async(var_args){
var G__119098 = arguments.length;
switch (G__119098) {
case 2:
return shared.fdb.query_async.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shared.fdb.query_async.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return shared.fdb.query_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.fdb.query_async.cljs$core$IFn$_invoke$arity$2 = (function (sources,query_map){
return shared.fdb.query_async.cljs$core$IFn$_invoke$arity$4(sources,query_map,null,shared.fdb.db);
});

shared.fdb.query_async.cljs$core$IFn$_invoke$arity$3 = (function (sources,query_map,opts){
return shared.fdb.query_async.cljs$core$IFn$_invoke$arity$4(sources,query_map,opts,shared.fdb.db);
});

shared.fdb.query_async.cljs$core$IFn$_invoke$arity$4 = (function (sources,query_map,opts,db_fn){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_119255){
var state_val_119256 = (state_119255[(1)]);
if((state_val_119256 === (65))){
var inst_119244 = [cljs.core.cst$kw$message,cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_119245 = ["Invalid query.",(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_119246 = cljs.core.PersistentHashMap.fromArrays(inst_119244,inst_119245);
var state_119255__$1 = state_119255;
var statearr_119257_119358 = state_119255__$1;
(statearr_119257_119358[(2)] = inst_119246);

(statearr_119257_119358[(1)] = (67));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (62))){
var inst_119206 = (state_119255[(7)]);
var state_119255__$1 = state_119255;
var statearr_119258_119359 = state_119255__$1;
(statearr_119258_119359[(2)] = inst_119206);

(statearr_119258_119359[(1)] = (64));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (7))){
var inst_119123 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
if(cljs.core.truth_(inst_119123)){
var statearr_119259_119360 = state_119255__$1;
(statearr_119259_119360[(1)] = (11));

} else {
var statearr_119260_119361 = state_119255__$1;
(statearr_119260_119361[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (59))){
var inst_119206 = (state_119255[(7)]);
var inst_119220 = cljs.core.doall.cljs$core$IFn$_invoke$arity$1(inst_119206);
var state_119255__$1 = state_119255;
var statearr_119261_119362 = state_119255__$1;
(statearr_119261_119362[(2)] = inst_119220);

(statearr_119261_119362[(1)] = (61));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (20))){
var inst_119157 = cljs.core.PersistentHashMap.EMPTY;
var state_119255__$1 = state_119255;
var statearr_119262_119363 = state_119255__$1;
(statearr_119262_119363[(2)] = inst_119157);

(statearr_119262_119363[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (58))){
var inst_119239 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
var statearr_119263_119364 = state_119255__$1;
(statearr_119263_119364[(2)] = inst_119239);

(statearr_119263_119364[(1)] = (55));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (60))){
var inst_119206 = (state_119255[(7)]);
var state_119255__$1 = state_119255;
var statearr_119264_119365 = state_119255__$1;
(statearr_119264_119365[(2)] = inst_119206);

(statearr_119264_119365[(1)] = (61));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (27))){
var inst_119174 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
var statearr_119265_119366 = state_119255__$1;
(statearr_119265_119366[(2)] = inst_119174);

(statearr_119265_119366[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (1))){
var state_119255__$1 = state_119255;
var statearr_119266_119367 = state_119255__$1;
(statearr_119266_119367[(2)] = null);

(statearr_119266_119367[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (24))){
var inst_119176 = (state_119255[(8)]);
var inst_119176__$1 = (state_119255[(2)]);
var state_119255__$1 = (function (){var statearr_119267 = state_119255;
(statearr_119267[(8)] = inst_119176__$1);

return statearr_119267;
})();
if(cljs.core.truth_(inst_119176__$1)){
var statearr_119268_119368 = state_119255__$1;
(statearr_119268_119368[(1)] = (34));

} else {
var statearr_119269_119369 = state_119255__$1;
(statearr_119269_119369[(1)] = (35));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (55))){
var inst_119241 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
var statearr_119270_119370 = state_119255__$1;
(statearr_119270_119370[(2)] = inst_119241);

(statearr_119270_119370[(1)] = (42));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (39))){
var inst_119181 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
var statearr_119271_119371 = state_119255__$1;
(statearr_119271_119371[(2)] = inst_119181);

(statearr_119271_119371[(1)] = (36));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (46))){
var inst_119191 = (state_119255[(9)]);
var state_119255__$1 = state_119255;
var statearr_119272_119372 = state_119255__$1;
(statearr_119272_119372[(2)] = inst_119191);

(statearr_119272_119372[(1)] = (48));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_119255,(3),cljs.core.cst$kw$default,null,(2));
var inst_119109 = (query_map == null);
var inst_119110 = cljs.core.not(inst_119109);
var state_119255__$1 = state_119255;
if(inst_119110){
var statearr_119273_119373 = state_119255__$1;
(statearr_119273_119373[(1)] = (5));

} else {
var statearr_119274_119374 = state_119255__$1;
(statearr_119274_119374[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (54))){
var inst_119186 = (state_119255[(10)]);
var state_119255__$1 = state_119255;
if(cljs.core.truth_(inst_119186)){
var statearr_119275_119375 = state_119255__$1;
(statearr_119275_119375[(1)] = (56));

} else {
var statearr_119276_119376 = state_119255__$1;
(statearr_119276_119376[(1)] = (57));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (15))){
var inst_119141 = (state_119255[(11)]);
var inst_119131 = (state_119255[(12)]);
var inst_119143 = fluree.db.time_travel.as_of_block(inst_119141,inst_119131);
var state_119255__$1 = state_119255;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119255__$1,(18),inst_119143);
} else {
if((state_val_119256 === (48))){
var inst_119195 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
if(cljs.core.truth_(inst_119195)){
var statearr_119277_119377 = state_119255__$1;
(statearr_119277_119377[(1)] = (49));

} else {
var statearr_119278_119378 = state_119255__$1;
(statearr_119278_119378[(1)] = (50));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (50))){
var state_119255__$1 = state_119255;
var statearr_119279_119379 = state_119255__$1;
(statearr_119279_119379[(2)] = null);

(statearr_119279_119379[(1)] = (51));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (21))){
var inst_119130 = (state_119255[(13)]);
var inst_119159 = (state_119255[(14)]);
var inst_119159__$1 = (state_119255[(2)]);
var inst_119160 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(opts,cljs.core.cst$kw$sources,inst_119159__$1);
var state_119255__$1 = (function (){var statearr_119280 = state_119255;
(statearr_119280[(15)] = inst_119160);

(statearr_119280[(14)] = inst_119159__$1);

return statearr_119280;
})();
if(cljs.core.truth_(inst_119130)){
var statearr_119281_119380 = state_119255__$1;
(statearr_119281_119380[(1)] = (22));

} else {
var statearr_119282_119381 = state_119255__$1;
(statearr_119282_119381[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (31))){
var inst_119138 = (state_119255[(16)]);
var state_119255__$1 = state_119255;
var statearr_119283_119382 = state_119255__$1;
(statearr_119283_119382[(2)] = inst_119138);

(statearr_119283_119382[(1)] = (33));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (32))){
var inst_119129 = (state_119255[(17)]);
var state_119255__$1 = state_119255;
var statearr_119284_119383 = state_119255__$1;
(statearr_119284_119383[(2)] = inst_119129);

(statearr_119284_119383[(1)] = (33));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (40))){
var inst_119160 = (state_119255[(15)]);
var inst_119187 = (state_119255[(18)]);
var inst_119186 = cljs.core.cst$kw$meta.cljs$core$IFn$_invoke$arity$1(inst_119160);
var inst_119187__$1 = cljs.core.cst$kw$fuel.cljs$core$IFn$_invoke$arity$1(inst_119160);
var state_119255__$1 = (function (){var statearr_119285 = state_119255;
(statearr_119285[(18)] = inst_119187__$1);

(statearr_119285[(10)] = inst_119186);

return statearr_119285;
})();
if(cljs.core.truth_(inst_119187__$1)){
var statearr_119286_119384 = state_119255__$1;
(statearr_119286_119384[(1)] = (43));

} else {
var statearr_119287_119385 = state_119255__$1;
(statearr_119287_119385[(1)] = (44));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (56))){
var inst_119206 = (state_119255[(7)]);
var inst_119217 = [cljs.core.cst$kw$status,cljs.core.cst$kw$result,cljs.core.cst$kw$fuel,cljs.core.cst$kw$time,cljs.core.cst$kw$block];
var inst_119218 = cljs.core.sequential_QMARK_(inst_119206);
var state_119255__$1 = (function (){var statearr_119288 = state_119255;
(statearr_119288[(19)] = inst_119217);

return statearr_119288;
})();
if(inst_119218){
var statearr_119289_119386 = state_119255__$1;
(statearr_119289_119386[(1)] = (59));

} else {
var statearr_119290_119387 = state_119255__$1;
(statearr_119290_119387[(1)] = (60));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (33))){
var inst_119170 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
var statearr_119291_119388 = state_119255__$1;
(statearr_119291_119388[(2)] = inst_119170);

(statearr_119291_119388[(1)] = (30));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (13))){
var inst_119128 = (state_119255[(20)]);
var inst_119128__$1 = (state_119255[(2)]);
var inst_119129 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119128__$1,cljs.core.cst$kw$construct);
var inst_119130 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119128__$1,cljs.core.cst$kw$select);
var inst_119131 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119128__$1,cljs.core.cst$kw$block);
var inst_119132 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119128__$1,cljs.core.cst$kw$where);
var inst_119133 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119128__$1,cljs.core.cst$kw$prefixes);
var inst_119134 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119128__$1,cljs.core.cst$kw$limit);
var inst_119135 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119128__$1,cljs.core.cst$kw$selectDistinct);
var inst_119136 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119128__$1,cljs.core.cst$kw$selectOne);
var inst_119137 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119128__$1,cljs.core.cst$kw$from);
var inst_119138 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119128__$1,cljs.core.cst$kw$selectReduced);
var state_119255__$1 = (function (){var statearr_119292 = state_119255;
(statearr_119292[(13)] = inst_119130);

(statearr_119292[(21)] = inst_119137);

(statearr_119292[(22)] = inst_119136);

(statearr_119292[(17)] = inst_119129);

(statearr_119292[(23)] = inst_119133);

(statearr_119292[(24)] = inst_119134);

(statearr_119292[(25)] = inst_119135);

(statearr_119292[(26)] = inst_119132);

(statearr_119292[(16)] = inst_119138);

(statearr_119292[(20)] = inst_119128__$1);

(statearr_119292[(12)] = inst_119131);

return statearr_119292;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119255__$1,(14),sources);
} else {
if((state_val_119256 === (22))){
var inst_119130 = (state_119255[(13)]);
var state_119255__$1 = state_119255;
var statearr_119293_119389 = state_119255__$1;
(statearr_119293_119389[(2)] = inst_119130);

(statearr_119293_119389[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (36))){
var inst_119184 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
if(cljs.core.truth_(inst_119184)){
var statearr_119294_119390 = state_119255__$1;
(statearr_119294_119390[(1)] = (40));

} else {
var statearr_119295_119391 = state_119255__$1;
(statearr_119295_119391[(1)] = (41));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (41))){
var state_119255__$1 = state_119255;
var statearr_119296_119392 = state_119255__$1;
(statearr_119296_119392[(1)] = (65));



return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (43))){
var inst_119187 = (state_119255[(18)]);
var state_119255__$1 = state_119255;
var statearr_119298_119393 = state_119255__$1;
(statearr_119298_119393[(2)] = inst_119187);

(statearr_119298_119393[(1)] = (45));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (61))){
var inst_119130 = (state_119255[(13)]);
var inst_119141 = (state_119255[(11)]);
var inst_119160 = (state_119255[(15)]);
var inst_119137 = (state_119255[(21)]);
var inst_119136 = (state_119255[(22)]);
var inst_119129 = (state_119255[(17)]);
var inst_119206 = (state_119255[(7)]);
var inst_119201 = (state_119255[(27)]);
var inst_119133 = (state_119255[(23)]);
var inst_119134 = (state_119255[(24)]);
var inst_119186 = (state_119255[(10)]);
var inst_119150 = (state_119255[(28)]);
var inst_119217 = (state_119255[(19)]);
var inst_119191 = (state_119255[(9)]);
var inst_119135 = (state_119255[(25)]);
var inst_119132 = (state_119255[(26)]);
var inst_119159 = (state_119255[(14)]);
var inst_119138 = (state_119255[(16)]);
var inst_119149 = (state_119255[(29)]);
var inst_119128 = (state_119255[(20)]);
var inst_119131 = (state_119255[(12)]);
var inst_119200 = (state_119255[(30)]);
var inst_119207 = (state_119255[(31)]);
var inst_119223 = (state_119255[(2)]);
var inst_119224 = cljs.core.deref(inst_119200);
var inst_119225 = (function (){var error_QMARK_ = inst_119207;
var construct = inst_119129;
var result_STAR_ = inst_119206;
var conn = inst_119150;
var select = inst_119130;
var block = inst_119131;
var where = inst_119132;
var prefixes = inst_119133;
var limit = inst_119134;
var db = inst_119141;
var meta_QMARK_ = inst_119186;
var map__119107 = inst_119128;
var source_opts = inst_119159;
var fuel = inst_119200;
var db_STAR_ = inst_119149;
var selectDistinct = inst_119135;
var start_ms = inst_119201;
var selectOne = inst_119136;
var from = inst_119137;
var max_fuel = inst_119191;
var opts__$1 = inst_119160;
var selectReduced = inst_119138;
return ((function (error_QMARK_,construct,result_STAR_,conn,select,block,where,prefixes,limit,db,meta_QMARK_,map__119107,source_opts,fuel,db_STAR_,selectDistinct,start_ms,selectOne,from,max_fuel,opts__$1,selectReduced,inst_119130,inst_119141,inst_119160,inst_119137,inst_119136,inst_119129,inst_119206,inst_119201,inst_119133,inst_119134,inst_119186,inst_119150,inst_119217,inst_119191,inst_119135,inst_119132,inst_119159,inst_119138,inst_119149,inst_119128,inst_119131,inst_119200,inst_119207,inst_119223,inst_119224,state_val_119256,c__99809__auto__){
return (function (p1__119096_SHARP_){
var G__119299 = "%.2fms";
var G__119300 = p1__119096_SHARP_;
return goog.string.format(G__119299,G__119300);
});
;})(error_QMARK_,construct,result_STAR_,conn,select,block,where,prefixes,limit,db,meta_QMARK_,map__119107,source_opts,fuel,db_STAR_,selectDistinct,start_ms,selectOne,from,max_fuel,opts__$1,selectReduced,inst_119130,inst_119141,inst_119160,inst_119137,inst_119136,inst_119129,inst_119206,inst_119201,inst_119133,inst_119134,inst_119186,inst_119150,inst_119217,inst_119191,inst_119135,inst_119132,inst_119159,inst_119138,inst_119149,inst_119128,inst_119131,inst_119200,inst_119207,inst_119223,inst_119224,state_val_119256,c__99809__auto__))
})();
var inst_119226 = fluree.db.util.core.current_time_millis();
var inst_119227 = (inst_119226 - inst_119201);
var inst_119228 = (inst_119227 / (1000000));
var inst_119229 = (inst_119225.cljs$core$IFn$_invoke$arity$1 ? inst_119225.cljs$core$IFn$_invoke$arity$1(inst_119228) : inst_119225.call(null,inst_119228));
var inst_119230 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(inst_119149);
var inst_119231 = [(200),inst_119223,inst_119224,inst_119229,inst_119230];
var inst_119232 = cljs.core.PersistentHashMap.fromArrays(inst_119217,inst_119231);
var state_119255__$1 = state_119255;
var statearr_119301_119394 = state_119255__$1;
(statearr_119301_119394[(2)] = inst_119232);

(statearr_119301_119394[(1)] = (58));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (29))){
var inst_119138 = (state_119255[(16)]);
var state_119255__$1 = state_119255;
if(cljs.core.truth_(inst_119138)){
var statearr_119302_119395 = state_119255__$1;
(statearr_119302_119395[(1)] = (31));

} else {
var statearr_119303_119396 = state_119255__$1;
(statearr_119303_119396[(1)] = (32));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (44))){
var state_119255__$1 = state_119255;
var statearr_119304_119397 = state_119255__$1;
(statearr_119304_119397[(2)] = (1000000));

(statearr_119304_119397[(1)] = (45));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (6))){
var state_119255__$1 = state_119255;
var statearr_119305_119398 = state_119255__$1;
(statearr_119305_119398[(2)] = false);

(statearr_119305_119398[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (28))){
var inst_119135 = (state_119255[(25)]);
var state_119255__$1 = state_119255;
var statearr_119306_119399 = state_119255__$1;
(statearr_119306_119399[(2)] = inst_119135);

(statearr_119306_119399[(1)] = (30));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (64))){
var inst_119237 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
var statearr_119307_119400 = state_119255__$1;
(statearr_119307_119400[(2)] = inst_119237);

(statearr_119307_119400[(1)] = (58));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (51))){
var inst_119160 = (state_119255[(15)]);
var inst_119191 = (state_119255[(9)]);
var inst_119149 = (state_119255[(29)]);
var inst_119200 = (state_119255[(30)]);
var inst_119200__$1 = (state_119255[(2)]);
var inst_119201 = fluree.db.util.core.current_time_millis();
var inst_119202 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(inst_119160,cljs.core.cst$kw$fuel,inst_119200__$1,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$max_DASH_fuel,inst_119191], 0));
var inst_119203 = fluree.db.query.fql.query.cljs$core$IFn$_invoke$arity$3(inst_119149,query_map,inst_119202);
var state_119255__$1 = (function (){var statearr_119308 = state_119255;
(statearr_119308[(27)] = inst_119201);

(statearr_119308[(30)] = inst_119200__$1);

return statearr_119308;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119255__$1,(52),inst_119203);
} else {
if((state_val_119256 === (25))){
var inst_119136 = (state_119255[(22)]);
var state_119255__$1 = state_119255;
var statearr_119309_119401 = state_119255__$1;
(statearr_119309_119401[(2)] = inst_119136);

(statearr_119309_119401[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (34))){
var inst_119137 = (state_119255[(21)]);
var state_119255__$1 = state_119255;
if(cljs.core.truth_(inst_119137)){
var statearr_119310_119402 = state_119255__$1;
(statearr_119310_119402[(1)] = (37));

} else {
var statearr_119311_119403 = state_119255__$1;
(statearr_119311_119403[(1)] = (38));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (17))){
var inst_119133 = (state_119255[(23)]);
var inst_119149 = (state_119255[(29)]);
var inst_119149__$1 = (state_119255[(2)]);
var inst_119150 = cljs.core.cst$kw$conn.cljs$core$IFn$_invoke$arity$1(inst_119149__$1);
var state_119255__$1 = (function (){var statearr_119312 = state_119255;
(statearr_119312[(28)] = inst_119150);

(statearr_119312[(29)] = inst_119149__$1);

return statearr_119312;
})();
if(cljs.core.truth_(inst_119133)){
var statearr_119313_119404 = state_119255__$1;
(statearr_119313_119404[(1)] = (19));

} else {
var statearr_119314_119405 = state_119255__$1;
(statearr_119314_119405[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (3))){
var inst_119099 = (state_119255[(2)]);
var inst_119100 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_119099], 0));
var inst_119101 = cljs.core.ex_data(inst_119099);
var inst_119102 = cljs.core.ex_message(inst_119099);
var inst_119103 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_119101,cljs.core.cst$kw$message,inst_119102);
var state_119255__$1 = (function (){var statearr_119315 = state_119255;
(statearr_119315[(32)] = inst_119100);

return statearr_119315;
})();
var statearr_119316_119406 = state_119255__$1;
(statearr_119316_119406[(2)] = inst_119103);


cljs.core.async.impl.ioc_helpers.process_exception(state_119255__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (12))){
var state_119255__$1 = state_119255;
var statearr_119317_119407 = state_119255__$1;
(statearr_119317_119407[(2)] = query_map);

(statearr_119317_119407[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (2))){
var inst_119253 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
return cljs.core.async.impl.ioc_helpers.return_chan(state_119255__$1,inst_119253);
} else {
if((state_val_119256 === (66))){
var state_119255__$1 = state_119255;
var statearr_119318_119408 = state_119255__$1;
(statearr_119318_119408[(2)] = null);

(statearr_119318_119408[(1)] = (67));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (23))){
var inst_119136 = (state_119255[(22)]);
var state_119255__$1 = state_119255;
if(cljs.core.truth_(inst_119136)){
var statearr_119319_119409 = state_119255__$1;
(statearr_119319_119409[(1)] = (25));

} else {
var statearr_119320_119410 = state_119255__$1;
(statearr_119320_119410[(1)] = (26));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (47))){
var inst_119186 = (state_119255[(10)]);
var state_119255__$1 = state_119255;
var statearr_119321_119411 = state_119255__$1;
(statearr_119321_119411[(2)] = inst_119186);

(statearr_119321_119411[(1)] = (48));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (35))){
var inst_119176 = (state_119255[(8)]);
var state_119255__$1 = state_119255;
var statearr_119322_119412 = state_119255__$1;
(statearr_119322_119412[(2)] = inst_119176);

(statearr_119322_119412[(1)] = (36));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (19))){
var inst_119133 = (state_119255[(23)]);
var inst_119150 = (state_119255[(28)]);
var inst_119149 = (state_119255[(29)]);
var inst_119152 = cljs.core.cst$kw$network.cljs$core$IFn$_invoke$arity$1(inst_119149);
var inst_119153 = shared.connection_handler.open_api_QMARK_(inst_119150);
var inst_119154 = cljs.core.cst$kw$auth.cljs$core$IFn$_invoke$arity$1(inst_119149);
var inst_119155 = shared.fdb.get_sources(inst_119150,inst_119152,inst_119153,inst_119154,inst_119133,db_fn);
var state_119255__$1 = state_119255;
var statearr_119323_119413 = state_119255__$1;
(statearr_119323_119413[(2)] = inst_119155);

(statearr_119323_119413[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (57))){
var state_119255__$1 = state_119255;
var statearr_119324_119414 = state_119255__$1;
(statearr_119324_119414[(1)] = (62));



return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (11))){
var inst_119125 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,query_map);
var state_119255__$1 = state_119255;
var statearr_119326_119415 = state_119255__$1;
(statearr_119326_119415[(2)] = inst_119125);

(statearr_119326_119415[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (9))){
var state_119255__$1 = state_119255;
var statearr_119327_119416 = state_119255__$1;
(statearr_119327_119416[(2)] = false);

(statearr_119327_119416[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (5))){
var inst_119112 = query_map.cljs$lang$protocol_mask$partition0$;
var inst_119113 = (inst_119112 & (64));
var inst_119114 = query_map.cljs$core$ISeq$;
var inst_119115 = (cljs.core.PROTOCOL_SENTINEL === inst_119114);
var inst_119116 = ((inst_119113) || (inst_119115));
var state_119255__$1 = state_119255;
if(cljs.core.truth_(inst_119116)){
var statearr_119328_119417 = state_119255__$1;
(statearr_119328_119417[(1)] = (8));

} else {
var statearr_119329_119418 = state_119255__$1;
(statearr_119329_119418[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (14))){
var inst_119131 = (state_119255[(12)]);
var inst_119140 = (state_119255[(2)]);
var inst_119141 = fluree.db.util.async.throw_err(inst_119140);
var state_119255__$1 = (function (){var statearr_119330 = state_119255;
(statearr_119330[(11)] = inst_119141);

return statearr_119330;
})();
if(cljs.core.truth_(inst_119131)){
var statearr_119331_119419 = state_119255__$1;
(statearr_119331_119419[(1)] = (15));

} else {
var statearr_119332_119420 = state_119255__$1;
(statearr_119332_119420[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (45))){
var inst_119191 = (state_119255[(9)]);
var inst_119191__$1 = (state_119255[(2)]);
var state_119255__$1 = (function (){var statearr_119333 = state_119255;
(statearr_119333[(9)] = inst_119191__$1);

return statearr_119333;
})();
if(cljs.core.truth_(inst_119191__$1)){
var statearr_119334_119421 = state_119255__$1;
(statearr_119334_119421[(1)] = (46));

} else {
var statearr_119335_119422 = state_119255__$1;
(statearr_119335_119422[(1)] = (47));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (53))){
var inst_119206 = (state_119255[(7)]);
var inst_119209 = cljs.core.ex_data(inst_119206);
var inst_119210 = [cljs.core.cst$kw$status,cljs.core.cst$kw$message,cljs.core.cst$kw$error];
var inst_119211 = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(inst_119209);
var inst_119212 = cljs.core.ex_message(inst_119206);
var inst_119213 = [inst_119211,inst_119212,cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_119214 = cljs.core.PersistentHashMap.fromArrays(inst_119210,inst_119213);
var state_119255__$1 = state_119255;
var statearr_119336_119423 = state_119255__$1;
(statearr_119336_119423[(2)] = inst_119214);

(statearr_119336_119423[(1)] = (55));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (26))){
var inst_119135 = (state_119255[(25)]);
var state_119255__$1 = state_119255;
if(cljs.core.truth_(inst_119135)){
var statearr_119337_119424 = state_119255__$1;
(statearr_119337_119424[(1)] = (28));

} else {
var statearr_119338_119425 = state_119255__$1;
(statearr_119338_119425[(1)] = (29));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (16))){
var inst_119141 = (state_119255[(11)]);
var state_119255__$1 = state_119255;
var statearr_119339_119426 = state_119255__$1;
(statearr_119339_119426[(2)] = inst_119141);

(statearr_119339_119426[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (38))){
var inst_119132 = (state_119255[(26)]);
var state_119255__$1 = state_119255;
var statearr_119340_119427 = state_119255__$1;
(statearr_119340_119427[(2)] = inst_119132);

(statearr_119340_119427[(1)] = (39));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (30))){
var inst_119172 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
var statearr_119341_119428 = state_119255__$1;
(statearr_119341_119428[(2)] = inst_119172);

(statearr_119341_119428[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (10))){
var inst_119120 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
var statearr_119342_119429 = state_119255__$1;
(statearr_119342_119429[(2)] = inst_119120);

(statearr_119342_119429[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (18))){
var inst_119145 = (state_119255[(2)]);
var inst_119146 = fluree.db.util.async.throw_err(inst_119145);
var state_119255__$1 = state_119255;
var statearr_119343_119430 = state_119255__$1;
(statearr_119343_119430[(2)] = inst_119146);

(statearr_119343_119430[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (52))){
var inst_119206 = (state_119255[(7)]);
var inst_119207 = (state_119255[(31)]);
var inst_119205 = (state_119255[(2)]);
var inst_119206__$1 = fluree.db.util.async.throw_err(inst_119205);
var inst_119207__$1 = (inst_119206__$1 instanceof cljs.core.ExceptionInfo);
var state_119255__$1 = (function (){var statearr_119344 = state_119255;
(statearr_119344[(7)] = inst_119206__$1);

(statearr_119344[(31)] = inst_119207__$1);

return statearr_119344;
})();
if(cljs.core.truth_(inst_119207__$1)){
var statearr_119345_119431 = state_119255__$1;
(statearr_119345_119431[(1)] = (53));

} else {
var statearr_119346_119432 = state_119255__$1;
(statearr_119346_119432[(1)] = (54));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (67))){
var inst_119249 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
var statearr_119347_119433 = state_119255__$1;
(statearr_119347_119433[(2)] = inst_119249);

(statearr_119347_119433[(1)] = (42));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (42))){
var inst_119251 = (state_119255[(2)]);
var state_119255__$1 = state_119255;
var statearr_119348_119434 = state_119255__$1;
(statearr_119348_119434[(2)] = inst_119251);


cljs.core.async.impl.ioc_helpers.process_exception(state_119255__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (37))){
var inst_119137 = (state_119255[(21)]);
var state_119255__$1 = state_119255;
var statearr_119349_119435 = state_119255__$1;
(statearr_119349_119435[(2)] = inst_119137);

(statearr_119349_119435[(1)] = (39));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (63))){
var state_119255__$1 = state_119255;
var statearr_119350_119436 = state_119255__$1;
(statearr_119350_119436[(2)] = null);

(statearr_119350_119436[(1)] = (64));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (8))){
var state_119255__$1 = state_119255;
var statearr_119351_119437 = state_119255__$1;
(statearr_119351_119437[(2)] = true);

(statearr_119351_119437[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119256 === (49))){
var inst_119197 = cljs.core.volatile_BANG_((0));
var state_119255__$1 = state_119255;
var statearr_119352_119438 = state_119255__$1;
(statearr_119352_119438[(2)] = inst_119197);

(statearr_119352_119438[(1)] = (51));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$fdb$state_machine__99703__auto__ = null;
var shared$fdb$state_machine__99703__auto____0 = (function (){
var statearr_119353 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_119353[(0)] = shared$fdb$state_machine__99703__auto__);

(statearr_119353[(1)] = (1));

return statearr_119353;
});
var shared$fdb$state_machine__99703__auto____1 = (function (state_119255){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_119255);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e119354){if((e119354 instanceof Object)){
var ex__99706__auto__ = e119354;
var statearr_119355_119439 = state_119255;
(statearr_119355_119439[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_119255);

return cljs.core.cst$kw$recur;
} else {
throw e119354;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__119440 = state_119255;
state_119255 = G__119440;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$state_machine__99703__auto__ = function(state_119255){
switch(arguments.length){
case 0:
return shared$fdb$state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$state_machine__99703__auto____1.call(this,state_119255);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$state_machine__99703__auto____0;
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$state_machine__99703__auto____1;
return shared$fdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_119356 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_119356[(6)] = c__99809__auto__);

return statearr_119356;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

shared.fdb.query_async.cljs$lang$maxFixedArity = 4;

/**
 * Monitors a database for a specific transaction id included in a block.
 * 
 *   Returns a core async channel that will eventually contain a response,
 *   or will close after the timeout has expired.
 * 
 *   Response may contain an exception, if the tx resulted in an exception.
 */
shared.fdb.monitor_tx = (function shared$fdb$monitor_tx(conn,ledger,tid,timeout_ms){
if(cljs.core.int_QMARK_(timeout_ms)){
} else {
throw (new Error(["Assert failed: ","monitor-tx requires timeout to be provided in milliseconds as an integer.","\n","(int? timeout-ms)"].join('')));
}

var session = fluree.db.session.session.cljs$core$IFn$_invoke$arity$2(conn,ledger);
var key = cljs.core.random_uuid();
var resp_chan = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();
var timeout_chan = cljs.core.async.timeout(timeout_ms);
fluree.db.session.monitor_tx(session,tid,key,((function (session,key,resp_chan,timeout_chan){
return (function (p1__119441_SHARP_){
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(resp_chan,p1__119441_SHARP_);
});})(session,key,resp_chan,timeout_chan))
);

var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,session,key,resp_chan,timeout_chan){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,session,key,resp_chan,timeout_chan){
return (function (state_119463){
var state_val_119464 = (state_119463[(1)]);
if((state_val_119464 === (1))){
var inst_119445 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_119446 = [resp_chan,timeout_chan];
var inst_119447 = (new cljs.core.PersistentVector(null,2,(5),inst_119445,inst_119446,null));
var state_119463__$1 = state_119463;
return cljs.core.async.ioc_alts_BANG_(state_119463__$1,(2),inst_119447);
} else {
if((state_val_119464 === (2))){
var inst_119449 = (state_119463[(2)]);
var inst_119450 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_119449,(0),null);
var inst_119451 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_119449,(1),null);
var inst_119452 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(timeout_chan,inst_119451);
var state_119463__$1 = (function (){var statearr_119465 = state_119463;
(statearr_119465[(7)] = inst_119450);

return statearr_119465;
})();
if(inst_119452){
var statearr_119466_119475 = state_119463__$1;
(statearr_119466_119475[(1)] = (3));

} else {
var statearr_119467_119476 = state_119463__$1;
(statearr_119467_119476[(1)] = (4));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119464 === (3))){
var inst_119454 = fluree.db.session.monitor_tx_remove(session,tid,key);
var inst_119455 = [cljs.core.cst$kw$txid,cljs.core.cst$kw$status,cljs.core.cst$kw$message];
var inst_119456 = ["Timeout of ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(timeout_ms)," ms for reached without transaction being included in new block. Transaction is still being processed. To view transaction results, issue: {\"select\": [\"*\"], \"from\": [\"_tx/id\", \"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(tid),"\" ]}"].join('');
var inst_119457 = [tid,(408),inst_119456];
var inst_119458 = cljs.core.PersistentHashMap.fromArrays(inst_119455,inst_119457);
var state_119463__$1 = (function (){var statearr_119468 = state_119463;
(statearr_119468[(8)] = inst_119454);

return statearr_119468;
})();
var statearr_119469_119477 = state_119463__$1;
(statearr_119469_119477[(2)] = inst_119458);

(statearr_119469_119477[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119464 === (4))){
var inst_119450 = (state_119463[(7)]);
var state_119463__$1 = state_119463;
var statearr_119470_119478 = state_119463__$1;
(statearr_119470_119478[(2)] = inst_119450);

(statearr_119470_119478[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119464 === (5))){
var inst_119461 = (state_119463[(2)]);
var state_119463__$1 = state_119463;
return cljs.core.async.impl.ioc_helpers.return_chan(state_119463__$1,inst_119461);
} else {
return null;
}
}
}
}
}
});})(c__99809__auto__,session,key,resp_chan,timeout_chan))
;
return ((function (switch__99702__auto__,c__99809__auto__,session,key,resp_chan,timeout_chan){
return (function() {
var shared$fdb$monitor_tx_$_state_machine__99703__auto__ = null;
var shared$fdb$monitor_tx_$_state_machine__99703__auto____0 = (function (){
var statearr_119471 = [null,null,null,null,null,null,null,null,null];
(statearr_119471[(0)] = shared$fdb$monitor_tx_$_state_machine__99703__auto__);

(statearr_119471[(1)] = (1));

return statearr_119471;
});
var shared$fdb$monitor_tx_$_state_machine__99703__auto____1 = (function (state_119463){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_119463);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e119472){if((e119472 instanceof Object)){
var ex__99706__auto__ = e119472;
var statearr_119473_119479 = state_119463;
(statearr_119473_119479[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_119463);

return cljs.core.cst$kw$recur;
} else {
throw e119472;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__119480 = state_119463;
state_119463 = G__119480;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$monitor_tx_$_state_machine__99703__auto__ = function(state_119463){
switch(arguments.length){
case 0:
return shared$fdb$monitor_tx_$_state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$monitor_tx_$_state_machine__99703__auto____1.call(this,state_119463);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$monitor_tx_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$monitor_tx_$_state_machine__99703__auto____0;
shared$fdb$monitor_tx_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$monitor_tx_$_state_machine__99703__auto____1;
return shared$fdb$monitor_tx_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,session,key,resp_chan,timeout_chan))
})();
var state__99811__auto__ = (function (){var statearr_119474 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_119474[(6)] = c__99809__auto__);

return statearr_119474;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,session,key,resp_chan,timeout_chan))
);

return c__99809__auto__;
});
/**
 * Helper function to fill out the parts of the transaction that are incomplete,
 *   producing a signed command.
 * 
 *   Optional opts is a map with the following keys. If not provided,
 *   defaults will be attempted.
 *   - auth        - The auth id for the auth record being used. The private key must
 *                correspond to this auth record, or an authority of this auth record.
 *   - expire      - When this transaction should expire if not yet attempted.
 *                Defaults to 5 minutes.
 *   - nonce       - Any long/64-bit integer value that will make this transaction unique.
 *                By default epoch milliseconds is used.
 *   - deps        - Not yet implemented, list of dependent transactions.
 * 
 *   If successful, will return a map with four keys:
 *  - cmd  - a map with the command/transaction data as a JSON string
 *  - sig  - the signature of the above stringified map
 *  - id   - the ID for this unique request - in case you want to look it up later, sha3 of 'cmd'
 *  - db   - the ledger for this transaction
 */
shared.fdb.tx__GT_command = (function shared$fdb$tx__GT_command(var_args){
var G__119482 = arguments.length;
switch (G__119482) {
case 3:
return shared.fdb.tx__GT_command.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return shared.fdb.tx__GT_command.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.fdb.tx__GT_command.cljs$core$IFn$_invoke$arity$3 = (function (ledger,txn,private_key){
return shared.fdb.tx__GT_command.cljs$core$IFn$_invoke$arity$4(ledger,txn,private_key,null);
});

shared.fdb.tx__GT_command.cljs$core$IFn$_invoke$arity$4 = (function (ledger,txn,private_key,opts){
if(cljs.core.truth_(private_key)){
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Private key not provided and no default present on connection",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_transaction], null));
}

var db_name = ((cljs.core.sequential_QMARK_(ledger))?[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.first(ledger)),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.second(ledger))].join(''):ledger);
var map__119483 = opts;
var map__119483__$1 = (((((!((map__119483 == null))))?(((((map__119483.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__119483.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__119483):map__119483);
var auth = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__119483__$1,cljs.core.cst$kw$auth);
var expire = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__119483__$1,cljs.core.cst$kw$expire);
var nonce = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__119483__$1,cljs.core.cst$kw$nonce);
var deps = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__119483__$1,cljs.core.cst$kw$deps);
var _ = (cljs.core.truth_(deps)?((cljs.core.sequential_QMARK_(deps))?null:(function(){throw (new Error(["Assert failed: ","Command/transaction 'deps', when provided, must be a sequential list/array.","\n","(sequential? deps)"].join('')))})()):null);
var key_auth_id = fluree.crypto.account_id_from_private(private_key);
var vec__119484 = (cljs.core.truth_((function (){var and__4120__auto__ = auth;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(auth,key_auth_id);
} else {
return and__4120__auto__;
}
})())?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [auth,key_auth_id], null):(cljs.core.truth_(auth)?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [auth,null], null):new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [key_auth_id,null], null)
));
var auth__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__119484,(0),null);
var authority = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__119484,(1),null);
var timestamp = fluree.db.util.core.current_time_millis();
var nonce__$1 = (function (){var or__4131__auto__ = nonce;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return timestamp;
}
})();
var expire__$1 = (function (){var or__4131__auto__ = expire;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (timestamp + (30000));
}
})();
var cmd = (function (){try{return fluree.db.util.json.stringify(fluree.db.util.core.without_nils(new cljs.core.PersistentArrayMap(null, 8, [cljs.core.cst$kw$type,cljs.core.cst$kw$tx,cljs.core.cst$kw$db,db_name,cljs.core.cst$kw$tx,txn,cljs.core.cst$kw$nonce,nonce__$1,cljs.core.cst$kw$auth,auth__$1,cljs.core.cst$kw$authority,authority,cljs.core.cst$kw$expire,expire__$1,cljs.core.cst$kw$deps,deps], null)));
}catch (e119488){var e = e119488;

throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Transaction contains data that cannot be serialized into JSON.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_tx], null));
}})();
var sig = fluree.crypto.sign_message(cmd,private_key);
var id = fluree.crypto.sha3_256.cljs$core$IFn$_invoke$arity$1(cmd);
return new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$cmd,cmd,cljs.core.cst$kw$sig,sig,cljs.core.cst$kw$id,id,cljs.core.cst$kw$db,ledger], null);
});

shared.fdb.tx__GT_command.cljs$lang$maxFixedArity = 4;

shared.fdb.transact_async = (function shared$fdb$transact_async(var_args){
var G__119491 = arguments.length;
switch (G__119491) {
case 3:
return shared.fdb.transact_async.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return shared.fdb.transact_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.fdb.transact_async.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,txn){
return shared.fdb.transact_async.cljs$core$IFn$_invoke$arity$4(conn,ledger,txn,null);
});

shared.fdb.transact_async.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,txn,opts){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_119572){
var state_val_119573 = (state_119572[(1)]);
if((state_val_119573 === (7))){
var inst_119516 = (state_119572[(2)]);
var state_119572__$1 = state_119572;
if(cljs.core.truth_(inst_119516)){
var statearr_119574_119615 = state_119572__$1;
(statearr_119574_119615[(1)] = (11));

} else {
var statearr_119575_119616 = state_119572__$1;
(statearr_119575_119616[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (20))){
var inst_119538 = (state_119572[(2)]);
var state_119572__$1 = state_119572;
var statearr_119576_119617 = state_119572__$1;
(statearr_119576_119617[(2)] = inst_119538);

(statearr_119576_119617[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (27))){
var inst_119553 = (state_119572[(7)]);
var state_119572__$1 = state_119572;
var statearr_119577_119618 = state_119572__$1;
(statearr_119577_119618[(2)] = inst_119553);

(statearr_119577_119618[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (1))){
var state_119572__$1 = state_119572;
var statearr_119578_119619 = state_119572__$1;
(statearr_119578_119619[(2)] = null);

(statearr_119578_119619[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (24))){
var inst_119566 = (state_119572[(2)]);
var state_119572__$1 = state_119572;
var statearr_119579_119620 = state_119572__$1;
(statearr_119579_119620[(2)] = inst_119566);

(statearr_119579_119620[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_119572,(3),cljs.core.cst$kw$default,null,(2));
var inst_119502 = (opts == null);
var inst_119503 = cljs.core.not(inst_119502);
var state_119572__$1 = state_119572;
if(inst_119503){
var statearr_119580_119621 = state_119572__$1;
(statearr_119580_119621[(1)] = (5));

} else {
var statearr_119581_119622 = state_119572__$1;
(statearr_119581_119622[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (15))){
var inst_119525 = (state_119572[(8)]);
var inst_119527 = (state_119572[(9)]);
var inst_119529 = (state_119572[(10)]);
var inst_119528 = (state_119572[(11)]);
var inst_119542 = [cljs.core.cst$kw$db,cljs.core.cst$kw$tx,cljs.core.cst$kw$auth,cljs.core.cst$kw$nonce,cljs.core.cst$kw$deps,cljs.core.cst$kw$expire];
var inst_119543 = [ledger,txn,inst_119525,inst_119527,inst_119528,inst_119529];
var inst_119544 = cljs.core.PersistentHashMap.fromArrays(inst_119542,inst_119543);
var inst_119545 = fluree.db.util.core.without_nils(inst_119544);
var inst_119546 = fluree.db.operations.transact_async(conn,inst_119545);
var state_119572__$1 = state_119572;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119572__$1,(21),inst_119546);
} else {
if((state_val_119573 === (21))){
var inst_119523 = (state_119572[(12)]);
var inst_119548 = (state_119572[(2)]);
var state_119572__$1 = (function (){var statearr_119582 = state_119572;
(statearr_119582[(13)] = inst_119548);

return statearr_119582;
})();
if(cljs.core.truth_(inst_119523)){
var statearr_119583_119623 = state_119572__$1;
(statearr_119583_119623[(1)] = (22));

} else {
var statearr_119584_119624 = state_119572__$1;
(statearr_119584_119624[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (13))){
var inst_119522 = (state_119572[(14)]);
var inst_119521 = (state_119572[(2)]);
var inst_119522__$1 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119521,cljs.core.cst$kw$private_DASH_key);
var inst_119523 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119521,cljs.core.cst$kw$txid_DASH_only);
var inst_119524 = cljs.core.get.cljs$core$IFn$_invoke$arity$3(inst_119521,cljs.core.cst$kw$timeout,(60000));
var inst_119525 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119521,cljs.core.cst$kw$auth);
var inst_119526 = fluree.db.util.core.current_time_millis();
var inst_119527 = cljs.core.get.cljs$core$IFn$_invoke$arity$3(inst_119521,cljs.core.cst$kw$nonce,inst_119526);
var inst_119528 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119521,cljs.core.cst$kw$deps);
var inst_119529 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119521,cljs.core.cst$kw$expire);
var state_119572__$1 = (function (){var statearr_119585 = state_119572;
(statearr_119585[(12)] = inst_119523);

(statearr_119585[(8)] = inst_119525);

(statearr_119585[(9)] = inst_119527);

(statearr_119585[(10)] = inst_119529);

(statearr_119585[(15)] = inst_119524);

(statearr_119585[(14)] = inst_119522__$1);

(statearr_119585[(11)] = inst_119528);

return statearr_119585;
})();
if(cljs.core.truth_(inst_119522__$1)){
var statearr_119586_119625 = state_119572__$1;
(statearr_119586_119625[(1)] = (14));

} else {
var statearr_119587_119626 = state_119572__$1;
(statearr_119587_119626[(1)] = (15));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (22))){
var inst_119548 = (state_119572[(13)]);
var state_119572__$1 = state_119572;
var statearr_119588_119627 = state_119572__$1;
(statearr_119588_119627[(2)] = inst_119548);

(statearr_119588_119627[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (6))){
var state_119572__$1 = state_119572;
var statearr_119589_119628 = state_119572__$1;
(statearr_119589_119628[(2)] = false);

(statearr_119589_119628[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (28))){
var inst_119564 = (state_119572[(2)]);
var state_119572__$1 = state_119572;
var statearr_119590_119629 = state_119572__$1;
(statearr_119590_119629[(2)] = inst_119564);

(statearr_119590_119629[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (25))){
var inst_119553 = (state_119572[(7)]);
var inst_119553__$1 = (state_119572[(2)]);
var inst_119554 = (inst_119553__$1 instanceof cljs.core.ExceptionInfo);
var state_119572__$1 = (function (){var statearr_119591 = state_119572;
(statearr_119591[(7)] = inst_119553__$1);

return statearr_119591;
})();
if(cljs.core.truth_(inst_119554)){
var statearr_119592_119630 = state_119572__$1;
(statearr_119592_119630[(1)] = (26));

} else {
var statearr_119593_119631 = state_119572__$1;
(statearr_119593_119631[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (17))){
var inst_119533 = (state_119572[(16)]);
var state_119572__$1 = state_119572;
var statearr_119594_119632 = state_119572__$1;
(statearr_119594_119632[(2)] = inst_119533);

(statearr_119594_119632[(1)] = (19));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (3))){
var inst_119492 = (state_119572[(2)]);
var inst_119493 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_119492], 0));
var inst_119494 = cljs.core.ex_data(inst_119492);
var inst_119495 = cljs.core.ex_message(inst_119492);
var inst_119496 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_119494,cljs.core.cst$kw$message,inst_119495);
var state_119572__$1 = (function (){var statearr_119595 = state_119572;
(statearr_119595[(17)] = inst_119493);

return statearr_119595;
})();
var statearr_119596_119633 = state_119572__$1;
(statearr_119596_119633[(2)] = inst_119496);


cljs.core.async.impl.ioc_helpers.process_exception(state_119572__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (12))){
var state_119572__$1 = state_119572;
var statearr_119597_119634 = state_119572__$1;
(statearr_119597_119634[(2)] = opts);

(statearr_119597_119634[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (2))){
var inst_119570 = (state_119572[(2)]);
var state_119572__$1 = state_119572;
return cljs.core.async.impl.ioc_helpers.return_chan(state_119572__$1,inst_119570);
} else {
if((state_val_119573 === (23))){
var inst_119524 = (state_119572[(15)]);
var inst_119548 = (state_119572[(13)]);
var inst_119551 = shared.fdb.monitor_tx(conn,ledger,inst_119548,inst_119524);
var state_119572__$1 = state_119572;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119572__$1,(25),inst_119551);
} else {
if((state_val_119573 === (19))){
var inst_119540 = (state_119572[(2)]);
var state_119572__$1 = state_119572;
var statearr_119598_119635 = state_119572__$1;
(statearr_119598_119635[(2)] = inst_119540);

(statearr_119598_119635[(1)] = (16));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (11))){
var inst_119518 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,opts);
var state_119572__$1 = state_119572;
var statearr_119599_119636 = state_119572__$1;
(statearr_119599_119636[(2)] = inst_119518);

(statearr_119599_119636[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (9))){
var state_119572__$1 = state_119572;
var statearr_119600_119637 = state_119572__$1;
(statearr_119600_119637[(2)] = false);

(statearr_119600_119637[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (5))){
var inst_119505 = opts.cljs$lang$protocol_mask$partition0$;
var inst_119506 = (inst_119505 & (64));
var inst_119507 = opts.cljs$core$ISeq$;
var inst_119508 = (cljs.core.PROTOCOL_SENTINEL === inst_119507);
var inst_119509 = ((inst_119506) || (inst_119508));
var state_119572__$1 = state_119572;
if(cljs.core.truth_(inst_119509)){
var statearr_119601_119638 = state_119572__$1;
(statearr_119601_119638[(1)] = (8));

} else {
var statearr_119602_119639 = state_119572__$1;
(statearr_119602_119639[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (14))){
var inst_119523 = (state_119572[(12)]);
var inst_119522 = (state_119572[(14)]);
var inst_119531 = shared.fdb.tx__GT_command.cljs$core$IFn$_invoke$arity$4(ledger,txn,inst_119522,opts);
var inst_119532 = cljs.core.cst$kw$id.cljs$core$IFn$_invoke$arity$1(inst_119531);
var inst_119533 = fluree.db.operations.command_async(conn,inst_119531);
var state_119572__$1 = (function (){var statearr_119603 = state_119572;
(statearr_119603[(16)] = inst_119533);

(statearr_119603[(18)] = inst_119532);

return statearr_119603;
})();
if(cljs.core.truth_(inst_119523)){
var statearr_119604_119640 = state_119572__$1;
(statearr_119604_119640[(1)] = (17));

} else {
var statearr_119605_119641 = state_119572__$1;
(statearr_119605_119641[(1)] = (18));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (26))){
var inst_119553 = (state_119572[(7)]);
var inst_119556 = cljs.core.ex_data(inst_119553);
var inst_119557 = [cljs.core.cst$kw$status,cljs.core.cst$kw$message,cljs.core.cst$kw$error];
var inst_119558 = cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(inst_119556);
var inst_119559 = cljs.core.ex_message(inst_119553);
var inst_119560 = [inst_119558,inst_119559,cljs.core.cst$kw$db_SLASH_invalid_DASH_tx];
var inst_119561 = cljs.core.PersistentHashMap.fromArrays(inst_119557,inst_119560);
var state_119572__$1 = state_119572;
var statearr_119606_119642 = state_119572__$1;
(statearr_119606_119642[(2)] = inst_119561);

(statearr_119606_119642[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (16))){
var inst_119568 = (state_119572[(2)]);
var state_119572__$1 = state_119572;
var statearr_119607_119643 = state_119572__$1;
(statearr_119607_119643[(2)] = inst_119568);


cljs.core.async.impl.ioc_helpers.process_exception(state_119572__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (10))){
var inst_119513 = (state_119572[(2)]);
var state_119572__$1 = state_119572;
var statearr_119608_119644 = state_119572__$1;
(statearr_119608_119644[(2)] = inst_119513);

(statearr_119608_119644[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119573 === (18))){
var inst_119524 = (state_119572[(15)]);
var inst_119532 = (state_119572[(18)]);
var inst_119536 = shared.fdb.monitor_tx(conn,ledger,inst_119532,inst_119524);
var state_119572__$1 = state_119572;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119572__$1,(20),inst_119536);
} else {
if((state_val_119573 === (8))){
var state_119572__$1 = state_119572;
var statearr_119609_119645 = state_119572__$1;
(statearr_119609_119645[(2)] = true);

(statearr_119609_119645[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$fdb$state_machine__99703__auto__ = null;
var shared$fdb$state_machine__99703__auto____0 = (function (){
var statearr_119610 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_119610[(0)] = shared$fdb$state_machine__99703__auto__);

(statearr_119610[(1)] = (1));

return statearr_119610;
});
var shared$fdb$state_machine__99703__auto____1 = (function (state_119572){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_119572);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e119611){if((e119611 instanceof Object)){
var ex__99706__auto__ = e119611;
var statearr_119612_119646 = state_119572;
(statearr_119612_119646[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_119572);

return cljs.core.cst$kw$recur;
} else {
throw e119611;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__119647 = state_119572;
state_119572 = G__119647;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$state_machine__99703__auto__ = function(state_119572){
switch(arguments.length){
case 0:
return shared$fdb$state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$state_machine__99703__auto____1.call(this,state_119572);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$state_machine__99703__auto____0;
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$state_machine__99703__auto____1;
return shared$fdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_119613 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_119613[(6)] = c__99809__auto__);

return statearr_119613;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

shared.fdb.transact_async.cljs$lang$maxFixedArity = 4;

shared.fdb.min_safe = (function shared$fdb$min_safe(var_args){
var args__4736__auto__ = [];
var len__4730__auto___119649 = arguments.length;
var i__4731__auto___119650 = (0);
while(true){
if((i__4731__auto___119650 < len__4730__auto___119649)){
args__4736__auto__.push((arguments[i__4731__auto___119650]));

var G__119651 = (i__4731__auto___119650 + (1));
i__4731__auto___119650 = G__119651;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((0) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((0)),(0),null)):null);
return shared.fdb.min_safe.cljs$core$IFn$_invoke$arity$variadic(argseq__4737__auto__);
});

shared.fdb.min_safe.cljs$core$IFn$_invoke$arity$variadic = (function (args){
return cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.min,cljs.core.remove.cljs$core$IFn$_invoke$arity$2(cljs.core.nil_QMARK_,args));
});

shared.fdb.min_safe.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
shared.fdb.min_safe.cljs$lang$applyTo = (function (seq119648){
var self__4718__auto__ = this;
return self__4718__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq(seq119648));
});

shared.fdb.format_flake_groups_pretty = (function shared$fdb$format_flake_groups_pretty(db,cache,fuel,flakes){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_119682){
var state_val_119683 = (state_119682[(1)]);
if((state_val_119683 === (1))){
var inst_119652 = cljs.core.first(flakes);
var inst_119653 = cljs.core.rest(flakes);
var inst_119654 = cljs.core.PersistentVector.EMPTY;
var inst_119655 = inst_119652;
var inst_119656 = inst_119653;
var inst_119657 = inst_119654;
var state_119682__$1 = (function (){var statearr_119684 = state_119682;
(statearr_119684[(7)] = inst_119656);

(statearr_119684[(8)] = inst_119657);

(statearr_119684[(9)] = inst_119655);

return statearr_119684;
})();
var statearr_119685_119697 = state_119682__$1;
(statearr_119685_119697[(2)] = null);

(statearr_119685_119697[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119683 === (2))){
var inst_119655 = (state_119682[(9)]);
var inst_119659 = [cljs.core.cst$kw$wildcard_QMARK_,cljs.core.cst$kw$select];
var inst_119660 = cljs.core.PersistentHashMap.EMPTY;
var inst_119661 = [true,inst_119660];
var inst_119662 = cljs.core.PersistentHashMap.fromArrays(inst_119659,inst_119661);
var inst_119663 = fluree.db.query.fql.flakes__GT_res(db,cache,fuel,(1000000),inst_119662,inst_119655);
var state_119682__$1 = state_119682;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119682__$1,(4),inst_119663);
} else {
if((state_val_119683 === (3))){
var inst_119680 = (state_119682[(2)]);
var state_119682__$1 = state_119682;
return cljs.core.async.impl.ioc_helpers.return_chan(state_119682__$1,inst_119680);
} else {
if((state_val_119683 === (4))){
var inst_119656 = (state_119682[(7)]);
var inst_119657 = (state_119682[(8)]);
var inst_119665 = (state_119682[(2)]);
var inst_119666 = fluree.db.util.async.throw_err(inst_119665);
var inst_119667 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_119668 = [inst_119666];
var inst_119669 = (new cljs.core.PersistentVector(null,1,(5),inst_119667,inst_119668,null));
var inst_119670 = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(inst_119657,inst_119669);
var inst_119671 = cljs.core.first(inst_119656);
var state_119682__$1 = (function (){var statearr_119686 = state_119682;
(statearr_119686[(10)] = inst_119670);

return statearr_119686;
})();
if(cljs.core.truth_(inst_119671)){
var statearr_119687_119698 = state_119682__$1;
(statearr_119687_119698[(1)] = (5));

} else {
var statearr_119688_119699 = state_119682__$1;
(statearr_119688_119699[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119683 === (5))){
var inst_119656 = (state_119682[(7)]);
var inst_119670 = (state_119682[(10)]);
var inst_119673 = cljs.core.first(inst_119656);
var inst_119674 = cljs.core.rest(inst_119656);
var inst_119655 = inst_119673;
var inst_119656__$1 = inst_119674;
var inst_119657 = inst_119670;
var state_119682__$1 = (function (){var statearr_119689 = state_119682;
(statearr_119689[(7)] = inst_119656__$1);

(statearr_119689[(8)] = inst_119657);

(statearr_119689[(9)] = inst_119655);

return statearr_119689;
})();
var statearr_119690_119700 = state_119682__$1;
(statearr_119690_119700[(2)] = null);

(statearr_119690_119700[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119683 === (6))){
var inst_119670 = (state_119682[(10)]);
var state_119682__$1 = state_119682;
var statearr_119691_119701 = state_119682__$1;
(statearr_119691_119701[(2)] = inst_119670);

(statearr_119691_119701[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119683 === (7))){
var inst_119678 = (state_119682[(2)]);
var state_119682__$1 = state_119682;
var statearr_119692_119702 = state_119682__$1;
(statearr_119692_119702[(2)] = inst_119678);

(statearr_119692_119702[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto__ = null;
var shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto____0 = (function (){
var statearr_119693 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_119693[(0)] = shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto__);

(statearr_119693[(1)] = (1));

return statearr_119693;
});
var shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto____1 = (function (state_119682){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_119682);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e119694){if((e119694 instanceof Object)){
var ex__99706__auto__ = e119694;
var statearr_119695_119703 = state_119682;
(statearr_119695_119703[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_119682);

return cljs.core.cst$kw$recur;
} else {
throw e119694;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__119704 = state_119682;
state_119682 = G__119704;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto__ = function(state_119682){
switch(arguments.length){
case 0:
return shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto____1.call(this,state_119682);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto____0;
shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto____1;
return shared$fdb$format_flake_groups_pretty_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_119696 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_119696[(6)] = c__99809__auto__);

return statearr_119696;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
shared.fdb.format_block_resp_pretty = (function shared$fdb$format_block_resp_pretty(db,resp){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_119772){
var state_val_119773 = (state_119772[(1)]);
if((state_val_119773 === (7))){
var inst_119732 = (state_119772[(2)]);
var inst_119733 = fluree.db.util.async.throw_err(inst_119732);
var state_119772__$1 = state_119772;
var statearr_119774_119799 = state_119772__$1;
(statearr_119774_119799[(2)] = inst_119733);

(statearr_119774_119799[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (1))){
var inst_119709 = cljs.core.volatile_BANG_((0));
var inst_119710 = cljs.core.PersistentHashMap.EMPTY;
var inst_119711 = cljs.core.volatile_BANG_(inst_119710);
var inst_119712 = cljs.core.first(resp);
var inst_119713 = cljs.core.rest(resp);
var inst_119714 = cljs.core.PersistentVector.EMPTY;
var inst_119715 = inst_119709;
var inst_119716 = inst_119711;
var inst_119717 = inst_119712;
var inst_119718 = inst_119713;
var inst_119719 = inst_119714;
var state_119772__$1 = (function (){var statearr_119775 = state_119772;
(statearr_119775[(7)] = inst_119719);

(statearr_119775[(8)] = inst_119718);

(statearr_119775[(9)] = inst_119716);

(statearr_119775[(10)] = inst_119715);

(statearr_119775[(11)] = inst_119717);

return statearr_119775;
})();
var statearr_119776_119800 = state_119772__$1;
(statearr_119776_119800[(2)] = null);

(statearr_119776_119800[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (4))){
var inst_119719 = (state_119772[(7)]);
var inst_119718 = (state_119772[(8)]);
var inst_119716 = (state_119772[(9)]);
var inst_119715 = (state_119772[(10)]);
var inst_119717 = (state_119772[(11)]);
var inst_119723 = (state_119772[(12)]);
var inst_119721 = (state_119772[(13)]);
var inst_119727 = (function (){var fuel = inst_119715;
var cache = inst_119716;
var curr_block = inst_119717;
var rest_blocks = inst_119718;
var acc = inst_119719;
var flakes = inst_119721;
var asserted = inst_119723;
return ((function (fuel,cache,curr_block,rest_blocks,acc,flakes,asserted,inst_119719,inst_119718,inst_119716,inst_119715,inst_119717,inst_119723,inst_119721,state_val_119773,c__99809__auto__){
return (function (p1__119706_SHARP_){
return p1__119706_SHARP_.s;
});
;})(fuel,cache,curr_block,rest_blocks,acc,flakes,asserted,inst_119719,inst_119718,inst_119716,inst_119715,inst_119717,inst_119723,inst_119721,state_val_119773,c__99809__auto__))
})();
var inst_119728 = cljs.core.group_by(inst_119727,inst_119723);
var inst_119729 = cljs.core.vals(inst_119728);
var inst_119730 = shared.fdb.format_flake_groups_pretty(db,inst_119716,inst_119715,inst_119729);
var state_119772__$1 = state_119772;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119772__$1,(7),inst_119730);
} else {
if((state_val_119773 === (13))){
var inst_119760 = (state_119772[(14)]);
var state_119772__$1 = state_119772;
var statearr_119777_119801 = state_119772__$1;
(statearr_119777_119801[(2)] = inst_119760);

(statearr_119777_119801[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (6))){
var inst_119719 = (state_119772[(7)]);
var inst_119738 = (state_119772[(15)]);
var inst_119718 = (state_119772[(8)]);
var inst_119716 = (state_119772[(9)]);
var inst_119715 = (state_119772[(10)]);
var inst_119736 = (state_119772[(16)]);
var inst_119717 = (state_119772[(11)]);
var inst_119723 = (state_119772[(12)]);
var inst_119721 = (state_119772[(13)]);
var inst_119736__$1 = (state_119772[(2)]);
var inst_119737 = (function (){var fuel = inst_119715;
var cache = inst_119716;
var curr_block = inst_119717;
var rest_blocks = inst_119718;
var acc = inst_119719;
var flakes = inst_119721;
var asserted = inst_119723;
var asserted_SINGLEQUOTE_ = inst_119736__$1;
return ((function (fuel,cache,curr_block,rest_blocks,acc,flakes,asserted,asserted_SINGLEQUOTE_,inst_119719,inst_119738,inst_119718,inst_119716,inst_119715,inst_119736,inst_119717,inst_119723,inst_119721,inst_119736__$1,state_val_119773,c__99809__auto__){
return (function (p1__119707_SHARP_){
return p1__119707_SHARP_.op === false;
});
;})(fuel,cache,curr_block,rest_blocks,acc,flakes,asserted,asserted_SINGLEQUOTE_,inst_119719,inst_119738,inst_119718,inst_119716,inst_119715,inst_119736,inst_119717,inst_119723,inst_119721,inst_119736__$1,state_val_119773,c__99809__auto__))
})();
var inst_119738__$1 = cljs.core.filter.cljs$core$IFn$_invoke$arity$2(inst_119737,inst_119721);
var inst_119739 = cljs.core.empty_QMARK_(inst_119738__$1);
var inst_119740 = (!(inst_119739));
var state_119772__$1 = (function (){var statearr_119780 = state_119772;
(statearr_119780[(15)] = inst_119738__$1);

(statearr_119780[(16)] = inst_119736__$1);

return statearr_119780;
})();
if(inst_119740){
var statearr_119781_119802 = state_119772__$1;
(statearr_119781_119802[(1)] = (8));

} else {
var statearr_119782_119803 = state_119772__$1;
(statearr_119782_119803[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (3))){
var inst_119770 = (state_119772[(2)]);
var state_119772__$1 = state_119772;
return cljs.core.async.impl.ioc_helpers.return_chan(state_119772__$1,inst_119770);
} else {
if((state_val_119773 === (12))){
var inst_119718 = (state_119772[(8)]);
var inst_119716 = (state_119772[(9)]);
var inst_119715 = (state_119772[(10)]);
var inst_119760 = (state_119772[(14)]);
var inst_119763 = cljs.core.first(inst_119718);
var inst_119764 = cljs.core.rest(inst_119718);
var tmp119778 = inst_119716;
var tmp119779 = inst_119715;
var inst_119715__$1 = tmp119779;
var inst_119716__$1 = tmp119778;
var inst_119717 = inst_119763;
var inst_119718__$1 = inst_119764;
var inst_119719 = inst_119760;
var state_119772__$1 = (function (){var statearr_119783 = state_119772;
(statearr_119783[(7)] = inst_119719);

(statearr_119783[(8)] = inst_119718__$1);

(statearr_119783[(9)] = inst_119716__$1);

(statearr_119783[(10)] = inst_119715__$1);

(statearr_119783[(11)] = inst_119717);

return statearr_119783;
})();
var statearr_119784_119804 = state_119772__$1;
(statearr_119784_119804[(2)] = null);

(statearr_119784_119804[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (2))){
var inst_119719 = (state_119772[(7)]);
var inst_119718 = (state_119772[(8)]);
var inst_119716 = (state_119772[(9)]);
var inst_119715 = (state_119772[(10)]);
var inst_119717 = (state_119772[(11)]);
var inst_119723 = (state_119772[(12)]);
var inst_119721 = (state_119772[(13)]);
var inst_119721__$1 = cljs.core.cst$kw$flakes.cljs$core$IFn$_invoke$arity$1(inst_119717);
var inst_119722 = (function (){var fuel = inst_119715;
var cache = inst_119716;
var curr_block = inst_119717;
var rest_blocks = inst_119718;
var acc = inst_119719;
var flakes = inst_119721__$1;
return ((function (fuel,cache,curr_block,rest_blocks,acc,flakes,inst_119719,inst_119718,inst_119716,inst_119715,inst_119717,inst_119723,inst_119721,inst_119721__$1,state_val_119773,c__99809__auto__){
return (function (p1__119705_SHARP_){
return p1__119705_SHARP_.op;
});
;})(fuel,cache,curr_block,rest_blocks,acc,flakes,inst_119719,inst_119718,inst_119716,inst_119715,inst_119717,inst_119723,inst_119721,inst_119721__$1,state_val_119773,c__99809__auto__))
})();
var inst_119723__$1 = cljs.core.filter.cljs$core$IFn$_invoke$arity$2(inst_119722,inst_119721__$1);
var inst_119724 = cljs.core.empty_QMARK_(inst_119723__$1);
var inst_119725 = (!(inst_119724));
var state_119772__$1 = (function (){var statearr_119785 = state_119772;
(statearr_119785[(12)] = inst_119723__$1);

(statearr_119785[(13)] = inst_119721__$1);

return statearr_119785;
})();
if(inst_119725){
var statearr_119786_119805 = state_119772__$1;
(statearr_119786_119805[(1)] = (4));

} else {
var statearr_119787_119806 = state_119772__$1;
(statearr_119787_119806[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (11))){
var inst_119748 = (state_119772[(2)]);
var inst_119749 = fluree.db.util.async.throw_err(inst_119748);
var state_119772__$1 = state_119772;
var statearr_119788_119807 = state_119772__$1;
(statearr_119788_119807[(2)] = inst_119749);

(statearr_119788_119807[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (9))){
var state_119772__$1 = state_119772;
var statearr_119789_119808 = state_119772__$1;
(statearr_119789_119808[(2)] = null);

(statearr_119789_119808[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (5))){
var state_119772__$1 = state_119772;
var statearr_119790_119809 = state_119772__$1;
(statearr_119790_119809[(2)] = null);

(statearr_119790_119809[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (14))){
var inst_119768 = (state_119772[(2)]);
var state_119772__$1 = state_119772;
var statearr_119791_119810 = state_119772__$1;
(statearr_119791_119810[(2)] = inst_119768);

(statearr_119791_119810[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (10))){
var inst_119719 = (state_119772[(7)]);
var inst_119718 = (state_119772[(8)]);
var inst_119736 = (state_119772[(16)]);
var inst_119717 = (state_119772[(11)]);
var inst_119752 = (state_119772[(2)]);
var inst_119753 = [cljs.core.cst$kw$asserted,cljs.core.cst$kw$retracted];
var inst_119754 = [inst_119736,inst_119752];
var inst_119755 = cljs.core.PersistentHashMap.fromArrays(inst_119753,inst_119754);
var inst_119756 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_119717,cljs.core.cst$kw$flakes,inst_119755);
var inst_119757 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_119758 = [inst_119756];
var inst_119759 = (new cljs.core.PersistentVector(null,1,(5),inst_119757,inst_119758,null));
var inst_119760 = cljs.core.concat.cljs$core$IFn$_invoke$arity$2(inst_119719,inst_119759);
var inst_119761 = cljs.core.first(inst_119718);
var state_119772__$1 = (function (){var statearr_119792 = state_119772;
(statearr_119792[(14)] = inst_119760);

return statearr_119792;
})();
if(cljs.core.truth_(inst_119761)){
var statearr_119793_119811 = state_119772__$1;
(statearr_119793_119811[(1)] = (12));

} else {
var statearr_119794_119812 = state_119772__$1;
(statearr_119794_119812[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119773 === (8))){
var inst_119719 = (state_119772[(7)]);
var inst_119738 = (state_119772[(15)]);
var inst_119718 = (state_119772[(8)]);
var inst_119716 = (state_119772[(9)]);
var inst_119715 = (state_119772[(10)]);
var inst_119736 = (state_119772[(16)]);
var inst_119717 = (state_119772[(11)]);
var inst_119723 = (state_119772[(12)]);
var inst_119721 = (state_119772[(13)]);
var inst_119742 = (function (){var flakes = inst_119721;
var rest_blocks = inst_119718;
var curr_block = inst_119717;
var asserted_SINGLEQUOTE_ = inst_119736;
var acc = inst_119719;
var fuel = inst_119715;
var cache = inst_119716;
var retracted = inst_119738;
var asserted = inst_119723;
return ((function (flakes,rest_blocks,curr_block,asserted_SINGLEQUOTE_,acc,fuel,cache,retracted,asserted,inst_119719,inst_119738,inst_119718,inst_119716,inst_119715,inst_119736,inst_119717,inst_119723,inst_119721,state_val_119773,c__99809__auto__){
return (function (p1__119708_SHARP_){
return p1__119708_SHARP_.s;
});
;})(flakes,rest_blocks,curr_block,asserted_SINGLEQUOTE_,acc,fuel,cache,retracted,asserted,inst_119719,inst_119738,inst_119718,inst_119716,inst_119715,inst_119736,inst_119717,inst_119723,inst_119721,state_val_119773,c__99809__auto__))
})();
var inst_119743 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(fluree.db.flake.flip_flake,inst_119738);
var inst_119744 = cljs.core.group_by(inst_119742,inst_119743);
var inst_119745 = cljs.core.vals(inst_119744);
var inst_119746 = shared.fdb.format_flake_groups_pretty(db,inst_119716,inst_119715,inst_119745);
var state_119772__$1 = state_119772;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119772__$1,(11),inst_119746);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto__ = null;
var shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto____0 = (function (){
var statearr_119795 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_119795[(0)] = shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto__);

(statearr_119795[(1)] = (1));

return statearr_119795;
});
var shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto____1 = (function (state_119772){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_119772);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e119796){if((e119796 instanceof Object)){
var ex__99706__auto__ = e119796;
var statearr_119797_119813 = state_119772;
(statearr_119797_119813[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_119772);

return cljs.core.cst$kw$recur;
} else {
throw e119796;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__119814 = state_119772;
state_119772 = G__119814;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto__ = function(state_119772){
switch(arguments.length){
case 0:
return shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto____1.call(this,state_119772);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto____0;
shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto____1;
return shared$fdb$format_block_resp_pretty_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_119798 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_119798[(6)] = c__99809__auto__);

return statearr_119798;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
shared.fdb.format_history_resp = (function shared$fdb$format_history_resp(db,resp){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_119909){
var state_val_119910 = (state_119909[(1)]);
if((state_val_119910 === (7))){
var inst_119904 = (state_119909[(2)]);
var inst_119905 = cljs.core.vals(inst_119904);
var state_119909__$1 = state_119909;
var statearr_119911_119941 = state_119909__$1;
(statearr_119911_119941[(2)] = inst_119905);


cljs.core.async.impl.ioc_helpers.process_exception(state_119909__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_119910 === (1))){
var state_119909__$1 = state_119909;
var statearr_119912_119942 = state_119909__$1;
(statearr_119912_119942[(2)] = null);

(statearr_119912_119942[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119910 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_119909,(3),Error,null,(2));
var inst_119820 = (function (){return ((function (_,state_val_119910,c__99809__auto__){
return (function (p1__119815_SHARP_){
return p1__119815_SHARP_.t;
});
;})(_,state_val_119910,c__99809__auto__))
})();
var inst_119821 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_119820,resp);
var inst_119822 = cljs.core.set(inst_119821);
var inst_119858 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_119859 = (function (){var ts = inst_119822;
var c__99809__auto____$1 = inst_119858;
return ((function (ts,c__99809__auto____$1,_,inst_119820,inst_119821,inst_119822,inst_119858,state_val_119910,c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (ts,c__99809__auto____$1,_,inst_119820,inst_119821,inst_119822,inst_119858,state_val_119910,c__99809__auto__){
return (function (state_119856){
var state_val_119857 = (state_119856[(1)]);
if((state_val_119857 === (1))){
var inst_119830 = cljs.core.seq(ts);
var inst_119831 = cljs.core.first(inst_119830);
var inst_119832 = cljs.core.next(inst_119830);
var inst_119833 = cljs.core.PersistentHashMap.EMPTY;
var inst_119834 = ts;
var inst_119835 = inst_119833;
var state_119856__$1 = (function (){var statearr_119913 = state_119856;
(statearr_119913[(7)] = inst_119832);

(statearr_119913[(8)] = inst_119834);

(statearr_119913[(9)] = inst_119831);

(statearr_119913[(10)] = inst_119835);

return statearr_119913;
})();
var statearr_119914_119943 = state_119856__$1;
(statearr_119914_119943[(2)] = null);

(statearr_119914_119943[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119857 === (2))){
var inst_119841 = (state_119856[(11)]);
var inst_119834 = (state_119856[(8)]);
var inst_119840 = cljs.core.seq(inst_119834);
var inst_119841__$1 = cljs.core.first(inst_119840);
var inst_119842 = cljs.core.next(inst_119840);
var state_119856__$1 = (function (){var statearr_119915 = state_119856;
(statearr_119915[(12)] = inst_119842);

(statearr_119915[(11)] = inst_119841__$1);

return statearr_119915;
})();
if(cljs.core.truth_(inst_119841__$1)){
var statearr_119916_119944 = state_119856__$1;
(statearr_119916_119944[(1)] = (4));

} else {
var statearr_119917_119945 = state_119856__$1;
(statearr_119917_119945[(1)] = (5));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119857 === (3))){
var inst_119854 = (state_119856[(2)]);
var state_119856__$1 = state_119856;
return cljs.core.async.impl.ioc_helpers.return_chan(state_119856__$1,inst_119854);
} else {
if((state_val_119857 === (4))){
var inst_119841 = (state_119856[(11)]);
var inst_119844 = fluree.db.time_travel.non_border_t_to_block(db,inst_119841);
var state_119856__$1 = state_119856;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119856__$1,(7),inst_119844);
} else {
if((state_val_119857 === (5))){
var inst_119835 = (state_119856[(10)]);
var state_119856__$1 = state_119856;
var statearr_119918_119946 = state_119856__$1;
(statearr_119918_119946[(2)] = inst_119835);

(statearr_119918_119946[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119857 === (6))){
var inst_119852 = (state_119856[(2)]);
var state_119856__$1 = state_119856;
var statearr_119919_119947 = state_119856__$1;
(statearr_119919_119947[(2)] = inst_119852);

(statearr_119919_119947[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119857 === (7))){
var inst_119842 = (state_119856[(12)]);
var inst_119841 = (state_119856[(11)]);
var inst_119835 = (state_119856[(10)]);
var inst_119846 = (state_119856[(2)]);
var inst_119847 = fluree.db.util.async.throw_err(inst_119846);
var inst_119848 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_119835,inst_119841,inst_119847);
var inst_119834 = inst_119842;
var inst_119835__$1 = inst_119848;
var state_119856__$1 = (function (){var statearr_119920 = state_119856;
(statearr_119920[(8)] = inst_119834);

(statearr_119920[(10)] = inst_119835__$1);

return statearr_119920;
})();
var statearr_119921_119948 = state_119856__$1;
(statearr_119921_119948[(2)] = null);

(statearr_119921_119948[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(ts,c__99809__auto____$1,_,inst_119820,inst_119821,inst_119822,inst_119858,state_val_119910,c__99809__auto__))
;
return ((function (switch__99702__auto__,ts,c__99809__auto____$1,_,inst_119820,inst_119821,inst_119822,inst_119858,state_val_119910,c__99809__auto__){
return (function() {
var shared$fdb$format_history_resp_$_state_machine__99703__auto__ = null;
var shared$fdb$format_history_resp_$_state_machine__99703__auto____0 = (function (){
var statearr_119922 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_119922[(0)] = shared$fdb$format_history_resp_$_state_machine__99703__auto__);

(statearr_119922[(1)] = (1));

return statearr_119922;
});
var shared$fdb$format_history_resp_$_state_machine__99703__auto____1 = (function (state_119856){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_119856);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e119923){if((e119923 instanceof Object)){
var ex__99706__auto__ = e119923;
var statearr_119924_119949 = state_119856;
(statearr_119924_119949[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_119856);

return cljs.core.cst$kw$recur;
} else {
throw e119923;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__119950 = state_119856;
state_119856 = G__119950;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$format_history_resp_$_state_machine__99703__auto__ = function(state_119856){
switch(arguments.length){
case 0:
return shared$fdb$format_history_resp_$_state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$format_history_resp_$_state_machine__99703__auto____1.call(this,state_119856);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$format_history_resp_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$format_history_resp_$_state_machine__99703__auto____0;
shared$fdb$format_history_resp_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$format_history_resp_$_state_machine__99703__auto____1;
return shared$fdb$format_history_resp_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,ts,c__99809__auto____$1,_,inst_119820,inst_119821,inst_119822,inst_119858,state_val_119910,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_119925 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_119925[(6)] = c__99809__auto____$1);

return statearr_119925;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});
;})(ts,c__99809__auto____$1,_,inst_119820,inst_119821,inst_119822,inst_119858,state_val_119910,c__99809__auto__))
})();
var inst_119860 = cljs.core.async.impl.dispatch.run(inst_119859);
var state_119909__$1 = (function (){var statearr_119926 = state_119909;
(statearr_119926[(7)] = inst_119860);

return statearr_119926;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_119909__$1,(5),inst_119858);
} else {
if((state_val_119910 === (6))){
var inst_119882 = (state_119909[(8)]);
var inst_119875 = (state_119909[(9)]);
var inst_119881 = cljs.core.seq(inst_119875);
var inst_119882__$1 = cljs.core.first(inst_119881);
var inst_119883 = cljs.core.next(inst_119881);
var state_119909__$1 = (function (){var statearr_119927 = state_119909;
(statearr_119927[(10)] = inst_119883);

(statearr_119927[(8)] = inst_119882__$1);

return statearr_119927;
})();
if(cljs.core.truth_(inst_119882__$1)){
var statearr_119928_119951 = state_119909__$1;
(statearr_119928_119951[(1)] = (8));

} else {
var statearr_119929_119952 = state_119909__$1;
(statearr_119929_119952[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_119910 === (3))){
var inst_119816 = (state_119909[(2)]);
var state_119909__$1 = state_119909;
var statearr_119930_119953 = state_119909__$1;
(statearr_119930_119953[(2)] = inst_119816);


cljs.core.async.impl.ioc_helpers.process_exception(state_119909__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_119910 === (2))){
var inst_119907 = (state_119909[(2)]);
var state_119909__$1 = state_119909;
return cljs.core.async.impl.ioc_helpers.return_chan(state_119909__$1,inst_119907);
} else {
if((state_val_119910 === (9))){
var inst_119876 = (state_119909[(11)]);
var state_119909__$1 = state_119909;
var statearr_119931_119954 = state_119909__$1;
(statearr_119931_119954[(2)] = inst_119876);

(statearr_119931_119954[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119910 === (5))){
var inst_119862 = (state_119909[(2)]);
var inst_119863 = fluree.db.util.async.throw_err(inst_119862);
var inst_119871 = cljs.core.seq(resp);
var inst_119872 = cljs.core.first(inst_119871);
var inst_119873 = cljs.core.next(inst_119871);
var inst_119874 = cljs.core.PersistentHashMap.EMPTY;
var inst_119875 = resp;
var inst_119876 = inst_119874;
var state_119909__$1 = (function (){var statearr_119932 = state_119909;
(statearr_119932[(12)] = inst_119872);

(statearr_119932[(11)] = inst_119876);

(statearr_119932[(13)] = inst_119873);

(statearr_119932[(14)] = inst_119863);

(statearr_119932[(9)] = inst_119875);

return statearr_119932;
})();
var statearr_119933_119955 = state_119909__$1;
(statearr_119933_119955[(2)] = null);

(statearr_119933_119955[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119910 === (10))){
var inst_119902 = (state_119909[(2)]);
var state_119909__$1 = state_119909;
var statearr_119934_119956 = state_119909__$1;
(statearr_119934_119956[(2)] = inst_119902);

(statearr_119934_119956[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_119910 === (8))){
var inst_119876 = (state_119909[(11)]);
var inst_119883 = (state_119909[(10)]);
var inst_119882 = (state_119909[(8)]);
var inst_119863 = (state_119909[(14)]);
var inst_119885 = inst_119882.t;
var inst_119886 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_119863,inst_119885);
var inst_119887 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_119888 = [inst_119886,cljs.core.cst$kw$block];
var inst_119889 = (new cljs.core.PersistentVector(null,2,(5),inst_119887,inst_119888,null));
var inst_119890 = cljs.core.assoc_in(inst_119876,inst_119889,inst_119886);
var inst_119891 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_119892 = [inst_119886,cljs.core.cst$kw$flakes];
var inst_119893 = (new cljs.core.PersistentVector(null,2,(5),inst_119891,inst_119892,null));
var inst_119894 = cljs.core.update_in.cljs$core$IFn$_invoke$arity$4(inst_119890,inst_119893,cljs.core.conj,inst_119882);
var inst_119895 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_119896 = [inst_119886,cljs.core.cst$kw$t];
var inst_119897 = (new cljs.core.PersistentVector(null,2,(5),inst_119895,inst_119896,null));
var inst_119898 = cljs.core.update_in.cljs$core$IFn$_invoke$arity$4(inst_119894,inst_119897,shared.fdb.min_safe,inst_119885);
var inst_119875 = inst_119883;
var inst_119876__$1 = inst_119898;
var state_119909__$1 = (function (){var statearr_119935 = state_119909;
(statearr_119935[(11)] = inst_119876__$1);

(statearr_119935[(9)] = inst_119875);

return statearr_119935;
})();
var statearr_119936_119957 = state_119909__$1;
(statearr_119936_119957[(2)] = null);

(statearr_119936_119957[(1)] = (6));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$fdb$format_history_resp_$_state_machine__99703__auto__ = null;
var shared$fdb$format_history_resp_$_state_machine__99703__auto____0 = (function (){
var statearr_119937 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_119937[(0)] = shared$fdb$format_history_resp_$_state_machine__99703__auto__);

(statearr_119937[(1)] = (1));

return statearr_119937;
});
var shared$fdb$format_history_resp_$_state_machine__99703__auto____1 = (function (state_119909){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_119909);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e119938){if((e119938 instanceof Object)){
var ex__99706__auto__ = e119938;
var statearr_119939_119958 = state_119909;
(statearr_119939_119958[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_119909);

return cljs.core.cst$kw$recur;
} else {
throw e119938;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__119959 = state_119909;
state_119909 = G__119959;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$format_history_resp_$_state_machine__99703__auto__ = function(state_119909){
switch(arguments.length){
case 0:
return shared$fdb$format_history_resp_$_state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$format_history_resp_$_state_machine__99703__auto____1.call(this,state_119909);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$format_history_resp_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$format_history_resp_$_state_machine__99703__auto____0;
shared$fdb$format_history_resp_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$format_history_resp_$_state_machine__99703__auto____1;
return shared$fdb$format_history_resp_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_119940 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_119940[(6)] = c__99809__auto__);

return statearr_119940;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns an asynchronous channel that eventually contains the start and end block for a query.
 */
shared.fdb.resolve_block_range = (function shared$fdb$resolve_block_range(db,query_map){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_120098){
var state_val_120099 = (state_120098[(1)]);
if((state_val_120099 === (7))){
var inst_119988 = (state_120098[(7)]);
var inst_119988__$1 = (state_120098[(2)]);
var inst_119989 = cljs.core.some(cljs.core.string_QMARK_,inst_119988__$1);
var state_120098__$1 = (function (){var statearr_120100 = state_120098;
(statearr_120100[(7)] = inst_119988__$1);

return statearr_120100;
})();
if(cljs.core.truth_(inst_119989)){
var statearr_120101_120160 = state_120098__$1;
(statearr_120101_120160[(1)] = (8));

} else {
var statearr_120102_120161 = state_120098__$1;
(statearr_120102_120161[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (20))){
var inst_120011 = (state_120098[(8)]);
var state_120098__$1 = state_120098;
var statearr_120103_120162 = state_120098__$1;
(statearr_120103_120162[(2)] = inst_120011);

(statearr_120103_120162[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (27))){
var inst_120054 = (state_120098[(2)]);
var state_120098__$1 = state_120098;
var statearr_120104_120163 = state_120098__$1;
(statearr_120104_120163[(2)] = inst_120054);

(statearr_120104_120163[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (1))){
var state_120098__$1 = state_120098;
var statearr_120105_120164 = state_120098__$1;
(statearr_120105_120164[(2)] = null);

(statearr_120105_120164[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (24))){
var inst_120057 = (state_120098[(9)]);
var inst_120058 = (state_120098[(10)]);
var inst_120056 = (state_120098[(2)]);
var inst_120057__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120056,(0),null);
var inst_120058__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120056,(1),null);
var inst_120059 = cljs.core.pos_int_QMARK_(inst_120057__$1);
var inst_120060 = cljs.core.pos_int_QMARK_(inst_120058__$1);
var inst_120061 = ((inst_120059) && (inst_120060));
var inst_120062 = cljs.core.not(inst_120061);
var state_120098__$1 = (function (){var statearr_120106 = state_120098;
(statearr_120106[(9)] = inst_120057__$1);

(statearr_120106[(10)] = inst_120058__$1);

return statearr_120106;
})();
if(inst_120062){
var statearr_120107_120165 = state_120098__$1;
(statearr_120107_120165[(1)] = (31));

} else {
var statearr_120108_120166 = state_120098__$1;
(statearr_120108_120166[(1)] = (32));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (39))){
var inst_120085 = (state_120098[(11)]);
var inst_120091 = (state_120098[(2)]);
var inst_120092 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120093 = [inst_120085,inst_120091];
var inst_120094 = (new cljs.core.PersistentVector(null,2,(5),inst_120092,inst_120093,null));
var state_120098__$1 = state_120098;
var statearr_120109_120167 = state_120098__$1;
(statearr_120109_120167[(2)] = inst_120094);


cljs.core.async.impl.ioc_helpers.process_exception(state_120098__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_120098,(3),cljs.core.cst$kw$default,null,(2));
var inst_119977 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(query_map);
var inst_119978 = cljs.core.sequential_QMARK_(inst_119977);
var state_120098__$1 = state_120098;
if(inst_119978){
var statearr_120110_120168 = state_120098__$1;
(statearr_120110_120168[(1)] = (5));

} else {
var statearr_120111_120169 = state_120098__$1;
(statearr_120111_120169[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (15))){
var inst_120001 = (state_120098[(2)]);
var inst_120002 = fluree.db.util.async.throw_err(inst_120001);
var state_120098__$1 = state_120098;
var statearr_120112_120170 = state_120098__$1;
(statearr_120112_120170[(2)] = inst_120002);

(statearr_120112_120170[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (21))){
var inst_120030 = (state_120098[(2)]);
var state_120098__$1 = state_120098;
if(cljs.core.truth_(inst_120030)){
var statearr_120113_120171 = state_120098__$1;
(statearr_120113_120171[(1)] = (22));

} else {
var statearr_120114_120172 = state_120098__$1;
(statearr_120114_120172[(1)] = (23));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (31))){
var inst_119988 = (state_120098[(7)]);
var inst_120064 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_119988], 0));
var inst_120065 = ["Invalid block range provided: ",inst_120064].join('');
var inst_120066 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_120067 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_120068 = cljs.core.PersistentHashMap.fromArrays(inst_120066,inst_120067);
var inst_120069 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_120065,inst_120068);
var inst_120070 = (function(){throw inst_120069})();
var state_120098__$1 = state_120098;
var statearr_120115_120173 = state_120098__$1;
(statearr_120115_120173[(2)] = inst_120070);

(statearr_120115_120173[(1)] = (33));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (32))){
var state_120098__$1 = state_120098;
var statearr_120116_120174 = state_120098__$1;
(statearr_120116_120174[(2)] = null);

(statearr_120116_120174[(1)] = (33));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (33))){
var inst_120057 = (state_120098[(9)]);
var inst_120058 = (state_120098[(10)]);
var inst_120073 = (state_120098[(2)]);
var inst_120074 = (inst_120058 < inst_120057);
var state_120098__$1 = (function (){var statearr_120117 = state_120098;
(statearr_120117[(12)] = inst_120073);

return statearr_120117;
})();
if(cljs.core.truth_(inst_120074)){
var statearr_120118_120175 = state_120098__$1;
(statearr_120118_120175[(1)] = (34));

} else {
var statearr_120119_120176 = state_120098__$1;
(statearr_120119_120176[(1)] = (35));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (13))){
var state_120098__$1 = state_120098;
var statearr_120120_120177 = state_120098__$1;
(statearr_120120_120177[(2)] = null);

(statearr_120120_120177[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (22))){
var inst_120012 = (state_120098[(13)]);
var inst_120011 = (state_120098[(8)]);
var inst_120032 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120033 = [inst_120011,inst_120012];
var inst_120034 = (new cljs.core.PersistentVector(null,2,(5),inst_120032,inst_120033,null));
var state_120098__$1 = state_120098;
var statearr_120121_120178 = state_120098__$1;
(statearr_120121_120178[(2)] = inst_120034);

(statearr_120121_120178[(1)] = (24));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (36))){
var inst_120013 = (state_120098[(14)]);
var inst_120086 = (state_120098[(15)]);
var inst_120084 = (state_120098[(2)]);
var inst_120085 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120084,(0),null);
var inst_120086__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120084,(1),null);
var inst_120087 = (inst_120086__$1 > inst_120013);
var state_120098__$1 = (function (){var statearr_120122 = state_120098;
(statearr_120122[(11)] = inst_120085);

(statearr_120122[(15)] = inst_120086__$1);

return statearr_120122;
})();
if(cljs.core.truth_(inst_120087)){
var statearr_120123_120179 = state_120098__$1;
(statearr_120123_120179[(1)] = (37));

} else {
var statearr_120124_120180 = state_120098__$1;
(statearr_120124_120180[(1)] = (38));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (29))){
var state_120098__$1 = state_120098;
var statearr_120125_120181 = state_120098__$1;
(statearr_120125_120181[(2)] = null);

(statearr_120125_120181[(1)] = (30));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (6))){
var inst_119982 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_119983 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(query_map);
var inst_119984 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(query_map);
var inst_119985 = [inst_119983,inst_119984];
var inst_119986 = (new cljs.core.PersistentVector(null,2,(5),inst_119982,inst_119985,null));
var state_120098__$1 = state_120098;
var statearr_120126_120182 = state_120098__$1;
(statearr_120126_120182[(2)] = inst_119986);

(statearr_120126_120182[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (28))){
var inst_119988 = (state_120098[(7)]);
var inst_120043 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_119988], 0));
var inst_120044 = ["Invalid block range provided: ",inst_120043].join('');
var inst_120045 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_120046 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_120047 = cljs.core.PersistentHashMap.fromArrays(inst_120045,inst_120046);
var inst_120048 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_120044,inst_120047);
var inst_120049 = (function(){throw inst_120048})();
var state_120098__$1 = state_120098;
var statearr_120127_120183 = state_120098__$1;
(statearr_120127_120183[(2)] = inst_120049);

(statearr_120127_120183[(1)] = (30));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (25))){
var inst_120011 = (state_120098[(8)]);
var inst_120037 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120038 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(db);
var inst_120039 = [inst_120011,inst_120038];
var inst_120040 = (new cljs.core.PersistentVector(null,2,(5),inst_120037,inst_120039,null));
var state_120098__$1 = state_120098;
var statearr_120128_120184 = state_120098__$1;
(statearr_120128_120184[(2)] = inst_120040);

(statearr_120128_120184[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (34))){
var inst_120057 = (state_120098[(9)]);
var inst_120058 = (state_120098[(10)]);
var inst_120076 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120077 = [inst_120058,inst_120057];
var inst_120078 = (new cljs.core.PersistentVector(null,2,(5),inst_120076,inst_120077,null));
var state_120098__$1 = state_120098;
var statearr_120129_120185 = state_120098__$1;
(statearr_120129_120185[(2)] = inst_120078);

(statearr_120129_120185[(1)] = (36));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (17))){
var state_120098__$1 = state_120098;
var statearr_120130_120186 = state_120098__$1;
(statearr_120130_120186[(2)] = null);

(statearr_120130_120186[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (3))){
var inst_119960 = (state_120098[(2)]);
var inst_119961 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_119960], 0));
var inst_119962 = cljs.core.ex_data(inst_119960);
var inst_119963 = cljs.core.ex_message(inst_119960);
var inst_119964 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_119962,cljs.core.cst$kw$message,inst_119963);
var state_120098__$1 = (function (){var statearr_120131 = state_120098;
(statearr_120131[(16)] = inst_119961);

return statearr_120131;
})();
var statearr_120132_120187 = state_120098__$1;
(statearr_120132_120187[(2)] = inst_119964);


cljs.core.async.impl.ioc_helpers.process_exception(state_120098__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (12))){
var inst_119997 = (state_120098[(17)]);
var inst_119999 = fluree.db.time_travel.block_to_int_format(db,inst_119997);
var state_120098__$1 = state_120098;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120098__$1,(15),inst_119999);
} else {
if((state_val_120099 === (2))){
var inst_120096 = (state_120098[(2)]);
var state_120098__$1 = state_120098;
return cljs.core.async.impl.ioc_helpers.return_chan(state_120098__$1,inst_120096);
} else {
if((state_val_120099 === (23))){
var inst_120011 = (state_120098[(8)]);
var state_120098__$1 = state_120098;
if(cljs.core.truth_(inst_120011)){
var statearr_120133_120188 = state_120098__$1;
(statearr_120133_120188[(1)] = (25));

} else {
var statearr_120134_120189 = state_120098__$1;
(statearr_120134_120189[(1)] = (26));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (35))){
var inst_120057 = (state_120098[(9)]);
var inst_120058 = (state_120098[(10)]);
var inst_120080 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120081 = [inst_120057,inst_120058];
var inst_120082 = (new cljs.core.PersistentVector(null,2,(5),inst_120080,inst_120081,null));
var state_120098__$1 = state_120098;
var statearr_120135_120190 = state_120098__$1;
(statearr_120135_120190[(2)] = inst_120082);

(statearr_120135_120190[(1)] = (36));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (19))){
var inst_120012 = (state_120098[(13)]);
var state_120098__$1 = state_120098;
var statearr_120136_120191 = state_120098__$1;
(statearr_120136_120191[(2)] = inst_120012);

(statearr_120136_120191[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (11))){
var inst_119997 = (state_120098[(17)]);
var inst_119988 = (state_120098[(7)]);
var inst_119995 = (state_120098[(2)]);
var inst_119996 = fluree.db.util.async.throw_err(inst_119995);
var inst_119997__$1 = cljs.core.second(inst_119988);
var state_120098__$1 = (function (){var statearr_120137 = state_120098;
(statearr_120137[(17)] = inst_119997__$1);

(statearr_120137[(18)] = inst_119996);

return statearr_120137;
})();
if(cljs.core.truth_(inst_119997__$1)){
var statearr_120138_120192 = state_120098__$1;
(statearr_120138_120192[(1)] = (12));

} else {
var statearr_120139_120193 = state_120098__$1;
(statearr_120139_120193[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (9))){
var inst_119988 = (state_120098[(7)]);
var state_120098__$1 = state_120098;
var statearr_120140_120194 = state_120098__$1;
(statearr_120140_120194[(2)] = inst_119988);

(statearr_120140_120194[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (5))){
var inst_119980 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(query_map);
var state_120098__$1 = state_120098;
var statearr_120141_120195 = state_120098__$1;
(statearr_120141_120195[(2)] = inst_119980);

(statearr_120141_120195[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (14))){
var inst_119996 = (state_120098[(18)]);
var inst_119991 = (state_120098[(19)]);
var inst_120005 = (state_120098[(2)]);
var inst_120006 = [inst_119996,inst_120005];
var inst_120007 = (new cljs.core.PersistentVector(null,2,(5),inst_119991,inst_120006,null));
var state_120098__$1 = state_120098;
var statearr_120142_120196 = state_120098__$1;
(statearr_120142_120196[(2)] = inst_120007);

(statearr_120142_120196[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (26))){
var state_120098__$1 = state_120098;
var statearr_120143_120197 = state_120098__$1;
(statearr_120143_120197[(1)] = (28));



return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (16))){
var inst_120013 = (state_120098[(14)]);
var inst_120011 = (state_120098[(8)]);
var inst_120016 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_120011], 0));
var inst_120017 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_120013], 0));
var inst_120018 = ["Start block is out of range for this ledger. Start block provided: ",inst_120016,". Database block: ",inst_120017].join('');
var inst_120019 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_120020 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_120021 = cljs.core.PersistentHashMap.fromArrays(inst_120019,inst_120020);
var inst_120022 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_120018,inst_120021);
var inst_120023 = (function(){throw inst_120022})();
var state_120098__$1 = state_120098;
var statearr_120145_120198 = state_120098__$1;
(statearr_120145_120198[(2)] = inst_120023);

(statearr_120145_120198[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (38))){
var inst_120086 = (state_120098[(15)]);
var state_120098__$1 = state_120098;
var statearr_120146_120199 = state_120098__$1;
(statearr_120146_120199[(2)] = inst_120086);

(statearr_120146_120199[(1)] = (39));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (30))){
var inst_120052 = (state_120098[(2)]);
var state_120098__$1 = state_120098;
var statearr_120147_120200 = state_120098__$1;
(statearr_120147_120200[(2)] = inst_120052);

(statearr_120147_120200[(1)] = (27));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (10))){
var inst_120013 = (state_120098[(14)]);
var inst_120011 = (state_120098[(8)]);
var inst_120010 = (state_120098[(2)]);
var inst_120011__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120010,(0),null);
var inst_120012 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120010,(1),null);
var inst_120013__$1 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(db);
var inst_120014 = (inst_120011__$1 > inst_120013__$1);
var state_120098__$1 = (function (){var statearr_120148 = state_120098;
(statearr_120148[(13)] = inst_120012);

(statearr_120148[(14)] = inst_120013__$1);

(statearr_120148[(8)] = inst_120011__$1);

return statearr_120148;
})();
if(cljs.core.truth_(inst_120014)){
var statearr_120149_120201 = state_120098__$1;
(statearr_120149_120201[(1)] = (16));

} else {
var statearr_120150_120202 = state_120098__$1;
(statearr_120150_120202[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (18))){
var inst_120011 = (state_120098[(8)]);
var inst_120026 = (state_120098[(2)]);
var state_120098__$1 = (function (){var statearr_120151 = state_120098;
(statearr_120151[(20)] = inst_120026);

return statearr_120151;
})();
if(cljs.core.truth_(inst_120011)){
var statearr_120152_120203 = state_120098__$1;
(statearr_120152_120203[(1)] = (19));

} else {
var statearr_120153_120204 = state_120098__$1;
(statearr_120153_120204[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (37))){
var inst_120013 = (state_120098[(14)]);
var state_120098__$1 = state_120098;
var statearr_120154_120205 = state_120098__$1;
(statearr_120154_120205[(2)] = inst_120013);

(statearr_120154_120205[(1)] = (39));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120099 === (8))){
var inst_119988 = (state_120098[(7)]);
var inst_119991 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_119992 = cljs.core.first(inst_119988);
var inst_119993 = fluree.db.time_travel.block_to_int_format(db,inst_119992);
var state_120098__$1 = (function (){var statearr_120155 = state_120098;
(statearr_120155[(19)] = inst_119991);

return statearr_120155;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120098__$1,(11),inst_119993);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$fdb$resolve_block_range_$_state_machine__99703__auto__ = null;
var shared$fdb$resolve_block_range_$_state_machine__99703__auto____0 = (function (){
var statearr_120156 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_120156[(0)] = shared$fdb$resolve_block_range_$_state_machine__99703__auto__);

(statearr_120156[(1)] = (1));

return statearr_120156;
});
var shared$fdb$resolve_block_range_$_state_machine__99703__auto____1 = (function (state_120098){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_120098);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e120157){if((e120157 instanceof Object)){
var ex__99706__auto__ = e120157;
var statearr_120158_120206 = state_120098;
(statearr_120158_120206[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_120098);

return cljs.core.cst$kw$recur;
} else {
throw e120157;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__120207 = state_120098;
state_120098 = G__120207;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$resolve_block_range_$_state_machine__99703__auto__ = function(state_120098){
switch(arguments.length){
case 0:
return shared$fdb$resolve_block_range_$_state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$resolve_block_range_$_state_machine__99703__auto____1.call(this,state_120098);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$resolve_block_range_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$resolve_block_range_$_state_machine__99703__auto____0;
shared$fdb$resolve_block_range_$_state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$resolve_block_range_$_state_machine__99703__auto____1;
return shared$fdb$resolve_block_range_$_state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_120159 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_120159[(6)] = c__99809__auto__);

return statearr_120159;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});
/**
 * Returns an asynchronous channel that eventually returns the results or an error.
 *   
 */
shared.fdb.block_query_async = (function shared$fdb$block_query_async(var_args){
var G__120210 = arguments.length;
switch (G__120210) {
case 2:
return shared.fdb.block_query_async.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shared.fdb.block_query_async.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.fdb.block_query_async.cljs$core$IFn$_invoke$arity$2 = (function (db,query_map){
return shared.fdb.block_query_async.cljs$core$IFn$_invoke$arity$3(db,query_map,null);
});

shared.fdb.block_query_async.cljs$core$IFn$_invoke$arity$3 = (function (db,query_map,opts){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_120303){
var state_val_120304 = (state_120303[(1)]);
if((state_val_120304 === (7))){
var inst_120239 = (state_120303[(2)]);
var state_120303__$1 = state_120303;
if(cljs.core.truth_(inst_120239)){
var statearr_120305_120350 = state_120303__$1;
(statearr_120305_120350[(1)] = (11));

} else {
var statearr_120306_120351 = state_120303__$1;
(statearr_120306_120351[(1)] = (12));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (20))){
var inst_120271 = (state_120303[(7)]);
var state_120303__$1 = state_120303;
var statearr_120307_120352 = state_120303__$1;
(statearr_120307_120352[(2)] = inst_120271);

(statearr_120307_120352[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (27))){
var inst_120280 = (state_120303[(8)]);
var state_120303__$1 = state_120303;
var statearr_120308_120353 = state_120303__$1;
(statearr_120308_120353[(2)] = inst_120280);

(statearr_120308_120353[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (1))){
var state_120303__$1 = state_120303;
var statearr_120309_120354 = state_120303__$1;
(statearr_120309_120354[(2)] = null);

(statearr_120309_120354[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (24))){
var inst_120280 = (state_120303[(8)]);
var state_120303__$1 = state_120303;
var statearr_120310_120355 = state_120303__$1;
(statearr_120310_120355[(2)] = inst_120280);

(statearr_120310_120355[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_120303,(3),cljs.core.cst$kw$default,null,(2));
var inst_120223 = fluree.db.util.core.current_time_millis();
var inst_120225 = (db == null);
var inst_120226 = cljs.core.not(inst_120225);
var state_120303__$1 = (function (){var statearr_120311 = state_120303;
(statearr_120311[(9)] = inst_120223);

return statearr_120311;
})();
if(inst_120226){
var statearr_120312_120356 = state_120303__$1;
(statearr_120312_120356[(1)] = (5));

} else {
var statearr_120313_120357 = state_120303__$1;
(statearr_120313_120357[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (15))){
var inst_120251 = (state_120303[(10)]);
var inst_120252 = (state_120303[(11)]);
var inst_120258 = fluree.db.query.block.block_range(db,inst_120251,inst_120252,opts);
var state_120303__$1 = state_120303;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120303__$1,(18),inst_120258);
} else {
if((state_val_120304 === (21))){
var inst_120280 = (state_120303[(2)]);
var inst_120281 = cljs.core.cst$kw$meta.cljs$core$IFn$_invoke$arity$1(opts);
var state_120303__$1 = (function (){var statearr_120314 = state_120303;
(statearr_120314[(8)] = inst_120280);

return statearr_120314;
})();
if(cljs.core.truth_(inst_120281)){
var statearr_120315_120358 = state_120303__$1;
(statearr_120315_120358[(1)] = (23));

} else {
var statearr_120316_120359 = state_120303__$1;
(statearr_120316_120359[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (13))){
var inst_120244 = (state_120303[(12)]);
var inst_120244__$1 = (state_120303[(2)]);
var inst_120245 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_120244__$1,cljs.core.cst$kw$network);
var inst_120246 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_120244__$1,cljs.core.cst$kw$dbid);
var inst_120247 = shared.fdb.resolve_block_range(db,query_map);
var state_120303__$1 = (function (){var statearr_120317 = state_120303;
(statearr_120317[(13)] = inst_120245);

(statearr_120317[(14)] = inst_120246);

(statearr_120317[(12)] = inst_120244__$1);

return statearr_120317;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120303__$1,(14),inst_120247);
} else {
if((state_val_120304 === (22))){
var inst_120276 = (state_120303[(2)]);
var inst_120277 = fluree.db.util.async.throw_err(inst_120276);
var state_120303__$1 = state_120303;
var statearr_120318_120360 = state_120303__$1;
(statearr_120318_120360[(2)] = inst_120277);

(statearr_120318_120360[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (6))){
var state_120303__$1 = state_120303;
var statearr_120319_120361 = state_120303__$1;
(statearr_120319_120361[(2)] = false);

(statearr_120319_120361[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (28))){
var inst_120280 = (state_120303[(8)]);
var inst_120245 = (state_120303[(13)]);
var inst_120246 = (state_120303[(14)]);
var inst_120251 = (state_120303[(10)]);
var inst_120252 = (state_120303[(11)]);
var inst_120271 = (state_120303[(7)]);
var inst_120283 = (state_120303[(15)]);
var inst_120223 = (state_120303[(9)]);
var inst_120250 = (state_120303[(16)]);
var inst_120244 = (state_120303[(12)]);
var inst_120289 = (state_120303[(2)]);
var inst_120290 = (function (){var network = inst_120245;
var block_start = inst_120251;
var block_end = inst_120252;
var dbid = inst_120246;
var map__120219 = inst_120244;
var vec__120220 = inst_120250;
var start = inst_120223;
var result_SINGLEQUOTE_ = inst_120280;
var result = inst_120271;
return ((function (network,block_start,block_end,dbid,map__120219,vec__120220,start,result_SINGLEQUOTE_,result,inst_120280,inst_120245,inst_120246,inst_120251,inst_120252,inst_120271,inst_120283,inst_120223,inst_120250,inst_120244,inst_120289,state_val_120304,c__99809__auto__){
return (function (p1__120208_SHARP_){
var G__120320 = "%.2fms";
var G__120321 = p1__120208_SHARP_;
return goog.string.format(G__120320,G__120321);
});
;})(network,block_start,block_end,dbid,map__120219,vec__120220,start,result_SINGLEQUOTE_,result,inst_120280,inst_120245,inst_120246,inst_120251,inst_120252,inst_120271,inst_120283,inst_120223,inst_120250,inst_120244,inst_120289,state_val_120304,c__99809__auto__))
})();
var inst_120291 = fluree.db.util.core.current_time_millis();
var inst_120292 = (inst_120291 - inst_120223);
var inst_120293 = (inst_120292 / (1000000));
var inst_120294 = (inst_120290.cljs$core$IFn$_invoke$arity$1 ? inst_120290.cljs$core$IFn$_invoke$arity$1(inst_120293) : inst_120290.call(null,inst_120293));
var inst_120295 = [(200),inst_120289,(100),inst_120294];
var inst_120296 = cljs.core.PersistentHashMap.fromArrays(inst_120283,inst_120295);
var state_120303__$1 = state_120303;
var statearr_120322_120362 = state_120303__$1;
(statearr_120322_120362[(2)] = inst_120296);

(statearr_120322_120362[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (25))){
var inst_120299 = (state_120303[(2)]);
var state_120303__$1 = state_120303;
var statearr_120323_120363 = state_120303__$1;
(statearr_120323_120363[(2)] = inst_120299);


cljs.core.async.impl.ioc_helpers.process_exception(state_120303__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (17))){
var inst_120271 = (state_120303[(2)]);
var inst_120272 = cljs.core.cst$kw$pretty_DASH_print.cljs$core$IFn$_invoke$arity$1(query_map);
var state_120303__$1 = (function (){var statearr_120324 = state_120303;
(statearr_120324[(7)] = inst_120271);

return statearr_120324;
})();
if(cljs.core.truth_(inst_120272)){
var statearr_120325_120364 = state_120303__$1;
(statearr_120325_120364[(1)] = (19));

} else {
var statearr_120326_120365 = state_120303__$1;
(statearr_120326_120365[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (3))){
var inst_120211 = (state_120303[(2)]);
var inst_120212 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_120211], 0));
var inst_120213 = cljs.core.ex_data(inst_120211);
var inst_120214 = cljs.core.ex_message(inst_120211);
var inst_120215 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_120213,cljs.core.cst$kw$message,inst_120214);
var state_120303__$1 = (function (){var statearr_120327 = state_120303;
(statearr_120327[(17)] = inst_120212);

return statearr_120327;
})();
var statearr_120328_120366 = state_120303__$1;
(statearr_120328_120366[(2)] = inst_120215);


cljs.core.async.impl.ioc_helpers.process_exception(state_120303__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (12))){
var state_120303__$1 = state_120303;
var statearr_120329_120367 = state_120303__$1;
(statearr_120329_120367[(2)] = db);

(statearr_120329_120367[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (2))){
var inst_120301 = (state_120303[(2)]);
var state_120303__$1 = state_120303;
return cljs.core.async.impl.ioc_helpers.return_chan(state_120303__$1,inst_120301);
} else {
if((state_val_120304 === (23))){
var inst_120280 = (state_120303[(8)]);
var inst_120283 = [cljs.core.cst$kw$status,cljs.core.cst$kw$result,cljs.core.cst$kw$fuel,cljs.core.cst$kw$time];
var inst_120284 = cljs.core.sequential_QMARK_(inst_120280);
var state_120303__$1 = (function (){var statearr_120330 = state_120303;
(statearr_120330[(15)] = inst_120283);

return statearr_120330;
})();
if(inst_120284){
var statearr_120331_120368 = state_120303__$1;
(statearr_120331_120368[(1)] = (26));

} else {
var statearr_120332_120369 = state_120303__$1;
(statearr_120332_120369[(1)] = (27));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (19))){
var inst_120271 = (state_120303[(7)]);
var inst_120274 = shared.fdb.format_block_resp_pretty(db,inst_120271);
var state_120303__$1 = state_120303;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120303__$1,(22),inst_120274);
} else {
if((state_val_120304 === (11))){
var inst_120241 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,db);
var state_120303__$1 = state_120303;
var statearr_120333_120370 = state_120303__$1;
(statearr_120333_120370[(2)] = inst_120241);

(statearr_120333_120370[(1)] = (13));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (9))){
var state_120303__$1 = state_120303;
var statearr_120334_120371 = state_120303__$1;
(statearr_120334_120371[(2)] = false);

(statearr_120334_120371[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (5))){
var inst_120228 = db.cljs$lang$protocol_mask$partition0$;
var inst_120229 = (inst_120228 & (64));
var inst_120230 = db.cljs$core$ISeq$;
var inst_120231 = (cljs.core.PROTOCOL_SENTINEL === inst_120230);
var inst_120232 = ((inst_120229) || (inst_120231));
var state_120303__$1 = state_120303;
if(cljs.core.truth_(inst_120232)){
var statearr_120335_120372 = state_120303__$1;
(statearr_120335_120372[(1)] = (8));

} else {
var statearr_120336_120373 = state_120303__$1;
(statearr_120336_120373[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (14))){
var inst_120250 = (state_120303[(16)]);
var inst_120249 = (state_120303[(2)]);
var inst_120250__$1 = fluree.db.util.async.throw_err(inst_120249);
var inst_120251 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120250__$1,(0),null);
var inst_120252 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120250__$1,(1),null);
var inst_120253 = cljs.core.list(cljs.core.cst$kw$block);
var inst_120254 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(query_map,cljs.core.cst$kw$pretty_DASH_print);
var inst_120255 = cljs.core.keys(inst_120254);
var inst_120256 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(inst_120253,inst_120255);
var state_120303__$1 = (function (){var statearr_120337 = state_120303;
(statearr_120337[(10)] = inst_120251);

(statearr_120337[(11)] = inst_120252);

(statearr_120337[(16)] = inst_120250__$1);

return statearr_120337;
})();
if(inst_120256){
var statearr_120338_120374 = state_120303__$1;
(statearr_120338_120374[(1)] = (15));

} else {
var statearr_120339_120375 = state_120303__$1;
(statearr_120339_120375[(1)] = (16));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (26))){
var inst_120280 = (state_120303[(8)]);
var inst_120286 = cljs.core.doall.cljs$core$IFn$_invoke$arity$1(inst_120280);
var state_120303__$1 = state_120303;
var statearr_120340_120376 = state_120303__$1;
(statearr_120340_120376[(2)] = inst_120286);

(statearr_120340_120376[(1)] = (28));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (16))){
var inst_120263 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([query_map], 0));
var inst_120264 = ["Block query not properly formatted. It must only have a block key. Provided ",inst_120263].join('');
var inst_120265 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_120266 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_120267 = cljs.core.PersistentHashMap.fromArrays(inst_120265,inst_120266);
var inst_120268 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_120264,inst_120267);
var inst_120269 = (function(){throw inst_120268})();
var state_120303__$1 = state_120303;
var statearr_120341_120377 = state_120303__$1;
(statearr_120341_120377[(2)] = inst_120269);

(statearr_120341_120377[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (10))){
var inst_120236 = (state_120303[(2)]);
var state_120303__$1 = state_120303;
var statearr_120342_120378 = state_120303__$1;
(statearr_120342_120378[(2)] = inst_120236);

(statearr_120342_120378[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (18))){
var inst_120260 = (state_120303[(2)]);
var inst_120261 = fluree.db.util.async.throw_err(inst_120260);
var state_120303__$1 = state_120303;
var statearr_120343_120379 = state_120303__$1;
(statearr_120343_120379[(2)] = inst_120261);

(statearr_120343_120379[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120304 === (8))){
var state_120303__$1 = state_120303;
var statearr_120344_120380 = state_120303__$1;
(statearr_120344_120380[(2)] = true);

(statearr_120344_120380[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$fdb$state_machine__99703__auto__ = null;
var shared$fdb$state_machine__99703__auto____0 = (function (){
var statearr_120345 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_120345[(0)] = shared$fdb$state_machine__99703__auto__);

(statearr_120345[(1)] = (1));

return statearr_120345;
});
var shared$fdb$state_machine__99703__auto____1 = (function (state_120303){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_120303);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e120346){if((e120346 instanceof Object)){
var ex__99706__auto__ = e120346;
var statearr_120347_120381 = state_120303;
(statearr_120347_120381[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_120303);

return cljs.core.cst$kw$recur;
} else {
throw e120346;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__120382 = state_120303;
state_120303 = G__120382;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$state_machine__99703__auto__ = function(state_120303){
switch(arguments.length){
case 0:
return shared$fdb$state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$state_machine__99703__auto____1.call(this,state_120303);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$state_machine__99703__auto____0;
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$state_machine__99703__auto____1;
return shared$fdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_120348 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_120348[(6)] = c__99809__auto__);

return statearr_120348;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

shared.fdb.block_query_async.cljs$lang$maxFixedArity = 3;

shared.fdb.history_query_async = (function shared$fdb$history_query_async(var_args){
var G__120384 = arguments.length;
switch (G__120384) {
case 2:
return shared.fdb.history_query_async.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shared.fdb.history_query_async.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.fdb.history_query_async.cljs$core$IFn$_invoke$arity$2 = (function (sources,query_map){
return shared.fdb.history_query_async.cljs$core$IFn$_invoke$arity$3(sources,query_map,null);
});

shared.fdb.history_query_async.cljs$core$IFn$_invoke$arity$3 = (function (sources,query_map,opts){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_120584){
var state_val_120585 = (state_120584[(1)]);
if((state_val_120585 === (7))){
var inst_120401 = (state_120584[(2)]);
var state_120584__$1 = state_120584;
var statearr_120586_120668 = state_120584__$1;
(statearr_120586_120668[(2)] = inst_120401);

(statearr_120586_120668[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (59))){
var inst_120582 = (state_120584[(2)]);
var state_120584__$1 = state_120584;
return cljs.core.async.impl.ioc_helpers.return_chan(state_120584__$1,inst_120582);
} else {
if((state_val_120585 === (20))){
var state_120584__$1 = state_120584;
var statearr_120587_120669 = state_120584__$1;
(statearr_120587_120669[(2)] = (-1));

(statearr_120587_120669[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (58))){
var inst_120574 = (state_120584[(7)]);
var state_120584__$1 = state_120584;
var statearr_120588_120670 = state_120584__$1;
(statearr_120588_120670[(2)] = inst_120574);

(statearr_120588_120670[(1)] = (59));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (27))){
var inst_120411 = (state_120584[(8)]);
var inst_120461 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120462 = [inst_120411];
var inst_120463 = (new cljs.core.PersistentVector(null,1,(5),inst_120461,inst_120462,null));
var state_120584__$1 = state_120584;
var statearr_120589_120671 = state_120584__$1;
(statearr_120589_120671[(2)] = inst_120463);

(statearr_120589_120671[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (1))){
var inst_120390 = (query_map == null);
var inst_120391 = cljs.core.not(inst_120390);
var state_120584__$1 = state_120584;
if(inst_120391){
var statearr_120590_120672 = state_120584__$1;
(statearr_120590_120672[(1)] = (2));

} else {
var statearr_120591_120673 = state_120584__$1;
(statearr_120591_120673[(1)] = (3));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (24))){
var inst_120415 = (state_120584[(9)]);
var inst_120456 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(inst_120415);
var state_120584__$1 = state_120584;
var statearr_120592_120674 = state_120584__$1;
(statearr_120592_120674[(2)] = inst_120456);

(statearr_120592_120674[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (55))){
var inst_120432 = (state_120584[(10)]);
var inst_120574 = (state_120584[(2)]);
var state_120584__$1 = (function (){var statearr_120593 = state_120584;
(statearr_120593[(7)] = inst_120574);

return statearr_120593;
})();
if(cljs.core.truth_(inst_120432)){
var statearr_120594_120675 = state_120584__$1;
(statearr_120594_120675[(1)] = (57));

} else {
var statearr_120595_120676 = state_120584__$1;
(statearr_120595_120676[(1)] = (58));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (39))){
var inst_120492 = (state_120584[(11)]);
var inst_120507 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120508 = [inst_120492,cljs.core.cst$kw$spot];
var inst_120509 = (new cljs.core.PersistentVector(null,2,(5),inst_120507,inst_120508,null));
var state_120584__$1 = state_120584;
var statearr_120596_120677 = state_120584__$1;
(statearr_120596_120677[(2)] = inst_120509);

(statearr_120596_120677[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (46))){
var state_120584__$1 = state_120584;
var statearr_120597_120678 = state_120584__$1;
(statearr_120597_120678[(1)] = (48));



return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (4))){
var inst_120404 = (state_120584[(2)]);
var state_120584__$1 = state_120584;
if(cljs.core.truth_(inst_120404)){
var statearr_120599_120679 = state_120584__$1;
(statearr_120599_120679[(1)] = (8));

} else {
var statearr_120600_120680 = state_120584__$1;
(statearr_120600_120680[(1)] = (9));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (54))){
var inst_120566 = (state_120584[(12)]);
var state_120584__$1 = state_120584;
var statearr_120601_120681 = state_120584__$1;
(statearr_120601_120681[(2)] = inst_120566);

(statearr_120601_120681[(1)] = (55));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (15))){
var inst_120419 = (state_120584[(2)]);
var inst_120420 = fluree.db.util.async.throw_err(inst_120419);
var state_120584__$1 = state_120584;
var statearr_120602_120682 = state_120584__$1;
(statearr_120602_120682[(2)] = inst_120420);

(statearr_120602_120682[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (48))){
var inst_120411 = (state_120584[(8)]);
var inst_120539 = ["History query not properly formatted. Must include at least an subject or predicate to query. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_120411)].join('');
var inst_120540 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_120541 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_120542 = cljs.core.PersistentHashMap.fromArrays(inst_120540,inst_120541);
var inst_120543 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_120539,inst_120542);
var inst_120544 = (function(){throw inst_120543})();
var state_120584__$1 = state_120584;
var statearr_120603_120683 = state_120584__$1;
(statearr_120603_120683[(2)] = inst_120544);

(statearr_120603_120683[(1)] = (50));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (50))){
var inst_120547 = (state_120584[(2)]);
var state_120584__$1 = state_120584;
var statearr_120604_120684 = state_120584__$1;
(statearr_120604_120684[(2)] = inst_120547);

(statearr_120604_120684[(1)] = (47));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (21))){
var inst_120425 = (state_120584[(13)]);
var inst_120448 = (state_120584[(2)]);
var state_120584__$1 = (function (){var statearr_120605 = state_120584;
(statearr_120605[(14)] = inst_120448);

return statearr_120605;
})();
if(cljs.core.truth_(inst_120425)){
var statearr_120606_120685 = state_120584__$1;
(statearr_120606_120685[(1)] = (23));

} else {
var statearr_120607_120686 = state_120584__$1;
(statearr_120607_120686[(1)] = (24));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (31))){
var state_120584__$1 = state_120584;
var statearr_120608_120687 = state_120584__$1;
(statearr_120608_120687[(1)] = (36));



return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (32))){
var inst_120490 = (state_120584[(2)]);
var state_120584__$1 = state_120584;
var statearr_120610_120688 = state_120584__$1;
(statearr_120610_120688[(2)] = inst_120490);

(statearr_120610_120688[(1)] = (29));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (40))){
var inst_120501 = (state_120584[(15)]);
var inst_120500 = (state_120584[(16)]);
var inst_120502 = (state_120584[(17)]);
var inst_120511 = (inst_120500 == null);
var inst_120512 = (inst_120501 == null);
var inst_120513 = cljs.core.not(inst_120512);
var inst_120514 = (inst_120502 == null);
var inst_120515 = ((inst_120511) && (inst_120513) && (inst_120514));
var state_120584__$1 = state_120584;
if(cljs.core.truth_(inst_120515)){
var statearr_120611_120689 = state_120584__$1;
(statearr_120611_120689[(1)] = (42));

} else {
var statearr_120612_120690 = state_120584__$1;
(statearr_120612_120690[(1)] = (43));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (56))){
var inst_120570 = (state_120584[(2)]);
var inst_120571 = fluree.db.util.async.throw_err(inst_120570);
var state_120584__$1 = state_120584;
var statearr_120613_120691 = state_120584__$1;
(statearr_120613_120691[(2)] = inst_120571);

(statearr_120613_120691[(1)] = (55));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (33))){
var inst_120411 = (state_120584[(8)]);
var inst_120469 = ["Please specify an subject for which to search history. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_120411)].join('');
var inst_120470 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_120471 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_120472 = cljs.core.PersistentHashMap.fromArrays(inst_120470,inst_120471);
var inst_120473 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_120469,inst_120472);
var inst_120474 = (function(){throw inst_120473})();
var state_120584__$1 = state_120584;
var statearr_120614_120692 = state_120584__$1;
(statearr_120614_120692[(2)] = inst_120474);

(statearr_120614_120692[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (13))){
var state_120584__$1 = state_120584;
var statearr_120615_120693 = state_120584__$1;
(statearr_120615_120693[(2)] = null);

(statearr_120615_120693[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (22))){
var inst_120442 = (state_120584[(2)]);
var inst_120443 = fluree.db.util.async.throw_err(inst_120442);
var inst_120444 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(inst_120443);
var inst_120445 = (inst_120444 - (1));
var state_120584__$1 = state_120584;
var statearr_120616_120694 = state_120584__$1;
(statearr_120616_120694[(2)] = inst_120445);

(statearr_120616_120694[(1)] = (21));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (36))){
var inst_120411 = (state_120584[(8)]);
var inst_120480 = ["History query not properly formatted. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_120411)].join('');
var inst_120481 = [cljs.core.cst$kw$status,cljs.core.cst$kw$error];
var inst_120482 = [(400),cljs.core.cst$kw$db_SLASH_invalid_DASH_query];
var inst_120483 = cljs.core.PersistentHashMap.fromArrays(inst_120481,inst_120482);
var inst_120484 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_120480,inst_120483);
var inst_120485 = (function(){throw inst_120484})();
var state_120584__$1 = state_120584;
var statearr_120617_120695 = state_120584__$1;
(statearr_120617_120695[(2)] = inst_120485);

(statearr_120617_120695[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (41))){
var inst_120458 = (state_120584[(18)]);
var inst_120415 = (state_120584[(9)]);
var inst_120448 = (state_120584[(14)]);
var inst_120553 = (state_120584[(2)]);
var inst_120554 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120553,(0),null);
var inst_120555 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120553,(1),null);
var inst_120556 = [cljs.core.cst$kw$from_DASH_t,cljs.core.cst$kw$to_DASH_t];
var inst_120557 = [inst_120448,inst_120458];
var inst_120558 = cljs.core.PersistentHashMap.fromArrays(inst_120556,inst_120557);
var inst_120559 = fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$5(inst_120415,inst_120555,cljs.core._EQ_,inst_120554,inst_120558);
var state_120584__$1 = state_120584;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120584__$1,(51),inst_120559);
} else {
if((state_val_120585 === (43))){
var inst_120501 = (state_120584[(15)]);
var inst_120500 = (state_120584[(16)]);
var inst_120502 = (state_120584[(17)]);
var inst_120524 = (inst_120500 == null);
var inst_120525 = (inst_120501 == null);
var inst_120526 = cljs.core.not(inst_120525);
var inst_120527 = (inst_120502 == null);
var inst_120528 = cljs.core.not(inst_120527);
var inst_120529 = ((inst_120524) && (inst_120526) && (inst_120528));
var state_120584__$1 = state_120584;
if(cljs.core.truth_(inst_120529)){
var statearr_120618_120696 = state_120584__$1;
(statearr_120618_120696[(1)] = (45));

} else {
var statearr_120619_120697 = state_120584__$1;
(statearr_120619_120697[(1)] = (46));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (29))){
var inst_120492 = (state_120584[(11)]);
var inst_120500 = (state_120584[(16)]);
var inst_120492__$1 = (state_120584[(2)]);
var inst_120493 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120494 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_120492__$1,(0));
var inst_120495 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_120492__$1,(1));
var inst_120496 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_120492__$1,(2));
var inst_120497 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_120492__$1,(3));
var inst_120498 = [inst_120494,inst_120495,inst_120496,inst_120497];
var inst_120499 = (new cljs.core.PersistentVector(null,4,(5),inst_120493,inst_120498,null));
var inst_120500__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120499,(0),null);
var inst_120501 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120499,(1),null);
var inst_120502 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120499,(2),null);
var inst_120503 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120499,(3),null);
var inst_120504 = (inst_120500__$1 == null);
var inst_120505 = cljs.core.not(inst_120504);
var state_120584__$1 = (function (){var statearr_120620 = state_120584;
(statearr_120620[(15)] = inst_120501);

(statearr_120620[(11)] = inst_120492__$1);

(statearr_120620[(16)] = inst_120500__$1);

(statearr_120620[(17)] = inst_120502);

(statearr_120620[(19)] = inst_120503);

return statearr_120620;
})();
if(inst_120505){
var statearr_120621_120698 = state_120584__$1;
(statearr_120621_120698[(1)] = (39));

} else {
var statearr_120622_120699 = state_120584__$1;
(statearr_120622_120699[(1)] = (40));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (44))){
var inst_120551 = (state_120584[(2)]);
var state_120584__$1 = state_120584;
var statearr_120623_120700 = state_120584__$1;
(statearr_120623_120700[(2)] = inst_120551);

(statearr_120623_120700[(1)] = (41));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (6))){
var state_120584__$1 = state_120584;
var statearr_120624_120701 = state_120584__$1;
(statearr_120624_120701[(2)] = false);

(statearr_120624_120701[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (28))){
var inst_120411 = (state_120584[(8)]);
var inst_120465 = cljs.core.sequential_QMARK_(inst_120411);
var state_120584__$1 = state_120584;
if(inst_120465){
var statearr_120625_120702 = state_120584__$1;
(statearr_120625_120702[(1)] = (30));

} else {
var statearr_120626_120703 = state_120584__$1;
(statearr_120626_120703[(1)] = (31));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (51))){
var inst_120562 = (state_120584[(20)]);
var inst_120415 = (state_120584[(9)]);
var inst_120561 = (state_120584[(2)]);
var inst_120562__$1 = fluree.db.util.async.throw_err(inst_120561);
var inst_120563 = shared.fdb.format_history_resp(inst_120415,inst_120562__$1);
var state_120584__$1 = (function (){var statearr_120627 = state_120584;
(statearr_120627[(20)] = inst_120562__$1);

return statearr_120627;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120584__$1,(52),inst_120563);
} else {
if((state_val_120585 === (25))){
var inst_120411 = (state_120584[(8)]);
var inst_120458 = (state_120584[(2)]);
var inst_120459 = fluree.db.util.core.subj_ident_QMARK_(inst_120411);
var state_120584__$1 = (function (){var statearr_120628 = state_120584;
(statearr_120628[(18)] = inst_120458);

return statearr_120628;
})();
if(inst_120459){
var statearr_120629_120704 = state_120584__$1;
(statearr_120629_120704[(1)] = (27));

} else {
var statearr_120630_120705 = state_120584__$1;
(statearr_120630_120705[(1)] = (28));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (34))){
var inst_120411 = (state_120584[(8)]);
var state_120584__$1 = state_120584;
var statearr_120631_120706 = state_120584__$1;
(statearr_120631_120706[(2)] = inst_120411);

(statearr_120631_120706[(1)] = (35));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (17))){
var inst_120424 = (state_120584[(21)]);
var state_120584__$1 = state_120584;
var statearr_120632_120707 = state_120584__$1;
(statearr_120632_120707[(2)] = inst_120424);

(statearr_120632_120707[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (3))){
var state_120584__$1 = state_120584;
var statearr_120633_120708 = state_120584__$1;
(statearr_120633_120708[(2)] = false);

(statearr_120633_120708[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (12))){
var inst_120415 = (state_120584[(9)]);
var inst_120417 = shared.fdb.resolve_block_range(inst_120415,query_map);
var state_120584__$1 = state_120584;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120584__$1,(15),inst_120417);
} else {
if((state_val_120585 === (2))){
var inst_120393 = query_map.cljs$lang$protocol_mask$partition0$;
var inst_120394 = (inst_120393 & (64));
var inst_120395 = query_map.cljs$core$ISeq$;
var inst_120396 = (cljs.core.PROTOCOL_SENTINEL === inst_120395);
var inst_120397 = ((inst_120394) || (inst_120396));
var state_120584__$1 = state_120584;
if(cljs.core.truth_(inst_120397)){
var statearr_120634_120709 = state_120584__$1;
(statearr_120634_120709[(1)] = (5));

} else {
var statearr_120635_120710 = state_120584__$1;
(statearr_120635_120710[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (23))){
var inst_120415 = (state_120584[(9)]);
var inst_120425 = (state_120584[(13)]);
var inst_120450 = fluree.db.time_travel.as_of_block(inst_120415,inst_120425);
var state_120584__$1 = state_120584;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120584__$1,(26),inst_120450);
} else {
if((state_val_120585 === (47))){
var inst_120549 = (state_120584[(2)]);
var state_120584__$1 = state_120584;
var statearr_120636_120711 = state_120584__$1;
(statearr_120636_120711[(2)] = inst_120549);

(statearr_120636_120711[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (35))){
var inst_120477 = (state_120584[(2)]);
var state_120584__$1 = state_120584;
var statearr_120637_120712 = state_120584__$1;
(statearr_120637_120712[(2)] = inst_120477);

(statearr_120637_120712[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (19))){
var inst_120415 = (state_120584[(9)]);
var inst_120424 = (state_120584[(21)]);
var inst_120439 = (inst_120424 - (1));
var inst_120440 = fluree.db.time_travel.as_of_block(inst_120415,inst_120439);
var state_120584__$1 = state_120584;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120584__$1,(22),inst_120440);
} else {
if((state_val_120585 === (57))){
var inst_120562 = (state_120584[(20)]);
var inst_120574 = (state_120584[(7)]);
var inst_120576 = [cljs.core.cst$kw$result,cljs.core.cst$kw$fuel,cljs.core.cst$kw$status];
var inst_120577 = cljs.core.count(inst_120562);
var inst_120578 = [inst_120574,inst_120577,(200)];
var inst_120579 = cljs.core.PersistentHashMap.fromArrays(inst_120576,inst_120578);
var state_120584__$1 = state_120584;
var statearr_120638_120713 = state_120584__$1;
(statearr_120638_120713[(2)] = inst_120579);

(statearr_120638_120713[(1)] = (59));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (11))){
var inst_120410 = (state_120584[(22)]);
var inst_120414 = (state_120584[(2)]);
var inst_120415 = fluree.db.util.async.throw_err(inst_120414);
var state_120584__$1 = (function (){var statearr_120639 = state_120584;
(statearr_120639[(9)] = inst_120415);

return statearr_120639;
})();
if(cljs.core.truth_(inst_120410)){
var statearr_120640_120714 = state_120584__$1;
(statearr_120640_120714[(1)] = (12));

} else {
var statearr_120641_120715 = state_120584__$1;
(statearr_120641_120715[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (9))){
var state_120584__$1 = state_120584;
var statearr_120642_120716 = state_120584__$1;
(statearr_120642_120716[(2)] = query_map);

(statearr_120642_120716[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (5))){
var state_120584__$1 = state_120584;
var statearr_120643_120717 = state_120584__$1;
(statearr_120643_120717[(2)] = true);

(statearr_120643_120717[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (14))){
var inst_120424 = (state_120584[(21)]);
var inst_120423 = (state_120584[(2)]);
var inst_120424__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120423,(0),null);
var inst_120425 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(inst_120423,(1),null);
var inst_120432 = cljs.core.cst$kw$meta.cljs$core$IFn$_invoke$arity$1(opts);
var state_120584__$1 = (function (){var statearr_120644 = state_120584;
(statearr_120644[(10)] = inst_120432);

(statearr_120644[(21)] = inst_120424__$1);

(statearr_120644[(13)] = inst_120425);

return statearr_120644;
})();
if(cljs.core.truth_(inst_120424__$1)){
var statearr_120645_120718 = state_120584__$1;
(statearr_120645_120718[(1)] = (16));

} else {
var statearr_120646_120719 = state_120584__$1;
(statearr_120646_120719[(1)] = (17));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (45))){
var inst_120501 = (state_120584[(15)]);
var inst_120500 = (state_120584[(16)]);
var inst_120502 = (state_120584[(17)]);
var inst_120503 = (state_120584[(19)]);
var inst_120531 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120532 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120533 = [inst_120501,inst_120502,inst_120500,inst_120503];
var inst_120534 = (new cljs.core.PersistentVector(null,4,(5),inst_120532,inst_120533,null));
var inst_120535 = [inst_120534,cljs.core.cst$kw$post];
var inst_120536 = (new cljs.core.PersistentVector(null,2,(5),inst_120531,inst_120535,null));
var state_120584__$1 = state_120584;
var statearr_120647_120720 = state_120584__$1;
(statearr_120647_120720[(2)] = inst_120536);

(statearr_120647_120720[(1)] = (47));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (53))){
var inst_120566 = (state_120584[(12)]);
var inst_120415 = (state_120584[(9)]);
var inst_120568 = shared.fdb.format_block_resp_pretty(inst_120415,inst_120566);
var state_120584__$1 = state_120584;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120584__$1,(56),inst_120568);
} else {
if((state_val_120585 === (26))){
var inst_120452 = (state_120584[(2)]);
var inst_120453 = fluree.db.util.async.throw_err(inst_120452);
var inst_120454 = cljs.core.cst$kw$t.cljs$core$IFn$_invoke$arity$1(inst_120453);
var state_120584__$1 = state_120584;
var statearr_120648_120721 = state_120584__$1;
(statearr_120648_120721[(2)] = inst_120454);

(statearr_120648_120721[(1)] = (25));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (16))){
var inst_120424 = (state_120584[(21)]);
var inst_120434 = cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2((1),inst_120424);
var state_120584__$1 = state_120584;
var statearr_120649_120722 = state_120584__$1;
(statearr_120649_120722[(2)] = inst_120434);

(statearr_120649_120722[(1)] = (18));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (38))){
var inst_120488 = (state_120584[(2)]);
var state_120584__$1 = state_120584;
var statearr_120650_120723 = state_120584__$1;
(statearr_120650_120723[(2)] = inst_120488);

(statearr_120650_120723[(1)] = (32));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (30))){
var inst_120411 = (state_120584[(8)]);
var inst_120467 = cljs.core.empty_QMARK_(inst_120411);
var state_120584__$1 = state_120584;
if(inst_120467){
var statearr_120651_120724 = state_120584__$1;
(statearr_120651_120724[(1)] = (33));

} else {
var statearr_120652_120725 = state_120584__$1;
(statearr_120652_120725[(1)] = (34));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (10))){
var inst_120409 = (state_120584[(2)]);
var inst_120410 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_120409,cljs.core.cst$kw$block);
var inst_120411 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_120409,cljs.core.cst$kw$history);
var inst_120412 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(inst_120409,cljs.core.cst$kw$prettyPrint);
var state_120584__$1 = (function (){var statearr_120653 = state_120584;
(statearr_120653[(23)] = inst_120412);

(statearr_120653[(8)] = inst_120411);

(statearr_120653[(22)] = inst_120410);

return statearr_120653;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120584__$1,(11),sources);
} else {
if((state_val_120585 === (18))){
var inst_120437 = (state_120584[(2)]);
var state_120584__$1 = state_120584;
if(cljs.core.truth_(inst_120437)){
var statearr_120654_120726 = state_120584__$1;
(statearr_120654_120726[(1)] = (19));

} else {
var statearr_120655_120727 = state_120584__$1;
(statearr_120655_120727[(1)] = (20));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (52))){
var inst_120412 = (state_120584[(23)]);
var inst_120565 = (state_120584[(2)]);
var inst_120566 = fluree.db.util.async.throw_err(inst_120565);
var state_120584__$1 = (function (){var statearr_120656 = state_120584;
(statearr_120656[(12)] = inst_120566);

return statearr_120656;
})();
if(cljs.core.truth_(inst_120412)){
var statearr_120657_120728 = state_120584__$1;
(statearr_120657_120728[(1)] = (53));

} else {
var statearr_120658_120729 = state_120584__$1;
(statearr_120658_120729[(1)] = (54));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (42))){
var inst_120501 = (state_120584[(15)]);
var inst_120500 = (state_120584[(16)]);
var inst_120502 = (state_120584[(17)]);
var inst_120503 = (state_120584[(19)]);
var inst_120517 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120518 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120519 = [inst_120501,inst_120500,inst_120502,inst_120503];
var inst_120520 = (new cljs.core.PersistentVector(null,4,(5),inst_120518,inst_120519,null));
var inst_120521 = [inst_120520,cljs.core.cst$kw$psot];
var inst_120522 = (new cljs.core.PersistentVector(null,2,(5),inst_120517,inst_120521,null));
var state_120584__$1 = state_120584;
var statearr_120659_120730 = state_120584__$1;
(statearr_120659_120730[(2)] = inst_120522);

(statearr_120659_120730[(1)] = (44));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (37))){
var state_120584__$1 = state_120584;
var statearr_120660_120731 = state_120584__$1;
(statearr_120660_120731[(2)] = null);

(statearr_120660_120731[(1)] = (38));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (8))){
var inst_120406 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,query_map);
var state_120584__$1 = state_120584;
var statearr_120661_120732 = state_120584__$1;
(statearr_120661_120732[(2)] = inst_120406);

(statearr_120661_120732[(1)] = (10));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120585 === (49))){
var state_120584__$1 = state_120584;
var statearr_120662_120733 = state_120584__$1;
(statearr_120662_120733[(2)] = null);

(statearr_120662_120733[(1)] = (50));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$fdb$state_machine__99703__auto__ = null;
var shared$fdb$state_machine__99703__auto____0 = (function (){
var statearr_120663 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_120663[(0)] = shared$fdb$state_machine__99703__auto__);

(statearr_120663[(1)] = (1));

return statearr_120663;
});
var shared$fdb$state_machine__99703__auto____1 = (function (state_120584){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_120584);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e120664){if((e120664 instanceof Object)){
var ex__99706__auto__ = e120664;
var statearr_120665_120734 = state_120584;
(statearr_120665_120734[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_120584);

return cljs.core.cst$kw$recur;
} else {
throw e120664;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__120735 = state_120584;
state_120584 = G__120735;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$state_machine__99703__auto__ = function(state_120584){
switch(arguments.length){
case 0:
return shared$fdb$state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$state_machine__99703__auto____1.call(this,state_120584);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$state_machine__99703__auto____0;
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$state_machine__99703__auto____1;
return shared$fdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_120666 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_120666[(6)] = c__99809__auto__);

return statearr_120666;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

shared.fdb.history_query_async.cljs$lang$maxFixedArity = 3;

/**
 * Returns an asynchronous channel that eventually contains the result or an error.
 * 
 *   The db function, required to evaluate prefixes/multiple sources, is passed
 *   as a parameter.  This allows for the node.js version to override the
 *   default [shared.fdb.db] with its own function.
 *   
 */
shared.fdb.multi_query_async = (function shared$fdb$multi_query_async(var_args){
var G__120743 = arguments.length;
switch (G__120743) {
case 2:
return shared.fdb.multi_query_async.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return shared.fdb.multi_query_async.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return shared.fdb.multi_query_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.fdb.multi_query_async.cljs$core$IFn$_invoke$arity$2 = (function (sources,multi_query_map){
return shared.fdb.multi_query_async.cljs$core$IFn$_invoke$arity$4(sources,multi_query_map,null,shared.fdb.db);
});

shared.fdb.multi_query_async.cljs$core$IFn$_invoke$arity$3 = (function (sources,multi_query_map,opts){
return shared.fdb.multi_query_async.cljs$core$IFn$_invoke$arity$4(sources,multi_query_map,opts,shared.fdb.db);
});

shared.fdb.multi_query_async.cljs$core$IFn$_invoke$arity$4 = (function (sources,multi_query_map,opts,db_fn){
var db = sources;
var block = (function (){var temp__5735__auto__ = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(multi_query_map);
if(cljs.core.truth_(temp__5735__auto__)){
var block = temp__5735__auto__;
return fluree.db.util.async.throw_err(cljs.core.async._LT__BANG_(fluree.db.time_travel.block_to_int_format(fluree.db.util.async.throw_err(cljs.core.async._LT__BANG_(db)),block)));
} else {
return null;
}
})();
var meta_QMARK_ = cljs.core.cst$kw$meta.cljs$core$IFn$_invoke$arity$1(opts);
var _ = (cljs.core.truth_((function (){var and__4120__auto__ = block;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.map_QMARK_(block);
} else {
return and__4120__auto__;
}
})())?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Block is a reserved keyword. Please choose another name for your query. ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error], null))})():null);
var ___$1 = (cljs.core.truth_((function (){var and__4120__auto__ = block;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.coll_QMARK_(block);
} else {
return and__4120__auto__;
}
})())?(function(){throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(["Query block must be a string or integer. Block: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(block)].join(''),new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(500),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_unexpected_DASH_error], null))})():null);
var multi_query_map_SINGLEQUOTE_ = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(multi_query_map,cljs.core.cst$kw$block);
var vals_SINGLEQUOTE_ = cljs.core.map.cljs$core$IFn$_invoke$arity$2(((function (db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_){
return (function (p1__120736_SHARP_){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(p1__120736_SHARP_,cljs.core.cst$kw$block);
});})(db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_))
,cljs.core.vals(multi_query_map_SINGLEQUOTE_));
var keys_SINGLEQUOTE_ = cljs.core.keys(multi_query_map_SINGLEQUOTE_);
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function (state_120829){
var state_val_120830 = (state_120829[(1)]);
if((state_val_120830 === (7))){
var inst_120786 = (state_120829[(7)]);
var inst_120790 = (state_120829[(8)]);
var inst_120783 = (state_120829[(9)]);
var inst_120780 = (state_120829[(10)]);
var inst_120796 = (function (){var responses = inst_120780;
var responses_STAR_ = inst_120783;
var statuses = inst_120786;
var fuel = inst_120790;
return ((function (responses,responses_STAR_,statuses,fuel,inst_120786,inst_120790,inst_120783,inst_120780,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function (p1__120739_SHARP_){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((200),p1__120739_SHARP_);
});
;})(responses,responses_STAR_,statuses,fuel,inst_120786,inst_120790,inst_120783,inst_120780,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
})();
var inst_120797 = cljs.core.some(inst_120796,inst_120786);
var state_120829__$1 = state_120829;
if(cljs.core.truth_(inst_120797)){
var statearr_120831_120877 = state_120829__$1;
(statearr_120831_120877[(1)] = (9));

} else {
var statearr_120832_120878 = state_120829__$1;
(statearr_120832_120878[(1)] = (10));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (20))){
var inst_120824 = (state_120829[(2)]);
var state_120829__$1 = state_120829;
var statearr_120833_120879 = state_120829__$1;
(statearr_120833_120879[(2)] = inst_120824);

(statearr_120833_120879[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (1))){
var inst_120775 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
var inst_120776 = (function (){var c__99809__auto____$1 = inst_120775;
return ((function (c__99809__auto____$1,inst_120775,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto____$1,inst_120775,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function (state_120773){
var state_val_120774 = (state_120773[(1)]);
if((state_val_120774 === (1))){
var inst_120744 = cljs.core.first(keys_SINGLEQUOTE_);
var inst_120745 = cljs.core.first(vals_SINGLEQUOTE_);
var inst_120746 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_120745,cljs.core.cst$kw$block,block);
var inst_120747 = cljs.core.rest(keys_SINGLEQUOTE_);
var inst_120748 = cljs.core.rest(vals_SINGLEQUOTE_);
var inst_120749 = cljs.core.PersistentHashMap.EMPTY;
var inst_120750 = inst_120744;
var inst_120751 = inst_120746;
var inst_120752 = inst_120747;
var inst_120753 = inst_120748;
var inst_120754 = inst_120749;
var state_120773__$1 = (function (){var statearr_120834 = state_120773;
(statearr_120834[(7)] = inst_120750);

(statearr_120834[(8)] = inst_120751);

(statearr_120834[(9)] = inst_120753);

(statearr_120834[(10)] = inst_120752);

(statearr_120834[(11)] = inst_120754);

return statearr_120834;
})();
var statearr_120835_120880 = state_120773__$1;
(statearr_120835_120880[(2)] = null);

(statearr_120835_120880[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120774 === (2))){
var inst_120751 = (state_120773[(8)]);
var inst_120756 = shared.fdb.query_async.cljs$core$IFn$_invoke$arity$4(db,inst_120751,opts,db_fn);
var state_120773__$1 = state_120773;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120773__$1,(4),inst_120756);
} else {
if((state_val_120774 === (3))){
var inst_120771 = (state_120773[(2)]);
var state_120773__$1 = state_120773;
return cljs.core.async.impl.ioc_helpers.return_chan(state_120773__$1,inst_120771);
} else {
if((state_val_120774 === (4))){
var inst_120750 = (state_120773[(7)]);
var inst_120752 = (state_120773[(10)]);
var inst_120754 = (state_120773[(11)]);
var inst_120758 = (state_120773[(2)]);
var inst_120759 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_120754,inst_120750,inst_120758);
var inst_120760 = cljs.core.first(inst_120752);
var state_120773__$1 = (function (){var statearr_120836 = state_120773;
(statearr_120836[(12)] = inst_120759);

return statearr_120836;
})();
if(cljs.core.truth_(inst_120760)){
var statearr_120837_120881 = state_120773__$1;
(statearr_120837_120881[(1)] = (5));

} else {
var statearr_120838_120882 = state_120773__$1;
(statearr_120838_120882[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120774 === (5))){
var inst_120759 = (state_120773[(12)]);
var inst_120753 = (state_120773[(9)]);
var inst_120752 = (state_120773[(10)]);
var inst_120762 = cljs.core.first(inst_120752);
var inst_120763 = cljs.core.first(inst_120753);
var inst_120764 = cljs.core.rest(inst_120752);
var inst_120765 = cljs.core.rest(inst_120753);
var inst_120750 = inst_120762;
var inst_120751 = inst_120763;
var inst_120752__$1 = inst_120764;
var inst_120753__$1 = inst_120765;
var inst_120754 = inst_120759;
var state_120773__$1 = (function (){var statearr_120839 = state_120773;
(statearr_120839[(7)] = inst_120750);

(statearr_120839[(8)] = inst_120751);

(statearr_120839[(9)] = inst_120753__$1);

(statearr_120839[(10)] = inst_120752__$1);

(statearr_120839[(11)] = inst_120754);

return statearr_120839;
})();
var statearr_120840_120883 = state_120773__$1;
(statearr_120840_120883[(2)] = null);

(statearr_120840_120883[(1)] = (2));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120774 === (6))){
var inst_120759 = (state_120773[(12)]);
var state_120773__$1 = state_120773;
var statearr_120841_120884 = state_120773__$1;
(statearr_120841_120884[(2)] = inst_120759);

(statearr_120841_120884[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120774 === (7))){
var inst_120769 = (state_120773[(2)]);
var state_120773__$1 = state_120773;
var statearr_120842_120885 = state_120773__$1;
(statearr_120842_120885[(2)] = inst_120769);

(statearr_120842_120885[(1)] = (3));


return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
});})(c__99809__auto____$1,inst_120775,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
;
return ((function (switch__99702__auto__,c__99809__auto____$1,inst_120775,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function() {
var shared$fdb$state_machine__99703__auto__ = null;
var shared$fdb$state_machine__99703__auto____0 = (function (){
var statearr_120843 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_120843[(0)] = shared$fdb$state_machine__99703__auto__);

(statearr_120843[(1)] = (1));

return statearr_120843;
});
var shared$fdb$state_machine__99703__auto____1 = (function (state_120773){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_120773);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e120844){if((e120844 instanceof Object)){
var ex__99706__auto__ = e120844;
var statearr_120845_120886 = state_120773;
(statearr_120845_120886[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_120773);

return cljs.core.cst$kw$recur;
} else {
throw e120844;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__120887 = state_120773;
state_120773 = G__120887;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$state_machine__99703__auto__ = function(state_120773){
switch(arguments.length){
case 0:
return shared$fdb$state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$state_machine__99703__auto____1.call(this,state_120773);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$state_machine__99703__auto____0;
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$state_machine__99703__auto____1;
return shared$fdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto____$1,inst_120775,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
})();
var state__99811__auto__ = (function (){var statearr_120846 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_120846[(6)] = c__99809__auto____$1);

return statearr_120846;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});
;})(c__99809__auto____$1,inst_120775,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
})();
var inst_120777 = cljs.core.async.impl.dispatch.run(inst_120776);
var state_120829__$1 = (function (){var statearr_120847 = state_120829;
(statearr_120847[(11)] = inst_120777);

return statearr_120847;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120829__$1,(2),inst_120775);
} else {
if((state_val_120830 === (4))){
var inst_120780 = (state_120829[(10)]);
var state_120829__$1 = state_120829;
var statearr_120848_120888 = state_120829__$1;
(statearr_120848_120888[(2)] = inst_120780);

(statearr_120848_120888[(1)] = (5));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (15))){
var state_120829__$1 = state_120829;
var statearr_120849_120889 = state_120829__$1;
(statearr_120849_120889[(2)] = (400));

(statearr_120849_120889[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (13))){
var state_120829__$1 = state_120829;
var statearr_120850_120890 = state_120829__$1;
(statearr_120850_120890[(1)] = (15));



return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (6))){
var inst_120786 = (state_120829[(7)]);
var inst_120794 = cljs.core.first(inst_120786);
var state_120829__$1 = state_120829;
var statearr_120852_120891 = state_120829__$1;
(statearr_120852_120891[(2)] = inst_120794);

(statearr_120852_120891[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (17))){
var inst_120807 = (state_120829[(2)]);
var state_120829__$1 = state_120829;
var statearr_120853_120892 = state_120829__$1;
(statearr_120853_120892[(2)] = inst_120807);

(statearr_120853_120892[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (3))){
var inst_120786 = (state_120829[(7)]);
var inst_120790 = (state_120829[(8)]);
var inst_120783 = (state_120829[(9)]);
var inst_120780 = (state_120829[(10)]);
var inst_120785 = cljs.core.vals(inst_120780);
var inst_120786__$1 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(cljs.core.cst$kw$status,inst_120785);
var inst_120787 = (function (){var responses = inst_120780;
var responses_STAR_ = inst_120783;
var statuses = inst_120786__$1;
return ((function (responses,responses_STAR_,statuses,inst_120786,inst_120790,inst_120783,inst_120780,inst_120785,inst_120786__$1,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function (p1__120737_SHARP_){
var or__4131__auto__ = cljs.core.cst$kw$fuel.cljs$core$IFn$_invoke$arity$1(p1__120737_SHARP_);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (0);
}
});
;})(responses,responses_STAR_,statuses,inst_120786,inst_120790,inst_120783,inst_120780,inst_120785,inst_120786__$1,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
})();
var inst_120788 = cljs.core.vals(inst_120780);
var inst_120789 = cljs.core.map.cljs$core$IFn$_invoke$arity$2(inst_120787,inst_120788);
var inst_120790__$1 = cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core._PLUS_,inst_120789);
var inst_120791 = (function (){var responses = inst_120780;
var responses_STAR_ = inst_120783;
var statuses = inst_120786__$1;
var fuel = inst_120790__$1;
return ((function (responses,responses_STAR_,statuses,fuel,inst_120786,inst_120790,inst_120783,inst_120780,inst_120785,inst_120786__$1,inst_120787,inst_120788,inst_120789,inst_120790__$1,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function (p1__120738_SHARP_){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(cljs.core.first(statuses),p1__120738_SHARP_);
});
;})(responses,responses_STAR_,statuses,fuel,inst_120786,inst_120790,inst_120783,inst_120780,inst_120785,inst_120786__$1,inst_120787,inst_120788,inst_120789,inst_120790__$1,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
})();
var inst_120792 = cljs.core.every_QMARK_(inst_120791,inst_120786__$1);
var state_120829__$1 = (function (){var statearr_120854 = state_120829;
(statearr_120854[(7)] = inst_120786__$1);

(statearr_120854[(8)] = inst_120790__$1);

return statearr_120854;
})();
if(inst_120792){
var statearr_120855_120893 = state_120829__$1;
(statearr_120855_120893[(1)] = (6));

} else {
var statearr_120856_120894 = state_120829__$1;
(statearr_120856_120894[(1)] = (7));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (12))){
var state_120829__$1 = state_120829;
var statearr_120857_120895 = state_120829__$1;
(statearr_120857_120895[(2)] = (500));

(statearr_120857_120895[(1)] = (14));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (2))){
var inst_120780 = (state_120829[(10)]);
var inst_120779 = (state_120829[(2)]);
var inst_120780__$1 = fluree.db.util.async.throw_err(inst_120779);
var inst_120781 = (function (){var responses = inst_120780__$1;
return ((function (responses,inst_120780,inst_120779,inst_120780__$1,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function (acc,index,response){
var resp = (function (){var or__4131__auto__ = cljs.core.cst$kw$result.cljs$core$IFn$_invoke$arity$1(response);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return response;
}
})();
if(cljs.core.truth_(meta_QMARK_)){
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((200),cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(response))){
return cljs.core.assoc_in(acc,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$result,index], null),resp);
} else {
return cljs.core.assoc_in(acc,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.cst$kw$errors,index], null),cljs.core.cst$kw$error.cljs$core$IFn$_invoke$arity$1(response));
}
} else {
return cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(acc,index,resp);
}
});
;})(responses,inst_120780,inst_120779,inst_120780__$1,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
})();
var inst_120782 = cljs.core.PersistentHashMap.EMPTY;
var inst_120783 = cljs.core.reduce_kv(inst_120781,inst_120782,inst_120780__$1);
var state_120829__$1 = (function (){var statearr_120858 = state_120829;
(statearr_120858[(9)] = inst_120783);

(statearr_120858[(10)] = inst_120780__$1);

return statearr_120858;
})();
if(cljs.core.truth_(meta_QMARK_)){
var statearr_120859_120896 = state_120829__$1;
(statearr_120859_120896[(1)] = (3));

} else {
var statearr_120860_120897 = state_120829__$1;
(statearr_120860_120897[(1)] = (4));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (19))){
var inst_120813 = (state_120829[(12)]);
var inst_120790 = (state_120829[(8)]);
var inst_120783 = (state_120829[(9)]);
var inst_120822 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(inst_120783,cljs.core.cst$kw$status,inst_120813,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$fuel,inst_120790], 0));
var state_120829__$1 = state_120829;
var statearr_120861_120898 = state_120829__$1;
(statearr_120861_120898[(2)] = inst_120822);

(statearr_120861_120898[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (11))){
var inst_120811 = (state_120829[(2)]);
var state_120829__$1 = state_120829;
var statearr_120862_120899 = state_120829__$1;
(statearr_120862_120899[(2)] = inst_120811);

(statearr_120862_120899[(1)] = (8));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (9))){
var state_120829__$1 = state_120829;
var statearr_120863_120900 = state_120829__$1;
(statearr_120863_120900[(2)] = (207));

(statearr_120863_120900[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (5))){
var inst_120827 = (state_120829[(2)]);
var state_120829__$1 = state_120829;
return cljs.core.async.impl.ioc_helpers.return_chan(state_120829__$1,inst_120827);
} else {
if((state_val_120830 === (14))){
var inst_120809 = (state_120829[(2)]);
var state_120829__$1 = state_120829;
var statearr_120864_120901 = state_120829__$1;
(statearr_120864_120901[(2)] = inst_120809);

(statearr_120864_120901[(1)] = (11));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (16))){
var state_120829__$1 = state_120829;
var statearr_120865_120902 = state_120829__$1;
(statearr_120865_120902[(2)] = null);

(statearr_120865_120902[(1)] = (17));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (10))){
var inst_120786 = (state_120829[(7)]);
var inst_120790 = (state_120829[(8)]);
var inst_120783 = (state_120829[(9)]);
var inst_120780 = (state_120829[(10)]);
var inst_120800 = (function (){var responses = inst_120780;
var responses_STAR_ = inst_120783;
var statuses = inst_120786;
var fuel = inst_120790;
return ((function (responses,responses_STAR_,statuses,fuel,inst_120786,inst_120790,inst_120783,inst_120780,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function (p1__120740_SHARP_){
return ((499) < p1__120740_SHARP_);
});
;})(responses,responses_STAR_,statuses,fuel,inst_120786,inst_120790,inst_120783,inst_120780,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
})();
var inst_120801 = cljs.core.some(inst_120800,inst_120786);
var state_120829__$1 = state_120829;
if(cljs.core.truth_(inst_120801)){
var statearr_120866_120903 = state_120829__$1;
(statearr_120866_120903[(1)] = (12));

} else {
var statearr_120867_120904 = state_120829__$1;
(statearr_120867_120904[(1)] = (13));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (18))){
var inst_120813 = (state_120829[(12)]);
var inst_120790 = (state_120829[(8)]);
var inst_120783 = (state_120829[(9)]);
var inst_120818 = (state_120829[(13)]);
var inst_120820 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(inst_120783,cljs.core.cst$kw$status,inst_120813,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([cljs.core.cst$kw$fuel,inst_120790,cljs.core.cst$kw$block,inst_120818], 0));
var state_120829__$1 = state_120829;
var statearr_120868_120905 = state_120829__$1;
(statearr_120868_120905[(2)] = inst_120820);

(statearr_120868_120905[(1)] = (20));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120830 === (8))){
var inst_120813 = (state_120829[(12)]);
var inst_120786 = (state_120829[(7)]);
var inst_120790 = (state_120829[(8)]);
var inst_120783 = (state_120829[(9)]);
var inst_120818 = (state_120829[(13)]);
var inst_120780 = (state_120829[(10)]);
var inst_120813__$1 = (state_120829[(2)]);
var inst_120814 = (function (){var responses = inst_120780;
var responses_STAR_ = inst_120783;
var statuses = inst_120786;
var fuel = inst_120790;
var status = inst_120813__$1;
return ((function (responses,responses_STAR_,statuses,fuel,status,inst_120813,inst_120786,inst_120790,inst_120783,inst_120818,inst_120780,inst_120813__$1,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function (p1__120741_SHARP_){
return cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((200),cljs.core.cst$kw$status.cljs$core$IFn$_invoke$arity$1(p1__120741_SHARP_));
});
;})(responses,responses_STAR_,statuses,fuel,status,inst_120813,inst_120786,inst_120790,inst_120783,inst_120818,inst_120780,inst_120813__$1,state_val_120830,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
})();
var inst_120815 = cljs.core.vals(inst_120780);
var inst_120816 = cljs.core.filter.cljs$core$IFn$_invoke$arity$2(inst_120814,inst_120815);
var inst_120817 = cljs.core.first(inst_120816);
var inst_120818__$1 = cljs.core.cst$kw$block.cljs$core$IFn$_invoke$arity$1(inst_120817);
var state_120829__$1 = (function (){var statearr_120869 = state_120829;
(statearr_120869[(12)] = inst_120813__$1);

(statearr_120869[(13)] = inst_120818__$1);

return statearr_120869;
})();
if(cljs.core.truth_(inst_120818__$1)){
var statearr_120870_120906 = state_120829__$1;
(statearr_120870_120906[(1)] = (18));

} else {
var statearr_120871_120907 = state_120829__$1;
(statearr_120871_120907[(1)] = (19));

}

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
;
return ((function (switch__99702__auto__,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_){
return (function() {
var shared$fdb$state_machine__99703__auto__ = null;
var shared$fdb$state_machine__99703__auto____0 = (function (){
var statearr_120872 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_120872[(0)] = shared$fdb$state_machine__99703__auto__);

(statearr_120872[(1)] = (1));

return statearr_120872;
});
var shared$fdb$state_machine__99703__auto____1 = (function (state_120829){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_120829);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e120873){if((e120873 instanceof Object)){
var ex__99706__auto__ = e120873;
var statearr_120874_120908 = state_120829;
(statearr_120874_120908[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_120829);

return cljs.core.cst$kw$recur;
} else {
throw e120873;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__120909 = state_120829;
state_120829 = G__120909;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$state_machine__99703__auto__ = function(state_120829){
switch(arguments.length){
case 0:
return shared$fdb$state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$state_machine__99703__auto____1.call(this,state_120829);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$state_machine__99703__auto____0;
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$state_machine__99703__auto____1;
return shared$fdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
})();
var state__99811__auto__ = (function (){var statearr_120875 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_120875[(6)] = c__99809__auto__);

return statearr_120875;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__,db,block,meta_QMARK_,_,___$1,multi_query_map_SINGLEQUOTE_,vals_SINGLEQUOTE_,keys_SINGLEQUOTE_))
);

return c__99809__auto__;
});

shared.fdb.multi_query_async.cljs$lang$maxFixedArity = 4;

/**
 * Helper function to fill out the parts of the query that are incomplete,
 *   producing a signed command.
 * 
 *   Optional opts is a map with the following keys. If not provided,
 *   defaults will be attempted.
 *   - auth        - The auth id for the auth record being used. The private key must
 *                correspond to this auth record, or an authority of this auth record.
 *   - expire      - When this transaction should expire if not yet attempted.
 *                Defaults to 5 minutes.
 *   - nonce       - Any long/64-bit integer value that will make this transaction unique.
 *                By default epoch milliseconds is used.
 *   - deps        - Not yet implemented, list of dependent transactions.
 * 
 *   If successful, will return a map with four keys:
 *  - cmd  - a map with the command/transaction data as a JSON string
 *  - sig  - the signature of the above stringified map
 *  - id   - the ID for this unique request - in case you want to look it up later, sha3 of 'cmd'
 *  - db   - the ledger for this transaction
 */
shared.fdb.qry__GT_command = (function shared$fdb$qry__GT_command(var_args){
var G__120911 = arguments.length;
switch (G__120911) {
case 3:
return shared.fdb.qry__GT_command.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return shared.fdb.qry__GT_command.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.fdb.qry__GT_command.cljs$core$IFn$_invoke$arity$3 = (function (ledger,qry_map,private_key){
return shared.fdb.qry__GT_command.cljs$core$IFn$_invoke$arity$4(ledger,qry_map,private_key,null);
});

shared.fdb.qry__GT_command.cljs$core$IFn$_invoke$arity$4 = (function (ledger,qry_map,private_key,opts){
if(cljs.core.truth_(private_key)){
} else {
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Private key not provided and no default present on connection",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_signed_DASH_query], null));
}

var db_name = ((cljs.core.sequential_QMARK_(ledger))?[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.first(ledger)),"/$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.second(ledger))].join(''):ledger);
var map__120912 = opts;
var map__120912__$1 = (((((!((map__120912 == null))))?(((((map__120912.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__120912.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.cljs$core$IFn$_invoke$arity$2(cljs.core.hash_map,map__120912):map__120912);
var auth = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__120912__$1,cljs.core.cst$kw$auth);
var expire = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__120912__$1,cljs.core.cst$kw$expire);
var nonce = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__120912__$1,cljs.core.cst$kw$nonce);
var action = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__120912__$1,cljs.core.cst$kw$action);
var key_auth_id = fluree.crypto.account_id_from_private(private_key);
var vec__120913 = (cljs.core.truth_((function (){var and__4120__auto__ = auth;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(auth,key_auth_id);
} else {
return and__4120__auto__;
}
})())?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [auth,key_auth_id], null):(cljs.core.truth_(auth)?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [auth,null], null):new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [key_auth_id,null], null)
));
var auth__$1 = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__120913,(0),null);
var authority = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__120913,(1),null);
var action__$1 = (function (){var or__4131__auto__ = action;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.cst$kw$query;
}
})();
var timestamp = fluree.db.util.core.current_time_millis();
var nonce__$1 = (function (){var or__4131__auto__ = nonce;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return timestamp;
}
})();
var expire__$1 = (function (){var or__4131__auto__ = expire;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (timestamp + (30000));
}
})();
var cmd = (function (){try{return fluree.db.util.json.stringify(fluree.db.util.core.without_nils(new cljs.core.PersistentArrayMap(null, 8, [cljs.core.cst$kw$type,cljs.core.cst$kw$signed_DASH_qry,cljs.core.cst$kw$action,action__$1,cljs.core.cst$kw$db,db_name,cljs.core.cst$kw$qry,qry_map,cljs.core.cst$kw$nonce,nonce__$1,cljs.core.cst$kw$auth,auth__$1,cljs.core.cst$kw$authority,authority,cljs.core.cst$kw$expire,expire__$1], null)));
}catch (e120917){var e = e120917;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Signed query contains data that cannot be serialized into JSON.",new cljs.core.PersistentArrayMap(null, 2, [cljs.core.cst$kw$status,(400),cljs.core.cst$kw$error,cljs.core.cst$kw$db_SLASH_invalid_DASH_signed_DASH_query], null));
}})();
var sig = fluree.crypto.sign_message(cmd,private_key);
var id = fluree.crypto.sha3_256.cljs$core$IFn$_invoke$arity$1(cmd);
return new cljs.core.PersistentArrayMap(null, 4, [cljs.core.cst$kw$cmd,cmd,cljs.core.cst$kw$sig,sig,cljs.core.cst$kw$id,id,cljs.core.cst$kw$db,ledger], null);
});

shared.fdb.qry__GT_command.cljs$lang$maxFixedArity = 4;

/**
 * Execute a signed query against a ledger.
 * 
 *   Returns an asynchronous channel that eventually contains the results.
 */
shared.fdb.signed_query_async = (function shared$fdb$signed_query_async(var_args){
var G__120920 = arguments.length;
switch (G__120920) {
case 3:
return shared.fdb.signed_query_async.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return shared.fdb.signed_query_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

shared.fdb.signed_query_async.cljs$core$IFn$_invoke$arity$3 = (function (conn,ledger,query_map){
return shared.fdb.signed_query_async.cljs$core$IFn$_invoke$arity$4(conn,ledger,query_map,null);
});

shared.fdb.signed_query_async.cljs$core$IFn$_invoke$arity$4 = (function (conn,ledger,query_map,opts){
var c__99809__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run(((function (c__99809__auto__){
return (function (){
var f__99810__auto__ = (function (){var switch__99702__auto__ = ((function (c__99809__auto__){
return (function (state_120948){
var state_val_120949 = (state_120948[(1)]);
if((state_val_120949 === (1))){
var state_120948__$1 = state_120948;
var statearr_120950_120964 = state_120948__$1;
(statearr_120950_120964[(2)] = null);

(statearr_120950_120964[(1)] = (4));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120949 === (2))){
var inst_120946 = (state_120948[(2)]);
var state_120948__$1 = state_120948;
return cljs.core.async.impl.ioc_helpers.return_chan(state_120948__$1,inst_120946);
} else {
if((state_val_120949 === (3))){
var inst_120921 = (state_120948[(2)]);
var inst_120922 = fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([inst_120921], 0));
var inst_120923 = cljs.core.ex_data(inst_120921);
var inst_120924 = cljs.core.ex_message(inst_120921);
var inst_120925 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(inst_120923,cljs.core.cst$kw$message,inst_120924);
var state_120948__$1 = (function (){var statearr_120951 = state_120948;
(statearr_120951[(7)] = inst_120922);

return statearr_120951;
})();
var statearr_120952_120965 = state_120948__$1;
(statearr_120952_120965[(2)] = inst_120925);


cljs.core.async.impl.ioc_helpers.process_exception(state_120948__$1);

return cljs.core.cst$kw$recur;
} else {
if((state_val_120949 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame(state_120948,(3),cljs.core.cst$kw$default,null,(2));
var inst_120929 = cljs.core.cst$kw$private_DASH_key.cljs$core$IFn$_invoke$arity$1(opts);
var inst_120930 = cljs.core.cst$kw$action.cljs$core$IFn$_invoke$arity$1(opts);
var inst_120931 = (inst_120930 == null);
var state_120948__$1 = (function (){var statearr_120953 = state_120948;
(statearr_120953[(8)] = inst_120929);

return statearr_120953;
})();
if(cljs.core.truth_(inst_120931)){
var statearr_120954_120966 = state_120948__$1;
(statearr_120954_120966[(1)] = (5));

} else {
var statearr_120955_120967 = state_120948__$1;
(statearr_120955_120967[(1)] = (6));

}

return cljs.core.cst$kw$recur;
} else {
if((state_val_120949 === (5))){
var inst_120933 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_120934 = [cljs.core.cst$kw$action];
var inst_120935 = (new cljs.core.PersistentVector(null,1,(5),inst_120933,inst_120934,null));
var inst_120936 = cljs.core.assoc_in(opts,inst_120935,cljs.core.cst$kw$query);
var state_120948__$1 = state_120948;
var statearr_120956_120968 = state_120948__$1;
(statearr_120956_120968[(2)] = inst_120936);

(statearr_120956_120968[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120949 === (6))){
var state_120948__$1 = state_120948;
var statearr_120957_120969 = state_120948__$1;
(statearr_120957_120969[(2)] = opts);

(statearr_120957_120969[(1)] = (7));


return cljs.core.cst$kw$recur;
} else {
if((state_val_120949 === (7))){
var inst_120929 = (state_120948[(8)]);
var inst_120939 = (state_120948[(2)]);
var inst_120940 = shared.fdb.qry__GT_command.cljs$core$IFn$_invoke$arity$4(ledger,query_map,inst_120929,inst_120939);
var inst_120941 = fluree.db.operations.command_async(conn,inst_120940);
var state_120948__$1 = state_120948;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_120948__$1,(8),inst_120941);
} else {
if((state_val_120949 === (8))){
var inst_120943 = (state_120948[(2)]);
var inst_120944 = fluree.db.util.async.throw_err(inst_120943);
var state_120948__$1 = state_120948;
var statearr_120958_120970 = state_120948__$1;
(statearr_120958_120970[(2)] = inst_120944);


cljs.core.async.impl.ioc_helpers.process_exception(state_120948__$1);

return cljs.core.cst$kw$recur;
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__99809__auto__))
;
return ((function (switch__99702__auto__,c__99809__auto__){
return (function() {
var shared$fdb$state_machine__99703__auto__ = null;
var shared$fdb$state_machine__99703__auto____0 = (function (){
var statearr_120959 = [null,null,null,null,null,null,null,null,null];
(statearr_120959[(0)] = shared$fdb$state_machine__99703__auto__);

(statearr_120959[(1)] = (1));

return statearr_120959;
});
var shared$fdb$state_machine__99703__auto____1 = (function (state_120948){
while(true){
var ret_value__99704__auto__ = (function (){try{while(true){
var result__99705__auto__ = switch__99702__auto__(state_120948);
if(cljs.core.keyword_identical_QMARK_(result__99705__auto__,cljs.core.cst$kw$recur)){
continue;
} else {
return result__99705__auto__;
}
break;
}
}catch (e120960){if((e120960 instanceof Object)){
var ex__99706__auto__ = e120960;
var statearr_120961_120971 = state_120948;
(statearr_120961_120971[(5)] = ex__99706__auto__);


cljs.core.async.impl.ioc_helpers.process_exception(state_120948);

return cljs.core.cst$kw$recur;
} else {
throw e120960;

}
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__99704__auto__,cljs.core.cst$kw$recur)){
var G__120972 = state_120948;
state_120948 = G__120972;
continue;
} else {
return ret_value__99704__auto__;
}
break;
}
});
shared$fdb$state_machine__99703__auto__ = function(state_120948){
switch(arguments.length){
case 0:
return shared$fdb$state_machine__99703__auto____0.call(this);
case 1:
return shared$fdb$state_machine__99703__auto____1.call(this,state_120948);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$0 = shared$fdb$state_machine__99703__auto____0;
shared$fdb$state_machine__99703__auto__.cljs$core$IFn$_invoke$arity$1 = shared$fdb$state_machine__99703__auto____1;
return shared$fdb$state_machine__99703__auto__;
})()
;})(switch__99702__auto__,c__99809__auto__))
})();
var state__99811__auto__ = (function (){var statearr_120962 = (f__99810__auto__.cljs$core$IFn$_invoke$arity$0 ? f__99810__auto__.cljs$core$IFn$_invoke$arity$0() : f__99810__auto__.call(null));
(statearr_120962[(6)] = c__99809__auto__);

return statearr_120962;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__99811__auto__);
});})(c__99809__auto__))
);

return c__99809__auto__;
});

shared.fdb.signed_query_async.cljs$lang$maxFixedArity = 4;

