// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('cljs.compiler');
goog.require('cljs.core');
goog.require('goog.string');
goog.require('clojure.string');
goog.require('clojure.set');
goog.require('cljs.tools.reader');
goog.require('cljs.env');
goog.require('cljs.analyzer');
goog.require('cljs.source_map');
goog.require('goog.string.StringBuffer');
cljs.compiler.js_reserved = cljs.analyzer.js_reserved;
cljs.compiler.es5_GT__EQ_ = cljs.core.into.call(null,cljs.core.PersistentHashSet.EMPTY,cljs.core.comp.call(null,cljs.core.mapcat.call(null,(function (lang){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [lang,cljs.core.keyword.call(null,clojure.string.replace.call(null,cljs.core.name.call(null,lang),/^ecmascript/,"es"))], null);
}))),new cljs.core.PersistentVector(null, 9, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ecmascript5","ecmascript5",342717552),new cljs.core.Keyword(null,"ecmascript5-strict","ecmascript5-strict",888234811),new cljs.core.Keyword(null,"ecmascript6","ecmascript6",723864898),new cljs.core.Keyword(null,"ecmascript6-strict","ecmascript6-strict",-786049555),new cljs.core.Keyword(null,"ecmascript-2015","ecmascript-2015",-902254444),new cljs.core.Keyword(null,"ecmascript6-typed","ecmascript6-typed",-1978203054),new cljs.core.Keyword(null,"ecmascript-2016","ecmascript-2016",471574729),new cljs.core.Keyword(null,"ecmascript-2017","ecmascript-2017",620145058),new cljs.core.Keyword(null,"ecmascript-next","ecmascript-next",-1935155962)], null));
cljs.compiler._STAR_recompiled_STAR_ = null;
cljs.compiler._STAR_inputs_STAR_ = null;
cljs.compiler._STAR_source_map_data_STAR_ = null;
cljs.compiler._STAR_source_map_data_gen_col_STAR_ = null;
cljs.compiler._STAR_lexical_renames_STAR_ = cljs.core.PersistentArrayMap.EMPTY;
cljs.compiler.cljs_reserved_file_names = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, ["deps.cljs",null], null), null);
/**
 * Gets the part up to the first `.` of a namespace.
 * Returns the empty string for nil.
 * Returns the entire string if no `.` in namespace
 */
cljs.compiler.get_first_ns_segment = (function cljs$compiler$get_first_ns_segment(ns){
var ns__$1 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(ns);
var idx = ns__$1.indexOf(".");
if(((-1) === idx)){
return ns__$1;
} else {
return cljs.core.subs.call(null,ns__$1,(0),idx);
}
});
cljs.compiler.find_ns_starts_with = (function cljs$compiler$find_ns_starts_with(needle){
return cljs.core.reduce_kv.call(null,(function (xs,ns,_){
if(cljs.core._EQ_.call(null,needle,cljs.compiler.get_first_ns_segment.call(null,ns))){
return cljs.core.reduced.call(null,needle);
} else {
return null;
}
}),null,new cljs.core.Keyword("cljs.analyzer","namespaces","cljs.analyzer/namespaces",-260788927).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)));
});
cljs.compiler.shadow_depth = (function cljs$compiler$shadow_depth(s){
var map__115880 = s;
var map__115880__$1 = (((((!((map__115880 == null))))?(((((map__115880.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__115880.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__115880):map__115880);
var name = cljs.core.get.call(null,map__115880__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var info = cljs.core.get.call(null,map__115880__$1,new cljs.core.Keyword(null,"info","info",-317069002));
var d = (0);
var G__115883 = info;
var map__115884 = G__115883;
var map__115884__$1 = (((((!((map__115884 == null))))?(((((map__115884.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__115884.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__115884):map__115884);
var shadow = cljs.core.get.call(null,map__115884__$1,new cljs.core.Keyword(null,"shadow","shadow",873231803));
var d__$1 = d;
var G__115883__$1 = G__115883;
while(true){
var d__$2 = d__$1;
var map__115888 = G__115883__$1;
var map__115888__$1 = (((((!((map__115888 == null))))?(((((map__115888.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__115888.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__115888):map__115888);
var shadow__$1 = cljs.core.get.call(null,map__115888__$1,new cljs.core.Keyword(null,"shadow","shadow",873231803));
if(cljs.core.truth_(shadow__$1)){
var G__115890 = (d__$2 + (1));
var G__115891 = shadow__$1;
d__$1 = G__115890;
G__115883__$1 = G__115891;
continue;
} else {
if(cljs.core.truth_(cljs.compiler.find_ns_starts_with.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)))){
return (d__$2 + (1));
} else {
return d__$2;

}
}
break;
}
});
cljs.compiler.hash_scope = (function cljs$compiler$hash_scope(s){
return cljs.core.hash_combine.call(null,cljs.core._hash.call(null,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(s)),cljs.compiler.shadow_depth.call(null,s));
});
cljs.compiler.fn_self_name = (function cljs$compiler$fn_self_name(p__115892){
var map__115893 = p__115892;
var map__115893__$1 = (((((!((map__115893 == null))))?(((((map__115893.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__115893.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__115893):map__115893);
var name_var = map__115893__$1;
var name = cljs.core.get.call(null,map__115893__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var info = cljs.core.get.call(null,map__115893__$1,new cljs.core.Keyword(null,"info","info",-317069002));
var name__$1 = clojure.string.replace.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(name),"..","_DOT__DOT_");
var map__115895 = info;
var map__115895__$1 = (((((!((map__115895 == null))))?(((((map__115895.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__115895.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__115895):map__115895);
var ns = cljs.core.get.call(null,map__115895__$1,new cljs.core.Keyword(null,"ns","ns",441598760));
var fn_scope = cljs.core.get.call(null,map__115895__$1,new cljs.core.Keyword(null,"fn-scope","fn-scope",-865664859));
var scoped_name = cljs.core.apply.call(null,cljs.core.str,cljs.core.interpose.call(null,"_$_",cljs.core.concat.call(null,cljs.core.map.call(null,cljs.core.comp.call(null,cljs.core.str,new cljs.core.Keyword(null,"name","name",1843675177)),fn_scope),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [name__$1], null))));
return cljs.core.symbol.call(null,cljs.compiler.munge.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.replace.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(ns),".","$")),"$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(scoped_name)].join('')));
});
cljs.compiler.munge_reserved = (function cljs$compiler$munge_reserved(reserved){
return (function (s){
if((!((cljs.core.get.call(null,reserved,s) == null)))){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(s),"$"].join('');
} else {
return s;
}
});
});
cljs.compiler.munge = (function cljs$compiler$munge(var_args){
var G__115898 = arguments.length;
switch (G__115898) {
case 1:
return cljs.compiler.munge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.compiler.munge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.compiler.munge.cljs$core$IFn$_invoke$arity$1 = (function (s){
return cljs.compiler.munge.call(null,s,cljs.compiler.js_reserved);
});

cljs.compiler.munge.cljs$core$IFn$_invoke$arity$2 = (function (s,reserved){
if(cljs.analyzer.cljs_map_QMARK_.call(null,s)){
var name_var = s;
var name = new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(name_var);
var field = new cljs.core.Keyword(null,"field","field",-1302436500).cljs$core$IFn$_invoke$arity$1(name_var);
var info = new cljs.core.Keyword(null,"info","info",-317069002).cljs$core$IFn$_invoke$arity$1(name_var);
if((!((new cljs.core.Keyword(null,"fn-self-name","fn-self-name",1461143531).cljs$core$IFn$_invoke$arity$1(info) == null)))){
return cljs.compiler.fn_self_name.call(null,s);
} else {
var depth = cljs.compiler.shadow_depth.call(null,s);
var code = cljs.compiler.hash_scope.call(null,s);
var renamed = cljs.core.get.call(null,cljs.compiler._STAR_lexical_renames_STAR_,code);
var name__$1 = ((field === true)?["self__.",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join(''):(((!((renamed == null))))?renamed:name
));
var munged_name = cljs.compiler.munge.call(null,name__$1,reserved);
if(((field === true) || ((depth === (0))))){
return munged_name;
} else {
return cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(munged_name),"__$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(depth)].join(''));
}
}
} else {
var ss = clojure.string.replace.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(s),"..","_DOT__DOT_");
var ss__$1 = clojure.string.replace.call(null,ss,(new RegExp("\\/(.)")),".$1");
var rf = cljs.compiler.munge_reserved.call(null,reserved);
var ss__$2 = cljs.core.map.call(null,rf,clojure.string.split.call(null,ss__$1,/\./));
var ss__$3 = clojure.string.join.call(null,".",ss__$2);
var ms = new cljs.core.Var(function(){return cljs.core.munge_str;},new cljs.core.Symbol("cljs.core","munge-str","cljs.core/munge-str",-301346665,null),cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"private","private",-558947994),new cljs.core.Keyword(null,"ns","ns",441598760),new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"file","file",-1269645878),new cljs.core.Keyword(null,"end-column","end-column",1425389514),new cljs.core.Keyword(null,"column","column",2078222095),new cljs.core.Keyword(null,"line","line",212345235),new cljs.core.Keyword(null,"end-line","end-line",1837326455),new cljs.core.Keyword(null,"arglists","arglists",1661989754),new cljs.core.Keyword(null,"doc","doc",1913296891),new cljs.core.Keyword(null,"test","test",577538877)],[true,new cljs.core.Symbol(null,"cljs.core","cljs.core",770546058,null),new cljs.core.Symbol(null,"munge-str","munge-str",-2042069652,null),"cljs/core.cljs",17,1,11478,11478,cljs.core.list(new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"name","name",-810760592,null)], null)),null,(cljs.core.truth_(cljs.core.munge_str)?cljs.core.munge_str.cljs$lang$test:null)])).call(null,ss__$3);
if((s instanceof cljs.core.Symbol)){
return cljs.core.symbol.call(null,ms);
} else {
return ms;
}
}
});

cljs.compiler.munge.cljs$lang$maxFixedArity = 2;

cljs.compiler.comma_sep = (function cljs$compiler$comma_sep(xs){
return cljs.core.interpose.call(null,",",xs);
});
cljs.compiler.escape_char = (function cljs$compiler$escape_char(c){
var cp = goog.string.hashCode(c);
var G__115900 = cp;
switch (G__115900) {
case (34):
return "\\\"";

break;
case (92):
return "\\\\";

break;
case (8):
return "\\b";

break;
case (12):
return "\\f";

break;
case (10):
return "\\n";

break;
case (13):
return "\\r";

break;
case (9):
return "\\t";

break;
default:
if(((((31) < cp)) && ((cp < (127))))){
return c;
} else {
var unpadded = cp.toString((16));
var pad = cljs.core.subs.call(null,"0000",unpadded.length);
return ["\\u",cljs.core.str.cljs$core$IFn$_invoke$arity$1(pad),cljs.core.str.cljs$core$IFn$_invoke$arity$1(unpadded)].join('');
}

}
});
cljs.compiler.escape_string = (function cljs$compiler$escape_string(s){
var sb = (new goog.string.StringBuffer());
var seq__115902_115906 = cljs.core.seq.call(null,s);
var chunk__115903_115907 = null;
var count__115904_115908 = (0);
var i__115905_115909 = (0);
while(true){
if((i__115905_115909 < count__115904_115908)){
var c_115910 = cljs.core._nth.call(null,chunk__115903_115907,i__115905_115909);
sb.append(cljs.compiler.escape_char.call(null,c_115910));


var G__115911 = seq__115902_115906;
var G__115912 = chunk__115903_115907;
var G__115913 = count__115904_115908;
var G__115914 = (i__115905_115909 + (1));
seq__115902_115906 = G__115911;
chunk__115903_115907 = G__115912;
count__115904_115908 = G__115913;
i__115905_115909 = G__115914;
continue;
} else {
var temp__5735__auto___115915 = cljs.core.seq.call(null,seq__115902_115906);
if(temp__5735__auto___115915){
var seq__115902_115916__$1 = temp__5735__auto___115915;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__115902_115916__$1)){
var c__4550__auto___115917 = cljs.core.chunk_first.call(null,seq__115902_115916__$1);
var G__115918 = cljs.core.chunk_rest.call(null,seq__115902_115916__$1);
var G__115919 = c__4550__auto___115917;
var G__115920 = cljs.core.count.call(null,c__4550__auto___115917);
var G__115921 = (0);
seq__115902_115906 = G__115918;
chunk__115903_115907 = G__115919;
count__115904_115908 = G__115920;
i__115905_115909 = G__115921;
continue;
} else {
var c_115922 = cljs.core.first.call(null,seq__115902_115916__$1);
sb.append(cljs.compiler.escape_char.call(null,c_115922));


var G__115923 = cljs.core.next.call(null,seq__115902_115916__$1);
var G__115924 = null;
var G__115925 = (0);
var G__115926 = (0);
seq__115902_115906 = G__115923;
chunk__115903_115907 = G__115924;
count__115904_115908 = G__115925;
i__115905_115909 = G__115926;
continue;
}
} else {
}
}
break;
}

return sb.toString();
});
cljs.compiler.wrap_in_double_quotes = (function cljs$compiler$wrap_in_double_quotes(x){
return ["\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x),"\""].join('');
});
if((typeof cljs !== 'undefined') && (typeof cljs.compiler !== 'undefined') && (typeof cljs.compiler.emit_STAR_ !== 'undefined')){
} else {
cljs.compiler.emit_STAR_ = (function (){var method_table__4613__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4614__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4615__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4616__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4617__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"cljs.compiler","emit*"),new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4617__auto__,method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__));
})();
}
cljs.compiler.emit = (function cljs$compiler$emit(ast){
if(cljs.core.truth_(cljs.compiler._STAR_source_map_data_STAR_)){
var map__115927_115932 = ast;
var map__115927_115933__$1 = (((((!((map__115927_115932 == null))))?(((((map__115927_115932.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__115927_115932.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__115927_115932):map__115927_115932);
var env_115934 = cljs.core.get.call(null,map__115927_115933__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
if(cljs.core.truth_(new cljs.core.Keyword(null,"line","line",212345235).cljs$core$IFn$_invoke$arity$1(env_115934))){
var map__115929_115935 = env_115934;
var map__115929_115936__$1 = (((((!((map__115929_115935 == null))))?(((((map__115929_115935.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__115929_115935.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__115929_115935):map__115929_115935);
var line_115937 = cljs.core.get.call(null,map__115929_115936__$1,new cljs.core.Keyword(null,"line","line",212345235));
var column_115938 = cljs.core.get.call(null,map__115929_115936__$1,new cljs.core.Keyword(null,"column","column",2078222095));
cljs.core.swap_BANG_.call(null,cljs.compiler._STAR_source_map_data_STAR_,((function (map__115929_115935,map__115929_115936__$1,line_115937,column_115938,map__115927_115932,map__115927_115933__$1,env_115934){
return (function (m){
var minfo = (function (){var G__115931 = new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"gcol","gcol",309250807),new cljs.core.Keyword(null,"gen-col","gen-col",1901918303).cljs$core$IFn$_invoke$arity$1(m),new cljs.core.Keyword(null,"gline","gline",-1086242431),new cljs.core.Keyword(null,"gen-line","gen-line",589592125).cljs$core$IFn$_invoke$arity$1(m)], null);
if(cljs.core.truth_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"binding","binding",539932593),null,new cljs.core.Keyword(null,"var","var",-769682797),null,new cljs.core.Keyword(null,"js-var","js-var",-1177899142),null,new cljs.core.Keyword(null,"local","local",-1497766724),null], null), null).call(null,new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(ast)))){
return cljs.core.assoc.call(null,G__115931,new cljs.core.Keyword(null,"name","name",1843675177),cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"info","info",-317069002).cljs$core$IFn$_invoke$arity$1(ast))));
} else {
return G__115931;
}
})();
return cljs.core.update_in.call(null,m,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"source-map","source-map",1706252311),(line_115937 - (1))], null),cljs.core.fnil.call(null,((function (minfo,map__115929_115935,map__115929_115936__$1,line_115937,column_115938,map__115927_115932,map__115927_115933__$1,env_115934){
return (function (line__$1){
return cljs.core.update_in.call(null,line__$1,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(cljs.core.truth_(column_115938)?(column_115938 - (1)):(0))], null),cljs.core.fnil.call(null,((function (minfo,map__115929_115935,map__115929_115936__$1,line_115937,column_115938,map__115927_115932,map__115927_115933__$1,env_115934){
return (function (column__$1){
return cljs.core.conj.call(null,column__$1,minfo);
});})(minfo,map__115929_115935,map__115929_115936__$1,line_115937,column_115938,map__115927_115932,map__115927_115933__$1,env_115934))
,cljs.core.PersistentVector.EMPTY));
});})(minfo,map__115929_115935,map__115929_115936__$1,line_115937,column_115938,map__115927_115932,map__115927_115933__$1,env_115934))
,cljs.core.sorted_map.call(null)));
});})(map__115929_115935,map__115929_115936__$1,line_115937,column_115938,map__115927_115932,map__115927_115933__$1,env_115934))
);
} else {
}
} else {
}

return cljs.compiler.emit_STAR_.call(null,ast);
});
cljs.compiler.emits = (function cljs$compiler$emits(var_args){
var G__115947 = arguments.length;
switch (G__115947) {
case 0:
return cljs.compiler.emits.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.compiler.emits.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.compiler.emits.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.compiler.emits.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.compiler.emits.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.compiler.emits.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
var args_arr__4751__auto__ = [];
var len__4730__auto___115954 = arguments.length;
var i__4731__auto___115955 = (0);
while(true){
if((i__4731__auto___115955 < len__4730__auto___115954)){
args_arr__4751__auto__.push((arguments[i__4731__auto___115955]));

var G__115956 = (i__4731__auto___115955 + (1));
i__4731__auto___115955 = G__115956;
continue;
} else {
}
break;
}

var argseq__4752__auto__ = (new cljs.core.IndexedSeq(args_arr__4751__auto__.slice((5)),(0),null));
return cljs.compiler.emits.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),argseq__4752__auto__);

}
});

cljs.compiler.emits.cljs$core$IFn$_invoke$arity$0 = (function (){
return null;
});

cljs.compiler.emits.cljs$core$IFn$_invoke$arity$1 = (function (a){
if((a == null)){
} else {
if(cljs.analyzer.cljs_map_QMARK_.call(null,a)){
cljs.compiler.emit.call(null,a);
} else {
if(cljs.analyzer.cljs_seq_QMARK_.call(null,a)){
cljs.core.apply.call(null,cljs.compiler.emits,a);
} else {
if(goog.isFunction(a)){
a.call(null);
} else {
var s_115957 = (function (){var G__115948 = a;
if((!(typeof a === 'string'))){
return G__115948.toString();
} else {
return G__115948;
}
})();
var temp__5739__auto___115958 = cljs.compiler._STAR_source_map_data_STAR_;
if((temp__5739__auto___115958 == null)){
} else {
var sm_data_115959 = temp__5739__auto___115958;
cljs.core.swap_BANG_.call(null,sm_data_115959,cljs.core.update,new cljs.core.Keyword(null,"gen-col","gen-col",1901918303),((function (sm_data_115959,temp__5739__auto___115958,s_115957){
return (function (p1__115939_SHARP_){
return (p1__115939_SHARP_ + s_115957.length);
});})(sm_data_115959,temp__5739__auto___115958,s_115957))
);
}

cljs.core.print.call(null,s_115957);

}
}
}
}

return null;
});

cljs.compiler.emits.cljs$core$IFn$_invoke$arity$2 = (function (a,b){
cljs.compiler.emits.call(null,a);

return cljs.compiler.emits.call(null,b);
});

cljs.compiler.emits.cljs$core$IFn$_invoke$arity$3 = (function (a,b,c){
cljs.compiler.emits.call(null,a);

cljs.compiler.emits.call(null,b);

return cljs.compiler.emits.call(null,c);
});

cljs.compiler.emits.cljs$core$IFn$_invoke$arity$4 = (function (a,b,c,d){
cljs.compiler.emits.call(null,a);

cljs.compiler.emits.call(null,b);

cljs.compiler.emits.call(null,c);

return cljs.compiler.emits.call(null,d);
});

cljs.compiler.emits.cljs$core$IFn$_invoke$arity$5 = (function (a,b,c,d,e){
cljs.compiler.emits.call(null,a);

cljs.compiler.emits.call(null,b);

cljs.compiler.emits.call(null,c);

cljs.compiler.emits.call(null,d);

return cljs.compiler.emits.call(null,e);
});

cljs.compiler.emits.cljs$core$IFn$_invoke$arity$variadic = (function (a,b,c,d,e,xs){
cljs.compiler.emits.call(null,a);

cljs.compiler.emits.call(null,b);

cljs.compiler.emits.call(null,c);

cljs.compiler.emits.call(null,d);

cljs.compiler.emits.call(null,e);

var seq__115949 = cljs.core.seq.call(null,xs);
var chunk__115950 = null;
var count__115951 = (0);
var i__115952 = (0);
while(true){
if((i__115952 < count__115951)){
var x = cljs.core._nth.call(null,chunk__115950,i__115952);
cljs.compiler.emits.call(null,x);


var G__115960 = seq__115949;
var G__115961 = chunk__115950;
var G__115962 = count__115951;
var G__115963 = (i__115952 + (1));
seq__115949 = G__115960;
chunk__115950 = G__115961;
count__115951 = G__115962;
i__115952 = G__115963;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq.call(null,seq__115949);
if(temp__5735__auto__){
var seq__115949__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__115949__$1)){
var c__4550__auto__ = cljs.core.chunk_first.call(null,seq__115949__$1);
var G__115964 = cljs.core.chunk_rest.call(null,seq__115949__$1);
var G__115965 = c__4550__auto__;
var G__115966 = cljs.core.count.call(null,c__4550__auto__);
var G__115967 = (0);
seq__115949 = G__115964;
chunk__115950 = G__115965;
count__115951 = G__115966;
i__115952 = G__115967;
continue;
} else {
var x = cljs.core.first.call(null,seq__115949__$1);
cljs.compiler.emits.call(null,x);


var G__115968 = cljs.core.next.call(null,seq__115949__$1);
var G__115969 = null;
var G__115970 = (0);
var G__115971 = (0);
seq__115949 = G__115968;
chunk__115950 = G__115969;
count__115951 = G__115970;
i__115952 = G__115971;
continue;
}
} else {
return null;
}
}
break;
}
});

/** @this {Function} */
cljs.compiler.emits.cljs$lang$applyTo = (function (seq115941){
var G__115942 = cljs.core.first.call(null,seq115941);
var seq115941__$1 = cljs.core.next.call(null,seq115941);
var G__115943 = cljs.core.first.call(null,seq115941__$1);
var seq115941__$2 = cljs.core.next.call(null,seq115941__$1);
var G__115944 = cljs.core.first.call(null,seq115941__$2);
var seq115941__$3 = cljs.core.next.call(null,seq115941__$2);
var G__115945 = cljs.core.first.call(null,seq115941__$3);
var seq115941__$4 = cljs.core.next.call(null,seq115941__$3);
var G__115946 = cljs.core.first.call(null,seq115941__$4);
var seq115941__$5 = cljs.core.next.call(null,seq115941__$4);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__115942,G__115943,G__115944,G__115945,G__115946,seq115941__$5);
});

cljs.compiler.emits.cljs$lang$maxFixedArity = (5);

cljs.compiler._emitln = (function cljs$compiler$_emitln(){
cljs.core.newline.call(null);

if(cljs.core.truth_(cljs.compiler._STAR_source_map_data_STAR_)){
cljs.core.swap_BANG_.call(null,cljs.compiler._STAR_source_map_data_STAR_,(function (p__115972){
var map__115973 = p__115972;
var map__115973__$1 = (((((!((map__115973 == null))))?(((((map__115973.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__115973.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__115973):map__115973);
var m = map__115973__$1;
var gen_line = cljs.core.get.call(null,map__115973__$1,new cljs.core.Keyword(null,"gen-line","gen-line",589592125));
return cljs.core.assoc.call(null,m,new cljs.core.Keyword(null,"gen-line","gen-line",589592125),(gen_line + (1)),new cljs.core.Keyword(null,"gen-col","gen-col",1901918303),(0));
}));
} else {
}

return null;
});
cljs.compiler.emitln = (function cljs$compiler$emitln(var_args){
var G__115982 = arguments.length;
switch (G__115982) {
case 0:
return cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
var args_arr__4751__auto__ = [];
var len__4730__auto___115988 = arguments.length;
var i__4731__auto___115989 = (0);
while(true){
if((i__4731__auto___115989 < len__4730__auto___115988)){
args_arr__4751__auto__.push((arguments[i__4731__auto___115989]));

var G__115990 = (i__4731__auto___115989 + (1));
i__4731__auto___115989 = G__115990;
continue;
} else {
}
break;
}

var argseq__4752__auto__ = (new cljs.core.IndexedSeq(args_arr__4751__auto__.slice((5)),(0),null));
return cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),argseq__4752__auto__);

}
});

cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.compiler._emitln.call(null);
});

cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$1 = (function (a){
cljs.compiler.emits.call(null,a);

return cljs.compiler._emitln.call(null);
});

cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$2 = (function (a,b){
cljs.compiler.emits.call(null,a);

cljs.compiler.emits.call(null,b);

return cljs.compiler._emitln.call(null);
});

cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$3 = (function (a,b,c){
cljs.compiler.emits.call(null,a);

cljs.compiler.emits.call(null,b);

cljs.compiler.emits.call(null,c);

return cljs.compiler._emitln.call(null);
});

cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$4 = (function (a,b,c,d){
cljs.compiler.emits.call(null,a);

cljs.compiler.emits.call(null,b);

cljs.compiler.emits.call(null,c);

cljs.compiler.emits.call(null,d);

return cljs.compiler._emitln.call(null);
});

cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$5 = (function (a,b,c,d,e){
cljs.compiler.emits.call(null,a);

cljs.compiler.emits.call(null,b);

cljs.compiler.emits.call(null,c);

cljs.compiler.emits.call(null,d);

cljs.compiler.emits.call(null,e);

return cljs.compiler._emitln.call(null);
});

cljs.compiler.emitln.cljs$core$IFn$_invoke$arity$variadic = (function (a,b,c,d,e,xs){
cljs.compiler.emits.call(null,a);

cljs.compiler.emits.call(null,b);

cljs.compiler.emits.call(null,c);

cljs.compiler.emits.call(null,d);

cljs.compiler.emits.call(null,e);

var seq__115983_115991 = cljs.core.seq.call(null,xs);
var chunk__115984_115992 = null;
var count__115985_115993 = (0);
var i__115986_115994 = (0);
while(true){
if((i__115986_115994 < count__115985_115993)){
var x_115995 = cljs.core._nth.call(null,chunk__115984_115992,i__115986_115994);
cljs.compiler.emits.call(null,x_115995);


var G__115996 = seq__115983_115991;
var G__115997 = chunk__115984_115992;
var G__115998 = count__115985_115993;
var G__115999 = (i__115986_115994 + (1));
seq__115983_115991 = G__115996;
chunk__115984_115992 = G__115997;
count__115985_115993 = G__115998;
i__115986_115994 = G__115999;
continue;
} else {
var temp__5735__auto___116000 = cljs.core.seq.call(null,seq__115983_115991);
if(temp__5735__auto___116000){
var seq__115983_116001__$1 = temp__5735__auto___116000;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__115983_116001__$1)){
var c__4550__auto___116002 = cljs.core.chunk_first.call(null,seq__115983_116001__$1);
var G__116003 = cljs.core.chunk_rest.call(null,seq__115983_116001__$1);
var G__116004 = c__4550__auto___116002;
var G__116005 = cljs.core.count.call(null,c__4550__auto___116002);
var G__116006 = (0);
seq__115983_115991 = G__116003;
chunk__115984_115992 = G__116004;
count__115985_115993 = G__116005;
i__115986_115994 = G__116006;
continue;
} else {
var x_116007 = cljs.core.first.call(null,seq__115983_116001__$1);
cljs.compiler.emits.call(null,x_116007);


var G__116008 = cljs.core.next.call(null,seq__115983_116001__$1);
var G__116009 = null;
var G__116010 = (0);
var G__116011 = (0);
seq__115983_115991 = G__116008;
chunk__115984_115992 = G__116009;
count__115985_115993 = G__116010;
i__115986_115994 = G__116011;
continue;
}
} else {
}
}
break;
}

return cljs.compiler._emitln.call(null);
});

/** @this {Function} */
cljs.compiler.emitln.cljs$lang$applyTo = (function (seq115976){
var G__115977 = cljs.core.first.call(null,seq115976);
var seq115976__$1 = cljs.core.next.call(null,seq115976);
var G__115978 = cljs.core.first.call(null,seq115976__$1);
var seq115976__$2 = cljs.core.next.call(null,seq115976__$1);
var G__115979 = cljs.core.first.call(null,seq115976__$2);
var seq115976__$3 = cljs.core.next.call(null,seq115976__$2);
var G__115980 = cljs.core.first.call(null,seq115976__$3);
var seq115976__$4 = cljs.core.next.call(null,seq115976__$3);
var G__115981 = cljs.core.first.call(null,seq115976__$4);
var seq115976__$5 = cljs.core.next.call(null,seq115976__$4);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__115977,G__115978,G__115979,G__115980,G__115981,seq115976__$5);
});

cljs.compiler.emitln.cljs$lang$maxFixedArity = (5);

cljs.compiler.emit_str = (function cljs$compiler$emit_str(expr){
var sb__4661__auto__ = (new goog.string.StringBuffer());
var _STAR_print_newline_STAR__orig_val__116012_116016 = cljs.core._STAR_print_newline_STAR_;
var _STAR_print_fn_STAR__orig_val__116013_116017 = cljs.core._STAR_print_fn_STAR_;
var _STAR_print_newline_STAR__temp_val__116014_116018 = true;
var _STAR_print_fn_STAR__temp_val__116015_116019 = ((function (_STAR_print_newline_STAR__orig_val__116012_116016,_STAR_print_fn_STAR__orig_val__116013_116017,_STAR_print_newline_STAR__temp_val__116014_116018,sb__4661__auto__){
return (function (x__4662__auto__){
return sb__4661__auto__.append(x__4662__auto__);
});})(_STAR_print_newline_STAR__orig_val__116012_116016,_STAR_print_fn_STAR__orig_val__116013_116017,_STAR_print_newline_STAR__temp_val__116014_116018,sb__4661__auto__))
;
cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__temp_val__116014_116018;

cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__temp_val__116015_116019;

try{cljs.compiler.emit.call(null,expr);
}finally {cljs.core._STAR_print_fn_STAR_ = _STAR_print_fn_STAR__orig_val__116013_116017;

cljs.core._STAR_print_newline_STAR_ = _STAR_print_newline_STAR__orig_val__116012_116016;
}
return cljs.core.str.cljs$core$IFn$_invoke$arity$1(sb__4661__auto__);
});
if((typeof cljs !== 'undefined') && (typeof cljs.compiler !== 'undefined') && (typeof cljs.compiler.emit_constant_STAR_ !== 'undefined')){
} else {
cljs.compiler.emit_constant_STAR_ = (function (){var method_table__4613__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4614__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4615__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4616__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4617__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"cljs.compiler","emit-constant*"),cljs.core.type,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4617__auto__,method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__));
})();
}









cljs.compiler.all_distinct_QMARK_ = (function cljs$compiler$all_distinct_QMARK_(xs){
return cljs.core.apply.call(null,cljs.core.distinct_QMARK_,xs);
});
cljs.compiler.emit_constant_no_meta = (function cljs$compiler$emit_constant_no_meta(x){
if(cljs.analyzer.cljs_seq_QMARK_.call(null,x)){
return cljs.compiler.emit_list.call(null,x,cljs.compiler.emit_constants_comma_sep);
} else {
if(cljs.core.record_QMARK_.call(null,x)){
var vec__116020 = cljs.analyzer.record_ns_PLUS_name.call(null,x);
var ns = cljs.core.nth.call(null,vec__116020,(0),null);
var name = cljs.core.nth.call(null,vec__116020,(1),null);
return cljs.compiler.emit_record_value.call(null,ns,name,((function (vec__116020,ns,name){
return (function (){
return cljs.compiler.emit_constant.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,x));
});})(vec__116020,ns,name))
);
} else {
if(cljs.analyzer.cljs_map_QMARK_.call(null,x)){
return cljs.compiler.emit_map.call(null,cljs.core.keys.call(null,x),cljs.core.vals.call(null,x),cljs.compiler.emit_constants_comma_sep,cljs.compiler.all_distinct_QMARK_);
} else {
if(cljs.analyzer.cljs_vector_QMARK_.call(null,x)){
return cljs.compiler.emit_vector.call(null,x,cljs.compiler.emit_constants_comma_sep);
} else {
if(cljs.analyzer.cljs_set_QMARK_.call(null,x)){
return cljs.compiler.emit_set.call(null,x,cljs.compiler.emit_constants_comma_sep,cljs.compiler.all_distinct_QMARK_);
} else {
return cljs.compiler.emit_constant_STAR_.call(null,x);

}
}
}
}
}
});
cljs.compiler.emit_constant = (function cljs$compiler$emit_constant(v){
var m = cljs.analyzer.elide_irrelevant_meta.call(null,cljs.core.meta.call(null,v));
if((!((cljs.core.seq.call(null,m) == null)))){
return cljs.compiler.emit_with_meta.call(null,((function (m){
return (function (){
return cljs.compiler.emit_constant_no_meta.call(null,v);
});})(m))
,((function (m){
return (function (){
return cljs.compiler.emit_constant_no_meta.call(null,m);
});})(m))
);
} else {
return cljs.compiler.emit_constant_no_meta.call(null,v);
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,new cljs.core.Keyword(null,"default","default",-1987822328),(function (x){
throw cljs.core.ex_info.call(null,["failed compiling constant: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x),"; ",cljs.core.pr_str.call(null,cljs.core.type.call(null,x))," is not a valid ClojureScript constant."].join(''),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"constant","constant",-379609303),x,new cljs.core.Keyword(null,"type","type",1174270348),cljs.core.type.call(null,x),new cljs.core.Keyword("clojure.error","phase","clojure.error/phase",275140358),new cljs.core.Keyword(null,"compilation","compilation",-1328774561)], null));
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,null,(function (x){
return cljs.compiler.emits.call(null,"null");
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,Number,(function (x){
if(cljs.core.truth_(isNaN(x))){
return cljs.compiler.emits.call(null,"NaN");
} else {
if(cljs.core.not.call(null,isFinite(x))){
return cljs.compiler.emits.call(null,(((x > (0)))?"Infinity":"-Infinity"));
} else {
return cljs.compiler.emits.call(null,"(",x,")");

}
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,String,(function (x){
return cljs.compiler.emits.call(null,cljs.compiler.wrap_in_double_quotes.call(null,cljs.compiler.escape_string.call(null,x)));
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,Boolean,(function (x){
return cljs.compiler.emits.call(null,(cljs.core.truth_(x)?"true":"false"));
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,RegExp,(function (x){
if(cljs.core._EQ_.call(null,"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x))){
return cljs.compiler.emits.call(null,"(new RegExp(\"\"))");
} else {
var vec__116023 = cljs.core.re_find.call(null,/^(?:\(\?([idmsux]*)\))?(.*)/,cljs.core.str.cljs$core$IFn$_invoke$arity$1(x));
var _ = cljs.core.nth.call(null,vec__116023,(0),null);
var flags = cljs.core.nth.call(null,vec__116023,(1),null);
var pattern = cljs.core.nth.call(null,vec__116023,(2),null);
return cljs.compiler.emits.call(null,pattern);
}
}));
cljs.compiler.emits_keyword = (function cljs$compiler$emits_keyword(kw){
var ns = cljs.core.namespace.call(null,kw);
var name = cljs.core.name.call(null,kw);
cljs.compiler.emits.call(null,"new cljs.core.Keyword(");

cljs.compiler.emit_constant.call(null,ns);

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,name);

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,(cljs.core.truth_(ns)?[ns,"/",name].join(''):name));

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,cljs.core.hash.call(null,kw));

return cljs.compiler.emits.call(null,")");
});
cljs.compiler.emits_symbol = (function cljs$compiler$emits_symbol(sym){
var ns = cljs.core.namespace.call(null,sym);
var name = cljs.core.name.call(null,sym);
var symstr = (((!((ns == null))))?[ns,"/",name].join(''):name);
cljs.compiler.emits.call(null,"new cljs.core.Symbol(");

cljs.compiler.emit_constant.call(null,ns);

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,name);

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,symstr);

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,cljs.core.hash.call(null,sym));

cljs.compiler.emits.call(null,",");

cljs.compiler.emit_constant.call(null,null);

return cljs.compiler.emits.call(null,")");
});
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,cljs.core.Keyword,(function (x){
var temp__5733__auto__ = (function (){var and__4120__auto__ = new cljs.core.Keyword(null,"emit-constants","emit-constants",-476585410).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"options","options",99638489).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)));
if(cljs.core.truth_(and__4120__auto__)){
return x.call(null,new cljs.core.Keyword("cljs.analyzer","constant-table","cljs.analyzer/constant-table",-114131889).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)));
} else {
return and__4120__auto__;
}
})();
if(cljs.core.truth_(temp__5733__auto__)){
var value = temp__5733__auto__;
return cljs.compiler.emits.call(null,"cljs.core.",value);
} else {
return cljs.compiler.emits_keyword.call(null,x);
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,cljs.core.Symbol,(function (x){
var temp__5733__auto__ = (function (){var and__4120__auto__ = new cljs.core.Keyword(null,"emit-constants","emit-constants",-476585410).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"options","options",99638489).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)));
if(cljs.core.truth_(and__4120__auto__)){
return x.call(null,new cljs.core.Keyword("cljs.analyzer","constant-table","cljs.analyzer/constant-table",-114131889).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)));
} else {
return and__4120__auto__;
}
})();
if(cljs.core.truth_(temp__5733__auto__)){
var value = temp__5733__auto__;
return cljs.compiler.emits.call(null,"cljs.core.",value);
} else {
return cljs.compiler.emits_symbol.call(null,x);
}
}));
cljs.compiler.emit_constants_comma_sep = (function cljs$compiler$emit_constants_comma_sep(cs){
return (function (){
return cljs.core.doall.call(null,cljs.core.map_indexed.call(null,(function (i,m){
if(cljs.core.even_QMARK_.call(null,i)){
return cljs.compiler.emit_constant.call(null,m);
} else {
return cljs.compiler.emits.call(null,m);
}
}),cljs.compiler.comma_sep.call(null,cs)));
});
});
cljs.compiler.array_map_threshold = (8);
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,Date,(function (date){
return cljs.compiler.emits.call(null,"new Date(",date.getTime(),")");
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,cljs.core.UUID,(function (uuid){
var uuid_str = uuid.toString();
return cljs.compiler.emits.call(null,"new cljs.core.UUID(\"",uuid_str,"\", ",cljs.core.hash.call(null,uuid_str),")");
}));
cljs.core._add_method.call(null,cljs.compiler.emit_constant_STAR_,cljs.tagged_literals.JSValue,(function (v){
var items = v.val;
if(cljs.core.map_QMARK_.call(null,items)){
return cljs.compiler.emit_js_object.call(null,items,((function (items){
return (function (p1__116026_SHARP_){
return ((function (items){
return (function (){
return cljs.compiler.emit_constant.call(null,p1__116026_SHARP_);
});
;})(items))
});})(items))
);
} else {
return cljs.compiler.emit_js_array.call(null,items,cljs.compiler.emit_constants_comma_sep);
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"no-op","no-op",-93046065),(function (m){
return null;
}));
cljs.compiler.emit_var = (function cljs$compiler$emit_var(p__116028){
var map__116029 = p__116028;
var map__116029__$1 = (((((!((map__116029 == null))))?(((((map__116029.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116029.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116029):map__116029);
var ast = map__116029__$1;
var info = cljs.core.get.call(null,map__116029__$1,new cljs.core.Keyword(null,"info","info",-317069002));
var env = cljs.core.get.call(null,map__116029__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var form = cljs.core.get.call(null,map__116029__$1,new cljs.core.Keyword(null,"form","form",-1624062471));
var temp__5733__auto__ = new cljs.core.Keyword(null,"const-expr","const-expr",-1379382292).cljs$core$IFn$_invoke$arity$1(ast);
if(cljs.core.truth_(temp__5733__auto__)){
var const_expr = temp__5733__auto__;
return cljs.compiler.emit.call(null,cljs.core.assoc.call(null,const_expr,new cljs.core.Keyword(null,"env","env",-1815813235),env));
} else {
var map__116031 = cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_);
var map__116031__$1 = (((((!((map__116031 == null))))?(((((map__116031.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116031.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116031):map__116031);
var cenv = map__116031__$1;
var options = cljs.core.get.call(null,map__116031__$1,new cljs.core.Keyword(null,"options","options",99638489));
var var_name = new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(info);
var info__$1 = ((cljs.core._EQ_.call(null,cljs.core.namespace.call(null,var_name),"js"))?(function (){var js_module_name = cljs.core.get_in.call(null,cenv,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"js-module-index","js-module-index",2072061931),cljs.core.name.call(null,var_name),new cljs.core.Keyword(null,"name","name",1843675177)], null));
var or__4131__auto__ = js_module_name;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.name.call(null,var_name);
}
})():info);
if(cljs.core.truth_(new cljs.core.Keyword(null,"binding-form?","binding-form?",1728940169).cljs$core$IFn$_invoke$arity$1(ast))){
return cljs.compiler.emits.call(null,cljs.compiler.munge.call(null,ast));
} else {
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"statement","statement",-32780863),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
return null;
} else {
var reserved = (function (){var G__116033 = cljs.compiler.js_reserved;
if(cljs.core.truth_((function (){var and__4120__auto__ = cljs.compiler.es5_GT__EQ_.call(null,new cljs.core.Keyword(null,"language-out","language-out",334619882).cljs$core$IFn$_invoke$arity$1(options));
if(cljs.core.truth_(and__4120__auto__)){
return (!((cljs.core.namespace.call(null,var_name) == null)));
} else {
return and__4120__auto__;
}
})())){
return clojure.set.difference.call(null,G__116033,cljs.analyzer.es5_allowed);
} else {
return G__116033;
}
})();
var js_module = cljs.core.get_in.call(null,cenv,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"js-namespaces","js-namespaces",-471353612),(function (){var or__4131__auto__ = cljs.core.namespace.call(null,var_name);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.name.call(null,var_name);
}
})()], null));
var info__$2 = (function (){var G__116034 = info__$1;
if(cljs.core.not_EQ_.call(null,form,new cljs.core.Symbol("js","-Infinity","js/-Infinity",958706333,null))){
return cljs.compiler.munge.call(null,G__116034,reserved);
} else {
return G__116034;
}
})();
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

var G__116035_116036 = new cljs.core.Keyword(null,"module-type","module-type",1392760304).cljs$core$IFn$_invoke$arity$1(js_module);
var G__116035_116037__$1 = (((G__116035_116036 instanceof cljs.core.Keyword))?G__116035_116036.fqn:null);
switch (G__116035_116037__$1) {
case "commonjs":
if(cljs.core.truth_(cljs.core.namespace.call(null,var_name))){
cljs.compiler.emits.call(null,cljs.compiler.munge.call(null,cljs.core.namespace.call(null,var_name),reserved),"[\"default\"].",cljs.compiler.munge.call(null,cljs.core.name.call(null,var_name),reserved));
} else {
cljs.compiler.emits.call(null,cljs.compiler.munge.call(null,cljs.core.name.call(null,var_name),reserved),"[\"default\"]");
}

break;
case "es6":
if(cljs.core.truth_((function (){var and__4120__auto__ = cljs.core.namespace.call(null,var_name);
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core._EQ_.call(null,"default",cljs.core.name.call(null,var_name));
} else {
return and__4120__auto__;
}
})())){
cljs.compiler.emits.call(null,cljs.compiler.munge.call(null,cljs.core.namespace.call(null,var_name),reserved),"[\"default\"]");
} else {
cljs.compiler.emits.call(null,info__$2);
}

break;
default:
cljs.compiler.emits.call(null,info__$2);

}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}
}
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"var","var",-769682797),(function (expr){
return cljs.compiler.emit_var.call(null,expr);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"binding","binding",539932593),(function (expr){
return cljs.compiler.emit_var.call(null,expr);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"js-var","js-var",-1177899142),(function (expr){
return cljs.compiler.emit_var.call(null,expr);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"local","local",-1497766724),(function (expr){
return cljs.compiler.emit_var.call(null,expr);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"the-var","the-var",1428415613),(function (p__116039){
var map__116040 = p__116039;
var map__116040__$1 = (((((!((map__116040 == null))))?(((((map__116040.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116040.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116040):map__116040);
var arg = map__116040__$1;
var env = cljs.core.get.call(null,map__116040__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var var$ = cljs.core.get.call(null,map__116040__$1,new cljs.core.Keyword(null,"var","var",-769682797));
var sym = cljs.core.get.call(null,map__116040__$1,new cljs.core.Keyword(null,"sym","sym",-1444860305));
var meta = cljs.core.get.call(null,map__116040__$1,new cljs.core.Keyword(null,"meta","meta",1499536964));
if(cljs.analyzer.ast_QMARK_.call(null,sym)){
} else {
throw (new Error("Assert failed: (ana/ast? sym)"));
}

if(cljs.analyzer.ast_QMARK_.call(null,meta)){
} else {
throw (new Error("Assert failed: (ana/ast? meta)"));
}

var map__116042 = new cljs.core.Keyword(null,"info","info",-317069002).cljs$core$IFn$_invoke$arity$1(var$);
var map__116042__$1 = (((((!((map__116042 == null))))?(((((map__116042.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116042.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116042):map__116042);
var name = cljs.core.get.call(null,map__116042__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emits.call(null,"new cljs.core.Var(function(){return ",cljs.compiler.munge.call(null,name),";},",sym,",",meta,")");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.compiler.emit_with_meta = (function cljs$compiler$emit_with_meta(expr,meta){
return cljs.compiler.emits.call(null,"cljs.core.with_meta(",expr,",",meta,")");
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"with-meta","with-meta",-1566856820),(function (p__116044){
var map__116045 = p__116044;
var map__116045__$1 = (((((!((map__116045 == null))))?(((((map__116045.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116045.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116045):map__116045);
var expr = cljs.core.get.call(null,map__116045__$1,new cljs.core.Keyword(null,"expr","expr",745722291));
var meta = cljs.core.get.call(null,map__116045__$1,new cljs.core.Keyword(null,"meta","meta",1499536964));
var env = cljs.core.get.call(null,map__116045__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emit_with_meta.call(null,expr,meta);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.compiler.distinct_keys_QMARK_ = (function cljs$compiler$distinct_keys_QMARK_(keys){
var keys__$1 = cljs.core.map.call(null,cljs.analyzer.unwrap_quote,keys);
return ((cljs.core.every_QMARK_.call(null,((function (keys__$1){
return (function (p1__116047_SHARP_){
return cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(p1__116047_SHARP_),new cljs.core.Keyword(null,"const","const",1709929842));
});})(keys__$1))
,keys__$1)) && (cljs.core._EQ_.call(null,cljs.core.count.call(null,cljs.core.into.call(null,cljs.core.PersistentHashSet.EMPTY,keys__$1)),cljs.core.count.call(null,keys__$1))));
});
cljs.compiler.emit_map = (function cljs$compiler$emit_map(keys,vals,comma_sep,distinct_keys_QMARK_){
if((cljs.core.count.call(null,keys) === (0))){
return cljs.compiler.emits.call(null,"cljs.core.PersistentArrayMap.EMPTY");
} else {
if((cljs.core.count.call(null,keys) <= cljs.compiler.array_map_threshold)){
if(cljs.core.truth_(distinct_keys_QMARK_.call(null,keys))){
return cljs.compiler.emits.call(null,"new cljs.core.PersistentArrayMap(null, ",cljs.core.count.call(null,keys),", [",comma_sep.call(null,cljs.core.interleave.call(null,keys,vals)),"], null)");
} else {
return cljs.compiler.emits.call(null,"cljs.core.PersistentArrayMap.createAsIfByAssoc([",comma_sep.call(null,cljs.core.interleave.call(null,keys,vals)),"])");
}
} else {
return cljs.compiler.emits.call(null,"cljs.core.PersistentHashMap.fromArrays([",comma_sep.call(null,keys),"],[",comma_sep.call(null,vals),"])");

}
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"map","map",1371690461),(function (p__116048){
var map__116049 = p__116048;
var map__116049__$1 = (((((!((map__116049 == null))))?(((((map__116049.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116049.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116049):map__116049);
var env = cljs.core.get.call(null,map__116049__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var keys = cljs.core.get.call(null,map__116049__$1,new cljs.core.Keyword(null,"keys","keys",1068423698));
var vals = cljs.core.get.call(null,map__116049__$1,new cljs.core.Keyword(null,"vals","vals",768058733));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emit_map.call(null,keys,vals,cljs.compiler.comma_sep,cljs.compiler.distinct_keys_QMARK_);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.compiler.emit_list = (function cljs$compiler$emit_list(items,comma_sep){
if(cljs.core.empty_QMARK_.call(null,items)){
return cljs.compiler.emits.call(null,"cljs.core.List.EMPTY");
} else {
return cljs.compiler.emits.call(null,"cljs.core.list(",comma_sep.call(null,items),")");
}
});
cljs.compiler.emit_vector = (function cljs$compiler$emit_vector(items,comma_sep){
if(cljs.core.empty_QMARK_.call(null,items)){
return cljs.compiler.emits.call(null,"cljs.core.PersistentVector.EMPTY");
} else {
var cnt = cljs.core.count.call(null,items);
if((cnt < (32))){
return cljs.compiler.emits.call(null,"new cljs.core.PersistentVector(null, ",cnt,", 5, cljs.core.PersistentVector.EMPTY_NODE, [",comma_sep.call(null,items),"], null)");
} else {
return cljs.compiler.emits.call(null,"cljs.core.PersistentVector.fromArray([",comma_sep.call(null,items),"], true)");
}
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"vector","vector",1902966158),(function (p__116051){
var map__116052 = p__116051;
var map__116052__$1 = (((((!((map__116052 == null))))?(((((map__116052.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116052.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116052):map__116052);
var items = cljs.core.get.call(null,map__116052__$1,new cljs.core.Keyword(null,"items","items",1031954938));
var env = cljs.core.get.call(null,map__116052__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emit_vector.call(null,items,cljs.compiler.comma_sep);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.compiler.distinct_constants_QMARK_ = (function cljs$compiler$distinct_constants_QMARK_(items){
var items__$1 = cljs.core.map.call(null,cljs.analyzer.unwrap_quote,items);
return ((cljs.core.every_QMARK_.call(null,((function (items__$1){
return (function (p1__116054_SHARP_){
return cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(p1__116054_SHARP_),new cljs.core.Keyword(null,"const","const",1709929842));
});})(items__$1))
,items__$1)) && (cljs.core._EQ_.call(null,cljs.core.count.call(null,cljs.core.into.call(null,cljs.core.PersistentHashSet.EMPTY,items__$1)),cljs.core.count.call(null,items__$1))));
});
cljs.compiler.emit_set = (function cljs$compiler$emit_set(items,comma_sep,distinct_constants_QMARK_){
if(cljs.core.empty_QMARK_.call(null,items)){
return cljs.compiler.emits.call(null,"cljs.core.PersistentHashSet.EMPTY");
} else {
if(cljs.core.truth_(distinct_constants_QMARK_.call(null,items))){
return cljs.compiler.emits.call(null,"new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, ",cljs.core.count.call(null,items),", [",comma_sep.call(null,cljs.core.interleave.call(null,items,cljs.core.repeat.call(null,"null"))),"], null), null)");
} else {
return cljs.compiler.emits.call(null,"cljs.core.PersistentHashSet.createAsIfByAssoc([",comma_sep.call(null,items),"])");

}
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"set","set",304602554),(function (p__116055){
var map__116056 = p__116055;
var map__116056__$1 = (((((!((map__116056 == null))))?(((((map__116056.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116056.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116056):map__116056);
var items = cljs.core.get.call(null,map__116056__$1,new cljs.core.Keyword(null,"items","items",1031954938));
var env = cljs.core.get.call(null,map__116056__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emit_set.call(null,items,cljs.compiler.comma_sep,cljs.compiler.distinct_constants_QMARK_);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.compiler.emit_js_object = (function cljs$compiler$emit_js_object(items,emit_js_object_val){
cljs.compiler.emits.call(null,"({");

var temp__5735__auto___116080 = cljs.core.seq.call(null,items);
if(temp__5735__auto___116080){
var items_116081__$1 = temp__5735__auto___116080;
var vec__116058_116082 = items_116081__$1;
var seq__116059_116083 = cljs.core.seq.call(null,vec__116058_116082);
var first__116060_116084 = cljs.core.first.call(null,seq__116059_116083);
var seq__116059_116085__$1 = cljs.core.next.call(null,seq__116059_116083);
var vec__116061_116086 = first__116060_116084;
var k_116087 = cljs.core.nth.call(null,vec__116061_116086,(0),null);
var v_116088 = cljs.core.nth.call(null,vec__116061_116086,(1),null);
var r_116089 = seq__116059_116085__$1;
cljs.compiler.emits.call(null,"\"",cljs.core.name.call(null,k_116087),"\": ",emit_js_object_val.call(null,v_116088));

var seq__116064_116090 = cljs.core.seq.call(null,r_116089);
var chunk__116065_116091 = null;
var count__116066_116092 = (0);
var i__116067_116093 = (0);
while(true){
if((i__116067_116093 < count__116066_116092)){
var vec__116074_116094 = cljs.core._nth.call(null,chunk__116065_116091,i__116067_116093);
var k_116095__$1 = cljs.core.nth.call(null,vec__116074_116094,(0),null);
var v_116096__$1 = cljs.core.nth.call(null,vec__116074_116094,(1),null);
cljs.compiler.emits.call(null,", \"",cljs.core.name.call(null,k_116095__$1),"\": ",emit_js_object_val.call(null,v_116096__$1));


var G__116097 = seq__116064_116090;
var G__116098 = chunk__116065_116091;
var G__116099 = count__116066_116092;
var G__116100 = (i__116067_116093 + (1));
seq__116064_116090 = G__116097;
chunk__116065_116091 = G__116098;
count__116066_116092 = G__116099;
i__116067_116093 = G__116100;
continue;
} else {
var temp__5735__auto___116101__$1 = cljs.core.seq.call(null,seq__116064_116090);
if(temp__5735__auto___116101__$1){
var seq__116064_116102__$1 = temp__5735__auto___116101__$1;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116064_116102__$1)){
var c__4550__auto___116103 = cljs.core.chunk_first.call(null,seq__116064_116102__$1);
var G__116104 = cljs.core.chunk_rest.call(null,seq__116064_116102__$1);
var G__116105 = c__4550__auto___116103;
var G__116106 = cljs.core.count.call(null,c__4550__auto___116103);
var G__116107 = (0);
seq__116064_116090 = G__116104;
chunk__116065_116091 = G__116105;
count__116066_116092 = G__116106;
i__116067_116093 = G__116107;
continue;
} else {
var vec__116077_116108 = cljs.core.first.call(null,seq__116064_116102__$1);
var k_116109__$1 = cljs.core.nth.call(null,vec__116077_116108,(0),null);
var v_116110__$1 = cljs.core.nth.call(null,vec__116077_116108,(1),null);
cljs.compiler.emits.call(null,", \"",cljs.core.name.call(null,k_116109__$1),"\": ",emit_js_object_val.call(null,v_116110__$1));


var G__116111 = cljs.core.next.call(null,seq__116064_116102__$1);
var G__116112 = null;
var G__116113 = (0);
var G__116114 = (0);
seq__116064_116090 = G__116111;
chunk__116065_116091 = G__116112;
count__116066_116092 = G__116113;
i__116067_116093 = G__116114;
continue;
}
} else {
}
}
break;
}
} else {
}

return cljs.compiler.emits.call(null,"})");
});
cljs.compiler.emit_js_array = (function cljs$compiler$emit_js_array(items,comma_sep){
return cljs.compiler.emits.call(null,"[",comma_sep.call(null,items),"]");
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"js-object","js-object",1830199158),(function (p__116115){
var map__116116 = p__116115;
var map__116116__$1 = (((((!((map__116116 == null))))?(((((map__116116.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116116.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116116):map__116116);
var keys = cljs.core.get.call(null,map__116116__$1,new cljs.core.Keyword(null,"keys","keys",1068423698));
var vals = cljs.core.get.call(null,map__116116__$1,new cljs.core.Keyword(null,"vals","vals",768058733));
var env = cljs.core.get.call(null,map__116116__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emit_js_object.call(null,cljs.core.map.call(null,cljs.core.vector,keys,vals),cljs.core.identity);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"js-array","js-array",-1210185421),(function (p__116118){
var map__116119 = p__116118;
var map__116119__$1 = (((((!((map__116119 == null))))?(((((map__116119.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116119.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116119):map__116119);
var items = cljs.core.get.call(null,map__116119__$1,new cljs.core.Keyword(null,"items","items",1031954938));
var env = cljs.core.get.call(null,map__116119__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emit_js_array.call(null,items,cljs.compiler.comma_sep);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.compiler.emit_record_value = (function cljs$compiler$emit_record_value(ns,name,items){
return cljs.compiler.emits.call(null,ns,".map__GT_",name,"(",items,")");
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"quote","quote",-262615245),(function (p__116121){
var map__116122 = p__116121;
var map__116122__$1 = (((((!((map__116122 == null))))?(((((map__116122.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116122.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116122):map__116122);
var expr = cljs.core.get.call(null,map__116122__$1,new cljs.core.Keyword(null,"expr","expr",745722291));
return cljs.compiler.emit.call(null,expr);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"const","const",1709929842),(function (p__116124){
var map__116125 = p__116124;
var map__116125__$1 = (((((!((map__116125 == null))))?(((((map__116125.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116125.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116125):map__116125);
var form = cljs.core.get.call(null,map__116125__$1,new cljs.core.Keyword(null,"form","form",-1624062471));
var env = cljs.core.get.call(null,map__116125__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"statement","statement",-32780863),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
return null;
} else {
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emit_constant.call(null,form);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}
}));
cljs.compiler.truthy_constant_QMARK_ = (function cljs$compiler$truthy_constant_QMARK_(expr){
var map__116127 = cljs.analyzer.unwrap_quote.call(null,expr);
var map__116127__$1 = (((((!((map__116127 == null))))?(((((map__116127.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116127.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116127):map__116127);
var op = cljs.core.get.call(null,map__116127__$1,new cljs.core.Keyword(null,"op","op",-1882987955));
var form = cljs.core.get.call(null,map__116127__$1,new cljs.core.Keyword(null,"form","form",-1624062471));
var const_expr = cljs.core.get.call(null,map__116127__$1,new cljs.core.Keyword(null,"const-expr","const-expr",-1379382292));
var or__4131__auto__ = (function (){var and__4120__auto__ = cljs.core._EQ_.call(null,op,new cljs.core.Keyword(null,"const","const",1709929842));
if(and__4120__auto__){
var and__4120__auto____$1 = form;
if(cljs.core.truth_(and__4120__auto____$1)){
return (!(((((typeof form === 'string') && (cljs.core._EQ_.call(null,form,"")))) || (((typeof form === 'number') && ((form === (0))))))));
} else {
return and__4120__auto____$1;
}
} else {
return and__4120__auto__;
}
})();
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var and__4120__auto__ = (!((const_expr == null)));
if(and__4120__auto__){
return cljs.compiler.truthy_constant_QMARK_.call(null,const_expr);
} else {
return and__4120__auto__;
}
}
});
cljs.compiler.falsey_constant_QMARK_ = (function cljs$compiler$falsey_constant_QMARK_(expr){
var map__116129 = cljs.analyzer.unwrap_quote.call(null,expr);
var map__116129__$1 = (((((!((map__116129 == null))))?(((((map__116129.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116129.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116129):map__116129);
var op = cljs.core.get.call(null,map__116129__$1,new cljs.core.Keyword(null,"op","op",-1882987955));
var form = cljs.core.get.call(null,map__116129__$1,new cljs.core.Keyword(null,"form","form",-1624062471));
var const_expr = cljs.core.get.call(null,map__116129__$1,new cljs.core.Keyword(null,"const-expr","const-expr",-1379382292));
var or__4131__auto__ = ((cljs.core._EQ_.call(null,op,new cljs.core.Keyword(null,"const","const",1709929842))) && (((form === false) || ((form == null)))));
if(or__4131__auto__){
return or__4131__auto__;
} else {
var and__4120__auto__ = (!((const_expr == null)));
if(and__4120__auto__){
return cljs.compiler.falsey_constant_QMARK_.call(null,const_expr);
} else {
return and__4120__auto__;
}
}
});
cljs.compiler.safe_test_QMARK_ = (function cljs$compiler$safe_test_QMARK_(env,e){
var tag = cljs.analyzer.infer_tag.call(null,env,e);
var or__4131__auto__ = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Symbol(null,"seq","seq",-177272256,null),null,new cljs.core.Symbol(null,"boolean","boolean",-278886877,null),null], null), null).call(null,tag);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.compiler.truthy_constant_QMARK_.call(null,e);
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"if","if",-458814265),(function (p__116131){
var map__116132 = p__116131;
var map__116132__$1 = (((((!((map__116132 == null))))?(((((map__116132.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116132.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116132):map__116132);
var test = cljs.core.get.call(null,map__116132__$1,new cljs.core.Keyword(null,"test","test",577538877));
var then = cljs.core.get.call(null,map__116132__$1,new cljs.core.Keyword(null,"then","then",460598070));
var else$ = cljs.core.get.call(null,map__116132__$1,new cljs.core.Keyword(null,"else","else",-1508377146));
var env = cljs.core.get.call(null,map__116132__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var unchecked = cljs.core.get.call(null,map__116132__$1,new cljs.core.Keyword(null,"unchecked","unchecked",924418378));
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env);
var checked = cljs.core.not.call(null,(function (){var or__4131__auto__ = unchecked;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.compiler.safe_test_QMARK_.call(null,env,test);
}
})());
if(cljs.core.truth_(cljs.compiler.truthy_constant_QMARK_.call(null,test))){
return cljs.compiler.emitln.call(null,then);
} else {
if(cljs.core.truth_(cljs.compiler.falsey_constant_QMARK_.call(null,test))){
return cljs.compiler.emitln.call(null,else$);
} else {
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
return cljs.compiler.emits.call(null,"(",((checked)?"cljs.core.truth_":null),"(",test,")?",then,":",else$,")");
} else {
if(checked){
cljs.compiler.emitln.call(null,"if(cljs.core.truth_(",test,")){");
} else {
cljs.compiler.emitln.call(null,"if(",test,"){");
}

cljs.compiler.emitln.call(null,then,"} else {");

return cljs.compiler.emitln.call(null,else$,"}");
}

}
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"case","case",1143702196),(function (p__116134){
var map__116135 = p__116134;
var map__116135__$1 = (((((!((map__116135 == null))))?(((((map__116135.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116135.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116135):map__116135);
var v = cljs.core.get.call(null,map__116135__$1,new cljs.core.Keyword(null,"test","test",577538877));
var nodes = cljs.core.get.call(null,map__116135__$1,new cljs.core.Keyword(null,"nodes","nodes",-2099585805));
var default$ = cljs.core.get.call(null,map__116135__$1,new cljs.core.Keyword(null,"default","default",-1987822328));
var env = cljs.core.get.call(null,map__116135__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env),new cljs.core.Keyword(null,"expr","expr",745722291))){
cljs.compiler.emitln.call(null,"(function(){");
} else {
}

var gs = cljs.core.gensym.call(null,"caseval__");
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,"var ",gs,";");
} else {
}

cljs.compiler.emitln.call(null,"switch (",v,") {");

var seq__116137_116173 = cljs.core.seq.call(null,nodes);
var chunk__116138_116174 = null;
var count__116139_116175 = (0);
var i__116140_116176 = (0);
while(true){
if((i__116140_116176 < count__116139_116175)){
var map__116157_116177 = cljs.core._nth.call(null,chunk__116138_116174,i__116140_116176);
var map__116157_116178__$1 = (((((!((map__116157_116177 == null))))?(((((map__116157_116177.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116157_116177.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116157_116177):map__116157_116177);
var ts_116179 = cljs.core.get.call(null,map__116157_116178__$1,new cljs.core.Keyword(null,"tests","tests",-1041085625));
var map__116158_116180 = cljs.core.get.call(null,map__116157_116178__$1,new cljs.core.Keyword(null,"then","then",460598070));
var map__116158_116181__$1 = (((((!((map__116158_116180 == null))))?(((((map__116158_116180.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116158_116180.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116158_116180):map__116158_116180);
var then_116182 = cljs.core.get.call(null,map__116158_116181__$1,new cljs.core.Keyword(null,"then","then",460598070));
var seq__116161_116183 = cljs.core.seq.call(null,cljs.core.map.call(null,new cljs.core.Keyword(null,"test","test",577538877),ts_116179));
var chunk__116162_116184 = null;
var count__116163_116185 = (0);
var i__116164_116186 = (0);
while(true){
if((i__116164_116186 < count__116163_116185)){
var test_116187 = cljs.core._nth.call(null,chunk__116162_116184,i__116164_116186);
cljs.compiler.emitln.call(null,"case ",test_116187,":");


var G__116188 = seq__116161_116183;
var G__116189 = chunk__116162_116184;
var G__116190 = count__116163_116185;
var G__116191 = (i__116164_116186 + (1));
seq__116161_116183 = G__116188;
chunk__116162_116184 = G__116189;
count__116163_116185 = G__116190;
i__116164_116186 = G__116191;
continue;
} else {
var temp__5735__auto___116192 = cljs.core.seq.call(null,seq__116161_116183);
if(temp__5735__auto___116192){
var seq__116161_116193__$1 = temp__5735__auto___116192;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116161_116193__$1)){
var c__4550__auto___116194 = cljs.core.chunk_first.call(null,seq__116161_116193__$1);
var G__116195 = cljs.core.chunk_rest.call(null,seq__116161_116193__$1);
var G__116196 = c__4550__auto___116194;
var G__116197 = cljs.core.count.call(null,c__4550__auto___116194);
var G__116198 = (0);
seq__116161_116183 = G__116195;
chunk__116162_116184 = G__116196;
count__116163_116185 = G__116197;
i__116164_116186 = G__116198;
continue;
} else {
var test_116199 = cljs.core.first.call(null,seq__116161_116193__$1);
cljs.compiler.emitln.call(null,"case ",test_116199,":");


var G__116200 = cljs.core.next.call(null,seq__116161_116193__$1);
var G__116201 = null;
var G__116202 = (0);
var G__116203 = (0);
seq__116161_116183 = G__116200;
chunk__116162_116184 = G__116201;
count__116163_116185 = G__116202;
i__116164_116186 = G__116203;
continue;
}
} else {
}
}
break;
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,gs,"=",then_116182);
} else {
cljs.compiler.emitln.call(null,then_116182);
}

cljs.compiler.emitln.call(null,"break;");


var G__116204 = seq__116137_116173;
var G__116205 = chunk__116138_116174;
var G__116206 = count__116139_116175;
var G__116207 = (i__116140_116176 + (1));
seq__116137_116173 = G__116204;
chunk__116138_116174 = G__116205;
count__116139_116175 = G__116206;
i__116140_116176 = G__116207;
continue;
} else {
var temp__5735__auto___116208 = cljs.core.seq.call(null,seq__116137_116173);
if(temp__5735__auto___116208){
var seq__116137_116209__$1 = temp__5735__auto___116208;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116137_116209__$1)){
var c__4550__auto___116210 = cljs.core.chunk_first.call(null,seq__116137_116209__$1);
var G__116211 = cljs.core.chunk_rest.call(null,seq__116137_116209__$1);
var G__116212 = c__4550__auto___116210;
var G__116213 = cljs.core.count.call(null,c__4550__auto___116210);
var G__116214 = (0);
seq__116137_116173 = G__116211;
chunk__116138_116174 = G__116212;
count__116139_116175 = G__116213;
i__116140_116176 = G__116214;
continue;
} else {
var map__116165_116215 = cljs.core.first.call(null,seq__116137_116209__$1);
var map__116165_116216__$1 = (((((!((map__116165_116215 == null))))?(((((map__116165_116215.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116165_116215.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116165_116215):map__116165_116215);
var ts_116217 = cljs.core.get.call(null,map__116165_116216__$1,new cljs.core.Keyword(null,"tests","tests",-1041085625));
var map__116166_116218 = cljs.core.get.call(null,map__116165_116216__$1,new cljs.core.Keyword(null,"then","then",460598070));
var map__116166_116219__$1 = (((((!((map__116166_116218 == null))))?(((((map__116166_116218.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116166_116218.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116166_116218):map__116166_116218);
var then_116220 = cljs.core.get.call(null,map__116166_116219__$1,new cljs.core.Keyword(null,"then","then",460598070));
var seq__116169_116221 = cljs.core.seq.call(null,cljs.core.map.call(null,new cljs.core.Keyword(null,"test","test",577538877),ts_116217));
var chunk__116170_116222 = null;
var count__116171_116223 = (0);
var i__116172_116224 = (0);
while(true){
if((i__116172_116224 < count__116171_116223)){
var test_116225 = cljs.core._nth.call(null,chunk__116170_116222,i__116172_116224);
cljs.compiler.emitln.call(null,"case ",test_116225,":");


var G__116226 = seq__116169_116221;
var G__116227 = chunk__116170_116222;
var G__116228 = count__116171_116223;
var G__116229 = (i__116172_116224 + (1));
seq__116169_116221 = G__116226;
chunk__116170_116222 = G__116227;
count__116171_116223 = G__116228;
i__116172_116224 = G__116229;
continue;
} else {
var temp__5735__auto___116230__$1 = cljs.core.seq.call(null,seq__116169_116221);
if(temp__5735__auto___116230__$1){
var seq__116169_116231__$1 = temp__5735__auto___116230__$1;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116169_116231__$1)){
var c__4550__auto___116232 = cljs.core.chunk_first.call(null,seq__116169_116231__$1);
var G__116233 = cljs.core.chunk_rest.call(null,seq__116169_116231__$1);
var G__116234 = c__4550__auto___116232;
var G__116235 = cljs.core.count.call(null,c__4550__auto___116232);
var G__116236 = (0);
seq__116169_116221 = G__116233;
chunk__116170_116222 = G__116234;
count__116171_116223 = G__116235;
i__116172_116224 = G__116236;
continue;
} else {
var test_116237 = cljs.core.first.call(null,seq__116169_116231__$1);
cljs.compiler.emitln.call(null,"case ",test_116237,":");


var G__116238 = cljs.core.next.call(null,seq__116169_116231__$1);
var G__116239 = null;
var G__116240 = (0);
var G__116241 = (0);
seq__116169_116221 = G__116238;
chunk__116170_116222 = G__116239;
count__116171_116223 = G__116240;
i__116172_116224 = G__116241;
continue;
}
} else {
}
}
break;
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,gs,"=",then_116220);
} else {
cljs.compiler.emitln.call(null,then_116220);
}

cljs.compiler.emitln.call(null,"break;");


var G__116242 = cljs.core.next.call(null,seq__116137_116209__$1);
var G__116243 = null;
var G__116244 = (0);
var G__116245 = (0);
seq__116137_116173 = G__116242;
chunk__116138_116174 = G__116243;
count__116139_116175 = G__116244;
i__116140_116176 = G__116245;
continue;
}
} else {
}
}
break;
}

if(cljs.core.truth_(default$)){
cljs.compiler.emitln.call(null,"default:");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,gs,"=",default$);
} else {
cljs.compiler.emitln.call(null,default$);
}
} else {
}

cljs.compiler.emitln.call(null,"}");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
return cljs.compiler.emitln.call(null,"return ",gs,";})()");
} else {
return null;
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"throw","throw",-1044625833),(function (p__116246){
var map__116247 = p__116246;
var map__116247__$1 = (((((!((map__116247 == null))))?(((((map__116247.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116247.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116247):map__116247);
var throw$ = cljs.core.get.call(null,map__116247__$1,new cljs.core.Keyword(null,"exception","exception",-335277064));
var env = cljs.core.get.call(null,map__116247__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
return cljs.compiler.emits.call(null,"(function(){throw ",throw$,"})()");
} else {
return cljs.compiler.emitln.call(null,"throw ",throw$,";");
}
}));
cljs.compiler.base_types = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 15, ["boolean",null,"object",null,"*",null,"string",null,"Object",null,"Number",null,"null",null,"Date",null,"number",null,"String",null,"RegExp",null,"...*",null,"Array",null,"array",null,"Boolean",null], null), null);
cljs.compiler.mapped_types = new cljs.core.PersistentArrayMap(null, 1, ["nil","null"], null);
cljs.compiler.resolve_type = (function cljs$compiler$resolve_type(env,t){
if(cljs.core.truth_(cljs.core.get.call(null,cljs.compiler.base_types,t))){
return t;
} else {
if(cljs.core.truth_(cljs.core.get.call(null,cljs.compiler.mapped_types,t))){
return cljs.core.get.call(null,cljs.compiler.mapped_types,t);
} else {
if(cljs.core.truth_(goog.string.startsWith(t,"!"))){
return ["!",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.resolve_type.call(null,env,cljs.core.subs.call(null,t,(1))))].join('');
} else {
if(cljs.core.truth_(goog.string.startsWith(t,"{"))){
return t;
} else {
if(cljs.core.truth_(goog.string.startsWith(t,"function"))){
var idx = t.lastIndexOf(":");
var vec__116250 = (((!(((-1) === idx))))?new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.subs.call(null,t,(0),idx),cljs.core.subs.call(null,t,(idx + (1)),cljs.core.count.call(null,t))], null):new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [t,null], null));
var fstr = cljs.core.nth.call(null,vec__116250,(0),null);
var rstr = cljs.core.nth.call(null,vec__116250,(1),null);
var ret_t = (cljs.core.truth_(rstr)?cljs.compiler.resolve_type.call(null,env,rstr):null);
var axstr = cljs.core.subs.call(null,fstr,(9),(cljs.core.count.call(null,fstr) - (1)));
var args_ts = ((clojure.string.blank_QMARK_.call(null,axstr))?null:cljs.core.map.call(null,cljs.core.comp.call(null,((function (idx,vec__116250,fstr,rstr,ret_t,axstr){
return (function (p1__116249_SHARP_){
return cljs.compiler.resolve_type.call(null,env,p1__116249_SHARP_);
});})(idx,vec__116250,fstr,rstr,ret_t,axstr))
,clojure.string.trim),clojure.string.split.call(null,axstr,/,/)));
var G__116253 = ["function(",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null,",",args_ts)),")"].join('');
if(cljs.core.truth_(ret_t)){
return [G__116253,":",cljs.core.str.cljs$core$IFn$_invoke$arity$1(ret_t)].join('');
} else {
return G__116253;
}
} else {
if(cljs.core.truth_(goog.string.endsWith(t,"="))){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.resolve_type.call(null,env,cljs.core.subs.call(null,t,(0),(cljs.core.count.call(null,t) - (1))))),"="].join('');
} else {
return cljs.compiler.munge.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(cljs.analyzer.resolve_var.call(null,env,cljs.core.symbol.call(null,t)))));

}
}
}
}
}
}
});
cljs.compiler.resolve_types = (function cljs$compiler$resolve_types(env,ts){
var ts__$1 = cljs.core.subs.call(null,clojure.string.trim.call(null,ts),(1),(cljs.core.count.call(null,ts) - (1)));
var xs = clojure.string.split.call(null,ts__$1,/\|/);
return ["{",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null,"|",cljs.core.map.call(null,((function (ts__$1,xs){
return (function (p1__116254_SHARP_){
return cljs.compiler.resolve_type.call(null,env,p1__116254_SHARP_);
});})(ts__$1,xs))
,xs))),"}"].join('');
});
cljs.compiler.munge_param_return = (function cljs$compiler$munge_param_return(env,line){
if(cljs.core.truth_(cljs.core.re_find.call(null,/@param/,line))){
var vec__116255 = cljs.core.map.call(null,clojure.string.trim,clojure.string.split.call(null,clojure.string.trim.call(null,line),/ /));
var seq__116256 = cljs.core.seq.call(null,vec__116255);
var first__116257 = cljs.core.first.call(null,seq__116256);
var seq__116256__$1 = cljs.core.next.call(null,seq__116256);
var p = first__116257;
var first__116257__$1 = cljs.core.first.call(null,seq__116256__$1);
var seq__116256__$2 = cljs.core.next.call(null,seq__116256__$1);
var ts = first__116257__$1;
var first__116257__$2 = cljs.core.first.call(null,seq__116256__$2);
var seq__116256__$3 = cljs.core.next.call(null,seq__116256__$2);
var n = first__116257__$2;
var xs = seq__116256__$3;
if(cljs.core.truth_((function (){var and__4120__auto__ = cljs.core._EQ_.call(null,"@param",p);
if(and__4120__auto__){
var and__4120__auto____$1 = ts;
if(cljs.core.truth_(and__4120__auto____$1)){
return goog.string.startsWith(ts,"{");
} else {
return and__4120__auto____$1;
}
} else {
return and__4120__auto__;
}
})())){
return clojure.string.join.call(null," ",cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [p,cljs.compiler.resolve_types.call(null,env,ts),cljs.compiler.munge.call(null,n)], null),xs));
} else {
return line;
}
} else {
if(cljs.core.truth_(cljs.core.re_find.call(null,/@return/,line))){
var vec__116258 = cljs.core.map.call(null,clojure.string.trim,clojure.string.split.call(null,clojure.string.trim.call(null,line),/ /));
var seq__116259 = cljs.core.seq.call(null,vec__116258);
var first__116260 = cljs.core.first.call(null,seq__116259);
var seq__116259__$1 = cljs.core.next.call(null,seq__116259);
var p = first__116260;
var first__116260__$1 = cljs.core.first.call(null,seq__116259__$1);
var seq__116259__$2 = cljs.core.next.call(null,seq__116259__$1);
var ts = first__116260__$1;
var xs = seq__116259__$2;
if(cljs.core.truth_((function (){var and__4120__auto__ = cljs.core._EQ_.call(null,"@return",p);
if(and__4120__auto__){
var and__4120__auto____$1 = ts;
if(cljs.core.truth_(and__4120__auto____$1)){
return goog.string.startsWith(ts,"{");
} else {
return and__4120__auto____$1;
}
} else {
return and__4120__auto__;
}
})())){
return clojure.string.join.call(null," ",cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p,cljs.compiler.resolve_types.call(null,env,ts)], null),xs));
} else {
return line;
}
} else {
return line;

}
}
});
cljs.compiler.checking_types_QMARK_ = (function cljs$compiler$checking_types_QMARK_(){
return new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"warning","warning",-1685650671),null,new cljs.core.Keyword(null,"error","error",-978969032),null], null), null).call(null,cljs.core.get_in.call(null,cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"options","options",99638489),new cljs.core.Keyword(null,"closure-warnings","closure-warnings",1362834211),new cljs.core.Keyword(null,"check-types","check-types",-833794607)], null)));
});
/**
 * Emit a nicely formatted comment string.
 */
cljs.compiler.emit_comment = (function cljs$compiler$emit_comment(var_args){
var G__116263 = arguments.length;
switch (G__116263) {
case 2:
return cljs.compiler.emit_comment.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.compiler.emit_comment.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.compiler.emit_comment.cljs$core$IFn$_invoke$arity$2 = (function (doc,jsdoc){
return cljs.compiler.emit_comment.call(null,null,doc,jsdoc);
});

cljs.compiler.emit_comment.cljs$core$IFn$_invoke$arity$3 = (function (env,doc,jsdoc){
var docs = (cljs.core.truth_(doc)?new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [doc], null):null);
var docs__$1 = (cljs.core.truth_(jsdoc)?cljs.core.concat.call(null,docs,jsdoc):docs);
var docs__$2 = cljs.core.remove.call(null,cljs.core.nil_QMARK_,docs__$1);
var print_comment_lines = ((function (docs,docs__$1,docs__$2){
return (function cljs$compiler$print_comment_lines(e){
var vec__116271 = cljs.core.map.call(null,((function (docs,docs__$1,docs__$2){
return (function (p1__116261_SHARP_){
if(cljs.core.truth_(cljs.compiler.checking_types_QMARK_.call(null))){
return cljs.compiler.munge_param_return.call(null,env,p1__116261_SHARP_);
} else {
return p1__116261_SHARP_;
}
});})(docs,docs__$1,docs__$2))
,clojure.string.split_lines.call(null,e));
var seq__116272 = cljs.core.seq.call(null,vec__116271);
var first__116273 = cljs.core.first.call(null,seq__116272);
var seq__116272__$1 = cljs.core.next.call(null,seq__116272);
var x = first__116273;
var ys = seq__116272__$1;
cljs.compiler.emitln.call(null," * ",clojure.string.replace.call(null,x,"*/","* /"));

var seq__116274 = cljs.core.seq.call(null,ys);
var chunk__116275 = null;
var count__116276 = (0);
var i__116277 = (0);
while(true){
if((i__116277 < count__116276)){
var next_line = cljs.core._nth.call(null,chunk__116275,i__116277);
cljs.compiler.emitln.call(null," * ",clojure.string.replace.call(null,clojure.string.replace.call(null,next_line,/^   /,""),"*/","* /"));


var G__116283 = seq__116274;
var G__116284 = chunk__116275;
var G__116285 = count__116276;
var G__116286 = (i__116277 + (1));
seq__116274 = G__116283;
chunk__116275 = G__116284;
count__116276 = G__116285;
i__116277 = G__116286;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq.call(null,seq__116274);
if(temp__5735__auto__){
var seq__116274__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116274__$1)){
var c__4550__auto__ = cljs.core.chunk_first.call(null,seq__116274__$1);
var G__116287 = cljs.core.chunk_rest.call(null,seq__116274__$1);
var G__116288 = c__4550__auto__;
var G__116289 = cljs.core.count.call(null,c__4550__auto__);
var G__116290 = (0);
seq__116274 = G__116287;
chunk__116275 = G__116288;
count__116276 = G__116289;
i__116277 = G__116290;
continue;
} else {
var next_line = cljs.core.first.call(null,seq__116274__$1);
cljs.compiler.emitln.call(null," * ",clojure.string.replace.call(null,clojure.string.replace.call(null,next_line,/^   /,""),"*/","* /"));


var G__116291 = cljs.core.next.call(null,seq__116274__$1);
var G__116292 = null;
var G__116293 = (0);
var G__116294 = (0);
seq__116274 = G__116291;
chunk__116275 = G__116292;
count__116276 = G__116293;
i__116277 = G__116294;
continue;
}
} else {
return null;
}
}
break;
}
});})(docs,docs__$1,docs__$2))
;
if(cljs.core.seq.call(null,docs__$2)){
cljs.compiler.emitln.call(null,"/**");

var seq__116278_116295 = cljs.core.seq.call(null,docs__$2);
var chunk__116279_116296 = null;
var count__116280_116297 = (0);
var i__116281_116298 = (0);
while(true){
if((i__116281_116298 < count__116280_116297)){
var e_116299 = cljs.core._nth.call(null,chunk__116279_116296,i__116281_116298);
if(cljs.core.truth_(e_116299)){
print_comment_lines.call(null,e_116299);
} else {
}


var G__116300 = seq__116278_116295;
var G__116301 = chunk__116279_116296;
var G__116302 = count__116280_116297;
var G__116303 = (i__116281_116298 + (1));
seq__116278_116295 = G__116300;
chunk__116279_116296 = G__116301;
count__116280_116297 = G__116302;
i__116281_116298 = G__116303;
continue;
} else {
var temp__5735__auto___116304 = cljs.core.seq.call(null,seq__116278_116295);
if(temp__5735__auto___116304){
var seq__116278_116305__$1 = temp__5735__auto___116304;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116278_116305__$1)){
var c__4550__auto___116306 = cljs.core.chunk_first.call(null,seq__116278_116305__$1);
var G__116307 = cljs.core.chunk_rest.call(null,seq__116278_116305__$1);
var G__116308 = c__4550__auto___116306;
var G__116309 = cljs.core.count.call(null,c__4550__auto___116306);
var G__116310 = (0);
seq__116278_116295 = G__116307;
chunk__116279_116296 = G__116308;
count__116280_116297 = G__116309;
i__116281_116298 = G__116310;
continue;
} else {
var e_116311 = cljs.core.first.call(null,seq__116278_116305__$1);
if(cljs.core.truth_(e_116311)){
print_comment_lines.call(null,e_116311);
} else {
}


var G__116312 = cljs.core.next.call(null,seq__116278_116305__$1);
var G__116313 = null;
var G__116314 = (0);
var G__116315 = (0);
seq__116278_116295 = G__116312;
chunk__116279_116296 = G__116313;
count__116280_116297 = G__116314;
i__116281_116298 = G__116315;
continue;
}
} else {
}
}
break;
}

return cljs.compiler.emitln.call(null," */");
} else {
return null;
}
});

cljs.compiler.emit_comment.cljs$lang$maxFixedArity = 3;

cljs.compiler.valid_define_value_QMARK_ = (function cljs$compiler$valid_define_value_QMARK_(x){
return ((typeof x === 'string') || (x === true) || (x === false) || (typeof x === 'number'));
});
cljs.compiler.get_define = (function cljs$compiler$get_define(mname,jsdoc){
var opts = cljs.core.get.call(null,cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_),new cljs.core.Keyword(null,"options","options",99638489));
var and__4120__auto__ = cljs.core.some.call(null,((function (opts){
return (function (p1__116317_SHARP_){
return goog.string.startsWith(p1__116317_SHARP_,"@define");
});})(opts))
,jsdoc);
if(cljs.core.truth_(and__4120__auto__)){
var and__4120__auto____$1 = opts;
if(cljs.core.truth_(and__4120__auto____$1)){
var and__4120__auto____$2 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"optimizations","optimizations",-2047476854).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"none","none",1333468478));
if(and__4120__auto____$2){
var define = cljs.core.get_in.call(null,opts,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"closure-defines","closure-defines",-1213856476),cljs.core.str.cljs$core$IFn$_invoke$arity$1(mname)], null));
if(cljs.compiler.valid_define_value_QMARK_.call(null,define)){
return cljs.core.pr_str.call(null,define);
} else {
return null;
}
} else {
return and__4120__auto____$2;
}
} else {
return and__4120__auto____$1;
}
} else {
return and__4120__auto__;
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"def","def",-1043430536),(function (p__116318){
var map__116319 = p__116318;
var map__116319__$1 = (((((!((map__116319 == null))))?(((((map__116319.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116319.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116319):map__116319);
var doc = cljs.core.get.call(null,map__116319__$1,new cljs.core.Keyword(null,"doc","doc",1913296891));
var jsdoc = cljs.core.get.call(null,map__116319__$1,new cljs.core.Keyword(null,"jsdoc","jsdoc",1745183516));
var test = cljs.core.get.call(null,map__116319__$1,new cljs.core.Keyword(null,"test","test",577538877));
var init = cljs.core.get.call(null,map__116319__$1,new cljs.core.Keyword(null,"init","init",-1875481434));
var name = cljs.core.get.call(null,map__116319__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var env = cljs.core.get.call(null,map__116319__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var export$ = cljs.core.get.call(null,map__116319__$1,new cljs.core.Keyword(null,"export","export",214356590));
var var$ = cljs.core.get.call(null,map__116319__$1,new cljs.core.Keyword(null,"var","var",-769682797));
var var_ast = cljs.core.get.call(null,map__116319__$1,new cljs.core.Keyword(null,"var-ast","var-ast",1200379319));
if(cljs.core.truth_((function (){var or__4131__auto__ = init;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.Keyword(null,"def-emits-var","def-emits-var",-1551927320).cljs$core$IFn$_invoke$arity$1(env);
}
})())){
var mname = cljs.compiler.munge.call(null,name);
cljs.compiler.emit_comment.call(null,env,doc,cljs.core.concat.call(null,jsdoc,new cljs.core.Keyword(null,"jsdoc","jsdoc",1745183516).cljs$core$IFn$_invoke$arity$1(init)));

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,"return (");
} else {
}

if(cljs.core.truth_(new cljs.core.Keyword(null,"def-emits-var","def-emits-var",-1551927320).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,"(function (){");
} else {
}

cljs.compiler.emits.call(null,var$);

if(cljs.core.truth_(init)){
cljs.compiler.emits.call(null," = ",(function (){var temp__5733__auto__ = cljs.compiler.get_define.call(null,mname,jsdoc);
if(cljs.core.truth_(temp__5733__auto__)){
var define = temp__5733__auto__;
return define;
} else {
return init;
}
})());
} else {
}

if(cljs.core.truth_(new cljs.core.Keyword(null,"def-emits-var","def-emits-var",-1551927320).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,"; return (");

cljs.compiler.emits.call(null,cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"op","op",-1882987955),new cljs.core.Keyword(null,"the-var","the-var",1428415613),new cljs.core.Keyword(null,"env","env",-1815813235),cljs.core.assoc.call(null,env,new cljs.core.Keyword(null,"context","context",-830191113),new cljs.core.Keyword(null,"expr","expr",745722291))], null),var_ast));

cljs.compiler.emitln.call(null,");})()");
} else {
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,")");
} else {
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
} else {
cljs.compiler.emitln.call(null,";");
}

if(cljs.core.truth_(export$)){
cljs.compiler.emitln.call(null,"goog.exportSymbol('",cljs.compiler.munge.call(null,export$),"', ",mname,");");
} else {
}

if(cljs.core.truth_((function (){var and__4120__auto__ = cljs.analyzer._STAR_load_tests_STAR_;
if(and__4120__auto__){
return test;
} else {
return and__4120__auto__;
}
})())){
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emitln.call(null,";");
} else {
}

return cljs.compiler.emitln.call(null,var$,".cljs$lang$test = ",test,";");
} else {
return null;
}
} else {
return null;
}
}));
cljs.compiler.emit_apply_to = (function cljs$compiler$emit_apply_to(p__116321){
var map__116322 = p__116321;
var map__116322__$1 = (((((!((map__116322 == null))))?(((((map__116322.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116322.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116322):map__116322);
var name = cljs.core.get.call(null,map__116322__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var params = cljs.core.get.call(null,map__116322__$1,new cljs.core.Keyword(null,"params","params",710516235));
var env = cljs.core.get.call(null,map__116322__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var arglist = cljs.core.gensym.call(null,"arglist__");
var delegate_name = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.munge.call(null,name)),"__delegate"].join('');
cljs.compiler.emitln.call(null,"(function (",arglist,"){");

var seq__116324_116348 = cljs.core.seq.call(null,cljs.core.map_indexed.call(null,cljs.core.vector,cljs.core.drop_last.call(null,(2),params)));
var chunk__116325_116349 = null;
var count__116326_116350 = (0);
var i__116327_116351 = (0);
while(true){
if((i__116327_116351 < count__116326_116350)){
var vec__116334_116352 = cljs.core._nth.call(null,chunk__116325_116349,i__116327_116351);
var i_116353 = cljs.core.nth.call(null,vec__116334_116352,(0),null);
var param_116354 = cljs.core.nth.call(null,vec__116334_116352,(1),null);
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,param_116354);

cljs.compiler.emits.call(null," = cljs.core.first(");

cljs.compiler.emitln.call(null,arglist,");");

cljs.compiler.emitln.call(null,arglist," = cljs.core.next(",arglist,");");


var G__116355 = seq__116324_116348;
var G__116356 = chunk__116325_116349;
var G__116357 = count__116326_116350;
var G__116358 = (i__116327_116351 + (1));
seq__116324_116348 = G__116355;
chunk__116325_116349 = G__116356;
count__116326_116350 = G__116357;
i__116327_116351 = G__116358;
continue;
} else {
var temp__5735__auto___116359 = cljs.core.seq.call(null,seq__116324_116348);
if(temp__5735__auto___116359){
var seq__116324_116360__$1 = temp__5735__auto___116359;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116324_116360__$1)){
var c__4550__auto___116361 = cljs.core.chunk_first.call(null,seq__116324_116360__$1);
var G__116362 = cljs.core.chunk_rest.call(null,seq__116324_116360__$1);
var G__116363 = c__4550__auto___116361;
var G__116364 = cljs.core.count.call(null,c__4550__auto___116361);
var G__116365 = (0);
seq__116324_116348 = G__116362;
chunk__116325_116349 = G__116363;
count__116326_116350 = G__116364;
i__116327_116351 = G__116365;
continue;
} else {
var vec__116337_116366 = cljs.core.first.call(null,seq__116324_116360__$1);
var i_116367 = cljs.core.nth.call(null,vec__116337_116366,(0),null);
var param_116368 = cljs.core.nth.call(null,vec__116337_116366,(1),null);
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,param_116368);

cljs.compiler.emits.call(null," = cljs.core.first(");

cljs.compiler.emitln.call(null,arglist,");");

cljs.compiler.emitln.call(null,arglist," = cljs.core.next(",arglist,");");


var G__116369 = cljs.core.next.call(null,seq__116324_116360__$1);
var G__116370 = null;
var G__116371 = (0);
var G__116372 = (0);
seq__116324_116348 = G__116369;
chunk__116325_116349 = G__116370;
count__116326_116350 = G__116371;
i__116327_116351 = G__116372;
continue;
}
} else {
}
}
break;
}

if(((1) < cljs.core.count.call(null,params))){
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,cljs.core.last.call(null,cljs.core.butlast.call(null,params)));

cljs.compiler.emitln.call(null," = cljs.core.first(",arglist,");");

cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,cljs.core.last.call(null,params));

cljs.compiler.emitln.call(null," = cljs.core.rest(",arglist,");");

cljs.compiler.emits.call(null,"return ",delegate_name,"(");

var seq__116340_116373 = cljs.core.seq.call(null,params);
var chunk__116341_116374 = null;
var count__116342_116375 = (0);
var i__116343_116376 = (0);
while(true){
if((i__116343_116376 < count__116342_116375)){
var param_116377 = cljs.core._nth.call(null,chunk__116341_116374,i__116343_116376);
cljs.compiler.emit.call(null,param_116377);

if(cljs.core._EQ_.call(null,param_116377,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__116378 = seq__116340_116373;
var G__116379 = chunk__116341_116374;
var G__116380 = count__116342_116375;
var G__116381 = (i__116343_116376 + (1));
seq__116340_116373 = G__116378;
chunk__116341_116374 = G__116379;
count__116342_116375 = G__116380;
i__116343_116376 = G__116381;
continue;
} else {
var temp__5735__auto___116382 = cljs.core.seq.call(null,seq__116340_116373);
if(temp__5735__auto___116382){
var seq__116340_116383__$1 = temp__5735__auto___116382;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116340_116383__$1)){
var c__4550__auto___116384 = cljs.core.chunk_first.call(null,seq__116340_116383__$1);
var G__116385 = cljs.core.chunk_rest.call(null,seq__116340_116383__$1);
var G__116386 = c__4550__auto___116384;
var G__116387 = cljs.core.count.call(null,c__4550__auto___116384);
var G__116388 = (0);
seq__116340_116373 = G__116385;
chunk__116341_116374 = G__116386;
count__116342_116375 = G__116387;
i__116343_116376 = G__116388;
continue;
} else {
var param_116389 = cljs.core.first.call(null,seq__116340_116383__$1);
cljs.compiler.emit.call(null,param_116389);

if(cljs.core._EQ_.call(null,param_116389,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__116390 = cljs.core.next.call(null,seq__116340_116383__$1);
var G__116391 = null;
var G__116392 = (0);
var G__116393 = (0);
seq__116340_116373 = G__116390;
chunk__116341_116374 = G__116391;
count__116342_116375 = G__116392;
i__116343_116376 = G__116393;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,");");
} else {
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,cljs.core.last.call(null,params));

cljs.compiler.emitln.call(null," = cljs.core.seq(",arglist,");");

cljs.compiler.emits.call(null,"return ",delegate_name,"(");

var seq__116344_116394 = cljs.core.seq.call(null,params);
var chunk__116345_116395 = null;
var count__116346_116396 = (0);
var i__116347_116397 = (0);
while(true){
if((i__116347_116397 < count__116346_116396)){
var param_116398 = cljs.core._nth.call(null,chunk__116345_116395,i__116347_116397);
cljs.compiler.emit.call(null,param_116398);

if(cljs.core._EQ_.call(null,param_116398,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__116399 = seq__116344_116394;
var G__116400 = chunk__116345_116395;
var G__116401 = count__116346_116396;
var G__116402 = (i__116347_116397 + (1));
seq__116344_116394 = G__116399;
chunk__116345_116395 = G__116400;
count__116346_116396 = G__116401;
i__116347_116397 = G__116402;
continue;
} else {
var temp__5735__auto___116403 = cljs.core.seq.call(null,seq__116344_116394);
if(temp__5735__auto___116403){
var seq__116344_116404__$1 = temp__5735__auto___116403;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116344_116404__$1)){
var c__4550__auto___116405 = cljs.core.chunk_first.call(null,seq__116344_116404__$1);
var G__116406 = cljs.core.chunk_rest.call(null,seq__116344_116404__$1);
var G__116407 = c__4550__auto___116405;
var G__116408 = cljs.core.count.call(null,c__4550__auto___116405);
var G__116409 = (0);
seq__116344_116394 = G__116406;
chunk__116345_116395 = G__116407;
count__116346_116396 = G__116408;
i__116347_116397 = G__116409;
continue;
} else {
var param_116410 = cljs.core.first.call(null,seq__116344_116404__$1);
cljs.compiler.emit.call(null,param_116410);

if(cljs.core._EQ_.call(null,param_116410,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__116411 = cljs.core.next.call(null,seq__116344_116404__$1);
var G__116412 = null;
var G__116413 = (0);
var G__116414 = (0);
seq__116344_116394 = G__116411;
chunk__116345_116395 = G__116412;
count__116346_116396 = G__116413;
i__116347_116397 = G__116414;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,");");
}

return cljs.compiler.emits.call(null,"})");
});
cljs.compiler.emit_fn_params = (function cljs$compiler$emit_fn_params(params){
var seq__116415 = cljs.core.seq.call(null,params);
var chunk__116416 = null;
var count__116417 = (0);
var i__116418 = (0);
while(true){
if((i__116418 < count__116417)){
var param = cljs.core._nth.call(null,chunk__116416,i__116418);
cljs.compiler.emit.call(null,param);

if(cljs.core._EQ_.call(null,param,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__116419 = seq__116415;
var G__116420 = chunk__116416;
var G__116421 = count__116417;
var G__116422 = (i__116418 + (1));
seq__116415 = G__116419;
chunk__116416 = G__116420;
count__116417 = G__116421;
i__116418 = G__116422;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq.call(null,seq__116415);
if(temp__5735__auto__){
var seq__116415__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116415__$1)){
var c__4550__auto__ = cljs.core.chunk_first.call(null,seq__116415__$1);
var G__116423 = cljs.core.chunk_rest.call(null,seq__116415__$1);
var G__116424 = c__4550__auto__;
var G__116425 = cljs.core.count.call(null,c__4550__auto__);
var G__116426 = (0);
seq__116415 = G__116423;
chunk__116416 = G__116424;
count__116417 = G__116425;
i__116418 = G__116426;
continue;
} else {
var param = cljs.core.first.call(null,seq__116415__$1);
cljs.compiler.emit.call(null,param);

if(cljs.core._EQ_.call(null,param,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__116427 = cljs.core.next.call(null,seq__116415__$1);
var G__116428 = null;
var G__116429 = (0);
var G__116430 = (0);
seq__116415 = G__116427;
chunk__116416 = G__116428;
count__116417 = G__116429;
i__116418 = G__116430;
continue;
}
} else {
return null;
}
}
break;
}
});
cljs.compiler.emit_fn_method = (function cljs$compiler$emit_fn_method(p__116431){
var map__116432 = p__116431;
var map__116432__$1 = (((((!((map__116432 == null))))?(((((map__116432.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116432.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116432):map__116432);
var expr = cljs.core.get.call(null,map__116432__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var type = cljs.core.get.call(null,map__116432__$1,new cljs.core.Keyword(null,"type","type",1174270348));
var name = cljs.core.get.call(null,map__116432__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var params = cljs.core.get.call(null,map__116432__$1,new cljs.core.Keyword(null,"params","params",710516235));
var env = cljs.core.get.call(null,map__116432__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var recurs = cljs.core.get.call(null,map__116432__$1,new cljs.core.Keyword(null,"recurs","recurs",-1959309309));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emits.call(null,"(function ",cljs.compiler.munge.call(null,name),"(");

cljs.compiler.emit_fn_params.call(null,params);

cljs.compiler.emitln.call(null,"){");

if(cljs.core.truth_(type)){
cljs.compiler.emitln.call(null,"var self__ = this;");
} else {
}

if(cljs.core.truth_(recurs)){
cljs.compiler.emitln.call(null,"while(true){");
} else {
}

cljs.compiler.emits.call(null,expr);

if(cljs.core.truth_(recurs)){
cljs.compiler.emitln.call(null,"break;");

cljs.compiler.emitln.call(null,"}");
} else {
}

cljs.compiler.emits.call(null,"})");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
});
/**
 * Emit code that copies function arguments into an array starting at an index.
 *   Returns name of var holding the array.
 */
cljs.compiler.emit_arguments_to_array = (function cljs$compiler$emit_arguments_to_array(startslice){
if((((startslice >= (0))) && (cljs.core.integer_QMARK_.call(null,startslice)))){
} else {
throw (new Error("Assert failed: (and (>= startslice 0) (integer? startslice))"));
}

var mname = cljs.compiler.munge.call(null,cljs.core.gensym.call(null));
var i = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(mname),"__i"].join('');
var a = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(mname),"__a"].join('');
cljs.compiler.emitln.call(null,"var ",i," = 0, ",a," = new Array(arguments.length -  ",startslice,");");

cljs.compiler.emitln.call(null,"while (",i," < ",a,".length) {",a,"[",i,"] = arguments[",i," + ",startslice,"]; ++",i,";}");

return a;
});
cljs.compiler.emit_variadic_fn_method = (function cljs$compiler$emit_variadic_fn_method(p__116434){
var map__116435 = p__116434;
var map__116435__$1 = (((((!((map__116435 == null))))?(((((map__116435.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116435.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116435):map__116435);
var f = map__116435__$1;
var expr = cljs.core.get.call(null,map__116435__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var max_fixed_arity = cljs.core.get.call(null,map__116435__$1,new cljs.core.Keyword(null,"fixed-arity","fixed-arity",1586445869));
var variadic = cljs.core.get.call(null,map__116435__$1,new cljs.core.Keyword(null,"variadic?","variadic?",584179762));
var type = cljs.core.get.call(null,map__116435__$1,new cljs.core.Keyword(null,"type","type",1174270348));
var name = cljs.core.get.call(null,map__116435__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var params = cljs.core.get.call(null,map__116435__$1,new cljs.core.Keyword(null,"params","params",710516235));
var env = cljs.core.get.call(null,map__116435__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var recurs = cljs.core.get.call(null,map__116435__$1,new cljs.core.Keyword(null,"recurs","recurs",-1959309309));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

var name_116445__$1 = (function (){var or__4131__auto__ = name;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.gensym.call(null);
}
})();
var mname_116446 = cljs.compiler.munge.call(null,name_116445__$1);
var delegate_name_116447 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(mname_116446),"__delegate"].join('');
cljs.compiler.emitln.call(null,"(function() { ");

cljs.compiler.emits.call(null,"var ",delegate_name_116447," = function (");

var seq__116437_116448 = cljs.core.seq.call(null,params);
var chunk__116438_116449 = null;
var count__116439_116450 = (0);
var i__116440_116451 = (0);
while(true){
if((i__116440_116451 < count__116439_116450)){
var param_116452 = cljs.core._nth.call(null,chunk__116438_116449,i__116440_116451);
cljs.compiler.emit.call(null,param_116452);

if(cljs.core._EQ_.call(null,param_116452,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__116453 = seq__116437_116448;
var G__116454 = chunk__116438_116449;
var G__116455 = count__116439_116450;
var G__116456 = (i__116440_116451 + (1));
seq__116437_116448 = G__116453;
chunk__116438_116449 = G__116454;
count__116439_116450 = G__116455;
i__116440_116451 = G__116456;
continue;
} else {
var temp__5735__auto___116457 = cljs.core.seq.call(null,seq__116437_116448);
if(temp__5735__auto___116457){
var seq__116437_116458__$1 = temp__5735__auto___116457;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116437_116458__$1)){
var c__4550__auto___116459 = cljs.core.chunk_first.call(null,seq__116437_116458__$1);
var G__116460 = cljs.core.chunk_rest.call(null,seq__116437_116458__$1);
var G__116461 = c__4550__auto___116459;
var G__116462 = cljs.core.count.call(null,c__4550__auto___116459);
var G__116463 = (0);
seq__116437_116448 = G__116460;
chunk__116438_116449 = G__116461;
count__116439_116450 = G__116462;
i__116440_116451 = G__116463;
continue;
} else {
var param_116464 = cljs.core.first.call(null,seq__116437_116458__$1);
cljs.compiler.emit.call(null,param_116464);

if(cljs.core._EQ_.call(null,param_116464,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__116465 = cljs.core.next.call(null,seq__116437_116458__$1);
var G__116466 = null;
var G__116467 = (0);
var G__116468 = (0);
seq__116437_116448 = G__116465;
chunk__116438_116449 = G__116466;
count__116439_116450 = G__116467;
i__116440_116451 = G__116468;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"){");

if(cljs.core.truth_(type)){
cljs.compiler.emitln.call(null,"var self__ = this;");
} else {
}

if(cljs.core.truth_(recurs)){
cljs.compiler.emitln.call(null,"while(true){");
} else {
}

cljs.compiler.emits.call(null,expr);

if(cljs.core.truth_(recurs)){
cljs.compiler.emitln.call(null,"break;");

cljs.compiler.emitln.call(null,"}");
} else {
}

cljs.compiler.emitln.call(null,"};");

cljs.compiler.emitln.call(null,"var ",mname_116446," = function (",cljs.compiler.comma_sep.call(null,(cljs.core.truth_(variadic)?cljs.core.concat.call(null,cljs.core.butlast.call(null,params),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"var_args","var_args",1214280389,null)], null)):params)),"){");

if(cljs.core.truth_(type)){
cljs.compiler.emitln.call(null,"var self__ = this;");
} else {
}

if(cljs.core.truth_(variadic)){
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,cljs.core.last.call(null,params));

cljs.compiler.emitln.call(null," = null;");

cljs.compiler.emitln.call(null,"if (arguments.length > ",(cljs.core.count.call(null,params) - (1)),") {");

var a_116469 = cljs.compiler.emit_arguments_to_array.call(null,(cljs.core.count.call(null,params) - (1)));
cljs.compiler.emitln.call(null,"  ",cljs.core.last.call(null,params)," = new cljs.core.IndexedSeq(",a_116469,",0,null);");

cljs.compiler.emitln.call(null,"} ");
} else {
}

cljs.compiler.emits.call(null,"return ",delegate_name_116447,".call(this,");

var seq__116441_116470 = cljs.core.seq.call(null,params);
var chunk__116442_116471 = null;
var count__116443_116472 = (0);
var i__116444_116473 = (0);
while(true){
if((i__116444_116473 < count__116443_116472)){
var param_116474 = cljs.core._nth.call(null,chunk__116442_116471,i__116444_116473);
cljs.compiler.emit.call(null,param_116474);

if(cljs.core._EQ_.call(null,param_116474,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__116475 = seq__116441_116470;
var G__116476 = chunk__116442_116471;
var G__116477 = count__116443_116472;
var G__116478 = (i__116444_116473 + (1));
seq__116441_116470 = G__116475;
chunk__116442_116471 = G__116476;
count__116443_116472 = G__116477;
i__116444_116473 = G__116478;
continue;
} else {
var temp__5735__auto___116479 = cljs.core.seq.call(null,seq__116441_116470);
if(temp__5735__auto___116479){
var seq__116441_116480__$1 = temp__5735__auto___116479;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116441_116480__$1)){
var c__4550__auto___116481 = cljs.core.chunk_first.call(null,seq__116441_116480__$1);
var G__116482 = cljs.core.chunk_rest.call(null,seq__116441_116480__$1);
var G__116483 = c__4550__auto___116481;
var G__116484 = cljs.core.count.call(null,c__4550__auto___116481);
var G__116485 = (0);
seq__116441_116470 = G__116482;
chunk__116442_116471 = G__116483;
count__116443_116472 = G__116484;
i__116444_116473 = G__116485;
continue;
} else {
var param_116486 = cljs.core.first.call(null,seq__116441_116480__$1);
cljs.compiler.emit.call(null,param_116486);

if(cljs.core._EQ_.call(null,param_116486,cljs.core.last.call(null,params))){
} else {
cljs.compiler.emits.call(null,",");
}


var G__116487 = cljs.core.next.call(null,seq__116441_116480__$1);
var G__116488 = null;
var G__116489 = (0);
var G__116490 = (0);
seq__116441_116470 = G__116487;
chunk__116442_116471 = G__116488;
count__116443_116472 = G__116489;
i__116444_116473 = G__116490;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emits.call(null,");");

cljs.compiler.emitln.call(null,"};");

cljs.compiler.emitln.call(null,mname_116446,".cljs$lang$maxFixedArity = ",max_fixed_arity,";");

cljs.compiler.emits.call(null,mname_116446,".cljs$lang$applyTo = ");

cljs.compiler.emit_apply_to.call(null,cljs.core.assoc.call(null,f,new cljs.core.Keyword(null,"name","name",1843675177),name_116445__$1));

cljs.compiler.emitln.call(null,";");

cljs.compiler.emitln.call(null,mname_116446,".cljs$core$IFn$_invoke$arity$variadic = ",delegate_name_116447,";");

cljs.compiler.emitln.call(null,"return ",mname_116446,";");

cljs.compiler.emitln.call(null,"})()");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"fn","fn",-1175266204),(function (p__116494){
var map__116495 = p__116494;
var map__116495__$1 = (((((!((map__116495 == null))))?(((((map__116495.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116495.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116495):map__116495);
var variadic = cljs.core.get.call(null,map__116495__$1,new cljs.core.Keyword(null,"variadic?","variadic?",584179762));
var name = cljs.core.get.call(null,map__116495__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var env = cljs.core.get.call(null,map__116495__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var methods$ = cljs.core.get.call(null,map__116495__$1,new cljs.core.Keyword(null,"methods","methods",453930866));
var max_fixed_arity = cljs.core.get.call(null,map__116495__$1,new cljs.core.Keyword(null,"max-fixed-arity","max-fixed-arity",-690205543));
var recur_frames = cljs.core.get.call(null,map__116495__$1,new cljs.core.Keyword(null,"recur-frames","recur-frames",-307205196));
var loop_lets = cljs.core.get.call(null,map__116495__$1,new cljs.core.Keyword(null,"loop-lets","loop-lets",2036794185));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"statement","statement",-32780863),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
return null;
} else {
var loop_locals = cljs.core.seq.call(null,cljs.core.map.call(null,cljs.compiler.munge,cljs.core.concat.call(null,cljs.core.mapcat.call(null,new cljs.core.Keyword(null,"params","params",710516235),cljs.core.filter.call(null,((function (map__116495,map__116495__$1,variadic,name,env,methods$,max_fixed_arity,recur_frames,loop_lets){
return (function (p1__116491_SHARP_){
var and__4120__auto__ = p1__116491_SHARP_;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.deref.call(null,new cljs.core.Keyword(null,"flag","flag",1088647881).cljs$core$IFn$_invoke$arity$1(p1__116491_SHARP_));
} else {
return and__4120__auto__;
}
});})(map__116495,map__116495__$1,variadic,name,env,methods$,max_fixed_arity,recur_frames,loop_lets))
,recur_frames)),cljs.core.mapcat.call(null,new cljs.core.Keyword(null,"params","params",710516235),loop_lets))));
if(loop_locals){
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emitln.call(null,"((function (",cljs.compiler.comma_sep.call(null,cljs.core.map.call(null,cljs.compiler.munge,loop_locals)),"){");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
} else {
cljs.compiler.emits.call(null,"return ");
}
} else {
}

if(cljs.core._EQ_.call(null,(1),cljs.core.count.call(null,methods$))){
if(cljs.core.truth_(variadic)){
cljs.compiler.emit_variadic_fn_method.call(null,cljs.core.assoc.call(null,cljs.core.first.call(null,methods$),new cljs.core.Keyword(null,"name","name",1843675177),name));
} else {
cljs.compiler.emit_fn_method.call(null,cljs.core.assoc.call(null,cljs.core.first.call(null,methods$),new cljs.core.Keyword(null,"name","name",1843675177),name));
}
} else {
var name_116548__$1 = (function (){var or__4131__auto__ = name;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.gensym.call(null);
}
})();
var mname_116549 = cljs.compiler.munge.call(null,name_116548__$1);
var maxparams_116550 = cljs.core.apply.call(null,cljs.core.max_key,cljs.core.count,cljs.core.map.call(null,new cljs.core.Keyword(null,"params","params",710516235),methods$));
var mmap_116551 = cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,cljs.core.map.call(null,((function (name_116548__$1,mname_116549,maxparams_116550,loop_locals,map__116495,map__116495__$1,variadic,name,env,methods$,max_fixed_arity,recur_frames,loop_lets){
return (function (method){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.compiler.munge.call(null,cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(mname_116549),"__",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(method)))].join(''))),method], null);
});})(name_116548__$1,mname_116549,maxparams_116550,loop_locals,map__116495,map__116495__$1,variadic,name,env,methods$,max_fixed_arity,recur_frames,loop_lets))
,methods$));
var ms_116552 = cljs.core.sort_by.call(null,((function (name_116548__$1,mname_116549,maxparams_116550,mmap_116551,loop_locals,map__116495,map__116495__$1,variadic,name,env,methods$,max_fixed_arity,recur_frames,loop_lets){
return (function (p1__116492_SHARP_){
return cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(cljs.core.second.call(null,p1__116492_SHARP_)));
});})(name_116548__$1,mname_116549,maxparams_116550,mmap_116551,loop_locals,map__116495,map__116495__$1,variadic,name,env,methods$,max_fixed_arity,recur_frames,loop_lets))
,cljs.core.seq.call(null,mmap_116551));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emitln.call(null,"(function() {");

cljs.compiler.emitln.call(null,"var ",mname_116549," = null;");

var seq__116497_116553 = cljs.core.seq.call(null,ms_116552);
var chunk__116498_116554 = null;
var count__116499_116555 = (0);
var i__116500_116556 = (0);
while(true){
if((i__116500_116556 < count__116499_116555)){
var vec__116507_116557 = cljs.core._nth.call(null,chunk__116498_116554,i__116500_116556);
var n_116558 = cljs.core.nth.call(null,vec__116507_116557,(0),null);
var meth_116559 = cljs.core.nth.call(null,vec__116507_116557,(1),null);
cljs.compiler.emits.call(null,"var ",n_116558," = ");

if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic?","variadic?",584179762).cljs$core$IFn$_invoke$arity$1(meth_116559))){
cljs.compiler.emit_variadic_fn_method.call(null,meth_116559);
} else {
cljs.compiler.emit_fn_method.call(null,meth_116559);
}

cljs.compiler.emitln.call(null,";");


var G__116560 = seq__116497_116553;
var G__116561 = chunk__116498_116554;
var G__116562 = count__116499_116555;
var G__116563 = (i__116500_116556 + (1));
seq__116497_116553 = G__116560;
chunk__116498_116554 = G__116561;
count__116499_116555 = G__116562;
i__116500_116556 = G__116563;
continue;
} else {
var temp__5735__auto___116564 = cljs.core.seq.call(null,seq__116497_116553);
if(temp__5735__auto___116564){
var seq__116497_116565__$1 = temp__5735__auto___116564;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116497_116565__$1)){
var c__4550__auto___116566 = cljs.core.chunk_first.call(null,seq__116497_116565__$1);
var G__116567 = cljs.core.chunk_rest.call(null,seq__116497_116565__$1);
var G__116568 = c__4550__auto___116566;
var G__116569 = cljs.core.count.call(null,c__4550__auto___116566);
var G__116570 = (0);
seq__116497_116553 = G__116567;
chunk__116498_116554 = G__116568;
count__116499_116555 = G__116569;
i__116500_116556 = G__116570;
continue;
} else {
var vec__116510_116571 = cljs.core.first.call(null,seq__116497_116565__$1);
var n_116572 = cljs.core.nth.call(null,vec__116510_116571,(0),null);
var meth_116573 = cljs.core.nth.call(null,vec__116510_116571,(1),null);
cljs.compiler.emits.call(null,"var ",n_116572," = ");

if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic?","variadic?",584179762).cljs$core$IFn$_invoke$arity$1(meth_116573))){
cljs.compiler.emit_variadic_fn_method.call(null,meth_116573);
} else {
cljs.compiler.emit_fn_method.call(null,meth_116573);
}

cljs.compiler.emitln.call(null,";");


var G__116574 = cljs.core.next.call(null,seq__116497_116565__$1);
var G__116575 = null;
var G__116576 = (0);
var G__116577 = (0);
seq__116497_116553 = G__116574;
chunk__116498_116554 = G__116575;
count__116499_116555 = G__116576;
i__116500_116556 = G__116577;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,mname_116549," = function(",cljs.compiler.comma_sep.call(null,(cljs.core.truth_(variadic)?cljs.core.concat.call(null,cljs.core.butlast.call(null,maxparams_116550),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"var_args","var_args",1214280389,null)], null)):maxparams_116550)),"){");

if(cljs.core.truth_(variadic)){
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,cljs.core.last.call(null,maxparams_116550));

cljs.compiler.emitln.call(null," = var_args;");
} else {
}

cljs.compiler.emitln.call(null,"switch(arguments.length){");

var seq__116513_116578 = cljs.core.seq.call(null,ms_116552);
var chunk__116514_116579 = null;
var count__116515_116580 = (0);
var i__116516_116581 = (0);
while(true){
if((i__116516_116581 < count__116515_116580)){
var vec__116523_116582 = cljs.core._nth.call(null,chunk__116514_116579,i__116516_116581);
var n_116583 = cljs.core.nth.call(null,vec__116523_116582,(0),null);
var meth_116584 = cljs.core.nth.call(null,vec__116523_116582,(1),null);
if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic?","variadic?",584179762).cljs$core$IFn$_invoke$arity$1(meth_116584))){
cljs.compiler.emitln.call(null,"default:");

var restarg_116585 = cljs.compiler.munge.call(null,cljs.core.gensym.call(null));
cljs.compiler.emitln.call(null,"var ",restarg_116585," = null;");

cljs.compiler.emitln.call(null,"if (arguments.length > ",max_fixed_arity,") {");

var a_116586 = cljs.compiler.emit_arguments_to_array.call(null,max_fixed_arity);
cljs.compiler.emitln.call(null,restarg_116585," = new cljs.core.IndexedSeq(",a_116586,",0,null);");

cljs.compiler.emitln.call(null,"}");

cljs.compiler.emitln.call(null,"return ",n_116583,".cljs$core$IFn$_invoke$arity$variadic(",cljs.compiler.comma_sep.call(null,cljs.core.butlast.call(null,maxparams_116550)),(((cljs.core.count.call(null,maxparams_116550) > (1)))?", ":null),restarg_116585,");");
} else {
var pcnt_116587 = cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(meth_116584));
cljs.compiler.emitln.call(null,"case ",pcnt_116587,":");

cljs.compiler.emitln.call(null,"return ",n_116583,".call(this",(((pcnt_116587 === (0)))?null:(new cljs.core.List(null,",",(new cljs.core.List(null,cljs.compiler.comma_sep.call(null,cljs.core.take.call(null,pcnt_116587,maxparams_116550)),null,(1),null)),(2),null))),");");
}


var G__116588 = seq__116513_116578;
var G__116589 = chunk__116514_116579;
var G__116590 = count__116515_116580;
var G__116591 = (i__116516_116581 + (1));
seq__116513_116578 = G__116588;
chunk__116514_116579 = G__116589;
count__116515_116580 = G__116590;
i__116516_116581 = G__116591;
continue;
} else {
var temp__5735__auto___116592 = cljs.core.seq.call(null,seq__116513_116578);
if(temp__5735__auto___116592){
var seq__116513_116593__$1 = temp__5735__auto___116592;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116513_116593__$1)){
var c__4550__auto___116594 = cljs.core.chunk_first.call(null,seq__116513_116593__$1);
var G__116595 = cljs.core.chunk_rest.call(null,seq__116513_116593__$1);
var G__116596 = c__4550__auto___116594;
var G__116597 = cljs.core.count.call(null,c__4550__auto___116594);
var G__116598 = (0);
seq__116513_116578 = G__116595;
chunk__116514_116579 = G__116596;
count__116515_116580 = G__116597;
i__116516_116581 = G__116598;
continue;
} else {
var vec__116526_116599 = cljs.core.first.call(null,seq__116513_116593__$1);
var n_116600 = cljs.core.nth.call(null,vec__116526_116599,(0),null);
var meth_116601 = cljs.core.nth.call(null,vec__116526_116599,(1),null);
if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic?","variadic?",584179762).cljs$core$IFn$_invoke$arity$1(meth_116601))){
cljs.compiler.emitln.call(null,"default:");

var restarg_116602 = cljs.compiler.munge.call(null,cljs.core.gensym.call(null));
cljs.compiler.emitln.call(null,"var ",restarg_116602," = null;");

cljs.compiler.emitln.call(null,"if (arguments.length > ",max_fixed_arity,") {");

var a_116603 = cljs.compiler.emit_arguments_to_array.call(null,max_fixed_arity);
cljs.compiler.emitln.call(null,restarg_116602," = new cljs.core.IndexedSeq(",a_116603,",0,null);");

cljs.compiler.emitln.call(null,"}");

cljs.compiler.emitln.call(null,"return ",n_116600,".cljs$core$IFn$_invoke$arity$variadic(",cljs.compiler.comma_sep.call(null,cljs.core.butlast.call(null,maxparams_116550)),(((cljs.core.count.call(null,maxparams_116550) > (1)))?", ":null),restarg_116602,");");
} else {
var pcnt_116604 = cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(meth_116601));
cljs.compiler.emitln.call(null,"case ",pcnt_116604,":");

cljs.compiler.emitln.call(null,"return ",n_116600,".call(this",(((pcnt_116604 === (0)))?null:(new cljs.core.List(null,",",(new cljs.core.List(null,cljs.compiler.comma_sep.call(null,cljs.core.take.call(null,pcnt_116604,maxparams_116550)),null,(1),null)),(2),null))),");");
}


var G__116605 = cljs.core.next.call(null,seq__116513_116593__$1);
var G__116606 = null;
var G__116607 = (0);
var G__116608 = (0);
seq__116513_116578 = G__116605;
chunk__116514_116579 = G__116606;
count__116515_116580 = G__116607;
i__116516_116581 = G__116608;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"}");

var arg_count_js_116609 = ((cljs.core._EQ_.call(null,new cljs.core.Symbol(null,"self__","self__",-153190816,null),new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(cljs.core.first.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(cljs.core.val.call(null,cljs.core.first.call(null,ms_116552)))))))?"(arguments.length - 1)":"arguments.length");
cljs.compiler.emitln.call(null,"throw(new Error('Invalid arity: ' + ",arg_count_js_116609,"));");

cljs.compiler.emitln.call(null,"};");

if(cljs.core.truth_(variadic)){
cljs.compiler.emitln.call(null,mname_116549,".cljs$lang$maxFixedArity = ",max_fixed_arity,";");

cljs.compiler.emitln.call(null,mname_116549,".cljs$lang$applyTo = ",cljs.core.some.call(null,((function (name_116548__$1,mname_116549,maxparams_116550,mmap_116551,ms_116552,loop_locals,map__116495,map__116495__$1,variadic,name,env,methods$,max_fixed_arity,recur_frames,loop_lets){
return (function (p1__116493_SHARP_){
var vec__116529 = p1__116493_SHARP_;
var n = cljs.core.nth.call(null,vec__116529,(0),null);
var m = cljs.core.nth.call(null,vec__116529,(1),null);
if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic?","variadic?",584179762).cljs$core$IFn$_invoke$arity$1(m))){
return n;
} else {
return null;
}
});})(name_116548__$1,mname_116549,maxparams_116550,mmap_116551,ms_116552,loop_locals,map__116495,map__116495__$1,variadic,name,env,methods$,max_fixed_arity,recur_frames,loop_lets))
,ms_116552),".cljs$lang$applyTo;");
} else {
}

var seq__116532_116610 = cljs.core.seq.call(null,ms_116552);
var chunk__116533_116611 = null;
var count__116534_116612 = (0);
var i__116535_116613 = (0);
while(true){
if((i__116535_116613 < count__116534_116612)){
var vec__116542_116614 = cljs.core._nth.call(null,chunk__116533_116611,i__116535_116613);
var n_116615 = cljs.core.nth.call(null,vec__116542_116614,(0),null);
var meth_116616 = cljs.core.nth.call(null,vec__116542_116614,(1),null);
var c_116617 = cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(meth_116616));
if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic?","variadic?",584179762).cljs$core$IFn$_invoke$arity$1(meth_116616))){
cljs.compiler.emitln.call(null,mname_116549,".cljs$core$IFn$_invoke$arity$variadic = ",n_116615,".cljs$core$IFn$_invoke$arity$variadic;");
} else {
cljs.compiler.emitln.call(null,mname_116549,".cljs$core$IFn$_invoke$arity$",c_116617," = ",n_116615,";");
}


var G__116618 = seq__116532_116610;
var G__116619 = chunk__116533_116611;
var G__116620 = count__116534_116612;
var G__116621 = (i__116535_116613 + (1));
seq__116532_116610 = G__116618;
chunk__116533_116611 = G__116619;
count__116534_116612 = G__116620;
i__116535_116613 = G__116621;
continue;
} else {
var temp__5735__auto___116622 = cljs.core.seq.call(null,seq__116532_116610);
if(temp__5735__auto___116622){
var seq__116532_116623__$1 = temp__5735__auto___116622;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116532_116623__$1)){
var c__4550__auto___116624 = cljs.core.chunk_first.call(null,seq__116532_116623__$1);
var G__116625 = cljs.core.chunk_rest.call(null,seq__116532_116623__$1);
var G__116626 = c__4550__auto___116624;
var G__116627 = cljs.core.count.call(null,c__4550__auto___116624);
var G__116628 = (0);
seq__116532_116610 = G__116625;
chunk__116533_116611 = G__116626;
count__116534_116612 = G__116627;
i__116535_116613 = G__116628;
continue;
} else {
var vec__116545_116629 = cljs.core.first.call(null,seq__116532_116623__$1);
var n_116630 = cljs.core.nth.call(null,vec__116545_116629,(0),null);
var meth_116631 = cljs.core.nth.call(null,vec__116545_116629,(1),null);
var c_116632 = cljs.core.count.call(null,new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(meth_116631));
if(cljs.core.truth_(new cljs.core.Keyword(null,"variadic?","variadic?",584179762).cljs$core$IFn$_invoke$arity$1(meth_116631))){
cljs.compiler.emitln.call(null,mname_116549,".cljs$core$IFn$_invoke$arity$variadic = ",n_116630,".cljs$core$IFn$_invoke$arity$variadic;");
} else {
cljs.compiler.emitln.call(null,mname_116549,".cljs$core$IFn$_invoke$arity$",c_116632," = ",n_116630,";");
}


var G__116633 = cljs.core.next.call(null,seq__116532_116623__$1);
var G__116634 = null;
var G__116635 = (0);
var G__116636 = (0);
seq__116532_116610 = G__116633;
chunk__116533_116611 = G__116634;
count__116534_116612 = G__116635;
i__116535_116613 = G__116636;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"return ",mname_116549,";");

cljs.compiler.emitln.call(null,"})()");
}

if(loop_locals){
return cljs.compiler.emitln.call(null,";})(",cljs.compiler.comma_sep.call(null,loop_locals),"))");
} else {
return null;
}
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"do","do",46310725),(function (p__116637){
var map__116638 = p__116637;
var map__116638__$1 = (((((!((map__116638 == null))))?(((((map__116638.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116638.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116638):map__116638);
var statements = cljs.core.get.call(null,map__116638__$1,new cljs.core.Keyword(null,"statements","statements",600349855));
var ret = cljs.core.get.call(null,map__116638__$1,new cljs.core.Keyword(null,"ret","ret",-468222814));
var env = cljs.core.get.call(null,map__116638__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env);
if(((cljs.core.seq.call(null,statements)) && (cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)))){
cljs.compiler.emitln.call(null,"(function (){");
} else {
}

var seq__116640_116644 = cljs.core.seq.call(null,statements);
var chunk__116641_116645 = null;
var count__116642_116646 = (0);
var i__116643_116647 = (0);
while(true){
if((i__116643_116647 < count__116642_116646)){
var s_116648 = cljs.core._nth.call(null,chunk__116641_116645,i__116643_116647);
cljs.compiler.emitln.call(null,s_116648);


var G__116649 = seq__116640_116644;
var G__116650 = chunk__116641_116645;
var G__116651 = count__116642_116646;
var G__116652 = (i__116643_116647 + (1));
seq__116640_116644 = G__116649;
chunk__116641_116645 = G__116650;
count__116642_116646 = G__116651;
i__116643_116647 = G__116652;
continue;
} else {
var temp__5735__auto___116653 = cljs.core.seq.call(null,seq__116640_116644);
if(temp__5735__auto___116653){
var seq__116640_116654__$1 = temp__5735__auto___116653;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116640_116654__$1)){
var c__4550__auto___116655 = cljs.core.chunk_first.call(null,seq__116640_116654__$1);
var G__116656 = cljs.core.chunk_rest.call(null,seq__116640_116654__$1);
var G__116657 = c__4550__auto___116655;
var G__116658 = cljs.core.count.call(null,c__4550__auto___116655);
var G__116659 = (0);
seq__116640_116644 = G__116656;
chunk__116641_116645 = G__116657;
count__116642_116646 = G__116658;
i__116643_116647 = G__116659;
continue;
} else {
var s_116660 = cljs.core.first.call(null,seq__116640_116654__$1);
cljs.compiler.emitln.call(null,s_116660);


var G__116661 = cljs.core.next.call(null,seq__116640_116654__$1);
var G__116662 = null;
var G__116663 = (0);
var G__116664 = (0);
seq__116640_116644 = G__116661;
chunk__116641_116645 = G__116662;
count__116642_116646 = G__116663;
i__116643_116647 = G__116664;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emit.call(null,ret);

if(((cljs.core.seq.call(null,statements)) && (cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)))){
return cljs.compiler.emitln.call(null,"})()");
} else {
return null;
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"try","try",1380742522),(function (p__116665){
var map__116666 = p__116665;
var map__116666__$1 = (((((!((map__116666 == null))))?(((((map__116666.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116666.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116666):map__116666);
var try$ = cljs.core.get.call(null,map__116666__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var env = cljs.core.get.call(null,map__116666__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var catch$ = cljs.core.get.call(null,map__116666__$1,new cljs.core.Keyword(null,"catch","catch",1038065524));
var name = cljs.core.get.call(null,map__116666__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var finally$ = cljs.core.get.call(null,map__116666__$1,new cljs.core.Keyword(null,"finally","finally",1589088705));
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env);
if(cljs.core.truth_((function (){var or__4131__auto__ = name;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return finally$;
}
})())){
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
cljs.compiler.emits.call(null,"(function (){");
} else {
}

cljs.compiler.emits.call(null,"try{",try$,"}");

if(cljs.core.truth_(name)){
cljs.compiler.emits.call(null,"catch (",cljs.compiler.munge.call(null,name),"){",catch$,"}");
} else {
}

if(cljs.core.truth_(finally$)){
if(cljs.core.not_EQ_.call(null,new cljs.core.Keyword(null,"const","const",1709929842),new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(cljs.analyzer.unwrap_quote.call(null,finally$)))){
} else {
throw (new Error(["Assert failed: ","finally block cannot contain constant","\n","(not= :const (:op (ana/unwrap-quote finally)))"].join('')));
}

cljs.compiler.emits.call(null,"finally {",finally$,"}");
} else {
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
return cljs.compiler.emits.call(null,"})()");
} else {
return null;
}
} else {
return cljs.compiler.emits.call(null,try$);
}
}));
cljs.compiler.emit_let = (function cljs$compiler$emit_let(p__116668,is_loop){
var map__116669 = p__116668;
var map__116669__$1 = (((((!((map__116669 == null))))?(((((map__116669.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116669.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116669):map__116669);
var expr = cljs.core.get.call(null,map__116669__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var bindings = cljs.core.get.call(null,map__116669__$1,new cljs.core.Keyword(null,"bindings","bindings",1271397192));
var env = cljs.core.get.call(null,map__116669__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env);
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
cljs.compiler.emits.call(null,"(function (){");
} else {
}

var _STAR_lexical_renames_STAR__orig_val__116671_116685 = cljs.compiler._STAR_lexical_renames_STAR_;
var _STAR_lexical_renames_STAR__temp_val__116672_116686 = cljs.core.into.call(null,cljs.compiler._STAR_lexical_renames_STAR_,((cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"statement","statement",-32780863),context))?cljs.core.map.call(null,((function (_STAR_lexical_renames_STAR__orig_val__116671_116685,context,map__116669,map__116669__$1,expr,bindings,env){
return (function (binding){
var name = new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(binding);
return (new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.compiler.hash_scope.call(null,binding),cljs.core.gensym.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(name),"-"].join(''))],null));
});})(_STAR_lexical_renames_STAR__orig_val__116671_116685,context,map__116669,map__116669__$1,expr,bindings,env))
,bindings):null));
cljs.compiler._STAR_lexical_renames_STAR_ = _STAR_lexical_renames_STAR__temp_val__116672_116686;

try{var seq__116673_116687 = cljs.core.seq.call(null,bindings);
var chunk__116674_116688 = null;
var count__116675_116689 = (0);
var i__116676_116690 = (0);
while(true){
if((i__116676_116690 < count__116675_116689)){
var map__116681_116691 = cljs.core._nth.call(null,chunk__116674_116688,i__116676_116690);
var map__116681_116692__$1 = (((((!((map__116681_116691 == null))))?(((((map__116681_116691.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116681_116691.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116681_116691):map__116681_116691);
var binding_116693 = map__116681_116692__$1;
var init_116694 = cljs.core.get.call(null,map__116681_116692__$1,new cljs.core.Keyword(null,"init","init",-1875481434));
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,binding_116693);

cljs.compiler.emitln.call(null," = ",init_116694,";");


var G__116695 = seq__116673_116687;
var G__116696 = chunk__116674_116688;
var G__116697 = count__116675_116689;
var G__116698 = (i__116676_116690 + (1));
seq__116673_116687 = G__116695;
chunk__116674_116688 = G__116696;
count__116675_116689 = G__116697;
i__116676_116690 = G__116698;
continue;
} else {
var temp__5735__auto___116699 = cljs.core.seq.call(null,seq__116673_116687);
if(temp__5735__auto___116699){
var seq__116673_116700__$1 = temp__5735__auto___116699;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116673_116700__$1)){
var c__4550__auto___116701 = cljs.core.chunk_first.call(null,seq__116673_116700__$1);
var G__116702 = cljs.core.chunk_rest.call(null,seq__116673_116700__$1);
var G__116703 = c__4550__auto___116701;
var G__116704 = cljs.core.count.call(null,c__4550__auto___116701);
var G__116705 = (0);
seq__116673_116687 = G__116702;
chunk__116674_116688 = G__116703;
count__116675_116689 = G__116704;
i__116676_116690 = G__116705;
continue;
} else {
var map__116683_116706 = cljs.core.first.call(null,seq__116673_116700__$1);
var map__116683_116707__$1 = (((((!((map__116683_116706 == null))))?(((((map__116683_116706.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116683_116706.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116683_116706):map__116683_116706);
var binding_116708 = map__116683_116707__$1;
var init_116709 = cljs.core.get.call(null,map__116683_116707__$1,new cljs.core.Keyword(null,"init","init",-1875481434));
cljs.compiler.emits.call(null,"var ");

cljs.compiler.emit.call(null,binding_116708);

cljs.compiler.emitln.call(null," = ",init_116709,";");


var G__116710 = cljs.core.next.call(null,seq__116673_116700__$1);
var G__116711 = null;
var G__116712 = (0);
var G__116713 = (0);
seq__116673_116687 = G__116710;
chunk__116674_116688 = G__116711;
count__116675_116689 = G__116712;
i__116676_116690 = G__116713;
continue;
}
} else {
}
}
break;
}

if(cljs.core.truth_(is_loop)){
cljs.compiler.emitln.call(null,"while(true){");
} else {
}

cljs.compiler.emits.call(null,expr);

if(cljs.core.truth_(is_loop)){
cljs.compiler.emitln.call(null,"break;");

cljs.compiler.emitln.call(null,"}");
} else {
}
}finally {cljs.compiler._STAR_lexical_renames_STAR_ = _STAR_lexical_renames_STAR__orig_val__116671_116685;
}
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
return cljs.compiler.emits.call(null,"})()");
} else {
return null;
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"let","let",-1282412701),(function (ast){
return cljs.compiler.emit_let.call(null,ast,false);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"loop","loop",-395552849),(function (ast){
return cljs.compiler.emit_let.call(null,ast,true);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"recur","recur",-437573268),(function (p__116714){
var map__116715 = p__116714;
var map__116715__$1 = (((((!((map__116715 == null))))?(((((map__116715.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116715.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116715):map__116715);
var frame = cljs.core.get.call(null,map__116715__$1,new cljs.core.Keyword(null,"frame","frame",-1711082588));
var exprs = cljs.core.get.call(null,map__116715__$1,new cljs.core.Keyword(null,"exprs","exprs",1795829094));
var env = cljs.core.get.call(null,map__116715__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var temps = cljs.core.vec.call(null,cljs.core.take.call(null,cljs.core.count.call(null,exprs),cljs.core.repeatedly.call(null,cljs.core.gensym)));
var params = new cljs.core.Keyword(null,"params","params",710516235).cljs$core$IFn$_invoke$arity$1(frame);
var n__4607__auto___116717 = cljs.core.count.call(null,exprs);
var i_116718 = (0);
while(true){
if((i_116718 < n__4607__auto___116717)){
cljs.compiler.emitln.call(null,"var ",temps.call(null,i_116718)," = ",exprs.call(null,i_116718),";");

var G__116719 = (i_116718 + (1));
i_116718 = G__116719;
continue;
} else {
}
break;
}

var n__4607__auto___116720 = cljs.core.count.call(null,exprs);
var i_116721 = (0);
while(true){
if((i_116721 < n__4607__auto___116720)){
cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,params.call(null,i_116721))," = ",temps.call(null,i_116721),";");

var G__116722 = (i_116721 + (1));
i_116721 = G__116722;
continue;
} else {
}
break;
}

return cljs.compiler.emitln.call(null,"continue;");
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"letfn","letfn",-2121022354),(function (p__116723){
var map__116724 = p__116723;
var map__116724__$1 = (((((!((map__116724 == null))))?(((((map__116724.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116724.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116724):map__116724);
var expr = cljs.core.get.call(null,map__116724__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var bindings = cljs.core.get.call(null,map__116724__$1,new cljs.core.Keyword(null,"bindings","bindings",1271397192));
var env = cljs.core.get.call(null,map__116724__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env);
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
cljs.compiler.emits.call(null,"(function (){");
} else {
}

var seq__116726_116738 = cljs.core.seq.call(null,bindings);
var chunk__116727_116739 = null;
var count__116728_116740 = (0);
var i__116729_116741 = (0);
while(true){
if((i__116729_116741 < count__116728_116740)){
var map__116734_116742 = cljs.core._nth.call(null,chunk__116727_116739,i__116729_116741);
var map__116734_116743__$1 = (((((!((map__116734_116742 == null))))?(((((map__116734_116742.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116734_116742.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116734_116742):map__116734_116742);
var binding_116744 = map__116734_116743__$1;
var init_116745 = cljs.core.get.call(null,map__116734_116743__$1,new cljs.core.Keyword(null,"init","init",-1875481434));
cljs.compiler.emitln.call(null,"var ",cljs.compiler.munge.call(null,binding_116744)," = ",init_116745,";");


var G__116746 = seq__116726_116738;
var G__116747 = chunk__116727_116739;
var G__116748 = count__116728_116740;
var G__116749 = (i__116729_116741 + (1));
seq__116726_116738 = G__116746;
chunk__116727_116739 = G__116747;
count__116728_116740 = G__116748;
i__116729_116741 = G__116749;
continue;
} else {
var temp__5735__auto___116750 = cljs.core.seq.call(null,seq__116726_116738);
if(temp__5735__auto___116750){
var seq__116726_116751__$1 = temp__5735__auto___116750;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116726_116751__$1)){
var c__4550__auto___116752 = cljs.core.chunk_first.call(null,seq__116726_116751__$1);
var G__116753 = cljs.core.chunk_rest.call(null,seq__116726_116751__$1);
var G__116754 = c__4550__auto___116752;
var G__116755 = cljs.core.count.call(null,c__4550__auto___116752);
var G__116756 = (0);
seq__116726_116738 = G__116753;
chunk__116727_116739 = G__116754;
count__116728_116740 = G__116755;
i__116729_116741 = G__116756;
continue;
} else {
var map__116736_116757 = cljs.core.first.call(null,seq__116726_116751__$1);
var map__116736_116758__$1 = (((((!((map__116736_116757 == null))))?(((((map__116736_116757.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116736_116757.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116736_116757):map__116736_116757);
var binding_116759 = map__116736_116758__$1;
var init_116760 = cljs.core.get.call(null,map__116736_116758__$1,new cljs.core.Keyword(null,"init","init",-1875481434));
cljs.compiler.emitln.call(null,"var ",cljs.compiler.munge.call(null,binding_116759)," = ",init_116760,";");


var G__116761 = cljs.core.next.call(null,seq__116726_116751__$1);
var G__116762 = null;
var G__116763 = (0);
var G__116764 = (0);
seq__116726_116738 = G__116761;
chunk__116727_116739 = G__116762;
count__116728_116740 = G__116763;
i__116729_116741 = G__116764;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emits.call(null,expr);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),context)){
return cljs.compiler.emits.call(null,"})()");
} else {
return null;
}
}));
cljs.compiler.protocol_prefix = (function cljs$compiler$protocol_prefix(psym){
return cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.str.cljs$core$IFn$_invoke$arity$1(psym).replace((new RegExp("\\.","g")),"$").replace("/","$")),"$"].join(''));
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"invoke","invoke",1145927159),(function (p__116767){
var map__116768 = p__116767;
var map__116768__$1 = (((((!((map__116768 == null))))?(((((map__116768.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116768.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116768):map__116768);
var expr = map__116768__$1;
var f = cljs.core.get.call(null,map__116768__$1,new cljs.core.Keyword(null,"fn","fn",-1175266204));
var args = cljs.core.get.call(null,map__116768__$1,new cljs.core.Keyword(null,"args","args",1315556576));
var env = cljs.core.get.call(null,map__116768__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var info = new cljs.core.Keyword(null,"info","info",-317069002).cljs$core$IFn$_invoke$arity$1(f);
var fn_QMARK_ = (function (){var and__4120__auto__ = cljs.analyzer._STAR_cljs_static_fns_STAR_;
if(and__4120__auto__){
var and__4120__auto____$1 = cljs.core.not.call(null,new cljs.core.Keyword(null,"dynamic","dynamic",704819571).cljs$core$IFn$_invoke$arity$1(info));
if(and__4120__auto____$1){
return new cljs.core.Keyword(null,"fn-var","fn-var",1086204730).cljs$core$IFn$_invoke$arity$1(info);
} else {
return and__4120__auto____$1;
}
} else {
return and__4120__auto__;
}
})();
var protocol = new cljs.core.Keyword(null,"protocol","protocol",652470118).cljs$core$IFn$_invoke$arity$1(info);
var tag = cljs.analyzer.infer_tag.call(null,env,cljs.core.first.call(null,new cljs.core.Keyword(null,"args","args",1315556576).cljs$core$IFn$_invoke$arity$1(expr)));
var proto_QMARK_ = (function (){var and__4120__auto__ = protocol;
if(cljs.core.truth_(and__4120__auto__)){
var and__4120__auto____$1 = tag;
if(cljs.core.truth_(and__4120__auto____$1)){
var or__4131__auto__ = (function (){var and__4120__auto____$2 = cljs.analyzer._STAR_cljs_static_fns_STAR_;
if(and__4120__auto____$2){
var and__4120__auto____$3 = protocol;
if(cljs.core.truth_(and__4120__auto____$3)){
return cljs.core._EQ_.call(null,tag,new cljs.core.Symbol(null,"not-native","not-native",-236392494,null));
} else {
return and__4120__auto____$3;
}
} else {
return and__4120__auto____$2;
}
})();
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var and__4120__auto____$2 = (function (){var or__4131__auto____$1 = cljs.analyzer._STAR_cljs_static_fns_STAR_;
if(or__4131__auto____$1){
return or__4131__auto____$1;
} else {
return new cljs.core.Keyword(null,"protocol-inline","protocol-inline",1550487556).cljs$core$IFn$_invoke$arity$1(env);
}
})();
if(cljs.core.truth_(and__4120__auto____$2)){
var or__4131__auto____$1 = cljs.core._EQ_.call(null,protocol,tag);
if(or__4131__auto____$1){
return or__4131__auto____$1;
} else {
var and__4120__auto____$3 = (!(cljs.core.set_QMARK_.call(null,tag)));
if(and__4120__auto____$3){
var and__4120__auto____$4 = cljs.core.not.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 11, [new cljs.core.Symbol(null,"clj","clj",980036099,null),"null",new cljs.core.Symbol(null,"boolean","boolean",-278886877,null),"null",new cljs.core.Symbol(null,"object","object",-1179821820,null),"null",new cljs.core.Symbol(null,"any","any",-948528346,null),"null",new cljs.core.Symbol(null,"js","js",-886355190,null),"null",new cljs.core.Symbol(null,"number","number",-1084057331,null),"null",new cljs.core.Symbol(null,"clj-or-nil","clj-or-nil",-2008798668,null),"null",new cljs.core.Symbol(null,"array","array",-440182315,null),"null",new cljs.core.Symbol(null,"string","string",-349010059,null),"null",new cljs.core.Symbol(null,"function","function",-486723946,null),"null",new cljs.core.Symbol(null,"clj-nil","clj-nil",1321798654,null),"null"], null), null).call(null,tag));
if(and__4120__auto____$4){
var temp__5735__auto__ = new cljs.core.Keyword(null,"protocols","protocols",-5615896).cljs$core$IFn$_invoke$arity$1(cljs.analyzer.resolve_existing_var.call(null,env,tag));
if(cljs.core.truth_(temp__5735__auto__)){
var ps = temp__5735__auto__;
return ps.call(null,protocol);
} else {
return null;
}
} else {
return and__4120__auto____$4;
}
} else {
return and__4120__auto____$3;
}
}
} else {
return and__4120__auto____$2;
}
}
} else {
return and__4120__auto____$1;
}
} else {
return and__4120__auto__;
}
})();
var opt_not_QMARK_ = ((cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(info),new cljs.core.Symbol("cljs.core","not","cljs.core/not",100665144,null))) && (cljs.core._EQ_.call(null,cljs.analyzer.infer_tag.call(null,env,cljs.core.first.call(null,new cljs.core.Keyword(null,"args","args",1315556576).cljs$core$IFn$_invoke$arity$1(expr))),new cljs.core.Symbol(null,"boolean","boolean",-278886877,null))));
var ns = new cljs.core.Keyword(null,"ns","ns",441598760).cljs$core$IFn$_invoke$arity$1(info);
var js_QMARK_ = ((cljs.core._EQ_.call(null,ns,new cljs.core.Symbol(null,"js","js",-886355190,null))) || (cljs.core._EQ_.call(null,ns,new cljs.core.Symbol(null,"Math","Math",2033287572,null))));
var goog_QMARK_ = (cljs.core.truth_(ns)?(function (){var or__4131__auto__ = cljs.core._EQ_.call(null,ns,new cljs.core.Symbol(null,"goog","goog",-70603925,null));
if(or__4131__auto__){
return or__4131__auto__;
} else {
var or__4131__auto____$1 = (function (){var temp__5735__auto__ = cljs.core.str.cljs$core$IFn$_invoke$arity$1(ns);
if(cljs.core.truth_(temp__5735__auto__)){
var ns_str = temp__5735__auto__;
return cljs.core._EQ_.call(null,cljs.core.get.call(null,clojure.string.split.call(null,ns_str,/\./),(0),null),"goog");
} else {
return null;
}
})();
if(cljs.core.truth_(or__4131__auto____$1)){
return or__4131__auto____$1;
} else {
return (!(cljs.core.contains_QMARK_.call(null,new cljs.core.Keyword("cljs.analyzer","namespaces","cljs.analyzer/namespaces",-260788927).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)),ns)));
}
}
})():null);
var keyword_QMARK_ = (function (){var or__4131__auto__ = cljs.core._EQ_.call(null,new cljs.core.Symbol("cljs.core","Keyword","cljs.core/Keyword",-451434488,null),cljs.analyzer.infer_tag.call(null,env,f));
if(or__4131__auto__){
return or__4131__auto__;
} else {
var f__$1 = cljs.analyzer.unwrap_quote.call(null,f);
return ((cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(f__$1),new cljs.core.Keyword(null,"const","const",1709929842))) && ((new cljs.core.Keyword(null,"form","form",-1624062471).cljs$core$IFn$_invoke$arity$1(f__$1) instanceof cljs.core.Keyword)));
}
})();
var vec__116770 = (cljs.core.truth_(fn_QMARK_)?(function (){var arity = cljs.core.count.call(null,args);
var variadic_QMARK_ = new cljs.core.Keyword(null,"variadic?","variadic?",584179762).cljs$core$IFn$_invoke$arity$1(info);
var mps = new cljs.core.Keyword(null,"method-params","method-params",-980792179).cljs$core$IFn$_invoke$arity$1(info);
var mfa = new cljs.core.Keyword(null,"max-fixed-arity","max-fixed-arity",-690205543).cljs$core$IFn$_invoke$arity$1(info);
if(((cljs.core.not.call(null,variadic_QMARK_)) && (cljs.core._EQ_.call(null,cljs.core.count.call(null,mps),(1))))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [f,null], null);
} else {
if(cljs.core.truth_((function (){var and__4120__auto__ = variadic_QMARK_;
if(cljs.core.truth_(and__4120__auto__)){
return (arity > mfa);
} else {
return and__4120__auto__;
}
})())){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.update_in.call(null,f,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"info","info",-317069002)], null),((function (arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__116768,map__116768__$1,expr,f,args,env){
return (function (info__$1){
return cljs.core.update_in.call(null,cljs.core.assoc.call(null,info__$1,new cljs.core.Keyword(null,"name","name",1843675177),cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.munge.call(null,info__$1)),".cljs$core$IFn$_invoke$arity$variadic"].join(''))),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"info","info",-317069002)], null),((function (arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__116768,map__116768__$1,expr,f,args,env){
return (function (p1__116765_SHARP_){
return cljs.core.dissoc.call(null,cljs.core.dissoc.call(null,p1__116765_SHARP_,new cljs.core.Keyword(null,"shadow","shadow",873231803)),new cljs.core.Keyword(null,"fn-self-name","fn-self-name",1461143531));
});})(arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__116768,map__116768__$1,expr,f,args,env))
);
});})(arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__116768,map__116768__$1,expr,f,args,env))
),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"max-fixed-arity","max-fixed-arity",-690205543),mfa], null)], null);
} else {
var arities = cljs.core.map.call(null,cljs.core.count,mps);
if(cljs.core.truth_(cljs.core.some.call(null,cljs.core.PersistentHashSet.createAsIfByAssoc([arity]),arities))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.update_in.call(null,f,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"info","info",-317069002)], null),((function (arities,arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__116768,map__116768__$1,expr,f,args,env){
return (function (info__$1){
return cljs.core.update_in.call(null,cljs.core.assoc.call(null,info__$1,new cljs.core.Keyword(null,"name","name",1843675177),cljs.core.symbol.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.munge.call(null,info__$1)),".cljs$core$IFn$_invoke$arity$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arity)].join(''))),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"info","info",-317069002)], null),((function (arities,arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__116768,map__116768__$1,expr,f,args,env){
return (function (p1__116766_SHARP_){
return cljs.core.dissoc.call(null,cljs.core.dissoc.call(null,p1__116766_SHARP_,new cljs.core.Keyword(null,"shadow","shadow",873231803)),new cljs.core.Keyword(null,"fn-self-name","fn-self-name",1461143531));
});})(arities,arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__116768,map__116768__$1,expr,f,args,env))
);
});})(arities,arity,variadic_QMARK_,mps,mfa,info,fn_QMARK_,protocol,tag,proto_QMARK_,opt_not_QMARK_,ns,js_QMARK_,goog_QMARK_,keyword_QMARK_,map__116768,map__116768__$1,expr,f,args,env))
),null], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [f,null], null);
}

}
}
})():new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [f,null], null));
var f__$1 = cljs.core.nth.call(null,vec__116770,(0),null);
var variadic_invoke = cljs.core.nth.call(null,vec__116770,(1),null);
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if(opt_not_QMARK_){
cljs.compiler.emits.call(null,"(!(",cljs.core.first.call(null,args),"))");
} else {
if(cljs.core.truth_(proto_QMARK_)){
var pimpl_116773 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.munge.call(null,cljs.compiler.protocol_prefix.call(null,protocol))),cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.compiler.munge.call(null,cljs.core.name.call(null,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(info)))),"$arity$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.count.call(null,args))].join('');
cljs.compiler.emits.call(null,cljs.core.first.call(null,args),".",pimpl_116773,"(",cljs.compiler.comma_sep.call(null,cljs.core.cons.call(null,"null",cljs.core.rest.call(null,args))),")");
} else {
if(keyword_QMARK_){
cljs.compiler.emits.call(null,f__$1,".cljs$core$IFn$_invoke$arity$",cljs.core.count.call(null,args),"(",cljs.compiler.comma_sep.call(null,args),")");
} else {
if(cljs.core.truth_(variadic_invoke)){
var mfa_116774 = new cljs.core.Keyword(null,"max-fixed-arity","max-fixed-arity",-690205543).cljs$core$IFn$_invoke$arity$1(variadic_invoke);
cljs.compiler.emits.call(null,f__$1,"(",cljs.compiler.comma_sep.call(null,cljs.core.take.call(null,mfa_116774,args)),(((mfa_116774 === (0)))?null:","),"cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([",cljs.compiler.comma_sep.call(null,cljs.core.drop.call(null,mfa_116774,args)),"], 0))");
} else {
if(cljs.core.truth_((function (){var or__4131__auto__ = fn_QMARK_;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var or__4131__auto____$1 = js_QMARK_;
if(or__4131__auto____$1){
return or__4131__auto____$1;
} else {
return goog_QMARK_;
}
}
})())){
cljs.compiler.emits.call(null,f__$1,"(",cljs.compiler.comma_sep.call(null,args),")");
} else {
if(cljs.core.truth_((function (){var and__4120__auto__ = cljs.analyzer._STAR_cljs_static_fns_STAR_;
if(and__4120__auto__){
return new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"var","var",-769682797),null,new cljs.core.Keyword(null,"js-var","js-var",-1177899142),null,new cljs.core.Keyword(null,"local","local",-1497766724),null], null), null).call(null,new cljs.core.Keyword(null,"op","op",-1882987955).cljs$core$IFn$_invoke$arity$1(f__$1));
} else {
return and__4120__auto__;
}
})())){
var fprop_116775 = [".cljs$core$IFn$_invoke$arity$",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.count.call(null,args))].join('');
if(cljs.analyzer._STAR_fn_invoke_direct_STAR_){
cljs.compiler.emits.call(null,"(",f__$1,fprop_116775," ? ",f__$1,fprop_116775,"(",cljs.compiler.comma_sep.call(null,args),") : ",f__$1,"(",cljs.compiler.comma_sep.call(null,args),"))");
} else {
cljs.compiler.emits.call(null,"(",f__$1,fprop_116775," ? ",f__$1,fprop_116775,"(",cljs.compiler.comma_sep.call(null,args),") : ",f__$1,".call(",cljs.compiler.comma_sep.call(null,cljs.core.cons.call(null,"null",args)),"))");
}
} else {
cljs.compiler.emits.call(null,f__$1,".call(",cljs.compiler.comma_sep.call(null,cljs.core.cons.call(null,"null",args)),")");
}

}
}
}
}
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"new","new",-2085437848),(function (p__116776){
var map__116777 = p__116776;
var map__116777__$1 = (((((!((map__116777 == null))))?(((((map__116777.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116777.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116777):map__116777);
var ctor = cljs.core.get.call(null,map__116777__$1,new cljs.core.Keyword(null,"class","class",-2030961996));
var args = cljs.core.get.call(null,map__116777__$1,new cljs.core.Keyword(null,"args","args",1315556576));
var env = cljs.core.get.call(null,map__116777__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emits.call(null,"(new ",ctor,"(",cljs.compiler.comma_sep.call(null,args),"))");

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"set!","set!",-1389817006),(function (p__116779){
var map__116780 = p__116779;
var map__116780__$1 = (((((!((map__116780 == null))))?(((((map__116780.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116780.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116780):map__116780);
var target = cljs.core.get.call(null,map__116780__$1,new cljs.core.Keyword(null,"target","target",253001721));
var val = cljs.core.get.call(null,map__116780__$1,new cljs.core.Keyword(null,"val","val",128701612));
var env = cljs.core.get.call(null,map__116780__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

cljs.compiler.emits.call(null,target," = ",val);

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}));
cljs.compiler.emit_global_export = (function cljs$compiler$emit_global_export(ns_name,global_exports,lib){
return cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,ns_name),".",cljs.analyzer.munge_global_export.call(null,lib)," = goog.global",cljs.core.apply.call(null,cljs.core.str,cljs.core.map.call(null,(function (prop){
return ["[\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(prop),"\"]"].join('');
}),clojure.string.split.call(null,cljs.core.name.call(null,(function (){var or__4131__auto__ = cljs.core.get.call(null,global_exports,cljs.core.symbol.call(null,lib));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.get.call(null,global_exports,cljs.core.name.call(null,lib));
}
})()),/\./))),";");
});
cljs.compiler.load_libs = (function cljs$compiler$load_libs(libs,seen,reloads,deps,ns_name){
var map__116782 = cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_);
var map__116782__$1 = (((((!((map__116782 == null))))?(((((map__116782.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116782.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116782):map__116782);
var options = cljs.core.get.call(null,map__116782__$1,new cljs.core.Keyword(null,"options","options",99638489));
var js_dependency_index = cljs.core.get.call(null,map__116782__$1,new cljs.core.Keyword(null,"js-dependency-index","js-dependency-index",-1887042131));
var map__116783 = options;
var map__116783__$1 = (((((!((map__116783 == null))))?(((((map__116783.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116783.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116783):map__116783);
var target = cljs.core.get.call(null,map__116783__$1,new cljs.core.Keyword(null,"target","target",253001721));
var optimizations = cljs.core.get.call(null,map__116783__$1,new cljs.core.Keyword(null,"optimizations","optimizations",-2047476854));
var loaded_libs = cljs.compiler.munge.call(null,new cljs.core.Symbol(null,"cljs.core.*loaded-libs*","cljs.core.*loaded-libs*",-1847086525,null));
var loaded_libs_temp = cljs.compiler.munge.call(null,cljs.core.gensym.call(null,new cljs.core.Symbol(null,"cljs.core.*loaded-libs*","cljs.core.*loaded-libs*",-1847086525,null)));
var vec__116784 = (function (){var libs__$1 = cljs.core.remove.call(null,cljs.core.set.call(null,cljs.core.vals.call(null,seen)),cljs.core.filter.call(null,cljs.core.set.call(null,cljs.core.vals.call(null,libs)),deps));
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"nodejs","nodejs",321212524),target)){
var map__116789 = cljs.core.group_by.call(null,cljs.analyzer.node_module_dep_QMARK_,libs__$1);
var map__116789__$1 = (((((!((map__116789 == null))))?(((((map__116789.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116789.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116789):map__116789);
var node_libs = cljs.core.get.call(null,map__116789__$1,true);
var libs_to_load = cljs.core.get.call(null,map__116789__$1,false);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [node_libs,libs_to_load], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [null,libs__$1], null);
}
})();
var node_libs = cljs.core.nth.call(null,vec__116784,(0),null);
var libs_to_load = cljs.core.nth.call(null,vec__116784,(1),null);
var global_exports_libs = cljs.core.filter.call(null,cljs.analyzer.dep_has_global_exports_QMARK_,libs_to_load);
if(cljs.core.truth_(new cljs.core.Keyword(null,"reload-all","reload-all",761570200).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs)))){
cljs.compiler.emitln.call(null,"if(!COMPILED) ",loaded_libs_temp," = ",loaded_libs," || cljs.core.set([\"cljs.core\"]);");

cljs.compiler.emitln.call(null,"if(!COMPILED) ",loaded_libs," = cljs.core.set([\"cljs.core\"]);");
} else {
}

var seq__116791_116811 = cljs.core.seq.call(null,libs_to_load);
var chunk__116792_116812 = null;
var count__116793_116813 = (0);
var i__116794_116814 = (0);
while(true){
if((i__116794_116814 < count__116793_116813)){
var lib_116815 = cljs.core._nth.call(null,chunk__116792_116812,i__116794_116814);
if(((cljs.analyzer.foreign_dep_QMARK_.call(null,lib_116815)) && ((!(cljs.core.keyword_identical_QMARK_.call(null,optimizations,new cljs.core.Keyword(null,"none","none",1333468478))))))){
} else {
if(cljs.core.truth_((function (){var or__4131__auto__ = new cljs.core.Keyword(null,"reload","reload",863702807).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core._EQ_.call(null,cljs.core.get.call(null,reloads,lib_116815),new cljs.core.Keyword(null,"reload","reload",863702807));
}
})())){
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_116815),"', 'reload');");
} else {
if(cljs.core.truth_((function (){var or__4131__auto__ = new cljs.core.Keyword(null,"reload-all","reload-all",761570200).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core._EQ_.call(null,cljs.core.get.call(null,reloads,lib_116815),new cljs.core.Keyword(null,"reload-all","reload-all",761570200));
}
})())){
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_116815),"', 'reload-all');");
} else {
if(cljs.core._EQ_.call(null,lib_116815,new cljs.core.Symbol(null,"goog","goog",-70603925,null))){
} else {
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_116815),"');");
}

}
}
}


var G__116816 = seq__116791_116811;
var G__116817 = chunk__116792_116812;
var G__116818 = count__116793_116813;
var G__116819 = (i__116794_116814 + (1));
seq__116791_116811 = G__116816;
chunk__116792_116812 = G__116817;
count__116793_116813 = G__116818;
i__116794_116814 = G__116819;
continue;
} else {
var temp__5735__auto___116820 = cljs.core.seq.call(null,seq__116791_116811);
if(temp__5735__auto___116820){
var seq__116791_116821__$1 = temp__5735__auto___116820;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116791_116821__$1)){
var c__4550__auto___116822 = cljs.core.chunk_first.call(null,seq__116791_116821__$1);
var G__116823 = cljs.core.chunk_rest.call(null,seq__116791_116821__$1);
var G__116824 = c__4550__auto___116822;
var G__116825 = cljs.core.count.call(null,c__4550__auto___116822);
var G__116826 = (0);
seq__116791_116811 = G__116823;
chunk__116792_116812 = G__116824;
count__116793_116813 = G__116825;
i__116794_116814 = G__116826;
continue;
} else {
var lib_116827 = cljs.core.first.call(null,seq__116791_116821__$1);
if(((cljs.analyzer.foreign_dep_QMARK_.call(null,lib_116827)) && ((!(cljs.core.keyword_identical_QMARK_.call(null,optimizations,new cljs.core.Keyword(null,"none","none",1333468478))))))){
} else {
if(cljs.core.truth_((function (){var or__4131__auto__ = new cljs.core.Keyword(null,"reload","reload",863702807).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core._EQ_.call(null,cljs.core.get.call(null,reloads,lib_116827),new cljs.core.Keyword(null,"reload","reload",863702807));
}
})())){
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_116827),"', 'reload');");
} else {
if(cljs.core.truth_((function (){var or__4131__auto__ = new cljs.core.Keyword(null,"reload-all","reload-all",761570200).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core._EQ_.call(null,cljs.core.get.call(null,reloads,lib_116827),new cljs.core.Keyword(null,"reload-all","reload-all",761570200));
}
})())){
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_116827),"', 'reload-all');");
} else {
if(cljs.core._EQ_.call(null,lib_116827,new cljs.core.Symbol(null,"goog","goog",-70603925,null))){
} else {
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,lib_116827),"');");
}

}
}
}


var G__116828 = cljs.core.next.call(null,seq__116791_116821__$1);
var G__116829 = null;
var G__116830 = (0);
var G__116831 = (0);
seq__116791_116811 = G__116828;
chunk__116792_116812 = G__116829;
count__116793_116813 = G__116830;
i__116794_116814 = G__116831;
continue;
}
} else {
}
}
break;
}

var seq__116795_116832 = cljs.core.seq.call(null,node_libs);
var chunk__116796_116833 = null;
var count__116797_116834 = (0);
var i__116798_116835 = (0);
while(true){
if((i__116798_116835 < count__116797_116834)){
var lib_116836 = cljs.core._nth.call(null,chunk__116796_116833,i__116798_116835);
cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,ns_name),".",cljs.analyzer.munge_node_lib.call(null,lib_116836)," = require('",lib_116836,"');");


var G__116837 = seq__116795_116832;
var G__116838 = chunk__116796_116833;
var G__116839 = count__116797_116834;
var G__116840 = (i__116798_116835 + (1));
seq__116795_116832 = G__116837;
chunk__116796_116833 = G__116838;
count__116797_116834 = G__116839;
i__116798_116835 = G__116840;
continue;
} else {
var temp__5735__auto___116841 = cljs.core.seq.call(null,seq__116795_116832);
if(temp__5735__auto___116841){
var seq__116795_116842__$1 = temp__5735__auto___116841;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116795_116842__$1)){
var c__4550__auto___116843 = cljs.core.chunk_first.call(null,seq__116795_116842__$1);
var G__116844 = cljs.core.chunk_rest.call(null,seq__116795_116842__$1);
var G__116845 = c__4550__auto___116843;
var G__116846 = cljs.core.count.call(null,c__4550__auto___116843);
var G__116847 = (0);
seq__116795_116832 = G__116844;
chunk__116796_116833 = G__116845;
count__116797_116834 = G__116846;
i__116798_116835 = G__116847;
continue;
} else {
var lib_116848 = cljs.core.first.call(null,seq__116795_116842__$1);
cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,ns_name),".",cljs.analyzer.munge_node_lib.call(null,lib_116848)," = require('",lib_116848,"');");


var G__116849 = cljs.core.next.call(null,seq__116795_116842__$1);
var G__116850 = null;
var G__116851 = (0);
var G__116852 = (0);
seq__116795_116832 = G__116849;
chunk__116796_116833 = G__116850;
count__116797_116834 = G__116851;
i__116798_116835 = G__116852;
continue;
}
} else {
}
}
break;
}

var seq__116799_116853 = cljs.core.seq.call(null,global_exports_libs);
var chunk__116800_116854 = null;
var count__116801_116855 = (0);
var i__116802_116856 = (0);
while(true){
if((i__116802_116856 < count__116801_116855)){
var lib_116857 = cljs.core._nth.call(null,chunk__116800_116854,i__116802_116856);
var map__116807_116858 = cljs.core.get.call(null,js_dependency_index,cljs.core.name.call(null,lib_116857));
var map__116807_116859__$1 = (((((!((map__116807_116858 == null))))?(((((map__116807_116858.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116807_116858.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116807_116858):map__116807_116858);
var global_exports_116860 = cljs.core.get.call(null,map__116807_116859__$1,new cljs.core.Keyword(null,"global-exports","global-exports",-1644865592));
cljs.compiler.emit_global_export.call(null,ns_name,global_exports_116860,lib_116857);


var G__116861 = seq__116799_116853;
var G__116862 = chunk__116800_116854;
var G__116863 = count__116801_116855;
var G__116864 = (i__116802_116856 + (1));
seq__116799_116853 = G__116861;
chunk__116800_116854 = G__116862;
count__116801_116855 = G__116863;
i__116802_116856 = G__116864;
continue;
} else {
var temp__5735__auto___116865 = cljs.core.seq.call(null,seq__116799_116853);
if(temp__5735__auto___116865){
var seq__116799_116866__$1 = temp__5735__auto___116865;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116799_116866__$1)){
var c__4550__auto___116867 = cljs.core.chunk_first.call(null,seq__116799_116866__$1);
var G__116868 = cljs.core.chunk_rest.call(null,seq__116799_116866__$1);
var G__116869 = c__4550__auto___116867;
var G__116870 = cljs.core.count.call(null,c__4550__auto___116867);
var G__116871 = (0);
seq__116799_116853 = G__116868;
chunk__116800_116854 = G__116869;
count__116801_116855 = G__116870;
i__116802_116856 = G__116871;
continue;
} else {
var lib_116872 = cljs.core.first.call(null,seq__116799_116866__$1);
var map__116809_116873 = cljs.core.get.call(null,js_dependency_index,cljs.core.name.call(null,lib_116872));
var map__116809_116874__$1 = (((((!((map__116809_116873 == null))))?(((((map__116809_116873.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116809_116873.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116809_116873):map__116809_116873);
var global_exports_116875 = cljs.core.get.call(null,map__116809_116874__$1,new cljs.core.Keyword(null,"global-exports","global-exports",-1644865592));
cljs.compiler.emit_global_export.call(null,ns_name,global_exports_116875,lib_116872);


var G__116876 = cljs.core.next.call(null,seq__116799_116866__$1);
var G__116877 = null;
var G__116878 = (0);
var G__116879 = (0);
seq__116799_116853 = G__116876;
chunk__116800_116854 = G__116877;
count__116801_116855 = G__116878;
i__116802_116856 = G__116879;
continue;
}
} else {
}
}
break;
}

if(cljs.core.truth_(new cljs.core.Keyword(null,"reload-all","reload-all",761570200).cljs$core$IFn$_invoke$arity$1(cljs.core.meta.call(null,libs)))){
return cljs.compiler.emitln.call(null,"if(!COMPILED) ",loaded_libs," = cljs.core.into(",loaded_libs_temp,", ",loaded_libs,");");
} else {
return null;
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"ns*","ns*",200417856),(function (p__116880){
var map__116881 = p__116880;
var map__116881__$1 = (((((!((map__116881 == null))))?(((((map__116881.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116881.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116881):map__116881);
var name = cljs.core.get.call(null,map__116881__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var requires = cljs.core.get.call(null,map__116881__$1,new cljs.core.Keyword(null,"requires","requires",-1201390927));
var uses = cljs.core.get.call(null,map__116881__$1,new cljs.core.Keyword(null,"uses","uses",232664692));
var require_macros = cljs.core.get.call(null,map__116881__$1,new cljs.core.Keyword(null,"require-macros","require-macros",707947416));
var reloads = cljs.core.get.call(null,map__116881__$1,new cljs.core.Keyword(null,"reloads","reloads",610698522));
var env = cljs.core.get.call(null,map__116881__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var deps = cljs.core.get.call(null,map__116881__$1,new cljs.core.Keyword(null,"deps","deps",1883360319));
cljs.compiler.load_libs.call(null,requires,null,new cljs.core.Keyword(null,"require","require",-468001333).cljs$core$IFn$_invoke$arity$1(reloads),deps,name);

cljs.compiler.load_libs.call(null,uses,requires,new cljs.core.Keyword(null,"use","use",-1846382424).cljs$core$IFn$_invoke$arity$1(reloads),deps,name);

if(cljs.core.truth_(new cljs.core.Keyword(null,"repl-env","repl-env",-1976503928).cljs$core$IFn$_invoke$arity$1(env))){
return cljs.compiler.emitln.call(null,"'nil';");
} else {
return null;
}
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"ns","ns",441598760),(function (p__116883){
var map__116884 = p__116883;
var map__116884__$1 = (((((!((map__116884 == null))))?(((((map__116884.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116884.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116884):map__116884);
var name = cljs.core.get.call(null,map__116884__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var requires = cljs.core.get.call(null,map__116884__$1,new cljs.core.Keyword(null,"requires","requires",-1201390927));
var uses = cljs.core.get.call(null,map__116884__$1,new cljs.core.Keyword(null,"uses","uses",232664692));
var require_macros = cljs.core.get.call(null,map__116884__$1,new cljs.core.Keyword(null,"require-macros","require-macros",707947416));
var reloads = cljs.core.get.call(null,map__116884__$1,new cljs.core.Keyword(null,"reloads","reloads",610698522));
var env = cljs.core.get.call(null,map__116884__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var deps = cljs.core.get.call(null,map__116884__$1,new cljs.core.Keyword(null,"deps","deps",1883360319));
cljs.compiler.emitln.call(null,"goog.provide('",cljs.compiler.munge.call(null,name),"');");

if(cljs.core._EQ_.call(null,name,new cljs.core.Symbol(null,"cljs.core","cljs.core",770546058,null))){
} else {
cljs.compiler.emitln.call(null,"goog.require('cljs.core');");

if(cljs.core.truth_(new cljs.core.Keyword(null,"emit-constants","emit-constants",-476585410).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"options","options",99638489).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_))))){
cljs.compiler.emitln.call(null,"goog.require('",cljs.compiler.munge.call(null,cljs.analyzer.constants_ns_sym),"');");
} else {
}
}

cljs.compiler.load_libs.call(null,requires,null,new cljs.core.Keyword(null,"require","require",-468001333).cljs$core$IFn$_invoke$arity$1(reloads),deps,name);

return cljs.compiler.load_libs.call(null,uses,requires,new cljs.core.Keyword(null,"use","use",-1846382424).cljs$core$IFn$_invoke$arity$1(reloads),deps,name);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"deftype","deftype",340294561),(function (p__116886){
var map__116887 = p__116886;
var map__116887__$1 = (((((!((map__116887 == null))))?(((((map__116887.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116887.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116887):map__116887);
var t = cljs.core.get.call(null,map__116887__$1,new cljs.core.Keyword(null,"t","t",-1397832519));
var fields = cljs.core.get.call(null,map__116887__$1,new cljs.core.Keyword(null,"fields","fields",-1932066230));
var pmasks = cljs.core.get.call(null,map__116887__$1,new cljs.core.Keyword(null,"pmasks","pmasks",-871416698));
var body = cljs.core.get.call(null,map__116887__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var protocols = cljs.core.get.call(null,map__116887__$1,new cljs.core.Keyword(null,"protocols","protocols",-5615896));
var fields__$1 = cljs.core.map.call(null,cljs.compiler.munge,fields);
cljs.compiler.emitln.call(null,"");

cljs.compiler.emitln.call(null,"/**");

cljs.compiler.emitln.call(null,"* @constructor");

var seq__116889_116913 = cljs.core.seq.call(null,protocols);
var chunk__116890_116914 = null;
var count__116891_116915 = (0);
var i__116892_116916 = (0);
while(true){
if((i__116892_116916 < count__116891_116915)){
var protocol_116917 = cljs.core._nth.call(null,chunk__116890_116914,i__116892_116916);
cljs.compiler.emitln.call(null," * @implements {",cljs.compiler.munge.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(protocol_116917)),"}");


var G__116918 = seq__116889_116913;
var G__116919 = chunk__116890_116914;
var G__116920 = count__116891_116915;
var G__116921 = (i__116892_116916 + (1));
seq__116889_116913 = G__116918;
chunk__116890_116914 = G__116919;
count__116891_116915 = G__116920;
i__116892_116916 = G__116921;
continue;
} else {
var temp__5735__auto___116922 = cljs.core.seq.call(null,seq__116889_116913);
if(temp__5735__auto___116922){
var seq__116889_116923__$1 = temp__5735__auto___116922;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116889_116923__$1)){
var c__4550__auto___116924 = cljs.core.chunk_first.call(null,seq__116889_116923__$1);
var G__116925 = cljs.core.chunk_rest.call(null,seq__116889_116923__$1);
var G__116926 = c__4550__auto___116924;
var G__116927 = cljs.core.count.call(null,c__4550__auto___116924);
var G__116928 = (0);
seq__116889_116913 = G__116925;
chunk__116890_116914 = G__116926;
count__116891_116915 = G__116927;
i__116892_116916 = G__116928;
continue;
} else {
var protocol_116929 = cljs.core.first.call(null,seq__116889_116923__$1);
cljs.compiler.emitln.call(null," * @implements {",cljs.compiler.munge.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(protocol_116929)),"}");


var G__116930 = cljs.core.next.call(null,seq__116889_116923__$1);
var G__116931 = null;
var G__116932 = (0);
var G__116933 = (0);
seq__116889_116913 = G__116930;
chunk__116890_116914 = G__116931;
count__116891_116915 = G__116932;
i__116892_116916 = G__116933;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"*/");

cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,t)," = (function (",cljs.compiler.comma_sep.call(null,fields__$1),"){");

var seq__116893_116934 = cljs.core.seq.call(null,fields__$1);
var chunk__116894_116935 = null;
var count__116895_116936 = (0);
var i__116896_116937 = (0);
while(true){
if((i__116896_116937 < count__116895_116936)){
var fld_116938 = cljs.core._nth.call(null,chunk__116894_116935,i__116896_116937);
cljs.compiler.emitln.call(null,"this.",fld_116938," = ",fld_116938,";");


var G__116939 = seq__116893_116934;
var G__116940 = chunk__116894_116935;
var G__116941 = count__116895_116936;
var G__116942 = (i__116896_116937 + (1));
seq__116893_116934 = G__116939;
chunk__116894_116935 = G__116940;
count__116895_116936 = G__116941;
i__116896_116937 = G__116942;
continue;
} else {
var temp__5735__auto___116943 = cljs.core.seq.call(null,seq__116893_116934);
if(temp__5735__auto___116943){
var seq__116893_116944__$1 = temp__5735__auto___116943;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116893_116944__$1)){
var c__4550__auto___116945 = cljs.core.chunk_first.call(null,seq__116893_116944__$1);
var G__116946 = cljs.core.chunk_rest.call(null,seq__116893_116944__$1);
var G__116947 = c__4550__auto___116945;
var G__116948 = cljs.core.count.call(null,c__4550__auto___116945);
var G__116949 = (0);
seq__116893_116934 = G__116946;
chunk__116894_116935 = G__116947;
count__116895_116936 = G__116948;
i__116896_116937 = G__116949;
continue;
} else {
var fld_116950 = cljs.core.first.call(null,seq__116893_116944__$1);
cljs.compiler.emitln.call(null,"this.",fld_116950," = ",fld_116950,";");


var G__116951 = cljs.core.next.call(null,seq__116893_116944__$1);
var G__116952 = null;
var G__116953 = (0);
var G__116954 = (0);
seq__116893_116934 = G__116951;
chunk__116894_116935 = G__116952;
count__116895_116936 = G__116953;
i__116896_116937 = G__116954;
continue;
}
} else {
}
}
break;
}

var seq__116897_116955 = cljs.core.seq.call(null,pmasks);
var chunk__116898_116956 = null;
var count__116899_116957 = (0);
var i__116900_116958 = (0);
while(true){
if((i__116900_116958 < count__116899_116957)){
var vec__116907_116959 = cljs.core._nth.call(null,chunk__116898_116956,i__116900_116958);
var pno_116960 = cljs.core.nth.call(null,vec__116907_116959,(0),null);
var pmask_116961 = cljs.core.nth.call(null,vec__116907_116959,(1),null);
cljs.compiler.emitln.call(null,"this.cljs$lang$protocol_mask$partition",pno_116960,"$ = ",pmask_116961,";");


var G__116962 = seq__116897_116955;
var G__116963 = chunk__116898_116956;
var G__116964 = count__116899_116957;
var G__116965 = (i__116900_116958 + (1));
seq__116897_116955 = G__116962;
chunk__116898_116956 = G__116963;
count__116899_116957 = G__116964;
i__116900_116958 = G__116965;
continue;
} else {
var temp__5735__auto___116966 = cljs.core.seq.call(null,seq__116897_116955);
if(temp__5735__auto___116966){
var seq__116897_116967__$1 = temp__5735__auto___116966;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116897_116967__$1)){
var c__4550__auto___116968 = cljs.core.chunk_first.call(null,seq__116897_116967__$1);
var G__116969 = cljs.core.chunk_rest.call(null,seq__116897_116967__$1);
var G__116970 = c__4550__auto___116968;
var G__116971 = cljs.core.count.call(null,c__4550__auto___116968);
var G__116972 = (0);
seq__116897_116955 = G__116969;
chunk__116898_116956 = G__116970;
count__116899_116957 = G__116971;
i__116900_116958 = G__116972;
continue;
} else {
var vec__116910_116973 = cljs.core.first.call(null,seq__116897_116967__$1);
var pno_116974 = cljs.core.nth.call(null,vec__116910_116973,(0),null);
var pmask_116975 = cljs.core.nth.call(null,vec__116910_116973,(1),null);
cljs.compiler.emitln.call(null,"this.cljs$lang$protocol_mask$partition",pno_116974,"$ = ",pmask_116975,";");


var G__116976 = cljs.core.next.call(null,seq__116897_116967__$1);
var G__116977 = null;
var G__116978 = (0);
var G__116979 = (0);
seq__116897_116955 = G__116976;
chunk__116898_116956 = G__116977;
count__116899_116957 = G__116978;
i__116900_116958 = G__116979;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"});");

return cljs.compiler.emit.call(null,body);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"defrecord","defrecord",-1367493418),(function (p__116980){
var map__116981 = p__116980;
var map__116981__$1 = (((((!((map__116981 == null))))?(((((map__116981.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__116981.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__116981):map__116981);
var t = cljs.core.get.call(null,map__116981__$1,new cljs.core.Keyword(null,"t","t",-1397832519));
var fields = cljs.core.get.call(null,map__116981__$1,new cljs.core.Keyword(null,"fields","fields",-1932066230));
var pmasks = cljs.core.get.call(null,map__116981__$1,new cljs.core.Keyword(null,"pmasks","pmasks",-871416698));
var body = cljs.core.get.call(null,map__116981__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var protocols = cljs.core.get.call(null,map__116981__$1,new cljs.core.Keyword(null,"protocols","protocols",-5615896));
var fields__$1 = cljs.core.concat.call(null,cljs.core.map.call(null,cljs.compiler.munge,fields),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"__meta","__meta",-946752628,null),new cljs.core.Symbol(null,"__extmap","__extmap",-1435580931,null),new cljs.core.Symbol(null,"__hash","__hash",-1328796629,null)], null));
cljs.compiler.emitln.call(null,"");

cljs.compiler.emitln.call(null,"/**");

cljs.compiler.emitln.call(null,"* @constructor");

var seq__116983_117007 = cljs.core.seq.call(null,protocols);
var chunk__116984_117008 = null;
var count__116985_117009 = (0);
var i__116986_117010 = (0);
while(true){
if((i__116986_117010 < count__116985_117009)){
var protocol_117011 = cljs.core._nth.call(null,chunk__116984_117008,i__116986_117010);
cljs.compiler.emitln.call(null," * @implements {",cljs.compiler.munge.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(protocol_117011)),"}");


var G__117012 = seq__116983_117007;
var G__117013 = chunk__116984_117008;
var G__117014 = count__116985_117009;
var G__117015 = (i__116986_117010 + (1));
seq__116983_117007 = G__117012;
chunk__116984_117008 = G__117013;
count__116985_117009 = G__117014;
i__116986_117010 = G__117015;
continue;
} else {
var temp__5735__auto___117016 = cljs.core.seq.call(null,seq__116983_117007);
if(temp__5735__auto___117016){
var seq__116983_117017__$1 = temp__5735__auto___117016;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116983_117017__$1)){
var c__4550__auto___117018 = cljs.core.chunk_first.call(null,seq__116983_117017__$1);
var G__117019 = cljs.core.chunk_rest.call(null,seq__116983_117017__$1);
var G__117020 = c__4550__auto___117018;
var G__117021 = cljs.core.count.call(null,c__4550__auto___117018);
var G__117022 = (0);
seq__116983_117007 = G__117019;
chunk__116984_117008 = G__117020;
count__116985_117009 = G__117021;
i__116986_117010 = G__117022;
continue;
} else {
var protocol_117023 = cljs.core.first.call(null,seq__116983_117017__$1);
cljs.compiler.emitln.call(null," * @implements {",cljs.compiler.munge.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(protocol_117023)),"}");


var G__117024 = cljs.core.next.call(null,seq__116983_117017__$1);
var G__117025 = null;
var G__117026 = (0);
var G__117027 = (0);
seq__116983_117007 = G__117024;
chunk__116984_117008 = G__117025;
count__116985_117009 = G__117026;
i__116986_117010 = G__117027;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"*/");

cljs.compiler.emitln.call(null,cljs.compiler.munge.call(null,t)," = (function (",cljs.compiler.comma_sep.call(null,fields__$1),"){");

var seq__116987_117028 = cljs.core.seq.call(null,fields__$1);
var chunk__116988_117029 = null;
var count__116989_117030 = (0);
var i__116990_117031 = (0);
while(true){
if((i__116990_117031 < count__116989_117030)){
var fld_117032 = cljs.core._nth.call(null,chunk__116988_117029,i__116990_117031);
cljs.compiler.emitln.call(null,"this.",fld_117032," = ",fld_117032,";");


var G__117033 = seq__116987_117028;
var G__117034 = chunk__116988_117029;
var G__117035 = count__116989_117030;
var G__117036 = (i__116990_117031 + (1));
seq__116987_117028 = G__117033;
chunk__116988_117029 = G__117034;
count__116989_117030 = G__117035;
i__116990_117031 = G__117036;
continue;
} else {
var temp__5735__auto___117037 = cljs.core.seq.call(null,seq__116987_117028);
if(temp__5735__auto___117037){
var seq__116987_117038__$1 = temp__5735__auto___117037;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116987_117038__$1)){
var c__4550__auto___117039 = cljs.core.chunk_first.call(null,seq__116987_117038__$1);
var G__117040 = cljs.core.chunk_rest.call(null,seq__116987_117038__$1);
var G__117041 = c__4550__auto___117039;
var G__117042 = cljs.core.count.call(null,c__4550__auto___117039);
var G__117043 = (0);
seq__116987_117028 = G__117040;
chunk__116988_117029 = G__117041;
count__116989_117030 = G__117042;
i__116990_117031 = G__117043;
continue;
} else {
var fld_117044 = cljs.core.first.call(null,seq__116987_117038__$1);
cljs.compiler.emitln.call(null,"this.",fld_117044," = ",fld_117044,";");


var G__117045 = cljs.core.next.call(null,seq__116987_117038__$1);
var G__117046 = null;
var G__117047 = (0);
var G__117048 = (0);
seq__116987_117028 = G__117045;
chunk__116988_117029 = G__117046;
count__116989_117030 = G__117047;
i__116990_117031 = G__117048;
continue;
}
} else {
}
}
break;
}

var seq__116991_117049 = cljs.core.seq.call(null,pmasks);
var chunk__116992_117050 = null;
var count__116993_117051 = (0);
var i__116994_117052 = (0);
while(true){
if((i__116994_117052 < count__116993_117051)){
var vec__117001_117053 = cljs.core._nth.call(null,chunk__116992_117050,i__116994_117052);
var pno_117054 = cljs.core.nth.call(null,vec__117001_117053,(0),null);
var pmask_117055 = cljs.core.nth.call(null,vec__117001_117053,(1),null);
cljs.compiler.emitln.call(null,"this.cljs$lang$protocol_mask$partition",pno_117054,"$ = ",pmask_117055,";");


var G__117056 = seq__116991_117049;
var G__117057 = chunk__116992_117050;
var G__117058 = count__116993_117051;
var G__117059 = (i__116994_117052 + (1));
seq__116991_117049 = G__117056;
chunk__116992_117050 = G__117057;
count__116993_117051 = G__117058;
i__116994_117052 = G__117059;
continue;
} else {
var temp__5735__auto___117060 = cljs.core.seq.call(null,seq__116991_117049);
if(temp__5735__auto___117060){
var seq__116991_117061__$1 = temp__5735__auto___117060;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__116991_117061__$1)){
var c__4550__auto___117062 = cljs.core.chunk_first.call(null,seq__116991_117061__$1);
var G__117063 = cljs.core.chunk_rest.call(null,seq__116991_117061__$1);
var G__117064 = c__4550__auto___117062;
var G__117065 = cljs.core.count.call(null,c__4550__auto___117062);
var G__117066 = (0);
seq__116991_117049 = G__117063;
chunk__116992_117050 = G__117064;
count__116993_117051 = G__117065;
i__116994_117052 = G__117066;
continue;
} else {
var vec__117004_117067 = cljs.core.first.call(null,seq__116991_117061__$1);
var pno_117068 = cljs.core.nth.call(null,vec__117004_117067,(0),null);
var pmask_117069 = cljs.core.nth.call(null,vec__117004_117067,(1),null);
cljs.compiler.emitln.call(null,"this.cljs$lang$protocol_mask$partition",pno_117068,"$ = ",pmask_117069,";");


var G__117070 = cljs.core.next.call(null,seq__116991_117061__$1);
var G__117071 = null;
var G__117072 = (0);
var G__117073 = (0);
seq__116991_117049 = G__117070;
chunk__116992_117050 = G__117071;
count__116993_117051 = G__117072;
i__116994_117052 = G__117073;
continue;
}
} else {
}
}
break;
}

cljs.compiler.emitln.call(null,"});");

return cljs.compiler.emit.call(null,body);
}));
cljs.compiler.emit_dot = (function cljs$compiler$emit_dot(p__117074){
var map__117075 = p__117074;
var map__117075__$1 = (((((!((map__117075 == null))))?(((((map__117075.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__117075.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__117075):map__117075);
var target = cljs.core.get.call(null,map__117075__$1,new cljs.core.Keyword(null,"target","target",253001721));
var field = cljs.core.get.call(null,map__117075__$1,new cljs.core.Keyword(null,"field","field",-1302436500));
var method = cljs.core.get.call(null,map__117075__$1,new cljs.core.Keyword(null,"method","method",55703592));
var args = cljs.core.get.call(null,map__117075__$1,new cljs.core.Keyword(null,"args","args",1315556576));
var env = cljs.core.get.call(null,map__117075__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if(cljs.core.truth_(field)){
cljs.compiler.emits.call(null,target,".",cljs.compiler.munge.call(null,field,cljs.core.PersistentHashSet.EMPTY));
} else {
cljs.compiler.emits.call(null,target,".",cljs.compiler.munge.call(null,method,cljs.core.PersistentHashSet.EMPTY),"(",cljs.compiler.comma_sep.call(null,args),")");
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
});
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"host-field","host-field",-72662140),(function (ast){
return cljs.compiler.emit_dot.call(null,ast);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"host-call","host-call",1059629755),(function (ast){
return cljs.compiler.emit_dot.call(null,ast);
}));
cljs.core._add_method.call(null,cljs.compiler.emit_STAR_,new cljs.core.Keyword(null,"js","js",1768080579),(function (p__117077){
var map__117078 = p__117077;
var map__117078__$1 = (((((!((map__117078 == null))))?(((((map__117078.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__117078.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__117078):map__117078);
var op = cljs.core.get.call(null,map__117078__$1,new cljs.core.Keyword(null,"op","op",-1882987955));
var env = cljs.core.get.call(null,map__117078__$1,new cljs.core.Keyword(null,"env","env",-1815813235));
var code = cljs.core.get.call(null,map__117078__$1,new cljs.core.Keyword(null,"code","code",1586293142));
var segs = cljs.core.get.call(null,map__117078__$1,new cljs.core.Keyword(null,"segs","segs",-1940299576));
var args = cljs.core.get.call(null,map__117078__$1,new cljs.core.Keyword(null,"args","args",1315556576));
if(cljs.core.truth_((function (){var and__4120__auto__ = code;
if(cljs.core.truth_(and__4120__auto__)){
return goog.string.startsWith(clojure.string.trim.call(null,code),"/*");
} else {
return and__4120__auto__;
}
})())){
return cljs.compiler.emits.call(null,code);
} else {
var env__115872__auto__ = env;
if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"return","return",-1891502105),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
cljs.compiler.emits.call(null,"return ");
} else {
}

if(cljs.core.truth_(code)){
cljs.compiler.emits.call(null,code);
} else {
cljs.compiler.emits.call(null,cljs.core.interleave.call(null,cljs.core.concat.call(null,segs,cljs.core.repeat.call(null,null)),cljs.core.concat.call(null,args,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [null], null))));
}

if(cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"expr","expr",745722291),new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(env__115872__auto__))){
return null;
} else {
return cljs.compiler.emitln.call(null,";");
}
}
}));
cljs.compiler.emit_constants_table = (function cljs$compiler$emit_constants_table(table){
cljs.compiler.emitln.call(null,"goog.provide('",cljs.compiler.munge.call(null,cljs.analyzer.constants_ns_sym),"');");

cljs.compiler.emitln.call(null,"goog.require('cljs.core');");

var seq__117084 = cljs.core.seq.call(null,table);
var chunk__117085 = null;
var count__117086 = (0);
var i__117087 = (0);
while(true){
if((i__117087 < count__117086)){
var vec__117094 = cljs.core._nth.call(null,chunk__117085,i__117087);
var sym = cljs.core.nth.call(null,vec__117094,(0),null);
var value = cljs.core.nth.call(null,vec__117094,(1),null);
var ns_117100 = cljs.core.namespace.call(null,sym);
var name_117101 = cljs.core.name.call(null,sym);
cljs.compiler.emits.call(null,"cljs.core.",value," = ");

if((sym instanceof cljs.core.Keyword)){
cljs.compiler.emits_keyword.call(null,sym);
} else {
if((sym instanceof cljs.core.Symbol)){
cljs.compiler.emits_symbol.call(null,sym);
} else {
throw cljs.core.ex_info.call(null,["Cannot emit constant for type ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.type.call(null,sym))].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"invalid-constant-type","invalid-constant-type",1294847471),new cljs.core.Keyword("clojure.error","phase","clojure.error/phase",275140358),new cljs.core.Keyword(null,"compilation","compilation",-1328774561)], null));

}
}

cljs.compiler.emits.call(null,";\n");


var G__117102 = seq__117084;
var G__117103 = chunk__117085;
var G__117104 = count__117086;
var G__117105 = (i__117087 + (1));
seq__117084 = G__117102;
chunk__117085 = G__117103;
count__117086 = G__117104;
i__117087 = G__117105;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq.call(null,seq__117084);
if(temp__5735__auto__){
var seq__117084__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__117084__$1)){
var c__4550__auto__ = cljs.core.chunk_first.call(null,seq__117084__$1);
var G__117106 = cljs.core.chunk_rest.call(null,seq__117084__$1);
var G__117107 = c__4550__auto__;
var G__117108 = cljs.core.count.call(null,c__4550__auto__);
var G__117109 = (0);
seq__117084 = G__117106;
chunk__117085 = G__117107;
count__117086 = G__117108;
i__117087 = G__117109;
continue;
} else {
var vec__117097 = cljs.core.first.call(null,seq__117084__$1);
var sym = cljs.core.nth.call(null,vec__117097,(0),null);
var value = cljs.core.nth.call(null,vec__117097,(1),null);
var ns_117110 = cljs.core.namespace.call(null,sym);
var name_117111 = cljs.core.name.call(null,sym);
cljs.compiler.emits.call(null,"cljs.core.",value," = ");

if((sym instanceof cljs.core.Keyword)){
cljs.compiler.emits_keyword.call(null,sym);
} else {
if((sym instanceof cljs.core.Symbol)){
cljs.compiler.emits_symbol.call(null,sym);
} else {
throw cljs.core.ex_info.call(null,["Cannot emit constant for type ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.type.call(null,sym))].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"invalid-constant-type","invalid-constant-type",1294847471),new cljs.core.Keyword("clojure.error","phase","clojure.error/phase",275140358),new cljs.core.Keyword(null,"compilation","compilation",-1328774561)], null));

}
}

cljs.compiler.emits.call(null,";\n");


var G__117112 = cljs.core.next.call(null,seq__117084__$1);
var G__117113 = null;
var G__117114 = (0);
var G__117115 = (0);
seq__117084 = G__117112;
chunk__117085 = G__117113;
count__117086 = G__117114;
i__117087 = G__117115;
continue;
}
} else {
return null;
}
}
break;
}
});
cljs.compiler.emit_externs = (function cljs$compiler$emit_externs(var_args){
var G__117117 = arguments.length;
switch (G__117117) {
case 1:
return cljs.compiler.emit_externs.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 4:
return cljs.compiler.emit_externs.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.compiler.emit_externs.cljs$core$IFn$_invoke$arity$1 = (function (externs){
return cljs.compiler.emit_externs.call(null,cljs.core.PersistentVector.EMPTY,externs,cljs.core.atom.call(null,cljs.core.PersistentHashSet.EMPTY),(cljs.core.truth_(cljs.env._STAR_compiler_STAR_)?new cljs.core.Keyword("cljs.analyzer","externs","cljs.analyzer/externs",893359239).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,cljs.env._STAR_compiler_STAR_)):null));
});

cljs.compiler.emit_externs.cljs$core$IFn$_invoke$arity$4 = (function (prefix,externs,top_level,known_externs){
var ks = cljs.core.seq.call(null,cljs.core.keys.call(null,externs));
while(true){
if(ks){
var k_117122 = cljs.core.first.call(null,ks);
var vec__117118_117123 = cljs.core.conj.call(null,prefix,k_117122);
var top_117124 = cljs.core.nth.call(null,vec__117118_117123,(0),null);
var prefix_SINGLEQUOTE__117125 = vec__117118_117123;
if(((cljs.core.not_EQ_.call(null,new cljs.core.Symbol(null,"prototype","prototype",519166522,null),k_117122)) && ((cljs.core.get_in.call(null,known_externs,prefix_SINGLEQUOTE__117125) == null)))){
if((!(((cljs.core.contains_QMARK_.call(null,cljs.core.deref.call(null,top_level),top_117124)) || (cljs.core.contains_QMARK_.call(null,known_externs,top_117124)))))){
cljs.compiler.emitln.call(null,"var ",clojure.string.join.call(null,".",cljs.core.map.call(null,cljs.compiler.munge,prefix_SINGLEQUOTE__117125)),";");

cljs.core.swap_BANG_.call(null,top_level,cljs.core.conj,top_117124);
} else {
cljs.compiler.emitln.call(null,clojure.string.join.call(null,".",cljs.core.map.call(null,cljs.compiler.munge,prefix_SINGLEQUOTE__117125)),";");
}
} else {
}

var m_117126 = cljs.core.get.call(null,externs,k_117122);
if(cljs.core.empty_QMARK_.call(null,m_117126)){
} else {
cljs.compiler.emit_externs.call(null,prefix_SINGLEQUOTE__117125,m_117126,top_level,known_externs);
}

var G__117127 = cljs.core.next.call(null,ks);
ks = G__117127;
continue;
} else {
return null;
}
break;
}
});

cljs.compiler.emit_externs.cljs$lang$maxFixedArity = 4;

