// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var G__97136 = arguments.length;
switch (G__97136) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.call(null,f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async97137 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async97137 = (function (f,blockable,meta97138){
this.f = f;
this.blockable = blockable;
this.meta97138 = meta97138;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async97137.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_97139,meta97138__$1){
var self__ = this;
var _97139__$1 = this;
return (new cljs.core.async.t_cljs$core$async97137(self__.f,self__.blockable,meta97138__$1));
});

cljs.core.async.t_cljs$core$async97137.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_97139){
var self__ = this;
var _97139__$1 = this;
return self__.meta97138;
});

cljs.core.async.t_cljs$core$async97137.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async97137.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async97137.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async97137.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async97137.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta97138","meta97138",852080623,null)], null);
});

cljs.core.async.t_cljs$core$async97137.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async97137.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async97137";

cljs.core.async.t_cljs$core$async97137.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"cljs.core.async/t_cljs$core$async97137");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async97137.
 */
cljs.core.async.__GT_t_cljs$core$async97137 = (function cljs$core$async$__GT_t_cljs$core$async97137(f__$1,blockable__$1,meta97138){
return (new cljs.core.async.t_cljs$core$async97137(f__$1,blockable__$1,meta97138));
});

}

return (new cljs.core.async.t_cljs$core$async97137(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if((!((buff == null)))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$)))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var G__97143 = arguments.length;
switch (G__97143) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error(["Assert failed: ","buffer must be supplied when transducer is","\n","buf-or-n"].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var G__97146 = arguments.length;
switch (G__97146) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.call(null,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.call(null,xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.call(null,cljs.core.async.impl.buffers.promise_buffer.call(null),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var G__97149 = arguments.length;
switch (G__97149) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_97151 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_97151);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_97151,ret){
return (function (){
return fn1.call(null,val_97151);
});})(val_97151,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn1 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn1 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var G__97153 = arguments.length;
switch (G__97153) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__5733__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__5733__auto__)){
var ret = temp__5733__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__5733__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__5733__auto__)){
var retb = temp__5733__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__5733__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__5733__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__4607__auto___97155 = n;
var x_97156 = (0);
while(true){
if((x_97156 < n__4607__auto___97155)){
(a[x_97156] = (0));

var G__97157 = (x_97156 + (1));
x_97156 = G__97157;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.call(null,i,n)){
return a;
} else {
var j = cljs.core.rand_int.call(null,i);
(a[i] = (a[j]));

(a[j] = i);

var G__97158 = (i + (1));
i = G__97158;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async97159 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async97159 = (function (flag,meta97160){
this.flag = flag;
this.meta97160 = meta97160;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async97159.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_97161,meta97160__$1){
var self__ = this;
var _97161__$1 = this;
return (new cljs.core.async.t_cljs$core$async97159(self__.flag,meta97160__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async97159.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_97161){
var self__ = this;
var _97161__$1 = this;
return self__.meta97160;
});})(flag))
;

cljs.core.async.t_cljs$core$async97159.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async97159.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async97159.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async97159.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async97159.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta97160","meta97160",-75472902,null)], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async97159.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async97159.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async97159";

cljs.core.async.t_cljs$core$async97159.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"cljs.core.async/t_cljs$core$async97159");
});})(flag))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async97159.
 */
cljs.core.async.__GT_t_cljs$core$async97159 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async97159(flag__$1,meta97160){
return (new cljs.core.async.t_cljs$core$async97159(flag__$1,meta97160));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async97159(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async97162 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async97162 = (function (flag,cb,meta97163){
this.flag = flag;
this.cb = cb;
this.meta97163 = meta97163;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async97162.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_97164,meta97163__$1){
var self__ = this;
var _97164__$1 = this;
return (new cljs.core.async.t_cljs$core$async97162(self__.flag,self__.cb,meta97163__$1));
});

cljs.core.async.t_cljs$core$async97162.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_97164){
var self__ = this;
var _97164__$1 = this;
return self__.meta97163;
});

cljs.core.async.t_cljs$core$async97162.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async97162.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t_cljs$core$async97162.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async97162.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async97162.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta97163","meta97163",1764810919,null)], null);
});

cljs.core.async.t_cljs$core$async97162.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async97162.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async97162";

cljs.core.async.t_cljs$core$async97162.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"cljs.core.async/t_cljs$core$async97162");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async97162.
 */
cljs.core.async.__GT_t_cljs$core$async97162 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async97162(flag__$1,cb__$1,meta97163){
return (new cljs.core.async.t_cljs$core$async97162(flag__$1,cb__$1,meta97163));
});

}

return (new cljs.core.async.t_cljs$core$async97162(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__97165_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__97165_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__97166_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__97166_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__4131__auto__ = wport;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return port;
}
})()], null));
} else {
var G__97167 = (i + (1));
i = G__97167;
continue;
}
} else {
return null;
}
break;
}
})();
var or__4131__auto__ = ret;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__5735__auto__ = (function (){var and__4120__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__4120__auto__;
}
})();
if(cljs.core.truth_(temp__5735__auto__)){
var got = temp__5735__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___97173 = arguments.length;
var i__4731__auto___97174 = (0);
while(true){
if((i__4731__auto___97174 < len__4730__auto___97173)){
args__4736__auto__.push((arguments[i__4731__auto___97174]));

var G__97175 = (i__4731__auto___97174 + (1));
i__4731__auto___97174 = G__97175;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__97170){
var map__97171 = p__97170;
var map__97171__$1 = (((((!((map__97171 == null))))?(((((map__97171.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__97171.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__97171):map__97171);
var opts = map__97171__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq97168){
var G__97169 = cljs.core.first.call(null,seq97168);
var seq97168__$1 = cljs.core.next.call(null,seq97168);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__97169,seq97168__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var G__97177 = arguments.length;
switch (G__97177) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__97076__auto___97223 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___97223){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___97223){
return (function (state_97201){
var state_val_97202 = (state_97201[(1)]);
if((state_val_97202 === (7))){
var inst_97197 = (state_97201[(2)]);
var state_97201__$1 = state_97201;
var statearr_97203_97224 = state_97201__$1;
(statearr_97203_97224[(2)] = inst_97197);

(statearr_97203_97224[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97202 === (1))){
var state_97201__$1 = state_97201;
var statearr_97204_97225 = state_97201__$1;
(statearr_97204_97225[(2)] = null);

(statearr_97204_97225[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97202 === (4))){
var inst_97180 = (state_97201[(7)]);
var inst_97180__$1 = (state_97201[(2)]);
var inst_97181 = (inst_97180__$1 == null);
var state_97201__$1 = (function (){var statearr_97205 = state_97201;
(statearr_97205[(7)] = inst_97180__$1);

return statearr_97205;
})();
if(cljs.core.truth_(inst_97181)){
var statearr_97206_97226 = state_97201__$1;
(statearr_97206_97226[(1)] = (5));

} else {
var statearr_97207_97227 = state_97201__$1;
(statearr_97207_97227[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97202 === (13))){
var state_97201__$1 = state_97201;
var statearr_97208_97228 = state_97201__$1;
(statearr_97208_97228[(2)] = null);

(statearr_97208_97228[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97202 === (6))){
var inst_97180 = (state_97201[(7)]);
var state_97201__$1 = state_97201;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_97201__$1,(11),to,inst_97180);
} else {
if((state_val_97202 === (3))){
var inst_97199 = (state_97201[(2)]);
var state_97201__$1 = state_97201;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97201__$1,inst_97199);
} else {
if((state_val_97202 === (12))){
var state_97201__$1 = state_97201;
var statearr_97209_97229 = state_97201__$1;
(statearr_97209_97229[(2)] = null);

(statearr_97209_97229[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97202 === (2))){
var state_97201__$1 = state_97201;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97201__$1,(4),from);
} else {
if((state_val_97202 === (11))){
var inst_97190 = (state_97201[(2)]);
var state_97201__$1 = state_97201;
if(cljs.core.truth_(inst_97190)){
var statearr_97210_97230 = state_97201__$1;
(statearr_97210_97230[(1)] = (12));

} else {
var statearr_97211_97231 = state_97201__$1;
(statearr_97211_97231[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97202 === (9))){
var state_97201__$1 = state_97201;
var statearr_97212_97232 = state_97201__$1;
(statearr_97212_97232[(2)] = null);

(statearr_97212_97232[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97202 === (5))){
var state_97201__$1 = state_97201;
if(cljs.core.truth_(close_QMARK_)){
var statearr_97213_97233 = state_97201__$1;
(statearr_97213_97233[(1)] = (8));

} else {
var statearr_97214_97234 = state_97201__$1;
(statearr_97214_97234[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97202 === (14))){
var inst_97195 = (state_97201[(2)]);
var state_97201__$1 = state_97201;
var statearr_97215_97235 = state_97201__$1;
(statearr_97215_97235[(2)] = inst_97195);

(statearr_97215_97235[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97202 === (10))){
var inst_97187 = (state_97201[(2)]);
var state_97201__$1 = state_97201;
var statearr_97216_97236 = state_97201__$1;
(statearr_97216_97236[(2)] = inst_97187);

(statearr_97216_97236[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97202 === (8))){
var inst_97184 = cljs.core.async.close_BANG_.call(null,to);
var state_97201__$1 = state_97201;
var statearr_97217_97237 = state_97201__$1;
(statearr_97217_97237[(2)] = inst_97184);

(statearr_97217_97237[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___97223))
;
return ((function (switch__96981__auto__,c__97076__auto___97223){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_97218 = [null,null,null,null,null,null,null,null];
(statearr_97218[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_97218[(1)] = (1));

return statearr_97218;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_97201){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97201);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97219){if((e97219 instanceof Object)){
var ex__96985__auto__ = e97219;
var statearr_97220_97238 = state_97201;
(statearr_97220_97238[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97201);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97219;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97239 = state_97201;
state_97201 = G__97239;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_97201){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_97201);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___97223))
})();
var state__97078__auto__ = (function (){var statearr_97221 = f__97077__auto__.call(null);
(statearr_97221[(6)] = c__97076__auto___97223);

return statearr_97221;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___97223))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__97240){
var vec__97241 = p__97240;
var v = cljs.core.nth.call(null,vec__97241,(0),null);
var p = cljs.core.nth.call(null,vec__97241,(1),null);
var job = vec__97241;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__97076__auto___97412 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___97412,res,vec__97241,v,p,job,jobs,results){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___97412,res,vec__97241,v,p,job,jobs,results){
return (function (state_97248){
var state_val_97249 = (state_97248[(1)]);
if((state_val_97249 === (1))){
var state_97248__$1 = state_97248;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_97248__$1,(2),res,v);
} else {
if((state_val_97249 === (2))){
var inst_97245 = (state_97248[(2)]);
var inst_97246 = cljs.core.async.close_BANG_.call(null,res);
var state_97248__$1 = (function (){var statearr_97250 = state_97248;
(statearr_97250[(7)] = inst_97245);

return statearr_97250;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97248__$1,inst_97246);
} else {
return null;
}
}
});})(c__97076__auto___97412,res,vec__97241,v,p,job,jobs,results))
;
return ((function (switch__96981__auto__,c__97076__auto___97412,res,vec__97241,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0 = (function (){
var statearr_97251 = [null,null,null,null,null,null,null,null];
(statearr_97251[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__);

(statearr_97251[(1)] = (1));

return statearr_97251;
});
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1 = (function (state_97248){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97248);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97252){if((e97252 instanceof Object)){
var ex__96985__auto__ = e97252;
var statearr_97253_97413 = state_97248;
(statearr_97253_97413[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97248);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97252;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97414 = state_97248;
state_97248 = G__97414;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__ = function(state_97248){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1.call(this,state_97248);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___97412,res,vec__97241,v,p,job,jobs,results))
})();
var state__97078__auto__ = (function (){var statearr_97254 = f__97077__auto__.call(null);
(statearr_97254[(6)] = c__97076__auto___97412);

return statearr_97254;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___97412,res,vec__97241,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__97255){
var vec__97256 = p__97255;
var v = cljs.core.nth.call(null,vec__97256,(0),null);
var p = cljs.core.nth.call(null,vec__97256,(1),null);
var job = vec__97256;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__4607__auto___97415 = n;
var __97416 = (0);
while(true){
if((__97416 < n__4607__auto___97415)){
var G__97259_97417 = type;
var G__97259_97418__$1 = (((G__97259_97417 instanceof cljs.core.Keyword))?G__97259_97417.fqn:null);
switch (G__97259_97418__$1) {
case "compute":
var c__97076__auto___97420 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__97416,c__97076__auto___97420,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (__97416,c__97076__auto___97420,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async){
return (function (state_97272){
var state_val_97273 = (state_97272[(1)]);
if((state_val_97273 === (1))){
var state_97272__$1 = state_97272;
var statearr_97274_97421 = state_97272__$1;
(statearr_97274_97421[(2)] = null);

(statearr_97274_97421[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97273 === (2))){
var state_97272__$1 = state_97272;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97272__$1,(4),jobs);
} else {
if((state_val_97273 === (3))){
var inst_97270 = (state_97272[(2)]);
var state_97272__$1 = state_97272;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97272__$1,inst_97270);
} else {
if((state_val_97273 === (4))){
var inst_97262 = (state_97272[(2)]);
var inst_97263 = process.call(null,inst_97262);
var state_97272__$1 = state_97272;
if(cljs.core.truth_(inst_97263)){
var statearr_97275_97422 = state_97272__$1;
(statearr_97275_97422[(1)] = (5));

} else {
var statearr_97276_97423 = state_97272__$1;
(statearr_97276_97423[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97273 === (5))){
var state_97272__$1 = state_97272;
var statearr_97277_97424 = state_97272__$1;
(statearr_97277_97424[(2)] = null);

(statearr_97277_97424[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97273 === (6))){
var state_97272__$1 = state_97272;
var statearr_97278_97425 = state_97272__$1;
(statearr_97278_97425[(2)] = null);

(statearr_97278_97425[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97273 === (7))){
var inst_97268 = (state_97272[(2)]);
var state_97272__$1 = state_97272;
var statearr_97279_97426 = state_97272__$1;
(statearr_97279_97426[(2)] = inst_97268);

(statearr_97279_97426[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__97416,c__97076__auto___97420,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async))
;
return ((function (__97416,switch__96981__auto__,c__97076__auto___97420,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0 = (function (){
var statearr_97280 = [null,null,null,null,null,null,null];
(statearr_97280[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__);

(statearr_97280[(1)] = (1));

return statearr_97280;
});
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1 = (function (state_97272){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97272);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97281){if((e97281 instanceof Object)){
var ex__96985__auto__ = e97281;
var statearr_97282_97427 = state_97272;
(statearr_97282_97427[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97272);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97281;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97428 = state_97272;
state_97272 = G__97428;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__ = function(state_97272){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1.call(this,state_97272);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__;
})()
;})(__97416,switch__96981__auto__,c__97076__auto___97420,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async))
})();
var state__97078__auto__ = (function (){var statearr_97283 = f__97077__auto__.call(null);
(statearr_97283[(6)] = c__97076__auto___97420);

return statearr_97283;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(__97416,c__97076__auto___97420,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async))
);


break;
case "async":
var c__97076__auto___97429 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__97416,c__97076__auto___97429,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (__97416,c__97076__auto___97429,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async){
return (function (state_97296){
var state_val_97297 = (state_97296[(1)]);
if((state_val_97297 === (1))){
var state_97296__$1 = state_97296;
var statearr_97298_97430 = state_97296__$1;
(statearr_97298_97430[(2)] = null);

(statearr_97298_97430[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97297 === (2))){
var state_97296__$1 = state_97296;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97296__$1,(4),jobs);
} else {
if((state_val_97297 === (3))){
var inst_97294 = (state_97296[(2)]);
var state_97296__$1 = state_97296;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97296__$1,inst_97294);
} else {
if((state_val_97297 === (4))){
var inst_97286 = (state_97296[(2)]);
var inst_97287 = async.call(null,inst_97286);
var state_97296__$1 = state_97296;
if(cljs.core.truth_(inst_97287)){
var statearr_97299_97431 = state_97296__$1;
(statearr_97299_97431[(1)] = (5));

} else {
var statearr_97300_97432 = state_97296__$1;
(statearr_97300_97432[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97297 === (5))){
var state_97296__$1 = state_97296;
var statearr_97301_97433 = state_97296__$1;
(statearr_97301_97433[(2)] = null);

(statearr_97301_97433[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97297 === (6))){
var state_97296__$1 = state_97296;
var statearr_97302_97434 = state_97296__$1;
(statearr_97302_97434[(2)] = null);

(statearr_97302_97434[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97297 === (7))){
var inst_97292 = (state_97296[(2)]);
var state_97296__$1 = state_97296;
var statearr_97303_97435 = state_97296__$1;
(statearr_97303_97435[(2)] = inst_97292);

(statearr_97303_97435[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__97416,c__97076__auto___97429,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async))
;
return ((function (__97416,switch__96981__auto__,c__97076__auto___97429,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0 = (function (){
var statearr_97304 = [null,null,null,null,null,null,null];
(statearr_97304[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__);

(statearr_97304[(1)] = (1));

return statearr_97304;
});
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1 = (function (state_97296){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97296);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97305){if((e97305 instanceof Object)){
var ex__96985__auto__ = e97305;
var statearr_97306_97436 = state_97296;
(statearr_97306_97436[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97296);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97305;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97437 = state_97296;
state_97296 = G__97437;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__ = function(state_97296){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1.call(this,state_97296);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__;
})()
;})(__97416,switch__96981__auto__,c__97076__auto___97429,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async))
})();
var state__97078__auto__ = (function (){var statearr_97307 = f__97077__auto__.call(null);
(statearr_97307[(6)] = c__97076__auto___97429);

return statearr_97307;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(__97416,c__97076__auto___97429,G__97259_97417,G__97259_97418__$1,n__4607__auto___97415,jobs,results,process,async))
);


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__97259_97418__$1)].join('')));

}

var G__97438 = (__97416 + (1));
__97416 = G__97438;
continue;
} else {
}
break;
}

var c__97076__auto___97439 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___97439,jobs,results,process,async){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___97439,jobs,results,process,async){
return (function (state_97329){
var state_val_97330 = (state_97329[(1)]);
if((state_val_97330 === (7))){
var inst_97325 = (state_97329[(2)]);
var state_97329__$1 = state_97329;
var statearr_97331_97440 = state_97329__$1;
(statearr_97331_97440[(2)] = inst_97325);

(statearr_97331_97440[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97330 === (1))){
var state_97329__$1 = state_97329;
var statearr_97332_97441 = state_97329__$1;
(statearr_97332_97441[(2)] = null);

(statearr_97332_97441[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97330 === (4))){
var inst_97310 = (state_97329[(7)]);
var inst_97310__$1 = (state_97329[(2)]);
var inst_97311 = (inst_97310__$1 == null);
var state_97329__$1 = (function (){var statearr_97333 = state_97329;
(statearr_97333[(7)] = inst_97310__$1);

return statearr_97333;
})();
if(cljs.core.truth_(inst_97311)){
var statearr_97334_97442 = state_97329__$1;
(statearr_97334_97442[(1)] = (5));

} else {
var statearr_97335_97443 = state_97329__$1;
(statearr_97335_97443[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97330 === (6))){
var inst_97310 = (state_97329[(7)]);
var inst_97315 = (state_97329[(8)]);
var inst_97315__$1 = cljs.core.async.chan.call(null,(1));
var inst_97316 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_97317 = [inst_97310,inst_97315__$1];
var inst_97318 = (new cljs.core.PersistentVector(null,2,(5),inst_97316,inst_97317,null));
var state_97329__$1 = (function (){var statearr_97336 = state_97329;
(statearr_97336[(8)] = inst_97315__$1);

return statearr_97336;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_97329__$1,(8),jobs,inst_97318);
} else {
if((state_val_97330 === (3))){
var inst_97327 = (state_97329[(2)]);
var state_97329__$1 = state_97329;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97329__$1,inst_97327);
} else {
if((state_val_97330 === (2))){
var state_97329__$1 = state_97329;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97329__$1,(4),from);
} else {
if((state_val_97330 === (9))){
var inst_97322 = (state_97329[(2)]);
var state_97329__$1 = (function (){var statearr_97337 = state_97329;
(statearr_97337[(9)] = inst_97322);

return statearr_97337;
})();
var statearr_97338_97444 = state_97329__$1;
(statearr_97338_97444[(2)] = null);

(statearr_97338_97444[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97330 === (5))){
var inst_97313 = cljs.core.async.close_BANG_.call(null,jobs);
var state_97329__$1 = state_97329;
var statearr_97339_97445 = state_97329__$1;
(statearr_97339_97445[(2)] = inst_97313);

(statearr_97339_97445[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97330 === (8))){
var inst_97315 = (state_97329[(8)]);
var inst_97320 = (state_97329[(2)]);
var state_97329__$1 = (function (){var statearr_97340 = state_97329;
(statearr_97340[(10)] = inst_97320);

return statearr_97340;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_97329__$1,(9),results,inst_97315);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___97439,jobs,results,process,async))
;
return ((function (switch__96981__auto__,c__97076__auto___97439,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0 = (function (){
var statearr_97341 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_97341[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__);

(statearr_97341[(1)] = (1));

return statearr_97341;
});
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1 = (function (state_97329){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97329);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97342){if((e97342 instanceof Object)){
var ex__96985__auto__ = e97342;
var statearr_97343_97446 = state_97329;
(statearr_97343_97446[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97329);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97342;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97447 = state_97329;
state_97329 = G__97447;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__ = function(state_97329){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1.call(this,state_97329);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___97439,jobs,results,process,async))
})();
var state__97078__auto__ = (function (){var statearr_97344 = f__97077__auto__.call(null);
(statearr_97344[(6)] = c__97076__auto___97439);

return statearr_97344;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___97439,jobs,results,process,async))
);


var c__97076__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto__,jobs,results,process,async){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto__,jobs,results,process,async){
return (function (state_97382){
var state_val_97383 = (state_97382[(1)]);
if((state_val_97383 === (7))){
var inst_97378 = (state_97382[(2)]);
var state_97382__$1 = state_97382;
var statearr_97384_97448 = state_97382__$1;
(statearr_97384_97448[(2)] = inst_97378);

(statearr_97384_97448[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (20))){
var state_97382__$1 = state_97382;
var statearr_97385_97449 = state_97382__$1;
(statearr_97385_97449[(2)] = null);

(statearr_97385_97449[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (1))){
var state_97382__$1 = state_97382;
var statearr_97386_97450 = state_97382__$1;
(statearr_97386_97450[(2)] = null);

(statearr_97386_97450[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (4))){
var inst_97347 = (state_97382[(7)]);
var inst_97347__$1 = (state_97382[(2)]);
var inst_97348 = (inst_97347__$1 == null);
var state_97382__$1 = (function (){var statearr_97387 = state_97382;
(statearr_97387[(7)] = inst_97347__$1);

return statearr_97387;
})();
if(cljs.core.truth_(inst_97348)){
var statearr_97388_97451 = state_97382__$1;
(statearr_97388_97451[(1)] = (5));

} else {
var statearr_97389_97452 = state_97382__$1;
(statearr_97389_97452[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (15))){
var inst_97360 = (state_97382[(8)]);
var state_97382__$1 = state_97382;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_97382__$1,(18),to,inst_97360);
} else {
if((state_val_97383 === (21))){
var inst_97373 = (state_97382[(2)]);
var state_97382__$1 = state_97382;
var statearr_97390_97453 = state_97382__$1;
(statearr_97390_97453[(2)] = inst_97373);

(statearr_97390_97453[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (13))){
var inst_97375 = (state_97382[(2)]);
var state_97382__$1 = (function (){var statearr_97391 = state_97382;
(statearr_97391[(9)] = inst_97375);

return statearr_97391;
})();
var statearr_97392_97454 = state_97382__$1;
(statearr_97392_97454[(2)] = null);

(statearr_97392_97454[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (6))){
var inst_97347 = (state_97382[(7)]);
var state_97382__$1 = state_97382;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97382__$1,(11),inst_97347);
} else {
if((state_val_97383 === (17))){
var inst_97368 = (state_97382[(2)]);
var state_97382__$1 = state_97382;
if(cljs.core.truth_(inst_97368)){
var statearr_97393_97455 = state_97382__$1;
(statearr_97393_97455[(1)] = (19));

} else {
var statearr_97394_97456 = state_97382__$1;
(statearr_97394_97456[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (3))){
var inst_97380 = (state_97382[(2)]);
var state_97382__$1 = state_97382;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97382__$1,inst_97380);
} else {
if((state_val_97383 === (12))){
var inst_97357 = (state_97382[(10)]);
var state_97382__$1 = state_97382;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97382__$1,(14),inst_97357);
} else {
if((state_val_97383 === (2))){
var state_97382__$1 = state_97382;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97382__$1,(4),results);
} else {
if((state_val_97383 === (19))){
var state_97382__$1 = state_97382;
var statearr_97395_97457 = state_97382__$1;
(statearr_97395_97457[(2)] = null);

(statearr_97395_97457[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (11))){
var inst_97357 = (state_97382[(2)]);
var state_97382__$1 = (function (){var statearr_97396 = state_97382;
(statearr_97396[(10)] = inst_97357);

return statearr_97396;
})();
var statearr_97397_97458 = state_97382__$1;
(statearr_97397_97458[(2)] = null);

(statearr_97397_97458[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (9))){
var state_97382__$1 = state_97382;
var statearr_97398_97459 = state_97382__$1;
(statearr_97398_97459[(2)] = null);

(statearr_97398_97459[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (5))){
var state_97382__$1 = state_97382;
if(cljs.core.truth_(close_QMARK_)){
var statearr_97399_97460 = state_97382__$1;
(statearr_97399_97460[(1)] = (8));

} else {
var statearr_97400_97461 = state_97382__$1;
(statearr_97400_97461[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (14))){
var inst_97360 = (state_97382[(8)]);
var inst_97362 = (state_97382[(11)]);
var inst_97360__$1 = (state_97382[(2)]);
var inst_97361 = (inst_97360__$1 == null);
var inst_97362__$1 = cljs.core.not.call(null,inst_97361);
var state_97382__$1 = (function (){var statearr_97401 = state_97382;
(statearr_97401[(8)] = inst_97360__$1);

(statearr_97401[(11)] = inst_97362__$1);

return statearr_97401;
})();
if(inst_97362__$1){
var statearr_97402_97462 = state_97382__$1;
(statearr_97402_97462[(1)] = (15));

} else {
var statearr_97403_97463 = state_97382__$1;
(statearr_97403_97463[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (16))){
var inst_97362 = (state_97382[(11)]);
var state_97382__$1 = state_97382;
var statearr_97404_97464 = state_97382__$1;
(statearr_97404_97464[(2)] = inst_97362);

(statearr_97404_97464[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (10))){
var inst_97354 = (state_97382[(2)]);
var state_97382__$1 = state_97382;
var statearr_97405_97465 = state_97382__$1;
(statearr_97405_97465[(2)] = inst_97354);

(statearr_97405_97465[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (18))){
var inst_97365 = (state_97382[(2)]);
var state_97382__$1 = state_97382;
var statearr_97406_97466 = state_97382__$1;
(statearr_97406_97466[(2)] = inst_97365);

(statearr_97406_97466[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97383 === (8))){
var inst_97351 = cljs.core.async.close_BANG_.call(null,to);
var state_97382__$1 = state_97382;
var statearr_97407_97467 = state_97382__$1;
(statearr_97407_97467[(2)] = inst_97351);

(statearr_97407_97467[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto__,jobs,results,process,async))
;
return ((function (switch__96981__auto__,c__97076__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0 = (function (){
var statearr_97408 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_97408[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__);

(statearr_97408[(1)] = (1));

return statearr_97408;
});
var cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1 = (function (state_97382){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97382);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97409){if((e97409 instanceof Object)){
var ex__96985__auto__ = e97409;
var statearr_97410_97468 = state_97382;
(statearr_97410_97468[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97382);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97409;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97469 = state_97382;
state_97382 = G__97469;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__ = function(state_97382){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1.call(this,state_97382);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__96982__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto__,jobs,results,process,async))
})();
var state__97078__auto__ = (function (){var statearr_97411 = f__97077__auto__.call(null);
(statearr_97411[(6)] = c__97076__auto__);

return statearr_97411;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto__,jobs,results,process,async))
);

return c__97076__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var G__97471 = arguments.length;
switch (G__97471) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var G__97474 = arguments.length;
switch (G__97474) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var G__97477 = arguments.length;
switch (G__97477) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__97076__auto___97526 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___97526,tc,fc){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___97526,tc,fc){
return (function (state_97503){
var state_val_97504 = (state_97503[(1)]);
if((state_val_97504 === (7))){
var inst_97499 = (state_97503[(2)]);
var state_97503__$1 = state_97503;
var statearr_97505_97527 = state_97503__$1;
(statearr_97505_97527[(2)] = inst_97499);

(statearr_97505_97527[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97504 === (1))){
var state_97503__$1 = state_97503;
var statearr_97506_97528 = state_97503__$1;
(statearr_97506_97528[(2)] = null);

(statearr_97506_97528[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97504 === (4))){
var inst_97480 = (state_97503[(7)]);
var inst_97480__$1 = (state_97503[(2)]);
var inst_97481 = (inst_97480__$1 == null);
var state_97503__$1 = (function (){var statearr_97507 = state_97503;
(statearr_97507[(7)] = inst_97480__$1);

return statearr_97507;
})();
if(cljs.core.truth_(inst_97481)){
var statearr_97508_97529 = state_97503__$1;
(statearr_97508_97529[(1)] = (5));

} else {
var statearr_97509_97530 = state_97503__$1;
(statearr_97509_97530[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97504 === (13))){
var state_97503__$1 = state_97503;
var statearr_97510_97531 = state_97503__$1;
(statearr_97510_97531[(2)] = null);

(statearr_97510_97531[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97504 === (6))){
var inst_97480 = (state_97503[(7)]);
var inst_97486 = p.call(null,inst_97480);
var state_97503__$1 = state_97503;
if(cljs.core.truth_(inst_97486)){
var statearr_97511_97532 = state_97503__$1;
(statearr_97511_97532[(1)] = (9));

} else {
var statearr_97512_97533 = state_97503__$1;
(statearr_97512_97533[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97504 === (3))){
var inst_97501 = (state_97503[(2)]);
var state_97503__$1 = state_97503;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97503__$1,inst_97501);
} else {
if((state_val_97504 === (12))){
var state_97503__$1 = state_97503;
var statearr_97513_97534 = state_97503__$1;
(statearr_97513_97534[(2)] = null);

(statearr_97513_97534[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97504 === (2))){
var state_97503__$1 = state_97503;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97503__$1,(4),ch);
} else {
if((state_val_97504 === (11))){
var inst_97480 = (state_97503[(7)]);
var inst_97490 = (state_97503[(2)]);
var state_97503__$1 = state_97503;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_97503__$1,(8),inst_97490,inst_97480);
} else {
if((state_val_97504 === (9))){
var state_97503__$1 = state_97503;
var statearr_97514_97535 = state_97503__$1;
(statearr_97514_97535[(2)] = tc);

(statearr_97514_97535[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97504 === (5))){
var inst_97483 = cljs.core.async.close_BANG_.call(null,tc);
var inst_97484 = cljs.core.async.close_BANG_.call(null,fc);
var state_97503__$1 = (function (){var statearr_97515 = state_97503;
(statearr_97515[(8)] = inst_97483);

return statearr_97515;
})();
var statearr_97516_97536 = state_97503__$1;
(statearr_97516_97536[(2)] = inst_97484);

(statearr_97516_97536[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97504 === (14))){
var inst_97497 = (state_97503[(2)]);
var state_97503__$1 = state_97503;
var statearr_97517_97537 = state_97503__$1;
(statearr_97517_97537[(2)] = inst_97497);

(statearr_97517_97537[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97504 === (10))){
var state_97503__$1 = state_97503;
var statearr_97518_97538 = state_97503__$1;
(statearr_97518_97538[(2)] = fc);

(statearr_97518_97538[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97504 === (8))){
var inst_97492 = (state_97503[(2)]);
var state_97503__$1 = state_97503;
if(cljs.core.truth_(inst_97492)){
var statearr_97519_97539 = state_97503__$1;
(statearr_97519_97539[(1)] = (12));

} else {
var statearr_97520_97540 = state_97503__$1;
(statearr_97520_97540[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___97526,tc,fc))
;
return ((function (switch__96981__auto__,c__97076__auto___97526,tc,fc){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_97521 = [null,null,null,null,null,null,null,null,null];
(statearr_97521[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_97521[(1)] = (1));

return statearr_97521;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_97503){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97503);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97522){if((e97522 instanceof Object)){
var ex__96985__auto__ = e97522;
var statearr_97523_97541 = state_97503;
(statearr_97523_97541[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97503);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97522;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97542 = state_97503;
state_97503 = G__97542;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_97503){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_97503);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___97526,tc,fc))
})();
var state__97078__auto__ = (function (){var statearr_97524 = f__97077__auto__.call(null);
(statearr_97524[(6)] = c__97076__auto___97526);

return statearr_97524;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___97526,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__97076__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto__){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto__){
return (function (state_97563){
var state_val_97564 = (state_97563[(1)]);
if((state_val_97564 === (7))){
var inst_97559 = (state_97563[(2)]);
var state_97563__$1 = state_97563;
var statearr_97565_97583 = state_97563__$1;
(statearr_97565_97583[(2)] = inst_97559);

(statearr_97565_97583[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97564 === (1))){
var inst_97543 = init;
var state_97563__$1 = (function (){var statearr_97566 = state_97563;
(statearr_97566[(7)] = inst_97543);

return statearr_97566;
})();
var statearr_97567_97584 = state_97563__$1;
(statearr_97567_97584[(2)] = null);

(statearr_97567_97584[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97564 === (4))){
var inst_97546 = (state_97563[(8)]);
var inst_97546__$1 = (state_97563[(2)]);
var inst_97547 = (inst_97546__$1 == null);
var state_97563__$1 = (function (){var statearr_97568 = state_97563;
(statearr_97568[(8)] = inst_97546__$1);

return statearr_97568;
})();
if(cljs.core.truth_(inst_97547)){
var statearr_97569_97585 = state_97563__$1;
(statearr_97569_97585[(1)] = (5));

} else {
var statearr_97570_97586 = state_97563__$1;
(statearr_97570_97586[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97564 === (6))){
var inst_97550 = (state_97563[(9)]);
var inst_97546 = (state_97563[(8)]);
var inst_97543 = (state_97563[(7)]);
var inst_97550__$1 = f.call(null,inst_97543,inst_97546);
var inst_97551 = cljs.core.reduced_QMARK_.call(null,inst_97550__$1);
var state_97563__$1 = (function (){var statearr_97571 = state_97563;
(statearr_97571[(9)] = inst_97550__$1);

return statearr_97571;
})();
if(inst_97551){
var statearr_97572_97587 = state_97563__$1;
(statearr_97572_97587[(1)] = (8));

} else {
var statearr_97573_97588 = state_97563__$1;
(statearr_97573_97588[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97564 === (3))){
var inst_97561 = (state_97563[(2)]);
var state_97563__$1 = state_97563;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97563__$1,inst_97561);
} else {
if((state_val_97564 === (2))){
var state_97563__$1 = state_97563;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97563__$1,(4),ch);
} else {
if((state_val_97564 === (9))){
var inst_97550 = (state_97563[(9)]);
var inst_97543 = inst_97550;
var state_97563__$1 = (function (){var statearr_97574 = state_97563;
(statearr_97574[(7)] = inst_97543);

return statearr_97574;
})();
var statearr_97575_97589 = state_97563__$1;
(statearr_97575_97589[(2)] = null);

(statearr_97575_97589[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97564 === (5))){
var inst_97543 = (state_97563[(7)]);
var state_97563__$1 = state_97563;
var statearr_97576_97590 = state_97563__$1;
(statearr_97576_97590[(2)] = inst_97543);

(statearr_97576_97590[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97564 === (10))){
var inst_97557 = (state_97563[(2)]);
var state_97563__$1 = state_97563;
var statearr_97577_97591 = state_97563__$1;
(statearr_97577_97591[(2)] = inst_97557);

(statearr_97577_97591[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97564 === (8))){
var inst_97550 = (state_97563[(9)]);
var inst_97553 = cljs.core.deref.call(null,inst_97550);
var state_97563__$1 = state_97563;
var statearr_97578_97592 = state_97563__$1;
(statearr_97578_97592[(2)] = inst_97553);

(statearr_97578_97592[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto__))
;
return ((function (switch__96981__auto__,c__97076__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__96982__auto__ = null;
var cljs$core$async$reduce_$_state_machine__96982__auto____0 = (function (){
var statearr_97579 = [null,null,null,null,null,null,null,null,null,null];
(statearr_97579[(0)] = cljs$core$async$reduce_$_state_machine__96982__auto__);

(statearr_97579[(1)] = (1));

return statearr_97579;
});
var cljs$core$async$reduce_$_state_machine__96982__auto____1 = (function (state_97563){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97563);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97580){if((e97580 instanceof Object)){
var ex__96985__auto__ = e97580;
var statearr_97581_97593 = state_97563;
(statearr_97581_97593[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97563);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97580;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97594 = state_97563;
state_97563 = G__97594;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__96982__auto__ = function(state_97563){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__96982__auto____1.call(this,state_97563);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$reduce_$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__96982__auto____0;
cljs$core$async$reduce_$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__96982__auto____1;
return cljs$core$async$reduce_$_state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto__))
})();
var state__97078__auto__ = (function (){var statearr_97582 = f__97077__auto__.call(null);
(statearr_97582[(6)] = c__97076__auto__);

return statearr_97582;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto__))
);

return c__97076__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = xform.call(null,f);
var c__97076__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto__,f__$1){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto__,f__$1){
return (function (state_97600){
var state_val_97601 = (state_97600[(1)]);
if((state_val_97601 === (1))){
var inst_97595 = cljs.core.async.reduce.call(null,f__$1,init,ch);
var state_97600__$1 = state_97600;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97600__$1,(2),inst_97595);
} else {
if((state_val_97601 === (2))){
var inst_97597 = (state_97600[(2)]);
var inst_97598 = f__$1.call(null,inst_97597);
var state_97600__$1 = state_97600;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97600__$1,inst_97598);
} else {
return null;
}
}
});})(c__97076__auto__,f__$1))
;
return ((function (switch__96981__auto__,c__97076__auto__,f__$1){
return (function() {
var cljs$core$async$transduce_$_state_machine__96982__auto__ = null;
var cljs$core$async$transduce_$_state_machine__96982__auto____0 = (function (){
var statearr_97602 = [null,null,null,null,null,null,null];
(statearr_97602[(0)] = cljs$core$async$transduce_$_state_machine__96982__auto__);

(statearr_97602[(1)] = (1));

return statearr_97602;
});
var cljs$core$async$transduce_$_state_machine__96982__auto____1 = (function (state_97600){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97600);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97603){if((e97603 instanceof Object)){
var ex__96985__auto__ = e97603;
var statearr_97604_97606 = state_97600;
(statearr_97604_97606[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97600);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97603;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97607 = state_97600;
state_97600 = G__97607;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__96982__auto__ = function(state_97600){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__96982__auto____1.call(this,state_97600);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$transduce_$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__96982__auto____0;
cljs$core$async$transduce_$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__96982__auto____1;
return cljs$core$async$transduce_$_state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto__,f__$1))
})();
var state__97078__auto__ = (function (){var statearr_97605 = f__97077__auto__.call(null);
(statearr_97605[(6)] = c__97076__auto__);

return statearr_97605;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto__,f__$1))
);

return c__97076__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var G__97609 = arguments.length;
switch (G__97609) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__97076__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto__){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto__){
return (function (state_97634){
var state_val_97635 = (state_97634[(1)]);
if((state_val_97635 === (7))){
var inst_97616 = (state_97634[(2)]);
var state_97634__$1 = state_97634;
var statearr_97636_97657 = state_97634__$1;
(statearr_97636_97657[(2)] = inst_97616);

(statearr_97636_97657[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97635 === (1))){
var inst_97610 = cljs.core.seq.call(null,coll);
var inst_97611 = inst_97610;
var state_97634__$1 = (function (){var statearr_97637 = state_97634;
(statearr_97637[(7)] = inst_97611);

return statearr_97637;
})();
var statearr_97638_97658 = state_97634__$1;
(statearr_97638_97658[(2)] = null);

(statearr_97638_97658[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97635 === (4))){
var inst_97611 = (state_97634[(7)]);
var inst_97614 = cljs.core.first.call(null,inst_97611);
var state_97634__$1 = state_97634;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_97634__$1,(7),ch,inst_97614);
} else {
if((state_val_97635 === (13))){
var inst_97628 = (state_97634[(2)]);
var state_97634__$1 = state_97634;
var statearr_97639_97659 = state_97634__$1;
(statearr_97639_97659[(2)] = inst_97628);

(statearr_97639_97659[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97635 === (6))){
var inst_97619 = (state_97634[(2)]);
var state_97634__$1 = state_97634;
if(cljs.core.truth_(inst_97619)){
var statearr_97640_97660 = state_97634__$1;
(statearr_97640_97660[(1)] = (8));

} else {
var statearr_97641_97661 = state_97634__$1;
(statearr_97641_97661[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97635 === (3))){
var inst_97632 = (state_97634[(2)]);
var state_97634__$1 = state_97634;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97634__$1,inst_97632);
} else {
if((state_val_97635 === (12))){
var state_97634__$1 = state_97634;
var statearr_97642_97662 = state_97634__$1;
(statearr_97642_97662[(2)] = null);

(statearr_97642_97662[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97635 === (2))){
var inst_97611 = (state_97634[(7)]);
var state_97634__$1 = state_97634;
if(cljs.core.truth_(inst_97611)){
var statearr_97643_97663 = state_97634__$1;
(statearr_97643_97663[(1)] = (4));

} else {
var statearr_97644_97664 = state_97634__$1;
(statearr_97644_97664[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97635 === (11))){
var inst_97625 = cljs.core.async.close_BANG_.call(null,ch);
var state_97634__$1 = state_97634;
var statearr_97645_97665 = state_97634__$1;
(statearr_97645_97665[(2)] = inst_97625);

(statearr_97645_97665[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97635 === (9))){
var state_97634__$1 = state_97634;
if(cljs.core.truth_(close_QMARK_)){
var statearr_97646_97666 = state_97634__$1;
(statearr_97646_97666[(1)] = (11));

} else {
var statearr_97647_97667 = state_97634__$1;
(statearr_97647_97667[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97635 === (5))){
var inst_97611 = (state_97634[(7)]);
var state_97634__$1 = state_97634;
var statearr_97648_97668 = state_97634__$1;
(statearr_97648_97668[(2)] = inst_97611);

(statearr_97648_97668[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97635 === (10))){
var inst_97630 = (state_97634[(2)]);
var state_97634__$1 = state_97634;
var statearr_97649_97669 = state_97634__$1;
(statearr_97649_97669[(2)] = inst_97630);

(statearr_97649_97669[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97635 === (8))){
var inst_97611 = (state_97634[(7)]);
var inst_97621 = cljs.core.next.call(null,inst_97611);
var inst_97611__$1 = inst_97621;
var state_97634__$1 = (function (){var statearr_97650 = state_97634;
(statearr_97650[(7)] = inst_97611__$1);

return statearr_97650;
})();
var statearr_97651_97670 = state_97634__$1;
(statearr_97651_97670[(2)] = null);

(statearr_97651_97670[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto__))
;
return ((function (switch__96981__auto__,c__97076__auto__){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_97652 = [null,null,null,null,null,null,null,null];
(statearr_97652[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_97652[(1)] = (1));

return statearr_97652;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_97634){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97634);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97653){if((e97653 instanceof Object)){
var ex__96985__auto__ = e97653;
var statearr_97654_97671 = state_97634;
(statearr_97654_97671[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97634);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97653;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97672 = state_97634;
state_97634 = G__97672;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_97634){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_97634);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto__))
})();
var state__97078__auto__ = (function (){var statearr_97655 = f__97077__auto__.call(null);
(statearr_97655[(6)] = c__97076__auto__);

return statearr_97655;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto__))
);

return c__97076__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if((((!((_ == null)))) && ((!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null)))))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__4433__auto__ = (((_ == null))?null:_);
var m__4434__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,_);
} else {
var m__4431__auto__ = (cljs.core.async.muxch_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null)))))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__4431__auto__ = (cljs.core.async.tap_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,m,ch);
} else {
var m__4431__auto__ = (cljs.core.async.untap_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,m);
} else {
var m__4431__auto__ = (cljs.core.async.untap_all_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async97673 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async97673 = (function (ch,cs,meta97674){
this.ch = ch;
this.cs = cs;
this.meta97674 = meta97674;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async97673.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_97675,meta97674__$1){
var self__ = this;
var _97675__$1 = this;
return (new cljs.core.async.t_cljs$core$async97673(self__.ch,self__.cs,meta97674__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async97673.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_97675){
var self__ = this;
var _97675__$1 = this;
return self__.meta97674;
});})(cs))
;

cljs.core.async.t_cljs$core$async97673.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async97673.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async97673.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async97673.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async97673.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async97673.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async97673.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta97674","meta97674",-2143542715,null)], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async97673.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async97673.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async97673";

cljs.core.async.t_cljs$core$async97673.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"cljs.core.async/t_cljs$core$async97673");
});})(cs))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async97673.
 */
cljs.core.async.__GT_t_cljs$core$async97673 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async97673(ch__$1,cs__$1,meta97674){
return (new cljs.core.async.t_cljs$core$async97673(ch__$1,cs__$1,meta97674));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async97673(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__97076__auto___97895 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___97895,cs,m,dchan,dctr,done){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___97895,cs,m,dchan,dctr,done){
return (function (state_97810){
var state_val_97811 = (state_97810[(1)]);
if((state_val_97811 === (7))){
var inst_97806 = (state_97810[(2)]);
var state_97810__$1 = state_97810;
var statearr_97812_97896 = state_97810__$1;
(statearr_97812_97896[(2)] = inst_97806);

(statearr_97812_97896[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (20))){
var inst_97709 = (state_97810[(7)]);
var inst_97721 = cljs.core.first.call(null,inst_97709);
var inst_97722 = cljs.core.nth.call(null,inst_97721,(0),null);
var inst_97723 = cljs.core.nth.call(null,inst_97721,(1),null);
var state_97810__$1 = (function (){var statearr_97813 = state_97810;
(statearr_97813[(8)] = inst_97722);

return statearr_97813;
})();
if(cljs.core.truth_(inst_97723)){
var statearr_97814_97897 = state_97810__$1;
(statearr_97814_97897[(1)] = (22));

} else {
var statearr_97815_97898 = state_97810__$1;
(statearr_97815_97898[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (27))){
var inst_97753 = (state_97810[(9)]);
var inst_97678 = (state_97810[(10)]);
var inst_97758 = (state_97810[(11)]);
var inst_97751 = (state_97810[(12)]);
var inst_97758__$1 = cljs.core._nth.call(null,inst_97751,inst_97753);
var inst_97759 = cljs.core.async.put_BANG_.call(null,inst_97758__$1,inst_97678,done);
var state_97810__$1 = (function (){var statearr_97816 = state_97810;
(statearr_97816[(11)] = inst_97758__$1);

return statearr_97816;
})();
if(cljs.core.truth_(inst_97759)){
var statearr_97817_97899 = state_97810__$1;
(statearr_97817_97899[(1)] = (30));

} else {
var statearr_97818_97900 = state_97810__$1;
(statearr_97818_97900[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (1))){
var state_97810__$1 = state_97810;
var statearr_97819_97901 = state_97810__$1;
(statearr_97819_97901[(2)] = null);

(statearr_97819_97901[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (24))){
var inst_97709 = (state_97810[(7)]);
var inst_97728 = (state_97810[(2)]);
var inst_97729 = cljs.core.next.call(null,inst_97709);
var inst_97687 = inst_97729;
var inst_97688 = null;
var inst_97689 = (0);
var inst_97690 = (0);
var state_97810__$1 = (function (){var statearr_97820 = state_97810;
(statearr_97820[(13)] = inst_97688);

(statearr_97820[(14)] = inst_97690);

(statearr_97820[(15)] = inst_97689);

(statearr_97820[(16)] = inst_97687);

(statearr_97820[(17)] = inst_97728);

return statearr_97820;
})();
var statearr_97821_97902 = state_97810__$1;
(statearr_97821_97902[(2)] = null);

(statearr_97821_97902[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (39))){
var state_97810__$1 = state_97810;
var statearr_97825_97903 = state_97810__$1;
(statearr_97825_97903[(2)] = null);

(statearr_97825_97903[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (4))){
var inst_97678 = (state_97810[(10)]);
var inst_97678__$1 = (state_97810[(2)]);
var inst_97679 = (inst_97678__$1 == null);
var state_97810__$1 = (function (){var statearr_97826 = state_97810;
(statearr_97826[(10)] = inst_97678__$1);

return statearr_97826;
})();
if(cljs.core.truth_(inst_97679)){
var statearr_97827_97904 = state_97810__$1;
(statearr_97827_97904[(1)] = (5));

} else {
var statearr_97828_97905 = state_97810__$1;
(statearr_97828_97905[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (15))){
var inst_97688 = (state_97810[(13)]);
var inst_97690 = (state_97810[(14)]);
var inst_97689 = (state_97810[(15)]);
var inst_97687 = (state_97810[(16)]);
var inst_97705 = (state_97810[(2)]);
var inst_97706 = (inst_97690 + (1));
var tmp97822 = inst_97688;
var tmp97823 = inst_97689;
var tmp97824 = inst_97687;
var inst_97687__$1 = tmp97824;
var inst_97688__$1 = tmp97822;
var inst_97689__$1 = tmp97823;
var inst_97690__$1 = inst_97706;
var state_97810__$1 = (function (){var statearr_97829 = state_97810;
(statearr_97829[(13)] = inst_97688__$1);

(statearr_97829[(14)] = inst_97690__$1);

(statearr_97829[(15)] = inst_97689__$1);

(statearr_97829[(16)] = inst_97687__$1);

(statearr_97829[(18)] = inst_97705);

return statearr_97829;
})();
var statearr_97830_97906 = state_97810__$1;
(statearr_97830_97906[(2)] = null);

(statearr_97830_97906[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (21))){
var inst_97732 = (state_97810[(2)]);
var state_97810__$1 = state_97810;
var statearr_97834_97907 = state_97810__$1;
(statearr_97834_97907[(2)] = inst_97732);

(statearr_97834_97907[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (31))){
var inst_97758 = (state_97810[(11)]);
var inst_97762 = done.call(null,null);
var inst_97763 = cljs.core.async.untap_STAR_.call(null,m,inst_97758);
var state_97810__$1 = (function (){var statearr_97835 = state_97810;
(statearr_97835[(19)] = inst_97762);

return statearr_97835;
})();
var statearr_97836_97908 = state_97810__$1;
(statearr_97836_97908[(2)] = inst_97763);

(statearr_97836_97908[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (32))){
var inst_97753 = (state_97810[(9)]);
var inst_97752 = (state_97810[(20)]);
var inst_97751 = (state_97810[(12)]);
var inst_97750 = (state_97810[(21)]);
var inst_97765 = (state_97810[(2)]);
var inst_97766 = (inst_97753 + (1));
var tmp97831 = inst_97752;
var tmp97832 = inst_97751;
var tmp97833 = inst_97750;
var inst_97750__$1 = tmp97833;
var inst_97751__$1 = tmp97832;
var inst_97752__$1 = tmp97831;
var inst_97753__$1 = inst_97766;
var state_97810__$1 = (function (){var statearr_97837 = state_97810;
(statearr_97837[(9)] = inst_97753__$1);

(statearr_97837[(20)] = inst_97752__$1);

(statearr_97837[(12)] = inst_97751__$1);

(statearr_97837[(21)] = inst_97750__$1);

(statearr_97837[(22)] = inst_97765);

return statearr_97837;
})();
var statearr_97838_97909 = state_97810__$1;
(statearr_97838_97909[(2)] = null);

(statearr_97838_97909[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (40))){
var inst_97778 = (state_97810[(23)]);
var inst_97782 = done.call(null,null);
var inst_97783 = cljs.core.async.untap_STAR_.call(null,m,inst_97778);
var state_97810__$1 = (function (){var statearr_97839 = state_97810;
(statearr_97839[(24)] = inst_97782);

return statearr_97839;
})();
var statearr_97840_97910 = state_97810__$1;
(statearr_97840_97910[(2)] = inst_97783);

(statearr_97840_97910[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (33))){
var inst_97769 = (state_97810[(25)]);
var inst_97771 = cljs.core.chunked_seq_QMARK_.call(null,inst_97769);
var state_97810__$1 = state_97810;
if(inst_97771){
var statearr_97841_97911 = state_97810__$1;
(statearr_97841_97911[(1)] = (36));

} else {
var statearr_97842_97912 = state_97810__$1;
(statearr_97842_97912[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (13))){
var inst_97699 = (state_97810[(26)]);
var inst_97702 = cljs.core.async.close_BANG_.call(null,inst_97699);
var state_97810__$1 = state_97810;
var statearr_97843_97913 = state_97810__$1;
(statearr_97843_97913[(2)] = inst_97702);

(statearr_97843_97913[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (22))){
var inst_97722 = (state_97810[(8)]);
var inst_97725 = cljs.core.async.close_BANG_.call(null,inst_97722);
var state_97810__$1 = state_97810;
var statearr_97844_97914 = state_97810__$1;
(statearr_97844_97914[(2)] = inst_97725);

(statearr_97844_97914[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (36))){
var inst_97769 = (state_97810[(25)]);
var inst_97773 = cljs.core.chunk_first.call(null,inst_97769);
var inst_97774 = cljs.core.chunk_rest.call(null,inst_97769);
var inst_97775 = cljs.core.count.call(null,inst_97773);
var inst_97750 = inst_97774;
var inst_97751 = inst_97773;
var inst_97752 = inst_97775;
var inst_97753 = (0);
var state_97810__$1 = (function (){var statearr_97845 = state_97810;
(statearr_97845[(9)] = inst_97753);

(statearr_97845[(20)] = inst_97752);

(statearr_97845[(12)] = inst_97751);

(statearr_97845[(21)] = inst_97750);

return statearr_97845;
})();
var statearr_97846_97915 = state_97810__$1;
(statearr_97846_97915[(2)] = null);

(statearr_97846_97915[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (41))){
var inst_97769 = (state_97810[(25)]);
var inst_97785 = (state_97810[(2)]);
var inst_97786 = cljs.core.next.call(null,inst_97769);
var inst_97750 = inst_97786;
var inst_97751 = null;
var inst_97752 = (0);
var inst_97753 = (0);
var state_97810__$1 = (function (){var statearr_97847 = state_97810;
(statearr_97847[(9)] = inst_97753);

(statearr_97847[(20)] = inst_97752);

(statearr_97847[(12)] = inst_97751);

(statearr_97847[(27)] = inst_97785);

(statearr_97847[(21)] = inst_97750);

return statearr_97847;
})();
var statearr_97848_97916 = state_97810__$1;
(statearr_97848_97916[(2)] = null);

(statearr_97848_97916[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (43))){
var state_97810__$1 = state_97810;
var statearr_97849_97917 = state_97810__$1;
(statearr_97849_97917[(2)] = null);

(statearr_97849_97917[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (29))){
var inst_97794 = (state_97810[(2)]);
var state_97810__$1 = state_97810;
var statearr_97850_97918 = state_97810__$1;
(statearr_97850_97918[(2)] = inst_97794);

(statearr_97850_97918[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (44))){
var inst_97803 = (state_97810[(2)]);
var state_97810__$1 = (function (){var statearr_97851 = state_97810;
(statearr_97851[(28)] = inst_97803);

return statearr_97851;
})();
var statearr_97852_97919 = state_97810__$1;
(statearr_97852_97919[(2)] = null);

(statearr_97852_97919[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (6))){
var inst_97742 = (state_97810[(29)]);
var inst_97741 = cljs.core.deref.call(null,cs);
var inst_97742__$1 = cljs.core.keys.call(null,inst_97741);
var inst_97743 = cljs.core.count.call(null,inst_97742__$1);
var inst_97744 = cljs.core.reset_BANG_.call(null,dctr,inst_97743);
var inst_97749 = cljs.core.seq.call(null,inst_97742__$1);
var inst_97750 = inst_97749;
var inst_97751 = null;
var inst_97752 = (0);
var inst_97753 = (0);
var state_97810__$1 = (function (){var statearr_97853 = state_97810;
(statearr_97853[(9)] = inst_97753);

(statearr_97853[(20)] = inst_97752);

(statearr_97853[(29)] = inst_97742__$1);

(statearr_97853[(30)] = inst_97744);

(statearr_97853[(12)] = inst_97751);

(statearr_97853[(21)] = inst_97750);

return statearr_97853;
})();
var statearr_97854_97920 = state_97810__$1;
(statearr_97854_97920[(2)] = null);

(statearr_97854_97920[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (28))){
var inst_97769 = (state_97810[(25)]);
var inst_97750 = (state_97810[(21)]);
var inst_97769__$1 = cljs.core.seq.call(null,inst_97750);
var state_97810__$1 = (function (){var statearr_97855 = state_97810;
(statearr_97855[(25)] = inst_97769__$1);

return statearr_97855;
})();
if(inst_97769__$1){
var statearr_97856_97921 = state_97810__$1;
(statearr_97856_97921[(1)] = (33));

} else {
var statearr_97857_97922 = state_97810__$1;
(statearr_97857_97922[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (25))){
var inst_97753 = (state_97810[(9)]);
var inst_97752 = (state_97810[(20)]);
var inst_97755 = (inst_97753 < inst_97752);
var inst_97756 = inst_97755;
var state_97810__$1 = state_97810;
if(cljs.core.truth_(inst_97756)){
var statearr_97858_97923 = state_97810__$1;
(statearr_97858_97923[(1)] = (27));

} else {
var statearr_97859_97924 = state_97810__$1;
(statearr_97859_97924[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (34))){
var state_97810__$1 = state_97810;
var statearr_97860_97925 = state_97810__$1;
(statearr_97860_97925[(2)] = null);

(statearr_97860_97925[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (17))){
var state_97810__$1 = state_97810;
var statearr_97861_97926 = state_97810__$1;
(statearr_97861_97926[(2)] = null);

(statearr_97861_97926[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (3))){
var inst_97808 = (state_97810[(2)]);
var state_97810__$1 = state_97810;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_97810__$1,inst_97808);
} else {
if((state_val_97811 === (12))){
var inst_97737 = (state_97810[(2)]);
var state_97810__$1 = state_97810;
var statearr_97862_97927 = state_97810__$1;
(statearr_97862_97927[(2)] = inst_97737);

(statearr_97862_97927[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (2))){
var state_97810__$1 = state_97810;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97810__$1,(4),ch);
} else {
if((state_val_97811 === (23))){
var state_97810__$1 = state_97810;
var statearr_97863_97928 = state_97810__$1;
(statearr_97863_97928[(2)] = null);

(statearr_97863_97928[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (35))){
var inst_97792 = (state_97810[(2)]);
var state_97810__$1 = state_97810;
var statearr_97864_97929 = state_97810__$1;
(statearr_97864_97929[(2)] = inst_97792);

(statearr_97864_97929[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (19))){
var inst_97709 = (state_97810[(7)]);
var inst_97713 = cljs.core.chunk_first.call(null,inst_97709);
var inst_97714 = cljs.core.chunk_rest.call(null,inst_97709);
var inst_97715 = cljs.core.count.call(null,inst_97713);
var inst_97687 = inst_97714;
var inst_97688 = inst_97713;
var inst_97689 = inst_97715;
var inst_97690 = (0);
var state_97810__$1 = (function (){var statearr_97865 = state_97810;
(statearr_97865[(13)] = inst_97688);

(statearr_97865[(14)] = inst_97690);

(statearr_97865[(15)] = inst_97689);

(statearr_97865[(16)] = inst_97687);

return statearr_97865;
})();
var statearr_97866_97930 = state_97810__$1;
(statearr_97866_97930[(2)] = null);

(statearr_97866_97930[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (11))){
var inst_97709 = (state_97810[(7)]);
var inst_97687 = (state_97810[(16)]);
var inst_97709__$1 = cljs.core.seq.call(null,inst_97687);
var state_97810__$1 = (function (){var statearr_97867 = state_97810;
(statearr_97867[(7)] = inst_97709__$1);

return statearr_97867;
})();
if(inst_97709__$1){
var statearr_97868_97931 = state_97810__$1;
(statearr_97868_97931[(1)] = (16));

} else {
var statearr_97869_97932 = state_97810__$1;
(statearr_97869_97932[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (9))){
var inst_97739 = (state_97810[(2)]);
var state_97810__$1 = state_97810;
var statearr_97870_97933 = state_97810__$1;
(statearr_97870_97933[(2)] = inst_97739);

(statearr_97870_97933[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (5))){
var inst_97685 = cljs.core.deref.call(null,cs);
var inst_97686 = cljs.core.seq.call(null,inst_97685);
var inst_97687 = inst_97686;
var inst_97688 = null;
var inst_97689 = (0);
var inst_97690 = (0);
var state_97810__$1 = (function (){var statearr_97871 = state_97810;
(statearr_97871[(13)] = inst_97688);

(statearr_97871[(14)] = inst_97690);

(statearr_97871[(15)] = inst_97689);

(statearr_97871[(16)] = inst_97687);

return statearr_97871;
})();
var statearr_97872_97934 = state_97810__$1;
(statearr_97872_97934[(2)] = null);

(statearr_97872_97934[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (14))){
var state_97810__$1 = state_97810;
var statearr_97873_97935 = state_97810__$1;
(statearr_97873_97935[(2)] = null);

(statearr_97873_97935[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (45))){
var inst_97800 = (state_97810[(2)]);
var state_97810__$1 = state_97810;
var statearr_97874_97936 = state_97810__$1;
(statearr_97874_97936[(2)] = inst_97800);

(statearr_97874_97936[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (26))){
var inst_97742 = (state_97810[(29)]);
var inst_97796 = (state_97810[(2)]);
var inst_97797 = cljs.core.seq.call(null,inst_97742);
var state_97810__$1 = (function (){var statearr_97875 = state_97810;
(statearr_97875[(31)] = inst_97796);

return statearr_97875;
})();
if(inst_97797){
var statearr_97876_97937 = state_97810__$1;
(statearr_97876_97937[(1)] = (42));

} else {
var statearr_97877_97938 = state_97810__$1;
(statearr_97877_97938[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (16))){
var inst_97709 = (state_97810[(7)]);
var inst_97711 = cljs.core.chunked_seq_QMARK_.call(null,inst_97709);
var state_97810__$1 = state_97810;
if(inst_97711){
var statearr_97878_97939 = state_97810__$1;
(statearr_97878_97939[(1)] = (19));

} else {
var statearr_97879_97940 = state_97810__$1;
(statearr_97879_97940[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (38))){
var inst_97789 = (state_97810[(2)]);
var state_97810__$1 = state_97810;
var statearr_97880_97941 = state_97810__$1;
(statearr_97880_97941[(2)] = inst_97789);

(statearr_97880_97941[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (30))){
var state_97810__$1 = state_97810;
var statearr_97881_97942 = state_97810__$1;
(statearr_97881_97942[(2)] = null);

(statearr_97881_97942[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (10))){
var inst_97688 = (state_97810[(13)]);
var inst_97690 = (state_97810[(14)]);
var inst_97698 = cljs.core._nth.call(null,inst_97688,inst_97690);
var inst_97699 = cljs.core.nth.call(null,inst_97698,(0),null);
var inst_97700 = cljs.core.nth.call(null,inst_97698,(1),null);
var state_97810__$1 = (function (){var statearr_97882 = state_97810;
(statearr_97882[(26)] = inst_97699);

return statearr_97882;
})();
if(cljs.core.truth_(inst_97700)){
var statearr_97883_97943 = state_97810__$1;
(statearr_97883_97943[(1)] = (13));

} else {
var statearr_97884_97944 = state_97810__$1;
(statearr_97884_97944[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (18))){
var inst_97735 = (state_97810[(2)]);
var state_97810__$1 = state_97810;
var statearr_97885_97945 = state_97810__$1;
(statearr_97885_97945[(2)] = inst_97735);

(statearr_97885_97945[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (42))){
var state_97810__$1 = state_97810;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_97810__$1,(45),dchan);
} else {
if((state_val_97811 === (37))){
var inst_97778 = (state_97810[(23)]);
var inst_97769 = (state_97810[(25)]);
var inst_97678 = (state_97810[(10)]);
var inst_97778__$1 = cljs.core.first.call(null,inst_97769);
var inst_97779 = cljs.core.async.put_BANG_.call(null,inst_97778__$1,inst_97678,done);
var state_97810__$1 = (function (){var statearr_97886 = state_97810;
(statearr_97886[(23)] = inst_97778__$1);

return statearr_97886;
})();
if(cljs.core.truth_(inst_97779)){
var statearr_97887_97946 = state_97810__$1;
(statearr_97887_97946[(1)] = (39));

} else {
var statearr_97888_97947 = state_97810__$1;
(statearr_97888_97947[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_97811 === (8))){
var inst_97690 = (state_97810[(14)]);
var inst_97689 = (state_97810[(15)]);
var inst_97692 = (inst_97690 < inst_97689);
var inst_97693 = inst_97692;
var state_97810__$1 = state_97810;
if(cljs.core.truth_(inst_97693)){
var statearr_97889_97948 = state_97810__$1;
(statearr_97889_97948[(1)] = (10));

} else {
var statearr_97890_97949 = state_97810__$1;
(statearr_97890_97949[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___97895,cs,m,dchan,dctr,done))
;
return ((function (switch__96981__auto__,c__97076__auto___97895,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__96982__auto__ = null;
var cljs$core$async$mult_$_state_machine__96982__auto____0 = (function (){
var statearr_97891 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_97891[(0)] = cljs$core$async$mult_$_state_machine__96982__auto__);

(statearr_97891[(1)] = (1));

return statearr_97891;
});
var cljs$core$async$mult_$_state_machine__96982__auto____1 = (function (state_97810){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_97810);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e97892){if((e97892 instanceof Object)){
var ex__96985__auto__ = e97892;
var statearr_97893_97950 = state_97810;
(statearr_97893_97950[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_97810);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e97892;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__97951 = state_97810;
state_97810 = G__97951;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__96982__auto__ = function(state_97810){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__96982__auto____1.call(this,state_97810);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mult_$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__96982__auto____0;
cljs$core$async$mult_$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__96982__auto____1;
return cljs$core$async$mult_$_state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___97895,cs,m,dchan,dctr,done))
})();
var state__97078__auto__ = (function (){var statearr_97894 = f__97077__auto__.call(null);
(statearr_97894[(6)] = c__97076__auto___97895);

return statearr_97894;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___97895,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var G__97953 = arguments.length;
switch (G__97953) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,m,ch);
} else {
var m__4431__auto__ = (cljs.core.async.admix_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,m,ch);
} else {
var m__4431__auto__ = (cljs.core.async.unmix_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null)))))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,m);
} else {
var m__4431__auto__ = (cljs.core.async.unmix_all_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,m,state_map);
} else {
var m__4431__auto__ = (cljs.core.async.toggle_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if((((!((m == null)))) && ((!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null)))))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__4433__auto__ = (((m == null))?null:m);
var m__4434__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,m,mode);
} else {
var m__4431__auto__ = (cljs.core.async.solo_mode_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__4736__auto__ = [];
var len__4730__auto___97965 = arguments.length;
var i__4731__auto___97966 = (0);
while(true){
if((i__4731__auto___97966 < len__4730__auto___97965)){
args__4736__auto__.push((arguments[i__4731__auto___97966]));

var G__97967 = (i__4731__auto___97966 + (1));
i__4731__auto___97966 = G__97967;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((3) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4737__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__97959){
var map__97960 = p__97959;
var map__97960__$1 = (((((!((map__97960 == null))))?(((((map__97960.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__97960.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__97960):map__97960);
var opts = map__97960__$1;
var statearr_97962_97968 = state;
(statearr_97962_97968[(1)] = cont_block);


var temp__5735__auto__ = cljs.core.async.do_alts.call(null,((function (map__97960,map__97960__$1,opts){
return (function (val){
var statearr_97963_97969 = state;
(statearr_97963_97969[(2)] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__97960,map__97960__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__5735__auto__)){
var cb = temp__5735__auto__;
var statearr_97964_97970 = state;
(statearr_97964_97970[(2)] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

/** @this {Function} */
cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq97955){
var G__97956 = cljs.core.first.call(null,seq97955);
var seq97955__$1 = cljs.core.next.call(null,seq97955);
var G__97957 = cljs.core.first.call(null,seq97955__$1);
var seq97955__$2 = cljs.core.next.call(null,seq97955__$1);
var G__97958 = cljs.core.first.call(null,seq97955__$2);
var seq97955__$3 = cljs.core.next.call(null,seq97955__$2);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__97956,G__97957,G__97958,seq97955__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,((((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && ((!(cljs.core.empty_QMARK_.call(null,solos))))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async97971 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async97971 = (function (change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,meta97972){
this.change = change;
this.solo_mode = solo_mode;
this.pick = pick;
this.cs = cs;
this.calc_state = calc_state;
this.out = out;
this.changed = changed;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.meta97972 = meta97972;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async97971.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_97973,meta97972__$1){
var self__ = this;
var _97973__$1 = this;
return (new cljs.core.async.t_cljs$core$async97971(self__.change,self__.solo_mode,self__.pick,self__.cs,self__.calc_state,self__.out,self__.changed,self__.solo_modes,self__.attrs,meta97972__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async97971.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_97973){
var self__ = this;
var _97973__$1 = this;
return self__.meta97972;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async97971.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async97971.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async97971.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async97971.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async97971.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async97971.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async97971.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async97971.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.solo_modes.call(null,mode))){
} else {
throw (new Error(["Assert failed: ",["mode must be one of: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.solo_modes)].join(''),"\n","(solo-modes mode)"].join('')));
}

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async97971.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"meta97972","meta97972",170820568,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async97971.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async97971.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async97971";

cljs.core.async.t_cljs$core$async97971.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"cljs.core.async/t_cljs$core$async97971");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async97971.
 */
cljs.core.async.__GT_t_cljs$core$async97971 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async97971(change__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta97972){
return (new cljs.core.async.t_cljs$core$async97971(change__$1,solo_mode__$1,pick__$1,cs__$1,calc_state__$1,out__$1,changed__$1,solo_modes__$1,attrs__$1,meta97972));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async97971(change,solo_mode,pick,cs,calc_state,out,changed,solo_modes,attrs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__97076__auto___98135 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___98135,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___98135,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_98075){
var state_val_98076 = (state_98075[(1)]);
if((state_val_98076 === (7))){
var inst_97990 = (state_98075[(2)]);
var state_98075__$1 = state_98075;
var statearr_98077_98136 = state_98075__$1;
(statearr_98077_98136[(2)] = inst_97990);

(statearr_98077_98136[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (20))){
var inst_98002 = (state_98075[(7)]);
var state_98075__$1 = state_98075;
var statearr_98078_98137 = state_98075__$1;
(statearr_98078_98137[(2)] = inst_98002);

(statearr_98078_98137[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (27))){
var state_98075__$1 = state_98075;
var statearr_98079_98138 = state_98075__$1;
(statearr_98079_98138[(2)] = null);

(statearr_98079_98138[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (1))){
var inst_97977 = (state_98075[(8)]);
var inst_97977__$1 = calc_state.call(null);
var inst_97979 = (inst_97977__$1 == null);
var inst_97980 = cljs.core.not.call(null,inst_97979);
var state_98075__$1 = (function (){var statearr_98080 = state_98075;
(statearr_98080[(8)] = inst_97977__$1);

return statearr_98080;
})();
if(inst_97980){
var statearr_98081_98139 = state_98075__$1;
(statearr_98081_98139[(1)] = (2));

} else {
var statearr_98082_98140 = state_98075__$1;
(statearr_98082_98140[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (24))){
var inst_98049 = (state_98075[(9)]);
var inst_98026 = (state_98075[(10)]);
var inst_98035 = (state_98075[(11)]);
var inst_98049__$1 = inst_98026.call(null,inst_98035);
var state_98075__$1 = (function (){var statearr_98083 = state_98075;
(statearr_98083[(9)] = inst_98049__$1);

return statearr_98083;
})();
if(cljs.core.truth_(inst_98049__$1)){
var statearr_98084_98141 = state_98075__$1;
(statearr_98084_98141[(1)] = (29));

} else {
var statearr_98085_98142 = state_98075__$1;
(statearr_98085_98142[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (4))){
var inst_97993 = (state_98075[(2)]);
var state_98075__$1 = state_98075;
if(cljs.core.truth_(inst_97993)){
var statearr_98086_98143 = state_98075__$1;
(statearr_98086_98143[(1)] = (8));

} else {
var statearr_98087_98144 = state_98075__$1;
(statearr_98087_98144[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (15))){
var inst_98020 = (state_98075[(2)]);
var state_98075__$1 = state_98075;
if(cljs.core.truth_(inst_98020)){
var statearr_98088_98145 = state_98075__$1;
(statearr_98088_98145[(1)] = (19));

} else {
var statearr_98089_98146 = state_98075__$1;
(statearr_98089_98146[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (21))){
var inst_98025 = (state_98075[(12)]);
var inst_98025__$1 = (state_98075[(2)]);
var inst_98026 = cljs.core.get.call(null,inst_98025__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_98027 = cljs.core.get.call(null,inst_98025__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_98028 = cljs.core.get.call(null,inst_98025__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_98075__$1 = (function (){var statearr_98090 = state_98075;
(statearr_98090[(13)] = inst_98027);

(statearr_98090[(10)] = inst_98026);

(statearr_98090[(12)] = inst_98025__$1);

return statearr_98090;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_98075__$1,(22),inst_98028);
} else {
if((state_val_98076 === (31))){
var inst_98057 = (state_98075[(2)]);
var state_98075__$1 = state_98075;
if(cljs.core.truth_(inst_98057)){
var statearr_98091_98147 = state_98075__$1;
(statearr_98091_98147[(1)] = (32));

} else {
var statearr_98092_98148 = state_98075__$1;
(statearr_98092_98148[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (32))){
var inst_98034 = (state_98075[(14)]);
var state_98075__$1 = state_98075;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98075__$1,(35),out,inst_98034);
} else {
if((state_val_98076 === (33))){
var inst_98025 = (state_98075[(12)]);
var inst_98002 = inst_98025;
var state_98075__$1 = (function (){var statearr_98093 = state_98075;
(statearr_98093[(7)] = inst_98002);

return statearr_98093;
})();
var statearr_98094_98149 = state_98075__$1;
(statearr_98094_98149[(2)] = null);

(statearr_98094_98149[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (13))){
var inst_98002 = (state_98075[(7)]);
var inst_98009 = inst_98002.cljs$lang$protocol_mask$partition0$;
var inst_98010 = (inst_98009 & (64));
var inst_98011 = inst_98002.cljs$core$ISeq$;
var inst_98012 = (cljs.core.PROTOCOL_SENTINEL === inst_98011);
var inst_98013 = ((inst_98010) || (inst_98012));
var state_98075__$1 = state_98075;
if(cljs.core.truth_(inst_98013)){
var statearr_98095_98150 = state_98075__$1;
(statearr_98095_98150[(1)] = (16));

} else {
var statearr_98096_98151 = state_98075__$1;
(statearr_98096_98151[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (22))){
var inst_98034 = (state_98075[(14)]);
var inst_98035 = (state_98075[(11)]);
var inst_98033 = (state_98075[(2)]);
var inst_98034__$1 = cljs.core.nth.call(null,inst_98033,(0),null);
var inst_98035__$1 = cljs.core.nth.call(null,inst_98033,(1),null);
var inst_98036 = (inst_98034__$1 == null);
var inst_98037 = cljs.core._EQ_.call(null,inst_98035__$1,change);
var inst_98038 = ((inst_98036) || (inst_98037));
var state_98075__$1 = (function (){var statearr_98097 = state_98075;
(statearr_98097[(14)] = inst_98034__$1);

(statearr_98097[(11)] = inst_98035__$1);

return statearr_98097;
})();
if(cljs.core.truth_(inst_98038)){
var statearr_98098_98152 = state_98075__$1;
(statearr_98098_98152[(1)] = (23));

} else {
var statearr_98099_98153 = state_98075__$1;
(statearr_98099_98153[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (36))){
var inst_98025 = (state_98075[(12)]);
var inst_98002 = inst_98025;
var state_98075__$1 = (function (){var statearr_98100 = state_98075;
(statearr_98100[(7)] = inst_98002);

return statearr_98100;
})();
var statearr_98101_98154 = state_98075__$1;
(statearr_98101_98154[(2)] = null);

(statearr_98101_98154[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (29))){
var inst_98049 = (state_98075[(9)]);
var state_98075__$1 = state_98075;
var statearr_98102_98155 = state_98075__$1;
(statearr_98102_98155[(2)] = inst_98049);

(statearr_98102_98155[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (6))){
var state_98075__$1 = state_98075;
var statearr_98103_98156 = state_98075__$1;
(statearr_98103_98156[(2)] = false);

(statearr_98103_98156[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (28))){
var inst_98045 = (state_98075[(2)]);
var inst_98046 = calc_state.call(null);
var inst_98002 = inst_98046;
var state_98075__$1 = (function (){var statearr_98104 = state_98075;
(statearr_98104[(15)] = inst_98045);

(statearr_98104[(7)] = inst_98002);

return statearr_98104;
})();
var statearr_98105_98157 = state_98075__$1;
(statearr_98105_98157[(2)] = null);

(statearr_98105_98157[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (25))){
var inst_98071 = (state_98075[(2)]);
var state_98075__$1 = state_98075;
var statearr_98106_98158 = state_98075__$1;
(statearr_98106_98158[(2)] = inst_98071);

(statearr_98106_98158[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (34))){
var inst_98069 = (state_98075[(2)]);
var state_98075__$1 = state_98075;
var statearr_98107_98159 = state_98075__$1;
(statearr_98107_98159[(2)] = inst_98069);

(statearr_98107_98159[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (17))){
var state_98075__$1 = state_98075;
var statearr_98108_98160 = state_98075__$1;
(statearr_98108_98160[(2)] = false);

(statearr_98108_98160[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (3))){
var state_98075__$1 = state_98075;
var statearr_98109_98161 = state_98075__$1;
(statearr_98109_98161[(2)] = false);

(statearr_98109_98161[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (12))){
var inst_98073 = (state_98075[(2)]);
var state_98075__$1 = state_98075;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_98075__$1,inst_98073);
} else {
if((state_val_98076 === (2))){
var inst_97977 = (state_98075[(8)]);
var inst_97982 = inst_97977.cljs$lang$protocol_mask$partition0$;
var inst_97983 = (inst_97982 & (64));
var inst_97984 = inst_97977.cljs$core$ISeq$;
var inst_97985 = (cljs.core.PROTOCOL_SENTINEL === inst_97984);
var inst_97986 = ((inst_97983) || (inst_97985));
var state_98075__$1 = state_98075;
if(cljs.core.truth_(inst_97986)){
var statearr_98110_98162 = state_98075__$1;
(statearr_98110_98162[(1)] = (5));

} else {
var statearr_98111_98163 = state_98075__$1;
(statearr_98111_98163[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (23))){
var inst_98034 = (state_98075[(14)]);
var inst_98040 = (inst_98034 == null);
var state_98075__$1 = state_98075;
if(cljs.core.truth_(inst_98040)){
var statearr_98112_98164 = state_98075__$1;
(statearr_98112_98164[(1)] = (26));

} else {
var statearr_98113_98165 = state_98075__$1;
(statearr_98113_98165[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (35))){
var inst_98060 = (state_98075[(2)]);
var state_98075__$1 = state_98075;
if(cljs.core.truth_(inst_98060)){
var statearr_98114_98166 = state_98075__$1;
(statearr_98114_98166[(1)] = (36));

} else {
var statearr_98115_98167 = state_98075__$1;
(statearr_98115_98167[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (19))){
var inst_98002 = (state_98075[(7)]);
var inst_98022 = cljs.core.apply.call(null,cljs.core.hash_map,inst_98002);
var state_98075__$1 = state_98075;
var statearr_98116_98168 = state_98075__$1;
(statearr_98116_98168[(2)] = inst_98022);

(statearr_98116_98168[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (11))){
var inst_98002 = (state_98075[(7)]);
var inst_98006 = (inst_98002 == null);
var inst_98007 = cljs.core.not.call(null,inst_98006);
var state_98075__$1 = state_98075;
if(inst_98007){
var statearr_98117_98169 = state_98075__$1;
(statearr_98117_98169[(1)] = (13));

} else {
var statearr_98118_98170 = state_98075__$1;
(statearr_98118_98170[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (9))){
var inst_97977 = (state_98075[(8)]);
var state_98075__$1 = state_98075;
var statearr_98119_98171 = state_98075__$1;
(statearr_98119_98171[(2)] = inst_97977);

(statearr_98119_98171[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (5))){
var state_98075__$1 = state_98075;
var statearr_98120_98172 = state_98075__$1;
(statearr_98120_98172[(2)] = true);

(statearr_98120_98172[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (14))){
var state_98075__$1 = state_98075;
var statearr_98121_98173 = state_98075__$1;
(statearr_98121_98173[(2)] = false);

(statearr_98121_98173[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (26))){
var inst_98035 = (state_98075[(11)]);
var inst_98042 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_98035);
var state_98075__$1 = state_98075;
var statearr_98122_98174 = state_98075__$1;
(statearr_98122_98174[(2)] = inst_98042);

(statearr_98122_98174[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (16))){
var state_98075__$1 = state_98075;
var statearr_98123_98175 = state_98075__$1;
(statearr_98123_98175[(2)] = true);

(statearr_98123_98175[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (38))){
var inst_98065 = (state_98075[(2)]);
var state_98075__$1 = state_98075;
var statearr_98124_98176 = state_98075__$1;
(statearr_98124_98176[(2)] = inst_98065);

(statearr_98124_98176[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (30))){
var inst_98027 = (state_98075[(13)]);
var inst_98026 = (state_98075[(10)]);
var inst_98035 = (state_98075[(11)]);
var inst_98052 = cljs.core.empty_QMARK_.call(null,inst_98026);
var inst_98053 = inst_98027.call(null,inst_98035);
var inst_98054 = cljs.core.not.call(null,inst_98053);
var inst_98055 = ((inst_98052) && (inst_98054));
var state_98075__$1 = state_98075;
var statearr_98125_98177 = state_98075__$1;
(statearr_98125_98177[(2)] = inst_98055);

(statearr_98125_98177[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (10))){
var inst_97977 = (state_98075[(8)]);
var inst_97998 = (state_98075[(2)]);
var inst_97999 = cljs.core.get.call(null,inst_97998,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_98000 = cljs.core.get.call(null,inst_97998,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_98001 = cljs.core.get.call(null,inst_97998,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_98002 = inst_97977;
var state_98075__$1 = (function (){var statearr_98126 = state_98075;
(statearr_98126[(16)] = inst_98000);

(statearr_98126[(7)] = inst_98002);

(statearr_98126[(17)] = inst_98001);

(statearr_98126[(18)] = inst_97999);

return statearr_98126;
})();
var statearr_98127_98178 = state_98075__$1;
(statearr_98127_98178[(2)] = null);

(statearr_98127_98178[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (18))){
var inst_98017 = (state_98075[(2)]);
var state_98075__$1 = state_98075;
var statearr_98128_98179 = state_98075__$1;
(statearr_98128_98179[(2)] = inst_98017);

(statearr_98128_98179[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (37))){
var state_98075__$1 = state_98075;
var statearr_98129_98180 = state_98075__$1;
(statearr_98129_98180[(2)] = null);

(statearr_98129_98180[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98076 === (8))){
var inst_97977 = (state_98075[(8)]);
var inst_97995 = cljs.core.apply.call(null,cljs.core.hash_map,inst_97977);
var state_98075__$1 = state_98075;
var statearr_98130_98181 = state_98075__$1;
(statearr_98130_98181[(2)] = inst_97995);

(statearr_98130_98181[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___98135,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__96981__auto__,c__97076__auto___98135,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__96982__auto__ = null;
var cljs$core$async$mix_$_state_machine__96982__auto____0 = (function (){
var statearr_98131 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_98131[(0)] = cljs$core$async$mix_$_state_machine__96982__auto__);

(statearr_98131[(1)] = (1));

return statearr_98131;
});
var cljs$core$async$mix_$_state_machine__96982__auto____1 = (function (state_98075){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_98075);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e98132){if((e98132 instanceof Object)){
var ex__96985__auto__ = e98132;
var statearr_98133_98182 = state_98075;
(statearr_98133_98182[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98075);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e98132;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__98183 = state_98075;
state_98075 = G__98183;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__96982__auto__ = function(state_98075){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__96982__auto____1.call(this,state_98075);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mix_$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__96982__auto____0;
cljs$core$async$mix_$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__96982__auto____1;
return cljs$core$async$mix_$_state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___98135,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__97078__auto__ = (function (){var statearr_98134 = f__97077__auto__.call(null);
(statearr_98134[(6)] = c__97076__auto___98135);

return statearr_98134;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___98135,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null)))))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__4433__auto__ = (((p == null))?null:p);
var m__4434__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__4431__auto__ = (cljs.core.async.sub_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null)))))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__4433__auto__ = (((p == null))?null:p);
var m__4434__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,p,v,ch);
} else {
var m__4431__auto__ = (cljs.core.async.unsub_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var G__98185 = arguments.length;
switch (G__98185) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__4433__auto__ = (((p == null))?null:p);
var m__4434__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,p);
} else {
var m__4431__auto__ = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if((((!((p == null)))) && ((!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null)))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__4433__auto__ = (((p == null))?null:p);
var m__4434__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4433__auto__)]);
if((!((m__4434__auto__ == null)))){
return m__4434__auto__.call(null,p,v);
} else {
var m__4431__auto__ = (cljs.core.async.unsub_all_STAR_["_"]);
if((!((m__4431__auto__ == null)))){
return m__4431__auto__.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var G__98189 = arguments.length;
switch (G__98189) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__4131__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__4131__auto__,mults){
return (function (p1__98187_SHARP_){
if(cljs.core.truth_(p1__98187_SHARP_.call(null,topic))){
return p1__98187_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__98187_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__4131__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async98190 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async98190 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta98191){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta98191 = meta98191;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async98190.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_98192,meta98191__$1){
var self__ = this;
var _98192__$1 = this;
return (new cljs.core.async.t_cljs$core$async98190(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta98191__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async98190.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_98192){
var self__ = this;
var _98192__$1 = this;
return self__.meta98191;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async98190.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98190.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async98190.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98190.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async98190.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__5735__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__5735__auto__)){
var m = temp__5735__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async98190.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async98190.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async98190.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta98191","meta98191",-962049565,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async98190.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async98190.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async98190";

cljs.core.async.t_cljs$core$async98190.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"cljs.core.async/t_cljs$core$async98190");
});})(mults,ensure_mult))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async98190.
 */
cljs.core.async.__GT_t_cljs$core$async98190 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async98190(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta98191){
return (new cljs.core.async.t_cljs$core$async98190(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta98191));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async98190(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__97076__auto___98310 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___98310,mults,ensure_mult,p){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___98310,mults,ensure_mult,p){
return (function (state_98264){
var state_val_98265 = (state_98264[(1)]);
if((state_val_98265 === (7))){
var inst_98260 = (state_98264[(2)]);
var state_98264__$1 = state_98264;
var statearr_98266_98311 = state_98264__$1;
(statearr_98266_98311[(2)] = inst_98260);

(statearr_98266_98311[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (20))){
var state_98264__$1 = state_98264;
var statearr_98267_98312 = state_98264__$1;
(statearr_98267_98312[(2)] = null);

(statearr_98267_98312[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (1))){
var state_98264__$1 = state_98264;
var statearr_98268_98313 = state_98264__$1;
(statearr_98268_98313[(2)] = null);

(statearr_98268_98313[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (24))){
var inst_98243 = (state_98264[(7)]);
var inst_98252 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_98243);
var state_98264__$1 = state_98264;
var statearr_98269_98314 = state_98264__$1;
(statearr_98269_98314[(2)] = inst_98252);

(statearr_98269_98314[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (4))){
var inst_98195 = (state_98264[(8)]);
var inst_98195__$1 = (state_98264[(2)]);
var inst_98196 = (inst_98195__$1 == null);
var state_98264__$1 = (function (){var statearr_98270 = state_98264;
(statearr_98270[(8)] = inst_98195__$1);

return statearr_98270;
})();
if(cljs.core.truth_(inst_98196)){
var statearr_98271_98315 = state_98264__$1;
(statearr_98271_98315[(1)] = (5));

} else {
var statearr_98272_98316 = state_98264__$1;
(statearr_98272_98316[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (15))){
var inst_98237 = (state_98264[(2)]);
var state_98264__$1 = state_98264;
var statearr_98273_98317 = state_98264__$1;
(statearr_98273_98317[(2)] = inst_98237);

(statearr_98273_98317[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (21))){
var inst_98257 = (state_98264[(2)]);
var state_98264__$1 = (function (){var statearr_98274 = state_98264;
(statearr_98274[(9)] = inst_98257);

return statearr_98274;
})();
var statearr_98275_98318 = state_98264__$1;
(statearr_98275_98318[(2)] = null);

(statearr_98275_98318[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (13))){
var inst_98219 = (state_98264[(10)]);
var inst_98221 = cljs.core.chunked_seq_QMARK_.call(null,inst_98219);
var state_98264__$1 = state_98264;
if(inst_98221){
var statearr_98276_98319 = state_98264__$1;
(statearr_98276_98319[(1)] = (16));

} else {
var statearr_98277_98320 = state_98264__$1;
(statearr_98277_98320[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (22))){
var inst_98249 = (state_98264[(2)]);
var state_98264__$1 = state_98264;
if(cljs.core.truth_(inst_98249)){
var statearr_98278_98321 = state_98264__$1;
(statearr_98278_98321[(1)] = (23));

} else {
var statearr_98279_98322 = state_98264__$1;
(statearr_98279_98322[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (6))){
var inst_98243 = (state_98264[(7)]);
var inst_98195 = (state_98264[(8)]);
var inst_98245 = (state_98264[(11)]);
var inst_98243__$1 = topic_fn.call(null,inst_98195);
var inst_98244 = cljs.core.deref.call(null,mults);
var inst_98245__$1 = cljs.core.get.call(null,inst_98244,inst_98243__$1);
var state_98264__$1 = (function (){var statearr_98280 = state_98264;
(statearr_98280[(7)] = inst_98243__$1);

(statearr_98280[(11)] = inst_98245__$1);

return statearr_98280;
})();
if(cljs.core.truth_(inst_98245__$1)){
var statearr_98281_98323 = state_98264__$1;
(statearr_98281_98323[(1)] = (19));

} else {
var statearr_98282_98324 = state_98264__$1;
(statearr_98282_98324[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (25))){
var inst_98254 = (state_98264[(2)]);
var state_98264__$1 = state_98264;
var statearr_98283_98325 = state_98264__$1;
(statearr_98283_98325[(2)] = inst_98254);

(statearr_98283_98325[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (17))){
var inst_98219 = (state_98264[(10)]);
var inst_98228 = cljs.core.first.call(null,inst_98219);
var inst_98229 = cljs.core.async.muxch_STAR_.call(null,inst_98228);
var inst_98230 = cljs.core.async.close_BANG_.call(null,inst_98229);
var inst_98231 = cljs.core.next.call(null,inst_98219);
var inst_98205 = inst_98231;
var inst_98206 = null;
var inst_98207 = (0);
var inst_98208 = (0);
var state_98264__$1 = (function (){var statearr_98284 = state_98264;
(statearr_98284[(12)] = inst_98205);

(statearr_98284[(13)] = inst_98208);

(statearr_98284[(14)] = inst_98206);

(statearr_98284[(15)] = inst_98230);

(statearr_98284[(16)] = inst_98207);

return statearr_98284;
})();
var statearr_98285_98326 = state_98264__$1;
(statearr_98285_98326[(2)] = null);

(statearr_98285_98326[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (3))){
var inst_98262 = (state_98264[(2)]);
var state_98264__$1 = state_98264;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_98264__$1,inst_98262);
} else {
if((state_val_98265 === (12))){
var inst_98239 = (state_98264[(2)]);
var state_98264__$1 = state_98264;
var statearr_98286_98327 = state_98264__$1;
(statearr_98286_98327[(2)] = inst_98239);

(statearr_98286_98327[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (2))){
var state_98264__$1 = state_98264;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_98264__$1,(4),ch);
} else {
if((state_val_98265 === (23))){
var state_98264__$1 = state_98264;
var statearr_98287_98328 = state_98264__$1;
(statearr_98287_98328[(2)] = null);

(statearr_98287_98328[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (19))){
var inst_98195 = (state_98264[(8)]);
var inst_98245 = (state_98264[(11)]);
var inst_98247 = cljs.core.async.muxch_STAR_.call(null,inst_98245);
var state_98264__$1 = state_98264;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98264__$1,(22),inst_98247,inst_98195);
} else {
if((state_val_98265 === (11))){
var inst_98205 = (state_98264[(12)]);
var inst_98219 = (state_98264[(10)]);
var inst_98219__$1 = cljs.core.seq.call(null,inst_98205);
var state_98264__$1 = (function (){var statearr_98288 = state_98264;
(statearr_98288[(10)] = inst_98219__$1);

return statearr_98288;
})();
if(inst_98219__$1){
var statearr_98289_98329 = state_98264__$1;
(statearr_98289_98329[(1)] = (13));

} else {
var statearr_98290_98330 = state_98264__$1;
(statearr_98290_98330[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (9))){
var inst_98241 = (state_98264[(2)]);
var state_98264__$1 = state_98264;
var statearr_98291_98331 = state_98264__$1;
(statearr_98291_98331[(2)] = inst_98241);

(statearr_98291_98331[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (5))){
var inst_98202 = cljs.core.deref.call(null,mults);
var inst_98203 = cljs.core.vals.call(null,inst_98202);
var inst_98204 = cljs.core.seq.call(null,inst_98203);
var inst_98205 = inst_98204;
var inst_98206 = null;
var inst_98207 = (0);
var inst_98208 = (0);
var state_98264__$1 = (function (){var statearr_98292 = state_98264;
(statearr_98292[(12)] = inst_98205);

(statearr_98292[(13)] = inst_98208);

(statearr_98292[(14)] = inst_98206);

(statearr_98292[(16)] = inst_98207);

return statearr_98292;
})();
var statearr_98293_98332 = state_98264__$1;
(statearr_98293_98332[(2)] = null);

(statearr_98293_98332[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (14))){
var state_98264__$1 = state_98264;
var statearr_98297_98333 = state_98264__$1;
(statearr_98297_98333[(2)] = null);

(statearr_98297_98333[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (16))){
var inst_98219 = (state_98264[(10)]);
var inst_98223 = cljs.core.chunk_first.call(null,inst_98219);
var inst_98224 = cljs.core.chunk_rest.call(null,inst_98219);
var inst_98225 = cljs.core.count.call(null,inst_98223);
var inst_98205 = inst_98224;
var inst_98206 = inst_98223;
var inst_98207 = inst_98225;
var inst_98208 = (0);
var state_98264__$1 = (function (){var statearr_98298 = state_98264;
(statearr_98298[(12)] = inst_98205);

(statearr_98298[(13)] = inst_98208);

(statearr_98298[(14)] = inst_98206);

(statearr_98298[(16)] = inst_98207);

return statearr_98298;
})();
var statearr_98299_98334 = state_98264__$1;
(statearr_98299_98334[(2)] = null);

(statearr_98299_98334[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (10))){
var inst_98205 = (state_98264[(12)]);
var inst_98208 = (state_98264[(13)]);
var inst_98206 = (state_98264[(14)]);
var inst_98207 = (state_98264[(16)]);
var inst_98213 = cljs.core._nth.call(null,inst_98206,inst_98208);
var inst_98214 = cljs.core.async.muxch_STAR_.call(null,inst_98213);
var inst_98215 = cljs.core.async.close_BANG_.call(null,inst_98214);
var inst_98216 = (inst_98208 + (1));
var tmp98294 = inst_98205;
var tmp98295 = inst_98206;
var tmp98296 = inst_98207;
var inst_98205__$1 = tmp98294;
var inst_98206__$1 = tmp98295;
var inst_98207__$1 = tmp98296;
var inst_98208__$1 = inst_98216;
var state_98264__$1 = (function (){var statearr_98300 = state_98264;
(statearr_98300[(17)] = inst_98215);

(statearr_98300[(12)] = inst_98205__$1);

(statearr_98300[(13)] = inst_98208__$1);

(statearr_98300[(14)] = inst_98206__$1);

(statearr_98300[(16)] = inst_98207__$1);

return statearr_98300;
})();
var statearr_98301_98335 = state_98264__$1;
(statearr_98301_98335[(2)] = null);

(statearr_98301_98335[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (18))){
var inst_98234 = (state_98264[(2)]);
var state_98264__$1 = state_98264;
var statearr_98302_98336 = state_98264__$1;
(statearr_98302_98336[(2)] = inst_98234);

(statearr_98302_98336[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98265 === (8))){
var inst_98208 = (state_98264[(13)]);
var inst_98207 = (state_98264[(16)]);
var inst_98210 = (inst_98208 < inst_98207);
var inst_98211 = inst_98210;
var state_98264__$1 = state_98264;
if(cljs.core.truth_(inst_98211)){
var statearr_98303_98337 = state_98264__$1;
(statearr_98303_98337[(1)] = (10));

} else {
var statearr_98304_98338 = state_98264__$1;
(statearr_98304_98338[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___98310,mults,ensure_mult,p))
;
return ((function (switch__96981__auto__,c__97076__auto___98310,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_98305 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_98305[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_98305[(1)] = (1));

return statearr_98305;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_98264){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_98264);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e98306){if((e98306 instanceof Object)){
var ex__96985__auto__ = e98306;
var statearr_98307_98339 = state_98264;
(statearr_98307_98339[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98264);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e98306;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__98340 = state_98264;
state_98264 = G__98340;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_98264){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_98264);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___98310,mults,ensure_mult,p))
})();
var state__97078__auto__ = (function (){var statearr_98308 = f__97077__auto__.call(null);
(statearr_98308[(6)] = c__97076__auto___98310);

return statearr_98308;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___98310,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var G__98342 = arguments.length;
switch (G__98342) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var G__98345 = arguments.length;
switch (G__98345) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var G__98348 = arguments.length;
switch (G__98348) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__97076__auto___98415 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___98415,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___98415,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_98387){
var state_val_98388 = (state_98387[(1)]);
if((state_val_98388 === (7))){
var state_98387__$1 = state_98387;
var statearr_98389_98416 = state_98387__$1;
(statearr_98389_98416[(2)] = null);

(statearr_98389_98416[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (1))){
var state_98387__$1 = state_98387;
var statearr_98390_98417 = state_98387__$1;
(statearr_98390_98417[(2)] = null);

(statearr_98390_98417[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (4))){
var inst_98351 = (state_98387[(7)]);
var inst_98353 = (inst_98351 < cnt);
var state_98387__$1 = state_98387;
if(cljs.core.truth_(inst_98353)){
var statearr_98391_98418 = state_98387__$1;
(statearr_98391_98418[(1)] = (6));

} else {
var statearr_98392_98419 = state_98387__$1;
(statearr_98392_98419[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (15))){
var inst_98383 = (state_98387[(2)]);
var state_98387__$1 = state_98387;
var statearr_98393_98420 = state_98387__$1;
(statearr_98393_98420[(2)] = inst_98383);

(statearr_98393_98420[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (13))){
var inst_98376 = cljs.core.async.close_BANG_.call(null,out);
var state_98387__$1 = state_98387;
var statearr_98394_98421 = state_98387__$1;
(statearr_98394_98421[(2)] = inst_98376);

(statearr_98394_98421[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (6))){
var state_98387__$1 = state_98387;
var statearr_98395_98422 = state_98387__$1;
(statearr_98395_98422[(2)] = null);

(statearr_98395_98422[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (3))){
var inst_98385 = (state_98387[(2)]);
var state_98387__$1 = state_98387;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_98387__$1,inst_98385);
} else {
if((state_val_98388 === (12))){
var inst_98373 = (state_98387[(8)]);
var inst_98373__$1 = (state_98387[(2)]);
var inst_98374 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_98373__$1);
var state_98387__$1 = (function (){var statearr_98396 = state_98387;
(statearr_98396[(8)] = inst_98373__$1);

return statearr_98396;
})();
if(cljs.core.truth_(inst_98374)){
var statearr_98397_98423 = state_98387__$1;
(statearr_98397_98423[(1)] = (13));

} else {
var statearr_98398_98424 = state_98387__$1;
(statearr_98398_98424[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (2))){
var inst_98350 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_98351 = (0);
var state_98387__$1 = (function (){var statearr_98399 = state_98387;
(statearr_98399[(7)] = inst_98351);

(statearr_98399[(9)] = inst_98350);

return statearr_98399;
})();
var statearr_98400_98425 = state_98387__$1;
(statearr_98400_98425[(2)] = null);

(statearr_98400_98425[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (11))){
var inst_98351 = (state_98387[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_98387,(10),Object,null,(9));
var inst_98360 = chs__$1.call(null,inst_98351);
var inst_98361 = done.call(null,inst_98351);
var inst_98362 = cljs.core.async.take_BANG_.call(null,inst_98360,inst_98361);
var state_98387__$1 = state_98387;
var statearr_98401_98426 = state_98387__$1;
(statearr_98401_98426[(2)] = inst_98362);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98387__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (9))){
var inst_98351 = (state_98387[(7)]);
var inst_98364 = (state_98387[(2)]);
var inst_98365 = (inst_98351 + (1));
var inst_98351__$1 = inst_98365;
var state_98387__$1 = (function (){var statearr_98402 = state_98387;
(statearr_98402[(7)] = inst_98351__$1);

(statearr_98402[(10)] = inst_98364);

return statearr_98402;
})();
var statearr_98403_98427 = state_98387__$1;
(statearr_98403_98427[(2)] = null);

(statearr_98403_98427[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (5))){
var inst_98371 = (state_98387[(2)]);
var state_98387__$1 = (function (){var statearr_98404 = state_98387;
(statearr_98404[(11)] = inst_98371);

return statearr_98404;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_98387__$1,(12),dchan);
} else {
if((state_val_98388 === (14))){
var inst_98373 = (state_98387[(8)]);
var inst_98378 = cljs.core.apply.call(null,f,inst_98373);
var state_98387__$1 = state_98387;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98387__$1,(16),out,inst_98378);
} else {
if((state_val_98388 === (16))){
var inst_98380 = (state_98387[(2)]);
var state_98387__$1 = (function (){var statearr_98405 = state_98387;
(statearr_98405[(12)] = inst_98380);

return statearr_98405;
})();
var statearr_98406_98428 = state_98387__$1;
(statearr_98406_98428[(2)] = null);

(statearr_98406_98428[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (10))){
var inst_98355 = (state_98387[(2)]);
var inst_98356 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_98387__$1 = (function (){var statearr_98407 = state_98387;
(statearr_98407[(13)] = inst_98355);

return statearr_98407;
})();
var statearr_98408_98429 = state_98387__$1;
(statearr_98408_98429[(2)] = inst_98356);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98387__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98388 === (8))){
var inst_98369 = (state_98387[(2)]);
var state_98387__$1 = state_98387;
var statearr_98409_98430 = state_98387__$1;
(statearr_98409_98430[(2)] = inst_98369);

(statearr_98409_98430[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___98415,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__96981__auto__,c__97076__auto___98415,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_98410 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_98410[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_98410[(1)] = (1));

return statearr_98410;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_98387){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_98387);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e98411){if((e98411 instanceof Object)){
var ex__96985__auto__ = e98411;
var statearr_98412_98431 = state_98387;
(statearr_98412_98431[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98387);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e98411;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__98432 = state_98387;
state_98387 = G__98432;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_98387){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_98387);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___98415,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__97078__auto__ = (function (){var statearr_98413 = f__97077__auto__.call(null);
(statearr_98413[(6)] = c__97076__auto___98415);

return statearr_98413;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___98415,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var G__98435 = arguments.length;
switch (G__98435) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__97076__auto___98489 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___98489,out){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___98489,out){
return (function (state_98467){
var state_val_98468 = (state_98467[(1)]);
if((state_val_98468 === (7))){
var inst_98446 = (state_98467[(7)]);
var inst_98447 = (state_98467[(8)]);
var inst_98446__$1 = (state_98467[(2)]);
var inst_98447__$1 = cljs.core.nth.call(null,inst_98446__$1,(0),null);
var inst_98448 = cljs.core.nth.call(null,inst_98446__$1,(1),null);
var inst_98449 = (inst_98447__$1 == null);
var state_98467__$1 = (function (){var statearr_98469 = state_98467;
(statearr_98469[(7)] = inst_98446__$1);

(statearr_98469[(8)] = inst_98447__$1);

(statearr_98469[(9)] = inst_98448);

return statearr_98469;
})();
if(cljs.core.truth_(inst_98449)){
var statearr_98470_98490 = state_98467__$1;
(statearr_98470_98490[(1)] = (8));

} else {
var statearr_98471_98491 = state_98467__$1;
(statearr_98471_98491[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98468 === (1))){
var inst_98436 = cljs.core.vec.call(null,chs);
var inst_98437 = inst_98436;
var state_98467__$1 = (function (){var statearr_98472 = state_98467;
(statearr_98472[(10)] = inst_98437);

return statearr_98472;
})();
var statearr_98473_98492 = state_98467__$1;
(statearr_98473_98492[(2)] = null);

(statearr_98473_98492[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98468 === (4))){
var inst_98437 = (state_98467[(10)]);
var state_98467__$1 = state_98467;
return cljs.core.async.ioc_alts_BANG_.call(null,state_98467__$1,(7),inst_98437);
} else {
if((state_val_98468 === (6))){
var inst_98463 = (state_98467[(2)]);
var state_98467__$1 = state_98467;
var statearr_98474_98493 = state_98467__$1;
(statearr_98474_98493[(2)] = inst_98463);

(statearr_98474_98493[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98468 === (3))){
var inst_98465 = (state_98467[(2)]);
var state_98467__$1 = state_98467;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_98467__$1,inst_98465);
} else {
if((state_val_98468 === (2))){
var inst_98437 = (state_98467[(10)]);
var inst_98439 = cljs.core.count.call(null,inst_98437);
var inst_98440 = (inst_98439 > (0));
var state_98467__$1 = state_98467;
if(cljs.core.truth_(inst_98440)){
var statearr_98476_98494 = state_98467__$1;
(statearr_98476_98494[(1)] = (4));

} else {
var statearr_98477_98495 = state_98467__$1;
(statearr_98477_98495[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98468 === (11))){
var inst_98437 = (state_98467[(10)]);
var inst_98456 = (state_98467[(2)]);
var tmp98475 = inst_98437;
var inst_98437__$1 = tmp98475;
var state_98467__$1 = (function (){var statearr_98478 = state_98467;
(statearr_98478[(10)] = inst_98437__$1);

(statearr_98478[(11)] = inst_98456);

return statearr_98478;
})();
var statearr_98479_98496 = state_98467__$1;
(statearr_98479_98496[(2)] = null);

(statearr_98479_98496[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98468 === (9))){
var inst_98447 = (state_98467[(8)]);
var state_98467__$1 = state_98467;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98467__$1,(11),out,inst_98447);
} else {
if((state_val_98468 === (5))){
var inst_98461 = cljs.core.async.close_BANG_.call(null,out);
var state_98467__$1 = state_98467;
var statearr_98480_98497 = state_98467__$1;
(statearr_98480_98497[(2)] = inst_98461);

(statearr_98480_98497[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98468 === (10))){
var inst_98459 = (state_98467[(2)]);
var state_98467__$1 = state_98467;
var statearr_98481_98498 = state_98467__$1;
(statearr_98481_98498[(2)] = inst_98459);

(statearr_98481_98498[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98468 === (8))){
var inst_98437 = (state_98467[(10)]);
var inst_98446 = (state_98467[(7)]);
var inst_98447 = (state_98467[(8)]);
var inst_98448 = (state_98467[(9)]);
var inst_98451 = (function (){var cs = inst_98437;
var vec__98442 = inst_98446;
var v = inst_98447;
var c = inst_98448;
return ((function (cs,vec__98442,v,c,inst_98437,inst_98446,inst_98447,inst_98448,state_val_98468,c__97076__auto___98489,out){
return (function (p1__98433_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__98433_SHARP_);
});
;})(cs,vec__98442,v,c,inst_98437,inst_98446,inst_98447,inst_98448,state_val_98468,c__97076__auto___98489,out))
})();
var inst_98452 = cljs.core.filterv.call(null,inst_98451,inst_98437);
var inst_98437__$1 = inst_98452;
var state_98467__$1 = (function (){var statearr_98482 = state_98467;
(statearr_98482[(10)] = inst_98437__$1);

return statearr_98482;
})();
var statearr_98483_98499 = state_98467__$1;
(statearr_98483_98499[(2)] = null);

(statearr_98483_98499[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___98489,out))
;
return ((function (switch__96981__auto__,c__97076__auto___98489,out){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_98484 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_98484[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_98484[(1)] = (1));

return statearr_98484;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_98467){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_98467);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e98485){if((e98485 instanceof Object)){
var ex__96985__auto__ = e98485;
var statearr_98486_98500 = state_98467;
(statearr_98486_98500[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98467);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e98485;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__98501 = state_98467;
state_98467 = G__98501;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_98467){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_98467);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___98489,out))
})();
var state__97078__auto__ = (function (){var statearr_98487 = f__97077__auto__.call(null);
(statearr_98487[(6)] = c__97076__auto___98489);

return statearr_98487;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___98489,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var G__98503 = arguments.length;
switch (G__98503) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__97076__auto___98548 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___98548,out){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___98548,out){
return (function (state_98527){
var state_val_98528 = (state_98527[(1)]);
if((state_val_98528 === (7))){
var inst_98509 = (state_98527[(7)]);
var inst_98509__$1 = (state_98527[(2)]);
var inst_98510 = (inst_98509__$1 == null);
var inst_98511 = cljs.core.not.call(null,inst_98510);
var state_98527__$1 = (function (){var statearr_98529 = state_98527;
(statearr_98529[(7)] = inst_98509__$1);

return statearr_98529;
})();
if(inst_98511){
var statearr_98530_98549 = state_98527__$1;
(statearr_98530_98549[(1)] = (8));

} else {
var statearr_98531_98550 = state_98527__$1;
(statearr_98531_98550[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98528 === (1))){
var inst_98504 = (0);
var state_98527__$1 = (function (){var statearr_98532 = state_98527;
(statearr_98532[(8)] = inst_98504);

return statearr_98532;
})();
var statearr_98533_98551 = state_98527__$1;
(statearr_98533_98551[(2)] = null);

(statearr_98533_98551[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98528 === (4))){
var state_98527__$1 = state_98527;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_98527__$1,(7),ch);
} else {
if((state_val_98528 === (6))){
var inst_98522 = (state_98527[(2)]);
var state_98527__$1 = state_98527;
var statearr_98534_98552 = state_98527__$1;
(statearr_98534_98552[(2)] = inst_98522);

(statearr_98534_98552[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98528 === (3))){
var inst_98524 = (state_98527[(2)]);
var inst_98525 = cljs.core.async.close_BANG_.call(null,out);
var state_98527__$1 = (function (){var statearr_98535 = state_98527;
(statearr_98535[(9)] = inst_98524);

return statearr_98535;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_98527__$1,inst_98525);
} else {
if((state_val_98528 === (2))){
var inst_98504 = (state_98527[(8)]);
var inst_98506 = (inst_98504 < n);
var state_98527__$1 = state_98527;
if(cljs.core.truth_(inst_98506)){
var statearr_98536_98553 = state_98527__$1;
(statearr_98536_98553[(1)] = (4));

} else {
var statearr_98537_98554 = state_98527__$1;
(statearr_98537_98554[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98528 === (11))){
var inst_98504 = (state_98527[(8)]);
var inst_98514 = (state_98527[(2)]);
var inst_98515 = (inst_98504 + (1));
var inst_98504__$1 = inst_98515;
var state_98527__$1 = (function (){var statearr_98538 = state_98527;
(statearr_98538[(8)] = inst_98504__$1);

(statearr_98538[(10)] = inst_98514);

return statearr_98538;
})();
var statearr_98539_98555 = state_98527__$1;
(statearr_98539_98555[(2)] = null);

(statearr_98539_98555[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98528 === (9))){
var state_98527__$1 = state_98527;
var statearr_98540_98556 = state_98527__$1;
(statearr_98540_98556[(2)] = null);

(statearr_98540_98556[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98528 === (5))){
var state_98527__$1 = state_98527;
var statearr_98541_98557 = state_98527__$1;
(statearr_98541_98557[(2)] = null);

(statearr_98541_98557[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98528 === (10))){
var inst_98519 = (state_98527[(2)]);
var state_98527__$1 = state_98527;
var statearr_98542_98558 = state_98527__$1;
(statearr_98542_98558[(2)] = inst_98519);

(statearr_98542_98558[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98528 === (8))){
var inst_98509 = (state_98527[(7)]);
var state_98527__$1 = state_98527;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98527__$1,(11),out,inst_98509);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___98548,out))
;
return ((function (switch__96981__auto__,c__97076__auto___98548,out){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_98543 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_98543[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_98543[(1)] = (1));

return statearr_98543;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_98527){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_98527);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e98544){if((e98544 instanceof Object)){
var ex__96985__auto__ = e98544;
var statearr_98545_98559 = state_98527;
(statearr_98545_98559[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98527);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e98544;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__98560 = state_98527;
state_98527 = G__98560;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_98527){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_98527);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___98548,out))
})();
var state__97078__auto__ = (function (){var statearr_98546 = f__97077__auto__.call(null);
(statearr_98546[(6)] = c__97076__auto___98548);

return statearr_98546;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___98548,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async98562 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async98562 = (function (f,ch,meta98563){
this.f = f;
this.ch = ch;
this.meta98563 = meta98563;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async98562.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_98564,meta98563__$1){
var self__ = this;
var _98564__$1 = this;
return (new cljs.core.async.t_cljs$core$async98562(self__.f,self__.ch,meta98563__$1));
});

cljs.core.async.t_cljs$core$async98562.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_98564){
var self__ = this;
var _98564__$1 = this;
return self__.meta98563;
});

cljs.core.async.t_cljs$core$async98562.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98562.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async98562.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async98562.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98562.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async98565 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async98565 = (function (f,ch,meta98563,_,fn1,meta98566){
this.f = f;
this.ch = ch;
this.meta98563 = meta98563;
this._ = _;
this.fn1 = fn1;
this.meta98566 = meta98566;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async98565.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_98567,meta98566__$1){
var self__ = this;
var _98567__$1 = this;
return (new cljs.core.async.t_cljs$core$async98565(self__.f,self__.ch,self__.meta98563,self__._,self__.fn1,meta98566__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async98565.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_98567){
var self__ = this;
var _98567__$1 = this;
return self__.meta98566;
});})(___$1))
;

cljs.core.async.t_cljs$core$async98565.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98565.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async98565.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async98565.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__98561_SHARP_){
return f1.call(null,(((p1__98561_SHARP_ == null))?null:self__.f.call(null,p1__98561_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async98565.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta98563","meta98563",1170008452,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async98562","cljs.core.async/t_cljs$core$async98562",-1392319019,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta98566","meta98566",58110028,null)], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async98565.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async98565.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async98565";

cljs.core.async.t_cljs$core$async98565.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"cljs.core.async/t_cljs$core$async98565");
});})(___$1))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async98565.
 */
cljs.core.async.__GT_t_cljs$core$async98565 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async98565(f__$1,ch__$1,meta98563__$1,___$2,fn1__$1,meta98566){
return (new cljs.core.async.t_cljs$core$async98565(f__$1,ch__$1,meta98563__$1,___$2,fn1__$1,meta98566));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async98565(self__.f,self__.ch,self__.meta98563,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__4120__auto__ = ret;
if(cljs.core.truth_(and__4120__auto__)){
return (!((cljs.core.deref.call(null,ret) == null)));
} else {
return and__4120__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async98562.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98562.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async98562.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta98563","meta98563",1170008452,null)], null);
});

cljs.core.async.t_cljs$core$async98562.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async98562.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async98562";

cljs.core.async.t_cljs$core$async98562.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"cljs.core.async/t_cljs$core$async98562");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async98562.
 */
cljs.core.async.__GT_t_cljs$core$async98562 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async98562(f__$1,ch__$1,meta98563){
return (new cljs.core.async.t_cljs$core$async98562(f__$1,ch__$1,meta98563));
});

}

return (new cljs.core.async.t_cljs$core$async98562(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async98568 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async98568 = (function (f,ch,meta98569){
this.f = f;
this.ch = ch;
this.meta98569 = meta98569;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async98568.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_98570,meta98569__$1){
var self__ = this;
var _98570__$1 = this;
return (new cljs.core.async.t_cljs$core$async98568(self__.f,self__.ch,meta98569__$1));
});

cljs.core.async.t_cljs$core$async98568.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_98570){
var self__ = this;
var _98570__$1 = this;
return self__.meta98569;
});

cljs.core.async.t_cljs$core$async98568.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98568.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async98568.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98568.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async98568.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98568.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t_cljs$core$async98568.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta98569","meta98569",1748820692,null)], null);
});

cljs.core.async.t_cljs$core$async98568.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async98568.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async98568";

cljs.core.async.t_cljs$core$async98568.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"cljs.core.async/t_cljs$core$async98568");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async98568.
 */
cljs.core.async.__GT_t_cljs$core$async98568 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async98568(f__$1,ch__$1,meta98569){
return (new cljs.core.async.t_cljs$core$async98568(f__$1,ch__$1,meta98569));
});

}

return (new cljs.core.async.t_cljs$core$async98568(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if((typeof cljs !== 'undefined') && (typeof cljs.core !== 'undefined') && (typeof cljs.core.async !== 'undefined') && (typeof cljs.core.async.t_cljs$core$async98571 !== 'undefined')){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async98571 = (function (p,ch,meta98572){
this.p = p;
this.ch = ch;
this.meta98572 = meta98572;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async98571.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_98573,meta98572__$1){
var self__ = this;
var _98573__$1 = this;
return (new cljs.core.async.t_cljs$core$async98571(self__.p,self__.ch,meta98572__$1));
});

cljs.core.async.t_cljs$core$async98571.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_98573){
var self__ = this;
var _98573__$1 = this;
return self__.meta98572;
});

cljs.core.async.t_cljs$core$async98571.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98571.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async98571.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async98571.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98571.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async98571.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async98571.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t_cljs$core$async98571.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta98572","meta98572",884618862,null)], null);
});

cljs.core.async.t_cljs$core$async98571.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async98571.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async98571";

cljs.core.async.t_cljs$core$async98571.cljs$lang$ctorPrWriter = (function (this__4374__auto__,writer__4375__auto__,opt__4376__auto__){
return cljs.core._write.call(null,writer__4375__auto__,"cljs.core.async/t_cljs$core$async98571");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async98571.
 */
cljs.core.async.__GT_t_cljs$core$async98571 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async98571(p__$1,ch__$1,meta98572){
return (new cljs.core.async.t_cljs$core$async98571(p__$1,ch__$1,meta98572));
});

}

return (new cljs.core.async.t_cljs$core$async98571(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var G__98575 = arguments.length;
switch (G__98575) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__97076__auto___98615 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___98615,out){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___98615,out){
return (function (state_98596){
var state_val_98597 = (state_98596[(1)]);
if((state_val_98597 === (7))){
var inst_98592 = (state_98596[(2)]);
var state_98596__$1 = state_98596;
var statearr_98598_98616 = state_98596__$1;
(statearr_98598_98616[(2)] = inst_98592);

(statearr_98598_98616[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98597 === (1))){
var state_98596__$1 = state_98596;
var statearr_98599_98617 = state_98596__$1;
(statearr_98599_98617[(2)] = null);

(statearr_98599_98617[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98597 === (4))){
var inst_98578 = (state_98596[(7)]);
var inst_98578__$1 = (state_98596[(2)]);
var inst_98579 = (inst_98578__$1 == null);
var state_98596__$1 = (function (){var statearr_98600 = state_98596;
(statearr_98600[(7)] = inst_98578__$1);

return statearr_98600;
})();
if(cljs.core.truth_(inst_98579)){
var statearr_98601_98618 = state_98596__$1;
(statearr_98601_98618[(1)] = (5));

} else {
var statearr_98602_98619 = state_98596__$1;
(statearr_98602_98619[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98597 === (6))){
var inst_98578 = (state_98596[(7)]);
var inst_98583 = p.call(null,inst_98578);
var state_98596__$1 = state_98596;
if(cljs.core.truth_(inst_98583)){
var statearr_98603_98620 = state_98596__$1;
(statearr_98603_98620[(1)] = (8));

} else {
var statearr_98604_98621 = state_98596__$1;
(statearr_98604_98621[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98597 === (3))){
var inst_98594 = (state_98596[(2)]);
var state_98596__$1 = state_98596;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_98596__$1,inst_98594);
} else {
if((state_val_98597 === (2))){
var state_98596__$1 = state_98596;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_98596__$1,(4),ch);
} else {
if((state_val_98597 === (11))){
var inst_98586 = (state_98596[(2)]);
var state_98596__$1 = state_98596;
var statearr_98605_98622 = state_98596__$1;
(statearr_98605_98622[(2)] = inst_98586);

(statearr_98605_98622[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98597 === (9))){
var state_98596__$1 = state_98596;
var statearr_98606_98623 = state_98596__$1;
(statearr_98606_98623[(2)] = null);

(statearr_98606_98623[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98597 === (5))){
var inst_98581 = cljs.core.async.close_BANG_.call(null,out);
var state_98596__$1 = state_98596;
var statearr_98607_98624 = state_98596__$1;
(statearr_98607_98624[(2)] = inst_98581);

(statearr_98607_98624[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98597 === (10))){
var inst_98589 = (state_98596[(2)]);
var state_98596__$1 = (function (){var statearr_98608 = state_98596;
(statearr_98608[(8)] = inst_98589);

return statearr_98608;
})();
var statearr_98609_98625 = state_98596__$1;
(statearr_98609_98625[(2)] = null);

(statearr_98609_98625[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98597 === (8))){
var inst_98578 = (state_98596[(7)]);
var state_98596__$1 = state_98596;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98596__$1,(11),out,inst_98578);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___98615,out))
;
return ((function (switch__96981__auto__,c__97076__auto___98615,out){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_98610 = [null,null,null,null,null,null,null,null,null];
(statearr_98610[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_98610[(1)] = (1));

return statearr_98610;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_98596){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_98596);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e98611){if((e98611 instanceof Object)){
var ex__96985__auto__ = e98611;
var statearr_98612_98626 = state_98596;
(statearr_98612_98626[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98596);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e98611;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__98627 = state_98596;
state_98596 = G__98627;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_98596){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_98596);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___98615,out))
})();
var state__97078__auto__ = (function (){var statearr_98613 = f__97077__auto__.call(null);
(statearr_98613[(6)] = c__97076__auto___98615);

return statearr_98613;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___98615,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var G__98629 = arguments.length;
switch (G__98629) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__97076__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto__){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto__){
return (function (state_98692){
var state_val_98693 = (state_98692[(1)]);
if((state_val_98693 === (7))){
var inst_98688 = (state_98692[(2)]);
var state_98692__$1 = state_98692;
var statearr_98694_98732 = state_98692__$1;
(statearr_98694_98732[(2)] = inst_98688);

(statearr_98694_98732[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (20))){
var inst_98658 = (state_98692[(7)]);
var inst_98669 = (state_98692[(2)]);
var inst_98670 = cljs.core.next.call(null,inst_98658);
var inst_98644 = inst_98670;
var inst_98645 = null;
var inst_98646 = (0);
var inst_98647 = (0);
var state_98692__$1 = (function (){var statearr_98695 = state_98692;
(statearr_98695[(8)] = inst_98647);

(statearr_98695[(9)] = inst_98646);

(statearr_98695[(10)] = inst_98645);

(statearr_98695[(11)] = inst_98669);

(statearr_98695[(12)] = inst_98644);

return statearr_98695;
})();
var statearr_98696_98733 = state_98692__$1;
(statearr_98696_98733[(2)] = null);

(statearr_98696_98733[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (1))){
var state_98692__$1 = state_98692;
var statearr_98697_98734 = state_98692__$1;
(statearr_98697_98734[(2)] = null);

(statearr_98697_98734[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (4))){
var inst_98633 = (state_98692[(13)]);
var inst_98633__$1 = (state_98692[(2)]);
var inst_98634 = (inst_98633__$1 == null);
var state_98692__$1 = (function (){var statearr_98698 = state_98692;
(statearr_98698[(13)] = inst_98633__$1);

return statearr_98698;
})();
if(cljs.core.truth_(inst_98634)){
var statearr_98699_98735 = state_98692__$1;
(statearr_98699_98735[(1)] = (5));

} else {
var statearr_98700_98736 = state_98692__$1;
(statearr_98700_98736[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (15))){
var state_98692__$1 = state_98692;
var statearr_98704_98737 = state_98692__$1;
(statearr_98704_98737[(2)] = null);

(statearr_98704_98737[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (21))){
var state_98692__$1 = state_98692;
var statearr_98705_98738 = state_98692__$1;
(statearr_98705_98738[(2)] = null);

(statearr_98705_98738[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (13))){
var inst_98647 = (state_98692[(8)]);
var inst_98646 = (state_98692[(9)]);
var inst_98645 = (state_98692[(10)]);
var inst_98644 = (state_98692[(12)]);
var inst_98654 = (state_98692[(2)]);
var inst_98655 = (inst_98647 + (1));
var tmp98701 = inst_98646;
var tmp98702 = inst_98645;
var tmp98703 = inst_98644;
var inst_98644__$1 = tmp98703;
var inst_98645__$1 = tmp98702;
var inst_98646__$1 = tmp98701;
var inst_98647__$1 = inst_98655;
var state_98692__$1 = (function (){var statearr_98706 = state_98692;
(statearr_98706[(8)] = inst_98647__$1);

(statearr_98706[(9)] = inst_98646__$1);

(statearr_98706[(14)] = inst_98654);

(statearr_98706[(10)] = inst_98645__$1);

(statearr_98706[(12)] = inst_98644__$1);

return statearr_98706;
})();
var statearr_98707_98739 = state_98692__$1;
(statearr_98707_98739[(2)] = null);

(statearr_98707_98739[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (22))){
var state_98692__$1 = state_98692;
var statearr_98708_98740 = state_98692__$1;
(statearr_98708_98740[(2)] = null);

(statearr_98708_98740[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (6))){
var inst_98633 = (state_98692[(13)]);
var inst_98642 = f.call(null,inst_98633);
var inst_98643 = cljs.core.seq.call(null,inst_98642);
var inst_98644 = inst_98643;
var inst_98645 = null;
var inst_98646 = (0);
var inst_98647 = (0);
var state_98692__$1 = (function (){var statearr_98709 = state_98692;
(statearr_98709[(8)] = inst_98647);

(statearr_98709[(9)] = inst_98646);

(statearr_98709[(10)] = inst_98645);

(statearr_98709[(12)] = inst_98644);

return statearr_98709;
})();
var statearr_98710_98741 = state_98692__$1;
(statearr_98710_98741[(2)] = null);

(statearr_98710_98741[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (17))){
var inst_98658 = (state_98692[(7)]);
var inst_98662 = cljs.core.chunk_first.call(null,inst_98658);
var inst_98663 = cljs.core.chunk_rest.call(null,inst_98658);
var inst_98664 = cljs.core.count.call(null,inst_98662);
var inst_98644 = inst_98663;
var inst_98645 = inst_98662;
var inst_98646 = inst_98664;
var inst_98647 = (0);
var state_98692__$1 = (function (){var statearr_98711 = state_98692;
(statearr_98711[(8)] = inst_98647);

(statearr_98711[(9)] = inst_98646);

(statearr_98711[(10)] = inst_98645);

(statearr_98711[(12)] = inst_98644);

return statearr_98711;
})();
var statearr_98712_98742 = state_98692__$1;
(statearr_98712_98742[(2)] = null);

(statearr_98712_98742[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (3))){
var inst_98690 = (state_98692[(2)]);
var state_98692__$1 = state_98692;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_98692__$1,inst_98690);
} else {
if((state_val_98693 === (12))){
var inst_98678 = (state_98692[(2)]);
var state_98692__$1 = state_98692;
var statearr_98713_98743 = state_98692__$1;
(statearr_98713_98743[(2)] = inst_98678);

(statearr_98713_98743[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (2))){
var state_98692__$1 = state_98692;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_98692__$1,(4),in$);
} else {
if((state_val_98693 === (23))){
var inst_98686 = (state_98692[(2)]);
var state_98692__$1 = state_98692;
var statearr_98714_98744 = state_98692__$1;
(statearr_98714_98744[(2)] = inst_98686);

(statearr_98714_98744[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (19))){
var inst_98673 = (state_98692[(2)]);
var state_98692__$1 = state_98692;
var statearr_98715_98745 = state_98692__$1;
(statearr_98715_98745[(2)] = inst_98673);

(statearr_98715_98745[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (11))){
var inst_98658 = (state_98692[(7)]);
var inst_98644 = (state_98692[(12)]);
var inst_98658__$1 = cljs.core.seq.call(null,inst_98644);
var state_98692__$1 = (function (){var statearr_98716 = state_98692;
(statearr_98716[(7)] = inst_98658__$1);

return statearr_98716;
})();
if(inst_98658__$1){
var statearr_98717_98746 = state_98692__$1;
(statearr_98717_98746[(1)] = (14));

} else {
var statearr_98718_98747 = state_98692__$1;
(statearr_98718_98747[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (9))){
var inst_98680 = (state_98692[(2)]);
var inst_98681 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_98692__$1 = (function (){var statearr_98719 = state_98692;
(statearr_98719[(15)] = inst_98680);

return statearr_98719;
})();
if(cljs.core.truth_(inst_98681)){
var statearr_98720_98748 = state_98692__$1;
(statearr_98720_98748[(1)] = (21));

} else {
var statearr_98721_98749 = state_98692__$1;
(statearr_98721_98749[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (5))){
var inst_98636 = cljs.core.async.close_BANG_.call(null,out);
var state_98692__$1 = state_98692;
var statearr_98722_98750 = state_98692__$1;
(statearr_98722_98750[(2)] = inst_98636);

(statearr_98722_98750[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (14))){
var inst_98658 = (state_98692[(7)]);
var inst_98660 = cljs.core.chunked_seq_QMARK_.call(null,inst_98658);
var state_98692__$1 = state_98692;
if(inst_98660){
var statearr_98723_98751 = state_98692__$1;
(statearr_98723_98751[(1)] = (17));

} else {
var statearr_98724_98752 = state_98692__$1;
(statearr_98724_98752[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (16))){
var inst_98676 = (state_98692[(2)]);
var state_98692__$1 = state_98692;
var statearr_98725_98753 = state_98692__$1;
(statearr_98725_98753[(2)] = inst_98676);

(statearr_98725_98753[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98693 === (10))){
var inst_98647 = (state_98692[(8)]);
var inst_98645 = (state_98692[(10)]);
var inst_98652 = cljs.core._nth.call(null,inst_98645,inst_98647);
var state_98692__$1 = state_98692;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98692__$1,(13),out,inst_98652);
} else {
if((state_val_98693 === (18))){
var inst_98658 = (state_98692[(7)]);
var inst_98667 = cljs.core.first.call(null,inst_98658);
var state_98692__$1 = state_98692;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98692__$1,(20),out,inst_98667);
} else {
if((state_val_98693 === (8))){
var inst_98647 = (state_98692[(8)]);
var inst_98646 = (state_98692[(9)]);
var inst_98649 = (inst_98647 < inst_98646);
var inst_98650 = inst_98649;
var state_98692__$1 = state_98692;
if(cljs.core.truth_(inst_98650)){
var statearr_98726_98754 = state_98692__$1;
(statearr_98726_98754[(1)] = (10));

} else {
var statearr_98727_98755 = state_98692__$1;
(statearr_98727_98755[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto__))
;
return ((function (switch__96981__auto__,c__97076__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__96982__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__96982__auto____0 = (function (){
var statearr_98728 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_98728[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__96982__auto__);

(statearr_98728[(1)] = (1));

return statearr_98728;
});
var cljs$core$async$mapcat_STAR__$_state_machine__96982__auto____1 = (function (state_98692){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_98692);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e98729){if((e98729 instanceof Object)){
var ex__96985__auto__ = e98729;
var statearr_98730_98756 = state_98692;
(statearr_98730_98756[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98692);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e98729;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__98757 = state_98692;
state_98692 = G__98757;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__96982__auto__ = function(state_98692){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__96982__auto____1.call(this,state_98692);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$mapcat_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__96982__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__96982__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto__))
})();
var state__97078__auto__ = (function (){var statearr_98731 = f__97077__auto__.call(null);
(statearr_98731[(6)] = c__97076__auto__);

return statearr_98731;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto__))
);

return c__97076__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var G__98759 = arguments.length;
switch (G__98759) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var G__98762 = arguments.length;
switch (G__98762) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var G__98765 = arguments.length;
switch (G__98765) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__97076__auto___98812 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___98812,out){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___98812,out){
return (function (state_98789){
var state_val_98790 = (state_98789[(1)]);
if((state_val_98790 === (7))){
var inst_98784 = (state_98789[(2)]);
var state_98789__$1 = state_98789;
var statearr_98791_98813 = state_98789__$1;
(statearr_98791_98813[(2)] = inst_98784);

(statearr_98791_98813[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98790 === (1))){
var inst_98766 = null;
var state_98789__$1 = (function (){var statearr_98792 = state_98789;
(statearr_98792[(7)] = inst_98766);

return statearr_98792;
})();
var statearr_98793_98814 = state_98789__$1;
(statearr_98793_98814[(2)] = null);

(statearr_98793_98814[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98790 === (4))){
var inst_98769 = (state_98789[(8)]);
var inst_98769__$1 = (state_98789[(2)]);
var inst_98770 = (inst_98769__$1 == null);
var inst_98771 = cljs.core.not.call(null,inst_98770);
var state_98789__$1 = (function (){var statearr_98794 = state_98789;
(statearr_98794[(8)] = inst_98769__$1);

return statearr_98794;
})();
if(inst_98771){
var statearr_98795_98815 = state_98789__$1;
(statearr_98795_98815[(1)] = (5));

} else {
var statearr_98796_98816 = state_98789__$1;
(statearr_98796_98816[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98790 === (6))){
var state_98789__$1 = state_98789;
var statearr_98797_98817 = state_98789__$1;
(statearr_98797_98817[(2)] = null);

(statearr_98797_98817[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98790 === (3))){
var inst_98786 = (state_98789[(2)]);
var inst_98787 = cljs.core.async.close_BANG_.call(null,out);
var state_98789__$1 = (function (){var statearr_98798 = state_98789;
(statearr_98798[(9)] = inst_98786);

return statearr_98798;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_98789__$1,inst_98787);
} else {
if((state_val_98790 === (2))){
var state_98789__$1 = state_98789;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_98789__$1,(4),ch);
} else {
if((state_val_98790 === (11))){
var inst_98769 = (state_98789[(8)]);
var inst_98778 = (state_98789[(2)]);
var inst_98766 = inst_98769;
var state_98789__$1 = (function (){var statearr_98799 = state_98789;
(statearr_98799[(10)] = inst_98778);

(statearr_98799[(7)] = inst_98766);

return statearr_98799;
})();
var statearr_98800_98818 = state_98789__$1;
(statearr_98800_98818[(2)] = null);

(statearr_98800_98818[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98790 === (9))){
var inst_98769 = (state_98789[(8)]);
var state_98789__$1 = state_98789;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98789__$1,(11),out,inst_98769);
} else {
if((state_val_98790 === (5))){
var inst_98766 = (state_98789[(7)]);
var inst_98769 = (state_98789[(8)]);
var inst_98773 = cljs.core._EQ_.call(null,inst_98769,inst_98766);
var state_98789__$1 = state_98789;
if(inst_98773){
var statearr_98802_98819 = state_98789__$1;
(statearr_98802_98819[(1)] = (8));

} else {
var statearr_98803_98820 = state_98789__$1;
(statearr_98803_98820[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98790 === (10))){
var inst_98781 = (state_98789[(2)]);
var state_98789__$1 = state_98789;
var statearr_98804_98821 = state_98789__$1;
(statearr_98804_98821[(2)] = inst_98781);

(statearr_98804_98821[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98790 === (8))){
var inst_98766 = (state_98789[(7)]);
var tmp98801 = inst_98766;
var inst_98766__$1 = tmp98801;
var state_98789__$1 = (function (){var statearr_98805 = state_98789;
(statearr_98805[(7)] = inst_98766__$1);

return statearr_98805;
})();
var statearr_98806_98822 = state_98789__$1;
(statearr_98806_98822[(2)] = null);

(statearr_98806_98822[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___98812,out))
;
return ((function (switch__96981__auto__,c__97076__auto___98812,out){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_98807 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_98807[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_98807[(1)] = (1));

return statearr_98807;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_98789){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_98789);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e98808){if((e98808 instanceof Object)){
var ex__96985__auto__ = e98808;
var statearr_98809_98823 = state_98789;
(statearr_98809_98823[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98789);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e98808;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__98824 = state_98789;
state_98789 = G__98824;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_98789){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_98789);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___98812,out))
})();
var state__97078__auto__ = (function (){var statearr_98810 = f__97077__auto__.call(null);
(statearr_98810[(6)] = c__97076__auto___98812);

return statearr_98810;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___98812,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var G__98826 = arguments.length;
switch (G__98826) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__97076__auto___98892 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___98892,out){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___98892,out){
return (function (state_98864){
var state_val_98865 = (state_98864[(1)]);
if((state_val_98865 === (7))){
var inst_98860 = (state_98864[(2)]);
var state_98864__$1 = state_98864;
var statearr_98866_98893 = state_98864__$1;
(statearr_98866_98893[(2)] = inst_98860);

(statearr_98866_98893[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98865 === (1))){
var inst_98827 = (new Array(n));
var inst_98828 = inst_98827;
var inst_98829 = (0);
var state_98864__$1 = (function (){var statearr_98867 = state_98864;
(statearr_98867[(7)] = inst_98828);

(statearr_98867[(8)] = inst_98829);

return statearr_98867;
})();
var statearr_98868_98894 = state_98864__$1;
(statearr_98868_98894[(2)] = null);

(statearr_98868_98894[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98865 === (4))){
var inst_98832 = (state_98864[(9)]);
var inst_98832__$1 = (state_98864[(2)]);
var inst_98833 = (inst_98832__$1 == null);
var inst_98834 = cljs.core.not.call(null,inst_98833);
var state_98864__$1 = (function (){var statearr_98869 = state_98864;
(statearr_98869[(9)] = inst_98832__$1);

return statearr_98869;
})();
if(inst_98834){
var statearr_98870_98895 = state_98864__$1;
(statearr_98870_98895[(1)] = (5));

} else {
var statearr_98871_98896 = state_98864__$1;
(statearr_98871_98896[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98865 === (15))){
var inst_98854 = (state_98864[(2)]);
var state_98864__$1 = state_98864;
var statearr_98872_98897 = state_98864__$1;
(statearr_98872_98897[(2)] = inst_98854);

(statearr_98872_98897[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98865 === (13))){
var state_98864__$1 = state_98864;
var statearr_98873_98898 = state_98864__$1;
(statearr_98873_98898[(2)] = null);

(statearr_98873_98898[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98865 === (6))){
var inst_98829 = (state_98864[(8)]);
var inst_98850 = (inst_98829 > (0));
var state_98864__$1 = state_98864;
if(cljs.core.truth_(inst_98850)){
var statearr_98874_98899 = state_98864__$1;
(statearr_98874_98899[(1)] = (12));

} else {
var statearr_98875_98900 = state_98864__$1;
(statearr_98875_98900[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98865 === (3))){
var inst_98862 = (state_98864[(2)]);
var state_98864__$1 = state_98864;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_98864__$1,inst_98862);
} else {
if((state_val_98865 === (12))){
var inst_98828 = (state_98864[(7)]);
var inst_98852 = cljs.core.vec.call(null,inst_98828);
var state_98864__$1 = state_98864;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98864__$1,(15),out,inst_98852);
} else {
if((state_val_98865 === (2))){
var state_98864__$1 = state_98864;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_98864__$1,(4),ch);
} else {
if((state_val_98865 === (11))){
var inst_98844 = (state_98864[(2)]);
var inst_98845 = (new Array(n));
var inst_98828 = inst_98845;
var inst_98829 = (0);
var state_98864__$1 = (function (){var statearr_98876 = state_98864;
(statearr_98876[(10)] = inst_98844);

(statearr_98876[(7)] = inst_98828);

(statearr_98876[(8)] = inst_98829);

return statearr_98876;
})();
var statearr_98877_98901 = state_98864__$1;
(statearr_98877_98901[(2)] = null);

(statearr_98877_98901[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98865 === (9))){
var inst_98828 = (state_98864[(7)]);
var inst_98842 = cljs.core.vec.call(null,inst_98828);
var state_98864__$1 = state_98864;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98864__$1,(11),out,inst_98842);
} else {
if((state_val_98865 === (5))){
var inst_98837 = (state_98864[(11)]);
var inst_98832 = (state_98864[(9)]);
var inst_98828 = (state_98864[(7)]);
var inst_98829 = (state_98864[(8)]);
var inst_98836 = (inst_98828[inst_98829] = inst_98832);
var inst_98837__$1 = (inst_98829 + (1));
var inst_98838 = (inst_98837__$1 < n);
var state_98864__$1 = (function (){var statearr_98878 = state_98864;
(statearr_98878[(11)] = inst_98837__$1);

(statearr_98878[(12)] = inst_98836);

return statearr_98878;
})();
if(cljs.core.truth_(inst_98838)){
var statearr_98879_98902 = state_98864__$1;
(statearr_98879_98902[(1)] = (8));

} else {
var statearr_98880_98903 = state_98864__$1;
(statearr_98880_98903[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98865 === (14))){
var inst_98857 = (state_98864[(2)]);
var inst_98858 = cljs.core.async.close_BANG_.call(null,out);
var state_98864__$1 = (function (){var statearr_98882 = state_98864;
(statearr_98882[(13)] = inst_98857);

return statearr_98882;
})();
var statearr_98883_98904 = state_98864__$1;
(statearr_98883_98904[(2)] = inst_98858);

(statearr_98883_98904[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98865 === (10))){
var inst_98848 = (state_98864[(2)]);
var state_98864__$1 = state_98864;
var statearr_98884_98905 = state_98864__$1;
(statearr_98884_98905[(2)] = inst_98848);

(statearr_98884_98905[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98865 === (8))){
var inst_98837 = (state_98864[(11)]);
var inst_98828 = (state_98864[(7)]);
var tmp98881 = inst_98828;
var inst_98828__$1 = tmp98881;
var inst_98829 = inst_98837;
var state_98864__$1 = (function (){var statearr_98885 = state_98864;
(statearr_98885[(7)] = inst_98828__$1);

(statearr_98885[(8)] = inst_98829);

return statearr_98885;
})();
var statearr_98886_98906 = state_98864__$1;
(statearr_98886_98906[(2)] = null);

(statearr_98886_98906[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___98892,out))
;
return ((function (switch__96981__auto__,c__97076__auto___98892,out){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_98887 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_98887[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_98887[(1)] = (1));

return statearr_98887;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_98864){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_98864);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e98888){if((e98888 instanceof Object)){
var ex__96985__auto__ = e98888;
var statearr_98889_98907 = state_98864;
(statearr_98889_98907[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98864);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e98888;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__98908 = state_98864;
state_98864 = G__98908;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_98864){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_98864);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___98892,out))
})();
var state__97078__auto__ = (function (){var statearr_98890 = f__97077__auto__.call(null);
(statearr_98890[(6)] = c__97076__auto___98892);

return statearr_98890;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___98892,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var G__98910 = arguments.length;
switch (G__98910) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__97076__auto___98980 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__97076__auto___98980,out){
return (function (){
var f__97077__auto__ = (function (){var switch__96981__auto__ = ((function (c__97076__auto___98980,out){
return (function (state_98952){
var state_val_98953 = (state_98952[(1)]);
if((state_val_98953 === (7))){
var inst_98948 = (state_98952[(2)]);
var state_98952__$1 = state_98952;
var statearr_98954_98981 = state_98952__$1;
(statearr_98954_98981[(2)] = inst_98948);

(statearr_98954_98981[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98953 === (1))){
var inst_98911 = [];
var inst_98912 = inst_98911;
var inst_98913 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_98952__$1 = (function (){var statearr_98955 = state_98952;
(statearr_98955[(7)] = inst_98912);

(statearr_98955[(8)] = inst_98913);

return statearr_98955;
})();
var statearr_98956_98982 = state_98952__$1;
(statearr_98956_98982[(2)] = null);

(statearr_98956_98982[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98953 === (4))){
var inst_98916 = (state_98952[(9)]);
var inst_98916__$1 = (state_98952[(2)]);
var inst_98917 = (inst_98916__$1 == null);
var inst_98918 = cljs.core.not.call(null,inst_98917);
var state_98952__$1 = (function (){var statearr_98957 = state_98952;
(statearr_98957[(9)] = inst_98916__$1);

return statearr_98957;
})();
if(inst_98918){
var statearr_98958_98983 = state_98952__$1;
(statearr_98958_98983[(1)] = (5));

} else {
var statearr_98959_98984 = state_98952__$1;
(statearr_98959_98984[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98953 === (15))){
var inst_98942 = (state_98952[(2)]);
var state_98952__$1 = state_98952;
var statearr_98960_98985 = state_98952__$1;
(statearr_98960_98985[(2)] = inst_98942);

(statearr_98960_98985[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98953 === (13))){
var state_98952__$1 = state_98952;
var statearr_98961_98986 = state_98952__$1;
(statearr_98961_98986[(2)] = null);

(statearr_98961_98986[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98953 === (6))){
var inst_98912 = (state_98952[(7)]);
var inst_98937 = inst_98912.length;
var inst_98938 = (inst_98937 > (0));
var state_98952__$1 = state_98952;
if(cljs.core.truth_(inst_98938)){
var statearr_98962_98987 = state_98952__$1;
(statearr_98962_98987[(1)] = (12));

} else {
var statearr_98963_98988 = state_98952__$1;
(statearr_98963_98988[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98953 === (3))){
var inst_98950 = (state_98952[(2)]);
var state_98952__$1 = state_98952;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_98952__$1,inst_98950);
} else {
if((state_val_98953 === (12))){
var inst_98912 = (state_98952[(7)]);
var inst_98940 = cljs.core.vec.call(null,inst_98912);
var state_98952__$1 = state_98952;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98952__$1,(15),out,inst_98940);
} else {
if((state_val_98953 === (2))){
var state_98952__$1 = state_98952;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_98952__$1,(4),ch);
} else {
if((state_val_98953 === (11))){
var inst_98916 = (state_98952[(9)]);
var inst_98920 = (state_98952[(10)]);
var inst_98930 = (state_98952[(2)]);
var inst_98931 = [];
var inst_98932 = inst_98931.push(inst_98916);
var inst_98912 = inst_98931;
var inst_98913 = inst_98920;
var state_98952__$1 = (function (){var statearr_98964 = state_98952;
(statearr_98964[(11)] = inst_98932);

(statearr_98964[(12)] = inst_98930);

(statearr_98964[(7)] = inst_98912);

(statearr_98964[(8)] = inst_98913);

return statearr_98964;
})();
var statearr_98965_98989 = state_98952__$1;
(statearr_98965_98989[(2)] = null);

(statearr_98965_98989[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98953 === (9))){
var inst_98912 = (state_98952[(7)]);
var inst_98928 = cljs.core.vec.call(null,inst_98912);
var state_98952__$1 = state_98952;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_98952__$1,(11),out,inst_98928);
} else {
if((state_val_98953 === (5))){
var inst_98916 = (state_98952[(9)]);
var inst_98920 = (state_98952[(10)]);
var inst_98913 = (state_98952[(8)]);
var inst_98920__$1 = f.call(null,inst_98916);
var inst_98921 = cljs.core._EQ_.call(null,inst_98920__$1,inst_98913);
var inst_98922 = cljs.core.keyword_identical_QMARK_.call(null,inst_98913,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_98923 = ((inst_98921) || (inst_98922));
var state_98952__$1 = (function (){var statearr_98966 = state_98952;
(statearr_98966[(10)] = inst_98920__$1);

return statearr_98966;
})();
if(cljs.core.truth_(inst_98923)){
var statearr_98967_98990 = state_98952__$1;
(statearr_98967_98990[(1)] = (8));

} else {
var statearr_98968_98991 = state_98952__$1;
(statearr_98968_98991[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98953 === (14))){
var inst_98945 = (state_98952[(2)]);
var inst_98946 = cljs.core.async.close_BANG_.call(null,out);
var state_98952__$1 = (function (){var statearr_98970 = state_98952;
(statearr_98970[(13)] = inst_98945);

return statearr_98970;
})();
var statearr_98971_98992 = state_98952__$1;
(statearr_98971_98992[(2)] = inst_98946);

(statearr_98971_98992[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98953 === (10))){
var inst_98935 = (state_98952[(2)]);
var state_98952__$1 = state_98952;
var statearr_98972_98993 = state_98952__$1;
(statearr_98972_98993[(2)] = inst_98935);

(statearr_98972_98993[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_98953 === (8))){
var inst_98916 = (state_98952[(9)]);
var inst_98912 = (state_98952[(7)]);
var inst_98920 = (state_98952[(10)]);
var inst_98925 = inst_98912.push(inst_98916);
var tmp98969 = inst_98912;
var inst_98912__$1 = tmp98969;
var inst_98913 = inst_98920;
var state_98952__$1 = (function (){var statearr_98973 = state_98952;
(statearr_98973[(14)] = inst_98925);

(statearr_98973[(7)] = inst_98912__$1);

(statearr_98973[(8)] = inst_98913);

return statearr_98973;
})();
var statearr_98974_98994 = state_98952__$1;
(statearr_98974_98994[(2)] = null);

(statearr_98974_98994[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__97076__auto___98980,out))
;
return ((function (switch__96981__auto__,c__97076__auto___98980,out){
return (function() {
var cljs$core$async$state_machine__96982__auto__ = null;
var cljs$core$async$state_machine__96982__auto____0 = (function (){
var statearr_98975 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_98975[(0)] = cljs$core$async$state_machine__96982__auto__);

(statearr_98975[(1)] = (1));

return statearr_98975;
});
var cljs$core$async$state_machine__96982__auto____1 = (function (state_98952){
while(true){
var ret_value__96983__auto__ = (function (){try{while(true){
var result__96984__auto__ = switch__96981__auto__.call(null,state_98952);
if(cljs.core.keyword_identical_QMARK_.call(null,result__96984__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__96984__auto__;
}
break;
}
}catch (e98976){if((e98976 instanceof Object)){
var ex__96985__auto__ = e98976;
var statearr_98977_98995 = state_98952;
(statearr_98977_98995[(5)] = ex__96985__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_98952);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e98976;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__96983__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__98996 = state_98952;
state_98952 = G__98996;
continue;
} else {
return ret_value__96983__auto__;
}
break;
}
});
cljs$core$async$state_machine__96982__auto__ = function(state_98952){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__96982__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__96982__auto____1.call(this,state_98952);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__96982__auto____0;
cljs$core$async$state_machine__96982__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__96982__auto____1;
return cljs$core$async$state_machine__96982__auto__;
})()
;})(switch__96981__auto__,c__97076__auto___98980,out))
})();
var state__97078__auto__ = (function (){var statearr_98978 = f__97077__auto__.call(null);
(statearr_98978[(6)] = c__97076__auto___98980);

return statearr_98978;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__97078__auto__);
});})(c__97076__auto___98980,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;

