// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.connection');
goog.require('cljs.core');
goog.require('clojure.string');
goog.require('cljs.core.async');
goog.require('fluree.db.util.json');
goog.require('fluree.db.util.log');
goog.require('cljs.cache');
goog.require('fluree.db.session');
goog.require('fluree.db.util.xhttp');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.async');
goog.require('fluree.db.serde.json');
goog.require('fluree.db.query.http_signatures');
fluree.db.connection.server_connections_atom = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
 * Tries all servers in parralel, the first healthy response will be used for the connection
 *   (additional server healthy writes will be no-ops after first).
 */
fluree.db.connection.acquire_healthy_server = (function fluree$db$connection$acquire_healthy_server(conn_id,servers,promise_chan){
var seq__103568_103731 = cljs.core.seq.call(null,servers);
var chunk__103569_103732 = null;
var count__103570_103733 = (0);
var i__103571_103734 = (0);
while(true){
if((i__103571_103734 < count__103570_103733)){
var server_103735 = cljs.core._nth.call(null,chunk__103569_103732,i__103571_103734);
var healthcheck_uri_103736 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(server_103735),"/fdb/health"].join('');
var resp_chan_103737 = fluree.db.util.xhttp.post_json.call(null,healthcheck_uri_103736,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"request-timeout","request-timeout",-2047539823),(5000)], null));
var c__86675__auto___103738 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,c__86675__auto___103738,healthcheck_uri_103736,resp_chan_103737,server_103735){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,c__86675__auto___103738,healthcheck_uri_103736,resp_chan_103737,server_103735){
return (function (state_103630){
var state_val_103631 = (state_103630[(1)]);
if((state_val_103631 === (1))){
var state_103630__$1 = state_103630;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_103630__$1,(2),resp_chan_103737);
} else {
if((state_val_103631 === (2))){
var inst_103619 = (state_103630[(7)]);
var inst_103619__$1 = (state_103630[(2)]);
var inst_103620 = fluree.db.util.core.exception_QMARK_.call(null,inst_103619__$1);
var state_103630__$1 = (function (){var statearr_103632 = state_103630;
(statearr_103632[(7)] = inst_103619__$1);

return statearr_103632;
})();
if(inst_103620){
var statearr_103633_103739 = state_103630__$1;
(statearr_103633_103739[(1)] = (3));

} else {
var statearr_103634_103740 = state_103630__$1;
(statearr_103634_103740[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103631 === (3))){
var inst_103619 = (state_103630[(7)]);
var inst_103622 = cljs.core.ex_message.call(null,inst_103619);
var inst_103623 = cljs.core.ex_data.call(null,inst_103619);
var inst_103624 = fluree.db.util.log.warn.call(null,"Server contact error: ",inst_103622,inst_103623);
var state_103630__$1 = state_103630;
var statearr_103635_103741 = state_103630__$1;
(statearr_103635_103741[(2)] = inst_103624);

(statearr_103635_103741[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103631 === (4))){
var inst_103626 = cljs.core.async.put_BANG_.call(null,promise_chan,server_103735);
var state_103630__$1 = state_103630;
var statearr_103636_103742 = state_103630__$1;
(statearr_103636_103742[(2)] = inst_103626);

(statearr_103636_103742[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103631 === (5))){
var inst_103628 = (state_103630[(2)]);
var state_103630__$1 = state_103630;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_103630__$1,inst_103628);
} else {
return null;
}
}
}
}
}
});})(seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,c__86675__auto___103738,healthcheck_uri_103736,resp_chan_103737,server_103735))
;
return ((function (seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,switch__86624__auto__,c__86675__auto___103738,healthcheck_uri_103736,resp_chan_103737,server_103735){
return (function() {
var fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__ = null;
var fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____0 = (function (){
var statearr_103637 = [null,null,null,null,null,null,null,null];
(statearr_103637[(0)] = fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__);

(statearr_103637[(1)] = (1));

return statearr_103637;
});
var fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____1 = (function (state_103630){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_103630);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e103638){if((e103638 instanceof Object)){
var ex__86628__auto__ = e103638;
var statearr_103639_103743 = state_103630;
(statearr_103639_103743[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_103630);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e103638;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__103744 = state_103630;
state_103630 = G__103744;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__ = function(state_103630){
switch(arguments.length){
case 0:
return fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____1.call(this,state_103630);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____0;
fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____1;
return fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__;
})()
;})(seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,switch__86624__auto__,c__86675__auto___103738,healthcheck_uri_103736,resp_chan_103737,server_103735))
})();
var state__86677__auto__ = (function (){var statearr_103640 = f__86676__auto__.call(null);
(statearr_103640[(6)] = c__86675__auto___103738);

return statearr_103640;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,c__86675__auto___103738,healthcheck_uri_103736,resp_chan_103737,server_103735))
);



var G__103745 = seq__103568_103731;
var G__103746 = chunk__103569_103732;
var G__103747 = count__103570_103733;
var G__103748 = (i__103571_103734 + (1));
seq__103568_103731 = G__103745;
chunk__103569_103732 = G__103746;
count__103570_103733 = G__103747;
i__103571_103734 = G__103748;
continue;
} else {
var temp__5735__auto___103749 = cljs.core.seq.call(null,seq__103568_103731);
if(temp__5735__auto___103749){
var seq__103568_103750__$1 = temp__5735__auto___103749;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__103568_103750__$1)){
var c__4550__auto___103751 = cljs.core.chunk_first.call(null,seq__103568_103750__$1);
var G__103752 = cljs.core.chunk_rest.call(null,seq__103568_103750__$1);
var G__103753 = c__4550__auto___103751;
var G__103754 = cljs.core.count.call(null,c__4550__auto___103751);
var G__103755 = (0);
seq__103568_103731 = G__103752;
chunk__103569_103732 = G__103753;
count__103570_103733 = G__103754;
i__103571_103734 = G__103755;
continue;
} else {
var server_103756 = cljs.core.first.call(null,seq__103568_103750__$1);
var healthcheck_uri_103757 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(server_103756),"/fdb/health"].join('');
var resp_chan_103758 = fluree.db.util.xhttp.post_json.call(null,healthcheck_uri_103757,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"request-timeout","request-timeout",-2047539823),(5000)], null));
var c__86675__auto___103759 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,c__86675__auto___103759,healthcheck_uri_103757,resp_chan_103758,server_103756,seq__103568_103750__$1,temp__5735__auto___103749){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,c__86675__auto___103759,healthcheck_uri_103757,resp_chan_103758,server_103756,seq__103568_103750__$1,temp__5735__auto___103749){
return (function (state_103653){
var state_val_103654 = (state_103653[(1)]);
if((state_val_103654 === (1))){
var state_103653__$1 = state_103653;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_103653__$1,(2),resp_chan_103758);
} else {
if((state_val_103654 === (2))){
var inst_103642 = (state_103653[(7)]);
var inst_103642__$1 = (state_103653[(2)]);
var inst_103643 = fluree.db.util.core.exception_QMARK_.call(null,inst_103642__$1);
var state_103653__$1 = (function (){var statearr_103655 = state_103653;
(statearr_103655[(7)] = inst_103642__$1);

return statearr_103655;
})();
if(inst_103643){
var statearr_103656_103760 = state_103653__$1;
(statearr_103656_103760[(1)] = (3));

} else {
var statearr_103657_103761 = state_103653__$1;
(statearr_103657_103761[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103654 === (3))){
var inst_103642 = (state_103653[(7)]);
var inst_103645 = cljs.core.ex_message.call(null,inst_103642);
var inst_103646 = cljs.core.ex_data.call(null,inst_103642);
var inst_103647 = fluree.db.util.log.warn.call(null,"Server contact error: ",inst_103645,inst_103646);
var state_103653__$1 = state_103653;
var statearr_103658_103762 = state_103653__$1;
(statearr_103658_103762[(2)] = inst_103647);

(statearr_103658_103762[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103654 === (4))){
var inst_103649 = cljs.core.async.put_BANG_.call(null,promise_chan,server_103756);
var state_103653__$1 = state_103653;
var statearr_103659_103763 = state_103653__$1;
(statearr_103659_103763[(2)] = inst_103649);

(statearr_103659_103763[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103654 === (5))){
var inst_103651 = (state_103653[(2)]);
var state_103653__$1 = state_103653;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_103653__$1,inst_103651);
} else {
return null;
}
}
}
}
}
});})(seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,c__86675__auto___103759,healthcheck_uri_103757,resp_chan_103758,server_103756,seq__103568_103750__$1,temp__5735__auto___103749))
;
return ((function (seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,switch__86624__auto__,c__86675__auto___103759,healthcheck_uri_103757,resp_chan_103758,server_103756,seq__103568_103750__$1,temp__5735__auto___103749){
return (function() {
var fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__ = null;
var fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____0 = (function (){
var statearr_103660 = [null,null,null,null,null,null,null,null];
(statearr_103660[(0)] = fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__);

(statearr_103660[(1)] = (1));

return statearr_103660;
});
var fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____1 = (function (state_103653){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_103653);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e103661){if((e103661 instanceof Object)){
var ex__86628__auto__ = e103661;
var statearr_103662_103764 = state_103653;
(statearr_103662_103764[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_103653);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e103661;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__103765 = state_103653;
state_103653 = G__103765;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__ = function(state_103653){
switch(arguments.length){
case 0:
return fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____1.call(this,state_103653);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____0;
fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____1;
return fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__;
})()
;})(seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,switch__86624__auto__,c__86675__auto___103759,healthcheck_uri_103757,resp_chan_103758,server_103756,seq__103568_103750__$1,temp__5735__auto___103749))
})();
var state__86677__auto__ = (function (){var statearr_103663 = f__86676__auto__.call(null);
(statearr_103663[(6)] = c__86675__auto___103759);

return statearr_103663;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(seq__103568_103731,chunk__103569_103732,count__103570_103733,i__103571_103734,c__86675__auto___103759,healthcheck_uri_103757,resp_chan_103758,server_103756,seq__103568_103750__$1,temp__5735__auto___103749))
);



var G__103766 = cljs.core.next.call(null,seq__103568_103750__$1);
var G__103767 = null;
var G__103768 = (0);
var G__103769 = (0);
seq__103568_103731 = G__103766;
chunk__103569_103732 = G__103767;
count__103570_103733 = G__103768;
i__103571_103734 = G__103769;
continue;
}
} else {
}
}
break;
}

var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_103706){
var state_val_103707 = (state_103706[(1)]);
if((state_val_103707 === (7))){
var inst_103678 = (state_103706[(7)]);
var inst_103685 = cljs.core._EQ_.call(null,inst_103678,new cljs.core.Keyword(null,"default","default",-1987822328));
var state_103706__$1 = state_103706;
if(inst_103685){
var statearr_103708_103770 = state_103706__$1;
(statearr_103708_103770[(1)] = (9));

} else {
var statearr_103709_103771 = state_103706__$1;
(statearr_103709_103771[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (1))){
var inst_103671 = (state_103706[(8)]);
var inst_103671__$1 = cljs.core.async.timeout.call(null,(60000));
var inst_103672 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_103673 = [promise_chan,inst_103671__$1];
var inst_103674 = (new cljs.core.PersistentVector(null,2,(5),inst_103672,inst_103673,null));
var state_103706__$1 = (function (){var statearr_103710 = state_103706;
(statearr_103710[(8)] = inst_103671__$1);

return statearr_103710;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_103706__$1,(2),inst_103674);
} else {
if((state_val_103707 === (4))){
var inst_103671 = (state_103706[(8)]);
var inst_103678 = (state_103706[(7)]);
var inst_103682 = cljs.core._EQ_.call(null,inst_103678,inst_103671);
var state_103706__$1 = state_103706;
if(inst_103682){
var statearr_103711_103772 = state_103706__$1;
(statearr_103711_103772[(1)] = (6));

} else {
var statearr_103712_103773 = state_103706__$1;
(statearr_103712_103773[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (13))){
var state_103706__$1 = state_103706;
var statearr_103713_103774 = state_103706__$1;
(statearr_103713_103774[(2)] = null);

(statearr_103713_103774[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (6))){
var state_103706__$1 = state_103706;
var statearr_103714_103775 = state_103706__$1;
(statearr_103714_103775[(2)] = new cljs.core.Keyword("fluree.db.connection","timeout","fluree.db.connection/timeout",-1888211715));

(statearr_103714_103775[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (3))){
var state_103706__$1 = state_103706;
var statearr_103715_103776 = state_103706__$1;
(statearr_103715_103776[(2)] = new cljs.core.Keyword("fluree.db.connection","server-found","fluree.db.connection/server-found",-972719416));

(statearr_103715_103776[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (12))){
var inst_103696 = cljs.core.swap_BANG_.call(null,fluree.db.connection.server_connections_atom,cljs.core.update,conn_id,cljs.core.dissoc,new cljs.core.Keyword(null,"server","server",1499190120));
var inst_103697 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_103698 = [(500),new cljs.core.Keyword("db","connection-error","db/connection-error",-707380971)];
var inst_103699 = cljs.core.PersistentHashMap.fromArrays(inst_103697,inst_103698);
var inst_103700 = cljs.core.ex_info.call(null,"Unable to find healthy server before timeout.",inst_103699);
var inst_103701 = cljs.core.async.put_BANG_.call(null,promise_chan,inst_103700);
var state_103706__$1 = (function (){var statearr_103716 = state_103706;
(statearr_103716[(9)] = inst_103696);

return statearr_103716;
})();
var statearr_103717_103777 = state_103706__$1;
(statearr_103717_103777[(2)] = inst_103701);

(statearr_103717_103777[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (2))){
var inst_103678 = (state_103706[(7)]);
var inst_103676 = (state_103706[(2)]);
var inst_103677 = cljs.core.nth.call(null,inst_103676,(0),null);
var inst_103678__$1 = cljs.core.nth.call(null,inst_103676,(1),null);
var inst_103679 = cljs.core._EQ_.call(null,inst_103678__$1,promise_chan);
var state_103706__$1 = (function (){var statearr_103718 = state_103706;
(statearr_103718[(10)] = inst_103677);

(statearr_103718[(7)] = inst_103678__$1);

return statearr_103718;
})();
if(inst_103679){
var statearr_103719_103778 = state_103706__$1;
(statearr_103719_103778[(1)] = (3));

} else {
var statearr_103720_103779 = state_103706__$1;
(statearr_103720_103779[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (11))){
var inst_103689 = (state_103706[(2)]);
var state_103706__$1 = state_103706;
var statearr_103721_103780 = state_103706__$1;
(statearr_103721_103780[(2)] = inst_103689);

(statearr_103721_103780[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (9))){
var inst_103677 = (state_103706[(10)]);
var state_103706__$1 = state_103706;
var statearr_103722_103781 = state_103706__$1;
(statearr_103722_103781[(2)] = inst_103677);

(statearr_103722_103781[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (5))){
var inst_103693 = (state_103706[(2)]);
var inst_103694 = cljs.core._EQ_.call(null,new cljs.core.Keyword("fluree.db.connection","timeout","fluree.db.connection/timeout",-1888211715),inst_103693);
var state_103706__$1 = state_103706;
if(inst_103694){
var statearr_103723_103782 = state_103706__$1;
(statearr_103723_103782[(1)] = (12));

} else {
var statearr_103724_103783 = state_103706__$1;
(statearr_103724_103783[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (14))){
var inst_103704 = (state_103706[(2)]);
var state_103706__$1 = state_103706;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_103706__$1,inst_103704);
} else {
if((state_val_103707 === (10))){
var state_103706__$1 = state_103706;
var statearr_103725_103784 = state_103706__$1;
(statearr_103725_103784[(2)] = null);

(statearr_103725_103784[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103707 === (8))){
var inst_103691 = (state_103706[(2)]);
var state_103706__$1 = state_103706;
var statearr_103726_103785 = state_103706__$1;
(statearr_103726_103785[(2)] = inst_103691);

(statearr_103726_103785[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__ = null;
var fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____0 = (function (){
var statearr_103727 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_103727[(0)] = fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__);

(statearr_103727[(1)] = (1));

return statearr_103727;
});
var fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____1 = (function (state_103706){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_103706);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e103728){if((e103728 instanceof Object)){
var ex__86628__auto__ = e103728;
var statearr_103729_103786 = state_103706;
(statearr_103729_103786[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_103706);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e103728;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__103787 = state_103706;
state_103706 = G__103787;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__ = function(state_103706){
switch(arguments.length){
case 0:
return fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____1.call(this,state_103706);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____0;
fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto____1;
return fluree$db$connection$acquire_healthy_server_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_103730 = f__86676__auto__.call(null);
(statearr_103730[(6)] = c__86675__auto__);

return statearr_103730;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Returns a core async channel that will contain first healthy as it appears.
 * 
 *   Use with a timeout to consume, as no healthy servers may be avail.
 */
fluree.db.connection.get_healthy_server = (function fluree$db$connection$get_healthy_server(conn_id,servers){
var lock_id = fluree.db.util.core.random_uuid.call(null);
var new_state = cljs.core.swap_BANG_.call(null,fluree.db.connection.server_connections_atom,cljs.core.update_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,new cljs.core.Keyword(null,"server","server",1499190120)], null),((function (lock_id){
return (function (x){
if(cljs.core.truth_(x)){
return x;
} else {
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"lock-id","lock-id",1910364390),lock_id,new cljs.core.Keyword(null,"chan","chan",-2103021695),cljs.core.async.promise_chan.call(null)], null);
}
});})(lock_id))
);
var have_lock_QMARK_ = cljs.core._EQ_.call(null,lock_id,cljs.core.get_in.call(null,new_state,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,new cljs.core.Keyword(null,"server","server",1499190120),new cljs.core.Keyword(null,"lock-id","lock-id",1910364390)], null)));
var promise_chan = cljs.core.get_in.call(null,new_state,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,new cljs.core.Keyword(null,"server","server",1499190120),new cljs.core.Keyword(null,"chan","chan",-2103021695)], null));
if(have_lock_QMARK_){
fluree.db.connection.acquire_healthy_server.call(null,conn_id,servers,promise_chan);
} else {
}

return promise_chan;
});
fluree.db.connection.establish_socket = (function fluree$db$connection$establish_socket(conn_id,sub_chan,pub_chan,servers){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_103828){
var state_val_103829 = (state_103828[(1)]);
if((state_val_103829 === (7))){
var inst_103806 = (state_103828[(7)]);
var inst_103824 = (state_103828[(2)]);
var state_103828__$1 = (function (){var statearr_103830 = state_103828;
(statearr_103830[(8)] = inst_103824);

return statearr_103830;
})();
var statearr_103831_103849 = state_103828__$1;
(statearr_103831_103849[(2)] = inst_103806);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_103828__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103829 === (1))){
var state_103828__$1 = state_103828;
var statearr_103832_103850 = state_103828__$1;
(statearr_103832_103850[(2)] = null);

(statearr_103832_103850[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103829 === (4))){
var inst_103797 = (state_103828[(9)]);
var inst_103792 = (state_103828[(10)]);
var inst_103802 = (state_103828[(11)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_103828,(3),Error,null,(2));
var inst_103792__$1 = fluree.db.util.core.random_uuid.call(null);
var inst_103793 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_103794 = [conn_id,new cljs.core.Keyword(null,"ws","ws",86841443)];
var inst_103795 = (new cljs.core.PersistentVector(null,2,(5),inst_103793,inst_103794,null));
var inst_103796 = (function (){var lock_id = inst_103792__$1;
return ((function (lock_id,inst_103797,inst_103792,inst_103802,_,inst_103792__$1,inst_103793,inst_103794,inst_103795,state_val_103829,c__86675__auto__){
return (function (x){
if(cljs.core.truth_(x)){
return x;
} else {
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"lock-id","lock-id",1910364390),lock_id,new cljs.core.Keyword(null,"socket","socket",59137063),cljs.core.async.promise_chan.call(null)], null);
}
});
;})(lock_id,inst_103797,inst_103792,inst_103802,_,inst_103792__$1,inst_103793,inst_103794,inst_103795,state_val_103829,c__86675__auto__))
})();
var inst_103797__$1 = cljs.core.swap_BANG_.call(null,fluree.db.connection.server_connections_atom,cljs.core.update_in,inst_103795,inst_103796);
var inst_103798 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_103799 = [conn_id,new cljs.core.Keyword(null,"ws","ws",86841443),new cljs.core.Keyword(null,"lock-id","lock-id",1910364390)];
var inst_103800 = (new cljs.core.PersistentVector(null,3,(5),inst_103798,inst_103799,null));
var inst_103801 = cljs.core.get_in.call(null,inst_103797__$1,inst_103800);
var inst_103802__$1 = cljs.core._EQ_.call(null,inst_103792__$1,inst_103801);
var inst_103803 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_103804 = [conn_id,new cljs.core.Keyword(null,"ws","ws",86841443),new cljs.core.Keyword(null,"socket","socket",59137063)];
var inst_103805 = (new cljs.core.PersistentVector(null,3,(5),inst_103803,inst_103804,null));
var inst_103806 = cljs.core.get_in.call(null,inst_103797__$1,inst_103805);
var state_103828__$1 = (function (){var statearr_103833 = state_103828;
(statearr_103833[(9)] = inst_103797__$1);

(statearr_103833[(10)] = inst_103792__$1);

(statearr_103833[(7)] = inst_103806);

(statearr_103833[(11)] = inst_103802__$1);

return statearr_103833;
})();
if(inst_103802__$1){
var statearr_103834_103851 = state_103828__$1;
(statearr_103834_103851[(1)] = (5));

} else {
var statearr_103835_103852 = state_103828__$1;
(statearr_103835_103852[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103829 === (6))){
var state_103828__$1 = state_103828;
var statearr_103836_103853 = state_103828__$1;
(statearr_103836_103853[(2)] = null);

(statearr_103836_103853[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103829 === (3))){
var inst_103788 = (state_103828[(2)]);
var state_103828__$1 = state_103828;
var statearr_103837_103854 = state_103828__$1;
(statearr_103837_103854[(2)] = inst_103788);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_103828__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103829 === (2))){
var inst_103826 = (state_103828[(2)]);
var state_103828__$1 = state_103828;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_103828__$1,inst_103826);
} else {
if((state_val_103829 === (11))){
var inst_103821 = (state_103828[(2)]);
var state_103828__$1 = state_103828;
var statearr_103838_103855 = state_103828__$1;
(statearr_103838_103855[(2)] = inst_103821);

(statearr_103838_103855[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103829 === (9))){
var inst_103810 = (state_103828[(12)]);
var inst_103806 = (state_103828[(7)]);
var inst_103816 = cljs.core.swap_BANG_.call(null,fluree.db.connection.server_connections_atom,cljs.core.update,conn_id,cljs.core.dissoc,new cljs.core.Keyword(null,"ws","ws",86841443));
var inst_103817 = cljs.core.async.put_BANG_.call(null,inst_103806,inst_103810);
var state_103828__$1 = (function (){var statearr_103839 = state_103828;
(statearr_103839[(13)] = inst_103816);

return statearr_103839;
})();
var statearr_103840_103856 = state_103828__$1;
(statearr_103840_103856[(2)] = inst_103817);

(statearr_103840_103856[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103829 === (5))){
var inst_103808 = fluree.db.connection.get_healthy_server.call(null,conn_id,servers);
var state_103828__$1 = state_103828;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_103828__$1,(8),inst_103808);
} else {
if((state_val_103829 === (10))){
var inst_103813 = (state_103828[(14)]);
var inst_103806 = (state_103828[(7)]);
var inst_103812 = (state_103828[(15)]);
var inst_103819 = fluree.db.util.xhttp.try_socket.call(null,inst_103812,sub_chan,pub_chan,inst_103806,(60000),inst_103813);
var state_103828__$1 = state_103828;
var statearr_103841_103857 = state_103828__$1;
(statearr_103841_103857[(2)] = inst_103819);

(statearr_103841_103857[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103829 === (8))){
var inst_103797 = (state_103828[(9)]);
var inst_103792 = (state_103828[(10)]);
var inst_103810 = (state_103828[(12)]);
var inst_103806 = (state_103828[(7)]);
var inst_103812 = (state_103828[(15)]);
var inst_103802 = (state_103828[(11)]);
var inst_103810__$1 = (state_103828[(2)]);
var inst_103811 = clojure.string.replace.call(null,inst_103810__$1,"http","ws");
var inst_103812__$1 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_103811),"/fdb/ws"].join('');
var inst_103813 = (function (){var lock_id = inst_103792;
var state = inst_103797;
var have_lock_QMARK_ = inst_103802;
var resp_chan = inst_103806;
var healthy_server = inst_103810__$1;
var ws_url = inst_103812__$1;
var timeout = (60000);
return ((function (lock_id,state,have_lock_QMARK_,resp_chan,healthy_server,ws_url,timeout,inst_103797,inst_103792,inst_103810,inst_103806,inst_103812,inst_103802,inst_103810__$1,inst_103811,inst_103812__$1,state_val_103829,c__86675__auto__){
return (function (){
cljs.core.swap_BANG_.call(null,fluree.db.connection.server_connections_atom,cljs.core.dissoc,conn_id);

return fluree.db.session.close_all_sessions.call(null,conn_id);
});
;})(lock_id,state,have_lock_QMARK_,resp_chan,healthy_server,ws_url,timeout,inst_103797,inst_103792,inst_103810,inst_103806,inst_103812,inst_103802,inst_103810__$1,inst_103811,inst_103812__$1,state_val_103829,c__86675__auto__))
})();
var inst_103814 = fluree.db.util.core.exception_QMARK_.call(null,inst_103810__$1);
var state_103828__$1 = (function (){var statearr_103842 = state_103828;
(statearr_103842[(14)] = inst_103813);

(statearr_103842[(12)] = inst_103810__$1);

(statearr_103842[(15)] = inst_103812__$1);

return statearr_103842;
})();
if(inst_103814){
var statearr_103843_103858 = state_103828__$1;
(statearr_103843_103858[(1)] = (9));

} else {
var statearr_103844_103859 = state_103828__$1;
(statearr_103844_103859[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$connection$establish_socket_$_state_machine__86625__auto__ = null;
var fluree$db$connection$establish_socket_$_state_machine__86625__auto____0 = (function (){
var statearr_103845 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_103845[(0)] = fluree$db$connection$establish_socket_$_state_machine__86625__auto__);

(statearr_103845[(1)] = (1));

return statearr_103845;
});
var fluree$db$connection$establish_socket_$_state_machine__86625__auto____1 = (function (state_103828){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_103828);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e103846){if((e103846 instanceof Object)){
var ex__86628__auto__ = e103846;
var statearr_103847_103860 = state_103828;
(statearr_103847_103860[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_103828);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e103846;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__103861 = state_103828;
state_103828 = G__103861;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$connection$establish_socket_$_state_machine__86625__auto__ = function(state_103828){
switch(arguments.length){
case 0:
return fluree$db$connection$establish_socket_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$connection$establish_socket_$_state_machine__86625__auto____1.call(this,state_103828);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$establish_socket_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$establish_socket_$_state_machine__86625__auto____0;
fluree$db$connection$establish_socket_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$establish_socket_$_state_machine__86625__auto____1;
return fluree$db$connection$establish_socket_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_103848 = f__86676__auto__.call(null);
(statearr_103848[(6)] = c__86675__auto__);

return statearr_103848;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.connection.Connection = (function (id,servers,state,req_chan,sub_chan,pub_chan,storage_read,storage_write,object_cache,parallelism,serializer,default_network,transactor_QMARK_,publish,transact_handler,tx_private_key,tx_key_id,meta,add_listener,remove_listener,close,__meta,__extmap,__hash){
this.id = id;
this.servers = servers;
this.state = state;
this.req_chan = req_chan;
this.sub_chan = sub_chan;
this.pub_chan = pub_chan;
this.storage_read = storage_read;
this.storage_write = storage_write;
this.object_cache = object_cache;
this.parallelism = parallelism;
this.serializer = serializer;
this.default_network = default_network;
this.transactor_QMARK_ = transactor_QMARK_;
this.publish = publish;
this.transact_handler = transact_handler;
this.tx_private_key = tx_private_key;
this.tx_key_id = tx_key_id;
this.meta = meta;
this.add_listener = add_listener;
this.remove_listener = remove_listener;
this.close = close;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
fluree.db.connection.Connection.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4385__auto__,k__4386__auto__){
var self__ = this;
var this__4385__auto____$1 = this;
return this__4385__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4386__auto__,null);
});

fluree.db.connection.Connection.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4387__auto__,k103863,else__4388__auto__){
var self__ = this;
var this__4387__auto____$1 = this;
var G__103867 = k103863;
var G__103867__$1 = (((G__103867 instanceof cljs.core.Keyword))?G__103867.fqn:null);
switch (G__103867__$1) {
case "id":
return self__.id;

break;
case "servers":
return self__.servers;

break;
case "state":
return self__.state;

break;
case "req-chan":
return self__.req_chan;

break;
case "sub-chan":
return self__.sub_chan;

break;
case "pub-chan":
return self__.pub_chan;

break;
case "storage-read":
return self__.storage_read;

break;
case "storage-write":
return self__.storage_write;

break;
case "object-cache":
return self__.object_cache;

break;
case "parallelism":
return self__.parallelism;

break;
case "serializer":
return self__.serializer;

break;
case "default-network":
return self__.default_network;

break;
case "transactor?":
return self__.transactor_QMARK_;

break;
case "publish":
return self__.publish;

break;
case "transact-handler":
return self__.transact_handler;

break;
case "tx-private-key":
return self__.tx_private_key;

break;
case "tx-key-id":
return self__.tx_key_id;

break;
case "meta":
return self__.meta;

break;
case "add-listener":
return self__.add_listener;

break;
case "remove-listener":
return self__.remove_listener;

break;
case "close":
return self__.close;

break;
default:
return cljs.core.get.call(null,self__.__extmap,k103863,else__4388__auto__);

}
});

fluree.db.connection.Connection.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4404__auto__,f__4405__auto__,init__4406__auto__){
var self__ = this;
var this__4404__auto____$1 = this;
return cljs.core.reduce.call(null,((function (this__4404__auto____$1){
return (function (ret__4407__auto__,p__103868){
var vec__103869 = p__103868;
var k__4408__auto__ = cljs.core.nth.call(null,vec__103869,(0),null);
var v__4409__auto__ = cljs.core.nth.call(null,vec__103869,(1),null);
return f__4405__auto__.call(null,ret__4407__auto__,k__4408__auto__,v__4409__auto__);
});})(this__4404__auto____$1))
,init__4406__auto__,this__4404__auto____$1);
});

fluree.db.connection.Connection.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4399__auto__,writer__4400__auto__,opts__4401__auto__){
var self__ = this;
var this__4399__auto____$1 = this;
var pr_pair__4402__auto__ = ((function (this__4399__auto____$1){
return (function (keyval__4403__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,cljs.core.pr_writer,""," ","",opts__4401__auto__,keyval__4403__auto__);
});})(this__4399__auto____$1))
;
return cljs.core.pr_sequential_writer.call(null,writer__4400__auto__,pr_pair__4402__auto__,"#fluree.db.connection.Connection{",", ","}",opts__4401__auto__,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 21, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"id","id",-1388402092),self__.id],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"servers","servers",1881102005),self__.servers],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"state","state",-1988618099),self__.state],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"req-chan","req-chan",-35924046),self__.req_chan],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215),self__.sub_chan],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593),self__.pub_chan],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"storage-read","storage-read",-885692537),self__.storage_read],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"storage-write","storage-write",595144816),self__.storage_write],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287),self__.object_cache],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"parallelism","parallelism",-930922333),self__.parallelism],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"serializer","serializer",-875689688),self__.serializer],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"default-network","default-network",586420705),self__.default_network],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057),self__.transactor_QMARK_],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"publish","publish",-1178026850),self__.publish],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"transact-handler","transact-handler",-745499037),self__.transact_handler],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"tx-private-key","tx-private-key",-1231668122),self__.tx_private_key],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"tx-key-id","tx-key-id",-1451912145),self__.tx_key_id],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"meta","meta",1499536964),self__.meta],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"add-listener","add-listener",313698051),self__.add_listener],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"remove-listener","remove-listener",-418647802),self__.remove_listener],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"close","close",1835149582),self__.close],null))], null),self__.__extmap));
});

fluree.db.connection.Connection.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__103862){
var self__ = this;
var G__103862__$1 = this;
return (new cljs.core.RecordIter((0),G__103862__$1,21,new cljs.core.PersistentVector(null, 21, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"servers","servers",1881102005),new cljs.core.Keyword(null,"state","state",-1988618099),new cljs.core.Keyword(null,"req-chan","req-chan",-35924046),new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215),new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593),new cljs.core.Keyword(null,"storage-read","storage-read",-885692537),new cljs.core.Keyword(null,"storage-write","storage-write",595144816),new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287),new cljs.core.Keyword(null,"parallelism","parallelism",-930922333),new cljs.core.Keyword(null,"serializer","serializer",-875689688),new cljs.core.Keyword(null,"default-network","default-network",586420705),new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057),new cljs.core.Keyword(null,"publish","publish",-1178026850),new cljs.core.Keyword(null,"transact-handler","transact-handler",-745499037),new cljs.core.Keyword(null,"tx-private-key","tx-private-key",-1231668122),new cljs.core.Keyword(null,"tx-key-id","tx-key-id",-1451912145),new cljs.core.Keyword(null,"meta","meta",1499536964),new cljs.core.Keyword(null,"add-listener","add-listener",313698051),new cljs.core.Keyword(null,"remove-listener","remove-listener",-418647802),new cljs.core.Keyword(null,"close","close",1835149582)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
});

fluree.db.connection.Connection.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4383__auto__){
var self__ = this;
var this__4383__auto____$1 = this;
return self__.__meta;
});

fluree.db.connection.Connection.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4380__auto__){
var self__ = this;
var this__4380__auto____$1 = this;
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,self__.__hash));
});

fluree.db.connection.Connection.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4389__auto__){
var self__ = this;
var this__4389__auto____$1 = this;
return (21 + cljs.core.count.call(null,self__.__extmap));
});

fluree.db.connection.Connection.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4381__auto__){
var self__ = this;
var this__4381__auto____$1 = this;
var h__4243__auto__ = self__.__hash;
if((!((h__4243__auto__ == null)))){
return h__4243__auto__;
} else {
var h__4243__auto____$1 = ((function (h__4243__auto__,this__4381__auto____$1){
return (function (coll__4382__auto__){
return (1865480964 ^ cljs.core.hash_unordered_coll.call(null,coll__4382__auto__));
});})(h__4243__auto__,this__4381__auto____$1))
.call(null,this__4381__auto____$1);
self__.__hash = h__4243__auto____$1;

return h__4243__auto____$1;
}
});

fluree.db.connection.Connection.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this103864,other103865){
var self__ = this;
var this103864__$1 = this;
return (((!((other103865 == null)))) && ((this103864__$1.constructor === other103865.constructor)) && (cljs.core._EQ_.call(null,this103864__$1.id,other103865.id)) && (cljs.core._EQ_.call(null,this103864__$1.servers,other103865.servers)) && (cljs.core._EQ_.call(null,this103864__$1.state,other103865.state)) && (cljs.core._EQ_.call(null,this103864__$1.req_chan,other103865.req_chan)) && (cljs.core._EQ_.call(null,this103864__$1.sub_chan,other103865.sub_chan)) && (cljs.core._EQ_.call(null,this103864__$1.pub_chan,other103865.pub_chan)) && (cljs.core._EQ_.call(null,this103864__$1.storage_read,other103865.storage_read)) && (cljs.core._EQ_.call(null,this103864__$1.storage_write,other103865.storage_write)) && (cljs.core._EQ_.call(null,this103864__$1.object_cache,other103865.object_cache)) && (cljs.core._EQ_.call(null,this103864__$1.parallelism,other103865.parallelism)) && (cljs.core._EQ_.call(null,this103864__$1.serializer,other103865.serializer)) && (cljs.core._EQ_.call(null,this103864__$1.default_network,other103865.default_network)) && (cljs.core._EQ_.call(null,this103864__$1.transactor_QMARK_,other103865.transactor_QMARK_)) && (cljs.core._EQ_.call(null,this103864__$1.publish,other103865.publish)) && (cljs.core._EQ_.call(null,this103864__$1.transact_handler,other103865.transact_handler)) && (cljs.core._EQ_.call(null,this103864__$1.tx_private_key,other103865.tx_private_key)) && (cljs.core._EQ_.call(null,this103864__$1.tx_key_id,other103865.tx_key_id)) && (cljs.core._EQ_.call(null,this103864__$1.meta,other103865.meta)) && (cljs.core._EQ_.call(null,this103864__$1.add_listener,other103865.add_listener)) && (cljs.core._EQ_.call(null,this103864__$1.remove_listener,other103865.remove_listener)) && (cljs.core._EQ_.call(null,this103864__$1.close,other103865.close)) && (cljs.core._EQ_.call(null,this103864__$1.__extmap,other103865.__extmap)));
});

fluree.db.connection.Connection.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4394__auto__,k__4395__auto__){
var self__ = this;
var this__4394__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 21, [new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287),null,new cljs.core.Keyword(null,"default-network","default-network",586420705),null,new cljs.core.Keyword(null,"parallelism","parallelism",-930922333),null,new cljs.core.Keyword(null,"transact-handler","transact-handler",-745499037),null,new cljs.core.Keyword(null,"add-listener","add-listener",313698051),null,new cljs.core.Keyword(null,"meta","meta",1499536964),null,new cljs.core.Keyword(null,"tx-private-key","tx-private-key",-1231668122),null,new cljs.core.Keyword(null,"remove-listener","remove-listener",-418647802),null,new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057),null,new cljs.core.Keyword(null,"storage-read","storage-read",-885692537),null,new cljs.core.Keyword(null,"serializer","serializer",-875689688),null,new cljs.core.Keyword(null,"state","state",-1988618099),null,new cljs.core.Keyword(null,"close","close",1835149582),null,new cljs.core.Keyword(null,"tx-key-id","tx-key-id",-1451912145),null,new cljs.core.Keyword(null,"storage-write","storage-write",595144816),null,new cljs.core.Keyword(null,"req-chan","req-chan",-35924046),null,new cljs.core.Keyword(null,"id","id",-1388402092),null,new cljs.core.Keyword(null,"servers","servers",1881102005),null,new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593),null,new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215),null,new cljs.core.Keyword(null,"publish","publish",-1178026850),null], null), null),k__4395__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4394__auto____$1),self__.__meta),k__4395__auto__);
} else {
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4395__auto__)),null));
}
});

fluree.db.connection.Connection.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4392__auto__,k__4393__auto__,G__103862){
var self__ = this;
var this__4392__auto____$1 = this;
var pred__103872 = cljs.core.keyword_identical_QMARK_;
var expr__103873 = k__4393__auto__;
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"id","id",-1388402092),expr__103873))){
return (new fluree.db.connection.Connection(G__103862,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"servers","servers",1881102005),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,G__103862,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"state","state",-1988618099),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,G__103862,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"req-chan","req-chan",-35924046),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,G__103862,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,G__103862,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,G__103862,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"storage-read","storage-read",-885692537),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,G__103862,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"storage-write","storage-write",595144816),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,G__103862,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,G__103862,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"parallelism","parallelism",-930922333),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,G__103862,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"serializer","serializer",-875689688),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,G__103862,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"default-network","default-network",586420705),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,G__103862,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,G__103862,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"publish","publish",-1178026850),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,G__103862,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"transact-handler","transact-handler",-745499037),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,G__103862,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"tx-private-key","tx-private-key",-1231668122),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,G__103862,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"tx-key-id","tx-key-id",-1451912145),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,G__103862,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"meta","meta",1499536964),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,G__103862,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"add-listener","add-listener",313698051),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,G__103862,self__.remove_listener,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"remove-listener","remove-listener",-418647802),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,G__103862,self__.close,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__103872.call(null,new cljs.core.Keyword(null,"close","close",1835149582),expr__103873))){
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,G__103862,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4393__auto__,G__103862),null));
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});

fluree.db.connection.Connection.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4397__auto__){
var self__ = this;
var this__4397__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 21, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"id","id",-1388402092),self__.id,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"servers","servers",1881102005),self__.servers,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"state","state",-1988618099),self__.state,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"req-chan","req-chan",-35924046),self__.req_chan,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215),self__.sub_chan,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593),self__.pub_chan,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"storage-read","storage-read",-885692537),self__.storage_read,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"storage-write","storage-write",595144816),self__.storage_write,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287),self__.object_cache,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"parallelism","parallelism",-930922333),self__.parallelism,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"serializer","serializer",-875689688),self__.serializer,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"default-network","default-network",586420705),self__.default_network,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057),self__.transactor_QMARK_,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"publish","publish",-1178026850),self__.publish,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"transact-handler","transact-handler",-745499037),self__.transact_handler,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"tx-private-key","tx-private-key",-1231668122),self__.tx_private_key,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"tx-key-id","tx-key-id",-1451912145),self__.tx_key_id,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"meta","meta",1499536964),self__.meta,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"add-listener","add-listener",313698051),self__.add_listener,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"remove-listener","remove-listener",-418647802),self__.remove_listener,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"close","close",1835149582),self__.close,null))], null),self__.__extmap));
});

fluree.db.connection.Connection.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4384__auto__,G__103862){
var self__ = this;
var this__4384__auto____$1 = this;
return (new fluree.db.connection.Connection(self__.id,self__.servers,self__.state,self__.req_chan,self__.sub_chan,self__.pub_chan,self__.storage_read,self__.storage_write,self__.object_cache,self__.parallelism,self__.serializer,self__.default_network,self__.transactor_QMARK_,self__.publish,self__.transact_handler,self__.tx_private_key,self__.tx_key_id,self__.meta,self__.add_listener,self__.remove_listener,self__.close,G__103862,self__.__extmap,self__.__hash));
});

fluree.db.connection.Connection.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4390__auto__,entry__4391__auto__){
var self__ = this;
var this__4390__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4391__auto__)){
return this__4390__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4391__auto__,(0)),cljs.core._nth.call(null,entry__4391__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4390__auto____$1,entry__4391__auto__);
}
});

fluree.db.connection.Connection.getBasis = (function (){
return new cljs.core.PersistentVector(null, 21, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"id","id",252129435,null),new cljs.core.Symbol(null,"servers","servers",-773333764,null),new cljs.core.Symbol(null,"state","state",-348086572,null),new cljs.core.Symbol(null,"req-chan","req-chan",1604607481,null),new cljs.core.Symbol(null,"sub-chan","sub-chan",-371906688,null),new cljs.core.Symbol(null,"pub-chan","pub-chan",1593615934,null),new cljs.core.Symbol(null,"storage-read","storage-read",754838990,null),new cljs.core.Symbol(null,"storage-write","storage-write",-2059290953,null),new cljs.core.Symbol(null,"object-cache","object-cache",-489792760,null),new cljs.core.Symbol(null,"parallelism","parallelism",709609194,null),new cljs.core.Symbol(null,"serializer","serializer",764841839,null),new cljs.core.Symbol(null,"default-network","default-network",-2068015064,null),new cljs.core.Symbol(null,"transactor?","transactor?",-260540530,null),new cljs.core.Symbol(null,"publish","publish",462504677,null),new cljs.core.Symbol(null,"transact-handler","transact-handler",895032490,null),new cljs.core.Symbol(null,"tx-private-key","tx-private-key",408863405,null),new cljs.core.Symbol(null,"tx-key-id","tx-key-id",188619382,null),new cljs.core.Symbol(null,"meta","meta",-1154898805,null),new cljs.core.Symbol(null,"add-listener","add-listener",1954229578,null),new cljs.core.Symbol(null,"remove-listener","remove-listener",1221883725,null),new cljs.core.Symbol(null,"close","close",-819286187,null)], null);
});

fluree.db.connection.Connection.cljs$lang$type = true;

fluree.db.connection.Connection.cljs$lang$ctorPrSeq = (function (this__4428__auto__){
return (new cljs.core.List(null,"fluree.db.connection/Connection",null,(1),null));
});

fluree.db.connection.Connection.cljs$lang$ctorPrWriter = (function (this__4428__auto__,writer__4429__auto__){
return cljs.core._write.call(null,writer__4429__auto__,"fluree.db.connection/Connection");
});

/**
 * Positional factory function for fluree.db.connection/Connection.
 */
fluree.db.connection.__GT_Connection = (function fluree$db$connection$__GT_Connection(id,servers,state,req_chan,sub_chan,pub_chan,storage_read,storage_write,object_cache,parallelism,serializer,default_network,transactor_QMARK_,publish,transact_handler,tx_private_key,tx_key_id,meta,add_listener,remove_listener,close){
return (new fluree.db.connection.Connection(id,servers,state,req_chan,sub_chan,pub_chan,storage_read,storage_write,object_cache,parallelism,serializer,default_network,transactor_QMARK_,publish,transact_handler,tx_private_key,tx_key_id,meta,add_listener,remove_listener,close,null,null,null));
});

/**
 * Factory function for fluree.db.connection/Connection, taking a map of keywords to field values.
 */
fluree.db.connection.map__GT_Connection = (function fluree$db$connection$map__GT_Connection(G__103866){
var extmap__4424__auto__ = (function (){var G__103875 = cljs.core.dissoc.call(null,G__103866,new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"servers","servers",1881102005),new cljs.core.Keyword(null,"state","state",-1988618099),new cljs.core.Keyword(null,"req-chan","req-chan",-35924046),new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215),new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593),new cljs.core.Keyword(null,"storage-read","storage-read",-885692537),new cljs.core.Keyword(null,"storage-write","storage-write",595144816),new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287),new cljs.core.Keyword(null,"parallelism","parallelism",-930922333),new cljs.core.Keyword(null,"serializer","serializer",-875689688),new cljs.core.Keyword(null,"default-network","default-network",586420705),new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057),new cljs.core.Keyword(null,"publish","publish",-1178026850),new cljs.core.Keyword(null,"transact-handler","transact-handler",-745499037),new cljs.core.Keyword(null,"tx-private-key","tx-private-key",-1231668122),new cljs.core.Keyword(null,"tx-key-id","tx-key-id",-1451912145),new cljs.core.Keyword(null,"meta","meta",1499536964),new cljs.core.Keyword(null,"add-listener","add-listener",313698051),new cljs.core.Keyword(null,"remove-listener","remove-listener",-418647802),new cljs.core.Keyword(null,"close","close",1835149582));
if(cljs.core.record_QMARK_.call(null,G__103866)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__103875);
} else {
return G__103875;
}
})();
return (new fluree.db.connection.Connection(new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"servers","servers",1881102005).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"storage-read","storage-read",-885692537).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"storage-write","storage-write",595144816).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"parallelism","parallelism",-930922333).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"serializer","serializer",-875689688).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"default-network","default-network",586420705).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"publish","publish",-1178026850).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"transact-handler","transact-handler",-745499037).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"tx-private-key","tx-private-key",-1231668122).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"tx-key-id","tx-key-id",-1451912145).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"meta","meta",1499536964).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"add-listener","add-listener",313698051).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"remove-listener","remove-listener",-418647802).cljs$core$IFn$_invoke$arity$1(G__103866),new cljs.core.Keyword(null,"close","close",1835149582).cljs$core$IFn$_invoke$arity$1(G__103866),null,cljs.core.not_empty.call(null,extmap__4424__auto__),null));
});

/**
 * Split servers in a string into a vector.
 * 
 *   Randomizies order, ensures uniqueness.
 */
fluree.db.connection.normalize_servers = (function fluree$db$connection$normalize_servers(servers,transactor_QMARK_){
var servers_STAR_ = ((typeof servers === 'string')?clojure.string.split.call(null,servers,/,/):servers);
if(((cljs.core.empty_QMARK_.call(null,servers)) && (cljs.core.not.call(null,transactor_QMARK_)))){
throw cljs.core.ex_info.call(null,"At least one server must be supplied for connection.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-connection","db/invalid-connection",2026003745)], null));
} else {
}

if(cljs.core.truth_(cljs.core.not_empty.call(null,servers_STAR_))){
var G__103880 = servers_STAR_;
var vec__103881 = G__103880;
var seq__103882 = cljs.core.seq.call(null,vec__103881);
var first__103883 = cljs.core.first.call(null,seq__103882);
var seq__103882__$1 = cljs.core.next.call(null,seq__103882);
var server = first__103883;
var r = seq__103882__$1;
var https_QMARK_ = null;
var result = cljs.core.PersistentHashSet.EMPTY;
var G__103880__$1 = G__103880;
var https_QMARK___$1 = https_QMARK_;
var result__$1 = result;
while(true){
var vec__103887 = G__103880__$1;
var seq__103888 = cljs.core.seq.call(null,vec__103887);
var first__103889 = cljs.core.first.call(null,seq__103888);
var seq__103888__$1 = cljs.core.next.call(null,seq__103888);
var server__$1 = first__103889;
var r__$1 = seq__103888__$1;
var https_QMARK___$2 = https_QMARK___$1;
var result__$2 = result__$1;
if(typeof server__$1 === 'string'){
} else {
throw cljs.core.ex_info.call(null,["Invalid server provided for connection, must be a string: ",cljs.core.pr_str.call(null,server__$1)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-connection","db/invalid-connection",2026003745)], null));
}

var server__$2 = clojure.string.replace.call(null,server__$1,/.+@/,"");
var server_STAR_ = (cljs.core.truth_(cljs.core.re_matches.call(null,/^https?:\/\/.+/,server__$2))?server__$2:((clojure.string.includes_QMARK_.call(null,server__$2,"//"))?(function(){throw cljs.core.ex_info.call(null,["Only http:// and https:// protocols currently supported for connection servers. Provided:",cljs.core.str.cljs$core$IFn$_invoke$arity$1(server__$2)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-connection","db/invalid-connection",2026003745)], null))})():["http://",cljs.core.str.cljs$core$IFn$_invoke$arity$1(server__$2)].join('')
));
var server_STAR___$1 = (cljs.core.truth_(cljs.core.re_matches.call(null,/.+:[0-9]+/,server_STAR_))?server_STAR_:[cljs.core.str.cljs$core$IFn$_invoke$arity$1(server_STAR_),":8080"].join(''));
var is_https_QMARK_ = clojure.string.starts_with_QMARK_.call(null,server__$2,"https://");
var result_STAR_ = cljs.core.conj.call(null,result__$2,server_STAR___$1);
if(cljs.core.truth_(cljs.core.re_matches.call(null,/^https?:\/\/(((?!-))(xn--|_{1,1})?[a-z0-9-]{0,61}[a-z0-9]{1,1}\.)*(xn--)?([a-z0-9\-]{1,61}|[a-z0-9-]{1,30}\.[a-z]{2,})(?:\:\d+)$/,server_STAR___$1))){
} else {
throw cljs.core.ex_info.call(null,["Invalid connection server, provide url and port only. Optionally specify http:// or https://. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(server__$2)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-connection","db/invalid-connection",2026003745)], null));
}

if(cljs.core.truth_((function (){var and__4120__auto__ = https_QMARK___$2;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.not_EQ_.call(null,is_https_QMARK_,https_QMARK___$2);
} else {
return and__4120__auto__;
}
})())){
throw cljs.core.ex_info.call(null,"Connection servers must all be http or https, not a mix.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-connection","db/invalid-connection",2026003745)], null));
} else {
}

if(cljs.core.empty_QMARK_.call(null,r__$1)){
return cljs.core.shuffle.call(null,result_STAR_);
} else {
var G__103890 = r__$1;
var G__103891 = is_https_QMARK_;
var G__103892 = result_STAR_;
G__103880__$1 = G__103890;
https_QMARK___$1 = G__103891;
result__$1 = G__103892;
continue;
}
break;
}
} else {
return null;
}
});
/**
 * Returns true if connection has been closed.
 */
fluree.db.connection.closed_QMARK_ = (function fluree$db$connection$closed_QMARK_(conn){
return new cljs.core.Keyword(null,"close?","close?",1600185693).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(conn)));
});
if((typeof fluree !== 'undefined') && (typeof fluree.db !== 'undefined') && (typeof fluree.db.connection !== 'undefined') && (typeof fluree.db.connection.process_event !== 'undefined')){
} else {
fluree.db.connection.process_event = (function (){var method_table__4613__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4614__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4615__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4616__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4617__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"fluree.db.connection","process-event"),((function (method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__){
return (function (_,event_type,___$1,___$2){
return event_type;
});})(method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__,hierarchy__4617__auto__))
,new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4617__auto__,method_table__4613__auto__,prefer_table__4614__auto__,method_cache__4615__auto__,cached_hierarchy__4616__auto__));
})();
}
cljs.core._add_method.call(null,fluree.db.connection.process_event,new cljs.core.Keyword(null,"set-ws-id","set-ws-id",-1586193013),(function (conn,_,___$1,ws_id){
return cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc,new cljs.core.Keyword(null,"socket-id","socket-id",1022615280),ws_id);
}));
cljs.core._add_method.call(null,fluree.db.connection.process_event,new cljs.core.Keyword(null,"default","default",-1987822328),(function (conn,event_type,subject,event_data){
var callbacks = cljs.core.get_in.call(null,cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(conn)),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"listeners","listeners",394544445),subject], null));
var seq__103893 = cljs.core.seq.call(null,callbacks);
var chunk__103894 = null;
var count__103895 = (0);
var i__103896 = (0);
while(true){
if((i__103896 < count__103895)){
var vec__103905 = cljs.core._nth.call(null,chunk__103894,i__103896);
var k = cljs.core.nth.call(null,vec__103905,(0),null);
var f = cljs.core.nth.call(null,vec__103905,(1),null);
try{f.call(null,event_type,event_data);
}catch (e103908){var e_103913 = e103908;
fluree.db.util.log.error.call(null,e_103913,["Error calling registered callback: ",cljs.core.pr_str.call(null,k)," for db: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(subject),". Event: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(event_type)," Data: ",cljs.core.pr_str.call(null,event_data),"."].join(''));
}

var G__103914 = seq__103893;
var G__103915 = chunk__103894;
var G__103916 = count__103895;
var G__103917 = (i__103896 + (1));
seq__103893 = G__103914;
chunk__103894 = G__103915;
count__103895 = G__103916;
i__103896 = G__103917;
continue;
} else {
var temp__5735__auto__ = cljs.core.seq.call(null,seq__103893);
if(temp__5735__auto__){
var seq__103893__$1 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__103893__$1)){
var c__4550__auto__ = cljs.core.chunk_first.call(null,seq__103893__$1);
var G__103918 = cljs.core.chunk_rest.call(null,seq__103893__$1);
var G__103919 = c__4550__auto__;
var G__103920 = cljs.core.count.call(null,c__4550__auto__);
var G__103921 = (0);
seq__103893 = G__103918;
chunk__103894 = G__103919;
count__103895 = G__103920;
i__103896 = G__103921;
continue;
} else {
var vec__103909 = cljs.core.first.call(null,seq__103893__$1);
var k = cljs.core.nth.call(null,vec__103909,(0),null);
var f = cljs.core.nth.call(null,vec__103909,(1),null);
try{f.call(null,event_type,event_data);
}catch (e103912){var e_103922 = e103912;
fluree.db.util.log.error.call(null,e_103922,["Error calling registered callback: ",cljs.core.pr_str.call(null,k)," for db: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(subject),". Event: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(event_type)," Data: ",cljs.core.pr_str.call(null,event_data),"."].join(''));
}

var G__103923 = cljs.core.next.call(null,seq__103893__$1);
var G__103924 = null;
var G__103925 = (0);
var G__103926 = (0);
seq__103893 = G__103923;
chunk__103894 = G__103924;
count__103895 = G__103925;
i__103896 = G__103926;
continue;
}
} else {
return null;
}
}
break;
}
}));
/**
 * Processes incoming events from the ledger.
 * 
 *   Requests that carry a :req-id in the header will attempt to lookup a
 *   corresponding return channel and send the message along on it.
 * 
 *   Otherwise looks for database events and updates local state accordingly.
 */
fluree.db.connection.process_events = (function fluree$db$connection$process_events(conn,msg){
try{var _ = fluree.db.util.log.trace.call(null,"Process events: ",msg);
var vec__103929 = msg;
var event_type = cljs.core.nth.call(null,vec__103929,(0),null);
var subject = cljs.core.nth.call(null,vec__103929,(1),null);
var event_data = cljs.core.nth.call(null,vec__103929,(2),null);
var error_data = cljs.core.nth.call(null,vec__103929,(3),null);
var event_type__$1 = cljs.core.keyword.call(null,event_type);
var map__103932 = conn;
var map__103932__$1 = (((((!((map__103932 == null))))?(((((map__103932.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__103932.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__103932):map__103932);
var state = cljs.core.get.call(null,map__103932__$1,new cljs.core.Keyword(null,"state","state",-1988618099));
var G__103934 = event_type__$1;
var G__103934__$1 = (((G__103934 instanceof cljs.core.Keyword))?G__103934.fqn:null);
switch (G__103934__$1) {
case "response":
var temp__5735__auto__ = cljs.core.get_in.call(null,cljs.core.deref.call(null,state),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"pending-req","pending-req",2064800871),subject], null));
if(cljs.core.truth_(temp__5735__auto__)){
var res_chan = temp__5735__auto__;
cljs.core.swap_BANG_.call(null,state,cljs.core.update,new cljs.core.Keyword(null,"pending-req","pending-req",2064800871),((function (res_chan,temp__5735__auto__,G__103934,G__103934__$1,_,vec__103929,event_type,subject,event_data,error_data,event_type__$1,map__103932,map__103932__$1,state){
return (function (p1__103927_SHARP_){
return cljs.core.dissoc.call(null,p1__103927_SHARP_,subject);
});})(res_chan,temp__5735__auto__,G__103934,G__103934__$1,_,vec__103929,event_type,subject,event_data,error_data,event_type__$1,map__103932,map__103932__$1,state))
);

if(cljs.core.truth_(error_data)){
var map__103935 = error_data;
var map__103935__$1 = (((((!((map__103935 == null))))?(((((map__103935.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__103935.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__103935):map__103935);
var message = cljs.core.get.call(null,map__103935__$1,new cljs.core.Keyword(null,"message","message",-406056002));
var exception = cljs.core.ex_info.call(null,(function (){var or__4131__auto__ = message;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.pr_str.call(null,error_data);
}
})(),cljs.core.dissoc.call(null,error_data,new cljs.core.Keyword(null,"message","message",-406056002)));
return cljs.core.async.put_BANG_.call(null,res_chan,exception);
} else {
if(cljs.core.truth_(event_data)){
return cljs.core.async.put_BANG_.call(null,res_chan,event_data);
} else {
return cljs.core.async.close_BANG_.call(null,res_chan);

}
}
} else {
return null;
}

break;
case "pong":
return null;

break;
default:
return fluree.db.connection.process_event.call(null,conn,event_type__$1,subject,event_data);

}
}catch (e103928){var e = e103928;
return fluree.db.util.log.error.call(null,e);
}});
/**
 * Closes websocket on connection if exists.
 */
fluree.db.connection.close_websocket = (function fluree$db$connection$close_websocket(conn_id){
var existing_socket = (function (){var G__103938 = cljs.core.get_in.call(null,fluree.db.connection.server_connections_atom,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,new cljs.core.Keyword(null,"ws","ws",86841443),new cljs.core.Keyword(null,"socket","socket",59137063)], null));
if((G__103938 == null)){
return null;
} else {
return cljs.core.async.poll_BANG_.call(null,G__103938);
}
})();
cljs.core.swap_BANG_.call(null,fluree.db.connection.server_connections_atom,cljs.core.dissoc,conn_id);

if(cljs.core.truth_(existing_socket)){
return fluree.db.util.xhttp.close_websocket.call(null,existing_socket);
} else {
return false;
}
});
/**
 * Gets websocket from connection, or establishes one if not already done.
 * 
 *   Returns a core async promise channel. Check for exceptions.
 */
fluree.db.connection.get_socket = (function fluree$db$connection$get_socket(conn){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_103964){
var state_val_103965 = (state_103964[(1)]);
if((state_val_103965 === (1))){
var state_103964__$1 = state_103964;
var statearr_103966_103978 = state_103964__$1;
(statearr_103966_103978[(2)] = null);

(statearr_103966_103978[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103965 === (2))){
var inst_103962 = (state_103964[(2)]);
var state_103964__$1 = state_103964;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_103964__$1,inst_103962);
} else {
if((state_val_103965 === (3))){
var inst_103939 = (state_103964[(2)]);
var state_103964__$1 = state_103964;
var statearr_103967_103979 = state_103964__$1;
(statearr_103967_103979[(2)] = inst_103939);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_103964__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103965 === (4))){
var inst_103948 = (state_103964[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_103964,(3),Error,null,(2));
var inst_103943 = cljs.core.deref.call(null,fluree.db.connection.server_connections_atom);
var inst_103944 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_103945 = new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(conn);
var inst_103946 = [inst_103945,new cljs.core.Keyword(null,"ws","ws",86841443),new cljs.core.Keyword(null,"socket","socket",59137063)];
var inst_103947 = (new cljs.core.PersistentVector(null,3,(5),inst_103944,inst_103946,null));
var inst_103948__$1 = cljs.core.get_in.call(null,inst_103943,inst_103947);
var state_103964__$1 = (function (){var statearr_103968 = state_103964;
(statearr_103968[(7)] = inst_103948__$1);

return statearr_103968;
})();
if(cljs.core.truth_(inst_103948__$1)){
var statearr_103969_103980 = state_103964__$1;
(statearr_103969_103980[(1)] = (5));

} else {
var statearr_103970_103981 = state_103964__$1;
(statearr_103970_103981[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103965 === (5))){
var inst_103948 = (state_103964[(7)]);
var state_103964__$1 = state_103964;
var statearr_103971_103982 = state_103964__$1;
(statearr_103971_103982[(2)] = inst_103948);

(statearr_103971_103982[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103965 === (6))){
var inst_103951 = new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(conn);
var inst_103952 = new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215).cljs$core$IFn$_invoke$arity$1(conn);
var inst_103953 = new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593).cljs$core$IFn$_invoke$arity$1(conn);
var inst_103954 = new cljs.core.Keyword(null,"servers","servers",1881102005).cljs$core$IFn$_invoke$arity$1(conn);
var inst_103955 = fluree.db.connection.establish_socket.call(null,inst_103951,inst_103952,inst_103953,inst_103954);
var state_103964__$1 = state_103964;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_103964__$1,(8),inst_103955);
} else {
if((state_val_103965 === (7))){
var inst_103960 = (state_103964[(2)]);
var state_103964__$1 = state_103964;
var statearr_103972_103983 = state_103964__$1;
(statearr_103972_103983[(2)] = inst_103960);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_103964__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_103965 === (8))){
var inst_103957 = (state_103964[(2)]);
var inst_103958 = fluree.db.util.async.throw_err.call(null,inst_103957);
var state_103964__$1 = state_103964;
var statearr_103973_103984 = state_103964__$1;
(statearr_103973_103984[(2)] = inst_103958);

(statearr_103973_103984[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$connection$get_socket_$_state_machine__86625__auto__ = null;
var fluree$db$connection$get_socket_$_state_machine__86625__auto____0 = (function (){
var statearr_103974 = [null,null,null,null,null,null,null,null];
(statearr_103974[(0)] = fluree$db$connection$get_socket_$_state_machine__86625__auto__);

(statearr_103974[(1)] = (1));

return statearr_103974;
});
var fluree$db$connection$get_socket_$_state_machine__86625__auto____1 = (function (state_103964){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_103964);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e103975){if((e103975 instanceof Object)){
var ex__86628__auto__ = e103975;
var statearr_103976_103985 = state_103964;
(statearr_103976_103985[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_103964);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e103975;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__103986 = state_103964;
state_103964 = G__103986;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$connection$get_socket_$_state_machine__86625__auto__ = function(state_103964){
switch(arguments.length){
case 0:
return fluree$db$connection$get_socket_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$connection$get_socket_$_state_machine__86625__auto____1.call(this,state_103964);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$get_socket_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$get_socket_$_state_machine__86625__auto____0;
fluree$db$connection$get_socket_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$get_socket_$_state_machine__86625__auto____1;
return fluree$db$connection$get_socket_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_103977 = f__86676__auto__.call(null);
(statearr_103977[(6)] = c__86675__auto__);

return statearr_103977;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * returns promise channel, check for errors
 */
fluree.db.connection.get_server = (function fluree$db$connection$get_server(conn_id,servers){
var or__4131__auto__ = cljs.core.get_in.call(null,cljs.core.deref.call(null,fluree.db.connection.server_connections_atom),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [conn_id,new cljs.core.Keyword(null,"server","server",1499190120),new cljs.core.Keyword(null,"chan","chan",-2103021695)], null));
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return fluree.db.connection.get_healthy_server.call(null,conn_id,servers);
}
});
/**
 * Publishes message to the websocket associated with the connection.
 */
fluree.db.connection.default_publish_fn = (function fluree$db$connection$default_publish_fn(conn,message){
var pub_chan = new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593).cljs$core$IFn$_invoke$arity$1(conn);
var resp_chan = cljs.core.async.promise_chan.call(null);
var msg = (function (){try{return fluree.db.util.json.stringify.call(null,message);
}catch (e103987){var e = e103987;
fluree.db.util.log.error.call(null,"Unable to publish message on websocket. Error encoding JSON message: ",message);

cljs.core.async.put_BANG_.call(null,resp_chan,cljs.core.ex_info.call(null,["Error encoding JSON message: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(message)].join(''),cljs.core.PersistentArrayMap.EMPTY));

return null;
}})();
if(cljs.core.truth_(msg)){
cljs.core.async.put_BANG_.call(null,pub_chan,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [msg,resp_chan], null));
} else {
}

return resp_chan;
});
/**
 * Shuffles outgoing messages to the web socket in order.
 */
fluree.db.connection.msg_producer = (function fluree$db$connection$msg_producer(conn){
var state = new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(conn);
var req_chan = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(conn);
var publish_fn = (function (){var or__4131__auto__ = new cljs.core.Keyword(null,"publish","publish",-1178026850).cljs$core$IFn$_invoke$arity$1(conn);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return fluree.db.connection.default_publish_fn;
}
})();
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,state,req_chan,publish_fn){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,state,req_chan,publish_fn){
return (function (state_104131){
var state_val_104132 = (state_104131[(1)]);
if((state_val_104132 === (7))){
var inst_104127 = (state_104131[(2)]);
var state_104131__$1 = state_104131;
var statearr_104133_104209 = state_104131__$1;
(statearr_104133_104209[(2)] = inst_104127);

(statearr_104133_104209[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (20))){
var inst_104030 = (state_104131[(7)]);
var inst_104035 = inst_104030.cljs$lang$protocol_mask$partition0$;
var inst_104036 = (inst_104035 & (64));
var inst_104037 = inst_104030.cljs$core$ISeq$;
var inst_104038 = (cljs.core.PROTOCOL_SENTINEL === inst_104037);
var inst_104039 = ((inst_104036) || (inst_104038));
var state_104131__$1 = state_104131;
if(cljs.core.truth_(inst_104039)){
var statearr_104134_104210 = state_104131__$1;
(statearr_104134_104210[(1)] = (23));

} else {
var statearr_104135_104211 = state_104131__$1;
(statearr_104135_104211[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (27))){
var inst_104030 = (state_104131[(7)]);
var state_104131__$1 = state_104131;
var statearr_104136_104212 = state_104131__$1;
(statearr_104136_104212[(2)] = inst_104030);

(statearr_104136_104212[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (1))){
var inst_103989 = (0);
var state_104131__$1 = (function (){var statearr_104137 = state_104131;
(statearr_104137[(8)] = inst_103989);

return statearr_104137;
})();
var statearr_104138_104213 = state_104131__$1;
(statearr_104138_104213[(2)] = null);

(statearr_104138_104213[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (24))){
var state_104131__$1 = state_104131;
var statearr_104139_104214 = state_104131__$1;
(statearr_104139_104214[(2)] = false);

(statearr_104139_104214[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (39))){
var inst_104108 = fluree.db.util.log.error.call(null,"Error processing message in producer. Socket closed.");
var state_104131__$1 = state_104131;
var statearr_104140_104215 = state_104131__$1;
(statearr_104140_104215[(2)] = inst_104108);

(statearr_104140_104215[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (4))){
var inst_103992 = (state_104131[(9)]);
var inst_103992__$1 = (state_104131[(2)]);
var state_104131__$1 = (function (){var statearr_104141 = state_104131;
(statearr_104141[(9)] = inst_103992__$1);

return statearr_104141;
})();
if(cljs.core.truth_(inst_103992__$1)){
var statearr_104142_104216 = state_104131__$1;
(statearr_104142_104216[(1)] = (5));

} else {
var statearr_104143_104217 = state_104131__$1;
(statearr_104143_104217[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (15))){
var inst_104010 = (state_104131[(2)]);
var state_104131__$1 = state_104131;
if(cljs.core.truth_(inst_104010)){
var statearr_104144_104218 = state_104131__$1;
(statearr_104144_104218[(1)] = (16));

} else {
var statearr_104145_104219 = state_104131__$1;
(statearr_104145_104219[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (21))){
var state_104131__$1 = state_104131;
var statearr_104146_104220 = state_104131__$1;
(statearr_104146_104220[(2)] = false);

(statearr_104146_104220[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (31))){
var inst_104054 = (state_104131[(10)]);
var inst_104027 = (state_104131[(11)]);
var inst_104028 = (state_104131[(12)]);
var inst_104092 = (state_104131[(2)]);
var inst_104093 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104094 = [inst_104027,inst_104054,inst_104028];
var inst_104095 = (new cljs.core.PersistentVector(null,3,(5),inst_104093,inst_104094,null));
var inst_104096 = publish_fn.call(null,conn,inst_104095);
var state_104131__$1 = (function (){var statearr_104147 = state_104131;
(statearr_104147[(13)] = inst_104092);

return statearr_104147;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_104131__$1,(32),inst_104096);
} else {
if((state_val_104132 === (32))){
var inst_104098 = (state_104131[(14)]);
var inst_104098__$1 = (state_104131[(2)]);
var inst_104099 = inst_104098__$1 === true;
var state_104131__$1 = (function (){var statearr_104148 = state_104131;
(statearr_104148[(14)] = inst_104098__$1);

return statearr_104148;
})();
if(cljs.core.truth_(inst_104099)){
var statearr_104149_104221 = state_104131__$1;
(statearr_104149_104221[(1)] = (33));

} else {
var statearr_104150_104222 = state_104131__$1;
(statearr_104150_104222[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (40))){
var state_104131__$1 = state_104131;
var statearr_104151_104223 = state_104131__$1;
(statearr_104151_104223[(1)] = (42));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (33))){
var state_104131__$1 = state_104131;
var statearr_104153_104224 = state_104131__$1;
(statearr_104153_104224[(2)] = null);

(statearr_104153_104224[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (13))){
var inst_104005 = (state_104131[(15)]);
var inst_104007 = fluree.db.util.async.channel_QMARK_.call(null,inst_104005);
var state_104131__$1 = state_104131;
var statearr_104154_104225 = state_104131__$1;
(statearr_104154_104225[(2)] = inst_104007);

(statearr_104154_104225[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (22))){
var inst_104046 = (state_104131[(2)]);
var state_104131__$1 = state_104131;
if(cljs.core.truth_(inst_104046)){
var statearr_104155_104226 = state_104131__$1;
(statearr_104155_104226[(1)] = (26));

} else {
var statearr_104156_104227 = state_104131__$1;
(statearr_104156_104227[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (36))){
var inst_104098 = (state_104131[(14)]);
var inst_104104 = fluree.db.util.log.error.call(null,inst_104098,"Error processing message in producer.");
var state_104131__$1 = state_104131;
var statearr_104157_104228 = state_104131__$1;
(statearr_104157_104228[(2)] = inst_104104);

(statearr_104157_104228[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (41))){
var inst_104116 = (state_104131[(2)]);
var state_104131__$1 = state_104131;
var statearr_104158_104229 = state_104131__$1;
(statearr_104158_104229[(2)] = inst_104116);

(statearr_104158_104229[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (43))){
var state_104131__$1 = state_104131;
var statearr_104159_104230 = state_104131__$1;
(statearr_104159_104230[(2)] = null);

(statearr_104159_104230[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (29))){
var inst_103992 = (state_104131[(9)]);
var inst_104026 = (state_104131[(16)]);
var inst_104054 = (state_104131[(10)]);
var inst_104030 = (state_104131[(7)]);
var inst_104051 = (state_104131[(17)]);
var inst_104027 = (state_104131[(11)]);
var inst_103989 = (state_104131[(8)]);
var inst_104029 = (state_104131[(18)]);
var inst_104055 = (state_104131[(19)]);
var inst_104028 = (state_104131[(12)]);
var inst_104057 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104058 = [new cljs.core.Keyword(null,"pending-req","pending-req",2064800871),inst_104054];
var inst_104059 = (new cljs.core.PersistentVector(null,2,(5),inst_104057,inst_104058,null));
var inst_104060 = cljs.core.swap_BANG_.call(null,state,cljs.core.assoc_in,inst_104059,inst_104029);
var inst_104087 = cljs.core.async.chan.call(null,(1));
var inst_104088 = (function (){var resp_chan = inst_104029;
var timeout = inst_104055;
var c__86675__auto____$1 = inst_104087;
var i = inst_103989;
var data = inst_104028;
var map__104025 = inst_104051;
var vec__104022 = inst_103992;
var _ = inst_104026;
var req_id = inst_104054;
var operation = inst_104027;
var msg = inst_103992;
var opts = inst_104030;
return ((function (resp_chan,timeout,c__86675__auto____$1,i,data,map__104025,vec__104022,_,req_id,operation,msg,opts,inst_103992,inst_104026,inst_104054,inst_104030,inst_104051,inst_104027,inst_103989,inst_104029,inst_104055,inst_104028,inst_104057,inst_104058,inst_104059,inst_104060,inst_104087,state_val_104132,c__86675__auto__,state,req_chan,publish_fn){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (resp_chan,timeout,c__86675__auto____$1,i,data,map__104025,vec__104022,_,req_id,operation,msg,opts,inst_103992,inst_104026,inst_104054,inst_104030,inst_104051,inst_104027,inst_103989,inst_104029,inst_104055,inst_104028,inst_104057,inst_104058,inst_104059,inst_104060,inst_104087,state_val_104132,c__86675__auto__,state,req_chan,publish_fn){
return (function (state_104085){
var state_val_104086 = (state_104085[(1)]);
if((state_val_104086 === (1))){
var inst_104064 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104065 = cljs.core.async.timeout.call(null,timeout);
var inst_104066 = [resp_chan,inst_104065];
var inst_104067 = (new cljs.core.PersistentVector(null,2,(5),inst_104064,inst_104066,null));
var state_104085__$1 = state_104085;
return cljs.core.async.ioc_alts_BANG_.call(null,state_104085__$1,(2),inst_104067);
} else {
if((state_val_104086 === (2))){
var inst_104070 = (state_104085[(7)]);
var inst_104069 = (state_104085[(2)]);
var inst_104070__$1 = cljs.core.nth.call(null,inst_104069,(0),null);
var inst_104071 = cljs.core.nth.call(null,inst_104069,(1),null);
var inst_104072 = (function (){var vec__104061 = inst_104069;
var resp = inst_104070__$1;
var c = inst_104071;
return ((function (vec__104061,resp,c,inst_104070,inst_104069,inst_104070__$1,inst_104071,state_val_104086,resp_chan,timeout,c__86675__auto____$1,i,data,map__104025,vec__104022,_,req_id,operation,msg,opts,inst_103992,inst_104026,inst_104054,inst_104030,inst_104051,inst_104027,inst_103989,inst_104029,inst_104055,inst_104028,inst_104057,inst_104058,inst_104059,inst_104060,inst_104087,state_val_104132,c__86675__auto__,state,req_chan,publish_fn){
return (function (p1__103988_SHARP_){
return cljs.core.dissoc.call(null,p1__103988_SHARP_,req_id);
});
;})(vec__104061,resp,c,inst_104070,inst_104069,inst_104070__$1,inst_104071,state_val_104086,resp_chan,timeout,c__86675__auto____$1,i,data,map__104025,vec__104022,_,req_id,operation,msg,opts,inst_103992,inst_104026,inst_104054,inst_104030,inst_104051,inst_104027,inst_103989,inst_104029,inst_104055,inst_104028,inst_104057,inst_104058,inst_104059,inst_104060,inst_104087,state_val_104132,c__86675__auto__,state,req_chan,publish_fn))
})();
var inst_104073 = cljs.core.swap_BANG_.call(null,state,cljs.core.update,new cljs.core.Keyword(null,"pending-req","pending-req",2064800871),inst_104072);
var inst_104074 = cljs.core._EQ_.call(null,inst_104071,resp_chan);
var state_104085__$1 = (function (){var statearr_104160 = state_104085;
(statearr_104160[(7)] = inst_104070__$1);

(statearr_104160[(8)] = inst_104073);

return statearr_104160;
})();
if(inst_104074){
var statearr_104161_104231 = state_104085__$1;
(statearr_104161_104231[(1)] = (3));

} else {
var statearr_104162_104232 = state_104085__$1;
(statearr_104162_104232[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104086 === (3))){
var inst_104070 = (state_104085[(7)]);
var state_104085__$1 = state_104085;
var statearr_104163_104233 = state_104085__$1;
(statearr_104163_104233[(2)] = inst_104070);

(statearr_104163_104233[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104086 === (4))){
var inst_104077 = ["Request ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(req_id)," timed out."].join('');
var inst_104078 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_104079 = [(408),new cljs.core.Keyword("db","timeout","db/timeout",-318636520)];
var inst_104080 = cljs.core.PersistentHashMap.fromArrays(inst_104078,inst_104079);
var inst_104081 = cljs.core.ex_info.call(null,inst_104077,inst_104080);
var state_104085__$1 = state_104085;
var statearr_104164_104234 = state_104085__$1;
(statearr_104164_104234[(2)] = inst_104081);

(statearr_104164_104234[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104086 === (5))){
var inst_104083 = (state_104085[(2)]);
var state_104085__$1 = state_104085;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_104085__$1,inst_104083);
} else {
return null;
}
}
}
}
}
});})(resp_chan,timeout,c__86675__auto____$1,i,data,map__104025,vec__104022,_,req_id,operation,msg,opts,inst_103992,inst_104026,inst_104054,inst_104030,inst_104051,inst_104027,inst_103989,inst_104029,inst_104055,inst_104028,inst_104057,inst_104058,inst_104059,inst_104060,inst_104087,state_val_104132,c__86675__auto__,state,req_chan,publish_fn))
;
return ((function (switch__86624__auto__,resp_chan,timeout,c__86675__auto____$1,i,data,map__104025,vec__104022,_,req_id,operation,msg,opts,inst_103992,inst_104026,inst_104054,inst_104030,inst_104051,inst_104027,inst_103989,inst_104029,inst_104055,inst_104028,inst_104057,inst_104058,inst_104059,inst_104060,inst_104087,state_val_104132,c__86675__auto__,state,req_chan,publish_fn){
return (function() {
var fluree$db$connection$msg_producer_$_state_machine__86625__auto__ = null;
var fluree$db$connection$msg_producer_$_state_machine__86625__auto____0 = (function (){
var statearr_104165 = [null,null,null,null,null,null,null,null,null];
(statearr_104165[(0)] = fluree$db$connection$msg_producer_$_state_machine__86625__auto__);

(statearr_104165[(1)] = (1));

return statearr_104165;
});
var fluree$db$connection$msg_producer_$_state_machine__86625__auto____1 = (function (state_104085){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_104085);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e104166){if((e104166 instanceof Object)){
var ex__86628__auto__ = e104166;
var statearr_104167_104235 = state_104085;
(statearr_104167_104235[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104085);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e104166;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__104236 = state_104085;
state_104085 = G__104236;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$connection$msg_producer_$_state_machine__86625__auto__ = function(state_104085){
switch(arguments.length){
case 0:
return fluree$db$connection$msg_producer_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$connection$msg_producer_$_state_machine__86625__auto____1.call(this,state_104085);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$msg_producer_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$msg_producer_$_state_machine__86625__auto____0;
fluree$db$connection$msg_producer_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$msg_producer_$_state_machine__86625__auto____1;
return fluree$db$connection$msg_producer_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,resp_chan,timeout,c__86675__auto____$1,i,data,map__104025,vec__104022,_,req_id,operation,msg,opts,inst_103992,inst_104026,inst_104054,inst_104030,inst_104051,inst_104027,inst_103989,inst_104029,inst_104055,inst_104028,inst_104057,inst_104058,inst_104059,inst_104060,inst_104087,state_val_104132,c__86675__auto__,state,req_chan,publish_fn))
})();
var state__86677__auto__ = (function (){var statearr_104168 = f__86676__auto__.call(null);
(statearr_104168[(6)] = c__86675__auto____$1);

return statearr_104168;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});
;})(resp_chan,timeout,c__86675__auto____$1,i,data,map__104025,vec__104022,_,req_id,operation,msg,opts,inst_103992,inst_104026,inst_104054,inst_104030,inst_104051,inst_104027,inst_103989,inst_104029,inst_104055,inst_104028,inst_104057,inst_104058,inst_104059,inst_104060,inst_104087,state_val_104132,c__86675__auto__,state,req_chan,publish_fn))
})();
var inst_104089 = cljs.core.async.impl.dispatch.run.call(null,inst_104088);
var state_104131__$1 = (function (){var statearr_104169 = state_104131;
(statearr_104169[(20)] = inst_104060);

(statearr_104169[(21)] = inst_104089);

return statearr_104169;
})();
var statearr_104170_104237 = state_104131__$1;
(statearr_104170_104237[(2)] = inst_104087);

(statearr_104170_104237[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (44))){
var inst_104114 = (state_104131[(2)]);
var state_104131__$1 = state_104131;
var statearr_104171_104238 = state_104131__$1;
(statearr_104171_104238[(2)] = inst_104114);

(statearr_104171_104238[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (6))){
var state_104131__$1 = state_104131;
var statearr_104172_104239 = state_104131__$1;
(statearr_104172_104239[(2)] = null);

(statearr_104172_104239[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (28))){
var inst_104051 = (state_104131[(17)]);
var inst_104029 = (state_104131[(18)]);
var inst_104051__$1 = (state_104131[(2)]);
var inst_104052 = fluree.db.util.core.random_uuid.call(null);
var inst_104053 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_104052);
var inst_104054 = cljs.core.get.call(null,inst_104051__$1,new cljs.core.Keyword(null,"req-id","req-id",-471642231),inst_104053);
var inst_104055 = cljs.core.get.call(null,inst_104051__$1,new cljs.core.Keyword(null,"timeout","timeout",-318625318),(60000));
var state_104131__$1 = (function (){var statearr_104173 = state_104131;
(statearr_104173[(10)] = inst_104054);

(statearr_104173[(17)] = inst_104051__$1);

(statearr_104173[(19)] = inst_104055);

return statearr_104173;
})();
if(cljs.core.truth_(inst_104029)){
var statearr_104174_104240 = state_104131__$1;
(statearr_104174_104240[(1)] = (29));

} else {
var statearr_104175_104241 = state_104131__$1;
(statearr_104175_104241[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (25))){
var inst_104043 = (state_104131[(2)]);
var state_104131__$1 = state_104131;
var statearr_104176_104242 = state_104131__$1;
(statearr_104176_104242[(2)] = inst_104043);

(statearr_104176_104242[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (34))){
var inst_104098 = (state_104131[(14)]);
var inst_104102 = fluree.db.util.core.exception_QMARK_.call(null,inst_104098);
var state_104131__$1 = state_104131;
if(inst_104102){
var statearr_104177_104243 = state_104131__$1;
(statearr_104177_104243[(1)] = (36));

} else {
var statearr_104178_104244 = state_104131__$1;
(statearr_104178_104244[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (17))){
var inst_103992 = (state_104131[(9)]);
var inst_103994 = (state_104131[(22)]);
var inst_104014 = cljs.core.pr_str.call(null,inst_103992);
var inst_104015 = ["Error processing ledger request, no valid return channel: ",inst_104014].join('');
var inst_104016 = fluree.db.util.log.error.call(null,inst_103994,inst_104015);
var state_104131__$1 = state_104131;
var statearr_104179_104245 = state_104131__$1;
(statearr_104179_104245[(2)] = inst_104016);

(statearr_104179_104245[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (3))){
var inst_104129 = (state_104131[(2)]);
var state_104131__$1 = state_104131;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_104131__$1,inst_104129);
} else {
if((state_val_104132 === (12))){
var inst_104005 = (state_104131[(15)]);
var inst_104002 = (state_104131[(2)]);
var inst_104003 = cljs.core.nth.call(null,inst_104002,(0),null);
var inst_104004 = cljs.core.nth.call(null,inst_104002,(1),null);
var inst_104005__$1 = cljs.core.nth.call(null,inst_104002,(2),null);
var state_104131__$1 = (function (){var statearr_104180 = state_104131;
(statearr_104180[(23)] = inst_104004);

(statearr_104180[(15)] = inst_104005__$1);

(statearr_104180[(24)] = inst_104003);

return statearr_104180;
})();
if(cljs.core.truth_(inst_104005__$1)){
var statearr_104181_104246 = state_104131__$1;
(statearr_104181_104246[(1)] = (13));

} else {
var statearr_104182_104247 = state_104131__$1;
(statearr_104182_104247[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (2))){
var state_104131__$1 = state_104131;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_104131__$1,(4),req_chan);
} else {
if((state_val_104132 === (23))){
var state_104131__$1 = state_104131;
var statearr_104183_104248 = state_104131__$1;
(statearr_104183_104248[(2)] = true);

(statearr_104183_104248[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (35))){
var inst_104120 = (state_104131[(2)]);
var state_104131__$1 = state_104131;
var statearr_104184_104249 = state_104131__$1;
(statearr_104184_104249[(2)] = inst_104120);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104131__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (19))){
var inst_103992 = (state_104131[(9)]);
var inst_104030 = (state_104131[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_104131,(9),new cljs.core.Keyword(null,"default","default",-1987822328),null,(8));
var inst_104026 = fluree.db.util.log.trace.call(null,"Outgoing message to websocket: ",inst_103992);
var inst_104027 = cljs.core.nth.call(null,inst_103992,(0),null);
var inst_104028 = cljs.core.nth.call(null,inst_103992,(1),null);
var inst_104029 = cljs.core.nth.call(null,inst_103992,(2),null);
var inst_104030__$1 = cljs.core.nth.call(null,inst_103992,(3),null);
var inst_104032 = (inst_104030__$1 == null);
var inst_104033 = cljs.core.not.call(null,inst_104032);
var state_104131__$1 = (function (){var statearr_104185 = state_104131;
(statearr_104185[(16)] = inst_104026);

(statearr_104185[(7)] = inst_104030__$1);

(statearr_104185[(11)] = inst_104027);

(statearr_104185[(18)] = inst_104029);

(statearr_104185[(12)] = inst_104028);

return statearr_104185;
})();
if(inst_104033){
var statearr_104186_104250 = state_104131__$1;
(statearr_104186_104250[(1)] = (20));

} else {
var statearr_104187_104251 = state_104131__$1;
(statearr_104187_104251[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (11))){
var state_104131__$1 = state_104131;
var statearr_104188_104252 = state_104131__$1;
(statearr_104188_104252[(2)] = null);

(statearr_104188_104252[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (9))){
var inst_103992 = (state_104131[(9)]);
var inst_103994 = (state_104131[(2)]);
var inst_103998 = cljs.core.sequential_QMARK_.call(null,inst_103992);
var state_104131__$1 = (function (){var statearr_104189 = state_104131;
(statearr_104189[(22)] = inst_103994);

return statearr_104189;
})();
if(inst_103998){
var statearr_104190_104253 = state_104131__$1;
(statearr_104190_104253[(1)] = (10));

} else {
var statearr_104191_104254 = state_104131__$1;
(statearr_104191_104254[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (5))){
var state_104131__$1 = state_104131;
var statearr_104192_104255 = state_104131__$1;
(statearr_104192_104255[(2)] = null);

(statearr_104192_104255[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (14))){
var inst_104005 = (state_104131[(15)]);
var state_104131__$1 = state_104131;
var statearr_104193_104256 = state_104131__$1;
(statearr_104193_104256[(2)] = inst_104005);

(statearr_104193_104256[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (26))){
var inst_104030 = (state_104131[(7)]);
var inst_104048 = cljs.core.apply.call(null,cljs.core.hash_map,inst_104030);
var state_104131__$1 = state_104131;
var statearr_104194_104257 = state_104131__$1;
(statearr_104194_104257[(2)] = inst_104048);

(statearr_104194_104257[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (16))){
var inst_103994 = (state_104131[(22)]);
var inst_104005 = (state_104131[(15)]);
var inst_104012 = cljs.core.async.put_BANG_.call(null,inst_104005,inst_103994);
var state_104131__$1 = state_104131;
var statearr_104195_104258 = state_104131__$1;
(statearr_104195_104258[(2)] = inst_104012);

(statearr_104195_104258[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (38))){
var inst_104118 = (state_104131[(2)]);
var state_104131__$1 = state_104131;
var statearr_104196_104259 = state_104131__$1;
(statearr_104196_104259[(2)] = inst_104118);

(statearr_104196_104259[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (30))){
var state_104131__$1 = state_104131;
var statearr_104197_104260 = state_104131__$1;
(statearr_104197_104260[(2)] = null);

(statearr_104197_104260[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (10))){
var inst_103992 = (state_104131[(9)]);
var state_104131__$1 = state_104131;
var statearr_104198_104261 = state_104131__$1;
(statearr_104198_104261[(2)] = inst_103992);

(statearr_104198_104261[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (18))){
var inst_104018 = (state_104131[(2)]);
var state_104131__$1 = state_104131;
var statearr_104199_104262 = state_104131__$1;
(statearr_104199_104262[(2)] = inst_104018);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104131__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (42))){
var inst_104098 = (state_104131[(14)]);
var inst_104111 = fluree.db.util.log.error.call(null,"Error processing message in producer. Socket closed. Published result",inst_104098);
var state_104131__$1 = state_104131;
var statearr_104200_104263 = state_104131__$1;
(statearr_104200_104263[(2)] = inst_104111);

(statearr_104200_104263[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (37))){
var inst_104098 = (state_104131[(14)]);
var inst_104106 = (inst_104098 == null);
var state_104131__$1 = state_104131;
if(cljs.core.truth_(inst_104106)){
var statearr_104201_104264 = state_104131__$1;
(statearr_104201_104264[(1)] = (39));

} else {
var statearr_104202_104265 = state_104131__$1;
(statearr_104202_104265[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104132 === (8))){
var inst_103989 = (state_104131[(8)]);
var inst_104122 = (state_104131[(2)]);
var inst_104123 = (inst_103989 + (1));
var inst_103989__$1 = inst_104123;
var state_104131__$1 = (function (){var statearr_104203 = state_104131;
(statearr_104203[(8)] = inst_103989__$1);

(statearr_104203[(25)] = inst_104122);

return statearr_104203;
})();
var statearr_104204_104266 = state_104131__$1;
(statearr_104204_104266[(2)] = null);

(statearr_104204_104266[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,state,req_chan,publish_fn))
;
return ((function (switch__86624__auto__,c__86675__auto__,state,req_chan,publish_fn){
return (function() {
var fluree$db$connection$msg_producer_$_state_machine__86625__auto__ = null;
var fluree$db$connection$msg_producer_$_state_machine__86625__auto____0 = (function (){
var statearr_104205 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_104205[(0)] = fluree$db$connection$msg_producer_$_state_machine__86625__auto__);

(statearr_104205[(1)] = (1));

return statearr_104205;
});
var fluree$db$connection$msg_producer_$_state_machine__86625__auto____1 = (function (state_104131){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_104131);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e104206){if((e104206 instanceof Object)){
var ex__86628__auto__ = e104206;
var statearr_104207_104267 = state_104131;
(statearr_104207_104267[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104131);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e104206;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__104268 = state_104131;
state_104131 = G__104268;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$connection$msg_producer_$_state_machine__86625__auto__ = function(state_104131){
switch(arguments.length){
case 0:
return fluree$db$connection$msg_producer_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$connection$msg_producer_$_state_machine__86625__auto____1.call(this,state_104131);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$msg_producer_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$msg_producer_$_state_machine__86625__auto____0;
fluree$db$connection$msg_producer_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$msg_producer_$_state_machine__86625__auto____1;
return fluree$db$connection$msg_producer_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,state,req_chan,publish_fn))
})();
var state__86677__auto__ = (function (){var statearr_104208 = f__86676__auto__.call(null);
(statearr_104208[(6)] = c__86675__auto__);

return statearr_104208;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,state,req_chan,publish_fn))
);

return c__86675__auto__;
});
fluree.db.connection.ping_transactor = (function fluree$db$connection$ping_transactor(conn){
var req_chan = new cljs.core.Keyword(null,"req-chan","req-chan",-35924046).cljs$core$IFn$_invoke$arity$1(conn);
return cljs.core.async.put_BANG_.call(null,req_chan,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"ping","ping",-1670114784),true], null));
});
/**
 * Takes messages from peer/ledger and processes them.
 */
fluree.db.connection.msg_consumer = (function fluree$db$connection$msg_consumer(conn){
var ping_transactor_after = (2500);
var map__104269 = conn;
var map__104269__$1 = (((((!((map__104269 == null))))?(((((map__104269.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__104269.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__104269):map__104269);
var sub_chan = cljs.core.get.call(null,map__104269__$1,new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215));
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,ping_transactor_after,map__104269,map__104269__$1,sub_chan){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,ping_transactor_after,map__104269,map__104269__$1,sub_chan){
return (function (state_104352){
var state_val_104353 = (state_104352[(1)]);
if((state_val_104353 === (7))){
var inst_104348 = (state_104352[(2)]);
var state_104352__$1 = state_104352;
var statearr_104354_104404 = state_104352__$1;
(statearr_104354_104404[(2)] = inst_104348);

(statearr_104354_104404[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (20))){
var inst_104289 = (state_104352[(7)]);
var inst_104303 = [new cljs.core.Keyword(null,"keep-alive-fn","keep-alive-fn",-1421484581)];
var inst_104304 = [inst_104289];
var inst_104305 = cljs.core.PersistentHashMap.fromArrays(inst_104303,inst_104304);
var inst_104306 = fluree.db.util.log.warn.call(null,"Unsupported callback registered",inst_104305);
var state_104352__$1 = state_104352;
var statearr_104355_104405 = state_104352__$1;
(statearr_104355_104405[(2)] = inst_104306);

(statearr_104355_104405[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (27))){
var state_104352__$1 = state_104352;
var statearr_104356_104406 = state_104352__$1;
(statearr_104356_104406[(1)] = (29));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (1))){
var inst_104271 = (0);
var state_104352__$1 = (function (){var statearr_104358 = state_104352;
(statearr_104358[(8)] = inst_104271);

return statearr_104358;
})();
var statearr_104359_104407 = state_104352__$1;
(statearr_104359_104407[(2)] = null);

(statearr_104359_104407[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (24))){
var inst_104282 = (state_104352[(9)]);
var inst_104331 = fluree.db.util.core.exception_QMARK_.call(null,inst_104282);
var state_104352__$1 = state_104352;
if(inst_104331){
var statearr_104360_104408 = state_104352__$1;
(statearr_104360_104408[(1)] = (26));

} else {
var statearr_104361_104409 = state_104352__$1;
(statearr_104361_104409[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (4))){
var inst_104276 = (state_104352[(10)]);
var inst_104281 = (state_104352[(2)]);
var inst_104282 = cljs.core.nth.call(null,inst_104281,(0),null);
var inst_104283 = cljs.core.nth.call(null,inst_104281,(1),null);
var inst_104284 = cljs.core._EQ_.call(null,inst_104283,inst_104276);
var state_104352__$1 = (function (){var statearr_104362 = state_104352;
(statearr_104362[(9)] = inst_104282);

return statearr_104362;
})();
if(inst_104284){
var statearr_104363_104410 = state_104352__$1;
(statearr_104363_104410[(1)] = (5));

} else {
var statearr_104364_104411 = state_104352__$1;
(statearr_104364_104411[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (15))){
var inst_104289 = (state_104352[(7)]);
var inst_104298 = typeof inst_104289 === 'string';
var state_104352__$1 = state_104352;
if(cljs.core.truth_(inst_104298)){
var statearr_104365_104412 = state_104352__$1;
(statearr_104365_104412[(1)] = (17));

} else {
var statearr_104366_104413 = state_104352__$1;
(statearr_104366_104413[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (21))){
var state_104352__$1 = state_104352;
var statearr_104367_104414 = state_104352__$1;
(statearr_104367_104414[(2)] = null);

(statearr_104367_104414[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (31))){
var inst_104342 = (state_104352[(2)]);
var state_104352__$1 = state_104352;
var statearr_104368_104415 = state_104352__$1;
(statearr_104368_104415[(2)] = inst_104342);

(statearr_104368_104415[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (13))){
var inst_104315 = (state_104352[(2)]);
var inst_104316 = new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(conn);
var inst_104317 = fluree.db.connection.close_websocket.call(null,inst_104316);
var inst_104318 = new cljs.core.Keyword(null,"id","id",-1388402092).cljs$core$IFn$_invoke$arity$1(conn);
var inst_104319 = fluree.db.session.close_all_sessions.call(null,inst_104318);
var state_104352__$1 = (function (){var statearr_104369 = state_104352;
(statearr_104369[(11)] = inst_104315);

(statearr_104369[(12)] = inst_104317);

return statearr_104369;
})();
var statearr_104370_104416 = state_104352__$1;
(statearr_104370_104416[(2)] = inst_104319);

(statearr_104370_104416[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (22))){
var inst_104309 = (state_104352[(2)]);
var state_104352__$1 = state_104352;
var statearr_104371_104417 = state_104352__$1;
(statearr_104371_104417[(2)] = inst_104309);

(statearr_104371_104417[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (29))){
var inst_104282 = (state_104352[(9)]);
var inst_104337 = fluree.db.util.json.parse.call(null,inst_104282);
var inst_104338 = fluree.db.connection.process_events.call(null,conn,inst_104337);
var inst_104271 = (0);
var state_104352__$1 = (function (){var statearr_104372 = state_104352;
(statearr_104372[(13)] = inst_104338);

(statearr_104372[(8)] = inst_104271);

return statearr_104372;
})();
var statearr_104373_104418 = state_104352__$1;
(statearr_104373_104418[(2)] = null);

(statearr_104373_104418[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (6))){
var inst_104282 = (state_104352[(9)]);
var inst_104327 = (inst_104282 == null);
var state_104352__$1 = state_104352;
if(cljs.core.truth_(inst_104327)){
var statearr_104374_104419 = state_104352__$1;
(statearr_104374_104419[(1)] = (23));

} else {
var statearr_104375_104420 = state_104352__$1;
(statearr_104375_104420[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (28))){
var inst_104344 = (state_104352[(2)]);
var state_104352__$1 = state_104352;
var statearr_104376_104421 = state_104352__$1;
(statearr_104376_104421[(2)] = inst_104344);

(statearr_104376_104421[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (25))){
var inst_104346 = (state_104352[(2)]);
var state_104352__$1 = state_104352;
var statearr_104377_104422 = state_104352__$1;
(statearr_104377_104422[(2)] = inst_104346);

(statearr_104377_104422[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (17))){
var inst_104289 = (state_104352[(7)]);
var inst_104300 = cljs.core.eval.call(null,inst_104289);
var state_104352__$1 = state_104352;
var statearr_104378_104423 = state_104352__$1;
(statearr_104378_104423[(2)] = inst_104300);

(statearr_104378_104423[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (3))){
var inst_104350 = (state_104352[(2)]);
var state_104352__$1 = state_104352;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_104352__$1,inst_104350);
} else {
if((state_val_104353 === (12))){
var inst_104289 = (state_104352[(7)]);
var inst_104294 = cljs.core.fn_QMARK_.call(null,inst_104289);
var state_104352__$1 = state_104352;
if(inst_104294){
var statearr_104379_104424 = state_104352__$1;
(statearr_104379_104424[(1)] = (14));

} else {
var statearr_104380_104425 = state_104352__$1;
(statearr_104380_104425[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (2))){
var inst_104276 = (state_104352[(10)]);
var inst_104276__$1 = cljs.core.async.timeout.call(null,ping_transactor_after);
var inst_104277 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_104278 = [sub_chan,inst_104276__$1];
var inst_104279 = (new cljs.core.PersistentVector(null,2,(5),inst_104277,inst_104278,null));
var state_104352__$1 = (function (){var statearr_104381 = state_104352;
(statearr_104381[(10)] = inst_104276__$1);

return statearr_104381;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_104352__$1,(4),inst_104279);
} else {
if((state_val_104353 === (23))){
var inst_104329 = fluree.db.util.log.info.call(null,"Connection closed.");
var state_104352__$1 = state_104352;
var statearr_104382_104426 = state_104352__$1;
(statearr_104382_104426[(2)] = inst_104329);

(statearr_104382_104426[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (19))){
var inst_104311 = (state_104352[(2)]);
var state_104352__$1 = state_104352;
var statearr_104383_104427 = state_104352__$1;
(statearr_104383_104427[(2)] = inst_104311);

(statearr_104383_104427[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (11))){
var inst_104292 = fluree.db.util.log.trace.call(null,"No keep-alive callback is registered");
var state_104352__$1 = state_104352;
var statearr_104384_104428 = state_104352__$1;
(statearr_104384_104428[(2)] = inst_104292);

(statearr_104384_104428[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (9))){
var inst_104271 = (state_104352[(8)]);
var inst_104321 = fluree.db.connection.ping_transactor.call(null,conn);
var inst_104322 = (inst_104271 + (1));
var inst_104271__$1 = inst_104322;
var state_104352__$1 = (function (){var statearr_104385 = state_104352;
(statearr_104385[(8)] = inst_104271__$1);

(statearr_104385[(14)] = inst_104321);

return statearr_104385;
})();
var statearr_104386_104429 = state_104352__$1;
(statearr_104386_104429[(2)] = null);

(statearr_104386_104429[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (5))){
var inst_104271 = (state_104352[(8)]);
var inst_104286 = cljs.core._EQ_.call(null,(2),inst_104271);
var state_104352__$1 = state_104352;
if(inst_104286){
var statearr_104387_104430 = state_104352__$1;
(statearr_104387_104430[(1)] = (8));

} else {
var statearr_104388_104431 = state_104352__$1;
(statearr_104388_104431[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (14))){
var inst_104289 = (state_104352[(7)]);
var inst_104296 = inst_104289.call(null);
var state_104352__$1 = state_104352;
var statearr_104389_104432 = state_104352__$1;
(statearr_104389_104432[(2)] = inst_104296);

(statearr_104389_104432[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (26))){
var inst_104282 = (state_104352[(9)]);
var inst_104333 = fluree.db.util.log.error.call(null,inst_104282);
var inst_104271 = (0);
var state_104352__$1 = (function (){var statearr_104390 = state_104352;
(statearr_104390[(15)] = inst_104333);

(statearr_104390[(8)] = inst_104271);

return statearr_104390;
})();
var statearr_104391_104433 = state_104352__$1;
(statearr_104391_104433[(2)] = null);

(statearr_104391_104433[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (16))){
var inst_104313 = (state_104352[(2)]);
var state_104352__$1 = state_104352;
var statearr_104392_104434 = state_104352__$1;
(statearr_104392_104434[(2)] = inst_104313);

(statearr_104392_104434[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (30))){
var state_104352__$1 = state_104352;
var statearr_104393_104435 = state_104352__$1;
(statearr_104393_104435[(2)] = null);

(statearr_104393_104435[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (10))){
var inst_104325 = (state_104352[(2)]);
var state_104352__$1 = state_104352;
var statearr_104394_104436 = state_104352__$1;
(statearr_104394_104436[(2)] = inst_104325);

(statearr_104394_104436[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (18))){
var state_104352__$1 = state_104352;
var statearr_104395_104437 = state_104352__$1;
(statearr_104395_104437[(1)] = (20));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104353 === (8))){
var inst_104289 = (state_104352[(7)]);
var inst_104288 = fluree.db.util.log.warn.call(null,"Connection has gone stale. Perhaps network conditions are poor. Disconnecting socket.");
var inst_104289__$1 = new cljs.core.Keyword(null,"keep-alive-fn","keep-alive-fn",-1421484581).cljs$core$IFn$_invoke$arity$1(conn);
var inst_104290 = (inst_104289__$1 == null);
var state_104352__$1 = (function (){var statearr_104397 = state_104352;
(statearr_104397[(7)] = inst_104289__$1);

(statearr_104397[(16)] = inst_104288);

return statearr_104397;
})();
if(cljs.core.truth_(inst_104290)){
var statearr_104398_104438 = state_104352__$1;
(statearr_104398_104438[(1)] = (11));

} else {
var statearr_104399_104439 = state_104352__$1;
(statearr_104399_104439[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,ping_transactor_after,map__104269,map__104269__$1,sub_chan))
;
return ((function (switch__86624__auto__,c__86675__auto__,ping_transactor_after,map__104269,map__104269__$1,sub_chan){
return (function() {
var fluree$db$connection$msg_consumer_$_state_machine__86625__auto__ = null;
var fluree$db$connection$msg_consumer_$_state_machine__86625__auto____0 = (function (){
var statearr_104400 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_104400[(0)] = fluree$db$connection$msg_consumer_$_state_machine__86625__auto__);

(statearr_104400[(1)] = (1));

return statearr_104400;
});
var fluree$db$connection$msg_consumer_$_state_machine__86625__auto____1 = (function (state_104352){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_104352);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e104401){if((e104401 instanceof Object)){
var ex__86628__auto__ = e104401;
var statearr_104402_104440 = state_104352;
(statearr_104402_104440[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104352);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e104401;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__104441 = state_104352;
state_104352 = G__104441;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$connection$msg_consumer_$_state_machine__86625__auto__ = function(state_104352){
switch(arguments.length){
case 0:
return fluree$db$connection$msg_consumer_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$connection$msg_consumer_$_state_machine__86625__auto____1.call(this,state_104352);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$msg_consumer_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$msg_consumer_$_state_machine__86625__auto____0;
fluree$db$connection$msg_consumer_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$msg_consumer_$_state_machine__86625__auto____1;
return fluree$db$connection$msg_consumer_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,ping_transactor_after,map__104269,map__104269__$1,sub_chan))
})();
var state__86677__auto__ = (function (){var statearr_104403 = f__86676__auto__.call(null);
(statearr_104403[(6)] = c__86675__auto__);

return statearr_104403;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,ping_transactor_after,map__104269,map__104269__$1,sub_chan))
);

return c__86675__auto__;
});
/**
 * Default storage read function - uses ledger storage and issues http(s) requests.
 */
fluree.db.connection.default_storage_read = (function fluree$db$connection$default_storage_read(var_args){
var G__104443 = arguments.length;
switch (G__104443) {
case 2:
return fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$2 = (function (conn_id,servers){
return fluree.db.connection.default_storage_read.call(null,conn_id,servers,null);
});

fluree.db.connection.default_storage_read.cljs$core$IFn$_invoke$arity$3 = (function (conn_id,servers,opts){
var map__104444 = opts;
var map__104444__$1 = (((((!((map__104444 == null))))?(((((map__104444.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__104444.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__104444):map__104444);
var private$ = cljs.core.get.call(null,map__104444__$1,new cljs.core.Keyword(null,"private","private",-558947994));
return ((function (map__104444,map__104444__$1,private$){
return (function (k){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,map__104444,map__104444__$1,private$){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,map__104444,map__104444__$1,private$){
return (function (state_104483){
var state_val_104484 = (state_104483[(1)]);
if((state_val_104484 === (7))){
var inst_104458 = (state_104483[(7)]);
var state_104483__$1 = state_104483;
var statearr_104485_104504 = state_104483__$1;
(statearr_104485_104504[(2)] = inst_104458);

(statearr_104485_104504[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104484 === (1))){
var state_104483__$1 = state_104483;
var statearr_104486_104505 = state_104483__$1;
(statearr_104486_104505[(2)] = null);

(statearr_104486_104505[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104484 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_104483,(3),Error,null,(2));
var inst_104450 = clojure.string.replace.call(null,k,"_","/");
var inst_104451 = fluree.db.connection.get_server.call(null,conn_id,servers);
var state_104483__$1 = (function (){var statearr_104487 = state_104483;
(statearr_104487[(8)] = inst_104450);

return statearr_104487;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_104483__$1,(5),inst_104451);
} else {
if((state_val_104484 === (6))){
var inst_104458 = (state_104483[(7)]);
var inst_104460 = cljs.core.assoc.call(null,inst_104458,"X-fdb-pri",private$);
var state_104483__$1 = state_104483;
var statearr_104488_104506 = state_104483__$1;
(statearr_104488_104506[(2)] = inst_104460);

(statearr_104488_104506[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104484 === (3))){
var inst_104446 = (state_104483[(2)]);
var state_104483__$1 = state_104483;
var statearr_104489_104507 = state_104483__$1;
(statearr_104489_104507[(2)] = inst_104446);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104483__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104484 === (12))){
var inst_104478 = (state_104483[(2)]);
var inst_104479 = fluree.db.util.async.throw_err.call(null,inst_104478);
var state_104483__$1 = state_104483;
var statearr_104490_104508 = state_104483__$1;
(statearr_104490_104508[(2)] = inst_104479);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104483__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104484 === (2))){
var inst_104481 = (state_104483[(2)]);
var state_104483__$1 = state_104483;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_104483__$1,inst_104481);
} else {
if((state_val_104484 === (11))){
var inst_104454 = (state_104483[(9)]);
var inst_104472 = (state_104483[(2)]);
var inst_104473 = [new cljs.core.Keyword(null,"request-timeout","request-timeout",-2047539823),new cljs.core.Keyword(null,"headers","headers",-835030129),new cljs.core.Keyword(null,"output-format","output-format",-1826382676)];
var inst_104474 = [(5000),inst_104472,new cljs.core.Keyword(null,"text","text",-1790561697)];
var inst_104475 = cljs.core.PersistentHashMap.fromArrays(inst_104473,inst_104474);
var inst_104476 = fluree.db.util.xhttp.get.call(null,inst_104454,inst_104475);
var state_104483__$1 = state_104483;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_104483__$1,(12),inst_104476);
} else {
if((state_val_104484 === (9))){
var inst_104463 = (state_104483[(10)]);
var inst_104454 = (state_104483[(9)]);
var inst_104465 = [new cljs.core.Keyword(null,"headers","headers",-835030129)];
var inst_104466 = [inst_104463];
var inst_104467 = cljs.core.PersistentHashMap.fromArrays(inst_104465,inst_104466);
var inst_104468 = fluree.db.query.http_signatures.sign_request.call(null,"get",inst_104454,inst_104467,private$);
var inst_104469 = new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(inst_104468);
var state_104483__$1 = state_104483;
var statearr_104491_104509 = state_104483__$1;
(statearr_104491_104509[(2)] = inst_104469);

(statearr_104491_104509[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104484 === (5))){
var inst_104450 = (state_104483[(8)]);
var inst_104453 = (state_104483[(2)]);
var inst_104454 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_104453),"/fdb/storage/",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_104450)].join('');
var inst_104456 = ["Accept"];
var inst_104457 = ["application/json"];
var inst_104458 = cljs.core.PersistentHashMap.fromArrays(inst_104456,inst_104457);
var state_104483__$1 = (function (){var statearr_104492 = state_104483;
(statearr_104492[(9)] = inst_104454);

(statearr_104492[(7)] = inst_104458);

return statearr_104492;
})();
if(cljs.core.truth_(private$)){
var statearr_104493_104510 = state_104483__$1;
(statearr_104493_104510[(1)] = (6));

} else {
var statearr_104494_104511 = state_104483__$1;
(statearr_104494_104511[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104484 === (10))){
var inst_104463 = (state_104483[(10)]);
var state_104483__$1 = state_104483;
var statearr_104495_104512 = state_104483__$1;
(statearr_104495_104512[(2)] = inst_104463);

(statearr_104495_104512[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104484 === (8))){
var inst_104463 = (state_104483[(2)]);
var state_104483__$1 = (function (){var statearr_104496 = state_104483;
(statearr_104496[(10)] = inst_104463);

return statearr_104496;
})();
if(cljs.core.truth_(private$)){
var statearr_104497_104513 = state_104483__$1;
(statearr_104497_104513[(1)] = (9));

} else {
var statearr_104498_104514 = state_104483__$1;
(statearr_104498_104514[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,map__104444,map__104444__$1,private$))
;
return ((function (switch__86624__auto__,c__86675__auto__,map__104444,map__104444__$1,private$){
return (function() {
var fluree$db$connection$state_machine__86625__auto__ = null;
var fluree$db$connection$state_machine__86625__auto____0 = (function (){
var statearr_104499 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_104499[(0)] = fluree$db$connection$state_machine__86625__auto__);

(statearr_104499[(1)] = (1));

return statearr_104499;
});
var fluree$db$connection$state_machine__86625__auto____1 = (function (state_104483){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_104483);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e104500){if((e104500 instanceof Object)){
var ex__86628__auto__ = e104500;
var statearr_104501_104515 = state_104483;
(statearr_104501_104515[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104483);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e104500;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__104516 = state_104483;
state_104483 = G__104516;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$connection$state_machine__86625__auto__ = function(state_104483){
switch(arguments.length){
case 0:
return fluree$db$connection$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$connection$state_machine__86625__auto____1.call(this,state_104483);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$state_machine__86625__auto____0;
fluree$db$connection$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$state_machine__86625__auto____1;
return fluree$db$connection$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,map__104444,map__104444__$1,private$))
})();
var state__86677__auto__ = (function (){var statearr_104502 = f__86676__auto__.call(null);
(statearr_104502[(6)] = c__86675__auto__);

return statearr_104502;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,map__104444,map__104444__$1,private$))
);

return c__86675__auto__;
});
;})(map__104444,map__104444__$1,private$))
});

fluree.db.connection.default_storage_read.cljs$lang$maxFixedArity = 3;

/**
 * Default object cache to use for ledger.
 */
fluree.db.connection.default_object_cache_fn = (function fluree$db$connection$default_object_cache_fn(cache_atom){
return (function (k,value_fn){
if((value_fn == null)){
return cljs.core.swap_BANG_.call(null,cache_atom,cljs.cache.evict,k);
} else {
var temp__5733__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,cache_atom),k);
if(cljs.core.truth_(temp__5733__auto__)){
var v = temp__5733__auto__;
cljs.core.swap_BANG_.call(null,cache_atom,cljs.cache.hit,k);

return v;
} else {
var v = value_fn.call(null,k);
cljs.core.swap_BANG_.call(null,cache_atom,cljs.cache.miss,k,v);

return v;
}
}
});
});
/**
 * Generates a default object cache.
 */
fluree.db.connection.default_object_cache_factory = (function fluree$db$connection$default_object_cache_factory(cache_size){
return cljs.cache.lru_cache_factory.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"threshold","threshold",204221583),cache_size);
});
/**
 * Gets a specific key from the environment, returns nil if doesn't exist.
 */
fluree.db.connection.from_environment = (function fluree$db$connection$from_environment(key){
return null;
});
/**
 * Returns list of listeners
 */
fluree.db.connection.listeners = (function fluree$db$connection$listeners(conn_state){
return new cljs.core.Keyword(null,"listeners","listeners",394544445).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,conn_state));
});
/**
 * Internal call to add-listener that uses the state atom directly.
 */
fluree.db.connection.add_listener_STAR_ = (function fluree$db$connection$add_listener_STAR_(conn_state,network,dbid,key,fn){
if(cljs.core.fn_QMARK_.call(null,fn)){
} else {
throw cljs.core.ex_info.call(null,"add-listener fn paramer not a function.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-listener","db/invalid-listener",632510971)], null));
}

if((key == null)){
throw cljs.core.ex_info.call(null,"add-listener key must not be nil.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-listener","db/invalid-listener",632510971)], null));
} else {
}

cljs.core.swap_BANG_.call(null,conn_state,cljs.core.update_in,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"listeners","listeners",394544445),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null),key], null),(function (p1__104517_SHARP_){
if(cljs.core.truth_(p1__104517_SHARP_)){
throw cljs.core.ex_info.call(null,["add-listener key already in use: ",cljs.core.pr_str.call(null,key)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-listener","db/invalid-listener",632510971)], null));
} else {
return fn;
}
}));

return true;
});
/**
 * Internal call to remove-listener that uses the state atom directly.
 */
fluree.db.connection.remove_listener_STAR_ = (function fluree$db$connection$remove_listener_STAR_(conn_state,network,dbid,key){
if(cljs.core.truth_(cljs.core.get_in.call(null,cljs.core.deref.call(null,conn_state),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"listeners","listeners",394544445),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null),key], null)))){
cljs.core.swap_BANG_.call(null,conn_state,cljs.core.update_in,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"listeners","listeners",394544445),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [network,dbid], null)], null),cljs.core.dissoc,key);

return true;
} else {
return false;
}
});
/**
 * Registers a new listener function, fn,  on connection.
 * 
 *   Each listener must have an associated key, which is used to remove the listener
 *   when needed but is otherwise opaque to the function. Each key must be unique for the
 *   given network + dbid.
 */
fluree.db.connection.add_listener = (function fluree$db$connection$add_listener(conn,network,dbid,key,fn){
return fluree.db.connection.add_listener_STAR_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(conn),network,dbid,key,fn);
});
/**
 * Removes listener on given network + dbid for the provided key.
 * 
 *   The key is the same provided for add-listener when registering.
 * 
 *   Will return true if a function exists for that key and it was removed.
 */
fluree.db.connection.remove_listener = (function fluree$db$connection$remove_listener(conn,network,dbid,key){
return fluree.db.connection.remove_listener_STAR_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(conn),network,dbid,key);
});
/**
 * Generates connection object.
 */
fluree.db.connection.generate_connection = (function fluree$db$connection$generate_connection(servers,opts){
var state_atom = cljs.core.atom.call(null,new cljs.core.PersistentArrayMap(null, 7, [new cljs.core.Keyword(null,"close?","close?",1600185693),false,new cljs.core.Keyword(null,"health","health",-295520649),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"connected-to","connected-to",-1930163150),null,new cljs.core.Keyword(null,"socket","socket",59137063),null,new cljs.core.Keyword(null,"socket-id","socket-id",1022615280),null,new cljs.core.Keyword(null,"pending-req","pending-req",2064800871),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"listeners","listeners",394544445),cljs.core.PersistentArrayMap.EMPTY], null));
var map__104518 = opts;
var map__104518__$1 = (((((!((map__104518 == null))))?(((((map__104518.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__104518.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__104518):map__104518);
var sub_chan = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215),cljs.core.async.chan.call(null));
var storage_rename = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"storage-rename","storage-rename",-310600229));
var keep_alive_fn = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"keep-alive-fn","keep-alive-fn",-1421484581));
var publish = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"publish","publish",-1178026850));
var close_fn = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"close-fn","close-fn",-1779772512));
var default_network = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"default-network","default-network",586420705));
var object_cache = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287));
var transact_handler = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"transact-handler","transact-handler",-745499037));
var parallelism = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"parallelism","parallelism",-930922333),(4));
var meta = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"meta","meta",1499536964));
var tx_private_key = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"tx-private-key","tx-private-key",-1231668122));
var private$ = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"private","private",-558947994));
var storage_read = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"storage-read","storage-read",-885692537));
var transactor_QMARK_ = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057),false);
var serializer = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"serializer","serializer",-875689688),fluree.db.serde.json.json_serde.call(null));
var memory = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"memory","memory",-1449401430),(1000000));
var storage_exists = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"storage-exists","storage-exists",1403264075));
var storage_write = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"storage-write","storage-write",595144816),((function (state_atom,map__104518,map__104518__$1,sub_chan,storage_rename,keep_alive_fn,publish,close_fn,default_network,object_cache,transact_handler,parallelism,meta,tx_private_key,private$,storage_read,transactor_QMARK_,serializer,memory,storage_exists){
return (function (k,v){
throw cljs.core.ex_info.call(null,["Storage write was not implemented on connection, but was called to store key: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(k)].join(''),cljs.core.PersistentArrayMap.EMPTY);
});})(state_atom,map__104518,map__104518__$1,sub_chan,storage_rename,keep_alive_fn,publish,close_fn,default_network,object_cache,transact_handler,parallelism,meta,tx_private_key,private$,storage_read,transactor_QMARK_,serializer,memory,storage_exists))
);
var memory_QMARK_ = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"memory?","memory?",-596367598),false);
var req_chan = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"req-chan","req-chan",-35924046),cljs.core.async.chan.call(null));
var pub_chan = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593),cljs.core.async.chan.call(null));
var private_key_file = cljs.core.get.call(null,map__104518__$1,new cljs.core.Keyword(null,"private-key-file","private-key-file",-1118989000),"default-private-key.txt");
var memory_object_size = cljs.core.quot.call(null,memory,(100000));
var _ = (((memory_object_size < (10)))?(function(){throw cljs.core.ex_info.call(null,["Must allocate at least 1MB of memory for Fluree. You've allocated: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(memory)," bytes."].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-configuration","db/invalid-configuration",559343174)], null))})():null);
var default_cache_atom = cljs.core.atom.call(null,fluree.db.connection.default_object_cache_factory.call(null,memory_object_size));
var object_cache_fn = (function (){var or__4131__auto__ = object_cache;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return fluree.db.connection.default_object_cache_fn.call(null,default_cache_atom);
}
})();
var conn_id = cljs.core.str.cljs$core$IFn$_invoke$arity$1(fluree.db.util.core.random_uuid.call(null));
var close = ((function (state_atom,map__104518,map__104518__$1,sub_chan,storage_rename,keep_alive_fn,publish,close_fn,default_network,object_cache,transact_handler,parallelism,meta,tx_private_key,private$,storage_read,transactor_QMARK_,serializer,memory,storage_exists,storage_write,memory_QMARK_,req_chan,pub_chan,private_key_file,memory_object_size,_,default_cache_atom,object_cache_fn,conn_id){
return (function (){
cljs.core.async.close_BANG_.call(null,req_chan);

cljs.core.async.close_BANG_.call(null,sub_chan);

cljs.core.async.close_BANG_.call(null,pub_chan);

fluree.db.connection.close_websocket.call(null,conn_id);

cljs.core.swap_BANG_.call(null,state_atom,cljs.core.assoc,new cljs.core.Keyword(null,"close?","close?",1600185693),true);

fluree.db.session.close_all_sessions.call(null,conn_id);

cljs.core.reset_BANG_.call(null,default_cache_atom,fluree.db.connection.default_object_cache_factory.call(null,memory_object_size));

if(cljs.core.fn_QMARK_.call(null,close_fn)){
close_fn.call(null);
} else {
}

return fluree.db.util.log.info.call(null,new cljs.core.Keyword(null,"conn-closed","conn-closed",-541764356));
});})(state_atom,map__104518,map__104518__$1,sub_chan,storage_rename,keep_alive_fn,publish,close_fn,default_network,object_cache,transact_handler,parallelism,meta,tx_private_key,private$,storage_read,transactor_QMARK_,serializer,memory,storage_exists,storage_write,memory_QMARK_,req_chan,pub_chan,private_key_file,memory_object_size,_,default_cache_atom,object_cache_fn,conn_id))
;
var servers_STAR_ = fluree.db.connection.normalize_servers.call(null,servers,transactor_QMARK_);
var storage_read_STAR_ = (function (){var or__4131__auto__ = storage_read;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return fluree.db.connection.default_storage_read.call(null,conn_id,servers_STAR_,opts);
}
})();
var storage_exists_STAR_ = (function (){var or__4131__auto__ = storage_exists;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
var or__4131__auto____$1 = storage_read;
if(cljs.core.truth_(or__4131__auto____$1)){
return or__4131__auto____$1;
} else {
return fluree.db.connection.default_storage_read.call(null,conn_id,servers_STAR_,opts);
}
}
})();
var ___$1 = ((cljs.core.fn_QMARK_.call(null,storage_read_STAR_))?null:(function(){throw cljs.core.ex_info.call(null,["Connection's storage-read must be a function. Provided: ",cljs.core.pr_str.call(null,storage_read)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(500),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)], null))})());
var ___$2 = ((cljs.core.fn_QMARK_.call(null,storage_exists_STAR_))?null:(function(){throw cljs.core.ex_info.call(null,["Connection's storage-exists must be a function. Provided: ",cljs.core.pr_str.call(null,storage_exists)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(500),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)], null))})());
var ___$3 = (cljs.core.truth_((function (){var and__4120__auto__ = storage_write;
if(cljs.core.truth_(and__4120__auto__)){
return (!(cljs.core.fn_QMARK_.call(null,storage_write)));
} else {
return and__4120__auto__;
}
})())?(function(){throw cljs.core.ex_info.call(null,["Connection's storage-write, if provided, must be a function. Provided: ",cljs.core.pr_str.call(null,storage_write)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(500),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)], null))})():null);
var settings = cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"object-cache","object-cache",-2130324287),new cljs.core.Keyword(null,"default-network","default-network",586420705),new cljs.core.Keyword(null,"parallelism","parallelism",-930922333),new cljs.core.Keyword(null,"transact-handler","transact-handler",-745499037),new cljs.core.Keyword(null,"add-listener","add-listener",313698051),new cljs.core.Keyword(null,"meta","meta",1499536964),new cljs.core.Keyword(null,"tx-private-key","tx-private-key",-1231668122),new cljs.core.Keyword(null,"remove-listener","remove-listener",-418647802),new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057),new cljs.core.Keyword(null,"storage-read","storage-read",-885692537),new cljs.core.Keyword(null,"serializer","serializer",-875689688),new cljs.core.Keyword(null,"memory","memory",-1449401430),new cljs.core.Keyword(null,"storage-exists","storage-exists",1403264075),new cljs.core.Keyword(null,"state","state",-1988618099),new cljs.core.Keyword(null,"close","close",1835149582),new cljs.core.Keyword(null,"tx-key-id","tx-key-id",-1451912145),new cljs.core.Keyword(null,"storage-write","storage-write",595144816),new cljs.core.Keyword(null,"req-chan","req-chan",-35924046),new cljs.core.Keyword(null,"id","id",-1388402092),new cljs.core.Keyword(null,"servers","servers",1881102005),new cljs.core.Keyword(null,"pub-chan","pub-chan",-46915593),new cljs.core.Keyword(null,"sub-chan","sub-chan",-2012438215),new cljs.core.Keyword(null,"storage-rename","storage-rename",-310600229),new cljs.core.Keyword(null,"keep-alive-fn","keep-alive-fn",-1421484581),new cljs.core.Keyword(null,"publish","publish",-1178026850)],[object_cache_fn,default_network,parallelism,transact_handler,cljs.core.partial.call(null,fluree.db.connection.add_listener_STAR_,state_atom),meta,tx_private_key,cljs.core.partial.call(null,fluree.db.connection.remove_listener_STAR_,state_atom),transactor_QMARK_,storage_read_STAR_,serializer,memory_QMARK_,storage_exists_STAR_,state_atom,close,(cljs.core.truth_(tx_private_key)?null:null),storage_write,req_chan,conn_id,servers_STAR_,pub_chan,sub_chan,storage_rename,((((cljs.core.fn_QMARK_.call(null,keep_alive_fn)) || (typeof keep_alive_fn === 'string')))?keep_alive_fn:null),publish]);
return fluree.db.connection.map__GT_Connection.call(null,settings);
});
/**
 * Closes connection, returns true if close successful, false if already closed.
 */
fluree.db.connection.close_BANG_ = (function fluree$db$connection$close_BANG_(conn){
if(cljs.core.truth_(fluree.db.connection.closed_QMARK_.call(null,conn))){
return false;
} else {
new cljs.core.Keyword(null,"close","close",1835149582).cljs$core$IFn$_invoke$arity$1(conn).call(null);

return true;
}
});
/**
 * Creates a connection to a ledger group server.
 *   Provide servers in either a sequence or as a string that is comma-separated.
 */
fluree.db.connection.connect = (function fluree$db$connection$connect(var_args){
var args__4736__auto__ = [];
var len__4730__auto___104551 = arguments.length;
var i__4731__auto___104552 = (0);
while(true){
if((i__4731__auto___104552 < len__4730__auto___104551)){
args__4736__auto__.push((arguments[i__4731__auto___104552]));

var G__104553 = (i__4731__auto___104552 + (1));
i__4731__auto___104552 = G__104553;
continue;
} else {
}
break;
}

var argseq__4737__auto__ = ((((1) < args__4736__auto__.length))?(new cljs.core.IndexedSeq(args__4736__auto__.slice((1)),(0),null)):null);
return fluree.db.connection.connect.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4737__auto__);
});

fluree.db.connection.connect.cljs$core$IFn$_invoke$arity$variadic = (function (servers,p__104522){
var vec__104523 = p__104522;
var opts = cljs.core.nth.call(null,vec__104523,(0),null);
var conn = fluree.db.connection.generate_connection.call(null,servers,opts);
var transactor_QMARK_ = new cljs.core.Keyword(null,"transactor?","transactor?",-1901072057).cljs$core$IFn$_invoke$arity$1(opts);
var dev_QMARK_ = new cljs.core.Keyword(null,"dev?","dev?",-613971064).cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"meta","meta",1499536964).cljs$core$IFn$_invoke$arity$1(conn));
if(cljs.core.truth_(transactor_QMARK_)){
} else {
var c__86675__auto___104554 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto___104554,conn,transactor_QMARK_,dev_QMARK_,vec__104523,opts){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto___104554,conn,transactor_QMARK_,dev_QMARK_,vec__104523,opts){
return (function (state_104540){
var state_val_104541 = (state_104540[(1)]);
if((state_val_104541 === (1))){
var inst_104526 = fluree.db.connection.get_socket.call(null,conn);
var state_104540__$1 = state_104540;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_104540__$1,(2),inst_104526);
} else {
if((state_val_104541 === (2))){
var inst_104528 = (state_104540[(2)]);
var inst_104529 = (inst_104528 == null);
var inst_104530 = fluree.db.util.core.exception_QMARK_.call(null,inst_104528);
var inst_104531 = ((inst_104529) || (inst_104530));
var state_104540__$1 = state_104540;
if(cljs.core.truth_(inst_104531)){
var statearr_104542_104555 = state_104540__$1;
(statearr_104542_104555[(1)] = (3));

} else {
var statearr_104543_104556 = state_104540__$1;
(statearr_104543_104556[(1)] = (4));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104541 === (3))){
var inst_104533 = fluree.db.util.log.warn.call(null,"Cannot establish connection to a healthy server, disconnecting.");
var inst_104534 = cljs.core.async.close_BANG_.call(null,conn);
var state_104540__$1 = (function (){var statearr_104544 = state_104540;
(statearr_104544[(7)] = inst_104533);

return statearr_104544;
})();
var statearr_104545_104557 = state_104540__$1;
(statearr_104545_104557[(2)] = inst_104534);

(statearr_104545_104557[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104541 === (4))){
var inst_104536 = fluree.db.connection.msg_consumer.call(null,conn);
var state_104540__$1 = state_104540;
var statearr_104546_104558 = state_104540__$1;
(statearr_104546_104558[(2)] = inst_104536);

(statearr_104546_104558[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_104541 === (5))){
var inst_104538 = (state_104540[(2)]);
var state_104540__$1 = state_104540;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_104540__$1,inst_104538);
} else {
return null;
}
}
}
}
}
});})(c__86675__auto___104554,conn,transactor_QMARK_,dev_QMARK_,vec__104523,opts))
;
return ((function (switch__86624__auto__,c__86675__auto___104554,conn,transactor_QMARK_,dev_QMARK_,vec__104523,opts){
return (function() {
var fluree$db$connection$state_machine__86625__auto__ = null;
var fluree$db$connection$state_machine__86625__auto____0 = (function (){
var statearr_104547 = [null,null,null,null,null,null,null,null];
(statearr_104547[(0)] = fluree$db$connection$state_machine__86625__auto__);

(statearr_104547[(1)] = (1));

return statearr_104547;
});
var fluree$db$connection$state_machine__86625__auto____1 = (function (state_104540){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_104540);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e104548){if((e104548 instanceof Object)){
var ex__86628__auto__ = e104548;
var statearr_104549_104559 = state_104540;
(statearr_104549_104559[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_104540);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e104548;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__104560 = state_104540;
state_104540 = G__104560;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$connection$state_machine__86625__auto__ = function(state_104540){
switch(arguments.length){
case 0:
return fluree$db$connection$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$connection$state_machine__86625__auto____1.call(this,state_104540);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$connection$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$connection$state_machine__86625__auto____0;
fluree$db$connection$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$connection$state_machine__86625__auto____1;
return fluree$db$connection$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto___104554,conn,transactor_QMARK_,dev_QMARK_,vec__104523,opts))
})();
var state__86677__auto__ = (function (){var statearr_104550 = f__86676__auto__.call(null);
(statearr_104550[(6)] = c__86675__auto___104554);

return statearr_104550;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto___104554,conn,transactor_QMARK_,dev_QMARK_,vec__104523,opts))
);

}

fluree.db.connection.msg_producer.call(null,conn);

return conn;
});

fluree.db.connection.connect.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
fluree.db.connection.connect.cljs$lang$applyTo = (function (seq104520){
var G__104521 = cljs.core.first.call(null,seq104520);
var seq104520__$1 = cljs.core.next.call(null,seq104520);
var self__4717__auto__ = this;
return self__4717__auto__.cljs$core$IFn$_invoke$arity$variadic(G__104521,seq104520__$1);
});

