// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.query.analytical');
goog.require('cljs.core');
goog.require('clojure.set');
goog.require('fluree.db.query.range');
goog.require('cljs.core.async');
goog.require('fluree.db.time_travel');
goog.require('fluree.db.util.async');
goog.require('fluree.db.util.core');
goog.require('fluree.db.flake');
goog.require('fluree.db.query.analytical_wikidata');
goog.require('fluree.db.query.analytical_filter');
goog.require('clojure.string');
goog.require('fluree.db.util.log');
goog.require('cljs.reader');
goog.require('fluree.db.dbproto');
fluree.db.query.analytical.variable_QMARK_ = (function fluree$db$query$analytical$variable_QMARK_(form){
if(((((typeof form === 'string') || ((form instanceof cljs.core.Keyword)) || ((form instanceof cljs.core.Symbol)))) && (cljs.core._EQ_.call(null,cljs.core.first.call(null,cljs.core.name.call(null,form)),"?")))){
return cljs.core.symbol.call(null,form);
} else {
return null;
}
});
fluree.db.query.analytical.internal_filter_QMARK_ = (function fluree$db$query$analytical$internal_filter_QMARK_(form){
if(((((typeof form === 'string') || ((form instanceof cljs.core.Keyword)) || ((form instanceof cljs.core.Symbol)))) && (cljs.core._EQ_.call(null,cljs.core.first.call(null,cljs.core.name.call(null,form)),"#")) && (cljs.core._EQ_.call(null,cljs.core.second.call(null,cljs.core.name.call(null,form)),"(")))){
return cljs.core.symbol.call(null,form);
} else {
return null;
}
});
fluree.db.query.analytical.escaped_string_QMARK_ = (function fluree$db$query$analytical$escaped_string_QMARK_(form){
return ((typeof form === 'string') && (cljs.core._EQ_.call(null,cljs.core.first.call(null,cljs.core.name.call(null,form)),"\"")) && (cljs.core._EQ_.call(null,cljs.core.last.call(null,cljs.core.name.call(null,form)),"\"")));
});
fluree.db.query.analytical.safe_read_string = (function fluree$db$query$analytical$safe_read_string(string){
try{return cljs.reader.read_string.call(null,string);
}catch (e94486){var e = e94486;
return string;
}});
fluree.db.query.analytical.get_vars = (function fluree$db$query$analytical$get_vars(filter_code){
return cljs.core.some.call(null,(function (p1__94487_SHARP_){
var or__4131__auto__ = fluree.db.query.analytical.variable_QMARK_.call(null,p1__94487_SHARP_);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
if(cljs.core.coll_QMARK_.call(null,p1__94487_SHARP_)){
return fluree.db.query.analytical.get_vars.call(null,p1__94487_SHARP_);
} else {
return null;
}
}
}),filter_code);
});
/**
 * Given any interm-vars, such as {?article 351843720901583}
 *   and an fdb clause, such as  ["?article", "articles/leadInstitutionOrg", "?org"],
 * 
 * 
 *   Returns a map with the following keys:
 * 
 *   - search - a vector that will be passed to query-range/search, i.e. [ nil "articles/leadInstitutionOrg" nil ]
 *   - rel - a map with any variables (that are not present in interm-vars) and their idx, i.e. {?org 2}
 *   - opts - search opts, currently recur, if the predicate is recurred, and object-fn, if there is an object function.
 *  
 */
fluree.db.query.analytical.clause__GT_rel = (function fluree$db$query$analytical$clause__GT_rel(db,interm_vars,clause){
return cljs.core.reduce_kv.call(null,(function (acc,idx,key){
var key_as_var = fluree.db.query.analytical.variable_QMARK_.call(null,key);
var static_value = cljs.core.get.call(null,interm_vars,key_as_var);
if(((cljs.core._EQ_.call(null,idx,(1))) && (cljs.core.not.call(null,key_as_var)) && (cljs.core.not.call(null,fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"name","name",1843675177),cljs.core.re_find.call(null,/[_a-zA-Z0-9\/]*/,key)))))){
throw cljs.core.ex_info.call(null,["Invalid predicate provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(key)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null));
} else {
}

if(cljs.core.truth_(static_value)){
return cljs.core.update.call(null,acc,new cljs.core.Keyword(null,"search","search",1564939822),((function (key_as_var,static_value){
return (function (p1__94488_SHARP_){
return cljs.core.conj.call(null,p1__94488_SHARP_,static_value);
});})(key_as_var,static_value))
);
} else {
if(cljs.core.truth_(key_as_var)){
return cljs.core.assoc_in.call(null,cljs.core.update.call(null,acc,new cljs.core.Keyword(null,"search","search",1564939822),((function (key_as_var,static_value){
return (function (p1__94489_SHARP_){
return cljs.core.conj.call(null,p1__94489_SHARP_,null);
});})(key_as_var,static_value))
),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"rel","rel",1378823488),key_as_var], null),idx);
} else {
if(cljs.core.truth_((function (){var and__4120__auto__ = fluree.db.query.analytical.internal_filter_QMARK_.call(null,key);
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core._EQ_.call(null,idx,(2));
} else {
return and__4120__auto__;
}
})())){
var filter_code = cljs.reader.read_string.call(null,cljs.core.subs.call(null,key,(1)));
var var$ = (function (){var or__4131__auto__ = fluree.db.query.analytical.get_vars.call(null,filter_code);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
throw cljs.core.ex_info.call(null,["Filter function must contain a valid variable. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(key)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null));
}
})();
var vec__94494 = fluree.db.query.analytical_filter.valid_filter_QMARK_.call(null,filter_code,cljs.core.PersistentHashSet.createAsIfByAssoc([var$]));
var fun = cljs.core.nth.call(null,vec__94494,(0),null);
var _ = cljs.core.nth.call(null,vec__94494,(1),null);
var filter_fn = fluree.db.query.analytical_filter.get_internal_filter_fn.call(null,var$,fun);
return cljs.core.assoc_in.call(null,cljs.core.assoc_in.call(null,cljs.core.update.call(null,acc,new cljs.core.Keyword(null,"search","search",1564939822),((function (filter_code,var$,vec__94494,fun,_,filter_fn,key_as_var,static_value){
return (function (p1__94490_SHARP_){
return cljs.core.conj.call(null,p1__94490_SHARP_,null);
});})(filter_code,var$,vec__94494,fun,_,filter_fn,key_as_var,static_value))
),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"opts","opts",155075701),new cljs.core.Keyword(null,"object-fn","object-fn",1425858481)], null),filter_fn),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"rel","rel",1378823488),var$], null),idx);
} else {
if(cljs.core.truth_((function (){var and__4120__auto__ = cljs.core._EQ_.call(null,idx,(1));
if(and__4120__auto__){
return cljs.core.re_find.call(null,/\+/,key);
} else {
return and__4120__auto__;
}
})())){
var vec__94497 = clojure.string.split.call(null,key,/\+/);
var pred = cljs.core.nth.call(null,vec__94497,(0),null);
var recur_amt = cljs.core.nth.call(null,vec__94497,(1),null);
var recur_amt__$1 = (cljs.core.truth_(recur_amt)?(function (){var or__4131__auto__ = fluree.db.query.analytical.safe_read_string.call(null,recur_amt);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return (100);
}
})():(100));
return cljs.core.assoc_in.call(null,cljs.core.update.call(null,acc,new cljs.core.Keyword(null,"search","search",1564939822),((function (vec__94497,pred,recur_amt,recur_amt__$1,key_as_var,static_value){
return (function (p1__94491_SHARP_){
return cljs.core.conj.call(null,p1__94491_SHARP_,pred);
});})(vec__94497,pred,recur_amt,recur_amt__$1,key_as_var,static_value))
),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"opts","opts",155075701),new cljs.core.Keyword(null,"recur","recur",-437573268)], null),recur_amt__$1);
} else {
if(fluree.db.query.analytical.escaped_string_QMARK_.call(null,key)){
return cljs.core.update.call(null,acc,new cljs.core.Keyword(null,"search","search",1564939822),((function (key_as_var,static_value){
return (function (p1__94492_SHARP_){
return cljs.core.conj.call(null,p1__94492_SHARP_,fluree.db.query.analytical.safe_read_string.call(null,key));
});})(key_as_var,static_value))
);
} else {
return cljs.core.update.call(null,acc,new cljs.core.Keyword(null,"search","search",1564939822),((function (key_as_var,static_value){
return (function (p1__94493_SHARP_){
return cljs.core.conj.call(null,p1__94493_SHARP_,key);
});})(key_as_var,static_value))
);

}
}
}
}
}
}),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"search","search",1564939822),cljs.core.PersistentVector.EMPTY,new cljs.core.Keyword(null,"rel","rel",1378823488),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"opts","opts",155075701),cljs.core.PersistentArrayMap.EMPTY], null),clause);
});
fluree.db.query.analytical.get_ns_arrays = (function fluree$db$query$analytical$get_ns_arrays(ns,arrays){
return cljs.core.map.call(null,(function (array){
return cljs.core.map.call(null,(function (p1__94500_SHARP_){
return cljs.core.nth.call(null,array,p1__94500_SHARP_);
}),ns);
}),arrays);
});
fluree.db.query.analytical.clause__GT_keys = (function fluree$db$query$analytical$clause__GT_keys(clause){
return cljs.core.reduce.call(null,(function (acc,var$){
var temp__5733__auto__ = fluree.db.query.analytical.variable_QMARK_.call(null,var$);
if(cljs.core.truth_(temp__5733__auto__)){
var var$__$1 = temp__5733__auto__;
return cljs.core.conj.call(null,acc,var$__$1);
} else {
return acc;
}
}),cljs.core.PersistentVector.EMPTY,clause);
});
fluree.db.query.analytical.intersecting_keys_tuples_clause = (function fluree$db$query$analytical$intersecting_keys_tuples_clause(tuples,clause){
var rel_keys = cljs.core.set.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(tuples));
var clause_keys = fluree.db.query.analytical.clause__GT_keys.call(null,clause);
return cljs.core.reduce.call(null,((function (rel_keys,clause_keys){
return (function (acc,key){
if(cljs.core.truth_(rel_keys.call(null,key))){
return cljs.core.conj.call(null,acc,key);
} else {
return acc;
}
});})(rel_keys,clause_keys))
,cljs.core.PersistentVector.EMPTY,clause_keys);
});
fluree.db.query.analytical.intersecting_keys_tuples = (function fluree$db$query$analytical$intersecting_keys_tuples(a_tuples,b_tuples){
var a_keys = cljs.core.set.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(a_tuples));
var b_keys = new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_tuples);
return cljs.core.reduce.call(null,((function (a_keys,b_keys){
return (function (acc,key){
if(cljs.core.truth_(a_keys.call(null,key))){
return cljs.core.conj.call(null,acc,key);
} else {
return acc;
}
});})(a_keys,b_keys))
,cljs.core.PersistentVector.EMPTY,b_keys);
});
fluree.db.query.analytical.select_from_tuples = (function fluree$db$query$analytical$select_from_tuples(vars,tuples){
var ns = cljs.core.reduce.call(null,(function (acc,var_smt){
var temp__5733__auto__ = (function (){var or__4131__auto__ = fluree.db.query.analytical.variable_QMARK_.call(null,var_smt);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.Keyword(null,"variable","variable",-281346492).cljs$core$IFn$_invoke$arity$1(var_smt);
}
})();
if(cljs.core.truth_(temp__5733__auto__)){
var var$ = temp__5733__auto__;
return cljs.core.conj.call(null,acc,fluree.db.util.core.index_of.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(tuples),var$));
} else {
throw cljs.core.ex_info.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(var_smt)," cannot be retrieved from the results. Check that it is declared in your where clause."].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null));
}
}),cljs.core.PersistentVector.EMPTY,vars);
return fluree.db.query.analytical.get_ns_arrays.call(null,ns,new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(tuples));
});
fluree.db.query.analytical.add_fuel = (function fluree$db$query$analytical$add_fuel(add_amount,fuel,max_fuel){
if(cljs.core.truth_((function (){var and__4120__auto__ = max_fuel;
if(cljs.core.truth_(and__4120__auto__)){
return (add_amount > max_fuel);
} else {
return and__4120__auto__;
}
})())){
throw cljs.core.ex_info.call(null,["Maximum query fuel exceeded: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(max_fuel)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","exceeded-cost","db/exceeded-cost",-915096223)], null));
} else {
if(cljs.core.truth_((function (){var and__4120__auto__ = fuel;
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core.volatile_QMARK_.call(null,fuel);
} else {
return and__4120__auto__;
}
})())){
return cljs.core._vreset_BANG_.call(null,fuel,(cljs.core._deref.call(null,fuel) + add_amount));
} else {
return null;
}
}
});
fluree.db.query.analytical.replace_vars_wikidata = (function fluree$db$query$analytical$replace_vars_wikidata(all_wd,intersecting_vars,vars){
return cljs.core.mapv.call(null,(function (clause){
return cljs.core.mapv.call(null,(function (clause_item){
var temp__5733__auto__ = intersecting_vars.call(null,cljs.core.symbol.call(null,clause_item));
if(cljs.core.truth_(temp__5733__auto__)){
var key_replace = temp__5733__auto__;
var replacement = cljs.core.get.call(null,vars,key_replace);
var replacement_SINGLEQUOTE_ = ((typeof cljs.reader.read_string.call(null,replacement) === 'number')?replacement:["\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(replacement),"\""].join(''));
return replacement_SINGLEQUOTE_;
} else {
return clause_item;
}
}),clause);
}),all_wd);
});
fluree.db.query.analytical.wikidata__GT_tuples = (function fluree$db$query$analytical$wikidata__GT_tuples(q_map,clause,r,p__94503,optional_QMARK_,fuel,max_fuel){
var map__94504 = p__94503;
var map__94504__$1 = (((((!((map__94504 == null))))?(((((map__94504.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__94504.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__94504):map__94504);
var res = map__94504__$1;
var vars = cljs.core.get.call(null,map__94504__$1,new cljs.core.Keyword(null,"vars","vars",-2046957217));
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,map__94504,map__94504__$1,res,vars){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,map__94504,map__94504__$1,res,vars){
return (function (state_94567){
var state_val_94568 = (state_94567[(1)]);
if((state_val_94568 === (7))){
var inst_94563 = (state_94567[(2)]);
var state_94567__$1 = state_94567;
var statearr_94569_94590 = state_94567__$1;
(statearr_94569_94590[(2)] = inst_94563);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_94567__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (1))){
var state_94567__$1 = state_94567;
var statearr_94570_94591 = state_94567__$1;
(statearr_94570_94591[(2)] = null);

(statearr_94570_94591[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_94567,(3),Error,null,(2));
var inst_94510 = (r == null);
var state_94567__$1 = state_94567;
if(cljs.core.truth_(inst_94510)){
var statearr_94571_94592 = state_94567__$1;
(statearr_94571_94592[(1)] = (5));

} else {
var statearr_94572_94593 = state_94567__$1;
(statearr_94572_94593[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (13))){
var inst_94555 = (state_94567[(2)]);
var state_94567__$1 = state_94567;
var statearr_94573_94594 = state_94567__$1;
(statearr_94573_94594[(2)] = inst_94555);

(statearr_94573_94594[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (6))){
var inst_94557 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94558 = fluree.db.query.analytical_wikidata.drop_all_wd_clauses.call(null,r);
var inst_94559 = cljs.core.conj.call(null,inst_94558,clause);
var inst_94560 = [null,inst_94559];
var inst_94561 = (new cljs.core.PersistentVector(null,2,(5),inst_94557,inst_94560,null));
var state_94567__$1 = state_94567;
var statearr_94574_94595 = state_94567__$1;
(statearr_94574_94595[(2)] = inst_94561);

(statearr_94574_94595[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (3))){
var inst_94506 = (state_94567[(2)]);
var state_94567__$1 = state_94567;
var statearr_94575_94596 = state_94567__$1;
(statearr_94575_94596[(2)] = inst_94506);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_94567__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (12))){
var inst_94513 = (state_94567[(7)]);
var inst_94525 = new cljs.core.Keyword(null,"optional","optional",2053951509).cljs$core$IFn$_invoke$arity$1(q_map);
var inst_94526 = fluree.db.query.analytical_wikidata.get_all_wd_clauses.call(null,inst_94525);
var inst_94527 = cljs.core.map.call(null,fluree.db.query.analytical.clause__GT_keys,inst_94513);
var inst_94528 = cljs.core.apply.call(null,cljs.core.concat,inst_94527);
var inst_94529 = cljs.core.set.call(null,inst_94528);
var inst_94530 = cljs.core.map.call(null,fluree.db.query.analytical.clause__GT_keys,inst_94526);
var inst_94531 = cljs.core.apply.call(null,cljs.core.concat,inst_94530);
var inst_94532 = cljs.core.into.call(null,inst_94529,inst_94531);
var inst_94533 = (function (){var all_wd = inst_94513;
var optional = inst_94526;
var all_wd_vars = inst_94529;
var all_vars = inst_94532;
return ((function (all_wd,optional,all_wd_vars,all_vars,inst_94513,inst_94525,inst_94526,inst_94527,inst_94528,inst_94529,inst_94530,inst_94531,inst_94532,state_val_94568,c__86675__auto__,map__94504,map__94504__$1,res,vars){
return (function (p1__94501_SHARP_){
return all_vars.call(null,p1__94501_SHARP_);
});
;})(all_wd,optional,all_wd_vars,all_vars,inst_94513,inst_94525,inst_94526,inst_94527,inst_94528,inst_94529,inst_94530,inst_94531,inst_94532,state_val_94568,c__86675__auto__,map__94504,map__94504__$1,res,vars))
})();
var inst_94534 = cljs.core.keys.call(null,vars);
var inst_94535 = cljs.core.map.call(null,inst_94533,inst_94534);
var inst_94536 = cljs.core.remove.call(null,cljs.core.nil_QMARK_,inst_94535);
var inst_94537 = cljs.core.set.call(null,inst_94536);
var inst_94538 = (function (){var all_wd = inst_94513;
var optional = inst_94526;
var all_wd_vars = inst_94529;
var all_vars = inst_94532;
var intersecting_vars = inst_94537;
return ((function (all_wd,optional,all_wd_vars,all_vars,intersecting_vars,inst_94513,inst_94525,inst_94526,inst_94527,inst_94528,inst_94529,inst_94530,inst_94531,inst_94532,inst_94533,inst_94534,inst_94535,inst_94536,inst_94537,state_val_94568,c__86675__auto__,map__94504,map__94504__$1,res,vars){
return (function (p1__94502_SHARP_){
return fluree.db.query.analytical.intersecting_keys_tuples_clause.call(null,res,p1__94502_SHARP_);
});
;})(all_wd,optional,all_wd_vars,all_vars,intersecting_vars,inst_94513,inst_94525,inst_94526,inst_94527,inst_94528,inst_94529,inst_94530,inst_94531,inst_94532,inst_94533,inst_94534,inst_94535,inst_94536,inst_94537,state_val_94568,c__86675__auto__,map__94504,map__94504__$1,res,vars))
})();
var inst_94539 = cljs.core.map.call(null,inst_94538,inst_94513);
var inst_94540 = cljs.core.apply.call(null,cljs.core.concat,inst_94539);
var inst_94541 = fluree.db.query.analytical.select_from_tuples.call(null,inst_94540,res);
var inst_94542 = fluree.db.query.analytical.replace_vars_wikidata.call(null,inst_94513,inst_94537,vars);
var inst_94543 = cljs.core.remove.call(null,inst_94537,inst_94532);
var inst_94544 = fluree.db.query.analytical_wikidata.get_wikidata_tuples.call(null,q_map,inst_94542,inst_94540,inst_94541,inst_94543,inst_94526);
var state_94567__$1 = state_94567;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_94567__$1,(14),inst_94544);
} else {
if((state_val_94568 === (2))){
var inst_94565 = (state_94567[(2)]);
var state_94567__$1 = state_94567;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_94567__$1,inst_94565);
} else {
if((state_val_94568 === (11))){
var inst_94521 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94522 = [null,r];
var inst_94523 = (new cljs.core.PersistentVector(null,2,(5),inst_94521,inst_94522,null));
var state_94567__$1 = state_94567;
var statearr_94576_94597 = state_94567__$1;
(statearr_94576_94597[(2)] = inst_94523);

(statearr_94576_94597[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (9))){
var state_94567__$1 = state_94567;
var statearr_94577_94598 = state_94567__$1;
(statearr_94577_94598[(2)] = optional_QMARK_);

(statearr_94577_94598[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (5))){
var inst_94512 = new cljs.core.Keyword(null,"where","where",-2044795965).cljs$core$IFn$_invoke$arity$1(q_map);
var inst_94513 = fluree.db.query.analytical_wikidata.get_all_wd_clauses.call(null,inst_94512);
var state_94567__$1 = (function (){var statearr_94578 = state_94567;
(statearr_94578[(7)] = inst_94513);

return statearr_94578;
})();
if(cljs.core.truth_(optional_QMARK_)){
var statearr_94579_94599 = state_94567__$1;
(statearr_94579_94599[(1)] = (8));

} else {
var statearr_94580_94600 = state_94567__$1;
(statearr_94580_94600[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (14))){
var inst_94546 = (state_94567[(2)]);
var inst_94547 = fluree.db.util.async.throw_err.call(null,inst_94546);
var inst_94548 = new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(inst_94547);
var inst_94549 = cljs.core.count.call(null,inst_94548);
var inst_94550 = fluree.db.query.analytical.add_fuel.call(null,inst_94549,fuel,max_fuel);
var inst_94551 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94552 = [inst_94547,r];
var inst_94553 = (new cljs.core.PersistentVector(null,2,(5),inst_94551,inst_94552,null));
var state_94567__$1 = (function (){var statearr_94581 = state_94567;
(statearr_94581[(8)] = inst_94550);

return statearr_94581;
})();
var statearr_94582_94601 = state_94567__$1;
(statearr_94582_94601[(2)] = inst_94553);

(statearr_94582_94601[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (10))){
var inst_94519 = (state_94567[(2)]);
var state_94567__$1 = state_94567;
if(cljs.core.truth_(inst_94519)){
var statearr_94583_94602 = state_94567__$1;
(statearr_94583_94602[(1)] = (11));

} else {
var statearr_94584_94603 = state_94567__$1;
(statearr_94584_94603[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94568 === (8))){
var inst_94513 = (state_94567[(7)]);
var inst_94515 = cljs.core.empty_QMARK_.call(null,inst_94513);
var inst_94516 = (!(inst_94515));
var state_94567__$1 = state_94567;
var statearr_94585_94604 = state_94567__$1;
(statearr_94585_94604[(2)] = inst_94516);

(statearr_94585_94604[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,map__94504,map__94504__$1,res,vars))
;
return ((function (switch__86624__auto__,c__86675__auto__,map__94504,map__94504__$1,res,vars){
return (function() {
var fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto__ = null;
var fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto____0 = (function (){
var statearr_94586 = [null,null,null,null,null,null,null,null,null];
(statearr_94586[(0)] = fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto__);

(statearr_94586[(1)] = (1));

return statearr_94586;
});
var fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto____1 = (function (state_94567){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_94567);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e94587){if((e94587 instanceof Object)){
var ex__86628__auto__ = e94587;
var statearr_94588_94605 = state_94567;
(statearr_94588_94605[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_94567);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e94587;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__94606 = state_94567;
state_94567 = G__94606;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto__ = function(state_94567){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto____1.call(this,state_94567);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto____0;
fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto____1;
return fluree$db$query$analytical$wikidata__GT_tuples_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,map__94504,map__94504__$1,res,vars))
})();
var state__86677__auto__ = (function (){var statearr_94589 = f__86676__auto__.call(null);
(statearr_94589[(6)] = c__86675__auto__);

return statearr_94589;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,map__94504,map__94504__$1,res,vars))
);

return c__86675__auto__;
});
fluree.db.query.analytical.db_ident_QMARK_ = (function fluree$db$query$analytical$db_ident_QMARK_(source){
return cljs.core._EQ_.call(null,cljs.core.count.call(null,clojure.string.split.call(null,source,/\//)),(2));
});
fluree.db.query.analytical.parse_block_from_source = (function fluree$db$query$analytical$parse_block_from_source(block){
var block_SINGLEQUOTE_ = fluree.db.query.analytical.safe_read_string.call(null,block);
if(cljs.core.int_QMARK_.call(null,block_SINGLEQUOTE_)){
return block_SINGLEQUOTE_;
} else {
return block;
}
});
fluree.db.query.analytical.isolate_source_name = (function fluree$db$query$analytical$isolate_source_name(dbid){
return cljs.core.re_find.call(null,/[a-z]+/,dbid);
});
fluree.db.query.analytical.isolate_source_block = (function fluree$db$query$analytical$isolate_source_block(dbid){
return cljs.core.re_find.call(null,/[A-Z0-9]+/,dbid);
});
fluree.db.query.analytical.get_source_clause = (function fluree$db$query$analytical$get_source_clause(var_args){
var G__94608 = arguments.length;
switch (G__94608) {
case 2:
return fluree.db.query.analytical.get_source_clause.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return fluree.db.query.analytical.get_source_clause.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.analytical.get_source_clause.cljs$core$IFn$_invoke$arity$2 = (function (db,clause){
return fluree.db.query.analytical.get_source_clause.call(null,db,clause,cljs.core.PersistentArrayMap.EMPTY,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.analytical.get_source_clause.cljs$core$IFn$_invoke$arity$4 = (function (db,clause,prefixes,opts){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_94699){
var state_val_94700 = (state_94699[(1)]);
if((state_val_94700 === (7))){
var inst_94695 = (state_94699[(2)]);
var state_94699__$1 = state_94699;
var statearr_94701_94743 = state_94699__$1;
(statearr_94701_94743[(2)] = inst_94695);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_94699__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (20))){
var inst_94689 = (state_94699[(2)]);
var state_94699__$1 = state_94699;
var statearr_94702_94744 = state_94699__$1;
(statearr_94702_94744[(2)] = inst_94689);

(statearr_94702_94744[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (27))){
var inst_94671 = (state_94699[(2)]);
var inst_94672 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94673 = cljs.core.PersistentVector.EMPTY;
var inst_94674 = cljs.core.subvec.call(null,clause,(1),(4));
var inst_94675 = cljs.core.into.call(null,inst_94673,inst_94674);
var inst_94676 = [inst_94671,inst_94675];
var inst_94677 = (new cljs.core.PersistentVector(null,2,(5),inst_94672,inst_94676,null));
var state_94699__$1 = state_94699;
var statearr_94703_94745 = state_94699__$1;
(statearr_94703_94745[(2)] = inst_94677);

(statearr_94703_94745[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (1))){
var state_94699__$1 = state_94699;
var statearr_94704_94746 = state_94699__$1;
(statearr_94704_94746[(2)] = null);

(statearr_94704_94746[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (24))){
var inst_94656 = (state_94699[(7)]);
var inst_94662 = (state_94699[(2)]);
var inst_94663 = fluree.db.util.async.throw_err.call(null,inst_94662);
var state_94699__$1 = (function (){var statearr_94705 = state_94699;
(statearr_94705[(8)] = inst_94663);

return statearr_94705;
})();
if(cljs.core.truth_(inst_94656)){
var statearr_94706_94747 = state_94699__$1;
(statearr_94706_94747[(1)] = (25));

} else {
var statearr_94707_94748 = state_94699__$1;
(statearr_94707_94748[(1)] = (26));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (4))){
var inst_94613 = (state_94699[(9)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_94699,(3),Error,null,(2));
var inst_94613__$1 = cljs.core.first.call(null,clause);
var inst_94614 = cljs.core._EQ_.call(null,"$fdb",inst_94613__$1);
var state_94699__$1 = (function (){var statearr_94708 = state_94699;
(statearr_94708[(9)] = inst_94613__$1);

return statearr_94708;
})();
if(inst_94614){
var statearr_94709_94749 = state_94699__$1;
(statearr_94709_94749[(1)] = (5));

} else {
var statearr_94710_94750 = state_94699__$1;
(statearr_94710_94750[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (15))){
var inst_94646 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94647 = ["$wd",clause];
var inst_94648 = (new cljs.core.PersistentVector(null,2,(5),inst_94646,inst_94647,null));
var state_94699__$1 = state_94699;
var statearr_94711_94751 = state_94699__$1;
(statearr_94711_94751[(2)] = inst_94648);

(statearr_94711_94751[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (21))){
var inst_94652 = (state_94699[(10)]);
var inst_94654 = (state_94699[(11)]);
var inst_94656 = fluree.db.query.analytical.parse_block_from_source.call(null,inst_94652);
var inst_94657 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94658 = [new cljs.core.Keyword(null,"sources","sources",-321166424),inst_94654];
var inst_94659 = (new cljs.core.PersistentVector(null,2,(5),inst_94657,inst_94658,null));
var inst_94660 = cljs.core.get_in.call(null,opts,inst_94659);
var state_94699__$1 = (function (){var statearr_94712 = state_94699;
(statearr_94712[(7)] = inst_94656);

return statearr_94712;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_94699__$1,(24),inst_94660);
} else {
if((state_val_94700 === (13))){
var state_94699__$1 = state_94699;
var statearr_94713_94752 = state_94699__$1;
(statearr_94713_94752[(2)] = null);

(statearr_94713_94752[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (22))){
var inst_94613 = (state_94699[(9)]);
var inst_94679 = ["The data source: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_94613)," is not supported in Fluree"].join('');
var inst_94680 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_94681 = [(400),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)];
var inst_94682 = cljs.core.PersistentHashMap.fromArrays(inst_94680,inst_94681);
var inst_94683 = cljs.core.ex_info.call(null,inst_94679,inst_94682);
var inst_94684 = (function(){throw inst_94683})();
var state_94699__$1 = state_94699;
var statearr_94714_94753 = state_94699__$1;
(statearr_94714_94753[(2)] = inst_94684);

(statearr_94714_94753[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (6))){
var inst_94613 = (state_94699[(9)]);
var inst_94623 = clojure.string.starts_with_QMARK_.call(null,inst_94613,"$fdb");
var state_94699__$1 = state_94699;
if(inst_94623){
var statearr_94715_94754 = state_94699__$1;
(statearr_94715_94754[(1)] = (8));

} else {
var statearr_94716_94755 = state_94699__$1;
(statearr_94716_94755[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (28))){
var inst_94667 = (state_94699[(2)]);
var inst_94668 = fluree.db.util.async.throw_err.call(null,inst_94667);
var state_94699__$1 = state_94699;
var statearr_94717_94756 = state_94699__$1;
(statearr_94717_94756[(2)] = inst_94668);

(statearr_94717_94756[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (25))){
var inst_94663 = (state_94699[(8)]);
var inst_94656 = (state_94699[(7)]);
var inst_94665 = fluree.db.time_travel.as_of_block.call(null,inst_94663,inst_94656);
var state_94699__$1 = state_94699;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_94699__$1,(28),inst_94665);
} else {
if((state_val_94700 === (17))){
var inst_94691 = (state_94699[(2)]);
var state_94699__$1 = state_94699;
var statearr_94718_94757 = state_94699__$1;
(statearr_94718_94757[(2)] = inst_94691);

(statearr_94718_94757[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (3))){
var inst_94609 = (state_94699[(2)]);
var state_94699__$1 = state_94699;
var statearr_94719_94758 = state_94699__$1;
(statearr_94719_94758[(2)] = inst_94609);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_94699__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (12))){
var inst_94630 = (state_94699[(12)]);
var inst_94633 = (function(){throw inst_94630})();
var state_94699__$1 = state_94699;
var statearr_94720_94759 = state_94699__$1;
(statearr_94720_94759[(2)] = inst_94633);

(statearr_94720_94759[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (2))){
var inst_94697 = (state_94699[(2)]);
var state_94699__$1 = state_94699;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_94699__$1,inst_94697);
} else {
if((state_val_94700 === (23))){
var inst_94686 = (state_94699[(2)]);
var state_94699__$1 = state_94699;
var statearr_94721_94760 = state_94699__$1;
(statearr_94721_94760[(2)] = inst_94686);

(statearr_94721_94760[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (19))){
var state_94699__$1 = state_94699;
var statearr_94722_94761 = state_94699__$1;
(statearr_94722_94761[(2)] = null);

(statearr_94722_94761[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (11))){
var inst_94630 = (state_94699[(12)]);
var inst_94629 = (state_94699[(2)]);
var inst_94630__$1 = fluree.db.util.async.throw_err.call(null,inst_94629);
var inst_94631 = fluree.db.util.core.exception_QMARK_.call(null,inst_94630__$1);
var state_94699__$1 = (function (){var statearr_94723 = state_94699;
(statearr_94723[(12)] = inst_94630__$1);

return statearr_94723;
})();
if(inst_94631){
var statearr_94724_94762 = state_94699__$1;
(statearr_94724_94762[(1)] = (12));

} else {
var statearr_94725_94763 = state_94699__$1;
(statearr_94725_94763[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (9))){
var inst_94613 = (state_94699[(9)]);
var inst_94644 = cljs.core._EQ_.call(null,"$wd",inst_94613);
var state_94699__$1 = state_94699;
if(inst_94644){
var statearr_94726_94764 = state_94699__$1;
(statearr_94726_94764[(1)] = (15));

} else {
var statearr_94727_94765 = state_94699__$1;
(statearr_94727_94765[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (5))){
var inst_94616 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94617 = cljs.core.PersistentVector.EMPTY;
var inst_94618 = cljs.core.subvec.call(null,clause,(1),(4));
var inst_94619 = cljs.core.into.call(null,inst_94617,inst_94618);
var inst_94620 = [db,inst_94619];
var inst_94621 = (new cljs.core.PersistentVector(null,2,(5),inst_94616,inst_94620,null));
var state_94699__$1 = state_94699;
var statearr_94728_94766 = state_94699__$1;
(statearr_94728_94766[(2)] = inst_94621);

(statearr_94728_94766[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (14))){
var inst_94630 = (state_94699[(12)]);
var inst_94636 = (state_94699[(2)]);
var inst_94637 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94638 = cljs.core.PersistentVector.EMPTY;
var inst_94639 = cljs.core.subvec.call(null,clause,(1),(4));
var inst_94640 = cljs.core.into.call(null,inst_94638,inst_94639);
var inst_94641 = [inst_94630,inst_94640];
var inst_94642 = (new cljs.core.PersistentVector(null,2,(5),inst_94637,inst_94641,null));
var state_94699__$1 = (function (){var statearr_94729 = state_94699;
(statearr_94729[(13)] = inst_94636);

return statearr_94729;
})();
var statearr_94730_94767 = state_94699__$1;
(statearr_94730_94767[(2)] = inst_94642);

(statearr_94730_94767[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (26))){
var inst_94663 = (state_94699[(8)]);
var state_94699__$1 = state_94699;
var statearr_94731_94768 = state_94699__$1;
(statearr_94731_94768[(2)] = inst_94663);

(statearr_94731_94768[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (16))){
var state_94699__$1 = state_94699;
var statearr_94732_94769 = state_94699__$1;
(statearr_94732_94769[(1)] = (18));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (10))){
var inst_94693 = (state_94699[(2)]);
var state_94699__$1 = state_94699;
var statearr_94734_94770 = state_94699__$1;
(statearr_94734_94770[(2)] = inst_94693);

(statearr_94734_94770[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (18))){
var inst_94654 = (state_94699[(11)]);
var inst_94613 = (state_94699[(9)]);
var inst_94651 = fluree.db.query.analytical.isolate_source_name.call(null,inst_94613);
var inst_94652 = fluree.db.query.analytical.isolate_source_block.call(null,inst_94613);
var inst_94653 = cljs.core.keyword.call(null,inst_94651);
var inst_94654__$1 = cljs.core.get.call(null,prefixes,inst_94653);
var state_94699__$1 = (function (){var statearr_94735 = state_94699;
(statearr_94735[(10)] = inst_94652);

(statearr_94735[(11)] = inst_94654__$1);

return statearr_94735;
})();
if(cljs.core.truth_(inst_94654__$1)){
var statearr_94736_94771 = state_94699__$1;
(statearr_94736_94771[(1)] = (21));

} else {
var statearr_94737_94772 = state_94699__$1;
(statearr_94737_94772[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94700 === (8))){
var inst_94613 = (state_94699[(9)]);
var inst_94625 = cljs.core.subs.call(null,inst_94613,(4));
var inst_94626 = fluree.db.query.analytical.parse_block_from_source.call(null,inst_94625);
var inst_94627 = fluree.db.time_travel.as_of_block.call(null,db,inst_94626);
var state_94699__$1 = state_94699;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_94699__$1,(11),inst_94627);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$analytical$state_machine__86625__auto__ = null;
var fluree$db$query$analytical$state_machine__86625__auto____0 = (function (){
var statearr_94738 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_94738[(0)] = fluree$db$query$analytical$state_machine__86625__auto__);

(statearr_94738[(1)] = (1));

return statearr_94738;
});
var fluree$db$query$analytical$state_machine__86625__auto____1 = (function (state_94699){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_94699);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e94739){if((e94739 instanceof Object)){
var ex__86628__auto__ = e94739;
var statearr_94740_94773 = state_94699;
(statearr_94740_94773[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_94699);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e94739;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__94774 = state_94699;
state_94699 = G__94774;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical$state_machine__86625__auto__ = function(state_94699){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical$state_machine__86625__auto____1.call(this,state_94699);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$state_machine__86625__auto____0;
fluree$db$query$analytical$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$state_machine__86625__auto____1;
return fluree$db$query$analytical$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_94741 = f__86676__auto__.call(null);
(statearr_94741[(6)] = c__86675__auto__);

return statearr_94741;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.query.analytical.get_source_clause.cljs$lang$maxFixedArity = 4;

fluree.db.query.analytical.tuples__GT_map = (function fluree$db$query$analytical$tuples__GT_map(start_map,tuples){
return cljs.core.reduce.call(null,(function (acc,p__94775){
var vec__94776 = p__94775;
var sub = cljs.core.nth.call(null,vec__94776,(0),null);
var obj = cljs.core.nth.call(null,vec__94776,(1),null);
return cljs.core.update.call(null,acc,sub,cljs.core.conj,obj);
}),start_map,tuples);
});
fluree.db.query.analytical.expand_map = (function fluree$db$query$analytical$expand_map(tuple_map){
return cljs.core.zipmap.call(null,cljs.core.keys.call(null,tuple_map),cljs.core.map.call(null,(function (p1__94779_SHARP_){
return cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"done","done",-889844188),new cljs.core.Keyword(null,"followed","followed",821961472),new cljs.core.Keyword(null,"all","all",892129742)],[false,cljs.core.PersistentHashSet.EMPTY,cljs.core.set.call(null,p1__94779_SHARP_)]);
}),cljs.core.vals.call(null,tuple_map)));
});
fluree.db.query.analytical.follow_all_original_subject_paths = (function fluree$db$query$analytical$follow_all_original_subject_paths(subjects,tuple_map){
var expanded_map = fluree.db.query.analytical.expand_map.call(null,tuple_map);
var G__94783 = subjects;
var vec__94784 = G__94783;
var seq__94785 = cljs.core.seq.call(null,vec__94784);
var first__94786 = cljs.core.first.call(null,seq__94785);
var seq__94785__$1 = cljs.core.next.call(null,seq__94785);
var subject = first__94786;
var r = seq__94785__$1;
var acc = expanded_map;
var G__94783__$1 = G__94783;
var acc__$1 = acc;
while(true){
var vec__94790 = G__94783__$1;
var seq__94791 = cljs.core.seq.call(null,vec__94790);
var first__94792 = cljs.core.first.call(null,seq__94791);
var seq__94791__$1 = cljs.core.next.call(null,seq__94791);
var subject__$1 = first__94792;
var r__$1 = seq__94791__$1;
var acc__$2 = acc__$1;
if(cljs.core.not.call(null,subject__$1)){
return acc__$2;
} else {
if(cljs.core.truth_(cljs.core.get_in.call(null,acc__$2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,new cljs.core.Keyword(null,"done","done",-889844188)], null)))){
var G__94793 = r__$1;
var G__94794 = acc__$2;
G__94783__$1 = G__94793;
acc__$1 = G__94794;
continue;
} else {
var subject_all = cljs.core.get_in.call(null,acc__$2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,new cljs.core.Keyword(null,"all","all",892129742)], null));
var subject_followed = cljs.core.get_in.call(null,acc__$2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,new cljs.core.Keyword(null,"followed","followed",821961472)], null));
var subjects_to_follow = clojure.set.difference.call(null,subject_all,subject_followed);
var acc_STAR_ = cljs.core.reduce.call(null,((function (G__94783__$1,acc__$1,subject_all,subject_followed,subjects_to_follow,vec__94790,seq__94791,first__94792,seq__94791__$1,subject__$1,r__$1,acc__$2,G__94783,vec__94784,seq__94785,first__94786,seq__94785__$1,subject,r,acc,expanded_map){
return (function (acc__$3,subject_to_follow){
var all_followed = cljs.core.get_in.call(null,acc__$3,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,new cljs.core.Keyword(null,"followed","followed",821961472)], null));
var self_QMARK_ = cljs.core._EQ_.call(null,subject__$1,subject_to_follow);
var already_followed_QMARK_ = ((self_QMARK_)?false:all_followed.call(null,subject_to_follow));
var acc_SINGLEQUOTE_ = cljs.core.update_in.call(null,acc__$3,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,new cljs.core.Keyword(null,"followed","followed",821961472)], null),cljs.core.conj,subject_to_follow);
if(cljs.core.truth_((function (){var or__4131__auto__ = already_followed_QMARK_;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return self_QMARK_;
}
})())){
return acc_SINGLEQUOTE_;
} else {
var subject_to_follow_all = cljs.core.get_in.call(null,acc_SINGLEQUOTE_,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject_to_follow,new cljs.core.Keyword(null,"all","all",892129742)], null));
var acc_SINGLEQUOTE___$1 = cljs.core.update_in.call(null,acc_SINGLEQUOTE_,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,new cljs.core.Keyword(null,"all","all",892129742)], null),((function (G__94783__$1,acc__$1,subject_to_follow_all,all_followed,self_QMARK_,already_followed_QMARK_,acc_SINGLEQUOTE_,subject_all,subject_followed,subjects_to_follow,vec__94790,seq__94791,first__94792,seq__94791__$1,subject__$1,r__$1,acc__$2,G__94783,vec__94784,seq__94785,first__94786,seq__94785__$1,subject,r,acc,expanded_map){
return (function (existing){
return cljs.core.apply.call(null,cljs.core.conj,existing,subject_to_follow_all);
});})(G__94783__$1,acc__$1,subject_to_follow_all,all_followed,self_QMARK_,already_followed_QMARK_,acc_SINGLEQUOTE_,subject_all,subject_followed,subjects_to_follow,vec__94790,seq__94791,first__94792,seq__94791__$1,subject__$1,r__$1,acc__$2,G__94783,vec__94784,seq__94785,first__94786,seq__94785__$1,subject,r,acc,expanded_map))
);
if(cljs.core.truth_(cljs.core.get_in.call(null,acc_SINGLEQUOTE___$1,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject_to_follow,new cljs.core.Keyword(null,"done","done",-889844188)], null)))){
return cljs.core.update_in.call(null,acc_SINGLEQUOTE___$1,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,new cljs.core.Keyword(null,"followed","followed",821961472)], null),((function (G__94783__$1,acc__$1,subject_to_follow_all,acc_SINGLEQUOTE___$1,all_followed,self_QMARK_,already_followed_QMARK_,acc_SINGLEQUOTE_,subject_all,subject_followed,subjects_to_follow,vec__94790,seq__94791,first__94792,seq__94791__$1,subject__$1,r__$1,acc__$2,G__94783,vec__94784,seq__94785,first__94786,seq__94785__$1,subject,r,acc,expanded_map){
return (function (existing){
return cljs.core.apply.call(null,cljs.core.conj,existing,subject_to_follow_all);
});})(G__94783__$1,acc__$1,subject_to_follow_all,acc_SINGLEQUOTE___$1,all_followed,self_QMARK_,already_followed_QMARK_,acc_SINGLEQUOTE_,subject_all,subject_followed,subjects_to_follow,vec__94790,seq__94791,first__94792,seq__94791__$1,subject__$1,r__$1,acc__$2,G__94783,vec__94784,seq__94785,first__94786,seq__94785__$1,subject,r,acc,expanded_map))
);
} else {
return acc_SINGLEQUOTE___$1;
}
}
});})(G__94783__$1,acc__$1,subject_all,subject_followed,subjects_to_follow,vec__94790,seq__94791,first__94792,seq__94791__$1,subject__$1,r__$1,acc__$2,G__94783,vec__94784,seq__94785,first__94786,seq__94785__$1,subject,r,acc,expanded_map))
,acc__$2,subjects_to_follow);
var subject_followed_count = cljs.core.get_in.call(null,acc__$2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,new cljs.core.Keyword(null,"followed","followed",821961472)], null));
var subject_all_count = cljs.core.get_in.call(null,acc__$2,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,new cljs.core.Keyword(null,"all","all",892129742)], null));
var subject_done_QMARK_ = cljs.core._EQ_.call(null,subject_followed_count,subject_all_count);
if(subject_done_QMARK_){
var G__94795 = r__$1;
var G__94796 = cljs.core.assoc_in.call(null,acc_STAR_,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject__$1,new cljs.core.Keyword(null,"done","done",-889844188)], null),true);
G__94783__$1 = G__94795;
acc__$1 = G__94796;
continue;
} else {
var G__94797 = subjects;
var G__94798 = acc_STAR_;
G__94783__$1 = G__94797;
acc__$1 = G__94798;
continue;
}

}
}
break;
}
});
fluree.db.query.analytical.recur_map__GT_tuples = (function fluree$db$query$analytical$recur_map__GT_tuples(subjects,recur_map){
return cljs.core.reduce.call(null,(function (acc,subject){
var subject_vals = cljs.core.get_in.call(null,recur_map,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [subject,new cljs.core.Keyword(null,"followed","followed",821961472)], null));
return cljs.core.concat.call(null,acc,cljs.core.map.call(null,((function (subject_vals){
return (function (p1__94799_SHARP_){
return (new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[subject,p1__94799_SHARP_],null));
});})(subject_vals))
,subject_vals));
}),cljs.core.PersistentVector.EMPTY,subjects);
});
fluree.db.query.analytical.tuples__GT_recur = (function fluree$db$query$analytical$tuples__GT_recur(db,predicate,recur_map,depth,var_first_QMARK_){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_94885){
var state_val_94886 = (state_94885[(1)]);
if((state_val_94886 === (7))){
var inst_94808 = (state_94885[(2)]);
var inst_94809 = recur_map;
var inst_94810 = (1);
var state_94885__$1 = (function (){var statearr_94887 = state_94885;
(statearr_94887[(7)] = inst_94809);

(statearr_94887[(8)] = inst_94808);

(statearr_94887[(9)] = inst_94810);

return statearr_94887;
})();
var statearr_94888_94925 = state_94885__$1;
(statearr_94888_94925[(2)] = null);

(statearr_94888_94925[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (20))){
var inst_94856 = (state_94885[(2)]);
var state_94885__$1 = state_94885;
var statearr_94889_94926 = state_94885__$1;
(statearr_94889_94926[(2)] = inst_94856);

(statearr_94889_94926[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (1))){
var state_94885__$1 = state_94885;
var statearr_94890_94927 = state_94885__$1;
(statearr_94890_94927[(2)] = null);

(statearr_94890_94927[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (24))){
var inst_94881 = (state_94885[(2)]);
var state_94885__$1 = state_94885;
var statearr_94891_94928 = state_94885__$1;
(statearr_94891_94928[(2)] = inst_94881);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_94885__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_94885,(3),Error,null,(2));
var state_94885__$1 = state_94885;
if(cljs.core.truth_(depth)){
var statearr_94892_94929 = state_94885__$1;
(statearr_94892_94929[(1)] = (5));

} else {
var statearr_94893_94930 = state_94885__$1;
(statearr_94893_94930[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (15))){
var inst_94867 = (state_94885[(2)]);
var state_94885__$1 = state_94885;
var statearr_94894_94931 = state_94885__$1;
(statearr_94894_94931[(2)] = inst_94867);

(statearr_94894_94931[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (21))){
var inst_94843 = (state_94885[(10)]);
var inst_94835 = (state_94885[(11)]);
var inst_94850 = (state_94885[(2)]);
var inst_94851 = fluree.db.util.async.throw_err.call(null,inst_94850);
var inst_94852 = cljs.core.concat.call(null,inst_94835,inst_94851);
var inst_94835__$1 = inst_94852;
var inst_94836 = inst_94843;
var state_94885__$1 = (function (){var statearr_94895 = state_94885;
(statearr_94895[(12)] = inst_94836);

(statearr_94895[(11)] = inst_94835__$1);

return statearr_94895;
})();
var statearr_94896_94932 = state_94885__$1;
(statearr_94896_94932[(2)] = null);

(statearr_94896_94932[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (13))){
var inst_94809 = (state_94885[(7)]);
var state_94885__$1 = state_94885;
var statearr_94897_94933 = state_94885__$1;
(statearr_94897_94933[(2)] = inst_94809);

(statearr_94897_94933[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (22))){
var inst_94874 = (state_94885[(13)]);
var state_94885__$1 = state_94885;
var statearr_94898_94934 = state_94885__$1;
(statearr_94898_94934[(2)] = inst_94874);

(statearr_94898_94934[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (6))){
var state_94885__$1 = state_94885;
var statearr_94899_94935 = state_94885__$1;
(statearr_94899_94935[(2)] = (100));

(statearr_94899_94935[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (17))){
var inst_94809 = (state_94885[(7)]);
var inst_94810 = (state_94885[(9)]);
var inst_94858 = (state_94885[(2)]);
var inst_94859 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94860 = [(0),(2)];
var inst_94861 = (new cljs.core.PersistentVector(null,2,(5),inst_94859,inst_94860,null));
var inst_94862 = fluree.db.query.analytical.get_ns_arrays.call(null,inst_94861,inst_94858);
var inst_94863 = fluree.db.query.analytical.tuples__GT_map.call(null,inst_94809,inst_94862);
var inst_94864 = (inst_94810 + (1));
var inst_94809__$1 = inst_94863;
var inst_94810__$1 = inst_94864;
var state_94885__$1 = (function (){var statearr_94900 = state_94885;
(statearr_94900[(7)] = inst_94809__$1);

(statearr_94900[(9)] = inst_94810__$1);

return statearr_94900;
})();
var statearr_94901_94936 = state_94885__$1;
(statearr_94901_94936[(2)] = null);

(statearr_94901_94936[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (3))){
var inst_94801 = (state_94885[(2)]);
var state_94885__$1 = state_94885;
var statearr_94902_94937 = state_94885__$1;
(statearr_94902_94937[(2)] = inst_94801);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_94885__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (12))){
var inst_94869 = (state_94885[(2)]);
var state_94885__$1 = state_94885;
var statearr_94903_94938 = state_94885__$1;
(statearr_94903_94938[(2)] = inst_94869);

(statearr_94903_94938[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (2))){
var inst_94883 = (state_94885[(2)]);
var state_94885__$1 = state_94885;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_94885__$1,inst_94883);
} else {
if((state_val_94886 === (23))){
var inst_94873 = (state_94885[(14)]);
var inst_94874 = (state_94885[(13)]);
var inst_94872 = (state_94885[(15)]);
var inst_94808 = (state_94885[(8)]);
var inst_94877 = (function (){var max_depth = inst_94808;
var recur_map__$1 = inst_94873;
var subjects = inst_94872;
var tuples = inst_94874;
return ((function (max_depth,recur_map__$1,subjects,tuples,inst_94873,inst_94874,inst_94872,inst_94808,state_val_94886,c__86675__auto__){
return (function (p1__94800_SHARP_){
return (new cljs.core.PersistentVector(null,1,(5),cljs.core.PersistentVector.EMPTY_NODE,[cljs.core.second.call(null,p1__94800_SHARP_)],null));
});
;})(max_depth,recur_map__$1,subjects,tuples,inst_94873,inst_94874,inst_94872,inst_94808,state_val_94886,c__86675__auto__))
})();
var inst_94878 = cljs.core.map.call(null,inst_94877,inst_94874);
var inst_94879 = cljs.core.distinct.call(null,inst_94878);
var state_94885__$1 = state_94885;
var statearr_94904_94939 = state_94885__$1;
(statearr_94904_94939[(2)] = inst_94879);

(statearr_94904_94939[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (19))){
var inst_94835 = (state_94885[(11)]);
var state_94885__$1 = state_94885;
var statearr_94905_94940 = state_94885__$1;
(statearr_94905_94940[(2)] = inst_94835);

(statearr_94905_94940[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (11))){
var inst_94820 = (state_94885[(16)]);
var inst_94809 = (state_94885[(7)]);
var inst_94815 = cljs.core.vals.call(null,inst_94809);
var inst_94816 = cljs.core.flatten.call(null,inst_94815);
var inst_94817 = cljs.core.set.call(null,inst_94816);
var inst_94818 = cljs.core.keys.call(null,inst_94809);
var inst_94819 = cljs.core.set.call(null,inst_94818);
var inst_94820__$1 = clojure.set.difference.call(null,inst_94817,inst_94819);
var inst_94821 = cljs.core.empty_QMARK_.call(null,inst_94820__$1);
var state_94885__$1 = (function (){var statearr_94906 = state_94885;
(statearr_94906[(16)] = inst_94820__$1);

return statearr_94906;
})();
if(inst_94821){
var statearr_94907_94941 = state_94885__$1;
(statearr_94907_94941[(1)] = (13));

} else {
var statearr_94908_94942 = state_94885__$1;
(statearr_94908_94942[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (9))){
var inst_94873 = (state_94885[(14)]);
var inst_94872 = (state_94885[(15)]);
var inst_94871 = (state_94885[(2)]);
var inst_94872__$1 = cljs.core.keys.call(null,inst_94871);
var inst_94873__$1 = fluree.db.query.analytical.follow_all_original_subject_paths.call(null,inst_94872__$1,inst_94871);
var inst_94874 = fluree.db.query.analytical.recur_map__GT_tuples.call(null,inst_94872__$1,inst_94873__$1);
var state_94885__$1 = (function (){var statearr_94909 = state_94885;
(statearr_94909[(14)] = inst_94873__$1);

(statearr_94909[(13)] = inst_94874);

(statearr_94909[(15)] = inst_94872__$1);

return statearr_94909;
})();
if(cljs.core.truth_(var_first_QMARK_)){
var statearr_94910_94943 = state_94885__$1;
(statearr_94910_94943[(1)] = (22));

} else {
var statearr_94911_94944 = state_94885__$1;
(statearr_94911_94944[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (5))){
var state_94885__$1 = state_94885;
var statearr_94912_94945 = state_94885__$1;
(statearr_94912_94945[(2)] = depth);

(statearr_94912_94945[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (14))){
var inst_94820 = (state_94885[(16)]);
var inst_94831 = cljs.core.PersistentVector.EMPTY;
var inst_94832 = cljs.core.seq.call(null,inst_94820);
var inst_94833 = cljs.core.first.call(null,inst_94832);
var inst_94834 = cljs.core.next.call(null,inst_94832);
var inst_94835 = inst_94831;
var inst_94836 = inst_94820;
var state_94885__$1 = (function (){var statearr_94913 = state_94885;
(statearr_94913[(17)] = inst_94834);

(statearr_94913[(12)] = inst_94836);

(statearr_94913[(11)] = inst_94835);

(statearr_94913[(18)] = inst_94833);

return statearr_94913;
})();
var statearr_94914_94946 = state_94885__$1;
(statearr_94914_94946[(2)] = null);

(statearr_94914_94946[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (16))){
var inst_94836 = (state_94885[(12)]);
var inst_94842 = (state_94885[(19)]);
var inst_94841 = cljs.core.seq.call(null,inst_94836);
var inst_94842__$1 = cljs.core.first.call(null,inst_94841);
var inst_94843 = cljs.core.next.call(null,inst_94841);
var state_94885__$1 = (function (){var statearr_94915 = state_94885;
(statearr_94915[(10)] = inst_94843);

(statearr_94915[(19)] = inst_94842__$1);

return statearr_94915;
})();
if(cljs.core.truth_(inst_94842__$1)){
var statearr_94916_94947 = state_94885__$1;
(statearr_94916_94947[(1)] = (18));

} else {
var statearr_94917_94948 = state_94885__$1;
(statearr_94917_94948[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (10))){
var inst_94809 = (state_94885[(7)]);
var state_94885__$1 = state_94885;
var statearr_94918_94949 = state_94885__$1;
(statearr_94918_94949[(2)] = inst_94809);

(statearr_94918_94949[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_94886 === (18))){
var inst_94842 = (state_94885[(19)]);
var inst_94845 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94846 = [inst_94842,predicate];
var inst_94847 = (new cljs.core.PersistentVector(null,2,(5),inst_94845,inst_94846,null));
var inst_94848 = fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"spot","spot",-1706962147),cljs.core._EQ_,inst_94847);
var state_94885__$1 = state_94885;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_94885__$1,(21),inst_94848);
} else {
if((state_val_94886 === (8))){
var inst_94808 = (state_94885[(8)]);
var inst_94810 = (state_94885[(9)]);
var inst_94812 = (inst_94810 >= inst_94808);
var state_94885__$1 = state_94885;
if(cljs.core.truth_(inst_94812)){
var statearr_94919_94950 = state_94885__$1;
(statearr_94919_94950[(1)] = (10));

} else {
var statearr_94920_94951 = state_94885__$1;
(statearr_94920_94951[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto__ = null;
var fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto____0 = (function (){
var statearr_94921 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_94921[(0)] = fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto__);

(statearr_94921[(1)] = (1));

return statearr_94921;
});
var fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto____1 = (function (state_94885){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_94885);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e94922){if((e94922 instanceof Object)){
var ex__86628__auto__ = e94922;
var statearr_94923_94952 = state_94885;
(statearr_94923_94952[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_94885);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e94922;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__94953 = state_94885;
state_94885 = G__94953;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto__ = function(state_94885){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto____1.call(this,state_94885);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto____0;
fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto____1;
return fluree$db$query$analytical$tuples__GT_recur_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_94924 = f__86676__auto__.call(null);
(statearr_94924[(6)] = c__86675__auto__);

return statearr_94924;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.query.analytical.fdb_clause__GT_tuples = (function fluree$db$query$analytical$fdb_clause__GT_tuples(db,p__94954,clause,fuel,max_fuel){
var map__94955 = p__94954;
var map__94955__$1 = (((((!((map__94955 == null))))?(((((map__94955.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__94955.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__94955):map__94955);
var res = map__94955__$1;
var headers = cljs.core.get.call(null,map__94955__$1,new cljs.core.Keyword(null,"headers","headers",-835030129));
var tuples = cljs.core.get.call(null,map__94955__$1,new cljs.core.Keyword(null,"tuples","tuples",-676032639));
var vars = cljs.core.get.call(null,map__94955__$1,new cljs.core.Keyword(null,"vars","vars",-2046957217));
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,map__94955,map__94955__$1,res,headers,tuples,vars){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,map__94955,map__94955__$1,res,headers,tuples,vars){
return (function (state_95084){
var state_val_95085 = (state_95084[(1)]);
if((state_val_95085 === (7))){
var inst_94981 = (state_95084[(2)]);
var state_95084__$1 = state_95084;
if(cljs.core.truth_(inst_94981)){
var statearr_95086_95145 = state_95084__$1;
(statearr_95086_95145[(1)] = (11));

} else {
var statearr_95087_95146 = state_95084__$1;
(statearr_95087_95146[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (20))){
var inst_94988 = (state_95084[(7)]);
var inst_95076 = (state_95084[(2)]);
var inst_95077 = [new cljs.core.Keyword(null,"headers","headers",-835030129),new cljs.core.Keyword(null,"vars","vars",-2046957217),new cljs.core.Keyword(null,"tuples","tuples",-676032639)];
var inst_95078 = cljs.core.keys.call(null,inst_94988);
var inst_95079 = [inst_95078,vars,inst_95076];
var inst_95080 = cljs.core.PersistentHashMap.fromArrays(inst_95077,inst_95079);
var state_95084__$1 = state_95084;
var statearr_95088_95147 = state_95084__$1;
(statearr_95088_95147[(2)] = inst_95080);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95084__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (27))){
var inst_95017 = (state_95084[(8)]);
var inst_95047 = cljs.core.PersistentHashMap.EMPTY;
var inst_95048 = fluree.db.query.analytical.tuples__GT_map.call(null,inst_95047,inst_95017);
var state_95084__$1 = state_95084;
var statearr_95089_95148 = state_95084__$1;
(statearr_95089_95148[(2)] = inst_95048);

(statearr_95089_95148[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (1))){
var state_95084__$1 = state_95084;
var statearr_95090_95149 = state_95084__$1;
(statearr_95090_95149[(2)] = null);

(statearr_95090_95149[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (24))){
var state_95084__$1 = state_95084;
var statearr_95091_95150 = state_95084__$1;
(statearr_95091_95150[(2)] = null);

(statearr_95091_95150[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (4))){
var inst_94965 = (state_95084[(9)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_95084,(3),Error,null,(2));
var inst_94965__$1 = fluree.db.query.analytical.clause__GT_rel.call(null,db,vars,clause);
var inst_94967 = (inst_94965__$1 == null);
var inst_94968 = cljs.core.not.call(null,inst_94967);
var state_95084__$1 = (function (){var statearr_95092 = state_95084;
(statearr_95092[(9)] = inst_94965__$1);

return statearr_95092;
})();
if(inst_94968){
var statearr_95093_95151 = state_95084__$1;
(statearr_95093_95151[(1)] = (5));

} else {
var statearr_95094_95152 = state_95084__$1;
(statearr_95094_95152[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (15))){
var inst_94991 = (state_95084[(10)]);
var state_95084__$1 = state_95084;
var statearr_95095_95153 = state_95084__$1;
(statearr_95095_95153[(2)] = inst_94991);

(statearr_95095_95153[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (21))){
var inst_95001 = (state_95084[(11)]);
var inst_95025 = ["Cannot use predicate recursion when predicate is variable. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_95001)].join('');
var inst_95026 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_95027 = [(400),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)];
var inst_95028 = cljs.core.PersistentHashMap.fromArrays(inst_95026,inst_95027);
var inst_95029 = cljs.core.ex_info.call(null,inst_95025,inst_95028);
var inst_95030 = (function(){throw inst_95029})();
var state_95084__$1 = state_95084;
var statearr_95096_95154 = state_95084__$1;
(statearr_95096_95154[(2)] = inst_95030);

(statearr_95096_95154[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (31))){
var inst_95019 = (state_95084[(12)]);
var inst_95056 = cljs.core.coll_QMARK_.call(null,inst_95019);
var state_95084__$1 = state_95084;
if(inst_95056){
var statearr_95097_95155 = state_95084__$1;
(statearr_95097_95155[(1)] = (33));

} else {
var statearr_95098_95156 = state_95084__$1;
(statearr_95098_95156[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (32))){
var inst_95067 = (state_95084[(2)]);
var state_95084__$1 = state_95084;
var statearr_95099_95157 = state_95084__$1;
(statearr_95099_95157[(2)] = inst_95067);

(statearr_95099_95157[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (33))){
var inst_95017 = (state_95084[(8)]);
var inst_95013 = (state_95084[(13)]);
var inst_95058 = cljs.core.PersistentHashMap.EMPTY;
var inst_95059 = cljs.core.first.call(null,inst_95013);
var inst_95060 = cljs.core.first.call(null,inst_95059);
var inst_95061 = cljs.core.flatten.call(null,inst_95017);
var inst_95062 = cljs.core.assoc.call(null,inst_95058,inst_95060,inst_95061);
var state_95084__$1 = state_95084;
var statearr_95100_95158 = state_95084__$1;
(statearr_95100_95158[(2)] = inst_95062);

(statearr_95100_95158[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (13))){
var inst_95003 = (state_95084[(14)]);
var inst_94992 = (state_95084[(15)]);
var inst_94991 = (state_95084[(10)]);
var inst_94988 = (state_95084[(7)]);
var inst_94986 = (state_95084[(2)]);
var inst_94987 = cljs.core.get.call(null,inst_94986,new cljs.core.Keyword(null,"search","search",1564939822));
var inst_94988__$1 = cljs.core.get.call(null,inst_94986,new cljs.core.Keyword(null,"rel","rel",1378823488));
var inst_94989 = cljs.core.get.call(null,inst_94986,new cljs.core.Keyword(null,"opts","opts",155075701));
var inst_94990 = fluree.db.query.analytical.intersecting_keys_tuples_clause.call(null,res,clause);
var inst_94991__$1 = new cljs.core.Keyword(null,"object-fn","object-fn",1425858481).cljs$core$IFn$_invoke$arity$1(inst_94989);
var inst_94992__$1 = new cljs.core.Keyword(null,"recur","recur",-437573268).cljs$core$IFn$_invoke$arity$1(inst_94989);
var inst_94994 = (function (){var map__94961 = inst_94986;
var search = inst_94987;
var rel = inst_94988__$1;
var opts = inst_94989;
var common_keys = inst_94990;
var object_fn = inst_94991__$1;
var recur_depth = inst_94992__$1;
return ((function (map__94961,search,rel,opts,common_keys,object_fn,recur_depth,inst_95003,inst_94992,inst_94991,inst_94988,inst_94986,inst_94987,inst_94988__$1,inst_94989,inst_94990,inst_94991__$1,inst_94992__$1,state_val_95085,c__86675__auto__,map__94955,map__94955__$1,res,headers,tuples,vars){
return (function (p__94993,common_key){
var vec__95101 = p__94993;
var acc = cljs.core.nth.call(null,vec__95101,(0),null);
var clause_SINGLEQUOTE_ = cljs.core.nth.call(null,vec__95101,(1),null);
var idx_of = fluree.db.util.core.index_of.call(null,clause,cljs.core.str.cljs$core$IFn$_invoke$arity$1(common_key));
var k = (function (){var pred__95104 = cljs.core._EQ_;
var expr__95105 = idx_of;
if(cljs.core.truth_(pred__95104.call(null,(0),expr__95105))){
return new cljs.core.Keyword(null,"subject-fn","subject-fn",-581375441);
} else {
if(cljs.core.truth_(pred__95104.call(null,(1),expr__95105))){
return new cljs.core.Keyword(null,"predicate-fn","predicate-fn",418606845);
} else {
if(cljs.core.truth_(pred__95104.call(null,(2),expr__95105))){
return new cljs.core.Keyword(null,"object-fn","object-fn",1425858481);
} else {
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(expr__95105)].join('')));
}
}
}
})();
var res_idx = fluree.db.util.core.index_of.call(null,headers,common_key);
var v = cljs.core.into.call(null,cljs.core.PersistentHashSet.EMPTY,cljs.core.map.call(null,cljs.core.first,fluree.db.query.analytical.get_ns_arrays.call(null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [res_idx], null),tuples)));
var single_v_QMARK_ = cljs.core._EQ_.call(null,(1),cljs.core.count.call(null,v));
var v__$1 = (cljs.core.truth_((function (){var and__4120__auto__ = (!(single_v_QMARK_));
if(and__4120__auto__){
var and__4120__auto____$1 = object_fn;
if(cljs.core.truth_(and__4120__auto____$1)){
return cljs.core._EQ_.call(null,k,object_fn);
} else {
return and__4120__auto____$1;
}
} else {
return and__4120__auto__;
}
})())?cljs.core.comp.call(null,v,object_fn):v);
if(single_v_QMARK_){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [acc,cljs.core.assoc.call(null,clause_SINGLEQUOTE_,idx_of,cljs.core.first.call(null,v__$1))], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.assoc.call(null,acc,k,v__$1),clause_SINGLEQUOTE_], null);
}
});
;})(map__94961,search,rel,opts,common_keys,object_fn,recur_depth,inst_95003,inst_94992,inst_94991,inst_94988,inst_94986,inst_94987,inst_94988__$1,inst_94989,inst_94990,inst_94991__$1,inst_94992__$1,state_val_95085,c__86675__auto__,map__94955,map__94955__$1,res,headers,tuples,vars))
})();
var inst_94995 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_94996 = cljs.core.PersistentHashMap.EMPTY;
var inst_94997 = [inst_94996,inst_94987];
var inst_94998 = (new cljs.core.PersistentVector(null,2,(5),inst_94995,inst_94997,null));
var inst_94999 = cljs.core.reduce.call(null,inst_94994,inst_94998,inst_94990);
var inst_95000 = cljs.core.nth.call(null,inst_94999,(0),null);
var inst_95001 = cljs.core.nth.call(null,inst_94999,(1),null);
var inst_95002 = [new cljs.core.Keyword(null,"object-fn","object-fn",1425858481)];
var inst_95003__$1 = new cljs.core.Keyword(null,"object-fn","object-fn",1425858481).cljs$core$IFn$_invoke$arity$1(inst_95000);
var state_95084__$1 = (function (){var statearr_95107 = state_95084;
(statearr_95107[(14)] = inst_95003__$1);

(statearr_95107[(15)] = inst_94992__$1);

(statearr_95107[(10)] = inst_94991__$1);

(statearr_95107[(16)] = inst_95002);

(statearr_95107[(11)] = inst_95001);

(statearr_95107[(7)] = inst_94988__$1);

return statearr_95107;
})();
if(cljs.core.truth_(inst_95003__$1)){
var statearr_95108_95159 = state_95084__$1;
(statearr_95108_95159[(1)] = (14));

} else {
var statearr_95109_95160 = state_95084__$1;
(statearr_95109_95160[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (22))){
var state_95084__$1 = state_95084;
var statearr_95110_95161 = state_95084__$1;
(statearr_95110_95161[(2)] = null);

(statearr_95110_95161[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (36))){
var inst_95072 = (state_95084[(2)]);
var inst_95073 = fluree.db.util.async.throw_err.call(null,inst_95072);
var state_95084__$1 = state_95084;
var statearr_95111_95162 = state_95084__$1;
(statearr_95111_95162[(2)] = inst_95073);

(statearr_95111_95162[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (29))){
var inst_95022 = (state_95084[(17)]);
var inst_94992 = (state_95084[(15)]);
var inst_95021 = (state_95084[(18)]);
var inst_95069 = (state_95084[(2)]);
var inst_95070 = fluree.db.query.analytical.tuples__GT_recur.call(null,db,inst_95022,inst_95069,inst_94992,inst_95021);
var state_95084__$1 = state_95084;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95084__$1,(36),inst_95070);
} else {
if((state_val_95085 === (6))){
var state_95084__$1 = state_95084;
var statearr_95112_95163 = state_95084__$1;
(statearr_95112_95163[(2)] = false);

(statearr_95112_95163[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (28))){
var inst_95019 = (state_95084[(12)]);
var inst_95050 = typeof inst_95019 === 'number';
var state_95084__$1 = state_95084;
if(cljs.core.truth_(inst_95050)){
var statearr_95113_95164 = state_95084__$1;
(statearr_95113_95164[(1)] = (30));

} else {
var statearr_95114_95165 = state_95084__$1;
(statearr_95114_95165[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (25))){
var inst_95001 = (state_95084[(11)]);
var inst_95038 = ["Cannot use predicate recursion when object is not a variable. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_95001)].join('');
var inst_95039 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_95040 = [(400),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)];
var inst_95041 = cljs.core.PersistentHashMap.fromArrays(inst_95039,inst_95040);
var inst_95042 = cljs.core.ex_info.call(null,inst_95038,inst_95041);
var inst_95043 = (function(){throw inst_95042})();
var state_95084__$1 = state_95084;
var statearr_95115_95166 = state_95084__$1;
(statearr_95115_95166[(2)] = inst_95043);

(statearr_95115_95166[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (34))){
var state_95084__$1 = state_95084;
var statearr_95116_95167 = state_95084__$1;
(statearr_95116_95167[(2)] = null);

(statearr_95116_95167[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (17))){
var inst_94992 = (state_95084[(15)]);
var inst_95013 = (state_95084[(13)]);
var inst_94988 = (state_95084[(7)]);
var inst_95012 = (state_95084[(2)]);
var inst_95013__$1 = fluree.db.util.async.throw_err.call(null,inst_95012);
var inst_95014 = cljs.core.count.call(null,inst_95013__$1);
var inst_95015 = fluree.db.query.analytical.add_fuel.call(null,inst_95014,fuel,max_fuel);
var inst_95016 = cljs.core.vals.call(null,inst_94988);
var inst_95017 = fluree.db.query.analytical.get_ns_arrays.call(null,inst_95016,inst_95013__$1);
var state_95084__$1 = (function (){var statearr_95117 = state_95084;
(statearr_95117[(19)] = inst_95015);

(statearr_95117[(8)] = inst_95017);

(statearr_95117[(13)] = inst_95013__$1);

return statearr_95117;
})();
if(cljs.core.truth_(inst_94992)){
var statearr_95118_95168 = state_95084__$1;
(statearr_95118_95168[(1)] = (18));

} else {
var statearr_95119_95169 = state_95084__$1;
(statearr_95119_95169[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (3))){
var inst_94957 = (state_95084[(2)]);
var state_95084__$1 = state_95084;
var statearr_95120_95170 = state_95084__$1;
(statearr_95120_95170[(2)] = inst_94957);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95084__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (12))){
var inst_94965 = (state_95084[(9)]);
var state_95084__$1 = state_95084;
var statearr_95121_95171 = state_95084__$1;
(statearr_95121_95171[(2)] = inst_94965);

(statearr_95121_95171[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (2))){
var inst_95082 = (state_95084[(2)]);
var state_95084__$1 = state_95084;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_95084__$1,inst_95082);
} else {
if((state_val_95085 === (23))){
var inst_95033 = (state_95084[(2)]);
var inst_95034 = cljs.core.nth.call(null,clause,(2));
var inst_95035 = fluree.db.query.analytical.variable_QMARK_.call(null,inst_95034);
var state_95084__$1 = (function (){var statearr_95122 = state_95084;
(statearr_95122[(20)] = inst_95033);

return statearr_95122;
})();
if(cljs.core.truth_(inst_95035)){
var statearr_95123_95172 = state_95084__$1;
(statearr_95123_95172[(1)] = (24));

} else {
var statearr_95124_95173 = state_95084__$1;
(statearr_95124_95173[(1)] = (25));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (35))){
var inst_95065 = (state_95084[(2)]);
var state_95084__$1 = state_95084;
var statearr_95125_95174 = state_95084__$1;
(statearr_95125_95174[(2)] = inst_95065);

(statearr_95125_95174[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (19))){
var inst_95017 = (state_95084[(8)]);
var state_95084__$1 = state_95084;
var statearr_95126_95175 = state_95084__$1;
(statearr_95126_95175[(2)] = inst_95017);

(statearr_95126_95175[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (11))){
var inst_94965 = (state_95084[(9)]);
var inst_94983 = cljs.core.apply.call(null,cljs.core.hash_map,inst_94965);
var state_95084__$1 = state_95084;
var statearr_95127_95176 = state_95084__$1;
(statearr_95127_95176[(2)] = inst_94983);

(statearr_95127_95176[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (9))){
var state_95084__$1 = state_95084;
var statearr_95128_95177 = state_95084__$1;
(statearr_95128_95177[(2)] = false);

(statearr_95128_95177[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (5))){
var inst_94965 = (state_95084[(9)]);
var inst_94970 = inst_94965.cljs$lang$protocol_mask$partition0$;
var inst_94971 = (inst_94970 & (64));
var inst_94972 = inst_94965.cljs$core$ISeq$;
var inst_94973 = (cljs.core.PROTOCOL_SENTINEL === inst_94972);
var inst_94974 = ((inst_94971) || (inst_94973));
var state_95084__$1 = state_95084;
if(cljs.core.truth_(inst_94974)){
var statearr_95129_95178 = state_95084__$1;
(statearr_95129_95178[(1)] = (8));

} else {
var statearr_95130_95179 = state_95084__$1;
(statearr_95130_95179[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (14))){
var inst_95003 = (state_95084[(14)]);
var state_95084__$1 = state_95084;
var statearr_95131_95180 = state_95084__$1;
(statearr_95131_95180[(2)] = inst_95003);

(statearr_95131_95180[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (26))){
var inst_95021 = (state_95084[(18)]);
var inst_95045 = (state_95084[(2)]);
var state_95084__$1 = (function (){var statearr_95132 = state_95084;
(statearr_95132[(21)] = inst_95045);

return statearr_95132;
})();
if(cljs.core.truth_(inst_95021)){
var statearr_95133_95181 = state_95084__$1;
(statearr_95133_95181[(1)] = (27));

} else {
var statearr_95134_95182 = state_95084__$1;
(statearr_95134_95182[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (16))){
var inst_95002 = (state_95084[(16)]);
var inst_95001 = (state_95084[(11)]);
var inst_95007 = (state_95084[(2)]);
var inst_95008 = [inst_95007];
var inst_95009 = cljs.core.PersistentHashMap.fromArrays(inst_95002,inst_95008);
var inst_95010 = fluree.db.query.range.search.call(null,db,inst_95001,inst_95009);
var state_95084__$1 = state_95084;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95084__$1,(17),inst_95010);
} else {
if((state_val_95085 === (30))){
var inst_95017 = (state_95084[(8)]);
var inst_95019 = (state_95084[(12)]);
var inst_95052 = cljs.core.PersistentHashMap.EMPTY;
var inst_95053 = cljs.core.flatten.call(null,inst_95017);
var inst_95054 = cljs.core.assoc.call(null,inst_95052,inst_95019,inst_95053);
var state_95084__$1 = state_95084;
var statearr_95135_95183 = state_95084__$1;
(statearr_95135_95183[(2)] = inst_95054);

(statearr_95135_95183[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (10))){
var inst_94978 = (state_95084[(2)]);
var state_95084__$1 = state_95084;
var statearr_95136_95184 = state_95084__$1;
(statearr_95136_95184[(2)] = inst_94978);

(statearr_95136_95184[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (18))){
var inst_95022 = (state_95084[(17)]);
var inst_95001 = (state_95084[(11)]);
var inst_95019 = cljs.core.first.call(null,inst_95001);
var inst_95020 = cljs.core.first.call(null,clause);
var inst_95021 = fluree.db.query.analytical.variable_QMARK_.call(null,inst_95020);
var inst_95022__$1 = cljs.core.nth.call(null,inst_95001,(1));
var inst_95023 = fluree.db.query.analytical.variable_QMARK_.call(null,inst_95022__$1);
var state_95084__$1 = (function (){var statearr_95137 = state_95084;
(statearr_95137[(17)] = inst_95022__$1);

(statearr_95137[(18)] = inst_95021);

(statearr_95137[(12)] = inst_95019);

return statearr_95137;
})();
if(cljs.core.truth_(inst_95023)){
var statearr_95138_95185 = state_95084__$1;
(statearr_95138_95185[(1)] = (21));

} else {
var statearr_95139_95186 = state_95084__$1;
(statearr_95139_95186[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95085 === (8))){
var state_95084__$1 = state_95084;
var statearr_95140_95187 = state_95084__$1;
(statearr_95140_95187[(2)] = true);

(statearr_95140_95187[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,map__94955,map__94955__$1,res,headers,tuples,vars))
;
return ((function (switch__86624__auto__,c__86675__auto__,map__94955,map__94955__$1,res,headers,tuples,vars){
return (function() {
var fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto__ = null;
var fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto____0 = (function (){
var statearr_95141 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_95141[(0)] = fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto__);

(statearr_95141[(1)] = (1));

return statearr_95141;
});
var fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto____1 = (function (state_95084){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_95084);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e95142){if((e95142 instanceof Object)){
var ex__86628__auto__ = e95142;
var statearr_95143_95188 = state_95084;
(statearr_95143_95188[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95084);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e95142;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__95189 = state_95084;
state_95084 = G__95189;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto__ = function(state_95084){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto____1.call(this,state_95084);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto____0;
fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto____1;
return fluree$db$query$analytical$fdb_clause__GT_tuples_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,map__94955,map__94955__$1,res,headers,tuples,vars))
})();
var state__86677__auto__ = (function (){var statearr_95144 = f__86676__auto__.call(null);
(statearr_95144[(6)] = c__86675__auto__);

return statearr_95144;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,map__94955,map__94955__$1,res,headers,tuples,vars))
);

return c__86675__auto__;
});
fluree.db.query.analytical.full_text__GT_tuples = (function fluree$db$query$analytical$full_text__GT_tuples(db,res,clause){
throw cljs.core.ex_info.call(null,"Full text search is not supported in JS",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null));
});
fluree.db.query.analytical.collection__GT_tuples = (function fluree$db$query$analytical$collection__GT_tuples(db,res,clause){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_95285){
var state_val_95286 = (state_95285[(1)]);
if((state_val_95286 === (7))){
var inst_95203 = (state_95285[(2)]);
var state_95285__$1 = state_95285;
if(cljs.core.truth_(inst_95203)){
var statearr_95287_95320 = state_95285__$1;
(statearr_95287_95320[(1)] = (8));

} else {
var statearr_95288_95321 = state_95285__$1;
(statearr_95288_95321[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (20))){
var inst_95250 = (state_95285[(7)]);
var state_95285__$1 = state_95285;
var statearr_95289_95322 = state_95285__$1;
(statearr_95289_95322[(2)] = inst_95250);

(statearr_95289_95322[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (1))){
var state_95285__$1 = state_95285;
var statearr_95290_95323 = state_95285__$1;
(statearr_95290_95323[(2)] = null);

(statearr_95290_95323[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (4))){
var inst_95197 = (state_95285[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_95285,(3),Error,null,(2));
var inst_95196 = cljs.core.first.call(null,clause);
var inst_95197__$1 = fluree.db.query.analytical.variable_QMARK_.call(null,inst_95196);
var inst_95198 = cljs.core.last.call(null,clause);
var inst_95199 = fluree.db.query.analytical.variable_QMARK_.call(null,inst_95198);
var state_95285__$1 = (function (){var statearr_95291 = state_95285;
(statearr_95291[(9)] = inst_95199);

(statearr_95291[(8)] = inst_95197__$1);

return statearr_95291;
})();
if(cljs.core.truth_(inst_95197__$1)){
var statearr_95292_95324 = state_95285__$1;
(statearr_95292_95324[(1)] = (5));

} else {
var statearr_95293_95325 = state_95285__$1;
(statearr_95293_95325[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (15))){
var inst_95199 = (state_95285[(9)]);
var inst_95197 = (state_95285[(8)]);
var inst_95230 = cljs.core.last.call(null,clause);
var inst_95231 = fluree.db.dbproto._c_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),inst_95230);
var inst_95232 = new cljs.core.Keyword(null,"ecount","ecount",-879380887).cljs$core$IFn$_invoke$arity$1(db);
var inst_95233 = cljs.core.get.call(null,inst_95232,inst_95231);
var inst_95234 = fluree.db.flake.min_subject_id.call(null,inst_95231);
var inst_95235 = [new cljs.core.Keyword(null,"headers","headers",-835030129),new cljs.core.Keyword(null,"tuples","tuples",-676032639),new cljs.core.Keyword(null,"vars","vars",-2046957217)];
var inst_95236 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95237 = [inst_95197];
var inst_95238 = (new cljs.core.PersistentVector(null,1,(5),inst_95236,inst_95237,null));
var inst_95239 = (function (){var subject_var = inst_95197;
var object_var = inst_95199;
var cid = inst_95231;
var max_sid = inst_95233;
var min_sid = inst_95234;
return ((function (subject_var,object_var,cid,max_sid,min_sid,inst_95199,inst_95197,inst_95230,inst_95231,inst_95232,inst_95233,inst_95234,inst_95235,inst_95236,inst_95237,inst_95238,state_val_95286,c__86675__auto__){
return (function (p1__95191_SHARP_){
return cljs.core.conj.call(null,cljs.core.PersistentVector.EMPTY,p1__95191_SHARP_);
});
;})(subject_var,object_var,cid,max_sid,min_sid,inst_95199,inst_95197,inst_95230,inst_95231,inst_95232,inst_95233,inst_95234,inst_95235,inst_95236,inst_95237,inst_95238,state_val_95286,c__86675__auto__))
})();
var inst_95240 = (inst_95233 + (1));
var inst_95241 = cljs.core.range.call(null,inst_95234,inst_95240);
var inst_95242 = cljs.core.map.call(null,inst_95239,inst_95241);
var inst_95243 = cljs.core.PersistentHashMap.EMPTY;
var inst_95244 = [inst_95238,inst_95242,inst_95243];
var inst_95245 = cljs.core.PersistentHashMap.fromArrays(inst_95235,inst_95244);
var state_95285__$1 = state_95285;
var statearr_95294_95326 = state_95285__$1;
(statearr_95294_95326[(2)] = inst_95245);

(statearr_95294_95326[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (21))){
var inst_95250 = (state_95285[(7)]);
var inst_95254 = fluree.db.dbproto._subid.call(null,db,inst_95250);
var state_95285__$1 = state_95285;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95285__$1,(23),inst_95254);
} else {
if((state_val_95286 === (13))){
var inst_95279 = (state_95285[(2)]);
var state_95285__$1 = state_95285;
var statearr_95295_95327 = state_95285__$1;
(statearr_95295_95327[(2)] = inst_95279);

(statearr_95295_95327[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (22))){
var inst_95199 = (state_95285[(9)]);
var inst_95259 = (state_95285[(2)]);
var inst_95260 = fluree.db.flake.sid__GT_cid.call(null,inst_95259);
var inst_95261 = fluree.db.dbproto._c_prop.call(null,db,new cljs.core.Keyword(null,"name","name",1843675177),inst_95260);
var inst_95262 = [new cljs.core.Keyword(null,"headers","headers",-835030129),new cljs.core.Keyword(null,"tuples","tuples",-676032639),new cljs.core.Keyword(null,"vars","vars",-2046957217)];
var inst_95263 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95264 = [inst_95199];
var inst_95265 = (new cljs.core.PersistentVector(null,1,(5),inst_95263,inst_95264,null));
var inst_95266 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95267 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95268 = [inst_95261];
var inst_95269 = (new cljs.core.PersistentVector(null,1,(5),inst_95267,inst_95268,null));
var inst_95270 = [inst_95269];
var inst_95271 = (new cljs.core.PersistentVector(null,1,(5),inst_95266,inst_95270,null));
var inst_95272 = cljs.core.PersistentHashMap.EMPTY;
var inst_95273 = [inst_95265,inst_95271,inst_95272];
var inst_95274 = cljs.core.PersistentHashMap.fromArrays(inst_95262,inst_95273);
var state_95285__$1 = state_95285;
var statearr_95296_95328 = state_95285__$1;
(statearr_95296_95328[(2)] = inst_95274);

(statearr_95296_95328[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (6))){
var inst_95197 = (state_95285[(8)]);
var state_95285__$1 = state_95285;
var statearr_95297_95329 = state_95285__$1;
(statearr_95297_95329[(2)] = inst_95197);

(statearr_95297_95329[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (17))){
var inst_95250 = (state_95285[(7)]);
var inst_95250__$1 = cljs.core.first.call(null,clause);
var inst_95251 = typeof inst_95250__$1 === 'number';
var state_95285__$1 = (function (){var statearr_95298 = state_95285;
(statearr_95298[(7)] = inst_95250__$1);

return statearr_95298;
})();
if(cljs.core.truth_(inst_95251)){
var statearr_95299_95330 = state_95285__$1;
(statearr_95299_95330[(1)] = (20));

} else {
var statearr_95300_95331 = state_95285__$1;
(statearr_95300_95331[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (3))){
var inst_95192 = (state_95285[(2)]);
var state_95285__$1 = state_95285;
var statearr_95301_95332 = state_95285__$1;
(statearr_95301_95332[(2)] = inst_95192);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95285__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (12))){
var inst_95199 = (state_95285[(9)]);
var state_95285__$1 = state_95285;
if(cljs.core.truth_(inst_95199)){
var statearr_95302_95333 = state_95285__$1;
(statearr_95302_95333[(1)] = (17));

} else {
var statearr_95303_95334 = state_95285__$1;
(statearr_95303_95334[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (2))){
var inst_95283 = (state_95285[(2)]);
var state_95285__$1 = state_95285;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_95285__$1,inst_95283);
} else {
if((state_val_95286 === (23))){
var inst_95256 = (state_95285[(2)]);
var inst_95257 = fluree.db.util.async.throw_err.call(null,inst_95256);
var state_95285__$1 = state_95285;
var statearr_95304_95335 = state_95285__$1;
(statearr_95304_95335[(2)] = inst_95257);

(statearr_95304_95335[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (19))){
var inst_95277 = (state_95285[(2)]);
var state_95285__$1 = state_95285;
var statearr_95305_95336 = state_95285__$1;
(statearr_95305_95336[(2)] = inst_95277);

(statearr_95305_95336[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (11))){
var inst_95212 = ["_tx",null,"_block",null];
var inst_95213 = (new cljs.core.PersistentArrayMap(null,2,inst_95212,null));
var inst_95214 = (new cljs.core.PersistentHashSet(null,inst_95213,null));
var inst_95215 = cljs.core.last.call(null,clause);
var inst_95216 = inst_95214.call(null,inst_95215);
var state_95285__$1 = state_95285;
if(cljs.core.truth_(inst_95216)){
var statearr_95306_95337 = state_95285__$1;
(statearr_95306_95337[(1)] = (14));

} else {
var statearr_95307_95338 = state_95285__$1;
(statearr_95307_95338[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (9))){
var inst_95197 = (state_95285[(8)]);
var state_95285__$1 = state_95285;
if(cljs.core.truth_(inst_95197)){
var statearr_95308_95339 = state_95285__$1;
(statearr_95308_95339[(1)] = (11));

} else {
var statearr_95309_95340 = state_95285__$1;
(statearr_95309_95340[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (5))){
var inst_95199 = (state_95285[(9)]);
var state_95285__$1 = state_95285;
var statearr_95310_95341 = state_95285__$1;
(statearr_95310_95341[(2)] = inst_95199);

(statearr_95310_95341[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (14))){
var inst_95199 = (state_95285[(9)]);
var inst_95197 = (state_95285[(8)]);
var inst_95218 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(db);
var inst_95219 = [new cljs.core.Keyword(null,"headers","headers",-835030129),new cljs.core.Keyword(null,"tuples","tuples",-676032639),new cljs.core.Keyword(null,"vars","vars",-2046957217)];
var inst_95220 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95221 = [inst_95197];
var inst_95222 = (new cljs.core.PersistentVector(null,1,(5),inst_95220,inst_95221,null));
var inst_95223 = (function (){var subject_var = inst_95197;
var object_var = inst_95199;
var min_sid = inst_95218;
var max_sid = (0);
return ((function (subject_var,object_var,min_sid,max_sid,inst_95199,inst_95197,inst_95218,inst_95219,inst_95220,inst_95221,inst_95222,state_val_95286,c__86675__auto__){
return (function (p1__95190_SHARP_){
return cljs.core.conj.call(null,cljs.core.PersistentVector.EMPTY,p1__95190_SHARP_);
});
;})(subject_var,object_var,min_sid,max_sid,inst_95199,inst_95197,inst_95218,inst_95219,inst_95220,inst_95221,inst_95222,state_val_95286,c__86675__auto__))
})();
var inst_95224 = cljs.core.range.call(null,inst_95218,(0));
var inst_95225 = cljs.core.map.call(null,inst_95223,inst_95224);
var inst_95226 = cljs.core.PersistentHashMap.EMPTY;
var inst_95227 = [inst_95222,inst_95225,inst_95226];
var inst_95228 = cljs.core.PersistentHashMap.fromArrays(inst_95219,inst_95227);
var state_95285__$1 = state_95285;
var statearr_95311_95342 = state_95285__$1;
(statearr_95311_95342[(2)] = inst_95228);

(statearr_95311_95342[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (16))){
var inst_95247 = (state_95285[(2)]);
var state_95285__$1 = state_95285;
var statearr_95312_95343 = state_95285__$1;
(statearr_95312_95343[(2)] = inst_95247);

(statearr_95312_95343[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (10))){
var inst_95281 = (state_95285[(2)]);
var state_95285__$1 = state_95285;
var statearr_95313_95344 = state_95285__$1;
(statearr_95313_95344[(2)] = inst_95281);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95285__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (18))){
var state_95285__$1 = state_95285;
var statearr_95314_95345 = state_95285__$1;
(statearr_95314_95345[(2)] = null);

(statearr_95314_95345[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95286 === (8))){
var inst_95205 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_95206 = [(400),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)];
var inst_95207 = cljs.core.PersistentHashMap.fromArrays(inst_95205,inst_95206);
var inst_95208 = cljs.core.ex_info.call(null,"When using rdf:type, either a subject or a type (collection) must be specified.",inst_95207);
var inst_95209 = (function(){throw inst_95208})();
var state_95285__$1 = state_95285;
var statearr_95315_95346 = state_95285__$1;
(statearr_95315_95346[(2)] = inst_95209);

(statearr_95315_95346[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto__ = null;
var fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto____0 = (function (){
var statearr_95316 = [null,null,null,null,null,null,null,null,null,null];
(statearr_95316[(0)] = fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto__);

(statearr_95316[(1)] = (1));

return statearr_95316;
});
var fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto____1 = (function (state_95285){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_95285);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e95317){if((e95317 instanceof Object)){
var ex__86628__auto__ = e95317;
var statearr_95318_95347 = state_95285;
(statearr_95318_95347[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95285);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e95317;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__95348 = state_95285;
state_95285 = G__95348;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto__ = function(state_95285){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto____1.call(this,state_95285);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto____0;
fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto____1;
return fluree$db$query$analytical$collection__GT_tuples_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_95319 = f__86676__auto__.call(null);
(statearr_95319[(6)] = c__86675__auto__);

return statearr_95319;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.query.analytical.all_functions = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 41, ["isIRI",null,"YEAR",null,"UCASE",null,"isBLANK",null,"MONTH",null,"STRSTARTS",null,"sameTerm",null,"NOW",null,"MINUTES",null,"isURI",null,"IF",null,"COALESCE",null,"STRLEN",null,"CONCAT",null,"CONTAINS",null,"SHA512",null,"CEIL",null,"SECONDS",null,"SHA384",null,"RAND",null,"TZ",null,"isNUMERIC",null,"STRENDS",null,"STRAFTER",null,"ENCODE_FOR_URI",null,"HOURS",null,"LCASE",null,"STRDT",null,"FLOOR",null,"SHA1",null,"STRBEFORE",null,"STR",null,"TIMEZONE",null,"DAY",null,"SHA256",null,"isLITERAL",null,"STRUUID",null,"MD5",null,"ABS",null,"STRLANG",null,"UUID",null], null), null);
fluree.db.query.analytical.built_in_aggregates = (function (){var sum = (function fluree$db$query$analytical$sum(coll){
return cljs.core.reduce.call(null,cljs.core._PLUS_,(0),coll);
});
var avg = (function fluree$db$query$analytical$avg(coll){
return (sum.call(null,coll) / cljs.core.count.call(null,coll));
});
var median = (function fluree$db$query$analytical$median(coll){
var terms = cljs.core.sort.call(null,coll);
var size = cljs.core.count.call(null,coll);
var med = (size >> (1));
var G__95354 = cljs.core.nth.call(null,terms,med);
if(cljs.core.even_QMARK_.call(null,size)){
return ((G__95354 + cljs.core.nth.call(null,terms,(med - (1)))) / (2));
} else {
return G__95354;
}
});
var variance = (function fluree$db$query$analytical$variance(coll){
var mean = avg.call(null,coll);
var sum__$1 = sum.call(null,(function (){var iter__4523__auto__ = ((function (mean){
return (function fluree$db$query$analytical$variance_$_iter__95355(s__95356){
return (new cljs.core.LazySeq(null,((function (mean){
return (function (){
var s__95356__$1 = s__95356;
while(true){
var temp__5735__auto__ = cljs.core.seq.call(null,s__95356__$1);
if(temp__5735__auto__){
var s__95356__$2 = temp__5735__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__95356__$2)){
var c__4521__auto__ = cljs.core.chunk_first.call(null,s__95356__$2);
var size__4522__auto__ = cljs.core.count.call(null,c__4521__auto__);
var b__95358 = cljs.core.chunk_buffer.call(null,size__4522__auto__);
if((function (){var i__95357 = (0);
while(true){
if((i__95357 < size__4522__auto__)){
var x = cljs.core._nth.call(null,c__4521__auto__,i__95357);
var delta = (x - mean);
cljs.core.chunk_append.call(null,b__95358,(delta * delta));

var G__95359 = (i__95357 + (1));
i__95357 = G__95359;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__95358),fluree$db$query$analytical$variance_$_iter__95355.call(null,cljs.core.chunk_rest.call(null,s__95356__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__95358),null);
}
} else {
var x = cljs.core.first.call(null,s__95356__$2);
var delta = (x - mean);
return cljs.core.cons.call(null,(delta * delta),fluree$db$query$analytical$variance_$_iter__95355.call(null,cljs.core.rest.call(null,s__95356__$2)));
}
} else {
return null;
}
break;
}
});})(mean))
,null,null));
});})(mean))
;
return iter__4523__auto__.call(null,coll);
})());
return (sum__$1 / cljs.core.count.call(null,coll));
});
var stddev = (function fluree$db$query$analytical$stddev(coll){
return Math.sqrt(variance.call(null,coll));
});
return cljs.core.PersistentHashMap.fromArrays([new cljs.core.Symbol(null,"variance","variance",-1522424942,null),new cljs.core.Symbol(null,"count","count",-514511684,null),new cljs.core.Symbol(null,"median","median",-2084869638,null),new cljs.core.Symbol(null,"groupconcat","groupconcat",-736310912,null),new cljs.core.Symbol(null,"sum","sum",1777518341,null),new cljs.core.Symbol(null,"abs","abs",1394505050,null),new cljs.core.Symbol(null,"min","min",2085523049,null),new cljs.core.Symbol(null,"ceil","ceil",-184398425,null),new cljs.core.Symbol(null,"max","max",1701898075,null),new cljs.core.Symbol(null,"count-distinct","count-distinct",-1566572514,null),new cljs.core.Symbol(null,"avg","avg",1837937727,null),new cljs.core.Symbol(null,"floor","floor",-772394748,null),new cljs.core.Symbol(null,"str","str",-1564826950,null),new cljs.core.Symbol(null,"stddev","stddev",775056588,null),new cljs.core.Symbol(null,"rand","rand",-1745930995,null),new cljs.core.Symbol(null,"sample","sample",1719555128,null)],[variance,cljs.core.count,median,cljs.core.concat,sum,(function (n){
var x__4219__auto__ = n;
var y__4220__auto__ = (- n);
return ((x__4219__auto__ > y__4220__auto__) ? x__4219__auto__ : y__4220__auto__);
}),(function() {
var G__95360 = null;
var G__95360__1 = (function (coll){
return cljs.core.reduce.call(null,(function (acc,x){
if((cljs.core.compare.call(null,x,acc) < (0))){
return x;
} else {
return acc;
}
}),cljs.core.first.call(null,coll),cljs.core.next.call(null,coll));
});
var G__95360__2 = (function (n,coll){
return cljs.core.vec.call(null,cljs.core.reduce.call(null,(function (acc,x){
if((cljs.core.count.call(null,acc) < n)){
return cljs.core.sort.call(null,cljs.core.compare,cljs.core.conj.call(null,acc,x));
} else {
if((cljs.core.compare.call(null,x,cljs.core.last.call(null,acc)) < (0))){
return cljs.core.sort.call(null,cljs.core.compare,cljs.core.conj.call(null,cljs.core.butlast.call(null,acc),x));
} else {
return acc;

}
}
}),cljs.core.PersistentVector.EMPTY,coll));
});
G__95360 = function(n,coll){
switch(arguments.length){
case 1:
return G__95360__1.call(this,n);
case 2:
return G__95360__2.call(this,n,coll);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
G__95360.cljs$core$IFn$_invoke$arity$1 = G__95360__1;
G__95360.cljs$core$IFn$_invoke$arity$2 = G__95360__2;
return G__95360;
})()
,(function (n){
if(cljs.core._EQ_.call(null,n,(n | (0)))){
return n;
} else {
if((n > (0))){
return ((n | (0)) + (1));
} else {
if((n < (0))){
return (n | (0));
} else {
return null;
}
}
}
}),(function() {
var G__95361 = null;
var G__95361__1 = (function (coll){
return cljs.core.reduce.call(null,(function (acc,x){
if((cljs.core.compare.call(null,x,acc) > (0))){
return x;
} else {
return acc;
}
}),cljs.core.first.call(null,coll),cljs.core.next.call(null,coll));
});
var G__95361__2 = (function (n,coll){
return cljs.core.vec.call(null,cljs.core.reduce.call(null,(function (acc,x){
if((cljs.core.count.call(null,acc) < n)){
return cljs.core.sort.call(null,cljs.core.compare,cljs.core.conj.call(null,acc,x));
} else {
if((cljs.core.compare.call(null,x,cljs.core.first.call(null,acc)) > (0))){
return cljs.core.sort.call(null,cljs.core.compare,cljs.core.conj.call(null,cljs.core.next.call(null,acc),x));
} else {
return acc;

}
}
}),cljs.core.PersistentVector.EMPTY,coll));
});
G__95361 = function(n,coll){
switch(arguments.length){
case 1:
return G__95361__1.call(this,n);
case 2:
return G__95361__2.call(this,n,coll);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
G__95361.cljs$core$IFn$_invoke$arity$1 = G__95361__1;
G__95361.cljs$core$IFn$_invoke$arity$2 = G__95361__2;
return G__95361;
})()
,(function (coll){
return cljs.core.count.call(null,cljs.core.distinct.call(null,coll));
}),avg,(function (n){
if(cljs.core._EQ_.call(null,n,(n | (0)))){
return n;
} else {
if((n > (0))){
return (n | (0));
} else {
if((n < (0))){
return ((n | (0)) - (1));
} else {
return null;
}
}
}
}),cljs.core.str,stddev,(function() {
var G__95362 = null;
var G__95362__1 = (function (coll){
return cljs.core.rand_nth.call(null,coll);
});
var G__95362__2 = (function (n,coll){
return cljs.core.vec.call(null,cljs.core.repeatedly.call(null,n,(function (){
return cljs.core.rand_nth.call(null,coll);
})));
});
G__95362 = function(n,coll){
switch(arguments.length){
case 1:
return G__95362__1.call(this,n);
case 2:
return G__95362__2.call(this,n,coll);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
G__95362.cljs$core$IFn$_invoke$arity$1 = G__95362__1;
G__95362.cljs$core$IFn$_invoke$arity$2 = G__95362__2;
return G__95362;
})()
,(function (n,coll){
return cljs.core.vec.call(null,cljs.core.take.call(null,n,cljs.core.shuffle.call(null,coll)));
})]);
})();
fluree.db.query.analytical.aggregate_QMARK_ = (function fluree$db$query$analytical$aggregate_QMARK_(x){
var and__4120__auto__ = typeof x === 'string';
if(and__4120__auto__){
return cljs.core.re_matches.call(null,/^\(.+\)$/,x);
} else {
return and__4120__auto__;
}
});
fluree.db.query.analytical.interm_aggregate_QMARK_ = (function fluree$db$query$analytical$interm_aggregate_QMARK_(x){
var and__4120__auto__ = typeof x === 'string';
if(and__4120__auto__){
return cljs.core.re_matches.call(null,/^#\(.+\)$/,x);
} else {
return and__4120__auto__;
}
});
fluree.db.query.analytical.parse_aggregate = (function fluree$db$query$analytical$parse_aggregate(x,valid_var){
var list_agg = cljs.reader.read_string.call(null,x);
var as_QMARK_ = cljs.core._EQ_.call(null,new cljs.core.Symbol(null,"as","as",-1505746128,null),cljs.core.first.call(null,list_agg));
var as = ((as_QMARK_)?cljs.core.first.call(null,list_agg):cljs.core.symbol.call(null,cljs.core.str.cljs$core$IFn$_invoke$arity$1(list_agg)));
var func_list = ((as_QMARK_)?(function (){var func_list = cljs.core.second.call(null,list_agg);
if(cljs.core.coll_QMARK_.call(null,func_list)){
return func_list;
} else {
throw cljs.core.ex_info.call(null,["Invalid aggregate selection. As can only be used in conjunction with other functions. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null));
}
})():list_agg);
var list_count = cljs.core.count.call(null,func_list);
var vec__95363 = ((cljs.core._EQ_.call(null,(3),list_count))?new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.first.call(null,func_list),cljs.core.second.call(null,func_list),cljs.core.last.call(null,func_list)], null):((((cljs.core._EQ_.call(null,(2),list_count)) && (cljs.core._EQ_.call(null,new cljs.core.Symbol(null,"sample","sample",1719555128,null),cljs.core.first.call(null,func_list)))))?(function(){throw cljs.core.ex_info.call(null,["The sample aggregate function takes two arguments: n and a variable, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null))})():((cljs.core._EQ_.call(null,(2),list_count))?new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.first.call(null,func_list),null,cljs.core.last.call(null,func_list)], null):(function(){throw cljs.core.ex_info.call(null,["Invalid aggregate selection, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null))})()
)));
var fun = cljs.core.nth.call(null,vec__95363,(0),null);
var arg = cljs.core.nth.call(null,vec__95363,(1),null);
var var$ = cljs.core.nth.call(null,vec__95363,(2),null);
var agg_fn = (function (){var temp__5733__auto__ = fluree.db.query.analytical.built_in_aggregates.call(null,fun);
if(cljs.core.truth_(temp__5733__auto__)){
var agg_fn = temp__5733__auto__;
if(cljs.core.truth_(arg)){
return ((function (agg_fn,temp__5733__auto__,list_agg,as_QMARK_,as,func_list,list_count,vec__95363,fun,arg,var$){
return (function (coll){
return agg_fn.call(null,arg,coll);
});
;})(agg_fn,temp__5733__auto__,list_agg,as_QMARK_,as,func_list,list_count,vec__95363,fun,arg,var$))
} else {
return agg_fn;
}
} else {
throw cljs.core.ex_info.call(null,["Invalid aggregate selection function, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null));
}
})();
var vec__95366 = (function (){var distinct_QMARK_ = ((cljs.core.coll_QMARK_.call(null,var$)) && (cljs.core._EQ_.call(null,cljs.core.first.call(null,var$),new cljs.core.Symbol(null,"distinct","distinct",-148347594,null))));
var variable = ((distinct_QMARK_)?cljs.core.second.call(null,var$):var$);
var agg_fn__$1 = ((distinct_QMARK_)?((function (distinct_QMARK_,variable,list_agg,as_QMARK_,as,func_list,list_count,vec__95363,fun,arg,var$,agg_fn){
return (function (coll){
return agg_fn.call(null,cljs.core.distinct.call(null,coll));
});})(distinct_QMARK_,variable,list_agg,as_QMARK_,as,func_list,list_count,vec__95363,fun,arg,var$,agg_fn))
:agg_fn);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [agg_fn__$1,variable], null);
})();
var agg_fn__$1 = cljs.core.nth.call(null,vec__95366,(0),null);
var variable = cljs.core.nth.call(null,vec__95366,(1),null);
var _ = (cljs.core.truth_(valid_var.call(null,variable))?null:(function(){throw cljs.core.ex_info.call(null,["Invalid select variable in aggregate select, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(x)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null))})());
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"variable","variable",-281346492),variable,new cljs.core.Keyword(null,"as","as",1148689641),as,new cljs.core.Keyword(null,"code","code",1586293142),agg_fn__$1], null);
});
fluree.db.query.analytical.calculate_aggregate = (function fluree$db$query$analytical$calculate_aggregate(res,agg){
var map__95369 = agg;
var map__95369__$1 = (((((!((map__95369 == null))))?(((((map__95369.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__95369.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__95369):map__95369);
var variable = cljs.core.get.call(null,map__95369__$1,new cljs.core.Keyword(null,"variable","variable",-281346492));
var as = cljs.core.get.call(null,map__95369__$1,new cljs.core.Keyword(null,"as","as",1148689641));
var code = cljs.core.get.call(null,map__95369__$1,new cljs.core.Keyword(null,"code","code",1586293142));
var agg_params = cljs.core.flatten.call(null,fluree.db.query.analytical.select_from_tuples.call(null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [variable], null),res));
var agg_result = code.call(null,agg_params);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [as,agg_result], null);
});
fluree.db.query.analytical.add_aggregate_cols = (function fluree$db$query$analytical$add_aggregate_cols(res,aggregate){
return cljs.core.reduce.call(null,(function (res__$1,agg){
var vec__95372 = fluree.db.query.analytical.calculate_aggregate.call(null,res__$1,agg);
var as = cljs.core.nth.call(null,vec__95372,(0),null);
var agg_result = cljs.core.nth.call(null,vec__95372,(1),null);
var map__95375 = res__$1;
var map__95375__$1 = (((((!((map__95375 == null))))?(((((map__95375.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__95375.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__95375):map__95375);
var headers = cljs.core.get.call(null,map__95375__$1,new cljs.core.Keyword(null,"headers","headers",-835030129));
var tuples = cljs.core.get.call(null,map__95375__$1,new cljs.core.Keyword(null,"tuples","tuples",-676032639));
var tuples_SINGLEQUOTE_ = cljs.core.map.call(null,((function (vec__95372,as,agg_result,map__95375,map__95375__$1,headers,tuples){
return (function (p1__95371_SHARP_){
return cljs.core.conj.call(null,cljs.core.vec.call(null,p1__95371_SHARP_),agg_result);
});})(vec__95372,as,agg_result,map__95375,map__95375__$1,headers,tuples))
,tuples);
var headers_SINGLEQUOTE_ = cljs.core.conj.call(null,cljs.core.vec.call(null,headers),as);
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"headers","headers",-835030129),headers_SINGLEQUOTE_,new cljs.core.Keyword(null,"tuples","tuples",-676032639),tuples_SINGLEQUOTE_], null);
}),res,aggregate);
});
fluree.db.query.analytical.symbolize_keys = (function fluree$db$query$analytical$symbolize_keys(q_map){
var keys = cljs.core.map.call(null,cljs.core.symbol,cljs.core.keys.call(null,q_map));
var vals = cljs.core.vals.call(null,q_map);
return cljs.core.zipmap.call(null,keys,vals);
});
/**
 * Given a single tuple from A, a-idxs, b-idxs, b-not-idxs, and b-tuples, return any tuples in b that match.
 */
fluree.db.query.analytical.find_match = (function fluree$db$query$analytical$find_match(a_tuple,a_idxs,b_tuples,b_idxs,b_not_idxs){
var a_tuple_part = cljs.core.map.call(null,(function (p1__95377_SHARP_){
return cljs.core.nth.call(null,a_tuple,p1__95377_SHARP_);
}),a_idxs);
return cljs.core.reduce.call(null,((function (a_tuple_part){
return (function (acc,b_tuple){
if(cljs.core._EQ_.call(null,a_tuple_part,cljs.core.map.call(null,((function (a_tuple_part){
return (function (p1__95378_SHARP_){
return cljs.core.nth.call(null,b_tuple,p1__95378_SHARP_);
});})(a_tuple_part))
,b_idxs))){
return cljs.core.conj.call(null,(function (){var or__4131__auto__ = acc;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.PersistentVector.EMPTY;
}
})(),cljs.core.concat.call(null,a_tuple,cljs.core.map.call(null,((function (a_tuple_part){
return (function (p1__95379_SHARP_){
return cljs.core.nth.call(null,b_tuple,p1__95379_SHARP_);
});})(a_tuple_part))
,b_not_idxs)));
} else {
return acc;
}
});})(a_tuple_part))
,null,b_tuples);
});
/**
 * Given a single tuple from A, a-idxs, b-idxs, b-not-idxs, and b-tuples, return any tuples in b that match.
 *   Along with their row-numbers
 */
fluree.db.query.analytical.find_match_PLUS_row_nums = (function fluree$db$query$analytical$find_match_PLUS_row_nums(a_tuple,a_idxs,b_tuples,b_idxs,b_not_idxs){
var a_tuple_part = cljs.core.map.call(null,(function (p1__95380_SHARP_){
return cljs.core.nth.call(null,a_tuple,p1__95380_SHARP_);
}),a_idxs);
return cljs.core.reduce_kv.call(null,((function (a_tuple_part){
return (function (p__95383,row,b_tuple){
var vec__95384 = p__95383;
var acc = cljs.core.nth.call(null,vec__95384,(0),null);
var b_rows = cljs.core.nth.call(null,vec__95384,(1),null);
if(cljs.core._EQ_.call(null,a_tuple_part,cljs.core.map.call(null,((function (vec__95384,acc,b_rows,a_tuple_part){
return (function (p1__95381_SHARP_){
return cljs.core.nth.call(null,b_tuple,p1__95381_SHARP_);
});})(vec__95384,acc,b_rows,a_tuple_part))
,b_idxs))){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.conj.call(null,(function (){var or__4131__auto__ = acc;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return cljs.core.PersistentVector.EMPTY;
}
})(),cljs.core.concat.call(null,a_tuple,cljs.core.map.call(null,((function (vec__95384,acc,b_rows,a_tuple_part){
return (function (p1__95382_SHARP_){
return cljs.core.nth.call(null,b_tuple,p1__95382_SHARP_);
});})(vec__95384,acc,b_rows,a_tuple_part))
,b_not_idxs))),cljs.core.conj.call(null,b_rows,row)], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [acc,b_rows], null);
}
});})(a_tuple_part))
,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [null,cljs.core.PersistentHashSet.EMPTY], null),cljs.core.into.call(null,cljs.core.PersistentVector.EMPTY,b_tuples));
});
fluree.db.query.analytical.inner_join = (function fluree$db$query$analytical$inner_join(a_res,b_res){
var common_keys = fluree.db.query.analytical.intersecting_keys_tuples.call(null,a_res,b_res);
var a_idxs = cljs.core.map.call(null,((function (common_keys){
return (function (p1__95387_SHARP_){
return fluree.db.util.core.index_of.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(a_res),p1__95387_SHARP_);
});})(common_keys))
,common_keys);
var b_idxs = cljs.core.map.call(null,((function (common_keys,a_idxs){
return (function (p1__95388_SHARP_){
return fluree.db.util.core.index_of.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_res),p1__95388_SHARP_);
});})(common_keys,a_idxs))
,common_keys);
var b_not_idxs = ((function (common_keys,a_idxs,b_idxs){
return (function (p1__95390_SHARP_){
return cljs.core.apply.call(null,cljs.core.vector,p1__95390_SHARP_);
});})(common_keys,a_idxs,b_idxs))
.call(null,clojure.set.difference.call(null,cljs.core.set.call(null,((function (common_keys,a_idxs,b_idxs){
return (function (p1__95389_SHARP_){
return cljs.core.range.call(null,(0),p1__95389_SHARP_);
});})(common_keys,a_idxs,b_idxs))
.call(null,cljs.core.count.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_res)))),cljs.core.set.call(null,b_idxs)));
var c_tuples = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,((function (common_keys,a_idxs,b_idxs,b_not_idxs){
return (function (a_tuple){
return fluree.db.query.analytical.find_match.call(null,a_tuple,a_idxs,new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(b_res),b_idxs,b_not_idxs);
});})(common_keys,a_idxs,b_idxs,b_not_idxs))
,new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(a_res)));
var c_headers = cljs.core.concat.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(a_res),cljs.core.map.call(null,((function (common_keys,a_idxs,b_idxs,b_not_idxs,c_tuples){
return (function (p1__95391_SHARP_){
return cljs.core.nth.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_res),p1__95391_SHARP_);
});})(common_keys,a_idxs,b_idxs,b_not_idxs,c_tuples))
,b_not_idxs));
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"headers","headers",-835030129),c_headers,new cljs.core.Keyword(null,"vars","vars",-2046957217),cljs.core.merge.call(null,new cljs.core.Keyword(null,"vars","vars",-2046957217).cljs$core$IFn$_invoke$arity$1(a_res),new cljs.core.Keyword(null,"vars","vars",-2046957217).cljs$core$IFn$_invoke$arity$1(b_res)),new cljs.core.Keyword(null,"tuples","tuples",-676032639),c_tuples], null);
});
/**
 * OPTIONAL clause is equivalent to a left outer join. If there are no matches in the b-tuples,
 *   we just return a 'match' where each element of the match from b-tuple is nil.
 */
fluree.db.query.analytical.left_outer_join = (function fluree$db$query$analytical$left_outer_join(a_tuples,b_tuples){
var common_keys = fluree.db.query.analytical.intersecting_keys_tuples.call(null,a_tuples,b_tuples);
var a_idxs = cljs.core.map.call(null,((function (common_keys){
return (function (p1__95392_SHARP_){
return fluree.db.util.core.index_of.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(a_tuples),p1__95392_SHARP_);
});})(common_keys))
,common_keys);
var b_idxs = cljs.core.map.call(null,((function (common_keys,a_idxs){
return (function (p1__95393_SHARP_){
return fluree.db.util.core.index_of.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_tuples),p1__95393_SHARP_);
});})(common_keys,a_idxs))
,common_keys);
var b_not_idxs = ((function (common_keys,a_idxs,b_idxs){
return (function (p1__95395_SHARP_){
return cljs.core.apply.call(null,cljs.core.vector,p1__95395_SHARP_);
});})(common_keys,a_idxs,b_idxs))
.call(null,clojure.set.difference.call(null,cljs.core.set.call(null,((function (common_keys,a_idxs,b_idxs){
return (function (p1__95394_SHARP_){
return cljs.core.range.call(null,(0),p1__95394_SHARP_);
});})(common_keys,a_idxs,b_idxs))
.call(null,cljs.core.count.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_tuples)))),cljs.core.set.call(null,b_idxs)));
var c_tuples = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,((function (common_keys,a_idxs,b_idxs,b_not_idxs){
return (function (a_tuple){
var matches = fluree.db.query.analytical.find_match.call(null,a_tuple,a_idxs,new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(b_tuples),b_idxs,b_not_idxs);
var or__4131__auto__ = matches;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.concat.call(null,a_tuple,cljs.core.repeat.call(null,cljs.core.count.call(null,b_not_idxs),null))], null);
}
});})(common_keys,a_idxs,b_idxs,b_not_idxs))
,new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(a_tuples)));
var c_headers = cljs.core.concat.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(a_tuples),cljs.core.map.call(null,((function (common_keys,a_idxs,b_idxs,b_not_idxs,c_tuples){
return (function (p1__95396_SHARP_){
return cljs.core.nth.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_tuples),p1__95396_SHARP_);
});})(common_keys,a_idxs,b_idxs,b_not_idxs,c_tuples))
,b_not_idxs));
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"headers","headers",-835030129),c_headers,new cljs.core.Keyword(null,"vars","vars",-2046957217),cljs.core.merge.call(null,new cljs.core.Keyword(null,"vars","vars",-2046957217).cljs$core$IFn$_invoke$arity$1(a_tuples),new cljs.core.Keyword(null,"vars","vars",-2046957217).cljs$core$IFn$_invoke$arity$1(b_tuples)),new cljs.core.Keyword(null,"tuples","tuples",-676032639),c_tuples], null);
});
/**
 * UNION clause takes a left-hand side, which is inner-joined, and a right-hand side, which is inner-joined.
 *   Any tuples unbound by the other set are included.
 */
fluree.db.query.analytical.outer_union = (function fluree$db$query$analytical$outer_union(a_tuples,b_tuples){
var common_keys = fluree.db.query.analytical.intersecting_keys_tuples.call(null,a_tuples,b_tuples);
var a_idxs = cljs.core.map.call(null,((function (common_keys){
return (function (p1__95397_SHARP_){
return fluree.db.util.core.index_of.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(a_tuples),p1__95397_SHARP_);
});})(common_keys))
,common_keys);
var b_idxs = cljs.core.map.call(null,((function (common_keys,a_idxs){
return (function (p1__95398_SHARP_){
return fluree.db.util.core.index_of.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_tuples),p1__95398_SHARP_);
});})(common_keys,a_idxs))
,common_keys);
var b_not_idxs = ((function (common_keys,a_idxs,b_idxs){
return (function (p1__95400_SHARP_){
return cljs.core.apply.call(null,cljs.core.vector,p1__95400_SHARP_);
});})(common_keys,a_idxs,b_idxs))
.call(null,clojure.set.difference.call(null,cljs.core.set.call(null,((function (common_keys,a_idxs,b_idxs){
return (function (p1__95399_SHARP_){
return cljs.core.range.call(null,(0),p1__95399_SHARP_);
});})(common_keys,a_idxs,b_idxs))
.call(null,cljs.core.count.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_tuples)))),cljs.core.set.call(null,b_idxs)));
var vec__95403 = cljs.core.reduce.call(null,((function (common_keys,a_idxs,b_idxs,b_not_idxs){
return (function (p__95406,a_tuple){
var vec__95407 = p__95406;
var c_tuples = cljs.core.nth.call(null,vec__95407,(0),null);
var b_matched_rows = cljs.core.nth.call(null,vec__95407,(1),null);
var vec__95410 = fluree.db.query.analytical.find_match_PLUS_row_nums.call(null,a_tuple,a_idxs,new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(b_tuples),b_idxs,b_not_idxs);
var matches = cljs.core.nth.call(null,vec__95410,(0),null);
var matched_rows = cljs.core.nth.call(null,vec__95410,(1),null);
var matches__$1 = (function (){var or__4131__auto__ = matches;
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.concat.call(null,a_tuple,cljs.core.repeat.call(null,cljs.core.count.call(null,b_not_idxs),null))], null);
}
})();
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.concat.call(null,c_tuples,matches__$1),clojure.set.union.call(null,b_matched_rows,matched_rows)], null);
});})(common_keys,a_idxs,b_idxs,b_not_idxs))
,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.PersistentVector.EMPTY,cljs.core.PersistentHashSet.EMPTY], null),new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(a_tuples));
var c_tuples = cljs.core.nth.call(null,vec__95403,(0),null);
var b_matched_rows = cljs.core.nth.call(null,vec__95403,(1),null);
var b_unmatched_rows = cljs.core.remove.call(null,b_matched_rows,cljs.core.range.call(null,(0),cljs.core.count.call(null,new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(b_tuples))));
var c_headers = cljs.core.concat.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(a_tuples),cljs.core.map.call(null,((function (common_keys,a_idxs,b_idxs,b_not_idxs,vec__95403,c_tuples,b_matched_rows,b_unmatched_rows){
return (function (p1__95401_SHARP_){
return cljs.core.nth.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_tuples),p1__95401_SHARP_);
});})(common_keys,a_idxs,b_idxs,b_not_idxs,vec__95403,c_tuples,b_matched_rows,b_unmatched_rows))
,b_not_idxs));
var b_idxs__GT_c_idxs = cljs.core.map.call(null,((function (common_keys,a_idxs,b_idxs,b_not_idxs,vec__95403,c_tuples,b_matched_rows,b_unmatched_rows,c_headers){
return (function (p1__95402_SHARP_){
return fluree.db.util.core.index_of.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(b_tuples),p1__95402_SHARP_);
});})(common_keys,a_idxs,b_idxs,b_not_idxs,vec__95403,c_tuples,b_matched_rows,b_unmatched_rows,c_headers))
,c_headers);
var c_from_unmatched_b_tuples = cljs.core.map.call(null,((function (common_keys,a_idxs,b_idxs,b_not_idxs,vec__95403,c_tuples,b_matched_rows,b_unmatched_rows,c_headers,b_idxs__GT_c_idxs){
return (function (b_row){
var b_tuple = cljs.core.into.call(null,cljs.core.PersistentVector.EMPTY,cljs.core.nth.call(null,new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(b_tuples),b_row));
return cljs.core.map.call(null,((function (b_tuple,common_keys,a_idxs,b_idxs,b_not_idxs,vec__95403,c_tuples,b_matched_rows,b_unmatched_rows,c_headers,b_idxs__GT_c_idxs){
return (function (c_idx){
if((c_idx == null)){
return null;
} else {
return cljs.core.get.call(null,b_tuple,c_idx);
}
});})(b_tuple,common_keys,a_idxs,b_idxs,b_not_idxs,vec__95403,c_tuples,b_matched_rows,b_unmatched_rows,c_headers,b_idxs__GT_c_idxs))
,b_idxs__GT_c_idxs);
});})(common_keys,a_idxs,b_idxs,b_not_idxs,vec__95403,c_tuples,b_matched_rows,b_unmatched_rows,c_headers,b_idxs__GT_c_idxs))
,b_unmatched_rows);
var c_tuples__$1 = cljs.core.concat.call(null,c_tuples,c_from_unmatched_b_tuples);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"headers","headers",-835030129),c_headers,new cljs.core.Keyword(null,"vars","vars",-2046957217),cljs.core.merge.call(null,new cljs.core.Keyword(null,"vars","vars",-2046957217).cljs$core$IFn$_invoke$arity$1(a_tuples),new cljs.core.Keyword(null,"vars","vars",-2046957217).cljs$core$IFn$_invoke$arity$1(b_tuples)),new cljs.core.Keyword(null,"tuples","tuples",-676032639),c_tuples__$1], null);
});
fluree.db.query.analytical.tuples__GT_filter_required = (function fluree$db$query$analytical$tuples__GT_filter_required(headers,tuples,valid_vars,filter_code_req){
var filter_code_req_str = ["(and ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null," ",filter_code_req)),")"].join('');
var vec__95414 = (function (){var or__4131__auto__ = fluree.db.query.analytical_filter.valid_filter_QMARK_.call(null,filter_code_req_str,valid_vars);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
throw cljs.core.ex_info.call(null,["Invalid required filters, provided: ",filter_code_req_str].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null));
}
})();
var filter_code_req_STAR_ = cljs.core.nth.call(null,vec__95414,(0),null);
var _ = cljs.core.nth.call(null,vec__95414,(1),null);
var filter_code_req_str_STAR_ = cljs.core.str.cljs$core$IFn$_invoke$arity$1(filter_code_req_STAR_);
return cljs.core.filter.call(null,((function (filter_code_req_str,vec__95414,filter_code_req_STAR_,_,filter_code_req_str_STAR_){
return (function (p1__95413_SHARP_){
return fluree.db.query.analytical_filter.filter_row.call(null,headers,p1__95413_SHARP_,filter_code_req_str_STAR_);
});})(filter_code_req_str,vec__95414,filter_code_req_STAR_,_,filter_code_req_str_STAR_))
,tuples);
});
fluree.db.query.analytical.tuples__GT_filter_optional = (function fluree$db$query$analytical$tuples__GT_filter_optional(headers,tuples,valid_vars,filter_code_opts){
return cljs.core.reduce.call(null,(function (tuples__$1,filt){
var var_atom = cljs.core.atom.call(null,cljs.core.PersistentHashSet.EMPTY);
var vec__95419 = (function (){var or__4131__auto__ = fluree.db.query.analytical_filter.valid_filter_QMARK_.call(null,filt,valid_vars,var_atom);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
throw cljs.core.ex_info.call(null,["Invalid filter, provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(filt)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null));
}
})();
var filt_STAR_ = cljs.core.nth.call(null,vec__95419,(0),null);
var filt_vars = cljs.core.nth.call(null,vec__95419,(1),null);
var filt_str = cljs.core.str.cljs$core$IFn$_invoke$arity$1(filt_STAR_);
var filt_vars_idxs = cljs.core.map.call(null,((function (var_atom,vec__95419,filt_STAR_,filt_vars,filt_str){
return (function (p1__95417_SHARP_){
return fluree.db.util.core.index_of.call(null,headers,p1__95417_SHARP_);
});})(var_atom,vec__95419,filt_STAR_,filt_vars,filt_str))
,cljs.core.deref.call(null,filt_vars));
var filtered_tuples = cljs.core.reduce.call(null,((function (var_atom,vec__95419,filt_STAR_,filt_vars,filt_str,filt_vars_idxs){
return (function (acc,clause){
if(cljs.core.every_QMARK_.call(null,((function (var_atom,vec__95419,filt_STAR_,filt_vars,filt_str,filt_vars_idxs){
return (function (p1__95418_SHARP_){
return cljs.core.nth.call(null,clause,p1__95418_SHARP_);
});})(var_atom,vec__95419,filt_STAR_,filt_vars,filt_str,filt_vars_idxs))
,filt_vars_idxs)){
if(cljs.core.truth_(fluree.db.query.analytical_filter.filter_row.call(null,headers,clause,filt_str))){
return cljs.core.conj.call(null,acc,clause);
} else {
return acc;
}
} else {
return cljs.core.conj.call(null,acc,clause);
}
});})(var_atom,vec__95419,filt_STAR_,filt_vars,filt_str,filt_vars_idxs))
,cljs.core.PersistentVector.EMPTY,tuples__$1);
return filtered_tuples;
}),tuples,filter_code_opts);
});
fluree.db.query.analytical.tuples__GT_filtered = (function fluree$db$query$analytical$tuples__GT_filtered(p__95422,filters,optional_QMARK_){
var map__95423 = p__95422;
var map__95423__$1 = (((((!((map__95423 == null))))?(((((map__95423.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__95423.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__95423):map__95423);
var tuple_map = map__95423__$1;
var headers = cljs.core.get.call(null,map__95423__$1,new cljs.core.Keyword(null,"headers","headers",-835030129));
var vars = cljs.core.get.call(null,map__95423__$1,new cljs.core.Keyword(null,"vars","vars",-2046957217));
var tuples = cljs.core.get.call(null,map__95423__$1,new cljs.core.Keyword(null,"tuples","tuples",-676032639));
var valid_vars = cljs.core.set.call(null,headers);
var header_vec = cljs.core.into.call(null,cljs.core.PersistentVector.EMPTY,headers);
var _ = ((typeof filters === 'string')?(function(){throw cljs.core.ex_info.call(null,["Filter must be enclosed in square brackets. Provided: ",filters].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null))})():null);
if(cljs.core.truth_(optional_QMARK_)){
var res = new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"headers","headers",-835030129),headers,new cljs.core.Keyword(null,"vars","vars",-2046957217),vars,new cljs.core.Keyword(null,"tuples","tuples",-676032639),fluree.db.query.analytical.tuples__GT_filter_optional.call(null,header_vec,tuples,valid_vars,filters)], null);
return res;
} else {
var filter_code_req = fluree.db.query.analytical_filter.get_filters.call(null,filters,false);
var tuples__$1 = (cljs.core.truth_(cljs.core.not_empty.call(null,filter_code_req))?fluree.db.query.analytical.tuples__GT_filter_required.call(null,header_vec,tuples,valid_vars,filter_code_req):tuples);
var filter_code_opt = fluree.db.query.analytical_filter.get_filters.call(null,filters,true);
var tuples__$2 = (cljs.core.truth_(cljs.core.not_empty.call(null,filter_code_opt))?fluree.db.query.analytical.tuples__GT_filter_optional.call(null,header_vec,tuples__$1,valid_vars,filter_code_opt):tuples__$1);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"headers","headers",-835030129),headers,new cljs.core.Keyword(null,"vars","vars",-2046957217),vars,new cljs.core.Keyword(null,"tuples","tuples",-676032639),tuples__$2], null);
}
});
fluree.db.query.analytical.bind_clause__GT_vars = (function fluree$db$query$analytical$bind_clause__GT_vars(res,clause){
var vec__95425 = clause;
var k = cljs.core.nth.call(null,vec__95425,(0),null);
var v = cljs.core.nth.call(null,vec__95425,(1),null);
var k__$1 = fluree.db.query.analytical.variable_QMARK_.call(null,k);
var _ = (cljs.core.truth_(k__$1)?null:(function(){throw cljs.core.ex_info.call(null,["Invalid intermediate aggregate value. Provided: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clause)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-query","db/invalid-query",-1009699917)], null))})());
var map__95428 = res;
var map__95428__$1 = (((((!((map__95428 == null))))?(((((map__95428.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__95428.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__95428):map__95428);
var headers = cljs.core.get.call(null,map__95428__$1,new cljs.core.Keyword(null,"headers","headers",-835030129));
var vars = cljs.core.get.call(null,map__95428__$1,new cljs.core.Keyword(null,"vars","vars",-2046957217));
var var_value = (cljs.core.truth_(fluree.db.query.analytical.interm_aggregate_QMARK_.call(null,v))?cljs.core.second.call(null,fluree.db.query.analytical.calculate_aggregate.call(null,res,fluree.db.query.analytical.parse_aggregate.call(null,cljs.core.subs.call(null,v,(1)),cljs.core.set.call(null,(function (){var temp__5733__auto__ = cljs.core.keys.call(null,vars);
if(cljs.core.truth_(temp__5733__auto__)){
var valid_var = temp__5733__auto__;
return cljs.core.conj.call(null,headers,valid_var);
} else {
return headers;
}
})())))):v);
return cljs.core.PersistentArrayMap.createAsIfByAssoc([k__$1,var_value]);
});
fluree.db.query.analytical.optional__GT_left_outer_joins = (function fluree$db$query$analytical$optional__GT_left_outer_joins(db,q_map,optional_clauses,where_tuples,fuel,max_fuel,opts){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_95483){
var state_val_95484 = (state_95483[(1)]);
if((state_val_95484 === (7))){
var inst_95457 = (state_95483[(7)]);
var inst_95455 = (state_95483[(2)]);
var inst_95456 = fluree.db.util.async.throw_err.call(null,inst_95455);
var inst_95457__$1 = cljs.core.nth.call(null,inst_95456,(0),null);
var inst_95458 = cljs.core.nth.call(null,inst_95456,(1),null);
var inst_95459 = (inst_95457__$1 == null);
var state_95483__$1 = (function (){var statearr_95485 = state_95483;
(statearr_95485[(7)] = inst_95457__$1);

(statearr_95485[(8)] = inst_95458);

return statearr_95485;
})();
if(cljs.core.truth_(inst_95459)){
var statearr_95486_95514 = state_95483__$1;
(statearr_95486_95514[(1)] = (8));

} else {
var statearr_95487_95515 = state_95483__$1;
(statearr_95487_95515[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (1))){
var inst_95437 = cljs.core.seq.call(null,optional_clauses);
var inst_95438 = cljs.core.first.call(null,inst_95437);
var inst_95439 = cljs.core.next.call(null,inst_95437);
var inst_95440 = optional_clauses;
var inst_95441 = where_tuples;
var state_95483__$1 = (function (){var statearr_95488 = state_95483;
(statearr_95488[(9)] = inst_95438);

(statearr_95488[(10)] = inst_95439);

(statearr_95488[(11)] = inst_95441);

(statearr_95488[(12)] = inst_95440);

return statearr_95488;
})();
var statearr_95489_95516 = state_95483__$1;
(statearr_95489_95516[(2)] = null);

(statearr_95489_95516[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (4))){
var inst_95447 = (state_95483[(13)]);
var inst_95441 = (state_95483[(11)]);
var inst_95448 = (state_95483[(14)]);
var inst_95453 = fluree.db.query.analytical.clause__GT_tuples.call(null,db,q_map,inst_95441,inst_95447,inst_95448,true,fuel,max_fuel,opts);
var state_95483__$1 = state_95483;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95483__$1,(7),inst_95453);
} else {
if((state_val_95484 === (15))){
var state_95483__$1 = state_95483;
var statearr_95490_95517 = state_95483__$1;
(statearr_95490_95517[(2)] = null);

(statearr_95490_95517[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (13))){
var inst_95474 = (state_95483[(2)]);
var state_95483__$1 = state_95483;
var statearr_95491_95518 = state_95483__$1;
(statearr_95491_95518[(2)] = inst_95474);

(statearr_95491_95518[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (6))){
var inst_95479 = (state_95483[(2)]);
var state_95483__$1 = state_95483;
var statearr_95492_95519 = state_95483__$1;
(statearr_95492_95519[(2)] = inst_95479);

(statearr_95492_95519[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (3))){
var inst_95481 = (state_95483[(2)]);
var state_95483__$1 = state_95483;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_95483__$1,inst_95481);
} else {
if((state_val_95484 === (12))){
var state_95483__$1 = state_95483;
var statearr_95493_95520 = state_95483__$1;
(statearr_95493_95520[(1)] = (14));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (2))){
var inst_95447 = (state_95483[(13)]);
var inst_95440 = (state_95483[(12)]);
var inst_95446 = cljs.core.seq.call(null,inst_95440);
var inst_95447__$1 = cljs.core.first.call(null,inst_95446);
var inst_95448 = cljs.core.next.call(null,inst_95446);
var state_95483__$1 = (function (){var statearr_95495 = state_95483;
(statearr_95495[(13)] = inst_95447__$1);

(statearr_95495[(14)] = inst_95448);

return statearr_95495;
})();
if(cljs.core.truth_(inst_95447__$1)){
var statearr_95496_95521 = state_95483__$1;
(statearr_95496_95521[(1)] = (4));

} else {
var statearr_95497_95522 = state_95483__$1;
(statearr_95497_95522[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (11))){
var inst_95457 = (state_95483[(7)]);
var inst_95458 = (state_95483[(8)]);
var inst_95440 = inst_95458;
var inst_95441 = inst_95457;
var state_95483__$1 = (function (){var statearr_95498 = state_95483;
(statearr_95498[(11)] = inst_95441);

(statearr_95498[(12)] = inst_95440);

return statearr_95498;
})();
var statearr_95499_95523 = state_95483__$1;
(statearr_95499_95523[(2)] = null);

(statearr_95499_95523[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (9))){
var inst_95447 = (state_95483[(13)]);
var inst_95463 = new cljs.core.Keyword(null,"filter","filter",-948537934).cljs$core$IFn$_invoke$arity$1(inst_95447);
var state_95483__$1 = state_95483;
if(cljs.core.truth_(inst_95463)){
var statearr_95500_95524 = state_95483__$1;
(statearr_95500_95524[(1)] = (11));

} else {
var statearr_95501_95525 = state_95483__$1;
(statearr_95501_95525[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (5))){
var inst_95441 = (state_95483[(11)]);
var state_95483__$1 = state_95483;
var statearr_95502_95526 = state_95483__$1;
(statearr_95502_95526[(2)] = inst_95441);

(statearr_95502_95526[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (14))){
var inst_95457 = (state_95483[(7)]);
var inst_95441 = (state_95483[(11)]);
var inst_95458 = (state_95483[(8)]);
var inst_95468 = fluree.db.query.analytical.left_outer_join.call(null,inst_95441,inst_95457);
var inst_95440 = inst_95458;
var inst_95441__$1 = inst_95468;
var state_95483__$1 = (function (){var statearr_95503 = state_95483;
(statearr_95503[(11)] = inst_95441__$1);

(statearr_95503[(12)] = inst_95440);

return statearr_95503;
})();
var statearr_95504_95527 = state_95483__$1;
(statearr_95504_95527[(2)] = null);

(statearr_95504_95527[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (16))){
var inst_95472 = (state_95483[(2)]);
var state_95483__$1 = state_95483;
var statearr_95506_95528 = state_95483__$1;
(statearr_95506_95528[(2)] = inst_95472);

(statearr_95506_95528[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (10))){
var inst_95476 = (state_95483[(2)]);
var state_95483__$1 = state_95483;
var statearr_95507_95529 = state_95483__$1;
(statearr_95507_95529[(2)] = inst_95476);

(statearr_95507_95529[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95484 === (8))){
var inst_95441 = (state_95483[(11)]);
var inst_95458 = (state_95483[(8)]);
var tmp95505 = inst_95441;
var inst_95440 = inst_95458;
var inst_95441__$1 = tmp95505;
var state_95483__$1 = (function (){var statearr_95508 = state_95483;
(statearr_95508[(11)] = inst_95441__$1);

(statearr_95508[(12)] = inst_95440);

return statearr_95508;
})();
var statearr_95509_95530 = state_95483__$1;
(statearr_95509_95530[(2)] = null);

(statearr_95509_95530[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto__ = null;
var fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto____0 = (function (){
var statearr_95510 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_95510[(0)] = fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto__);

(statearr_95510[(1)] = (1));

return statearr_95510;
});
var fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto____1 = (function (state_95483){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_95483);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e95511){if((e95511 instanceof Object)){
var ex__86628__auto__ = e95511;
var statearr_95512_95531 = state_95483;
(statearr_95512_95531[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95483);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e95511;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__95532 = state_95483;
state_95483 = G__95532;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto__ = function(state_95483){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto____1.call(this,state_95483);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto____0;
fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto____1;
return fluree$db$query$analytical$optional__GT_left_outer_joins_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_95513 = f__86676__auto__.call(null);
(statearr_95513[(6)] = c__86675__auto__);

return statearr_95513;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.query.analytical.res_absorb_vars = (function fluree$db$query$analytical$res_absorb_vars(res){
return cljs.core.reduce.call(null,(function (acc,p__95534){
var vec__95535 = p__95534;
var var_name = cljs.core.nth.call(null,vec__95535,(0),null);
var var_val = cljs.core.nth.call(null,vec__95535,(1),null);
var tuples_SINGLEQUOTE_ = cljs.core.map.call(null,((function (vec__95535,var_name,var_val){
return (function (p1__95533_SHARP_){
return cljs.core.conj.call(null,p1__95533_SHARP_,var_val);
});})(vec__95535,var_name,var_val))
,new cljs.core.Keyword(null,"tuples","tuples",-676032639).cljs$core$IFn$_invoke$arity$1(res));
var headers_SINGLEQUOTE_ = cljs.core.conj.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(res),var_name);
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"tuples","tuples",-676032639),tuples_SINGLEQUOTE_,new cljs.core.Keyword(null,"headers","headers",-835030129),headers_SINGLEQUOTE_], null);
}),res,new cljs.core.Keyword(null,"vars","vars",-2046957217).cljs$core$IFn$_invoke$arity$1(res));
});
/**
 * Tuples and optional? are only used for Wikidata, because need to both limit calls to Wikidata,
 *   and ensure that returned results are as limited as possible (but still relevant).
 */
fluree.db.query.analytical.clause__GT_tuples = (function fluree$db$query$analytical$clause__GT_tuples(db,p__95539,p__95540,clause,r,optional_QMARK_,fuel,max_fuel,opts){
var map__95541 = p__95539;
var map__95541__$1 = (((((!((map__95541 == null))))?(((((map__95541.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__95541.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__95541):map__95541);
var q_map = map__95541__$1;
var prefixes = cljs.core.get.call(null,map__95541__$1,new cljs.core.Keyword(null,"prefixes","prefixes",1192472197));
var map__95542 = p__95540;
var map__95542__$1 = (((((!((map__95542 == null))))?(((((map__95542.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__95542.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__95542):map__95542);
var res = map__95542__$1;
var vars = cljs.core.get.call(null,map__95542__$1,new cljs.core.Keyword(null,"vars","vars",-2046957217));
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__,map__95541,map__95541__$1,q_map,prefixes,map__95542,map__95542__$1,res,vars){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__,map__95541,map__95541__$1,q_map,prefixes,map__95542,map__95542__$1,res,vars){
return (function (state_95747){
var state_val_95748 = (state_95747[(1)]);
if((state_val_95748 === (7))){
var inst_95743 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95749_95829 = state_95747__$1;
(statearr_95749_95829[(2)] = inst_95743);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95747__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (20))){
var inst_95576 = (state_95747[(7)]);
var inst_95587 = (state_95747[(8)]);
var inst_95552 = (state_95747[(9)]);
var inst_95588 = (state_95747[(10)]);
var inst_95580 = (state_95747[(11)]);
var inst_95581 = (state_95747[(12)]);
var inst_95578 = (state_95747[(13)]);
var inst_95579 = (state_95747[(14)]);
var inst_95592 = (state_95747[(2)]);
var inst_95593 = fluree.db.util.async.throw_err.call(null,inst_95592);
var inst_95594 = (function (){var new_res = inst_95593;
var first__95575 = inst_95578;
var rest = inst_95588;
var tuples = inst_95581;
var seq__95574 = inst_95579;
var seq__95584 = inst_95588;
var first__95585 = inst_95587;
var pred__95553 = cljs.core._EQ_;
var G__95572 = inst_95580;
var expr__95554 = inst_95552;
var vec__95573 = inst_95576;
var segment_type = inst_95552;
var clause_group = inst_95587;
var vec__95583 = inst_95580;
return ((function (new_res,first__95575,rest,tuples,seq__95574,seq__95584,first__95585,pred__95553,G__95572,expr__95554,vec__95573,segment_type,clause_group,vec__95583,inst_95576,inst_95587,inst_95552,inst_95588,inst_95580,inst_95581,inst_95578,inst_95579,inst_95592,inst_95593,state_val_95748,c__86675__auto__,map__95541,map__95541__$1,q_map,prefixes,map__95542,map__95542__$1,res,vars){
return (function (res__$1,var$){
return cljs.core.update.call(null,new_res,new cljs.core.Keyword(null,"var","var",-769682797),cljs.core.dissoc,var$);
});
;})(new_res,first__95575,rest,tuples,seq__95574,seq__95584,first__95585,pred__95553,G__95572,expr__95554,vec__95573,segment_type,clause_group,vec__95583,inst_95576,inst_95587,inst_95552,inst_95588,inst_95580,inst_95581,inst_95578,inst_95579,inst_95592,inst_95593,state_val_95748,c__86675__auto__,map__95541,map__95541__$1,q_map,prefixes,map__95542,map__95542__$1,res,vars))
})();
var inst_95595 = cljs.core.keys.call(null,vars);
var inst_95596 = cljs.core.reduce.call(null,inst_95594,inst_95593,inst_95595);
var inst_95597 = fluree.db.query.analytical.res_absorb_vars.call(null,inst_95596);
var state_95747__$1 = (function (){var statearr_95750 = state_95747;
(statearr_95750[(15)] = inst_95597);

return statearr_95750;
})();
if(cljs.core.truth_(inst_95581)){
var statearr_95751_95830 = state_95747__$1;
(statearr_95751_95830[(1)] = (21));

} else {
var statearr_95752_95831 = state_95747__$1;
(statearr_95752_95831[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (58))){
var inst_95717 = (state_95747[(16)]);
var inst_95720 = (state_95747[(2)]);
var inst_95721 = fluree.db.util.async.throw_err.call(null,inst_95720);
var inst_95722 = [inst_95721,r];
var inst_95723 = (new cljs.core.PersistentVector(null,2,(5),inst_95717,inst_95722,null));
var state_95747__$1 = state_95747;
var statearr_95753_95832 = state_95747__$1;
(statearr_95753_95832[(2)] = inst_95723);

(statearr_95753_95832[(1)] = (57));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (27))){
var inst_95628 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95629 = new cljs.core.Keyword(null,"filter","filter",-948537934).cljs$core$IFn$_invoke$arity$1(clause);
var inst_95630 = fluree.db.query.analytical.tuples__GT_filtered.call(null,res,inst_95629,optional_QMARK_);
var inst_95631 = [inst_95630,r];
var inst_95632 = (new cljs.core.PersistentVector(null,2,(5),inst_95628,inst_95631,null));
var state_95747__$1 = state_95747;
var statearr_95754_95833 = state_95747__$1;
(statearr_95754_95833[(2)] = inst_95632);

(statearr_95754_95833[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (1))){
var state_95747__$1 = state_95747;
var statearr_95755_95834 = state_95747__$1;
(statearr_95755_95834[(2)] = null);

(statearr_95755_95834[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (24))){
var inst_95552 = (state_95747[(9)]);
var inst_95616 = new cljs.core.Keyword(null,"bind","bind",-113428417).cljs$core$IFn$_invoke$arity$1(clause);
var inst_95617 = (function (){var segment_type = inst_95552;
var pred__95553 = cljs.core._EQ_;
var expr__95554 = inst_95552;
var bindings = inst_95616;
return ((function (segment_type,pred__95553,expr__95554,bindings,inst_95552,inst_95616,state_val_95748,c__86675__auto__,map__95541,map__95541__$1,q_map,prefixes,map__95542,map__95542__$1,res,vars){
return (function (p1__95538_SHARP_){
return fluree.db.query.analytical.bind_clause__GT_vars.call(null,res,p1__95538_SHARP_);
});
;})(segment_type,pred__95553,expr__95554,bindings,inst_95552,inst_95616,state_val_95748,c__86675__auto__,map__95541,map__95541__$1,q_map,prefixes,map__95542,map__95542__$1,res,vars))
})();
var inst_95618 = cljs.core.map.call(null,inst_95617,inst_95616);
var inst_95619 = cljs.core.PersistentHashMap.EMPTY;
var inst_95620 = cljs.core.into.call(null,inst_95619,inst_95618);
var inst_95621 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95622 = cljs.core.update.call(null,res,new cljs.core.Keyword(null,"vars","vars",-2046957217),cljs.core.merge,inst_95620);
var inst_95623 = [inst_95622,r];
var inst_95624 = (new cljs.core.PersistentVector(null,2,(5),inst_95621,inst_95623,null));
var state_95747__$1 = state_95747;
var statearr_95756_95835 = state_95747__$1;
(statearr_95756_95835[(2)] = inst_95624);

(statearr_95756_95835[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (55))){
var inst_95700 = (state_95747[(17)]);
var inst_95699 = (state_95747[(18)]);
var inst_95717 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95718 = fluree.db.query.analytical.fdb_clause__GT_tuples.call(null,inst_95699,res,inst_95700,fuel,max_fuel);
var state_95747__$1 = (function (){var statearr_95757 = state_95747;
(statearr_95757[(16)] = inst_95717);

return statearr_95757;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95747__$1,(58),inst_95718);
} else {
if((state_val_95748 === (39))){
var inst_95737 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95758_95836 = state_95747__$1;
(statearr_95758_95836[(2)] = inst_95737);

(statearr_95758_95836[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (46))){
var inst_95733 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95759_95837 = state_95747__$1;
(statearr_95759_95837[(2)] = inst_95733);

(statearr_95759_95837[(1)] = (43));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_95747,(3),Error,null,(2));
var inst_95549 = cljs.core.map_QMARK_.call(null,clause);
var state_95747__$1 = state_95747;
if(inst_95549){
var statearr_95760_95838 = state_95747__$1;
(statearr_95760_95838[(1)] = (5));

} else {
var statearr_95761_95839 = state_95747__$1;
(statearr_95761_95839[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (54))){
var inst_95728 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95762_95840 = state_95747__$1;
(statearr_95762_95840[(2)] = inst_95728);

(statearr_95762_95840[(1)] = (50));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (15))){
var inst_95587 = (state_95747[(8)]);
var inst_95580 = (state_95747[(11)]);
var inst_95586 = cljs.core.seq.call(null,inst_95580);
var inst_95587__$1 = cljs.core.first.call(null,inst_95586);
var inst_95588 = cljs.core.next.call(null,inst_95586);
var state_95747__$1 = (function (){var statearr_95763 = state_95747;
(statearr_95763[(8)] = inst_95587__$1);

(statearr_95763[(10)] = inst_95588);

return statearr_95763;
})();
if(cljs.core.truth_(inst_95587__$1)){
var statearr_95764_95841 = state_95747__$1;
(statearr_95764_95841[(1)] = (17));

} else {
var statearr_95765_95842 = state_95747__$1;
(statearr_95765_95842[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (48))){
var inst_95700 = (state_95747[(17)]);
var inst_95703 = fluree.db.query.analytical.wikidata__GT_tuples.call(null,q_map,inst_95700,r,res,optional_QMARK_,fuel,max_fuel);
var state_95747__$1 = state_95747;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95747__$1,(51),inst_95703);
} else {
if((state_val_95748 === (50))){
var inst_95730 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95766_95843 = state_95747__$1;
(statearr_95766_95843[(2)] = inst_95730);

(statearr_95766_95843[(1)] = (46));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (21))){
var inst_95588 = (state_95747[(10)]);
var inst_95581 = (state_95747[(12)]);
var inst_95597 = (state_95747[(15)]);
var inst_95599 = fluree.db.query.analytical.outer_union.call(null,inst_95581,inst_95597);
var inst_95580 = inst_95588;
var inst_95581__$1 = inst_95599;
var state_95747__$1 = (function (){var statearr_95767 = state_95747;
(statearr_95767[(11)] = inst_95580);

(statearr_95767[(12)] = inst_95581__$1);

return statearr_95767;
})();
var statearr_95768_95844 = state_95747__$1;
(statearr_95768_95844[(2)] = null);

(statearr_95768_95844[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (31))){
var inst_95657 = cljs.core.count.call(null,clause);
var inst_95658 = cljs.core._EQ_.call(null,(3),inst_95657);
var inst_95659 = cljs.core.second.call(null,clause);
var inst_95660 = cljs.core._EQ_.call(null,inst_95659,"rdf:type");
var inst_95661 = ((inst_95658) && (inst_95660));
var state_95747__$1 = state_95747;
if(cljs.core.truth_(inst_95661)){
var statearr_95769_95845 = state_95747__$1;
(statearr_95769_95845[(1)] = (33));

} else {
var statearr_95770_95846 = state_95747__$1;
(statearr_95770_95846[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (32))){
var inst_95741 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95771_95847 = state_95747__$1;
(statearr_95771_95847[(2)] = inst_95741);

(statearr_95771_95847[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (40))){
var inst_95674 = (state_95747[(19)]);
var inst_95677 = (state_95747[(2)]);
var inst_95678 = fluree.db.util.async.throw_err.call(null,inst_95677);
var inst_95679 = [inst_95678,r];
var inst_95680 = (new cljs.core.PersistentVector(null,2,(5),inst_95674,inst_95679,null));
var state_95747__$1 = state_95747;
var statearr_95772_95848 = state_95747__$1;
(statearr_95772_95848[(2)] = inst_95680);

(statearr_95772_95848[(1)] = (39));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (56))){
var state_95747__$1 = state_95747;
var statearr_95773_95849 = state_95747__$1;
(statearr_95773_95849[(2)] = null);

(statearr_95773_95849[(1)] = (57));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (33))){
var inst_95663 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95664 = fluree.db.query.analytical.collection__GT_tuples.call(null,db,res,clause);
var state_95747__$1 = (function (){var statearr_95774 = state_95747;
(statearr_95774[(20)] = inst_95663);

return statearr_95774;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95747__$1,(36),inst_95664);
} else {
if((state_val_95748 === (13))){
var inst_95552 = (state_95747[(9)]);
var inst_95614 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"bind","bind",-113428417),inst_95552);
var state_95747__$1 = state_95747;
if(inst_95614){
var statearr_95775_95850 = state_95747__$1;
(statearr_95775_95850[(1)] = (24));

} else {
var statearr_95776_95851 = state_95747__$1;
(statearr_95776_95851[(1)] = (25));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (22))){
var inst_95588 = (state_95747[(10)]);
var inst_95597 = (state_95747[(15)]);
var inst_95580 = inst_95588;
var inst_95581 = inst_95597;
var state_95747__$1 = (function (){var statearr_95777 = state_95747;
(statearr_95777[(11)] = inst_95580);

(statearr_95777[(12)] = inst_95581);

return statearr_95777;
})();
var statearr_95778_95852 = state_95747__$1;
(statearr_95778_95852[(2)] = null);

(statearr_95778_95852[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (36))){
var inst_95663 = (state_95747[(20)]);
var inst_95666 = (state_95747[(2)]);
var inst_95667 = fluree.db.util.async.throw_err.call(null,inst_95666);
var inst_95668 = [inst_95667,r];
var inst_95669 = (new cljs.core.PersistentVector(null,2,(5),inst_95663,inst_95668,null));
var state_95747__$1 = state_95747;
var statearr_95779_95853 = state_95747__$1;
(statearr_95779_95853[(2)] = inst_95669);

(statearr_95779_95853[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (41))){
var inst_95685 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95686 = fluree.db.query.analytical.bind_clause__GT_vars.call(null,res,clause);
var inst_95687 = cljs.core.update.call(null,res,new cljs.core.Keyword(null,"vars","vars",-2046957217),cljs.core.merge,inst_95686);
var inst_95688 = [inst_95687,r];
var inst_95689 = (new cljs.core.PersistentVector(null,2,(5),inst_95685,inst_95688,null));
var state_95747__$1 = state_95747;
var statearr_95780_95854 = state_95747__$1;
(statearr_95780_95854[(2)] = inst_95689);

(statearr_95780_95854[(1)] = (43));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (43))){
var inst_95735 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95781_95855 = state_95747__$1;
(statearr_95781_95855[(2)] = inst_95735);

(statearr_95781_95855[(1)] = (39));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (29))){
var inst_95638 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95782_95856 = state_95747__$1;
(statearr_95782_95856[(2)] = inst_95638);

(statearr_95782_95856[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (44))){
var inst_95695 = fluree.db.query.analytical.get_source_clause.call(null,db,clause,prefixes,opts);
var state_95747__$1 = state_95747;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95747__$1,(47),inst_95695);
} else {
if((state_val_95748 === (6))){
var inst_95646 = cljs.core.count.call(null,clause);
var inst_95647 = cljs.core._EQ_.call(null,(3),inst_95646);
var inst_95648 = cljs.core.second.call(null,clause);
var inst_95649 = clojure.string.starts_with_QMARK_.call(null,inst_95648,"fullText:");
var inst_95650 = ((inst_95647) && (inst_95649));
var state_95747__$1 = state_95747;
if(cljs.core.truth_(inst_95650)){
var statearr_95783_95857 = state_95747__$1;
(statearr_95783_95857[(1)] = (30));

} else {
var statearr_95784_95858 = state_95747__$1;
(statearr_95784_95858[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (28))){
var inst_95552 = (state_95747[(9)]);
var inst_95634 = ["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_95552)].join('');
var inst_95635 = (new Error(inst_95634));
var inst_95636 = (function(){throw inst_95635})();
var state_95747__$1 = state_95747;
var statearr_95785_95859 = state_95747__$1;
(statearr_95785_95859[(2)] = inst_95636);

(statearr_95785_95859[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (51))){
var inst_95705 = (state_95747[(2)]);
var inst_95706 = fluree.db.util.async.throw_err.call(null,inst_95705);
var state_95747__$1 = state_95747;
var statearr_95786_95860 = state_95747__$1;
(statearr_95786_95860[(2)] = inst_95706);

(statearr_95786_95860[(1)] = (50));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (25))){
var inst_95552 = (state_95747[(9)]);
var inst_95626 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"filter","filter",-948537934),inst_95552);
var state_95747__$1 = state_95747;
if(inst_95626){
var statearr_95787_95861 = state_95747__$1;
(statearr_95787_95861[(1)] = (27));

} else {
var statearr_95788_95862 = state_95747__$1;
(statearr_95788_95862[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (34))){
var inst_95671 = cljs.core.count.call(null,clause);
var inst_95672 = cljs.core._EQ_.call(null,(3),inst_95671);
var state_95747__$1 = state_95747;
if(inst_95672){
var statearr_95789_95863 = state_95747__$1;
(statearr_95789_95863[(1)] = (37));

} else {
var statearr_95790_95864 = state_95747__$1;
(statearr_95790_95864[(1)] = (38));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (17))){
var inst_95587 = (state_95747[(8)]);
var inst_95590 = fluree.db.query.analytical.resolve_where_clause.call(null,db,inst_95587,q_map,vars,fuel,max_fuel,opts);
var state_95747__$1 = state_95747;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95747__$1,(20),inst_95590);
} else {
if((state_val_95748 === (3))){
var inst_95545 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95791_95865 = state_95747__$1;
(statearr_95791_95865[(2)] = inst_95545);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95747__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (12))){
var inst_95576 = (state_95747[(7)]);
var inst_95576__$1 = new cljs.core.Keyword(null,"union","union",2142937499).cljs$core$IFn$_invoke$arity$1(clause);
var inst_95577 = cljs.core.seq.call(null,inst_95576__$1);
var inst_95578 = cljs.core.first.call(null,inst_95577);
var inst_95579 = cljs.core.next.call(null,inst_95577);
var inst_95580 = inst_95576__$1;
var inst_95581 = null;
var state_95747__$1 = (function (){var statearr_95792 = state_95747;
(statearr_95792[(7)] = inst_95576__$1);

(statearr_95792[(11)] = inst_95580);

(statearr_95792[(12)] = inst_95581);

(statearr_95792[(13)] = inst_95578);

(statearr_95792[(14)] = inst_95579);

return statearr_95792;
})();
var statearr_95793_95866 = state_95747__$1;
(statearr_95793_95866[(2)] = null);

(statearr_95793_95866[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (2))){
var inst_95745 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_95747__$1,inst_95745);
} else {
if((state_val_95748 === (23))){
var inst_95604 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95794_95867 = state_95747__$1;
(statearr_95794_95867[(2)] = inst_95604);

(statearr_95794_95867[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (47))){
var inst_95699 = (state_95747[(18)]);
var inst_95697 = (state_95747[(2)]);
var inst_95698 = fluree.db.util.async.throw_err.call(null,inst_95697);
var inst_95699__$1 = cljs.core.nth.call(null,inst_95698,(0),null);
var inst_95700 = cljs.core.nth.call(null,inst_95698,(1),null);
var inst_95701 = cljs.core._EQ_.call(null,"$wd",inst_95699__$1);
var state_95747__$1 = (function (){var statearr_95795 = state_95747;
(statearr_95795[(17)] = inst_95700);

(statearr_95795[(18)] = inst_95699__$1);

return statearr_95795;
})();
if(inst_95701){
var statearr_95796_95868 = state_95747__$1;
(statearr_95796_95868[(1)] = (48));

} else {
var statearr_95797_95869 = state_95747__$1;
(statearr_95797_95869[(1)] = (49));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (35))){
var inst_95739 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95798_95870 = state_95747__$1;
(statearr_95798_95870[(2)] = inst_95739);

(statearr_95798_95870[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (19))){
var inst_95610 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95799_95871 = state_95747__$1;
(statearr_95799_95871[(2)] = inst_95610);

(statearr_95799_95871[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (57))){
var inst_95726 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95800_95872 = state_95747__$1;
(statearr_95800_95872[(2)] = inst_95726);

(statearr_95800_95872[(1)] = (54));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (11))){
var inst_95558 = (state_95747[(21)]);
var inst_95562 = (state_95747[(2)]);
var inst_95563 = fluree.db.util.async.throw_err.call(null,inst_95562);
var inst_95564 = [inst_95563,r];
var inst_95565 = (new cljs.core.PersistentVector(null,2,(5),inst_95558,inst_95564,null));
var state_95747__$1 = state_95747;
var statearr_95801_95873 = state_95747__$1;
(statearr_95801_95873[(2)] = inst_95565);

(statearr_95801_95873[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (9))){
var inst_95552 = (state_95747[(9)]);
var inst_95567 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"union","union",2142937499),inst_95552);
var state_95747__$1 = state_95747;
if(inst_95567){
var statearr_95802_95874 = state_95747__$1;
(statearr_95802_95874[(1)] = (12));

} else {
var statearr_95803_95875 = state_95747__$1;
(statearr_95803_95875[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (5))){
var inst_95552 = (state_95747[(9)]);
var inst_95551 = cljs.core.keys.call(null,clause);
var inst_95552__$1 = cljs.core.first.call(null,inst_95551);
var inst_95556 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"optional","optional",2053951509),inst_95552__$1);
var state_95747__$1 = (function (){var statearr_95804 = state_95747;
(statearr_95804[(9)] = inst_95552__$1);

return statearr_95804;
})();
if(inst_95556){
var statearr_95805_95876 = state_95747__$1;
(statearr_95805_95876[(1)] = (8));

} else {
var statearr_95806_95877 = state_95747__$1;
(statearr_95806_95877[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (14))){
var inst_95642 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95807_95878 = state_95747__$1;
(statearr_95807_95878[(2)] = inst_95642);

(statearr_95807_95878[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (45))){
var state_95747__$1 = state_95747;
var statearr_95808_95879 = state_95747__$1;
(statearr_95808_95879[(2)] = null);

(statearr_95808_95879[(1)] = (46));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (53))){
var state_95747__$1 = state_95747;
var statearr_95809_95880 = state_95747__$1;
(statearr_95809_95880[(1)] = (55));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (26))){
var inst_95640 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95811_95881 = state_95747__$1;
(statearr_95811_95881[(2)] = inst_95640);

(statearr_95811_95881[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (16))){
var inst_95612 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95812_95882 = state_95747__$1;
(statearr_95812_95882[(2)] = inst_95612);

(statearr_95812_95882[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (38))){
var inst_95682 = cljs.core.count.call(null,clause);
var inst_95683 = cljs.core._EQ_.call(null,(2),inst_95682);
var state_95747__$1 = state_95747;
if(inst_95683){
var statearr_95813_95883 = state_95747__$1;
(statearr_95813_95883[(1)] = (41));

} else {
var statearr_95814_95884 = state_95747__$1;
(statearr_95814_95884[(1)] = (42));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (30))){
var inst_95652 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95653 = fluree.db.query.analytical.full_text__GT_tuples.call(null,db,res,clause);
var inst_95654 = [inst_95653,r];
var inst_95655 = (new cljs.core.PersistentVector(null,2,(5),inst_95652,inst_95654,null));
var state_95747__$1 = state_95747;
var statearr_95815_95885 = state_95747__$1;
(statearr_95815_95885[(2)] = inst_95655);

(statearr_95815_95885[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (10))){
var inst_95644 = (state_95747[(2)]);
var state_95747__$1 = state_95747;
var statearr_95816_95886 = state_95747__$1;
(statearr_95816_95886[(2)] = inst_95644);

(statearr_95816_95886[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (18))){
var inst_95581 = (state_95747[(12)]);
var inst_95606 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95607 = [inst_95581,r];
var inst_95608 = (new cljs.core.PersistentVector(null,2,(5),inst_95606,inst_95607,null));
var state_95747__$1 = state_95747;
var statearr_95817_95887 = state_95747__$1;
(statearr_95817_95887[(2)] = inst_95608);

(statearr_95817_95887[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (52))){
var inst_95700 = (state_95747[(17)]);
var inst_95699 = (state_95747[(18)]);
var inst_95711 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95712 = fluree.db.query.analytical.full_text__GT_tuples.call(null,inst_95699,res,inst_95700);
var inst_95713 = [inst_95712,r];
var inst_95714 = (new cljs.core.PersistentVector(null,2,(5),inst_95711,inst_95713,null));
var state_95747__$1 = state_95747;
var statearr_95818_95888 = state_95747__$1;
(statearr_95818_95888[(2)] = inst_95714);

(statearr_95818_95888[(1)] = (54));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (42))){
var state_95747__$1 = state_95747;
var statearr_95819_95889 = state_95747__$1;
(statearr_95819_95889[(1)] = (44));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95748 === (37))){
var inst_95674 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95675 = fluree.db.query.analytical.fdb_clause__GT_tuples.call(null,db,res,clause,fuel,max_fuel);
var state_95747__$1 = (function (){var statearr_95821 = state_95747;
(statearr_95821[(19)] = inst_95674);

return statearr_95821;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95747__$1,(40),inst_95675);
} else {
if((state_val_95748 === (8))){
var inst_95558 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_95559 = new cljs.core.Keyword(null,"optional","optional",2053951509).cljs$core$IFn$_invoke$arity$1(clause);
var inst_95560 = fluree.db.query.analytical.optional__GT_left_outer_joins.call(null,db,q_map,inst_95559,res,fuel,max_fuel,opts);
var state_95747__$1 = (function (){var statearr_95822 = state_95747;
(statearr_95822[(21)] = inst_95558);

return statearr_95822;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95747__$1,(11),inst_95560);
} else {
if((state_val_95748 === (49))){
var inst_95700 = (state_95747[(17)]);
var inst_95708 = cljs.core.second.call(null,inst_95700);
var inst_95709 = clojure.string.starts_with_QMARK_.call(null,inst_95708,"fullText:");
var state_95747__$1 = state_95747;
if(inst_95709){
var statearr_95823_95890 = state_95747__$1;
(statearr_95823_95890[(1)] = (52));

} else {
var statearr_95824_95891 = state_95747__$1;
(statearr_95824_95891[(1)] = (53));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__,map__95541,map__95541__$1,q_map,prefixes,map__95542,map__95542__$1,res,vars))
;
return ((function (switch__86624__auto__,c__86675__auto__,map__95541,map__95541__$1,q_map,prefixes,map__95542,map__95542__$1,res,vars){
return (function() {
var fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto__ = null;
var fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto____0 = (function (){
var statearr_95825 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_95825[(0)] = fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto__);

(statearr_95825[(1)] = (1));

return statearr_95825;
});
var fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto____1 = (function (state_95747){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_95747);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e95826){if((e95826 instanceof Object)){
var ex__86628__auto__ = e95826;
var statearr_95827_95892 = state_95747;
(statearr_95827_95892[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95747);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e95826;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__95893 = state_95747;
state_95747 = G__95893;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto__ = function(state_95747){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto____1.call(this,state_95747);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto____0;
fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto____1;
return fluree$db$query$analytical$clause__GT_tuples_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__,map__95541,map__95541__$1,q_map,prefixes,map__95542,map__95542__$1,res,vars))
})();
var state__86677__auto__ = (function (){var statearr_95828 = f__86676__auto__.call(null);
(statearr_95828[(6)] = c__86675__auto__);

return statearr_95828;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__,map__95541,map__95541__$1,q_map,prefixes,map__95542,map__95542__$1,res,vars))
);

return c__86675__auto__;
});
fluree.db.query.analytical.resolve_where_clause = (function fluree$db$query$analytical$resolve_where_clause(var_args){
var G__95895 = arguments.length;
switch (G__95895) {
case 6:
return fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
case 7:
return fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$7((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]),(arguments[(6)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$6 = (function (db,where,q_map,vars,fuel,max_fuel){
return fluree.db.query.analytical.resolve_where_clause.call(null,db,where,q_map,vars,fuel,max_fuel,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.analytical.resolve_where_clause.cljs$core$IFn$_invoke$arity$7 = (function (db,where,q_map,vars,fuel,max_fuel,opts){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_95971){
var state_val_95972 = (state_95971[(1)]);
if((state_val_95972 === (7))){
var inst_95921 = (state_95971[(7)]);
var inst_95915 = (state_95971[(8)]);
var inst_95922 = (state_95971[(9)]);
var inst_95927 = fluree.db.query.analytical.clause__GT_tuples.call(null,db,q_map,inst_95915,inst_95921,inst_95922,false,fuel,max_fuel,opts);
var state_95971__$1 = state_95971;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_95971__$1,(10),inst_95927);
} else {
if((state_val_95972 === (20))){
var inst_95932 = (state_95971[(10)]);
var inst_95915 = (state_95971[(8)]);
var tmp95973 = inst_95915;
var inst_95914 = inst_95932;
var inst_95915__$1 = tmp95973;
var state_95971__$1 = (function (){var statearr_95974 = state_95971;
(statearr_95974[(8)] = inst_95915__$1);

(statearr_95974[(11)] = inst_95914);

return statearr_95974;
})();
var statearr_95975_96015 = state_95971__$1;
(statearr_95975_96015[(2)] = null);

(statearr_95975_96015[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (1))){
var state_95971__$1 = state_95971;
var statearr_95976_96016 = state_95971__$1;
(statearr_95976_96016[(2)] = null);

(statearr_95976_96016[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (24))){
var state_95971__$1 = state_95971;
var statearr_95977_96017 = state_95971__$1;
(statearr_95977_96017[(2)] = null);

(statearr_95977_96017[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_95971,(3),Error,null,(2));
var inst_95907 = cljs.core.seq.call(null,where);
var inst_95908 = cljs.core.first.call(null,inst_95907);
var inst_95909 = cljs.core.next.call(null,inst_95907);
var inst_95910 = [new cljs.core.Keyword(null,"vars","vars",-2046957217)];
var inst_95911 = fluree.db.query.analytical.symbolize_keys.call(null,vars);
var inst_95912 = [inst_95911];
var inst_95913 = cljs.core.PersistentHashMap.fromArrays(inst_95910,inst_95912);
var inst_95914 = where;
var inst_95915 = inst_95913;
var state_95971__$1 = (function (){var statearr_95978 = state_95971;
(statearr_95978[(12)] = inst_95909);

(statearr_95978[(8)] = inst_95915);

(statearr_95978[(11)] = inst_95914);

(statearr_95978[(13)] = inst_95908);

return statearr_95978;
})();
var statearr_95979_96018 = state_95971__$1;
(statearr_95979_96018[(2)] = null);

(statearr_95979_96018[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (15))){
var inst_95931 = (state_95971[(14)]);
var inst_95947 = (inst_95931 == null);
var state_95971__$1 = state_95971;
if(cljs.core.truth_(inst_95947)){
var statearr_95980_96019 = state_95971__$1;
(statearr_95980_96019[(1)] = (20));

} else {
var statearr_95981_96020 = state_95971__$1;
(statearr_95981_96020[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (21))){
var state_95971__$1 = state_95971;
var statearr_95982_96021 = state_95971__$1;
(statearr_95982_96021[(1)] = (23));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (13))){
var inst_95962 = (state_95971[(2)]);
var state_95971__$1 = state_95971;
var statearr_95984_96022 = state_95971__$1;
(statearr_95984_96022[(2)] = inst_95962);

(statearr_95984_96022[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (22))){
var inst_95958 = (state_95971[(2)]);
var state_95971__$1 = state_95971;
var statearr_95985_96023 = state_95971__$1;
(statearr_95985_96023[(2)] = inst_95958);

(statearr_95985_96023[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (6))){
var inst_95967 = (state_95971[(2)]);
var state_95971__$1 = state_95971;
var statearr_95986_96024 = state_95971__$1;
(statearr_95986_96024[(2)] = inst_95967);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95971__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (25))){
var inst_95956 = (state_95971[(2)]);
var state_95971__$1 = state_95971;
var statearr_95987_96025 = state_95971__$1;
(statearr_95987_96025[(2)] = inst_95956);

(statearr_95987_96025[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (17))){
var inst_95931 = (state_95971[(14)]);
var state_95971__$1 = state_95971;
var statearr_95988_96026 = state_95971__$1;
(statearr_95988_96026[(2)] = inst_95931);

(statearr_95988_96026[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (3))){
var inst_95896 = (state_95971[(2)]);
var state_95971__$1 = state_95971;
var statearr_95989_96027 = state_95971__$1;
(statearr_95989_96027[(2)] = inst_95896);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95971__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (12))){
var inst_95915 = (state_95971[(8)]);
var inst_95938 = cljs.core.dissoc.call(null,inst_95915,new cljs.core.Keyword(null,"vars","vars",-2046957217));
var inst_95939 = cljs.core.empty_QMARK_.call(null,inst_95938);
var state_95971__$1 = state_95971;
if(inst_95939){
var statearr_95990_96028 = state_95971__$1;
(statearr_95990_96028[(1)] = (14));

} else {
var statearr_95991_96029 = state_95971__$1;
(statearr_95991_96029[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (2))){
var inst_95969 = (state_95971[(2)]);
var state_95971__$1 = state_95971;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_95971__$1,inst_95969);
} else {
if((state_val_95972 === (23))){
var inst_95932 = (state_95971[(10)]);
var inst_95915 = (state_95971[(8)]);
var inst_95931 = (state_95971[(14)]);
var inst_95952 = fluree.db.query.analytical.inner_join.call(null,inst_95915,inst_95931);
var inst_95914 = inst_95932;
var inst_95915__$1 = inst_95952;
var state_95971__$1 = (function (){var statearr_95992 = state_95971;
(statearr_95992[(8)] = inst_95915__$1);

(statearr_95992[(11)] = inst_95914);

return statearr_95992;
})();
var statearr_95993_96030 = state_95971__$1;
(statearr_95993_96030[(2)] = null);

(statearr_95993_96030[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (19))){
var inst_95932 = (state_95971[(10)]);
var inst_95944 = (state_95971[(2)]);
var inst_95914 = inst_95932;
var inst_95915 = inst_95944;
var state_95971__$1 = (function (){var statearr_95994 = state_95971;
(statearr_95994[(8)] = inst_95915);

(statearr_95994[(11)] = inst_95914);

return statearr_95994;
})();
var statearr_95995_96031 = state_95971__$1;
(statearr_95995_96031[(2)] = null);

(statearr_95995_96031[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (11))){
var inst_95932 = (state_95971[(10)]);
var inst_95931 = (state_95971[(14)]);
var inst_95914 = inst_95932;
var inst_95915 = inst_95931;
var state_95971__$1 = (function (){var statearr_95996 = state_95971;
(statearr_95996[(8)] = inst_95915);

(statearr_95996[(11)] = inst_95914);

return statearr_95996;
})();
var statearr_95997_96032 = state_95971__$1;
(statearr_95997_96032[(2)] = null);

(statearr_95997_96032[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (9))){
var inst_95965 = (state_95971[(2)]);
var state_95971__$1 = state_95971;
var statearr_95998_96033 = state_95971__$1;
(statearr_95998_96033[(2)] = inst_95965);

(statearr_95998_96033[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (5))){
var inst_95921 = (state_95971[(7)]);
var inst_95914 = (state_95971[(11)]);
var inst_95920 = cljs.core.seq.call(null,inst_95914);
var inst_95921__$1 = cljs.core.first.call(null,inst_95920);
var inst_95922 = cljs.core.next.call(null,inst_95920);
var state_95971__$1 = (function (){var statearr_95999 = state_95971;
(statearr_95999[(7)] = inst_95921__$1);

(statearr_95999[(9)] = inst_95922);

return statearr_95999;
})();
if(cljs.core.truth_(inst_95921__$1)){
var statearr_96000_96034 = state_95971__$1;
(statearr_96000_96034[(1)] = (7));

} else {
var statearr_96001_96035 = state_95971__$1;
(statearr_96001_96035[(1)] = (8));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (14))){
var inst_95931 = (state_95971[(14)]);
var state_95971__$1 = state_95971;
if(cljs.core.truth_(inst_95931)){
var statearr_96002_96036 = state_95971__$1;
(statearr_96002_96036[(1)] = (17));

} else {
var statearr_96003_96037 = state_95971__$1;
(statearr_96003_96037[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (16))){
var inst_95960 = (state_95971[(2)]);
var state_95971__$1 = state_95971;
var statearr_96004_96038 = state_95971__$1;
(statearr_96004_96038[(2)] = inst_95960);

(statearr_96004_96038[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (10))){
var inst_95921 = (state_95971[(7)]);
var inst_95929 = (state_95971[(2)]);
var inst_95930 = fluree.db.util.async.throw_err.call(null,inst_95929);
var inst_95931 = cljs.core.nth.call(null,inst_95930,(0),null);
var inst_95932 = cljs.core.nth.call(null,inst_95930,(1),null);
var inst_95933 = cljs.core.count.call(null,inst_95921);
var inst_95934 = cljs.core._EQ_.call(null,(2),inst_95933);
var state_95971__$1 = (function (){var statearr_96005 = state_95971;
(statearr_96005[(10)] = inst_95932);

(statearr_96005[(14)] = inst_95931);

return statearr_96005;
})();
if(inst_95934){
var statearr_96006_96039 = state_95971__$1;
(statearr_96006_96039[(1)] = (11));

} else {
var statearr_96007_96040 = state_95971__$1;
(statearr_96007_96040[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (18))){
var inst_95915 = (state_95971[(8)]);
var state_95971__$1 = state_95971;
var statearr_96008_96041 = state_95971__$1;
(statearr_96008_96041[(2)] = inst_95915);

(statearr_96008_96041[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_95972 === (8))){
var inst_95915 = (state_95971[(8)]);
var state_95971__$1 = state_95971;
var statearr_96009_96042 = state_95971__$1;
(statearr_96009_96042[(2)] = inst_95915);

(statearr_96009_96042[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$analytical$state_machine__86625__auto__ = null;
var fluree$db$query$analytical$state_machine__86625__auto____0 = (function (){
var statearr_96010 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_96010[(0)] = fluree$db$query$analytical$state_machine__86625__auto__);

(statearr_96010[(1)] = (1));

return statearr_96010;
});
var fluree$db$query$analytical$state_machine__86625__auto____1 = (function (state_95971){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_95971);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e96011){if((e96011 instanceof Object)){
var ex__86628__auto__ = e96011;
var statearr_96012_96043 = state_95971;
(statearr_96012_96043[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_95971);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e96011;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__96044 = state_95971;
state_95971 = G__96044;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical$state_machine__86625__auto__ = function(state_95971){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical$state_machine__86625__auto____1.call(this,state_95971);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$state_machine__86625__auto____0;
fluree$db$query$analytical$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$state_machine__86625__auto____1;
return fluree$db$query$analytical$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_96013 = f__86676__auto__.call(null);
(statearr_96013[(6)] = c__86675__auto__);

return statearr_96013;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.query.analytical.resolve_where_clause.cljs$lang$maxFixedArity = 7;

fluree.db.query.analytical.q = (function fluree$db$query$analytical$q(q_map,fuel,max_fuel,db,opts){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_96101){
var state_val_96102 = (state_96101[(1)]);
if((state_val_96102 === (7))){
var inst_96065 = (state_96101[(2)]);
var state_96101__$1 = state_96101;
if(cljs.core.truth_(inst_96065)){
var statearr_96103_96135 = state_96101__$1;
(statearr_96103_96135[(1)] = (11));

} else {
var statearr_96104_96136 = state_96101__$1;
(statearr_96104_96136[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (20))){
var inst_96089 = (state_96101[(7)]);
var state_96101__$1 = state_96101;
var statearr_96105_96137 = state_96101__$1;
(statearr_96105_96137[(2)] = inst_96089);

(statearr_96105_96137[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (1))){
var state_96101__$1 = state_96101;
var statearr_96106_96138 = state_96101__$1;
(statearr_96106_96138[(2)] = null);

(statearr_96106_96138[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_96101,(3),Error,null,(2));
var inst_96051 = (q_map == null);
var inst_96052 = cljs.core.not.call(null,inst_96051);
var state_96101__$1 = state_96101;
if(inst_96052){
var statearr_96107_96139 = state_96101__$1;
(statearr_96107_96139[(1)] = (5));

} else {
var statearr_96108_96140 = state_96101__$1;
(statearr_96108_96140[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (15))){
var inst_96073 = (state_96101[(8)]);
var inst_96078 = (state_96101[(9)]);
var inst_96080 = cljs.core.pr_str.call(null,q_map);
var inst_96081 = ["The query key: optional should be included in the 'where' array. The top-level 'optional' is being deprecated. Provided: ",inst_96080].join('');
var inst_96082 = fluree.db.util.log.warn.call(null,inst_96081);
var inst_96083 = fluree.db.query.analytical.optional__GT_left_outer_joins.call(null,db,q_map,inst_96073,inst_96078,fuel,max_fuel,opts);
var state_96101__$1 = (function (){var statearr_96109 = state_96101;
(statearr_96109[(10)] = inst_96082);

return statearr_96109;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_96101__$1,(18),inst_96083);
} else {
if((state_val_96102 === (21))){
var inst_96097 = (state_96101[(2)]);
var state_96101__$1 = state_96101;
var statearr_96110_96141 = state_96101__$1;
(statearr_96110_96141[(2)] = inst_96097);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_96101__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (13))){
var inst_96070 = (state_96101[(2)]);
var inst_96071 = cljs.core.get.call(null,inst_96070,new cljs.core.Keyword(null,"vars","vars",-2046957217));
var inst_96072 = cljs.core.get.call(null,inst_96070,new cljs.core.Keyword(null,"where","where",-2044795965));
var inst_96073 = cljs.core.get.call(null,inst_96070,new cljs.core.Keyword(null,"optional","optional",2053951509));
var inst_96074 = cljs.core.get.call(null,inst_96070,new cljs.core.Keyword(null,"filter","filter",-948537934));
var inst_96075 = fluree.db.query.analytical.resolve_where_clause.call(null,db,inst_96072,q_map,inst_96071,fuel,max_fuel,opts);
var state_96101__$1 = (function (){var statearr_96111 = state_96101;
(statearr_96111[(8)] = inst_96073);

(statearr_96111[(11)] = inst_96074);

return statearr_96111;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_96101__$1,(14),inst_96075);
} else {
if((state_val_96102 === (6))){
var state_96101__$1 = state_96101;
var statearr_96112_96142 = state_96101__$1;
(statearr_96112_96142[(2)] = false);

(statearr_96112_96142[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (17))){
var inst_96074 = (state_96101[(11)]);
var inst_96089 = (state_96101[(2)]);
var state_96101__$1 = (function (){var statearr_96113 = state_96101;
(statearr_96113[(7)] = inst_96089);

return statearr_96113;
})();
if(cljs.core.truth_(inst_96074)){
var statearr_96114_96143 = state_96101__$1;
(statearr_96114_96143[(1)] = (19));

} else {
var statearr_96115_96144 = state_96101__$1;
(statearr_96115_96144[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (3))){
var inst_96045 = (state_96101[(2)]);
var state_96101__$1 = state_96101;
var statearr_96116_96145 = state_96101__$1;
(statearr_96116_96145[(2)] = inst_96045);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_96101__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (12))){
var state_96101__$1 = state_96101;
var statearr_96117_96146 = state_96101__$1;
(statearr_96117_96146[(2)] = q_map);

(statearr_96117_96146[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (2))){
var inst_96099 = (state_96101[(2)]);
var state_96101__$1 = state_96101;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_96101__$1,inst_96099);
} else {
if((state_val_96102 === (19))){
var inst_96089 = (state_96101[(7)]);
var inst_96074 = (state_96101[(11)]);
var inst_96091 = cljs.core.pr_str.call(null,q_map);
var inst_96092 = ["The query key: filter should be included in the 'where' array. The top-level 'filter' is being deprecated. Provided: ",inst_96091].join('');
var inst_96093 = fluree.db.util.log.warn.call(null,inst_96092);
var inst_96094 = fluree.db.query.analytical.tuples__GT_filtered.call(null,inst_96089,inst_96074,null);
var state_96101__$1 = (function (){var statearr_96118 = state_96101;
(statearr_96118[(12)] = inst_96093);

return statearr_96118;
})();
var statearr_96119_96147 = state_96101__$1;
(statearr_96119_96147[(2)] = inst_96094);

(statearr_96119_96147[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (11))){
var inst_96067 = cljs.core.apply.call(null,cljs.core.hash_map,q_map);
var state_96101__$1 = state_96101;
var statearr_96120_96148 = state_96101__$1;
(statearr_96120_96148[(2)] = inst_96067);

(statearr_96120_96148[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (9))){
var state_96101__$1 = state_96101;
var statearr_96121_96149 = state_96101__$1;
(statearr_96121_96149[(2)] = false);

(statearr_96121_96149[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (5))){
var inst_96054 = q_map.cljs$lang$protocol_mask$partition0$;
var inst_96055 = (inst_96054 & (64));
var inst_96056 = q_map.cljs$core$ISeq$;
var inst_96057 = (cljs.core.PROTOCOL_SENTINEL === inst_96056);
var inst_96058 = ((inst_96055) || (inst_96057));
var state_96101__$1 = state_96101;
if(cljs.core.truth_(inst_96058)){
var statearr_96122_96150 = state_96101__$1;
(statearr_96122_96150[(1)] = (8));

} else {
var statearr_96123_96151 = state_96101__$1;
(statearr_96123_96151[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (14))){
var inst_96073 = (state_96101[(8)]);
var inst_96077 = (state_96101[(2)]);
var inst_96078 = fluree.db.util.async.throw_err.call(null,inst_96077);
var state_96101__$1 = (function (){var statearr_96124 = state_96101;
(statearr_96124[(9)] = inst_96078);

return statearr_96124;
})();
if(cljs.core.truth_(inst_96073)){
var statearr_96125_96152 = state_96101__$1;
(statearr_96125_96152[(1)] = (15));

} else {
var statearr_96126_96153 = state_96101__$1;
(statearr_96126_96153[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (16))){
var inst_96078 = (state_96101[(9)]);
var state_96101__$1 = state_96101;
var statearr_96127_96154 = state_96101__$1;
(statearr_96127_96154[(2)] = inst_96078);

(statearr_96127_96154[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (10))){
var inst_96062 = (state_96101[(2)]);
var state_96101__$1 = state_96101;
var statearr_96128_96155 = state_96101__$1;
(statearr_96128_96155[(2)] = inst_96062);

(statearr_96128_96155[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (18))){
var inst_96085 = (state_96101[(2)]);
var inst_96086 = fluree.db.util.async.throw_err.call(null,inst_96085);
var state_96101__$1 = state_96101;
var statearr_96129_96156 = state_96101__$1;
(statearr_96129_96156[(2)] = inst_96086);

(statearr_96129_96156[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_96102 === (8))){
var state_96101__$1 = state_96101;
var statearr_96130_96157 = state_96101__$1;
(statearr_96130_96157[(2)] = true);

(statearr_96130_96157[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$analytical$q_$_state_machine__86625__auto__ = null;
var fluree$db$query$analytical$q_$_state_machine__86625__auto____0 = (function (){
var statearr_96131 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_96131[(0)] = fluree$db$query$analytical$q_$_state_machine__86625__auto__);

(statearr_96131[(1)] = (1));

return statearr_96131;
});
var fluree$db$query$analytical$q_$_state_machine__86625__auto____1 = (function (state_96101){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_96101);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e96132){if((e96132 instanceof Object)){
var ex__86628__auto__ = e96132;
var statearr_96133_96158 = state_96101;
(statearr_96133_96158[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_96101);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e96132;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__96159 = state_96101;
state_96101 = G__96159;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$analytical$q_$_state_machine__86625__auto__ = function(state_96101){
switch(arguments.length){
case 0:
return fluree$db$query$analytical$q_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$analytical$q_$_state_machine__86625__auto____1.call(this,state_96101);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$analytical$q_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$analytical$q_$_state_machine__86625__auto____0;
fluree$db$query$analytical$q_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$analytical$q_$_state_machine__86625__auto____1;
return fluree$db$query$analytical$q_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_96134 = f__86676__auto__.call(null);
(statearr_96134[(6)] = c__86675__auto__);

return statearr_96134;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
