// Compiled by ClojureScript 1.10.520 {:target :nodejs}
goog.provide('fluree.db.query.range');
goog.require('cljs.core');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.constants');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.log');
goog.require('fluree.db.util.json');
goog.require('fluree.db.flake');
goog.require('cljs.core.async');
goog.require('fluree.db.util.async');
/**
 * Checks whether an index range is :spot, starts with [s1 -1 o1] and ends with [s1 int/max p1]
 */
fluree.db.query.range.value_with_nil_pred = (function fluree$db$query$range$value_with_nil_pred(idx,start_flake,end_flake){
return ((cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"spot","spot",-1706962147),idx)) && ((!((start_flake.o == null)))) && (cljs.core._EQ_.call(null,start_flake.o,end_flake.o)) && (cljs.core._EQ_.call(null,(-1),start_flake.p)) && (cljs.core._EQ_.call(null,fluree.db.flake.MAX_PREDICATE_ID,end_flake.p)));
});
/**
 * Will throw if predicate doesn't exist.
 */
fluree.db.query.range.pred_id_strict = (function fluree$db$query$range$pred_id_strict(db,p){
if(cljs.core.truth_(p)){
var or__4131__auto__ = fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),p);
if(cljs.core.truth_(or__4131__auto__)){
return or__4131__auto__;
} else {
throw cljs.core.ex_info.call(null,["Invalid predicate, does not exist: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(p)].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-predicate","db/invalid-predicate",1598480850)], null));
}
} else {
return null;
}
});
/**
 * Takes a match from index-range, and based on the index
 *   returns flake-ordered components of [s p o t op m].
 *   Coerces idents and string predicate names.
 */
fluree.db.query.range.match__GT_flake_parts = (function fluree$db$query$range$match__GT_flake_parts(db,idx,match){
var vec__88805 = match;
var p1 = cljs.core.nth.call(null,vec__88805,(0),null);
var p2 = cljs.core.nth.call(null,vec__88805,(1),null);
var p3 = cljs.core.nth.call(null,vec__88805,(2),null);
var t = cljs.core.nth.call(null,vec__88805,(3),null);
var op = cljs.core.nth.call(null,vec__88805,(4),null);
var m = cljs.core.nth.call(null,vec__88805,(5),null);
var G__88808 = idx;
var G__88808__$1 = (((G__88808 instanceof cljs.core.Keyword))?G__88808.fqn:null);
switch (G__88808__$1) {
case "spot":
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1,fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),p2),p3,t,op,m], null);

break;
case "psot":
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [p2,fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),p1),p3,t,op,m], null);

break;
case "post":
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [p3,fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),p1),p2,t,op,m], null);

break;
case "opst":
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [p3,fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),p2),p1,t,op,m], null);

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__88808__$1)].join('')));

}
});
fluree.db.query.range.subject_min_match = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [fluree.db.util.core.max_long], null);
fluree.db.query.range.subject_max_match = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [fluree.db.util.core.min_long], null);
fluree.db.query.range.pred_min_match = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0)], null);
fluree.db.query.range.pred_max_match = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [fluree.db.flake.MAX_PREDICATE_ID], null);
/**
 * Smallest index flake part match by index
 */
fluree.db.query.range.min_match = (function fluree$db$query$range$min_match(idx){
var G__88810 = idx;
var G__88810__$1 = (((G__88810 instanceof cljs.core.Keyword))?G__88810.fqn:null);
switch (G__88810__$1) {
case "spot":
return fluree.db.query.range.subject_min_match;

break;
case "psot":
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0)], null);

break;
case "post":
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0)], null);

break;
case "opst":
return fluree.db.query.range.subject_min_match;

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__88810__$1)].join('')));

}
});
/**
 * Smallest index flake part match by index
 */
fluree.db.query.range.max_match = (function fluree$db$query$range$max_match(idx){
var G__88812 = idx;
var G__88812__$1 = (((G__88812 instanceof cljs.core.Keyword))?G__88812.fqn:null);
switch (G__88812__$1) {
case "spot":
return fluree.db.query.range.subject_max_match;

break;
case "psot":
return fluree.db.query.range.pred_max_match;

break;
case "post":
return fluree.db.query.range.pred_max_match;

break;
case "opst":
return fluree.db.query.range.subject_max_match;

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__88812__$1)].join('')));

}
});
/**
 * Range query across an index.
 * 
 *   Uses a DB, but in the future support supplying a connection and db name, as we don't need a 't'
 * 
 *   Ranges take the natural numeric sort orders, but all results will
 *   return in reverse order (newest subjects and predicates first).
 * 
 *   Returns core async channel.
 * 
 *   opts:
 *   :from-t - start transaction (transaction 't' is negative, so smallest number is most recent). Defaults to db's t
 *   :to-t - stop transaction - can be null, which pulls full history
 *   :xform - xform applied to each result individually. This is not used when :chan is supplied.
 *   :limit - max number of flakes to return
 */
fluree.db.query.range.time_range = (function fluree$db$query$range$time_range(var_args){
var G__88815 = arguments.length;
switch (G__88815) {
case 2:
return fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
case 7:
return fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$7((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]),(arguments[(6)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$2 = (function (db,idx){
return fluree.db.query.range.time_range.call(null,db,idx,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$3 = (function (db,idx,opts){
return fluree.db.query.range.time_range.call(null,db,idx,cljs.core._GT__EQ_,fluree.db.query.range.min_match.call(null,idx),cljs.core._LT__EQ_,fluree.db.query.range.max_match.call(null,idx),opts);
});

fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$4 = (function (db,idx,test,match){
return fluree.db.query.range.time_range.call(null,db,idx,test,match,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$5 = (function (db,idx,test,match,opts){
var vec__88816 = (function (){var pred__88819 = cljs.core.identical_QMARK_;
var expr__88820 = test;
if(cljs.core.truth_(pred__88819.call(null,cljs.core._EQ_,expr__88820))){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core._GT__EQ_,match,cljs.core._LT__EQ_,match], null);
} else {
if(cljs.core.truth_(pred__88819.call(null,cljs.core._LT_,expr__88820))){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core._GT_,fluree.db.query.range.min_match.call(null,idx),cljs.core._LT_,match], null);
} else {
if(cljs.core.truth_(pred__88819.call(null,cljs.core._LT__EQ_,expr__88820))){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core._GT_,fluree.db.query.range.min_match.call(null,idx),cljs.core._LT__EQ_,match], null);
} else {
if(cljs.core.truth_(pred__88819.call(null,cljs.core._GT_,expr__88820))){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core._GT_,match,cljs.core._LT__EQ_,fluree.db.query.range.max_match.call(null,idx)], null);
} else {
if(cljs.core.truth_(pred__88819.call(null,cljs.core._GT__EQ_,expr__88820))){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core._GT__EQ_,match,cljs.core._LT_,fluree.db.query.range.max_match.call(null,idx)], null);
} else {
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(expr__88820)].join('')));
}
}
}
}
}
})();
var start_test = cljs.core.nth.call(null,vec__88816,(0),null);
var start_match = cljs.core.nth.call(null,vec__88816,(1),null);
var end_test = cljs.core.nth.call(null,vec__88816,(2),null);
var end_match = cljs.core.nth.call(null,vec__88816,(3),null);
return fluree.db.query.range.time_range.call(null,db,idx,start_test,start_match,end_test,end_match,opts);
});

fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$6 = (function (db,idx,start_test,start_match,end_test,end_match){
return fluree.db.query.range.time_range.call(null,db,idx,start_test,start_match,end_test,end_match,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.range.time_range.cljs$core$IFn$_invoke$arity$7 = (function (db,idx,start_test,start_match,end_test,end_match,opts){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_89030){
var state_val_89031 = (state_89030[(1)]);
if((state_val_89031 === (65))){
var inst_88991 = (state_89030[(7)]);
var inst_88984 = (state_89030[(8)]);
var inst_88983 = (state_89030[(9)]);
var inst_88998 = (inst_88983 + (1));
var tmp89032 = inst_88984;
var inst_88982 = inst_88991;
var inst_88983__$1 = inst_88998;
var inst_88984__$1 = tmp89032;
var state_89030__$1 = (function (){var statearr_89033 = state_89030;
(statearr_89033[(8)] = inst_88984__$1);

(statearr_89033[(10)] = inst_88982);

(statearr_89033[(9)] = inst_88983__$1);

return statearr_89033;
})();
var statearr_89034_89141 = state_89030__$1;
(statearr_89034_89141[(2)] = null);

(statearr_89034_89141[(1)] = (62));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (70))){
var inst_89005 = (state_89030[(11)]);
var state_89030__$1 = state_89030;
var statearr_89035_89142 = state_89030__$1;
(statearr_89035_89142[(2)] = inst_89005);

(statearr_89035_89142[(1)] = (72));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (62))){
var inst_88982 = (state_89030[(10)]);
var inst_88924 = (state_89030[(12)]);
var inst_88983 = (state_89030[(9)]);
var inst_88989 = cljs.core.seq.call(null,inst_88982);
var inst_88990 = cljs.core.first.call(null,inst_88989);
var inst_88991 = cljs.core.next.call(null,inst_88989);
var inst_88992 = (inst_88990 == null);
var inst_88993 = (inst_88983 > inst_88924);
var inst_88994 = ((inst_88992) || (inst_88993));
var state_89030__$1 = (function (){var statearr_89036 = state_89030;
(statearr_89036[(7)] = inst_88991);

return statearr_89036;
})();
if(cljs.core.truth_(inst_88994)){
var statearr_89037_89143 = state_89030__$1;
(statearr_89037_89143[(1)] = (64));

} else {
var statearr_89038_89144 = state_89030__$1;
(statearr_89038_89144[(1)] = (65));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (7))){
var inst_88840 = (state_89030[(13)]);
var inst_88854 = (state_89030[(2)]);
var inst_88855 = fluree.db.util.core.pred_ident_QMARK_.call(null,inst_88840);
var state_89030__$1 = (function (){var statearr_89039 = state_89030;
(statearr_89039[(14)] = inst_88854);

return statearr_89039;
})();
if(inst_88855){
var statearr_89040_89145 = state_89030__$1;
(statearr_89040_89145[(1)] = (9));

} else {
var statearr_89041_89146 = state_89030__$1;
(statearr_89041_89146[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (59))){
var inst_88951 = (state_89030[(15)]);
var inst_88924 = (state_89030[(12)]);
var inst_88965 = (state_89030[(16)]);
var inst_88952 = (state_89030[(17)]);
var inst_88968 = (inst_88924 - inst_88951);
var inst_88969 = fluree.db.flake.take.call(null,inst_88968,inst_88965);
var inst_88970 = cljs.core.into.call(null,inst_88969,inst_88952);
var state_89030__$1 = state_89030;
var statearr_89042_89147 = state_89030__$1;
(statearr_89042_89147[(2)] = inst_88970);

(statearr_89042_89147[(1)] = (61));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (20))){
var inst_88877 = (state_89030[(2)]);
var inst_88878 = fluree.db.util.async.throw_err.call(null,inst_88877);
var state_89030__$1 = state_89030;
var statearr_89043_89148 = state_89030__$1;
(statearr_89043_89148[(2)] = inst_88878);

(statearr_89043_89148[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (72))){
var inst_89024 = (state_89030[(2)]);
var state_89030__$1 = state_89030;
var statearr_89044_89149 = state_89030__$1;
(statearr_89044_89149[(2)] = inst_89024);

(statearr_89044_89149[(1)] = (54));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (58))){
var inst_88950 = (state_89030[(18)]);
var inst_88965 = (state_89030[(2)]);
var inst_88966 = fluree.db.dbproto._rhs.call(null,inst_88950);
var state_89030__$1 = (function (){var statearr_89045 = state_89030;
(statearr_89045[(19)] = inst_88966);

(statearr_89045[(16)] = inst_88965);

return statearr_89045;
})();
var statearr_89046_89150 = state_89030__$1;
(statearr_89046_89150[(1)] = (59));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (60))){
var inst_88951 = (state_89030[(15)]);
var inst_88965 = (state_89030[(16)]);
var inst_88979 = cljs.core.seq.call(null,inst_88965);
var inst_88980 = cljs.core.first.call(null,inst_88979);
var inst_88981 = cljs.core.next.call(null,inst_88979);
var inst_88982 = inst_88965;
var inst_88983 = inst_88951;
var inst_88984 = inst_88965;
var state_89030__$1 = (function (){var statearr_89048 = state_89030;
(statearr_89048[(8)] = inst_88984);

(statearr_89048[(20)] = inst_88981);

(statearr_89048[(10)] = inst_88982);

(statearr_89048[(9)] = inst_88983);

(statearr_89048[(21)] = inst_88980);

return statearr_89048;
})();
var statearr_89049_89151 = state_89030__$1;
(statearr_89049_89151[(2)] = null);

(statearr_89049_89151[(1)] = (62));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (27))){
var inst_88881 = (state_89030[(22)]);
var state_89030__$1 = state_89030;
var statearr_89050_89152 = state_89030__$1;
(statearr_89050_89152[(2)] = inst_88881);

(statearr_89050_89152[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (1))){
var state_89030__$1 = state_89030;
var statearr_89051_89153 = state_89030__$1;
(statearr_89051_89153[(2)] = null);

(statearr_89051_89153[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (69))){
var inst_89014 = (state_89030[(2)]);
var inst_89015 = cljs.core.not.call(null,inst_89014);
var state_89030__$1 = state_89030;
if(inst_89015){
var statearr_89052_89154 = state_89030__$1;
(statearr_89052_89154[(1)] = (70));

} else {
var statearr_89053_89155 = state_89030__$1;
(statearr_89053_89155[(1)] = (71));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (24))){
var state_89030__$1 = state_89030;
var statearr_89054_89156 = state_89030__$1;
(statearr_89054_89156[(2)] = (-1));

(statearr_89054_89156[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (55))){
var inst_88957 = (state_89030[(23)]);
var inst_88918 = (state_89030[(24)]);
var inst_88919 = (state_89030[(25)]);
var inst_88956 = (state_89030[(2)]);
var inst_88957__$1 = fluree.db.util.async.throw_err.call(null,inst_88956);
var inst_88958 = fluree.db.flake.subrange.call(null,inst_88957__$1,start_test,inst_88918,end_test,inst_88919);
var inst_88959 = fluree.db.query.range.value_with_nil_pred.call(null,idx,inst_88918,inst_88919);
var state_89030__$1 = (function (){var statearr_89055 = state_89030;
(statearr_89055[(26)] = inst_88958);

(statearr_89055[(23)] = inst_88957__$1);

return statearr_89055;
})();
if(inst_88959){
var statearr_89056_89157 = state_89030__$1;
(statearr_89056_89157[(1)] = (56));

} else {
var statearr_89057_89158 = state_89030__$1;
(statearr_89057_89158[(1)] = (57));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (39))){
var inst_88845 = (state_89030[(27)]);
var state_89030__$1 = state_89030;
var statearr_89058_89159 = state_89030__$1;
(statearr_89058_89159[(2)] = inst_88845);

(statearr_89058_89159[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (46))){
var state_89030__$1 = state_89030;
var statearr_89059_89160 = state_89030__$1;
(statearr_89059_89160[(2)] = fluree.db.util.core.max_long);

(statearr_89059_89160[(1)] = (47));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (4))){
var inst_88832 = (state_89030[(28)]);
var inst_88833 = (state_89030[(29)]);
var inst_88839 = (state_89030[(30)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_89030,(3),Error,null,(2));
var inst_88832__$1 = fluree.db.query.range.match__GT_flake_parts.call(null,db,idx,start_match);
var inst_88833__$1 = cljs.core.nth.call(null,inst_88832__$1,(0),null);
var inst_88834 = cljs.core.nth.call(null,inst_88832__$1,(1),null);
var inst_88835 = cljs.core.nth.call(null,inst_88832__$1,(2),null);
var inst_88836 = cljs.core.nth.call(null,inst_88832__$1,(3),null);
var inst_88837 = cljs.core.nth.call(null,inst_88832__$1,(4),null);
var inst_88838 = cljs.core.nth.call(null,inst_88832__$1,(5),null);
var inst_88839__$1 = fluree.db.query.range.match__GT_flake_parts.call(null,db,idx,end_match);
var inst_88840 = cljs.core.nth.call(null,inst_88839__$1,(0),null);
var inst_88841 = cljs.core.nth.call(null,inst_88839__$1,(1),null);
var inst_88842 = cljs.core.nth.call(null,inst_88839__$1,(2),null);
var inst_88843 = cljs.core.nth.call(null,inst_88839__$1,(3),null);
var inst_88844 = cljs.core.nth.call(null,inst_88839__$1,(4),null);
var inst_88845 = cljs.core.nth.call(null,inst_88839__$1,(5),null);
var inst_88846 = fluree.db.util.core.pred_ident_QMARK_.call(null,inst_88833__$1);
var state_89030__$1 = (function (){var statearr_89060 = state_89030;
(statearr_89060[(31)] = inst_88835);

(statearr_89060[(28)] = inst_88832__$1);

(statearr_89060[(13)] = inst_88840);

(statearr_89060[(32)] = inst_88838);

(statearr_89060[(33)] = inst_88844);

(statearr_89060[(29)] = inst_88833__$1);

(statearr_89060[(34)] = inst_88837);

(statearr_89060[(35)] = inst_88836);

(statearr_89060[(36)] = inst_88841);

(statearr_89060[(37)] = inst_88843);

(statearr_89060[(38)] = inst_88834);

(statearr_89060[(27)] = inst_88845);

(statearr_89060[(30)] = inst_88839__$1);

(statearr_89060[(39)] = inst_88842);

return statearr_89060;
})();
if(inst_88846){
var statearr_89061_89161 = state_89030__$1;
(statearr_89061_89161[(1)] = (5));

} else {
var statearr_89062_89162 = state_89030__$1;
(statearr_89062_89162[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (54))){
var inst_89026 = (state_89030[(2)]);
var state_89030__$1 = state_89030;
var statearr_89063_89163 = state_89030__$1;
(statearr_89063_89163[(2)] = inst_89026);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89030__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (15))){
var inst_88842 = (state_89030[(39)]);
var inst_88872 = (state_89030[(2)]);
var inst_88873 = fluree.db.util.core.pred_ident_QMARK_.call(null,inst_88842);
var state_89030__$1 = (function (){var statearr_89064 = state_89030;
(statearr_89064[(40)] = inst_88872);

return statearr_89064;
})();
if(inst_88873){
var statearr_89065_89164 = state_89030__$1;
(statearr_89065_89164[(1)] = (17));

} else {
var statearr_89066_89165 = state_89030__$1;
(statearr_89066_89165[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (48))){
var inst_88930 = (state_89030[(41)]);
var state_89030__$1 = state_89030;
var statearr_89067_89166 = state_89030__$1;
(statearr_89067_89166[(2)] = inst_88930);

(statearr_89067_89166[(1)] = (50));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (50))){
var inst_88935 = (state_89030[(2)]);
var inst_88936 = new cljs.core.Keyword(null,"to-t","to-t",569467359).cljs$core$IFn$_invoke$arity$1(opts);
var inst_88937 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_88938 = [new cljs.core.Keyword(null,"novelty","novelty",-1590246024),idx];
var inst_88939 = (new cljs.core.PersistentVector(null,2,(5),inst_88937,inst_88938,null));
var inst_88940 = cljs.core.get_in.call(null,db,inst_88939);
var inst_88941 = cljs.core.get.call(null,db,idx);
var inst_88942 = fluree.db.dbproto._resolve.call(null,inst_88941);
var state_89030__$1 = (function (){var statearr_89068 = state_89030;
(statearr_89068[(42)] = inst_88935);

(statearr_89068[(43)] = inst_88936);

(statearr_89068[(44)] = inst_88940);

return statearr_89068;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89030__$1,(51),inst_88942);
} else {
if((state_val_89031 === (21))){
var inst_88872 = (state_89030[(40)]);
var state_89030__$1 = state_89030;
var statearr_89069_89167 = state_89030__$1;
(statearr_89069_89167[(2)] = inst_88872);

(statearr_89069_89167[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (31))){
var inst_88841 = (state_89030[(36)]);
var state_89030__$1 = state_89030;
var statearr_89070_89168 = state_89030__$1;
(statearr_89070_89168[(2)] = inst_88841);

(statearr_89070_89168[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (32))){
var inst_88838 = (state_89030[(32)]);
var inst_88899 = (state_89030[(2)]);
var state_89030__$1 = (function (){var statearr_89071 = state_89030;
(statearr_89071[(45)] = inst_88899);

return statearr_89071;
})();
if(cljs.core.truth_(inst_88838)){
var statearr_89072_89169 = state_89030__$1;
(statearr_89072_89169[(1)] = (33));

} else {
var statearr_89073_89170 = state_89030__$1;
(statearr_89073_89170[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (40))){
var inst_88911 = (cljs.core._LT__EQ_ === end_test);
var state_89030__$1 = state_89030;
if(cljs.core.truth_(inst_88911)){
var statearr_89074_89171 = state_89030__$1;
(statearr_89074_89171[(1)] = (42));

} else {
var statearr_89075_89172 = state_89030__$1;
(statearr_89075_89172[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (56))){
var inst_88958 = (state_89030[(26)]);
var inst_88945 = (state_89030[(46)]);
var inst_88881 = (state_89030[(22)]);
var inst_88832 = (state_89030[(28)]);
var inst_88957 = (state_89030[(23)]);
var inst_88844 = (state_89030[(33)]);
var inst_88935 = (state_89030[(42)]);
var inst_88863 = (state_89030[(47)]);
var inst_88837 = (state_89030[(34)]);
var inst_88890 = (state_89030[(48)]);
var inst_88951 = (state_89030[(15)]);
var inst_88925 = (state_89030[(49)]);
var inst_88917 = (state_89030[(50)]);
var inst_88929 = (state_89030[(51)]);
var inst_88924 = (state_89030[(12)]);
var inst_88908 = (state_89030[(52)]);
var inst_88918 = (state_89030[(24)]);
var inst_88836 = (state_89030[(35)]);
var inst_88899 = (state_89030[(45)]);
var inst_88854 = (state_89030[(14)]);
var inst_88843 = (state_89030[(37)]);
var inst_88950 = (state_89030[(18)]);
var inst_88872 = (state_89030[(40)]);
var inst_88936 = (state_89030[(43)]);
var inst_88839 = (state_89030[(30)]);
var inst_88940 = (state_89030[(44)]);
var inst_88952 = (state_89030[(17)]);
var inst_88919 = (state_89030[(25)]);
var inst_88961 = (function (){var no_filter_QMARK_ = true;
var vec__88829 = inst_88839;
var next_node = inst_88950;
var flakes = inst_88957;
var s1 = inst_88854;
var o2 = inst_88881;
var t1 = inst_88836;
var i = inst_88951;
var m1 = inst_88908;
var root_node = inst_88945;
var to_t = inst_88936;
var s2 = inst_88863;
var p2 = inst_88899;
var permissions = inst_88925;
var vec__88826 = inst_88832;
var limit = inst_88924;
var start_flake = inst_88918;
var acc = inst_88952;
var t2 = inst_88843;
var op1 = inst_88837;
var o1 = inst_88872;
var end_flake = inst_88919;
var base_result = inst_88958;
var p1 = inst_88890;
var idx_compare = inst_88929;
var op2 = inst_88844;
var from_t = inst_88935;
var m2 = inst_88917;
var novelty = inst_88940;
return ((function (no_filter_QMARK_,vec__88829,next_node,flakes,s1,o2,t1,i,m1,root_node,to_t,s2,p2,permissions,vec__88826,limit,start_flake,acc,t2,op1,o1,end_flake,base_result,p1,idx_compare,op2,from_t,m2,novelty,inst_88958,inst_88945,inst_88881,inst_88832,inst_88957,inst_88844,inst_88935,inst_88863,inst_88837,inst_88890,inst_88951,inst_88925,inst_88917,inst_88929,inst_88924,inst_88908,inst_88918,inst_88836,inst_88899,inst_88854,inst_88843,inst_88950,inst_88872,inst_88936,inst_88839,inst_88940,inst_88952,inst_88919,state_val_89031,c__86675__auto__){
return (function (filtered_result,f){
if(cljs.core._EQ_.call(null,f.o,start_flake.o)){
return filtered_result;
} else {
return cljs.core.disj.call(null,filtered_result,f);
}
});
;})(no_filter_QMARK_,vec__88829,next_node,flakes,s1,o2,t1,i,m1,root_node,to_t,s2,p2,permissions,vec__88826,limit,start_flake,acc,t2,op1,o1,end_flake,base_result,p1,idx_compare,op2,from_t,m2,novelty,inst_88958,inst_88945,inst_88881,inst_88832,inst_88957,inst_88844,inst_88935,inst_88863,inst_88837,inst_88890,inst_88951,inst_88925,inst_88917,inst_88929,inst_88924,inst_88908,inst_88918,inst_88836,inst_88899,inst_88854,inst_88843,inst_88950,inst_88872,inst_88936,inst_88839,inst_88940,inst_88952,inst_88919,state_val_89031,c__86675__auto__))
})();
var inst_88962 = cljs.core.reduce.call(null,inst_88961,inst_88958,inst_88958);
var state_89030__$1 = state_89030;
var statearr_89076_89173 = state_89030__$1;
(statearr_89076_89173[(2)] = inst_88962);

(statearr_89076_89173[(1)] = (58));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (33))){
var inst_88838 = (state_89030[(32)]);
var state_89030__$1 = state_89030;
var statearr_89077_89174 = state_89030__$1;
(statearr_89077_89174[(2)] = inst_88838);

(statearr_89077_89174[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (13))){
var inst_88835 = (state_89030[(31)]);
var inst_88866 = fluree.db.dbproto._subid.call(null,db,inst_88835);
var state_89030__$1 = state_89030;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89030__$1,(16),inst_88866);
} else {
if((state_val_89031 === (22))){
var inst_88882 = (state_89030[(53)]);
var state_89030__$1 = state_89030;
var statearr_89078_89175 = state_89030__$1;
(statearr_89078_89175[(2)] = inst_88882);

(statearr_89078_89175[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (36))){
var state_89030__$1 = state_89030;
var statearr_89079_89176 = state_89030__$1;
(statearr_89079_89176[(2)] = fluree.db.util.core.min_integer);

(statearr_89079_89176[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (41))){
var inst_88881 = (state_89030[(22)]);
var inst_88920 = (state_89030[(54)]);
var inst_88844 = (state_89030[(33)]);
var inst_88863 = (state_89030[(47)]);
var inst_88837 = (state_89030[(34)]);
var inst_88890 = (state_89030[(48)]);
var inst_88917 = (state_89030[(50)]);
var inst_88908 = (state_89030[(52)]);
var inst_88836 = (state_89030[(35)]);
var inst_88899 = (state_89030[(45)]);
var inst_88854 = (state_89030[(14)]);
var inst_88843 = (state_89030[(37)]);
var inst_88872 = (state_89030[(40)]);
var inst_88917__$1 = (state_89030[(2)]);
var inst_88918 = fluree.db.flake.__GT_Flake.call(null,inst_88854,inst_88890,inst_88872,inst_88836,inst_88837,inst_88908);
var inst_88919 = fluree.db.flake.__GT_Flake.call(null,inst_88863,inst_88899,inst_88881,inst_88843,inst_88844,inst_88917__$1);
var inst_88920__$1 = new cljs.core.Keyword(null,"limit","limit",-1355822363).cljs$core$IFn$_invoke$arity$1(opts);
var state_89030__$1 = (function (){var statearr_89080 = state_89030;
(statearr_89080[(54)] = inst_88920__$1);

(statearr_89080[(50)] = inst_88917__$1);

(statearr_89080[(24)] = inst_88918);

(statearr_89080[(25)] = inst_88919);

return statearr_89080;
})();
if(cljs.core.truth_(inst_88920__$1)){
var statearr_89081_89177 = state_89030__$1;
(statearr_89081_89177[(1)] = (45));

} else {
var statearr_89082_89178 = state_89030__$1;
(statearr_89082_89178[(1)] = (46));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (43))){
var state_89030__$1 = state_89030;
var statearr_89083_89179 = state_89030__$1;
(statearr_89083_89179[(2)] = fluree.db.util.core.min_integer);

(statearr_89083_89179[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (61))){
var inst_88966 = (state_89030[(19)]);
var inst_89005 = (state_89030[(11)]);
var inst_89005__$1 = (state_89030[(2)]);
var inst_89006 = cljs.core.count.call(null,inst_89005__$1);
var state_89030__$1 = (function (){var statearr_89084 = state_89030;
(statearr_89084[(11)] = inst_89005__$1);

(statearr_89084[(55)] = inst_89006);

return statearr_89084;
})();
if(cljs.core.truth_(inst_88966)){
var statearr_89085_89180 = state_89030__$1;
(statearr_89085_89180[(1)] = (67));

} else {
var statearr_89086_89181 = state_89030__$1;
(statearr_89086_89181[(1)] = (68));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (29))){
var inst_88895 = (state_89030[(2)]);
var state_89030__$1 = state_89030;
if(cljs.core.truth_(inst_88895)){
var statearr_89087_89182 = state_89030__$1;
(statearr_89087_89182[(1)] = (30));

} else {
var statearr_89088_89183 = state_89030__$1;
(statearr_89088_89183[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (44))){
var inst_88915 = (state_89030[(2)]);
var state_89030__$1 = state_89030;
var statearr_89089_89184 = state_89030__$1;
(statearr_89089_89184[(2)] = inst_88915);

(statearr_89089_89184[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (6))){
var inst_88833 = (state_89030[(29)]);
var state_89030__$1 = state_89030;
var statearr_89090_89185 = state_89030__$1;
(statearr_89090_89185[(2)] = inst_88833);

(statearr_89090_89185[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (28))){
var inst_88891 = (state_89030[(56)]);
var state_89030__$1 = state_89030;
var statearr_89091_89186 = state_89030__$1;
(statearr_89091_89186[(2)] = inst_88891);

(statearr_89091_89186[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (64))){
var inst_88984 = (state_89030[(8)]);
var inst_88952 = (state_89030[(17)]);
var inst_88996 = cljs.core.into.call(null,inst_88984,inst_88952);
var state_89030__$1 = state_89030;
var statearr_89092_89187 = state_89030__$1;
(statearr_89092_89187[(2)] = inst_88996);

(statearr_89092_89187[(1)] = (66));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (51))){
var inst_88945 = (state_89030[(46)]);
var inst_88918 = (state_89030[(24)]);
var inst_88944 = (state_89030[(2)]);
var inst_88945__$1 = fluree.db.util.async.throw_err.call(null,inst_88944);
var inst_88946 = fluree.db.dbproto._lookup_leaf.call(null,inst_88945__$1,inst_88918);
var state_89030__$1 = (function (){var statearr_89093 = state_89030;
(statearr_89093[(46)] = inst_88945__$1);

return statearr_89093;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89030__$1,(52),inst_88946);
} else {
if((state_val_89031 === (25))){
var inst_88834 = (state_89030[(38)]);
var state_89030__$1 = state_89030;
var statearr_89094_89188 = state_89030__$1;
(statearr_89094_89188[(2)] = inst_88834);

(statearr_89094_89188[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (34))){
var inst_88902 = (cljs.core._GT__EQ_ === start_test);
var state_89030__$1 = state_89030;
if(cljs.core.truth_(inst_88902)){
var statearr_89095_89189 = state_89030__$1;
(statearr_89095_89189[(1)] = (36));

} else {
var statearr_89096_89190 = state_89030__$1;
(statearr_89096_89190[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (17))){
var inst_88842 = (state_89030[(39)]);
var inst_88875 = fluree.db.dbproto._subid.call(null,db,inst_88842);
var state_89030__$1 = state_89030;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89030__$1,(20),inst_88875);
} else {
if((state_val_89031 === (3))){
var inst_88822 = (state_89030[(2)]);
var state_89030__$1 = state_89030;
var statearr_89097_89191 = state_89030__$1;
(statearr_89097_89191[(2)] = inst_88822);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89030__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (12))){
var inst_88859 = (state_89030[(2)]);
var inst_88860 = fluree.db.util.async.throw_err.call(null,inst_88859);
var state_89030__$1 = state_89030;
var statearr_89098_89192 = state_89030__$1;
(statearr_89098_89192[(2)] = inst_88860);

(statearr_89098_89192[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (2))){
var inst_89028 = (state_89030[(2)]);
var state_89030__$1 = state_89030;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_89030__$1,inst_89028);
} else {
if((state_val_89031 === (66))){
var inst_89001 = (state_89030[(2)]);
var state_89030__$1 = state_89030;
var statearr_89099_89193 = state_89030__$1;
(statearr_89099_89193[(2)] = inst_89001);

(statearr_89099_89193[(1)] = (63));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (23))){
var inst_88886 = (state_89030[(2)]);
var state_89030__$1 = state_89030;
if(cljs.core.truth_(inst_88886)){
var statearr_89100_89194 = state_89030__$1;
(statearr_89100_89194[(1)] = (24));

} else {
var statearr_89101_89195 = state_89030__$1;
(statearr_89101_89195[(1)] = (25));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (47))){
var inst_88930 = (state_89030[(41)]);
var inst_88924 = (state_89030[(2)]);
var inst_88925 = new cljs.core.Keyword(null,"permissions","permissions",67803075).cljs$core$IFn$_invoke$arity$1(db);
var inst_88926 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_88927 = [new cljs.core.Keyword(null,"index-configs","index-configs",1053959280),idx,new cljs.core.Keyword(null,"comparator","comparator",2144896662)];
var inst_88928 = (new cljs.core.PersistentVector(null,3,(5),inst_88926,inst_88927,null));
var inst_88929 = cljs.core.get_in.call(null,db,inst_88928);
var inst_88930__$1 = new cljs.core.Keyword(null,"from-t","from-t",1730913525).cljs$core$IFn$_invoke$arity$1(opts);
var state_89030__$1 = (function (){var statearr_89102 = state_89030;
(statearr_89102[(49)] = inst_88925);

(statearr_89102[(41)] = inst_88930__$1);

(statearr_89102[(51)] = inst_88929);

(statearr_89102[(12)] = inst_88924);

return statearr_89102;
})();
if(cljs.core.truth_(inst_88930__$1)){
var statearr_89103_89196 = state_89030__$1;
(statearr_89103_89196[(1)] = (48));

} else {
var statearr_89104_89197 = state_89030__$1;
(statearr_89104_89197[(1)] = (49));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (35))){
var inst_88845 = (state_89030[(27)]);
var inst_88908 = (state_89030[(2)]);
var state_89030__$1 = (function (){var statearr_89105 = state_89030;
(statearr_89105[(52)] = inst_88908);

return statearr_89105;
})();
if(cljs.core.truth_(inst_88845)){
var statearr_89106_89198 = state_89030__$1;
(statearr_89106_89198[(1)] = (39));

} else {
var statearr_89107_89199 = state_89030__$1;
(statearr_89107_89199[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (19))){
var inst_88834 = (state_89030[(38)]);
var inst_88882 = (state_89030[(53)]);
var inst_88881 = (state_89030[(2)]);
var inst_88882__$1 = (inst_88834 == null);
var state_89030__$1 = (function (){var statearr_89108 = state_89030;
(statearr_89108[(22)] = inst_88881);

(statearr_89108[(53)] = inst_88882__$1);

return statearr_89108;
})();
if(cljs.core.truth_(inst_88882__$1)){
var statearr_89109_89200 = state_89030__$1;
(statearr_89109_89200[(1)] = (21));

} else {
var statearr_89110_89201 = state_89030__$1;
(statearr_89110_89201[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (57))){
var inst_88958 = (state_89030[(26)]);
var state_89030__$1 = state_89030;
var statearr_89111_89202 = state_89030__$1;
(statearr_89111_89202[(2)] = inst_88958);

(statearr_89111_89202[(1)] = (58));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (68))){
var inst_88966 = (state_89030[(19)]);
var state_89030__$1 = state_89030;
var statearr_89112_89203 = state_89030__$1;
(statearr_89112_89203[(2)] = inst_88966);

(statearr_89112_89203[(1)] = (69));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (11))){
var inst_88835 = (state_89030[(31)]);
var inst_88863 = (state_89030[(2)]);
var inst_88864 = fluree.db.util.core.pred_ident_QMARK_.call(null,inst_88835);
var state_89030__$1 = (function (){var statearr_89113 = state_89030;
(statearr_89113[(47)] = inst_88863);

return statearr_89113;
})();
if(inst_88864){
var statearr_89114_89204 = state_89030__$1;
(statearr_89114_89204[(1)] = (13));

} else {
var statearr_89115_89205 = state_89030__$1;
(statearr_89115_89205[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (9))){
var inst_88840 = (state_89030[(13)]);
var inst_88857 = fluree.db.dbproto._subid.call(null,db,inst_88840);
var state_89030__$1 = state_89030;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89030__$1,(12),inst_88857);
} else {
if((state_val_89031 === (5))){
var inst_88833 = (state_89030[(29)]);
var inst_88848 = fluree.db.dbproto._subid.call(null,db,inst_88833);
var state_89030__$1 = state_89030;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89030__$1,(8),inst_88848);
} else {
if((state_val_89031 === (14))){
var inst_88835 = (state_89030[(31)]);
var state_89030__$1 = state_89030;
var statearr_89116_89206 = state_89030__$1;
(statearr_89116_89206[(2)] = inst_88835);

(statearr_89116_89206[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (45))){
var inst_88920 = (state_89030[(54)]);
var state_89030__$1 = state_89030;
var statearr_89117_89207 = state_89030__$1;
(statearr_89117_89207[(2)] = inst_88920);

(statearr_89117_89207[(1)] = (47));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (53))){
var inst_88935 = (state_89030[(42)]);
var inst_88950 = (state_89030[(18)]);
var inst_88936 = (state_89030[(43)]);
var inst_88940 = (state_89030[(44)]);
var inst_88954 = fluree.db.dbproto._resolve_history_range.call(null,inst_88950,inst_88935,inst_88936,inst_88940);
var state_89030__$1 = state_89030;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89030__$1,(55),inst_88954);
} else {
if((state_val_89031 === (26))){
var inst_88891 = (state_89030[(56)]);
var inst_88841 = (state_89030[(36)]);
var inst_88890 = (state_89030[(2)]);
var inst_88891__$1 = (inst_88841 == null);
var state_89030__$1 = (function (){var statearr_89118 = state_89030;
(statearr_89118[(48)] = inst_88890);

(statearr_89118[(56)] = inst_88891__$1);

return statearr_89118;
})();
if(cljs.core.truth_(inst_88891__$1)){
var statearr_89119_89208 = state_89030__$1;
(statearr_89119_89208[(1)] = (27));

} else {
var statearr_89120_89209 = state_89030__$1;
(statearr_89120_89209[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (16))){
var inst_88868 = (state_89030[(2)]);
var inst_88869 = fluree.db.util.async.throw_err.call(null,inst_88868);
var state_89030__$1 = state_89030;
var statearr_89121_89210 = state_89030__$1;
(statearr_89121_89210[(2)] = inst_88869);

(statearr_89121_89210[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (38))){
var inst_88906 = (state_89030[(2)]);
var state_89030__$1 = state_89030;
var statearr_89122_89211 = state_89030__$1;
(statearr_89122_89211[(2)] = inst_88906);

(statearr_89122_89211[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (30))){
var state_89030__$1 = state_89030;
var statearr_89123_89212 = state_89030__$1;
(statearr_89123_89212[(2)] = fluree.db.flake.MAX_PREDICATE_ID);

(statearr_89123_89212[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (73))){
var inst_89005 = (state_89030[(11)]);
var inst_89006 = (state_89030[(55)]);
var inst_89020 = (state_89030[(2)]);
var inst_89021 = fluree.db.util.async.throw_err.call(null,inst_89020);
var inst_88950 = inst_89021;
var inst_88951 = inst_89006;
var inst_88952 = inst_89005;
var state_89030__$1 = (function (){var statearr_89124 = state_89030;
(statearr_89124[(15)] = inst_88951);

(statearr_89124[(18)] = inst_88950);

(statearr_89124[(17)] = inst_88952);

return statearr_89124;
})();
var statearr_89125_89213 = state_89030__$1;
(statearr_89125_89213[(2)] = null);

(statearr_89125_89213[(1)] = (53));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (10))){
var inst_88840 = (state_89030[(13)]);
var state_89030__$1 = state_89030;
var statearr_89126_89214 = state_89030__$1;
(statearr_89126_89214[(2)] = inst_88840);

(statearr_89126_89214[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (18))){
var inst_88842 = (state_89030[(39)]);
var state_89030__$1 = state_89030;
var statearr_89127_89215 = state_89030__$1;
(statearr_89127_89215[(2)] = inst_88842);

(statearr_89127_89215[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (52))){
var inst_88948 = (state_89030[(2)]);
var inst_88949 = fluree.db.util.async.throw_err.call(null,inst_88948);
var inst_88950 = inst_88949;
var inst_88951 = (0);
var inst_88952 = null;
var state_89030__$1 = (function (){var statearr_89128 = state_89030;
(statearr_89128[(15)] = inst_88951);

(statearr_89128[(18)] = inst_88950);

(statearr_89128[(17)] = inst_88952);

return statearr_89128;
})();
var statearr_89129_89216 = state_89030__$1;
(statearr_89129_89216[(2)] = null);

(statearr_89129_89216[(1)] = (53));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (67))){
var inst_88966 = (state_89030[(19)]);
var inst_88929 = (state_89030[(51)]);
var inst_88924 = (state_89030[(12)]);
var inst_89006 = (state_89030[(55)]);
var inst_88919 = (state_89030[(25)]);
var inst_89008 = inst_88929.call(null,inst_88966,inst_88919);
var inst_89009 = (inst_89008 < (0));
var inst_89010 = (inst_89006 < inst_88924);
var inst_89011 = ((inst_89009) && (inst_89010));
var state_89030__$1 = state_89030;
var statearr_89130_89217 = state_89030__$1;
(statearr_89130_89217[(2)] = inst_89011);

(statearr_89130_89217[(1)] = (69));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (71))){
var inst_88945 = (state_89030[(46)]);
var inst_88966 = (state_89030[(19)]);
var inst_89018 = fluree.db.dbproto._lookup_leaf.call(null,inst_88945,inst_88966);
var state_89030__$1 = state_89030;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89030__$1,(73),inst_89018);
} else {
if((state_val_89031 === (42))){
var state_89030__$1 = state_89030;
var statearr_89131_89218 = state_89030__$1;
(statearr_89131_89218[(2)] = (2147483647));

(statearr_89131_89218[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (37))){
var state_89030__$1 = state_89030;
var statearr_89132_89219 = state_89030__$1;
(statearr_89132_89219[(2)] = (2147483647));

(statearr_89132_89219[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (63))){
var inst_89003 = (state_89030[(2)]);
var state_89030__$1 = state_89030;
var statearr_89133_89220 = state_89030__$1;
(statearr_89133_89220[(2)] = inst_89003);

(statearr_89133_89220[(1)] = (61));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (8))){
var inst_88850 = (state_89030[(2)]);
var inst_88851 = fluree.db.util.async.throw_err.call(null,inst_88850);
var state_89030__$1 = state_89030;
var statearr_89134_89221 = state_89030__$1;
(statearr_89134_89221[(2)] = inst_88851);

(statearr_89134_89221[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89031 === (49))){
var inst_88933 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(db);
var state_89030__$1 = state_89030;
var statearr_89135_89222 = state_89030__$1;
(statearr_89135_89222[(2)] = inst_88933);

(statearr_89135_89222[(1)] = (50));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$range$state_machine__86625__auto__ = null;
var fluree$db$query$range$state_machine__86625__auto____0 = (function (){
var statearr_89136 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_89136[(0)] = fluree$db$query$range$state_machine__86625__auto__);

(statearr_89136[(1)] = (1));

return statearr_89136;
});
var fluree$db$query$range$state_machine__86625__auto____1 = (function (state_89030){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_89030);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e89137){if((e89137 instanceof Object)){
var ex__86628__auto__ = e89137;
var statearr_89138_89223 = state_89030;
(statearr_89138_89223[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89030);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e89137;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__89224 = state_89030;
state_89030 = G__89224;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$range$state_machine__86625__auto__ = function(state_89030){
switch(arguments.length){
case 0:
return fluree$db$query$range$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$range$state_machine__86625__auto____1.call(this,state_89030);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$range$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$range$state_machine__86625__auto____0;
fluree$db$query$range$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$range$state_machine__86625__auto____1;
return fluree$db$query$range$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_89139 = f__86676__auto__.call(null);
(statearr_89139[(6)] = c__86675__auto__);

return statearr_89139;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.query.range.time_range.cljs$lang$maxFixedArity = 7;

/**
 * Starting with flakes grouped by subject id, filters the flakes until
 *   either flake-limit or subject-limit reached.
 */
fluree.db.query.range.subject_groups__GT_allow_flakes = (function fluree$db$query$range$subject_groups__GT_allow_flakes(db,subject_groups,flake_start,subject_start,flake_limit,subject_limit){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_89271){
var state_val_89272 = (state_89271[(1)]);
if((state_val_89272 === (7))){
var state_89271__$1 = state_89271;
var statearr_89273_89291 = state_89271__$1;
(statearr_89273_89291[(2)] = (0));

(statearr_89273_89291[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89272 === (1))){
var inst_89232 = cljs.core.seq.call(null,subject_groups);
var inst_89233 = cljs.core.first.call(null,inst_89232);
var inst_89234 = cljs.core.next.call(null,inst_89232);
var inst_89235 = cljs.core.PersistentVector.EMPTY;
var inst_89236 = subject_groups;
var inst_89237 = flake_start;
var inst_89238 = subject_start;
var inst_89239 = inst_89235;
var state_89271__$1 = (function (){var statearr_89274 = state_89271;
(statearr_89274[(7)] = inst_89237);

(statearr_89274[(8)] = inst_89233);

(statearr_89274[(9)] = inst_89234);

(statearr_89274[(10)] = inst_89238);

(statearr_89274[(11)] = inst_89236);

(statearr_89274[(12)] = inst_89239);

return statearr_89274;
})();
var statearr_89275_89292 = state_89271__$1;
(statearr_89275_89292[(2)] = null);

(statearr_89275_89292[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89272 === (4))){
var inst_89237 = (state_89271[(7)]);
var inst_89238 = (state_89271[(10)]);
var inst_89239 = (state_89271[(12)]);
var inst_89252 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89253 = [inst_89237,inst_89238,inst_89239];
var inst_89254 = (new cljs.core.PersistentVector(null,3,(5),inst_89252,inst_89253,null));
var state_89271__$1 = state_89271;
var statearr_89276_89293 = state_89271__$1;
(statearr_89276_89293[(2)] = inst_89254);

(statearr_89276_89293[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89272 === (6))){
var inst_89267 = (state_89271[(2)]);
var state_89271__$1 = state_89271;
var statearr_89277_89294 = state_89271__$1;
(statearr_89277_89294[(2)] = inst_89267);

(statearr_89277_89294[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89272 === (3))){
var inst_89269 = (state_89271[(2)]);
var state_89271__$1 = state_89271;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_89271__$1,inst_89269);
} else {
if((state_val_89272 === (2))){
var inst_89237 = (state_89271[(7)]);
var inst_89238 = (state_89271[(10)]);
var inst_89236 = (state_89271[(11)]);
var inst_89245 = (state_89271[(13)]);
var inst_89244 = cljs.core.seq.call(null,inst_89236);
var inst_89245__$1 = cljs.core.first.call(null,inst_89244);
var inst_89246 = cljs.core.next.call(null,inst_89244);
var inst_89247 = (inst_89245__$1 == null);
var inst_89248 = (inst_89237 >= flake_limit);
var inst_89249 = (inst_89238 >= subject_limit);
var inst_89250 = ((inst_89247) || (inst_89248) || (inst_89249));
var state_89271__$1 = (function (){var statearr_89278 = state_89271;
(statearr_89278[(14)] = inst_89246);

(statearr_89278[(13)] = inst_89245__$1);

return statearr_89278;
})();
if(cljs.core.truth_(inst_89250)){
var statearr_89279_89295 = state_89271__$1;
(statearr_89279_89295[(1)] = (4));

} else {
var statearr_89280_89296 = state_89271__$1;
(statearr_89280_89296[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89272 === (9))){
var inst_89246 = (state_89271[(14)]);
var inst_89237 = (state_89271[(7)]);
var inst_89238 = (state_89271[(10)]);
var inst_89256 = (state_89271[(15)]);
var inst_89239 = (state_89271[(12)]);
var inst_89245 = (state_89271[(13)]);
var inst_89261 = (state_89271[(2)]);
var inst_89262 = (inst_89237 + inst_89256);
var inst_89263 = (inst_89238 + inst_89261);
var inst_89264 = cljs.core.into.call(null,inst_89239,inst_89245);
var inst_89236 = inst_89246;
var inst_89237__$1 = inst_89262;
var inst_89238__$1 = inst_89263;
var inst_89239__$1 = inst_89264;
var state_89271__$1 = (function (){var statearr_89281 = state_89271;
(statearr_89281[(7)] = inst_89237__$1);

(statearr_89281[(10)] = inst_89238__$1);

(statearr_89281[(11)] = inst_89236);

(statearr_89281[(12)] = inst_89239__$1);

return statearr_89281;
})();
var statearr_89282_89297 = state_89271__$1;
(statearr_89282_89297[(2)] = null);

(statearr_89282_89297[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89272 === (5))){
var inst_89256 = (state_89271[(15)]);
var inst_89245 = (state_89271[(13)]);
var inst_89256__$1 = cljs.core.count.call(null,inst_89245);
var inst_89257 = cljs.core._EQ_.call(null,(0),inst_89256__$1);
var state_89271__$1 = (function (){var statearr_89283 = state_89271;
(statearr_89283[(15)] = inst_89256__$1);

return statearr_89283;
})();
if(inst_89257){
var statearr_89284_89298 = state_89271__$1;
(statearr_89284_89298[(1)] = (7));

} else {
var statearr_89285_89299 = state_89271__$1;
(statearr_89285_89299[(1)] = (8));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89272 === (8))){
var state_89271__$1 = state_89271;
var statearr_89286_89300 = state_89271__$1;
(statearr_89286_89300[(2)] = (1));

(statearr_89286_89300[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto__ = null;
var fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto____0 = (function (){
var statearr_89287 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_89287[(0)] = fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto__);

(statearr_89287[(1)] = (1));

return statearr_89287;
});
var fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto____1 = (function (state_89271){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_89271);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e89288){if((e89288 instanceof Object)){
var ex__86628__auto__ = e89288;
var statearr_89289_89301 = state_89271;
(statearr_89289_89301[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89271);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e89288;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__89302 = state_89271;
state_89271 = G__89302;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto__ = function(state_89271){
switch(arguments.length){
case 0:
return fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto____1.call(this,state_89271);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto____0;
fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto____1;
return fluree$db$query$range$subject_groups__GT_allow_flakes_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_89290 = f__86676__auto__.call(null);
(statearr_89290[(6)] = c__86675__auto__);

return statearr_89290;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.query.range.find_next_valid_node = (function fluree$db$query$range$find_next_valid_node(root_node,rhs,t,novelty,fast_forward_db_QMARK_){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_89342){
var state_val_89343 = (state_89342[(1)]);
if((state_val_89343 === (7))){
var inst_89338 = (state_89342[(2)]);
var state_89342__$1 = state_89342;
var statearr_89344_89369 = state_89342__$1;
(statearr_89344_89369[(2)] = inst_89338);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89342__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (1))){
var state_89342__$1 = state_89342;
var statearr_89345_89370 = state_89342__$1;
(statearr_89345_89370[(2)] = null);

(statearr_89345_89370[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (4))){
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_89342,(3),Error,null,(2));
var inst_89307 = fluree.db.dbproto._lookup_leaf.call(null,root_node,rhs);
var state_89342__$1 = state_89342;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89342__$1,(5),inst_89307);
} else {
if((state_val_89343 === (15))){
var inst_89325 = (state_89342[(7)]);
var inst_89327 = fluree.db.dbproto._lookup_leaf.call(null,root_node,inst_89325);
var state_89342__$1 = state_89342;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89342__$1,(18),inst_89327);
} else {
if((state_val_89343 === (13))){
var inst_89325 = (state_89342[(7)]);
var inst_89311 = (state_89342[(8)]);
var inst_89325__$1 = new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(inst_89311);
var state_89342__$1 = (function (){var statearr_89346 = state_89342;
(statearr_89346[(7)] = inst_89325__$1);

return statearr_89346;
})();
if(cljs.core.truth_(inst_89325__$1)){
var statearr_89347_89371 = state_89342__$1;
(statearr_89347_89371[(1)] = (15));

} else {
var statearr_89348_89372 = state_89342__$1;
(statearr_89348_89372[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (6))){
var state_89342__$1 = state_89342;
var statearr_89349_89373 = state_89342__$1;
(statearr_89349_89373[(2)] = null);

(statearr_89349_89373[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (17))){
var inst_89334 = (state_89342[(2)]);
var state_89342__$1 = state_89342;
var statearr_89350_89374 = state_89342__$1;
(statearr_89350_89374[(2)] = inst_89334);

(statearr_89350_89374[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (3))){
var inst_89303 = (state_89342[(2)]);
var state_89342__$1 = state_89342;
var statearr_89351_89375 = state_89342__$1;
(statearr_89351_89375[(2)] = inst_89303);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89342__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (12))){
var inst_89322 = (state_89342[(9)]);
var state_89342__$1 = state_89342;
var statearr_89352_89376 = state_89342__$1;
(statearr_89352_89376[(2)] = inst_89322);

(statearr_89352_89376[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (2))){
var inst_89340 = (state_89342[(2)]);
var state_89342__$1 = state_89342;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_89342__$1,inst_89340);
} else {
if((state_val_89343 === (11))){
var inst_89319 = (state_89342[(2)]);
var inst_89320 = fluree.db.util.async.throw_err.call(null,inst_89319);
var state_89342__$1 = state_89342;
var statearr_89353_89377 = state_89342__$1;
(statearr_89353_89377[(2)] = inst_89320);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89342__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (9))){
var inst_89313 = (state_89342[(2)]);
var state_89342__$1 = (function (){var statearr_89354 = state_89342;
(statearr_89354[(10)] = inst_89313);

return statearr_89354;
})();
var statearr_89355_89378 = state_89342__$1;
(statearr_89355_89378[(2)] = null);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89342__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (5))){
var inst_89309 = (state_89342[(2)]);
var inst_89310 = fluree.db.util.async.throw_err.call(null,inst_89309);
var inst_89311 = inst_89310;
var state_89342__$1 = (function (){var statearr_89356 = state_89342;
(statearr_89356[(8)] = inst_89311);

return statearr_89356;
})();
var statearr_89357_89379 = state_89342__$1;
(statearr_89357_89379[(2)] = null);

(statearr_89357_89379[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (14))){
var inst_89336 = (state_89342[(2)]);
var state_89342__$1 = state_89342;
var statearr_89358_89380 = state_89342__$1;
(statearr_89358_89380[(2)] = inst_89336);

(statearr_89358_89380[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (16))){
var state_89342__$1 = state_89342;
var statearr_89359_89381 = state_89342__$1;
(statearr_89359_89381[(2)] = null);

(statearr_89359_89381[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (10))){
var inst_89311 = (state_89342[(8)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_89342,(9),new cljs.core.Keyword(null,"default","default",-1987822328),null,(8));
var inst_89317 = fluree.db.dbproto._resolve_to_t.call(null,inst_89311,t,novelty,fast_forward_db_QMARK_);
var state_89342__$1 = state_89342;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89342__$1,(11),inst_89317);
} else {
if((state_val_89343 === (18))){
var inst_89329 = (state_89342[(2)]);
var inst_89330 = fluree.db.util.async.throw_err.call(null,inst_89329);
var inst_89311 = inst_89330;
var state_89342__$1 = (function (){var statearr_89360 = state_89342;
(statearr_89360[(8)] = inst_89311);

return statearr_89360;
})();
var statearr_89361_89382 = state_89342__$1;
(statearr_89361_89382[(2)] = null);

(statearr_89361_89382[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89343 === (8))){
var inst_89322 = (state_89342[(9)]);
var inst_89322__$1 = (state_89342[(2)]);
var state_89342__$1 = (function (){var statearr_89362 = state_89342;
(statearr_89362[(9)] = inst_89322__$1);

return statearr_89362;
})();
if(cljs.core.truth_(inst_89322__$1)){
var statearr_89363_89383 = state_89342__$1;
(statearr_89363_89383[(1)] = (12));

} else {
var statearr_89364_89384 = state_89342__$1;
(statearr_89364_89384[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto__ = null;
var fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto____0 = (function (){
var statearr_89365 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_89365[(0)] = fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto__);

(statearr_89365[(1)] = (1));

return statearr_89365;
});
var fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto____1 = (function (state_89342){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_89342);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e89366){if((e89366 instanceof Object)){
var ex__86628__auto__ = e89366;
var statearr_89367_89385 = state_89342;
(statearr_89367_89385[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89342);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e89366;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__89386 = state_89342;
state_89342 = G__89386;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto__ = function(state_89342){
switch(arguments.length){
case 0:
return fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto____1.call(this,state_89342);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto____0;
fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto____1;
return fluree$db$query$range$find_next_valid_node_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_89368 = f__86676__auto__.call(null);
(statearr_89368[(6)] = c__86675__auto__);

return statearr_89368;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
/**
 * Range query across an index as of a 't' defined by the db.
 * 
 *   Ranges take the natural numeric sort orders, but all results will
 *   return in reverse order (newest subjects and predicates first).
 * 
 *   Returns core async channel.
 * 
 *   opts:
 *   :xform - xform applied to each result individually. This is not used when :chan is supplied.
 *   :limit - max number of flakes to return
 */
fluree.db.query.range.index_range = (function fluree$db$query$range$index_range(var_args){
var G__89393 = arguments.length;
switch (G__89393) {
case 2:
return fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
case 7:
return fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$7((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]),(arguments[(6)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$2 = (function (db,idx){
return fluree.db.query.range.index_range.call(null,db,idx,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$3 = (function (db,idx,opts){
return fluree.db.query.range.index_range.call(null,db,idx,cljs.core._GT__EQ_,fluree.db.query.range.min_match.call(null,idx),cljs.core._LT__EQ_,fluree.db.query.range.max_match.call(null,idx),opts);
});

fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4 = (function (db,idx,test,match){
return fluree.db.query.range.index_range.call(null,db,idx,test,match,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$5 = (function (db,idx,test,match,opts){
var vec__89394 = (function (){var pred__89397 = cljs.core.identical_QMARK_;
var expr__89398 = test;
if(cljs.core.truth_(pred__89397.call(null,cljs.core._EQ_,expr__89398))){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core._GT__EQ_,match,cljs.core._LT__EQ_,match], null);
} else {
if(cljs.core.truth_(pred__89397.call(null,cljs.core._LT_,expr__89398))){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core._GT_,fluree.db.query.range.min_match.call(null,idx),cljs.core._LT_,match], null);
} else {
if(cljs.core.truth_(pred__89397.call(null,cljs.core._LT__EQ_,expr__89398))){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core._GT_,fluree.db.query.range.min_match.call(null,idx),cljs.core._LT__EQ_,match], null);
} else {
if(cljs.core.truth_(pred__89397.call(null,cljs.core._GT_,expr__89398))){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core._GT_,match,cljs.core._LT__EQ_,fluree.db.query.range.max_match.call(null,idx)], null);
} else {
if(cljs.core.truth_(pred__89397.call(null,cljs.core._GT__EQ_,expr__89398))){
return new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core._GT__EQ_,match,cljs.core._LT_,fluree.db.query.range.max_match.call(null,idx)], null);
} else {
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(expr__89398)].join('')));
}
}
}
}
}
})();
var start_test = cljs.core.nth.call(null,vec__89394,(0),null);
var start_match = cljs.core.nth.call(null,vec__89394,(1),null);
var end_test = cljs.core.nth.call(null,vec__89394,(2),null);
var end_match = cljs.core.nth.call(null,vec__89394,(3),null);
return fluree.db.query.range.index_range.call(null,db,idx,start_test,start_match,end_test,end_match,opts);
});

fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$6 = (function (db,idx,start_test,start_match,end_test,end_match){
return fluree.db.query.range.index_range.call(null,db,idx,start_test,start_match,end_test,end_match,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$7 = (function (db,idx,start_test,start_match,end_test,end_match,opts){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_89791){
var state_val_89792 = (state_89791[(1)]);
if((state_val_89792 === (121))){
var inst_89764 = (state_89791[(7)]);
var inst_89764__$1 = (state_89791[(2)]);
var state_89791__$1 = (function (){var statearr_89793 = state_89791;
(statearr_89793[(7)] = inst_89764__$1);

return statearr_89793;
})();
if(cljs.core.truth_(inst_89764__$1)){
var statearr_89794_89990 = state_89791__$1;
(statearr_89794_89990[(1)] = (122));

} else {
var statearr_89795_89991 = state_89791__$1;
(statearr_89795_89991[(1)] = (123));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (65))){
var inst_89560 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89796_89992 = state_89791__$1;
(statearr_89796_89992[(2)] = inst_89560);

(statearr_89796_89992[(1)] = (62));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (70))){
var state_89791__$1 = state_89791;
var statearr_89797_89993 = state_89791__$1;
(statearr_89797_89993[(2)] = false);

(statearr_89797_89993[(1)] = (71));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (62))){
var inst_89430 = (state_89791[(8)]);
var inst_89429 = (state_89791[(9)]);
var inst_89423 = (state_89791[(10)]);
var inst_89473 = (state_89791[(11)]);
var inst_89517 = (state_89791[(12)]);
var inst_89553 = (state_89791[(13)]);
var inst_89535 = (state_89791[(14)]);
var inst_89544 = (state_89791[(15)]);
var inst_89526 = (state_89791[(16)]);
var inst_89562 = (state_89791[(17)]);
var inst_89464 = (state_89791[(18)]);
var inst_89422 = (state_89791[(19)]);
var inst_89562__$1 = (state_89791[(2)]);
var inst_89563 = fluree.db.flake.__GT_Flake.call(null,inst_89464,inst_89535,inst_89517,inst_89422,inst_89423,inst_89553);
var inst_89564 = fluree.db.flake.__GT_Flake.call(null,inst_89473,inst_89544,inst_89526,inst_89429,inst_89430,inst_89562__$1);
var inst_89566 = (opts == null);
var inst_89567 = cljs.core.not.call(null,inst_89566);
var state_89791__$1 = (function (){var statearr_89798 = state_89791;
(statearr_89798[(20)] = inst_89564);

(statearr_89798[(21)] = inst_89563);

(statearr_89798[(17)] = inst_89562__$1);

return statearr_89798;
})();
if(inst_89567){
var statearr_89799_89994 = state_89791__$1;
(statearr_89799_89994[(1)] = (66));

} else {
var statearr_89800_89995 = state_89791__$1;
(statearr_89800_89995[(1)] = (67));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (74))){
var inst_89585 = (state_89791[(22)]);
var inst_89587 = (state_89791[(23)]);
var inst_89585__$1 = (state_89791[(2)]);
var inst_89586 = cljs.core.get.call(null,inst_89585__$1,new cljs.core.Keyword(null,"flake-limit","flake-limit",-1060039961),fluree.db.util.core.max_long);
var inst_89587__$1 = cljs.core.get.call(null,inst_89585__$1,new cljs.core.Keyword(null,"limit","limit",-1355822363));
var inst_89588 = cljs.core.get.call(null,inst_89585__$1,new cljs.core.Keyword(null,"offset","offset",296498311),(0));
var state_89791__$1 = (function (){var statearr_89801 = state_89791;
(statearr_89801[(24)] = inst_89586);

(statearr_89801[(22)] = inst_89585__$1);

(statearr_89801[(23)] = inst_89587__$1);

(statearr_89801[(25)] = inst_89588);

return statearr_89801;
})();
if(cljs.core.truth_(inst_89587__$1)){
var statearr_89802_89996 = state_89791__$1;
(statearr_89802_89996[(1)] = (75));

} else {
var statearr_89803_89997 = state_89791__$1;
(statearr_89803_89997[(1)] = (76));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (110))){
var inst_89586 = (state_89791[(24)]);
var inst_89618 = (state_89791[(26)]);
var inst_89686 = (state_89791[(27)]);
var inst_89619 = (state_89791[(28)]);
var inst_89592 = (state_89791[(29)]);
var inst_89735 = fluree.db.query.range.subject_groups__GT_allow_flakes.call(null,db,inst_89686,inst_89618,inst_89619,inst_89586,inst_89592);
var state_89791__$1 = state_89791;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89791__$1,(118),inst_89735);
} else {
if((state_val_89792 === (130))){
var inst_89753 = (state_89791[(30)]);
var inst_89772 = (state_89791[(31)]);
var inst_89755 = (state_89791[(32)]);
var inst_89754 = (state_89791[(33)]);
var inst_89752 = (state_89791[(34)]);
var inst_89616 = inst_89772;
var inst_89617 = inst_89752;
var inst_89618 = inst_89753;
var inst_89619 = inst_89754;
var inst_89620 = inst_89755;
var state_89791__$1 = (function (){var statearr_89804 = state_89791;
(statearr_89804[(26)] = inst_89618);

(statearr_89804[(35)] = inst_89620);

(statearr_89804[(28)] = inst_89619);

(statearr_89804[(36)] = inst_89617);

(statearr_89804[(37)] = inst_89616);

return statearr_89804;
})();
var statearr_89805_89998 = state_89791__$1;
(statearr_89805_89998[(2)] = null);

(statearr_89805_89998[(1)] = (83));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (128))){
var inst_89776 = (state_89791[(2)]);
var inst_89777 = cljs.core.not.call(null,inst_89776);
var state_89791__$1 = state_89791;
if(inst_89777){
var statearr_89806_89999 = state_89791__$1;
(statearr_89806_89999[(1)] = (129));

} else {
var statearr_89807_90000 = state_89791__$1;
(statearr_89807_90000[(1)] = (130));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (7))){
var inst_89447 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
if(cljs.core.truth_(inst_89447)){
var statearr_89808_90001 = state_89791__$1;
(statearr_89808_90001[(1)] = (11));

} else {
var statearr_89809_90002 = state_89791__$1;
(statearr_89809_90002[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (59))){
var inst_89551 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89810_90003 = state_89791__$1;
(statearr_89810_90003[(2)] = inst_89551);

(statearr_89810_90003[(1)] = (56));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (86))){
var inst_89626 = (state_89791[(38)]);
var state_89791__$1 = state_89791;
var statearr_89811_90004 = state_89791__$1;
(statearr_89811_90004[(2)] = inst_89626);

(statearr_89811_90004[(1)] = (87));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (20))){
var inst_89421 = (state_89791[(39)]);
var inst_89473 = (state_89791[(2)]);
var inst_89474 = cljs.core.boolean_QMARK_.call(null,inst_89421);
var state_89791__$1 = (function (){var statearr_89812 = state_89791;
(statearr_89812[(11)] = inst_89473);

return statearr_89812;
})();
if(inst_89474){
var statearr_89813_90005 = state_89791__$1;
(statearr_89813_90005[(1)] = (22));

} else {
var statearr_89814_90006 = state_89791__$1;
(statearr_89814_90006[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (72))){
var inst_89582 = cljs.core.apply.call(null,cljs.core.hash_map,opts);
var state_89791__$1 = state_89791;
var statearr_89815_90007 = state_89791__$1;
(statearr_89815_90007[(2)] = inst_89582);

(statearr_89815_90007[(1)] = (74));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (58))){
var state_89791__$1 = state_89791;
var statearr_89816_90008 = state_89791__$1;
(statearr_89816_90008[(2)] = (2147483647));

(statearr_89816_90008[(1)] = (59));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (60))){
var inst_89431 = (state_89791[(40)]);
var state_89791__$1 = state_89791;
var statearr_89817_90009 = state_89791__$1;
(statearr_89817_90009[(2)] = inst_89431);

(statearr_89817_90009[(1)] = (62));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (27))){
var inst_89485 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89818_90010 = state_89791__$1;
(statearr_89818_90010[(2)] = inst_89485);

(statearr_89818_90010[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (1))){
var state_89791__$1 = state_89791;
var statearr_89819_90011 = state_89791__$1;
(statearr_89819_90011[(2)] = null);

(statearr_89819_90011[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (69))){
var state_89791__$1 = state_89791;
var statearr_89820_90012 = state_89791__$1;
(statearr_89820_90012[(2)] = true);

(statearr_89820_90012[(1)] = (71));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (101))){
var inst_89655 = (state_89791[(41)]);
var state_89791__$1 = state_89791;
var statearr_89821_90013 = state_89791__$1;
(statearr_89821_90013[(2)] = inst_89655);

(statearr_89821_90013[(1)] = (102));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (24))){
var inst_89487 = (state_89791[(42)]);
var inst_89487__$1 = (state_89791[(2)]);
var state_89791__$1 = (function (){var statearr_89822 = state_89791;
(statearr_89822[(42)] = inst_89487__$1);

return statearr_89822;
})();
if(cljs.core.truth_(inst_89487__$1)){
var statearr_89823_90014 = state_89791__$1;
(statearr_89823_90014[(1)] = (31));

} else {
var statearr_89824_90015 = state_89791__$1;
(statearr_89824_90015[(1)] = (32));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (102))){
var inst_89659 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89825_90016 = state_89791__$1;
(statearr_89825_90016[(2)] = inst_89659);

(statearr_89825_90016[(1)] = (99));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (55))){
var inst_89547 = (cljs.core._GT__EQ_ === start_test);
var state_89791__$1 = state_89791;
if(cljs.core.truth_(inst_89547)){
var statearr_89826_90017 = state_89791__$1;
(statearr_89826_90017[(1)] = (57));

} else {
var statearr_89827_90018 = state_89791__$1;
(statearr_89827_90018[(1)] = (58));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (85))){
var inst_89504 = (state_89791[(43)]);
var inst_89613 = (state_89791[(44)]);
var inst_89599 = (state_89791[(45)]);
var inst_89505 = (state_89791[(46)]);
var inst_89508 = (state_89791[(47)]);
var inst_89430 = (state_89791[(8)]);
var inst_89452 = (state_89791[(48)]);
var inst_89429 = (state_89791[(9)]);
var inst_89586 = (state_89791[(24)]);
var inst_89604 = (state_89791[(49)]);
var inst_89423 = (state_89791[(10)]);
var inst_89618 = (state_89791[(26)]);
var inst_89473 = (state_89791[(11)]);
var inst_89620 = (state_89791[(35)]);
var inst_89517 = (state_89791[(12)]);
var inst_89418 = (state_89791[(50)]);
var inst_89425 = (state_89791[(51)]);
var inst_89603 = (state_89791[(52)]);
var inst_89453 = (state_89791[(53)]);
var inst_89553 = (state_89791[(13)]);
var inst_89585 = (state_89791[(22)]);
var inst_89619 = (state_89791[(28)]);
var inst_89609 = (state_89791[(54)]);
var inst_89535 = (state_89791[(14)]);
var inst_89564 = (state_89791[(20)]);
var inst_89563 = (state_89791[(21)]);
var inst_89544 = (state_89791[(15)]);
var inst_89526 = (state_89791[(16)]);
var inst_89454 = (state_89791[(55)]);
var inst_89594 = (state_89791[(56)]);
var inst_89562 = (state_89791[(17)]);
var inst_89593 = (state_89791[(57)]);
var inst_89617 = (state_89791[(36)]);
var inst_89464 = (state_89791[(18)]);
var inst_89616 = (state_89791[(37)]);
var inst_89422 = (state_89791[(19)]);
var inst_89598 = (state_89791[(58)]);
var inst_89626 = (state_89791[(38)]);
var inst_89592 = (state_89791[(29)]);
var inst_89630 = (function (){var no_filter_QMARK_ = true;
var t = inst_89599;
var max_limit_QMARK_ = inst_89593;
var next_node = inst_89616;
var fast_forward_db_QMARK_ = inst_89604;
var s1 = inst_89464;
var o2 = inst_89526;
var vec__89407 = inst_89425;
var t1 = inst_89422;
var predicate_fn = inst_89454;
var i = inst_89618;
var map__89410 = inst_89452;
var m1 = inst_89553;
var root_node = inst_89609;
var s2 = inst_89473;
var p2 = inst_89544;
var map__89417 = inst_89585;
var permissions = inst_89594;
var limit = inst_89592;
var vec__89404 = inst_89418;
var start_flake = inst_89563;
var flake_limit = inst_89586;
var vec__89414 = inst_89505;
var offset = inst_89617;
var vec__89411 = inst_89504;
var acc = inst_89620;
var t2 = inst_89429;
var G__89627 = inst_89626;
var op1 = inst_89423;
var o1 = inst_89517;
var end_flake = inst_89564;
var base_result = inst_89626;
var s = inst_89619;
var node_start = inst_89613;
var p1 = inst_89535;
var subject_fn = inst_89453;
var object_fn = inst_89508;
var idx_compare = inst_89598;
var op2 = inst_89430;
var m2 = inst_89562;
var novelty = inst_89603;
return ((function (no_filter_QMARK_,t,max_limit_QMARK_,next_node,fast_forward_db_QMARK_,s1,o2,vec__89407,t1,predicate_fn,i,map__89410,m1,root_node,s2,p2,map__89417,permissions,limit,vec__89404,start_flake,flake_limit,vec__89414,offset,vec__89411,acc,t2,G__89627,op1,o1,end_flake,base_result,s,node_start,p1,subject_fn,object_fn,idx_compare,op2,m2,novelty,inst_89504,inst_89613,inst_89599,inst_89505,inst_89508,inst_89430,inst_89452,inst_89429,inst_89586,inst_89604,inst_89423,inst_89618,inst_89473,inst_89620,inst_89517,inst_89418,inst_89425,inst_89603,inst_89453,inst_89553,inst_89585,inst_89619,inst_89609,inst_89535,inst_89564,inst_89563,inst_89544,inst_89526,inst_89454,inst_89594,inst_89562,inst_89593,inst_89617,inst_89464,inst_89616,inst_89422,inst_89598,inst_89626,inst_89592,state_val_89792,c__86675__auto__){
return (function (p1__89387_SHARP_){
return cljs.core._EQ_.call(null,p1__89387_SHARP_.o,start_flake.o);
});
;})(no_filter_QMARK_,t,max_limit_QMARK_,next_node,fast_forward_db_QMARK_,s1,o2,vec__89407,t1,predicate_fn,i,map__89410,m1,root_node,s2,p2,map__89417,permissions,limit,vec__89404,start_flake,flake_limit,vec__89414,offset,vec__89411,acc,t2,G__89627,op1,o1,end_flake,base_result,s,node_start,p1,subject_fn,object_fn,idx_compare,op2,m2,novelty,inst_89504,inst_89613,inst_89599,inst_89505,inst_89508,inst_89430,inst_89452,inst_89429,inst_89586,inst_89604,inst_89423,inst_89618,inst_89473,inst_89620,inst_89517,inst_89418,inst_89425,inst_89603,inst_89453,inst_89553,inst_89585,inst_89619,inst_89609,inst_89535,inst_89564,inst_89563,inst_89544,inst_89526,inst_89454,inst_89594,inst_89562,inst_89593,inst_89617,inst_89464,inst_89616,inst_89422,inst_89598,inst_89626,inst_89592,state_val_89792,c__86675__auto__))
})();
var inst_89631 = cljs.core.filter.call(null,inst_89630,inst_89626);
var state_89791__$1 = state_89791;
var statearr_89828_90019 = state_89791__$1;
(statearr_89828_90019[(2)] = inst_89631);

(statearr_89828_90019[(1)] = (87));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (39))){
var inst_89507 = (state_89791[(59)]);
var state_89791__$1 = state_89791;
var statearr_89829_90020 = state_89791__$1;
(statearr_89829_90020[(2)] = inst_89507);

(statearr_89829_90020[(1)] = (40));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (88))){
var inst_89504 = (state_89791[(43)]);
var inst_89613 = (state_89791[(44)]);
var inst_89599 = (state_89791[(45)]);
var inst_89505 = (state_89791[(46)]);
var inst_89508 = (state_89791[(47)]);
var inst_89430 = (state_89791[(8)]);
var inst_89452 = (state_89791[(48)]);
var inst_89429 = (state_89791[(9)]);
var inst_89586 = (state_89791[(24)]);
var inst_89604 = (state_89791[(49)]);
var inst_89423 = (state_89791[(10)]);
var inst_89618 = (state_89791[(26)]);
var inst_89473 = (state_89791[(11)]);
var inst_89620 = (state_89791[(35)]);
var inst_89517 = (state_89791[(12)]);
var inst_89418 = (state_89791[(50)]);
var inst_89425 = (state_89791[(51)]);
var inst_89603 = (state_89791[(52)]);
var inst_89634 = (state_89791[(60)]);
var inst_89453 = (state_89791[(53)]);
var inst_89553 = (state_89791[(13)]);
var inst_89585 = (state_89791[(22)]);
var inst_89619 = (state_89791[(28)]);
var inst_89609 = (state_89791[(54)]);
var inst_89535 = (state_89791[(14)]);
var inst_89564 = (state_89791[(20)]);
var inst_89563 = (state_89791[(21)]);
var inst_89544 = (state_89791[(15)]);
var inst_89526 = (state_89791[(16)]);
var inst_89454 = (state_89791[(55)]);
var inst_89594 = (state_89791[(56)]);
var inst_89562 = (state_89791[(17)]);
var inst_89593 = (state_89791[(57)]);
var inst_89617 = (state_89791[(36)]);
var inst_89464 = (state_89791[(18)]);
var inst_89616 = (state_89791[(37)]);
var inst_89422 = (state_89791[(19)]);
var inst_89598 = (state_89791[(58)]);
var inst_89626 = (state_89791[(38)]);
var inst_89592 = (state_89791[(29)]);
var inst_89636 = (function (){var no_filter_QMARK_ = true;
var t = inst_89599;
var max_limit_QMARK_ = inst_89593;
var next_node = inst_89616;
var fast_forward_db_QMARK_ = inst_89604;
var s1 = inst_89464;
var o2 = inst_89526;
var vec__89407 = inst_89425;
var t1 = inst_89422;
var predicate_fn = inst_89454;
var i = inst_89618;
var map__89410 = inst_89452;
var m1 = inst_89553;
var root_node = inst_89609;
var s2 = inst_89473;
var p2 = inst_89544;
var map__89417 = inst_89585;
var permissions = inst_89594;
var limit = inst_89592;
var vec__89404 = inst_89418;
var start_flake = inst_89563;
var flake_limit = inst_89586;
var vec__89414 = inst_89505;
var offset = inst_89617;
var vec__89411 = inst_89504;
var acc = inst_89620;
var t2 = inst_89429;
var G__89627 = inst_89634;
var op1 = inst_89423;
var o1 = inst_89517;
var end_flake = inst_89564;
var base_result = inst_89626;
var s = inst_89619;
var node_start = inst_89613;
var p1 = inst_89535;
var subject_fn = inst_89453;
var object_fn = inst_89508;
var idx_compare = inst_89598;
var op2 = inst_89430;
var m2 = inst_89562;
var novelty = inst_89603;
return ((function (no_filter_QMARK_,t,max_limit_QMARK_,next_node,fast_forward_db_QMARK_,s1,o2,vec__89407,t1,predicate_fn,i,map__89410,m1,root_node,s2,p2,map__89417,permissions,limit,vec__89404,start_flake,flake_limit,vec__89414,offset,vec__89411,acc,t2,G__89627,op1,o1,end_flake,base_result,s,node_start,p1,subject_fn,object_fn,idx_compare,op2,m2,novelty,inst_89504,inst_89613,inst_89599,inst_89505,inst_89508,inst_89430,inst_89452,inst_89429,inst_89586,inst_89604,inst_89423,inst_89618,inst_89473,inst_89620,inst_89517,inst_89418,inst_89425,inst_89603,inst_89634,inst_89453,inst_89553,inst_89585,inst_89619,inst_89609,inst_89535,inst_89564,inst_89563,inst_89544,inst_89526,inst_89454,inst_89594,inst_89562,inst_89593,inst_89617,inst_89464,inst_89616,inst_89422,inst_89598,inst_89626,inst_89592,state_val_89792,c__86675__auto__){
return (function (p1__89388_SHARP_){
return subject_fn.call(null,p1__89388_SHARP_.s);
});
;})(no_filter_QMARK_,t,max_limit_QMARK_,next_node,fast_forward_db_QMARK_,s1,o2,vec__89407,t1,predicate_fn,i,map__89410,m1,root_node,s2,p2,map__89417,permissions,limit,vec__89404,start_flake,flake_limit,vec__89414,offset,vec__89411,acc,t2,G__89627,op1,o1,end_flake,base_result,s,node_start,p1,subject_fn,object_fn,idx_compare,op2,m2,novelty,inst_89504,inst_89613,inst_89599,inst_89505,inst_89508,inst_89430,inst_89452,inst_89429,inst_89586,inst_89604,inst_89423,inst_89618,inst_89473,inst_89620,inst_89517,inst_89418,inst_89425,inst_89603,inst_89634,inst_89453,inst_89553,inst_89585,inst_89619,inst_89609,inst_89535,inst_89564,inst_89563,inst_89544,inst_89526,inst_89454,inst_89594,inst_89562,inst_89593,inst_89617,inst_89464,inst_89616,inst_89422,inst_89598,inst_89626,inst_89592,state_val_89792,c__86675__auto__))
})();
var inst_89637 = cljs.core.filter.call(null,inst_89636,inst_89634);
var state_89791__$1 = state_89791;
var statearr_89830_90021 = state_89791__$1;
(statearr_89830_90021[(2)] = inst_89637);

(statearr_89830_90021[(1)] = (90));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (46))){
var inst_89420 = (state_89791[(61)]);
var state_89791__$1 = state_89791;
var statearr_89831_90022 = state_89791__$1;
(statearr_89831_90022[(2)] = inst_89420);

(statearr_89831_90022[(1)] = (47));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (4))){
var inst_89418 = (state_89791[(50)]);
var inst_89425 = (state_89791[(51)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_89791,(3),Error,null,(2));
var inst_89418__$1 = fluree.db.query.range.match__GT_flake_parts.call(null,db,idx,start_match);
var inst_89419 = cljs.core.nth.call(null,inst_89418__$1,(0),null);
var inst_89420 = cljs.core.nth.call(null,inst_89418__$1,(1),null);
var inst_89421 = cljs.core.nth.call(null,inst_89418__$1,(2),null);
var inst_89422 = cljs.core.nth.call(null,inst_89418__$1,(3),null);
var inst_89423 = cljs.core.nth.call(null,inst_89418__$1,(4),null);
var inst_89424 = cljs.core.nth.call(null,inst_89418__$1,(5),null);
var inst_89425__$1 = fluree.db.query.range.match__GT_flake_parts.call(null,db,idx,end_match);
var inst_89426 = cljs.core.nth.call(null,inst_89425__$1,(0),null);
var inst_89427 = cljs.core.nth.call(null,inst_89425__$1,(1),null);
var inst_89428 = cljs.core.nth.call(null,inst_89425__$1,(2),null);
var inst_89429 = cljs.core.nth.call(null,inst_89425__$1,(3),null);
var inst_89430 = cljs.core.nth.call(null,inst_89425__$1,(4),null);
var inst_89431 = cljs.core.nth.call(null,inst_89425__$1,(5),null);
var inst_89433 = (opts == null);
var inst_89434 = cljs.core.not.call(null,inst_89433);
var state_89791__$1 = (function (){var statearr_89832 = state_89791;
(statearr_89832[(39)] = inst_89421);

(statearr_89832[(8)] = inst_89430);

(statearr_89832[(62)] = inst_89424);

(statearr_89832[(63)] = inst_89419);

(statearr_89832[(64)] = inst_89426);

(statearr_89832[(9)] = inst_89429);

(statearr_89832[(10)] = inst_89423);

(statearr_89832[(65)] = inst_89427);

(statearr_89832[(40)] = inst_89431);

(statearr_89832[(50)] = inst_89418__$1);

(statearr_89832[(51)] = inst_89425__$1);

(statearr_89832[(61)] = inst_89420);

(statearr_89832[(66)] = inst_89428);

(statearr_89832[(19)] = inst_89422);

return statearr_89832;
})();
if(inst_89434){
var statearr_89833_90023 = state_89791__$1;
(statearr_89833_90023[(1)] = (5));

} else {
var statearr_89834_90024 = state_89791__$1;
(statearr_89834_90024[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (77))){
var inst_89592 = (state_89791[(29)]);
var inst_89592__$1 = (state_89791[(2)]);
var inst_89593 = cljs.core._EQ_.call(null,inst_89592__$1,fluree.db.util.core.max_long);
var inst_89594 = new cljs.core.Keyword(null,"permissions","permissions",67803075).cljs$core$IFn$_invoke$arity$1(db);
var inst_89595 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89596 = [new cljs.core.Keyword(null,"index-configs","index-configs",1053959280),idx,new cljs.core.Keyword(null,"comparator","comparator",2144896662)];
var inst_89597 = (new cljs.core.PersistentVector(null,3,(5),inst_89595,inst_89596,null));
var inst_89598 = cljs.core.get_in.call(null,db,inst_89597);
var inst_89599 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(db);
var inst_89600 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89601 = [new cljs.core.Keyword(null,"novelty","novelty",-1590246024),idx];
var inst_89602 = (new cljs.core.PersistentVector(null,2,(5),inst_89600,inst_89601,null));
var inst_89603 = cljs.core.get_in.call(null,db,inst_89602);
var inst_89604 = new cljs.core.Keyword(null,"tt-id","tt-id",725587484).cljs$core$IFn$_invoke$arity$1(db);
var inst_89605 = cljs.core.get.call(null,db,idx);
var inst_89606 = fluree.db.dbproto._resolve.call(null,inst_89605);
var state_89791__$1 = (function (){var statearr_89835 = state_89791;
(statearr_89835[(45)] = inst_89599);

(statearr_89835[(49)] = inst_89604);

(statearr_89835[(52)] = inst_89603);

(statearr_89835[(56)] = inst_89594);

(statearr_89835[(57)] = inst_89593);

(statearr_89835[(58)] = inst_89598);

(statearr_89835[(29)] = inst_89592__$1);

return statearr_89835;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89791__$1,(78),inst_89606);
} else {
if((state_val_89792 === (106))){
var inst_89675 = (state_89791[(67)]);
var inst_89618 = (state_89791[(26)]);
var inst_89620 = (state_89791[(35)]);
var inst_89619 = (state_89791[(28)]);
var inst_89617 = (state_89791[(36)]);
var inst_89678 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89679 = (inst_89617 - inst_89675);
var inst_89680 = [inst_89679,inst_89618,inst_89619,inst_89620];
var inst_89681 = (new cljs.core.PersistentVector(null,4,(5),inst_89678,inst_89680,null));
var state_89791__$1 = state_89791;
var statearr_89836_90025 = state_89791__$1;
(statearr_89836_90025[(2)] = inst_89681);

(statearr_89836_90025[(1)] = (108));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (119))){
var inst_89753 = (state_89791[(30)]);
var inst_89586 = (state_89791[(24)]);
var inst_89653 = (state_89791[(68)]);
var inst_89564 = (state_89791[(20)]);
var inst_89754 = (state_89791[(33)]);
var inst_89598 = (state_89791[(58)]);
var inst_89592 = (state_89791[(29)]);
var inst_89757 = inst_89598.call(null,inst_89653,inst_89564);
var inst_89758 = (inst_89757 < (0));
var inst_89759 = (inst_89753 < inst_89586);
var inst_89760 = (inst_89754 < inst_89592);
var inst_89761 = ((inst_89758) && (inst_89759) && (inst_89760));
var state_89791__$1 = state_89791;
var statearr_89837_90026 = state_89791__$1;
(statearr_89837_90026[(2)] = inst_89761);

(statearr_89837_90026[(1)] = (121));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (95))){
var inst_89646 = (state_89791[(69)]);
var state_89791__$1 = state_89791;
var statearr_89838_90027 = state_89791__$1;
(statearr_89838_90027[(2)] = inst_89646);

(statearr_89838_90027[(1)] = (96));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (54))){
var inst_89424 = (state_89791[(62)]);
var state_89791__$1 = state_89791;
var statearr_89839_90028 = state_89791__$1;
(statearr_89839_90028[(2)] = inst_89424);

(statearr_89839_90028[(1)] = (56));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (92))){
var inst_89640 = (state_89791[(70)]);
var state_89791__$1 = state_89791;
var statearr_89840_90029 = state_89791__$1;
(statearr_89840_90029[(2)] = inst_89640);

(statearr_89840_90029[(1)] = (93));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (104))){
var inst_89504 = (state_89791[(43)]);
var inst_89613 = (state_89791[(44)]);
var inst_89599 = (state_89791[(45)]);
var inst_89505 = (state_89791[(46)]);
var inst_89508 = (state_89791[(47)]);
var inst_89675 = (state_89791[(67)]);
var inst_89430 = (state_89791[(8)]);
var inst_89452 = (state_89791[(48)]);
var inst_89429 = (state_89791[(9)]);
var inst_89586 = (state_89791[(24)]);
var inst_89604 = (state_89791[(49)]);
var inst_89423 = (state_89791[(10)]);
var inst_89618 = (state_89791[(26)]);
var inst_89473 = (state_89791[(11)]);
var inst_89653 = (state_89791[(68)]);
var inst_89620 = (state_89791[(35)]);
var inst_89517 = (state_89791[(12)]);
var inst_89418 = (state_89791[(50)]);
var inst_89652 = (state_89791[(71)]);
var inst_89425 = (state_89791[(51)]);
var inst_89603 = (state_89791[(52)]);
var inst_89453 = (state_89791[(53)]);
var inst_89553 = (state_89791[(13)]);
var inst_89585 = (state_89791[(22)]);
var inst_89619 = (state_89791[(28)]);
var inst_89609 = (state_89791[(54)]);
var inst_89535 = (state_89791[(14)]);
var inst_89564 = (state_89791[(20)]);
var inst_89674 = (state_89791[(72)]);
var inst_89563 = (state_89791[(21)]);
var inst_89544 = (state_89791[(15)]);
var inst_89526 = (state_89791[(16)]);
var inst_89454 = (state_89791[(55)]);
var inst_89594 = (state_89791[(56)]);
var inst_89562 = (state_89791[(17)]);
var inst_89593 = (state_89791[(57)]);
var inst_89617 = (state_89791[(36)]);
var inst_89464 = (state_89791[(18)]);
var inst_89616 = (state_89791[(37)]);
var inst_89422 = (state_89791[(19)]);
var inst_89598 = (state_89791[(58)]);
var inst_89626 = (state_89791[(38)]);
var inst_89592 = (state_89791[(29)]);
var inst_89673 = (function (){var no_filter_QMARK_ = true;
var base_result_SINGLEQUOTE_ = inst_89652;
var t = inst_89599;
var max_limit_QMARK_ = inst_89593;
var next_node = inst_89616;
var fast_forward_db_QMARK_ = inst_89604;
var s1 = inst_89464;
var o2 = inst_89526;
var vec__89407 = inst_89425;
var t1 = inst_89422;
var predicate_fn = inst_89454;
var i = inst_89618;
var rhs = inst_89653;
var map__89410 = inst_89452;
var m1 = inst_89553;
var root_node = inst_89609;
var s2 = inst_89473;
var p2 = inst_89544;
var map__89417 = inst_89585;
var permissions = inst_89594;
var limit = inst_89592;
var vec__89404 = inst_89418;
var start_flake = inst_89563;
var flake_limit = inst_89586;
var vec__89414 = inst_89505;
var offset = inst_89617;
var vec__89411 = inst_89504;
var acc = inst_89620;
var t2 = inst_89429;
var op1 = inst_89423;
var o1 = inst_89517;
var end_flake = inst_89564;
var base_result = inst_89626;
var s = inst_89619;
var node_start = inst_89613;
var p1 = inst_89535;
var subject_fn = inst_89453;
var object_fn = inst_89508;
var idx_compare = inst_89598;
var op2 = inst_89430;
var m2 = inst_89562;
var novelty = inst_89603;
return ((function (no_filter_QMARK_,base_result_SINGLEQUOTE_,t,max_limit_QMARK_,next_node,fast_forward_db_QMARK_,s1,o2,vec__89407,t1,predicate_fn,i,rhs,map__89410,m1,root_node,s2,p2,map__89417,permissions,limit,vec__89404,start_flake,flake_limit,vec__89414,offset,vec__89411,acc,t2,op1,o1,end_flake,base_result,s,node_start,p1,subject_fn,object_fn,idx_compare,op2,m2,novelty,inst_89504,inst_89613,inst_89599,inst_89505,inst_89508,inst_89675,inst_89430,inst_89452,inst_89429,inst_89586,inst_89604,inst_89423,inst_89618,inst_89473,inst_89653,inst_89620,inst_89517,inst_89418,inst_89652,inst_89425,inst_89603,inst_89453,inst_89553,inst_89585,inst_89619,inst_89609,inst_89535,inst_89564,inst_89674,inst_89563,inst_89544,inst_89526,inst_89454,inst_89594,inst_89562,inst_89593,inst_89617,inst_89464,inst_89616,inst_89422,inst_89598,inst_89626,inst_89592,state_val_89792,c__86675__auto__){
return (function (p1__89391_SHARP_){
return p1__89391_SHARP_.s;
});
;})(no_filter_QMARK_,base_result_SINGLEQUOTE_,t,max_limit_QMARK_,next_node,fast_forward_db_QMARK_,s1,o2,vec__89407,t1,predicate_fn,i,rhs,map__89410,m1,root_node,s2,p2,map__89417,permissions,limit,vec__89404,start_flake,flake_limit,vec__89414,offset,vec__89411,acc,t2,op1,o1,end_flake,base_result,s,node_start,p1,subject_fn,object_fn,idx_compare,op2,m2,novelty,inst_89504,inst_89613,inst_89599,inst_89505,inst_89508,inst_89675,inst_89430,inst_89452,inst_89429,inst_89586,inst_89604,inst_89423,inst_89618,inst_89473,inst_89653,inst_89620,inst_89517,inst_89418,inst_89652,inst_89425,inst_89603,inst_89453,inst_89553,inst_89585,inst_89619,inst_89609,inst_89535,inst_89564,inst_89674,inst_89563,inst_89544,inst_89526,inst_89454,inst_89594,inst_89562,inst_89593,inst_89617,inst_89464,inst_89616,inst_89422,inst_89598,inst_89626,inst_89592,state_val_89792,c__86675__auto__))
})();
var inst_89674__$1 = cljs.core.partition_by.call(null,inst_89673,inst_89652);
var inst_89675__$1 = cljs.core.count.call(null,inst_89674__$1);
var inst_89676 = (inst_89617 > inst_89675__$1);
var state_89791__$1 = (function (){var statearr_89841 = state_89791;
(statearr_89841[(67)] = inst_89675__$1);

(statearr_89841[(72)] = inst_89674__$1);

return statearr_89841;
})();
if(cljs.core.truth_(inst_89676)){
var statearr_89842_90030 = state_89791__$1;
(statearr_89842_90030[(1)] = (106));

} else {
var statearr_89843_90031 = state_89791__$1;
(statearr_89843_90031[(1)] = (107));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (15))){
var inst_89419 = (state_89791[(63)]);
var state_89791__$1 = state_89791;
var statearr_89844_90032 = state_89791__$1;
(statearr_89844_90032[(2)] = inst_89419);

(statearr_89844_90032[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (48))){
var inst_89526 = (state_89791[(16)]);
var state_89791__$1 = state_89791;
var statearr_89845_90033 = state_89791__$1;
(statearr_89845_90033[(2)] = inst_89526);

(statearr_89845_90033[(1)] = (50));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (50))){
var inst_89540 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
if(cljs.core.truth_(inst_89540)){
var statearr_89846_90034 = state_89791__$1;
(statearr_89846_90034[(1)] = (51));

} else {
var statearr_89847_90035 = state_89791__$1;
(statearr_89847_90035[(1)] = (52));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (116))){
var inst_89714 = (state_89791[(73)]);
var inst_89712 = (state_89791[(74)]);
var inst_89724 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89725 = [inst_89714,inst_89712];
var inst_89726 = (new cljs.core.PersistentVector(null,2,(5),inst_89724,inst_89725,null));
var state_89791__$1 = state_89791;
var statearr_89848_90036 = state_89791__$1;
(statearr_89848_90036[(2)] = inst_89726);

(statearr_89848_90036[(1)] = (117));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (75))){
var inst_89587 = (state_89791[(23)]);
var state_89791__$1 = state_89791;
var statearr_89849_90037 = state_89791__$1;
(statearr_89849_90037[(2)] = inst_89587);

(statearr_89849_90037[(1)] = (77));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (99))){
var inst_89662 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
if(cljs.core.truth_(inst_89662)){
var statearr_89850_90038 = state_89791__$1;
(statearr_89850_90038[(1)] = (103));

} else {
var statearr_89851_90039 = state_89791__$1;
(statearr_89851_90039[(1)] = (104));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (21))){
var inst_89469 = (state_89791[(2)]);
var inst_89470 = fluree.db.util.async.throw_err.call(null,inst_89469);
var state_89791__$1 = state_89791;
var statearr_89852_90040 = state_89791__$1;
(statearr_89852_90040[(2)] = inst_89470);

(statearr_89852_90040[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (31))){
var inst_89421 = (state_89791[(39)]);
var inst_89430 = (state_89791[(8)]);
var inst_89424 = (state_89791[(62)]);
var inst_89452 = (state_89791[(48)]);
var inst_89429 = (state_89791[(9)]);
var inst_89423 = (state_89791[(10)]);
var inst_89455 = (state_89791[(75)]);
var inst_89427 = (state_89791[(65)]);
var inst_89473 = (state_89791[(11)]);
var inst_89431 = (state_89791[(40)]);
var inst_89418 = (state_89791[(50)]);
var inst_89425 = (state_89791[(51)]);
var inst_89453 = (state_89791[(53)]);
var inst_89420 = (state_89791[(61)]);
var inst_89454 = (state_89791[(55)]);
var inst_89487 = (state_89791[(42)]);
var inst_89428 = (state_89791[(66)]);
var inst_89464 = (state_89791[(18)]);
var inst_89422 = (state_89791[(19)]);
var inst_89489 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89490 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89491 = [null,null];
var inst_89492 = (new cljs.core.PersistentVector(null,2,(5),inst_89490,inst_89491,null));
var inst_89493 = (function (){var bool = inst_89487;
var temp__5733__auto__ = inst_89487;
var s1 = inst_89464;
var o2 = inst_89428;
var vec__89407 = inst_89425;
var t1 = inst_89422;
var predicate_fn = inst_89454;
var map__89410 = inst_89452;
var m1 = inst_89424;
var s2 = inst_89473;
var p2 = inst_89427;
var vec__89404 = inst_89418;
var t2 = inst_89429;
var op1 = inst_89423;
var o1 = inst_89421;
var p1 = inst_89420;
var subject_fn = inst_89453;
var object_fn = inst_89455;
var op2 = inst_89430;
var m2 = inst_89431;
return ((function (bool,temp__5733__auto__,s1,o2,vec__89407,t1,predicate_fn,map__89410,m1,s2,p2,vec__89404,t2,op1,o1,p1,subject_fn,object_fn,op2,m2,inst_89421,inst_89430,inst_89424,inst_89452,inst_89429,inst_89423,inst_89455,inst_89427,inst_89473,inst_89431,inst_89418,inst_89425,inst_89453,inst_89420,inst_89454,inst_89487,inst_89428,inst_89464,inst_89422,inst_89489,inst_89490,inst_89491,inst_89492,state_val_89792,c__86675__auto__){
return (function (o){
return cljs.core._EQ_.call(null,o,bool);
});
;})(bool,temp__5733__auto__,s1,o2,vec__89407,t1,predicate_fn,map__89410,m1,s2,p2,vec__89404,t2,op1,o1,p1,subject_fn,object_fn,op2,m2,inst_89421,inst_89430,inst_89424,inst_89452,inst_89429,inst_89423,inst_89455,inst_89427,inst_89473,inst_89431,inst_89418,inst_89425,inst_89453,inst_89420,inst_89454,inst_89487,inst_89428,inst_89464,inst_89422,inst_89489,inst_89490,inst_89491,inst_89492,state_val_89792,c__86675__auto__))
})();
var inst_89494 = [inst_89492,inst_89493];
var inst_89495 = (new cljs.core.PersistentVector(null,2,(5),inst_89489,inst_89494,null));
var state_89791__$1 = state_89791;
var statearr_89853_90041 = state_89791__$1;
(statearr_89853_90041[(2)] = inst_89495);

(statearr_89853_90041[(1)] = (33));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (113))){
var inst_89695 = (state_89791[(76)]);
var inst_89704 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89705 = [inst_89695,inst_89695];
var inst_89706 = (new cljs.core.PersistentVector(null,2,(5),inst_89704,inst_89705,null));
var state_89791__$1 = state_89791;
var statearr_89854_90042 = state_89791__$1;
(statearr_89854_90042[(2)] = inst_89706);

(statearr_89854_90042[(1)] = (114));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (32))){
var inst_89421 = (state_89791[(39)]);
var inst_89455 = (state_89791[(75)]);
var inst_89428 = (state_89791[(66)]);
var inst_89497 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89498 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89499 = [inst_89421,inst_89428];
var inst_89500 = (new cljs.core.PersistentVector(null,2,(5),inst_89498,inst_89499,null));
var inst_89501 = [inst_89500,inst_89455];
var inst_89502 = (new cljs.core.PersistentVector(null,2,(5),inst_89497,inst_89501,null));
var state_89791__$1 = state_89791;
var statearr_89855_90043 = state_89791__$1;
(statearr_89855_90043[(2)] = inst_89502);

(statearr_89855_90043[(1)] = (33));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (40))){
var inst_89527 = (state_89791[(77)]);
var inst_89420 = (state_89791[(61)]);
var inst_89526 = (state_89791[(2)]);
var inst_89527__$1 = (inst_89420 == null);
var state_89791__$1 = (function (){var statearr_89856 = state_89791;
(statearr_89856[(77)] = inst_89527__$1);

(statearr_89856[(16)] = inst_89526);

return statearr_89856;
})();
if(cljs.core.truth_(inst_89527__$1)){
var statearr_89857_90044 = state_89791__$1;
(statearr_89857_90044[(1)] = (42));

} else {
var statearr_89858_90045 = state_89791__$1;
(statearr_89858_90045[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (129))){
var inst_89755 = (state_89791[(32)]);
var state_89791__$1 = state_89791;
var statearr_89859_90046 = state_89791__$1;
(statearr_89859_90046[(2)] = inst_89755);

(statearr_89859_90046[(1)] = (131));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (91))){
var inst_89504 = (state_89791[(43)]);
var inst_89613 = (state_89791[(44)]);
var inst_89640 = (state_89791[(70)]);
var inst_89599 = (state_89791[(45)]);
var inst_89505 = (state_89791[(46)]);
var inst_89508 = (state_89791[(47)]);
var inst_89430 = (state_89791[(8)]);
var inst_89452 = (state_89791[(48)]);
var inst_89429 = (state_89791[(9)]);
var inst_89586 = (state_89791[(24)]);
var inst_89604 = (state_89791[(49)]);
var inst_89423 = (state_89791[(10)]);
var inst_89618 = (state_89791[(26)]);
var inst_89473 = (state_89791[(11)]);
var inst_89620 = (state_89791[(35)]);
var inst_89517 = (state_89791[(12)]);
var inst_89418 = (state_89791[(50)]);
var inst_89425 = (state_89791[(51)]);
var inst_89603 = (state_89791[(52)]);
var inst_89453 = (state_89791[(53)]);
var inst_89553 = (state_89791[(13)]);
var inst_89585 = (state_89791[(22)]);
var inst_89619 = (state_89791[(28)]);
var inst_89609 = (state_89791[(54)]);
var inst_89535 = (state_89791[(14)]);
var inst_89564 = (state_89791[(20)]);
var inst_89563 = (state_89791[(21)]);
var inst_89544 = (state_89791[(15)]);
var inst_89526 = (state_89791[(16)]);
var inst_89454 = (state_89791[(55)]);
var inst_89594 = (state_89791[(56)]);
var inst_89562 = (state_89791[(17)]);
var inst_89593 = (state_89791[(57)]);
var inst_89617 = (state_89791[(36)]);
var inst_89464 = (state_89791[(18)]);
var inst_89616 = (state_89791[(37)]);
var inst_89422 = (state_89791[(19)]);
var inst_89598 = (state_89791[(58)]);
var inst_89626 = (state_89791[(38)]);
var inst_89592 = (state_89791[(29)]);
var inst_89642 = (function (){var no_filter_QMARK_ = true;
var t = inst_89599;
var max_limit_QMARK_ = inst_89593;
var next_node = inst_89616;
var fast_forward_db_QMARK_ = inst_89604;
var s1 = inst_89464;
var o2 = inst_89526;
var vec__89407 = inst_89425;
var t1 = inst_89422;
var predicate_fn = inst_89454;
var i = inst_89618;
var map__89410 = inst_89452;
var m1 = inst_89553;
var root_node = inst_89609;
var s2 = inst_89473;
var p2 = inst_89544;
var map__89417 = inst_89585;
var permissions = inst_89594;
var limit = inst_89592;
var vec__89404 = inst_89418;
var start_flake = inst_89563;
var flake_limit = inst_89586;
var vec__89414 = inst_89505;
var offset = inst_89617;
var vec__89411 = inst_89504;
var acc = inst_89620;
var t2 = inst_89429;
var G__89627 = inst_89640;
var op1 = inst_89423;
var o1 = inst_89517;
var end_flake = inst_89564;
var base_result = inst_89626;
var s = inst_89619;
var node_start = inst_89613;
var p1 = inst_89535;
var subject_fn = inst_89453;
var object_fn = inst_89508;
var idx_compare = inst_89598;
var op2 = inst_89430;
var m2 = inst_89562;
var novelty = inst_89603;
return ((function (no_filter_QMARK_,t,max_limit_QMARK_,next_node,fast_forward_db_QMARK_,s1,o2,vec__89407,t1,predicate_fn,i,map__89410,m1,root_node,s2,p2,map__89417,permissions,limit,vec__89404,start_flake,flake_limit,vec__89414,offset,vec__89411,acc,t2,G__89627,op1,o1,end_flake,base_result,s,node_start,p1,subject_fn,object_fn,idx_compare,op2,m2,novelty,inst_89504,inst_89613,inst_89640,inst_89599,inst_89505,inst_89508,inst_89430,inst_89452,inst_89429,inst_89586,inst_89604,inst_89423,inst_89618,inst_89473,inst_89620,inst_89517,inst_89418,inst_89425,inst_89603,inst_89453,inst_89553,inst_89585,inst_89619,inst_89609,inst_89535,inst_89564,inst_89563,inst_89544,inst_89526,inst_89454,inst_89594,inst_89562,inst_89593,inst_89617,inst_89464,inst_89616,inst_89422,inst_89598,inst_89626,inst_89592,state_val_89792,c__86675__auto__){
return (function (p1__89389_SHARP_){
return predicate_fn.call(null,p1__89389_SHARP_.p);
});
;})(no_filter_QMARK_,t,max_limit_QMARK_,next_node,fast_forward_db_QMARK_,s1,o2,vec__89407,t1,predicate_fn,i,map__89410,m1,root_node,s2,p2,map__89417,permissions,limit,vec__89404,start_flake,flake_limit,vec__89414,offset,vec__89411,acc,t2,G__89627,op1,o1,end_flake,base_result,s,node_start,p1,subject_fn,object_fn,idx_compare,op2,m2,novelty,inst_89504,inst_89613,inst_89640,inst_89599,inst_89505,inst_89508,inst_89430,inst_89452,inst_89429,inst_89586,inst_89604,inst_89423,inst_89618,inst_89473,inst_89620,inst_89517,inst_89418,inst_89425,inst_89603,inst_89453,inst_89553,inst_89585,inst_89619,inst_89609,inst_89535,inst_89564,inst_89563,inst_89544,inst_89526,inst_89454,inst_89594,inst_89562,inst_89593,inst_89617,inst_89464,inst_89616,inst_89422,inst_89598,inst_89626,inst_89592,state_val_89792,c__86675__auto__))
})();
var inst_89643 = cljs.core.filter.call(null,inst_89642,inst_89640);
var state_89791__$1 = state_89791;
var statearr_89860_90047 = state_89791__$1;
(statearr_89860_90047[(2)] = inst_89643);

(statearr_89860_90047[(1)] = (93));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (117))){
var inst_89709 = (state_89791[(78)]);
var inst_89728 = (state_89791[(2)]);
var inst_89729 = cljs.core.nth.call(null,inst_89728,(0),null);
var inst_89730 = cljs.core.nth.call(null,inst_89728,(1),null);
var inst_89731 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89732 = [inst_89729,inst_89709,inst_89730];
var inst_89733 = (new cljs.core.PersistentVector(null,3,(5),inst_89731,inst_89732,null));
var state_89791__$1 = state_89791;
var statearr_89861_90048 = state_89791__$1;
(statearr_89861_90048[(2)] = inst_89733);

(statearr_89861_90048[(1)] = (111));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (108))){
var inst_89749 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89862_90049 = state_89791__$1;
(statearr_89862_90049[(2)] = inst_89749);

(statearr_89862_90049[(1)] = (105));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (56))){
var inst_89431 = (state_89791[(40)]);
var inst_89553 = (state_89791[(2)]);
var state_89791__$1 = (function (){var statearr_89863 = state_89791;
(statearr_89863[(13)] = inst_89553);

return statearr_89863;
})();
if(cljs.core.truth_(inst_89431)){
var statearr_89864_90050 = state_89791__$1;
(statearr_89864_90050[(1)] = (60));

} else {
var statearr_89865_90051 = state_89791__$1;
(statearr_89865_90051[(1)] = (61));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (33))){
var inst_89506 = (state_89791[(79)]);
var inst_89504 = (state_89791[(43)]);
var inst_89505 = (state_89791[(46)]);
var inst_89504__$1 = (state_89791[(2)]);
var inst_89505__$1 = cljs.core.nth.call(null,inst_89504__$1,(0),null);
var inst_89506__$1 = cljs.core.nth.call(null,inst_89505__$1,(0),null);
var inst_89507 = cljs.core.nth.call(null,inst_89505__$1,(1),null);
var inst_89508 = cljs.core.nth.call(null,inst_89504__$1,(1),null);
var inst_89509 = fluree.db.util.core.pred_ident_QMARK_.call(null,inst_89506__$1);
var state_89791__$1 = (function (){var statearr_89866 = state_89791;
(statearr_89866[(79)] = inst_89506__$1);

(statearr_89866[(43)] = inst_89504__$1);

(statearr_89866[(46)] = inst_89505__$1);

(statearr_89866[(47)] = inst_89508);

(statearr_89866[(59)] = inst_89507);

return statearr_89866;
})();
if(inst_89509){
var statearr_89867_90052 = state_89791__$1;
(statearr_89867_90052[(1)] = (34));

} else {
var statearr_89868_90053 = state_89791__$1;
(statearr_89868_90053[(1)] = (35));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (13))){
var inst_89419 = (state_89791[(63)]);
var inst_89452 = (state_89791[(48)]);
var inst_89452__$1 = (state_89791[(2)]);
var inst_89453 = cljs.core.get.call(null,inst_89452__$1,new cljs.core.Keyword(null,"subject-fn","subject-fn",-581375441));
var inst_89454 = cljs.core.get.call(null,inst_89452__$1,new cljs.core.Keyword(null,"predicate-fn","predicate-fn",418606845));
var inst_89455 = cljs.core.get.call(null,inst_89452__$1,new cljs.core.Keyword(null,"object-fn","object-fn",1425858481));
var inst_89456 = fluree.db.util.core.pred_ident_QMARK_.call(null,inst_89419);
var state_89791__$1 = (function (){var statearr_89869 = state_89791;
(statearr_89869[(48)] = inst_89452__$1);

(statearr_89869[(75)] = inst_89455);

(statearr_89869[(53)] = inst_89453);

(statearr_89869[(55)] = inst_89454);

return statearr_89869;
})();
if(inst_89456){
var statearr_89870_90054 = state_89791__$1;
(statearr_89870_90054[(1)] = (14));

} else {
var statearr_89871_90055 = state_89791__$1;
(statearr_89871_90055[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (22))){
var inst_89421 = (state_89791[(39)]);
var state_89791__$1 = state_89791;
var statearr_89872_90056 = state_89791__$1;
(statearr_89872_90056[(2)] = inst_89421);

(statearr_89872_90056[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (90))){
var inst_89454 = (state_89791[(55)]);
var inst_89640 = (state_89791[(2)]);
var state_89791__$1 = (function (){var statearr_89873 = state_89791;
(statearr_89873[(70)] = inst_89640);

return statearr_89873;
})();
if(cljs.core.truth_(inst_89454)){
var statearr_89874_90057 = state_89791__$1;
(statearr_89874_90057[(1)] = (91));

} else {
var statearr_89875_90058 = state_89791__$1;
(statearr_89875_90058[(1)] = (92));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (109))){
var inst_89696 = (state_89791[(80)]);
var inst_89694 = (state_89791[(81)]);
var inst_89686 = (state_89791[(27)]);
var inst_89619 = (state_89791[(28)]);
var inst_89592 = (state_89791[(29)]);
var inst_89695 = (state_89791[(76)]);
var inst_89694__$1 = cljs.core.count.call(null,inst_89686);
var inst_89695__$1 = (inst_89619 + inst_89694__$1);
var inst_89696__$1 = (inst_89695__$1 - inst_89592);
var inst_89697 = cljs.core.pos_int_QMARK_.call(null,inst_89696__$1);
var state_89791__$1 = (function (){var statearr_89876 = state_89791;
(statearr_89876[(80)] = inst_89696__$1);

(statearr_89876[(81)] = inst_89694__$1);

(statearr_89876[(76)] = inst_89695__$1);

return statearr_89876;
})();
if(inst_89697){
var statearr_89877_90059 = state_89791__$1;
(statearr_89877_90059[(1)] = (112));

} else {
var statearr_89878_90060 = state_89791__$1;
(statearr_89878_90060[(1)] = (113));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (36))){
var inst_89507 = (state_89791[(59)]);
var inst_89517 = (state_89791[(2)]);
var inst_89518 = fluree.db.util.core.pred_ident_QMARK_.call(null,inst_89507);
var state_89791__$1 = (function (){var statearr_89879 = state_89791;
(statearr_89879[(12)] = inst_89517);

return statearr_89879;
})();
if(inst_89518){
var statearr_89880_90061 = state_89791__$1;
(statearr_89880_90061[(1)] = (38));

} else {
var statearr_89881_90062 = state_89791__$1;
(statearr_89881_90062[(1)] = (39));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (41))){
var inst_89522 = (state_89791[(2)]);
var inst_89523 = fluree.db.util.async.throw_err.call(null,inst_89522);
var state_89791__$1 = state_89791;
var statearr_89882_90063 = state_89791__$1;
(statearr_89882_90063[(2)] = inst_89523);

(statearr_89882_90063[(1)] = (40));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (118))){
var inst_89737 = (state_89791[(2)]);
var inst_89738 = fluree.db.util.async.throw_err.call(null,inst_89737);
var state_89791__$1 = state_89791;
var statearr_89883_90064 = state_89791__$1;
(statearr_89883_90064[(2)] = inst_89738);

(statearr_89883_90064[(1)] = (111));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (89))){
var inst_89634 = (state_89791[(60)]);
var state_89791__$1 = state_89791;
var statearr_89884_90065 = state_89791__$1;
(statearr_89884_90065[(2)] = inst_89634);

(statearr_89884_90065[(1)] = (90));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (100))){
var state_89791__$1 = state_89791;
var statearr_89885_90066 = state_89791__$1;
(statearr_89885_90066[(2)] = true);

(statearr_89885_90066[(1)] = (102));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (131))){
var inst_89782 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89886_90067 = state_89791__$1;
(statearr_89886_90067[(2)] = inst_89782);

(statearr_89886_90067[(1)] = (84));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (122))){
var inst_89599 = (state_89791[(45)]);
var inst_89604 = (state_89791[(49)]);
var inst_89653 = (state_89791[(68)]);
var inst_89603 = (state_89791[(52)]);
var inst_89609 = (state_89791[(54)]);
var inst_89766 = fluree.db.query.range.find_next_valid_node.call(null,inst_89609,inst_89653,inst_89599,inst_89603,inst_89604);
var state_89791__$1 = state_89791;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89791__$1,(125),inst_89766);
} else {
if((state_val_89792 === (43))){
var inst_89527 = (state_89791[(77)]);
var state_89791__$1 = state_89791;
var statearr_89887_90068 = state_89791__$1;
(statearr_89887_90068[(2)] = inst_89527);

(statearr_89887_90068[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (61))){
var inst_89556 = (cljs.core._LT__EQ_ === end_test);
var state_89791__$1 = state_89791;
if(cljs.core.truth_(inst_89556)){
var statearr_89888_90069 = state_89791__$1;
(statearr_89888_90069[(1)] = (63));

} else {
var statearr_89889_90070 = state_89791__$1;
(statearr_89889_90070[(1)] = (64));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (29))){
var state_89791__$1 = state_89791;
var statearr_89890_90071 = state_89791__$1;
(statearr_89890_90071[(2)] = null);

(statearr_89890_90071[(1)] = (30));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (44))){
var inst_89531 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
if(cljs.core.truth_(inst_89531)){
var statearr_89891_90072 = state_89791__$1;
(statearr_89891_90072[(1)] = (45));

} else {
var statearr_89892_90073 = state_89791__$1;
(statearr_89892_90073[(1)] = (46));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (93))){
var inst_89508 = (state_89791[(47)]);
var inst_89646 = (state_89791[(2)]);
var state_89791__$1 = (function (){var statearr_89893 = state_89791;
(statearr_89893[(69)] = inst_89646);

return statearr_89893;
})();
if(cljs.core.truth_(inst_89508)){
var statearr_89894_90074 = state_89791__$1;
(statearr_89894_90074[(1)] = (94));

} else {
var statearr_89895_90075 = state_89791__$1;
(statearr_89895_90075[(1)] = (95));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (6))){
var state_89791__$1 = state_89791;
var statearr_89896_90076 = state_89791__$1;
(statearr_89896_90076[(2)] = false);

(statearr_89896_90076[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (111))){
var inst_89620 = (state_89791[(35)]);
var inst_89740 = (state_89791[(2)]);
var inst_89741 = cljs.core.nth.call(null,inst_89740,(0),null);
var inst_89742 = cljs.core.nth.call(null,inst_89740,(1),null);
var inst_89743 = cljs.core.nth.call(null,inst_89740,(2),null);
var inst_89744 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89745 = cljs.core.into.call(null,inst_89620,inst_89743);
var inst_89746 = [(0),inst_89741,inst_89742,inst_89745];
var inst_89747 = (new cljs.core.PersistentVector(null,4,(5),inst_89744,inst_89746,null));
var state_89791__$1 = state_89791;
var statearr_89897_90077 = state_89791__$1;
(statearr_89897_90077[(2)] = inst_89747);

(statearr_89897_90077[(1)] = (108));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (28))){
var state_89791__$1 = state_89791;
var statearr_89898_90078 = state_89791__$1;
(statearr_89898_90078[(2)] = null);

(statearr_89898_90078[(1)] = (30));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (64))){
var state_89791__$1 = state_89791;
var statearr_89899_90079 = state_89791__$1;
(statearr_89899_90079[(2)] = fluree.db.util.core.min_integer);

(statearr_89899_90079[(1)] = (65));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (103))){
var inst_89586 = (state_89791[(24)]);
var inst_89618 = (state_89791[(26)]);
var inst_89620 = (state_89791[(35)]);
var inst_89652 = (state_89791[(71)]);
var inst_89619 = (state_89791[(28)]);
var inst_89664 = cljs.core.count.call(null,inst_89652);
var inst_89665 = (inst_89586 - inst_89618);
var inst_89666 = cljs.core.take.call(null,inst_89665,inst_89652);
var inst_89667 = cljs.core.into.call(null,inst_89620,inst_89666);
var inst_89668 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89669 = (inst_89618 + inst_89664);
var inst_89670 = [(0),inst_89669,inst_89619,inst_89667];
var inst_89671 = (new cljs.core.PersistentVector(null,4,(5),inst_89668,inst_89670,null));
var state_89791__$1 = state_89791;
var statearr_89900_90080 = state_89791__$1;
(statearr_89900_90080[(2)] = inst_89671);

(statearr_89900_90080[(1)] = (105));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (51))){
var state_89791__$1 = state_89791;
var statearr_89901_90081 = state_89791__$1;
(statearr_89901_90081[(2)] = fluree.db.flake.MAX_PREDICATE_ID);

(statearr_89901_90081[(1)] = (53));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (25))){
var inst_89428 = (state_89791[(66)]);
var state_89791__$1 = state_89791;
var statearr_89902_90082 = state_89791__$1;
(statearr_89902_90082[(2)] = inst_89428);

(statearr_89902_90082[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (34))){
var inst_89506 = (state_89791[(79)]);
var inst_89511 = fluree.db.dbproto._subid.call(null,db,inst_89506);
var state_89791__$1 = state_89791;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89791__$1,(37),inst_89511);
} else {
if((state_val_89792 === (125))){
var inst_89768 = (state_89791[(2)]);
var inst_89769 = fluree.db.util.async.throw_err.call(null,inst_89768);
var state_89791__$1 = state_89791;
var statearr_89903_90083 = state_89791__$1;
(statearr_89903_90083[(2)] = inst_89769);

(statearr_89903_90083[(1)] = (124));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (17))){
var inst_89460 = (state_89791[(2)]);
var inst_89461 = fluree.db.util.async.throw_err.call(null,inst_89460);
var state_89791__$1 = state_89791;
var statearr_89904_90084 = state_89791__$1;
(statearr_89904_90084[(2)] = inst_89461);

(statearr_89904_90084[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (3))){
var inst_89400 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89905_90085 = state_89791__$1;
(statearr_89905_90085[(2)] = inst_89400);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89791__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (12))){
var state_89791__$1 = state_89791;
var statearr_89906_90086 = state_89791__$1;
(statearr_89906_90086[(2)] = opts);

(statearr_89906_90086[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (2))){
var inst_89789 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_89791__$1,inst_89789);
} else {
if((state_val_89792 === (66))){
var inst_89569 = opts.cljs$lang$protocol_mask$partition0$;
var inst_89570 = (inst_89569 & (64));
var inst_89571 = opts.cljs$core$ISeq$;
var inst_89572 = (cljs.core.PROTOCOL_SENTINEL === inst_89571);
var inst_89573 = ((inst_89570) || (inst_89572));
var state_89791__$1 = state_89791;
if(cljs.core.truth_(inst_89573)){
var statearr_89907_90087 = state_89791__$1;
(statearr_89907_90087[(1)] = (69));

} else {
var statearr_89908_90088 = state_89791__$1;
(statearr_89908_90088[(1)] = (70));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (107))){
var inst_89674 = (state_89791[(72)]);
var inst_89617 = (state_89791[(36)]);
var inst_89686 = cljs.core.drop.call(null,inst_89617,inst_89674);
var state_89791__$1 = (function (){var statearr_89909 = state_89791;
(statearr_89909[(27)] = inst_89686);

return statearr_89909;
})();
var statearr_89910_90089 = state_89791__$1;
(statearr_89910_90089[(1)] = (109));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (23))){
var inst_89428 = (state_89791[(66)]);
var inst_89477 = cljs.core.boolean_QMARK_.call(null,inst_89428);
var state_89791__$1 = state_89791;
if(inst_89477){
var statearr_89912_90090 = state_89791__$1;
(statearr_89912_90090[(1)] = (25));

} else {
var statearr_89913_90091 = state_89791__$1;
(statearr_89913_90091[(1)] = (26));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (47))){
var inst_89427 = (state_89791[(65)]);
var inst_89536 = (state_89791[(82)]);
var inst_89535 = (state_89791[(2)]);
var inst_89536__$1 = (inst_89427 == null);
var state_89791__$1 = (function (){var statearr_89914 = state_89791;
(statearr_89914[(82)] = inst_89536__$1);

(statearr_89914[(14)] = inst_89535);

return statearr_89914;
})();
if(cljs.core.truth_(inst_89536__$1)){
var statearr_89915_90092 = state_89791__$1;
(statearr_89915_90092[(1)] = (48));

} else {
var statearr_89916_90093 = state_89791__$1;
(statearr_89916_90093[(1)] = (49));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (35))){
var inst_89506 = (state_89791[(79)]);
var state_89791__$1 = state_89791;
var statearr_89917_90094 = state_89791__$1;
(statearr_89917_90094[(2)] = inst_89506);

(statearr_89917_90094[(1)] = (36));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (127))){
var inst_89764 = (state_89791[(7)]);
var state_89791__$1 = state_89791;
var statearr_89918_90095 = state_89791__$1;
(statearr_89918_90095[(2)] = inst_89764);

(statearr_89918_90095[(1)] = (128));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (82))){
var inst_89787 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89919_90096 = state_89791__$1;
(statearr_89919_90096[(2)] = inst_89787);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89791__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (76))){
var state_89791__$1 = state_89791;
var statearr_89920_90097 = state_89791__$1;
(statearr_89920_90097[(2)] = fluree.db.util.core.max_long);

(statearr_89920_90097[(1)] = (77));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (97))){
var inst_89655 = (state_89791[(41)]);
var inst_89617 = (state_89791[(36)]);
var inst_89655__$1 = cljs.core._EQ_.call(null,(0),inst_89617);
var state_89791__$1 = (function (){var statearr_89921 = state_89791;
(statearr_89921[(41)] = inst_89655__$1);

return statearr_89921;
})();
if(inst_89655__$1){
var statearr_89922_90098 = state_89791__$1;
(statearr_89922_90098[(1)] = (100));

} else {
var statearr_89923_90099 = state_89791__$1;
(statearr_89923_90099[(1)] = (101));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (19))){
var inst_89426 = (state_89791[(64)]);
var state_89791__$1 = state_89791;
var statearr_89924_90100 = state_89791__$1;
(statearr_89924_90100[(2)] = inst_89426);

(statearr_89924_90100[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (57))){
var state_89791__$1 = state_89791;
var statearr_89925_90101 = state_89791__$1;
(statearr_89925_90101[(2)] = fluree.db.util.core.min_integer);

(statearr_89925_90101[(1)] = (59));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (68))){
var inst_89580 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
if(cljs.core.truth_(inst_89580)){
var statearr_89926_90102 = state_89791__$1;
(statearr_89926_90102[(1)] = (72));

} else {
var statearr_89927_90103 = state_89791__$1;
(statearr_89927_90103[(1)] = (73));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (11))){
var inst_89449 = cljs.core.apply.call(null,cljs.core.hash_map,opts);
var state_89791__$1 = state_89791;
var statearr_89928_90104 = state_89791__$1;
(statearr_89928_90104[(2)] = inst_89449);

(statearr_89928_90104[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (115))){
var inst_89714 = (state_89791[(73)]);
var inst_89586 = (state_89791[(24)]);
var inst_89712 = (state_89791[(74)]);
var inst_89713 = (state_89791[(83)]);
var inst_89717 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89718 = (inst_89714 - inst_89586);
var inst_89719 = (inst_89713 - inst_89718);
var inst_89720 = cljs.core.take.call(null,inst_89719,inst_89712);
var inst_89721 = [inst_89586,inst_89720];
var inst_89722 = (new cljs.core.PersistentVector(null,2,(5),inst_89717,inst_89721,null));
var state_89791__$1 = state_89791;
var statearr_89929_90105 = state_89791__$1;
(statearr_89929_90105[(2)] = inst_89722);

(statearr_89929_90105[(1)] = (117));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (9))){
var state_89791__$1 = state_89791;
var statearr_89930_90106 = state_89791__$1;
(statearr_89930_90106[(2)] = false);

(statearr_89930_90106[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (5))){
var inst_89436 = opts.cljs$lang$protocol_mask$partition0$;
var inst_89437 = (inst_89436 & (64));
var inst_89438 = opts.cljs$core$ISeq$;
var inst_89439 = (cljs.core.PROTOCOL_SENTINEL === inst_89438);
var inst_89440 = ((inst_89437) || (inst_89439));
var state_89791__$1 = state_89791;
if(cljs.core.truth_(inst_89440)){
var statearr_89931_90107 = state_89791__$1;
(statearr_89931_90107[(1)] = (8));

} else {
var statearr_89932_90108 = state_89791__$1;
(statearr_89932_90108[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (112))){
var inst_89696 = (state_89791[(80)]);
var inst_89694 = (state_89791[(81)]);
var inst_89592 = (state_89791[(29)]);
var inst_89699 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_89700 = (inst_89694 - inst_89696);
var inst_89701 = [inst_89592,inst_89700];
var inst_89702 = (new cljs.core.PersistentVector(null,2,(5),inst_89699,inst_89701,null));
var state_89791__$1 = state_89791;
var statearr_89933_90109 = state_89791__$1;
(statearr_89933_90109[(2)] = inst_89702);

(statearr_89933_90109[(1)] = (114));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (83))){
var inst_89564 = (state_89791[(20)]);
var inst_89563 = (state_89791[(21)]);
var inst_89616 = (state_89791[(37)]);
var inst_89625 = new cljs.core.Keyword(null,"flakes","flakes",1977895739).cljs$core$IFn$_invoke$arity$1(inst_89616);
var inst_89626 = fluree.db.flake.subrange.call(null,inst_89625,start_test,inst_89563,end_test,inst_89564);
var inst_89628 = fluree.db.query.range.value_with_nil_pred.call(null,idx,inst_89563,inst_89564);
var state_89791__$1 = (function (){var statearr_89934 = state_89791;
(statearr_89934[(38)] = inst_89626);

return statearr_89934;
})();
if(inst_89628){
var statearr_89935_90110 = state_89791__$1;
(statearr_89935_90110[(1)] = (85));

} else {
var statearr_89936_90111 = state_89791__$1;
(statearr_89936_90111[(1)] = (86));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (14))){
var inst_89419 = (state_89791[(63)]);
var inst_89458 = fluree.db.dbproto._subid.call(null,db,inst_89419);
var state_89791__$1 = state_89791;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89791__$1,(17),inst_89458);
} else {
if((state_val_89792 === (45))){
var state_89791__$1 = state_89791;
var statearr_89937_90112 = state_89791__$1;
(statearr_89937_90112[(2)] = (-1));

(statearr_89937_90112[(1)] = (47));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (53))){
var inst_89424 = (state_89791[(62)]);
var inst_89544 = (state_89791[(2)]);
var state_89791__$1 = (function (){var statearr_89938 = state_89791;
(statearr_89938[(15)] = inst_89544);

return statearr_89938;
})();
if(cljs.core.truth_(inst_89424)){
var statearr_89939_90113 = state_89791__$1;
(statearr_89939_90113[(1)] = (54));

} else {
var statearr_89940_90114 = state_89791__$1;
(statearr_89940_90114[(1)] = (55));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (78))){
var inst_89599 = (state_89791[(45)]);
var inst_89604 = (state_89791[(49)]);
var inst_89603 = (state_89791[(52)]);
var inst_89609 = (state_89791[(54)]);
var inst_89563 = (state_89791[(21)]);
var inst_89608 = (state_89791[(2)]);
var inst_89609__$1 = fluree.db.util.async.throw_err.call(null,inst_89608);
var inst_89610 = fluree.db.query.range.find_next_valid_node.call(null,inst_89609__$1,inst_89563,inst_89599,inst_89603,inst_89604);
var state_89791__$1 = (function (){var statearr_89941 = state_89791;
(statearr_89941[(54)] = inst_89609__$1);

return statearr_89941;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89791__$1,(79),inst_89610);
} else {
if((state_val_89792 === (26))){
var state_89791__$1 = state_89791;
var statearr_89942_90115 = state_89791__$1;
(statearr_89942_90115[(1)] = (28));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (123))){
var state_89791__$1 = state_89791;
var statearr_89944_90116 = state_89791__$1;
(statearr_89944_90116[(2)] = null);

(statearr_89944_90116[(1)] = (124));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (16))){
var inst_89426 = (state_89791[(64)]);
var inst_89464 = (state_89791[(2)]);
var inst_89465 = fluree.db.util.core.pred_ident_QMARK_.call(null,inst_89426);
var state_89791__$1 = (function (){var statearr_89945 = state_89791;
(statearr_89945[(18)] = inst_89464);

return statearr_89945;
})();
if(inst_89465){
var statearr_89946_90117 = state_89791__$1;
(statearr_89946_90117[(1)] = (18));

} else {
var statearr_89947_90118 = state_89791__$1;
(statearr_89947_90118[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (81))){
var state_89791__$1 = state_89791;
var statearr_89948_90119 = state_89791__$1;
(statearr_89948_90119[(2)] = null);

(statearr_89948_90119[(1)] = (82));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (120))){
var inst_89653 = (state_89791[(68)]);
var state_89791__$1 = state_89791;
var statearr_89949_90120 = state_89791__$1;
(statearr_89949_90120[(2)] = inst_89653);

(statearr_89949_90120[(1)] = (121));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (79))){
var inst_89613 = (state_89791[(44)]);
var inst_89612 = (state_89791[(2)]);
var inst_89613__$1 = fluree.db.util.async.throw_err.call(null,inst_89612);
var state_89791__$1 = (function (){var statearr_89950 = state_89791;
(statearr_89950[(44)] = inst_89613__$1);

return statearr_89950;
})();
if(cljs.core.truth_(inst_89613__$1)){
var statearr_89951_90121 = state_89791__$1;
(statearr_89951_90121[(1)] = (80));

} else {
var statearr_89952_90122 = state_89791__$1;
(statearr_89952_90122[(1)] = (81));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (38))){
var inst_89507 = (state_89791[(59)]);
var inst_89520 = fluree.db.dbproto._subid.call(null,db,inst_89507);
var state_89791__$1 = state_89791;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89791__$1,(41),inst_89520);
} else {
if((state_val_89792 === (126))){
var inst_89772 = (state_89791[(31)]);
var state_89791__$1 = state_89791;
var statearr_89953_90123 = state_89791__$1;
(statearr_89953_90123[(2)] = inst_89772);

(statearr_89953_90123[(1)] = (128));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (98))){
var inst_89593 = (state_89791[(57)]);
var state_89791__$1 = state_89791;
var statearr_89954_90124 = state_89791__$1;
(statearr_89954_90124[(2)] = inst_89593);

(statearr_89954_90124[(1)] = (99));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (124))){
var inst_89764 = (state_89791[(7)]);
var inst_89772 = (state_89791[(2)]);
var state_89791__$1 = (function (){var statearr_89955 = state_89791;
(statearr_89955[(31)] = inst_89772);

return statearr_89955;
})();
if(cljs.core.truth_(inst_89764)){
var statearr_89956_90125 = state_89791__$1;
(statearr_89956_90125[(1)] = (126));

} else {
var statearr_89957_90126 = state_89791__$1;
(statearr_89957_90126[(1)] = (127));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (87))){
var inst_89453 = (state_89791[(53)]);
var inst_89634 = (state_89791[(2)]);
var state_89791__$1 = (function (){var statearr_89958 = state_89791;
(statearr_89958[(60)] = inst_89634);

return statearr_89958;
})();
if(cljs.core.truth_(inst_89453)){
var statearr_89959_90127 = state_89791__$1;
(statearr_89959_90127[(1)] = (88));

} else {
var statearr_89960_90128 = state_89791__$1;
(statearr_89960_90128[(1)] = (89));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (30))){
var inst_89483 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89961_90129 = state_89791__$1;
(statearr_89961_90129[(2)] = inst_89483);

(statearr_89961_90129[(1)] = (27));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (73))){
var state_89791__$1 = state_89791;
var statearr_89962_90130 = state_89791__$1;
(statearr_89962_90130[(2)] = opts);

(statearr_89962_90130[(1)] = (74));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (96))){
var inst_89593 = (state_89791[(57)]);
var inst_89616 = (state_89791[(37)]);
var inst_89652 = (state_89791[(2)]);
var inst_89653 = fluree.db.dbproto._rhs.call(null,inst_89616);
var state_89791__$1 = (function (){var statearr_89963 = state_89791;
(statearr_89963[(68)] = inst_89653);

(statearr_89963[(71)] = inst_89652);

return statearr_89963;
})();
if(cljs.core.truth_(inst_89593)){
var statearr_89964_90131 = state_89791__$1;
(statearr_89964_90131[(1)] = (97));

} else {
var statearr_89965_90132 = state_89791__$1;
(statearr_89965_90132[(1)] = (98));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (10))){
var inst_89444 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89966_90133 = state_89791__$1;
(statearr_89966_90133[(2)] = inst_89444);

(statearr_89966_90133[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (18))){
var inst_89426 = (state_89791[(64)]);
var inst_89467 = fluree.db.dbproto._subid.call(null,db,inst_89426);
var state_89791__$1 = state_89791;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_89791__$1,(21),inst_89467);
} else {
if((state_val_89792 === (105))){
var inst_89653 = (state_89791[(68)]);
var inst_89751 = (state_89791[(2)]);
var inst_89752 = cljs.core.nth.call(null,inst_89751,(0),null);
var inst_89753 = cljs.core.nth.call(null,inst_89751,(1),null);
var inst_89754 = cljs.core.nth.call(null,inst_89751,(2),null);
var inst_89755 = cljs.core.nth.call(null,inst_89751,(3),null);
var state_89791__$1 = (function (){var statearr_89967 = state_89791;
(statearr_89967[(30)] = inst_89753);

(statearr_89967[(32)] = inst_89755);

(statearr_89967[(33)] = inst_89754);

(statearr_89967[(34)] = inst_89752);

return statearr_89967;
})();
if(cljs.core.truth_(inst_89653)){
var statearr_89968_90134 = state_89791__$1;
(statearr_89968_90134[(1)] = (119));

} else {
var statearr_89969_90135 = state_89791__$1;
(statearr_89969_90135[(1)] = (120));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (52))){
var inst_89427 = (state_89791[(65)]);
var state_89791__$1 = state_89791;
var statearr_89970_90136 = state_89791__$1;
(statearr_89970_90136[(2)] = inst_89427);

(statearr_89970_90136[(1)] = (53));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (114))){
var inst_89714 = (state_89791[(73)]);
var inst_89586 = (state_89791[(24)]);
var inst_89618 = (state_89791[(26)]);
var inst_89686 = (state_89791[(27)]);
var inst_89712 = (state_89791[(74)]);
var inst_89713 = (state_89791[(83)]);
var inst_89708 = (state_89791[(2)]);
var inst_89709 = cljs.core.nth.call(null,inst_89708,(0),null);
var inst_89710 = cljs.core.nth.call(null,inst_89708,(1),null);
var inst_89711 = cljs.core.take.call(null,inst_89710,inst_89686);
var inst_89712__$1 = cljs.core.apply.call(null,cljs.core.concat,inst_89711);
var inst_89713__$1 = cljs.core.count.call(null,inst_89712__$1);
var inst_89714__$1 = (inst_89618 + inst_89713__$1);
var inst_89715 = (inst_89714__$1 > inst_89586);
var state_89791__$1 = (function (){var statearr_89971 = state_89791;
(statearr_89971[(78)] = inst_89709);

(statearr_89971[(73)] = inst_89714__$1);

(statearr_89971[(74)] = inst_89712__$1);

(statearr_89971[(83)] = inst_89713__$1);

return statearr_89971;
})();
if(cljs.core.truth_(inst_89715)){
var statearr_89972_90137 = state_89791__$1;
(statearr_89972_90137[(1)] = (115));

} else {
var statearr_89973_90138 = state_89791__$1;
(statearr_89973_90138[(1)] = (116));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (67))){
var state_89791__$1 = state_89791;
var statearr_89974_90139 = state_89791__$1;
(statearr_89974_90139[(2)] = false);

(statearr_89974_90139[(1)] = (68));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (71))){
var inst_89577 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89975_90140 = state_89791__$1;
(statearr_89975_90140[(2)] = inst_89577);

(statearr_89975_90140[(1)] = (68));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (42))){
var inst_89517 = (state_89791[(12)]);
var state_89791__$1 = state_89791;
var statearr_89976_90141 = state_89791__$1;
(statearr_89976_90141[(2)] = inst_89517);

(statearr_89976_90141[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (80))){
var inst_89613 = (state_89791[(44)]);
var inst_89588 = (state_89791[(25)]);
var inst_89615 = cljs.core.PersistentVector.EMPTY;
var inst_89616 = inst_89613;
var inst_89617 = inst_89588;
var inst_89618 = (0);
var inst_89619 = (0);
var inst_89620 = inst_89615;
var state_89791__$1 = (function (){var statearr_89977 = state_89791;
(statearr_89977[(26)] = inst_89618);

(statearr_89977[(35)] = inst_89620);

(statearr_89977[(28)] = inst_89619);

(statearr_89977[(36)] = inst_89617);

(statearr_89977[(37)] = inst_89616);

return statearr_89977;
})();
var statearr_89978_90142 = state_89791__$1;
(statearr_89978_90142[(2)] = null);

(statearr_89978_90142[(1)] = (83));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (37))){
var inst_89513 = (state_89791[(2)]);
var inst_89514 = fluree.db.util.async.throw_err.call(null,inst_89513);
var state_89791__$1 = state_89791;
var statearr_89979_90143 = state_89791__$1;
(statearr_89979_90143[(2)] = inst_89514);

(statearr_89979_90143[(1)] = (36));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (63))){
var state_89791__$1 = state_89791;
var statearr_89980_90144 = state_89791__$1;
(statearr_89980_90144[(2)] = (2147483647));

(statearr_89980_90144[(1)] = (65));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (94))){
var inst_89504 = (state_89791[(43)]);
var inst_89613 = (state_89791[(44)]);
var inst_89646 = (state_89791[(69)]);
var inst_89599 = (state_89791[(45)]);
var inst_89505 = (state_89791[(46)]);
var inst_89508 = (state_89791[(47)]);
var inst_89430 = (state_89791[(8)]);
var inst_89452 = (state_89791[(48)]);
var inst_89429 = (state_89791[(9)]);
var inst_89586 = (state_89791[(24)]);
var inst_89604 = (state_89791[(49)]);
var inst_89423 = (state_89791[(10)]);
var inst_89618 = (state_89791[(26)]);
var inst_89473 = (state_89791[(11)]);
var inst_89620 = (state_89791[(35)]);
var inst_89517 = (state_89791[(12)]);
var inst_89418 = (state_89791[(50)]);
var inst_89425 = (state_89791[(51)]);
var inst_89603 = (state_89791[(52)]);
var inst_89453 = (state_89791[(53)]);
var inst_89553 = (state_89791[(13)]);
var inst_89585 = (state_89791[(22)]);
var inst_89619 = (state_89791[(28)]);
var inst_89609 = (state_89791[(54)]);
var inst_89535 = (state_89791[(14)]);
var inst_89564 = (state_89791[(20)]);
var inst_89563 = (state_89791[(21)]);
var inst_89544 = (state_89791[(15)]);
var inst_89526 = (state_89791[(16)]);
var inst_89454 = (state_89791[(55)]);
var inst_89594 = (state_89791[(56)]);
var inst_89562 = (state_89791[(17)]);
var inst_89593 = (state_89791[(57)]);
var inst_89617 = (state_89791[(36)]);
var inst_89464 = (state_89791[(18)]);
var inst_89616 = (state_89791[(37)]);
var inst_89422 = (state_89791[(19)]);
var inst_89598 = (state_89791[(58)]);
var inst_89626 = (state_89791[(38)]);
var inst_89592 = (state_89791[(29)]);
var inst_89648 = (function (){var no_filter_QMARK_ = true;
var t = inst_89599;
var max_limit_QMARK_ = inst_89593;
var next_node = inst_89616;
var fast_forward_db_QMARK_ = inst_89604;
var s1 = inst_89464;
var o2 = inst_89526;
var vec__89407 = inst_89425;
var t1 = inst_89422;
var predicate_fn = inst_89454;
var i = inst_89618;
var map__89410 = inst_89452;
var m1 = inst_89553;
var root_node = inst_89609;
var s2 = inst_89473;
var p2 = inst_89544;
var map__89417 = inst_89585;
var permissions = inst_89594;
var limit = inst_89592;
var vec__89404 = inst_89418;
var start_flake = inst_89563;
var flake_limit = inst_89586;
var vec__89414 = inst_89505;
var offset = inst_89617;
var vec__89411 = inst_89504;
var acc = inst_89620;
var t2 = inst_89429;
var G__89627 = inst_89646;
var op1 = inst_89423;
var o1 = inst_89517;
var end_flake = inst_89564;
var base_result = inst_89626;
var s = inst_89619;
var node_start = inst_89613;
var p1 = inst_89535;
var subject_fn = inst_89453;
var object_fn = inst_89508;
var idx_compare = inst_89598;
var op2 = inst_89430;
var m2 = inst_89562;
var novelty = inst_89603;
return ((function (no_filter_QMARK_,t,max_limit_QMARK_,next_node,fast_forward_db_QMARK_,s1,o2,vec__89407,t1,predicate_fn,i,map__89410,m1,root_node,s2,p2,map__89417,permissions,limit,vec__89404,start_flake,flake_limit,vec__89414,offset,vec__89411,acc,t2,G__89627,op1,o1,end_flake,base_result,s,node_start,p1,subject_fn,object_fn,idx_compare,op2,m2,novelty,inst_89504,inst_89613,inst_89646,inst_89599,inst_89505,inst_89508,inst_89430,inst_89452,inst_89429,inst_89586,inst_89604,inst_89423,inst_89618,inst_89473,inst_89620,inst_89517,inst_89418,inst_89425,inst_89603,inst_89453,inst_89553,inst_89585,inst_89619,inst_89609,inst_89535,inst_89564,inst_89563,inst_89544,inst_89526,inst_89454,inst_89594,inst_89562,inst_89593,inst_89617,inst_89464,inst_89616,inst_89422,inst_89598,inst_89626,inst_89592,state_val_89792,c__86675__auto__){
return (function (p1__89390_SHARP_){
return object_fn.call(null,p1__89390_SHARP_.o);
});
;})(no_filter_QMARK_,t,max_limit_QMARK_,next_node,fast_forward_db_QMARK_,s1,o2,vec__89407,t1,predicate_fn,i,map__89410,m1,root_node,s2,p2,map__89417,permissions,limit,vec__89404,start_flake,flake_limit,vec__89414,offset,vec__89411,acc,t2,G__89627,op1,o1,end_flake,base_result,s,node_start,p1,subject_fn,object_fn,idx_compare,op2,m2,novelty,inst_89504,inst_89613,inst_89646,inst_89599,inst_89505,inst_89508,inst_89430,inst_89452,inst_89429,inst_89586,inst_89604,inst_89423,inst_89618,inst_89473,inst_89620,inst_89517,inst_89418,inst_89425,inst_89603,inst_89453,inst_89553,inst_89585,inst_89619,inst_89609,inst_89535,inst_89564,inst_89563,inst_89544,inst_89526,inst_89454,inst_89594,inst_89562,inst_89593,inst_89617,inst_89464,inst_89616,inst_89422,inst_89598,inst_89626,inst_89592,state_val_89792,c__86675__auto__))
})();
var inst_89649 = cljs.core.filter.call(null,inst_89648,inst_89646);
var state_89791__$1 = state_89791;
var statearr_89981_90145 = state_89791__$1;
(statearr_89981_90145[(2)] = inst_89649);

(statearr_89981_90145[(1)] = (96));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (8))){
var state_89791__$1 = state_89791;
var statearr_89982_90146 = state_89791__$1;
(statearr_89982_90146[(2)] = true);

(statearr_89982_90146[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (49))){
var inst_89536 = (state_89791[(82)]);
var state_89791__$1 = state_89791;
var statearr_89983_90147 = state_89791__$1;
(statearr_89983_90147[(2)] = inst_89536);

(statearr_89983_90147[(1)] = (50));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_89792 === (84))){
var inst_89784 = (state_89791[(2)]);
var state_89791__$1 = state_89791;
var statearr_89984_90148 = state_89791__$1;
(statearr_89984_90148[(2)] = inst_89784);

(statearr_89984_90148[(1)] = (82));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$range$state_machine__86625__auto__ = null;
var fluree$db$query$range$state_machine__86625__auto____0 = (function (){
var statearr_89985 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_89985[(0)] = fluree$db$query$range$state_machine__86625__auto__);

(statearr_89985[(1)] = (1));

return statearr_89985;
});
var fluree$db$query$range$state_machine__86625__auto____1 = (function (state_89791){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_89791);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e89986){if((e89986 instanceof Object)){
var ex__86628__auto__ = e89986;
var statearr_89987_90149 = state_89791;
(statearr_89987_90149[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_89791);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e89986;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__90150 = state_89791;
state_89791 = G__90150;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$range$state_machine__86625__auto__ = function(state_89791){
switch(arguments.length){
case 0:
return fluree$db$query$range$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$range$state_machine__86625__auto____1.call(this,state_89791);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$range$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$range$state_machine__86625__auto____0;
fluree$db$query$range$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$range$state_machine__86625__auto____1;
return fluree$db$query$range$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_89988 = f__86676__auto__.call(null);
(statearr_89988[(6)] = c__86675__auto__);

return statearr_89988;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.query.range.index_range.cljs$lang$maxFixedArity = 7;

fluree.db.query.range.non_nil_non_boolean_QMARK_ = (function fluree$db$query$range$non_nil_non_boolean_QMARK_(o){
return (((!((o == null)))) && ((!(cljs.core.boolean_QMARK_.call(null,o)))));
});
fluree.db.query.range.tag_string_QMARK_ = (function fluree$db$query$range$tag_string_QMARK_(possible_tag){
return cljs.core.re_find.call(null,/^[a-zA-Z0-9-_]*\/[a-zA-Z0-9-_]*:[a-zA-Z0-9-]*$/,possible_tag);
});
fluree.db.query.range.tag_sid_start = fluree.db.flake.min_subject_id.call(null,(3));
fluree.db.query.range.tag_sid_end = fluree.db.flake.max_subject_id.call(null,(3));
/**
 * Returns true if flake is a root setting flake.
 */
fluree.db.query.range.is_tag_flake_QMARK_ = (function fluree$db$query$range$is_tag_flake_QMARK_(f){
return (((fluree.db.query.range.tag_sid_start <= f.o)) && ((f.o <= fluree.db.query.range.tag_sid_end)));
});
fluree.db.query.range.coerce_tag_flakes = (function fluree$db$query$range$coerce_tag_flakes(db,flakes){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_90205){
var state_val_90206 = (state_90205[(1)]);
if((state_val_90206 === (7))){
var inst_90179 = (state_90205[(7)]);
var inst_90169 = (state_90205[(8)]);
var inst_90177 = fluree.db.flake.Flake__GT_parts.call(null,inst_90169);
var inst_90178 = cljs.core.nth.call(null,inst_90177,(0),null);
var inst_90179__$1 = cljs.core.nth.call(null,inst_90177,(1),null);
var inst_90180 = cljs.core.nth.call(null,inst_90177,(2),null);
var inst_90181 = cljs.core.nth.call(null,inst_90177,(3),null);
var inst_90182 = cljs.core.nth.call(null,inst_90177,(4),null);
var inst_90183 = cljs.core.nth.call(null,inst_90177,(5),null);
var inst_90184 = fluree.db.dbproto._tag.call(null,db,inst_90180,inst_90179__$1);
var state_90205__$1 = (function (){var statearr_90207 = state_90205;
(statearr_90207[(9)] = inst_90183);

(statearr_90207[(7)] = inst_90179__$1);

(statearr_90207[(10)] = inst_90182);

(statearr_90207[(11)] = inst_90181);

(statearr_90207[(12)] = inst_90178);

return statearr_90207;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_90205__$1,(10),inst_90184);
} else {
if((state_val_90206 === (1))){
var inst_90158 = cljs.core.seq.call(null,flakes);
var inst_90159 = cljs.core.first.call(null,inst_90158);
var inst_90160 = cljs.core.next.call(null,inst_90158);
var inst_90161 = cljs.core.PersistentVector.EMPTY;
var inst_90162 = flakes;
var inst_90163 = inst_90161;
var state_90205__$1 = (function (){var statearr_90208 = state_90205;
(statearr_90208[(13)] = inst_90162);

(statearr_90208[(14)] = inst_90159);

(statearr_90208[(15)] = inst_90163);

(statearr_90208[(16)] = inst_90160);

return statearr_90208;
})();
var statearr_90209_90226 = state_90205__$1;
(statearr_90209_90226[(2)] = null);

(statearr_90209_90226[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90206 === (4))){
var inst_90169 = (state_90205[(8)]);
var inst_90172 = fluree.db.query.range.is_tag_flake_QMARK_.call(null,inst_90169);
var state_90205__$1 = state_90205;
if(inst_90172){
var statearr_90210_90227 = state_90205__$1;
(statearr_90210_90227[(1)] = (7));

} else {
var statearr_90211_90228 = state_90205__$1;
(statearr_90211_90228[(1)] = (8));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90206 === (6))){
var inst_90201 = (state_90205[(2)]);
var state_90205__$1 = state_90205;
var statearr_90212_90229 = state_90205__$1;
(statearr_90212_90229[(2)] = inst_90201);

(statearr_90212_90229[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90206 === (3))){
var inst_90203 = (state_90205[(2)]);
var state_90205__$1 = state_90205;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_90205__$1,inst_90203);
} else {
if((state_val_90206 === (2))){
var inst_90162 = (state_90205[(13)]);
var inst_90169 = (state_90205[(8)]);
var inst_90168 = cljs.core.seq.call(null,inst_90162);
var inst_90169__$1 = cljs.core.first.call(null,inst_90168);
var inst_90170 = cljs.core.next.call(null,inst_90168);
var state_90205__$1 = (function (){var statearr_90213 = state_90205;
(statearr_90213[(17)] = inst_90170);

(statearr_90213[(8)] = inst_90169__$1);

return statearr_90213;
})();
if(cljs.core.truth_(inst_90169__$1)){
var statearr_90214_90230 = state_90205__$1;
(statearr_90214_90230[(1)] = (4));

} else {
var statearr_90215_90231 = state_90205__$1;
(statearr_90215_90231[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90206 === (9))){
var inst_90198 = (state_90205[(2)]);
var state_90205__$1 = state_90205;
var statearr_90216_90232 = state_90205__$1;
(statearr_90216_90232[(2)] = inst_90198);

(statearr_90216_90232[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90206 === (5))){
var inst_90163 = (state_90205[(15)]);
var state_90205__$1 = state_90205;
var statearr_90217_90233 = state_90205__$1;
(statearr_90217_90233[(2)] = inst_90163);

(statearr_90217_90233[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90206 === (10))){
var inst_90170 = (state_90205[(17)]);
var inst_90183 = (state_90205[(9)]);
var inst_90179 = (state_90205[(7)]);
var inst_90182 = (state_90205[(10)]);
var inst_90163 = (state_90205[(15)]);
var inst_90181 = (state_90205[(11)]);
var inst_90178 = (state_90205[(12)]);
var inst_90186 = (state_90205[(2)]);
var inst_90187 = fluree.db.util.async.throw_err.call(null,inst_90186);
var inst_90188 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_90189 = [inst_90178,inst_90179,inst_90187,inst_90181,inst_90182,inst_90183];
var inst_90190 = (new cljs.core.PersistentVector(null,6,(5),inst_90188,inst_90189,null));
var inst_90191 = fluree.db.flake.parts__GT_Flake.call(null,inst_90190);
var inst_90192 = cljs.core.conj.call(null,inst_90163,inst_90191);
var inst_90162 = inst_90170;
var inst_90163__$1 = inst_90192;
var state_90205__$1 = (function (){var statearr_90218 = state_90205;
(statearr_90218[(13)] = inst_90162);

(statearr_90218[(15)] = inst_90163__$1);

return statearr_90218;
})();
var statearr_90219_90234 = state_90205__$1;
(statearr_90219_90234[(2)] = null);

(statearr_90219_90234[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90206 === (8))){
var inst_90170 = (state_90205[(17)]);
var inst_90169 = (state_90205[(8)]);
var inst_90163 = (state_90205[(15)]);
var inst_90195 = cljs.core.conj.call(null,inst_90163,inst_90169);
var inst_90162 = inst_90170;
var inst_90163__$1 = inst_90195;
var state_90205__$1 = (function (){var statearr_90220 = state_90205;
(statearr_90220[(13)] = inst_90162);

(statearr_90220[(15)] = inst_90163__$1);

return statearr_90220;
})();
var statearr_90221_90235 = state_90205__$1;
(statearr_90221_90235[(2)] = null);

(statearr_90221_90235[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto__ = null;
var fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto____0 = (function (){
var statearr_90222 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_90222[(0)] = fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto__);

(statearr_90222[(1)] = (1));

return statearr_90222;
});
var fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto____1 = (function (state_90205){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_90205);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e90223){if((e90223 instanceof Object)){
var ex__86628__auto__ = e90223;
var statearr_90224_90236 = state_90205;
(statearr_90224_90236[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_90205);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e90223;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__90237 = state_90205;
state_90205 = G__90237;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto__ = function(state_90205){
switch(arguments.length){
case 0:
return fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto____1.call(this,state_90205);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto____0;
fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto____1;
return fluree$db$query$range$coerce_tag_flakes_$_state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_90225 = f__86676__auto__.call(null);
(statearr_90225[(6)] = c__86675__auto__);

return statearr_90225;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});
fluree.db.query.range.search = (function fluree$db$query$range$search(var_args){
var G__90239 = arguments.length;
switch (G__90239) {
case 2:
return fluree.db.query.range.search.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.query.range.search.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.range.search.cljs$core$IFn$_invoke$arity$2 = (function (db,fparts){
return fluree.db.query.range.search.call(null,db,fparts,cljs.core.PersistentArrayMap.EMPTY);
});

fluree.db.query.range.search.cljs$core$IFn$_invoke$arity$3 = (function (db,fparts,opts){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_90386){
var state_val_90387 = (state_90386[(1)]);
if((state_val_90387 === (62))){
var inst_90382 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90388_90472 = state_90386__$1;
(statearr_90388_90472[(2)] = inst_90382);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_90386__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (7))){
var inst_90257 = (state_90386[(7)]);
var inst_90257__$1 = (state_90386[(2)]);
var state_90386__$1 = (function (){var statearr_90389 = state_90386;
(statearr_90389[(7)] = inst_90257__$1);

return statearr_90389;
})();
if(cljs.core.truth_(inst_90257__$1)){
var statearr_90390_90473 = state_90386__$1;
(statearr_90390_90473[(1)] = (8));

} else {
var statearr_90391_90474 = state_90386__$1;
(statearr_90391_90474[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (59))){
var inst_90362 = (state_90386[(2)]);
var inst_90363 = fluree.db.util.async.throw_err.call(null,inst_90362);
var state_90386__$1 = state_90386;
var statearr_90392_90475 = state_90386__$1;
(statearr_90392_90475[(2)] = inst_90363);

(statearr_90392_90475[(1)] = (58));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (20))){
var inst_90283 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90393_90476 = state_90386__$1;
(statearr_90393_90476[(2)] = inst_90283);

(statearr_90393_90476[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (58))){
var inst_90366 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90394_90477 = state_90386__$1;
(statearr_90394_90477[(2)] = inst_90366);

(statearr_90394_90477[(1)] = (54));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (60))){
var inst_90374 = (state_90386[(8)]);
var inst_90376 = fluree.db.query.range.coerce_tag_flakes.call(null,db,inst_90374);
var state_90386__$1 = state_90386;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_90386__$1,(63),inst_90376);
} else {
if((state_val_90387 === (27))){
var inst_90248 = (state_90386[(9)]);
var state_90386__$1 = state_90386;
var statearr_90395_90478 = state_90386__$1;
(statearr_90395_90478[(2)] = inst_90248);

(statearr_90395_90478[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (1))){
var state_90386__$1 = state_90386;
var statearr_90396_90479 = state_90386__$1;
(statearr_90396_90479[(2)] = null);

(statearr_90396_90479[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (24))){
var inst_90257 = (state_90386[(7)]);
var inst_90374 = (state_90386[(2)]);
var state_90386__$1 = (function (){var statearr_90397 = state_90386;
(statearr_90397[(8)] = inst_90374);

return statearr_90397;
})();
if(cljs.core.truth_(inst_90257)){
var statearr_90398_90480 = state_90386__$1;
(statearr_90398_90480[(1)] = (60));

} else {
var statearr_90399_90481 = state_90386__$1;
(statearr_90399_90481[(1)] = (61));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (55))){
var inst_90353 = (state_90386[(2)]);
var inst_90354 = fluree.db.util.async.throw_err.call(null,inst_90353);
var state_90386__$1 = state_90386;
var statearr_90400_90482 = state_90386__$1;
(statearr_90400_90482[(2)] = inst_90354);

(statearr_90400_90482[(1)] = (54));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (39))){
var inst_90251 = (state_90386[(10)]);
var inst_90322 = (state_90386[(11)]);
var inst_90322__$1 = cljs.core.not.call(null,inst_90251);
var state_90386__$1 = (function (){var statearr_90401 = state_90386;
(statearr_90401[(11)] = inst_90322__$1);

return statearr_90401;
})();
if(inst_90322__$1){
var statearr_90402_90483 = state_90386__$1;
(statearr_90402_90483[(1)] = (42));

} else {
var statearr_90403_90484 = state_90386__$1;
(statearr_90403_90484[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (46))){
var inst_90248 = (state_90386[(9)]);
var state_90386__$1 = state_90386;
if(cljs.core.truth_(inst_90248)){
var statearr_90404_90485 = state_90386__$1;
(statearr_90404_90485[(1)] = (52));

} else {
var statearr_90405_90486 = state_90386__$1;
(statearr_90405_90486[(1)] = (53));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (4))){
var inst_90248 = (state_90386[(9)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_90386,(3),Error,null,(2));
var inst_90247 = cljs.core.nth.call(null,fparts,(0),null);
var inst_90248__$1 = cljs.core.nth.call(null,fparts,(1),null);
var inst_90249 = cljs.core.nth.call(null,fparts,(2),null);
var inst_90250 = cljs.core.nth.call(null,fparts,(3),null);
var inst_90251 = fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"idx?","idx?",-564590377),inst_90248__$1);
var state_90386__$1 = (function (){var statearr_90406 = state_90386;
(statearr_90406[(12)] = inst_90250);

(statearr_90406[(9)] = inst_90248__$1);

(statearr_90406[(13)] = inst_90247);

(statearr_90406[(10)] = inst_90251);

(statearr_90406[(14)] = inst_90249);

return statearr_90406;
})();
if(cljs.core.truth_(inst_90248__$1)){
var statearr_90407_90487 = state_90386__$1;
(statearr_90407_90487[(1)] = (5));

} else {
var statearr_90408_90488 = state_90386__$1;
(statearr_90408_90488[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (54))){
var inst_90368 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90409_90489 = state_90386__$1;
(statearr_90409_90489[(2)] = inst_90368);

(statearr_90409_90489[(1)] = (47));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (15))){
var inst_90249 = (state_90386[(14)]);
var inst_90273 = typeof inst_90249 === 'string';
var state_90386__$1 = state_90386;
if(cljs.core.truth_(inst_90273)){
var statearr_90410_90490 = state_90386__$1;
(statearr_90410_90490[(1)] = (18));

} else {
var statearr_90411_90491 = state_90386__$1;
(statearr_90411_90491[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (48))){
var inst_90331 = (state_90386[(15)]);
var inst_90250 = (state_90386[(12)]);
var inst_90248 = (state_90386[(9)]);
var inst_90257 = (state_90386[(7)]);
var inst_90247 = (state_90386[(13)]);
var inst_90287 = (state_90386[(16)]);
var inst_90251 = (state_90386[(10)]);
var inst_90262 = (state_90386[(17)]);
var inst_90333 = (function (){var obj_fn = inst_90331;
var t = inst_90250;
var temp__5733__auto__ = inst_90331;
var p = inst_90248;
var idx_predicate_QMARK_ = inst_90251;
var o = inst_90287;
var vec__90244 = fparts;
var tag_predicate_QMARK_ = inst_90257;
var s = inst_90247;
var o_coerce_QMARK_ = inst_90262;
return ((function (obj_fn,t,temp__5733__auto__,p,idx_predicate_QMARK_,o,vec__90244,tag_predicate_QMARK_,s,o_coerce_QMARK_,inst_90331,inst_90250,inst_90248,inst_90257,inst_90247,inst_90287,inst_90251,inst_90262,state_val_90387,c__86675__auto__){
return (function (x){
var and__4120__auto__ = obj_fn.call(null,x);
if(cljs.core.truth_(and__4120__auto__)){
return cljs.core._EQ_.call(null,x,o);
} else {
return and__4120__auto__;
}
});
;})(obj_fn,t,temp__5733__auto__,p,idx_predicate_QMARK_,o,vec__90244,tag_predicate_QMARK_,s,o_coerce_QMARK_,inst_90331,inst_90250,inst_90248,inst_90257,inst_90247,inst_90287,inst_90251,inst_90262,state_val_90387,c__86675__auto__))
})();
var state_90386__$1 = state_90386;
var statearr_90412_90492 = state_90386__$1;
(statearr_90412_90492[(2)] = inst_90333);

(statearr_90412_90492[(1)] = (50));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (50))){
var inst_90250 = (state_90386[(12)]);
var inst_90248 = (state_90386[(9)]);
var inst_90247 = (state_90386[(13)]);
var inst_90337 = (state_90386[(2)]);
var inst_90338 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_90339 = [inst_90248,inst_90247,null,inst_90250];
var inst_90340 = (new cljs.core.PersistentVector(null,4,(5),inst_90338,inst_90339,null));
var inst_90341 = cljs.core.assoc.call(null,opts,new cljs.core.Keyword(null,"object-fn","object-fn",1425858481),inst_90337);
var inst_90342 = fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"psot","psot",2111653059),cljs.core._EQ_,inst_90340,inst_90341);
var state_90386__$1 = state_90386;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_90386__$1,(51),inst_90342);
} else {
if((state_val_90387 === (21))){
var inst_90279 = (state_90386[(2)]);
var inst_90280 = fluree.db.util.async.throw_err.call(null,inst_90279);
var state_90386__$1 = state_90386;
var statearr_90413_90493 = state_90386__$1;
(statearr_90413_90493[(2)] = inst_90280);

(statearr_90413_90493[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (31))){
var inst_90308 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90414_90494 = state_90386__$1;
(statearr_90414_90494[(2)] = inst_90308);

(statearr_90414_90494[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (32))){
var inst_90287 = (state_90386[(16)]);
var inst_90301 = cljs.core.fn_QMARK_.call(null,inst_90287);
var inst_90302 = (!(inst_90301));
var state_90386__$1 = state_90386;
var statearr_90415_90495 = state_90386__$1;
(statearr_90415_90495[(2)] = inst_90302);

(statearr_90415_90495[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (40))){
var inst_90248 = (state_90386[(9)]);
var state_90386__$1 = state_90386;
var statearr_90416_90496 = state_90386__$1;
(statearr_90416_90496[(2)] = inst_90248);

(statearr_90416_90496[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (56))){
var inst_90250 = (state_90386[(12)]);
var inst_90248 = (state_90386[(9)]);
var inst_90247 = (state_90386[(13)]);
var inst_90287 = (state_90386[(16)]);
var inst_90357 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_90358 = [inst_90287,inst_90248,inst_90247,inst_90250];
var inst_90359 = (new cljs.core.PersistentVector(null,4,(5),inst_90357,inst_90358,null));
var inst_90360 = fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"opst","opst",1213963058),cljs.core._EQ_,inst_90359,opts);
var state_90386__$1 = state_90386;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_90386__$1,(59),inst_90360);
} else {
if((state_val_90387 === (33))){
var inst_90251 = (state_90386[(10)]);
var state_90386__$1 = state_90386;
var statearr_90417_90497 = state_90386__$1;
(statearr_90417_90497[(2)] = inst_90251);

(statearr_90417_90497[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (13))){
var inst_90247 = (state_90386[(13)]);
var inst_90287 = (state_90386[(2)]);
var state_90386__$1 = (function (){var statearr_90418 = state_90386;
(statearr_90418[(16)] = inst_90287);

return statearr_90418;
})();
if(cljs.core.truth_(inst_90247)){
var statearr_90419_90498 = state_90386__$1;
(statearr_90419_90498[(1)] = (22));

} else {
var statearr_90420_90499 = state_90386__$1;
(statearr_90420_90499[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (22))){
var inst_90250 = (state_90386[(12)]);
var inst_90248 = (state_90386[(9)]);
var inst_90247 = (state_90386[(13)]);
var inst_90287 = (state_90386[(16)]);
var inst_90289 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_90290 = [inst_90247,inst_90248,inst_90287,inst_90250];
var inst_90291 = (new cljs.core.PersistentVector(null,4,(5),inst_90289,inst_90290,null));
var inst_90292 = fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"spot","spot",-1706962147),cljs.core._EQ_,inst_90291,opts);
var state_90386__$1 = state_90386;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_90386__$1,(25),inst_90292);
} else {
if((state_val_90387 === (36))){
var inst_90248 = (state_90386[(9)]);
var state_90386__$1 = state_90386;
if(cljs.core.truth_(inst_90248)){
var statearr_90421_90500 = state_90386__$1;
(statearr_90421_90500[(1)] = (39));

} else {
var statearr_90422_90501 = state_90386__$1;
(statearr_90422_90501[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (41))){
var inst_90329 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
if(cljs.core.truth_(inst_90329)){
var statearr_90423_90502 = state_90386__$1;
(statearr_90423_90502[(1)] = (45));

} else {
var statearr_90424_90503 = state_90386__$1;
(statearr_90424_90503[(1)] = (46));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (43))){
var inst_90322 = (state_90386[(11)]);
var state_90386__$1 = state_90386;
var statearr_90425_90504 = state_90386__$1;
(statearr_90425_90504[(2)] = inst_90322);

(statearr_90425_90504[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (61))){
var inst_90374 = (state_90386[(8)]);
var state_90386__$1 = state_90386;
var statearr_90426_90505 = state_90386__$1;
(statearr_90426_90505[(2)] = inst_90374);

(statearr_90426_90505[(1)] = (62));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (29))){
var inst_90251 = (state_90386[(10)]);
var state_90386__$1 = state_90386;
if(cljs.core.truth_(inst_90251)){
var statearr_90427_90506 = state_90386__$1;
(statearr_90427_90506[(1)] = (32));

} else {
var statearr_90428_90507 = state_90386__$1;
(statearr_90428_90507[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (44))){
var inst_90326 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90429_90508 = state_90386__$1;
(statearr_90429_90508[(2)] = inst_90326);

(statearr_90429_90508[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (6))){
var state_90386__$1 = state_90386;
var statearr_90430_90509 = state_90386__$1;
(statearr_90430_90509[(2)] = false);

(statearr_90430_90509[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (28))){
var inst_90311 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
if(cljs.core.truth_(inst_90311)){
var statearr_90431_90510 = state_90386__$1;
(statearr_90431_90510[(1)] = (35));

} else {
var statearr_90432_90511 = state_90386__$1;
(statearr_90432_90511[(1)] = (36));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (51))){
var inst_90344 = (state_90386[(2)]);
var inst_90345 = fluree.db.util.async.throw_err.call(null,inst_90344);
var state_90386__$1 = state_90386;
var statearr_90433_90512 = state_90386__$1;
(statearr_90433_90512[(2)] = inst_90345);

(statearr_90433_90512[(1)] = (47));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (25))){
var inst_90294 = (state_90386[(2)]);
var inst_90295 = fluree.db.util.async.throw_err.call(null,inst_90294);
var state_90386__$1 = state_90386;
var statearr_90434_90513 = state_90386__$1;
(statearr_90434_90513[(2)] = inst_90295);

(statearr_90434_90513[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (34))){
var inst_90305 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90435_90514 = state_90386__$1;
(statearr_90435_90514[(2)] = inst_90305);

(statearr_90435_90514[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (17))){
var inst_90270 = (state_90386[(2)]);
var inst_90271 = fluree.db.util.async.throw_err.call(null,inst_90270);
var state_90386__$1 = state_90386;
var statearr_90436_90515 = state_90386__$1;
(statearr_90436_90515[(2)] = inst_90271);

(statearr_90436_90515[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (3))){
var inst_90240 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90437_90516 = state_90386__$1;
(statearr_90437_90516[(2)] = inst_90240);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_90386__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (12))){
var inst_90249 = (state_90386[(14)]);
var inst_90266 = fluree.db.query.range.tag_string_QMARK_.call(null,inst_90249);
var state_90386__$1 = state_90386;
if(cljs.core.truth_(inst_90266)){
var statearr_90438_90517 = state_90386__$1;
(statearr_90438_90517[(1)] = (14));

} else {
var statearr_90439_90518 = state_90386__$1;
(statearr_90439_90518[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (2))){
var inst_90384 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_90386__$1,inst_90384);
} else {
if((state_val_90387 === (23))){
var inst_90248 = (state_90386[(9)]);
var state_90386__$1 = state_90386;
if(cljs.core.truth_(inst_90248)){
var statearr_90440_90519 = state_90386__$1;
(statearr_90440_90519[(1)] = (26));

} else {
var statearr_90441_90520 = state_90386__$1;
(statearr_90441_90520[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (47))){
var inst_90370 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90442_90521 = state_90386__$1;
(statearr_90442_90521[(2)] = inst_90370);

(statearr_90442_90521[(1)] = (37));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (35))){
var inst_90250 = (state_90386[(12)]);
var inst_90248 = (state_90386[(9)]);
var inst_90247 = (state_90386[(13)]);
var inst_90287 = (state_90386[(16)]);
var inst_90313 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_90314 = [inst_90248,inst_90287,inst_90247,inst_90250];
var inst_90315 = (new cljs.core.PersistentVector(null,4,(5),inst_90313,inst_90314,null));
var inst_90316 = fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"post","post",269697687),cljs.core._EQ_,inst_90315,opts);
var state_90386__$1 = state_90386;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_90386__$1,(38),inst_90316);
} else {
if((state_val_90387 === (19))){
var state_90386__$1 = state_90386;
var statearr_90443_90522 = state_90386__$1;
(statearr_90443_90522[(2)] = null);

(statearr_90443_90522[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (57))){
var state_90386__$1 = state_90386;
var statearr_90444_90523 = state_90386__$1;
(statearr_90444_90523[(2)] = null);

(statearr_90444_90523[(1)] = (58));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (11))){
var inst_90249 = (state_90386[(14)]);
var state_90386__$1 = state_90386;
var statearr_90445_90524 = state_90386__$1;
(statearr_90445_90524[(2)] = inst_90249);

(statearr_90445_90524[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (9))){
var inst_90257 = (state_90386[(7)]);
var state_90386__$1 = state_90386;
var statearr_90446_90525 = state_90386__$1;
(statearr_90446_90525[(2)] = inst_90257);

(statearr_90446_90525[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (5))){
var inst_90248 = (state_90386[(9)]);
var inst_90253 = fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"type","type",1174270348),inst_90248);
var inst_90254 = cljs.core._EQ_.call(null,new cljs.core.Keyword(null,"tag","tag",-1290361223),inst_90253);
var state_90386__$1 = state_90386;
var statearr_90447_90526 = state_90386__$1;
(statearr_90447_90526[(2)] = inst_90254);

(statearr_90447_90526[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (14))){
var inst_90249 = (state_90386[(14)]);
var inst_90268 = fluree.db.dbproto._tag_id.call(null,db,inst_90249);
var state_90386__$1 = state_90386;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_90386__$1,(17),inst_90268);
} else {
if((state_val_90387 === (45))){
var inst_90331 = (state_90386[(15)]);
var inst_90331__$1 = new cljs.core.Keyword(null,"object-fn","object-fn",1425858481).cljs$core$IFn$_invoke$arity$1(opts);
var state_90386__$1 = (function (){var statearr_90448 = state_90386;
(statearr_90448[(15)] = inst_90331__$1);

return statearr_90448;
})();
if(cljs.core.truth_(inst_90331__$1)){
var statearr_90449_90527 = state_90386__$1;
(statearr_90449_90527[(1)] = (48));

} else {
var statearr_90450_90528 = state_90386__$1;
(statearr_90450_90528[(1)] = (49));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (53))){
var inst_90287 = (state_90386[(16)]);
var state_90386__$1 = state_90386;
if(cljs.core.truth_(inst_90287)){
var statearr_90451_90529 = state_90386__$1;
(statearr_90451_90529[(1)] = (56));

} else {
var statearr_90452_90530 = state_90386__$1;
(statearr_90452_90530[(1)] = (57));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (26))){
var inst_90287 = (state_90386[(16)]);
var inst_90298 = (state_90386[(18)]);
var inst_90298__$1 = fluree.db.query.range.non_nil_non_boolean_QMARK_.call(null,inst_90287);
var state_90386__$1 = (function (){var statearr_90453 = state_90386;
(statearr_90453[(18)] = inst_90298__$1);

return statearr_90453;
})();
if(inst_90298__$1){
var statearr_90454_90531 = state_90386__$1;
(statearr_90454_90531[(1)] = (29));

} else {
var statearr_90455_90532 = state_90386__$1;
(statearr_90455_90532[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (16))){
var inst_90285 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90456_90533 = state_90386__$1;
(statearr_90456_90533[(2)] = inst_90285);

(statearr_90456_90533[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (38))){
var inst_90318 = (state_90386[(2)]);
var inst_90319 = fluree.db.util.async.throw_err.call(null,inst_90318);
var state_90386__$1 = state_90386;
var statearr_90457_90534 = state_90386__$1;
(statearr_90457_90534[(2)] = inst_90319);

(statearr_90457_90534[(1)] = (37));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (30))){
var inst_90298 = (state_90386[(18)]);
var state_90386__$1 = state_90386;
var statearr_90458_90535 = state_90386__$1;
(statearr_90458_90535[(2)] = inst_90298);

(statearr_90458_90535[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (10))){
var inst_90262 = (state_90386[(17)]);
var inst_90262__$1 = (state_90386[(2)]);
var inst_90263 = cljs.core.not.call(null,inst_90262__$1);
var state_90386__$1 = (function (){var statearr_90459 = state_90386;
(statearr_90459[(17)] = inst_90262__$1);

return statearr_90459;
})();
if(inst_90263){
var statearr_90460_90536 = state_90386__$1;
(statearr_90460_90536[(1)] = (11));

} else {
var statearr_90461_90537 = state_90386__$1;
(statearr_90461_90537[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (18))){
var inst_90248 = (state_90386[(9)]);
var inst_90249 = (state_90386[(14)]);
var inst_90275 = fluree.db.dbproto._p_prop.call(null,db,new cljs.core.Keyword(null,"name","name",1843675177),inst_90248);
var inst_90276 = [cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_90275),":",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_90249)].join('');
var inst_90277 = fluree.db.dbproto._tag_id.call(null,db,inst_90276);
var state_90386__$1 = state_90386;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_90386__$1,(21),inst_90277);
} else {
if((state_val_90387 === (52))){
var inst_90250 = (state_90386[(12)]);
var inst_90248 = (state_90386[(9)]);
var inst_90247 = (state_90386[(13)]);
var inst_90287 = (state_90386[(16)]);
var inst_90348 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_90349 = [inst_90248,inst_90247,inst_90287,inst_90250];
var inst_90350 = (new cljs.core.PersistentVector(null,4,(5),inst_90348,inst_90349,null));
var inst_90351 = fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"psot","psot",2111653059),cljs.core._EQ_,inst_90350,opts);
var state_90386__$1 = state_90386;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_90386__$1,(55),inst_90351);
} else {
if((state_val_90387 === (42))){
var inst_90287 = (state_90386[(16)]);
var state_90386__$1 = state_90386;
var statearr_90462_90538 = state_90386__$1;
(statearr_90462_90538[(2)] = inst_90287);

(statearr_90462_90538[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (37))){
var inst_90372 = (state_90386[(2)]);
var state_90386__$1 = state_90386;
var statearr_90463_90539 = state_90386__$1;
(statearr_90463_90539[(2)] = inst_90372);

(statearr_90463_90539[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (63))){
var inst_90378 = (state_90386[(2)]);
var inst_90379 = fluree.db.util.async.throw_err.call(null,inst_90378);
var state_90386__$1 = state_90386;
var statearr_90464_90540 = state_90386__$1;
(statearr_90464_90540[(2)] = inst_90379);

(statearr_90464_90540[(1)] = (62));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (8))){
var inst_90249 = (state_90386[(14)]);
var inst_90259 = typeof inst_90249 === 'string';
var state_90386__$1 = state_90386;
var statearr_90465_90541 = state_90386__$1;
(statearr_90465_90541[(2)] = inst_90259);

(statearr_90465_90541[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90387 === (49))){
var inst_90331 = (state_90386[(15)]);
var inst_90250 = (state_90386[(12)]);
var inst_90248 = (state_90386[(9)]);
var inst_90257 = (state_90386[(7)]);
var inst_90247 = (state_90386[(13)]);
var inst_90287 = (state_90386[(16)]);
var inst_90251 = (state_90386[(10)]);
var inst_90262 = (state_90386[(17)]);
var inst_90335 = (function (){var t = inst_90250;
var temp__5733__auto__ = inst_90331;
var p = inst_90248;
var idx_predicate_QMARK_ = inst_90251;
var o = inst_90287;
var vec__90244 = fparts;
var tag_predicate_QMARK_ = inst_90257;
var s = inst_90247;
var o_coerce_QMARK_ = inst_90262;
return ((function (t,temp__5733__auto__,p,idx_predicate_QMARK_,o,vec__90244,tag_predicate_QMARK_,s,o_coerce_QMARK_,inst_90331,inst_90250,inst_90248,inst_90257,inst_90247,inst_90287,inst_90251,inst_90262,state_val_90387,c__86675__auto__){
return (function (x){
return cljs.core._EQ_.call(null,x,o);
});
;})(t,temp__5733__auto__,p,idx_predicate_QMARK_,o,vec__90244,tag_predicate_QMARK_,s,o_coerce_QMARK_,inst_90331,inst_90250,inst_90248,inst_90257,inst_90247,inst_90287,inst_90251,inst_90262,state_val_90387,c__86675__auto__))
})();
var state_90386__$1 = state_90386;
var statearr_90466_90542 = state_90386__$1;
(statearr_90466_90542[(2)] = inst_90335);

(statearr_90466_90542[(1)] = (50));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$range$state_machine__86625__auto__ = null;
var fluree$db$query$range$state_machine__86625__auto____0 = (function (){
var statearr_90467 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_90467[(0)] = fluree$db$query$range$state_machine__86625__auto__);

(statearr_90467[(1)] = (1));

return statearr_90467;
});
var fluree$db$query$range$state_machine__86625__auto____1 = (function (state_90386){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_90386);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e90468){if((e90468 instanceof Object)){
var ex__86628__auto__ = e90468;
var statearr_90469_90543 = state_90386;
(statearr_90469_90543[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_90386);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e90468;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__90544 = state_90386;
state_90386 = G__90544;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$range$state_machine__86625__auto__ = function(state_90386){
switch(arguments.length){
case 0:
return fluree$db$query$range$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$range$state_machine__86625__auto____1.call(this,state_90386);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$range$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$range$state_machine__86625__auto____0;
fluree$db$query$range$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$range$state_machine__86625__auto____1;
return fluree$db$query$range$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_90470 = f__86676__auto__.call(null);
(statearr_90470[(6)] = c__86675__auto__);

return statearr_90470;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.query.range.search.cljs$lang$maxFixedArity = 3;

/**
 * Returns spot index range for only the requested collection.
 */
fluree.db.query.range.collection = (function fluree$db$query$range$collection(var_args){
var G__90546 = arguments.length;
switch (G__90546) {
case 2:
return fluree.db.query.range.collection.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return fluree.db.query.range.collection.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

fluree.db.query.range.collection.cljs$core$IFn$_invoke$arity$2 = (function (db,name){
return fluree.db.query.range.collection.call(null,db,name,null);
});

fluree.db.query.range.collection.cljs$core$IFn$_invoke$arity$3 = (function (db,name,opts){
var c__86675__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__86675__auto__){
return (function (){
var f__86676__auto__ = (function (){var switch__86624__auto__ = ((function (c__86675__auto__){
return (function (state_90578){
var state_val_90579 = (state_90578[(1)]);
if((state_val_90579 === (1))){
var state_90578__$1 = state_90578;
var statearr_90580_90593 = state_90578__$1;
(statearr_90580_90593[(2)] = null);

(statearr_90580_90593[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90579 === (2))){
var inst_90576 = (state_90578[(2)]);
var state_90578__$1 = state_90578;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_90578__$1,inst_90576);
} else {
if((state_val_90579 === (3))){
var inst_90547 = (state_90578[(2)]);
var state_90578__$1 = state_90578;
var statearr_90581_90594 = state_90578__$1;
(statearr_90581_90594[(2)] = inst_90547);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_90578__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90579 === (4))){
var inst_90551 = (state_90578[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_90578,(3),new cljs.core.Keyword(null,"default","default",-1987822328),null,(2));
var inst_90551__$1 = fluree.db.dbproto._c_prop.call(null,db,new cljs.core.Keyword(null,"id","id",-1388402092),name);
var state_90578__$1 = (function (){var statearr_90582 = state_90578;
(statearr_90582[(7)] = inst_90551__$1);

return statearr_90582;
})();
if(cljs.core.truth_(inst_90551__$1)){
var statearr_90583_90595 = state_90578__$1;
(statearr_90583_90595[(1)] = (5));

} else {
var statearr_90584_90596 = state_90578__$1;
(statearr_90584_90596[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90579 === (5))){
var inst_90551 = (state_90578[(7)]);
var inst_90553 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_90554 = fluree.db.flake.max_subject_id.call(null,inst_90551);
var inst_90555 = [inst_90554];
var inst_90556 = (new cljs.core.PersistentVector(null,1,(5),inst_90553,inst_90555,null));
var inst_90557 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_90558 = fluree.db.flake.min_subject_id.call(null,inst_90551);
var inst_90559 = [inst_90558];
var inst_90560 = (new cljs.core.PersistentVector(null,1,(5),inst_90557,inst_90559,null));
var inst_90561 = fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"spot","spot",-1706962147),cljs.core._GT__EQ_,inst_90556,cljs.core._LT__EQ_,inst_90560,opts);
var state_90578__$1 = state_90578;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_90578__$1,(8),inst_90561);
} else {
if((state_val_90579 === (6))){
var inst_90566 = cljs.core.pr_str.call(null,name);
var inst_90567 = ["Invalid collection name: ",inst_90566].join('');
var inst_90568 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_90569 = [(400),new cljs.core.Keyword("db","invalid-collection","db/invalid-collection",1742380218)];
var inst_90570 = cljs.core.PersistentHashMap.fromArrays(inst_90568,inst_90569);
var inst_90571 = cljs.core.ex_info.call(null,inst_90567,inst_90570);
var inst_90572 = (function(){throw inst_90571})();
var state_90578__$1 = state_90578;
var statearr_90585_90597 = state_90578__$1;
(statearr_90585_90597[(2)] = inst_90572);

(statearr_90585_90597[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90579 === (7))){
var inst_90574 = (state_90578[(2)]);
var state_90578__$1 = state_90578;
var statearr_90586_90598 = state_90578__$1;
(statearr_90586_90598[(2)] = inst_90574);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_90578__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_90579 === (8))){
var inst_90563 = (state_90578[(2)]);
var inst_90564 = fluree.db.util.async.throw_err.call(null,inst_90563);
var state_90578__$1 = state_90578;
var statearr_90587_90599 = state_90578__$1;
(statearr_90587_90599[(2)] = inst_90564);

(statearr_90587_90599[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});})(c__86675__auto__))
;
return ((function (switch__86624__auto__,c__86675__auto__){
return (function() {
var fluree$db$query$range$state_machine__86625__auto__ = null;
var fluree$db$query$range$state_machine__86625__auto____0 = (function (){
var statearr_90588 = [null,null,null,null,null,null,null,null];
(statearr_90588[(0)] = fluree$db$query$range$state_machine__86625__auto__);

(statearr_90588[(1)] = (1));

return statearr_90588;
});
var fluree$db$query$range$state_machine__86625__auto____1 = (function (state_90578){
while(true){
var ret_value__86626__auto__ = (function (){try{while(true){
var result__86627__auto__ = switch__86624__auto__.call(null,state_90578);
if(cljs.core.keyword_identical_QMARK_.call(null,result__86627__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__86627__auto__;
}
break;
}
}catch (e90589){if((e90589 instanceof Object)){
var ex__86628__auto__ = e90589;
var statearr_90590_90600 = state_90578;
(statearr_90590_90600[(5)] = ex__86628__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_90578);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e90589;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__86626__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__90601 = state_90578;
state_90578 = G__90601;
continue;
} else {
return ret_value__86626__auto__;
}
break;
}
});
fluree$db$query$range$state_machine__86625__auto__ = function(state_90578){
switch(arguments.length){
case 0:
return fluree$db$query$range$state_machine__86625__auto____0.call(this);
case 1:
return fluree$db$query$range$state_machine__86625__auto____1.call(this,state_90578);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$query$range$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$query$range$state_machine__86625__auto____0;
fluree$db$query$range$state_machine__86625__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$query$range$state_machine__86625__auto____1;
return fluree$db$query$range$state_machine__86625__auto__;
})()
;})(switch__86624__auto__,c__86675__auto__))
})();
var state__86677__auto__ = (function (){var statearr_90591 = f__86676__auto__.call(null);
(statearr_90591[(6)] = c__86675__auto__);

return statearr_90591;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__86677__auto__);
});})(c__86675__auto__))
);

return c__86675__auto__;
});

fluree.db.query.range.collection.cljs$lang$maxFixedArity = 3;

/**
 * Returns spot index range for only the requested collection.
 */
fluree.db.query.range._block_or_tx_collection = (function fluree$db$query$range$_block_or_tx_collection(db,opts){
return fluree.db.query.range.index_range.call(null,db,new cljs.core.Keyword(null,"spot","spot",-1706962147),cljs.core._GT_,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0)], null),cljs.core._LT__EQ_,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [fluree.db.util.core.min_long], null),opts);
});
/**
 * Returns vector of transactions from a set of flakes.
 * Each transaction is a map with the following keys:
 * 1. db - the associated ledger
 * 2. tx - a map containing all transaction data in the original cmd
 * 3. nonce - the nonce
 * 4. auth - the authority that submitted the transaction
 * 5. expire - expiration
 */
fluree.db.query.range.txn_from_flakes = (function fluree$db$query$range$txn_from_flakes(flakes){
var G__90605 = flakes;
var vec__90606 = G__90605;
var seq__90607 = cljs.core.seq.call(null,vec__90606);
var first__90608 = cljs.core.first.call(null,seq__90607);
var seq__90607__$1 = cljs.core.next.call(null,seq__90607);
var flake_SINGLEQUOTE_ = first__90608;
var r = seq__90607__$1;
var result_STAR_ = cljs.core.PersistentVector.EMPTY;
var G__90605__$1 = G__90605;
var result_STAR___$1 = result_STAR_;
while(true){
var vec__90615 = G__90605__$1;
var seq__90616 = cljs.core.seq.call(null,vec__90615);
var first__90617 = cljs.core.first.call(null,seq__90616);
var seq__90616__$1 = cljs.core.next.call(null,seq__90616);
var flake_SINGLEQUOTE___$1 = first__90617;
var r__$1 = seq__90616__$1;
var result_STAR___$2 = result_STAR___$1;
if((flake_SINGLEQUOTE___$1 == null)){
return result_STAR___$2;
} else {
var obj = flake_SINGLEQUOTE___$1.o;
var cmd_map = (function (){try{return fluree.db.util.json.parse.call(null,obj);
}catch (e90619){var e = e90619;
return null;
}})();
var map__90618 = cmd_map;
var map__90618__$1 = (((((!((map__90618 == null))))?(((((map__90618.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__90618.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__90618):map__90618);
var type = cljs.core.get.call(null,map__90618__$1,new cljs.core.Keyword(null,"type","type",1174270348));
var db = cljs.core.get.call(null,map__90618__$1,new cljs.core.Keyword(null,"db","db",993250759));
var tx = cljs.core.get.call(null,map__90618__$1,new cljs.core.Keyword(null,"tx","tx",466630418));
var nonce = cljs.core.get.call(null,map__90618__$1,new cljs.core.Keyword(null,"nonce","nonce",564330331));
var auth = cljs.core.get.call(null,map__90618__$1,new cljs.core.Keyword(null,"auth","auth",1389754926));
var expire = cljs.core.get.call(null,map__90618__$1,new cljs.core.Keyword(null,"expire","expire",-70657108));
var G__90621 = r__$1;
var G__90622 = ((cljs.core._EQ_.call(null,type,"tx"))?cljs.core.conj.call(null,result_STAR___$2,new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"db","db",993250759),db,new cljs.core.Keyword(null,"tx","tx",466630418),tx,new cljs.core.Keyword(null,"nonce","nonce",564330331),nonce,new cljs.core.Keyword(null,"auth","auth",1389754926),auth,new cljs.core.Keyword(null,"expire","expire",-70657108),expire], null)):result_STAR___$2);
G__90605__$1 = G__90621;
result_STAR___$1 = G__90622;
continue;
}
break;
}
});
/**
 * Returns block data as a map, with the following keys:
 *   1. block - block number
 *   2. t - fluree "time" since ledger creation
 *   3. sigs - List of transactor signatures that signed this block
 *   4. instant - instant this block was created, per the transactor.
 *   5. hash - hash of current block
 *   6. prev-hash - hash of previous block, if relevant
 *   7. flakes - list of flakes comprising block
 *   8. txn - list of transactions in block
 *   
 */
fluree.db.query.range.block_with_tx_data = (function fluree$db$query$range$block_with_tx_data(blocks){
var G__90631 = blocks;
var vec__90632 = G__90631;
var seq__90633 = cljs.core.seq.call(null,vec__90632);
var first__90634 = cljs.core.first.call(null,seq__90633);
var seq__90633__$1 = cljs.core.next.call(null,seq__90633);
var block_SINGLEQUOTE_ = first__90634;
var r = seq__90633__$1;
var result_STAR_ = cljs.core.PersistentVector.EMPTY;
var G__90631__$1 = G__90631;
var result_STAR___$1 = result_STAR_;
while(true){
var vec__90640 = G__90631__$1;
var seq__90641 = cljs.core.seq.call(null,vec__90640);
var first__90642 = cljs.core.first.call(null,seq__90641);
var seq__90641__$1 = cljs.core.next.call(null,seq__90641);
var block_SINGLEQUOTE___$1 = first__90642;
var r__$1 = seq__90641__$1;
var result_STAR___$2 = result_STAR___$1;
if((block_SINGLEQUOTE___$1 == null)){
return result_STAR___$2;
} else {
var map__90643 = block_SINGLEQUOTE___$1;
var map__90643__$1 = (((((!((map__90643 == null))))?(((((map__90643.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__90643.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__90643):map__90643);
var block = cljs.core.get.call(null,map__90643__$1,new cljs.core.Keyword(null,"block","block",664686210));
var t = cljs.core.get.call(null,map__90643__$1,new cljs.core.Keyword(null,"t","t",-1397832519));
var flakes = cljs.core.get.call(null,map__90643__$1,new cljs.core.Keyword(null,"flakes","flakes",1977895739));
var prev_hash = cljs.core.some.call(null,((function (G__90631__$1,result_STAR___$1,map__90643,map__90643__$1,block,t,flakes,vec__90640,seq__90641,first__90642,seq__90641__$1,block_SINGLEQUOTE___$1,r__$1,result_STAR___$2,G__90631,vec__90632,seq__90633,first__90634,seq__90633__$1,block_SINGLEQUOTE_,r,result_STAR_){
return (function (p1__90623_SHARP_){
if(cljs.core._EQ_.call(null,p1__90623_SHARP_.p,(2))){
return p1__90623_SHARP_.o;
} else {
return null;
}
});})(G__90631__$1,result_STAR___$1,map__90643,map__90643__$1,block,t,flakes,vec__90640,seq__90641,first__90642,seq__90641__$1,block_SINGLEQUOTE___$1,r__$1,result_STAR___$2,G__90631,vec__90632,seq__90633,first__90634,seq__90633__$1,block_SINGLEQUOTE_,r,result_STAR_))
,flakes);
var hash = cljs.core.some.call(null,((function (G__90631__$1,result_STAR___$1,map__90643,map__90643__$1,block,t,flakes,prev_hash,vec__90640,seq__90641,first__90642,seq__90641__$1,block_SINGLEQUOTE___$1,r__$1,result_STAR___$2,G__90631,vec__90632,seq__90633,first__90634,seq__90633__$1,block_SINGLEQUOTE_,r,result_STAR_){
return (function (p1__90624_SHARP_){
if(cljs.core._EQ_.call(null,p1__90624_SHARP_.p,(1))){
return p1__90624_SHARP_.o;
} else {
return null;
}
});})(G__90631__$1,result_STAR___$1,map__90643,map__90643__$1,block,t,flakes,prev_hash,vec__90640,seq__90641,first__90642,seq__90641__$1,block_SINGLEQUOTE___$1,r__$1,result_STAR___$2,G__90631,vec__90632,seq__90633,first__90634,seq__90633__$1,block_SINGLEQUOTE_,r,result_STAR_))
,flakes);
var instant = cljs.core.some.call(null,((function (G__90631__$1,result_STAR___$1,map__90643,map__90643__$1,block,t,flakes,prev_hash,hash,vec__90640,seq__90641,first__90642,seq__90641__$1,block_SINGLEQUOTE___$1,r__$1,result_STAR___$2,G__90631,vec__90632,seq__90633,first__90634,seq__90633__$1,block_SINGLEQUOTE_,r,result_STAR_){
return (function (p1__90625_SHARP_){
if(cljs.core._EQ_.call(null,p1__90625_SHARP_.p,(5))){
return p1__90625_SHARP_.o;
} else {
return null;
}
});})(G__90631__$1,result_STAR___$1,map__90643,map__90643__$1,block,t,flakes,prev_hash,hash,vec__90640,seq__90641,first__90642,seq__90641__$1,block_SINGLEQUOTE___$1,r__$1,result_STAR___$2,G__90631,vec__90632,seq__90633,first__90634,seq__90633__$1,block_SINGLEQUOTE_,r,result_STAR_))
,flakes);
var sigs = cljs.core.some.call(null,((function (G__90631__$1,result_STAR___$1,map__90643,map__90643__$1,block,t,flakes,prev_hash,hash,instant,vec__90640,seq__90641,first__90642,seq__90641__$1,block_SINGLEQUOTE___$1,r__$1,result_STAR___$2,G__90631,vec__90632,seq__90633,first__90634,seq__90633__$1,block_SINGLEQUOTE_,r,result_STAR_){
return (function (p1__90626_SHARP_){
if(cljs.core._EQ_.call(null,p1__90626_SHARP_.p,(7))){
return p1__90626_SHARP_.o;
} else {
return null;
}
});})(G__90631__$1,result_STAR___$1,map__90643,map__90643__$1,block,t,flakes,prev_hash,hash,instant,vec__90640,seq__90641,first__90642,seq__90641__$1,block_SINGLEQUOTE___$1,r__$1,result_STAR___$2,G__90631,vec__90632,seq__90633,first__90634,seq__90633__$1,block_SINGLEQUOTE_,r,result_STAR_))
,flakes);
var txn_flakes = cljs.core.filter.call(null,((function (G__90631__$1,result_STAR___$1,map__90643,map__90643__$1,block,t,flakes,prev_hash,hash,instant,sigs,vec__90640,seq__90641,first__90642,seq__90641__$1,block_SINGLEQUOTE___$1,r__$1,result_STAR___$2,G__90631,vec__90632,seq__90633,first__90634,seq__90633__$1,block_SINGLEQUOTE_,r,result_STAR_){
return (function (p1__90627_SHARP_){
return cljs.core._EQ_.call(null,p1__90627_SHARP_.p,(106));
});})(G__90631__$1,result_STAR___$1,map__90643,map__90643__$1,block,t,flakes,prev_hash,hash,instant,sigs,vec__90640,seq__90641,first__90642,seq__90641__$1,block_SINGLEQUOTE___$1,r__$1,result_STAR___$2,G__90631,vec__90632,seq__90633,first__90634,seq__90633__$1,block_SINGLEQUOTE_,r,result_STAR_))
,flakes);
var txn_flakes_SINGLEQUOTE_ = fluree.db.query.range.txn_from_flakes.call(null,txn_flakes);
var G__90645 = r__$1;
var G__90646 = cljs.core.conj.call(null,result_STAR___$2,new cljs.core.PersistentArrayMap(null, 8, [new cljs.core.Keyword(null,"block","block",664686210),block,new cljs.core.Keyword(null,"t","t",-1397832519),t,new cljs.core.Keyword(null,"hash","hash",-13781596),hash,new cljs.core.Keyword(null,"prev-hash","prev-hash",209337330),prev_hash,new cljs.core.Keyword(null,"instant","instant",655498374),instant,new cljs.core.Keyword(null,"sigs","sigs",-1653119622),sigs,new cljs.core.Keyword(null,"flakes","flakes",1977895739),flakes,new cljs.core.Keyword(null,"txn","txn",-469204789),txn_flakes_SINGLEQUOTE_], null));
G__90631__$1 = G__90645;
result_STAR___$1 = G__90646;
continue;
}
break;
}
});
